/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/platform","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/editor/common/core/range","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/stopwatch","vs/base/common/event","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/base/common/uri","vs/base/common/diff/diffChange","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/base/common/hash","vs/editor/common/core/characterClassifier","vs/editor/common/core/selection","vs/editor/common/core/token","vs/editor/common/diff/diffComputer","vs/editor/common/model/wordHelper","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/standalone/standaloneEnums","vs/editor/common/standalone/standaloneBase","vs/editor/common/viewModel/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],X=function(I){for(var t=[],M=0,U=I.length;M<U;M++)t[M]=Q[I[M]];return t};"use strict";var Le=this,be=typeof global=="object"?global:{},ee;(function(I){I.global=Le;var t=function(){function M(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1}return Object.defineProperty(M.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),M.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=M._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof I.global.importScripts=="function")},M._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},M}();I.Environment=t})(ee||(ee={}));var ee;(function(I){var t=function(){function C(s,S,l){this.type=s,this.detail=S,this.timestamp=l}return C}();I.LoaderEvent=t;var M=function(){function C(s){this._events=[new t(1,"",s)]}return C.prototype.record=function(s,S){this._events.push(new t(s,S,I.Utilities.getHighPerformanceTimestamp()))},C.prototype.getEvents=function(){return this._events},C}();I.LoaderEventRecorder=M;var U=function(){function C(){}return C.prototype.record=function(s,S){},C.prototype.getEvents=function(){return[]},C.INSTANCE=new C,C}();I.NullLoaderEventRecorder=U})(ee||(ee={}));var ee;(function(I){var t=function(){function M(){}return M.fileUriToFilePath=function(U,C){if(C=decodeURI(C).replace(/%23/g,"#"),U){if(/^file:\/\/\//.test(C))return C.substr(8);if(/^file:\/\//.test(C))return C.substr(5)}else if(/^file:\/\//.test(C))return C.substr(7);return C},M.startsWith=function(U,C){return U.length>=C.length&&U.substr(0,C.length)===C},M.endsWith=function(U,C){return U.length>=C.length&&U.substr(U.length-C.length)===C},M.containsQueryString=function(U){return/^[^\#]*\?/gi.test(U)},M.isAbsolutePath=function(U){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(U)},M.forEachProperty=function(U,C){if(U){var s=void 0;for(s in U)U.hasOwnProperty(s)&&C(s,U[s])}},M.isEmpty=function(U){var C=!0;return M.forEachProperty(U,function(){C=!1}),C},M.recursiveClone=function(U){if(!U||typeof U!="object"||U instanceof RegExp||!Array.isArray(U)&&Object.getPrototypeOf(U)!==Object.prototype)return U;var C=Array.isArray(U)?[]:{};return M.forEachProperty(U,function(s,S){S&&typeof S=="object"?C[s]=M.recursiveClone(S):C[s]=S}),C},M.generateAnonymousModule=function(){return"===anonymous"+M.NEXT_ANONYMOUS_ID+++"==="},M.isAnonymousModule=function(U){return M.startsWith(U,"===anonymous")},M.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=I.global.performance&&typeof I.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?I.global.performance.now():Date.now()},M.NEXT_ANONYMOUS_ID=1,M.PERFORMANCE_NOW_PROBED=!1,M.HAS_PERFORMANCE_NOW=!1,M}();I.Utilities=t})(ee||(ee={}));var ee;(function(I){function t(C){if(C instanceof Error)return C;var s=new Error(C.message||String(C)||"Unknown Error");return C.stack&&(s.stack=C.stack),s}I.ensureError=t;var M=function(){function C(){}return C.validateConfigurationOptions=function(s){function S(o){if(o.phase==="loading"){console.error('Loading "'+o.moduleId+'" failed'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}if(o.phase==="factory"){console.error('The factory method of "'+o.moduleId+'" has thrown an exception'),console.error(o);return}}if(s=s||{},typeof s.baseUrl!="string"&&(s.baseUrl=""),typeof s.isBuild!="boolean"&&(s.isBuild=!1),typeof s.paths!="object"&&(s.paths={}),typeof s.config!="object"&&(s.config={}),typeof s.catchError=="undefined"&&(s.catchError=!1),typeof s.recordStats=="undefined"&&(s.recordStats=!1),typeof s.urlArgs!="string"&&(s.urlArgs=""),typeof s.onError!="function"&&(s.onError=S),Array.isArray(s.ignoreDuplicateModules)||(s.ignoreDuplicateModules=[]),s.baseUrl.length>0&&(I.Utilities.endsWith(s.baseUrl,"/")||(s.baseUrl+="/")),typeof s.cspNonce!="string"&&(s.cspNonce=""),typeof s.preferScriptTags=="undefined"&&(s.preferScriptTags=!1),Array.isArray(s.nodeModules)||(s.nodeModules=[]),s.nodeCachedData&&typeof s.nodeCachedData=="object"&&(typeof s.nodeCachedData.seed!="string"&&(s.nodeCachedData.seed="seed"),(typeof s.nodeCachedData.writeDelay!="number"||s.nodeCachedData.writeDelay<0)&&(s.nodeCachedData.writeDelay=1e3*7),!s.nodeCachedData.path||typeof s.nodeCachedData.path!="string")){var l=t(new Error("INVALID cached data configuration, 'path' MUST be set"));l.phase="configuration",s.onError(l),s.nodeCachedData=void 0}return s},C.mergeConfigurationOptions=function(s,S){s===void 0&&(s=null),S===void 0&&(S=null);var l=I.Utilities.recursiveClone(S||{});return I.Utilities.forEachProperty(s,function(o,a){o==="ignoreDuplicateModules"&&typeof l.ignoreDuplicateModules!="undefined"?l.ignoreDuplicateModules=l.ignoreDuplicateModules.concat(a):o==="paths"&&typeof l.paths!="undefined"?I.Utilities.forEachProperty(a,function(E,w){return l.paths[E]=w}):o==="config"&&typeof l.config!="undefined"?I.Utilities.forEachProperty(a,function(E,w){return l.config[E]=w}):l[o]=I.Utilities.recursiveClone(a)}),C.validateConfigurationOptions(l)},C}();I.ConfigurationOptionsUtil=M;var U=function(){function C(s,S){if(this._env=s,this.options=M.mergeConfigurationOptions(S),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var l=this.options.nodeRequire.main.filename,o=Math.max(l.lastIndexOf("/"),l.lastIndexOf("\\"));this.options.baseUrl=l.substring(0,o+1)}if(this.options.nodeMain&&this._env.isNode){var l=this.options.nodeMain,o=Math.max(l.lastIndexOf("/"),l.lastIndexOf("\\"));this.options.baseUrl=l.substring(0,o+1)}}}return C.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var s=0;s<this.options.ignoreDuplicateModules.length;s++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[s]]=!0},C.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var s=0,S=this.options.nodeModules;s<S.length;s++){var l=S[s];this.nodeModulesMap[l]=!0}},C.prototype._createSortedPathsRules=function(){var s=this;this.sortedPathsRules=[],I.Utilities.forEachProperty(this.options.paths,function(S,l){Array.isArray(l)?s.sortedPathsRules.push({from:S,to:l}):s.sortedPathsRules.push({from:S,to:[l]})}),this.sortedPathsRules.sort(function(S,l){return l.from.length-S.from.length})},C.prototype.cloneAndMerge=function(s){return new C(this._env,M.mergeConfigurationOptions(s,this.options))},C.prototype.getOptionsLiteral=function(){return this.options},C.prototype._applyPaths=function(s){for(var S,l=0,o=this.sortedPathsRules.length;l<o;l++)if(S=this.sortedPathsRules[l],I.Utilities.startsWith(s,S.from)){for(var a=[],E=0,w=S.to.length;E<w;E++)a.push(S.to[E]+s.substr(S.from.length));return a}return[s]},C.prototype._addUrlArgsToUrl=function(s){return I.Utilities.containsQueryString(s)?s+"&"+this.options.urlArgs:s+"?"+this.options.urlArgs},C.prototype._addUrlArgsIfNecessaryToUrl=function(s){return this.options.urlArgs?this._addUrlArgsToUrl(s):s},C.prototype._addUrlArgsIfNecessaryToUrls=function(s){if(this.options.urlArgs)for(var S=0,l=s.length;S<l;S++)s[S]=this._addUrlArgsToUrl(s[S]);return s},C.prototype.moduleIdToPaths=function(s){var S=this.nodeModulesMap[s]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(s);if(S)return this.isBuild()?["empty:"]:["node|"+s];var l=s,o;if(!I.Utilities.endsWith(l,".js")&&!I.Utilities.isAbsolutePath(l)){o=this._applyPaths(l);for(var a=0,E=o.length;a<E;a++)this.isBuild()&&o[a]==="empty:"||(I.Utilities.isAbsolutePath(o[a])||(o[a]=this.options.baseUrl+o[a]),!I.Utilities.endsWith(o[a],".js")&&!I.Utilities.containsQueryString(o[a])&&(o[a]=o[a]+".js"))}else!I.Utilities.endsWith(l,".js")&&!I.Utilities.containsQueryString(l)&&(l=l+".js"),o=[l];return this._addUrlArgsIfNecessaryToUrls(o)},C.prototype.requireToUrl=function(s){var S=s;return I.Utilities.isAbsolutePath(S)||(S=this._applyPaths(S)[0],I.Utilities.isAbsolutePath(S)||(S=this.options.baseUrl+S)),this._addUrlArgsIfNecessaryToUrl(S)},C.prototype.isBuild=function(){return this.options.isBuild},C.prototype.isDuplicateMessageIgnoredFor=function(s){return this.ignoreDuplicateModulesMap.hasOwnProperty(s)},C.prototype.getConfigForModule=function(s){if(this.options.config)return this.options.config[s]},C.prototype.shouldCatchError=function(){return this.options.catchError},C.prototype.shouldRecordStats=function(){return this.options.recordStats},C.prototype.onError=function(s){this.options.onError(s)},C}();I.Configuration=U})(ee||(ee={}));var ee;(function(I){var t=function(){function l(o){this._env=o,this._scriptLoader=null,this._callbackMap={}}return l.prototype.load=function(o,a,E,w){var h=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new U;else if(this._env.isElectronRenderer){var c=o.getConfig().getOptionsLiteral().preferScriptTags;c?this._scriptLoader=new M:this._scriptLoader=new C(this._env)}else this._env.isNode?this._scriptLoader=new C(this._env):this._scriptLoader=new M;var g={callback:E,errorback:w};if(this._callbackMap.hasOwnProperty(a)){this._callbackMap[a].push(g);return}this._callbackMap[a]=[g],this._scriptLoader.load(o,a,function(){return h.triggerCallback(a)},function(b){return h.triggerErrorback(a,b)})},l.prototype.triggerCallback=function(o){var a=this._callbackMap[o];delete this._callbackMap[o];for(var E=0;E<a.length;E++)a[E].callback()},l.prototype.triggerErrorback=function(o,a){var E=this._callbackMap[o];delete this._callbackMap[o];for(var w=0;w<E.length;w++)E[w].errorback(a)},l}(),M=function(){function l(){}return l.prototype.attachListeners=function(o,a,E){var w=function(){o.removeEventListener("load",h),o.removeEventListener("error",c)},h=function(g){w(),a()},c=function(g){w(),E(g)};o.addEventListener("load",h),o.addEventListener("error",c)},l.prototype.load=function(o,a,E,w){if(/^node\|/.test(a)){var h=o.getConfig().getOptionsLiteral(),c=s(o.getRecorder(),h.nodeRequire||I.global.nodeRequire),g=a.split("|"),b=null;try{b=c(g[1])}catch(i){w(i);return}o.enqueueDefineAnonymousModule([],function(){return b}),E()}else{var N=document.createElement("script");N.setAttribute("async","async"),N.setAttribute("type","text/javascript"),this.attachListeners(N,E,w);var _=o.getConfig().getOptionsLiteral().trustedTypesPolicy;_&&(a=_.createScriptURL(a)),N.setAttribute("src",a);var n=o.getConfig().getOptionsLiteral().cspNonce;n&&N.setAttribute("nonce",n),document.getElementsByTagName("head")[0].appendChild(N)}},l}(),U=function(){function l(){}return l.prototype.load=function(o,a,E,w){var h=o.getConfig().getOptionsLiteral().trustedTypesPolicy,c=/^((http:)|(https:)|(file:))/.test(a)&&a.substring(0,self.origin.length)!==self.origin;if(!c){fetch(a).then(function(g){if(g.status!==200)throw new Error(g.statusText);return g.text()}).then(function(g){g=g+`
//# sourceURL=`+a;var b=h?self.eval(h.createScript("",g)):new Function(g);b.call(self),E()}).then(void 0,w);return}try{h&&(a=h.createScriptURL(a)),importScripts(a),E()}catch(g){w(g)}},l}(),C=function(){function l(o){this._env=o,this._didInitialize=!1,this._didPatchNodeRequire=!1}return l.prototype._init=function(o){this._didInitialize||(this._didInitialize=!0,this._fs=o("fs"),this._vm=o("vm"),this._path=o("path"),this._crypto=o("crypto"))},l.prototype._initNodeRequire=function(o,a){var E=a.getConfig().getOptionsLiteral().nodeCachedData;if(!!E&&!this._didPatchNodeRequire){this._didPatchNodeRequire=!0;var w=this,h=o("module");function c(g){var b=g.constructor,N=function(n){try{return g.require(n)}finally{}};return N.resolve=function(n,i){return b._resolveFilename(n,g,!1,i)},N.resolve.paths=function(n){return b._resolveLookupPaths(n,g)},N.main=process.mainModule,N.extensions=b._extensions,N.cache=b._cache,N}h.prototype._compile=function(g,b){var N=h.wrap(g.replace(/^#!.*/,"")),_=a.getRecorder(),n=w._getCachedDataPath(E,b),i={filename:b},r;try{var u=w._fs.readFileSync(n);r=u.slice(0,16),i.cachedData=u.slice(16),_.record(60,n)}catch(P){_.record(61,n)}var f=new w._vm.Script(N,i),v=f.runInThisContext(i),d=w._path.dirname(b),m=c(this),A=[this.exports,m,this,b,d,process,be,Buffer],p=v.apply(this.exports,A);return w._handleCachedData(f,N,n,!i.cachedData,a),w._verifyCachedData(f,N,n,r,a),p}}},l.prototype.load=function(o,a,E,w){var h=this,c=o.getConfig().getOptionsLiteral(),g=s(o.getRecorder(),c.nodeRequire||I.global.nodeRequire),b=c.nodeInstrumenter||function(v){return v};this._init(g),this._initNodeRequire(g,o);var N=o.getRecorder();if(/^node\|/.test(a)){var _=a.split("|"),n=null;try{n=g(_[1])}catch(v){w(v);return}o.enqueueDefineAnonymousModule([],function(){return n}),E()}else{a=I.Utilities.fileUriToFilePath(this._env.isWindows,a);var i=this._path.normalize(a),r=this._getElectronRendererScriptPathOrUri(i),u=Boolean(c.nodeCachedData),f=u?this._getCachedDataPath(c.nodeCachedData,a):void 0;this._readSourceAndCachedData(i,f,N,function(v,d,m,A){if(v){w(v);return}var p;d.charCodeAt(0)===l._BOM?p=l._PREFIX+d.substring(1)+l._SUFFIX:p=l._PREFIX+d+l._SUFFIX,p=b(p,i);var P={filename:r,cachedData:m},F=h._createAndEvalScript(o,p,P,E,w);h._handleCachedData(F,p,f,u&&!m,o),h._verifyCachedData(F,p,f,A,o)})}},l.prototype._createAndEvalScript=function(o,a,E,w,h){var c=o.getRecorder();c.record(31,E.filename);var g=new this._vm.Script(a,E),b=g.runInThisContext(E),N=o.getGlobalAMDDefineFunc(),_=!1,n=function(){return _=!0,N.apply(null,arguments)};return n.amd=N.amd,b.call(I.global,o.getGlobalAMDRequireFunc(),n,E.filename,this._path.dirname(E.filename)),c.record(32,E.filename),_?w():h(new Error("Didn't receive define call in "+E.filename+"!")),g},l.prototype._getElectronRendererScriptPathOrUri=function(o){if(!this._env.isElectronRenderer)return o;var a=o.match(/^([a-z])\:(.*)/i);return a?"file:///"+(a[1].toUpperCase()+":"+a[2]).replace(/\\/g,"/"):"file://"+o},l.prototype._getCachedDataPath=function(o,a){var E=this._crypto.createHash("md5").update(a,"utf8").update(o.seed,"utf8").update(process.arch,"").digest("hex"),w=this._path.basename(a).replace(/\.js$/,"");return this._path.join(o.path,w+"-"+E+".code")},l.prototype._handleCachedData=function(o,a,E,w,h){var c=this;o.cachedDataRejected?this._fs.unlink(E,function(g){h.getRecorder().record(62,E),c._createAndWriteCachedData(o,a,E,h),g&&h.getConfig().onError(g)}):w&&this._createAndWriteCachedData(o,a,E,h)},l.prototype._createAndWriteCachedData=function(o,a,E,w){var h=this,c=Math.ceil(w.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),g=-1,b=0,N=void 0,_=function(){setTimeout(function(){N||(N=h._crypto.createHash("md5").update(a,"utf8").digest());var n=o.createCachedData();if(!(n.length===0||n.length===g||b>=5)){if(n.length<g){_();return}g=n.length,h._fs.writeFile(E,Buffer.concat([N,n]),function(i){i&&w.getConfig().onError(i),w.getRecorder().record(63,E),_()})}},c*Math.pow(4,b++))};_()},l.prototype._readSourceAndCachedData=function(o,a,E,w){if(!a)this._fs.readFile(o,{encoding:"utf8"},w);else{var h=void 0,c=void 0,g=void 0,b=2,N=function(_){_?w(_):--b==0&&w(void 0,h,c,g)};this._fs.readFile(o,{encoding:"utf8"},function(_,n){h=n,N(_)}),this._fs.readFile(a,function(_,n){!_&&n&&n.length>0?(g=n.slice(0,16),c=n.slice(16),E.record(60,a)):E.record(61,a),N()})}},l.prototype._verifyCachedData=function(o,a,E,w,h){var c=this;!w||o.cachedDataRejected||setTimeout(function(){var g=c._crypto.createHash("md5").update(a,"utf8").digest();w.equals(g)||(h.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+E+"' now, but a RESTART IS REQUIRED")),c._fs.unlink(E,function(b){b&&h.getConfig().onError(b)}))},Math.ceil(5e3*(1+Math.random())))},l._BOM=65279,l._PREFIX="(function (require, define, __filename, __dirname) { ",l._SUFFIX=`
});`,l}();function s(l,o){if(o.__$__isRecorded)return o;var a=function(w){l.record(33,w);try{return o(w)}finally{l.record(34,w)}};return a.__$__isRecorded=!0,a}I.ensureRecordedNodeRequire=s;function S(l){return new t(l)}I.createScriptLoader=S})(ee||(ee={}));var ee;(function(I){var t=function(){function l(o){var a=o.lastIndexOf("/");a!==-1?this.fromModulePath=o.substr(0,a+1):this.fromModulePath=""}return l._normalizeModuleId=function(o){var a=o,E;for(E=/\/\.\//;E.test(a);)a=a.replace(E,"/");for(a=a.replace(/^\.\//g,""),E=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;E.test(a);)a=a.replace(E,"/");return a=a.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),a},l.prototype.resolveModule=function(o){var a=o;return I.Utilities.isAbsolutePath(a)||(I.Utilities.startsWith(a,"./")||I.Utilities.startsWith(a,"../"))&&(a=l._normalizeModuleId(this.fromModulePath+a)),a},l.ROOT=new l(""),l}();I.ModuleIdResolver=t;var M=function(){function l(o,a,E,w,h,c){this.id=o,this.strId=a,this.dependencies=E,this._callback=w,this._errorback=h,this.moduleIdResolver=c,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return l._safeInvokeFunction=function(o,a){try{return{returnedValue:o.apply(I.global,a),producedError:null}}catch(E){return{returnedValue:null,producedError:E}}},l._invokeFactory=function(o,a,E,w){return o.isBuild()&&!I.Utilities.isAnonymousModule(a)?{returnedValue:null,producedError:null}:o.shouldCatchError()?this._safeInvokeFunction(E,w):{returnedValue:E.apply(I.global,w),producedError:null}},l.prototype.complete=function(o,a,E){this._isComplete=!0;var w=null;if(this._callback)if(typeof this._callback=="function"){o.record(21,this.strId);var h=l._invokeFactory(a,this.strId,this._callback,E);w=h.producedError,o.record(22,this.strId),!w&&typeof h.returnedValue!="undefined"&&(!this.exportsPassedIn||I.Utilities.isEmpty(this.exports))&&(this.exports=h.returnedValue)}else this.exports=this._callback;if(w){var c=I.ensureError(w);c.phase="factory",c.moduleId=this.strId,this.error=c,a.onError(c)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},l.prototype.onDependencyError=function(o){return this._isComplete=!0,this.error=o,this._errorback?(this._errorback(o),!0):!1},l.prototype.isComplete=function(){return this._isComplete},l}();I.Module=M;var U=function(){function l(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return l.prototype.getMaxModuleId=function(){return this._nextId},l.prototype.getModuleId=function(o){var a=this._strModuleIdToIntModuleId.get(o);return typeof a=="undefined"&&(a=this._nextId++,this._strModuleIdToIntModuleId.set(o,a),this._intModuleIdToStrModuleId[a]=o),a},l.prototype.getStrModuleId=function(o){return this._intModuleIdToStrModuleId[o]},l}(),C=function(){function l(o){this.id=o}return l.EXPORTS=new l(0),l.MODULE=new l(1),l.REQUIRE=new l(2),l}();I.RegularDependency=C;var s=function(){function l(o,a,E){this.id=o,this.pluginId=a,this.pluginParam=E}return l}();I.PluginDependency=s;var S=function(){function l(o,a,E,w,h){h===void 0&&(h=0),this._env=o,this._scriptLoader=a,this._loaderAvailableTimestamp=h,this._defineFunc=E,this._requireFunc=w,this._moduleIdProvider=new U,this._config=new I.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return l.prototype.reset=function(){return new l(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},l.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},l.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},l._findRelevantLocationInStack=function(o,a){for(var E=function(r){return r.replace(/\\/g,"/")},w=E(o),h=a.split(/\n/),c=0;c<h.length;c++){var g=h[c].match(/(.*):(\d+):(\d+)\)?$/);if(g){var b=g[1],N=g[2],_=g[3],n=Math.max(b.lastIndexOf(" ")+1,b.lastIndexOf("(")+1);if(b=b.substr(n),b=E(b),b===w){var i={line:parseInt(N,10),col:parseInt(_,10)};return i.line===1&&(i.col-="(function (require, define, __filename, __dirname) { ".length),i}}}throw new Error("Could not correlate define call site for needle "+o)},l.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var o=[],a=0,E=0,w=this._modules2.length;E<w;E++){var h=this._modules2[E];if(!!h){var c=this._buildInfoPath[h.id]||null,g=this._buildInfoDefineStack[h.id]||null,b=this._buildInfoDependencies[h.id];o[a++]={id:h.strId,path:c,defineLocation:c&&g?l._findRelevantLocationInStack(c,g):null,dependencies:b,shim:null,exports:h.exports}}}return o},l.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new I.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=I.NullLoaderEventRecorder.INSTANCE),this._recorder},l.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},l.prototype.enqueueDefineAnonymousModule=function(o,a){if(this._currentAnnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var E=null;this._config.isBuild()&&(E=new Error("StackLocation").stack||null),this._currentAnnonymousDefineCall={stack:E,dependencies:o,callback:a}},l.prototype.defineModule=function(o,a,E,w,h,c){var g=this;c===void 0&&(c=new t(o));var b=this._moduleIdProvider.getModuleId(o);if(this._modules2[b]){this._config.isDuplicateMessageIgnoredFor(o)||console.warn("Duplicate definition of module '"+o+"'");return}var N=new M(b,o,this._normalizeDependencies(a,c),E,w,c);this._modules2[b]=N,this._config.isBuild()&&(this._buildInfoDefineStack[b]=h,this._buildInfoDependencies[b]=(N.dependencies||[]).map(function(_){return g._moduleIdProvider.getStrModuleId(_.id)})),this._resolve(N)},l.prototype._normalizeDependency=function(o,a){if(o==="exports")return C.EXPORTS;if(o==="module")return C.MODULE;if(o==="require")return C.REQUIRE;var E=o.indexOf("!");if(E>=0){var w=a.resolveModule(o.substr(0,E)),h=a.resolveModule(o.substr(E+1)),c=this._moduleIdProvider.getModuleId(w+"!"+h),g=this._moduleIdProvider.getModuleId(w);return new s(c,g,h)}return new C(this._moduleIdProvider.getModuleId(a.resolveModule(o)))},l.prototype._normalizeDependencies=function(o,a){for(var E=[],w=0,h=0,c=o.length;h<c;h++)E[w++]=this._normalizeDependency(o[h],a);return E},l.prototype._relativeRequire=function(o,a,E,w){if(typeof a=="string")return this.synchronousRequire(a,o);this.defineModule(I.Utilities.generateAnonymousModule(),a,E,w,null,o)},l.prototype.synchronousRequire=function(o,a){a===void 0&&(a=new t(o));var E=this._normalizeDependency(o,a),w=this._modules2[E.id];if(!w)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This is the first mention of this module!");if(!w.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This module has not been resolved completely yet.");if(w.error)throw w.error;return w.exports},l.prototype.configure=function(o,a){var E=this._config.shouldRecordStats();a?this._config=new I.Configuration(this._env,o):this._config=this._config.cloneAndMerge(o),this._config.shouldRecordStats()&&!E&&(this._recorder=null)},l.prototype.getConfig=function(){return this._config},l.prototype._onLoad=function(o){if(this._currentAnnonymousDefineCall!==null){var a=this._currentAnnonymousDefineCall;this._currentAnnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(o),a.dependencies,a.callback,null,a.stack)}},l.prototype._createLoadError=function(o,a){var E=this,w=this._moduleIdProvider.getStrModuleId(o),h=(this._inverseDependencies2[o]||[]).map(function(g){return E._moduleIdProvider.getStrModuleId(g)}),c=I.ensureError(a);return c.phase="loading",c.moduleId=w,c.neededBy=h,c},l.prototype._onLoadError=function(o,a){var E=this._createLoadError(o,a);this._modules2[o]||(this._modules2[o]=new M(o,this._moduleIdProvider.getStrModuleId(o),[],function(){},function(){},null));for(var w=[],h=0,c=this._moduleIdProvider.getMaxModuleId();h<c;h++)w[h]=!1;var g=!1,b=[];for(b.push(o),w[o]=!0;b.length>0;){var N=b.shift(),_=this._modules2[N];_&&(g=_.onDependencyError(E)||g);var n=this._inverseDependencies2[N];if(n)for(var h=0,c=n.length;h<c;h++){var i=n[h];w[i]||(b.push(i),w[i]=!0)}}g||this._config.onError(E)},l.prototype._hasDependencyPath=function(o,a){var E=this._modules2[o];if(!E)return!1;for(var w=[],h=0,c=this._moduleIdProvider.getMaxModuleId();h<c;h++)w[h]=!1;var g=[];for(g.push(E),w[o]=!0;g.length>0;){var b=g.shift(),N=b.dependencies;if(N)for(var h=0,c=N.length;h<c;h++){var _=N[h];if(_.id===a)return!0;var n=this._modules2[_.id];n&&!w[_.id]&&(w[_.id]=!0,g.push(n))}}return!1},l.prototype._findCyclePath=function(o,a,E){if(o===a||E===50)return[o];var w=this._modules2[o];if(!w)return null;var h=w.dependencies;if(h)for(var c=0,g=h.length;c<g;c++){var b=this._findCyclePath(h[c].id,a,E+1);if(b!==null)return b.push(o),b}return null},l.prototype._createRequire=function(o){var a=this,E=function(w,h,c){return a._relativeRequire(o,w,h,c)};return E.toUrl=function(w){return a._config.requireToUrl(o.resolveModule(w))},E.getStats=function(){return a.getLoaderEvents()},E.hasDependencyCycle=function(){return a._hasDependencyCycle},E.config=function(w,h){h===void 0&&(h=!1),a.configure(w,h)},E.__$__nodeRequire=I.global.nodeRequire,E},l.prototype._loadModule=function(o){var a=this;if(!(this._modules2[o]||this._knownModules2[o])){this._knownModules2[o]=!0;var E=this._moduleIdProvider.getStrModuleId(o),w=this._config.moduleIdToPaths(E),h=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(E.indexOf("/")===-1||h.test(E))&&w.push("node|"+E);var c=-1,g=function(b){if(c++,c>=w.length)a._onLoadError(o,b);else{var N=w[c],_=a.getRecorder();if(a._config.isBuild()&&N==="empty:"){a._buildInfoPath[o]=N,a.defineModule(a._moduleIdProvider.getStrModuleId(o),[],null,null,null),a._onLoad(o);return}_.record(10,N),a._scriptLoader.load(a,N,function(){a._config.isBuild()&&(a._buildInfoPath[o]=N),_.record(11,N),a._onLoad(o)},function(n){_.record(12,N),g(n)})}};g(null)}},l.prototype._loadPluginDependency=function(o,a){var E=this;if(!(this._modules2[a.id]||this._knownModules2[a.id])){this._knownModules2[a.id]=!0;var w=function(h){E.defineModule(E._moduleIdProvider.getStrModuleId(a.id),[],h,null,null)};w.error=function(h){E._config.onError(E._createLoadError(a.id,h))},o.load(a.pluginParam,this._createRequire(t.ROOT),w,this._config.getOptionsLiteral())}},l.prototype._resolve=function(o){var a=this,E=o.dependencies;if(E)for(var w=0,h=E.length;w<h;w++){var c=E[w];if(c===C.EXPORTS){o.exportsPassedIn=!0,o.unresolvedDependenciesCount--;continue}if(c===C.MODULE){o.unresolvedDependenciesCount--;continue}if(c===C.REQUIRE){o.unresolvedDependenciesCount--;continue}var g=this._modules2[c.id];if(g&&g.isComplete()){if(g.error){o.onDependencyError(g.error);return}o.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(c.id,o.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(c.id)+"' and '"+this._moduleIdProvider.getStrModuleId(o.id)+"'. The cyclic path follows:");var b=this._findCyclePath(c.id,o.id,0)||[];b.reverse(),b.push(c.id),console.warn(b.map(function(n){return a._moduleIdProvider.getStrModuleId(n)}).join(` => 
`)),o.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[c.id]=this._inverseDependencies2[c.id]||[],this._inverseDependencies2[c.id].push(o.id),c instanceof s){var N=this._modules2[c.pluginId];if(N&&N.isComplete()){this._loadPluginDependency(N.exports,c);continue}var _=this._inversePluginDependencies2.get(c.pluginId);_||(_=[],this._inversePluginDependencies2.set(c.pluginId,_)),_.push(c),this._loadModule(c.pluginId);continue}this._loadModule(c.id)}o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)},l.prototype._onModuleComplete=function(o){var a=this,E=this.getRecorder();if(!o.isComplete()){var w=o.dependencies,h=[];if(w)for(var c=0,g=w.length;c<g;c++){var b=w[c];if(b===C.EXPORTS){h[c]=o.exports;continue}if(b===C.MODULE){h[c]={id:o.strId,config:function(){return a._config.getConfigForModule(o.strId)}};continue}if(b===C.REQUIRE){h[c]=this._createRequire(o.moduleIdResolver);continue}var N=this._modules2[b.id];if(N){h[c]=N.exports;continue}h[c]=null}o.complete(E,this._config,h);var _=this._inverseDependencies2[o.id];if(this._inverseDependencies2[o.id]=null,_)for(var c=0,g=_.length;c<g;c++){var n=_[c],i=this._modules2[n];i.unresolvedDependenciesCount--,i.unresolvedDependenciesCount===0&&this._onModuleComplete(i)}var r=this._inversePluginDependencies2.get(o.id);if(r){this._inversePluginDependencies2.delete(o.id);for(var c=0,g=r.length;c<g;c++)this._loadPluginDependency(o.exports,r[c])}}},l}();I.ModuleManager=S})(ee||(ee={}));var G,ee;(function(I){var t=new I.Environment,M=null,U=function(l,o,a){typeof l!="string"&&(a=o,o=l,l=null),(typeof o!="object"||!Array.isArray(o))&&(a=o,o=null),o||(o=["require","exports","module"]),l?M.defineModule(l,o,a,null,null):M.enqueueDefineAnonymousModule(o,a)};U.amd={jQuery:!0};var C=function(l,o){o===void 0&&(o=!1),M.configure(l,o)},s=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){C(arguments[0]);return}if(typeof arguments[0]=="string")return M.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){M.defineModule(I.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};s.config=C,s.getConfig=function(){return M.getConfig().getOptionsLiteral()},s.reset=function(){M=M.reset()},s.getBuildInfo=function(){return M.getBuildInfo()},s.getStats=function(){return M.getLoaderEvents()},s.define=function(){return U.apply(null,arguments)};function S(){if(typeof I.global.require!="undefined"||typeof require!="undefined"){var l=I.global.require||require;if(typeof l=="function"&&typeof l.resolve=="function"){var o=I.ensureRecordedNodeRequire(M.getRecorder(),l);I.global.nodeRequire=o,s.nodeRequire=o,s.__$__nodeRequire=o}}t.isNode&&!t.isElectronRenderer?(module.exports=s,require=s):(t.isElectronRenderer||(I.global.define=U),I.global.require=s)}I.init=S,(typeof I.global.define!="function"||!I.global.define.amd)&&(M=new I.ModuleManager(t,I.createScriptLoader(t),U,s,I.Utilities.getHighPerformanceTimestamp()),typeof I.global.require!="undefined"&&typeof I.global.require!="function"&&s.config(I.global.require),G=function(){return U.apply(null,arguments)},G.amd=U.amd,typeof doNotInitLoader=="undefined"&&S())})(ee||(ee={}));"use strict";var Se=this,de;(function(I){var t=Se||{},M=t.Plugin&&t.Plugin.Resources?t.Plugin.Resources:void 0,U=t&&t.document&&t.document.location&&t.document.location.hash.indexOf("pseudo=true")>=0;function C(a,E){var w;return E.length===0?w=a:w=a.replace(/\{(\d+)\}/g,function(h,c){var g=c[0];return typeof E[g]!="undefined"?E[g]:h}),U&&(w="\uFF3B"+w.replace(/[aouei]/g,"$&$&")+"\uFF3D"),w}function s(a,E){var w=a[E];return w||(w=a["*"],w)?w:null}function S(a,E){for(var w=[],h=0;h<arguments.length-2;h++)w[h]=arguments[h+2];return C(E,w)}function l(a){return function(E,w){var h=Array.prototype.slice.call(arguments,2);return C(a[E],h)}}var o=function(){function a(){this.localize=S}return a.prototype.setPseudoTranslation=function(E){U=E},a.prototype.create=function(E,w){return{localize:l(w[E])}},a.prototype.load=function(E,w,h,c){if(c=c||{},!E||E.length===0)h({localize:S});else{var g=void 0;if(M&&M.getString)g=".nls.keys",w([E+g],function(_){h({localize:function(n,i){if(!_[n])return"NLS error: unknown key "+n;var r=_[n].keys;if(i>=r.length)return"NLS error unknow index "+i;var u=r[i],f=[];f[0]=n+"_"+u;for(var v=0;v<arguments.length-2;v++)f[v+1]=arguments[v+2];return M.getString.apply(M,f)}})});else if(c.isBuild)w([E+".nls",E+".nls.keys"],function(_,n){a.BUILD_MAP[E]=_,a.BUILD_MAP_KEYS[E]=n,h(_)});else{var b=c["vs/nls"]||{},N=b.availableLanguages?s(b.availableLanguages,E):null;g=".nls",N!==null&&N!==a.DEFAULT_TAG&&(g=g+"."+N),w([E+g],function(_){Array.isArray(_)?_.localize=l(_):_.localize=l(_[E]),h(_)})}}},a.prototype._getEntryPointsMap=function(){return t.nlsPluginEntryPoints=t.nlsPluginEntryPoints||{},t.nlsPluginEntryPoints},a.prototype.write=function(E,w,h){var c=h.getEntryPoint(),g=this._getEntryPointsMap();g[c]=g[c]||[],g[c].push(w),w!==c&&h.asModule(E+"!"+w,"define(['vs/nls', 'vs/nls!"+c+`'], function(nls, data) { return nls.create("`+w+'", data); });')},a.prototype.writeFile=function(E,w,h,c,g){var b=this._getEntryPointsMap();if(b.hasOwnProperty(w)){for(var N=h.toUrl(w+".nls.js"),_=["/*---------------------------------------------------------"," * Copyright (c) Microsoft Corporation. All rights reserved."," *--------------------------------------------------------*/"],n=b[w],i={},r=0;r<n.length;r++)i[n[r]]=a.BUILD_MAP[n[r]];_.push('define("'+w+'.nls", '+JSON.stringify(i,null,"	")+");"),c(N,_.join(`\r
`))}},a.prototype.finishBuild=function(E){E("nls.metadata.json",JSON.stringify({keys:a.BUILD_MAP_KEYS,messages:a.BUILD_MAP,bundles:this._getEntryPointsMap()},null,"	"))},a.DEFAULT_TAG="i-default",a.BUILD_MAP={},a.BUILD_MAP_KEYS={},a}();I.NLSPlugin=o,function(){G("vs/nls",new o)}()})(de||(de={})),G(Q[15],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class M{constructor(C,s,S,l){this.originalStart=C,this.originalLength=s,this.modifiedStart=S,this.modifiedLength=l}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=M}),G(Q[4],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createErrorWithActions=t.isErrorWithActions=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isPromiseCanceledError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class M{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(f){setTimeout(()=>{throw f.stack?new Error(f.message+`

`+f.stack):f},0)}}addListener(f){return this.listeners.push(f),()=>{this._removeListener(f)}}emit(f){this.listeners.forEach(v=>{v(f)})}_removeListener(f){this.listeners.splice(this.listeners.indexOf(f),1)}setUnexpectedErrorHandler(f){this.unexpectedErrorHandler=f}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(f){this.unexpectedErrorHandler(f),this.emit(f)}onUnexpectedExternalError(f){this.unexpectedErrorHandler(f)}}t.ErrorHandler=M,t.errorHandler=new M;function U(u){t.errorHandler.setUnexpectedErrorHandler(u)}t.setUnexpectedErrorHandler=U;function C(u){o(u)||t.errorHandler.onUnexpectedError(u)}t.onUnexpectedError=C;function s(u){o(u)||t.errorHandler.onUnexpectedExternalError(u)}t.onUnexpectedExternalError=s;function S(u){if(u instanceof Error){let{name:f,message:v}=u;const d=u.stacktrace||u.stack;return{$isError:!0,name:f,message:v,stack:d}}return u}t.transformErrorForSerialization=S;const l="Canceled";function o(u){return u instanceof Error&&u.name===l&&u.message===l}t.isPromiseCanceledError=o;class a extends Error{constructor(){super(l);this.name=this.message}}t.CancellationError=a;function E(){const u=new Error(l);return u.name=u.message,u}t.canceled=E;function w(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}t.illegalArgument=w;function h(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}t.illegalState=h;function c(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=c;function g(u){const f=new Error(`${u} has been disposed`);return f.name="DISPOSED",f}t.disposed=g;function b(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}t.getErrorMessage=b;class N extends Error{constructor(f){super("NotImplemented");f&&(this.message=f)}}t.NotImplementedError=N;class _ extends Error{constructor(f){super("NotSupported");f&&(this.message=f)}}t.NotSupportedError=_;class n extends Error{constructor(){super(...arguments);this.isExpected=!0}}t.ExpectedError=n;function i(u){const f=u;return f instanceof Error&&Array.isArray(f.actions)}t.isErrorWithActions=i;function r(u,f=Object.create(null)){const v=new Error(u);return f.actions&&(v.actions=f.actions),v}t.createErrorWithActions=r}),G(Q[7],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function M(U){const C=this;let s=!1,S;return function(){return s||(s=!0,S=U.apply(C,arguments)),S}}t.once=M}),G(Q[16],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var M;(function(U){function C(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}U.is=C;const s=Object.freeze([]);function S(){return s}U.empty=S;function*l(u){yield u}U.single=l;function o(u){return u||s}U.from=o;function a(u){return!u||u[Symbol.iterator]().next().done===!0}U.isEmpty=a;function E(u){return u[Symbol.iterator]().next().value}U.first=E;function w(u,f){for(const v of u)if(f(v))return!0;return!1}U.some=w;function h(u,f){for(const v of u)if(f(v))return v}U.find=h;function*c(u,f){for(const v of u)f(v)&&(yield v)}U.filter=c;function*g(u,f){for(const v of u)yield f(v)}U.map=g;function*b(...u){for(const f of u)for(const v of f)yield v}U.concat=b;function*N(u){for(const f of u)for(const v of f)yield v}U.concatNested=N;function _(u,f,v){let d=v;for(const m of u)d=f(d,m);return d}U.reduce=_;function*n(u,f,v=u.length){for(f<0&&(f+=u.length),v<0?v+=u.length:v>u.length&&(v=u.length);f<v;f++)yield u[f]}U.slice=n;function i(u,f=Number.POSITIVE_INFINITY){const v=[];if(f===0)return[v,u];const d=u[Symbol.iterator]();for(let m=0;m<f;m++){const A=d.next();if(A.done)return[v,U.empty()];v.push(A.value)}return[v,{[Symbol.iterator](){return d}}]}U.consume=i;function r(u,f,v=(d,m)=>d===m){const d=u[Symbol.iterator](),m=f[Symbol.iterator]();for(;;){const A=d.next(),p=m.next();if(A.done!==p.done)return!1;if(A.done)return!0;if(!v(A.value,p.value))return!1}}U.equals=r})(M=t.Iterable||(t.Iterable={}))}),G(Q[17],X([0,1,4]),function(I,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.KeyCode=void 0;var U;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.KEY_0=21]="KEY_0",n[n.KEY_1=22]="KEY_1",n[n.KEY_2=23]="KEY_2",n[n.KEY_3=24]="KEY_3",n[n.KEY_4=25]="KEY_4",n[n.KEY_5=26]="KEY_5",n[n.KEY_6=27]="KEY_6",n[n.KEY_7=28]="KEY_7",n[n.KEY_8=29]="KEY_8",n[n.KEY_9=30]="KEY_9",n[n.KEY_A=31]="KEY_A",n[n.KEY_B=32]="KEY_B",n[n.KEY_C=33]="KEY_C",n[n.KEY_D=34]="KEY_D",n[n.KEY_E=35]="KEY_E",n[n.KEY_F=36]="KEY_F",n[n.KEY_G=37]="KEY_G",n[n.KEY_H=38]="KEY_H",n[n.KEY_I=39]="KEY_I",n[n.KEY_J=40]="KEY_J",n[n.KEY_K=41]="KEY_K",n[n.KEY_L=42]="KEY_L",n[n.KEY_M=43]="KEY_M",n[n.KEY_N=44]="KEY_N",n[n.KEY_O=45]="KEY_O",n[n.KEY_P=46]="KEY_P",n[n.KEY_Q=47]="KEY_Q",n[n.KEY_R=48]="KEY_R",n[n.KEY_S=49]="KEY_S",n[n.KEY_T=50]="KEY_T",n[n.KEY_U=51]="KEY_U",n[n.KEY_V=52]="KEY_V",n[n.KEY_W=53]="KEY_W",n[n.KEY_X=54]="KEY_X",n[n.KEY_Y=55]="KEY_Y",n[n.KEY_Z=56]="KEY_Z",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.US_SEMICOLON=80]="US_SEMICOLON",n[n.US_EQUAL=81]="US_EQUAL",n[n.US_COMMA=82]="US_COMMA",n[n.US_MINUS=83]="US_MINUS",n[n.US_DOT=84]="US_DOT",n[n.US_SLASH=85]="US_SLASH",n[n.US_BACKTICK=86]="US_BACKTICK",n[n.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",n[n.US_BACKSLASH=88]="US_BACKSLASH",n[n.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",n[n.US_QUOTE=90]="US_QUOTE",n[n.OEM_8=91]="OEM_8",n[n.OEM_102=92]="OEM_102",n[n.NUMPAD_0=93]="NUMPAD_0",n[n.NUMPAD_1=94]="NUMPAD_1",n[n.NUMPAD_2=95]="NUMPAD_2",n[n.NUMPAD_3=96]="NUMPAD_3",n[n.NUMPAD_4=97]="NUMPAD_4",n[n.NUMPAD_5=98]="NUMPAD_5",n[n.NUMPAD_6=99]="NUMPAD_6",n[n.NUMPAD_7=100]="NUMPAD_7",n[n.NUMPAD_8=101]="NUMPAD_8",n[n.NUMPAD_9=102]="NUMPAD_9",n[n.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",n[n.NUMPAD_ADD=104]="NUMPAD_ADD",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",n[n.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",n[n.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.MAX_VALUE=112]="MAX_VALUE"})(U=t.KeyCode||(t.KeyCode={}));class C{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(i,r){this._keyCodeToStr[i]=r,this._strToKeyCode[r.toLowerCase()]=i}keyCodeToStr(i){return this._keyCodeToStr[i]}strToKeyCode(i){return this._strToKeyCode[i.toLowerCase()]||0}}const s=new C,S=new C,l=new C;(function(){function n(i,r,u=r,f=u){s.define(i,r),S.define(i,u),l.define(i,f)}n(0,"unknown"),n(1,"Backspace"),n(2,"Tab"),n(3,"Enter"),n(4,"Shift"),n(5,"Ctrl"),n(6,"Alt"),n(7,"PauseBreak"),n(8,"CapsLock"),n(9,"Escape"),n(10,"Space"),n(11,"PageUp"),n(12,"PageDown"),n(13,"End"),n(14,"Home"),n(15,"LeftArrow","Left"),n(16,"UpArrow","Up"),n(17,"RightArrow","Right"),n(18,"DownArrow","Down"),n(19,"Insert"),n(20,"Delete"),n(21,"0"),n(22,"1"),n(23,"2"),n(24,"3"),n(25,"4"),n(26,"5"),n(27,"6"),n(28,"7"),n(29,"8"),n(30,"9"),n(31,"A"),n(32,"B"),n(33,"C"),n(34,"D"),n(35,"E"),n(36,"F"),n(37,"G"),n(38,"H"),n(39,"I"),n(40,"J"),n(41,"K"),n(42,"L"),n(43,"M"),n(44,"N"),n(45,"O"),n(46,"P"),n(47,"Q"),n(48,"R"),n(49,"S"),n(50,"T"),n(51,"U"),n(52,"V"),n(53,"W"),n(54,"X"),n(55,"Y"),n(56,"Z"),n(57,"Meta"),n(58,"ContextMenu"),n(59,"F1"),n(60,"F2"),n(61,"F3"),n(62,"F4"),n(63,"F5"),n(64,"F6"),n(65,"F7"),n(66,"F8"),n(67,"F9"),n(68,"F10"),n(69,"F11"),n(70,"F12"),n(71,"F13"),n(72,"F14"),n(73,"F15"),n(74,"F16"),n(75,"F17"),n(76,"F18"),n(77,"F19"),n(78,"NumLock"),n(79,"ScrollLock"),n(80,";",";","OEM_1"),n(81,"=","=","OEM_PLUS"),n(82,",",",","OEM_COMMA"),n(83,"-","-","OEM_MINUS"),n(84,".",".","OEM_PERIOD"),n(85,"/","/","OEM_2"),n(86,"`","`","OEM_3"),n(110,"ABNT_C1"),n(111,"ABNT_C2"),n(87,"[","[","OEM_4"),n(88,"\\","\\","OEM_5"),n(89,"]","]","OEM_6"),n(90,"'","'","OEM_7"),n(91,"OEM_8"),n(92,"OEM_102"),n(93,"NumPad0"),n(94,"NumPad1"),n(95,"NumPad2"),n(96,"NumPad3"),n(97,"NumPad4"),n(98,"NumPad5"),n(99,"NumPad6"),n(100,"NumPad7"),n(101,"NumPad8"),n(102,"NumPad9"),n(103,"NumPad_Multiply"),n(104,"NumPad_Add"),n(105,"NumPad_Separator"),n(106,"NumPad_Subtract"),n(107,"NumPad_Decimal"),n(108,"NumPad_Divide")})();var o;(function(n){function i(d){return s.keyCodeToStr(d)}n.toString=i;function r(d){return s.strToKeyCode(d)}n.fromString=r;function u(d){return S.keyCodeToStr(d)}n.toUserSettingsUS=u;function f(d){return l.keyCodeToStr(d)}n.toUserSettingsGeneral=f;function v(d){return S.strToKeyCode(d)||l.strToKeyCode(d)}n.fromUserSettings=v})(o=t.KeyCodeUtils||(t.KeyCodeUtils={}));var a;(function(n){n[n.CtrlCmd=2048]="CtrlCmd",n[n.Shift=1024]="Shift",n[n.Alt=512]="Alt",n[n.WinCtrl=256]="WinCtrl",n[n.KeyCode=255]="KeyCode"})(a||(a={}));var E;(function(n){n[n.CtrlCmd=2048]="CtrlCmd",n[n.Shift=1024]="Shift",n[n.Alt=512]="Alt",n[n.WinCtrl=256]="WinCtrl"})(E=t.KeyMod||(t.KeyMod={}));function w(n,i){const r=(i&65535)<<16>>>0;return(n|r)>>>0}t.KeyChord=w;function h(n,i){if(n===0)return null;const r=(n&65535)>>>0,u=(n&4294901760)>>>16;return u!==0?new b([c(r,i),c(u,i)]):new b([c(r,i)])}t.createKeybinding=h;function c(n,i){const r=!!(n&2048),u=!!(n&256),f=i===2?u:r,v=!!(n&1024),d=!!(n&512),m=i===2?r:u,A=n&255;return new g(f,v,d,m,A)}t.createSimpleKeybinding=c;class g{constructor(i,r,u,f,v){this.ctrlKey=i,this.shiftKey=r,this.altKey=u,this.metaKey=f,this.keyCode=v}equals(i){return this.ctrlKey===i.ctrlKey&&this.shiftKey===i.shiftKey&&this.altKey===i.altKey&&this.metaKey===i.metaKey&&this.keyCode===i.keyCode}getHashCode(){const i=this.ctrlKey?"1":"0",r=this.shiftKey?"1":"0",u=this.altKey?"1":"0",f=this.metaKey?"1":"0";return`${i}${r}${u}${f}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new b([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=g;class b{constructor(i){if(i.length===0)throw(0,M.illegalArgument)("parts");this.parts=i}getHashCode(){let i="";for(let r=0,u=this.parts.length;r<u;r++)r!==0&&(i+=";"),i+=this.parts[r].getHashCode();return i}equals(i){if(i===null||this.parts.length!==i.parts.length)return!1;for(let r=0;r<this.parts.length;r++)if(!this.parts[r].equals(i.parts[r]))return!1;return!0}}t.ChordKeybinding=b;class N{constructor(i,r,u,f,v,d){this.ctrlKey=i,this.shiftKey=r,this.altKey=u,this.metaKey=f,this.keyLabel=v,this.keyAriaLabel=d}}t.ResolvedKeybindingPart=N;class _{}t.ResolvedKeybinding=_}),G(Q[8],X([0,1,7,16]),function(I,t,M,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ImmortalReference=t.ReferenceCollection=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=t.trackDisposable=t.setDisposableTracker=void 0;const C=!1;let s=null;function S(i){s=i}if(t.setDisposableTracker=S,C){const i="__is_disposable_tracked__";s=new class{trackDisposable(r){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[i]||console.log(u)},3e3)}markTracked(r){if(r&&r!==b.None)try{r[i]=!0}catch(u){}}}}function l(i){!s||s.markTracked(i)}function o(i){return s&&s.trackDisposable(i),i}t.trackDisposable=o;class a extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}t.MultiDisposeError=a;function E(i){return typeof i.dispose=="function"&&i.dispose.length===0}t.isDisposable=E;function w(i){if(U.Iterable.is(i)){let r=[];for(const u of i)if(u){l(u);try{u.dispose()}catch(f){r.push(f)}}if(r.length===1)throw r[0];if(r.length>1)throw new a(r);return Array.isArray(i)?[]:i}else if(i)return l(i),i.dispose(),i}t.dispose=w;function h(...i){return i.forEach(l),c(()=>w(i))}t.combinedDisposable=h;function c(i){const r=o({dispose:()=>{l(r),i()}});return r}t.toDisposable=c;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(l(this),this._isDisposed=!0,this.clear())}clear(){try{w(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return l(r),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}t.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new g,o(this)}dispose(){l(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}t.Disposable=b,b.None=Object.freeze({dispose(){}});class N{constructor(){this._isDisposed=!1,o(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){var u;this._isDisposed||r===this._value||((u=this._value)===null||u===void 0||u.dispose(),r&&l(r),this._value=r)}clear(){this.value=void 0}dispose(){var r;this._isDisposed=!0,l(this),(r=this._value)===null||r===void 0||r.dispose(),this._value=void 0}}t.MutableDisposable=N;class _{constructor(){this.references=new Map}acquire(r,...u){let f=this.references.get(r);f||(f={counter:0,object:this.createReferencedObject(r,...u)},this.references.set(r,f));const{object:v}=f,d=(0,M.once)(()=>{--f.counter==0&&(this.destroyReferencedObject(r,f.object),this.references.delete(r))});return f.counter++,{object:v,dispose:d}}}t.ReferenceCollection=_;class n{constructor(r){this.object=r}dispose(){}}t.ImmortalReference=n}),G(Q[18],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class M{constructor(s){this.element=s,this.next=M.Undefined,this.prev=M.Undefined}}M.Undefined=new M(void 0);class U{constructor(){this._first=M.Undefined,this._last=M.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===M.Undefined}clear(){let s=this._first;for(;s!==M.Undefined;){const S=s.next;s.prev=M.Undefined,s.next=M.Undefined,s=S}this._first=M.Undefined,this._last=M.Undefined,this._size=0}unshift(s){return this._insert(s,!1)}push(s){return this._insert(s,!0)}_insert(s,S){const l=new M(s);if(this._first===M.Undefined)this._first=l,this._last=l;else if(S){const a=this._last;this._last=l,l.prev=a,a.next=l}else{const a=this._first;this._first=l,l.next=a,a.prev=l}this._size+=1;let o=!1;return()=>{o||(o=!0,this._remove(l))}}shift(){if(this._first!==M.Undefined){const s=this._first.element;return this._remove(this._first),s}}pop(){if(this._last!==M.Undefined){const s=this._last.element;return this._remove(this._last),s}}_remove(s){if(s.prev!==M.Undefined&&s.next!==M.Undefined){const S=s.prev;S.next=s.next,s.next.prev=S}else s.prev===M.Undefined&&s.next===M.Undefined?(this._first=M.Undefined,this._last=M.Undefined):s.next===M.Undefined?(this._last=this._last.prev,this._last.next=M.Undefined):s.prev===M.Undefined&&(this._first=this._first.next,this._first.prev=M.Undefined);this._size-=1}*[Symbol.iterator](){let s=this._first;for(;s!==M.Undefined;)yield s.element,s=s.next}}t.LinkedList=U}),G(Q[2],X([0,1]),function(I,t){"use strict";var M;Object.defineProperty(t,"__esModule",{value:!0}),t.isLittleEndian=t.OS=t.OperatingSystem=t.setImmediate=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isIOS=t.isWeb=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.isPreferringBrowserCodeLoad=t.browserCodeLoadingCacheStrategy=t.isElectronSandboxed=t.globals=void 0;const U="en";let C=!1,s=!1,S=!1,l=!1,o=!1,a=!1,E=!1,w,h=U,c,g;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let b;typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.process!="undefined"?b=t.globals.vscode.process:typeof process!="undefined"&&(b=process);const N=typeof((M=b==null?void 0:b.versions)===null||M===void 0?void 0:M.electron)=="string"&&b.type==="renderer";if(t.isElectronSandboxed=N&&(b==null?void 0:b.sandboxed),t.browserCodeLoadingCacheStrategy=(()=>{if(t.isElectronSandboxed)return"bypassHeatCheck";const m=b==null?void 0:b.env.VSCODE_BROWSER_CODE_LOADING;if(typeof m=="string")return m==="none"||m==="code"||m==="bypassHeatCheck"||m==="bypassHeatCheckAndEagerCompile"?m:"bypassHeatCheck"})(),t.isPreferringBrowserCodeLoad=typeof t.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!N)g=navigator.userAgent,C=g.indexOf("Windows")>=0,s=g.indexOf("Macintosh")>=0,E=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=g.indexOf("Linux")>=0,a=!0,w=navigator.language,h=w;else if(typeof b=="object"){C=b.platform==="win32",s=b.platform==="darwin",S=b.platform==="linux",l=S&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,w=U,h=U;const m=b.env.VSCODE_NLS_CONFIG;if(m)try{const A=JSON.parse(m),p=A.availableLanguages["*"];w=A.locale,h=p||U,c=A._translationsConfigFile}catch(A){}o=!0}else console.error("Unable to resolve platform.");var _;(function(m){m[m.Web=0]="Web",m[m.Mac=1]="Mac",m[m.Linux=2]="Linux",m[m.Windows=3]="Windows"})(_=t.Platform||(t.Platform={}));function n(m){switch(m){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=n;let i=0;s?i=1:C?i=3:S&&(i=2),t.isWindows=C,t.isMacintosh=s,t.isLinux=S,t.isLinuxSnap=l,t.isNative=o,t.isWeb=a,t.isIOS=E,t.platform=i,t.userAgent=g,t.language=h;var r;(function(m){function A(){return t.language}m.value=A;function p(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}m.isDefaultVariant=p;function P(){return t.language==="en"}m.isDefault=P})(r=t.Language||(t.Language={})),t.locale=w,t.translationsConfigFile=c,t.setImmediate=function(){if(t.globals.setImmediate)return t.globals.setImmediate.bind(t.globals);if(typeof t.globals.postMessage=="function"&&!t.globals.importScripts){let p=[];t.globals.addEventListener("message",F=>{if(F.data&&F.data.vscodeSetImmediateId)for(let R=0,y=p.length;R<y;R++){const q=p[R];if(q.id===F.data.vscodeSetImmediateId){p.splice(R,1),q.callback();return}}});let P=0;return F=>{const R=++P;p.push({id:R,callback:F}),t.globals.postMessage({vscodeSetImmediateId:R},"*")}}if(typeof(b==null?void 0:b.nextTick)=="function")return b.nextTick.bind(b);const A=Promise.resolve();return p=>A.then(p)}();var u;(function(m){m[m.Windows=1]="Windows",m[m.Macintosh=2]="Macintosh",m[m.Linux=3]="Linux"})(u=t.OperatingSystem||(t.OperatingSystem={})),t.OS=s||E?2:C?1:3;let f=!0,v=!1;function d(){if(!v){v=!0;const m=new Uint8Array(2);m[0]=1,m[1]=2,f=new Uint16Array(m.buffer)[0]===(2<<8)+1}return f}t.isLittleEndian=d}),G(Q[19],X([0,1,2]),function(I,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.nextTick=t.platform=t.env=t.cwd=void 0;let U;if(typeof M.globals.vscode!="undefined"&&typeof M.globals.vscode.process!="undefined"){const C=M.globals.vscode.process;U={get platform(){return C.platform},get env(){return C.env},cwd(){return C.cwd()},nextTick(s){return(0,M.setImmediate)(s)}}}else typeof process!="undefined"?U={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:U={get platform(){return M.isWindows?"win32":M.isMacintosh?"darwin":"linux"},nextTick(C){return(0,M.setImmediate)(C)},get env(){return Object.create(null)},cwd(){return"/"}};t.cwd=U.cwd,t.env=U.env,t.platform=U.platform,t.nextTick=U.nextTick}),G(Q[20],X([0,1,19]),function(I,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const U=65,C=97,s=90,S=122,l=46,o=47,a=92,E=58,w=63;class h extends Error{constructor(r,u,f){let v;typeof u=="string"&&u.indexOf("not ")===0?(v="must not be",u=u.replace(/^not /,"")):v="must be";const d=r.indexOf(".")!==-1?"property":"argument";let m=`The "${r}" ${d} ${v} of type ${u}`;m+=`. Received type ${typeof f}`,super(m),this.code="ERR_INVALID_ARG_TYPE"}}function c(i,r){if(typeof i!="string")throw new h(r,"string",i)}function g(i){return i===o||i===a}function b(i){return i===o}function N(i){return i>=U&&i<=s||i>=C&&i<=S}function _(i,r,u,f){let v="",d=0,m=-1,A=0,p=0;for(let P=0;P<=i.length;++P){if(P<i.length)p=i.charCodeAt(P);else{if(f(p))break;p=o}if(f(p)){if(!(m===P-1||A===1))if(A===2){if(v.length<2||d!==2||v.charCodeAt(v.length-1)!==l||v.charCodeAt(v.length-2)!==l){if(v.length>2){const F=v.lastIndexOf(u);F===-1?(v="",d=0):(v=v.slice(0,F),d=v.length-1-v.lastIndexOf(u)),m=P,A=0;continue}else if(v.length!==0){v="",d=0,m=P,A=0;continue}}r&&(v+=v.length>0?`${u}..`:"..",d=2)}else v.length>0?v+=`${u}${i.slice(m+1,P)}`:v=i.slice(m+1,P),d=P-m-1;m=P,A=0}else p===l&&A!==-1?++A:A=-1}return v}function n(i,r){if(r===null||typeof r!="object")throw new h("pathObject","Object",r);const u=r.dir||r.root,f=r.base||`${r.name||""}${r.ext||""}`;return u?u===r.root?`${u}${f}`:`${u}${i}${f}`:f}t.win32={resolve(...i){let r="",u="",f=!1;for(let v=i.length-1;v>=-1;v--){let d;if(v>=0){if(d=i[v],c(d,"path"),d.length===0)continue}else r.length===0?d=M.cwd():(d=M.env[`=${r}`]||M.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==r.toLowerCase()&&d.charCodeAt(2)===a)&&(d=`${r}\\`));const m=d.length;let A=0,p="",P=!1;const F=d.charCodeAt(0);if(m===1)g(F)&&(A=1,P=!0);else if(g(F))if(P=!0,g(d.charCodeAt(1))){let R=2,y=R;for(;R<m&&!g(d.charCodeAt(R));)R++;if(R<m&&R!==y){const q=d.slice(y,R);for(y=R;R<m&&g(d.charCodeAt(R));)R++;if(R<m&&R!==y){for(y=R;R<m&&!g(d.charCodeAt(R));)R++;(R===m||R!==y)&&(p=`\\\\${q}\\${d.slice(y,R)}`,A=R)}}}else A=1;else N(F)&&d.charCodeAt(1)===E&&(p=d.slice(0,2),A=2,m>2&&g(d.charCodeAt(2))&&(P=!0,A=3));if(p.length>0)if(r.length>0){if(p.toLowerCase()!==r.toLowerCase())continue}else r=p;if(f){if(r.length>0)break}else if(u=`${d.slice(A)}\\${u}`,f=P,P&&r.length>0)break}return u=_(u,!f,"\\",g),f?`${r}\\${u}`:`${r}${u}`||"."},normalize(i){c(i,"path");const r=i.length;if(r===0)return".";let u=0,f,v=!1;const d=i.charCodeAt(0);if(r===1)return b(d)?"\\":i;if(g(d))if(v=!0,g(i.charCodeAt(1))){let A=2,p=A;for(;A<r&&!g(i.charCodeAt(A));)A++;if(A<r&&A!==p){const P=i.slice(p,A);for(p=A;A<r&&g(i.charCodeAt(A));)A++;if(A<r&&A!==p){for(p=A;A<r&&!g(i.charCodeAt(A));)A++;if(A===r)return`\\\\${P}\\${i.slice(p)}\\`;A!==p&&(f=`\\\\${P}\\${i.slice(p,A)}`,u=A)}}}else u=1;else N(d)&&i.charCodeAt(1)===E&&(f=i.slice(0,2),u=2,r>2&&g(i.charCodeAt(2))&&(v=!0,u=3));let m=u<r?_(i.slice(u),!v,"\\",g):"";return m.length===0&&!v&&(m="."),m.length>0&&g(i.charCodeAt(r-1))&&(m+="\\"),f===void 0?v?`\\${m}`:m:v?`${f}\\${m}`:`${f}${m}`},isAbsolute(i){c(i,"path");const r=i.length;if(r===0)return!1;const u=i.charCodeAt(0);return g(u)||r>2&&N(u)&&i.charCodeAt(1)===E&&g(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let r,u;for(let d=0;d<i.length;++d){const m=i[d];c(m,"path"),m.length>0&&(r===void 0?r=u=m:r+=`\\${m}`)}if(r===void 0)return".";let f=!0,v=0;if(typeof u=="string"&&g(u.charCodeAt(0))){++v;const d=u.length;d>1&&g(u.charCodeAt(1))&&(++v,d>2&&(g(u.charCodeAt(2))?++v:f=!1))}if(f){for(;v<r.length&&g(r.charCodeAt(v));)v++;v>=2&&(r=`\\${r.slice(v)}`)}return t.win32.normalize(r)},relative(i,r){if(c(i,"from"),c(r,"to"),i===r)return"";const u=t.win32.resolve(i),f=t.win32.resolve(r);if(u===f||(i=u.toLowerCase(),r=f.toLowerCase(),i===r))return"";let v=0;for(;v<i.length&&i.charCodeAt(v)===a;)v++;let d=i.length;for(;d-1>v&&i.charCodeAt(d-1)===a;)d--;const m=d-v;let A=0;for(;A<r.length&&r.charCodeAt(A)===a;)A++;let p=r.length;for(;p-1>A&&r.charCodeAt(p-1)===a;)p--;const P=p-A,F=m<P?m:P;let R=-1,y=0;for(;y<F;y++){const $=i.charCodeAt(v+y);if($!==r.charCodeAt(A+y))break;$===a&&(R=y)}if(y!==F){if(R===-1)return f}else{if(P>F){if(r.charCodeAt(A+y)===a)return f.slice(A+y+1);if(y===2)return f.slice(A+y)}m>F&&(i.charCodeAt(v+y)===a?R=y:y===2&&(R=3)),R===-1&&(R=0)}let q="";for(y=v+R+1;y<=d;++y)(y===d||i.charCodeAt(y)===a)&&(q+=q.length===0?"..":"\\..");return A+=R,q.length>0?`${q}${f.slice(A,p)}`:(f.charCodeAt(A)===a&&++A,f.slice(A,p))},toNamespacedPath(i){if(typeof i!="string")return i;if(i.length===0)return"";const r=t.win32.resolve(i);if(r.length<=2)return i;if(r.charCodeAt(0)===a){if(r.charCodeAt(1)===a){const u=r.charCodeAt(2);if(u!==w&&u!==l)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(N(r.charCodeAt(0))&&r.charCodeAt(1)===E&&r.charCodeAt(2)===a)return`\\\\?\\${r}`;return i},dirname(i){c(i,"path");const r=i.length;if(r===0)return".";let u=-1,f=0;const v=i.charCodeAt(0);if(r===1)return g(v)?i:".";if(g(v)){if(u=f=1,g(i.charCodeAt(1))){let A=2,p=A;for(;A<r&&!g(i.charCodeAt(A));)A++;if(A<r&&A!==p){for(p=A;A<r&&g(i.charCodeAt(A));)A++;if(A<r&&A!==p){for(p=A;A<r&&!g(i.charCodeAt(A));)A++;if(A===r)return i;A!==p&&(u=f=A+1)}}}}else N(v)&&i.charCodeAt(1)===E&&(u=r>2&&g(i.charCodeAt(2))?3:2,f=u);let d=-1,m=!0;for(let A=r-1;A>=f;--A)if(g(i.charCodeAt(A))){if(!m){d=A;break}}else m=!1;if(d===-1){if(u===-1)return".";d=u}return i.slice(0,d)},basename(i,r){r!==void 0&&c(r,"ext"),c(i,"path");let u=0,f=-1,v=!0,d;if(i.length>=2&&N(i.charCodeAt(0))&&i.charCodeAt(1)===E&&(u=2),r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let m=r.length-1,A=-1;for(d=i.length-1;d>=u;--d){const p=i.charCodeAt(d);if(g(p)){if(!v){u=d+1;break}}else A===-1&&(v=!1,A=d+1),m>=0&&(p===r.charCodeAt(m)?--m==-1&&(f=d):(m=-1,f=A))}return u===f?f=A:f===-1&&(f=i.length),i.slice(u,f)}for(d=i.length-1;d>=u;--d)if(g(i.charCodeAt(d))){if(!v){u=d+1;break}}else f===-1&&(v=!1,f=d+1);return f===-1?"":i.slice(u,f)},extname(i){c(i,"path");let r=0,u=-1,f=0,v=-1,d=!0,m=0;i.length>=2&&i.charCodeAt(1)===E&&N(i.charCodeAt(0))&&(r=f=2);for(let A=i.length-1;A>=r;--A){const p=i.charCodeAt(A);if(g(p)){if(!d){f=A+1;break}continue}v===-1&&(d=!1,v=A+1),p===l?u===-1?u=A:m!==1&&(m=1):u!==-1&&(m=-1)}return u===-1||v===-1||m===0||m===1&&u===v-1&&u===f+1?"":i.slice(u,v)},format:n.bind(null,"\\"),parse(i){c(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const u=i.length;let f=0,v=i.charCodeAt(0);if(u===1)return g(v)?(r.root=r.dir=i,r):(r.base=r.name=i,r);if(g(v)){if(f=1,g(i.charCodeAt(1))){let R=2,y=R;for(;R<u&&!g(i.charCodeAt(R));)R++;if(R<u&&R!==y){for(y=R;R<u&&g(i.charCodeAt(R));)R++;if(R<u&&R!==y){for(y=R;R<u&&!g(i.charCodeAt(R));)R++;R===u?f=R:R!==y&&(f=R+1)}}}}else if(N(v)&&i.charCodeAt(1)===E){if(u<=2)return r.root=r.dir=i,r;if(f=2,g(i.charCodeAt(2))){if(u===3)return r.root=r.dir=i,r;f=3}}f>0&&(r.root=i.slice(0,f));let d=-1,m=f,A=-1,p=!0,P=i.length-1,F=0;for(;P>=f;--P){if(v=i.charCodeAt(P),g(v)){if(!p){m=P+1;break}continue}A===-1&&(p=!1,A=P+1),v===l?d===-1?d=P:F!==1&&(F=1):d!==-1&&(F=-1)}return A!==-1&&(d===-1||F===0||F===1&&d===A-1&&d===m+1?r.base=r.name=i.slice(m,A):(r.name=i.slice(m,d),r.base=i.slice(m,A),r.ext=i.slice(d,A))),m>0&&m!==f?r.dir=i.slice(0,m-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...i){let r="",u=!1;for(let f=i.length-1;f>=-1&&!u;f--){const v=f>=0?i[f]:M.cwd();c(v,"path"),v.length!==0&&(r=`${v}/${r}`,u=v.charCodeAt(0)===o)}return r=_(r,!u,"/",b),u?`/${r}`:r.length>0?r:"."},normalize(i){if(c(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===o,u=i.charCodeAt(i.length-1)===o;return i=_(i,!r,"/",b),i.length===0?r?"/":u?"./":".":(u&&(i+="/"),r?`/${i}`:i)},isAbsolute(i){return c(i,"path"),i.length>0&&i.charCodeAt(0)===o},join(...i){if(i.length===0)return".";let r;for(let u=0;u<i.length;++u){const f=i[u];c(f,"path"),f.length>0&&(r===void 0?r=f:r+=`/${f}`)}return r===void 0?".":t.posix.normalize(r)},relative(i,r){if(c(i,"from"),c(r,"to"),i===r||(i=t.posix.resolve(i),r=t.posix.resolve(r),i===r))return"";const u=1,f=i.length,v=f-u,d=1,m=r.length-d,A=v<m?v:m;let p=-1,P=0;for(;P<A;P++){const R=i.charCodeAt(u+P);if(R!==r.charCodeAt(d+P))break;R===o&&(p=P)}if(P===A)if(m>A){if(r.charCodeAt(d+P)===o)return r.slice(d+P+1);if(P===0)return r.slice(d+P)}else v>A&&(i.charCodeAt(u+P)===o?p=P:P===0&&(p=0));let F="";for(P=u+p+1;P<=f;++P)(P===f||i.charCodeAt(P)===o)&&(F+=F.length===0?"..":"/..");return`${F}${r.slice(d+p)}`},toNamespacedPath(i){return i},dirname(i){if(c(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===o;let u=-1,f=!0;for(let v=i.length-1;v>=1;--v)if(i.charCodeAt(v)===o){if(!f){u=v;break}}else f=!1;return u===-1?r?"/":".":r&&u===1?"//":i.slice(0,u)},basename(i,r){r!==void 0&&c(r,"ext"),c(i,"path");let u=0,f=-1,v=!0,d;if(r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let m=r.length-1,A=-1;for(d=i.length-1;d>=0;--d){const p=i.charCodeAt(d);if(p===o){if(!v){u=d+1;break}}else A===-1&&(v=!1,A=d+1),m>=0&&(p===r.charCodeAt(m)?--m==-1&&(f=d):(m=-1,f=A))}return u===f?f=A:f===-1&&(f=i.length),i.slice(u,f)}for(d=i.length-1;d>=0;--d)if(i.charCodeAt(d)===o){if(!v){u=d+1;break}}else f===-1&&(v=!1,f=d+1);return f===-1?"":i.slice(u,f)},extname(i){c(i,"path");let r=-1,u=0,f=-1,v=!0,d=0;for(let m=i.length-1;m>=0;--m){const A=i.charCodeAt(m);if(A===o){if(!v){u=m+1;break}continue}f===-1&&(v=!1,f=m+1),A===l?r===-1?r=m:d!==1&&(d=1):r!==-1&&(d=-1)}return r===-1||f===-1||d===0||d===1&&r===f-1&&r===u+1?"":i.slice(r,f)},format:n.bind(null,"/"),parse(i){c(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const u=i.charCodeAt(0)===o;let f;u?(r.root="/",f=1):f=0;let v=-1,d=0,m=-1,A=!0,p=i.length-1,P=0;for(;p>=f;--p){const F=i.charCodeAt(p);if(F===o){if(!A){d=p+1;break}continue}m===-1&&(A=!1,m=p+1),F===l?v===-1?v=p:P!==1&&(P=1):v!==-1&&(P=-1)}if(m!==-1){const F=d===0&&u?1:d;v===-1||P===0||P===1&&v===m-1&&v===d+1?r.base=r.name=i.slice(F,m):(r.name=i.slice(F,v),r.base=i.slice(F,m),r.ext=i.slice(v,m))}return d>0?r.dir=i.slice(0,d-1):u&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=M.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=M.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=M.platform==="win32"?t.win32.join:t.posix.join,t.resolve=M.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=M.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=M.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=M.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=M.platform==="win32"?t.win32.extname:t.posix.extname,t.format=M.platform==="win32"?t.win32.format:t.posix.format,t.parse=M.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=M.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=M.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=M.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),G(Q[9],X([0,1,2]),function(I,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const U=M.globals.performance&&typeof M.globals.performance.now=="function";class C{constructor(S){this._highResolution=U&&S,this._startTime=this._now(),this._stopTime=-1}static create(S=!0){return new C(S)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?M.globals.performance.now():Date.now()}}t.StopWatch=C}),G(Q[10],X([0,1,4,7,8,18,9]),function(I,t,M,U,C,s,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.PauseableEmitter=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0;var l;(function(_){_.None=()=>C.Disposable.None;function n(H){return(W,O=null,j)=>{let Z=!1,J;return J=H(K=>{if(!Z)return J?J.dispose():Z=!0,W.call(O,K)},null,j),Z&&J.dispose(),J}}_.once=n;function i(H,W){return m((O,j=null,Z)=>H(J=>O.call(j,W(J)),null,Z))}_.map=i;function r(H,W){return m((O,j=null,Z)=>H(J=>{W(J),O.call(j,J)},null,Z))}_.forEach=r;function u(H,W){return m((O,j=null,Z)=>H(J=>W(J)&&O.call(j,J),null,Z))}_.filter=u;function f(H){return H}_.signal=f;function v(...H){return(W,O=null,j)=>(0,C.combinedDisposable)(...H.map(Z=>Z(J=>W.call(O,J),null,j)))}_.any=v;function d(H,W,O){let j=O;return i(H,Z=>(j=W(j,Z),j))}_.reduce=d;function m(H){let W;const O=new h({onFirstListenerAdd(){W=H(O.fire,O)},onLastListenerRemove(){W.dispose()}});return O.event}_.snapshot=m;function A(H,W,O=100,j=!1,Z){let J,K,ne,ue=0;const oe=new h({leakWarningThreshold:Z,onFirstListenerAdd(){J=H(fe=>{ue++,K=W(K,fe),j&&!ne&&(oe.fire(K),K=void 0),clearTimeout(ne),ne=setTimeout(()=>{const he=K;K=void 0,ne=void 0,(!j||ue>1)&&oe.fire(he),ue=0},O)})},onLastListenerRemove(){J.dispose()}});return oe.event}_.debounce=A;function p(H){const W=new Date().getTime();return i(n(H),O=>new Date().getTime()-W)}_.stopwatch=p;function P(H,W=(O,j)=>O===j){let O=!0,j;return u(H,Z=>{const J=O||!W(Z,j);return O=!1,j=Z,J})}_.latch=P;function F(H,W){return[_.filter(H,W),_.filter(H,O=>!W(O))]}_.split=F;function R(H,W=!1,O=[]){let j=O.slice(),Z=H(ne=>{j?j.push(ne):K.fire(ne)});const J=()=>{j&&j.forEach(ne=>K.fire(ne)),j=null},K=new h({onFirstListenerAdd(){Z||(Z=H(ne=>K.fire(ne)))},onFirstListenerDidAdd(){j&&(W?setTimeout(J):J())},onLastListenerRemove(){Z&&Z.dispose(),Z=null}});return K.event}_.buffer=R;class y{constructor(W){this.event=W}map(W){return new y(i(this.event,W))}forEach(W){return new y(r(this.event,W))}filter(W){return new y(u(this.event,W))}reduce(W,O){return new y(d(this.event,W,O))}latch(){return new y(P(this.event))}debounce(W,O=100,j=!1,Z){return new y(A(this.event,W,O,j,Z))}on(W,O,j){return this.event(W,O,j)}once(W,O,j){return n(this.event)(W,O,j)}}function q(H){return new y(H)}_.chain=q;function $(H,W,O=j=>j){const j=(...ne)=>K.fire(O(...ne)),Z=()=>H.on(W,j),J=()=>H.removeListener(W,j),K=new h({onFirstListenerAdd:Z,onLastListenerRemove:J});return K.event}_.fromNodeEventEmitter=$;function x(H,W,O=j=>j){const j=(...ne)=>K.fire(O(...ne)),Z=()=>H.addEventListener(W,j),J=()=>H.removeEventListener(W,j),K=new h({onFirstListenerAdd:Z,onLastListenerRemove:J});return K.event}_.fromDOMEventEmitter=x;function z(H){const W=new h;let O=!1;return H.then(void 0,()=>null).then(()=>{O?W.fire(void 0):setTimeout(()=>W.fire(void 0),0)}),O=!0,W.event}_.fromPromise=z;function e(H){return new Promise(W=>n(H)(W))}_.toPromise=e})(l=t.Event||(t.Event={}));class o{constructor(n){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${n}_${o._idPool++}`}start(n){this._stopWatch=new S.StopWatch(!0),this._listenerCount=n}stop(){if(this._stopWatch){const n=this._stopWatch.elapsed();this._elapsedOverall+=n,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${n.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}o._idPool=0;let a=-1;function E(_){const n=a;return a=_,{dispose(){a=n}}}t.setGlobalLeakWarningThreshold=E;class w{constructor(n,i=Math.random().toString(18).slice(2,5)){this.customThreshold=n,this.name=i,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(n){let i=a;if(typeof this.customThreshold=="number"&&(i=this.customThreshold),!(i<=0||n<i)){this._stacks||(this._stacks=new Map);const r=new Error().stack.split(`
`).slice(3).join(`
`),u=this._stacks.get(r)||0;if(this._stacks.set(r,u+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=i*.5;let f,v=0;for(const[d,m]of this._stacks)(!f||v<m)&&(f=d,v=m);console.warn(`[${this.name}] potential listener LEAK detected, having ${n} listeners already. MOST frequent listener (${v}):`),console.warn(f)}return()=>{const f=this._stacks.get(r)||0;this._stacks.set(r,f-1)}}}}class h{constructor(n){var i;this._disposed=!1,this._options=n,this._leakageMon=a>0?new w(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((i=this._options)===null||i===void 0?void 0:i._profName)?new o(this._options._profName):void 0}get event(){return this._event||(this._event=(n,i,r)=>{var u;this._listeners||(this._listeners=new s.LinkedList);const f=this._listeners.isEmpty();f&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const v=this._listeners.push(i?[n,i]:n);f&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,n,i);const d=(u=this._leakageMon)===null||u===void 0?void 0:u.check(this._listeners.size);let m;return m={dispose:()=>{d&&d(),m.dispose=h._noop,this._disposed||(v(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},r instanceof C.DisposableStore?r.add(m):Array.isArray(r)&&r.push(m),m}),this._event}fire(n){var i,r;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new s.LinkedList);for(let u of this._listeners)this._deliveryQueue.push([u,n]);for((i=this._perfMon)===null||i===void 0||i.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[u,f]=this._deliveryQueue.shift();try{typeof u=="function"?u.call(void 0,f):u[0].call(u[1],f)}catch(v){(0,M.onUnexpectedError)(v)}}(r=this._perfMon)===null||r===void 0||r.stop()}}dispose(){var n,i,r,u;(n=this._listeners)===null||n===void 0||n.clear(),(i=this._deliveryQueue)===null||i===void 0||i.clear(),((r=this._options)===null||r===void 0?void 0:r.onLastListenerRemove)&&this._options.onLastListenerRemove(),(u=this._leakageMon)===null||u===void 0||u.dispose(),this._disposed=!0}}t.Emitter=h,h._noop=function(){};class c extends h{constructor(n){super(n);this._isPaused=0,this._eventQueue=new s.LinkedList,this._mergeFn=n==null?void 0:n.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const n=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(n))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(n){this._listeners&&(this._isPaused!==0?this._eventQueue.push(n):super.fire(n))}}t.PauseableEmitter=c;class g{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(n){const i={event:n,listener:null};this.events.push(i),this.hasListeners&&this.hook(i);const r=()=>{this.hasListeners&&this.unhook(i);const u=this.events.indexOf(i);this.events.splice(u,1)};return(0,C.toDisposable)((0,U.once)(r))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(n=>this.hook(n))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(n=>this.unhook(n))}hook(n){n.listener=n.event(i=>this.emitter.fire(i))}unhook(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=g;class b{constructor(){this.buffers=[]}wrapEvent(n){return(i,r,u)=>n(f=>{const v=this.buffers[this.buffers.length-1];v?v.push(()=>i.call(r,f)):i.call(r,f)},void 0,u)}bufferEvents(n){const i=[];this.buffers.push(i);const r=n();return this.buffers.pop(),i.forEach(u=>u()),r}}t.EventBufferer=b;class N{constructor(){this.listening=!1,this.inputEvent=l.None,this.inputEventListener=C.Disposable.None,this.emitter=new h({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(n){this.inputEvent=n,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=n(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=N}),G(Q[21],X([0,1,10]),function(I,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const U=Object.freeze(function(l,o){const a=setTimeout(l.bind(o),0);return{dispose(){clearTimeout(a)}}});var C;(function(l){function o(a){return a===l.None||a===l.Cancelled||a instanceof s?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}l.isCancellationToken=o,l.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:M.Event.None}),l.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:U})})(C=t.CancellationToken||(t.CancellationToken={}));class s{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?U:(this._emitter||(this._emitter=new M.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class S{constructor(o){this._token=void 0,this._parentListener=void 0,this._parentListener=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new s),this._token}cancel(){this._token?this._token instanceof s&&this._token.cancel():this._token=C.Cancelled}dispose(o=!1){o&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof s&&this._token.dispose():this._token=C.None}}t.CancellationTokenSource=S}),G(Q[5],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLeftDeleteOffset=t.GraphemeBreakType=t.breakBetweenGraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsEmoji=t.containsRTL=t.decodeUTF8=t.encodeUTF8=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format=t.isFalsyOrWhitespace=void 0;function M(L){return!L||typeof L!="string"?!0:L.trim().length===0}t.isFalsyOrWhitespace=M;const U=/{(\d+)}/g;function C(L,...D){return D.length===0?L:L.replace(U,function(T,k){const B=parseInt(k,10);return isNaN(B)||B<0||B>=D.length?T:D[B]})}t.format=C;function s(L){return L.replace(/[<>&]/g,function(D){switch(D){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return D}})}t.escape=s;function S(L){return L.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=S;function l(L,D){let T=0;const k=D.charCodeAt(0);for(let B=L.length-1;B>=0;B--)L.charCodeAt(B)===k&&T++;return T}t.count=l;function o(L,D,T="\u2026"){return L.length<=D?L:`${L.substr(0,D)}${T}`}t.truncate=o;function a(L,D=" "){const T=E(L,D);return w(T,D)}t.trim=a;function E(L,D){if(!L||!D)return L;const T=D.length;if(T===0||L.length===0)return L;let k=0;for(;L.indexOf(D,k)===k;)k=k+T;return L.substring(k)}t.ltrim=E;function w(L,D){if(!L||!D)return L;const T=D.length,k=L.length;if(T===0||k===0)return L;let B=k,Y=-1;for(;Y=L.lastIndexOf(D,B-1),!(Y===-1||Y+T!==B);){if(Y===0)return"";B=Y}return L.substring(0,B)}t.rtrim=w;function h(L){return L.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=h;function c(L){return L.replace(/\*/g,"")}t.stripWildcards=c;function g(L,D,T={}){if(!L)throw new Error("Cannot create regex from empty string");D||(L=S(L)),T.wholeWord&&(/\B/.test(L.charAt(0))||(L="\\b"+L),/\B/.test(L.charAt(L.length-1))||(L=L+"\\b"));let k="";return T.global&&(k+="g"),T.matchCase||(k+="i"),T.multiline&&(k+="m"),T.unicode&&(k+="u"),new RegExp(L,k)}t.createRegExp=g;function b(L){return L.source==="^"||L.source==="^$"||L.source==="$"||L.source==="^\\s*$"?!1:!!(L.exec("")&&L.lastIndex===0)}t.regExpLeadsToEndlessLoop=b;function N(L){return!!L.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=N;function _(L){return(L.global?"g":"")+(L.ignoreCase?"i":"")+(L.multiline?"m":"")+(L.unicode?"u":"")}t.regExpFlags=_;function n(L){return L.split(/\r\n|\r|\n/)}t.splitLines=n;function i(L){for(let D=0,T=L.length;D<T;D++){const k=L.charCodeAt(D);if(k!==32&&k!==9)return D}return-1}t.firstNonWhitespaceIndex=i;function r(L,D=0,T=L.length){for(let k=D;k<T;k++){const B=L.charCodeAt(k);if(B!==32&&B!==9)return L.substring(D,k)}return L.substring(D,T)}t.getLeadingWhitespace=r;function u(L,D=L.length-1){for(let T=D;T>=0;T--){const k=L.charCodeAt(T);if(k!==32&&k!==9)return T}return-1}t.lastNonWhitespaceIndex=u;function f(L,D){return L<D?-1:L>D?1:0}t.compare=f;function v(L,D,T=0,k=L.length,B=0,Y=D.length){for(;T<k&&B<Y;T++,B++){let ie=L.charCodeAt(T),re=D.charCodeAt(B);if(ie<re)return-1;if(ie>re)return 1}const V=k-T,te=Y-B;return V<te?-1:V>te?1:0}t.compareSubstring=v;function d(L,D){return m(L,D,0,L.length,0,D.length)}t.compareIgnoreCase=d;function m(L,D,T=0,k=L.length,B=0,Y=D.length){for(;T<k&&B<Y;T++,B++){let ie=L.charCodeAt(T),re=D.charCodeAt(B);if(ie!==re){const le=ie-re;if(!(le===32&&p(re))&&!(le===-32&&p(ie)))return A(ie)&&A(re)?le:v(L.toLowerCase(),D.toLowerCase(),T,k,B,Y)}}const V=k-T,te=Y-B;return V<te?-1:V>te?1:0}t.compareSubstringIgnoreCase=m;function A(L){return L>=97&&L<=122}t.isLowerAsciiLetter=A;function p(L){return L>=65&&L<=90}t.isUpperAsciiLetter=p;function P(L){return A(L)||p(L)}function F(L,D){return L.length===D.length&&R(L,D)}t.equalsIgnoreCase=F;function R(L,D,T=L.length){for(let k=0;k<T;k++){const B=L.charCodeAt(k),Y=D.charCodeAt(k);if(B!==Y){if(P(B)&&P(Y)){const V=Math.abs(B-Y);if(V!==0&&V!==32)return!1}else if(String.fromCharCode(B).toLowerCase()!==String.fromCharCode(Y).toLowerCase())return!1}}return!0}function y(L,D){const T=D.length;return D.length>L.length?!1:R(L,D,T)}t.startsWithIgnoreCase=y;function q(L,D){let T,k=Math.min(L.length,D.length);for(T=0;T<k;T++)if(L.charCodeAt(T)!==D.charCodeAt(T))return T;return k}t.commonPrefixLength=q;function $(L,D){let T,k=Math.min(L.length,D.length);const B=L.length-1,Y=D.length-1;for(T=0;T<k;T++)if(L.charCodeAt(B-T)!==D.charCodeAt(Y-T))return T;return k}t.commonSuffixLength=$;function x(L){return 55296<=L&&L<=56319}t.isHighSurrogate=x;function z(L){return 56320<=L&&L<=57343}t.isLowSurrogate=z;function e(L,D){return(L-55296<<10)+(D-56320)+65536}t.computeCodePoint=e;function H(L,D,T){const k=L.charCodeAt(T);if(x(k)&&T+1<D){const B=L.charCodeAt(T+1);if(z(B))return e(k,B)}return k}t.getNextCodePoint=H;function W(L,D){const T=L.charCodeAt(D-1);if(z(T)&&D>1){const k=L.charCodeAt(D-2);if(x(k))return e(k,T)}return T}function O(L,D){const T=se.getInstance(),k=D,B=L.length,Y=H(L,B,D);D+=Y>=65536?2:1;let V=T.getGraphemeBreakType(Y);for(;D<B;){const te=H(L,B,D),ie=T.getGraphemeBreakType(te);if(ae(V,ie))break;D+=te>=65536?2:1,V=ie}return D-k}t.nextCharLength=O;function j(L,D){const T=se.getInstance(),k=D,B=W(L,D);D-=B>=65536?2:1;let Y=T.getGraphemeBreakType(B);for(;D>0;){const V=W(L,D),te=T.getGraphemeBreakType(V);if(ae(te,Y))break;D-=V>=65536?2:1,Y=te}return k-D}t.prevCharLength=j;function Z(L,D){const T=se.getInstance(),k=L.length,B=D,Y=H(L,k,D),V=T.getGraphemeBreakType(Y);D+=Y>=65536?2:1;let te=V;for(;D<k;){const re=H(L,k,D),le=T.getGraphemeBreakType(re);if(ae(te,le))break;D+=re>=65536?2:1,te=le}const ie=D;for(D=B,te=V;D>0;){const re=W(L,D),le=T.getGraphemeBreakType(re);if(ae(le,te))break;D-=re>=65536?2:1,te=le}return[D,ie]}function J(L,D){return D>0&&z(L.charCodeAt(D))?Z(L,D-1):Z(L,D)}t.getCharContainingOffset=J;function K(L){const D=L.length;let T=0,k=0;for(;k<D;){const V=H(L,D,k);k+=V>=65536?2:1,V<128?T+=1:V<2048?T+=2:V<65536?T+=3:T+=4}const B=new Uint8Array(T);k=0;let Y=0;for(;k<D;){const V=H(L,D,k);k+=V>=65536?2:1,V<128?B[Y++]=V:V<2048?(B[Y++]=192|(V&1984)>>>6,B[Y++]=128|(V&63)>>>0):V<65536?(B[Y++]=224|(V&61440)>>>12,B[Y++]=128|(V&4032)>>>6,B[Y++]=128|(V&63)>>>0):(B[Y++]=240|(V&1835008)>>>18,B[Y++]=128|(V&258048)>>>12,B[Y++]=128|(V&4032)>>>6,B[Y++]=128|(V&63)>>>0)}return B}t.encodeUTF8=K;function ne(L){const D=L.byteLength,T=[];let k=0;for(;k<D;){const B=L[k];let Y;if(B>=240&&k+3<D?Y=(L[k++]&7)<<18>>>0|(L[k++]&63)<<12>>>0|(L[k++]&63)<<6>>>0|(L[k++]&63)<<0>>>0:B>=224&&k+2<D?Y=(L[k++]&15)<<12>>>0|(L[k++]&63)<<6>>>0|(L[k++]&63)<<0>>>0:B>=192&&k+1<D?Y=(L[k++]&31)<<6>>>0|(L[k++]&63)<<0>>>0:Y=L[k++],Y>=0&&Y<=55295||Y>=57344&&Y<=65535)T.push(String.fromCharCode(Y));else if(Y>=65536&&Y<=1114111){const V=Y-65536,te=55296+((V&1047552)>>>10),ie=56320+((V&1023)>>>0);T.push(String.fromCharCode(te)),T.push(String.fromCharCode(ie))}else T.push(String.fromCharCode(65533))}return T.join("")}t.decodeUTF8=ne;const ue=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function oe(L){return ue.test(L)}t.containsRTL=oe;const fe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function he(L){return fe.test(L)}t.containsEmoji=he;const Ee=/^[\t\n\r\x20-\x7E]*$/;function Ne(L){return Ee.test(L)}t.isBasicASCII=Ne,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ae(L){return t.UNUSUAL_LINE_TERMINATORS.test(L)}t.containsUnusualLineTerminators=Ae;function we(L){for(let D=0,T=L.length;D<T;D++)if(ge(L.charCodeAt(D)))return!0;return!1}t.containsFullWidthCharacter=we;function ge(L){return L=+L,L>=11904&&L<=55215||L>=63744&&L<=64255||L>=65281&&L<=65374}t.isFullWidthCharacter=ge;function me(L){return L>=127462&&L<=127487||L===8986||L===8987||L===9200||L===9203||L>=9728&&L<=10175||L===11088||L===11093||L>=127744&&L<=128591||L>=128640&&L<=128764||L>=128992&&L<=129003||L>=129280&&L<=129535||L>=129648&&L<=129750}t.isEmojiImprecise=me;function Ce(L,D){if(L.length<D)return L;const T=/\b/g;let k=0;for(;T.test(L)&&!(L.length-T.lastIndex<D);)k=T.lastIndex,T.lastIndex+=1;return L.substring(k).replace(/^\s/,"")}t.lcut=Ce;const Pe=/\x1B\x5B[12]?K/g,Me=/\x1b\[\d+m/g,pe=/\x1b\[0?m/g;function De(L){return L&&(L=L.replace(Pe,""),L=L.replace(Me,""),L=L.replace(pe,"")),L}t.removeAnsiEscapeCodes=De,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function _e(L){return!!(L&&L.length>0&&L.charCodeAt(0)===65279)}t.startsWithUTF8BOM=_e;function Ue(L){return _e(L)?L.substr(1):L}t.stripUTF8BOM=Ue;function Re(L,D){if(!L||!D||L.length<D.length)return!1;const T=D.length,k=L.toLowerCase();let B=0,Y=-1;for(;B<T;){const V=k.indexOf(D[B],Y+1);if(V<0)return!1;Y=V,B++}return!0}t.fuzzyContains=Re;function Fe(L,D=!1){return L?(D&&(L=L.replace(/\\./g,"")),L.toLowerCase()!==L):!1}t.containsUppercaseCharacter=Fe;function Ie(L){return L.charAt(0).toUpperCase()+L.slice(1)}t.uppercaseFirstLetter=Ie;function Te(L,D=1){if(D===0)return"";let T=-1;do T=L.indexOf(`
`,T+1),D--;while(D>0&&T>=0);return T===-1?L:(L[T-1]==="\r"&&T--,L.substr(0,T))}t.getNLines=Te;function ke(L){const D=90-65+1;return L=L%(2*D),L<D?String.fromCharCode(97+L):String.fromCharCode(65+L-D)}t.singleLetterHash=ke;function ye(L){return se.getInstance().getGraphemeBreakType(L)}t.getGraphemeBreakType=ye;function ae(L,D){return L===0?D!==5&&D!==7:L===2&&D===3?!1:L===4||L===2||L===3||D===4||D===2||D===3?!0:!(L===8&&(D===8||D===9||D===11||D===12)||(L===11||L===9)&&(D===9||D===10)||(L===12||L===10)&&D===10||D===5||D===13||D===7||L===1||L===13&&D===14||L===6&&D===6)}t.breakBetweenGraphemeBreakType=ae;var We;(function(L){L[L.Other=0]="Other",L[L.Prepend=1]="Prepend",L[L.CR=2]="CR",L[L.LF=3]="LF",L[L.Control=4]="Control",L[L.Extend=5]="Extend",L[L.Regional_Indicator=6]="Regional_Indicator",L[L.SpacingMark=7]="SpacingMark",L[L.L=8]="L",L[L.V=9]="V",L[L.T=10]="T",L[L.LV=11]="LV",L[L.LVT=12]="LVT",L[L.ZWJ=13]="ZWJ",L[L.Extended_Pictographic=14]="Extended_Pictographic"})(We=t.GraphemeBreakType||(t.GraphemeBreakType={}));class se{constructor(){this._data=Oe()}static getInstance(){return se._INSTANCE||(se._INSTANCE=new se),se._INSTANCE}getGraphemeBreakType(D){if(D<32)return D===10?3:D===13?2:4;if(D<127)return 0;const T=this._data,k=T.length/3;let B=1;for(;B<=k;)if(D<T[3*B])B=2*B;else if(D>T[3*B+1])B=2*B+1;else return T[3*B+2];return 0}}se._INSTANCE=null;function Oe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Be(L,D){if(L===0)return 0;const T=qe(L,D);if(T!==void 0)return T;const k=W(D,L);return L-=ce(k),L}t.getLeftDeleteOffset=Be;function qe(L,D){let T=W(D,L);for(L-=ce(T);He(T)||T===65039||T===8419;){if(L===0)return;T=W(D,L),L-=ce(T)}if(!!me(T)){if(L>=0){const k=W(D,L);k===8205&&(L-=ce(k))}return L}}function ce(L){return L>=65536?2:1}function He(L){return 127995<=L&&L<=127999}var ve;(function(L){L[L.zwj=8205]="zwj",L[L.emojiVariantSelector=65039]="emojiVariantSelector",L[L.enclosingKeyCap=8419]="enclosingKeyCap"})(ve||(ve={}))}),G(Q[22],X([0,1,5]),function(I,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.doHash=t.hash=void 0;function U(_){return C(_,0)}t.hash=U;function C(_,n){switch(typeof _){case"object":return _===null?s(349,n):Array.isArray(_)?o(_,n):a(_,n);case"string":return l(_,n);case"boolean":return S(_,n);case"number":return s(_,n);case"undefined":return s(937,n);default:return s(617,n)}}t.doHash=C;function s(_,n){return(n<<5)-n+_|0}function S(_,n){return s(_?433:863,n)}function l(_,n){n=s(149417,n);for(let i=0,r=_.length;i<r;i++)n=s(_.charCodeAt(i),n);return n}t.stringHash=l;function o(_,n){return n=s(104579,n),_.reduce((i,r)=>C(r,i),n)}function a(_,n){return n=s(181387,n),Object.keys(_).sort().reduce((i,r)=>(i=l(r,i),C(_[r],i)),n)}class E{constructor(){this._value=0}get value(){return this._value}hash(n){return this._value=C(n,this._value),this._value}}t.Hasher=E;var w;(function(_){_[_.BLOCK_SIZE=64]="BLOCK_SIZE",_[_.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function h(_,n,i=32){const r=i-n,u=~((1<<r)-1);return(_<<n|(u&_)>>>r)>>>0}function c(_,n=0,i=_.byteLength,r=0){for(let u=0;u<i;u++)_[n+u]=r}function g(_,n,i="0"){for(;_.length<n;)_=i+_;return _}function b(_,n=32){return _ instanceof ArrayBuffer?Array.from(new Uint8Array(_)).map(i=>i.toString(16).padStart(2,"0")).join(""):g((_>>>0).toString(16),n/4)}t.toHexString=b;class N{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(n){const i=n.length;if(i!==0){const r=this._buff;let u=this._buffLen,f=this._leftoverHighSurrogate,v,d;for(f!==0?(v=f,d=-1,f=0):(v=n.charCodeAt(0),d=0);;){let m=v;if(M.isHighSurrogate(v))if(d+1<i){const A=n.charCodeAt(d+1);M.isLowSurrogate(A)?(d++,m=M.computeCodePoint(v,A)):m=65533}else{f=v;break}else M.isLowSurrogate(v)&&(m=65533);if(u=this._push(r,u,m),d++,d<i)v=n.charCodeAt(d);else break}this._buffLen=u,this._leftoverHighSurrogate=f}}_push(n,i,r){return r<128?n[i++]=r:r<2048?(n[i++]=192|(r&1984)>>>6,n[i++]=128|(r&63)>>>0):r<65536?(n[i++]=224|(r&61440)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0):(n[i++]=240|(r&1835008)>>>18,n[i++]=128|(r&258048)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0),i>=64&&(this._step(),i-=64,this._totalLen+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),i}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),b(this._h0)+b(this._h1)+b(this._h2)+b(this._h3)+b(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,c(this._buff,this._buffLen),this._buffLen>56&&(this._step(),c(this._buff));const n=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(n/4294967296),!1),this._buffDV.setUint32(60,n%4294967296,!1),this._step()}_step(){const n=N._bigBlock32,i=this._buffDV;for(let P=0;P<64;P+=4)n.setUint32(P,i.getUint32(P,!1),!1);for(let P=64;P<320;P+=4)n.setUint32(P,h(n.getUint32(P-12,!1)^n.getUint32(P-32,!1)^n.getUint32(P-56,!1)^n.getUint32(P-64,!1),1),!1);let r=this._h0,u=this._h1,f=this._h2,v=this._h3,d=this._h4,m,A,p;for(let P=0;P<80;P++)P<20?(m=u&f|~u&v,A=1518500249):P<40?(m=u^f^v,A=1859775393):P<60?(m=u&f|u&v|f&v,A=2400959708):(m=u^f^v,A=3395469782),p=h(r,5)+m+d+A+n.getUint32(P*4,!1)&4294967295,d=v,v=f,f=h(u,30),u=r,r=p;this._h0=this._h0+r&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+f&4294967295,this._h3=this._h3+v&4294967295,this._h4=this._h4+d&4294967295}}t.StringSHA1=N,N._bigBlock32=new DataView(new ArrayBuffer(320))}),G(Q[11],X([0,1,15,22]),function(I,t,M,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class C{constructor(h){this.source=h}getElements(){const h=this.source,c=new Int32Array(h.length);for(let g=0,b=h.length;g<b;g++)c[g]=h.charCodeAt(g);return c}}t.StringDiffSequence=C;function s(w,h,c){return new E(new C(w),new C(h)).ComputeDiff(c).changes}t.stringDiff=s;class S{static Assert(h,c){if(!h)throw new Error(c)}}t.Debug=S;class l{static Copy(h,c,g,b,N){for(let _=0;_<N;_++)g[b+_]=h[c+_]}static Copy2(h,c,g,b,N){for(let _=0;_<N;_++)g[b+_]=h[c+_]}}t.MyArray=l;var o;(function(w){w[w.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(o||(o={}));class a{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new M.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(h,c){this.m_originalStart=Math.min(this.m_originalStart,h),this.m_modifiedStart=Math.min(this.m_modifiedStart,c),this.m_originalCount++}AddModifiedElement(h,c){this.m_originalStart=Math.min(this.m_originalStart,h),this.m_modifiedStart=Math.min(this.m_modifiedStart,c),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class E{constructor(h,c,g=null){this.ContinueProcessingPredicate=g;const[b,N,_]=E._getElements(h),[n,i,r]=E._getElements(c);this._hasStrings=_&&r,this._originalStringElements=b,this._originalElementsOrHash=N,this._modifiedStringElements=n,this._modifiedElementsOrHash=i,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(h){return h.length>0&&typeof h[0]=="string"}static _getElements(h){const c=h.getElements();if(E._isStringArray(c)){const g=new Int32Array(c.length);for(let b=0,N=c.length;b<N;b++)g[b]=(0,U.stringHash)(c[b],0);return[c,g,!0]}return c instanceof Int32Array?[[],c,!1]:[[],new Int32Array(c),!1]}ElementsAreEqual(h,c){return this._originalElementsOrHash[h]!==this._modifiedElementsOrHash[c]?!1:this._hasStrings?this._originalStringElements[h]===this._modifiedStringElements[c]:!0}OriginalElementsAreEqual(h,c){return this._originalElementsOrHash[h]!==this._originalElementsOrHash[c]?!1:this._hasStrings?this._originalStringElements[h]===this._originalStringElements[c]:!0}ModifiedElementsAreEqual(h,c){return this._modifiedElementsOrHash[h]!==this._modifiedElementsOrHash[c]?!1:this._hasStrings?this._modifiedStringElements[h]===this._modifiedStringElements[c]:!0}ComputeDiff(h){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,h)}_ComputeDiff(h,c,g,b,N){const _=[!1];let n=this.ComputeDiffRecursive(h,c,g,b,_);return N&&(n=this.PrettifyChanges(n)),{quitEarly:_[0],changes:n}}ComputeDiffRecursive(h,c,g,b,N){for(N[0]=!1;h<=c&&g<=b&&this.ElementsAreEqual(h,g);)h++,g++;for(;c>=h&&b>=g&&this.ElementsAreEqual(c,b);)c--,b--;if(h>c||g>b){let f;return g<=b?(S.Assert(h===c+1,"originalStart should only be one more than originalEnd"),f=[new M.DiffChange(h,0,g,b-g+1)]):h<=c?(S.Assert(g===b+1,"modifiedStart should only be one more than modifiedEnd"),f=[new M.DiffChange(h,c-h+1,g,0)]):(S.Assert(h===c+1,"originalStart should only be one more than originalEnd"),S.Assert(g===b+1,"modifiedStart should only be one more than modifiedEnd"),f=[]),f}const _=[0],n=[0],i=this.ComputeRecursionPoint(h,c,g,b,_,n,N),r=_[0],u=n[0];if(i!==null)return i;if(!N[0]){const f=this.ComputeDiffRecursive(h,r,g,u,N);let v=[];return N[0]?v=[new M.DiffChange(r+1,c-(r+1)+1,u+1,b-(u+1)+1)]:v=this.ComputeDiffRecursive(r+1,c,u+1,b,N),this.ConcatenateChanges(f,v)}return[new M.DiffChange(h,c-h+1,g,b-g+1)]}WALKTRACE(h,c,g,b,N,_,n,i,r,u,f,v,d,m,A,p,P,F){let R=null,y=null,q=new a,$=c,x=g,z=d[0]-p[0]-b,e=-1073741824,H=this.m_forwardHistory.length-1;do{const W=z+h;W===$||W<x&&r[W-1]<r[W+1]?(f=r[W+1],m=f-z-b,f<e&&q.MarkNextChange(),e=f,q.AddModifiedElement(f+1,m),z=W+1-h):(f=r[W-1]+1,m=f-z-b,f<e&&q.MarkNextChange(),e=f-1,q.AddOriginalElement(f,m+1),z=W-1-h),H>=0&&(r=this.m_forwardHistory[H],h=r[0],$=1,x=r.length-1)}while(--H>=-1);if(R=q.getReverseChanges(),F[0]){let W=d[0]+1,O=p[0]+1;if(R!==null&&R.length>0){const j=R[R.length-1];W=Math.max(W,j.getOriginalEnd()),O=Math.max(O,j.getModifiedEnd())}y=[new M.DiffChange(W,v-W+1,O,A-O+1)]}else{q=new a,$=_,x=n,z=d[0]-p[0]-i,e=1073741824,H=P?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const W=z+N;W===$||W<x&&u[W-1]>=u[W+1]?(f=u[W+1]-1,m=f-z-i,f>e&&q.MarkNextChange(),e=f+1,q.AddOriginalElement(f+1,m+1),z=W+1-N):(f=u[W-1],m=f-z-i,f>e&&q.MarkNextChange(),e=f,q.AddModifiedElement(f+1,m+1),z=W-1-N),H>=0&&(u=this.m_reverseHistory[H],N=u[0],$=1,x=u.length-1)}while(--H>=-1);y=q.getChanges()}return this.ConcatenateChanges(R,y)}ComputeRecursionPoint(h,c,g,b,N,_,n){let i=0,r=0,u=0,f=0,v=0,d=0;h--,g--,N[0]=0,_[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const m=c-h+(b-g),A=m+1,p=new Int32Array(A),P=new Int32Array(A),F=b-g,R=c-h,y=h-g,q=c-b,x=(R-F)%2==0;p[F]=h,P[R]=c,n[0]=!1;for(let z=1;z<=m/2+1;z++){let e=0,H=0;u=this.ClipDiagonalBound(F-z,z,F,A),f=this.ClipDiagonalBound(F+z,z,F,A);for(let O=u;O<=f;O+=2){O===u||O<f&&p[O-1]<p[O+1]?i=p[O+1]:i=p[O-1]+1,r=i-(O-F)-y;const j=i;for(;i<c&&r<b&&this.ElementsAreEqual(i+1,r+1);)i++,r++;if(p[O]=i,i+r>e+H&&(e=i,H=r),!x&&Math.abs(O-R)<=z-1&&i>=P[O])return N[0]=i,_[0]=r,j<=P[O]&&1447>0&&z<=1447+1?this.WALKTRACE(F,u,f,y,R,v,d,q,p,P,i,c,N,r,b,_,x,n):null}const W=(e-h+(H-g)-z)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(e,W))return n[0]=!0,N[0]=e,_[0]=H,W>0&&1447>0&&z<=1447+1?this.WALKTRACE(F,u,f,y,R,v,d,q,p,P,i,c,N,r,b,_,x,n):(h++,g++,[new M.DiffChange(h,c-h+1,g,b-g+1)]);v=this.ClipDiagonalBound(R-z,z,R,A),d=this.ClipDiagonalBound(R+z,z,R,A);for(let O=v;O<=d;O+=2){O===v||O<d&&P[O-1]>=P[O+1]?i=P[O+1]-1:i=P[O-1],r=i-(O-R)-q;const j=i;for(;i>h&&r>g&&this.ElementsAreEqual(i,r);)i--,r--;if(P[O]=i,x&&Math.abs(O-F)<=z&&i<=p[O])return N[0]=i,_[0]=r,j>=p[O]&&1447>0&&z<=1447+1?this.WALKTRACE(F,u,f,y,R,v,d,q,p,P,i,c,N,r,b,_,x,n):null}if(z<=1447){let O=new Int32Array(f-u+2);O[0]=F-u+1,l.Copy2(p,u,O,1,f-u+1),this.m_forwardHistory.push(O),O=new Int32Array(d-v+2),O[0]=R-v+1,l.Copy2(P,v,O,1,d-v+1),this.m_reverseHistory.push(O)}}return this.WALKTRACE(F,u,f,y,R,v,d,q,p,P,i,c,N,r,b,_,x,n)}PrettifyChanges(h){for(let c=0;c<h.length;c++){const g=h[c],b=c<h.length-1?h[c+1].originalStart:this._originalElementsOrHash.length,N=c<h.length-1?h[c+1].modifiedStart:this._modifiedElementsOrHash.length,_=g.originalLength>0,n=g.modifiedLength>0;for(;g.originalStart+g.originalLength<b&&g.modifiedStart+g.modifiedLength<N&&(!_||this.OriginalElementsAreEqual(g.originalStart,g.originalStart+g.originalLength))&&(!n||this.ModifiedElementsAreEqual(g.modifiedStart,g.modifiedStart+g.modifiedLength));)g.originalStart++,g.modifiedStart++;let i=[null];if(c<h.length-1&&this.ChangesOverlap(h[c],h[c+1],i)){h[c]=i[0],h.splice(c+1,1),c--;continue}}for(let c=h.length-1;c>=0;c--){const g=h[c];let b=0,N=0;if(c>0){const f=h[c-1];b=f.originalStart+f.originalLength,N=f.modifiedStart+f.modifiedLength}const _=g.originalLength>0,n=g.modifiedLength>0;let i=0,r=this._boundaryScore(g.originalStart,g.originalLength,g.modifiedStart,g.modifiedLength);for(let f=1;;f++){const v=g.originalStart-f,d=g.modifiedStart-f;if(v<b||d<N||_&&!this.OriginalElementsAreEqual(v,v+g.originalLength)||n&&!this.ModifiedElementsAreEqual(d,d+g.modifiedLength))break;const A=(v===b&&d===N?5:0)+this._boundaryScore(v,g.originalLength,d,g.modifiedLength);A>r&&(r=A,i=f)}g.originalStart-=i,g.modifiedStart-=i;const u=[null];if(c>0&&this.ChangesOverlap(h[c-1],h[c],u)){h[c-1]=u[0],h.splice(c,1),c++;continue}}if(this._hasStrings)for(let c=1,g=h.length;c<g;c++){const b=h[c-1],N=h[c],_=N.originalStart-b.originalStart-b.originalLength,n=b.originalStart,i=N.originalStart+N.originalLength,r=i-n,u=b.modifiedStart,f=N.modifiedStart+N.modifiedLength,v=f-u;if(_<5&&r<20&&v<20){const d=this._findBetterContiguousSequence(n,r,u,v,_);if(d){const[m,A]=d;(m!==b.originalStart+b.originalLength||A!==b.modifiedStart+b.modifiedLength)&&(b.originalLength=m-b.originalStart,b.modifiedLength=A-b.modifiedStart,N.originalStart=m+_,N.modifiedStart=A+_,N.originalLength=i-N.originalStart,N.modifiedLength=f-N.modifiedStart)}}}return h}_findBetterContiguousSequence(h,c,g,b,N){if(c<N||b<N)return null;const _=h+c-N+1,n=g+b-N+1;let i=0,r=0,u=0;for(let f=h;f<_;f++)for(let v=g;v<n;v++){const d=this._contiguousSequenceScore(f,v,N);d>0&&d>i&&(i=d,r=f,u=v)}return i>0?[r,u]:null}_contiguousSequenceScore(h,c,g){let b=0;for(let N=0;N<g;N++){if(!this.ElementsAreEqual(h+N,c+N))return 0;b+=this._originalStringElements[h+N].length}return b}_OriginalIsBoundary(h){return h<=0||h>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[h])}_OriginalRegionIsBoundary(h,c){if(this._OriginalIsBoundary(h)||this._OriginalIsBoundary(h-1))return!0;if(c>0){const g=h+c;if(this._OriginalIsBoundary(g-1)||this._OriginalIsBoundary(g))return!0}return!1}_ModifiedIsBoundary(h){return h<=0||h>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[h])}_ModifiedRegionIsBoundary(h,c){if(this._ModifiedIsBoundary(h)||this._ModifiedIsBoundary(h-1))return!0;if(c>0){const g=h+c;if(this._ModifiedIsBoundary(g-1)||this._ModifiedIsBoundary(g))return!0}return!1}_boundaryScore(h,c,g,b){const N=this._OriginalRegionIsBoundary(h,c)?1:0,_=this._ModifiedRegionIsBoundary(g,b)?1:0;return N+_}ConcatenateChanges(h,c){let g=[];if(h.length===0||c.length===0)return c.length>0?c:h;if(this.ChangesOverlap(h[h.length-1],c[0],g)){const b=new Array(h.length+c.length-1);return l.Copy(h,0,b,0,h.length-1),b[h.length-1]=g[0],l.Copy(c,1,b,h.length,c.length-1),b}else{const b=new Array(h.length+c.length);return l.Copy(h,0,b,0,h.length),l.Copy(c,0,b,h.length,c.length),b}}ChangesOverlap(h,c,g){if(S.Assert(h.originalStart<=c.originalStart,"Left change is not less than or equal to right change"),S.Assert(h.modifiedStart<=c.modifiedStart,"Left change is not less than or equal to right change"),h.originalStart+h.originalLength>=c.originalStart||h.modifiedStart+h.modifiedLength>=c.modifiedStart){const b=h.originalStart;let N=h.originalLength;const _=h.modifiedStart;let n=h.modifiedLength;return h.originalStart+h.originalLength>=c.originalStart&&(N=c.originalStart+c.originalLength-h.originalStart),h.modifiedStart+h.modifiedLength>=c.modifiedStart&&(n=c.modifiedStart+c.modifiedLength-h.modifiedStart),g[0]=new M.DiffChange(b,N,_,n),!0}else return g[0]=null,!1}ClipDiagonalBound(h,c,g,b){if(h>=0&&h<b)return h;const N=g,_=b-g-1,n=c%2==0;if(h<0){const i=N%2==0;return n===i?0:1}else{const i=_%2==0;return n===i?b-1:b-2}}}t.LcsDiff=E}),G(Q[12],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.assertNever=t.NotImplementedProxy=t.withUndefinedAsNull=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isObject=t.isStringArray=t.isString=t.isArray=void 0;function M(P){return Array.isArray(P)}t.isArray=M;function U(P){return typeof P=="string"}t.isString=U;function C(P){return Array.isArray(P)&&P.every(F=>U(F))}t.isStringArray=C;function s(P){return typeof P=="object"&&P!==null&&!Array.isArray(P)&&!(P instanceof RegExp)&&!(P instanceof Date)}t.isObject=s;function S(P){return typeof P=="number"&&!isNaN(P)}t.isNumber=S;function l(P){return!!P&&typeof P[Symbol.iterator]=="function"}t.isIterable=l;function o(P){return P===!0||P===!1}t.isBoolean=o;function a(P){return typeof P=="undefined"}t.isUndefined=a;function E(P){return!w(P)}t.isDefined=E;function w(P){return a(P)||P===null}t.isUndefinedOrNull=w;function h(P,F){if(!P)throw new Error(F?`Unexpected type, expected '${F}'`:"Unexpected type")}t.assertType=h;function c(P){if(w(P))throw new Error("Assertion Failed: argument is undefined or null");return P}t.assertIsDefined=c;function g(...P){const F=[];for(let R=0;R<P.length;R++){const y=P[R];if(w(y))throw new Error(`Assertion Failed: argument at index ${R} is undefined or null`);F.push(y)}return F}t.assertAllDefined=g;const b=Object.prototype.hasOwnProperty;function N(P){if(!s(P))return!1;for(let F in P)if(b.call(P,F))return!1;return!0}t.isEmptyObject=N;function _(P){return typeof P=="function"}t.isFunction=_;function n(...P){return P.length>0&&P.every(_)}t.areFunctions=n;function i(P,F){const R=Math.min(P.length,F.length);for(let y=0;y<R;y++)r(P[y],F[y])}t.validateConstraints=i;function r(P,F){if(U(F)){if(typeof P!==F)throw new Error(`argument does not match constraint: typeof ${F}`)}else if(_(F)){try{if(P instanceof F)return}catch(R){}if(!w(P)&&P.constructor===F||F.length===1&&F.call(void 0,P)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=r;function u(P){let F=[],R=Object.getPrototypeOf(P);for(;Object.prototype!==R;)F=F.concat(Object.getOwnPropertyNames(R)),R=Object.getPrototypeOf(R);return F}t.getAllPropertyNames=u;function f(P){const F=[];for(const R of u(P))typeof P[R]=="function"&&F.push(R);return F}t.getAllMethodNames=f;function v(P,F){const R=q=>function(){const $=Array.prototype.slice.call(arguments,0);return F(q,$)};let y={};for(const q of P)y[q]=R(q);return y}t.createProxyObject=v;function d(P){return P===null?void 0:P}t.withNullAsUndefined=d;function m(P){return typeof P=="undefined"?null:P}t.withUndefinedAsNull=m;function A(P){return class{constructor(){return new Proxy({},{get(F,R){if(F[R])return F[R];throw new Error(`Not Implemented: ${P}->${String(R)}`)}})}}}t.NotImplementedProxy=A;function p(P){throw new Error("Unreachable")}t.assertNever=p}),G(Q[13],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var M;(function(s){s[s.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",s[s.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",s[s.MAX_UINT_8=255]="MAX_UINT_8",s[s.MAX_UINT_16=65535]="MAX_UINT_16",s[s.MAX_UINT_32=4294967295]="MAX_UINT_32",s[s.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(M=t.Constants||(t.Constants={}));function U(s){return s<0?0:s>255?255:s|0}t.toUint8=U;function C(s){return s<0?0:s>4294967295?4294967295:s|0}t.toUint32=C}),G(Q[14],X([0,1,2,20]),function(I,t,M,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const C=/^\w[\w\d+.-]*$/,s=/^\//,S=/^\/\//;function l(d,m){if(!d.scheme&&m)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!C.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!s.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function o(d,m){return!d&&!m?"file":d}function a(d,m){switch(d){case"https":case"http":case"file":m?m[0]!==w&&(m=w+m):m=w;break}return m}const E="",w="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{constructor(m,A,p,P,F,R=!1){typeof m=="object"?(this.scheme=m.scheme||E,this.authority=m.authority||E,this.path=m.path||E,this.query=m.query||E,this.fragment=m.fragment||E):(this.scheme=o(m,R),this.authority=A||E,this.path=a(this.scheme,p||E),this.query=P||E,this.fragment=F||E,l(this,R))}static isUri(m){return m instanceof c?!0:m?typeof m.authority=="string"&&typeof m.fragment=="string"&&typeof m.path=="string"&&typeof m.query=="string"&&typeof m.scheme=="string"&&typeof m.fsPath=="string"&&typeof m.with=="function"&&typeof m.toString=="function":!1}get fsPath(){return i(this,!1)}with(m){if(!m)return this;let{scheme:A,authority:p,path:P,query:F,fragment:R}=m;return A===void 0?A=this.scheme:A===null&&(A=E),p===void 0?p=this.authority:p===null&&(p=E),P===void 0?P=this.path:P===null&&(P=E),F===void 0?F=this.query:F===null&&(F=E),R===void 0?R=this.fragment:R===null&&(R=E),A===this.scheme&&p===this.authority&&P===this.path&&F===this.query&&R===this.fragment?this:new b(A,p,P,F,R)}static parse(m,A=!1){const p=h.exec(m);return p?new b(p[2]||E,v(p[4]||E),v(p[5]||E),v(p[7]||E),v(p[9]||E),A):new b(E,E,E,E,E)}static file(m){let A=E;if(M.isWindows&&(m=m.replace(/\\/g,w)),m[0]===w&&m[1]===w){const p=m.indexOf(w,2);p===-1?(A=m.substring(2),m=w):(A=m.substring(2,p),m=m.substring(p)||w)}return new b("file",A,m,E,E)}static from(m){return new b(m.scheme,m.authority,m.path,m.query,m.fragment)}static joinPath(m,...A){if(!m.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return M.isWindows&&m.scheme==="file"?p=c.file(U.win32.join(i(m,!0),...A)).path:p=U.posix.join(m.path,...A),m.with({path:p})}toString(m=!1){return r(this,m)}toJSON(){return this}static revive(m){if(m){if(m instanceof c)return m;{const A=new b(m);return A._formatted=m.external,A._fsPath=m._sep===g?m.fsPath:null,A}}else return m}}t.URI=c;const g=M.isWindows?1:void 0;class b extends c{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(m=!1){return m?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const m={$mid:1};return this._fsPath&&(m.fsPath=this._fsPath,m._sep=g),this._formatted&&(m.external=this._formatted),this.path&&(m.path=this.path),this.scheme&&(m.scheme=this.scheme),this.authority&&(m.authority=this.authority),this.query&&(m.query=this.query),this.fragment&&(m.fragment=this.fragment),m}}const N={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function _(d,m){let A,p=-1;for(let P=0;P<d.length;P++){const F=d.charCodeAt(P);if(F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57||F===45||F===46||F===95||F===126||m&&F===47)p!==-1&&(A+=encodeURIComponent(d.substring(p,P)),p=-1),A!==void 0&&(A+=d.charAt(P));else{A===void 0&&(A=d.substr(0,P));const R=N[F];R!==void 0?(p!==-1&&(A+=encodeURIComponent(d.substring(p,P)),p=-1),A+=R):p===-1&&(p=P)}}return p!==-1&&(A+=encodeURIComponent(d.substring(p))),A!==void 0?A:d}function n(d){let m;for(let A=0;A<d.length;A++){const p=d.charCodeAt(A);p===35||p===63?(m===void 0&&(m=d.substr(0,A)),m+=N[p]):m!==void 0&&(m+=d[A])}return m!==void 0?m:d}function i(d,m){let A;return d.authority&&d.path.length>1&&d.scheme==="file"?A=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?m?A=d.path.substr(1):A=d.path[1].toLowerCase()+d.path.substr(2):A=d.path,M.isWindows&&(A=A.replace(/\//g,"\\")),A}t.uriToFsPath=i;function r(d,m){const A=m?n:_;let p="",{scheme:P,authority:F,path:R,query:y,fragment:q}=d;if(P&&(p+=P,p+=":"),(F||P==="file")&&(p+=w,p+=w),F){let $=F.indexOf("@");if($!==-1){const x=F.substr(0,$);F=F.substr($+1),$=x.indexOf(":"),$===-1?p+=A(x,!1):(p+=A(x.substr(0,$),!1),p+=":",p+=A(x.substr($+1),!1)),p+="@"}F=F.toLowerCase(),$=F.indexOf(":"),$===-1?p+=A(F,!1):(p+=A(F.substr(0,$),!1),p+=F.substr($))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const $=R.charCodeAt(1);$>=65&&$<=90&&(R=`/${String.fromCharCode($+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const $=R.charCodeAt(0);$>=65&&$<=90&&(R=`${String.fromCharCode($+32)}:${R.substr(2)}`)}p+=A(R,!0)}return y&&(p+="?",p+=A(y,!1)),q&&(p+="#",p+=m?q:_(q,!1)),p}function u(d){try{return decodeURIComponent(d)}catch(m){return d.length>3?d.substr(0,3)+u(d.substr(3)):d}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function v(d){return d.match(f)?d.replace(f,m=>u(m)):d}}),G(Q[34],X([0,1,4,8,2,12]),function(I,t,M,U,C,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const S="$initialize";let l=!1;function o(c){!C.isWeb||(l||(l=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(c.message))}t.logOnceWebWorkerWarning=o;class a{constructor(g){this._workerId=-1,this._handler=g,this._lastSentReq=0,this._pendingReplies=Object.create(null)}setWorkerId(g){this._workerId=g}sendMessage(g,b){let N=String(++this._lastSentReq);return new Promise((_,n)=>{this._pendingReplies[N]={resolve:_,reject:n},this._send({vsWorker:this._workerId,req:N,method:g,args:b})})}handleMessage(g){!g||!g.vsWorker||this._workerId!==-1&&g.vsWorker!==this._workerId||this._handleMessage(g)}_handleMessage(g){if(g.seq){let n=g;if(!this._pendingReplies[n.seq]){console.warn("Got reply to unknown seq");return}let i=this._pendingReplies[n.seq];if(delete this._pendingReplies[n.seq],n.err){let r=n.err;n.err.$isError&&(r=new Error,r.name=n.err.name,r.message=n.err.message,r.stack=n.err.stack),i.reject(r);return}i.resolve(n.res);return}let b=g,N=b.req;this._handler.handleMessage(b.method,b.args).then(n=>{this._send({vsWorker:this._workerId,seq:N,res:n,err:void 0})},n=>{n.detail instanceof Error&&(n.detail=(0,M.transformErrorForSerialization)(n.detail)),this._send({vsWorker:this._workerId,seq:N,res:void 0,err:(0,M.transformErrorForSerialization)(n)})})}_send(g){let b=[];if(g.req){const N=g;for(let _=0;_<N.args.length;_++)N.args[_]instanceof ArrayBuffer&&b.push(N.args[_])}else{const N=g;N.res instanceof ArrayBuffer&&b.push(N.res)}this._handler.sendMessage(g,b)}}class E extends U.Disposable{constructor(g,b,N){super();let _=null;this._worker=this._register(g.create("vs/base/common/worker/simpleWorker",u=>{this._protocol.handleMessage(u)},u=>{_&&_(u)})),this._protocol=new a({sendMessage:(u,f)=>{this._worker.postMessage(u,f)},handleMessage:(u,f)=>{if(typeof N[u]!="function")return Promise.reject(new Error("Missing method "+u+" on main thread host."));try{return Promise.resolve(N[u].apply(N,f))}catch(v){return Promise.reject(v)}}}),this._protocol.setWorkerId(this._worker.getId());let n=null;typeof self.require!="undefined"&&typeof self.require.getConfig=="function"?n=self.require.getConfig():typeof self.requirejs!="undefined"&&(n=self.requirejs.s.contexts._.config);const i=s.getAllMethodNames(N);this._onModuleLoaded=this._protocol.sendMessage(S,[this._worker.getId(),JSON.parse(JSON.stringify(n)),b,i]);const r=(u,f)=>this._request(u,f);this._lazyProxy=new Promise((u,f)=>{_=f,this._onModuleLoaded.then(v=>{u(s.createProxyObject(v,r))},v=>{f(v),this._onError("Worker failed to load "+b,v)})})}getProxyObject(){return this._lazyProxy}_request(g,b){return new Promise((N,_)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(g,b).then(N,_)},_)})}_onError(g,b){console.error(g),console.info(b)}}t.SimpleWorkerClient=E;class w{constructor(g,b){this._requestHandlerFactory=b,this._requestHandler=null,this._protocol=new a({sendMessage:(N,_)=>{g(N,_)},handleMessage:(N,_)=>this._handleMessage(N,_)})}onmessage(g){this._protocol.handleMessage(g)}_handleMessage(g,b){if(g===S)return this.initialize(b[0],b[1],b[2],b[3]);if(!this._requestHandler||typeof this._requestHandler[g]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+g));try{return Promise.resolve(this._requestHandler[g].apply(this._requestHandler,b))}catch(N){return Promise.reject(N)}}initialize(g,b,N,_){this._protocol.setWorkerId(g);const n=(r,u)=>this._protocol.sendMessage(r,u),i=s.createProxyObject(_,n);return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(i),Promise.resolve(s.getAllMethodNames(this._requestHandler))):(b&&(typeof b.baseUrl!="undefined"&&delete b.baseUrl,typeof b.paths!="undefined"&&typeof b.paths.vs!="undefined"&&delete b.paths.vs,typeof b.trustedTypesPolicy!==void 0&&delete b.trustedTypesPolicy,b.catchError=!0,self.require.config(b)),new Promise((r,u)=>{self.require([N],f=>{if(this._requestHandler=f.create(i),!this._requestHandler){u(new Error("No RequestHandler!"));return}r(s.getAllMethodNames(this._requestHandler))},u)}))}}t.SimpleWorkerServer=w;function h(c){return new w(c,null)}t.create=h}),G(Q[23],X([0,1,13]),function(I,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class U{constructor(l){let o=(0,M.toUint8)(l);this._defaultValue=o,this._asciiMap=U._createAsciiMap(o),this._map=new Map}static _createAsciiMap(l){let o=new Uint8Array(256);for(let a=0;a<256;a++)o[a]=l;return o}set(l,o){let a=(0,M.toUint8)(o);l>=0&&l<256?this._asciiMap[l]=a:this._map.set(l,a)}get(l){return l>=0&&l<256?this._asciiMap[l]:this._map.get(l)||this._defaultValue}}t.CharacterClassifier=U;var C;(function(S){S[S.False=0]="False",S[S.True=1]="True"})(C||(C={}));class s{constructor(){this._actual=new U(0)}add(l){this._actual.set(l,1)}has(l){return this._actual.get(l)===1}}t.CharacterSet=s}),G(Q[3],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class M{constructor(C,s){this.lineNumber=C,this.column=s}with(C=this.lineNumber,s=this.column){return C===this.lineNumber&&s===this.column?this:new M(C,s)}delta(C=0,s=0){return this.with(this.lineNumber+C,this.column+s)}equals(C){return M.equals(this,C)}static equals(C,s){return!C&&!s?!0:!!C&&!!s&&C.lineNumber===s.lineNumber&&C.column===s.column}isBefore(C){return M.isBefore(this,C)}static isBefore(C,s){return C.lineNumber<s.lineNumber?!0:s.lineNumber<C.lineNumber?!1:C.column<s.column}isBeforeOrEqual(C){return M.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,s){return C.lineNumber<s.lineNumber?!0:s.lineNumber<C.lineNumber?!1:C.column<=s.column}static compare(C,s){let S=C.lineNumber|0,l=s.lineNumber|0;if(S===l){let o=C.column|0,a=s.column|0;return o-a}return S-l}clone(){return new M(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new M(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}t.Position=M}),G(Q[6],X([0,1,3]),function(I,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class U{constructor(s,S,l,o){s>l||s===l&&S>o?(this.startLineNumber=l,this.startColumn=o,this.endLineNumber=s,this.endColumn=S):(this.startLineNumber=s,this.startColumn=S,this.endLineNumber=l,this.endColumn=o)}isEmpty(){return U.isEmpty(this)}static isEmpty(s){return s.startLineNumber===s.endLineNumber&&s.startColumn===s.endColumn}containsPosition(s){return U.containsPosition(this,s)}static containsPosition(s,S){return!(S.lineNumber<s.startLineNumber||S.lineNumber>s.endLineNumber||S.lineNumber===s.startLineNumber&&S.column<s.startColumn||S.lineNumber===s.endLineNumber&&S.column>s.endColumn)}containsRange(s){return U.containsRange(this,s)}static containsRange(s,S){return!(S.startLineNumber<s.startLineNumber||S.endLineNumber<s.startLineNumber||S.startLineNumber>s.endLineNumber||S.endLineNumber>s.endLineNumber||S.startLineNumber===s.startLineNumber&&S.startColumn<s.startColumn||S.endLineNumber===s.endLineNumber&&S.endColumn>s.endColumn)}strictContainsRange(s){return U.strictContainsRange(this,s)}static strictContainsRange(s,S){return!(S.startLineNumber<s.startLineNumber||S.endLineNumber<s.startLineNumber||S.startLineNumber>s.endLineNumber||S.endLineNumber>s.endLineNumber||S.startLineNumber===s.startLineNumber&&S.startColumn<=s.startColumn||S.endLineNumber===s.endLineNumber&&S.endColumn>=s.endColumn)}plusRange(s){return U.plusRange(this,s)}static plusRange(s,S){let l,o,a,E;return S.startLineNumber<s.startLineNumber?(l=S.startLineNumber,o=S.startColumn):S.startLineNumber===s.startLineNumber?(l=S.startLineNumber,o=Math.min(S.startColumn,s.startColumn)):(l=s.startLineNumber,o=s.startColumn),S.endLineNumber>s.endLineNumber?(a=S.endLineNumber,E=S.endColumn):S.endLineNumber===s.endLineNumber?(a=S.endLineNumber,E=Math.max(S.endColumn,s.endColumn)):(a=s.endLineNumber,E=s.endColumn),new U(l,o,a,E)}intersectRanges(s){return U.intersectRanges(this,s)}static intersectRanges(s,S){let l=s.startLineNumber,o=s.startColumn,a=s.endLineNumber,E=s.endColumn,w=S.startLineNumber,h=S.startColumn,c=S.endLineNumber,g=S.endColumn;return l<w?(l=w,o=h):l===w&&(o=Math.max(o,h)),a>c?(a=c,E=g):a===c&&(E=Math.min(E,g)),l>a||l===a&&o>E?null:new U(l,o,a,E)}equalsRange(s){return U.equalsRange(this,s)}static equalsRange(s,S){return!!s&&!!S&&s.startLineNumber===S.startLineNumber&&s.startColumn===S.startColumn&&s.endLineNumber===S.endLineNumber&&s.endColumn===S.endColumn}getEndPosition(){return U.getEndPosition(this)}static getEndPosition(s){return new M.Position(s.endLineNumber,s.endColumn)}getStartPosition(){return U.getStartPosition(this)}static getStartPosition(s){return new M.Position(s.startLineNumber,s.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(s,S){return new U(this.startLineNumber,this.startColumn,s,S)}setStartPosition(s,S){return new U(s,S,this.endLineNumber,this.endColumn)}collapseToStart(){return U.collapseToStart(this)}static collapseToStart(s){return new U(s.startLineNumber,s.startColumn,s.startLineNumber,s.startColumn)}static fromPositions(s,S=s){return new U(s.lineNumber,s.column,S.lineNumber,S.column)}static lift(s){return s?new U(s.startLineNumber,s.startColumn,s.endLineNumber,s.endColumn):null}static isIRange(s){return s&&typeof s.startLineNumber=="number"&&typeof s.startColumn=="number"&&typeof s.endLineNumber=="number"&&typeof s.endColumn=="number"}static areIntersectingOrTouching(s,S){return!(s.endLineNumber<S.startLineNumber||s.endLineNumber===S.startLineNumber&&s.endColumn<S.startColumn||S.endLineNumber<s.startLineNumber||S.endLineNumber===s.startLineNumber&&S.endColumn<s.startColumn)}static areIntersecting(s,S){return!(s.endLineNumber<S.startLineNumber||s.endLineNumber===S.startLineNumber&&s.endColumn<=S.startColumn||S.endLineNumber<s.startLineNumber||S.endLineNumber===s.startLineNumber&&S.endColumn<=s.startColumn)}static compareRangesUsingStarts(s,S){if(s&&S){const a=s.startLineNumber|0,E=S.startLineNumber|0;if(a===E){const w=s.startColumn|0,h=S.startColumn|0;if(w===h){const c=s.endLineNumber|0,g=S.endLineNumber|0;if(c===g){const b=s.endColumn|0,N=S.endColumn|0;return b-N}return c-g}return w-h}return a-E}return(s?1:0)-(S?1:0)}static compareRangesUsingEnds(s,S){return s.endLineNumber===S.endLineNumber?s.endColumn===S.endColumn?s.startLineNumber===S.startLineNumber?s.startColumn-S.startColumn:s.startLineNumber-S.startLineNumber:s.endColumn-S.endColumn:s.endLineNumber-S.endLineNumber}static spansMultipleLines(s){return s.endLineNumber>s.startLineNumber}}t.Range=U}),G(Q[24],X([0,1,3,6]),function(I,t,M,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var C;(function(S){S[S.LTR=0]="LTR",S[S.RTL=1]="RTL"})(C=t.SelectionDirection||(t.SelectionDirection={}));class s extends U.Range{constructor(l,o,a,E){super(l,o,a,E);this.selectionStartLineNumber=l,this.selectionStartColumn=o,this.positionLineNumber=a,this.positionColumn=E}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(l){return s.selectionsEqual(this,l)}static selectionsEqual(l,o){return l.selectionStartLineNumber===o.selectionStartLineNumber&&l.selectionStartColumn===o.selectionStartColumn&&l.positionLineNumber===o.positionLineNumber&&l.positionColumn===o.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(l,o){return this.getDirection()===0?new s(this.startLineNumber,this.startColumn,l,o):new s(l,o,this.startLineNumber,this.startColumn)}getPosition(){return new M.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(l,o){return this.getDirection()===0?new s(l,o,this.endLineNumber,this.endColumn):new s(this.endLineNumber,this.endColumn,l,o)}static fromPositions(l,o=l){return new s(l.lineNumber,l.column,o.lineNumber,o.column)}static liftSelection(l){return new s(l.selectionStartLineNumber,l.selectionStartColumn,l.positionLineNumber,l.positionColumn)}static selectionsArrEqual(l,o){if(l&&!o||!l&&o)return!1;if(!l&&!o)return!0;if(l.length!==o.length)return!1;for(let a=0,E=l.length;a<E;a++)if(!this.selectionsEqual(l[a],o[a]))return!1;return!0}static isISelection(l){return l&&typeof l.selectionStartLineNumber=="number"&&typeof l.selectionStartColumn=="number"&&typeof l.positionLineNumber=="number"&&typeof l.positionColumn=="number"}static createWithDirection(l,o,a,E,w){return w===0?new s(l,o,a,E):new s(a,E,l,o)}}t.Selection=s}),G(Q[25],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationResult2=t.TokenizationResult=t.Token=void 0;class M{constructor(S,l,o){this.offset=S|0,this.type=l,this.language=o}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=M;class U{constructor(S,l){this.tokens=S,this.endState=l}}t.TokenizationResult=U;class C{constructor(S,l){this.tokens=S,this.endState=l}}t.TokenizationResult2=C}),G(Q[26],X([0,1,11,5]),function(I,t,M,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=void 0;const C=3;function s(b,N,_,n){return new M.LcsDiff(b,N,_).ComputeDiff(n)}class S{constructor(N){const _=[],n=[];for(let i=0,r=N.length;i<r;i++)_[i]=h(N[i],1),n[i]=c(N[i],1);this.lines=N,this._startColumns=_,this._endColumns=n}getElements(){const N=[];for(let _=0,n=this.lines.length;_<n;_++)N[_]=this.lines[_].substring(this._startColumns[_]-1,this._endColumns[_]-1);return N}getStartLineNumber(N){return N+1}getEndLineNumber(N){return N+1}createCharSequence(N,_,n){const i=[],r=[],u=[];let f=0;for(let v=_;v<=n;v++){const d=this.lines[v],m=N?this._startColumns[v]:1,A=N?this._endColumns[v]:d.length+1;for(let p=m;p<A;p++)i[f]=d.charCodeAt(p-1),r[f]=v+1,u[f]=p,f++}return new l(i,r,u)}}class l{constructor(N,_,n){this._charCodes=N,this._lineNumbers=_,this._columns=n}getElements(){return this._charCodes}getStartLineNumber(N){return this._lineNumbers[N]}getStartColumn(N){return this._columns[N]}getEndLineNumber(N){return this._lineNumbers[N]}getEndColumn(N){return this._columns[N]+1}}class o{constructor(N,_,n,i,r,u,f,v){this.originalStartLineNumber=N,this.originalStartColumn=_,this.originalEndLineNumber=n,this.originalEndColumn=i,this.modifiedStartLineNumber=r,this.modifiedStartColumn=u,this.modifiedEndLineNumber=f,this.modifiedEndColumn=v}static createFromDiffChange(N,_,n){let i,r,u,f,v,d,m,A;return N.originalLength===0?(i=0,r=0,u=0,f=0):(i=_.getStartLineNumber(N.originalStart),r=_.getStartColumn(N.originalStart),u=_.getEndLineNumber(N.originalStart+N.originalLength-1),f=_.getEndColumn(N.originalStart+N.originalLength-1)),N.modifiedLength===0?(v=0,d=0,m=0,A=0):(v=n.getStartLineNumber(N.modifiedStart),d=n.getStartColumn(N.modifiedStart),m=n.getEndLineNumber(N.modifiedStart+N.modifiedLength-1),A=n.getEndColumn(N.modifiedStart+N.modifiedLength-1)),new o(i,r,u,f,v,d,m,A)}}function a(b){if(b.length<=1)return b;const N=[b[0]];let _=N[0];for(let n=1,i=b.length;n<i;n++){const r=b[n],u=r.originalStart-(_.originalStart+_.originalLength),f=r.modifiedStart-(_.modifiedStart+_.modifiedLength);Math.min(u,f)<C?(_.originalLength=r.originalStart+r.originalLength-_.originalStart,_.modifiedLength=r.modifiedStart+r.modifiedLength-_.modifiedStart):(N.push(r),_=r)}return N}class E{constructor(N,_,n,i,r){this.originalStartLineNumber=N,this.originalEndLineNumber=_,this.modifiedStartLineNumber=n,this.modifiedEndLineNumber=i,this.charChanges=r}static createFromDiffResult(N,_,n,i,r,u,f){let v,d,m,A,p;if(_.originalLength===0?(v=n.getStartLineNumber(_.originalStart)-1,d=0):(v=n.getStartLineNumber(_.originalStart),d=n.getEndLineNumber(_.originalStart+_.originalLength-1)),_.modifiedLength===0?(m=i.getStartLineNumber(_.modifiedStart)-1,A=0):(m=i.getStartLineNumber(_.modifiedStart),A=i.getEndLineNumber(_.modifiedStart+_.modifiedLength-1)),u&&_.originalLength>0&&_.originalLength<20&&_.modifiedLength>0&&_.modifiedLength<20&&r()){const P=n.createCharSequence(N,_.originalStart,_.originalStart+_.originalLength-1),F=i.createCharSequence(N,_.modifiedStart,_.modifiedStart+_.modifiedLength-1);let R=s(P,F,r,!0).changes;f&&(R=a(R)),p=[];for(let y=0,q=R.length;y<q;y++)p.push(o.createFromDiffChange(R[y],P,F))}return new E(v,d,m,A,p)}}class w{constructor(N,_,n){this.shouldComputeCharChanges=n.shouldComputeCharChanges,this.shouldPostProcessCharChanges=n.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=n.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=n.shouldMakePrettyDiff,this.originalLines=N,this.modifiedLines=_,this.original=new S(N),this.modified=new S(_),this.continueLineDiff=g(n.maxComputationTime),this.continueCharDiff=g(n.maxComputationTime===0?0:Math.min(n.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const N=s(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),_=N.changes,n=N.quitEarly;if(this.shouldIgnoreTrimWhitespace){const f=[];for(let v=0,d=_.length;v<d;v++)f.push(E.createFromDiffResult(this.shouldIgnoreTrimWhitespace,_[v],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:n,changes:f}}const i=[];let r=0,u=0;for(let f=-1,v=_.length;f<v;f++){const d=f+1<v?_[f+1]:null,m=d?d.originalStart:this.originalLines.length,A=d?d.modifiedStart:this.modifiedLines.length;for(;r<m&&u<A;){const p=this.originalLines[r],P=this.modifiedLines[u];if(p!==P){{let F=h(p,1),R=h(P,1);for(;F>1&&R>1;){const y=p.charCodeAt(F-2),q=P.charCodeAt(R-2);if(y!==q)break;F--,R--}(F>1||R>1)&&this._pushTrimWhitespaceCharChange(i,r+1,1,F,u+1,1,R)}{let F=c(p,1),R=c(P,1);const y=p.length+1,q=P.length+1;for(;F<y&&R<q;){const $=p.charCodeAt(F-1),x=p.charCodeAt(R-1);if($!==x)break;F++,R++}(F<y||R<q)&&this._pushTrimWhitespaceCharChange(i,r+1,F,y,u+1,R,q)}}r++,u++}d&&(i.push(E.createFromDiffResult(this.shouldIgnoreTrimWhitespace,d,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),r+=d.originalLength,u+=d.modifiedLength)}return{quitEarly:n,changes:i}}_pushTrimWhitespaceCharChange(N,_,n,i,r,u,f){if(!this._mergeTrimWhitespaceCharChange(N,_,n,i,r,u,f)){let v;this.shouldComputeCharChanges&&(v=[new o(_,n,_,i,r,u,r,f)]),N.push(new E(_,_,r,r,v))}}_mergeTrimWhitespaceCharChange(N,_,n,i,r,u,f){const v=N.length;if(v===0)return!1;const d=N[v-1];return d.originalEndLineNumber===0||d.modifiedEndLineNumber===0?!1:d.originalEndLineNumber+1===_&&d.modifiedEndLineNumber+1===r?(d.originalEndLineNumber=_,d.modifiedEndLineNumber=r,this.shouldComputeCharChanges&&d.charChanges&&d.charChanges.push(new o(_,n,_,i,r,u,r,f)),!0):!1}}t.DiffComputer=w;function h(b,N){const _=U.firstNonWhitespaceIndex(b);return _===-1?N:_+1}function c(b,N){const _=U.lastNonWhitespaceIndex(b);return _===-1?N:_+2}function g(b){if(b===0)return()=>!0;const N=Date.now();return()=>Date.now()-N<b}}),G(Q[27],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function M(l=""){let o="(-?\\d*\\.\\d\\w*)|([^";for(const a of t.USUAL_WORD_SEPARATORS)l.indexOf(a)>=0||(o+="\\"+a);return o+="\\s]+)",new RegExp(o,"g")}t.DEFAULT_WORD_REGEXP=M();function U(l){let o=t.DEFAULT_WORD_REGEXP;if(l&&l instanceof RegExp)if(l.global)o=l;else{let a="g";l.ignoreCase&&(a+="i"),l.multiline&&(a+="m"),l.unicode&&(a+="u"),o=new RegExp(l.source,a)}return o.lastIndex=0,o}t.ensureValidWordDefinition=U;const C={maxLen:1e3,windowSize:15,timeBudget:150};function s(l,o,a,E,w=C){if(a.length>w.maxLen){let N=l-w.maxLen/2;return N<0?N=0:E+=N,a=a.substring(N,l+w.maxLen/2),s(l,o,a,E,w)}const h=Date.now(),c=l-1-E;let g=-1,b=null;for(let N=1;!(Date.now()-h>=w.timeBudget);N++){const _=c-w.windowSize*N;o.lastIndex=Math.max(0,_);const n=S(o,a,c,g);if(!n&&b||(b=n,_<=0))break;g=_}if(b){let N={word:b[0],startColumn:E+1+b.index,endColumn:E+1+b.index+b[0].length};return o.lastIndex=0,N}return null}t.getWordAtText=s;function S(l,o,a,E){let w;for(;w=l.exec(o);){const h=w.index||0;if(h<=a&&l.lastIndex>=a)return w;if(E>0&&h>E)return null}return null}}),G(Q[28],X([0,1,23]),function(I,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.Uint8Matrix=t.State=void 0;var U;(function(c){c[c.Invalid=0]="Invalid",c[c.Start=1]="Start",c[c.H=2]="H",c[c.HT=3]="HT",c[c.HTT=4]="HTT",c[c.HTTP=5]="HTTP",c[c.F=6]="F",c[c.FI=7]="FI",c[c.FIL=8]="FIL",c[c.BeforeColon=9]="BeforeColon",c[c.AfterColon=10]="AfterColon",c[c.AlmostThere=11]="AlmostThere",c[c.End=12]="End",c[c.Accept=13]="Accept",c[c.LastKnownState=14]="LastKnownState"})(U=t.State||(t.State={}));class C{constructor(g,b,N){const _=new Uint8Array(g*b);for(let n=0,i=g*b;n<i;n++)_[n]=N;this._data=_,this.rows=g,this.cols=b}get(g,b){return this._data[g*this.cols+b]}set(g,b,N){this._data[g*this.cols+b]=N}}t.Uint8Matrix=C;class s{constructor(g){let b=0,N=0;for(let n=0,i=g.length;n<i;n++){let[r,u,f]=g[n];u>b&&(b=u),r>N&&(N=r),f>N&&(N=f)}b++,N++;let _=new C(N,b,0);for(let n=0,i=g.length;n<i;n++){let[r,u,f]=g[n];_.set(r,u,f)}this._states=_,this._maxCharCode=b}nextState(g,b){return b<0||b>=this._maxCharCode?0:this._states.get(g,b)}}t.StateMachine=s;let S=null;function l(){return S===null&&(S=new s([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),S}var o;(function(c){c[c.None=0]="None",c[c.ForceTermination=1]="ForceTermination",c[c.CannotEndIn=2]="CannotEndIn"})(o||(o={}));let a=null;function E(){if(a===null){a=new M.CharacterClassifier(0);const c=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let b=0;b<c.length;b++)a.set(c.charCodeAt(b),1);const g=".,;";for(let b=0;b<g.length;b++)a.set(g.charCodeAt(b),2)}return a}class w{static _createLink(g,b,N,_,n){let i=n-1;do{const r=b.charCodeAt(i);if(g.get(r)!==2)break;i--}while(i>_);if(_>0){const r=b.charCodeAt(_-1),u=b.charCodeAt(i);(r===40&&u===41||r===91&&u===93||r===123&&u===125)&&i--}return{range:{startLineNumber:N,startColumn:_+1,endLineNumber:N,endColumn:i+2},url:b.substring(_,i+1)}}static computeLinks(g,b=l()){const N=E();let _=[];for(let n=1,i=g.getLineCount();n<=i;n++){const r=g.getLineContent(n),u=r.length;let f=0,v=0,d=0,m=1,A=!1,p=!1,P=!1,F=!1;for(;f<u;){let R=!1;const y=r.charCodeAt(f);if(m===13){let q;switch(y){case 40:A=!0,q=0;break;case 41:q=A?0:1;break;case 91:P=!0,p=!0,q=0;break;case 93:P=!1,q=p?0:1;break;case 123:F=!0,q=0;break;case 125:q=F?0:1;break;case 39:q=d===34||d===96?0:1;break;case 34:q=d===39||d===96?0:1;break;case 96:q=d===39||d===34?0:1;break;case 42:q=d===42?1:0;break;case 124:q=d===124?1:0;break;case 32:q=P?0:1;break;default:q=N.get(y)}q===1&&(_.push(w._createLink(N,r,n,v,f)),R=!0)}else if(m===12){let q;y===91?(p=!0,q=0):q=N.get(y),q===1?R=!0:m=13}else m=b.nextState(m,y),m===0&&(R=!0);R&&(m=1,A=!1,p=!1,F=!1,v=f+1,d=y),f++}m===13&&_.push(w._createLink(N,r,n,v,u))}return _}}t.LinkComputer=w;function h(c){return!c||typeof c.getLineCount!="function"||typeof c.getLineContent!="function"?[]:w.computeLinks(c)}t.computeLinks=h}),G(Q[29],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class M{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(C,s,S,l,o){if(C&&s){let a=this.doNavigateValueSet(s,o);if(a)return{range:C,value:a}}if(S&&l){let a=this.doNavigateValueSet(l,o);if(a)return{range:S,value:a}}return null}doNavigateValueSet(C,s){let S=this.numberReplace(C,s);return S!==null?S:this.textReplace(C,s)}numberReplace(C,s){let S=Math.pow(10,C.length-(C.lastIndexOf(".")+1)),l=Number(C),o=parseFloat(C);return!isNaN(l)&&!isNaN(o)&&l===o?l===0&&!s?null:(l=Math.floor(l*S),l+=s?S:-S,String(l/S)):null}textReplace(C,s){return this.valueSetsReplace(this._defaultValueSet,C,s)}valueSetsReplace(C,s,S){let l=null;for(let o=0,a=C.length;l===null&&o<a;o++)l=this.valueSetReplace(C[o],s,S);return l}valueSetReplace(C,s,S){let l=C.indexOf(s);return l>=0?(l+=S?1:-1,l<0?l=C.length-1:l%=C.length,C[l]):null}}t.BasicInplaceReplace=M,M.INSTANCE=new M}),G(Q[30],X([0,1]),function(I,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlayHintKind=t.IndentAction=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.AccessibilitySupport=void 0;var M;(function(e){e[e.Unknown=0]="Unknown",e[e.Disabled=1]="Disabled",e[e.Enabled=2]="Enabled"})(M=t.AccessibilitySupport||(t.AccessibilitySupport={}));var U;(function(e){e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet"})(U=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var C;(function(e){e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue",e[e.Snippet=27]="Snippet"})(C=t.CompletionItemKind||(t.CompletionItemKind={}));var s;(function(e){e[e.Deprecated=1]="Deprecated"})(s=t.CompletionItemTag||(t.CompletionItemTag={}));var S;(function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(S=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var l;(function(e){e[e.EXACT=0]="EXACT",e[e.ABOVE=1]="ABOVE",e[e.BELOW=2]="BELOW"})(l=t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));var o;(function(e){e[e.NotSet=0]="NotSet",e[e.ContentFlush=1]="ContentFlush",e[e.RecoverFromMarkers=2]="RecoverFromMarkers",e[e.Explicit=3]="Explicit",e[e.Paste=4]="Paste",e[e.Undo=5]="Undo",e[e.Redo=6]="Redo"})(o=t.CursorChangeReason||(t.CursorChangeReason={}));var a;(function(e){e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(a=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var E;(function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"})(E=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));var w;(function(e){e[e.None=0]="None",e[e.Keep=1]="Keep",e[e.Brackets=2]="Brackets",e[e.Advanced=3]="Advanced",e[e.Full=4]="Full"})(w=t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={}));var h;(function(e){e[e.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",e[e.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",e[e.accessibilitySupport=2]="accessibilitySupport",e[e.accessibilityPageSize=3]="accessibilityPageSize",e[e.ariaLabel=4]="ariaLabel",e[e.autoClosingBrackets=5]="autoClosingBrackets",e[e.autoClosingDelete=6]="autoClosingDelete",e[e.autoClosingOvertype=7]="autoClosingOvertype",e[e.autoClosingQuotes=8]="autoClosingQuotes",e[e.autoIndent=9]="autoIndent",e[e.automaticLayout=10]="automaticLayout",e[e.autoSurround=11]="autoSurround",e[e.codeLens=12]="codeLens",e[e.codeLensFontFamily=13]="codeLensFontFamily",e[e.codeLensFontSize=14]="codeLensFontSize",e[e.colorDecorators=15]="colorDecorators",e[e.columnSelection=16]="columnSelection",e[e.comments=17]="comments",e[e.contextmenu=18]="contextmenu",e[e.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",e[e.cursorBlinking=20]="cursorBlinking",e[e.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",e[e.cursorStyle=22]="cursorStyle",e[e.cursorSurroundingLines=23]="cursorSurroundingLines",e[e.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",e[e.cursorWidth=25]="cursorWidth",e[e.disableLayerHinting=26]="disableLayerHinting",e[e.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",e[e.domReadOnly=28]="domReadOnly",e[e.dragAndDrop=29]="dragAndDrop",e[e.emptySelectionClipboard=30]="emptySelectionClipboard",e[e.extraEditorClassName=31]="extraEditorClassName",e[e.fastScrollSensitivity=32]="fastScrollSensitivity",e[e.find=33]="find",e[e.fixedOverflowWidgets=34]="fixedOverflowWidgets",e[e.folding=35]="folding",e[e.foldingStrategy=36]="foldingStrategy",e[e.foldingHighlight=37]="foldingHighlight",e[e.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",e[e.fontFamily=39]="fontFamily",e[e.fontInfo=40]="fontInfo",e[e.fontLigatures=41]="fontLigatures",e[e.fontSize=42]="fontSize",e[e.fontWeight=43]="fontWeight",e[e.formatOnPaste=44]="formatOnPaste",e[e.formatOnType=45]="formatOnType",e[e.glyphMargin=46]="glyphMargin",e[e.gotoLocation=47]="gotoLocation",e[e.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",e[e.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",e[e.hover=50]="hover",e[e.inDiffEditor=51]="inDiffEditor",e[e.letterSpacing=52]="letterSpacing",e[e.lightbulb=53]="lightbulb",e[e.lineDecorationsWidth=54]="lineDecorationsWidth",e[e.lineHeight=55]="lineHeight",e[e.lineNumbers=56]="lineNumbers",e[e.lineNumbersMinChars=57]="lineNumbersMinChars",e[e.linkedEditing=58]="linkedEditing",e[e.links=59]="links",e[e.matchBrackets=60]="matchBrackets",e[e.minimap=61]="minimap",e[e.mouseStyle=62]="mouseStyle",e[e.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",e[e.mouseWheelZoom=64]="mouseWheelZoom",e[e.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",e[e.multiCursorModifier=66]="multiCursorModifier",e[e.multiCursorPaste=67]="multiCursorPaste",e[e.occurrencesHighlight=68]="occurrencesHighlight",e[e.overviewRulerBorder=69]="overviewRulerBorder",e[e.overviewRulerLanes=70]="overviewRulerLanes",e[e.padding=71]="padding",e[e.parameterHints=72]="parameterHints",e[e.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",e[e.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",e[e.quickSuggestions=75]="quickSuggestions",e[e.quickSuggestionsDelay=76]="quickSuggestionsDelay",e[e.readOnly=77]="readOnly",e[e.renameOnType=78]="renameOnType",e[e.renderControlCharacters=79]="renderControlCharacters",e[e.renderIndentGuides=80]="renderIndentGuides",e[e.renderFinalNewline=81]="renderFinalNewline",e[e.renderLineHighlight=82]="renderLineHighlight",e[e.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",e[e.renderValidationDecorations=84]="renderValidationDecorations",e[e.renderWhitespace=85]="renderWhitespace",e[e.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",e[e.roundedSelection=87]="roundedSelection",e[e.rulers=88]="rulers",e[e.scrollbar=89]="scrollbar",e[e.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",e[e.scrollBeyondLastLine=91]="scrollBeyondLastLine",e[e.scrollPredominantAxis=92]="scrollPredominantAxis",e[e.selectionClipboard=93]="selectionClipboard",e[e.selectionHighlight=94]="selectionHighlight",e[e.selectOnLineNumbers=95]="selectOnLineNumbers",e[e.showFoldingControls=96]="showFoldingControls",e[e.showUnused=97]="showUnused",e[e.snippetSuggestions=98]="snippetSuggestions",e[e.smartSelect=99]="smartSelect",e[e.smoothScrolling=100]="smoothScrolling",e[e.stickyTabStops=101]="stickyTabStops",e[e.stopRenderingLineAfter=102]="stopRenderingLineAfter",e[e.suggest=103]="suggest",e[e.suggestFontSize=104]="suggestFontSize",e[e.suggestLineHeight=105]="suggestLineHeight",e[e.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",e[e.suggestSelection=107]="suggestSelection",e[e.tabCompletion=108]="tabCompletion",e[e.tabIndex=109]="tabIndex",e[e.unusualLineTerminators=110]="unusualLineTerminators",e[e.useShadowDOM=111]="useShadowDOM",e[e.useTabStops=112]="useTabStops",e[e.wordSeparators=113]="wordSeparators",e[e.wordWrap=114]="wordWrap",e[e.wordWrapBreakAfterCharacters=115]="wordWrapBreakAfterCharacters",e[e.wordWrapBreakBeforeCharacters=116]="wordWrapBreakBeforeCharacters",e[e.wordWrapColumn=117]="wordWrapColumn",e[e.wordWrapOverride1=118]="wordWrapOverride1",e[e.wordWrapOverride2=119]="wordWrapOverride2",e[e.wrappingIndent=120]="wrappingIndent",e[e.wrappingStrategy=121]="wrappingStrategy",e[e.showDeprecated=122]="showDeprecated",e[e.inlayHints=123]="inlayHints",e[e.editorClassName=124]="editorClassName",e[e.pixelRatio=125]="pixelRatio",e[e.tabFocusMode=126]="tabFocusMode",e[e.layoutInfo=127]="layoutInfo",e[e.wrappingInfo=128]="wrappingInfo"})(h=t.EditorOption||(t.EditorOption={}));var c;(function(e){e[e.TextDefined=0]="TextDefined",e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(c=t.EndOfLinePreference||(t.EndOfLinePreference={}));var g;(function(e){e[e.LF=0]="LF",e[e.CRLF=1]="CRLF"})(g=t.EndOfLineSequence||(t.EndOfLineSequence={}));var b;(function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"})(b=t.IndentAction||(t.IndentAction={}));var N;(function(e){e[e.Other=0]="Other",e[e.Type=1]="Type",e[e.Parameter=2]="Parameter"})(N=t.InlayHintKind||(t.InlayHintKind={}));var _;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.KEY_0=21]="KEY_0",e[e.KEY_1=22]="KEY_1",e[e.KEY_2=23]="KEY_2",e[e.KEY_3=24]="KEY_3",e[e.KEY_4=25]="KEY_4",e[e.KEY_5=26]="KEY_5",e[e.KEY_6=27]="KEY_6",e[e.KEY_7=28]="KEY_7",e[e.KEY_8=29]="KEY_8",e[e.KEY_9=30]="KEY_9",e[e.KEY_A=31]="KEY_A",e[e.KEY_B=32]="KEY_B",e[e.KEY_C=33]="KEY_C",e[e.KEY_D=34]="KEY_D",e[e.KEY_E=35]="KEY_E",e[e.KEY_F=36]="KEY_F",e[e.KEY_G=37]="KEY_G",e[e.KEY_H=38]="KEY_H",e[e.KEY_I=39]="KEY_I",e[e.KEY_J=40]="KEY_J",e[e.KEY_K=41]="KEY_K",e[e.KEY_L=42]="KEY_L",e[e.KEY_M=43]="KEY_M",e[e.KEY_N=44]="KEY_N",e[e.KEY_O=45]="KEY_O",e[e.KEY_P=46]="KEY_P",e[e.KEY_Q=47]="KEY_Q",e[e.KEY_R=48]="KEY_R",e[e.KEY_S=49]="KEY_S",e[e.KEY_T=50]="KEY_T",e[e.KEY_U=51]="KEY_U",e[e.KEY_V=52]="KEY_V",e[e.KEY_W=53]="KEY_W",e[e.KEY_X=54]="KEY_X",e[e.KEY_Y=55]="KEY_Y",e[e.KEY_Z=56]="KEY_Z",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.US_SEMICOLON=80]="US_SEMICOLON",e[e.US_EQUAL=81]="US_EQUAL",e[e.US_COMMA=82]="US_COMMA",e[e.US_MINUS=83]="US_MINUS",e[e.US_DOT=84]="US_DOT",e[e.US_SLASH=85]="US_SLASH",e[e.US_BACKTICK=86]="US_BACKTICK",e[e.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",e[e.US_BACKSLASH=88]="US_BACKSLASH",e[e.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",e[e.US_QUOTE=90]="US_QUOTE",e[e.OEM_8=91]="OEM_8",e[e.OEM_102=92]="OEM_102",e[e.NUMPAD_0=93]="NUMPAD_0",e[e.NUMPAD_1=94]="NUMPAD_1",e[e.NUMPAD_2=95]="NUMPAD_2",e[e.NUMPAD_3=96]="NUMPAD_3",e[e.NUMPAD_4=97]="NUMPAD_4",e[e.NUMPAD_5=98]="NUMPAD_5",e[e.NUMPAD_6=99]="NUMPAD_6",e[e.NUMPAD_7=100]="NUMPAD_7",e[e.NUMPAD_8=101]="NUMPAD_8",e[e.NUMPAD_9=102]="NUMPAD_9",e[e.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",e[e.NUMPAD_ADD=104]="NUMPAD_ADD",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",e[e.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",e[e.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.MAX_VALUE=112]="MAX_VALUE"})(_=t.KeyCode||(t.KeyCode={}));var n;(function(e){e[e.Hint=1]="Hint",e[e.Info=2]="Info",e[e.Warning=4]="Warning",e[e.Error=8]="Error"})(n=t.MarkerSeverity||(t.MarkerSeverity={}));var i;(function(e){e[e.Unnecessary=1]="Unnecessary",e[e.Deprecated=2]="Deprecated"})(i=t.MarkerTag||(t.MarkerTag={}));var r;(function(e){e[e.Inline=1]="Inline",e[e.Gutter=2]="Gutter"})(r=t.MinimapPosition||(t.MinimapPosition={}));var u;(function(e){e[e.UNKNOWN=0]="UNKNOWN",e[e.TEXTAREA=1]="TEXTAREA",e[e.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",e[e.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",e[e.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",e[e.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",e[e.CONTENT_TEXT=6]="CONTENT_TEXT",e[e.CONTENT_EMPTY=7]="CONTENT_EMPTY",e[e.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",e[e.CONTENT_WIDGET=9]="CONTENT_WIDGET",e[e.OVERVIEW_RULER=10]="OVERVIEW_RULER",e[e.SCROLLBAR=11]="SCROLLBAR",e[e.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",e[e.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(u=t.MouseTargetType||(t.MouseTargetType={}));var f;(function(e){e[e.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",e[e.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",e[e.TOP_CENTER=2]="TOP_CENTER"})(f=t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));var v;(function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"})(v=t.OverviewRulerLane||(t.OverviewRulerLane={}));var d;(function(e){e[e.Off=0]="Off",e[e.On=1]="On",e[e.Relative=2]="Relative",e[e.Interval=3]="Interval",e[e.Custom=4]="Custom"})(d=t.RenderLineNumbersType||(t.RenderLineNumbersType={}));var m;(function(e){e[e.None=0]="None",e[e.Text=1]="Text",e[e.Blocks=2]="Blocks"})(m=t.RenderMinimap||(t.RenderMinimap={}));var A;(function(e){e[e.Smooth=0]="Smooth",e[e.Immediate=1]="Immediate"})(A=t.ScrollType||(t.ScrollType={}));var p;(function(e){e[e.Auto=1]="Auto",e[e.Hidden=2]="Hidden",e[e.Visible=3]="Visible"})(p=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));var P;(function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"})(P=t.SelectionDirection||(t.SelectionDirection={}));var F;(function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"})(F=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var R;(function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",e[e.TypeParameter=25]="TypeParameter"})(R=t.SymbolKind||(t.SymbolKind={}));var y;(function(e){e[e.Deprecated=1]="Deprecated"})(y=t.SymbolTag||(t.SymbolTag={}));var q;(function(e){e[e.Hidden=0]="Hidden",e[e.Blink=1]="Blink",e[e.Smooth=2]="Smooth",e[e.Phase=3]="Phase",e[e.Expand=4]="Expand",e[e.Solid=5]="Solid"})(q=t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={}));var $;(function(e){e[e.Line=1]="Line",e[e.Block=2]="Block",e[e.Underline=3]="Underline",e[e.LineThin=4]="LineThin",e[e.BlockOutline=5]="BlockOutline",e[e.UnderlineThin=6]="UnderlineThin"})($=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={}));var x;(function(e){e[e.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",e[e.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",e[e.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",e[e.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(x=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var z;(function(e){e[e.None=0]="None",e[e.Same=1]="Same",e[e.Indent=2]="Indent",e[e.DeepIndent=3]="DeepIndent"})(z=t.WrappingIndent||(t.WrappingIndent={}))}),G(Q[31],X([0,1,21,10,17,14,3,6,24,25,30]),function(I,t,M,U,C,s,S,l,o,a,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class w{static chord(g,b){return(0,C.KeyChord)(g,b)}}t.KeyMod=w,w.CtrlCmd=2048,w.Shift=1024,w.Alt=512,w.WinCtrl=256;function h(){return{editor:void 0,languages:void 0,CancellationTokenSource:M.CancellationTokenSource,Emitter:U.Emitter,KeyCode:E.KeyCode,KeyMod:w,Position:S.Position,Range:l.Range,Selection:o.Selection,SelectionDirection:E.SelectionDirection,MarkerSeverity:E.MarkerSeverity,MarkerTag:E.MarkerTag,Uri:s.URI,Token:a.Token}}t.createMonacoBaseAPI=h}),G(Q[32],X([0,1,13]),function(I,t,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumComputer=t.PrefixSumIndexOfResult=void 0;class U{constructor(S,l){this.index=S,this.remainder=l}}t.PrefixSumIndexOfResult=U;class C{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,l){S=(0,M.toUint32)(S);const o=this.values,a=this.prefixSum,E=l.length;return E===0?!1:(this.values=new Uint32Array(o.length+E),this.values.set(o.subarray(0,S),0),this.values.set(o.subarray(S),S+E),this.values.set(l,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(a.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(S,l){return S=(0,M.toUint32)(S),l=(0,M.toUint32)(l),this.values[S]===l?!1:(this.values[S]=l,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,l){S=(0,M.toUint32)(S),l=(0,M.toUint32)(l);const o=this.values,a=this.prefixSum;if(S>=o.length)return!1;let E=o.length-S;return l>=E&&(l=E),l===0?!1:(this.values=new Uint32Array(o.length-l),this.values.set(o.subarray(0,S),0),this.values.set(o.subarray(S+l),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(a.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(S){return S<0?0:(S=(0,M.toUint32)(S),this._getAccumulatedValue(S))}_getAccumulatedValue(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let l=this.prefixSumValidIndex[0]+1;l===0&&(this.prefixSum[0]=this.values[0],l++),S>=this.values.length&&(S=this.values.length-1);for(let o=l;o<=S;o++)this.prefixSum[o]=this.prefixSum[o-1]+this.values[o];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalValue();let l=0,o=this.values.length-1,a=0,E=0,w=0;for(;l<=o;)if(a=l+(o-l)/2|0,E=this.prefixSum[a],w=E-this.values[a],S<w)o=a-1;else if(S>=E)l=a+1;else break;return new U(a,S-w)}}t.PrefixSumComputer=C}),G(Q[33],X([0,1,5,3,32]),function(I,t,M,U,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class s{constructor(l,o,a,E){this._uri=l,this._lines=o,this._eol=a,this._versionId=E,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(l){l.eol&&l.eol!==this._eol&&(this._eol=l.eol,this._lineStarts=null);const o=l.changes;for(const a of o)this._acceptDeleteRange(a.range),this._acceptInsertText(new U.Position(a.range.startLineNumber,a.range.startColumn),a.text);this._versionId=l.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const l=this._eol.length,o=this._lines.length,a=new Uint32Array(o);for(let E=0;E<o;E++)a[E]=this._lines[E].length+l;this._lineStarts=new C.PrefixSumComputer(a)}}_setLineText(l,o){this._lines[l]=o,this._lineStarts&&this._lineStarts.changeValue(l,this._lines[l].length+this._eol.length)}_acceptDeleteRange(l){if(l.startLineNumber===l.endLineNumber){if(l.startColumn===l.endColumn)return;this._setLineText(l.startLineNumber-1,this._lines[l.startLineNumber-1].substring(0,l.startColumn-1)+this._lines[l.startLineNumber-1].substring(l.endColumn-1));return}this._setLineText(l.startLineNumber-1,this._lines[l.startLineNumber-1].substring(0,l.startColumn-1)+this._lines[l.endLineNumber-1].substring(l.endColumn-1)),this._lines.splice(l.startLineNumber,l.endLineNumber-l.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(l.startLineNumber,l.endLineNumber-l.startLineNumber)}_acceptInsertText(l,o){if(o.length!==0){let a=(0,M.splitLines)(o);if(a.length===1){this._setLineText(l.lineNumber-1,this._lines[l.lineNumber-1].substring(0,l.column-1)+a[0]+this._lines[l.lineNumber-1].substring(l.column-1));return}a[a.length-1]+=this._lines[l.lineNumber-1].substring(l.column-1),this._setLineText(l.lineNumber-1,this._lines[l.lineNumber-1].substring(0,l.column-1)+a[0]);let E=new Uint32Array(a.length-1);for(let w=1;w<a.length;w++)this._lines.splice(l.lineNumber+w-1,0,a[w]),E[w-1]=a[w].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(l.lineNumber,E)}}}t.MirrorTextModel=s}),G(Q[35],X([0,1,11,2,14,3,6,26,33,27,28,29,31,12,9]),function(I,t,M,U,C,s,S,l,o,a,E,w,h,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class b extends o.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,r){let u=(0,a.getWordAtText)(i.column,(0,a.ensureValidWordDefinition)(r),this._lines[i.lineNumber-1],0);return u?new S.Range(i.lineNumber,u.startColumn,i.lineNumber,u.endColumn):null}getWordUntilPosition(i,r){const u=this.getWordAtPosition(i,r);return u?{word:this._lines[i.lineNumber-1].substring(u.startColumn-1,i.column-1),startColumn:u.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const r=this._lines,u=this._wordenize.bind(this);let f=0,v="",d=0,m=[];return{*[Symbol.iterator](){for(;;)if(d<m.length){const A=v.substring(m[d].start,m[d].end);d+=1,yield A}else if(f<r.length)v=r[f],m=u(v,i),d=0,f+=1;else break}}}getLineWords(i,r){let u=this._lines[i-1],f=this._wordenize(u,r),v=[];for(const d of f)v.push({word:u.substring(d.start,d.end),startColumn:d.start+1,endColumn:d.end+1});return v}_wordenize(i,r){const u=[];let f;for(r.lastIndex=0;(f=r.exec(i))&&f[0].length!==0;)u.push({start:f.index,end:f.index+f[0].length});return u}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);let r=this._eol,u=i.startLineNumber-1,f=i.endLineNumber-1,v=[];v.push(this._lines[u].substring(i.startColumn-1));for(let d=u+1;d<f;d++)v.push(this._lines[d]);return v.push(this._lines[f].substring(0,i.endColumn-1)),v.join(r)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();let r=this._lineStarts.getIndexOf(i),u=this._lines[r.index].length;return{lineNumber:1+r.index,column:1+Math.min(r.remainder,u)}}_validateRange(i){const r=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),u=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return r.lineNumber!==i.startLineNumber||r.column!==i.startColumn||u.lineNumber!==i.endLineNumber||u.column!==i.endColumn?{startLineNumber:r.lineNumber,startColumn:r.column,endLineNumber:u.lineNumber,endColumn:u.column}:i}_validatePosition(i){if(!s.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:r,column:u}=i,f=!1;if(r<1)r=1,u=1,f=!0;else if(r>this._lines.length)r=this._lines.length,u=this._lines[r-1].length+1,f=!0;else{let v=this._lines[r-1].length+1;u<1?(u=1,f=!0):u>v&&(u=v,f=!0)}return f?{lineNumber:r,column:u}:i}}class N{constructor(i,r){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=r,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){let i=[];return Object.keys(this._models).forEach(r=>i.push(this._models[r])),i}acceptNewModel(i){this._models[i.url]=new b(C.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,r){!this._models[i]||this._models[i].onEvents(r)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}async computeDiff(i,r,u,f){const v=this._getModel(i),d=this._getModel(r);if(!v||!d)return null;const m=v.getLinesContent(),A=d.getLinesContent(),P=new l.DiffComputer(m,A,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:u,shouldMakePrettyDiff:!0,maxComputationTime:f}).computeDiff(),F=P.changes.length>0?!1:this._modelsAreIdentical(v,d);return{quitEarly:P.quitEarly,identical:F,changes:P.changes}}_modelsAreIdentical(i,r){const u=i.getLineCount(),f=r.getLineCount();if(u!==f)return!1;for(let v=1;v<=u;v++){const d=i.getLineContent(v),m=r.getLineContent(v);if(d!==m)return!1}return!0}async computeDirtyDiff(i,r,u){let f=this._getModel(i),v=this._getModel(r);if(!f||!v)return null;let d=f.getLinesContent(),m=v.getLinesContent();return new l.DiffComputer(d,m,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:u,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(i,r){const u=this._getModel(i);if(!u)return r;const f=[];let v;r=r.slice(0).sort((d,m)=>{if(d.range&&m.range)return S.Range.compareRangesUsingStarts(d.range,m.range);let A=d.range?0:1,p=m.range?0:1;return A-p});for(let{range:d,text:m,eol:A}of r)if(typeof A=="number"&&(v=A),!(S.Range.isEmpty(d)&&!m)){const p=u.getValueInRange(d);if(m=m.replace(/\r\n|\n|\r/g,u.eol),p!==m){if(Math.max(m.length,p.length)>N._diffLimit){f.push({range:d,text:m});continue}const P=(0,M.stringDiff)(p,m,!1),F=u.offsetAt(S.Range.lift(d).getStartPosition());for(const R of P){const y=u.positionAt(F+R.originalStart),q=u.positionAt(F+R.originalStart+R.originalLength),$={text:m.substr(R.modifiedStart,R.modifiedLength),range:{startLineNumber:y.lineNumber,startColumn:y.column,endLineNumber:q.lineNumber,endColumn:q.column}};u.getValueInRange($.range)!==$.text&&f.push($)}}}return typeof v=="number"&&f.push({eol:v,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),f}async computeLinks(i){let r=this._getModel(i);return r?(0,E.computeLinks)(r):null}async textualSuggest(i,r,u,f){const v=new g.StopWatch(!0),d=new RegExp(u,f),m=new Set;e:for(let A of i){const p=this._getModel(A);if(!!p){for(let P of p.words(d))if(!(P===r||!isNaN(Number(P)))&&(m.add(P),m.size>N._suggestionsLimit))break e}}return{words:Array.from(m),duration:v.elapsed()}}async computeWordRanges(i,r,u,f){let v=this._getModel(i);if(!v)return Object.create(null);const d=new RegExp(u,f),m=Object.create(null);for(let A=r.startLineNumber;A<r.endLineNumber;A++){let p=v.getLineWords(A,d);for(const P of p)if(!!isNaN(Number(P.word))){let F=m[P.word];F||(F=[],m[P.word]=F),F.push({startLineNumber:A,startColumn:P.startColumn,endLineNumber:A,endColumn:P.endColumn})}}return m}async navigateValueSet(i,r,u,f,v){let d=this._getModel(i);if(!d)return null;let m=new RegExp(f,v);r.startColumn===r.endColumn&&(r={startLineNumber:r.startLineNumber,startColumn:r.startColumn,endLineNumber:r.endLineNumber,endColumn:r.endColumn+1});let A=d.getValueInRange(r),p=d.getWordAtPosition({lineNumber:r.startLineNumber,column:r.startColumn},m);if(!p)return null;let P=d.getValueInRange(p);return w.BasicInplaceReplace.INSTANCE.navigateValueSet(r,A,p,P,u)}loadForeignModule(i,r,u){const f=(m,A)=>this._host.fhr(m,A);let d={host:c.createProxyObject(u,f),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(d,r),Promise.resolve(c.getAllMethodNames(this._foreignModule))):new Promise((m,A)=>{I([i],p=>{this._foreignModule=p.create(d,r),m(c.getAllMethodNames(this._foreignModule))},A)})}fmr(i,r){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,r))}catch(u){return Promise.reject(u)}}}t.EditorSimpleWorker=N,N._diffLimit=1e5,N._suggestionsLimit=1e4;function _(n){return new N(n,null)}t.create=_,typeof importScripts=="function"&&(U.globals.monaco=(0,h.createMonacoBaseAPI)())});"use strict";(function(){var I,t;const M=self.MonacoEnvironment,U=M&&M.baseUrl?M.baseUrl:"../../../",C=typeof((I=self.trustedTypes)===null||I===void 0?void 0:I.createPolicy)=="function"?(t=self.trustedTypes)===null||t===void 0?void 0:t.createPolicy("amdLoader",{createScriptURL:a=>a,createScript:(a,...E)=>{const w=E.slice(0,-1).join(","),h=E.pop().toString();return`(function anonymous(${w}) {
${h}
})`}}):void 0;function s(){return new Promise((a,E)=>{if(typeof self.define=="function"&&self.define.amd)return a();const w=U+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(w)&&w.substring(0,self.origin.length)!==self.origin)){fetch(w).then(c=>{if(c.status!==200)throw new Error(c.statusText);return c.text()}).then(c=>{c=`${c}
//# sourceURL=${w}`,(C?self.eval(C.createScript("",c)):new Function(c)).call(self),a()}).then(void 0,E);return}C?importScripts(C.createScriptURL(w)):importScripts(w),a()})}const S=function(a){s().then(()=>{require.config({baseUrl:U,catchError:!0,trustedTypesPolicy:C}),require([a],function(E){setTimeout(function(){let w=E.create((h,c)=>{self.postMessage(h,c)},null);for(self.onmessage=h=>w.onmessage(h.data);o.length>0;)self.onmessage(o.shift())},0)})})};let l=!0,o=[];self.onmessage=a=>{if(!l){o.push(a);return}l=!1,S(a.data)}})()}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/659175fa39b994fc39381b0af2874c85efeb2a01/core/vs/base/worker/workerMain.js.map
