/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/platform","vs/base/common/path","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/resources","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/base/common/arrays","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/platform/telemetry/common/telemetry","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/objects","fs","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/base/common/uuid","vs/base/common/json","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/process","vs/base/common/map","os","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","child_process","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","util","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/code/electron-browser/sharedProcess/contrib/nodeCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","path","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(K){for(var e=[],p=0,k=K.length;p<k;p++)e[p]=Z[K[p]];return e};define(Z[85],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(k,A){if(!k)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=p}),define(Z[62],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupByNumber=e.groupBy=e.forEach=e.values=void 0;const p=Object.prototype.hasOwnProperty;function k(y){const v=[];for(let b in y)p.call(y,b)&&v.push(y[b]);return v}e.values=k;function A(y,v){for(let b in y)if(p.call(y,b)&&v({key:b,value:y[b]},function(){delete y[b]})===!1)return}e.forEach=A;function R(y,v){const b=Object.create(null);for(const u of y){const S=v(u);let C=b[S];C||(C=b[S]=[]),C.push(u)}return b}e.groupBy=R;function U(y,v){const b=new Map;for(const u of y){const S=v(u);let C=b.get(S);C||(C=[],b.set(S,C)),C.push(u)}return b}e.groupByNumber=U;function O(y){const v=Object.create(null);return y&&y.forEach((b,u)=>{v[u]=b}),v}e.fromMap=O;function g(y,v){const b=[],u=[];for(let S of y)v.has(S)||b.push(S);for(let S of v)y.has(S)||u.push(S);return{removed:b,added:u}}e.diffSets=g;function m(y,v){const b=[],u=[];for(let[S,C]of y)v.has(S)||b.push(C);for(let[S,C]of v)y.has(S)||u.push(C);return{removed:b,added:u}}e.diffMaps=m;class T{constructor(){this.map=new Map}add(v,b){let u=this.map.get(v);u||(u=new Set,this.map.set(v,u)),u.add(b)}delete(v,b){const u=this.map.get(v);!u||(u.delete(b),u.size===0&&this.map.delete(v))}forEach(v,b){const u=this.map.get(v);!u||u.forEach(b)}}e.SetMap=T}),define(Z[63],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(U){return(O,g,m)=>{let T=null,y=null;if(typeof m.value=="function"?(T="value",y=m.value):typeof m.get=="function"&&(T="get",y=m.get),!y)throw new Error("not supported");m[T]=U(y,g)}}e.createDecorator=p;function k(U,O,g){let m=null,T=null;if(typeof g.value=="function"?(m="value",T=g.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(m="get",T=g.get),!T)throw new Error("not supported");const y=`$memoize$${O}`;g[m]=function(...v){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,v)}),this[y]}}e.memoize=k;function A(U,O,g){return p((m,T)=>{const y=`$debounce$${T}`,v=`$debounce$result$${T}`;return function(...b){this[v]||(this[v]=g?g():void 0),clearTimeout(this[y]),O&&(this[v]=O(this[v],...b),b=[this[v]]),this[y]=setTimeout(()=>{m.apply(this,b),this[v]=g?g():void 0},U)}})}e.debounce=A;function R(U,O,g){return p((m,T)=>{const y=`$throttle$timer$${T}`,v=`$throttle$result$${T}`,b=`$throttle$lastRun$${T}`,u=`$throttle$pending$${T}`;return function(...S){if(this[v]||(this[v]=g?g():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),O&&(this[v]=O(this[v],...S)),!this[u]){const C=this[b]+U;C<=Date.now()?(this[b]=Date.now(),m.apply(this,[this[v]]),this[v]=g?g():void 0):(this[u]=!0,this[y]=setTimeout(()=>{this[u]=!1,this[b]=Date.now(),m.apply(this,[this[v]]),this[v]=g?g():void 0},C-Date.now()))}}})}e.throttle=R}),define(Z[11],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=p,e.errorHandler=new p;function k(r){e.errorHandler.setUnexpectedErrorHandler(r)}e.setUnexpectedErrorHandler=k;function A(r){g(r)||e.errorHandler.onUnexpectedError(r)}e.onUnexpectedError=A;function R(r){g(r)||e.errorHandler.onUnexpectedExternalError(r)}e.onUnexpectedExternalError=R;function U(r){if(r instanceof Error){let{name:t,message:i}=r;const n=r.stacktrace||r.stack;return{$isError:!0,name:t,message:i,stack:n}}return r}e.transformErrorForSerialization=U;const O="Canceled";function g(r){return r instanceof Error&&r.name===O&&r.message===O}e.isPromiseCanceledError=g;class m extends Error{constructor(){super(O);this.name=this.message}}e.CancellationError=m;function T(){const r=new Error(O);return r.name=r.message,r}e.canceled=T;function y(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}e.illegalArgument=y;function v(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}e.illegalState=v;function b(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function u(r){const t=new Error(`${r} has been disposed`);return t.name="DISPOSED",t}e.disposed=u;function S(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}e.getErrorMessage=S;class C extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=C;class E extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=E;class D extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=D;function f(r){const t=r;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=f;function s(r,t=Object.create(null)){const i=new Error(r);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=s}),define(Z[18],ee([0,1,11]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function k($,V=0){return $[$.length-(1+V)]}e.tail=k;function A($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=A;function R($,V,H=(L,I)=>L===I){if($===V)return!0;if(!$||!V||$.length!==V.length)return!1;for(let L=0,I=$.length;L<I;L++)if(!H($[L],V[L]))return!1;return!0}e.equals=R;function U($,V,H){let L=0,I=$.length-1;for(;L<=I;){const F=(L+I)/2|0,N=H($[F],V);if(N<0)L=F+1;else if(N>0)I=F-1;else return F}return-(L+1)}e.binarySearch=U;function O($,V){let H=0,L=$.length;if(L===0)return 0;for(;H<L;){const I=Math.floor((H+L)/2);V($[I])?L=I:H=I+1}return H}e.findFirstInSorted=O;function g($,V,H){if($=$|0,$>=V.length)throw new TypeError("invalid index");let L=V[Math.floor(V.length*Math.random())],I=[],F=[],N=[];for(let W of V){const x=H(W,L);x<0?I.push(W):x>0?F.push(W):N.push(W)}return $<I.length?g($,I,H):$<I.length+N.length?N[0]:g($-(I.length+N.length),F,H)}e.quickSelect=g;function m($,V){const H=[];let L;for(const I of $.slice(0).sort(V))!L||V(L[0],I)!==0?(L=[I],H.push(L)):L.push(I);return H}e.groupBy=m;function T($,V,H){const L=[];function I(W,x,X){if(!(x===0&&X.length===0)){const Q=L[L.length-1];Q&&Q.start+Q.deleteCount===W?(Q.deleteCount+=x,Q.toInsert.push(...X)):L.push({start:W,deleteCount:x,toInsert:X})}}let F=0,N=0;for(;;){if(F===$.length){I(F,0,V.slice(N));break}if(N===V.length){I(F,$.length-F,[]);break}const W=$[F],x=V[N],X=H(W,x);X===0?(F+=1,N+=1):X<0?(I(F,1,[]),F+=1):X>0&&(I(F,0,[x]),N+=1)}return L}e.sortedDiff=T;function y($,V,H){const L=T($,V,H),I=[],F=[];for(const N of L)I.push(...$.slice(N.start,N.start+N.deleteCount)),F.push(...N.toInsert);return{removed:I,added:F}}e.delta=y;function v($,V,H){if(H===0)return[];const L=$.slice(0,H).sort(V);return u($,V,L,H,$.length),L}e.top=v;function b($,V,H,L,I){return H===0?Promise.resolve([]):new Promise((F,N)=>{(async()=>{const W=$.length,x=$.slice(0,H).sort(V);for(let X=H,Q=Math.min(H+L,W);X<W;X=Q,Q=Math.min(Q+L,W)){if(X>H&&await new Promise(ne=>setTimeout(ne)),I&&I.isCancellationRequested)throw(0,p.canceled)();u($,V,x,X,Q)}return x})().then(F,N)})}e.topAsync=b;function u($,V,H,L,I){for(const F=H.length;L<I;L++){const N=$[L];if(V(N,H[F-1])<0){H.pop();const W=O(H,x=>V(N,x)<0);H.splice(W,0,N)}}}function S($){return $.filter(V=>!!V)}e.coalesce=S;function C($){let V=0;for(let H=0;H<$.length;H++)$[H]&&($[V]=$[H],V+=1);$.length=V}e.coalesceInPlace=C;function E($,V,H){$.splice(H,0,$.splice(V,1)[0])}e.move=E;function D($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=D;function f($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=f;function s($,V){if(!V)return $.filter((L,I)=>$.indexOf(L)===I);const H=Object.create(null);return $.filter(L=>{const I=V(L);return H[I]?!1:(H[I]=!0,!0)})}e.distinct=s;function r($){const V=new Set;return $.filter(H=>V.has(H)?!1:(V.add(H),!0))}e.distinctES6=r;function t($){const V=Object.create(null);return H=>{const L=$(H);return V[L]?!1:(V[L]=!0,!0)}}e.uniqueFilter=t;function i($,V){for(let H=$.length-1;H>=0;H--){const L=$[H];if(V(L))return H}return-1}e.lastIndex=i;function n($,V){return $.length>0?$[0]:V}e.firstOrDefault=n;function o($,V,H=(L,I)=>L===I){let L=0;for(let I=0,F=Math.min($.length,V.length);I<F&&H($[I],V[I]);I++)L++;return L}e.commonPrefixLength=o;function a($){return[].concat(...$)}e.flatten=a;function c($,V){let H=typeof V=="number"?$:0;typeof V=="number"?H=$:(H=0,V=$);const L=[];if(H<=V)for(let I=H;I<V;I++)L.push(I);else for(let I=H;I>V;I--)L.push(I);return L}e.range=c;function l($,V,H){return $.reduce((L,I)=>(L[V(I)]=H?H(I):I,L),Object.create(null))}e.index=l;function d($,V){return $.push(V),()=>w($,V)}e.insert=d;function w($,V){const H=$.indexOf(V);if(H>-1)return $.splice(H,1),V}e.remove=w;function h($,V,H){const L=$.slice(0,V),I=$.slice(V);return L.concat(H,I)}e.arrayInsert=h;function P($,V){let H;if(typeof V=="number"){let L=V;H=()=>{const I=Math.sin(L++)*179426549;return I-Math.floor(I)}}else H=Math.random;for(let L=$.length-1;L>0;L-=1){const I=Math.floor(H()*(L+1)),F=$[L];$[L]=$[I],$[I]=F}}e.shuffle=P;function _($,V){const H=$.indexOf(V);H>-1&&($.splice(H,1),$.unshift(V))}e.pushToStart=_;function j($,V){const H=$.indexOf(V);H>-1&&($.splice(H,1),$.push(V))}e.pushToEnd=j;function q($,V){return Array.isArray($)?$.map(V):V($)}e.mapArrayOrNot=q;function G($){return Array.isArray($)?$:[$]}e.asArray=G;function M($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=M;function z($,V){for(const H of $){const L=V(H);if(L!==void 0)return L}}e.mapFind=z}),define(Z[64],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(k){const A=this;let R=!1,U;return function(){return R||(R=!0,U=k.apply(A,arguments)),U}}e.once=p}),define(Z[53],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(k){function A(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}k.is=A;const R=Object.freeze([]);function U(){return R}k.empty=U;function*O(r){yield r}k.single=O;function g(r){return r||R}k.from=g;function m(r){return!r||r[Symbol.iterator]().next().done===!0}k.isEmpty=m;function T(r){return r[Symbol.iterator]().next().value}k.first=T;function y(r,t){for(const i of r)if(t(i))return!0;return!1}k.some=y;function v(r,t){for(const i of r)if(t(i))return i}k.find=v;function*b(r,t){for(const i of r)t(i)&&(yield i)}k.filter=b;function*u(r,t){for(const i of r)yield t(i)}k.map=u;function*S(...r){for(const t of r)for(const i of t)yield i}k.concat=S;function*C(r){for(const t of r)for(const i of t)yield i}k.concatNested=C;function E(r,t,i){let n=i;for(const o of r)n=t(n,o);return n}k.reduce=E;function*D(r,t,i=r.length){for(t<0&&(t+=r.length),i<0?i+=r.length:i>r.length&&(i=r.length);t<i;t++)yield r[t]}k.slice=D;function f(r,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,r];const n=r[Symbol.iterator]();for(let o=0;o<t;o++){const a=n.next();if(a.done)return[i,k.empty()];i.push(a.value)}return[i,{[Symbol.iterator](){return n}}]}k.consume=f;function s(r,t,i=(n,o)=>n===o){const n=r[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const a=n.next(),c=o.next();if(a.done!==c.done)return!1;if(a.done)return!0;if(!i(a.value,c.value))return!1}}k.equals=s})(p=e.Iterable||(e.Iterable={}))}),define(Z[32],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function U(t,i=!1){let n=0,o=t.length,a="",c=0,l=16,d=0;function w(M){let z=0,$=0;for(;z<M;){const V=t.charCodeAt(n);if(V>=48&&V<=57)$=$*16+V-48;else if(V>=65&&V<=70)$=$*16+V-65+10;else if(V>=97&&V<=102)$=$*16+V-97+10;else break;n++,z++}return z<M&&($=-1),$}function h(M){n=M,a="",c=0,l=16,d=0}function P(){const M=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&m(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&m(t.charCodeAt(n)))for(n++;n<t.length&&m(t.charCodeAt(n));)n++;else return d=3,t.substring(M,n);let z=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&m(t.charCodeAt(n))){for(n++;n<t.length&&m(t.charCodeAt(n));)n++;z=n}else d=3;return t.substring(M,z)}function _(){let M="",z=n;for(;;){if(n>=o){M+=t.substring(z,n),d=2;break}const $=t.charCodeAt(n);if($===34){M+=t.substring(z,n),n++;break}if($===92){if(M+=t.substring(z,n),n++,n>=o){d=2;break}switch(t.charCodeAt(n++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:const H=w(4);H>=0?M+=String.fromCharCode(H):d=4;break;default:d=5}z=n;continue}if($>=0&&$<=31)if(g($)){M+=t.substring(z,n),d=2;break}else d=6;n++}return M}function j(){if(a="",d=0,c=n,n>=o)return c=o,l=17;let M=t.charCodeAt(n);if(O(M)){do n++,a+=String.fromCharCode(M),M=t.charCodeAt(n);while(O(M));return l=15}if(g(M))return n++,a+=String.fromCharCode(M),M===13&&t.charCodeAt(n)===10&&(n++,a+=`
`),l=14;switch(M){case 123:return n++,l=1;case 125:return n++,l=2;case 91:return n++,l=3;case 93:return n++,l=4;case 58:return n++,l=6;case 44:return n++,l=5;case 34:return n++,a=_(),l=10;case 47:const z=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<o&&!g(t.charCodeAt(n));)n++;return a=t.substring(z,n),l=12}if(t.charCodeAt(n+1)===42){n+=2;const $=o-1;let V=!1;for(;n<$;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,V=!0;break}n++}return V||(n++,d=1),a=t.substring(z,n),l=13}return a+=String.fromCharCode(M),n++,l=16;case 45:if(a+=String.fromCharCode(M),n++,n===o||!m(t.charCodeAt(n)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=P(),l=11;default:for(;n<o&&q(M);)n++,M=t.charCodeAt(n);if(c!==n){switch(a=t.substring(c,n),a){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return a+=String.fromCharCode(M),n++,l=16}}function q(M){if(O(M)||g(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let M;do M=j();while(M>=12&&M<=15);return M}return{setPosition:h,getPosition:()=>n,scan:i?G:j,getToken:()=>l,getTokenValue:()=>a,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>d}}e.createScanner=U;function O(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function m(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function y(t,i){const n=[],o=new Object;let a;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function d(w,h,P,_){c.value=w,c.offset=h,c.length=P,c.type=_,c.colonOffset=void 0,a=c}try{f(t,{onObjectBegin:(w,h)=>{if(i<=w)throw o;a=void 0,l=i>w,n.push("")},onObjectProperty:(w,h,P)=>{if(i<h||(d(w,h,P,"property"),n[n.length-1]=w,i<=h+P))throw o},onObjectEnd:(w,h)=>{if(i<=w)throw o;a=void 0,n.pop()},onArrayBegin:(w,h)=>{if(i<=w)throw o;a=void 0,n.push(0)},onArrayEnd:(w,h)=>{if(i<=w)throw o;a=void 0,n.pop()},onLiteralValue:(w,h,P)=>{if(i<h||(d(w,h,P,r(w)),i<=h+P))throw o},onSeparator:(w,h,P)=>{if(i<=h)throw o;if(w===":"&&a&&a.type==="property")a.colonOffset=h,l=!1,a=void 0;else if(w===","){const _=n[n.length-1];typeof _=="number"?n[n.length-1]=_+1:(l=!0,n[n.length-1]=""),a=void 0}}})}catch(w){if(w!==o)throw w}return{path:n,previousNode:a,isAtPropertyKey:l,matches:w=>{let h=0;for(let P=0;h<w.length&&P<n.length;P++)if(w[h]===n[P]||w[h]==="*")h++;else if(w[h]!=="**")return!1;return h===w.length}}}e.getLocation=y;function v(t,i=[],n=R.DEFAULT){let o=null,a=[];const c=[];function l(w){Array.isArray(a)?a.push(w):o!==null&&(a[o]=w)}return f(t,{onObjectBegin:()=>{const w={};l(w),c.push(a),a=w,o=null},onObjectProperty:w=>{o=w},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{const w=[];l(w),c.push(a),a=w,o=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:l,onError:(w,h,P)=>{i.push({error:w,offset:h,length:P})}},n),a[0]}e.parse=v;function b(t,i=[],n=R.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(w){o.type==="property"&&(o.length=w-o.offset,o=o.parent)}function c(w){return o.children.push(w),w}f(t,{onObjectBegin:w=>{o=c({type:"object",offset:w,length:-1,parent:o,children:[]})},onObjectProperty:(w,h,P)=>{o=c({type:"property",offset:h,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:w,offset:h,length:P,parent:o})},onObjectEnd:(w,h)=>{o.length=w+h-o.offset,o=o.parent,a(w+h)},onArrayBegin:(w,h)=>{o=c({type:"array",offset:w,length:-1,parent:o,children:[]})},onArrayEnd:(w,h)=>{o.length=w+h-o.offset,o=o.parent,a(w+h)},onLiteralValue:(w,h,P)=>{c({type:r(w),offset:h,length:P,parent:o,value:w}),a(h+P)},onSeparator:(w,h,P)=>{o.type==="property"&&(w===":"?o.colonOffset=h:w===","&&a(h))},onError:(w,h,P)=>{i.push({error:w,offset:h,length:P})}},n);const d=o.children[0];return d&&delete d.parent,d}e.parseTree=b;function u(t,i){if(!!t){let n=t;for(let o of i)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const c of n.children)if(Array.isArray(c.children)&&c.children[0].value===o){n=c.children[1],a=!0;break}if(!a)return}else{const a=o;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}}e.findNodeAtLocation=u;function S(t){if(!t.parent||!t.parent.children)return[];const i=S(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;i.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&i.push(n)}return i}e.getNodePath=S;function C(t){switch(t.type){case"array":return t.children.map(C);case"object":const i=Object.create(null);for(let n of t.children){const o=n.children[1];o&&(i[n.children[0].value]=C(o))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=C;function E(t,i,n=!1){return i>=t.offset&&i<t.offset+t.length||n&&i===t.offset+t.length}e.contains=E;function D(t,i,n=!1){if(E(t,i,n)){const o=t.children;if(Array.isArray(o))for(let a=0;a<o.length&&o[a].offset<=i;a++){const c=D(o[a],i,n);if(c)return c}return t}}e.findNodeAtOffset=D;function f(t,i,n=R.DEFAULT){const o=U(t,!1);function a(x){return x?()=>x(o.getTokenOffset(),o.getTokenLength()):()=>!0}function c(x){return x?X=>x(X,o.getTokenOffset(),o.getTokenLength()):()=>!0}const l=a(i.onObjectBegin),d=c(i.onObjectProperty),w=a(i.onObjectEnd),h=a(i.onArrayBegin),P=a(i.onArrayEnd),_=c(i.onLiteralValue),j=c(i.onSeparator),q=a(i.onComment),G=c(i.onError),M=n&&n.disallowComments,z=n&&n.allowTrailingComma;function $(){for(;;){const x=o.scan();switch(o.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:M||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(x){case 12:case 13:M?V(10):q();break;case 16:V(1);break;case 15:case 14:break;default:return x}}}function V(x,X=[],Q=[]){if(G(x),X.length+Q.length>0){let ne=o.getToken();for(;ne!==17;){if(X.indexOf(ne)!==-1){$();break}else if(Q.indexOf(ne)!==-1)break;ne=$()}}}function H(x){const X=o.getTokenValue();return x?_(X):d(X),$(),!0}function L(){switch(o.getToken()){case 11:let x=0;try{x=JSON.parse(o.getTokenValue()),typeof x!="number"&&(V(2),x=0)}catch(X){V(2)}_(x);break;case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return $(),!0}function I(){return o.getToken()!==10?(V(3,[],[2,5]),!1):(H(!1),o.getToken()===6?(j(":"),$(),W()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function F(){l(),$();let x=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(x||V(4,[],[]),j(","),$(),o.getToken()===2&&z)break}else x&&V(6,[],[]);I()||V(4,[],[2,5]),x=!0}return w(),o.getToken()!==2?V(7,[2],[]):$(),!0}function N(){h(),$();let x=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(x||V(4,[],[]),j(","),$(),o.getToken()===4&&z)break}else x&&V(6,[],[]);W()||V(4,[],[4,5]),x=!0}return P(),o.getToken()!==4?V(8,[4],[]):$(),!0}function W(){switch(o.getToken()){case 3:return N();case 1:return F();case 10:return H(!0);default:return L()}}return $(),o.getToken()===17?n.allowEmptyContent?!0:(V(4,[],[]),!1):W()?(o.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=f;function s(t,i){let n=U(t),o=[],a,c=0,l;do switch(l=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:c!==l&&o.push(t.substring(c,l)),i!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,i)),c=n.getPosition();break}while(a!==17);return o.join("")}e.stripComments=s;function r(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=r}),define(Z[46],ee([0,1,32]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function k(g,m,T){let y,v,b,u,S;if(m){for(u=m.offset,S=u+m.length,b=u;b>0&&!O(g,b-1);)b--;let c=S;for(;c<g.length&&!O(g,c);)c++;v=g.substring(b,c),y=R(v,T)}else v=g,y=0,b=0,u=0,S=g.length;const C=U(T,g);let E=!1,D=0,f;T.insertSpaces?f=A(" ",T.tabSize||4):f="	";const s=(0,p.createScanner)(v,!1);let r=!1;function t(){return C+A(f,y+D)}function i(){let c=s.scan();for(E=!1;c===15||c===14;)E=E||c===14,c=s.scan();return r=c===16||s.getTokenError()!==0,c}const n=[];function o(c,l,d){!r&&l<S&&d>u&&g.substring(l,d)!==c&&n.push({offset:l,length:d-l,content:c})}let a=i();if(a!==17){const c=s.getTokenOffset()+b,l=A(f,y);o(l,b,c)}for(;a!==17;){let c=s.getTokenOffset()+s.getTokenLength()+b,l=i(),d="";for(;!E&&(l===12||l===13);){const h=s.getTokenOffset()+b;o(" ",c,h),c=s.getTokenOffset()+s.getTokenLength()+b,d=l===12?t():"",l=i()}if(l===2)a!==1&&(D--,d=t());else if(l===4)a!==3&&(D--,d=t());else{switch(a){case 3:case 1:D++,d=t();break;case 5:case 12:d=t();break;case 13:E?d=t():d=" ";break;case 6:d=" ";break;case 10:if(l===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?d=" ":l!==5&&l!==17&&(r=!0);break;case 16:r=!0;break}E&&(l===12||l===13)&&(d=t())}const w=s.getTokenOffset()+b;o(d,c,w),a=l}return n}e.format=k;function A(g,m){let T="";for(let y=0;y<m;y++)T+=g;return T}function R(g,m){let T=0,y=0;const v=m.tabSize||4;for(;T<g.length;){const b=g.charAt(T);if(b===" ")y++;else if(b==="	")y+=v;else break;T++}return Math.floor(y/v)}function U(g,m){for(let T=0;T<m.length;T++){const y=m.charAt(T);if(y==="\r")return T+1<m.length&&m.charAt(T+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return g&&g.eol||`
`}e.getEOL=U;function O(g,m){return`\r
`.indexOf(g.charAt(m))!==-1}e.isEOL=O}),define(Z[41],ee([0,1,32,46]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(m,T,y){return R(m,T,void 0,y)}e.removeProperty=A;function R(m,T,y,v,b){const u=T.slice(),S=[],C=(0,p.parseTree)(m,S);let E,D;for(;u.length>0&&(D=u.pop(),E=(0,p.findNodeAtLocation)(C,u),E===void 0&&y!==void 0);)typeof D=="string"?y={[D]:y}:y=[y];if(E)if(E.type==="object"&&typeof D=="string"&&Array.isArray(E.children)){const f=(0,p.findNodeAtLocation)(E,[D]);if(f!==void 0)if(y===void 0){if(!f.parent)throw new Error("Malformed AST");const s=E.children.indexOf(f.parent);let r,t=f.parent.offset+f.parent.length;if(s>0){const i=E.children[s-1];r=i.offset+i.length}else r=E.offset+1,E.children.length>1&&(t=E.children[1].offset);return U(m,{offset:r,length:t-r,content:""},v)}else return U(m,{offset:f.offset,length:f.length,content:JSON.stringify(y)},v);else{if(y===void 0)return[];const s=`${JSON.stringify(D)}: ${JSON.stringify(y)}`,r=b?b(E.children.map(i=>i.children[0].value)):E.children.length;let t;if(r>0){const i=E.children[r-1];t={offset:i.offset+i.length,length:0,content:","+s}}else E.children.length===0?t={offset:E.offset+1,length:0,content:s}:t={offset:E.offset+1,length:0,content:s+","};return U(m,t,v)}}else if(E.type==="array"&&typeof D=="number"&&Array.isArray(E.children))if(y!==void 0){const f=`${JSON.stringify(y)}`;let s;if(E.children.length===0||D===0)s={offset:E.offset+1,length:0,content:E.children.length===0?f:f+","};else{const r=D===-1||D>E.children.length?E.children.length:D,t=E.children[r-1];s={offset:t.offset+t.length,length:0,content:","+f}}return U(m,s,v)}else{const f=D,s=E.children[f];let r;if(E.children.length===1)r={offset:E.offset+1,length:E.length-2,content:""};else if(E.children.length-1===f){const t=E.children[f-1],i=t.offset+t.length,n=E.offset+E.length;r={offset:i,length:n-2-i,content:""}}else r={offset:s.offset,length:E.children[f+1].offset-s.offset,content:""};return U(m,r,v)}else throw new Error(`Can not add ${typeof D!="number"?"index":"property"} to parent of type ${E.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return U(m,{offset:C?C.offset:0,length:C?C.length:0,content:JSON.stringify(y)},v)}}e.setProperty=R;function U(m,T,y){let v=O(m,T),b=T.offset,u=T.offset+T.content.length;if(T.length===0||T.content.length===0){for(;b>0&&!(0,k.isEOL)(v,b-1);)b--;for(;u<v.length&&!(0,k.isEOL)(v,u);)u++}const S=(0,k.format)(v,{offset:b,length:u-b},y);for(let E=S.length-1;E>=0;E--){const D=S[E];v=O(v,D),b=Math.min(b,D.offset),u=Math.max(u,D.offset+D.length),u+=D.content.length-D.length}const C=m.length-(v.length-u)-b;return[{offset:b,length:C,content:v.substring(b,u)}]}e.withFormatting=U;function O(m,T){return m.substring(0,T.offset)+T.content+m.substring(T.offset+T.length)}e.applyEdit=O;function g(m,T){let y=T.slice(0).sort((b,u)=>{const S=b.offset-u.offset;return S===0?b.length-u.length:S}),v=m.length;for(let b=y.length-1;b>=0;b--){let u=y[b];if(u.offset+u.length<=v)m=O(m,u);else throw new Error("Overlapping edit");v=u.offset}return m}e.applyEdits=g}),define(Z[2],ee([0,1,64,53]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let R=null;function U(f){R=f}if(e.setDisposableTracker=U,A){const f="__is_disposable_tracked__";R=new class{trackDisposable(s){const r=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[f]||console.log(r)},3e3)}markTracked(s){if(s&&s!==S.None)try{s[f]=!0}catch(r){}}}}function O(f){!R||R.markTracked(f)}function g(f){return R&&R.trackDisposable(f),f}e.trackDisposable=g;class m extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=m;function T(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.isDisposable=T;function y(f){if(k.Iterable.is(f)){let s=[];for(const r of f)if(r){O(r);try{r.dispose()}catch(t){s.push(t)}}if(s.length===1)throw s[0];if(s.length>1)throw new m(s);return Array.isArray(f)?[]:f}else if(f)return O(f),f.dispose(),f}e.dispose=y;function v(...f){return f.forEach(O),b(()=>y(f))}e.combinedDisposable=v;function b(f){const s=g({dispose:()=>{O(s),f()}});return s}e.toDisposable=b;class u{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(O(this),this._isDisposed=!0,this.clear())}clear(){try{y(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return O(s),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class S{constructor(){this._store=new u,g(this)}dispose(){O(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=S,S.None=Object.freeze({dispose(){}});class C{constructor(){this._isDisposed=!1,g(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){var r;this._isDisposed||s===this._value||((r=this._value)===null||r===void 0||r.dispose(),s&&O(s),this._value=s)}clear(){this.value=void 0}dispose(){var s;this._isDisposed=!0,O(this),(s=this._value)===null||s===void 0||s.dispose(),this._value=void 0}}e.MutableDisposable=C;class E{constructor(){this.references=new Map}acquire(s,...r){let t=this.references.get(s);t||(t={counter:0,object:this.createReferencedObject(s,...r)},this.references.set(s,t));const{object:i}=t,n=(0,p.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(s,t.object),this.references.delete(s))});return t.counter++,{object:i,dispose:n}}}e.ReferenceCollection=E;class D{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=D}),define(Z[65],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(R){this.element=R,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class k{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let R=this._first;for(;R!==p.Undefined;){const U=R.next;R.prev=p.Undefined,R.next=p.Undefined,R=U}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,U){const O=new p(R);if(this._first===p.Undefined)this._first=O,this._last=O;else if(U){const m=this._last;this._last=O,O.prev=m,m.next=O}else{const m=this._first;this._first=O,O.next=m,m.prev=O}this._size+=1;let g=!1;return()=>{g||(g=!0,this._remove(O))}}shift(){if(this._first!==p.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==p.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==p.Undefined&&R.next!==p.Undefined){const U=R.prev;U.next=R.next,R.next.prev=U}else R.prev===p.Undefined&&R.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):R.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):R.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==p.Undefined;)yield R.element,R=R.next}}e.LinkedList=k});"use strict";(function(){function K(A){const R=[];typeof A=="number"&&R.push("code/timeOrigin",A);function U(g){R.push(g,Date.now())}function O(){const g=[];for(let m=0;m<R.length;m+=2)g.push({name:R[m],startTime:R[m+1]});return g}return{mark:U,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const U of performance.getEntriesByType("mark"))R.push({name:U.name,startTime:Math.round(A+U.startTime)});return R}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function p(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=p(k))})(),define(Z[7],ee([0,1]),function(K,e){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const k="en";let A=!1,R=!1,U=!1,O=!1,g=!1,m=!1,T=!1,y,v=k,b,u;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let S;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?S=e.globals.vscode.process:typeof process!="undefined"&&(S=process);const C=typeof((p=S==null?void 0:S.versions)===null||p===void 0?void 0:p.electron)=="string"&&S.type==="renderer";if(e.isElectronSandboxed=C&&(S==null?void 0:S.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const o=S==null?void 0:S.env.VSCODE_BROWSER_CODE_LOADING;if(typeof o=="string")return o==="none"||o==="code"||o==="bypassHeatCheck"||o==="bypassHeatCheckAndEagerCompile"?o:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!C)u=navigator.userAgent,A=u.indexOf("Windows")>=0,R=u.indexOf("Macintosh")>=0,T=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=u.indexOf("Linux")>=0,m=!0,y=navigator.language,v=y;else if(typeof S=="object"){A=S.platform==="win32",R=S.platform==="darwin",U=S.platform==="linux",O=U&&!!S.env.SNAP&&!!S.env.SNAP_REVISION,y=k,v=k;const o=S.env.VSCODE_NLS_CONFIG;if(o)try{const a=JSON.parse(o),c=a.availableLanguages["*"];y=a.locale,v=c||k,b=a._translationsConfigFile}catch(a){}g=!0}else console.error("Unable to resolve platform.");var E;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function D(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=D;let f=0;R?f=1:A?f=3:U&&(f=2),e.isWindows=A,e.isMacintosh=R,e.isLinux=U,e.isLinuxSnap=O,e.isNative=g,e.isWeb=m,e.isIOS=T,e.platform=f,e.userAgent=u,e.language=v;var s;(function(o){function a(){return e.language}o.value=a;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=c;function l(){return e.language==="en"}o.isDefault=l})(s=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=b,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeSetImmediateId)for(let w=0,h=c.length;w<h;w++){const P=c[w];if(P.id===d.data.vscodeSetImmediateId){c.splice(w,1),P.callback();return}}});let l=0;return d=>{const w=++l;c.push({id:w,callback:d}),e.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(typeof(S==null?void 0:S.nextTick)=="function")return S.nextTick.bind(S);const a=Promise.resolve();return c=>a.then(c)}();var r;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||T?2:A?1:3;let t=!0,i=!1;function n(){if(!i){i=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,t=new Uint16Array(o.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=n}),define(Z[36],ee([0,1,7]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let k;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const A=p.globals.vscode.process;k={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(R){return(0,p.setImmediate)(R)}}}else typeof process!="undefined"?k={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:k={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},nextTick(A){return(0,p.setImmediate)(A)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.nextTick=k.nextTick}),define(Z[8],ee([0,1,36]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,A=97,R=90,U=122,O=46,g=47,m=92,T=58,y=63;class v extends Error{constructor(s,r,t){let i;typeof r=="string"&&r.indexOf("not ")===0?(i="must not be",r=r.replace(/^not /,"")):i="must be";const n=s.indexOf(".")!==-1?"property":"argument";let o=`The "${s}" ${n} ${i} of type ${r}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function b(f,s){if(typeof f!="string")throw new v(s,"string",f)}function u(f){return f===g||f===m}function S(f){return f===g}function C(f){return f>=k&&f<=R||f>=A&&f<=U}function E(f,s,r,t){let i="",n=0,o=-1,a=0,c=0;for(let l=0;l<=f.length;++l){if(l<f.length)c=f.charCodeAt(l);else{if(t(c))break;c=g}if(t(c)){if(!(o===l-1||a===1))if(a===2){if(i.length<2||n!==2||i.charCodeAt(i.length-1)!==O||i.charCodeAt(i.length-2)!==O){if(i.length>2){const d=i.lastIndexOf(r);d===-1?(i="",n=0):(i=i.slice(0,d),n=i.length-1-i.lastIndexOf(r)),o=l,a=0;continue}else if(i.length!==0){i="",n=0,o=l,a=0;continue}}s&&(i+=i.length>0?`${r}..`:"..",n=2)}else i.length>0?i+=`${r}${f.slice(o+1,l)}`:i=f.slice(o+1,l),n=l-o-1;o=l,a=0}else c===O&&a!==-1?++a:a=-1}return i}function D(f,s){if(s===null||typeof s!="object")throw new v("pathObject","Object",s);const r=s.dir||s.root,t=s.base||`${s.name||""}${s.ext||""}`;return r?r===s.root?`${r}${t}`:`${r}${f}${t}`:t}e.win32={resolve(...f){let s="",r="",t=!1;for(let i=f.length-1;i>=-1;i--){let n;if(i>=0){if(n=f[i],b(n,"path"),n.length===0)continue}else s.length===0?n=p.cwd():(n=p.env[`=${s}`]||p.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==s.toLowerCase()&&n.charCodeAt(2)===m)&&(n=`${s}\\`));const o=n.length;let a=0,c="",l=!1;const d=n.charCodeAt(0);if(o===1)u(d)&&(a=1,l=!0);else if(u(d))if(l=!0,u(n.charCodeAt(1))){let w=2,h=w;for(;w<o&&!u(n.charCodeAt(w));)w++;if(w<o&&w!==h){const P=n.slice(h,w);for(h=w;w<o&&u(n.charCodeAt(w));)w++;if(w<o&&w!==h){for(h=w;w<o&&!u(n.charCodeAt(w));)w++;(w===o||w!==h)&&(c=`\\\\${P}\\${n.slice(h,w)}`,a=w)}}}else a=1;else C(d)&&n.charCodeAt(1)===T&&(c=n.slice(0,2),a=2,o>2&&u(n.charCodeAt(2))&&(l=!0,a=3));if(c.length>0)if(s.length>0){if(c.toLowerCase()!==s.toLowerCase())continue}else s=c;if(t){if(s.length>0)break}else if(r=`${n.slice(a)}\\${r}`,t=l,l&&s.length>0)break}return r=E(r,!t,"\\",u),t?`${s}\\${r}`:`${s}${r}`||"."},normalize(f){b(f,"path");const s=f.length;if(s===0)return".";let r=0,t,i=!1;const n=f.charCodeAt(0);if(s===1)return S(n)?"\\":f;if(u(n))if(i=!0,u(f.charCodeAt(1))){let a=2,c=a;for(;a<s&&!u(f.charCodeAt(a));)a++;if(a<s&&a!==c){const l=f.slice(c,a);for(c=a;a<s&&u(f.charCodeAt(a));)a++;if(a<s&&a!==c){for(c=a;a<s&&!u(f.charCodeAt(a));)a++;if(a===s)return`\\\\${l}\\${f.slice(c)}\\`;a!==c&&(t=`\\\\${l}\\${f.slice(c,a)}`,r=a)}}}else r=1;else C(n)&&f.charCodeAt(1)===T&&(t=f.slice(0,2),r=2,s>2&&u(f.charCodeAt(2))&&(i=!0,r=3));let o=r<s?E(f.slice(r),!i,"\\",u):"";return o.length===0&&!i&&(o="."),o.length>0&&u(f.charCodeAt(s-1))&&(o+="\\"),t===void 0?i?`\\${o}`:o:i?`${t}\\${o}`:`${t}${o}`},isAbsolute(f){b(f,"path");const s=f.length;if(s===0)return!1;const r=f.charCodeAt(0);return u(r)||s>2&&C(r)&&f.charCodeAt(1)===T&&u(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let s,r;for(let n=0;n<f.length;++n){const o=f[n];b(o,"path"),o.length>0&&(s===void 0?s=r=o:s+=`\\${o}`)}if(s===void 0)return".";let t=!0,i=0;if(typeof r=="string"&&u(r.charCodeAt(0))){++i;const n=r.length;n>1&&u(r.charCodeAt(1))&&(++i,n>2&&(u(r.charCodeAt(2))?++i:t=!1))}if(t){for(;i<s.length&&u(s.charCodeAt(i));)i++;i>=2&&(s=`\\${s.slice(i)}`)}return e.win32.normalize(s)},relative(f,s){if(b(f,"from"),b(s,"to"),f===s)return"";const r=e.win32.resolve(f),t=e.win32.resolve(s);if(r===t||(f=r.toLowerCase(),s=t.toLowerCase(),f===s))return"";let i=0;for(;i<f.length&&f.charCodeAt(i)===m;)i++;let n=f.length;for(;n-1>i&&f.charCodeAt(n-1)===m;)n--;const o=n-i;let a=0;for(;a<s.length&&s.charCodeAt(a)===m;)a++;let c=s.length;for(;c-1>a&&s.charCodeAt(c-1)===m;)c--;const l=c-a,d=o<l?o:l;let w=-1,h=0;for(;h<d;h++){const _=f.charCodeAt(i+h);if(_!==s.charCodeAt(a+h))break;_===m&&(w=h)}if(h!==d){if(w===-1)return t}else{if(l>d){if(s.charCodeAt(a+h)===m)return t.slice(a+h+1);if(h===2)return t.slice(a+h)}o>d&&(f.charCodeAt(i+h)===m?w=h:h===2&&(w=3)),w===-1&&(w=0)}let P="";for(h=i+w+1;h<=n;++h)(h===n||f.charCodeAt(h)===m)&&(P+=P.length===0?"..":"\\..");return a+=w,P.length>0?`${P}${t.slice(a,c)}`:(t.charCodeAt(a)===m&&++a,t.slice(a,c))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const s=e.win32.resolve(f);if(s.length<=2)return f;if(s.charCodeAt(0)===m){if(s.charCodeAt(1)===m){const r=s.charCodeAt(2);if(r!==y&&r!==O)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(C(s.charCodeAt(0))&&s.charCodeAt(1)===T&&s.charCodeAt(2)===m)return`\\\\?\\${s}`;return f},dirname(f){b(f,"path");const s=f.length;if(s===0)return".";let r=-1,t=0;const i=f.charCodeAt(0);if(s===1)return u(i)?f:".";if(u(i)){if(r=t=1,u(f.charCodeAt(1))){let a=2,c=a;for(;a<s&&!u(f.charCodeAt(a));)a++;if(a<s&&a!==c){for(c=a;a<s&&u(f.charCodeAt(a));)a++;if(a<s&&a!==c){for(c=a;a<s&&!u(f.charCodeAt(a));)a++;if(a===s)return f;a!==c&&(r=t=a+1)}}}}else C(i)&&f.charCodeAt(1)===T&&(r=s>2&&u(f.charCodeAt(2))?3:2,t=r);let n=-1,o=!0;for(let a=s-1;a>=t;--a)if(u(f.charCodeAt(a))){if(!o){n=a;break}}else o=!1;if(n===-1){if(r===-1)return".";n=r}return f.slice(0,n)},basename(f,s){s!==void 0&&b(s,"ext"),b(f,"path");let r=0,t=-1,i=!0,n;if(f.length>=2&&C(f.charCodeAt(0))&&f.charCodeAt(1)===T&&(r=2),s!==void 0&&s.length>0&&s.length<=f.length){if(s===f)return"";let o=s.length-1,a=-1;for(n=f.length-1;n>=r;--n){const c=f.charCodeAt(n);if(u(c)){if(!i){r=n+1;break}}else a===-1&&(i=!1,a=n+1),o>=0&&(c===s.charCodeAt(o)?--o==-1&&(t=n):(o=-1,t=a))}return r===t?t=a:t===-1&&(t=f.length),f.slice(r,t)}for(n=f.length-1;n>=r;--n)if(u(f.charCodeAt(n))){if(!i){r=n+1;break}}else t===-1&&(i=!1,t=n+1);return t===-1?"":f.slice(r,t)},extname(f){b(f,"path");let s=0,r=-1,t=0,i=-1,n=!0,o=0;f.length>=2&&f.charCodeAt(1)===T&&C(f.charCodeAt(0))&&(s=t=2);for(let a=f.length-1;a>=s;--a){const c=f.charCodeAt(a);if(u(c)){if(!n){t=a+1;break}continue}i===-1&&(n=!1,i=a+1),c===O?r===-1?r=a:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||i===-1||o===0||o===1&&r===i-1&&r===t+1?"":f.slice(r,i)},format:D.bind(null,"\\"),parse(f){b(f,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return s;const r=f.length;let t=0,i=f.charCodeAt(0);if(r===1)return u(i)?(s.root=s.dir=f,s):(s.base=s.name=f,s);if(u(i)){if(t=1,u(f.charCodeAt(1))){let w=2,h=w;for(;w<r&&!u(f.charCodeAt(w));)w++;if(w<r&&w!==h){for(h=w;w<r&&u(f.charCodeAt(w));)w++;if(w<r&&w!==h){for(h=w;w<r&&!u(f.charCodeAt(w));)w++;w===r?t=w:w!==h&&(t=w+1)}}}}else if(C(i)&&f.charCodeAt(1)===T){if(r<=2)return s.root=s.dir=f,s;if(t=2,u(f.charCodeAt(2))){if(r===3)return s.root=s.dir=f,s;t=3}}t>0&&(s.root=f.slice(0,t));let n=-1,o=t,a=-1,c=!0,l=f.length-1,d=0;for(;l>=t;--l){if(i=f.charCodeAt(l),u(i)){if(!c){o=l+1;break}continue}a===-1&&(c=!1,a=l+1),i===O?n===-1?n=l:d!==1&&(d=1):n!==-1&&(d=-1)}return a!==-1&&(n===-1||d===0||d===1&&n===a-1&&n===o+1?s.base=s.name=f.slice(o,a):(s.name=f.slice(o,n),s.base=f.slice(o,a),s.ext=f.slice(n,a))),o>0&&o!==t?s.dir=f.slice(0,o-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let s="",r=!1;for(let t=f.length-1;t>=-1&&!r;t--){const i=t>=0?f[t]:p.cwd();b(i,"path"),i.length!==0&&(s=`${i}/${s}`,r=i.charCodeAt(0)===g)}return s=E(s,!r,"/",S),r?`/${s}`:s.length>0?s:"."},normalize(f){if(b(f,"path"),f.length===0)return".";const s=f.charCodeAt(0)===g,r=f.charCodeAt(f.length-1)===g;return f=E(f,!s,"/",S),f.length===0?s?"/":r?"./":".":(r&&(f+="/"),s?`/${f}`:f)},isAbsolute(f){return b(f,"path"),f.length>0&&f.charCodeAt(0)===g},join(...f){if(f.length===0)return".";let s;for(let r=0;r<f.length;++r){const t=f[r];b(t,"path"),t.length>0&&(s===void 0?s=t:s+=`/${t}`)}return s===void 0?".":e.posix.normalize(s)},relative(f,s){if(b(f,"from"),b(s,"to"),f===s||(f=e.posix.resolve(f),s=e.posix.resolve(s),f===s))return"";const r=1,t=f.length,i=t-r,n=1,o=s.length-n,a=i<o?i:o;let c=-1,l=0;for(;l<a;l++){const w=f.charCodeAt(r+l);if(w!==s.charCodeAt(n+l))break;w===g&&(c=l)}if(l===a)if(o>a){if(s.charCodeAt(n+l)===g)return s.slice(n+l+1);if(l===0)return s.slice(n+l)}else i>a&&(f.charCodeAt(r+l)===g?c=l:l===0&&(c=0));let d="";for(l=r+c+1;l<=t;++l)(l===t||f.charCodeAt(l)===g)&&(d+=d.length===0?"..":"/..");return`${d}${s.slice(n+c)}`},toNamespacedPath(f){return f},dirname(f){if(b(f,"path"),f.length===0)return".";const s=f.charCodeAt(0)===g;let r=-1,t=!0;for(let i=f.length-1;i>=1;--i)if(f.charCodeAt(i)===g){if(!t){r=i;break}}else t=!1;return r===-1?s?"/":".":s&&r===1?"//":f.slice(0,r)},basename(f,s){s!==void 0&&b(s,"ext"),b(f,"path");let r=0,t=-1,i=!0,n;if(s!==void 0&&s.length>0&&s.length<=f.length){if(s===f)return"";let o=s.length-1,a=-1;for(n=f.length-1;n>=0;--n){const c=f.charCodeAt(n);if(c===g){if(!i){r=n+1;break}}else a===-1&&(i=!1,a=n+1),o>=0&&(c===s.charCodeAt(o)?--o==-1&&(t=n):(o=-1,t=a))}return r===t?t=a:t===-1&&(t=f.length),f.slice(r,t)}for(n=f.length-1;n>=0;--n)if(f.charCodeAt(n)===g){if(!i){r=n+1;break}}else t===-1&&(i=!1,t=n+1);return t===-1?"":f.slice(r,t)},extname(f){b(f,"path");let s=-1,r=0,t=-1,i=!0,n=0;for(let o=f.length-1;o>=0;--o){const a=f.charCodeAt(o);if(a===g){if(!i){r=o+1;break}continue}t===-1&&(i=!1,t=o+1),a===O?s===-1?s=o:n!==1&&(n=1):s!==-1&&(n=-1)}return s===-1||t===-1||n===0||n===1&&s===t-1&&s===r+1?"":f.slice(s,t)},format:D.bind(null,"/"),parse(f){b(f,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return s;const r=f.charCodeAt(0)===g;let t;r?(s.root="/",t=1):t=0;let i=-1,n=0,o=-1,a=!0,c=f.length-1,l=0;for(;c>=t;--c){const d=f.charCodeAt(c);if(d===g){if(!a){n=c+1;break}continue}o===-1&&(a=!1,o=c+1),d===O?i===-1?i=c:l!==1&&(l=1):i!==-1&&(l=-1)}if(o!==-1){const d=n===0&&r?1:n;i===-1||l===0||l===1&&i===o-1&&i===n+1?s.base=s.name=f.slice(d,o):(s.name=f.slice(d,i),s.base=f.slice(d,o),s.ext=f.slice(i,o))}return n>0?s.dir=f.slice(0,n-1):r&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var p=e();for(var k in p)(typeof exports=="object"?exports:K)[k]=p[k]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function p(k){if(e[k])return e[k].exports;var A=e[k]={i:k,l:!1,exports:{}};return K[k].call(A.exports,A,A.exports,p),A.l=!0,A.exports}return p.m=K,p.c=e,p.d=function(k,A,R){p.o(k,A)||Object.defineProperty(k,A,{enumerable:!0,get:R})},p.r=function(k){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},p.t=function(k,A){if(1&A&&(k=p(k)),8&A||4&A&&typeof k=="object"&&k&&k.__esModule)return k;var R=Object.create(null);if(p.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:k}),2&A&&typeof k!="string")for(var U in k)p.d(R,U,function(O){return k[O]}.bind(null,U));return R},p.n=function(k){var A=k&&k.__esModule?function(){return k.default}:function(){return k};return p.d(A,"a",A),A},p.o=function(k,A){return Object.prototype.hasOwnProperty.call(k,A)},p.p="",p(p.s=0)}([function(K,e,p){(function(k){var A;e=K.exports=Q,A=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,U=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],g=e.src=[],m=0,T=m++;g[T]="0|[1-9]\\d*";var y=m++;g[y]="[0-9]+";var v=m++;g[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=m++;g[b]="("+g[T]+")\\.("+g[T]+")\\.("+g[T]+")";var u=m++;g[u]="("+g[y]+")\\.("+g[y]+")\\.("+g[y]+")";var S=m++;g[S]="(?:"+g[T]+"|"+g[v]+")";var C=m++;g[C]="(?:"+g[y]+"|"+g[v]+")";var E=m++;g[E]="(?:-("+g[S]+"(?:\\."+g[S]+")*))";var D=m++;g[D]="(?:-?("+g[C]+"(?:\\."+g[C]+")*))";var f=m++;g[f]="[0-9A-Za-z-]+";var s=m++;g[s]="(?:\\+("+g[f]+"(?:\\."+g[f]+")*))";var r=m++,t="v?"+g[b]+g[E]+"?"+g[s]+"?";g[r]="^"+t+"$";var i="[v=\\s]*"+g[u]+g[D]+"?"+g[s]+"?",n=m++;g[n]="^"+i+"$";var o=m++;g[o]="((?:<|>)?=?)";var a=m++;g[a]=g[y]+"|x|X|\\*";var c=m++;g[c]=g[T]+"|x|X|\\*";var l=m++;g[l]="[v=\\s]*("+g[c]+")(?:\\.("+g[c]+")(?:\\.("+g[c]+")(?:"+g[E]+")?"+g[s]+"?)?)?";var d=m++;g[d]="[v=\\s]*("+g[a]+")(?:\\.("+g[a]+")(?:\\.("+g[a]+")(?:"+g[D]+")?"+g[s]+"?)?)?";var w=m++;g[w]="^"+g[o]+"\\s*"+g[l]+"$";var h=m++;g[h]="^"+g[o]+"\\s*"+g[d]+"$";var P=m++;g[P]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=m++;g[_]="(?:~>?)";var j=m++;g[j]="(\\s*)"+g[_]+"\\s+",O[j]=new RegExp(g[j],"g");var q=m++;g[q]="^"+g[_]+g[l]+"$";var G=m++;g[G]="^"+g[_]+g[d]+"$";var M=m++;g[M]="(?:\\^)";var z=m++;g[z]="(\\s*)"+g[M]+"\\s+",O[z]=new RegExp(g[z],"g");var $=m++;g[$]="^"+g[M]+g[l]+"$";var V=m++;g[V]="^"+g[M]+g[d]+"$";var H=m++;g[H]="^"+g[o]+"\\s*("+i+")$|^$";var L=m++;g[L]="^"+g[o]+"\\s*("+t+")$|^$";var I=m++;g[I]="(\\s*)"+g[o]+"\\s*("+i+"|"+g[l]+")",O[I]=new RegExp(g[I],"g");var F=m++;g[F]="^\\s*("+g[l]+")\\s+-\\s+("+g[l]+")\\s*$";var N=m++;g[N]="^\\s*("+g[d]+")\\s+-\\s+("+g[d]+")\\s*$";var W=m++;g[W]="(<|>)?=?\\s*\\*";for(var x=0;x<35;x++)A(x,g[x]),O[x]||(O[x]=new RegExp(g[x]));function X(J,re){if(J instanceof Q)return J;if(typeof J!="string"||J.length>R||!(re?O[n]:O[r]).test(J))return null;try{return new Q(J,re)}catch(se){return null}}function Q(J,re){if(J instanceof Q){if(J.loose===re)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Q))return new Q(J,re);A("SemVer",J,re),this.loose=re;var se=J.trim().match(re?O[n]:O[r]);if(!se)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>U||this.major<0)throw new TypeError("Invalid major version");if(this.minor>U||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>U||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(ve){if(/^[0-9]+$/.test(ve)){var Se=+ve;if(Se>=0&&Se<U)return Se}return ve}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=X,e.valid=function(J,re){var se=X(J,re);return se?se.version:null},e.clean=function(J,re){var se=X(J.trim().replace(/^[=v]+/,""),re);return se?se.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(J){return A("SemVer.compare",this.version,this.loose,J),J instanceof Q||(J=new Q(J,this.loose)),this.compareMain(J)||this.comparePre(J)},Q.prototype.compareMain=function(J){return J instanceof Q||(J=new Q(J,this.loose)),ie(this.major,J.major)||ie(this.minor,J.minor)||ie(this.patch,J.patch)},Q.prototype.comparePre=function(J){if(J instanceof Q||(J=new Q(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var re=0;do{var se=this.prerelease[re],ve=J.prerelease[re];if(A("prerelease compare",re,se,ve),se===void 0&&ve===void 0)return 0;if(ve===void 0)return 1;if(se===void 0)return-1;if(se!==ve)return ie(se,ve)}while(++re)},Q.prototype.inc=function(J,re){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,re,se,ve){typeof se=="string"&&(ve=se,se=void 0);try{return new Q(J,se).inc(re,ve).version}catch(Se){return null}},e.diff=function(J,re){if(pe(J,re))return null;var se=X(J),ve=X(re);if(se.prerelease.length||ve.prerelease.length){for(var Se in se)if((Se==="major"||Se==="minor"||Se==="patch")&&se[Se]!==ve[Se])return"pre"+Se;return"prerelease"}for(var Se in se)if((Se==="major"||Se==="minor"||Se==="patch")&&se[Se]!==ve[Se])return Se},e.compareIdentifiers=ie;var ne=/^[0-9]+$/;function ie(J,re){var se=ne.test(J),ve=ne.test(re);return se&&ve&&(J=+J,re=+re),se&&!ve?-1:ve&&!se?1:J<re?-1:J>re?1:0}function ce(J,re,se){return new Q(J,se).compare(new Q(re,se))}function ue(J,re,se){return ce(J,re,se)>0}function ge(J,re,se){return ce(J,re,se)<0}function pe(J,re,se){return ce(J,re,se)===0}function Ce(J,re,se){return ce(J,re,se)!==0}function Oe(J,re,se){return ce(J,re,se)>=0}function _e(J,re,se){return ce(J,re,se)<=0}function Te(J,re,se,ve){var Se;switch(re){case"===":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),Se=J===se;break;case"!==":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),Se=J!==se;break;case"":case"=":case"==":Se=pe(J,se,ve);break;case"!=":Se=Ce(J,se,ve);break;case">":Se=ue(J,se,ve);break;case">=":Se=Oe(J,se,ve);break;case"<":Se=ge(J,se,ve);break;case"<=":Se=_e(J,se,ve);break;default:throw new TypeError("Invalid operator: "+re)}return Se}function Le(J,re){if(J instanceof Le){if(J.loose===re)return J;J=J.value}if(!(this instanceof Le))return new Le(J,re);A("comparator",J,re),this.loose=re,this.parse(J),this.semver===Ne?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(J,re){return ie(re,J)},e.major=function(J,re){return new Q(J,re).major},e.minor=function(J,re){return new Q(J,re).minor},e.patch=function(J,re){return new Q(J,re).patch},e.compare=ce,e.compareLoose=function(J,re){return ce(J,re,!0)},e.rcompare=function(J,re,se){return ce(re,J,se)},e.sort=function(J,re){return J.sort(function(se,ve){return e.compare(se,ve,re)})},e.rsort=function(J,re){return J.sort(function(se,ve){return e.rcompare(se,ve,re)})},e.gt=ue,e.lt=ge,e.eq=pe,e.neq=Ce,e.gte=Oe,e.lte=_e,e.cmp=Te,e.Comparator=Le;var Ne={};function Ie(J,re){if(J instanceof Ie)return J.loose===re?J:new Ie(J.raw,re);if(J instanceof Le)return new Ie(J.value,re);if(!(this instanceof Ie))return new Ie(J,re);if(this.loose=re,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Ae(J){return!J||J.toLowerCase()==="x"||J==="*"}function Ge(J,re,se,ve,Se,Re,be,ke,De,B,te,oe,ae){return((re=Ae(se)?"":Ae(ve)?">="+se+".0.0":Ae(Se)?">="+se+"."+ve+".0":">="+re)+" "+(ke=Ae(De)?"":Ae(B)?"<"+(+De+1)+".0.0":Ae(te)?"<"+De+"."+(+B+1)+".0":oe?"<="+De+"."+B+"."+te+"-"+oe:"<="+ke)).trim()}function Ke(J,re){for(var se=0;se<J.length;se++)if(!J[se].test(re))return!1;if(re.prerelease.length){for(se=0;se<J.length;se++)if(A(J[se].semver),J[se].semver!==Ne&&J[se].semver.prerelease.length>0){var ve=J[se].semver;if(ve.major===re.major&&ve.minor===re.minor&&ve.patch===re.patch)return!0}return!1}return!0}function $e(J,re,se){try{re=new Ie(re,se)}catch(ve){return!1}return re.test(J)}function ze(J,re,se,ve){var Se,Re,be,ke,De;switch(J=new Q(J,ve),re=new Ie(re,ve),se){case">":Se=ue,Re=_e,be=ge,ke=">",De=">=";break;case"<":Se=ge,Re=Oe,be=ue,ke="<",De="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(J,re,ve))return!1;for(var B=0;B<re.set.length;++B){var te=re.set[B],oe=null,ae=null;if(te.forEach(function(he){he.semver===Ne&&(he=new Le(">=0.0.0")),oe=oe||he,ae=ae||he,Se(he.semver,oe.semver,ve)?oe=he:be(he.semver,ae.semver,ve)&&(ae=he)}),oe.operator===ke||oe.operator===De||(!ae.operator||ae.operator===ke)&&Re(J,ae.semver)||ae.operator===De&&be(J,ae.semver))return!1}return!0}Le.prototype.parse=function(J){var re=this.loose?O[H]:O[L],se=J.match(re);if(!se)throw new TypeError("Invalid comparator: "+J);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new Q(se[2],this.loose):this.semver=Ne},Le.prototype.toString=function(){return this.value},Le.prototype.test=function(J){return A("Comparator.test",J,this.loose),this.semver===Ne||(typeof J=="string"&&(J=new Q(J,this.loose)),Te(J,this.operator,this.semver,this.loose))},Le.prototype.intersects=function(J,re){if(!(J instanceof Le))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new Ie(J.value,re),$e(this.value,se,re);if(J.operator==="")return se=new Ie(this.value,re),$e(J.semver,se,re);var ve=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Re=this.semver.version===J.semver.version,be=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),ke=Te(this.semver,"<",J.semver,re)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),De=Te(this.semver,">",J.semver,re)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return ve||Se||Re&&be||ke||De},e.Range=Ie,Ie.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},Ie.prototype.toString=function(){return this.range},Ie.prototype.parseRange=function(J){var re=this.loose;J=J.trim(),A("range",J,re);var se=re?O[N]:O[F];J=J.replace(se,Ge),A("hyphen replace",J),J=J.replace(O[I],"$1$2$3"),A("comparator trim",J,O[I]),J=(J=(J=J.replace(O[j],"$1~")).replace(O[z],"$1^")).split(/\s+/).join(" ");var ve=re?O[H]:O[L],Se=J.split(" ").map(function(Re){return function(be,ke){return A("comp",be),be=function(De,B){return De.trim().split(/\s+/).map(function(te){return function(oe,ae){A("caret",oe,ae);var he=ae?O[V]:O[$];return oe.replace(he,function(me,de,ye,Ee,we){var le;return A("caret",oe,me,de,ye,Ee,we),Ae(de)?le="":Ae(ye)?le=">="+de+".0.0 <"+(+de+1)+".0.0":Ae(Ee)?le=de==="0"?">="+de+"."+ye+".0 <"+de+"."+(+ye+1)+".0":">="+de+"."+ye+".0 <"+(+de+1)+".0.0":we?(A("replaceCaret pr",we),we.charAt(0)!=="-"&&(we="-"+we),le=de==="0"?ye==="0"?">="+de+"."+ye+"."+Ee+we+" <"+de+"."+ye+"."+(+Ee+1):">="+de+"."+ye+"."+Ee+we+" <"+de+"."+(+ye+1)+".0":">="+de+"."+ye+"."+Ee+we+" <"+(+de+1)+".0.0"):(A("no pr"),le=de==="0"?ye==="0"?">="+de+"."+ye+"."+Ee+" <"+de+"."+ye+"."+(+Ee+1):">="+de+"."+ye+"."+Ee+" <"+de+"."+(+ye+1)+".0":">="+de+"."+ye+"."+Ee+" <"+(+de+1)+".0.0"),A("caret return",le),le})}(te,B)}).join(" ")}(be,ke),A("caret",be),be=function(De,B){return De.trim().split(/\s+/).map(function(te){return function(oe,ae){var he=ae?O[G]:O[q];return oe.replace(he,function(me,de,ye,Ee,we){var le;return A("tilde",oe,me,de,ye,Ee,we),Ae(de)?le="":Ae(ye)?le=">="+de+".0.0 <"+(+de+1)+".0.0":Ae(Ee)?le=">="+de+"."+ye+".0 <"+de+"."+(+ye+1)+".0":we?(A("replaceTilde pr",we),we.charAt(0)!=="-"&&(we="-"+we),le=">="+de+"."+ye+"."+Ee+we+" <"+de+"."+(+ye+1)+".0"):le=">="+de+"."+ye+"."+Ee+" <"+de+"."+(+ye+1)+".0",A("tilde return",le),le})}(te,B)}).join(" ")}(be,ke),A("tildes",be),be=function(De,B){return A("replaceXRanges",De,B),De.split(/\s+/).map(function(te){return function(oe,ae){oe=oe.trim();var he=ae?O[h]:O[w];return oe.replace(he,function(me,de,ye,Ee,we,le){A("xRange",oe,me,de,ye,Ee,we,le);var Pe=Ae(ye),Ue=Pe||Ae(Ee),Fe=Ue||Ae(we);return de==="="&&Fe&&(de=""),Pe?me=de===">"||de==="<"?"<0.0.0":"*":de&&Fe?(Ue&&(Ee=0),Fe&&(we=0),de===">"?(de=">=",Ue?(ye=+ye+1,Ee=0,we=0):Fe&&(Ee=+Ee+1,we=0)):de==="<="&&(de="<",Ue?ye=+ye+1:Ee=+Ee+1),me=de+ye+"."+Ee+"."+we):Ue?me=">="+ye+".0.0 <"+(+ye+1)+".0.0":Fe&&(me=">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0"),A("xRange return",me),me})}(te,B)}).join(" ")}(be,ke),A("xrange",be),be=function(De,B){return A("replaceStars",De,B),De.trim().replace(O[W],"")}(be,ke),A("stars",be),be}(Re,re)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(Re){return!!Re.match(ve)})),Se=Se.map(function(Re){return new Le(Re,re)})},Ie.prototype.intersects=function(J,re){if(!(J instanceof Ie))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(ve){return J.set.some(function(Se){return Se.every(function(Re){return ve.intersects(Re,re)})})})})},e.toComparators=function(J,re){return new Ie(J,re).set.map(function(se){return se.map(function(ve){return ve.value}).join(" ").trim().split(" ")})},Ie.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new Q(J,this.loose));for(var re=0;re<this.set.length;re++)if(Ke(this.set[re],J))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(J,re,se){var ve=null,Se=null;try{var Re=new Ie(re,se)}catch(be){return null}return J.forEach(function(be){Re.test(be)&&(ve&&Se.compare(be)!==-1||(Se=new Q(ve=be,se)))}),ve},e.minSatisfying=function(J,re,se){var ve=null,Se=null;try{var Re=new Ie(re,se)}catch(be){return null}return J.forEach(function(be){Re.test(be)&&(ve&&Se.compare(be)!==1||(Se=new Q(ve=be,se)))}),ve},e.validRange=function(J,re){try{return new Ie(J,re).range||"*"}catch(se){return null}},e.ltr=function(J,re,se){return ze(J,re,"<",se)},e.gtr=function(J,re,se){return ze(J,re,">",se)},e.outside=ze,e.prerelease=function(J,re){var se=X(J,re);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(J,re,se){return J=new Ie(J,se),re=new Ie(re,se),J.intersects(re)},e.coerce=function(J){if(J instanceof Q)return J;if(typeof J!="string")return null;var re=J.match(O[P]);return re==null?null:X((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,p(1))},function(K,e){var p,k,A=K.exports={};function R(){throw new Error("setTimeout has not been defined")}function U(){throw new Error("clearTimeout has not been defined")}function O(C){if(p===setTimeout)return setTimeout(C,0);if((p===R||!p)&&setTimeout)return p=setTimeout,setTimeout(C,0);try{return p(C,0)}catch(E){try{return p.call(null,C,0)}catch(D){return p.call(this,C,0)}}}(function(){try{p=typeof setTimeout=="function"?setTimeout:R}catch(C){p=R}try{k=typeof clearTimeout=="function"?clearTimeout:U}catch(C){k=U}})();var g,m=[],T=!1,y=-1;function v(){T&&g&&(T=!1,g.length?m=g.concat(m):y=-1,m.length&&b())}function b(){if(!T){var C=O(v);T=!0;for(var E=m.length;E;){for(g=m,m=[];++y<E;)g&&g[y].run();y=-1,E=m.length}g=null,T=!1,function(D){if(k===clearTimeout)return clearTimeout(D);if((k===U||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(D);try{k(D)}catch(f){try{return k.call(null,D)}catch(s){return k.call(this,D)}}}(C)}}function u(C,E){this.fun=C,this.array=E}function S(){}A.nextTick=function(C){var E=new Array(arguments.length-1);if(arguments.length>1)for(var D=1;D<arguments.length;D++)E[D-1]=arguments[D];m.push(new u(C,E)),m.length!==1||T||O(b)},u.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=S,A.addListener=S,A.once=S,A.off=S,A.removeListener=S,A.removeAllListeners=S,A.emit=S,A.prependListener=S,A.prependOnceListener=S,A.listeners=function(C){return[]},A.binding=function(C){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(C){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(Z[86],ee([0,1,7]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=p.globals.performance&&typeof p.globals.performance.now=="function";class A{constructor(U){this._highResolution=k&&U,this._startTime=this._now(),this._stopTime=-1}static create(U=!0){return new A(U)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=A}),define(Z[3],ee([0,1,11,64,2,65,86]),function(K,e,p,k,A,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var O;(function(E){E.None=()=>A.Disposable.None;function D(M){return(z,$=null,V)=>{let H=!1,L;return L=M(I=>{if(!H)return L?L.dispose():H=!0,z.call($,I)},null,V),H&&L.dispose(),L}}E.once=D;function f(M,z){return o(($,V=null,H)=>M(L=>$.call(V,z(L)),null,H))}E.map=f;function s(M,z){return o(($,V=null,H)=>M(L=>{z(L),$.call(V,L)},null,H))}E.forEach=s;function r(M,z){return o(($,V=null,H)=>M(L=>z(L)&&$.call(V,L),null,H))}E.filter=r;function t(M){return M}E.signal=t;function i(...M){return(z,$=null,V)=>(0,A.combinedDisposable)(...M.map(H=>H(L=>z.call($,L),null,V)))}E.any=i;function n(M,z,$){let V=$;return f(M,H=>(V=z(V,H),V))}E.reduce=n;function o(M){let z;const $=new v({onFirstListenerAdd(){z=M($.fire,$)},onLastListenerRemove(){z.dispose()}});return $.event}E.snapshot=o;function a(M,z,$=100,V=!1,H){let L,I,F,N=0;const W=new v({leakWarningThreshold:H,onFirstListenerAdd(){L=M(x=>{N++,I=z(I,x),V&&!F&&(W.fire(I),I=void 0),clearTimeout(F),F=setTimeout(()=>{const X=I;I=void 0,F=void 0,(!V||N>1)&&W.fire(X),N=0},$)})},onLastListenerRemove(){L.dispose()}});return W.event}E.debounce=a;function c(M){const z=new Date().getTime();return f(D(M),$=>new Date().getTime()-z)}E.stopwatch=c;function l(M,z=($,V)=>$===V){let $=!0,V;return r(M,H=>{const L=$||!z(H,V);return $=!1,V=H,L})}E.latch=l;function d(M,z){return[E.filter(M,z),E.filter(M,$=>!z($))]}E.split=d;function w(M,z=!1,$=[]){let V=$.slice(),H=M(F=>{V?V.push(F):I.fire(F)});const L=()=>{V&&V.forEach(F=>I.fire(F)),V=null},I=new v({onFirstListenerAdd(){H||(H=M(F=>I.fire(F)))},onFirstListenerDidAdd(){V&&(z?setTimeout(L):L())},onLastListenerRemove(){H&&H.dispose(),H=null}});return I.event}E.buffer=w;class h{constructor(z){this.event=z}map(z){return new h(f(this.event,z))}forEach(z){return new h(s(this.event,z))}filter(z){return new h(r(this.event,z))}reduce(z,$){return new h(n(this.event,z,$))}latch(){return new h(l(this.event))}debounce(z,$=100,V=!1,H){return new h(a(this.event,z,$,V,H))}on(z,$,V){return this.event(z,$,V)}once(z,$,V){return D(this.event)(z,$,V)}}function P(M){return new h(M)}E.chain=P;function _(M,z,$=V=>V){const V=(...F)=>I.fire($(...F)),H=()=>M.on(z,V),L=()=>M.removeListener(z,V),I=new v({onFirstListenerAdd:H,onLastListenerRemove:L});return I.event}E.fromNodeEventEmitter=_;function j(M,z,$=V=>V){const V=(...F)=>I.fire($(...F)),H=()=>M.addEventListener(z,V),L=()=>M.removeEventListener(z,V),I=new v({onFirstListenerAdd:H,onLastListenerRemove:L});return I.event}E.fromDOMEventEmitter=j;function q(M){const z=new v;let $=!1;return M.then(void 0,()=>null).then(()=>{$?z.fire(void 0):setTimeout(()=>z.fire(void 0),0)}),$=!0,z.event}E.fromPromise=q;function G(M){return new Promise(z=>D(M)(z))}E.toPromise=G})(O=e.Event||(e.Event={}));class g{constructor(D){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${D}_${g._idPool++}`}start(D){this._stopWatch=new U.StopWatch(!0),this._listenerCount=D}stop(){if(this._stopWatch){const D=this._stopWatch.elapsed();this._elapsedOverall+=D,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${D.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}g._idPool=0;let m=-1;function T(E){const D=m;return m=E,{dispose(){m=D}}}e.setGlobalLeakWarningThreshold=T;class y{constructor(D,f=Math.random().toString(18).slice(2,5)){this.customThreshold=D,this.name=f,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(D){let f=m;if(typeof this.customThreshold=="number"&&(f=this.customThreshold),!(f<=0||D<f)){this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(s)||0;if(this._stacks.set(s,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=f*.5;let t,i=0;for(const[n,o]of this._stacks)(!t||i<o)&&(t=n,i=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${D} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(s)||0;this._stacks.set(s,t-1)}}}}class v{constructor(D){var f;this._disposed=!1,this._options=D,this._leakageMon=m>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((f=this._options)===null||f===void 0?void 0:f._profName)?new g(this._options._profName):void 0}get event(){return this._event||(this._event=(D,f,s)=>{var r;this._listeners||(this._listeners=new R.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(f?[D,f]:D);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,D,f);const n=(r=this._leakageMon)===null||r===void 0?void 0:r.check(this._listeners.size);let o;return o={dispose:()=>{n&&n(),o.dispose=v._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},s instanceof A.DisposableStore?s.add(o):Array.isArray(s)&&s.push(o),o}),this._event}fire(D){var f,s;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new R.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,D]);for((f=this._perfMon)===null||f===void 0||f.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,t]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,t):r[0].call(r[1],t)}catch(i){(0,p.onUnexpectedError)(i)}}(s=this._perfMon)===null||s===void 0||s.stop()}}dispose(){var D,f,s,r;(D=this._listeners)===null||D===void 0||D.clear(),(f=this._deliveryQueue)===null||f===void 0||f.clear(),((s=this._options)===null||s===void 0?void 0:s.onLastListenerRemove)&&this._options.onLastListenerRemove(),(r=this._leakageMon)===null||r===void 0||r.dispose(),this._disposed=!0}}e.Emitter=v,v._noop=function(){};class b extends v{constructor(D){super(D);this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=D==null?void 0:D.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const D=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(D))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(D){this._listeners&&(this._isPaused!==0?this._eventQueue.push(D):super.fire(D))}}e.PauseableEmitter=b;class u{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(D){const f={event:D,listener:null};this.events.push(f),this.hasListeners&&this.hook(f);const s=()=>{this.hasListeners&&this.unhook(f);const r=this.events.indexOf(f);this.events.splice(r,1)};return(0,A.toDisposable)((0,k.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(D=>this.hook(D))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(D=>this.unhook(D))}hook(D){D.listener=D.event(f=>this.emitter.fire(f))}unhook(D){D.listener&&D.listener.dispose(),D.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=u;class S{constructor(){this.buffers=[]}wrapEvent(D){return(f,s,r)=>D(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>f.call(s,t)):f.call(s,t)},void 0,r)}bufferEvents(D){const f=[];this.buffers.push(f);const s=D();return this.buffers.pop(),f.forEach(r=>r()),s}}e.EventBufferer=S;class C{constructor(){this.listening=!1,this.inputEvent=O.None,this.inputEventListener=A.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(D){this.inputEvent=D,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=D(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=C}),define(Z[30],ee([0,1,3]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(O,g){const m=setTimeout(O.bind(g),0);return{dispose(){clearTimeout(m)}}});var A;(function(O){function g(m){return m===O.None||m===O.Cancelled||m instanceof R?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}O.isCancellationToken=g,O.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),O.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(A=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class U{constructor(g){this._token=void 0,this._parentListener=void 0,this._parentListener=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=A.Cancelled}dispose(g=!1){g&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=U}),define(Z[47],ee([0,1,11,2]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(f){const s=f;return s?[s.on,s.pause,s.resume,s.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=A;function R(f){const s=f;return s?A(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=R;function U(f,s){return new O(f,s)}e.newWriteableStream=U;class O{constructor(s,r){this.reducer=s,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){var r;if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof((r=this.options)===null||r===void 0?void 0:r.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(r=>r(s))}emitError(s){this.listeners.error.length===0?(0,p.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(r=>r(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,r){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(s,r){if(!this.state.destroyed){let t;switch(s){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(r);i>=0&&t.splice(i,1)}}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function g(f,s){const r=[];let t;for(;(t=f.read())!==null;)r.push(t);return s(r)}e.consumeReadable=g;function m(f,s,r){const t=[];let i;for(;(i=f.read())!==null&&t.length<r;)t.push(i);return i===null&&t.length>0?s(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return f.read()}}}e.peekReadable=m;function T(f,s){return new Promise((r,t)=>{const i=[];y(f,{onData:n=>{s&&i.push(n)},onError:n=>{s?t(n):r(void 0)},onEnd:()=>{r(s?s(i):void 0)}})})}e.consumeStream=T;function y(f,s){f.on("error",r=>s.onError(r)),f.on("end",()=>s.onEnd()),f.on("data",r=>s.onData(r))}e.listenStream=y;function v(f,s){return new Promise((r,t)=>{const i=new k.DisposableStore,n=[],o=l=>{if(n.push(l),n.length>s)return i.dispose(),f.pause(),r({stream:f,buffer:n,ended:!1})},a=l=>t(l),c=()=>r({stream:f,buffer:n,ended:!0});i.add((0,k.toDisposable)(()=>f.removeListener("error",a))),f.on("error",a),i.add((0,k.toDisposable)(()=>f.removeListener("end",c))),f.on("end",c),i.add((0,k.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}e.peekStream=v;function b(f,s){const r=U(s);return r.end(f),r}e.toStream=b;function u(){const f=U(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=u;function S(f){let s=!1;return{read:()=>s?null:(s=!0,f)}}e.toReadable=S;function C(f,s,r){const t=U(r);return y(f,{onData:i=>t.write(s.data(i)),onError:i=>t.error(s.error?s.error(i):i),onEnd:()=>t.end()}),t}e.transform=C;function E(f,s,r){let t=!1;return{read:()=>{const i=s.read();return t?i:(t=!0,i!==null?r([f,i]):f)}}}e.prefixedReadable=E;function D(f,s,r){let t=!1;const i=U(r);return y(s,{onData:n=>t?i.write(n):(t=!0,i.write(r([f,n]))),onError:n=>i.error(n),onEnd:()=>{t||(t=!0,i.write(f)),i.end()}}),i}e.prefixedStream=D}),define(Z[21],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function p(B){return!B||typeof B!="string"?!0:B.trim().length===0}e.isFalsyOrWhitespace=p;const k=/{(\d+)}/g;function A(B,...te){return te.length===0?B:B.replace(k,function(oe,ae){const he=parseInt(ae,10);return isNaN(he)||he<0||he>=te.length?oe:te[he]})}e.format=A;function R(B){return B.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=R;function U(B){return B.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=U;function O(B,te){let oe=0;const ae=te.charCodeAt(0);for(let he=B.length-1;he>=0;he--)B.charCodeAt(he)===ae&&oe++;return oe}e.count=O;function g(B,te,oe="\u2026"){return B.length<=te?B:`${B.substr(0,te)}${oe}`}e.truncate=g;function m(B,te=" "){const oe=T(B,te);return y(oe,te)}e.trim=m;function T(B,te){if(!B||!te)return B;const oe=te.length;if(oe===0||B.length===0)return B;let ae=0;for(;B.indexOf(te,ae)===ae;)ae=ae+oe;return B.substring(ae)}e.ltrim=T;function y(B,te){if(!B||!te)return B;const oe=te.length,ae=B.length;if(oe===0||ae===0)return B;let he=ae,me=-1;for(;me=B.lastIndexOf(te,he-1),!(me===-1||me+oe!==he);){if(me===0)return"";he=me}return B.substring(0,he)}e.rtrim=y;function v(B){return B.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function b(B){return B.replace(/\*/g,"")}e.stripWildcards=b;function u(B,te,oe={}){if(!B)throw new Error("Cannot create regex from empty string");te||(B=U(B)),oe.wholeWord&&(/\B/.test(B.charAt(0))||(B="\\b"+B),/\B/.test(B.charAt(B.length-1))||(B=B+"\\b"));let ae="";return oe.global&&(ae+="g"),oe.matchCase||(ae+="i"),oe.multiline&&(ae+="m"),oe.unicode&&(ae+="u"),new RegExp(B,ae)}e.createRegExp=u;function S(B){return B.source==="^"||B.source==="^$"||B.source==="$"||B.source==="^\\s*$"?!1:!!(B.exec("")&&B.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function C(B){return!!B.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=C;function E(B){return(B.global?"g":"")+(B.ignoreCase?"i":"")+(B.multiline?"m":"")+(B.unicode?"u":"")}e.regExpFlags=E;function D(B){return B.split(/\r\n|\r|\n/)}e.splitLines=D;function f(B){for(let te=0,oe=B.length;te<oe;te++){const ae=B.charCodeAt(te);if(ae!==32&&ae!==9)return te}return-1}e.firstNonWhitespaceIndex=f;function s(B,te=0,oe=B.length){for(let ae=te;ae<oe;ae++){const he=B.charCodeAt(ae);if(he!==32&&he!==9)return B.substring(te,ae)}return B.substring(te,oe)}e.getLeadingWhitespace=s;function r(B,te=B.length-1){for(let oe=te;oe>=0;oe--){const ae=B.charCodeAt(oe);if(ae!==32&&ae!==9)return oe}return-1}e.lastNonWhitespaceIndex=r;function t(B,te){return B<te?-1:B>te?1:0}e.compare=t;function i(B,te,oe=0,ae=B.length,he=0,me=te.length){for(;oe<ae&&he<me;oe++,he++){let Ee=B.charCodeAt(oe),we=te.charCodeAt(he);if(Ee<we)return-1;if(Ee>we)return 1}const de=ae-oe,ye=me-he;return de<ye?-1:de>ye?1:0}e.compareSubstring=i;function n(B,te){return o(B,te,0,B.length,0,te.length)}e.compareIgnoreCase=n;function o(B,te,oe=0,ae=B.length,he=0,me=te.length){for(;oe<ae&&he<me;oe++,he++){let Ee=B.charCodeAt(oe),we=te.charCodeAt(he);if(Ee!==we){const le=Ee-we;if(!(le===32&&c(we))&&!(le===-32&&c(Ee)))return a(Ee)&&a(we)?le:i(B.toLowerCase(),te.toLowerCase(),oe,ae,he,me)}}const de=ae-oe,ye=me-he;return de<ye?-1:de>ye?1:0}e.compareSubstringIgnoreCase=o;function a(B){return B>=97&&B<=122}e.isLowerAsciiLetter=a;function c(B){return B>=65&&B<=90}e.isUpperAsciiLetter=c;function l(B){return a(B)||c(B)}function d(B,te){return B.length===te.length&&w(B,te)}e.equalsIgnoreCase=d;function w(B,te,oe=B.length){for(let ae=0;ae<oe;ae++){const he=B.charCodeAt(ae),me=te.charCodeAt(ae);if(he!==me){if(l(he)&&l(me)){const de=Math.abs(he-me);if(de!==0&&de!==32)return!1}else if(String.fromCharCode(he).toLowerCase()!==String.fromCharCode(me).toLowerCase())return!1}}return!0}function h(B,te){const oe=te.length;return te.length>B.length?!1:w(B,te,oe)}e.startsWithIgnoreCase=h;function P(B,te){let oe,ae=Math.min(B.length,te.length);for(oe=0;oe<ae;oe++)if(B.charCodeAt(oe)!==te.charCodeAt(oe))return oe;return ae}e.commonPrefixLength=P;function _(B,te){let oe,ae=Math.min(B.length,te.length);const he=B.length-1,me=te.length-1;for(oe=0;oe<ae;oe++)if(B.charCodeAt(he-oe)!==te.charCodeAt(me-oe))return oe;return ae}e.commonSuffixLength=_;function j(B){return 55296<=B&&B<=56319}e.isHighSurrogate=j;function q(B){return 56320<=B&&B<=57343}e.isLowSurrogate=q;function G(B,te){return(B-55296<<10)+(te-56320)+65536}e.computeCodePoint=G;function M(B,te,oe){const ae=B.charCodeAt(oe);if(j(ae)&&oe+1<te){const he=B.charCodeAt(oe+1);if(q(he))return G(ae,he)}return ae}e.getNextCodePoint=M;function z(B,te){const oe=B.charCodeAt(te-1);if(q(oe)&&te>1){const ae=B.charCodeAt(te-2);if(j(ae))return G(ae,oe)}return oe}function $(B,te){const oe=se.getInstance(),ae=te,he=B.length,me=M(B,he,te);te+=me>=65536?2:1;let de=oe.getGraphemeBreakType(me);for(;te<he;){const ye=M(B,he,te),Ee=oe.getGraphemeBreakType(ye);if(J(de,Ee))break;te+=ye>=65536?2:1,de=Ee}return te-ae}e.nextCharLength=$;function V(B,te){const oe=se.getInstance(),ae=te,he=z(B,te);te-=he>=65536?2:1;let me=oe.getGraphemeBreakType(he);for(;te>0;){const de=z(B,te),ye=oe.getGraphemeBreakType(de);if(J(ye,me))break;te-=de>=65536?2:1,me=ye}return ae-te}e.prevCharLength=V;function H(B,te){const oe=se.getInstance(),ae=B.length,he=te,me=M(B,ae,te),de=oe.getGraphemeBreakType(me);te+=me>=65536?2:1;let ye=de;for(;te<ae;){const we=M(B,ae,te),le=oe.getGraphemeBreakType(we);if(J(ye,le))break;te+=we>=65536?2:1,ye=le}const Ee=te;for(te=he,ye=de;te>0;){const we=z(B,te),le=oe.getGraphemeBreakType(we);if(J(le,ye))break;te-=we>=65536?2:1,ye=le}return[te,Ee]}function L(B,te){return te>0&&q(B.charCodeAt(te))?H(B,te-1):H(B,te)}e.getCharContainingOffset=L;function I(B){const te=B.length;let oe=0,ae=0;for(;ae<te;){const de=M(B,te,ae);ae+=de>=65536?2:1,de<128?oe+=1:de<2048?oe+=2:de<65536?oe+=3:oe+=4}const he=new Uint8Array(oe);ae=0;let me=0;for(;ae<te;){const de=M(B,te,ae);ae+=de>=65536?2:1,de<128?he[me++]=de:de<2048?(he[me++]=192|(de&1984)>>>6,he[me++]=128|(de&63)>>>0):de<65536?(he[me++]=224|(de&61440)>>>12,he[me++]=128|(de&4032)>>>6,he[me++]=128|(de&63)>>>0):(he[me++]=240|(de&1835008)>>>18,he[me++]=128|(de&258048)>>>12,he[me++]=128|(de&4032)>>>6,he[me++]=128|(de&63)>>>0)}return he}e.encodeUTF8=I;function F(B){const te=B.byteLength,oe=[];let ae=0;for(;ae<te;){const he=B[ae];let me;if(he>=240&&ae+3<te?me=(B[ae++]&7)<<18>>>0|(B[ae++]&63)<<12>>>0|(B[ae++]&63)<<6>>>0|(B[ae++]&63)<<0>>>0:he>=224&&ae+2<te?me=(B[ae++]&15)<<12>>>0|(B[ae++]&63)<<6>>>0|(B[ae++]&63)<<0>>>0:he>=192&&ae+1<te?me=(B[ae++]&31)<<6>>>0|(B[ae++]&63)<<0>>>0:me=B[ae++],me>=0&&me<=55295||me>=57344&&me<=65535)oe.push(String.fromCharCode(me));else if(me>=65536&&me<=1114111){const de=me-65536,ye=55296+((de&1047552)>>>10),Ee=56320+((de&1023)>>>0);oe.push(String.fromCharCode(ye)),oe.push(String.fromCharCode(Ee))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=F;const N=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(B){return N.test(B)}e.containsRTL=W;const x=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function X(B){return x.test(B)}e.containsEmoji=X;const Q=/^[\t\n\r\x20-\x7E]*$/;function ne(B){return Q.test(B)}e.isBasicASCII=ne,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ie(B){return e.UNUSUAL_LINE_TERMINATORS.test(B)}e.containsUnusualLineTerminators=ie;function ce(B){for(let te=0,oe=B.length;te<oe;te++)if(ue(B.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=ce;function ue(B){return B=+B,B>=11904&&B<=55215||B>=63744&&B<=64255||B>=65281&&B<=65374}e.isFullWidthCharacter=ue;function ge(B){return B>=127462&&B<=127487||B===8986||B===8987||B===9200||B===9203||B>=9728&&B<=10175||B===11088||B===11093||B>=127744&&B<=128591||B>=128640&&B<=128764||B>=128992&&B<=129003||B>=129280&&B<=129535||B>=129648&&B<=129750}e.isEmojiImprecise=ge;function pe(B,te){if(B.length<te)return B;const oe=/\b/g;let ae=0;for(;oe.test(B)&&!(B.length-oe.lastIndex<te);)ae=oe.lastIndex,oe.lastIndex+=1;return B.substring(ae).replace(/^\s/,"")}e.lcut=pe;const Ce=/\x1B\x5B[12]?K/g,Oe=/\x1b\[\d+m/g,_e=/\x1b\[0?m/g;function Te(B){return B&&(B=B.replace(Ce,""),B=B.replace(Oe,""),B=B.replace(_e,"")),B}e.removeAnsiEscapeCodes=Te,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(B){return!!(B&&B.length>0&&B.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Le;function Ne(B){return Le(B)?B.substr(1):B}e.stripUTF8BOM=Ne;function Ie(B,te){if(!B||!te||B.length<te.length)return!1;const oe=te.length,ae=B.toLowerCase();let he=0,me=-1;for(;he<oe;){const de=ae.indexOf(te[he],me+1);if(de<0)return!1;me=de,he++}return!0}e.fuzzyContains=Ie;function Ae(B,te=!1){return B?(te&&(B=B.replace(/\\./g,"")),B.toLowerCase()!==B):!1}e.containsUppercaseCharacter=Ae;function Ge(B){return B.charAt(0).toUpperCase()+B.slice(1)}e.uppercaseFirstLetter=Ge;function Ke(B,te=1){if(te===0)return"";let oe=-1;do oe=B.indexOf(`
`,oe+1),te--;while(te>0&&oe>=0);return oe===-1?B:(B[oe-1]==="\r"&&oe--,B.substr(0,oe))}e.getNLines=Ke;function $e(B){const te=90-65+1;return B=B%(2*te),B<te?String.fromCharCode(97+B):String.fromCharCode(65+B-te)}e.singleLetterHash=$e;function ze(B){return se.getInstance().getGraphemeBreakType(B)}e.getGraphemeBreakType=ze;function J(B,te){return B===0?te!==5&&te!==7:B===2&&te===3?!1:B===4||B===2||B===3||te===4||te===2||te===3?!0:!(B===8&&(te===8||te===9||te===11||te===12)||(B===11||B===9)&&(te===9||te===10)||(B===12||B===10)&&te===10||te===5||te===13||te===7||B===1||B===13&&te===14||B===6&&te===6)}e.breakBetweenGraphemeBreakType=J;var re;(function(B){B[B.Other=0]="Other",B[B.Prepend=1]="Prepend",B[B.CR=2]="CR",B[B.LF=3]="LF",B[B.Control=4]="Control",B[B.Extend=5]="Extend",B[B.Regional_Indicator=6]="Regional_Indicator",B[B.SpacingMark=7]="SpacingMark",B[B.L=8]="L",B[B.V=9]="V",B[B.T=10]="T",B[B.LV=11]="LV",B[B.LVT=12]="LVT",B[B.ZWJ=13]="ZWJ",B[B.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class se{constructor(){this._data=ve()}static getInstance(){return se._INSTANCE||(se._INSTANCE=new se),se._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const oe=this._data,ae=oe.length/3;let he=1;for(;he<=ae;)if(te<oe[3*he])he=2*he;else if(te>oe[3*he+1])he=2*he+1;else return oe[3*he+2];return 0}}se._INSTANCE=null;function ve(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Se(B,te){if(B===0)return 0;const oe=Re(B,te);if(oe!==void 0)return oe;const ae=z(te,B);return B-=be(ae),B}e.getLeftDeleteOffset=Se;function Re(B,te){let oe=z(te,B);for(B-=be(oe);ke(oe)||oe===65039||oe===8419;){if(B===0)return;oe=z(te,B),B-=be(oe)}if(!!ge(oe)){if(B>=0){const ae=z(te,B);ae===8205&&(B-=be(ae))}return B}}function be(B){return B>=65536?2:1}function ke(B){return 127995<=B&&B<=127999}var De;(function(B){B[B.zwj=8205]="zwj",B[B.emojiVariantSelector=65039]="emojiVariantSelector",B[B.enclosingKeyCap=8419]="enclosingKeyCap"})(De||(De={}))}),define(Z[23],ee([0,1,21,47]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",R=typeof TextEncoder!="undefined",U=typeof TextDecoder!="undefined";let O,g;class m{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return A?new m(Buffer.allocUnsafe(l)):new m(new Uint8Array(l))}static wrap(l){return A&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new m(l)}static fromString(l,d){return!((d==null?void 0:d.dontUseNodeBuffer)||!1)&&A?new m(Buffer.from(l)):R?(O||(O=new TextEncoder),new m(O.encode(l))):new m(p.encodeUTF8(l))}static concat(l,d){if(typeof d=="undefined"){d=0;for(let P=0,_=l.length;P<_;P++)d+=l[P].byteLength}const w=m.alloc(d);let h=0;for(let P=0,_=l.length;P<_;P++){const j=l[P];w.set(j,h),h+=j.byteLength}return w}toString(){return A?this.buffer.toString():U?(g||(g=new TextDecoder),g.decode(this.buffer)):p.decodeUTF8(this.buffer)}slice(l,d){return new m(this.buffer.subarray(l,d))}set(l,d){l instanceof m?this.buffer.set(l.buffer,d):this.buffer.set(l,d)}readUInt32BE(l){return v(this.buffer,l)}writeUInt32BE(l,d){b(this.buffer,l,d)}readUInt32LE(l){return u(this.buffer,l)}writeUInt32LE(l,d){S(this.buffer,l,d)}readUInt8(l){return C(this.buffer,l)}writeUInt8(l,d){E(this.buffer,l,d)}}e.VSBuffer=m;function T(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0}e.readUInt16LE=T;function y(c,l,d){c[d+0]=l&255,l=l>>>8,c[d+1]=l&255}e.writeUInt16LE=y;function v(c,l){return c[l]*2**24+c[l+1]*2**16+c[l+2]*2**8+c[l+3]}e.readUInt32BE=v;function b(c,l,d){c[d+3]=l,l=l>>>8,c[d+2]=l,l=l>>>8,c[d+1]=l,l=l>>>8,c[d]=l}e.writeUInt32BE=b;function u(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0|c[l+2]<<16>>>0|c[l+3]<<24>>>0}e.readUInt32LE=u;function S(c,l,d){c[d+0]=l&255,l=l>>>8,c[d+1]=l&255,l=l>>>8,c[d+2]=l&255,l=l>>>8,c[d+3]=l&255}e.writeUInt32LE=S;function C(c,l){return c[l]}e.readUInt8=C;function E(c,l,d){c[d]=l}e.writeUInt8=E;function D(c){return k.consumeReadable(c,l=>m.concat(l))}e.readableToBuffer=D;function f(c){return k.toReadable(c)}e.bufferToReadable=f;function s(c){return k.consumeStream(c,l=>m.concat(l))}e.streamToBuffer=s;async function r(c){return c.ended?m.concat(c.buffer):m.concat([...c.buffer,await s(c.stream)])}e.bufferedStreamToBuffer=r;function t(c){return k.toStream(c,l=>m.concat(l))}e.bufferToStream=t;function i(c){return k.transform(c,{data:l=>typeof l=="string"?m.fromString(l):m.wrap(l)},l=>m.concat(l))}e.streamToBufferReadableStream=i;function n(c){return k.newWriteableStream(l=>m.concat(l),c)}e.newWriteableBufferStream=n;function o(c,l){return k.prefixedReadable(c,l,d=>m.concat(d))}e.prefixedBufferReadable=o;function a(c,l){return k.prefixedStream(c,l,d=>m.concat(d))}e.prefixedBufferStream=a}),define(Z[15],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(l){return Array.isArray(l)}e.isArray=p;function k(l){return typeof l=="string"}e.isString=k;function A(l){return Array.isArray(l)&&l.every(d=>k(d))}e.isStringArray=A;function R(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=R;function U(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=U;function O(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=O;function g(l){return l===!0||l===!1}e.isBoolean=g;function m(l){return typeof l=="undefined"}e.isUndefined=m;function T(l){return!y(l)}e.isDefined=T;function y(l){return m(l)||l===null}e.isUndefinedOrNull=y;function v(l,d){if(!l)throw new Error(d?`Unexpected type, expected '${d}'`:"Unexpected type")}e.assertType=v;function b(l){if(y(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=b;function u(...l){const d=[];for(let w=0;w<l.length;w++){const h=l[w];if(y(h))throw new Error(`Assertion Failed: argument at index ${w} is undefined or null`);d.push(h)}return d}e.assertAllDefined=u;const S=Object.prototype.hasOwnProperty;function C(l){if(!R(l))return!1;for(let d in l)if(S.call(l,d))return!1;return!0}e.isEmptyObject=C;function E(l){return typeof l=="function"}e.isFunction=E;function D(...l){return l.length>0&&l.every(E)}e.areFunctions=D;function f(l,d){const w=Math.min(l.length,d.length);for(let h=0;h<w;h++)s(l[h],d[h])}e.validateConstraints=f;function s(l,d){if(k(d)){if(typeof l!==d)throw new Error(`argument does not match constraint: typeof ${d}`)}else if(E(d)){try{if(l instanceof d)return}catch(w){}if(!y(l)&&l.constructor===d||d.length===1&&d.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function r(l){let d=[],w=Object.getPrototypeOf(l);for(;Object.prototype!==w;)d=d.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return d}e.getAllPropertyNames=r;function t(l){const d=[];for(const w of r(l))typeof l[w]=="function"&&d.push(w);return d}e.getAllMethodNames=t;function i(l,d){const w=P=>function(){const _=Array.prototype.slice.call(arguments,0);return d(P,_)};let h={};for(const P of l)h[P]=w(P);return h}e.createProxyObject=i;function n(l){return l===null?void 0:l}e.withNullAsUndefined=n;function o(l){return typeof l=="undefined"?null:l}e.withUndefinedAsNull=o;function a(l){return class{constructor(){return new Proxy({},{get(d,w){if(d[w])return d[w];throw new Error(`Not Implemented: ${l}->${String(w)}`)}})}}}e.NotImplementedProxy=a;function c(l){throw new Error("Unreachable")}e.assertNever=c}),define(Z[42],ee([0,1,7,21,8,15]),function(K,e,p,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function U(i){return i===47||i===92}e.isPathSeparator=U;function O(i){return i.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=O;function g(i,n=A.posix.sep){if(!i)return"";const o=i.length,a=i.charCodeAt(0);if(U(a)){if(U(i.charCodeAt(1))&&!U(i.charCodeAt(2))){let l=3;const d=l;for(;l<o&&!U(i.charCodeAt(l));l++);if(d!==l&&!U(i.charCodeAt(l+1))){for(l+=1;l<o;l++)if(U(i.charCodeAt(l)))return i.slice(0,l+1).replace(/[\\/]/g,n)}}return n}else if(C(a)&&i.charCodeAt(1)===58)return U(i.charCodeAt(2))?i.slice(0,2)+n:i.slice(0,2);let c=i.indexOf("://");if(c!==-1){for(c+=3;c<o;c++)if(U(i.charCodeAt(c)))return i.slice(0,c+1)}return""}e.getRoot=g;function m(i){if(!p.isWindows||!i||i.length<5)return!1;let n=i.charCodeAt(0);if(n!==92||(n=i.charCodeAt(1),n!==92))return!1;let o=2;const a=o;for(;o<i.length&&(n=i.charCodeAt(o),n!==92);o++);return!(a===o||(n=i.charCodeAt(o+1),isNaN(n)||n===92))}e.isUNC=m;const T=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(i,n=p.isWindows){const o=n?T:y;return!(!i||i.length===0||/^\s+$/.test(i)||(o.lastIndex=0,o.test(i))||n&&v.test(i)||i==="."||i===".."||n&&i[i.length-1]==="."||n&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=b;function u(i,n,o){const a=i===n;return!o||a?a:!i||!n?!1:(0,k.equalsIgnoreCase)(i,n)}e.isEqual=u;function S(i,n,o,a=A.sep){if(i===n)return!0;if(!i||!n||n.length>i.length)return!1;if(o){if(!(0,k.startsWithIgnoreCase)(i,n))return!1;if(n.length===i.length)return!0;let l=n.length;return n.charAt(n.length-1)===a&&l--,i.charAt(l)===a}return n.charAt(n.length-1)!==a&&(n+=a),i.indexOf(n)===0}e.isEqualOrParent=S;function C(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=C;function E(i,n){return p.isWindows&&i.endsWith(":")&&(i+=A.sep),(0,A.isAbsolute)(i)||(i=(0,A.join)(n,i)),i=(0,A.normalize)(i),p.isWindows?(i=(0,k.rtrim)(i,A.sep),i.endsWith(":")&&(i+=A.sep)):(i=(0,k.rtrim)(i,A.sep),i||(i=A.sep)),i}e.sanitizeFilePath=E;function D(i){const n=(0,A.normalize)(i);return p.isWindows?i.length>3?!1:f(n)&&(i.length===2||n.charCodeAt(2)===92):n===A.posix.sep}e.isRootOrDriveLetter=D;function f(i){return p.isWindows?C(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function s(i){return f(i)?i[0]:void 0}e.getDriveLetter=s;function r(i,n,o){return n.length>i.length?-1:i===n?0:(o&&(i=i.toLowerCase(),n=n.toLowerCase()),i.indexOf(n))}e.indexOfPath=r;function t(i){const n=i.split(":");let o,a,c;if(n.forEach(l=>{const d=Number(l);(0,R.isNumber)(d)?a===void 0?a=d:c===void 0&&(c=d):o=o?[o,l].join(":"):l}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:a!==void 0?a:void 0,column:c!==void 0?c:a!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(Z[26],ee([0,1,15]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function k(S){if(!S||typeof S!="object"||S instanceof RegExp)return S;const C=Array.isArray(S)?[]:{};return Object.keys(S).forEach(E=>{S[E]&&typeof S[E]=="object"?C[E]=k(S[E]):C[E]=S[E]}),C}e.deepClone=k;function A(S){if(!S||typeof S!="object")return S;const C=[S];for(;C.length>0;){const E=C.shift();Object.freeze(E);for(const D in E)if(R.call(E,D)){const f=E[D];typeof f=="object"&&!Object.isFrozen(f)&&C.push(f)}}return S}e.deepFreeze=A;const R=Object.prototype.hasOwnProperty;function U(S,C){return O(S,C,new Set)}e.cloneAndChange=U;function O(S,C,E){if((0,p.isUndefinedOrNull)(S))return S;const D=C(S);if(typeof D!="undefined")return D;if((0,p.isArray)(S)){const f=[];for(const s of S)f.push(O(s,C,E));return f}if((0,p.isObject)(S)){if(E.has(S))throw new Error("Cannot clone recursive data-structure");E.add(S);const f={};for(let s in S)R.call(S,s)&&(f[s]=O(S[s],C,E));return E.delete(S),f}return S}function g(S,C,E=!0){return(0,p.isObject)(S)?((0,p.isObject)(C)&&Object.keys(C).forEach(D=>{D in S?E&&((0,p.isObject)(S[D])&&(0,p.isObject)(C[D])?g(S[D],C[D],E):S[D]=C[D]):S[D]=C[D]}),S):C}e.mixin=g;function m(S,C){if(S===C)return!0;if(S==null||C===null||C===void 0||typeof S!=typeof C||typeof S!="object"||Array.isArray(S)!==Array.isArray(C))return!1;let E,D;if(Array.isArray(S)){if(S.length!==C.length)return!1;for(E=0;E<S.length;E++)if(!m(S[E],C[E]))return!1}else{const f=[];for(D in S)f.push(D);f.sort();const s=[];for(D in C)s.push(D);if(s.sort(),!m(f,s))return!1;for(E=0;E<f.length;E++)if(!m(S[f[E]],C[f[E]]))return!1}return!0}e.equals=m;function T(S){const C=new Set;return JSON.stringify(S,(E,D)=>{if((0,p.isObject)(D)||Array.isArray(D)){if(C.has(D))return"[Circular]";C.add(D)}return D})}e.safeStringify=T;function y(S,C,E){const D=C(S);return typeof D=="undefined"?E:D}e.getOrDefault=y;function v(S,C){const E=Object.create(null);return!S||!C||Object.keys(C).forEach(f=>{const s=S[f],r=C[f];m(s,r)||(E[f]=r)}),E}e.distinct=v;function b(S,C){const E=C.toLowerCase(),D=Object.keys(S).find(f=>f.toLowerCase()===E);return D?S[D]:S[C]}e.getCaseInsensitive=b;function u(S,C){const E=Object.create(null);for(const D of Object.keys(S))C(D,S[D])&&(E[D]=S[D]);return E}e.filter=u}),define(Z[4],ee([0,1,7,8]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,R=/^\//,U=/^\/\//;function O(n,o){if(!n.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!A.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!R.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(U.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(n,o){return!n&&!o?"file":n}function m(n,o){switch(n){case"https":case"http":case"file":o?o[0]!==y&&(o=y+o):o=y;break}return o}const T="",y="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(o,a,c,l,d,w=!1){typeof o=="object"?(this.scheme=o.scheme||T,this.authority=o.authority||T,this.path=o.path||T,this.query=o.query||T,this.fragment=o.fragment||T):(this.scheme=g(o,w),this.authority=a||T,this.path=m(this.scheme,c||T),this.query=l||T,this.fragment=d||T,O(this,w))}static isUri(o){return o instanceof b?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return f(this,!1)}with(o){if(!o)return this;let{scheme:a,authority:c,path:l,query:d,fragment:w}=o;return a===void 0?a=this.scheme:a===null&&(a=T),c===void 0?c=this.authority:c===null&&(c=T),l===void 0?l=this.path:l===null&&(l=T),d===void 0?d=this.query:d===null&&(d=T),w===void 0?w=this.fragment:w===null&&(w=T),a===this.scheme&&c===this.authority&&l===this.path&&d===this.query&&w===this.fragment?this:new S(a,c,l,d,w)}static parse(o,a=!1){const c=v.exec(o);return c?new S(c[2]||T,i(c[4]||T),i(c[5]||T),i(c[7]||T),i(c[9]||T),a):new S(T,T,T,T,T)}static file(o){let a=T;if(p.isWindows&&(o=o.replace(/\\/g,y)),o[0]===y&&o[1]===y){const c=o.indexOf(y,2);c===-1?(a=o.substring(2),o=y):(a=o.substring(2,c),o=o.substring(c)||y)}return new S("file",a,o,T,T)}static from(o){return new S(o.scheme,o.authority,o.path,o.query,o.fragment)}static joinPath(o,...a){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return p.isWindows&&o.scheme==="file"?c=b.file(k.win32.join(f(o,!0),...a)).path:c=k.posix.join(o.path,...a),o.with({path:c})}toString(o=!1){return s(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof b)return o;{const a=new S(o);return a._formatted=o.external,a._fsPath=o._sep===u?o.fsPath:null,a}}else return o}}e.URI=b;const u=p.isWindows?1:void 0;class S extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(o=!1){return o?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=u),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const C={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(n,o){let a,c=-1;for(let l=0;l<n.length;l++){const d=n.charCodeAt(l);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||o&&d===47)c!==-1&&(a+=encodeURIComponent(n.substring(c,l)),c=-1),a!==void 0&&(a+=n.charAt(l));else{a===void 0&&(a=n.substr(0,l));const w=C[d];w!==void 0?(c!==-1&&(a+=encodeURIComponent(n.substring(c,l)),c=-1),a+=w):c===-1&&(c=l)}}return c!==-1&&(a+=encodeURIComponent(n.substring(c))),a!==void 0?a:n}function D(n){let o;for(let a=0;a<n.length;a++){const c=n.charCodeAt(a);c===35||c===63?(o===void 0&&(o=n.substr(0,a)),o+=C[c]):o!==void 0&&(o+=n[a])}return o!==void 0?o:n}function f(n,o){let a;return n.authority&&n.path.length>1&&n.scheme==="file"?a=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?o?a=n.path.substr(1):a=n.path[1].toLowerCase()+n.path.substr(2):a=n.path,p.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=f;function s(n,o){const a=o?D:E;let c="",{scheme:l,authority:d,path:w,query:h,fragment:P}=n;if(l&&(c+=l,c+=":"),(d||l==="file")&&(c+=y,c+=y),d){let _=d.indexOf("@");if(_!==-1){const j=d.substr(0,_);d=d.substr(_+1),_=j.indexOf(":"),_===-1?c+=a(j,!1):(c+=a(j.substr(0,_),!1),c+=":",c+=a(j.substr(_+1),!1)),c+="@"}d=d.toLowerCase(),_=d.indexOf(":"),_===-1?c+=a(d,!1):(c+=a(d.substr(0,_),!1),c+=d.substr(_))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const _=w.charCodeAt(1);_>=65&&_<=90&&(w=`/${String.fromCharCode(_+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const _=w.charCodeAt(0);_>=65&&_<=90&&(w=`${String.fromCharCode(_+32)}:${w.substr(2)}`)}c+=a(w,!0)}return h&&(c+="?",c+=a(h,!1)),P&&(c+="#",c+=o?P:E(P,!1)),c}function r(n){try{return decodeURIComponent(n)}catch(o){return n.length>3?n.substr(0,3)+r(n.substr(3)):n}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(n){return n.match(t)?n.replace(t,o=>r(o)):n}}),define(Z[87],ee([0,1,4]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function k(m){const T=m;return T&&typeof T.type=="string"&&typeof T.severity=="string"}e.isRemoteConsoleLog=k;function A(m){const T=[];let y;try{const v=JSON.parse(m.arguments),b=v[v.length-1];b&&b.__$stack&&(v.pop(),y=b.__$stack),T.push(...v)}catch(v){T.push("Unable to log remote console arguments",m.arguments)}return{args:T,stack:y}}e.parse=A;function R(m){if(typeof m!="string")return R(A(m).stack);const T=m;if(T){const y=U(T),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(v&&v.length===4)return{uri:p.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=R;function U(m){if(!m)return m;const T=m.indexOf(`
`);return T===-1?m:m.substring(0,T)}function O(m,T){const{args:y,stack:v}=A(m),b=typeof y[0]=="string"&&y.length===1;let u=U(v);u&&(u=`(${u.trim()})`);let S=[];if(typeof y[0]=="string"?u&&b?S=[`%c[${T}] %c${y[0]} %c${u}`,g("blue"),g(""),g("grey")]:S=[`%c[${T}] %c${y[0]}`,g("blue"),g(""),...y.slice(1)]:S=[`%c[${T}]%`,g("blue"),...y],u&&!b&&S.push(u),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,S)}e.log=O;function g(m){return`color: ${m}`}});var lt=this&&this.__classPrivateFieldSet||function(K,e,p,k,A){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!A:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?A.call(K,p):A?A.value=p:e.set(K,p),p},je=this&&this.__classPrivateFieldGet||function(K,e,p,k){if(p==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!k:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?k:p==="a"?k.call(K):k?k.value:e.get(K)};define(Z[37],ee([0,1,4,21]),function(K,e,p,k){"use strict";var A,R,U;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function O(t,i,n){let o=t.get(i);return o===void 0&&(o=n,t.set(i,o)),o}e.getOrSet=O;function g(t){const i=[];return t.forEach((n,o)=>{i.push(`${o} => ${n}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=g;function m(t){const i=[];return t.forEach(n=>{i.push(n)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=m;class T{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const n=i.charCodeAt(0),o=this._value.charCodeAt(this._pos);return n-o}value(){return this._value[this._pos]}}e.StringIterator=T;class y{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,k.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class v{constructor(i=!0,n=!0){this._splitOnBackslash=i,this._caseSensitive=n}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,k.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=v;var b;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(b||(b={}));class u{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new v(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,k.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class S{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class C{constructor(i){this._iter=i}static forUris(i=()=>!1){return new C(new u(i))}static forPaths(){return new C(new v)}static forStrings(){return new C(new T)}static forConfigKeys(){return new C(new y)}clear(){this._root=void 0}set(i,n){const o=this._iter.reset(i);let a;for(this._root||(this._root=new S,this._root.segment=o.value()),a=this._root;;){const l=o.cmp(a.segment);if(l>0)a.left||(a.left=new S,a.left.segment=o.value()),a=a.left;else if(l<0)a.right||(a.right=new S,a.right.segment=o.value()),a=a.right;else if(o.hasNext())o.next(),a.mid||(a.mid=new S,a.mid.segment=o.value()),a=a.mid;else break}const c=a.value;return a.value=n,a.key=i,c}get(i){var n;return(n=this._getNode(i))===null||n===void 0?void 0:n.value}_getNode(i){const n=this._iter.reset(i);let o=this._root;for(;o;){const a=n.cmp(o.segment);if(a>0)o=o.left;else if(a<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else break}return o}has(i){const n=this._getNode(i);return!((n==null?void 0:n.value)===void 0&&(n==null?void 0:n.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,n){const o=this._iter.reset(i),a=[];let c=this._root;for(;c;){const l=o.cmp(c.segment);if(l>0)a.push([1,c]),c=c.left;else if(l<0)a.push([-1,c]),c=c.right;else if(o.hasNext())o.next(),a.push([0,c]),c=c.mid;else{for(n?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;a.length>0&&c.isEmpty();){let[d,w]=a.pop();switch(d){case 1:w.left=void 0;break;case 0:w.mid=void 0;break;case-1:w.right=void 0;break}c=w}break}}}findSubstr(i){const n=this._iter.reset(i);let o=this._root,a;for(;o;){const c=n.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(n.hasNext())n.next(),a=o.value||a,o=o.mid;else break}return o&&o.value||a}findSuperstr(i){const n=this._iter.reset(i);let o=this._root;for(;o;){const a=n.cmp(o.segment);if(a>0)o=o.left;else if(a<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(i){for(const[n,o]of this)i(o,n)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){i&&(yield*this._entries(i.left),i.value&&(yield[i.key,i.value]),yield*this._entries(i.mid),yield*this._entries(i.right))}}e.TernarySearchTree=C;class E{constructor(i,n){this[A]="ResourceMap",i instanceof E?(this.map=new Map(i.map),this.toKey=n!=null?n:E.defaultToKey):(this.map=new Map,this.toKey=i!=null?i:E.defaultToKey)}set(i,n){return this.map.set(this.toKey(i),n),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,n){typeof n!="undefined"&&(i=i.bind(n));for(let[o,a]of this.map)i(a,p.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield p.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[p.URI.parse(i[0]),i[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[p.URI.parse(i[0]),i[1]]}}e.ResourceMap=E,E.defaultToKey=t=>t.toString();var D;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(D=e.Touch||(e.Touch={}));class f{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,n=0){const o=this._map.get(i);if(!!o)return n!==0&&this.touch(o,n),o.value}set(i,n,o=0){let a=this._map.get(i);if(a)a.value=n,o!==0&&this.touch(a,o);else{switch(a={key:i,value:n,next:void 0,previous:void 0},o){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(i,a),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this._map.get(i);if(!!n)return this._map.delete(i),this.removeItem(n),this._size--,n.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}}forEach(i,n){const o=this._state;let a=this._head;for(;a;){if(n?i.bind(n)(a.value,a.key,this):i(a.value,a.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const i=this,n=this._state;let o=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:o.key,done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return a}values(){const i=this,n=this._state;let o=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:o.value,done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return a}entries(){const i=this,n=this._state;let o=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:[o.key,o.value],done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return a}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(!(i>=this.size)){if(i===0){this.clear();return}let n=this._head,o=this.size;for(;n&&o>i;)this._map.delete(n.key),n=n.next,o--;this._head=n,this._size=o,n&&(n.previous=void 0),this._state++}}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const n=i.next,o=i.previous;if(!n||!o)throw new Error("Invalid list");n.previous=o,o.next=n}i.next=void 0,i.previous=void 0,this._state++}touch(i,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(i===this._head)return;const o=i.next,a=i.previous;i===this._tail?(a.next=void 0,this._tail=a):(o.previous=a,a.next=o),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(n===2){if(i===this._tail)return;const o=i.next,a=i.previous;i===this._head?(o.previous=void 0,this._head=o):(o.previous=a,a.next=o),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((n,o)=>{i.push([o,n])}),i}fromJSON(i){this.clear();for(const[n,o]of i)this.set(n,o)}}e.LinkedMap=f;class s extends f{constructor(i,n=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,n=2){return super.get(i,n)}peek(i){return super.get(i,0)}set(i,n){return super.set(i,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class r{constructor(i){U.set(this,void 0),lt(this,U,i,"f")}get size(){return je(this,U,"f").size}forEach(i,n){je(this,U,"f").forEach(i,n)}get(i){return je(this,U,"f").get(i)}has(i){return je(this,U,"f").has(i)}entries(){return je(this,U,"f").entries()}keys(){return je(this,U,"f").keys()}values(){return je(this,U,"f").values()}[(U=new WeakMap,Symbol.iterator)](){return je(this,U,"f").entries()}}e.ReadonlyMapView=r}),define(Z[88],ee([0,1,23,21,4]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(m){return JSON.stringify(m,O)}e.stringify=R;function U(m){let T=JSON.parse(m);return T=g(T),T}e.parse=U;function O(m,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,k.regExpFlags)(T)}:T}function g(m,T=0){if(!m||T>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return A.URI.revive(m);case 2:return new RegExp(m.source,m.flags)}if(m instanceof p.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let y=0;y<m.length;++y)m[y]=g(m[y],T+1);else for(const y in m)Object.hasOwnProperty.call(m,y)&&(m[y]=g(m[y],T+1))}return m}e.revive=g}),define(Z[16],ee([0,1,4,7]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(O){O.inMemory="inmemory",O.vscode="vscode",O.internal="private",O.walkThrough="walkThrough",O.walkThroughSnippet="walkThroughSnippet",O.http="http",O.https="https",O.file="file",O.mailto="mailto",O.untitled="untitled",O.data="data",O.command="command",O.vscodeRemote="vscode-remote",O.vscodeRemoteResource="vscode-remote-resource",O.userData="vscode-userdata",O.vscodeCustomEditor="vscode-custom-editor",O.vscodeNotebook="vscode-notebook",O.vscodeNotebookCell="vscode-notebook-cell",O.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",O.vscodeNotebookCellOutput="vscode-notebook-cell-output",O.vscodeSettings="vscode-settings",O.vscodeWorkspaceTrust="vscode-workspace-trust",O.vscodeTerminal="vscode-terminal",O.webviewPanel="webview-panel",O.vscodeWebview="vscode-webview",O.extension="extension",O.vscodeFileResource="vscode-file",O.tmp="tmp"})(A=e.Schemas||(e.Schemas={}));class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}set(g,m,T){this._hosts[g]=m,this._ports[g]=T}setConnectionToken(g,m){this._connectionTokens[g]=m}rewrite(g){if(this._delegate)return this._delegate(g);const m=g.authority;let T=this._hosts[m];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const y=this._ports[m],v=this._connectionTokens[m];let b=`path=${encodeURIComponent(g.path)}`;return typeof v=="string"&&(b+=`&tkn=${encodeURIComponent(v)}`),p.URI.from({scheme:k.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${T}:${y}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new R;class U{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(g,m,T){const y=this.toUri(g,m);return y.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(y):k.isNative&&(T||k.isPreferringBrowserCodeLoad)&&y.scheme===A.file?y.with({scheme:A.vscodeFileResource,authority:y.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(g,m){const T=this.toUri(g,m);return T.scheme===A.vscodeFileResource?T.with({scheme:A.file,authority:T.authority!==this.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(g,m){return p.URI.isUri(g)?g:p.URI.parse(m.toUrl(g))}}e.FileAccess=new U}),define(Z[66],ee([0,1,37]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const k=new p.LRUCache(1e4);function A(m){return g(m,"NFC",k)}e.normalizeNFC=A;const R=new p.LRUCache(1e4);function U(m){return g(m,"NFD",R)}e.normalizeNFD=U;const O=/[^\u0000-\u0080]/;function g(m,T,y){if(!e.canNormalize||!m)return m;const v=y.get(m);if(v)return v;let b;return O.test(m)?b=m.normalize(T):b=m,y.set(m,b),b}e.removeAccents=function(){if(e.canNormalize){const m=/[\u0300-\u036f]/g;return function(T){return U(T).replace(m,"")}}else return function(m){return m}}()}),define(Z[12],ee([0,1,42,8,4,21,16,7]),function(K,e,p,k,A,R,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function g(b){return(0,A.uriToFsPath)(b,!0)}e.originalFSPath=g;class m{constructor(u){this._ignorePathCasing=u}compare(u,S,C=!1){return u===S?0:(0,R.compare)(this.getComparisonKey(u,C),this.getComparisonKey(S,C))}isEqual(u,S,C=!1){return u===S?!0:!u||!S?!1:this.getComparisonKey(u,C)===this.getComparisonKey(S,C)}getComparisonKey(u,S=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,S,C=!1){if(u.scheme===S.scheme){if(u.scheme===U.Schemas.file)return p.isEqualOrParent(g(u),g(S),this._ignorePathCasing(u))&&u.query===S.query&&(C||u.fragment===S.fragment);if((0,e.isEqualAuthority)(u.authority,S.authority))return p.isEqualOrParent(u.path,S.path,this._ignorePathCasing(u),"/")&&u.query===S.query&&(C||u.fragment===S.fragment)}return!1}joinPath(u,...S){return A.URI.joinPath(u,...S)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return k.posix.basename(u.path)}extname(u){return k.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let S;return u.scheme===U.Schemas.file?S=A.URI.file(k.dirname(g(u))).path:(S=k.posix.dirname(u.path),u.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),S="/")),u.with({path:S})}normalizePath(u){if(!u.path.length)return u;let S;return u.scheme===U.Schemas.file?S=A.URI.file(k.normalize(g(u))).path:S=k.posix.normalize(u.path),u.with({path:S})}relativePath(u,S){if(!(u.scheme!==S.scheme||!(0,e.isEqualAuthority)(u.authority,S.authority))){if(u.scheme===U.Schemas.file){const D=k.relative(g(u),g(S));return O.isWindows?p.toSlashes(D):D}let C=u.path||"/",E=S.path||"/";if(this._ignorePathCasing(u)){let D=0;for(const f=Math.min(C.length,E.length);D<f&&!(C.charCodeAt(D)!==E.charCodeAt(D)&&C.charAt(D).toLowerCase()!==E.charAt(D).toLowerCase());D++);C=E.substr(0,D)+C.substr(D)}return k.posix.relative(C,E)}}resolvePath(u,S){if(u.scheme===U.Schemas.file){const C=A.URI.file(k.resolve(g(u),S));return u.with({authority:C.authority,path:C.path})}return S.indexOf("/")===-1&&(S=p.toSlashes(S),/^[a-zA-Z]:(\/|$)/.test(S)&&(S="/"+S)),u.with({path:k.posix.resolve(u.path,S)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,S){return u===S||(0,R.equalsIgnoreCase)(u,S)}hasTrailingPathSeparator(u,S=k.sep){if(u.scheme===U.Schemas.file){const C=g(u);return C.length>p.getRoot(C).length&&C[C.length-1]===S}else{const C=u.path;return C.length>1&&C.charCodeAt(C.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,S=k.sep){return(0,e.hasTrailingPathSeparator)(u,S)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,S=k.sep){let C=!1;if(u.scheme===U.Schemas.file){const E=g(u);C=E!==void 0&&E.length===p.getRoot(E).length&&E[E.length-1]===S}else{S="/";const E=u.path;C=E.length===1&&E.charCodeAt(E.length-1)===47}return!C&&!(0,e.hasTrailingPathSeparator)(u,S)?u.with({path:u.path+"/"}):u}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(b=>b.scheme===U.Schemas.file?!O.isLinux:!0),e.extUriIgnorePathCase=new m(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(b,u){const S=[];for(let C=0;C<b.length;C++){const E=u(b[C]);b.some((D,f)=>f===C?!1:(0,e.isEqualOrParent)(E,u(D)))||S.push(b[C])}return S}e.distinctParents=T;var y;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function u(S){const C=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(f=>{const[s,r]=f.split(":");s&&r&&C.set(s,r)});const D=S.path.substring(0,S.path.indexOf(";"));return D&&C.set(b.META_DATA_MIME,D),C}b.parseMetaData=u})(y=e.DataUri||(e.DataUri={}));function v(b,u,S){if(u){let C=b.path;return C&&C[0]!==k.posix.sep&&(C=k.posix.sep+C),b.with({scheme:S,authority:u,path:C})}return b.with({scheme:S})}e.toLocalResource=v}),define(Z[6],ee([0,1,30,11,3,2,65,12]),function(K,e,p,k,A,R,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(H){return!!H&&typeof H.then=="function"}e.isThenable=g;function m(H){const L=new p.CancellationTokenSource,I=H(L.token),F=new Promise((N,W)=>{L.token.onCancellationRequested(()=>{W((0,k.canceled)())}),Promise.resolve(I).then(x=>{L.dispose(),N(x)},x=>{L.dispose(),W(x)})});return new class{cancel(){L.cancel()}then(N,W){return F.then(N,W)}catch(N){return this.then(void 0,N)}finally(N){return F.finally(N)}}}e.createCancelablePromise=m;function T(H,L,I){return Promise.race([H,new Promise(F=>L.onCancellationRequested(()=>F(I)))])}e.raceCancellation=T;async function y(H){let L=-1;const I=H.map((N,W)=>N.then(x=>(L=W,x))),F=await Promise.race(I);return H.forEach((N,W)=>{W!==L&&N.cancel()}),F}e.raceCancellablePromises=y;function v(H,L,I){let F;const N=setTimeout(()=>{F==null||F(void 0),I==null||I()},L);return Promise.race([H.finally(()=>clearTimeout(N)),new Promise(W=>F=W)])}e.raceTimeout=v;function b(H){return new Promise((L,I)=>{const F=H();g(F)?F.then(L,I):L(F)})}e.asPromise=b;class u{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const I=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(I,I).then(F)})}return new Promise((I,F)=>{this.queuedPromise.then(I,F)})}return this.activePromise=L(),new Promise((I,F)=>{this.activePromise.then(N=>{this.activePromise=null,I(N)},N=>{this.activePromise=null,F(N)})})}}e.Throttler=u;class S{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=S;class C{constructor(){this.promiseMap=new Map}queue(L,I){var F;const W=((F=this.promiseMap.get(L))!==null&&F!==void 0?F:Promise.resolve()).catch(()=>{}).then(I).finally(()=>{this.promiseMap.get(L)===W&&this.promiseMap.delete(L)});return this.promiseMap.set(L,W),W}}e.SequencerByKey=C;class E{constructor(L){this.defaultDelay=L,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,I=this.defaultDelay){return this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,N)=>{this.doResolve=F,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},I),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,k.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=E;class D{constructor(L){this.delayer=new E(L),this.throttler=new u}trigger(L,I){return this.delayer.trigger(()=>this.throttler.queue(L),I)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=D;class f{constructor(){this._isOpen=!1,this._promise=new Promise((L,I)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=f;class s extends f{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function r(H,L){return L?new Promise((I,F)=>{const N=setTimeout(I,H);L.onCancellationRequested(()=>{clearTimeout(N),F((0,k.canceled)())})}):m(I=>r(H,I))}e.timeout=r;function t(H,L=0){const I=setTimeout(H,L);return(0,R.toDisposable)(()=>clearTimeout(I))}e.disposableTimeout=t;function i(H){return H.then(void 0,L=>{})}e.ignoreErrors=i;function n(H){const L=[];let I=0;const F=H.length;function N(){return I<F?H[I++]():null}function W(x){x!=null&&L.push(x);const X=N();return X?X.then(W):Promise.resolve(L)}return Promise.resolve(null).then(W)}e.sequence=n;function o(H,L=F=>!!F,I=null){let F=0;const N=H.length,W=()=>{if(F>=N)return Promise.resolve(I);const x=H[F++];return Promise.resolve(x()).then(Q=>L(Q)?Promise.resolve(Q):W())};return W()}e.first=o;function a(H,L=F=>!!F,I=null){if(H.length===0)return Promise.resolve(I);let F=H.length;const N=()=>{var W,x;F=-1;for(const X of H)(x=(W=X).cancel)===null||x===void 0||x.call(W)};return new Promise((W,x)=>{for(const X of H)X.then(Q=>{--F>=0&&L(Q)?(N(),W(Q)):F===0&&W(I)}).catch(Q=>{--F>=0&&(N(),x(Q))})})}e.firstParallel=a;class c{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(L){return this._size++,new Promise((I,F)=>{this.outstandingPromises.push({factory:L,c:I,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const I=L.factory();I.then(L.c,L.e),I.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=c;class l extends c{constructor(){super(1)}}e.Queue=l;class d{constructor(){this.queues=new Map}queueFor(L,I=O.extUri){const F=I.getComparisonKey(L);let N=this.queues.get(F);return N||(N=new l,A.Event.once(N.onFinished)(()=>{N==null||N.dispose(),this.queues.delete(F)}),this.queues.set(F,N)),N}dispose(){this.queues.forEach(L=>L.dispose()),this.queues.clear()}}e.ResourceQueue=d;class w{constructor(L,I){this._token=-1,typeof L=="function"&&typeof I=="number"&&this.setIfNotSet(L,I)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,I){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},I)}setIfNotSet(L,I){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},I))}}e.TimeoutTimer=w;class h{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,I){this.cancel(),this._token=setInterval(()=>{L()},I)}}e.IntervalTimer=h;class P{constructor(L,I){this.timeoutToken=-1,this.runner=L,this.timeout=I,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class _ extends P{constructor(L,I){super(L,I);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner&&this.runner(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const H=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=L=>{const I=setTimeout(()=>L(H));let F=!1;return{dispose(){F||(F=!0,clearTimeout(I))}}}}else e.runWhenIdle=(H,L)=>{const I=requestIdleCallback(H,typeof L=="number"?{timeout:L}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(I))}}}}();class j{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(I){this._error=I}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=j;async function q(H,L,I){let F;for(let N=0;N<I;N++)try{return await H()}catch(W){F=W,await r(L)}throw F}e.retry=q;class G{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var L;(L=this._pending)===null||L===void 0||L.cancel()}setPending(L,I,F){return this._pending={taskId:L,cancel:()=>F==null?void 0:F(),promise:I},I.then(()=>this.donePending(L),()=>this.donePending(L)),I}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let I,F;const N=new Promise((W,x)=>{I=W,F=x});this._next={run:L,promise:N,promiseResolve:I,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=G;class M{constructor(L){this.interval=L,this.lastIncrementTime=0,this.value=0}increment(){const L=Date.now();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=M;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,I)=>{this.completeCallback=L,this.errorCallback=I})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(I=>{this.completeCallback(L),this.resolved=!0,I()})}error(L){return new Promise(I=>{this.errorCallback(L),this.rejected=!0,I()})}cancel(){new Promise(L=>{this.errorCallback((0,k.canceled)()),this.rejected=!0,L()})}}e.DeferredPromise=z;class $ extends A.Emitter{async fireAsync(L,I,F){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new U.LinkedList);for(const N of this._listeners)this._asyncDeliveryQueue.push([N,L]);for(;this._asyncDeliveryQueue.size>0&&!I.isCancellationRequested;){const[N,W]=this._asyncDeliveryQueue.shift(),x=[],X=Object.assign(Object.assign({},W),{waitUntil:Q=>{if(Object.isFrozen(x))throw new Error("waitUntil can NOT be called asynchronous");F&&(Q=F(Q,typeof N=="function"?N:N[0])),x.push(Q)}});try{typeof N=="function"?N.call(void 0,X):N[0].call(N[1],X)}catch(Q){(0,k.onUnexpectedError)(Q);continue}Object.freeze(x),await V.settled(x).catch(Q=>(0,k.onUnexpectedError)(Q))}}}}e.AsyncEmitter=$;var V;(function(H){async function L(W){return typeof Promise.allSettled=="function"?I(W):F(W)}H.allSettled=L;async function I(W){return Promise.allSettled(W)}async function F(W){return Promise.all(W.map(x=>x.then(X=>({status:"fulfilled",value:X}),X=>({status:"rejected",reason:X}))))}async function N(W){let x;const X=await Promise.all(W.map(Q=>Q.then(ne=>ne,ne=>{x||(x=ne)})));if(typeof x!="undefined")throw x;return X}H.settled=N})(V=e.Promises||(e.Promises={}))}),define(Z[89],ee([0,1,21,42,8,37,6]),function(K,e,p,k,A,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function O(){return Object.create(null)}e.getEmptyExpression=O;const g="**",m="/",T="[/\\\\]",y="[^/\\\\]",v=/\//g;function b(I){switch(I){case 0:return"";case 1:return`${y}*?`;default:return`(?:${T}|${y}+${T}|${T}${y}+)*?`}}function u(I,F){if(!I)return[];const N=[];let W=!1,x=!1,X="";for(const Q of I){switch(Q){case F:if(!W&&!x){N.push(X),X="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":x=!0;break;case"]":x=!1;break}X+=Q}return X&&N.push(X),N}e.splitGlobAware=u;function S(I){if(!I)return"";let F="";const N=u(I,m);if(N.every(W=>W===g))F=".*";else{let W=!1;N.forEach((x,X)=>{if(x===g){W||(F+=b(2),W=!0);return}let Q=!1,ne="",ie=!1,ce="";for(const ue of x){if(ue!=="}"&&Q){ne+=ue;continue}if(ie&&(ue!=="]"||!ce)){let ge;ue==="-"?ge=ue:(ue==="^"||ue==="!")&&!ce?ge="^":ue===m?ge="":ge=p.escapeRegExpCharacters(ue),ce+=ge;continue}switch(ue){case"{":Q=!0;continue;case"[":ie=!0;continue;case"}":F+=`(?:${u(ne,",").map(Ce=>S(Ce)).join("|")})`,Q=!1,ne="";break;case"]":F+="["+ce+"]",ie=!1,ce="";break;case"?":F+=y;continue;case"*":F+=b(1);continue;default:F+=p.escapeRegExpCharacters(ue)}}X<N.length-1&&(N[X+1]!==g||X+2<N.length)&&(F+=T),W=!1})}return F}const C=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,D=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),i=function(){return!1},n=function(){return null};function o(I,F){if(!I)return n;let N;typeof I!="string"?N=I.pattern:N=I,N=N.trim();const W=`${N}_${!!F.trimForExclusions}`;let x=t.get(W);if(x)return a(x,I);let X;if(C.test(N)){const Q=N.substr(4);x=function(ne,ie){return typeof ne=="string"&&ne.endsWith(Q)?N:null}}else(X=E.exec(c(N,F)))?x=l(X[1],N):(F.trimForExclusions?f:D).test(N)?x=d(N,F):(X=s.exec(c(N,F)))?x=w(X[1].substr(1),N,!0):(X=r.exec(c(N,F)))?x=w(X[1],N,!1):x=h(N);return t.set(W,x),a(x,I)}function a(I,F){return typeof F=="string"?I:function(N,W){return k.isEqualOrParent(N,F.base)?I(A.relative(F.base,N),W):null}}function c(I,F){return F.trimForExclusions&&I.endsWith("/**")?I.substr(0,I.length-2):I}function l(I,F){const N=`/${I}`,W=`\\${I}`,x=function(Q,ne){return typeof Q!="string"?null:ne?ne===I?F:null:Q===I||Q.endsWith(N)||Q.endsWith(W)?F:null},X=[I];return x.basenames=X,x.patterns=[F],x.allBasenames=X,x}function d(I,F){const N=L(I.slice(1,-1).split(",").map(ne=>o(ne,F)).filter(ne=>ne!==n),I),W=N.length;if(!W)return n;if(W===1)return N[0];const x=function(ne,ie){for(let ce=0,ue=N.length;ce<ue;ce++)if(N[ce](ne,ie))return I;return null},X=N.find(ne=>!!ne.allBasenames);X&&(x.allBasenames=X.allBasenames);const Q=N.reduce((ne,ie)=>ie.allPaths?ne.concat(ie.allPaths):ne,[]);return Q.length&&(x.allPaths=Q),x}function w(I,F,N){const W=A.sep===A.posix.sep,x=W?I:I.replace(v,A.sep),X=A.sep+x,Q=A.posix.sep+I,ne=N?function(ie,ce){return typeof ie=="string"&&(ie===x||ie.endsWith(X)||!W&&(ie===I||ie.endsWith(Q)))?F:null}:function(ie,ce){return typeof ie=="string"&&(ie===x||!W&&ie===I)?F:null};return ne.allPaths=[(N?"*/":"./")+I],ne}function h(I){try{const F=new RegExp(`^${S(I)}$`);return function(N){return F.lastIndex=0,typeof N=="string"&&F.test(N)?I:null}}catch(F){return n}}function P(I,F,N){return!I||typeof F!="string"?!1:_(I)(F,void 0,N)}e.match=P;function _(I,F={}){if(!I)return i;if(typeof I=="string"||M(I)){const N=o(I,F);if(N===n)return i;const W=function(x,X){return!!N(x,X)};return N.allBasenames&&(W.allBasenames=N.allBasenames),N.allPaths&&(W.allPaths=N.allPaths),W}return V(I,F)}e.parse=_;function j(I){if(!!I){let F;return N=>(F||(F=(I()||Promise.resolve([])).then(W=>W?G(W):{})),F.then(W=>!!W[N]))}}e.hasSiblingPromiseFn=j;function q(I){if(!!I){let F;return N=>{if(!F){const W=I();F=W?G(W):{}}return!!F[N]}}}e.hasSiblingFn=q;function G(I){const F={};for(const N of I)F[N]=!0;return F}function M(I){const F=I;return F&&typeof F.base=="string"&&typeof F.pattern=="string"}e.isRelativePattern=M;function z(I){return I.allBasenames||[]}e.getBasenameTerms=z;function $(I){return I.allPaths||[]}e.getPathTerms=$;function V(I,F){const N=L(Object.getOwnPropertyNames(I).map(ne=>H(ne,I[ne],F)).filter(ne=>ne!==n)),W=N.length;if(!W)return n;if(!N.some(ne=>!!ne.requiresSiblings)){if(W===1)return N[0];const ne=function(ue,ge){for(let pe=0,Ce=N.length;pe<Ce;pe++){const Oe=N[pe](ue,ge);if(Oe)return Oe}return null},ie=N.find(ue=>!!ue.allBasenames);ie&&(ne.allBasenames=ie.allBasenames);const ce=N.reduce((ue,ge)=>ge.allPaths?ue.concat(ge.allPaths):ue,[]);return ce.length&&(ne.allPaths=ce),ne}const x=function(ne,ie,ce){let ue;for(let ge=0,pe=N.length;ge<pe;ge++){const Ce=N[ge];Ce.requiresSiblings&&ce&&(ie||(ie=A.basename(ne)),ue||(ue=ie.substr(0,ie.length-A.extname(ne).length)));const Oe=Ce(ne,ie,ue,ce);if(Oe)return Oe}return null},X=N.find(ne=>!!ne.allBasenames);X&&(x.allBasenames=X.allBasenames);const Q=N.reduce((ne,ie)=>ie.allPaths?ne.concat(ie.allPaths):ne,[]);return Q.length&&(x.allPaths=Q),x}function H(I,F,N){if(F===!1)return n;const W=o(I,N);if(W===n)return n;if(typeof F=="boolean")return W;if(F){const x=F.when;if(typeof x=="string"){const X=(Q,ne,ie,ce)=>{if(!ce||!W(Q,ne))return null;const ue=x.replace("$(basename)",ie),ge=ce(ue);return(0,U.isThenable)(ge)?ge.then(pe=>pe?I:null):ge?I:null};return X.requiresSiblings=!0,X}}return W}function L(I,F){const N=I.filter(ne=>!!ne.basenames);if(N.length<2)return I;const W=N.reduce((ne,ie)=>{const ce=ie.basenames;return ce?ne.concat(ce):ne},[]);let x;if(F){x=[];for(let ne=0,ie=W.length;ne<ie;ne++)x.push(F)}else x=N.reduce((ne,ie)=>{const ce=ie.patterns;return ce?ne.concat(ce):ne},[]);const X=function(ne,ie){if(typeof ne!="string")return null;if(!ie){let ue;for(ue=ne.length;ue>0;ue--){const ge=ne.charCodeAt(ue-1);if(ge===47||ge===92)break}ie=ne.substr(ue)}const ce=W.indexOf(ie);return ce!==-1?x[ce]:null};X.basenames=W,X.patterns=x,X.allBasenames=W;const Q=I.filter(ne=>!ne.basenames);return Q.push(X),Q}}),define(Z[90],ee([0,1,4]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(T){return T.toJSON()}class A{constructor(y){this._uriTransformer=y}transformIncoming(y){const v=this._uriTransformer.transformIncoming(y);return v===y?y:k(p.URI.from(v))}transformOutgoing(y){const v=this._uriTransformer.transformOutgoing(y);return v===y?y:k(p.URI.from(v))}transformOutgoingURI(y){const v=this._uriTransformer.transformOutgoing(y);return v===y?y:p.URI.from(v)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function R(T,y,v){if(!T||v>200)return null;if(typeof T=="object"){if(T instanceof p.URI)return y.transformOutgoing(T);for(let b in T)if(Object.hasOwnProperty.call(T,b)){const u=R(T[b],y,v+1);u!==null&&(T[b]=u)}}return null}function U(T,y){const v=R(T,y,0);return v===null?T:v}e.transformOutgoingURIs=U;function O(T,y,v,b){if(!T||b>200)return null;if(typeof T=="object"){if(T.$mid===1)return v?p.URI.revive(y.transformIncoming(T)):y.transformIncoming(T);for(let u in T)if(Object.hasOwnProperty.call(T,u)){const S=O(T[u],y,v,b+1);S!==null&&(T[u]=S)}}return null}function g(T,y){const v=O(T,y,!1,0);return v===null?T:v}e.transformIncomingURIs=g;function m(T,y){const v=O(T,y,!0,0);return v===null?T:v}e.transformAndReviveIncomingURIs=m}),define(Z[31],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(g){return p.test(g)}e.isUUID=k;const A=new Uint8Array(16),R=[];for(let g=0;g<256;g++)R.push(g.toString(16).padStart(2,"0"));let U;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?U=crypto.getRandomValues.bind(crypto):U=function(g){for(let m=0;m<g.length;m++)g[m]=Math.floor(Math.random()*256);return g};function O(){U(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let g=0,m="";return m+=R[A[g++]],m+=R[A[g++]],m+=R[A[g++]],m+=R[A[g++]],m+="-",m+=R[A[g++]],m+=R[A[g++]],m+="-",m+=R[A[g++]],m+=R[A[g++]],m+="-",m+=R[A[g++]],m+=R[A[g++]],m+="-",m+=R[A[g++]],m+=R[A[g++]],m+=R[A[g++]],m+=R[A[g++]],m+=R[A[g++]],m+=R[A[g++]],m}e.generateUuid=O}),define(Z[67],ee([0,1,199]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class k{constructor(R="utf8"){this.stringDecoder=new p.StringDecoder(R),this.remaining=null}write(R){const U=[],O=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(O.length<1)return U;let g=0,m,T=g;for(;T<O.length;)if(m=O.charCodeAt(T),m===13||m===10){if(U.push(O.substring(g,T)),T++,T<O.length){const y=m;m=O.charCodeAt(T),(y===13&&m===10||y===10&&m===13)&&T++}g=T}else T++;return this.remaining=g<O.length?O.substr(g):null,U}end(){return this.remaining}}e.LineDecoder=k}),define(Z[91],ee([0,1,38]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const k=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(O){const g=O.replace(/\-/g,":").toLowerCase();return!k.has(g)}function R(){return new Promise(async(O,g)=>{const m=setTimeout(()=>g("Unable to retrieve mac address (timeout after 10s)"),1e4);try{O(await U())}catch(T){g(T)}finally{clearTimeout(m)}})}e.getMac=R;function U(){return new Promise((O,g)=>{try{const m=(0,p.networkInterfaces)();for(let T in m){const y=m[T];if(y){for(const{mac:v}of y)if(A(v))return O(v)}}g("Unable to retrieve mac address (unexpected format)")}catch(m){g(m)}})}}),define(Z[92],ee([0,1,11,31,38,37,91]),function(K,e,p,k,A,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(T){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(T)}value(){if(this._value===void 0){let T=0,y=0;const v=(0,A.networkInterfaces)();for(let b in v){const u=v[b];if(u)for(const{mac:S,internal:C}of u)C||(y+=1,this._isVirtualMachineMacAdress(S.toUpperCase())&&(T+=1))}this._value=y>0?T/y:0}return this._value}};let O;async function g(){return O||(O=(async()=>await m()||k.generateUuid())()),O}e.getMachineId=g;async function m(){try{const T=await new Promise((v,b)=>{K(["crypto"],v,b)}),y=await(0,U.getMac)();return T.createHash("sha256").update(y,"utf8").digest("hex")}catch(T){p.onUnexpectedError(T);return}}}),define(Z[24],ee([0,1,27,38,8,6,7,42,31,66,12,4]),function(K,e,p,k,A,R,U,O,g,m,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var v;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function b(z,$=v.UNLINK){if((0,O.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return $===v.UNLINK?S(z):u(z)}e.rimraf=b;async function u(z){try{const $=(0,A.join)((0,k.tmpdir)(),(0,g.generateUuid)());try{await p.promises.rename(z,$)}catch(V){return S(z)}S($).catch(V=>{})}catch($){if($.code!=="ENOENT")throw $}}async function S(z){return p.promises.rmdir(z,{recursive:!0,maxRetries:3})}function C(z){if((0,O.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(z,{recursive:!0})}e.rimrafSync=C;async function E(z,$){return s(await($?D(z):p.promises.readdir(z)))}e.readdir=E;async function D(z){try{return await p.promises.readdir(z,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const $=[],V=await E(z);for(const H of V){let L=!1,I=!1,F=!1;try{const N=await p.promises.lstat((0,A.join)(z,H));L=N.isFile(),I=N.isDirectory(),F=N.isSymbolicLink()}catch(N){console.warn("[node.js fs] unexpected error from lstat after readdir: ",N)}$.push({name:H,isFile:()=>L,isDirectory:()=>I,isSymbolicLink:()=>F})}return $}function f(z){return s(p.readdirSync(z))}e.readdirSync=f;function s(z){return z.map($=>typeof $=="string"?U.isMacintosh?(0,m.normalizeNFC)($):$:($.name=U.isMacintosh?(0,m.normalizeNFC)($.name):$.name,$))}async function r(z){const $=await E(z),V=[];for(const H of $)await i.existsDirectory((0,A.join)(z,H))&&V.push(H);return V}e.readDirsInDir=r;function t(z,$=1e3){return new Promise(V=>{let H=!1;const L=setInterval(()=>{H||(H=!0,p.access(z,I=>{H=!1,I&&(clearInterval(L),V(void 0))}))},$)})}e.whenDeleted=t;var i;(function(z){async function $(L){let I;try{if(I=await p.promises.lstat(L),!I.isSymbolicLink())return{stat:I}}catch(F){}try{return{stat:await p.promises.stat(L),symbolicLink:(I==null?void 0:I.isSymbolicLink())?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&I)return{stat:I,symbolicLink:{dangling:!0}};if(U.isWindows&&F.code==="EACCES")try{return{stat:await p.promises.stat(await p.promises.readlink(L)),symbolicLink:{dangling:!1}}}catch(N){if(N.code==="ENOENT"&&I)return{stat:I,symbolicLink:{dangling:!0}};throw N}throw F}}z.stat=$;async function V(L){try{const{stat:I,symbolicLink:F}=await z.stat(L);return I.isFile()&&(F==null?void 0:F.dangling)!==!0}catch(I){}return!1}z.existsFile=V;async function H(L){try{const{stat:I,symbolicLink:F}=await z.stat(L);return I.isDirectory()&&(F==null?void 0:F.dangling)!==!0}catch(I){}return!1}z.existsDirectory=H})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new R.ResourceQueue;function o(z,$,V){return n.queueFor(y.URI.file(z),T.extUriBiasedIgnorePathCase).queue(()=>{const H=d(V);return new Promise((L,I)=>c(z,$,H,F=>F?I(F):L()))})}e.writeFile=o;let a=!0;function c(z,$,V,H){if(!a)return p.writeFile(z,$,{mode:V.mode,flag:V.flag},H);p.open(z,V.flag,V.mode,(L,I)=>{if(L)return H(L);p.writeFile(I,$,F=>{if(F)return p.close(I,()=>H(F));p.fdatasync(I,N=>(N&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",N),a=!1),p.close(I,W=>H(W))))})})}function l(z,$,V){const H=d(V);if(!a)return p.writeFileSync(z,$,{mode:H.mode,flag:H.flag});const L=p.openSync(z,H.flag,H.mode);try{p.writeFileSync(L,$);try{p.fdatasyncSync(L)}catch(I){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",I),a=!1}}finally{p.closeSync(L)}}e.writeFileSync=l;function d(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function w(z,$){if(z!==$){async function V(H){try{const L=await p.promises.lstat(H);if(L.isDirectory()||L.isSymbolicLink())return;const I=await p.promises.open(H,"a");try{await I.utimes(L.atime,new Date)}finally{await I.close()}}catch(L){}}try{await p.promises.rename(z,$),await V($)}catch(H){if(z.toLowerCase()!==$.toLowerCase()&&H.code==="EXDEV"||z.endsWith("."))await h(z,$,{preserveSymlinks:!1}),await b(z,v.MOVE),await V($);else throw H}}}e.move=w;async function h(z,$,V){return _(z,$,{root:{source:z,target:$},options:V,handledSourcePaths:new Set})}e.copy=h;const P=511;async function _(z,$,V){if(!V.handledSourcePaths.has(z)){V.handledSourcePaths.add(z);const{stat:H,symbolicLink:L}=await i.stat(z);if(L){if(V.options.preserveSymlinks)try{return await G(z,$,V)}catch(I){console.warn("[node.js fs] copy of symlink failed: ",I)}if(L.dangling)return}return H.isDirectory()?j(z,$,H.mode&P,V):q(z,$,H.mode&P)}}async function j(z,$,V,H){await p.promises.mkdir($,{recursive:!0,mode:V});const L=await E(z);for(const I of L)await _((0,A.join)(z,I),(0,A.join)($,I),H)}async function q(z,$,V){await p.promises.copyFile(z,$),await p.promises.chmod($,V)}async function G(z,$,V){let H=await p.promises.readlink(z);(0,O.isEqualOrParent)(H,V.root.source,!U.isLinux)&&(H=(0,A.join)(V.root.target,H.substr(V.root.source.length+1))),await p.promises.symlink(H,$)}async function M(z){try{return await p.promises.access(z),!0}catch($){return!1}}e.exists=M}),define(Z[93],ee([0,1,27,94,21,8,24]),function(K,e,p,k,A,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function O(y){const v=(0,R.dirname)(y);if(y===v)return y;const b=((0,R.basename)(y)||y).toLowerCase();try{const S=(0,U.readdirSync)(v).filter(C=>C.toLowerCase()===b);if(S.length===1){const C=O(v);if(C)return(0,R.join)(C,S[0])}else if(S.length>1){const C=S.indexOf(b);if(C>=0){const E=O(v);if(E)return(0,R.join)(E,S[C])}}}catch(u){}return null}e.realcaseSync=O;async function g(y){try{return await(0,k.promisify)(p.realpath)(y)}catch(v){const b=T(y);return await p.promises.access(b,p.constants.R_OK),b}}e.realpath=g;function m(y){try{return p.realpathSync(y)}catch(v){const b=T(y);return p.accessSync(b,p.constants.R_OK),b}}e.realpathSync=m;function T(y){return(0,A.rtrim)((0,R.normalize)(y),R.sep)}}),define(Z[95],ee([0,1,48,16]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function A(U){return new Promise((O,g)=>{let m;const T=new Map;function y(u,S,C,E,D){const f=T.get(S);if(u===U||f){const s={name:v(C),cmd:C,pid:u,ppid:S,load:E,mem:D};T.set(u,s),u===U&&(m=s),f&&(f.children||(f.children=[]),f.children.push(s),f.children.length>1&&(f.children=f.children.sort((r,t)=>r.pid-t.pid)))}}function v(u){const S=/--disable-blink-features=Auxclick/,C=/\\watcher\\win32\\CodeHelper\.exe/,E=/--crashes-directory/,D=/\\pipe\\winpty-control/,f=/conhost\.exe/,s=/--type=([a-zA-Z-]+)/;if(C.exec(u))return"watcherService ";if(E.exec(u))return"electron-crash-reporter";if(D.exec(u))return"winpty-process";if(f.exec(u))return"console-window-host (Windows internal process)";let r=s.exec(u);if(r&&r.length===2)return r[1]==="renderer"?S.exec(u)?"shared-process":"window":r[1];const t=/[a-zA-Z-]+\.js/g;let i="";do r=t.exec(u),r&&(i+=r+" ");while(r);return i&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron_node ${i}`:u}if(process.platform==="win32"){const u=S=>S.indexOf("\\\\?\\")===0||S.indexOf("\\??\\")===0?S.substr(4):S.indexOf('"\\\\?\\')===0||S.indexOf('"\\??\\')===0?'"'+S.substr(5):S;new Promise((S,C)=>{K(["windows-process-tree"],S,C)}).then(S=>{S.getProcessList(U,C=>{S.getProcessCpuUsage(C,E=>{const D=new Map;E.forEach(f=>{const s=u(f.commandLine||"");D.set(f.pid,{name:v(s),cmd:s,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),m=D.get(U),m?(D.forEach(f=>{const s=D.get(f.ppid);s&&(s.children||(s.children=[]),s.children.push(f))}),D.forEach(f=>{f.children&&(f.children=f.children.sort((s,r)=>s.pid-r.pid))}),O(m)):g(new Error(`Root process ${U} not found`))})},S.ProcessDataFlag.CommandLine|S.ProcessDataFlag.Memory)})}else{function b(){let u=[m];const S=[];for(;u.length;){const E=u.shift();E&&(S.push(E.pid),E.children&&(u=u.concat(E.children)))}let C=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);C+=" "+S.join(" "),(0,p.exec)(C,{},(E,D,f)=>{if(E||f)g(E||new Error(f.toString()));else{const s=D.toString().split(`
`);for(let r=0;r<S.length;r++){const t=T.get(S[r]);t.load=parseFloat(s[r])}if(!m){g(new Error(`Root process ${U} not found`));return}O(m)}})}(0,p.exec)("which ps",{},(u,S,C)=>{if(u||C)if(process.platform!=="linux")g(u||new Error(C.toString()));else{const E=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,p.exec)(E,{},(D,f,s)=>{D||s?g(D||new Error(s.toString())):(R(f,y),b())})}else{const E=S.toString().trim(),D="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${E} ${D}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,s,r)=>{f||r&&!r.includes("screen size is bogus")?g(f||new Error(r.toString())):(R(s,y),process.platform==="linux"?b():m?O(m):g(new Error(`Root process ${U} not found`)))})}})}})}e.listProcesses=A;function R(U,O){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=U.toString().split(`
`);for(const T of m){const y=g.exec(T.trim());y&&y.length===6&&O(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(Z[96],ee([0,1,8,27,7,66,2,24]),function(K,e,p,k,A,R,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function g(y,v,b){return T({path:y,isDirectory:!1},v,b)}e.watchFile=g;function m(y,v,b){return T({path:y,isDirectory:!0},v,b)}e.watchFolder=m,e.CHANGE_BUFFER_DELAY=100;function T(y,v,b){const u=(0,p.basename)(y.path),S=new Map;let C=!1,E=[(0,U.toDisposable)(()=>{S.forEach(D=>(0,U.dispose)(D)),S.clear()})];try{const D=(0,k.watch)(y.path);E.push((0,U.toDisposable)(()=>{D.removeAllListeners(),D.close()}));const f=new Set;y.isDirectory&&(0,O.readdir)(y.path).then(s=>s.forEach(r=>f.add(r))),D.on("error",(s,r)=>{C||b(`Failed to watch ${y.path} for changes using fs.watch() (${s}, ${r})`)}),D.on("change",(s,r)=>{if(!C){let t="";if(r&&(t=r.toString(),A.isMacintosh&&(t=(0,R.normalizeNFC)(t))),!(!t||s!=="change"&&s!=="rename")){const i=y.isDirectory?(0,p.join)(y.path,t):y.path;if(y.isDirectory)if(s==="rename"){const n=S.get(i);n&&(0,U.dispose)(n);const o=setTimeout(async()=>{S.delete(i);const a=await(0,O.exists)(i);if(!C){let c;a?f.has(t)?c="changed":(c="added",f.add(t)):(f.delete(t),c="deleted"),v(c,i)}},e.CHANGE_BUFFER_DELAY);S.set(i,(0,U.toDisposable)(()=>clearTimeout(o)))}else{let n;f.has(t)?n="changed":(n="added",f.add(t)),v(n,i)}else if(s==="rename"||t!==u){const n=setTimeout(async()=>{const o=await(0,O.exists)(i);C||(o?(v("changed",i),E=[T(y,v,b)]):v("deleted",i))},e.CHANGE_BUFFER_DELAY);(0,U.dispose)(E),E=[(0,U.toDisposable)(()=>clearTimeout(n))]}else v("changed",i)}}})}catch(D){(0,O.exists)(y.path).then(f=>{f&&!C&&b(`Failed to watch ${y.path} for changes using fs.watch() (${D.toString()})`)})}return(0,U.toDisposable)(()=>{C=!0,E=(0,U.dispose)(E)})}});var fe=this&&this.__decorate||function(K,e,p,k){var A=arguments.length,R=A<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,p):k,U;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(K,e,p,k);else for(var O=K.length-1;O>=0;O--)(U=K[O])&&(R=(A<3?U(R):A>3?U(e,p,R):U(e,p))||R);return A>3&&R&&Object.defineProperty(e,p,R),R};define(Z[34],ee([0,1,3,2,6,30,11,23,18,15,88,21,63]),function(K,e,p,k,A,R,U,O,g,m,T,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(L){L[L.Promise=100]="Promise",L[L.PromiseCancel=101]="PromiseCancel",L[L.EventListen=102]="EventListen",L[L.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function u(L){switch(L){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(L){L[L.Initialize=200]="Initialize",L[L.PromiseSuccess=201]="PromiseSuccess",L[L.PromiseError=202]="PromiseError",L[L.PromiseErrorObj=203]="PromiseErrorObj",L[L.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function C(L){switch(L){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(L){L[L.Uninitialized=0]="Uninitialized",L[L.Idle=1]="Idle"})(E||(E={}));class D{constructor(I){this.buffer=I,this.pos=0}read(I){const F=this.buffer.slice(this.pos,this.pos+I);return this.pos+=F.byteLength,F}}class f{constructor(){this.buffers=[]}get buffer(){return O.VSBuffer.concat(this.buffers)}write(I){this.buffers.push(I)}}var s;(function(L){L[L.Undefined=0]="Undefined",L[L.String=1]="String",L[L.Buffer=2]="Buffer",L[L.VSBuffer=3]="VSBuffer",L[L.Array=4]="Array",L[L.Object=5]="Object"})(s||(s={}));function r(L){const I=O.VSBuffer.alloc(4);return I.writeUInt32BE(L,0),I}function t(L){return L.read(4).readUInt32BE(0)}function i(L){const I=O.VSBuffer.alloc(1);return I.writeUInt8(L,0),I}const n={Undefined:i(s.Undefined),String:i(s.String),Buffer:i(s.Buffer),VSBuffer:i(s.VSBuffer),Array:i(s.Array),Object:i(s.Object)},o=typeof Buffer!="undefined";function a(L,I){if(typeof I=="undefined")L.write(n.Undefined);else if(typeof I=="string"){const F=O.VSBuffer.fromString(I);L.write(n.String),L.write(r(F.byteLength)),L.write(F)}else if(o&&Buffer.isBuffer(I)){const F=O.VSBuffer.wrap(I);L.write(n.Buffer),L.write(r(F.byteLength)),L.write(F)}else if(I instanceof O.VSBuffer)L.write(n.VSBuffer),L.write(r(I.byteLength)),L.write(I);else if(Array.isArray(I)){L.write(n.Array),L.write(r(I.length));for(const F of I)a(L,F)}else{const F=O.VSBuffer.fromString(JSON.stringify(I));L.write(n.Object),L.write(r(F.byteLength)),L.write(F)}}function c(L){switch(L.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return L.read(t(L)).toString();case s.Buffer:return L.read(t(L)).buffer;case s.VSBuffer:return L.read(t(L));case s.Array:{const F=t(L),N=[];for(let W=0;W<F;W++)N.push(c(L));return N}case s.Object:return JSON.parse(L.read(t(L)).toString())}}class l{constructor(I,F,N=null,W=1e3){this.protocol=I,this.ctx=F,this.logger=N,this.timeoutDelay=W,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(x=>this.onRawMessage(x)),this.sendResponse({type:200})}registerChannel(I,F){this.channels.set(I,F),setTimeout(()=>this.flushPendingRequests(I),0)}sendResponse(I){switch(I.type){case 200:{const F=this.send([I.type]);this.logger&&this.logger.logOutgoing(F,0,1,C(I.type));return}case 201:case 202:case 204:case 203:{const F=this.send([I.type,I.id],I.data);this.logger&&this.logger.logOutgoing(F,I.id,1,C(I.type),I.data);return}}}send(I,F=void 0){const N=new f;return a(N,I),a(N,F),this.sendBuffer(N.buffer)}sendBuffer(I){try{return this.protocol.send(I),I.byteLength}catch(F){return 0}}onRawMessage(I){const F=new D(I),N=c(F),W=c(F),x=N[0];switch(x){case 100:return this.logger&&this.logger.logIncoming(I.byteLength,N[1],1,`${u(x)}: ${N[2]}.${N[3]}`,W),this.onPromise({type:x,id:N[1],channelName:N[2],name:N[3],arg:W});case 102:return this.logger&&this.logger.logIncoming(I.byteLength,N[1],1,`${u(x)}: ${N[2]}.${N[3]}`,W),this.onEventListen({type:x,id:N[1],channelName:N[2],name:N[3],arg:W});case 101:return this.logger&&this.logger.logIncoming(I.byteLength,N[1],1,`${u(x)}`),this.disposeActiveRequest({type:x,id:N[1]});case 103:return this.logger&&this.logger.logIncoming(I.byteLength,N[1],1,`${u(x)}`),this.disposeActiveRequest({type:x,id:N[1]})}}onPromise(I){const F=this.channels.get(I.channelName);if(!F){this.collectPendingRequest(I);return}const N=new R.CancellationTokenSource;let W;try{W=F.call(this.ctx,I.name,I.arg,N.token)}catch(Q){W=Promise.reject(Q)}const x=I.id;W.then(Q=>{this.sendResponse({id:x,data:Q,type:201}),this.activeRequests.delete(I.id)},Q=>{Q instanceof Error?this.sendResponse({id:x,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.sendResponse({id:x,data:Q,type:203}),this.activeRequests.delete(I.id)});const X=(0,k.toDisposable)(()=>N.cancel());this.activeRequests.set(I.id,X)}onEventListen(I){const F=this.channels.get(I.channelName);if(!F){this.collectPendingRequest(I);return}const N=I.id,x=F.listen(this.ctx,I.name,I.arg)(X=>this.sendResponse({id:N,data:X,type:204}));this.activeRequests.set(I.id,x)}disposeActiveRequest(I){const F=this.activeRequests.get(I.id);F&&(F.dispose(),this.activeRequests.delete(I.id))}collectPendingRequest(I){let F=this.pendingRequests.get(I.channelName);F||(F=[],this.pendingRequests.set(I.channelName,F));const N=setTimeout(()=>{console.error(`Unknown channel: ${I.channelName}`),I.type===100&&this.sendResponse({id:I.id,data:{name:"Unknown channel",message:`Channel name '${I.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);F.push({request:I,timeoutTimer:N})}flushPendingRequests(I){const F=this.pendingRequests.get(I);if(F){for(const N of F)switch(clearTimeout(N.timeoutTimer),N.request.type){case 100:this.onPromise(N.request);break;case 102:this.onEventListen(N.request);break}this.pendingRequests.delete(I)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(I=>I.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var d;(function(L){L[L.LocalSide=0]="LocalSide",L[L.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(I,F=null){this.protocol=I,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(N=>this.onBuffer(N)),this.logger=F}getChannel(I){const F=this;return{call(N,W,x){return F.isDisposed?Promise.reject(U.canceled()):F.requestPromise(I,N,W,x)},listen(N,W){return F.isDisposed?Promise.reject(U.canceled()):F.requestEvent(I,N,W)}}}requestPromise(I,F,N,W=R.CancellationToken.None){const x=this.lastRequestId++,Q={id:x,type:100,channelName:I,name:F,arg:N};if(W.isCancellationRequested)return Promise.reject(U.canceled());let ne;return new Promise((ce,ue)=>{if(W.isCancellationRequested)return ue(U.canceled());const ge=()=>{const _e=Te=>{switch(Te.type){case 201:this.handlers.delete(x),ce(Te.data);break;case 202:this.handlers.delete(x);const Le=new Error(Te.data.message);Le.stack=Te.data.stack,Le.name=Te.data.name,ue(Le);break;case 203:this.handlers.delete(x),ue(Te.data);break}};this.handlers.set(x,_e),this.sendRequest(Q)};let pe=null;this.state===E.Idle?ge():(pe=(0,A.createCancelablePromise)(_e=>this.whenInitialized()),pe.then(()=>{pe=null,ge()}));const Ce=()=>{pe?(pe.cancel(),pe=null):this.sendRequest({id:x,type:101}),ue(U.canceled())},Oe=W.onCancellationRequested(Ce);ne=(0,k.combinedDisposable)((0,k.toDisposable)(Ce),Oe),this.activeRequests.add(ne)}).finally(()=>{this.activeRequests.delete(ne)})}requestEvent(I,F,N){const W=this.lastRequestId++,X={id:W,type:102,channelName:I,name:F,arg:N};let Q=null;const ne=new p.Emitter({onFirstListenerAdd:()=>{Q=(0,A.createCancelablePromise)(ce=>this.whenInitialized()),Q.then(()=>{Q=null,this.activeRequests.add(ne),this.sendRequest(X)})},onLastListenerRemove:()=>{Q?(Q.cancel(),Q=null):(this.activeRequests.delete(ne),this.sendRequest({id:W,type:103}))}}),ie=ce=>ne.fire(ce.data);return this.handlers.set(W,ie),ne.event}sendRequest(I){switch(I.type){case 100:case 102:{const F=this.send([I.type,I.id,I.channelName,I.name],I.arg);this.logger&&this.logger.logOutgoing(F,I.id,0,`${u(I.type)}: ${I.channelName}.${I.name}`,I.arg);return}case 101:case 103:{const F=this.send([I.type,I.id]);this.logger&&this.logger.logOutgoing(F,I.id,0,u(I.type));return}}}send(I,F=void 0){const N=new f;return a(N,I),a(N,F),this.sendBuffer(N.buffer)}sendBuffer(I){try{return this.protocol.send(I),I.byteLength}catch(F){return 0}}onBuffer(I){const F=new D(I),N=c(F),W=c(F),x=N[0];switch(x){case 200:return this.logger&&this.logger.logIncoming(I.byteLength,0,0,C(x)),this.onResponse({type:N[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(I.byteLength,N[1],0,C(x),W),this.onResponse({type:N[0],id:N[1],data:W})}}onResponse(I){if(I.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const F=this.handlers.get(I.id);F&&F(I)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===E.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(I=>I.dispose()),this.activeRequests.clear()}}fe([v.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class h{constructor(I){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,I(({protocol:F,onDidClientDisconnect:N})=>{p.Event.once(F.onMessage)(x=>{const X=new D(x),Q=c(X),ne=new l(F,Q),ie=new w(F);this.channels.forEach((ue,ge)=>ne.registerChannel(ge,ue));const ce={channelServer:ne,channelClient:ie,ctx:Q};this._connections.add(ce),this._onDidAddConnection.fire(ce),N(()=>{ne.dispose(),ie.dispose(),this._connections.delete(ce),this._onDidRemoveConnection.fire(ce)})})})}get connections(){const I=[];return this._connections.forEach(F=>I.push(F)),I}getChannel(I,F){const N=this;return{call(W,x,X){let Q;if((0,m.isFunction)(F)){let ie=(0,g.getRandomElement)(N.connections.filter(F));Q=ie?Promise.resolve(ie):p.Event.toPromise(p.Event.filter(N.onDidAddConnection,F))}else Q=F.routeCall(N,W,x);const ne=Q.then(ie=>ie.channelClient.getChannel(I));return _(ne).call(W,x,X)},listen(W,x){if((0,m.isFunction)(F))return N.getMulticastEvent(I,F,W,x);const X=F.routeEvent(N,W,x).then(Q=>Q.channelClient.getChannel(I));return _(X).listen(W,x)}}}getMulticastEvent(I,F,N,W){const x=this;let X=new k.DisposableStore;const Q=new p.Emitter({onFirstListenerAdd:()=>{X=new k.DisposableStore;const ne=new p.EventMultiplexer,ie=new Map,ce=ge=>{const Ce=ge.channelClient.getChannel(I).listen(N,W),Oe=ne.add(Ce);ie.set(ge,Oe)},ue=ge=>{const pe=ie.get(ge);!pe||(pe.dispose(),ie.delete(ge))};x.connections.filter(F).forEach(ce),p.Event.filter(x.onDidAddConnection,F)(ce,void 0,X),x.onDidRemoveConnection(ue,void 0,X),ne.event(Q.fire,Q,X),X.add(ne)},onLastListenerRemove:()=>{X.dispose()}});return Q.event}registerChannel(I,F){this.channels.set(I,F),this._connections.forEach(N=>{N.channelServer.registerChannel(I,F)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=h;class P{constructor(I,F,N=null){const W=new f;a(W,F),I.send(W.buffer),this.channelClient=new w(I,N),this.channelServer=new l(I,F,N)}getChannel(I){return this.channelClient.getChannel(I)}registerChannel(I,F){this.channelServer.registerChannel(I,F)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=P;function _(L){return{call(I,F,N){return L.then(W=>W.call(I,F,N))},listen(I,F){const N=new p.Relay;return L.then(W=>N.input=W.listen(I,F)),N.event}}}e.getDelayedChannel=_;function j(L){let I=!1;return{call(F,N,W){return I?L.call(F,N,W):(0,A.timeout)(0).then(()=>I=!0).then(()=>L.call(F,N,W))},listen(F,N){if(I)return L.listen(F,N);const W=new p.Relay;return(0,A.timeout)(0).then(()=>I=!0).then(()=>W.input=L.listen(F,N)),W.event}}}e.getNextTickChannel=j;class q{constructor(I){this.fn=I}routeCall(I){return this.route(I)}routeEvent(I){return this.route(I)}async route(I){for(const F of I.connections)if(await Promise.resolve(this.fn(F.ctx)))return Promise.resolve(F);return await p.Event.toPromise(I.onDidAddConnection),await this.route(I)}}e.StaticRouter=q;var G;(function(L){function I(W,x){const X=W,Q=x&&x.disableMarshalling,ne=new Map;for(const ie in X)N(ie)&&ne.set(ie,p.Event.buffer(X[ie],!0));return new class{listen(ie,ce){const ue=ne.get(ce);if(ue)return ue;throw new Error(`Event not found: ${ce}`)}call(ie,ce,ue){const ge=X[ce];if(typeof ge=="function"){if(!Q&&Array.isArray(ue))for(let pe=0;pe<ue.length;pe++)ue[pe]=(0,T.revive)(ue[pe]);return ge.apply(X,ue)}throw new Error(`Method not found: ${ce}`)}}}L.fromService=I;function F(W,x){const X=x&&x.disableMarshalling;return new Proxy({},{get(Q,ne){var ie;if(typeof ne=="string")return((ie=x==null?void 0:x.properties)===null||ie===void 0?void 0:ie.has(ne))?x.properties.get(ne):N(ne)?W.listen(ne):async function(...ce){let ue;x&&!(0,m.isUndefinedOrNull)(x.context)?ue=[x.context,...ce]:ue=ce;const ge=await W.call(ne,ue);return X?ge:(0,T.revive)(ge)};throw new Error(`Property not found: ${String(ne)}`)}})}L.toService=F;function N(W){return W[0]==="o"&&W[1]==="n"&&y.isUpperAsciiLetter(W.charCodeAt(2))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(L){if(Array.isArray(L))return L;if(L&&typeof L=="object"&&typeof L.toString=="function"){let I=L.toString();if(I!=="[object Object]")return I}return L}function $(L){return Array.isArray(L)?L.map(z):z(L)}function V(L,I,F,N,W,x,X){X=$(X);const Q=M[W],ne=Q[N%Q.length];let ie=[`%c[${L}]%c[${String(I).padStart(7," ")}]%c[len: ${String(F).padStart(5," ")}]%c${String(N).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${ne}`];/\($/.test(x)?(ie=ie.concat(X),ie.push(")")):ie.push(X),console.log.apply(console,ie)}e.logWithColors=V;class H{constructor(I,F){this._outgoingPrefix=I,this._incomingPrefix=F,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(I,F,N,W,x){this._totalOutgoing+=I,V(this._outgoingPrefix,this._totalOutgoing,I,F,N,W,x)}logIncoming(I,F,N,W,x){this._totalIncoming+=I,V(this._incomingPrefix,this._totalIncoming,I,F,N,W,x)}}e.IPCLogger=H}),define(Z[97],ee([0,1,3,34,23]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(g){this.port=g,this.onMessage=p.Event.fromDOMEventEmitter(this.port,"message",m=>A.VSBuffer.wrap(m.data)),g.start()}send(g){this.port.postMessage(g.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class U extends k.IPCClient{constructor(g,m){const T=new R(g);super(T,m);this.protocol=T}dispose(){this.protocol.disconnect()}}e.Client=U}),define(Z[98],ee([0,1,99,3,34,97]),function(K,e,p,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class U extends A.IPCServer{static getOnDidClientConnect(){const g=k.Event.fromNodeEventEmitter(p.ipcRenderer,"vscode:createMessageChannel",(m,T)=>T);return k.Event.map(g,m=>{const{port1:T,port2:y}=new MessageChannel,b={protocol:new R.Protocol(T),onDidClientDisconnect:k.Event.fromDOMEventEmitter(T,"close")};return p.ipcRenderer.postMessage("vscode:createMessageChannelResult",m,[y]),b})}constructor(){super(U.getOnDidClientConnect())}}e.Server=U}),define(Z[100],ee([0,1,11,23]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function A(O,g){O.proxyAuthorization&&(O.headers=Object.assign(Object.assign({},O.headers||{}),{"Proxy-Authorization":O.proxyAuthorization}));const m=new XMLHttpRequest;return new Promise((T,y)=>{m.open(O.type||"GET",O.url||"",!0,O.user,O.password),R(m,O),m.responseType="arraybuffer",m.onerror=v=>y(new Error(m.statusText&&"XHR failed: "+m.statusText||"XHR failed")),m.onload=v=>{T({res:{statusCode:m.status,headers:U(m)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(m.response)))})},m.ontimeout=v=>y(new Error(`XHR timeout: ${O.timeout}ms`)),O.timeout&&(m.timeout=O.timeout),m.send(O.data),g.onCancellationRequested(()=>{m.abort(),y((0,p.canceled)())})})}e.request=A;function R(O,g){if(g.headers){e:for(let m in g.headers){switch(m){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}O.setRequestHeader(m,g.headers[m])}}}function U(O){const g=Object.create(null);for(const m of O.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(m){const T=m.indexOf(":");g[m.substr(0,T).trim().toLowerCase()]=m.substr(T+1).trim()}return g}}),define(Z[68],ee([0,1,2,3,6,15]),function(K,e,p,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var U;(function(T){T[T.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(U=e.StorageHint||(e.StorageHint={}));var O;(function(T){T[T.None=0]="None",T[T.Initialized=1]="Initialized",T[T.Closed=2]="Closed"})(O||(O={}));class g extends p.Disposable{constructor(y,v=Object.create(null)){super();this.database=y,this.options=v,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=O.None,this.cache=new Map,this.flushDelayer=new A.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){var v,b;(v=y.changed)===null||v===void 0||v.forEach((u,S)=>this.accept(S,u)),(b=y.deleted)===null||b===void 0||b.forEach(u=>this.accept(u,void 0))}accept(y,v){if(this.state!==O.Closed){let b=!1;(0,R.isUndefinedOrNull)(v)?b=this.cache.delete(y):this.cache.get(y)!==v&&(this.cache.set(y,v),b=!0),b&&this._onDidChangeStorage.fire(y)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===O.None&&(this.state=O.Initialized,this.options.hint!==U.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,v){const b=this.cache.get(y);return(0,R.isUndefinedOrNull)(b)?v:b}getBoolean(y,v){const b=this.get(y);return(0,R.isUndefinedOrNull)(b)?v:b==="true"}getNumber(y,v){const b=this.get(y);return(0,R.isUndefinedOrNull)(b)?v:parseInt(b,10)}async set(y,v){if(this.state!==O.Closed){if((0,R.isUndefinedOrNull)(v))return this.delete(y);const b=String(v);if(this.cache.get(y)!==b)return this.cache.set(y,b),this.pendingInserts.set(y,b),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(y){if(this.state!==O.Closed&&!!this.cache.delete(y))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=O.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(y){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{var v;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(v=this.whenFlushedCallbacks.pop())===null||v===void 0||v()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class m{constructor(){this.onDidChangeItemsExternal=k.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert&&y.insert.forEach((v,b)=>this.items.set(b,v)),y.delete&&y.delete.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=m}),define(Z[101],ee([13,14]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[54],ee([0,1,101]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,A=k*60,R=A*24,U=R*7,O=R*30,g=R*365;function m(y,v){typeof y!="number"&&(y=y.getTime());const b=Math.round((new Date().getTime()-y)/1e3);if(b<-30)return(0,p.localize)(0,null,m(new Date().getTime()+b*1e3,!1));if(b<30)return(0,p.localize)(1,null);let u;return b<k?(u=b,v?u===1?(0,p.localize)(2,null,u):(0,p.localize)(3,null,u):u===1?(0,p.localize)(4,null,u):(0,p.localize)(5,null,u)):b<A?(u=Math.floor(b/k),v?u===1?(0,p.localize)(6,null,u):(0,p.localize)(7,null,u):u===1?(0,p.localize)(8,null,u):(0,p.localize)(9,null,u)):b<R?(u=Math.floor(b/A),v?u===1?(0,p.localize)(10,null,u):(0,p.localize)(11,null,u):u===1?(0,p.localize)(12,null,u):(0,p.localize)(13,null,u)):b<U?(u=Math.floor(b/R),v?u===1?(0,p.localize)(14,null,u):(0,p.localize)(15,null,u):u===1?(0,p.localize)(16,null,u):(0,p.localize)(17,null,u)):b<O?(u=Math.floor(b/U),v?u===1?(0,p.localize)(18,null,u):(0,p.localize)(19,null,u):u===1?(0,p.localize)(20,null,u):(0,p.localize)(21,null,u)):b<g?(u=Math.floor(b/O),v?u===1?(0,p.localize)(22,null,u):(0,p.localize)(23,null,u):u===1?(0,p.localize)(24,null,u):(0,p.localize)(25,null,u)):(u=Math.floor(b/g),v?u===1?(0,p.localize)(26,null,u):(0,p.localize)(27,null,u):u===1?(0,p.localize)(28,null,u):(0,p.localize)(29,null,u))}e.fromNow=m;function T(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(Z[102],ee([13,14]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[43],ee([0,1,102,15,18]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function R(m,T){return T&&(m.stack||m.stacktrace)?p.localize(0,null,O(m),U(m.stack)||U(m.stacktrace)):O(m)}function U(m){return Array.isArray(m)?m.join(`
`):m}function O(m){return typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?p.localize(1,null,m.message):m.message||p.localize(2,null)}function g(m=null,T=!1){if(!m)return p.localize(3,null);if(Array.isArray(m)){const y=A.coalesce(m),v=g(y[0],T);return y.length>1?p.localize(4,null,v,y.length):v}if(k.isString(m))return m;if(m.detail){const y=m.detail;if(y.error)return R(y.error,T);if(y.exception)return R(y.exception,T)}return m.stack?R(m,T):m.message?m.message:p.localize(5,null)}e.toErrorMessage=g}),define(Z[103],ee([13,14]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[104],ee([0,1,8,27,24,48,103,36,15,26,42,7,67,16]),function(K,e,p,k,A,R,U,O,g,m,T,y,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function u(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function S(r,t){if(y.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};t&&(i.cwd=t);const n=R.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(o=>{n.once("error",a=>{o({success:!1,error:a})}),n.once("exit",(a,c)=>{o(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?u(i.status):1})}else if(y.isLinux||y.isMacintosh)try{const i=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(n=>{R.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(o,a,c)=>{n(o?{success:!1,error:o}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function C(r=O.env){return r.comspec||"cmd.exe"}e.getWindowsShell=C;class E{constructor(t,i,n,o){if(i!==void 0&&n!==void 0&&o!==void 0)this.cmd=t,this.args=i,this.shell=n,this.options=o;else{const a=t;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(O.env).forEach(c=>{a[c]=O.env[c]}),Object.keys(this.options.env).forEach(c=>{a[c]=this.options.env[c]}),this.options.env=a}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const i=t.lastIndexOf(p.sep);return i!==-1&&(t=t.substring(i+1)),E.WellKnowCommands[t]?t:"other"}start(t){return y.isWindows&&(this.options&&this.options.cwd&&T.isUNC(this.options.cwd)||!this.options&&T.isUNC(O.cwd()))?Promise.reject(new Error(U.localize(0,null))):this.useExec().then(i=>{let n,o;const a=new Promise((c,l)=>{n=c,o=l});if(i){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=R.exec(c,this.options,(l,d,w)=>{this.childProcess=null;const h=l;h&&h.killed?o({killed:this.terminateRequested,stdout:d.toString(),stderr:w.toString()}):this.handleExec(n,t,l,d,w)})}else{let c=null;const l=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,n,t,o);const w={terminated:this.terminateRequested};g.isNumber(d)&&(w.cmdCode=d),n(w)};if(this.shell&&y.isWindows){const d=m.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let w=!1,h=!1;const P=[];let _=this.ensureQuotes(this.cmd);P.push(_.value),w=_.quoted,this.args&&this.args.forEach(q=>{_=this.ensureQuotes(q),P.push(_.value),h=h&&_.quoted});const j=["/s","/c"];w?h?j.push('"'+P.join(" ")+'"'):P.length>1?j.push('"'+P[0]+'" '+P.slice(1).join(" ")):j.push('"'+P[0]+'"'):j.push(P.join(" ")),c=R.spawn(C(),j,d)}else this.cmd&&(c=R.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(g.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",d=>{this.childProcess=null,o({terminated:this.terminateRequested,error:d})}),c.pid&&(this.childProcess.on("close",l),this.handleSpawn(c,n,t,o,!0)))}return a})}handleClose(t,i,n,o){}ensureQuotes(t){return E.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,S(t,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!y.isWindows)return t(!1);const i=R.spawn(C(),["/s","/c"]);i.on("error",n=>t(!0)),i.on("exit",n=>t(!1))})}}e.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class D extends E{constructor(t,i,n,o){super(t,i,n,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,i,n,o,a){[o,a].forEach((c,l)=>{const d=new v.LineDecoder;d.write(c).forEach(P=>{i({line:P,source:l===0?0:1})});const h=d.end();h&&i({line:h,source:l===0?0:1})}),t({terminated:this.terminateRequested,error:n})}handleSpawn(t,i,n,o,a){const c=new v.LineDecoder,l=new v.LineDecoder;t.stdout.on("data",d=>{c.write(d).forEach(h=>n({line:h,source:0}))}),t.stderr.on("data",d=>{l.write(d).forEach(h=>n({line:h,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=l}handleClose(t,i,n,o){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&n({line:a,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&n({line:c,source:1})}}e.LineProcess=D;function f(r){let t=[],i=!1;const n=function(o){if(i){t.push(o);return}(!r.send(o,c=>{if(c&&console.error(c),i=!1,t.length>0){const l=t.slice(0);t=[],l.forEach(d=>n(d))}})||y.isWindows)&&(i=!0)};return{send:n}}e.createQueuedSender=f;var s;(function(r){async function t(i,n,o){if(p.isAbsolute(i))return i;if(n===void 0&&(n=O.cwd()),p.dirname(i)!=="."||(o===void 0&&g.isString(O.env.PATH)&&(o=O.env.PATH.split(p.delimiter)),o===void 0||o.length===0))return p.join(n,i);async function c(l){return await A.exists(l)?!(await k.promises.stat(l)).isDirectory():!1}for(let l of o){let d;if(p.isAbsolute(l)?d=p.join(l,i):d=p.join(n,l,i),await c(d))return d;let w=d+".com";if(await c(w)||(w=d+".exe",await c(w)))return w}return p.join(n,i)}r.findExecutable=t})(s=e.win32||(e.win32={}))}),define(Z[49],ee([0,1,48,2,6,26,3,104,34,87,30,11,23,7]),function(K,e,p,k,A,R,U,O,g,m,T,y,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends g.ChannelServer{constructor(E){super({send:D=>{try{process.send&&process.send(D.buffer.toString("base64"))}catch(f){}},onMessage:U.Event.fromNodeEventEmitter(process,"message",D=>v.VSBuffer.wrap(Buffer.from(D,"base64")))},E);process.once("disconnect",()=>this.dispose())}}e.Server=u;class S{constructor(E,D){this.modulePath=E,this.options=D,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new U.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=D&&D.timeout?D.timeout:6e4;this.disposeDelayer=new A.Delayer(f),this.child=null,this._client=null}getChannel(E){const D=this;return{call(f,s,r){return D.requestPromise(E,f,s,r)},listen(f,s){return D.requestEvent(E,f,s)}}}requestPromise(E,D,f,s=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(y.canceled());this.disposeDelayer.cancel();const r=this.getCachedChannel(E),t=(0,A.createCancelablePromise)(o=>r.call(D,f,o)),i=s.onCancellationRequested(()=>t.cancel()),n=(0,k.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(E,D,f){if(!this.disposeDelayer)return U.Event.None;this.disposeDelayer.cancel();let s;const r=new U.Emitter({onFirstListenerAdd:()=>{s=this.getCachedChannel(E).listen(D,f)(r.fire,r),this.activeRequests.add(s)},onLastListenerRemove:()=>{this.activeRequests.delete(s),s.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return r.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],D=Object.create(null);D.env=Object.assign(Object.assign({},(0,R.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(D.env=Object.assign(Object.assign({},D.env),this.options.env)),this.options&&this.options.freshExecArgv&&(D.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(D.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(D.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),D.execArgv===void 0&&(D.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),b.isMacintosh&&D.env&&delete D.env.DYLD_LIBRARY_PATH,this.child=(0,p.fork)(this.modulePath,E,D);const f=new U.Emitter;U.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,m.isRemoteConsoleLog)(a)){(0,m.log)(a,`IPC Library: ${this.options.serverName}`);return}f.fire(v.VSBuffer.wrap(Buffer.from(a,"base64")))});const r=this.options.useQueue?(0,O.createQueuedSender)(this.child):this.child,t=a=>this.child&&this.child.connected&&r.send(a.buffer.toString("base64")),i=f.event,n={send:t,onMessage:i};this._client=new g.ChannelClient(n);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,c)=>{process.removeListener("exit",o),this.activeRequests.forEach(l=>(0,k.dispose)(l)),this.activeRequests.clear(),a!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+c),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:c})})}return this._client}getCachedChannel(E){let D=this.channels.get(E);return D||(D=this.client.getChannel(E),this.channels.set(E,D)),D}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=S}),define(Z[105],ee([13,14]),function(K,e){return K.create("vs/base/node/zip",e)}),define(Z[106],ee([13,14]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[107],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[108],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[109],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[110],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[111],ee([13,14]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[112],ee([13,14]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[113],ee([13,14]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[114],ee([13,14]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[115],ee([13,14]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[116],ee([13,14]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[117],ee([13,14]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[118],ee([13,14]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[119],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[120],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[121],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[122],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[123],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[124],ee([13,14]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(Z[125],ee([0,1,8,12,63,54,16,4,36]),function(K,e,p,k,A,R,U,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class m{constructor(u,S,C){this._args=u,this.paths=S,this.productService=C}get appRoot(){return(0,p.dirname)(U.FileAccess.asFileUri("",K).fsPath)}get userHome(){return O.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return O.URI.file((0,p.join)(this.userDataPath,"User"))}get tmpDir(){return O.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,k.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const u=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,p.join)(this.userDataPath,"logs",u)}return this.args.logsPath}get userDataSyncLogResource(){return O.URI.file((0,p.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(O.URI.file((0,p.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return O.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return O.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=g.env.VSCODE_PORTABLE;return u?O.URI.file((0,p.join)(u,"argv.json")):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,k.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return O.URI.file((0,p.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,p.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,p.resolve)(u):(0,p.normalize)((0,p.join)(U.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const u=this.args["extensions-download-dir"];return u?(0,p.resolve)(u):(0,p.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,p.resolve)(u);const S=g.env.VSCODE_EXTENSIONS;if(S)return S;const C=g.env.VSCODE_PORTABLE;return C?(0,p.join)(C,"extensions"):(0,k.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(S=>/^[^:/?#]+?:\/\//.test(S)?O.URI.parse(S):O.URI.file((0,p.normalize)(S)))}get extensionDevelopmentKind(){var u;return(u=this.args.extensionDevelopmentKind)===null||u===void 0?void 0:u.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?O.URI.parse(u):O.URI.file((0,p.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return T(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!g.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,k.joinPath)(O.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return O.URI.file((0,p.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}fe([A.memoize],m.prototype,"appRoot",null),fe([A.memoize],m.prototype,"userHome",null),fe([A.memoize],m.prototype,"userDataPath",null),fe([A.memoize],m.prototype,"appSettingsHome",null),fe([A.memoize],m.prototype,"tmpDir",null),fe([A.memoize],m.prototype,"userRoamingDataHome",null),fe([A.memoize],m.prototype,"settingsResource",null),fe([A.memoize],m.prototype,"userDataSyncHome",null),fe([A.memoize],m.prototype,"userDataSyncLogResource",null),fe([A.memoize],m.prototype,"sync",null),fe([A.memoize],m.prototype,"machineSettingsResource",null),fe([A.memoize],m.prototype,"globalStorageHome",null),fe([A.memoize],m.prototype,"workspaceStorageHome",null),fe([A.memoize],m.prototype,"keybindingsResource",null),fe([A.memoize],m.prototype,"keyboardLayoutResource",null),fe([A.memoize],m.prototype,"argvResource",null),fe([A.memoize],m.prototype,"snippetsHome",null),fe([A.memoize],m.prototype,"isExtensionDevelopment",null),fe([A.memoize],m.prototype,"untitledWorkspacesHome",null),fe([A.memoize],m.prototype,"installSourcePath",null),fe([A.memoize],m.prototype,"builtinExtensionsPath",null),fe([A.memoize],m.prototype,"extensionsPath",null),fe([A.memoize],m.prototype,"extensionDevelopmentLocationURI",null),fe([A.memoize],m.prototype,"extensionDevelopmentKind",null),fe([A.memoize],m.prototype,"extensionTestsLocationURI",null),fe([A.memoize],m.prototype,"debugExtensionHost",null),fe([A.memoize],m.prototype,"serviceMachineIdResource",null),fe([A.memoize],m.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=m;function T(b,u){return v(b["inspect-extensions"],b["inspect-brk-extensions"],5870,u,b.debugId)}e.parseExtensionHostPort=T;function y(b,u){return v(b["inspect-search"],b["inspect-brk-search"],5876,u)}e.parseSearchPort=y;function v(b,u,S,C,E){const f=Number(u||b)||(C?null:S),s=f?Boolean(!!u):!1;return{port:f,break:s,debugId:E}}}),function(){"use strict";function K(e,p,k,A){function R(O){const g=U(O),m=[g];return e.isAbsolute(g)||m.unshift(A),e.resolve(...m)}function U(O){const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");const m=O["user-data-dir"];if(m)return m;let T=process.env.VSCODE_APPDATA;if(!T)switch(process.platform){case"win32":if(T=process.env.APPDATA,!T){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");T=e.join(y,"AppData","Roaming")}break;case"darwin":T=e.join(p.homedir(),"Library","Application Support");break;case"linux":T=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(T,k)}return{getUserDataPath:R}}if(typeof define=="function")define(Z[126],ee([0,200,38,16,12,36]),function(e,p,k,A,R,U){const O=R.dirname(A.FileAccess.asFileUri("",e)),g=e.__$__nodeRequire(R.joinPath(O,"package.json").fsPath);return K(p,k,g.name,U.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),p=require("path"),k=require("os");module.exports=K(p,k,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[127],ee([0,1,38,126,125]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends A.AbstractNativeEnvironmentService{constructor(O,g){super(O,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,k.getUserDataPath)(O)},g)}}e.NativeEnvironmentService=R}),define(Z[128],ee([0,1,4]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const k=/^([^@:]+@)?([^:]+):/,A=/^([^@:]+@)?([^:]+):(.+)$/,R=/^([^@]+@)?([^:]+)(:\d+)?$/,U=/([^@:.]+\.[^@:.]+)(:\d+)?$/,O=/^\s*url\s*=\s*(.+\S)\s*$/mg,g=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function m(C){const E=C.match(U);return E?E[1]:null}function T(C){if(C.indexOf("://")===-1){const E=C.match(k);return E?m(E[2]):null}try{const E=p.URI.parse(C);if(E.authority)return m(E.authority)}catch(E){}return null}function y(C,E){const D=new Set;let f;for(;f=O.exec(C);){const r=T(f[1]);r&&D.add(r)}const s=new Set(E);return Array.from(D).map(r=>s.has(r)?r:r.replace(g,"a"))}e.getDomainsOfRemotes=y;function v(C){const E=C.match(R);return E?E[2]:null}function b(C,E,D){return C&&E?(D&&E.endsWith(".git")&&(E=E.substr(0,E.length-4)),E.indexOf("/")===0?`${C}${E}`:`${C}/${E}`):null}function u(C,E){if(C.indexOf("://")===-1){const D=C.match(A);if(D)return b(D[2],D[3],E)}try{const D=p.URI.parse(C);if(D.authority)return b(v(D.authority),D.path,E)}catch(D){}return null}function S(C,E=!1){const D=[];let f;for(;f=O.exec(C);){const s=u(f[1],E);s&&D.push(s)}return D}e.getRemotes=S}),define(Z[129],ee([0,1,3,4,90,26,2]),function(K,e,p,k,A,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function O(u,S){return k.URI.revive(S?S.transformIncoming(u):u)}function g(u,S){return S?S.transformOutgoingURI(u):u}function m(u,S){S=S||A.DefaultURITransformer;const C=u.manifest,E=(0,A.transformAndReviveIncomingURIs)(Object.assign(Object.assign({},u),{manifest:void 0}),S);return Object.assign(Object.assign({},E),{manifest:C})}function T(u,S){return S?(0,R.cloneAndChange)(u,C=>C instanceof k.URI?S.transformOutgoingURI(C):void 0):u}class y{constructor(S,C){this.service=S,this.getUriTransformer=C,this.onInstallExtension=p.Event.buffer(S.onInstallExtension,!0),this.onDidInstallExtension=p.Event.buffer(S.onDidInstallExtension,!0),this.onUninstallExtension=p.Event.buffer(S.onUninstallExtension,!0),this.onDidUninstallExtension=p.Event.buffer(S.onDidUninstallExtension,!0)}listen(S,C){const E=this.getUriTransformer(S);switch(C){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return p.Event.map(this.onDidInstallExtension,D=>Object.assign(Object.assign({},D),{local:D.local?T(D.local,E):D.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(S,C,E){const D=this.getUriTransformer(S);switch(C){case"zip":return this.service.zip(m(E[0],D)).then(f=>g(f,D));case"unzip":return this.service.unzip(O(E[0],D));case"install":return this.service.install(O(E[0],D));case"getManifest":return this.service.getManifest(O(E[0],D));case"canInstall":return this.service.canInstall(E[0]);case"installFromGallery":return this.service.installFromGallery(E[0],E[1]);case"uninstall":return this.service.uninstall(m(E[0],D),E[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(m(E[0],D));case"getInstalled":return this.service.getInstalled(E[0]).then(f=>f.map(s=>T(s,D)));case"updateMetadata":return this.service.updateMetadata(m(E[0],D),E[1]).then(f=>T(f,D));case"updateExtensionScope":return this.service.updateExtensionScope(m(E[0],D),E[1]).then(f=>T(f,D));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=y;class v extends U.Disposable{constructor(S){super();this.channel=S,this._onInstallExtension=this._register(new p.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new p.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new p.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new p.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(C=>this._onInstallExtension.fire(C))),this._register(this.channel.listen("onDidInstallExtension")(C=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},C),{local:C.local?m(C.local,null):C.local})))),this._register(this.channel.listen("onUninstallExtension")(C=>this._onUninstallExtension.fire(C))),this._register(this.channel.listen("onDidUninstallExtension")(C=>this._onDidUninstallExtension.fire(C)))}zip(S){return Promise.resolve(this.channel.call("zip",[S]).then(C=>k.URI.revive(C)))}unzip(S){return Promise.resolve(this.channel.call("unzip",[S]))}install(S){return Promise.resolve(this.channel.call("install",[S])).then(C=>m(C,null))}getManifest(S){return Promise.resolve(this.channel.call("getManifest",[S]))}async canInstall(S){return!0}installFromGallery(S,C){return Promise.resolve(this.channel.call("installFromGallery",[S,C])).then(E=>m(E,null))}uninstall(S,C){return Promise.resolve(this.channel.call("uninstall",[S,C]))}reinstallFromGallery(S){return Promise.resolve(this.channel.call("reinstallFromGallery",[S]))}getInstalled(S=null){return Promise.resolve(this.channel.call("getInstalled",[S])).then(C=>C.map(E=>m(E,null)))}updateMetadata(S,C){return Promise.resolve(this.channel.call("updateMetadata",[S,C])).then(E=>m(E,null))}updateExtensionScope(S,C){return Promise.resolve(this.channel.call("updateExtensionScope",[S,C])).then(E=>m(E,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=v;class b{constructor(S){this.service=S}listen(S,C){throw new Error("Invalid listen")}call(S,C,E){switch(C){case"getConfigBasedTips":return this.service.getConfigBasedTips(k.URI.revive(E[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=b}),define(Z[130],ee([0,1,26]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const k=/^%([\w\d.-]+)%$/i;function A(R,U){const O=g=>{if(typeof g=="string"){const m=k.exec(g);if(!!m)return U[m[1]]||g}};return(0,p.cloneAndChange)(R,O)}e.localizeManifest=A}),define(Z[131],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class p{constructor(R){this.channel=R}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(R,U,O,g){return this.channel.call("promptImportantExtensionsInstallNotification",[R,U,O,g])}promptWorkspaceRecommendations(R){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=p;class k{constructor(R){this.service=R}listen(R,U){throw new Error(`Event not found: ${U}`)}call(R,U,O){switch(U){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(O[0],O[1],O[2],O[3])}throw new Error(`Call not found: ${U}`)}}e.ExtensionRecommendationNotificationServiceChannel=k}),define(Z[69],ee([0,1,112]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function R(v){return v=v.trim(),v==="*"||k.test(v)}e.isValidVersionStr=R;function U(v){if(!R(v))return null;if(v=v.trim(),v==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=v.match(k);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=U;function O(v){if(!v)return null;let b=v.majorBase,u=v.majorMustEqual,S=v.minorBase,C=v.minorMustEqual,E=v.patchBase,D=v.patchMustEqual;v.hasCaret&&(b===0||(C=!1),D=!1);let f=0;if(v.preRelease){const s=A.exec(v.preRelease);if(s){const[,r,t,i]=s;f=Date.UTC(Number(r),Number(t)-1,Number(i))}}return{majorBase:b,majorMustEqual:u,minorBase:S,minorMustEqual:C,patchBase:E,patchMustEqual:D,isMinimum:v.hasGreaterEquals,notBefore:f}}e.normalizeVersion=O;function g(v,b,u){let S;typeof v=="string"?S=O(U(v)):S=v;let C;b instanceof Date?C=b.getTime():typeof b=="string"&&(C=new Date(b).getTime());let E;if(typeof u=="string"?E=O(U(u)):E=u,!S||!E)return!1;let D=S.majorBase,f=S.minorBase,s=S.patchBase,r=E.majorBase,t=E.minorBase,i=E.patchBase,n=E.notBefore,o=E.majorMustEqual,a=E.minorMustEqual,c=E.patchMustEqual;return E.isMinimum?D>r?!0:D<r?!1:f>t?!0:f<t||C&&C<n?!1:s>=i:(D===1&&r===0&&(!o||!a||!c)&&(r=1,t=0,i=0,o=!0,a=!1,c=!1),D<r?!1:D>r?!o:f<t?!1:f>t?!a:s<i?!1:s>i?!c:!(C&&C<n))}e.isValidVersion=g;function m(v,b,u,S){return u.isBuiltin||typeof u.main=="undefined"?!0:y(v,b,u.engines.vscode,S)}e.isValidExtensionVersion=m;function T(v,b,u){return v==="*"||y(b,u,v)}e.isEngineValid=T;function y(v,b,u,S=[]){let C=O(U(u));if(!C)return S.push(p.localize(0,null,u)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return S.push(p.localize(1,null,u)),!1}else if(!C.majorMustEqual)return S.push(p.localize(2,null,u)),!1;return g(v,b,C)?!0:(S.push(p.localize(3,null,v,u)),!1)}}),define(Z[132],ee([0,1,34,49,2,16]),function(K,e,p,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class U extends A.Disposable{constructor(g,m,T,y){super();this.folders=g,this.onDidFilesChange=m,this.onLogMessage=T,this.verboseLogging=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const g=this._register(new k.Client(R.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(g.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=U.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=p.ProxyChannel.toService((0,p.getNextTickChannel)(g.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(m=>!this.isDisposed&&this.onDidFilesChange(m))),this._register(this.service.onDidLogMessage(m=>this.onLogMessage(m))),this.setFolders(this.folders)}setVerboseLogging(g){this.verboseLogging=g,!this.isDisposed&&this.service&&this.service.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${g}`})}setFolders(g){this.folders=g,this.service&&this.service.setRoots(g)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=U,U.MAX_RESTARTS=5}),define(Z[133],ee([0,1,34,49,2,16]),function(K,e,p,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class U extends A.Disposable{constructor(g,m,T,y,v={}){super();this.folders=g,this.onDidFilesChange=m,this.onLogMessage=T,this.verboseLogging=y,this.watcherOptions=v,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const g=this._register(new k.Client(R.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(g.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=U.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=p.ProxyChannel.toService((0,p.getNextTickChannel)(g.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(m=>!this.isDisposed&&this.onDidFilesChange(m))),this._register(this.service.onDidLogMessage(m=>this.onLogMessage(m))),this.service.setRoots(this.folders)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${g}`})}setVerboseLogging(g){this.verboseLogging=g,this.service&&this.service.setVerboseLogging(g)}setFolders(g){this.folders=g,this.service&&this.service.setRoots(g)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=U,U.MAX_RESTARTS=5}),define(Z[134],ee([0,1,48,67,89,16]),function(K,e,p,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class U{constructor(g,m,T,y,v){this.watchedFolder=g,this.eventCallback=T,this.logCallback=y,this.verboseLogging=v,this.restartCounter=0,Array.isArray(m)?this.ignored=m.map(b=>A.parse(b)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${g}`),this.startWatcher()}startWatcher(){const g=[this.watchedFolder];this.verboseLogging&&g.push("-verbose"),this.handle=p.spawn(R.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,g);const m=new k.LineDecoder;this.handle.stdout.on("data",T=>{const y=[];m.write(T).forEach(v=>{const b=v.split("|");if(b.length===2){const u=Number(b[0]),S=b[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(C=>C(S))){this.verboseLogging&&this.log(S);return}y.push({type:U.changeTypeMap[u],path:S})}else this.log(b[1])}}),y.length>0&&this.eventCallback(y)}),this.handle.on("error",T=>this.onError(T)),this.handle.stderr.on("data",T=>this.onError(T)),this.handle.on("exit",(T,y)=>this.onExit(T,y))}onError(g){this.error("process error: "+g.toString())}onExit(g,m){this.handle&&(this.error(`terminated unexpectedly (code: ${g}, signal: ${m})`),this.restartCounter<=U.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(g){this.logCallback({type:"error",message:`[File Watcher (C#)] ${g}`})}log(g){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${g}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=U,U.MAX_RESTARTS=5,U.changeTypeMap=[0,1,2]}),define(Z[135],ee([0,1,134,8,21]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class R{constructor(O,g,m,T){this.onDidFilesChange=g,this.onLogMessage=m,this.verboseLogging=T,this.service=void 0,this.folder=O[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(k.posix.sep)&&(this.folder.path=(0,A.rtrim)(this.folder.path,k.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new p.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,O=>this.onFileEvents(O),O=>this.onLogMessage(O),this.verboseLogging)}setVerboseLogging(O){this.verboseLogging=O,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(O){this.isDisposed||O.length>0&&this.onDidFilesChange(O)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=R}),define(Z[50],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class p{constructor(R,U=[],O=!1){this.ctor=R,this.staticArguments=U,this.supportsDelayedInstantiation=O}}e.SyncDescriptor=p;const k=(A,...R)=>new p(A,R);e.createSyncDescriptor=k}),define(Z[136],ee([0,1,50]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const k=[];function A(U,O,g){O instanceof p.SyncDescriptor||(O=new p.SyncDescriptor(O,[],g)),k.push([U,O])}e.registerSingleton=A;function R(){return k}e.getSingletonServiceDescriptors=R}),define(Z[137],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=p;class k{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let U of this._nodes.values())U.outgoing.size===0&&R.push(U);return R}insertEdge(R,U){const O=this.lookupOrInsertNode(R),g=this.lookupOrInsertNode(U);O.outgoing.set(this._hashFn(U),g),g.incoming.set(this._hashFn(R),O)}removeNode(R){const U=this._hashFn(R);this._nodes.delete(U);for(let O of this._nodes.values())O.outgoing.delete(U),O.incoming.delete(U)}lookupOrInsertNode(R){const U=this._hashFn(R);let O=this._nodes.get(U);return O||(O=new p(R),this._nodes.set(U,O)),O}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[U,O]of this._nodes)R.push(`${U}, (incoming)[${[...O.incoming.keys()].join(", ")}], (outgoing)[${[...O.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,U]of this._nodes){const O=new Set([R]),g=this._findCycle(U,O);if(g)return g}}_findCycle(R,U){for(let[O,g]of R.outgoing){if(U.has(O))return[...U,O].join(" -> ");U.add(O);const m=this._findCycle(g,U);if(m)return m;U.delete(O)}}}e.Graph=k}),define(Z[5],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function g(m){return m[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=g})(p=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function k(O,g,m,T){g[p.DI_TARGET]===g?g[p.DI_DEPENDENCIES].push({id:O,index:m,optional:T}):(g[p.DI_DEPENDENCIES]=[{id:O,index:m,optional:T}],g[p.DI_TARGET]=g)}function A(O){if(p.serviceIds.has(O))return p.serviceIds.get(O);const g=function(m,T,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(g,m,y,!1)};return g.toString=()=>O,p.serviceIds.set(O,g),g}e.createDecorator=A;function R(O){return O}e.refineServiceDecorator=R;function U(O){return function(g,m,T){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");k(O,g,T,!0)}}e.optional=U}),define(Z[138],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,p.createDecorator)("checksumService")}),define(Z[139],ee([0,1,21,5,7]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let R=A.userAgent||"";const U=new Map;U.set("false",!1),U.set("true",!0),U.set("isMac",A.isMacintosh),U.set("isLinux",A.isLinux),U.set("isWindows",A.isWindows),U.set("isWeb",A.isWeb),U.set("isMacNative",A.isMacintosh&&!A.isWeb),U.set("isEdge",R.indexOf("Edg/")>=0),U.set("isFirefox",R.indexOf("Firefox")>=0),U.set("isChrome",R.indexOf("Chrome")>=0),U.set("isSafari",R.indexOf("Safari")>=0);const O=Object.prototype.hasOwnProperty;var g;(function(w){w[w.False=0]="False",w[w.True=1]="True",w[w.Defined=2]="Defined",w[w.Not=3]="Not",w[w.Equals=4]="Equals",w[w.NotEquals=5]="NotEquals",w[w.And=6]="And",w[w.Regex=7]="Regex",w[w.NotRegex=8]="NotRegex",w[w.Or=9]="Or",w[w.In=10]="In",w[w.NotIn=11]="NotIn",w[w.Greater=12]="Greater",w[w.GreaterEquals=13]="GreaterEquals",w[w.Smaller=14]="Smaller",w[w.SmallerEquals=15]="SmallerEquals"})(g=e.ContextKeyExprType||(e.ContextKeyExprType={}));class m{static false(){return y.INSTANCE}static true(){return v.INSTANCE}static has(h){return b.create(h)}static equals(h,P){return u.create(h,P)}static notEquals(h,P){return E.create(h,P)}static regex(h,P){return i.create(h,P)}static in(h,P){return S.create(h,P)}static not(h){return D.create(h)}static and(...h){return o.create(h)}static or(...h){return a.create(h)}static greater(h,P){return f.create(h,P)}static less(h,P){return r.create(h,P)}static deserialize(h,P=!1){if(!!h)return this._deserializeOrExpression(h,P)}static _deserializeOrExpression(h,P){let _=h.split("||");return a.create(_.map(j=>this._deserializeAndExpression(j,P)))}static _deserializeAndExpression(h,P){let _=h.split("&&");return o.create(_.map(j=>this._deserializeOne(j,P)))}static _deserializeOne(h,P){if(h=h.trim(),h.indexOf("!=")>=0){let _=h.split("!=");return E.create(_[0].trim(),this._deserializeValue(_[1],P))}if(h.indexOf("==")>=0){let _=h.split("==");return u.create(_[0].trim(),this._deserializeValue(_[1],P))}if(h.indexOf("=~")>=0){let _=h.split("=~");return i.create(_[0].trim(),this._deserializeRegexValue(_[1],P))}if(h.indexOf(" in ")>=0){let _=h.split(" in ");return S.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(h)){const _=h.split(">=");return s.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(h)){const _=h.split(">");return f.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(h)){const _=h.split("<=");return t.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(h)){const _=h.split("<");return r.create(_[0].trim(),_[1].trim())}return/^\!\s*/.test(h)?D.create(h.substr(1).trim()):b.create(h)}static _deserializeValue(h,P){if(h=h.trim(),h==="true")return!0;if(h==="false")return!1;let _=/^'([^']*)'$/.exec(h);return _?_[1].trim():h}static _deserializeRegexValue(h,P){if((0,p.isFalsyOrWhitespace)(h)){if(P)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let _=h.indexOf("/"),j=h.lastIndexOf("/");if(_===j||_<0){if(P)throw new Error(`bad regexp-value '${h}', missing /-enclosure`);return console.warn(`bad regexp-value '${h}', missing /-enclosure`),null}let q=h.slice(_+1,j),G=h[j+1]==="i"?"i":"";try{return new RegExp(q,G)}catch(M){if(P)throw new Error(`bad regexp-value '${h}', parse error: ${M}`);return console.warn(`bad regexp-value '${h}', parse error: ${M}`),null}}}e.ContextKeyExpr=m;function T(w,h){return w.cmp(h)}class y{constructor(){this.type=0}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}evaluate(h){return!1}serialize(){return"false"}keys(){return[]}map(h){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=y,y.INSTANCE=new y;class v{constructor(){this.type=1}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}evaluate(h){return!0}serialize(){return"true"}keys(){return[]}map(h){return this}negate(){return y.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class b{constructor(h){this.key=h,this.type=2}static create(h){const P=U.get(h);return typeof P=="boolean"?P?v.INSTANCE:y.INSTANCE:new b(h)}cmp(h){return h.type!==this.type?this.type-h.type:l(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}evaluate(h){return!!h.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(h){return h.mapDefined(this.key)}negate(){return D.create(this.key)}}e.ContextKeyDefinedExpr=b;class u{constructor(h,P){this.key=h,this.value=P,this.type=4}static create(h,P){if(typeof P=="boolean")return P?b.create(h):D.create(h);const _=U.get(h);return typeof _=="boolean"?P===(_?"true":"false")?v.INSTANCE:y.INSTANCE:new u(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return h.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(h){return h.mapEquals(this.key,this.value)}negate(){return E.create(this.key,this.value)}}e.ContextKeyEqualsExpr=u;class S{constructor(h,P){this.key=h,this.valueKey=P,this.type=10}static create(h,P){return new S(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.valueKey,h.key,h.valueKey)}equals(h){return h.type===this.type?this.key===h.key&&this.valueKey===h.valueKey:!1}evaluate(h){const P=h.getValue(this.valueKey),_=h.getValue(this.key);return Array.isArray(P)?P.indexOf(_)>=0:typeof _=="string"&&typeof P=="object"&&P!==null?O.call(P,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(h){return h.mapIn(this.key,this.valueKey)}negate(){return C.create(this)}}e.ContextKeyInExpr=S;class C{constructor(h){this._actual=h,this.type=11}static create(h){return new C(h)}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}evaluate(h){return!this._actual.evaluate(h)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(h){return new C(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotInExpr=C;class E{constructor(h,P){this.key=h,this.value=P,this.type=5}static create(h,P){if(typeof P=="boolean")return P?D.create(h):b.create(h);const _=U.get(h);return typeof _=="boolean"?P===(_?"true":"false")?y.INSTANCE:v.INSTANCE:new E(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return h.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(h){return h.mapNotEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=E;class D{constructor(h){this.key=h,this.type=3}static create(h){const P=U.get(h);return typeof P=="boolean"?P?y.INSTANCE:v.INSTANCE:new D(h)}cmp(h){return h.type!==this.type?this.type-h.type:l(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}evaluate(h){return!h.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(h){return h.mapNot(this.key)}negate(){return b.create(this.key)}}e.ContextKeyNotExpr=D;class f{constructor(h,P){this.key=h,this.value=P,this.type=12}static create(h,P){return new f(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=f;class s{constructor(h,P){this.key=h,this.value=P,this.type=13}static create(h,P){return new s(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreaterEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=s;class r{constructor(h,P){this.key=h,this.value=P,this.type=14}static create(h,P){return new r(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmaller(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeySmallerExpr=r;class t{constructor(h,P){this.key=h,this.value=P,this.type=15}static create(h,P){return new t(h,P)}cmp(h){return h.type!==this.type?this.type-h.type:d(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmallerEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(h,P){this.key=h,this.regexp=P,this.type=7}static create(h,P){return new i(h,P)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.key<h.key)return-1;if(this.key>h.key)return 1;const P=this.regexp?this.regexp.source:"",_=h.regexp?h.regexp.source:"";return P<_?-1:P>_?1:0}equals(h){if(h.type===this.type){const P=this.regexp?this.regexp.source:"",_=h.regexp?h.regexp.source:"";return this.key===h.key&&P===_}return!1}evaluate(h){let P=h.getValue(this.key);return this.regexp?this.regexp.test(P):!1}serialize(){const h=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${h}`}keys(){return[this.key]}map(h){return h.mapRegex(this.key,this.regexp)}negate(){return n.create(this)}}e.ContextKeyRegexExpr=i;class n{constructor(h){this._actual=h,this.type=8}static create(h){return new n(h)}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}evaluate(h){return!this._actual.evaluate(h)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(h){return new n(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;class o{constructor(h){this.expr=h,this.type=6}static create(h){return o._normalizeArr(h)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let P=0,_=this.expr.length;P<_;P++){const j=T(this.expr[P],h.expr[P]);if(j!==0)return j}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].equals(h.expr[P]))return!1;return!0}return!1}evaluate(h){for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].evaluate(h))return!1;return!0}static _normalizeArr(h){const P=[];let _=!1;for(const j of h)if(!!j){if(j.type===1){_=!0;continue}if(j.type===0)return y.INSTANCE;if(j.type===6){P.push(...j.expr);continue}P.push(j)}if(P.length===0&&_)return v.INSTANCE;if(P.length!==0){if(P.length===1)return P[0];for(P.sort(T);P.length>1;){const j=P[P.length-1];if(j.type!==9)break;P.pop();const q=P.pop(),G=a.create(j.expr.map(M=>o.create([M,q])));G&&(P.push(G),P.sort(T))}return P.length===1?P[0]:new o(P)}}serialize(){return this.expr.map(h=>h.serialize()).join(" && ")}keys(){const h=[];for(let P of this.expr)h.push(...P.keys());return h}map(h){return new o(this.expr.map(P=>P.map(h)))}negate(){let h=[];for(let P of this.expr)h.push(P.negate());return a.create(h)}}e.ContextKeyAndExpr=o;class a{constructor(h){this.expr=h,this.type=9}static create(h){const P=a._normalizeArr(h);if(P.length!==0)return P.length===1?P[0]:new a(P)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let P=0,_=this.expr.length;P<_;P++){const j=T(this.expr[P],h.expr[P]);if(j!==0)return j}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let P=0,_=this.expr.length;P<_;P++)if(!this.expr[P].equals(h.expr[P]))return!1;return!0}return!1}evaluate(h){for(let P=0,_=this.expr.length;P<_;P++)if(this.expr[P].evaluate(h))return!0;return!1}static _normalizeArr(h){let P=[],_=!1;if(h){for(let j=0,q=h.length;j<q;j++){const G=h[j];if(!!G){if(G.type===0){_=!0;continue}if(G.type===1)return[v.INSTANCE];if(G.type===9){P=P.concat(G.expr);continue}P.push(G)}}if(P.length===0&&_)return[y.INSTANCE];P.sort(T)}return P}serialize(){return this.expr.map(h=>h.serialize()).join(" || ")}keys(){const h=[];for(let P of this.expr)h.push(...P.keys());return h}map(h){return new a(this.expr.map(P=>P.map(h)))}negate(){let h=[];for(let _ of this.expr)h.push(_.negate());const P=_=>_.type===9?_.expr:[_];for(;h.length>1;){const _=h.shift(),j=h.shift(),q=[];for(const G of P(_))for(const M of P(j))q.push(m.and(G,M));h.unshift(m.or(...q))}return h[0]}}e.ContextKeyOrExpr=a;class c extends b{constructor(h,P,_){super(h);this._defaultValue=P,typeof _=="object"?c._info.push(Object.assign(Object.assign({},_),{key:h})):_!==!0&&c._info.push({key:h,description:_,type:P!=null?typeof P:void 0})}static all(){return c._info.values()}bindTo(h){return h.createKey(this.key,this._defaultValue)}getValue(h){return h.getContextKeyValue(this.key)}toNegated(){return m.not(this.key)}isEqualTo(h){return m.equals(this.key,h)}notEqualsTo(h){return m.notEquals(this.key,h)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function l(w,h){return w<h?-1:w>h?1:0}function d(w,h,P,_){return w<P?-1:w>P?1:h<_?-1:h>_?1:0}}),define(Z[70],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function k(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=k}),define(Z[71],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,p.createDecorator)("downloadService")}),define(Z[9],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)});var Y=this&&this.__param||function(K,e){return function(p,k){e(p,k,K)}};define(Z[140],ee([0,1,9,8,24,11,2,6]),function(K,e,p,k,A,R,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let g=class extends U.Disposable{constructor(T){super();this.environmentService=T,this.cleanUpOldLogsSoon()}cleanUpOldLogsSoon(){let T=setTimeout(()=>{T=void 0;const y=(0,k.basename)(this.environmentService.logsPath),v=(0,k.dirname)(this.environmentService.logsPath);(0,A.readdir)(v).then(b=>{const S=b.filter(E=>/^\d{8}T\d{6}$/.test(E)).sort().filter((E,D)=>E!==y),C=S.slice(0,Math.max(0,S.length-9));return O.Promises.settled(C.map(E=>(0,A.rimraf)((0,k.join)(v,E))))}).then(null,R.onUnexpectedError)},10*1e3);this._register((0,U.toDisposable)(()=>{T&&(clearTimeout(T),T=void 0)}))}};g=fe([Y(0,p.IEnvironmentService)],g),e.LogsDataCleaner=g}),define(Z[141],ee([0,1,27,9,8,24,11,2]),function(K,e,p,k,A,R,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let g=class ct extends O.Disposable{constructor(T,y){super();this.backupWorkspacesPath=T,this.environmentService=y,this.cleanUpStorageSoon()}cleanUpStorageSoon(){let T=setTimeout(()=>{T=void 0,(async()=>{try{const y=await p.promises.readFile(this.backupWorkspacesPath,"utf8"),b=JSON.parse(y).emptyWorkspaceInfos.map(C=>C.backupFolder),u=await(0,R.readdir)(this.environmentService.workspaceStorageHome.fsPath),S=[];u.forEach(C=>{C.length!==ct.NON_EMPTY_WORKSPACE_ID_LENGTH&&b.indexOf(C)===-1&&S.push((0,R.rimraf)((0,A.join)(this.environmentService.workspaceStorageHome.fsPath,C)))}),await Promise.all(S)}catch(y){(0,U.onUnexpectedError)(y)}})()},30*1e3);this._register((0,O.toDisposable)(()=>{T&&(clearTimeout(T),T=void 0)}))}};g.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,g=fe([Y(1,k.INativeEnvironmentService)],g),e.StorageDataCleaner=g}),define(Z[29],ee([0,1,107,5,16]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function R(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=R;var U;(function(y){y[y.NoneOrRelevance=0]="NoneOrRelevance",y[y.LastUpdatedDate=1]="LastUpdatedDate",y[y.Title=2]="Title",y[y.PublisherName=3]="PublisherName",y[y.InstallCount=4]="InstallCount",y[y.PublishedDate=5]="PublishedDate",y[y.AverageRating=6]="AverageRating",y[y.WeightedRating=12]="WeightedRating"})(U=e.SortBy||(e.SortBy={}));var O;(function(y){y[y.Default=0]="Default",y[y.Ascending=1]="Ascending",y[y.Descending=2]="Descending"})(O=e.SortOrder||(e.SortOrder={}));var g;(function(y){y.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var m;(function(y){y[y.None=0]="None",y[y.Install=1]="Install",y[y.Update=2]="Update"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class T extends Error{constructor(v,b){super(v);this.code=b}}e.ExtensionManagementError=T,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=A.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,p.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,p.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(Z[142],ee([0,1,2,29]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let A=class extends p.Disposable{constructor(U){super();this.extensionManagementService=U,this._register(U),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};A=fe([Y(0,k.IExtensionManagementService)],A),e.DeprecatedExtensionsCleaner=A}),define(Z[72],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var k;(function(U){U[U.FILE=1]="FILE",U[U.WORKSPACE=2]="WORKSPACE",U[U.EXE=3]="EXE"})(k=e.RecommendationSource||(e.RecommendationSource={}));function A(U){switch(U){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=A;var R;(function(U){U.Ignored="ignored",U.Cancelled="cancelled",U.TooMany="toomany",U.IncompatibleWindow="incompatibleWindow",U.Accepted="reacted"})(R=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,p.createDecorator)("IExtensionRecommendationNotificationService")}),define(Z[73],ee([0,1,21,5]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class U{constructor(T){this.value=T,this._lower=T.toLowerCase()}static equals(T,y){if(typeof T=="undefined"||T===null)return typeof y=="undefined"||y===null;if(typeof y=="undefined"||y===null)return!1;if(typeof T=="string"||typeof y=="string"){let v=typeof T=="string"?T:T.value,b=typeof y=="string"?y:y.value;return p.equalsIgnoreCase(v,b)}return T._lower===y._lower}static toKey(T){return typeof T=="string"?T.toLowerCase():T._lower}}e.ExtensionIdentifier=U;function O(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=O;function g(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=g,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[33],ee([0,1,21,73]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(b,u){return b.uuid&&u.uuid?b.uuid===u.uuid:b.id===u.id?!0:(0,p.compareIgnoreCase)(b.id,u.id)===0}e.areSameExtensions=A;class R{constructor(u,S){this.version=S,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof R?A(this,u)&&this.version===u.version:!1}}e.ExtensionIdentifierWithVersion=R;function U(b,u){return`${b}.${u}`}e.getExtensionId=U;function O(b){return b.toLocaleLowerCase()}e.adoptToGalleryExtensionId=O;function g(b,u){return O(U(b,u))}e.getGalleryExtensionId=g;function m(b,u){const S=[],C=E=>{for(const D of S)if(D.some(f=>A(u(f),u(E))))return D;return null};for(const E of b){const D=C(E);D?D.push(E):S.push([E])}return S}e.groupByExtension=m;function T(b){return{id:b.identifier.id,name:b.manifest.name,galleryId:null,publisherId:b.publisherId,publisherName:b.manifest.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:b.manifest.extensionDependencies&&b.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=T;function y(b){return Object.assign({id:b.identifier.id,name:b.name,galleryId:b.identifier.uuid,publisherId:b.publisherId,publisherName:b.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:!!(b.properties.dependencies&&b.properties.dependencies.length>0)},b.telemetryData)}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function v(b){const u=new Set;for(const S of b)S.malicious&&u.add(S.id.id);return u}e.getMaliciousExtensionsSet=v}),define(Z[143],ee([0,1,2,8,73,24]),function(K,e,p,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class U extends p.Disposable{constructor(g,m){super();this.environmentService=g,this.extensionsManifestCache=(0,k.join)(this.environmentService.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this._register(m.onDidInstallExtension(T=>this.onDidInstallExtension(T))),this._register(m.onDidUninstallExtension(T=>this.onDidUnInstallExtension(T)))}onDidInstallExtension(g){g.error||this.invalidate()}onDidUnInstallExtension(g){g.error||this.invalidate()}invalidate(){R.rimraf(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=U}),define(Z[10],ee([0,1,114,8,4,5,21,15,37]),function(K,e,p,k,A,R,U,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,R.createDecorator)("fileService");function m(M){return M.create===!0}e.isFileOpenForWriteOptions=m;var T;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var y;(function(M){M[M.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var v;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(v=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=b;function u(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=u;function S(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=S;function C(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=C;var E;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class D extends Error{constructor(z,$){super(z);this.code=$}}e.FileSystemProviderError=D;function f(M,z){const $=new D(M.toString(),z);return r($,z),$}e.createFileSystemProviderError=f;function s(M){return M||f((0,p.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=s;function r(M,z){return M.name=z?`${z} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=r;function t(M){if(!M)return E.Unknown;if(M instanceof D)return M.code;const z=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!z)return E.Unknown;switch(z[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=t;function i(M){if(M instanceof d)return M.fileOperationResult;switch(t(M)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var n;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class o{constructor(z,$,V){this.resource=z,this.operation=$,this.target=V}isOperation(z){return this.operation===z}}e.FileOperationEvent=o;var a;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class c{constructor(z,$){this.ignorePathCasing=$,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=z;for(const V of z)switch(V.type){case 1:this.added||(this.added=g.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(V.resource,V);break;case 0:this.updated||(this.updated=g.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(V.resource,V);break;case 2:this.deleted||(this.deleted=g.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(V.resource,V);break}}contains(z,...$){return this.doContains(z,{includeChildren:!1},...$)}affects(z,...$){return this.doContains(z,{includeChildren:!0},...$)}doContains(z,$,...V){var H,L,I,F,N,W;if(!z)return!1;const x=V.length>0;return!!((!x||V.includes(1))&&(((H=this.added)===null||H===void 0?void 0:H.get(z))||$.includeChildren&&((L=this.added)===null||L===void 0?void 0:L.findSuperstr(z)))||(!x||V.includes(0))&&(((I=this.updated)===null||I===void 0?void 0:I.get(z))||$.includeChildren&&((F=this.updated)===null||F===void 0?void 0:F.findSuperstr(z)))||(!x||V.includes(2))&&(((N=this.deleted)===null||N===void 0?void 0:N.findSubstr(z))||$.includeChildren&&((W=this.deleted)===null||W===void 0?void 0:W.findSuperstr(z))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(z){const $=[],V=z===1?this.added:z===0?this.updated:this.deleted;if(V)for(const[,H]of V)$.push(H);return $}filter(z){return new c(this.changes.filter($=>z($)),this.ignorePathCasing)}}e.FileChangesEvent=c;function l(M,z,$){return!M||!z||M===z||z.length>M.length?!1:(z.charAt(z.length-1)!==k.sep&&(z+=k.sep),$?(0,U.startsWithIgnoreCase)(M,z):M.indexOf(z)===0)}e.isParent=l;class d extends Error{constructor(z,$,V){super(z);this.fileOperationResult=$,this.options=V}static isFileOperationError(z){return z instanceof Error&&!(0,O.isUndefinedOrNull)(z.fileOperationResult)}}e.FileOperationError=d;var w;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(w=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var h;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(h=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function P(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=P;async function _(M,z){if(!z.canHandleResource(A.URI.from({scheme:M.scheme})))return new Promise($=>{const V=z.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===M.scheme&&H.added&&(V.dispose(),$())})})}e.whenProviderRegistered=_,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class j{static formatSize(z){return(0,O.isNumber)(z)||(z=0),z<j.KB?(0,p.localize)(1,null,z.toFixed(0)):z<j.MB?(0,p.localize)(2,null,(z/j.KB).toFixed(2)):z<j.GB?(0,p.localize)(3,null,(z/j.MB).toFixed(2)):z<j.TB?(0,p.localize)(4,null,(z/j.GB).toFixed(2)):(0,p.localize)(5,null,(z/j.TB).toFixed(2))}}e.ByteSize=j,j.KB=1024,j.MB=j.KB*j.KB,j.GB=j.MB*j.KB,j.TB=j.GB*j.KB;var q;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function G(M){return{maxFileSize:M===0?300*j.MB:16*j.GB,maxHeapSize:M===0?700*j.MB:2*700*j.MB}}e.getPlatformLimits=G}),define(Z[144],ee([0,1,145,47,10]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let R=class{constructor(O){this.fileService=O}checksum(O){return new Promise(async(g,m)=>{const T=(0,p.createHash)("md5"),y=(await this.fileService.readFileStream(O)).value;(0,k.listenStream)(y,{onData:v=>T.update(v.buffer),onError:v=>m(v),onEnd:()=>g(T.digest("base64").replace(/=+$/,""))})})}};R=fe([Y(0,A.IFileService)],R),e.ChecksumService=R}),define(Z[74],ee([0,1,4,10,7]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function R(g){return g.map(m=>({type:m.type,resource:p.URI.file(m.path)}))}e.toFileChanges=R;function U(g){const m=new O;for(const T of g)m.processEvent(T);return m.normalize()}e.normalizeFileChanges=U;class O{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(m){const T=this.mapPathToChange.get(m.path);if(T){const y=T.type,v=m.type;y===1&&v===2?(this.mapPathToChange.delete(m.path),this.normalized.splice(this.normalized.indexOf(T),1)):y===2&&v===1?T.type=0:y===1&&v===0||(T.type=v)}else this.normalized.push(m),this.mapPathToChange.set(m.path,m)}normalize(){const m=[],T=[];return this.normalized.filter(y=>y.type!==2?(m.push(y),!1):!0).sort((y,v)=>y.path.length-v.path.length).filter(y=>T.some(v=>(0,k.isParent)(y.path,v,!A.isLinux))?!1:(T.push(y.path),!0)).concat(m)}}}),define(Z[146],ee([0,1,74,2,24,93,96,6,8]),function(K,e,p,k,A,R,U,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class m extends k.Disposable{constructor(y,v,b,u){super();this.path=y,this.onDidFilesChange=v,this.onLogMessage=b,this.verboseLogging=u,this.fileChangesDelayer=this._register(new O.ThrottledDelayer(U.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(y){this.verboseLogging=y}async startWatching(){try{const{stat:y,symbolicLink:v}=await A.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let b=this.path;if(v)try{b=await(0,R.realpath)(b)}catch(u){if(this.onError(u),v.dangling)return}y.isDirectory()?this._register((0,U.watchFolder)(b,(u,S)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,g.join)(this.path,(0,g.basename)(S))})},u=>this.onError(u))):this._register((0,U.watchFile)(b,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(y){y.code!=="ENOENT"&&this.onError(y)}}onFileChange(y){this.fileChangesBuffer.push(y),this.verboseLogging&&this.onVerbose(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),this.fileChangesDelayer.trigger(async()=>{const v=this.fileChangesBuffer;this.fileChangesBuffer=[];const b=(0,p.normalizeFileChanges)(v);this.verboseLogging&&b.forEach(u=>{this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`)}),b.length>0&&this.onDidFilesChange(b)})}onError(y){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${y}`})}onVerbose(y){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=m}),define(Z[75],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...A){this._entries=new Map;for(let[R,U]of A)this.set(R,U)}set(A,R){const U=this._entries.get(A);return this._entries.set(A,R),U}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=p}),define(Z[147],ee([0,1,11,137,50,5,75,6]),function(K,e,p,k,A,R,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const g=!1;class m extends Error{constructor(u){var S;super("cyclic dependency between services");this.message=(S=u.findCycleSlow())!==null&&S!==void 0?S:`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class T{constructor(u=new U.ServiceCollection,S=!1,C){this._activeInstantiations=new Set,this._services=u,this._strict=S,this._parent=C,this._services.set(R.IInstantiationService,this)}createChild(u){return new T(u,this._strict,this)}invokeFunction(u,...S){let C=v.traceInvocation(u),E=!1;try{return u({get:(f,s)=>{if(E)throw(0,p.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(f,C);if(!r&&s!==R.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return r}},...S)}finally{E=!0,C.stop()}}createInstance(u,...S){let C,E;return u instanceof A.SyncDescriptor?(C=v.traceCreation(u.ctor),E=this._createInstance(u.ctor,u.staticArguments.concat(S),C)):(C=v.traceCreation(u),E=this._createInstance(u,S,C)),C.stop(),E}_createInstance(u,S=[],C){let E=R._util.getServiceDependencies(u).sort((s,r)=>s.index-r.index),D=[];for(const s of E){let r=this._getOrCreateServiceInstance(s.id,C);if(!r&&this._strict&&!s.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${s.id}.`);D.push(r)}let f=E.length>0?E[0].index:S.length;if(S.length!==f){console.warn(`[createInstance] First service dependency of ${u.name} at position ${f+1} conflicts with ${S.length} static arguments`);let s=f-S.length;s>0?S=S.concat(new Array(s)):S=S.slice(0,f)}return new u(...[...S,...D])}_setServiceInstance(u,S){if(this._services.get(u)instanceof A.SyncDescriptor)this._services.set(u,S);else if(this._parent)this._parent._setServiceInstance(u,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let S=this._services.get(u);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):S}_getOrCreateServiceInstance(u,S){let C=this._getServiceInstanceOrDescriptor(u);return C instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,C,S.branch(u,!0)):(S.branch(u,!1),C)}_safeCreateAndCacheServiceInstance(u,S,C){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,S,C)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,S,C){const E=new k.Graph(s=>s.id.toString());let D=0;const f=[{id:u,desc:S,_trace:C}];for(;f.length;){const s=f.pop();if(E.lookupOrInsertNode(s),D++>1e3)throw new m(E);for(let r of R._util.getServiceDependencies(s.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(r.id);if(!t&&!r.optional&&console.warn(`[createInstance] ${u} depends on ${r.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const i={id:r.id,desc:t,_trace:s._trace.branch(r.id,!0)};E.insertEdge(s,i),f.push(i)}}}for(;;){const s=E.roots();if(s.length===0){if(!E.isEmpty())throw new m(E);break}for(const{data:r}of s){if(this._getServiceInstanceOrDescriptor(r.id)instanceof A.SyncDescriptor){const i=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,i)}E.removeNode(r)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,S,C=[],E,D){if(this._services.get(u)instanceof A.SyncDescriptor)return this._createServiceInstance(S,C,E,D);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,S,C,E,D);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(u,S=[],C,E){if(C){const D=new O.IdleValue(()=>this._createInstance(u,S,E));return new Proxy(Object.create(null),{get(f,s){if(s in f)return f[s];let r=D.value,t=r[s];return typeof t!="function"||(t=t.bind(r),f[s]=t),t},set(f,s,r){return D.value[s]=r,!0}})}else return this._createInstance(u,S,E)}}e.InstantiationService=T;var y;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(y||(y={}));class v{constructor(u,S){this.type=u,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return g?new v(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(u){return g?new v(0,u.name):v._None}branch(u,S){let C=new v(2,u.toString());return this._dep.push([u,S,C]),C}stop(){let u=Date.now()-this._start;v._totals+=u;let S=!1;function C(D,f){let s=[],r=new Array(D+1).join("	");for(const[t,i,n]of f._dep)if(i&&n){S=!0,s.push(`${r}CREATES -> ${t}`);let o=C(D+1,n);o&&s.push(o)}else s.push(`${r}uses -> ${t}`);return s.join(`
`)}let E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${C(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(u>2||S)&&console.log(E.join(`
`))}}v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(Z[148],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class p{constructor(A,R){this.server=A,this.router=R}getChannel(A){return this.server.getChannel(A,this.router)}registerChannel(A,R){this.server.registerChannel(A,R)}}e.MessagePortMainProcessService=p}),define(Z[149],ee([0,1,34,50,136,5]),function(K,e,p,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class U{constructor(b,u,S){const C=S.getChannel(b);return O(u)?new u.channelClientCtor(C):p.ProxyChannel.toService(C,u==null?void 0:u.proxyOptions)}}function O(v){const b=v;return!!(b==null?void 0:b.channelClientCtor)}e.IMainProcessService=(0,R.createDecorator)("mainProcessService");let g=class extends U{constructor(b,u,S){super(b,u,S)}};g=fe([Y(2,e.IMainProcessService)],g);function m(v,b,u){(0,A.registerSingleton)(v,new k.SyncDescriptor(g,[b,u],u==null?void 0:u.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=m,e.ISharedProcessService=(0,R.createDecorator)("sharedProcessService");let T=class extends U{constructor(b,u,S){super(b,u,S)}};T=fe([Y(2,e.ISharedProcessService)],T);function y(v,b,u){(0,A.registerSingleton)(v,new k.SyncDescriptor(T,[b,u],u==null?void 0:u.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=y}),define(Z[55],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,p.createDecorator)("localizationsService");function k(A){if(typeof A.languageId!="string"||!Array.isArray(A.translations)||A.translations.length===0)return!1;for(const R of A.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(A.languageName&&typeof A.languageName!="string"||A.localizedLanguageName&&typeof A.localizedLanguageName!="string")}e.isValidLocalization=k}),define(Z[150],ee([0,1,2,55]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let A=class extends p.Disposable{constructor(U){super();this.localizationsService=U,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};A=fe([Y(0,k.ILocalizationsService)],A),e.LocalizationsUpdater=A}),define(Z[17],ee([0,1,5,2,7,3,43]),function(K,e,p,k,A,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,p.createDecorator)("logService"),e.ILoggerService=(0,p.createDecorator)("loggerService");function O(){return new Date().toISOString()}var g;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(g=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=g.Info;class m extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=m;class T extends m{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(g.Trace)&&this.log(g.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(g.Debug)&&this.log(g.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(g.Info)&&this.log(g.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(g.Warning)&&this.log(g.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(g.Error))if(t instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=t.stack,this.log(g.Error,this.format(n))}else this.log(g.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(g.Critical)&&this.log(g.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let n=0;n<t.length;n++){let o=t[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch(a){}i+=(n>0?" ":"")+o}return i}}e.AbstractMessageLogger=T;class y extends m{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...i){this.getLevel()<=g.Trace&&(this.useColors?console.log(`[90m[main ${O()}][0m`,t,...i):console.log(`[main ${O()}]`,t,...i))}debug(t,...i){this.getLevel()<=g.Debug&&(this.useColors?console.log(`[90m[main ${O()}][0m`,t,...i):console.log(`[main ${O()}]`,t,...i))}info(t,...i){this.getLevel()<=g.Info&&(this.useColors?console.log(`[90m[main ${O()}][0m`,t,...i):console.log(`[main ${O()}]`,t,...i))}warn(t,...i){this.getLevel()<=g.Warning&&(this.useColors?console.warn(`[93m[main ${O()}][0m`,t,...i):console.warn(`[main ${O()}]`,t,...i))}error(t,...i){this.getLevel()<=g.Error&&(this.useColors?console.error(`[91m[main ${O()}][0m`,t,...i):console.error(`[main ${O()}]`,t,...i))}critical(t,...i){this.getLevel()<=g.Critical&&(this.useColors?console.error(`[90m[main ${O()}][0m`,t,...i):console.error(`[main ${O()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class v extends m{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=g.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=g.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=g.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=g.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=g.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=g.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=v;class b extends m{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=g.Trace&&this.adapter.log(g.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=g.Debug&&this.adapter.log(g.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=g.Info&&this.adapter.log(g.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=g.Warning&&this.adapter.log(g.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=g.Error&&this.adapter.log(g.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=g.Critical&&this.adapter.log(g.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,U.toErrorMessage)(t,this.getLevel()<=g.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class u extends m{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const n of this.logServices)n.trace(t,...i)}debug(t,...i){for(const n of this.logServices)n.debug(t,...i)}info(t,...i){for(const n of this.logServices)n.info(t,...i)}warn(t,...i){for(const n of this.logServices)n.warn(t,...i)}error(t,...i){for(const n of this.logServices)n.error(t,...i)}critical(t,...i){for(const n of this.logServices)n.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=u;class S extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=S;class C extends k.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(n))}))}createLogger(t,i){let n=this.loggers.get(t.toString());return n||(n=this.doCreateLogger(t,(i==null?void 0:i.always)?g.Trace:this.logLevel,i),this.loggers.set(t.toString(),n),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=C;class E{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(t){}getLevel(){return g.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=E;function D(r){if(r.verbose)return g.Trace;if(typeof r.logLevel=="string"){const t=f(r.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=D;function f(r){switch(r){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Critical;case"off":return g.Off}}e.parseLogLevel=f;function s(r){switch(r){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Critical:return"critical";case g.Off:return"off"}}e.LogLevelToString=s}),define(Z[151],ee([0,1,27,2,10,29,9,4,12,33,17,31,56,7,6,11]),function(K,e,p,k,A,R,U,O,g,m,T,y,v,b,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let E=class extends k.Disposable{constructor(f,s,r,t){super();this.fileService=s,this.extensionGalleryService=r,this.logService=t,this.extensionsDownloadDir=O.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,s){await this.cleanUpPromise;const r=this.getName(f),t=(0,g.joinPath)(this.extensionsDownloadDir,r);if(!await this.fileService.exists(t)){const i=(0,g.joinPath)(this.extensionsDownloadDir,`.${(0,y.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(f,i,s);try{await this.rename(i,t,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(o){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,S.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return t}async delete(f){}async rename(f,s,r){try{await p.promises.rename(f.fsPath,s.fsPath)}catch(t){if(b.isWindows&&t&&t.code==="EPERM"&&Date.now()<r)return this.logService.info(`Failed renaming ${f} to ${s} with 'EPERM' error. Trying again...`),this.rename(f,s,r);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const s=[],r=[];for(const n of f.children){const o=this.parse(n.name);o&&r.push([o,n])}const t=(0,m.groupByExtension)(r,([n])=>n),i=[];for(const n of t)n.sort((o,a)=>v.rcompare(o[0].version,a[0].version)),s.push(...n.slice(1).map(o=>o[1].resource)),i.push(n[0][1]);i.sort((n,o)=>n.mtime-o.mtime),s.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await u.Promises.settled(s.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?new m.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase():(0,y.generateUuid)()}parse(f){const s=C.exec(f);return s&&s[1]&&s[2]?new m.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};E=fe([Y(0,U.INativeEnvironmentService),Y(1,A.IFileService),Y(2,R.IExtensionGalleryService),Y(3,T.ILogService)],E),e.ExtensionsDownloader=E}),define(Z[152],ee([0,1,2,17,48,43,8,6,3,16,24,9]),function(K,e,p,k,A,R,U,O,g,m,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=class extends p.Disposable{constructor(u,S){super();this.environmentService=u,this.logService=S,this.processesLimiter=new O.Limiter(5)}async postUninstall(u){const S=this.parseScript(u,"uninstall");return S&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),C=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${C}`)))),(0,T.rimraf)(this.getExtensionStoragePath(u)).then(void 0,C=>this.logService.error("Error while removing extension storage path",C))}parseScript(u,S){const C=`vscode:${S}`;if(u.location.scheme===m.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[C]=="string"){const E=u.manifest.scripts[C].split(" ");return E.length<2||E[0]!=="node"||!E[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${C} should be a node script`),null):{script:(0,U.join)(u.location.fsPath,E[1]),args:E.slice(2)||[]}}return null}runLifecycleHook(u,S,C,E,D){return new Promise((f,s)=>{const r=this.start(u,S,C,D);let t;const i=n=>{t&&(clearTimeout(t),t=null),n?s(n):f(void 0)};r.on("error",n=>{i((0,R.toErrorMessage)(n)||"Unknown")}),r.on("exit",(n,o)=>{i(n?`post-${S} process exited with code ${n}`:void 0)}),E&&(t=setTimeout(()=>{t=null,r.kill(),s("timed out")},5e3))})}start(u,S,C,E){const D={silent:!0,execArgv:void 0},f=(0,A.fork)(u,[`--type=extension-post-${S}`,...C],D);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const s=g.Event.fromNodeEventEmitter(f.stdout,"data"),r=g.Event.fromNodeEventEmitter(f.stderr,"data");s(n=>this.logService.info(E.identifier.id,E.manifest.version,`post-${S}`,n)),r(n=>this.logService.error(E.identifier.id,E.manifest.version,`post-${S}`,n));const t=g.Event.any(g.Event.map(s,n=>({data:`%c${n}`,format:[""]})),g.Event.map(r,n=>({data:`%c${n}`,format:["color: red"]})));return g.Event.debounce(t,(n,o)=>n?{data:n.data+o.data,format:[...n.format,...o.format]}:{data:o.data,format:o.format},100)(n=>{console.group(E.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}getExtensionStoragePath(u){return(0,U.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};v=fe([Y(0,y.IEnvironmentService),Y(1,k.ILogService)],v),e.ExtensionsLifecycle=v}),define(Z[153],ee([0,1,2,9,3,10,4,33,12,17]),function(K,e,p,k,A,R,U,O,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let T=class extends p.Disposable{constructor(v,b,u,S){super();this.extensionsManagementService=v,this.logService=S,this._onDidChangeExtensionsByAnotherSource=this._register(new A.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(D=>{this.installedExtensions=D.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(v.onInstallExtension(D=>this.onInstallExtension(D))),this._register(v.onDidInstallExtension(D=>this.onDidInstallExtension(D))),this._register(v.onDidUninstallExtension(D=>this.onDidUninstallExtension(D)));const C=U.URI.file(u.extensionsPath),E=new g.ExtUri(D=>!b.hasCapability(D,1024));this._register(b.watch(C)),this._register(A.Event.filter(b.onDidFilesChange,D=>D.changes.some(f=>this.doesChangeAffects(f,C,E)))(()=>this.onDidChange()))}doesChangeAffects(v,b,u){return u.isEqual(u.dirname(v.resource),b)?u.isEqual(v.resource,u.joinPath(b,".obsolete"))?!0:!(v.type!==1&&v.type!==2||u.basename(v.resource).startsWith(".")):!1}onInstallExtension(v){this.addInstallingExtension(v.identifier)}onDidInstallExtension(v){this.removeInstallingExtension(v.identifier),v.error||this.addInstalledExtension(v.identifier)}onDidUninstallExtension(v){v.error||this.removeInstalledExtension(v.identifier)}addInstallingExtension(v){this.removeInstallingExtension(v),this.installingExtensions.push(v)}removeInstallingExtension(v){this.installingExtensions=this.installingExtensions.filter(b=>!(0,O.areSameExtensions)(b,v))}addInstalledExtension(v){this.installedExtensions&&(this.removeInstalledExtension(v),this.installedExtensions.push(v))}removeInstalledExtension(v){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(b=>!(0,O.areSameExtensions)(b,v)))}async onDidChange(){if(this.installedExtensions){const v=await this.extensionsManagementService.getInstalled(1),b=v.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(C=>(0,O.areSameExtensions)(C,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),u=this.installedExtensions.filter(S=>this.installingExtensions.some(C=>(0,O.areSameExtensions)(C,S))?!1:v.every(C=>!(0,O.areSameExtensions)(C.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=v.map(S=>S.identifier),(b.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:b,removed:u})}}};T=fe([Y(1,R.IFileService),Y(2,k.INativeEnvironmentService),Y(3,m.ILogService)],T),e.ExtensionsWatcher=T}),define(Z[154],ee([0,1,24,27,145,29,2,9,6,33,17,55,18,3,16,8]),function(K,e,p,k,A,R,U,O,g,m,T,y,v,b,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let C=class extends U.Disposable{constructor(f,s,r){super();this.extensionManagementService=f,this.logService=r,this._onDidLanguagesChange=this._register(new b.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new E(s,r)),this._register(f.onDidInstallExtension(({local:t})=>this.onDidInstallExtension(t))),this._register(f.onDidUninstallExtension(({identifier:t})=>this.onDidUninstallExtension(t)))}getLanguageIds(){return this.cache.getLanguagePacks().then(f=>{const s=["en",...Object.keys(f)];return(0,v.distinct)(s)})}onDidInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",f.identifier.id),this.update().then(s=>{s&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(f){this.cache.getLanguagePacks().then(s=>{Object.keys(s).some(r=>s[r]&&s[r].extensions.some(t=>(0,m.areSameExtensions)(t.extensionIdentifier,f)))&&(this.logService.debug("Removing language packs from the extension",f.id),this.update().then(r=>{r&&this._onDidLanguagesChange.fire()}))})}async update(){const[f,s]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),r=await this.cache.update(s);return!(0,v.equals)(Object.keys(f),Object.keys(r))}};C=fe([Y(0,R.IExtensionManagementService),Y(1,O.INativeEnvironmentService),Y(2,T.ILogService)],C),e.LocalizationsService=C;let E=class extends U.Disposable{constructor(f,s){super();this.logService=s,this.languagePacks={},this.languagePacksFilePath=(0,S.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new g.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(s=>{Object.keys(s).forEach(r=>delete s[r]),this.createLanguagePacksFromExtensions(s,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...s){for(const r of s)r&&r.manifest&&r.manifest.contributes&&r.manifest.contributes.localizations&&r.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,r);Object.keys(f).forEach(r=>this.updateHash(f[r]))}createLanguagePacksFromExtension(f,s){const r=s.identifier,t=s.manifest.contributes&&s.manifest.contributes.localizations?s.manifest.contributes.localizations:[];for(const i of t)if(s.location.scheme===u.Schemas.file&&(0,y.isValidLocalization)(i)){let n=f[i.languageId];n||(n={hash:"",extensions:[],translations:{}},f[i.languageId]=n);let o=n.extensions.filter(a=>(0,m.areSameExtensions)(a.extensionIdentifier,r))[0];o?o.version=s.manifest.version:n.extensions.push({extensionIdentifier:r,version:s.manifest.version});for(const a of i.translations)n.translations[a.id]=(0,S.join)(s.location.fsPath,a.path)}}updateHash(f){if(f){const s=(0,A.createHash)("md5");for(const r of f.extensions)s.update(r.extensionIdentifier.uuid||r.extensionIdentifier.id).update(r.version);f.hash=s.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let s=null;return k.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,r=>r.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(r)).then(r=>{try{return JSON.parse(r)}catch(t){return{}}}).then(r=>(s=f(r),r)).then(r=>{for(const i of Object.keys(r))r[i]||delete r[i];this.languagePacks=r,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),(0,p.writeFile)(this.languagePacksFilePath,t)}).then(()=>s,r=>this.logService.error(r))})}};E=fe([Y(0,O.INativeEnvironmentService),Y(1,T.ILogService)],E)}),define(Z[76],ee([0,1,17,3,4]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(v){this.service=v,this.onDidChangeLogLevel=k.Event.buffer(v.onDidChangeLogLevel,!0)}listen(v,b){switch(b){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${b}`)}async call(v,b,u){switch(b){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${b}`)}}e.LogLevelChannel=R;class U{constructor(v){this.channel=v}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(v){U.setLevel(this.channel,v)}static setLevel(v,b){return v.call("setLevel",b)}}e.LogLevelChannelClient=U;class O{constructor(v){this.loggerService=v,this.loggers=new Map}listen(v,b){throw new Error(`Event not found: ${b}`)}async call(v,b,u){switch(b){case"createLogger":this.createLogger(A.URI.revive(u[0]),u[1]);return;case"log":return this.log(A.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${b}`)}createLogger(v,b){this.loggers.set(v.toString(),this.loggerService.createLogger(v,b))}consoleLog(v,b){let u=console.log;switch(v){case p.LogLevel.Error:u=console.error;break;case p.LogLevel.Warning:u=console.warn;break;case p.LogLevel.Info:u=console.info;break}u.call(console,...b)}log(v,b){const u=this.loggers.get(v.toString());if(!u)throw new Error("Create the logger before logging");for(const[S,C]of b)switch(S){case p.LogLevel.Trace:u.trace(C);break;case p.LogLevel.Debug:u.debug(C);break;case p.LogLevel.Info:u.info(C);break;case p.LogLevel.Warning:u.warn(C);break;case p.LogLevel.Error:u.error(C);break;case p.LogLevel.Critical:u.critical(C);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=O;class g extends p.AbstractLoggerService{constructor(v,b,u){super(v,b);this.channel=u}createConsoleMainLogger(){return new p.AdapterLogger({log:(v,b)=>{this.channel.call("consoleLog",[v,b])}})}doCreateLogger(v,b,u){return new m(this.channel,v,b,u)}}e.LoggerChannelClient=g;class m extends p.AbstractMessageLogger{constructor(v,b,u,S){super(S==null?void 0:S.always);this.channel=v,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[b,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(v,b){const u=[[v,b]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(v){this.channel.call("log",[this.file,v])}}class T extends p.LogService{constructor(v,b){super(b);this.parent=v,this._register(v.onDidChangeLogLevel(u=>b.setLevel(u)))}setLevel(v){super.setLevel(v),this.parent.setLevel(v)}}e.FollowerLogService=T}),define(Z[57],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,p.createDecorator)("nativeHostService")}),define(Z[51],ee([0,1,16,7,36,12]),function(K,e,p,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let U;if(typeof k.globals.vscode!="undefined"&&typeof k.globals.vscode.context!="undefined"){const O=k.globals.vscode.context.configuration();if(O)U=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(K==null?void 0:K.__$__nodeRequire)=="function"){const O=(0,R.dirname)(p.FileAccess.asFileUri("",K));U=K.__$__nodeRequire((0,R.joinPath)(O,"product.json").fsPath);const g=K.__$__nodeRequire((0,R.joinPath)(O,"package.json").fsPath);A.env.VSCODE_DEV&&Object.assign(U,{nameShort:`${U.nameShort} Dev`,nameLong:`${U.nameLong} Dev`,dataFolderName:`${U.dataFolderName}-dev`}),Object.assign(U,{version:g.version})}else U={},Object.keys(U).length===0&&Object.assign(U,{version:"1.57.0-dev",nameShort:k.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:k.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=U}),define(Z[77],ee([0,1,115,23,10,11,51]),function(K,e,p,k,A,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function O(y,v,b,u,S,C){let E;try{await g(y,v,b,u,S,C)}catch(D){E=D}finally{E&&S.errorTransformer&&(E=S.errorTransformer(E)),typeof E!="undefined"&&b.error(E),b.end()}}e.readFileIntoStream=O;async function g(y,v,b,u,S,C){m(C);const E=await y.open(v,{create:!1});try{m(C);let D=0,f=0,s=S&&typeof S.length=="number"?S.length:void 0,r=k.VSBuffer.alloc(Math.min(S.bufferSize,typeof s=="number"?s:S.bufferSize)),t=S&&typeof S.position=="number"?S.position:0,i=0;do f=await y.read(E,t,r.buffer,i,r.byteLength-i),t+=f,i+=f,D+=f,typeof s=="number"&&(s-=f),i===r.byteLength&&(await b.write(u(r)),r=k.VSBuffer.alloc(Math.min(S.bufferSize,typeof s=="number"?s:S.bufferSize)),i=0);while(f>0&&(typeof s!="number"||s>0)&&m(C)&&T(D,S));if(i>0){let n=i;typeof s=="number"&&(n=Math.min(i,s)),b.write(u(r.slice(0,n)))}}catch(D){throw(0,A.ensureFileSystemProviderError)(D)}finally{await y.close(E)}}function m(y){if(y.isCancellationRequested)throw(0,R.canceled)();return!0}function T(y,v){if(v==null?void 0:v.limits){if(typeof v.limits.memory=="number"&&y>v.limits.memory)throw(0,A.createFileSystemProviderError)((0,p.localize)(0,null,U.default.nameShort),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof v.limits.size=="number"&&y>v.limits.size)throw(0,A.createFileSystemProviderError)((0,p.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[155],ee([0,1,113,156,2,10,3,12,37,18,17,23,47,6,30,16,77,53]),function(K,e,p,k,A,R,U,O,g,m,T,y,v,b,u,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let D=class extends A.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new U.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new U.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new U.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new U.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new U.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new U.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new b.ResourceQueue)}registerProvider(s,r){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,k.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:r});const t=new A.DisposableStore;return t.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new R.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),t.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:s}))),typeof r.onDidErrorOccur=="function"&&t.add(r.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,A.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:r}),this.provider.delete(s),(0,A.dispose)(t)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(t){r.push(t)}}),!this.provider.has(s)&&await b.Promises.settled(r)}canHandleResource(s){return this.provider.has(s.scheme)}hasCapability(s,r){const t=this.provider.get(s.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return E.Iterable.map(this.provider,([s,r])=>({scheme:s,capabilities:r.capabilities}))}async withProvider(s){if(!(0,O.isAbsolutePath)(s))throw new R.FileOperationError((0,p.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const r=this.provider.get(s.scheme);if(!r){const t=new Error;throw t.name="ENOPRO",t.message=(0,p.localize)(1,null,s.toString()),t}return r}async withReadProvider(s){const r=await this.withProvider(s);if((0,R.hasOpenReadWriteCloseCapability)(r)||(0,R.hasReadWriteCapability)(r)||(0,R.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const r=await this.withProvider(s);if((0,R.hasOpenReadWriteCloseCapability)(r)||(0,R.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,r){try{return await this.doResolveFile(s,r)}catch(t){throw(0,R.toFileSystemProviderErrorCode)(t)===R.FileSystemProviderErrorCode.FileNotFound?new R.FileOperationError((0,p.localize)(2,null,this.resourceForError(s)),1):(0,R.ensureFileSystemProviderError)(t)}}async doResolveFile(s,r){const t=await this.withProvider(s),i=this.isPathCaseSensitive(t),n=r==null?void 0:r.resolveTo,o=r==null?void 0:r.resolveSingleChildDescendants,a=r==null?void 0:r.resolveMetadata,c=await t.stat(s);let l;return this.toFileStat(t,s,c,void 0,!!a,(d,w)=>(l||(l=g.TernarySearchTree.forUris(()=>!i),l.set(s,!0),(0,m.isNonEmptyArray)(n)&&n.forEach(h=>l.set(h,!0))),Boolean(l.findSuperstr(d.resource)||l.get(d.resource))?!0:d.isDirectory&&o?w===1:!1))}async toFileStat(s,r,t,i,n,o){var a,c;const{providerExtUri:l}=this.getExtUri(s),d={resource:r,name:l.basename(r),isFile:(t.type&R.FileType.File)!=0,isDirectory:(t.type&R.FileType.Directory)!=0,isSymbolicLink:(t.type&R.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:(c=Boolean((a=t.permissions)!==null&&a!==void 0?a:0&R.FilePermission.Readonly))!==null&&c!==void 0?c:Boolean(s.capabilities&2048),etag:(0,R.etag)({mtime:t.mtime,size:t.size})};if(d.isDirectory&&o(d,i)){try{const w=await s.readdir(r),h=await b.Promises.settled(w.map(async([P,_])=>{try{const j=l.joinPath(r,P),q=n?await s.stat(j):{type:_};return await this.toFileStat(s,j,q,w.length,n,o)}catch(j){return this.logService.trace(j),null}}));d.children=(0,m.coalesce)(h)}catch(w){this.logService.trace(w),d.children=[]}return d}return d}async resolveAll(s){return b.Promises.settled(s.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(s){const r=await this.withProvider(s);try{return!!await r.stat(s)}catch(t){return!1}}async canCreateFile(s,r){try{await this.doValidateCreateFile(s,r)}catch(t){return t}return!0}async doValidateCreateFile(s,r){if(!(r==null?void 0:r.overwrite)&&await this.exists(s))throw new R.FileOperationError((0,p.localize)(3,null,this.resourceForError(s)),3,r)}async createFile(s,r=y.VSBuffer.fromString(""),t){await this.doValidateCreateFile(s,t);const i=await this.writeFile(s,r);return this._onDidRunOperation.fire(new R.FileOperationEvent(s,0,i)),i}async writeFile(s,r,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,s,t)||await this.mkdirp(i,n.dirname(s));let a;if((0,R.hasReadWriteCapability)(i)&&!(r instanceof y.VSBuffer))if((0,v.isReadableStream)(r)){const c=await(0,v.peekStream)(r,3);c.ended?a=y.VSBuffer.concat(c.buffer):a=c}else a=(0,v.peekReadable)(r,c=>y.VSBuffer.concat(c),3);else a=r;!(0,R.hasOpenReadWriteCloseCapability)(i)||(0,R.hasReadWriteCapability)(i)&&a instanceof y.VSBuffer?await this.doWriteUnbuffered(i,s,t,a):await this.doWriteBuffered(i,s,t,a instanceof y.VSBuffer?(0,y.bufferToReadable)(a):a)}catch(o){throw new R.FileOperationError((0,p.localize)(4,null,this.resourceForError(s),(0,R.ensureFileSystemProviderError)(o).toString()),(0,R.toFileOperationResult)(o),t)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,r,t){if(!!(t==null?void 0:t.unlock)&&!(s.capabilities&8192))throw new Error((0,p.localize)(5,null,this.resourceForError(r)));let n;try{n=await s.stat(r)}catch(o){return}if((n.type&R.FileType.Directory)!=0)throw new R.FileOperationError((0,p.localize)(6,null,this.resourceForError(r)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==R.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&t.mtime<n.mtime&&t.etag!==(0,R.etag)({mtime:t.mtime,size:n.size}))throw new R.FileOperationError((0,p.localize)(7,null),3,t);return n}async readFile(s,r){const t=await this.withReadProvider(s);return(r==null?void 0:r.atomic)?this.doReadFileAtomic(t,s,r):this.doReadFile(t,s,r)}async doReadFileAtomic(s,r,t){return new Promise((i,n)=>{this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(s,r,t);i(o)}catch(o){n(o)}})})}async doReadFile(s,r,t){const i=await this.doReadFileStream(s,r,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await(0,y.streamToBuffer)(i.value)})}async readFileStream(s,r){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,r)}async doReadFileStream(s,r,t){const i=new u.CancellationTokenSource,n=this.validateReadFile(r,t).then(a=>a,a=>{throw i.cancel(),a});let o;try{t&&typeof t.etag=="string"&&t.etag!==R.ETAG_DISABLED&&await n,!((0,R.hasOpenReadWriteCloseCapability)(s)||(0,R.hasFileReadStreamCapability)(s))||(0,R.hasReadWriteCapability)(s)&&(t==null?void 0:t.preferUnbuffered)?o=this.readFileUnbuffered(s,r,t):(0,R.hasFileReadStreamCapability)(s)?o=this.readFileStreamed(s,r,i.token,t):o=this.readFileBuffered(s,r,i.token,t);const a=await n;return Object.assign(Object.assign({},a),{value:o})}catch(a){throw o&&await(0,v.consumeStream)(o),new R.FileOperationError((0,p.localize)(8,null,this.resourceForError(r),(0,R.ensureFileSystemProviderError)(a).toString()),(0,R.toFileOperationResult)(a),t)}}readFileStreamed(s,r,t,i=Object.create(null)){const n=s.readFileStream(r,i,t);return(0,v.transform)(n,{data:o=>o instanceof y.VSBuffer?o:y.VSBuffer.wrap(o),error:o=>new R.FileOperationError((0,p.localize)(9,null,this.resourceForError(r),(0,R.ensureFileSystemProviderError)(o).toString()),(0,R.toFileOperationResult)(o),i)},o=>y.VSBuffer.concat(o))}readFileBuffered(s,r,t,i=Object.create(null)){const n=(0,y.newWriteableBufferStream)();return(0,C.readFileIntoStream)(s,r,n,o=>o,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new R.FileOperationError((0,p.localize)(10,null,this.resourceForError(r),(0,R.ensureFileSystemProviderError)(o).toString()),(0,R.toFileOperationResult)(o),i)}),t),n}readFileUnbuffered(s,r,t){const i=(0,v.newWriteableStream)(n=>y.VSBuffer.concat(n));return(async()=>{try{let n=await s.readFile(r);t&&typeof t.position=="number"&&(n=n.slice(t.position)),t&&typeof t.length=="number"&&(n=n.slice(0,t.length)),this.validateReadFileLimits(r,n.byteLength,t),i.end(y.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(s,r){const t=await this.resolve(s,{resolveMetadata:!0});if(t.isDirectory)throw new R.FileOperationError((0,p.localize)(11,null,this.resourceForError(s)),0,r);if(r&&typeof r.etag=="string"&&r.etag!==R.ETAG_DISABLED&&r.etag===t.etag)throw new R.FileOperationError((0,p.localize)(12,null),2,r);return this.validateReadFileLimits(s,t.size,r),t}validateReadFileLimits(s,r,t){if(t==null?void 0:t.limits){let i;if(typeof t.limits.memory=="number"&&r>t.limits.memory&&(i=9),typeof t.limits.size=="number"&&r>t.limits.size&&(i=7),typeof i=="number")throw new R.FileOperationError((0,p.localize)(13,null,this.resourceForError(s)),i)}}async canMove(s,r,t){return this.doCanMoveCopy(s,r,"move",t)}async canCopy(s,r,t){return this.doCanMoveCopy(s,r,"copy",t)}async doCanMoveCopy(s,r,t,i){if(s.toString()!==r.toString())try{const n=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(n,s,o,r,t,i)}catch(n){return n}return!0}async move(s,r,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,s,n,r,"move",!!t),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(s,o==="move"?2:3,a)),a}async copy(s,r,t){const i=await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,s,n,r,"copy",!!t),a=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(s,o==="copy"?3:2,a)),a}async doMoveCopy(s,r,t,i,n,o){if(r.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(s,r,t,i,n,o);if(a&&!c&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i)),n==="copy"){if(s===t&&(0,R.hasFileFolderCopyCapability)(s))await s.copy(r,i,{overwrite:o});else{const l=await this.resolve(r);l.isDirectory?await this.doCopyFolder(s,l,t,i):await this.doCopyFile(s,r,t,i)}return n}else return s===t?(await s.rename(r,i,{overwrite:o}),n):(await this.doMoveCopy(s,r,t,i,"copy",o),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(s,r,t,i){if((0,R.hasOpenReadWriteCloseCapability)(s)&&(0,R.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(s,r,t,i);if((0,R.hasOpenReadWriteCloseCapability)(s)&&(0,R.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(s,r,t,i);if((0,R.hasReadWriteCapability)(s)&&(0,R.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(s,r,t,i);if((0,R.hasReadWriteCapability)(s)&&(0,R.hasReadWriteCapability)(t))return this.doPipeUnbuffered(s,r,t,i)}async doCopyFolder(s,r,t,i){await t.mkdir(i),Array.isArray(r.children)&&await b.Promises.settled(r.children.map(async n=>{const o=this.getExtUri(t).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(s,await this.resolve(n.resource),t,o):this.doCopyFile(s,n.resource,t,o)}))}async doValidateMoveCopy(s,r,t,i,n,o){let a=!1;if(s===t){const{providerExtUri:l,isPathCaseSensitive:d}=this.getExtUri(s);if(d||(a=l.isEqual(r,i)),a&&n==="copy")throw new Error((0,p.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!a&&l.isEqualOrParent(i,r))throw new Error((0,p.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const c=await this.exists(i);if(c&&!a){if(!o)throw new R.FileOperationError((0,p.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(s===t){const{providerExtUri:l}=this.getExtUri(s);if(l.isEqualOrParent(r,i))throw new Error((0,p.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:c,isSameResourceWithDifferentPathCase:a}}getExtUri(s){const r=this.isPathCaseSensitive(s);return{providerExtUri:r?O.extUri:O.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(r,s);const t=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(s,0,t)),t}async mkdirp(s,r){const t=[],{providerExtUri:i}=this.getExtUri(s);for(;!i.isEqual(r,i.dirname(r));)try{if(((await s.stat(r)).type&R.FileType.Directory)==0)throw new Error((0,p.localize)(18,null,this.resourceForError(r)));break}catch(n){if((0,R.toFileSystemProviderErrorCode)(n)!==R.FileSystemProviderErrorCode.FileNotFound)throw n;t.push(i.basename(r)),r=i.dirname(r)}for(let n=t.length-1;n>=0;n--){r=i.joinPath(r,t[n]);try{await s.mkdir(r)}catch(o){if((0,R.toFileSystemProviderErrorCode)(o)!==R.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,r){try{await this.doValidateDelete(s,r)}catch(t){return t}return!0}async doValidateDelete(s,r){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!(r==null?void 0:r.useTrash)&&!(t.capabilities&4096))throw new Error((0,p.localize)(19,null,this.resourceForError(s)));const n=await this.exists(s);if(!n)throw new R.FileOperationError((0,p.localize)(20,null,this.resourceForError(s)),1);if(!!!(r==null?void 0:r.recursive)&&n){const a=await this.resolve(s);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,p.localize)(21,null,this.resourceForError(s)))}return t}async del(s,r){const t=await this.doValidateDelete(s,r),i=!!(r==null?void 0:r.useTrash),n=!!(r==null?void 0:r.recursive);await t.delete(s,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new R.FileOperationEvent(s,1))}watch(s,r={recursive:!1,excludes:[]}){let t=!1,i=()=>{t=!0};return this.doWatch(s,r).then(n=>{t?(0,A.dispose)(n):i=()=>(0,A.dispose)(n)},n=>this.logService.error(n)),(0,A.toDisposable)(()=>i())}async doWatch(s,r){const t=await this.withProvider(s),i=this.toWatchKey(t,s,r),n=this.activeWatchers.get(i)||{count:0,disposable:t.watch(s,r)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,A.toDisposable)(()=>{n.count--,n.count===0&&((0,A.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(s,r,t){const{providerExtUri:i}=this.getExtUri(s);return[i.getComparisonKey(r),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(s=>(0,A.dispose)(s.disposable)),this.activeWatchers.clear()}async doWriteBuffered(s,r,t,i){return this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(async()=>{var n;const o=await s.open(r,{create:!0,unlock:(n=t==null?void 0:t.unlock)!==null&&n!==void 0?n:!1});try{(0,v.isReadableStream)(i)||(0,v.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(s,o,i):await this.doWriteReadableBufferedQueued(s,o,i)}catch(a){throw(0,R.ensureFileSystemProviderError)(a)}finally{await s.close(o)}})}async doWriteStreamBufferedQueued(s,r,t){let i=0,n;if((0,v.isReadableBufferedStream)(t)){if(t.buffer.length>0){const o=y.VSBuffer.concat(t.buffer);await this.doWriteBuffer(s,r,o,o.byteLength,i,0),i+=o.byteLength}if(t.ended)return;n=t.stream}else n=t;return new Promise(async(o,a)=>{(0,v.listenStream)(n,{onData:async c=>{n.pause();try{await this.doWriteBuffer(s,r,c,c.byteLength,i,0)}catch(l){return a(l)}i+=c.byteLength,setTimeout(()=>n.resume())},onError:c=>a(c),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,r,t){let i=0,n;for(;(n=t.read())!==null;)await this.doWriteBuffer(s,r,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(s,r,t,i,n,o){let a=0;for(;a<i;)a+=await s.write(r,n+a,t.buffer,o+a,i-a)}async doWriteUnbuffered(s,r,t,i){return this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,r,t,i))}async doWriteUnbufferedQueued(s,r,t,i){var n;let o;i instanceof y.VSBuffer?o=i:(0,v.isReadableStream)(i)?o=await(0,y.streamToBuffer)(i):(0,v.isReadableBufferedStream)(i)?o=await(0,y.bufferedStreamToBuffer)(i):o=(0,y.readableToBuffer)(i),await s.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:(n=t==null?void 0:t.unlock)!==null&&n!==void 0?n:!1})}async doPipeBuffered(s,r,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,r,t,i))}async doPipeBufferedQueued(s,r,t,i){let n,o;try{n=await s.open(r,{create:!1}),o=await t.open(i,{create:!0,unlock:!1});const a=y.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,l=0,d=0;do d=await s.read(n,c,a.buffer,l,a.byteLength-l),await this.doWriteBuffer(t,o,a,d,c,l),c+=d,l+=d,l===a.byteLength&&(l=0);while(d>0)}catch(a){throw(0,R.ensureFileSystemProviderError)(a)}finally{await b.Promises.settled([typeof n=="number"?s.close(n):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,r,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,r,t,i))}async doPipeUnbufferedQueued(s,r,t,i){return t.writeFile(i,await s.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,r,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,r,t,i))}async doPipeUnbufferedToBufferedQueued(s,r,t,i){const n=await t.open(i,{create:!0,unlock:!1});try{const o=await s.readFile(r);await this.doWriteBuffer(t,n,y.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,R.ensureFileSystemProviderError)(o)}finally{await t.close(n)}}async doPipeBufferedToUnbuffered(s,r,t,i){const n=await(0,y.streamToBuffer)(this.readFileBuffered(s,r,u.CancellationToken.None));await this.doWriteUnbuffered(t,i,void 0,n)}throwIfFileSystemIsReadonly(s,r){if(s.capabilities&2048)throw new R.FileOperationError((0,p.localize)(22,null,this.resourceForError(r)),6);return s}resourceForError(s){return s.scheme===S.Schemas.file?s.fsPath:s.toString(!0)}};D=fe([Y(0,T.ILogService)],D),e.FileService=D}),define(Z[157],ee([0,1,27,94,2,10,3,7,24,8,12,42,6,17,116,74,133,135,132,146,47,77,18,23]),function(K,e,p,k,A,R,U,O,g,m,T,y,v,b,u,S,C,E,D,f,s,r,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class n extends A.Disposable{constructor(a,c){var l;super();this.logService=a,this.options=c,this.BUFFER_SIZE=((l=this.options)===null||l===void 0?void 0:l.bufferSize)||64*1024,this.onDidChangeCapabilities=U.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new U.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new U.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new v.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,O.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(a){try{const{stat:c,symbolicLink:l}=await g.SymlinkSupport.stat(this.toFilePath(a));return{type:this.toType(c,l),ctime:c.birthtime.getTime(),mtime:c.mtime.getTime(),size:c.size}}catch(c){throw this.toFileSystemProviderError(c)}}async readdir(a){try{const c=await(0,g.readdir)(this.toFilePath(a),{withFileTypes:!0}),l=[];return await Promise.all(c.map(async d=>{try{let w;d.isSymbolicLink()?w=(await this.stat((0,T.joinPath)(a,d.name))).type:w=this.toType(d),l.push([d.name,w])}catch(w){this.logService.trace(w)}})),l}catch(c){throw this.toFileSystemProviderError(c)}}toType(a,c){let l;return(c==null?void 0:c.dangling)?l=R.FileType.Unknown:a.isFile()?l=R.FileType.File:a.isDirectory()?l=R.FileType.Directory:l=R.FileType.Unknown,c&&(l|=R.FileType.SymbolicLink),l}async readFile(a){try{const c=this.toFilePath(a);return await p.promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}}readFileStream(a,c,l){const d=(0,s.newWriteableStream)(w=>i.VSBuffer.concat(w.map(h=>i.VSBuffer.wrap(h))).buffer);return(0,r.readFileIntoStream)(this,a,d,w=>w.buffer,Object.assign(Object.assign({},c),{bufferSize:this.BUFFER_SIZE}),l),d}async writeFile(a,c,l){let d;try{const w=this.toFilePath(a);if(!l.create||!l.overwrite){if(await(0,g.exists)(w)){if(!l.overwrite)throw(0,R.createFileSystemProviderError)((0,u.localize)(0,null),R.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,R.createFileSystemProviderError)((0,u.localize)(1,null),R.FileSystemProviderErrorCode.FileNotFound)}d=await this.open(a,{create:!0,unlock:l.unlock}),await this.write(d,0,c,0,c.byteLength)}catch(w){throw await this.toFileSystemProviderWriteError(a,w)}finally{typeof d=="number"&&await this.close(d)}}async open(a,c){try{const l=this.toFilePath(a);if((0,R.isFileOpenForWriteOptions)(c)&&c.unlock)try{const{stat:h}=await g.SymlinkSupport.stat(l);h.mode&128||await p.promises.chmod(l,h.mode|128)}catch(h){this.logService.trace(h)}let d;if((0,R.isFileOpenForWriteOptions)(c)){if(O.isWindows)try{await p.promises.truncate(l,0),d="r+"}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}d||(d="w")}else d="r";const w=await(0,k.promisify)(p.open)(l,d);return this.mapHandleToPos.set(w,0),(0,R.isFileOpenForWriteOptions)(c)&&this.writeHandles.set(w,a),w}catch(l){throw(0,R.isFileOpenForWriteOptions)(c)?await this.toFileSystemProviderWriteError(a,l):this.toFileSystemProviderError(l)}}async close(a){try{if(this.mapHandleToPos.delete(a),this.writeHandles.delete(a)&&this.canFlush)try{await(0,k.promisify)(p.fdatasync)(a)}catch(c){this.canFlush=!1,this.logService.error(c)}return await(0,k.promisify)(p.close)(a)}catch(c){throw this.toFileSystemProviderError(c)}}async read(a,c,l,d,w){const h=this.normalizePos(a,c);let P=null;try{const _=await(0,k.promisify)(p.read)(a,l,d,w,h);return typeof _=="number"?P=_:P=_.bytesRead,P}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(a,h,P)}}normalizePos(a,c){return c===this.mapHandleToPos.get(a)?null:c}updatePos(a,c,l){const d=this.mapHandleToPos.get(a);typeof d=="number"&&(typeof c=="number"||(typeof l=="number"?this.mapHandleToPos.set(a,d+l):this.mapHandleToPos.delete(a)))}async write(a,c,l,d,w){return(0,v.retry)(()=>this.doWrite(a,c,l,d,w),100,3)}async doWrite(a,c,l,d,w){const h=this.normalizePos(a,c);let P=null;try{const _=await(0,k.promisify)(p.write)(a,l,d,w,h);return typeof _=="number"?P=_:P=_.bytesWritten,P}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(a),_)}finally{this.updatePos(a,h,P)}}async mkdir(a){try{await p.promises.mkdir(this.toFilePath(a))}catch(c){throw this.toFileSystemProviderError(c)}}async delete(a,c){try{const l=this.toFilePath(a);await this.doDelete(l,c)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(a,c){c.recursive?await(0,g.rimraf)(a,g.RimRafMode.MOVE):await p.promises.unlink(a)}async rename(a,c,l){const d=this.toFilePath(a),w=this.toFilePath(c);if(d!==w)try{await this.validateTargetDeleted(a,c,"move",l.overwrite),await(0,g.move)(d,w)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,u.localize)(2,null,(0,m.basename)(d),(0,m.basename)((0,m.dirname)(w)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(a,c,l){const d=this.toFilePath(a),w=this.toFilePath(c);if(d!==w)try{await this.validateTargetDeleted(a,c,"copy",l.overwrite),await(0,g.copy)(d,w,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,u.localize)(3,null,(0,m.basename)(d),(0,m.basename)((0,m.dirname)(w)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(a,c,l,d){const w=this.toFilePath(a),h=this.toFilePath(c);let P=!1;if(!!(this.capabilities&1024)||(P=(0,y.isEqual)(w,h,!0)),P&&l==="copy")throw(0,R.createFileSystemProviderError)((0,u.localize)(4,null),R.FileSystemProviderErrorCode.FileExists);if(!P&&await(0,g.exists)(h)){if(!d)throw(0,R.createFileSystemProviderError)((0,u.localize)(5,null),R.FileSystemProviderErrorCode.FileExists);await this.delete(c,{recursive:!0,useTrash:!1})}}watch(a,c){return c.recursive?this.watchRecursive(a,c.excludes):this.watchNonRecursive(a)}watchRecursive(a,c){const l={path:this.toFilePath(a),excludes:c},d=(0,t.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,A.toDisposable)(()=>{d(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var a,c,l;if(this.recursiveWatcher instanceof D.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,A.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let d,w;((c=(a=this.options)===null||a===void 0?void 0:a.watcher)===null||c===void 0?void 0:c.usePolling)?(d=C.FileWatcher,w=(l=this.options)===null||l===void 0?void 0:l.watcher):this.recursiveFoldersToWatch.length===1?O.isWindows?d=E.FileWatcher:d=C.FileWatcher:d=D.FileWatcher,this.recursiveWatcher=new d(this.recursiveFoldersToWatch,h=>this._onDidChangeFile.fire((0,S.toFileChanges)(h)),h=>{h.type==="error"&&this._onDidWatchErrorOccur.fire(h.message),this.logService[h.type](h.message)},this.logService.getLevel()===b.LogLevel.Trace,w),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))}}watchNonRecursive(a){const c=new f.FileWatcher(this.toFilePath(a),d=>this._onDidChangeFile.fire((0,S.toFileChanges)(d)),d=>{d.type==="error"&&this._onDidWatchErrorOccur.fire(d.message),this.logService[d.type](d.message)},this.logService.getLevel()===b.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{c.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)});return(0,A.combinedDisposable)(c,l)}toFilePath(a){return(0,m.normalize)(a.fsPath)}toFileSystemProviderError(a){if(a instanceof R.FileSystemProviderError)return a;let c;switch(a.code){case"ENOENT":c=R.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=R.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=R.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=R.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=R.FileSystemProviderErrorCode.NoPermissions;break;default:c=R.FileSystemProviderErrorCode.Unknown}return(0,R.createFileSystemProviderError)(a,c)}async toFileSystemProviderWriteError(a,c){let l=this.toFileSystemProviderError(c);if(a&&l.code===R.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await g.SymlinkSupport.stat(this.toFilePath(a));d.mode&128||(l=(0,R.createFileSystemProviderError)(c,R.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.logService.trace(d)}return l}dispose(){super.dispose(),(0,A.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,A.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=n}),define(Z[28],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService")}),define(Z[158],ee([0,1,27,8,24,28,2,11,17,9]),function(K,e,p,k,A,R,U,O,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let T=class extends U.Disposable{constructor(v,b,u){super();this._environmentService=v,this._logService=b,this._productService=u,this._DataMaxAge=this._productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._environmentService.isBuilt&&this._manageCachedDataSoon()}_manageCachedDataSoon(){let v=setTimeout(async()=>{v=void 0,this._logService.info("Starting to clean up unused language packs.");try{const b=Object.create(null),u=JSON.parse(await p.promises.readFile(k.join(this._environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let D of Object.keys(u)){const f=u[D];b[`${f.hash}.${D}`]=!0}const S=k.join(this._environmentService.userDataPath,"clp");if(!await A.exists(S))return;for(let D of await A.readdir(S)){if(b[D]){this._logService.info(`Skipping directory ${D}. Language pack still in use.`);continue}this._logService.info("Removing unused language pack:",D),await A.rimraf(k.join(S,D))}const E=Date.now();for(let D of Object.keys(b)){const f=k.join(S,D);for(let s of await A.readdir(f))if(s!=="tcf.json"){const r=k.join(f,s),t=await p.promises.stat(r);t.isDirectory()&&E-t.mtime.getTime()>this._DataMaxAge&&(this._logService.info("Removing language pack cache entry: ",k.join(D,s)),await A.rimraf(r))}}}catch(b){(0,O.onUnexpectedError)(b)}},40*1e3);this._register((0,U.toDisposable)(()=>{v!==void 0&&clearTimeout(v)}))}};T=fe([Y(0,m.INativeEnvironmentService),Y(1,g.ILogService),Y(2,R.IProductService)],T),e.LanguagePackCachedDataCleaner=T}),define(Z[159],ee([0,1,27,8,11,2,24,28]),function(K,e,p,k,A,R,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeCachedDataCleaner=void 0;let g=class{constructor(T,y){this.nodeCachedDataDir=T,this.productService=y,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._disposables=new R.DisposableStore,this._manageCachedDataSoon()}dispose(){this._disposables.dispose()}_manageCachedDataSoon(){if(!!this.nodeCachedDataDir){const T=(0,k.dirname)(this.nodeCachedDataDir),y=(0,k.basename)(this.nodeCachedDataDir);let v=setTimeout(()=>{v=void 0,(0,U.readdir)(T).then(b=>{const u=Date.now(),S=[];return b.forEach(C=>{if(C!==y){const E=(0,k.join)(T,C);S.push(p.promises.stat(E).then(D=>{if(D.isDirectory()&&u-D.mtime.getTime()>this._DataMaxAge)return(0,U.rimraf)(E)}))}}),Promise.all(S)}).then(void 0,A.onUnexpectedError)},30*1e3);this._disposables.add((0,R.toDisposable)(()=>{v&&(clearTimeout(v),v=void 0)}))}}};g=fe([Y(1,O.IProductService)],g),e.NodeCachedDataCleaner=g}),define(Z[35],ee([0,1,15,85]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(U,O){k.ok(p.isString(U)),k.ok(p.isObject(O)),k.ok(!this.data.has(U),"There is already an extension with this id"),this.data.set(U,O)}knows(U){return this.data.has(U)}as(U){return this.data.get(U)||null}}e.Registry=new A}),define(Z[78],ee([0,1,35,3]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(O){return O.length>0&&O.charAt(O.length-1)==="#"?O.substring(0,O.length-1):O}class R{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(g,m){this.schemasById[A(g)]=m,this._onDidChangeSchema.fire(g)}notifySchemaChanged(g){this._onDidChangeSchema.fire(g)}getSchemaContributions(){return{schemas:this.schemasById}}}const U=new R;p.Registry.add(e.Extensions.JSONContribution,U)}),define(Z[39],ee([0,1,106,3,35,15,78]),function(K,e,p,k,A,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const g=A.Registry.as(U.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:p.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,D=!0){this.registerConfigurations([E],D)}registerConfigurations(E,D=!0){const f=[];E.forEach(s=>{f.push(...this.validateAndRegisterProperties(s,D,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterConfigurations(E){const D=[],f=s=>{if(s.properties)for(const r in s.properties)D.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,s.properties[r]);s.allOf&&s.allOf.forEach(r=>f(r))};for(const s of E){f(s);const r=this.configurationContributors.indexOf(s);r!==-1&&this.configurationContributors.splice(r,1)}g.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}registerDefaultConfigurations(E){const D=[],f=[];for(const s of E)for(const r in s)if(D.push(r),e.OVERRIDE_PROPERTY_PATTERN.test(r)){this.defaultValues[r]=Object.assign(Object.assign({},this.defaultValues[r]||{}),s[r]);const t={type:"object",default:this.defaultValues[r],description:p.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId};f.push(y(r)),this.configurationProperties[r]=t,this.defaultLanguageConfigurationOverridesNode.properties[r]=t}else{this.defaultValues[r]=s[r];const t=this.configurationProperties[r];t&&(this.updatePropertyDefaultValue(r,t),this.updateSchema(r,t))}this.registerOverrideIdentifiers(f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}deregisterDefaultConfigurations(E){const D=[];for(const f of E)for(const s in f)if(D.push(s),delete this.defaultValues[s],e.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const r=this.configurationProperties[s];r&&(this.updatePropertyDefaultValue(s,r),this.updateSchema(s,r))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const D of E)this.overrideIdentifiers.add(D);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,D=!0,f,s=3){var r;s=R.isUndefinedOrNull(E.scope)?s:E.scope;let t=[],i=E.properties;if(i)for(let o in i){if(D&&u(o)){delete i[o];continue}const a=i[o];if(this.updatePropertyDefaultValue(o,a),e.OVERRIDE_PROPERTY_PATTERN.test(o)?a.scope=void 0:(a.scope=R.isUndefinedOrNull(a.scope)?s:a.scope,a.restricted=R.isUndefinedOrNull(a.restricted)?!!((r=f==null?void 0:f.restrictedConfigurations)===null||r===void 0?void 0:r.includes(o)):a.restricted),i[o].hasOwnProperty("included")&&!i[o].included){this.excludedConfigurationProperties[o]=i[o],delete i[o];continue}else this.configurationProperties[o]=i[o];!i[o].deprecationMessage&&i[o].markdownDeprecationMessage&&(i[o].deprecationMessage=i[o].markdownDeprecationMessage),t.push(o)}let n=E.allOf;if(n)for(let o of n)t.push(...this.validateAndRegisterProperties(o,D,f,s));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const D=f=>{let s=f.properties;if(s)for(const t in s)this.updateSchema(t,s[t]);let r=f.allOf;r&&r.forEach(D)};D(E)}updateSchema(E,D){switch(e.allSettings.properties[E]=D,D.scope){case 1:e.applicationSettings.properties[E]=D;break;case 2:e.machineSettings.properties[E]=D;break;case 6:e.machineOverridableSettings.properties[E]=D;break;case 3:e.windowSettings.properties[E]=D;break;case 4:e.resourceSettings.properties[E]=D;break;case 5:e.resourceSettings.properties[E]=D,this.resourceLanguageSettingsSchema.properties[E]=D;break}}removeFromSchema(E,D){switch(delete e.allSettings.properties[E],D.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const D=`[${E}]`,f={type:"object",description:p.localize(2,null),errorMessage:p.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(D,f),e.allSettings.properties[D]=f,e.applicationSettings.properties[D]=f,e.machineSettings.properties[D]=f,e.machineOverridableSettings.properties[D]=f,e.windowSettings.properties[D]=f,e.resourceSettings.properties[D]=f}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,D){let f=this.defaultValues[E];R.isUndefined(f)&&(f=D.default),R.isUndefined(f)&&(f=v(D.type)),D.default=f}}const T="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(T);function y(C){return C.substring(1,C.length-1)}e.overrideIdentifierFromKey=y;function v(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const b=new m;A.Registry.add(e.Extensions.Configuration,b);function u(C){return C.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(C)?p.localize(5,null,C):b.getConfigurationProperties()[C]!==void 0?p.localize(6,null,C):null:p.localize(4,null)}e.validateProperty=u;function S(){const C=[],E=b.getConfigurationProperties();for(const D of Object.keys(E))C.push([D,E[D].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.getScopes=S}),define(Z[25],ee([0,1,26,15,4,35,5,39]),function(K,e,p,k,A,R,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,U.createDecorator)("configurationService");function g(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof A.URI)}e.isConfigurationOverrides=g;var m;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(m=e.ConfigurationTarget||(e.ConfigurationTarget={}));function T(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=T;function y(i,n){const o=n?i?n.keys.filter(P=>i.keys.indexOf(P)===-1):[...n.keys]:[],a=i?n?i.keys.filter(P=>n.keys.indexOf(P)===-1):[...i.keys]:[],c=[];if(n&&i){for(const P of i.keys)if(n.keys.indexOf(P)!==-1){const _=E(i.contents,P),j=E(n.contents,P);p.equals(_,j)||c.push(P)}}const l=[],d=P=>{const _={};for(const j of P)for(const q of j.identifiers)_[r(q)]=j;return _},w=n?d(n.overrides):{},h=i?d(i.overrides):{};if(Object.keys(w).length)for(const P of o){const _=w[P];_&&l.push([(0,O.overrideIdentifierFromKey)(P),_.keys])}if(Object.keys(h).length)for(const P of a){const _=h[P];_&&l.push([(0,O.overrideIdentifierFromKey)(P),_.keys])}if(Object.keys(w).length&&Object.keys(h).length)for(const P of c){const _=h[P],j=w[P];if(_&&j){const q=y({contents:_.contents,keys:_.keys,overrides:[]},{contents:j.contents,keys:j.keys,overrides:[]});l.push([(0,O.overrideIdentifierFromKey)(P),[...q.added,...q.removed,...q.updated]])}}return{added:o,removed:a,updated:c,overrides:l}}e.compare=y;function v(i,n){const o=[];for(const a of Object.keys(i))if(O.OVERRIDE_PROPERTY_PATTERN.test(a)){const c={};for(const l in i[a])c[l]=i[a][l];o.push({identifiers:[(0,O.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(c),contents:b(c,n)})}return o}e.toOverrides=v;function b(i,n){const o=Object.create(null);for(let a in i)u(o,a,i[a],n);return o}e.toValuesTree=b;function u(i,n,o,a){const c=n.split("."),l=c.pop();let d=i;for(let w=0;w<c.length;w++){let h=c[w],P=d[h];switch(typeof P){case"undefined":P=d[h]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${c.slice(0,w+1).join(".")} is ${JSON.stringify(P)}`);return}d=P}if(typeof d=="object"&&d!==null)try{d[l]=o}catch(w){a(`Ignoring ${n} as ${c.join(".")} is ${JSON.stringify(d)}`)}else a(`Ignoring ${n} as ${c.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=u;function S(i,n){const o=n.split(".");C(i,o)}e.removeFromValueTree=S;function C(i,n){const o=n.shift();if(n.length===0){delete i[o];return}if(Object.keys(i).indexOf(o)!==-1){const a=i[o];typeof a=="object"&&!Array.isArray(a)&&(C(a,n),Object.keys(a).length===0&&delete i[o])}}function E(i,n,o){function a(d,w){let h=d;for(const P of w){if(typeof h!="object"||h===null)return;h=h[P]}return h}const c=n.split("."),l=a(i,c);return typeof l=="undefined"?o:l}e.getConfigurationValue=E;function D(i,n,o){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in i?k.isObject(i[a])&&k.isObject(n[a])?D(i[a],n[a],o):o&&(i[a]=n[a]):i[a]=n[a])})}e.merge=D;function f(){const i=R.Registry.as(O.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=f;function s(){const i=Object.create(null),n=R.Registry.as(O.Extensions.Configuration).getConfigurationProperties();for(let o in n){let a=n[o].default;u(i,o,a,c=>console.error(`Conflict in default settings: ${c}`))}return i}e.getDefaultValues=s;function r(i){return`[${i}]`}e.keyFromOverrideIdentifier=r;function t(i,n,o){const a=i.inspect(n),c=i.inspect(o);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:a.defaultValue}e.getMigratedSettingValue=t}),define(Z[160],ee([0,1,32,37,18,15,26,4,39,25,35,2,3]),function(K,e,p,k,A,R,U,O,g,m,T,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(t={},i=[],n=[]){this._contents=t,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,m.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const n=this.getContentsForOverrideIdentifer(i);return n?t?(0,m.getConfigurationValue)(n,t):n:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const o of A.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[o],c=i[o];c&&(typeof a=="object"&&typeof c=="object"?(a=U.deepClone(a),this.mergeContents(a,c)):a=c),n[o]=a}return new b(n,this.keys,this.overrides)}merge(...t){const i=U.deepClone(this.contents),n=U.deepClone(this.overrides),o=[...this.keys];for(const a of t){this.mergeContents(i,a.contents);for(const c of a.overrides){const[l]=n.filter(d=>A.equals(d.identifiers,c.identifiers));l?this.mergeContents(l.contents,c.contents):n.push(U.deepClone(c))}for(const c of a.keys)o.indexOf(c)===-1&&o.push(c)}return new b(i,o,n)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const n of Object.keys(i)){if(n in t&&R.isObject(t[n])&&R.isObject(i[n])){this.mergeContents(t[n],i[n]);continue}t[n]=U.deepClone(i[n])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?U.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,m.addToValueTree)(this.contents,t,i,n=>{throw new Error(n)})}removeValue(t){this.removeKey(t)&&(0,m.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let n=0;n<i;n++)t.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=b;class u extends b{constructor(){const t=(0,m.getDefaultValues)(),i=(0,m.getConfigurationKeys)(),n=[];for(const o of Object.keys(t))g.OVERRIDE_PROPERTY_PATTERN.test(o)&&n.push({identifiers:[(0,g.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(t[o]),contents:(0,m.toValuesTree)(t[o],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,i,n)}}e.DefaultConfigurationModel=u;class S{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!R.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:n,keys:o,overrides:a,restricted:c}=this.doParseRaw(t,i);this._configurationModel=new b(n,o,a),this._restrictedConfigurations=c||[]}doParseContent(t){let i={},n=null,o=[],a=[],c=[];function l(w){Array.isArray(o)?o.push(w):n&&(o[n]=w)}let d={onObjectBegin:()=>{let w={};l(w),a.push(o),o=w,n=null},onObjectProperty:w=>{n=w},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{let w=[];l(w),a.push(o),o=w,n=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:l,onError:(w,h,P)=>{c.push({error:w,offset:h,length:P})}};if(t)try{p.visit(t,d),i=o[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return i}doParseRaw(t,i){const n=T.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,n,!0,i);t=o.raw;const a=(0,m.toValuesTree)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),c=Object.keys(t),l=(0,m.toOverrides)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:a,keys:c,overrides:l,restricted:o.restricted}}filter(t,i,n,o){if(!(o==null?void 0:o.scopes)&&!(o==null?void 0:o.skipRestricted))return{raw:t,restricted:[]};const a={},c=[];for(let l in t)if(g.OVERRIDE_PROPERTY_PATTERN.test(l)&&n){const d=this.filter(t[l],i,!1,o);a[l]=d.raw,c.push(...d.restricted)}else{const d=i[l],w=d?typeof d.scope!="undefined"?d.scope:3:void 0;(d==null?void 0:d.restricted)&&c.push(l),(w===void 0||o.scopes===void 0||o.scopes.includes(w))&&(o.skipRestricted&&(d==null?void 0:d.restricted)||(a[l]=t[l]))}return{raw:a,restricted:c}}}e.ConfigurationModelParser=S;class C extends y.Disposable{constructor(t,i,n,o){super();this.userSettingsResource=t,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new S(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(v.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=C;class E{constructor(t,i,n=new b,o=new b,a=new k.ResourceMap,c=new b,l=new k.ResourceMap,d=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=o,this._folderConfigurations=a,this._memoryConfiguration=c,this._memoryConfigurationByResource=l,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(t)}updateValue(t,i,n={}){let o;n.resource?(o=this._memoryConfigurationByResource.get(n.resource),o||(o=new b,this._memoryConfigurationByResource.set(n.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(t):o.setValue(t,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,n){const o=this.getConsolidateConfigurationModel(i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),c=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,l=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),d=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),w=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),h=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),P=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,_=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,j=i.overrideIdentifier?c.override(i.overrideIdentifier).getValue(t):c.getValue(t),q=o.getValue(t),G=A.distinct(A.flatten(o.overrides.map(M=>M.identifiers))).filter(M=>o.getOverrideValue(t,M)!==void 0);return{defaultValue:l,userValue:d,userLocalValue:w,userRemoteValue:h,workspaceValue:P,workspaceFolderValue:_,memoryValue:j,value:q,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:w!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:h!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:P!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:_!==void 0?{value:a==null?void 0:a.freeze().getValue(t),override:i.overrideIdentifier?a==null?void 0:a.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:j!==void 0?{value:c.getValue(t),override:i.overrideIdentifier?c.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:G.length?G:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=i.filter(o=>g.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const a=(0,g.overrideIdentifierFromKey)(o),c=this._defaultConfiguration.getKeysForOverrideIdentifier(a),l=t.getKeysForOverrideIdentifier(a),d=[...l.filter(w=>c.indexOf(w)===-1),...c.filter(w=>l.indexOf(w)===-1),...c.filter(w=>!U.equals(this._defaultConfiguration.override(a).getValue(w),t.override(a).getValue(w)))];return[a,d]});return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:o,overrides:a}=(0,m.compare)(this.localUserConfiguration,t),c=[...i,...n,...o];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:o,overrides:a}=(0,m.compare)(this.remoteUserConfiguration,t);let c=[...i,...n,...o];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:o,overrides:a}=(0,m.compare)(this.workspaceConfiguration,t);let c=[...i,...n,...o];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:a}}compareAndUpdateFolderConfiguration(t,i){const n=this.folderConfigurations.get(t),{added:o,updated:a,removed:c,overrides:l}=(0,m.compare)(n,i);let d=[...o,...a,...c];return(d.length||!n)&&this.updateFolderConfiguration(t,i),{keys:d,overrides:l}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:o,removed:a,overrides:c}=(0,m.compare)(i,void 0);return{keys:[...n,...o,...a],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let n=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?n.override(t.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:t},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const o=i.getFolder(t);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);const a=this._memoryConfigurationByResource.get(t);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(i=n.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=n}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:n,overrides:o,keys:a}=this._folderConfigurations.get(i);return t.push([i,{contents:n,overrides:o,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((c,l)=>(c.set(O.URI.revive(l[0]),this.parseConfigurationModel(l[1])),c),new k.ResourceMap);return new E(i,n,new b,o,a,new b,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new b(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=E;function D(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,i=new Map;for(const o of r)o.keys.forEach(a=>t.add(a)),o.overrides.forEach(([a,c])=>{const l=(0,k.getOrSet)(i,a,new Set);c.forEach(d=>l.add(d))});const n=[];return i.forEach((o,a)=>n.push([a,[...o.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=D;class f{constructor(t,i,n,o){this.change=t,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=o,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(l=>a.add(l)),t.overrides.forEach(([,l])=>l.forEach(d=>a.add(d))),this.affectedKeys=[...a.values()];const c=new b;this.affectedKeys.forEach(l=>c.setValue(l,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var n;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(n=this.previous)===null||n===void 0?void 0:n.workspace):void 0,a=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!U.equals(o,a)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let n=(0,m.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof n=="object"&&(o=Object.keys(n)[0]);){if(t=t[o],!t)return!1;n=n[o]}return!0}}e.ConfigurationChangeEvent=f;class s extends f{constructor(t,i,n,o){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=n,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=s}),define(Z[161],ee([0,1,35,39,2,25,160,3,6,12]),function(K,e,p,k,A,R,U,O,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class T extends A.Disposable{constructor(v,b){super();this.settingsResource=v,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new U.UserSettings(this.settingsResource,void 0,m.extUriBiasedIgnorePathCase,b)),this.configuration=new U.Configuration(new U.DefaultConfigurationModel,new U.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new g.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(p.Registry.as(k.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const v=await this.userConfiguration.loadConfiguration();this.configuration=new U.Configuration(new U.DefaultConfigurationModel,v)}getConfigurationData(){return this.configuration.toData()}getValue(v,b){const u=typeof v=="string"?v:void 0,S=(0,R.isConfigurationOverrides)(v)?v:(0,R.isConfigurationOverrides)(b)?b:{};return this.configuration.getValue(u,S,void 0)}updateValue(v,b,u,S){return Promise.reject(new Error("not supported"))}inspect(v){return this.configuration.inspect(v,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const b=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(u,b,1)}onDidDefaultConfigurationChange(v){const b=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new U.DefaultConfigurationModel,v);this.trigger(u,b,6)}trigger(v,b,u){const S=new U.ConfigurationChangeEvent(v,{data:b},this.configuration);S.source=u,S.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(v){switch(v){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=T}),define(Z[162],ee([0,1,25,17,100]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let R=class{constructor(O,g){this.configurationService=O,this.logService=g}request(O,g){return this.logService.trace("RequestService#request",O.url),O.proxyAuthorization||(O.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,A.request)(O,g)}async resolveProxy(O){}};R=fe([Y(0,p.IConfigurationService),Y(1,k.ILogService)],R),e.RequestService=R}),define(Z[40],ee([0,1,117,5,39,35,23]),function(K,e,p,k,A,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function O(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.isSuccess=O;function g(u){return u.res.statusCode===204}async function m(u){if(!O(u))throw new Error("Server returned "+u.res.statusCode);return g(u)?null:(await(0,U.streamToBuffer)(u.stream)).toString()}e.asText=m;async function T(u){if(!O(u))throw new Error("Server returned "+u.res.statusCode);if(g(u))return null;const C=(await(0,U.streamToBuffer)(u.stream)).toString();try{return JSON.parse(C)}catch(E){throw E.message+=`:
`+C,E}}e.asJson=T;function y(u){b(u)}e.updateProxyConfigurationsScope=y;let v;function b(u){const S=R.Registry.as(A.Extensions.Configuration);v&&S.deregisterConfigurations([v]),v={id:"http",order:15,title:(0,p.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,p.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,p.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,p.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,p.localize)(4,null),(0,p.localize)(5,null),(0,p.localize)(6,null),(0,p.localize)(7,null)],default:"override",description:(0,p.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,p.localize)(9,null),restricted:!0}}},S.registerConfiguration(v)}b(2)}),define(Z[163],ee([0,1,40,30,10,16]),function(K,e,p,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let U=class{constructor(g,m){this.requestService=g,this.fileService=m}async download(g,m,T=k.CancellationToken.None){if(g.scheme===R.Schemas.file||g.scheme===R.Schemas.vscodeRemote){await this.fileService.copy(g,m);return}const y={type:"GET",url:g.toString()},v=await this.requestService.request(y,T);if(v.res.statusCode===200)await this.fileService.writeFile(m,v.stream);else{const b=await(0,p.asText)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${b}`)}}};U=fe([Y(0,p.IRequestService),Y(1,A.IFileService)],U),e.DownloadService=U}),define(Z[164],ee([0,1,28,10,18,62,40,30,17,12,128,2]),function(K,e,p,k,A,R,U,O,g,m,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let v=class extends y.Disposable{constructor(u,S,C,E){super();this.fileService=u,this.productService=S,this.requestService=C,this.logService=E,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,R.forEach)(this.productService.configBasedExtensionTips,({value:D})=>this.allConfigBasedTips.set(D.configPath,D))}getConfigBasedTips(u){return this.getValidConfigBasedTips(u)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(u){const S=[];for(const[C,E]of this.allConfigBasedTips)try{const D=await this.fileService.readFile((0,m.joinPath)(u,C)),f=new Map;(0,R.forEach)(E.recommendations,({key:r,value:t})=>{if((0,A.isNonEmptyArray)(t.remotes))for(const i of t.remotes)f.set(i,{extensionId:r,extensionName:t.name,configName:E.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else S.push({extensionId:r,extensionName:t.name,configName:E.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const s=(0,T.getDomainsOfRemotes)(D.value.toString(),[...f.keys()]);for(const r of s){const t=f.get(r);t&&S.push(t)}}catch(D){}return S}async fetchWorkspacesTips(){var u,S;if(!((u=this.productService.extensionsGallery)===null||u===void 0?void 0:u.recommendationsUrl))return[];try{const C=await this.requestService.request({type:"GET",url:(S=this.productService.extensionsGallery)===null||S===void 0?void 0:S.recommendationsUrl},O.CancellationToken.None);if(C.res.statusCode!==200)return[];const E=await(0,U.asJson)(C);return E?E.workspaceRecommendations||[]:[]}catch(C){return this.logService.error(C),[]}}};v=fe([Y(0,k.IFileService),Y(1,p.IProductService),Y(2,U.IRequestService),Y(3,g.ILogService)],v),e.ExtensionTipsService=v}),define(Z[44],ee([0,1,31,23]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function A(R,U,O){let g=O&&O.get("storage.serviceMachineId",0)||null;if(g)return g;try{const T=(await U.readFile(R.serviceMachineIdResource)).value.toString();g=(0,p.isUUID)(T)?T:null}catch(m){g=null}if(!g){g=(0,p.generateUuid)();try{await U.writeFile(R.serviceMachineIdResource,k.VSBuffer.fromString(g))}catch(m){}}return O&&O.store("storage.serviceMachineId",g,0,1),g}e.getServiceMachineId=A}),define(Z[19],ee([0,1,5,3,2,15,68,6]),function(K,e,p,k,A,R,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const g="__$__targetStorageMarker";e.IStorageService=(0,p.createDecorator)("storageService");var m;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(m=e.WillSaveStateReason||(e.WillSaveStateReason={}));var T;(function(S){S[S.GLOBAL=0]="GLOBAL",S[S.WORKSPACE=1]="WORKSPACE"})(T=e.StorageScope||(e.StorageScope={}));var y;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));class v extends A.Disposable{constructor(C={flushInterval:v.DEFAULT_FLUSH_INTERVAL}){super();this.options=C,this._onDidChangeValue=this._register(new k.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new k.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new k.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new O.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new A.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,O.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,A.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(C,E){E===g?(C===0?this._globalKeyTargets=void 0:C===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:C})):this._onDidChangeValue.fire({scope:C,key:E,target:this.getKeyTargets(C)[E]})}emitWillSaveState(C){this._onWillSaveState.fire({reason:C})}get(C,E,D){var f;return(f=this.getStorage(E))===null||f===void 0?void 0:f.get(C,D)}getBoolean(C,E,D){var f;return(f=this.getStorage(E))===null||f===void 0?void 0:f.getBoolean(C,D)}getNumber(C,E,D){var f;return(f=this.getStorage(E))===null||f===void 0?void 0:f.getNumber(C,D)}store(C,E,D,f){if((0,R.isUndefinedOrNull)(E)){this.remove(C,D);return}this.withPausedEmitters(()=>{var s;this.updateKeyTarget(C,D,f),(s=this.getStorage(D))===null||s===void 0||s.set(C,E)})}remove(C,E){this.withPausedEmitters(()=>{var D;this.updateKeyTarget(C,E,void 0),(D=this.getStorage(E))===null||D===void 0||D.delete(C)})}withPausedEmitters(C){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{C()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(C,E){const D=[],f=this.getKeyTargets(C);for(const s of Object.keys(f))f[s]===E&&D.push(s);return D}updateKeyTarget(C,E,D){var f,s;const r=this.getKeyTargets(E);typeof D=="number"?r[C]!==D&&(r[C]=D,(f=this.getStorage(E))===null||f===void 0||f.set(g,JSON.stringify(r))):typeof r[C]=="number"&&(delete r[C],(s=this.getStorage(E))===null||s===void 0||s.set(g,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(C){return C===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(C){const E=this.get(g,C);if(E)try{return JSON.parse(E)}catch(D){}return Object.create(null)}isNew(C){return this.getBoolean(e.IS_NEW_KEY,C)===!0}async flush(){var C,E,D,f;this._onWillSaveState.fire({reason:m.NONE}),await O.Promises.settled([(E=(C=this.getStorage(0))===null||C===void 0?void 0:C.whenFlushed())!==null&&E!==void 0?E:Promise.resolve(),(f=(D=this.getStorage(1))===null||D===void 0?void 0:D.whenFlushed())!==null&&f!==void 0?f:Promise.resolve()])}async logStorage(){var C,E,D,f,s,r;const t=(E=(C=this.getStorage(0))===null||C===void 0?void 0:C.items)!==null&&E!==void 0?E:new Map,i=(f=(D=this.getStorage(1))===null||D===void 0?void 0:D.items)!==null&&f!==void 0?f:new Map;return u(t,i,(s=this.getLogDetails(0))!==null&&s!==void 0?s:"",(r=this.getLogDetails(1))!==null&&r!==void 0?r:"")}}e.AbstractStorageService=v,v.DEFAULT_FLUSH_INTERVAL=60*1e3;class b extends v{constructor(){super();this.globalStorage=new U.Storage(new U.InMemoryStorageDatabase),this.workspaceStorage=new U.Storage(new U.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(C=>this.emitDidChangeValue(1,C))),this._register(this.globalStorage.onDidChangeStorage(C=>this.emitDidChangeValue(0,C)))}getStorage(C){return C===0?this.globalStorage:this.workspaceStorage}getLogDetails(C){return C===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(C){}}e.InMemoryStorageService=b;async function u(S,C,E,D){const f=a=>{try{return JSON.parse(a)}catch(c){return a}},s=new Map,r=new Map;S.forEach((a,c)=>{s.set(c,a),r.set(c,f(a))});const t=new Map,i=new Map;C.forEach((a,c)=>{t.set(c,a),i.set(c,f(a))}),console.group(`Storage: Global (path: ${E})`);let n=[];s.forEach((a,c)=>{n.push({key:c,value:a})}),console.table(n),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${D})`);let o=[];t.forEach((a,c)=>{o.push({key:c,value:a})}),console.table(o),console.groupEnd(),console.log(i)}e.logStorage=u}),define(Z[165],ee([0,1,3,2,29,33,19,15]),function(K,e,p,k,A,R,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let g=class extends k.Disposable{constructor(y){super();this._onDidChangeEnablement=new p.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new m(y)),this._register(this.storageManger.onDidChange(v=>this._onDidChangeEnablement.fire({extensions:v,source:"storage"})))}async enableExtension(y,v){return this._removeFromDisabledExtensions(y)?(this._onDidChangeEnablement.fire({extensions:[y],source:v}),!0):!1}async disableExtension(y,v){return this._addToDisabledExtensions(y)?(this._onDidChangeEnablement.fire({extensions:[y],source:v}),!0):!1}getDisabledExtensions(){return this._getExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(y){let v=this.getDisabledExtensions();return v.every(b=>!(0,R.areSameExtensions)(b,y))?(v.push(y),this._setDisabledExtensions(v),!0):!1}_removeFromDisabledExtensions(y){let v=this.getDisabledExtensions();for(let b=0;b<v.length;b++){const u=v[b];if((0,R.areSameExtensions)(u,y))return v.splice(b,1),this._setDisabledExtensions(v),!0}return!1}_setDisabledExtensions(y){this._setExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH,y)}_getExtensions(y){return this.storageManger.get(y,0)}_setExtensions(y,v){this.storageManger.set(y,v,0)}};g=fe([Y(0,U.IStorageService)],g),e.GlobalExtensionEnablementService=g;class m extends k.Disposable{constructor(y){super();this.storageService=y,this.storage=Object.create(null),this._onDidChange=this._register(new p.Emitter),this.onDidChange=this._onDidChange.event,this._register(y.onDidChangeValue(v=>this.onDidStorageChange(v)))}get(y,v){let b;return v===0?((0,O.isUndefinedOrNull)(this.storage[y])&&(this.storage[y]=this._get(y,v)),b=this.storage[y]):b=this._get(y,v),JSON.parse(b)}set(y,v,b){let u=JSON.stringify(v.map(({id:C,uuid:E})=>({id:C,uuid:E})));this._get(y,b)!==u&&(b===0&&(v.length?this.storage[y]=u:delete this.storage[y]),this._set(y,v.length?u:void 0,b))}onDidStorageChange(y){if(y.scope===0&&!(0,O.isUndefinedOrNull)(this.storage[y.key])&&this._get(y.key,y.scope)!==this.storage[y.key]){const b=this.get(y.key,y.scope);delete this.storage[y.key];const u=this.get(y.key,y.scope),S=b.filter(E=>!u.some(D=>(0,R.areSameExtensions)(E,D))),C=u.filter(E=>!b.some(D=>(0,R.areSameExtensions)(D,E)));(S.length||C.length)&&this._onDidChange.fire([...S,...C])}}_get(y,v){return this.storageService.get(y,v,"[]")}_set(y,v,b){v?this.storageService.store(y,v,b,1):this.storageService.remove(y,b)}}e.StorageManager=m}),define(Z[166],ee([0,1,3,2]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class A extends k.Disposable{constructor(m,T){super();this.channel=m,this.workspace=T}async getItems(){const m={workspace:this.workspace},T=await this.channel.call("getItems",m);return new Map(T)}updateItems(m){const T={workspace:this.workspace};return m.insert&&(T.insert=Array.from(m.insert.entries())),m.delete&&(T.delete=Array.from(m.delete.values())),this.channel.call("updateItems",T)}}class R extends A{constructor(m){super(m,void 0);this._onDidChangeItemsExternal=this._register(new p.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(m=>this.onDidChangeGlobalStorage(m)))}onDidChangeGlobalStorage(m){(Array.isArray(m.changed)||Array.isArray(m.deleted))&&this._onDidChangeItemsExternal.fire({changed:m.changed?new Map(m.changed):void 0,deleted:m.deleted?new Set(m.deleted):void 0})}async close(){this.dispose()}}class U extends A{constructor(m,T){super(m,T);this.onDidChangeItemsExternal=p.Event.None}async close(){const m={workspace:this.workspace};return this.channel.call("close",m)}}class O extends k.Disposable{constructor(m,T){super();this.channel=m,this.workspace=T,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new R(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new U(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=O}),define(Z[167],ee([0,1,2,19,68,6,156,166,12]),function(K,e,p,k,A,R,U,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class m extends k.AbstractStorageService{constructor(y,v,b){super();this.mainProcessService=v,this.environmentService=b,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new p.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(y)}createGlobalStorage(){const y=new O.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),v=new A.Storage(y.globalStorage);return this._register(v.onDidChangeStorage(b=>this.emitDidChangeValue(0,b))),v}createWorkspaceStorage(y){const v=new O.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),y);if(v.workspaceStorage){const b=new A.Storage(v.workspaceStorage);return this.workspaceStorageDisposable.value=b.onDidChangeStorage(u=>this.emitDidChangeValue(1,u)),this.workspaceStorageId=y==null?void 0:y.id,b}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){var y,v;(0,U.mark)("code/willInitStorage");try{await R.Promises.settled([this.globalStorage.init(),(v=(y=this.workspaceStorage)===null||y===void 0?void 0:y.init())!==null&&v!==void 0?v:Promise.resolve()])}finally{(0,U.mark)("code/didInitStorage")}}getStorage(y){return y===0?this.globalStorage:this.workspaceStorage}getLogDetails(y){return y===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,g.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){var y,v;this.stopFlushWhenIdle(),this.emitWillSaveState(k.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.globalStorage.close(),(v=(y=this.workspaceStorage)===null||y===void 0?void 0:y.close())!==null&&v!==void 0?v:Promise.resolve()])}async migrate(y){var v;const b=this.workspaceStorage,u=(v=b==null?void 0:b.items)!==null&&v!==void 0?v:new Map;b&&(await b.close(),b.dispose()),this.workspaceStorage=this.createWorkspaceStorage(y),await this.workspaceStorage.init();for(const[S,C]of u)this.workspaceStorage.set(S,C)}}e.NativeStorageService=m}),define(Z[168],ee([0,1,7,36,31,4]),function(K,e,p,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function U(m){if(p.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function O(m,T,y,v,b,u,S,C,E,D){const f=Object.create(null);f["common.machineId"]=S,f.sessionID=(0,A.generateUuid)()+Date.now(),f.commitHash=b,f.version=u,f["common.platformVersion"]=(T||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,p.PlatformToString)(p.platform),f["common.nodePlatform"]=k.platform,f["common.nodeArch"]=v,f["common.product"]=D||"desktop";const s=g(C||[]);s&&(f["common.msftInternal"]=s);let r=0;const t=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),p.isLinuxSnap&&(f["common.snap"]="true");const i=U(y);i&&(f["common.platformDetail"]=i);try{const n=await m.readFile(R.URI.file(E));f["common.source"]=n.value.toString().slice(0,30)}catch(n){}return f}e.resolveCommonProperties=O;function g(m){const T=k.env.USERDNSDOMAIN;if(!T)return!1;const y=T.toLowerCase();return m.some(v=>y===v)}e.verifyMicrosoftInternalDomain=g}),define(Z[22],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[169],ee([0,1,38,92,70,27,8,32,95,28,7,4,22,53,16,10,24]),function(K,e,p,k,A,R,U,O,g,m,T,y,v,b,u,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function E(t,i){const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],o=new Map,a=new Map,c=2e4;function l(h,P,_,j){const q=P.substring(h.length+1);return new Promise(async G=>{var M,z,$;let V;try{V=await(0,C.readdir)(P,{withFileTypes:!0})}catch(I){G();return}if(j.count>=c){j.count+=V.length,j.maxReached=!0,G();return}let H=V.length;if(H===0){G();return}let L=V;j.count+V.length>c&&(j.maxReached=!0,H=c-j.count,L=V.slice(0,H)),j.count+=V.length;for(const I of L)if(I.isDirectory()){if(_.includes(I.name)||await l(h,(0,U.join)(P,I.name),_,j),--H==0){G();return}}else{const F=I.name.lastIndexOf(".");if(F>=0){const N=I.name.substring(F+1);N&&o.set(N,((M=o.get(N))!==null&&M!==void 0?M:0)+1)}for(const N of n)((z=N.relativePathPattern)===null||z===void 0?void 0:z.test(q))!==!1&&N.filePattern.test(I.name)&&a.set(N.tag,(($=a.get(N.tag))!==null&&$!==void 0?$:0)+1);if(--H==0){G();return}}})}const d={count:0,maxReached:!1};await l(t,t,i,d);const w=await s(t);return{configFiles:D(a),fileTypes:D(o),fileCount:d.count,maxFilesReached:d.maxReached,launchConfigFiles:w}}e.collectWorkspaceStats=E;function D(t){return[...b.Iterable.map(t.entries(),([i,n])=>({name:i,count:n}))].sort((i,n)=>n.count-i.count)}function f(){const t={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/S.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/S.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(k.virtualMachineHint.value()*100)}%`},i=p.cpus();return i&&i.length>0&&(t.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),t}e.getMachineInfo=f;function s(t){let i=new Map,n=(0,U.join)(t,".vscode","launch.json");return new Promise((o,a)=>{(0,R.exists)(n,c=>{if(c)(0,R.readFile)(n,(l,d)=>{if(l)return o([]);const w=[],h=(0,O.parse)(d.toString(),w);if(w.length)return console.log(`Unable to parse ${n}`),o([]);if((0,O.getNodeType)(h)==="object"&&h.configurations)for(const P of h.configurations){const _=P.type;_&&(i.has(_)?i.set(_,i.get(_)+1):i.set(_,1))}return o(D(i))});else return o([])})})}e.collectLaunchConfigs=s;let r=class{constructor(i,n){this.telemetryService=i,this.productService=n}formatMachineInfo(i){const n=[];return n.push(`OS Version:       ${i.os}`),n.push(`CPUs:             ${i.cpus}`),n.push(`Memory (System):  ${i.memory}`),n.push(`VM:               ${i.vmHint}`),n.join(`
`)}formatEnvironment(i){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const o=p.cpus();return o&&o.length>0&&n.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),n.push(`Memory (System):  ${(p.totalmem()/S.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/S.ByteSize.GB).toFixed(2)}GB free)`),T.isWindows||n.push(`Load (avg):       ${p.loadavg().map(a=>Math.round(a)).join(", ")}`),n.push(`VM:               ${Math.round(k.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${i.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(i,n){return Promise.all([(0,g.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async o=>{let[a,c]=o,l=this.formatProcessList(i,a);return n.forEach(d=>{if((0,A.isRemoteDiagnosticError)(d))l+=`
${d.errorMessage}`,c+=`
${d.errorMessage}`;else if(l+=`

Remote: ${d.hostName}`,d.processes&&(l+=`
${this.formatProcessList(i,d.processes)}`),d.workspaceMetadata){c+=`
|  Remote: ${d.hostName}`;for(const w of Object.keys(d.workspaceMetadata)){const h=d.workspaceMetadata[w];let P=`${h.fileCount} files`;h.maxFilesReached&&(P=`more than ${P}`),c+=`|    Folder (${w}): ${P}`,c+=this.formatWorkspaceStats(h)}}}),{processInfo:l,workspaceInfo:c}})}async getSystemInfo(i,n){const{memory:o,vmHint:a,os:c,cpus:l}=f(),d={os:c,memory:o,cpus:l,vmHint:a,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:n};return T.isWindows||(d.load=`${p.loadavg().map(w=>Math.round(w)).join(", ")}`),T.isLinux&&(d.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(d)}async getDiagnostics(i,n){const o=[];return(0,g.listProcesses)(i.mainPID).then(async a=>(o.push(""),o.push(this.formatEnvironment(i)),o.push(""),o.push(this.formatProcessList(i,a)),i.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(i))),n.forEach(c=>{if((0,A.isRemoteDiagnosticError)(c))o.push(`
${c.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${c.hostName}`),o.push(this.formatMachineInfo(c.machineInfo)),c.processes&&o.push(this.formatProcessList(i,c.processes)),c.workspaceMetadata)for(const l of Object.keys(c.workspaceMetadata)){const d=c.workspaceMetadata[l];let w=`${d.fileCount} files`;d.maxFilesReached&&(w=`more than ${w}`),o.push(`Folder (${l}): ${w}`),o.push(this.formatWorkspaceStats(d))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(i){const n=[],o=60;let a=0;const c=(h,P)=>{const _=` ${h}(${P})`;a+_.length>o?(n.push(l),l="|                 ",a=l.length):a+=_.length,l+=_};let l="|      File types:";const d=10;let w=i.fileTypes.length>d?d:i.fileTypes.length;for(let h=0;h<w;h++){const P=i.fileTypes[h];c(P.name,P.count)}if(n.push(l),i.configFiles.length>=0&&(l="|      Conf files:",a=0,i.configFiles.forEach(h=>{c(h.name,h.count)}),n.push(l)),i.launchConfigFiles.length>0){let h="|      Launch Configs:";i.launchConfigFiles.forEach(P=>{h+=P.count>1?` ${P.name}(${P.count})`:` ${P.name}`}),n.push(h)}return n.join(`
`)}expandGPUFeatures(i){const n=Math.max(...Object.keys(i).map(o=>o.length));return Object.keys(i).map(o=>`${o}:  ${" ".repeat(n-o.length)}  ${i[o]}`).join(`
                  `)}formatWorkspaceMetadata(i){const n=[],o=[];return i.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(n.push(`|  Window (${a.title})`),a.folderURIs.forEach(c=>{const l=y.URI.revive(c);if(l.scheme===u.Schemas.file){const d=l.fsPath;o.push(E(d,["node_modules",".git"]).then(w=>{let h=`${w.fileCount} files`;w.maxFilesReached&&(h=`more than ${h}`),n.push(`|    Folder (${(0,U.basename)(d)}): ${h}`),n.push(this.formatWorkspaceStats(w))}).catch(w=>{n.push(`|      Error: Unable to collect workspace stats for folder ${d} (${w.toString()})`)}))}else n.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(a=>n.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(i,n){const o=new Map;i.windows.forEach(c=>o.set(c.pid,c.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(i.mainPID,o,a,n,0),a.join(`
`)}formatProcessItem(i,n,o,a,c){const l=c===0;let d;l?d=a.pid===i?`${this.productService.applicationName} main`:"remote agent":(d=`${"  ".repeat(c)} ${a.name}`,a.name==="window"&&(d=`${d} (${n.get(a.pid)})`));const w=process.platform==="win32"?a.mem:p.totalmem()*(a.mem/100);o.push(`${a.load.toFixed(0).padStart(5," ")}	${(w/S.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${d}`),Array.isArray(a.children)&&a.children.forEach(h=>this.formatProcessItem(i,n,o,h,c+1))}async reportWorkspaceStats(i){for(const{uri:n}of i.folders){const o=y.URI.revive(n);if(o.scheme===u.Schemas.file){const a=o.fsPath;try{const c=await E(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),c.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:l.name,count:l.count})}),c.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:l.name,count:l.count})}),c.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:l.name,count:l.count})})}catch(c){}}}}};r=fe([Y(0,v.ITelemetryService),Y(1,m.IProductService)],r),e.DiagnosticsService=r}),define(Z[170],ee([0,1,11,29,33,26,22,40,69,9,30,17,10,4,28,19,44,5,12]),function(K,e,p,k,A,R,U,O,g,m,T,y,v,b,u,S,C,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var f;(function(L){L[L.None=0]="None",L[L.IncludeVersions=1]="IncludeVersions",L[L.IncludeFiles=2]="IncludeFiles",L[L.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",L[L.IncludeSharedAccounts=8]="IncludeSharedAccounts",L[L.IncludeVersionProperties=16]="IncludeVersionProperties",L[L.ExcludeNonValidated=32]="ExcludeNonValidated",L[L.IncludeInstallationTargets=64]="IncludeInstallationTargets",L[L.IncludeAssetUri=128]="IncludeAssetUri",L[L.IncludeStatistics=256]="IncludeStatistics",L[L.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",L[L.Unpublished=4096]="Unpublished"})(f||(f={}));function s(...L){return String(L.reduce((I,F)=>I|F,0))}var r;(function(L){L[L.Tag=1]="Tag",L[L.ExtensionId=4]="ExtensionId",L[L.Category=5]="Category",L[L.ExtensionName=7]="ExtensionName",L[L.Target=8]="Target",L[L.Featured=9]="Featured",L[L.SearchText=10]="SearchText",L[L.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:f.None,criteria:[],assetTypes:[]};class a{constructor(I=o){this.state=I}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(I,F=this.state.pageSize){return new a(Object.assign(Object.assign({},this.state),{pageNumber:I,pageSize:F}))}withFilter(I,...F){const N=[...this.state.criteria,...F.length?F.map(W=>({filterType:I,value:W})):[{filterType:I}]];return new a(Object.assign(Object.assign({},this.state),{criteria:N}))}withSortBy(I){return new a(Object.assign(Object.assign({},this.state),{sortBy:I}))}withSortOrder(I){return new a(Object.assign(Object.assign({},this.state),{sortOrder:I}))}withFlags(...I){return new a(Object.assign(Object.assign({},this.state),{flags:I.reduce((F,N)=>F|N,0)}))}withAssetTypes(...I){return new a(Object.assign(Object.assign({},this.state),{assetTypes:I}))}get raw(){const{criteria:I,pageNumber:F,pageSize:N,sortBy:W,sortOrder:x,flags:X,assetTypes:Q}=this.state;return{filters:[{criteria:I,pageNumber:F,pageSize:N,sortBy:W,sortOrder:x}],assetTypes:Q,flags:X}}get searchText(){const I=this.state.criteria.filter(F=>F.filterType===r.SearchText)[0];return I&&I.value?I.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(I=>String(I.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function c(L,I){const F=(L||[]).filter(N=>N.statisticName===I)[0];return F?F.value:0}function l(L){const I="Microsoft.VisualStudio.Code.Translation.";return L.files.filter(N=>N.assetType.indexOf(I)===0).reduce((N,W)=>{const x=P(L,W.assetType);return x&&N.push([W.assetType.substring(I.length),x]),N},[])}function d(L){if(L.properties){const I=L.properties.filter(W=>W.key===t.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),N=I.filter(W=>F.test(W.value))[0];return N?{uri:N.value,fallbackUri:N.value}:null}return P(L,t.Repository)}function w(L){return{uri:`${L.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${L.fallbackAssetUri}/${t.VSIX}`}}function h(L){const I=P(L,t.Icon);if(I)return I;const F=k.DefaultIconPath;return{uri:F,fallbackUri:F}}function P(L,I){return L.files.filter(N=>N.assetType===I)[0]?{uri:`${L.assetUri}/${I}`,fallbackUri:`${L.fallbackAssetUri}/${I}`}:null}function _(L,I){const F=L.properties?L.properties.filter(W=>W.key===I):[],N=F.length>0&&F[0].value;return N?N.split(",").map(W=>(0,A.adoptToGalleryExtensionId)(W)):[]}function j(L){const I=L.properties?L.properties.filter(F=>F.key===i.Engine):[];return I.length>0&&I[0].value||""}function q(L){const I=L.properties?L.properties.filter(N=>N.key===i.LocalizedLanguages):[],F=I.length>0&&I[0].value||"";return F?F.split(","):[]}function G(L){return L.indexOf("preview")!==-1}function M(L){const I=L.properties?L.properties.find(F=>F.key===i.WebExtension):void 0;return!!I&&I.value==="true"}function z(L){return L.files.some(I=>I.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,D.joinPath)(b.URI.parse(L.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function $(L,I,F,N,W){const x={manifest:P(I,t.Manifest),readme:P(I,t.Details),changelog:P(I,t.Changelog),license:P(I,t.License),repository:d(I),download:w(I),icon:h(I),coreTranslations:l(I)};return{identifier:{id:(0,A.getGalleryExtensionId)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},name:L.extensionName,version:I.version,date:I.lastUpdated,displayName:L.displayName,publisherId:L.publisher.publisherId,publisher:L.publisher.publisherName,publisherDisplayName:L.publisher.displayName,description:L.shortDescription||"",installCount:c(L.statistics,"install"),rating:c(L.statistics,"averagerating"),ratingCount:c(L.statistics,"ratingcount"),assetUri:b.URI.parse(I.assetUri),webResource:z(I),assetTypes:I.files.map(({assetType:X})=>X),assets:x,properties:{dependencies:_(I,i.Dependency),extensionPack:_(I,i.ExtensionPack),engine:j(I),localizedLanguages:q(I),webExtension:M(I)},telemetryData:{index:(N.pageNumber-1)*N.pageSize+F,querySource:W},preview:G(L.flags)}}let V=class{constructor(I,F,N,W,x,X,Q){this.requestService=I,this.logService=F,this.environmentService=N,this.telemetryService=W,this.fileService=x,this.productService=X;const ne=X.extensionsGallery;this.extensionsGalleryUrl=ne&&ne.serviceUrl,this.extensionsControlUrl=ne&&ne.controlUrl,this.commonHeadersPromise=H(X.version,this.environmentService,this.fileService,Q)}api(I=""){return`${this.extensionsGalleryUrl}${I}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(I,F){const N=[];let{total:W,firstPage:x,getPage:X}=await this.query({names:I,pageSize:I.length},F);N.push(...x);for(let Q=1;N.length<W&&(x=await X(Q,F),x.length);Q++)N.push(...x);return N}async getCompatibleExtension(I,F){const N=await this.getCompatibleExtensionByEngine(I,F);return(N==null?void 0:N.properties.webExtension)?N.webResource?N:null:N}async getCompatibleExtensionByEngine(I,F){const N=(0,k.isIExtensionIdentifier)(I)?null:I;if(N&&N.properties.engine&&(0,g.isEngineValid)(N.properties.engine,this.productService.version,this.productService.date))return N;const{id:W,uuid:x}=N?N.identifier:I;let X=new a().withFlags(f.IncludeAssetUri,f.IncludeStatistics,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");x?X=X.withFilter(r.ExtensionId,x):X=X.withFilter(r.ExtensionName,W);const{galleryExtensions:Q}=await this.queryGallery(X,T.CancellationToken.None),[ne]=Q;if(!ne||!ne.versions.length)return null;if(F){const ce=ne.versions.filter(ue=>ue.version===F)[0];if(ce){const ue=$(ne,ce,0,X);if(ue.properties.engine&&(0,g.isEngineValid)(ue.properties.engine,this.productService.version,this.productService.date))return ue}return null}const ie=await this.getLastValidExtensionVersion(ne,ne.versions);return ie?$(ne,ie,0,X):null}async query(I,F){const N=T.CancellationToken.isCancellationToken(I)?{}:I,W=T.CancellationToken.isCancellationToken(I)?I:F;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let x=N.text||"";const X=(0,R.getOrDefault)(N,ge=>ge.pageSize,50);let Q=new a().withFlags(f.IncludeLatestVersionOnly,f.IncludeAssetUri,f.IncludeStatistics,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,X).withFilter(r.Target,"Microsoft.VisualStudio.Code");x?(x=x.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,pe,Ce)=>(Q=Q.withFilter(r.Category,Ce||pe),"")),x=x.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,pe,Ce)=>(Q=Q.withFilter(r.Tag,Ce||pe),"")),x=x.replace(/\bfeatured(\s+|\b|$)/g,()=>(Q=Q.withFilter(r.Featured),"")),x=x.trim(),x&&(x=x.length<200?x:x.substring(0,200),Q=Q.withFilter(r.SearchText,x)),Q=Q.withSortBy(0)):N.ids?Q=Q.withFilter(r.ExtensionId,...N.ids):N.names?Q=Q.withFilter(r.ExtensionName,...N.names):Q=Q.withSortBy(4),typeof N.sortBy=="number"&&(Q=Q.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(Q=Q.withSortOrder(N.sortOrder));const{galleryExtensions:ne,total:ie}=await this.queryGallery(Q,W),ce=ne.map((ge,pe)=>$(ge,ge.versions[0],pe,Q,N.source)),ue=async(ge,pe)=>{if(pe.isCancellationRequested)throw(0,p.canceled)();const Ce=Q.withPage(ge+1),{galleryExtensions:Oe}=await this.queryGallery(Ce,pe);return Oe.map((_e,Te)=>$(_e,_e.versions[0],Te,Ce,N.source))};return{firstPage:ce,total:ie,pageSize:Q.pageSize,getPage:ue}}async queryGallery(I,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");I=I.withFlags(I.flags,f.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,s(f.Unpublished));const N=await this.commonHeadersPromise,W=JSON.stringify(I.raw),x=Object.assign(Object.assign({},N),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)}),X=new Date().getTime();let Q,ne,ie=0;try{if(Q=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:W,headers:x},F),Q.res.statusCode&&Q.res.statusCode>=400&&Q.res.statusCode<500)return{galleryExtensions:[],total:ie};const ce=await(0,O.asJson)(Q);if(ce){const ue=ce.results[0],ge=ue.extensions,pe=ue.resultMetadata&&ue.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return ie=pe&&pe.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:ie}}return{galleryExtensions:[],total:ie}}catch(ce){throw ne=ce,ce}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},I.telemetryData),{requestBodySize:String(W.length),duration:new Date().getTime()-X,success:!!Q&&(0,O.isSuccess)(Q),responseBodySize:Q==null?void 0:Q.res.headers["Content-Length"],statusCode:Q?String(Q.res.statusCode):void 0,errorCode:ne?(0,p.isPromiseCanceledError)(ne)?"canceled":(0,p.getErrorMessage)(ne).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ie)}))}}async reportStatistic(I,F,N,W){if(!!this.isEnabled()){const x=await this.commonHeadersPromise,X=Object.assign(Object.assign({},x),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${I}/extensions/${F}/${N}/stats?statType=${W}`),headers:X},T.CancellationToken.None)}catch(Q){}}}async download(I,F,N){this.logService.trace("ExtensionGalleryService#download",I.identifier.id);const W=(0,A.getGalleryExtensionTelemetryData)(I),x=new Date().getTime(),X=ce=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},W),{duration:ce})),Q=N===1?"install":N===2?"update":"",ne=Q?{uri:`${I.assets.download.uri}&${Q}=true`,fallbackUri:`${I.assets.download.fallbackUri}?${Q}=true`}:I.assets.download,ie=await this.getAsset(ne);await this.fileService.writeFile(F,ie.stream),X(new Date().getTime()-x)}async getReadme(I,F){if(I.assets.readme){const N=await this.getAsset(I.assets.readme,{},F);return await(0,O.asText)(N)||""}return""}async getManifest(I,F){if(I.assets.manifest){const N=await this.getAsset(I.assets.manifest,{},F),W=await(0,O.asText)(N);return W?JSON.parse(W):null}return null}async getCoreTranslation(I,F){const N=I.assets.coreTranslations.filter(W=>W[0]===F.toUpperCase())[0];if(N){const W=await this.getAsset(N[1]),x=await(0,O.asText)(W);return x?JSON.parse(x):null}return null}async getChangelog(I,F){if(I.assets.changelog){const N=await this.getAsset(I.assets.changelog,{},F);return await(0,O.asText)(N)||""}return""}async getAllVersions(I,F){let N=new a().withFlags(f.IncludeVersions,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");I.identifier.uuid?N=N.withFilter(r.ExtensionId,I.identifier.uuid):N=N.withFilter(r.ExtensionName,I.identifier.id);const W=[],{galleryExtensions:x}=await this.queryGallery(N,T.CancellationToken.None);return x.length&&(F?await Promise.all(x[0].versions.map(async X=>{let Q;try{Q=await this.getEngine(X)}catch(ne){}Q&&(0,g.isEngineValid)(Q,this.productService.version,this.productService.date)&&W.push({version:X.version,date:X.lastUpdated})})):W.push(...x[0].versions.map(X=>({version:X.version,date:X.lastUpdated})))),W}async getAsset(I,F={},N=T.CancellationToken.None){const W=await this.commonHeadersPromise,x={type:"GET"},X=Object.assign(Object.assign({},W),F.headers||{});F=Object.assign(Object.assign(Object.assign({},F),x),{headers:X});const Q=I.uri,ne=I.fallbackUri,ie=Object.assign(Object.assign({},F),{url:Q});try{const ce=await this.requestService.request(ie,N);if(ce.res.statusCode===200)return ce;const ue=await(0,O.asText)(ce);throw new Error(`Expected 200, got back ${ce.res.statusCode} instead.

${ue}`)}catch(ce){if((0,p.isPromiseCanceledError)(ce))throw ce;const ue=(0,p.getErrorMessage)(ce);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Q,message:ue});const ge=Object.assign(Object.assign({},F),{url:ne});return this.requestService.request(ge,N)}}async getLastValidExtensionVersion(I,F){const N=this.getLastValidExtensionVersionFromProperties(I,F);return N||this.getLastValidExtensionVersionRecursively(I,F)}getLastValidExtensionVersionFromProperties(I,F){for(const N of F){const W=j(N);if(!W)return null;if((0,g.isEngineValid)(W,this.productService.version,this.productService.date))return N}return null}async getEngine(I){const F=j(I);if(F)return F;const N=P(I,t.Manifest);if(!N)throw new Error("Manifest was not found");const W={"Accept-Encoding":"gzip"},x=await this.getAsset(N,{headers:W}),X=await(0,O.asJson)(x);if(X)return X.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(I,F){if(!F.length)return null;const N=F[0],W=await this.getEngine(N);return(0,g.isEngineValid)(W,this.productService.version,this.productService.date)?(N.properties=N.properties||[],N.properties.push({key:i.Engine,value:W}),N):this.getLastValidExtensionVersionRecursively(I,F.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const I=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},T.CancellationToken.None);if(I.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await(0,O.asJson)(I),N=new Map;if(F)for(const W of F.malicious){const x=N.get(W)||{id:{id:W},malicious:!0,slow:!1};x.malicious=!0,N.set(W,x)}return[...N.values()]}};V=fe([Y(0,O.IRequestService),Y(1,y.ILogService),Y(2,m.IEnvironmentService),Y(3,U.ITelemetryService),Y(4,v.IFileService),Y(5,u.IProductService),Y(6,(0,E.optional)(S.IStorageService))],V),e.ExtensionGalleryService=V;async function H(L,I,F,N){const W={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L}`},x=await(0,C.getServiceMachineId)(I,F,N);return W["X-Market-User-Id"]=x,W}e.resolveMarketplaceHeaders=H}),define(Z[171],ee([0,1,4,8,28,9,36,10,7,18,29,62,40,17,164,6,22,72,108,19,3,57]),function(K,e,p,k,A,R,U,O,g,m,T,y,v,b,u,S,C,E,D,f,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",i="extensionTips/lastPromptedMediumImpExeTime";let n=class extends u.ExtensionTipsService{constructor(a,c,l,d,w,h,P,_,j,q){super(P,_,j,q);this.environmentService=a,this.telemetryService=c,this.extensionManagementService=l,this.storageService=d,this.nativeHostService=w,this.extensionRecommendationNotificationService=h,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,_.exeBasedExtensionTips&&(0,y.forEach)(_.exeBasedExtensionTips,({key:G,value:M})=>{const z=[],$=[],V=[];(0,y.forEach)(M.recommendations,({key:H,value:L})=>{L.important?M.important?z.push({extensionId:H,extensionName:L.name,isExtensionPack:!!L.isExtensionPack}):$.push({extensionId:H,extensionName:L.name,isExtensionPack:!!L.isExtensionPack}):V.push({extensionId:H,extensionName:L.name,isExtensionPack:!!L.isExtensionPack})}),z.length&&this.highImportanceExecutableTips.set(G,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:z}),$.length&&this.mediumImportanceExecutableTips.set(G,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:$}),V.length&&this.allOtherExecutableTips.set(G,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:V})}),(0,S.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...a,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(a,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,l)}groupImportantTipsByExe(a,c){const l=new Map;a.forEach(_=>l.set(_.extensionId.toLowerCase(),_));const{installed:d,uninstalled:w}=this.groupByInstalled([...l.keys()],c);for(const _ of d){const j=l.get(_);j&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:_,exeName:(0,k.basename)(j.windowsPath)})}for(const _ of w){const j=l.get(_);j&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:_,exeName:(0,k.basename)(j.windowsPath)})}const h=this.getPromptedExecutableTips(),P=new Map;for(const _ of w){const j=l.get(_);if(j&&(!h[j.exeName]||!h[j.exeName].includes(j.extensionId))){let q=P.get(j.exeName);q||(q=[],P.set(j.exeName,q)),q.push(j)}}return P}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size!==0){const[a,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(a);break;case"incompatibleWindow":const d=s.Event.once(s.Event.latch(s.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const w=this._register((0,S.disposableTimeout)(()=>{w.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size!==0){const a=this.getLastPromptedMediumExeTime(),c=Date.now()-a,l=7*24*60*60*1e3;if(c<l){const h=this._register((0,S.disposableTimeout)(()=>{h.dispose(),this.promptMediumImportanceExeBasedTip()},l-c));return}const[d,w]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(w).then(h=>{switch(h){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(w[0].exeName,w);const P=this._register((0,S.disposableTimeout)(()=>{P.dispose(),this.promptMediumImportanceExeBasedTip()},l));break;case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const _=s.Event.once(s.Event.latch(s.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const j=this._register((0,S.disposableTimeout)(()=>{j.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}}promptExeRecommendations(a){const c=a.map(({extensionId:d})=>d.toLowerCase()),l=(0,D.localize)(0,null,a[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(c,l,`@exe:"${a[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let a=this.storageService.getNumber(i,0);return a||(a=Date.now(),this.updateLastPromptedMediumExeTime(a)),a}updateLastPromptedMediumExeTime(a){this.storageService.store(i,a,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(a,c){const l=this.getPromptedExecutableTips();l[a]=c.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(t,JSON.stringify(l),0,0)}groupByInstalled(a,c){const l=[],d=[],w=c.reduce((h,P)=>(h.add(P.identifier.id.toLowerCase()),h),new Set);return a.forEach(h=>{w.has(h.toLowerCase())?l.push(h):d.push(h)}),{installed:l,uninstalled:d}}async getValidExecutableBasedExtensionTips(a){const c=[],l=new Map;for(const d of a.keys()){const w=a.get(d);if(!(!w||!(0,m.isNonEmptyArray)(w.recommendations))){const h=[];g.isWindows?w.windowsPath&&h.push(w.windowsPath.replace("%USERPROFILE%",U.env.USERPROFILE).replace("%ProgramFiles(x86)%",U.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",U.env.ProgramFiles).replace("%APPDATA%",U.env.APPDATA).replace("%WINDIR%",U.env.WINDIR)):(h.push((0,k.join)("/usr/local/bin",d)),h.push((0,k.join)("/usr/bin",d)),h.push((0,k.join)(this.environmentService.userHome.fsPath,d)));for(const P of h){let _=l.get(P);if(_===void 0&&(_=await this.fileService.exists(p.URI.file(P)),l.set(P,_)),_)for(const{extensionId:j,extensionName:q,isExtensionPack:G}of w.recommendations)c.push({extensionId:j,extensionName:q,isExtensionPack:G,exeName:d,exeFriendlyName:w.exeFriendlyName,windowsPath:w.windowsPath})}}}return c}};n=fe([Y(0,R.INativeEnvironmentService),Y(1,C.ITelemetryService),Y(2,T.IExtensionManagementService),Y(3,f.IStorageService),Y(4,r.INativeHostService),Y(5,E.IExtensionRecommendationNotificationService),Y(6,O.IFileService),Y(7,A.IProductService),Y(8,v.IRequestService),Y(9,b.ILogService)],n),e.ExtensionTipsService=n}),define(Z[79],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(R){this.appender=R}listen(R,U){throw new Error(`Event not found: ${U}`)}call(R,U,{eventName:O,data:g}){return this.appender.log(O,g),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class k{constructor(R){this.channel=R}log(R,U){return this.channel.call("log",{eventName:R,data:U}).then(void 0,O=>`Failed to log telemetry: ${console.warn(O)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=k}),define(Z[80],ee([0,1,51,118,21,5,25,39,2,26,35]),function(K,e,p,k,A,R,U,O,g,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(u,S){this._configurationService=S,this._experimentProperties={},this._disposables=new g.DisposableStore,this._cleanupPatterns=[],this._appender=u.appender,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let C of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(C),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(C=>{const E=/^[a-f0-9]+$/i.test(C["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!E})}))}setExperimentProperty(u,S){this._experimentProperties[u]=S}setEnabled(u){this._enabled=u}_updateUserOptIn(){var u;const S=(u=this._configurationService)===null||u===void 0?void 0:u.getValue(v);this._userOptIn=S?S.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const u=await this._commonProperties;let S=u.sessionID,C=u["common.instanceId"],E=u["common.machineId"],D=u["common.firstSessionDate"],f=u["common.msftInternal"];return{sessionId:S,instanceId:C,machineId:E,firstSessionDate:D,msftInternal:f}}dispose(){this._disposables.dispose()}publicLog(u,S,C){return this.isOptedIn?this._commonProperties.then(E=>{S=(0,m.mixin)(S,E),S=(0,m.mixin)(S,this._experimentProperties),S=(0,m.cloneAndChange)(S,D=>{if(typeof D=="string")return this._cleanupInfo(D,C)}),this._appender.log(u,S)},E=>{console.error(E)}):Promise.resolve(void 0)}publicLog2(u,S,C){return this.publicLog(u,S,C)}publicLogError(u,S){return this.sendErrorTelemetry?this.publicLog(u,S,!0):Promise.resolve(void 0)}publicLogError2(u,S){return this.publicLogError(u,S)}_cleanupInfo(u,S){let C=u;if(S){const E=[];for(let r of this._cleanupPatterns)for(;;){const t=r.exec(u);if(!t)break;E.push([t.index,r.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(C="";;){const r=f.exec(u);if(!r)break;!D.test(r[0])&&E.every(([t,i])=>r.index<t||r.index>=i)&&(C+=u.substring(s,r.index)+"<REDACTED: user-file-path>",s=f.lastIndex)}s<u.length&&(C+=u.substr(s))}for(let E of this._cleanupPatterns)C=C.replace(E,"");return C}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=fe([Y(1,(0,R.optional)(U.IConfigurationService))],y),e.TelemetryService=y;const v="telemetry";T.Registry.as(O.Extensions.Configuration).registerConfiguration({id:v,order:110,type:"object",title:(0,k.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:p.default.privacyStatementUrl?(0,k.localize)(2,null,p.default.privacyStatementUrl):(0,k.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(Z[58],ee([0,1,25,26,15,6]),function(K,e,p,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(u,S){return Promise.resolve(void 0)}publicLog2(u,S){return this.publicLog(u,S)}publicLogError(u,S){return Promise.resolve(void 0)}publicLogError2(u,S){return this.publicLogError(u,S)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class U{async publicLog(S,C,E){}async publicLogError(S,C,E){}}e.NullEndpointTelemetryService=U;function O(...u){return{log:(S,C)=>u.forEach(E=>E.log(S,C)),flush:()=>R.Promises.settled(u.map(S=>S.flush()))}}e.combinedAppender=O,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(u,S){return S.onDidChangeConfiguration(C=>{C.source!==6&&u.publicLog2("updateConfiguration",{configurationSource:(0,p.ConfigurationTargetToString)(C.source),configurationKeys:v(C.sourceConfig)})})}e.configurationTelemetry=g;function m(u){const S=Object.create(null),C=Object.create(null),E=Object.create(null);y(u,E);for(let D in E){D=D.length>150?D.substr(D.length-149):D;const f=E[D];typeof f=="number"?C[D]=f:typeof f=="boolean"?C[D]=f?1:0:typeof f=="string"?S[D]=f.substring(0,1023):typeof f!="undefined"&&f!==null&&(S[D]=f)}return{properties:S,measurements:C}}e.validateTelemetryData=m;function T(u){if(!u)return"none";let S="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(E=>{u.indexOf(`${E}+`)===0&&(S=E)}),S}e.cleanRemoteAuthority=T;function y(u,S,C=0,E){if(!!u)for(let D of Object.getOwnPropertyNames(u)){const f=u[D],s=E?E+D:D;Array.isArray(f)?S[s]=(0,k.safeStringify)(f):f instanceof Date?S[s]=f.toISOString():(0,A.isObject)(f)?C<2?y(f,S,C+1,s+"."):S[s]=(0,k.safeStringify)(f):S[s]=f}}function v(u){if(!u)return[];const S=[];return b(S,"",u),S}function b(u,S,C){C&&typeof C=="object"&&!Array.isArray(C)?Object.keys(C).forEach(E=>b(u,S?`${S}.${E}`:E,C[E])):u.push(S)}}),define(Z[172],ee([0,1,2,9,17,58]),function(K,e,p,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let U=class extends p.Disposable{constructor(g,m){super();this.logger=this._register(g.createLogger(m.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(g,m){this.logger.trace(`telemetry/${g}`,(0,R.validateTelemetryData)(m))}};U=fe([Y(0,A.ILoggerService),Y(1,k.IEnvironmentService)],U),e.TelemetryLogAppender=U}),define(Z[173],ee([0,1,11,26,58]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function R(O){const g=await new Promise((T,y)=>{K(["applicationinsights"],T,y)});let m;return g.defaultClient?(m=new g.TelemetryClient(O),m.channel.setUseDiskRetryCaching(!0)):(g.setup(O).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),m=g.defaultClient),O.indexOf("AIF-")===0&&(m.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),m}class U{constructor(g,m,T){this._eventPrefix=g,this._defaultData=m,this._defaultData||(this._defaultData=Object.create(null)),typeof T=="function"?this._aiClient=T():this._aiClient=T,this._asyncAIClient=null}_withAIClient(g){if(!!this._aiClient){if(typeof this._aiClient!="string"){g(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient)),this._asyncAIClient.then(m=>{g(m)},m=>{(0,p.onUnexpectedError)(m),console.error(m)})}}log(g,m){!this._aiClient||(m=(0,k.mixin)(m,this._defaultData),m=(0,A.validateTelemetryData)(m),this._withAIClient(T=>T.trackEvent({name:this._eventPrefix+"/"+g,properties:m.properties,measurements:m.measurements})))}flush(){return this._aiClient?new Promise(g=>{this._withAIClient(m=>{m.flush({callback:()=>{this._aiClient=void 0,g(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=U}),define(Z[174],ee([0,1,49,79,16,80,25,22]),function(K,e,p,k,A,R,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let g=class{constructor(T,y){this.configurationService=T,this.telemetryService=y,this.customTelemetryServices=new Map}async getCustomTelemetryService(T){if(!this.customTelemetryServices.has(T.id)){const{machineId:y,sessionId:v}=await this.telemetryService.getTelemetryInfo(),b=Object.create(null);b["common.vscodemachineid"]=y,b["common.vscodesessionid"]=v;const u=[T.id,JSON.stringify(b),T.aiKey],C=new p.Client(A.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:u,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),E=new k.TelemetryAppenderClient(C);this.customTelemetryServices.set(T.id,new R.TelemetryService({appender:E,sendErrorTelemetry:T.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(T.id)}async publicLog(T,y,v){await(await this.getCustomTelemetryService(T)).publicLog(y,v)}async publicLogError(T,y,v){await(await this.getCustomTelemetryService(T)).publicLogError(y,v)}};g=fe([Y(0,U.IConfigurationService),Y(1,O.ITelemetryService)],g),e.CustomEndpointTelemetryService=g}),define(Z[81],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FlowControlConstants=e.LocalReconnectConstants=e.HeartbeatConstants=e.IPtyService=e.ILocalTerminalService=e.TerminalIpcChannels=e.WindowsShellType=void 0;var k;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.Log="log",g.Heartbeat="heartbeat"})(A=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.ILocalTerminalService=(0,p.createDecorator)("localTerminalService"),e.IPtyService=(0,p.createDecorator)("ptyService");var R;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(R=e.HeartbeatConstants||(e.HeartbeatConstants={}));var U;(function(g){g[g.ReconnectionGraceTime=6e4]="ReconnectionGraceTime",g[g.ReconnectionShortGraceTime=6e3]="ReconnectionShortGraceTime"})(U=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var O;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(O=e.FlowControlConstants||(e.FlowControlConstants={}))}),define(Z[175],ee([0,1,5]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,p.createDecorator)("localPtyService")}),define(Z[176],ee([0,1,2,17,81,49,16,34,3,76,22]),function(K,e,p,k,A,R,U,O,g,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var y;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})(y||(y={}));let v=0,b=class extends p.Disposable{constructor(S,C){super();this._logService=S,this._telemetryService=C,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new g.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new g.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new g.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new g.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onProcessData=this._register(new g.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new g.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new g.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new g.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new g.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new g.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new g.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new g.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new g.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._register((0,p.toDisposable)(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const S=new R.Client(U.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:v,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}});this._onPtyHostStart.fire(),O.ProxyChannel.toService(S.getChannel(A.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(S.onDidProcessExit(f=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(f.code),this._isDisposed||(this._restartCount<=y.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${f.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${f.code}, giving up`))}));const E=S.getChannel(A.TerminalIpcChannels.Log);m.LogLevelChannelClient.setLevel(E,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{m.LogLevelChannelClient.setLevel(E,this._logService.getLevel())}));const D=O.ProxyChannel.toService(S.getChannel(A.TerminalIpcChannels.PtyHost));return this._register(D.onProcessData(f=>this._onProcessData.fire(f))),this._register(D.onProcessExit(f=>this._onProcessExit.fire(f))),this._register(D.onProcessReady(f=>this._onProcessReady.fire(f))),this._register(D.onProcessTitleChanged(f=>this._onProcessTitleChanged.fire(f))),this._register(D.onProcessShellTypeChanged(f=>this._onProcessShellTypeChanged.fire(f))),this._register(D.onProcessOverrideDimensions(f=>this._onProcessOverrideDimensions.fire(f))),this._register(D.onProcessResolvedShellLaunchConfig(f=>this._onProcessResolvedShellLaunchConfig.fire(f))),this._register(D.onProcessReplay(f=>this._onProcessReplay.fire(f))),this._register(D.onProcessOrphanQuestion(f=>this._onProcessOrphanQuestion.fire(f))),[S,D]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(S,C,E,D,f,s,r,t,i,n){const o=setTimeout(()=>this._handleUnresponsiveCreateProcess(),A.HeartbeatConstants.CreateProcessTimeout),a=await this._proxy.createProcess(S,C,E,D,f,s,r,t,i,n);return clearTimeout(o),v=Math.max(v,a),a}updateTitle(S,C){return this._proxy.updateTitle(S,C)}updateIcon(S,C,E){return this._proxy.updateIcon(S,C,E)}attachToProcess(S){return this._proxy.attachToProcess(S)}detachFromProcess(S){return this._proxy.detachFromProcess(S)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(S){return this._proxy.start(S)}shutdown(S,C){return this._proxy.shutdown(S,C)}input(S,C){return this._proxy.input(S,C)}processBinary(S,C){return this._proxy.processBinary(S,C)}resize(S,C,E){return this._proxy.resize(S,C,E)}acknowledgeDataEvent(S,C){return this._proxy.acknowledgeDataEvent(S,C)}getInitialCwd(S){return this._proxy.getInitialCwd(S)}getCwd(S){return this._proxy.getCwd(S)}getLatency(S){return this._proxy.getLatency(S)}orphanQuestionReply(S){return this._proxy.orphanQuestionReply(S)}getDefaultSystemShell(S){return this._proxy.getDefaultSystemShell(S)}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(S){return this._proxy.getWslPath(S)}setTerminalLayoutInfo(S){return this._proxy.setTerminalLayoutInfo(S)}async getTerminalLayoutInfo(S){return await this._proxy.getTerminalLayoutInfo(S)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier+A.HeartbeatConstants.BeatInterval*A.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${A.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}};b=fe([Y(0,k.ILogService),Y(1,T.ITelemetryService)],b),e.PtyHostService=b}),define(Z[52],ee([0,1,41]),function(K,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function k(U,O,g,m){const T=(0,p.setProperty)(U,O,g,m)[0];return T&&(U=U.substring(0,T.offset)+T.content+U.substring(T.offset+T.length)),U}e.edit=k;function A(U,O,g){let m=g;for(;m>=0;){if(U.charAt(m)===O.charAt(O.length-1)&&O.length===1)return m+1;if(m--,O.length===2&&m>=0&&U.charAt(m)===O.charAt(0))return m+2}return 0}e.getLineStartOffset=A;function R(U,O,g){let m=g;for(;m>=0;)if(U.charAt(m)===O.charAt(O.length-1)&&O.length===1||(m++,O.length===2&&m>=0&&U.charAt(m)===O.charAt(1)))return m;return U.length-1}e.getLineEndOffset=R}),define(Z[177],ee([0,1,26,56]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(y,v,b,u,S){var C,E;const D=[],f=[],s=[];if(!v){const j=y.filter(({identifier:q})=>S.every(G=>G.toLowerCase()!==q.id.toLowerCase()));return{added:D,removed:f,updated:s,remote:j.length>0?j:null}}y=y.map(m),v=v.map(m),b=b?b.map(m):null;const r=new Map,t=j=>{j.uuid&&r.set(j.id.toLowerCase(),j.uuid)};y.forEach(({identifier:j})=>t(j)),v.forEach(({identifier:j})=>t(j)),b&&b.forEach(({identifier:j})=>t(j));const i=j=>{const q=j.identifier.uuid||r.get(j.identifier.id.toLowerCase());return q?`uuid:${q}`:`id:${j.identifier.id.toLowerCase()}`},n=(j,q)=>(j.set(i(q),q),j),o=y.reduce(n,new Map),a=v.reduce(n,new Map),c=v.reduce((j,q)=>{const G=i(q);q=(0,p.deepClone)(q);const M=o.get(G);return M&&(M.installed&&(q.installed=!0),q.version||(q.version=M.version)),n(j,q)},new Map),l=b?b.reduce(n,new Map):null,d=u.reduce(n,new Map),w=S.reduce((j,q)=>{const G=r.get(q.toLowerCase());return j.add(G?`uuid:${G}`:`id:${q.toLowerCase()}`)},new Set),h=R(o,a,w);if(h.added.size>0||h.removed.size>0||h.updated.size>0){const j=R(l,o,w),q=R(l,a,w),G=(M,z)=>{const $=o.get(M);if($){const V=a.get(M);return Object.assign(Object.assign({},z?V:$),{version:(V.version&&k.gt(V.version,$.version),$.version),state:U($,V,l==null?void 0:l.get(M))})}};for(const M of q.removed.values()){const z=o.get(M);z&&f.push(z.identifier)}for(const M of q.added.values())if(j.added.has(M)){if(h.updated.has(M)){const z=G(M,!0);z&&(s.push(T(z,M)),c.set(M,z))}}else{const z=a.get(M);z.installed&&D.push(T(z,M))}for(const M of q.updated.values()){const z=G(M,!0);z&&(s.push(T(z,M)),c.set(M,z))}for(const M of j.added.values())q.added.has(M)||c.set(M,o.get(M));for(const M of j.updated.values())if(!q.removed.has(M)&&!q.updated.has(M)){const z=G(M,!1);z&&(((C=c.get(M))===null||C===void 0?void 0:C.installed)&&(z.installed=!0),c.set(M,z))}for(const M of j.removed.values())!d.has(M)&&!q.updated.has(M)&&((E=l==null?void 0:l.get(M))===null||E===void 0?void 0:E.installed)&&c.delete(M)}const P=[],_=R(a,c,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&c.forEach((j,q)=>P.push(T(j,q))),{added:D,removed:f,updated:s,remote:P.length?P:null}}e.merge=A;function R(y,v,b,{checkInstalledProperty:u,checkVersionProperty:S}={checkInstalledProperty:!1,checkVersionProperty:!1}){const C=y?[...y.keys()].filter(r=>!b.has(r)):[],E=[...v.keys()].filter(r=>!b.has(r)),D=E.filter(r=>C.indexOf(r)===-1).reduce((r,t)=>(r.add(t),r),new Set),f=C.filter(r=>E.indexOf(r)===-1).reduce((r,t)=>(r.add(t),r),new Set),s=new Set;for(const r of C)if(!f.has(r)){const t=y.get(r),i=v.get(r);(!i||t.disabled!==i.disabled||!g(t.state,i.state)||S&&t.version!==i.version||u&&t.installed!==i.installed)&&s.add(r)}return{added:D,removed:f,updated:s}}function U(y,v,b){const u=y.state,S=v.state,C=b==null?void 0:b.state;if(!v.version||u&&k.gt(y.version,v.version))return u;if(S&&k.gt(v.version,y.version)||!u)return S;if(!S)return u;const E=(0,p.deepClone)(u),D=C?O(C,S):{added:Object.keys(S).reduce((s,r)=>(s.add(r),s),new Set),removed:new Set,updated:new Set},f=C?O(C,u):{added:Object.keys(u).reduce((s,r)=>(s.add(r),s),new Set),removed:new Set,updated:new Set};for(const s of[...D.added.values(),...D.updated.values()])E[s]=S[s];for(const s of D.removed.values())f.updated.has(s)||delete E[s];return E}function O(y,v){const b=Object.keys(y),u=Object.keys(v),S=u.filter(D=>b.indexOf(D)===-1).reduce((D,f)=>(D.add(f),D),new Set),C=b.filter(D=>u.indexOf(D)===-1).reduce((D,f)=>(D.add(f),D),new Set),E=new Set;for(const D of b)if(!C.has(D)){const f=y[D],s=v[D];(0,p.equals)(f,s)||E.add(D)}return{added:S,removed:C,updated:E}}function g(y={},v={}){const{added:b,removed:u,updated:S}=O(y,v);return b.size===0&&u.size===0&&S.size===0}function m(y){return Object.assign(Object.assign({},y),{disabled:!!y.disabled,installed:!!y.installed})}function T(y,v){const b={identifier:{id:y.identifier.id,uuid:v.startsWith("uuid:")?v.substring("uuid:".length):void 0}};return y.version&&(b.version=y.version),y.disabled&&(b.disabled=!0),y.installed&&(b.installed=!0),y.state&&(b.state=y.state),b}}),define(Z[82],ee([0,1,18,3,2,33,5,28,19]),function(K,e,p,k,A,R,U,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,U.createDecorator)("IExtensionsStorageSyncService");const m=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let T=class Qe extends A.Disposable{constructor(v,b){super();this.storageService=v,this.productService=b,this._onDidChangeExtensionsStorage=this._register(new k.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(u=>this.onDidChangeStorageValue(u)))}static toKey(v){return`extensionKeys/${(0,R.adoptToGalleryExtensionId)(v.id)}@${v.version}`}static fromKey(v){const b=m.exec(v);if(b&&b[1])return{id:b[1],version:b[2]}}initialize(){const v=this.storageService.keys(0,1);for(const b of v){const u=Qe.fromKey(b);u&&this.extensionsWithKeysForSync.add(u.id.toLowerCase())}}onDidChangeStorageValue(v){if(v.scope===0){if(this.extensionsWithKeysForSync.has(v.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const b=Qe.fromKey(v.key);if(b){this.extensionsWithKeysForSync.add(b.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}}setKeysForSync(v,b){this.storageService.store(Qe.toKey(v),JSON.stringify(b),0,1)}getKeysForSync(v){var b;const u=(b=this.productService.extensionSyncedKeys)===null||b===void 0?void 0:b[v.id.toLowerCase()],S=this.storageService.get(Qe.toKey(v),0),C=S?JSON.parse(S):void 0;return C&&u?(0,p.distinct)([...C,...u]):C||u}};T=fe([Y(0,g.IStorageService),Y(1,O.IProductService)],T),e.ExtensionsStorageSyncService=T}),define(Z[83],ee([0,1,18,25,5]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,A.createDecorator)("IIgnoredExtensionsManagementService");let R=class{constructor(O){this.configurationService=O}hasToNeverSyncExtension(O){return this.getConfiguredIgnoredExtensions().includes(O.toLowerCase())}hasToAlwaysSyncExtension(O){return this.getConfiguredIgnoredExtensions().includes(`-${O.toLowerCase()}`)}updateIgnoredExtensions(O,g){let m=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(T=>T.toLowerCase());return m=m.filter(T=>T!==O&&T!==`-${O}`),g&&m.push(O.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,1)}updateSynchronizedExtensions(O,g){let m=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(T=>T.toLowerCase());return m=m.filter(T=>T!==O&&T!==`-${O}`),g&&m.push(`-${O.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",m.length?m:void 0,1)}getIgnoredExtensions(O){const g=O.filter(v=>v.isMachineScoped).map(v=>v.identifier.id.toLowerCase()),m=this.getConfiguredIgnoredExtensions().map(v=>v.toLowerCase()),T=[],y=[];if(Array.isArray(m))for(const v of m)v.startsWith("-")?y.push(v.substring(1)):T.push(v);return(0,p.distinct)([...g,...T].filter(v=>y.indexOf(v)===-1))}getConfiguredIgnoredExtensions(){let O=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return O!==void 0||(O=this.configurationService.inspect("sync.ignoredExtensions").userValue,O!==void 0)?O:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(g=>g.toLowerCase())}};R=fe([Y(0,k.IConfigurationService)],R),e.IgnoredExtensionsManagementService=R}),define(Z[178],ee([0,1,26,32,18,139,52]),function(K,e,p,k,A,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function O(s){return(0,k.parse)(s)||[]}e.parseKeybindings=O;async function g(s,r,t,i,n){const o=O(s),a=O(r),c=t?O(t):null,l=[...o,...a,...c||[]].map($=>$.key),d=await n.resolveUserBindings(l);let w=T(o,a,c,d);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:s,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:r,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};const h=v(o),P=v(a),_=c?v(c):null,j=u(h,P,d),q=_?u(_,h,d):{added:[...h.keys()].reduce(($,V)=>($.add(V),$),new Set),removed:new Set,updated:new Set},G=_?u(_,P,d):{added:[...P.keys()].reduce(($,V)=>($.add(V),$),new Set),removed:new Set,updated:new Set},M=m(j,q,G);let z=s;for(const $ of M.removed.values())M.conflicts.has($)||(z=D(z,$,i));for(const $ of M.added.values())if(!M.conflicts.has($)){const V=P.get($);if(V.some(H=>H.command!==`-${$}`&&w.conflicts.has(d[H.key]))){M.conflicts.add($);continue}z=E(z,V,i)}for(const $ of M.updated.values())if(!M.conflicts.has($)){const V=P.get($);if(V.some(H=>H.command!==`-${$}`&&w.conflicts.has(d[H.key]))){M.conflicts.add($);continue}z=f(z,$,V,i)}return{mergeContent:z,hasChanges:!0,hasConflicts:M.conflicts.size>0}}e.merge=g;function m(s,r,t){const i=new Set,n=new Set,o=new Set,a=new Set;for(const c of r.removed.values())t.updated.has(c)&&a.add(c);for(const c of t.removed.values())a.has(c)||(r.updated.has(c)?a.add(c):n.add(c));for(const c of r.added.values())a.has(c)||t.added.has(c)&&s.updated.has(c)&&a.add(c);for(const c of t.added.values())a.has(c)||(r.added.has(c)?s.updated.has(c)&&a.add(c):i.add(c));for(const c of r.updated.values())a.has(c)||t.updated.has(c)&&s.updated.has(c)&&a.add(c);for(const c of t.updated.values())a.has(c)||(r.updated.has(c)?s.updated.has(c)&&a.add(c):o.add(c));return{added:i,removed:n,updated:o,conflicts:a}}function T(s,r,t,i){const n=new Set,o=y(s,i),a=y(r,i),c=t?y(t,i):null,l=b(o,a);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const d=c?b(c,o):{added:[...o.keys()].reduce((q,G)=>(q.add(G),q),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const w=c?b(c,a):{added:[...a.keys()].reduce((q,G)=>(q.add(G),q),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:h,removed:P,updated:_,conflicts:j}=m(l,d,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:h,removed:P,updated:_,conflicts:j}}function y(s,r){const t=new Map;for(const i of s){const n=r[i.key];let o=t.get(n);o||(o=[],t.set(n,o)),o.push(i)}return t}function v(s){const r=new Map;for(const t of s){const i=t.command[0]==="-"?t.command.substring(1):t.command;let n=r.get(i);n||(n=[],r.set(i,n)),n.push(t)}return r}function b(s,r){const t=[...s.keys()],i=[...r.keys()],n=i.filter(c=>t.indexOf(c)===-1).reduce((c,l)=>(c.add(l),c),new Set),o=t.filter(c=>i.indexOf(c)===-1).reduce((c,l)=>(c.add(l),c),new Set),a=new Set;for(const c of t)if(!o.has(c)){const l=s.get(c).map(w=>Object.assign(Object.assign({},w),{key:c})),d=r.get(c).map(w=>Object.assign(Object.assign({},w),{key:c}));(0,A.equals)(l,d,(w,h)=>C(w,h))||a.add(c)}return{added:n,removed:o,updated:a}}function u(s,r,t){const i=[...s.keys()],n=[...r.keys()],o=n.filter(l=>i.indexOf(l)===-1).reduce((l,d)=>(l.add(d),l),new Set),a=i.filter(l=>n.indexOf(l)===-1).reduce((l,d)=>(l.add(d),l),new Set),c=new Set;for(const l of i)if(!a.has(l)){const d=s.get(l).map(h=>Object.assign(Object.assign({},h),{key:t[h.key]})),w=r.get(l).map(h=>Object.assign(Object.assign({},h),{key:t[h.key]}));S(d,w)||c.add(l)}return{added:o,removed:a,updated:c}}function S(s,r){return!(!(0,A.equals)(s.filter(({command:t})=>t[0]!=="-"),r.filter(({command:t})=>t[0]!=="-"),(t,i)=>C(t,i))||!(0,A.equals)(s.filter(({command:t})=>t[0]==="-"),r.filter(({command:t})=>t[0]==="-"),(t,i)=>C(t,i)))}function C(s,r){if(s.command!==r.command||s.key!==r.key)return!1;const t=R.ContextKeyExpr.deserialize(s.when),i=R.ContextKeyExpr.deserialize(r.when);return!(t&&!i||!t&&i||t&&i&&!t.equals(i)||!p.equals(s.args,r.args))}function E(s,r,t){for(const i of r)s=U.edit(s,[-1],i,t);return s}function D(s,r,t){const i=O(s);for(let n=i.length-1;n>=0;n--)(i[n].command===r||i[n].command===`-${r}`)&&(s=U.edit(s,[n],void 0,t));return s}function f(s,r,t,i){const n=O(s),o=n.findIndex(a=>a.command===r||a.command===`-${r}`);for(let a=n.length-1;a>=0;a--)(n[a].command===r||n[a].command===`-${r}`)&&(s=U.edit(s,[a],void 0,i));for(let a=t.length-1;a>=0;a--)s=U.edit(s,[o],t[a],i);return s}}),define(Z[179],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function p(R,U,O){const g={},m={},T=new Set;if(!U)return{local:{added:g,updated:m,removed:[...T.values()]},remote:{added:R,updated:{},removed:[]},conflicts:[]};const y=k(R,U);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{local:{added:g,updated:m,removed:[...T.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const v=k(O,R),b=k(O,U),u={},S={},C=new Set,E=new Set;for(const D of v.removed.values())b.updated.has(D)?g[D]=U[D]:C.add(D);for(const D of b.removed.values())E.has(D)||(v.updated.has(D)?E.add(D):T.add(D));for(const D of v.updated.values())E.has(D)||(b.updated.has(D)?y.updated.has(D)&&E.add(D):S[D]=R[D]);for(const D of b.updated.values())E.has(D)||(v.updated.has(D)?y.updated.has(D)&&E.add(D):R[D]!==void 0&&(m[D]=U[D]));for(const D of v.added.values())E.has(D)||(b.added.has(D)?y.updated.has(D)&&E.add(D):u[D]=R[D]);for(const D of b.added.values())E.has(D)||(v.added.has(D)?y.updated.has(D)&&E.add(D):g[D]=U[D]);return{local:{added:g,removed:[...T.values()],updated:m},remote:{added:u,removed:[...C.values()],updated:S},conflicts:[...E.values()]}}e.merge=p;function k(R,U){const O=R?Object.keys(R):[],g=U?Object.keys(U):[],m=g.filter(v=>O.indexOf(v)===-1).reduce((v,b)=>(v.add(b),v),new Set),T=O.filter(v=>g.indexOf(v)===-1).reduce((v,b)=>(v.add(b),v),new Set),y=new Set;for(const v of O)if(!T.has(v)){const b=R[v],u=U[v];b!==u&&y.add(v)}return{added:m,removed:T,updated:y}}function A(R,U){const{added:O,removed:g,updated:m}=k(R,U);return O.size===0&&g.size===0&&m.size===0}e.areSame=A}),define(Z[20],ee([0,1,5,29,35,39,123,78,12,18,15]),function(K,e,p,k,A,R,U,O,g,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function y(){const a=A.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(a).filter(c=>!!a[c].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=y;function v(){const a=A.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(a).filter(w=>!!a[w].ignoreSync),l=Object.keys(a).filter(w=>a[w].scope===2||a[w].scope===6),d=y();return(0,m.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...c,...l,...d])}e.getDefaultIgnoredSettings=v;function b(){const a="vscode://schemas/ignoredSettings",c=A.Registry.as(R.Extensions.Configuration);c.registerConfiguration({id:"settingsSync",order:30,title:(0,U.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,U.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,U.localize)(2,null),items:[{type:"string",pattern:k.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,U.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,U.localize)(4,null),default:[],scope:1,$ref:a,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const l=A.Registry.as(O.Extensions.JSONContribution),d=()=>{const w=y(),h=v().filter(q=>q!==e.CONFIGURATION_SYNC_STORE_KEY),P=Object.keys(R.allSettings.properties).filter(q=>h.indexOf(q)===-1),_=h.filter(q=>w.indexOf(q)===-1),j={items:{type:"string",enum:[...P,..._.map(q=>`-${q}`)]}};l.registerSchema(a,j)};return c.onDidUpdateConfiguration(()=>d())}e.registerConfiguration=b;function u(a){return a&&(0,T.isObject)(a)&&(0,T.isString)(a.id)&&(0,T.isArray)(a.scopes)}e.isAuthenticationProvider=u;var S;(function(a){a.Settings="settings",a.Keybindings="keybindings",a.Snippets="snippets",a.Extensions="extensions",a.GlobalState="globalState"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"],e.IUserDataSyncStoreManagementService=(0,p.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,p.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,p.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function C(a){const c={};return c[e.HEADER_EXECUTION_ID]=a,c}e.createSyncHeaders=C;var E;(function(a){a.Unauthorized="Unauthorized",a.Conflict="Conflict",a.Gone="Gone",a.PreconditionFailed="PreconditionFailed",a.TooLarge="TooLarge",a.UpgradeRequired="UpgradeRequired",a.PreconditionRequired="PreconditionRequired",a.TooManyRequests="RemoteTooManyRequests",a.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",a.RequestFailed="RequestFailed",a.RequestCanceled="RequestCanceled",a.RequestTimeout="RequestTimeout",a.NoRef="NoRef",a.TurnedOff="TurnedOff",a.SessionExpired="SessionExpired",a.ServiceChanged="ServiceChanged",a.DefaultServiceChanged="DefaultServiceChanged",a.LocalTooManyRequests="LocalTooManyRequests",a.LocalPreconditionFailed="LocalPreconditionFailed",a.LocalInvalidContent="LocalInvalidContent",a.LocalError="LocalError",a.IncompatibleLocalContent="IncompatibleLocalContent",a.IncompatibleRemoteContent="IncompatibleRemoteContent",a.UnresolvedConflicts="UnresolvedConflicts",a.Unknown="Unknown"})(E=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class D extends Error{constructor(c,l,d,w){super(c);this.code=l,this.resource=d,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=D;class f extends D{constructor(c,l,d,w){super(c,d,void 0,w);this.url=l}}e.UserDataSyncStoreError=f;class s extends D{constructor(c,l){super(c,l)}}e.UserDataAutoSyncError=s,function(a){function c(l){if(l instanceof a)return l;const d=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(l.name);if(d&&d[1]){const w=d[2]==="unknown"?void 0:d[2],h=d[3]==="unknown"?void 0:d[3];return new a(l.message,d[1],w,h)}return new a(l.message,E.Unknown)}a.toUserDataSyncError=c}(D=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(a){a.Uninitialized="uninitialized",a.Idle="idle",a.Syncing="syncing",a.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var t;(function(a){a[a.None=0]="None",a[a.Added=1]="Added",a[a.Modified=2]="Modified",a[a.Deleted=3]="Deleted"})(t=e.Change||(e.Change={}));var i;(function(a){a.Preview="preview",a.Conflict="conflict",a.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(a){return`sync.enable.${a}`}e.getEnablementKey=n,e.IUserDataSyncResourceEnablementService=(0,p.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,p.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,p.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,p.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,p.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,p.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(a,c){if(a.scheme!==e.USER_DATA_SYNC_SCHEME)return a=a.with({scheme:c.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(l=>(0,g.isEqualOrParent)(a,(0,g.joinPath)(c.userDataSyncHome,l,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(Z[45],ee([0,1,2,10,23,4,20,9,12,6,3,22,32,119,25,15,21,18,44,19,30]),function(K,e,p,k,A,R,U,O,g,m,T,y,v,b,u,S,C,E,D,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(c){return!!(c&&c.version!==void 0&&typeof c.version=="number"&&c.content!==void 0&&typeof c.content=="string"&&(Object.keys(c).length===2||Object.keys(c).length===3&&c.machineId!==void 0&&typeof c.machineId=="string"))}e.isSyncData=r;function t(c,l,d){return d.joinPath(l.userDataSyncHome,c,`lastSync${c}.json`)}let i=class extends p.Disposable{constructor(l,d,w,h,P,_,j,q,G,M){super();this.resource=l,this.fileService=d,this.environmentService=w,this.userDataSyncStoreService=P,this.userDataSyncBackupStoreService=_,this.userDataSyncResourceEnablementService=j,this.telemetryService=q,this.logService=G,this.configurationService=M,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new m.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,C.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(w.userDataSyncHome,1024)?g.extUri:g.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(w.userDataSyncHome,l),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,U.PREVIEW_DIR_NAME),this.lastSyncResource=t(l,w,this.extUri),this.currentMachineIdPromise=(0,D.getServiceMachineId)(w,d,h)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const l=await this.syncPreviewPromise;this.syncPreviewPromise=null;const d=await this.performSync(l.remoteUserData,l.lastSyncUserData,!0);this.setStatus(d)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const l=await this.getLastSyncUserData();(l?(await this.doGenerateSyncResourcePreview(l,l,!0,s.CancellationToken.None)).resourcePreviews.some(({remoteChange:w})=>w!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(l){if(this._status!==l){const d=this._status;l==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),d==="hasConflicts"&&l==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=l,this._onDidChangStatus.fire(l)}}async sync(l,d={}){await this._sync(l,!0,d)}async preview(l,d={}){return this._sync(l,!1,d)}async apply(l,d={}){try{this.syncHeaders=Object.assign({},d);const w=await this.doApply(l);return this.setStatus(w),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(l,d,w){try{if(this.syncHeaders=Object.assign({},w),!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let h="idle";try{const P=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(l,P);return h=await this.performSync(_,P,d),h==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):h==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(h)}}finally{this.syncHeaders={}}}async replace(l){const d=await this.resolveContent(l);if(!d)return!1;const w=this.parseSyncData(d);if(!w)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const h=await this.getLastSyncUserData(),P=await this.getLatestRemoteUserData(null,h),_=await this.generateSyncPreview({ref:P.ref,syncData:w},h,s.CancellationToken.None),j=[];for(const q of _){const G=await this.getAcceptResult(q,q.remoteResource,void 0,s.CancellationToken.None),{remoteChange:M}=await this.getAcceptResult(q,q.previewResource,q.remoteContent,s.CancellationToken.None);j.push([q,Object.assign(Object.assign({},G),{remoteChange:M!==0?M:2})])}await this.applyResult(P,h,j,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async getLatestRemoteUserData(l,d){if(d){const w=l&&l.latest?l.latest[this.resource]:void 0;if(d.ref===w||w===void 0&&d.syncData===null)return d}return this.getRemoteUserData(d)}async performSync(l,d,w){if(l.syncData&&l.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new U.UserDataSyncError((0,b.localize)(0,null,this.resource,this.version,l.syncData.version),U.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(l,d,w)}catch(h){if(h instanceof U.UserDataSyncError)switch(h.code){case U.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(l,d,w);case U.UserDataSyncErrorCode.Conflict:case U.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),l=await this.getRemoteUserData(null),d=await this.getLastSyncUserData(),this.performSync(l,d,w)}throw h}}async doSync(l,d,w){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,m.createCancelablePromise)(P=>this.doGenerateSyncResourcePreview(l,d,w,P)));const h=await this.syncPreviewPromise;return this.updateConflicts(h.resourcePreviews),h.resourcePreviews.some(({mergeState:P})=>P==="conflict")?"hasConflicts":w?await this.doApply(!1):"syncing"}catch(h){throw this.syncPreviewPromise=null,h}}async merge(l){return await this.updateSyncResourcePreview(l,async d=>{const w=await this.getMergeResult(d,s.CancellationToken.None);await this.fileService.writeFile(d.previewResource,A.VSBuffer.fromString((w==null?void 0:w.content)||""));const h=w&&!w.hasConflicts?await this.getAcceptResult(d,d.previewResource,void 0,s.CancellationToken.None):void 0;return d.acceptResult=h,d.mergeState=w.hasConflicts?"conflict":h?"accepted":"preview",d.localChange=h?h.localChange:w.localChange,d.remoteChange=h?h.remoteChange:w.remoteChange,d}),this.syncPreviewPromise}async accept(l,d){return await this.updateSyncResourcePreview(l,async w=>{const h=await this.getAcceptResult(w,l,d,s.CancellationToken.None);return w.acceptResult=h,w.mergeState="accepted",w.localChange=h.localChange,w.remoteChange=h.remoteChange,w}),this.syncPreviewPromise}async discard(l){return await this.updateSyncResourcePreview(l,async d=>{const w=await this.getMergeResult(d,s.CancellationToken.None);return await this.fileService.writeFile(d.previewResource,A.VSBuffer.fromString(w.content||"")),d.acceptResult=void 0,d.mergeState="preview",d.localChange=w.localChange,d.remoteChange=w.remoteChange,d}),this.syncPreviewPromise}async updateSyncResourcePreview(l,d){if(!!this.syncPreviewPromise){let w=await this.syncPreviewPromise;const h=w.resourcePreviews.findIndex(({localResource:P,remoteResource:_,previewResource:j})=>this.extUri.isEqual(P,l)||this.extUri.isEqual(_,l)||this.extUri.isEqual(j,l));h!==-1&&(this.syncPreviewPromise=(0,m.createCancelablePromise)(async P=>{const _=[...w.resourcePreviews];return _[h]=await d(_[h]),Object.assign(Object.assign({},w),{resourcePreviews:_})}),w=await this.syncPreviewPromise,this.updateConflicts(w.resourcePreviews),w.resourcePreviews.some(({mergeState:P})=>P==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}}async doApply(l){if(!this.syncPreviewPromise)return"idle";const d=await this.syncPreviewPromise;return d.resourcePreviews.some(({mergeState:w})=>w==="conflict")?"hasConflicts":d.resourcePreviews.some(({mergeState:w})=>w!=="accepted")?"syncing":(await this.applyResult(d.remoteUserData,d.lastSyncUserData,d.resourcePreviews.map(w=>[w,w.acceptResult]),l),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(l){}}updateConflicts(l){const d=l.filter(({mergeState:w})=>w==="conflict");(0,E.equals)(this._conflicts,d,(w,h)=>this.extUri.isEqual(w.previewResource,h.previewResource))||(this._conflicts=d,this._onDidChangeConflicts.fire(d))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:d,ref:w})=>({created:d,uri:this.toRemoteBackupResource(w)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:d,ref:w})=>({created:d,uri:this.toLocalBackupResource(w)}))}toRemoteBackupResource(l){return R.URI.from({scheme:U.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${l}`})}toLocalBackupResource(l){return R.URI.from({scheme:U.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${l}`})}async getMachineId({uri:l}){const d=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(d))){const{content:w}=await this.getUserData(d);if(w){const h=this.parseSyncData(w);return h==null?void 0:h.machineId}}}async resolveContent(l){const d=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(d))){const{content:w}=await this.getUserData(d);return w}return this.extUri.isEqual(l,this.toLocalBackupResource(d))?this.userDataSyncBackupStoreService.resolveContent(this.resource,d):null}async resolvePreviewContent(l){const d=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(d)for(const w of d.resourcePreviews){if(this.extUri.isEqual(w.acceptedResource,l))return w.acceptResult?w.acceptResult.content:null;if(this.extUri.isEqual(w.remoteResource,l))return w.remoteContent;if(this.extUri.isEqual(w.localResource,l))return w.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(l){}}async doGenerateSyncResourcePreview(l,d,w,h){var P;const _=await this.currentMachineIdPromise,j=!!((P=l.syncData)===null||P===void 0?void 0:P.machineId)&&l.syncData.machineId===_,q=d===null&&j&&!this.hasSyncResourceStateVersionChanged?l:d,G=await this.generateSyncPreview(l,q,h),M=[];for(const z of G){const $=z.previewResource.with({scheme:U.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(z.localChange===0&&z.remoteChange===0)M.push(Object.assign(Object.assign({},z),{acceptedResource:$,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"}));else{const V=w?await this.getMergeResult(z,h):void 0;if(h.isCancellationRequested)break;await this.fileService.writeFile(z.previewResource,A.VSBuffer.fromString((V==null?void 0:V.content)||""));const H=V&&!V.hasConflicts?await this.getAcceptResult(z,z.previewResource,void 0,h):void 0;M.push(Object.assign(Object.assign({},z),{acceptResult:H,mergeState:(V==null?void 0:V.hasConflicts)?"conflict":H?"accepted":"preview",localChange:H?H.localChange:V?V.localChange:z.localChange,remoteChange:H?H.remoteChange:V?V.remoteChange:z.remoteChange}))}}return{remoteUserData:l,lastSyncUserData:d,resourcePreviews:M,isLastSyncFromCurrentMachine:j}}async getLastSyncUserData(){try{const l=await this.fileService.readFile(this.lastSyncResource),d=JSON.parse(l.value.toString()),w=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=d.version&&w&&d.version!==w,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${d.version} is not compatible with current sync state version ${w}.`),await this.resetLocal(),null;const h=d;if(h.content===null)return{ref:d.ref,syncData:null};const P=JSON.parse(h.content);if(r(P))return Object.assign(Object.assign({},d),{syncData:P,content:void 0})}catch(l){l instanceof k.FileOperationError&&l.fileOperationResult===1||this.logService.error(l)}return null}async updateLastSyncUserData(l,d={}){if(d.ref||d.content||d.version)throw new Error("Cannot have core properties as additional");const w=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),h=Object.assign({ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,version:w},d);await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(h)))}async getRemoteUserData(l){const{ref:d,content:w}=await this.getUserData(l);let h=null;return w!==null&&(h=this.parseSyncData(w)),{ref:d,syncData:h}}parseSyncData(l){try{const d=JSON.parse(l);if(r(d))return d}catch(d){this.logService.error(d)}throw new U.UserDataSyncError((0,b.localize)(1,null),U.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(l){if((0,S.isString)(l)){const d=await this.userDataSyncStoreService.resolveContent(this.resource,l);return{ref:l,content:d}}else{const d=l?{ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,d,this.syncHeaders)}}async updateRemoteUserData(l,d){const w=await this.currentMachineIdPromise,h={version:this.version,machineId:w,content:l};return d=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(h),d,this.syncHeaders),{ref:d,syncData:h}}async backupLocal(l){const d={version:this.version,content:l};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(d))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};i=fe([Y(1,k.IFileService),Y(2,O.IEnvironmentService),Y(3,f.IStorageService),Y(4,U.IUserDataSyncStoreService),Y(5,U.IUserDataSyncBackupStoreService),Y(6,U.IUserDataSyncResourceEnablementService),Y(7,y.ITelemetryService),Y(8,U.IUserDataSyncLogService),Y(9,u.IConfigurationService)],i),e.AbstractSynchroniser=i;let n=class extends i{constructor(l,d,w,h,P,_,j,q,G,M,z){super(d,w,h,P,_,j,q,G,M,z);this.file=l,this._register(this.fileService.watch(this.extUri.dirname(l))),this._register(this.fileService.onDidFilesChange($=>this.onFileChanges($)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(l){return null}}async updateLocalFileContent(l,d,w){try{d?await this.fileService.writeFile(this.file,A.VSBuffer.fromString(l),w?void 0:d):await this.fileService.createFile(this.file,A.VSBuffer.fromString(l),{overwrite:w})}catch(h){throw h instanceof k.FileOperationError&&h.fileOperationResult===1||h instanceof k.FileOperationError&&h.fileOperationResult===3?new U.UserDataSyncError(h.message,U.UserDataSyncErrorCode.LocalPreconditionFailed):h}}onFileChanges(l){!l.contains(this.file)||this.triggerLocalChange()}};n=fe([Y(2,k.IFileService),Y(3,O.IEnvironmentService),Y(4,f.IStorageService),Y(5,U.IUserDataSyncStoreService),Y(6,U.IUserDataSyncBackupStoreService),Y(7,U.IUserDataSyncResourceEnablementService),Y(8,y.ITelemetryService),Y(9,U.IUserDataSyncLogService),Y(10,u.IConfigurationService)],n),e.AbstractFileSynchroniser=n;let o=class extends n{constructor(l,d,w,h,P,_,j,q,G,M,z,$){super(l,d,w,h,P,_,j,q,G,M,$);this.userDataSyncUtilService=z,this._formattingOptions=void 0}hasErrors(l){const d=[];return(0,v.parse)(l,d,{allowEmptyContent:!0,allowTrailingComma:!0}),d.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};o=fe([Y(2,k.IFileService),Y(3,O.IEnvironmentService),Y(4,f.IStorageService),Y(5,U.IUserDataSyncStoreService),Y(6,U.IUserDataSyncBackupStoreService),Y(7,U.IUserDataSyncResourceEnablementService),Y(8,y.ITelemetryService),Y(9,U.IUserDataSyncLogService),Y(10,U.IUserDataSyncUtilService),Y(11,u.IConfigurationService)],o),e.AbstractJsonFileSynchroniser=o;let a=class{constructor(l,d,w,h){this.resource=l,this.environmentService=d,this.logService=w,this.fileService=h,this.extUri=this.fileService.hasCapability(d.userDataSyncHome,1024)?g.extUri:g.extUriIgnorePathCase,this.lastSyncResource=t(this.resource,d,g.extUri)}async initialize({ref:l,content:d}){if(!d){this.logService.info("Remote content does not exist.",this.resource);return}const w=this.parseSyncData(d);if(!!w){if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:l,syncData:w})}catch(P){this.logService.error(P)}}}parseSyncData(l){try{const d=JSON.parse(l);if(r(d))return d}catch(d){this.logService.error(d)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(l,d={}){const w=Object.assign({ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null},d);await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(w)))}};a=fe([Y(1,O.IEnvironmentService),Y(2,U.IUserDataSyncLogService),Y(3,k.IFileService)],a),e.AbstractInitializer=a}),define(Z[180],ee([0,1,20,3,9,29,33,10,25,177,45,22,4,46,41,21,19,83,11,82,6]),function(K,e,p,k,A,R,U,O,g,m,T,y,v,b,u,S,C,E,D,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function r(a,c){const l=JSON.parse(a.content);if(a.version===1||a.version===2){const d=(await c.getInstalled(0)).filter(w=>w.isBuiltin);for(const w of l)a.version===1&&(w.enabled===!1&&(w.disabled=!0),delete w.enabled),a.version===2&&d.every(h=>!(0,U.areSameExtensions)(h.identifier,w.identifier))&&(w.installed=!0)}return l}function t(a,c,l){const d=l.get((0,U.getExtensionId)(a,c),0)||"{}";return JSON.parse(d)}e.getExtensionStorageState=t;function i(a,c,l,d){d.store((0,U.getExtensionId)(a,c),JSON.stringify(l),0,1)}e.storeExtensionStorageState=i;let n=class st extends T.AbstractSynchroniser{constructor(c,l,d,w,h,P,_,j,q,G,M,z,$,V){super("extensions",l,c,d,w,h,z,$,q,M);this.storageService=d,this.extensionManagementService=P,this.extensionEnablementService=_,this.ignoredExtensionsManagementService=j,this.extensionGalleryService=G,this.extensionsStorageSyncService=V,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.debounce(k.Event.any(k.Event.filter(this.extensionManagementService.onDidInstallExtension,H=>!!H.gallery),k.Event.filter(this.extensionManagementService.onDidUninstallExtension,H=>!H.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(c,l){const d=c.syncData?await r(c.syncData,this.extensionManagementService):null,w=(l==null?void 0:l.skippedExtensions)||[],h=(l==null?void 0:l.syncData)?await r(l.syncData,this.extensionManagementService):null,P=await this.extensionManagementService.getInstalled(),_=this.getLocalExtensions(P),j=this.ignoredExtensionsManagementService.getIgnoredExtensions(P);d?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{added:q,removed:G,updated:M,remote:z}=(0,m.merge)(_,d,h,w,j),$={added:q,removed:G,updated:M,remote:z,content:this.getPreviewContent(_,q,M,G),localChange:q.length>0||G.length>0||M.length>0?2:0,remoteChange:z!==null?2:0};return[{skippedExtensions:w,localResource:this.localResource,localContent:this.format(_),localExtensions:_,remoteResource:this.remoteResource,remoteContent:d?this.format(d):null,previewResource:this.previewResource,previewResult:$,localChange:$.localChange,remoteChange:$.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(c,l,d,w){const h=[...l,...d],P=new Set,_=j=>{P.add(j.id.toLowerCase()),j.uuid&&P.add(j.uuid)};h.forEach(({identifier:j})=>_(j)),w.forEach(_);for(const j of c)P.has(j.identifier.id.toLowerCase())||j.identifier.uuid&&P.has(j.identifier.uuid)||h.push(j);return this.format(h)}async getMergeResult(c,l){return Object.assign(Object.assign({},c.previewResult),{hasConflicts:!1})}async getAcceptResult(c,l,d,w){if(this.extUri.isEqual(l,this.localResource))return this.acceptLocal(c);if(this.extUri.isEqual(l,this.remoteResource))return this.acceptRemote(c);if(this.extUri.isEqual(l,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${l.toString()}`)}async acceptLocal(c){const l=await this.extensionManagementService.getInstalled(),d=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),w=(0,m.merge)(c.localExtensions,null,null,c.skippedExtensions,d),{added:h,removed:P,updated:_,remote:j}=w;return{content:c.localContent,added:h,removed:P,updated:_,remote:j,localChange:h.length>0||P.length>0||_.length>0?2:0,remoteChange:j!==null?2:0}}async acceptRemote(c){const l=await this.extensionManagementService.getInstalled(),d=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),w=c.remoteContent?JSON.parse(c.remoteContent):null;if(w!==null){const h=(0,m.merge)(c.localExtensions,w,c.localExtensions,[],d),{added:P,removed:_,updated:j,remote:q}=h;return{content:c.remoteContent,added:P,removed:_,updated:j,remote:q,localChange:P.length>0||_.length>0||j.length>0?2:0,remoteChange:q!==null?2:0}}else return{content:c.remoteContent,added:[],removed:[],updated:[],remote:null,localChange:0,remoteChange:0}}async applyResult(c,l,d,w){let{skippedExtensions:h,localExtensions:P}=d[0][0],{added:_,removed:j,updated:q,remote:G,localChange:M,remoteChange:z}=d[0][1];if(M===0&&z===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),M!==0&&(await this.backupLocal(JSON.stringify(P)),h=await this.updateLocalExtensions(_,j,q,h)),G){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const $=JSON.stringify(G);c=await this.updateRemoteUserData($,w?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions`)}(l==null?void 0:l.ref)!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(c,{skippedExtensions:h}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions`))}async getAssociatedResources({uri:c}){return[{resource:this.extUri.joinPath(c,"extensions.json"),comparableResource:st.EXTENSIONS_DATA_URI}]}async resolveContent(c){if(this.extUri.isEqual(c,st.EXTENSIONS_DATA_URI)){const d=await this.extensionManagementService.getInstalled(),w=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),h=this.getLocalExtensions(d).filter(P=>!w.some(_=>(0,U.areSameExtensions)({id:_},P.identifier)));return this.format(h)}if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c))return this.resolvePreviewContent(c);let l=await super.resolveContent(c);if(l)return l;if(l=await super.resolveContent(this.extUri.dirname(c)),l){const d=this.parseSyncData(l);if(d)switch(this.extUri.basename(c)){case"extensions.json":return this.format(this.parseExtensions(d))}}return null}format(c){c.sort((w,h)=>!w.identifier.uuid&&h.identifier.uuid?-1:w.identifier.uuid&&!h.identifier.uuid?1:(0,S.compare)(w.identifier.id,h.identifier.id));const l=JSON.stringify(c),d=(0,b.format)(l,void 0,{});return(0,u.applyEdits)(l,d)}async hasLocalData(){try{const c=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(c).some(d=>d.installed||d.disabled))return!0}catch(c){}return!1}async updateLocalExtensions(c,l,d,w){const h=[],P=[],_=await this.extensionManagementService.getInstalled();if(l.length){const q=_.filter(({identifier:G,isBuiltin:M})=>!M&&l.some(z=>(0,U.areSameExtensions)(G,z)));await s.Promises.settled(q.map(async G=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,G.identifier.id),await this.extensionManagementService.uninstall(G,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,G.identifier.id),h.push(G.identifier)}))}(c.length||d.length)&&await s.Promises.settled([...c,...d].map(async q=>{const G=_.find(z=>(0,U.areSameExtensions)(z.identifier,q.identifier));if(G&&G.isBuiltin){q.state&&G.manifest.version===q.version&&this.updateExtensionState(q.state,G.manifest.publisher,G.manifest.name,G.manifest.version),q.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,q.identifier.id),await this.extensionEnablementService.disableExtension(q.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,q.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,q.identifier.id),await this.extensionEnablementService.enableExtension(q.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,q.identifier.id)),h.push(q.identifier);return}const M=await this.extensionGalleryService.getCompatibleExtension(q.identifier);if(q.state&&(G?G.manifest.version===q.version:!!M)){const z=G?G.manifest.publisher:M.publisher,$=G?G.manifest.name:M.name;this.updateExtensionState(q.state,z,$,G==null?void 0:G.manifest.version)}if(M)try{q.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,q.identifier.id,M.version),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,q.identifier.id,M.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,q.identifier.id,M.version),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,q.identifier.id,M.version)),G||(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,q.identifier.id,M.version),await this.extensionManagementService.installFromGallery(M,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,q.identifier.id,M.version),h.push(M.identifier))}catch(z){P.push(q),this.logService.error(z),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,M.displayName||M.identifier.id)}else P.push(q)}));const j=[];for(const q of w)h.some(G=>(0,U.areSameExtensions)(G,q.identifier))||j.push(q);for(const q of P)j.some(G=>(0,U.areSameExtensions)(G.identifier,q.identifier))||j.push(q);return j}updateExtensionState(c,l,d,w){const h=t(l,d,this.storageService),P=w?this.extensionsStorageSyncService.getKeysForSync({id:(0,U.getGalleryExtensionId)(l,d),version:w}):void 0;P?P.forEach(_=>{h[_]=c[_]}):Object.keys(c).forEach(_=>h[_]=c[_]),i(l,d,h,this.storageService)}parseExtensions(c){return JSON.parse(c.content)}getLocalExtensions(c){const l=this.extensionEnablementService.getDisabledExtensions();return c.map(({identifier:d,isBuiltin:w,manifest:h})=>{const P={identifier:d,version:h.version};l.some(_=>(0,U.areSameExtensions)(_,d))&&(P.disabled=!0),w||(P.installed=!0);try{const _=this.extensionsStorageSyncService.getKeysForSync({id:d.id,version:h.version});if(_){const j=t(h.publisher,h.name,this.storageService);P.state=Object.keys(j).reduce((q,G)=>(_.includes(G)&&(q[G]=j[G]),q),{})}}catch(_){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,D.getErrorMessage)(_))}return P})}};n.EXTENSIONS_DATA_URI=v.URI.from({scheme:p.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),n=fe([Y(0,A.IEnvironmentService),Y(1,O.IFileService),Y(2,C.IStorageService),Y(3,p.IUserDataSyncStoreService),Y(4,p.IUserDataSyncBackupStoreService),Y(5,R.IExtensionManagementService),Y(6,R.IGlobalExtensionEnablementService),Y(7,E.IIgnoredExtensionsManagementService),Y(8,p.IUserDataSyncLogService),Y(9,R.IExtensionGalleryService),Y(10,g.IConfigurationService),Y(11,p.IUserDataSyncResourceEnablementService),Y(12,y.ITelemetryService),Y(13,f.IExtensionsStorageSyncService)],n),e.ExtensionsSynchroniser=n;let o=class extends T.AbstractInitializer{constructor(c,l,d,w,h){super("extensions",w,h,d);this.extensionManagementService=c,this.ignoredExtensionsManagementService=l}async parseExtensions(c){return c.syncData?await r(c.syncData,this.extensionManagementService):null}generatePreview(c,l){const d=[],w=[],h=[];for(const P of c)if(!this.ignoredExtensionsManagementService.hasToNeverSyncExtension(P.identifier.id)){const _=l.find(j=>(0,U.areSameExtensions)(j.identifier,P.identifier));_?(d.push(_),P.disabled&&h.push(P.identifier)):P.installed&&(w.push(P.identifier),P.disabled&&h.push(P.identifier))}return{installedExtensions:d,newExtensions:w,disabledExtensions:h,remoteExtensions:c}}};o=fe([Y(0,R.IExtensionManagementService),Y(1,E.IIgnoredExtensionsManagementService),Y(2,O.IFileService),Y(3,A.IEnvironmentService),Y(4,p.IUserDataSyncLogService)],o),e.AbstractExtensionsInitializer=o}),define(Z[181],ee([0,1,26,20]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(O,g,m,T,y){if(!g)return{remote:Object.keys(O).length>0?O:null,local:{added:{},removed:[],updated:{}}};const v=R(O,g);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const b=m?R(m,g):{added:Object.keys(g).reduce((D,f)=>(D.add(f),D),new Set),removed:new Set,updated:new Set},u=m?R(m,O):{added:Object.keys(O).reduce((D,f)=>(D.add(f),D),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},C=p.deepClone(g),E=!m;for(const D of u.added.values())D!==k.SYNC_SERVICE_URL_TYPE&&E&&b.added.has(D)||(C[D]=O[D]);for(const D of u.updated.values())C[D]=O[D];for(const D of u.removed.values())T.unregistered.includes(D)||delete C[D];for(const D of b.added.values()){const f=g[D];if(T.machine.includes(D)){y.info(`GlobalState: Skipped adding ${D} in local storage because it is declared as machine scoped.`);continue}if(!(m&&u.added.has(D))){const s=O[D];s&&s.value===f.value||D===k.SYNC_SERVICE_URL_TYPE&&E&&u.added.has(D)||(s?S.updated[D]=f:S.added[D]=f)}}for(const D of b.updated.values()){const f=g[D];if(T.machine.includes(D)){y.info(`GlobalState: Skipped updating ${D} in local storage because it is declared as machine scoped.`);continue}if(!(u.updated.has(D)||u.removed.has(D))){const s=O[D];s&&s.value===f.value||(S.updated[D]=f)}}for(const D of b.removed.values()){if(T.machine.includes(D)){y.trace(`GlobalState: Skipped removing ${D} in local storage because it is declared as machine scoped.`);continue}u.updated.has(D)||u.removed.has(D)||S.removed.push(D)}return{local:S,remote:U(C,g)?null:C}}e.merge=A;function R(O,g){const m=Object.keys(O),T=Object.keys(g),y=T.filter(u=>m.indexOf(u)===-1).reduce((u,S)=>(u.add(S),u),new Set),v=m.filter(u=>T.indexOf(u)===-1).reduce((u,S)=>(u.add(S),u),new Set),b=new Set;for(const u of m)if(!v.has(u)){const S=O[u],C=g[u];p.equals(S,C)||b.add(u)}return{added:y,removed:v,updated:b}}function U(O,g){const{added:m,removed:T,updated:y}=R(O,g);return m.size===0&&T.size===0&&y.size===0}}),define(Z[182],ee([0,1,20,23,3,9,10,52,181,32,45,22,25,4,46,41,19,7,44,31,17]),function(K,e,p,k,A,R,U,O,g,m,T,y,v,b,u,S,C,E,D,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",t=["locale"];function i(l){const d=l.storage?Object.keys(l.storage).sort():[],w={};d.forEach(_=>w[_]=l.storage[_]),l.storage=w;const h=JSON.stringify(l),P=(0,u.format)(h,void 0,{});return(0,S.applyEdits)(h,P)}const n=1;let o=class ot extends T.AbstractSynchroniser{constructor(d,w,h,P,_,j,q,G,M){super("globalState",d,_,M,w,h,j,q,P,G);this.storageService=M,this.version=n,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(d.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(A.Event.any(A.Event.filter(d.onDidFilesChange,z=>z.contains(this.environmentService.argvResource)),A.Event.filter(M.onDidChangeValue,z=>z.scope===0&&z.target!==void 0?z.target===0:M.keys(0,0).includes(z.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(d,w,h){const P=d.syncData?JSON.parse(d.syncData.content):null,_=w&&w.syncData?JSON.parse(w.syncData.content):null,j=await this.getLocalGlobalState();P?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const q=this.getStorageKeys(_),{local:G,remote:M}=(0,g.merge)(j.storage,P?P.storage:null,_?_.storage:null,q,this.logService),z={content:null,local:G,remote:M,localChange:Object.keys(G.added).length>0||Object.keys(G.updated).length>0||G.removed.length>0?2:0,remoteChange:M!==null?2:0};return[{localResource:this.localResource,localContent:i(j),localUserData:j,remoteResource:this.remoteResource,remoteContent:P?i(P):null,previewResource:this.previewResource,previewResult:z,localChange:z.localChange,remoteChange:z.remoteChange,acceptedResource:this.acceptedResource,storageKeys:q}]}async getMergeResult(d,w){return Object.assign(Object.assign({},d.previewResult),{hasConflicts:!1})}async getAcceptResult(d,w,h,P){if(this.extUri.isEqual(w,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(w,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(w,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${w.toString()}`)}async acceptLocal(d){return{content:d.localContent,local:{added:{},removed:[],updated:{}},remote:d.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(d){if(d.remoteContent!==null){const w=JSON.parse(d.remoteContent),{local:h,remote:P}=(0,g.merge)(d.localUserData.storage,w.storage,null,d.storageKeys,this.logService);return{content:d.remoteContent,local:h,remote:P,localChange:Object.keys(h.added).length>0||Object.keys(h.updated).length>0||h.removed.length>0?2:0,remoteChange:P!==null?2:0}}else return{content:d.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(d,w,h,P){let{localUserData:_}=h[0][0],{local:j,remote:q,localChange:G,remoteChange:M}=h[0][1];if(G===0&&M===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),G!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(_)),await this.writeLocalGlobalState(j),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),M!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const z=JSON.stringify({storage:q});d=await this.updateRemoteUserData(z,P?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}(w==null?void 0:w.ref)!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:d}){return[{resource:this.extUri.joinPath(d,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(d){if(this.extUri.isEqual(d,ot.GLOBAL_STATE_DATA_URI)){const h=await this.getLocalGlobalState();return i(h)}if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d))return this.resolvePreviewContent(d);let w=await super.resolveContent(d);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(d)),w){const h=this.parseSyncData(w);if(h)switch(this.extUri.basename(d)){case"globalState.json":return i(JSON.parse(h.content))}}return null}async hasLocalData(){var d;try{const{storage:w}=await this.getLocalGlobalState();if(Object.keys(w).length>1||((d=w[`${r}.locale`])===null||d===void 0?void 0:d.value)!=="en")return!0}catch(w){}return!1}async getLocalGlobalState(){const d={},w=await this.getLocalArgvContent(),h=(0,m.parse)(w);for(const P of t)h[P]!==void 0&&(d[`${r}${P}`]={version:1,value:h[P]});for(const P of this.storageService.keys(0,0)){const _=this.storageService.get(P,0);_&&(d[P]={version:1,value:_})}return{storage:d}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(d){}return"{}"}async writeLocalGlobalState({added:d,removed:w,updated:h}){const P={},_={},j=(G,M)=>{for(const z of G){if(z.startsWith(r)){P[z.substring(r.length)]=M?M[z].value:void 0;continue}if(M){const $=M[z];$.value!==String(this.storageService.get(z,0))&&(_[z]=$.value)}else this.storageService.get(z,0)!==void 0&&(_[z]=void 0)}};if(j(Object.keys(d),d),j(Object.keys(h),h),j(w),Object.keys(P).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(P),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(_).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const G of Object.keys(_))this.storageService.store(G,_[G],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(_))}}async updateArgv(d){const w=await this.getLocalArgvContent();let h=w;for(const P of Object.keys(d))h=(0,O.edit)(h,[P],d[P],{});w!==h&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(h)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(d){const w=this.storageService.keys(0,0),h=this.storageService.keys(0,1),P=[...w,...h],_=(d==null?void 0:d.storage)?Object.keys(d.storage).filter(j=>!j.startsWith(r)&&!P.includes(j)&&this.storageService.get(j,0)!==void 0):[];if(!E.isWeb){const j=[...p.ALL_SYNC_RESOURCES.map(q=>(0,p.getEnablementKey)(q)),p.SYNC_SERVICE_URL_TYPE];_.push(...j),h.push(...j)}return{user:w,machine:h,unregistered:_}}};o.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:p.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=fe([Y(0,U.IFileService),Y(1,p.IUserDataSyncStoreService),Y(2,p.IUserDataSyncBackupStoreService),Y(3,p.IUserDataSyncLogService),Y(4,R.IEnvironmentService),Y(5,p.IUserDataSyncResourceEnablementService),Y(6,y.ITelemetryService),Y(7,v.IConfigurationService),Y(8,C.IStorageService)],o),e.GlobalStateSynchroniser=o;let a=class extends T.AbstractInitializer{constructor(d,w,h,P){super("globalState",h,P,w);this.storageService=d}async doInitialize(d){const w=d.syncData?JSON.parse(d.syncData.content):null;if(!w){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const h={},P={};for(const _ of Object.keys(w.storage))_.startsWith(r)?h[_.substring(r.length)]=w.storage[_].value:this.storageService.get(_,0)===void 0&&(P[_]=w.storage[_].value);if(Object.keys(h).length){let _="{}";try{_=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(j){}for(const j of Object.keys(h))_=(0,O.edit)(_,[j],h[j],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(_))}if(Object.keys(P).length)for(const _ of Object.keys(P))this.storageService.store(_,P[_],0,0)}};a=fe([Y(0,C.IStorageService),Y(1,U.IFileService),Y(2,R.IEnvironmentService),Y(3,p.IUserDataSyncLogService)],a),e.GlobalStateInitializer=a;let c=class{constructor(d,w,h,P,_){this.userDataSyncStoreClient=d,this.storageService=w,this.environmentService=h,this.fileService=P,this.logService=_}getSyncStoreType(d){var w;const h=this.parseGlobalState(d);return(w=h==null?void 0:h.storage[p.SYNC_SERVICE_URL_TYPE])===null||w===void 0?void 0:w.value}async sync(d){const w=(0,p.createSyncHeaders)((0,f.generateUuid)());try{return await this.doSync(d,w)}catch(h){if(h instanceof p.UserDataSyncError)switch(h.code){case p.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(d,w)}throw h}}async doSync(d,w){const h=await this.userDataSyncStoreClient.read("globalState",null,w),P=this.parseGlobalState(h)||{storage:{}};P.storage[p.SYNC_SERVICE_URL_TYPE]={value:d,version:n};const _=await(0,D.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),j={version:n,machineId:_,content:i(P)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(j),h.ref,w)}parseGlobalState({content:d}){if(!d)return null;const w=JSON.parse(d);if((0,T.isSyncData)(w))return w?JSON.parse(w.content):null;throw new Error("Invalid remote data")}};c=fe([Y(1,C.IStorageService),Y(2,R.IEnvironmentService),Y(3,U.IFileService),Y(4,s.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(Z[183],ee([0,1,10,20,178,32,120,9,25,7,15,18,45,22,19,23,3]),function(K,e,p,k,A,R,U,O,g,m,T,y,v,b,u,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function E(s,r){const t=JSON.parse(s);if(!r)return(0,T.isUndefined)(t.all)?null:t.all;switch(m.OS){case 2:return(0,T.isUndefined)(t.mac)?null:t.mac;case 3:return(0,T.isUndefined)(t.linux)?null:t.linux;case 1:return(0,T.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=E;let D=class extends v.AbstractJsonFileSynchroniser{constructor(r,t,i,n,o,a,c,l,d,w){super(c.keybindingsResource,"keybindings",a,c,l,r,t,o,w,i,d,n);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(C.Event.filter(n.onDidChangeConfiguration,h=>h.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,t,i){const n=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null,o=t?this.getKeybindingsContentFromLastSyncUserData(t):null,a=await this.getLocalFileContent(),c=await this.getFormattingOptions();let l=null,d=!1,w=!1,h=!1;if(n){let _=a?a.value.toString():"[]";if(_=_||"[]",this.hasErrors(_))throw new k.UserDataSyncError((0,U.localize)(0,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!o||o!==_||o!==n){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const j=await(0,A.merge)(_,n,o,c,this.userDataSyncUtilService);j.hasChanges&&(l=j.mergeContent,h=j.hasConflicts,d=h||j.mergeContent!==_,w=h||j.mergeContent!==n)}}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),l=a.value.toString(),w=!0);const P={content:l,localChange:d?a?2:1:0,remoteChange:w?2:0,hasConflicts:h};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:P.localChange,remoteResource:this.remoteResource,remoteContent:n,remoteChange:P.remoteChange,previewResource:this.previewResource,previewResult:P,acceptedResource:this.acceptedResource}]}async getMergeResult(r,t){return r.previewResult}async getAcceptResult(r,t,i,n){if(this.extUri.isEqual(t,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(r,t,i,n){var o;const{fileContent:a}=i[0][0];let{content:c,localChange:l,remoteChange:d}=i[0][1];if(l===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),c!==null&&(c=c.trim(),c=c||"[]",this.hasErrors(c)))throw new k.UserDataSyncError((0,U.localize)(1,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),a&&await this.backupLocal(this.toSyncContent(a.value.toString())),await this.updateLocalFileContent(c||"[]",a,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),d!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const w=this.toSyncContent(c||"[]",(o=r.syncData)===null||o===void 0?void 0:o.content);r=await this.updateRemoteUserData(w,n?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(w){}(t==null?void 0:t.ref)!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const t=(0,R.parse)(r.value.toString());if((0,y.isNonEmptyArray)(t))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:t}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let t=await super.resolveContent(r);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(r)),t){const i=this.parseSyncData(t);if(i)switch(this.extUri.basename(r)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(i.content)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(r.syncData.content)}getKeybindingsContentFromSyncContent(r){try{return E(r,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(r,t){let i={};try{i=JSON.parse(t||"{}")}catch(n){this.logService.error(n)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=r,m.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){let r=this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return r!==void 0||(r=this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,r!==void 0)?r:this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};D=fe([Y(0,k.IUserDataSyncStoreService),Y(1,k.IUserDataSyncBackupStoreService),Y(2,k.IUserDataSyncLogService),Y(3,g.IConfigurationService),Y(4,k.IUserDataSyncResourceEnablementService),Y(5,p.IFileService),Y(6,O.IEnvironmentService),Y(7,u.IStorageService),Y(8,k.IUserDataSyncUtilService),Y(9,b.ITelemetryService)],D),e.KeybindingsSynchroniser=D;let f=class extends v.AbstractInitializer{constructor(r,t,i){super("keybindings",t,i,r)}async doInitialize(r){const t=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,S.VSBuffer.fromString(t)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,R.parse)(r.value.toString());return!(0,y.isNonEmptyArray)(t)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return E(r,!0)}catch(t){return this.logService.error(t),null}}};f=fe([Y(0,p.IFileService),Y(1,O.IEnvironmentService),Y(2,k.IUserDataSyncLogService)],f),e.KeybindingsInitializer=f}),define(Z[184],ee([0,1,26,32,41,46,52,20,18]),function(K,e,p,k,A,R,U,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function m(c,l,d){let w=[];d?w=y(d):w=T(l);const h=[],P=[...(0,O.getDisallowedIgnoredSettings)()];if(Array.isArray(w))for(const _ of w)_.startsWith("-")?P.push(_.substring(1)):h.push(_);return(0,g.distinct)([...c,...h].filter(_=>P.indexOf(_)===-1))}e.getIgnoredSettings=m;function T(c){let l=c.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=c.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:c.getValue("settingsSync.ignoredSettings")||[]}function y(c){const l=(0,k.parse)(c);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function v(c,l,d,w){if(d.length){const h=a(l),P=(0,k.parse)(l),_=(0,k.parse)(c),j=[];for(const q of d){const G=P[q],M=_[q];G===void 0?c=U.edit(c,[q],void 0,w):M!==void 0?c=U.edit(c,[q],G,w):j.push(r(q,h))}j.sort((q,G)=>q.startOffset-G.startOffset),j.forEach(q=>c=E(q.setting.key,l,c,w))}return c}e.updateIgnoredSettings=v;function b(c,l,d,w,h,P){const _=v(c,l,w,P),j=d!==_,q=d!==l;if(!j&&!q)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(j&&!q)return{conflictsSettings:[],localContent:null,remoteContent:_,hasConflicts:!1};if(q&&!j)return{conflictsSettings:[],localContent:v(l,c,w,P),remoteContent:null,hasConflicts:!1};if(d===null&&S(c)){const ie=u(c,l,w)?null:v(l,c,w,P);return{conflictsSettings:[],localContent:ie,remoteContent:null,hasConflicts:!1}}let G=c,M=l;const z=(0,k.parse)(c),$=(0,k.parse)(l),V=d?(0,k.parse)(d):null,H=w.reduce((ie,ce)=>(ie.add(ce),ie),new Set),L=C(z,$,H),I=C(V,z,H),F=C(V,$,H),N=new Map,W=new Set,x=ie=>{W.add(ie);const ce=h.filter(({key:ue})=>ue===ie)[0];ce?(G=U.edit(G,[ie],ce.value,P),M=U.edit(M,[ie],ce.value,P)):N.set(ie,{key:ie,localValue:z[ie],remoteValue:$[ie]})};for(const ie of I.removed.values())F.updated.has(ie)?x(ie):M=U.edit(M,[ie],void 0,P);for(const ie of F.removed.values())W.has(ie)||(I.updated.has(ie)?x(ie):G=U.edit(G,[ie],void 0,P));for(const ie of I.updated.values())W.has(ie)||(F.updated.has(ie)?L.updated.has(ie)&&x(ie):M=U.edit(M,[ie],z[ie],P));for(const ie of F.updated.values())W.has(ie)||(I.updated.has(ie)?L.updated.has(ie)&&x(ie):G=U.edit(G,[ie],$[ie],P));for(const ie of I.added.values())W.has(ie)||(F.added.has(ie)?L.updated.has(ie)&&x(ie):M=E(ie,G,M,P));for(const ie of F.added.values())W.has(ie)||(I.added.has(ie)?L.updated.has(ie)&&x(ie):G=E(ie,M,G,P));const X=N.size>0||!u(G,M,w),Q=X||!u(G,c,[]),ne=X||!u(M,l,[]);return{localContent:Q?G:null,remoteContent:ne?M:null,conflictsSettings:[...N.values()],hasConflicts:X}}e.merge=b;function u(c,l,d){if(c===l)return!0;const w=(0,k.parse)(c),h=(0,k.parse)(l),P=d.reduce((q,G)=>(q.add(G),q),new Set),_=a(c).filter(q=>!(q.setting&&P.has(q.setting.key))),j=a(l).filter(q=>!(q.setting&&P.has(q.setting.key)));if(_.length!==j.length)return!1;for(let q=0;q<_.length;q++){const G=_[q],M=j[q];if(G.setting&&M.setting){if(G.setting.key!==M.setting.key||!p.equals(w[G.setting.key],h[G.setting.key]))return!1}else if(!G.setting&&!M.setting){if(G.value!==M.value)return!1}else return!1}return!0}e.areSame=u;function S(c){return c?a(c).length===0:!0}e.isEmpty=S;function C(c,l,d){const w=c?Object.keys(c).filter(q=>!d.has(q)):[],h=Object.keys(l).filter(q=>!d.has(q)),P=h.filter(q=>w.indexOf(q)===-1).reduce((q,G)=>(q.add(G),q),new Set),_=w.filter(q=>h.indexOf(q)===-1).reduce((q,G)=>(q.add(G),q),new Set),j=new Set;if(c){for(const q of w)if(!_.has(q)){const G=c[q],M=l[q];p.equals(G,M)||j.add(q)}}return{added:P,removed:_,updated:j}}function E(c,l,d,w){const h=(0,k.parse)(l),P=a(l),_=a(d),j=D(c,P,_);return f(d,c,h[c],j,_,w)}e.addSetting=E;function D(c,l,d){const w=l.findIndex(P=>{var _;return((_=P.setting)===null||_===void 0?void 0:_.key)===c}),h=l[w-1];if(h){if(h.setting){const _=r(h.setting.key,d);if(_)return{index:d.indexOf(_),insertAfter:!0}}else{const _=t(w,l);if(_){const j=r(_.setting.key,d);if(j){const q=i(d.indexOf(j),d),G=n(l,_,l[w]);if(q){const M=n(d,j,q),z=o(G,M);return z?{index:d.indexOf(z),insertAfter:!0}:{index:d.indexOf(q),insertAfter:!1}}else{const M=n(d,j,d[d.length-1]),z=o(G,M);return z?{index:d.indexOf(z),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const P=l[w+1];if(P)if(P.setting){const _=r(P.setting.key,d);if(_)return{index:d.indexOf(_),insertAfter:!1}}else{const _=i(w,l);if(_){const j=r(_.setting.key,d);if(j){const q=t(d.indexOf(j),d),G=n(l,l[w],_);if(q){const M=n(d,q,j),z=o(G.reverse(),M.reverse());return z?{index:d.indexOf(z),insertAfter:!1}:{index:d.indexOf(q),insertAfter:!0}}else{const M=n(d,d[0],j),z=o(G.reverse(),M.reverse());return z?{index:d.indexOf(z),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function f(c,l,d,w,h,P){let _;return w.index===-1?_=(0,A.setProperty)(c,[l],d,P):_=s(c,l,d,w,h,P).map(j=>(0,A.withFormatting)(c,j,P)[0]),(0,A.applyEdits)(c,_)}function s(c,l,d,w,h,P){var _;const j=`${JSON.stringify(l)}: ${JSON.stringify(d)}`,q=(0,R.getEOL)(P,c),G=h[w.index];if(w.insertAfter){const M=[];if(G.setting)M.push({offset:G.endOffset,length:0,content:","+j});else{const z=i(w.index,h),$=t(w.index,h),V=(_=$==null?void 0:$.setting)===null||_===void 0?void 0:_.commaOffset;$&&V===void 0&&M.push({offset:$.endOffset,length:0,content:","});const H=V!==void 0&&V>G.endOffset;M.push({offset:H?V+1:G.endOffset,length:0,content:z?q+j+",":q+j})}return M}else{if(G.setting)return[{offset:G.startOffset,length:0,content:j+","}];const M=(h[w.index-1]&&!h[w.index-1].setting?q:"")+j+(i(w.index,h)?",":"")+q;return[{offset:G.startOffset,length:0,content:M}]}}function r(c,l){return l.filter(d=>{var w;return((w=d.setting)===null||w===void 0?void 0:w.key)===c})[0]}function t(c,l){for(let d=c-1;d>=0;d--)if(l[d].setting)return l[d]}function i(c,l){for(let d=c+1;d<l.length;d++)if(l[d].setting)return l[d]}function n(c,l,d){const w=c.indexOf(l),h=c.indexOf(d);return c.filter((P,_)=>w<_&&_<h)}function o(c,l){if(c.length&&l.length){let d=0;for(;d<l.length&&d<c.length;d++)if(c[d].value!==l[d].value)return l[d-1];return l[d-1]}}function a(c){const l=[];let d=-1,w,h;const P={onObjectBegin:_=>{d++},onObjectProperty:(_,j,q)=>{d===0&&(w=j,h=_)},onObjectEnd:(_,j)=>{d--,d===0&&l.push({startOffset:w,endOffset:_+j,value:c.substring(w,_+j),setting:{key:h,commaOffset:void 0}})},onArrayBegin:(_,j)=>{d++},onArrayEnd:(_,j)=>{d--,d===0&&l.push({startOffset:w,endOffset:_+j,value:c.substring(w,_+j),setting:{key:h,commaOffset:void 0}})},onLiteralValue:(_,j,q)=>{d===0&&l.push({startOffset:w,endOffset:j+q,value:c.substring(w,j+q),setting:{key:h,commaOffset:void 0}})},onSeparator:(_,j,q)=>{if(d===0&&_===","){let G=l.length-1;for(;G>=0&&!l[G].setting;G--);const M=l[G];M&&l.splice(G,1,{startOffset:M.startOffset,endOffset:M.endOffset,value:M.value,setting:{key:M.setting.key,commaOffset:j}})}},onComment:(_,j)=>{d===0&&l.push({startOffset:_,endOffset:_+j,value:c.substring(_,_+j)})}};return(0,k.visit)(c,P),l}}),define(Z[185],ee([0,1,10,20,23,121,3,9,25,184,52,45,22,29,19,41]),function(K,e,p,k,A,R,U,O,g,m,T,y,v,b,u,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function C(r){return r&&r.settings&&typeof r.settings=="string"&&Object.keys(r).length===1}function E(r){const t=JSON.parse(r);return C(t)?t:{settings:r}}e.parseSettingsSyncContent=E;let D=class extends y.AbstractJsonFileSynchroniser{constructor(t,i,n,o,a,c,l,d,w,h,P){super(i.settingsResource,"settings",t,i,n,o,a,w,h,c,l,d);this.extensionManagementService=P,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,i,n){const o=await this.getLocalFileContent(),a=await this.getFormattingOptions(),c=this.getSettingsSyncContent(t),l=i?this.getSettingsSyncContent(i):null,d=await this.getIgnoredSettings();let w=null,h=!1,P=!1,_=!1;if(c){let q=o?o.value.toString().trim():"{}";q=q||"{}",this.validateContent(q),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const G=(0,m.merge)(q,c.settings,l?l.settings:null,d,[],a);w=G.localContent||G.remoteContent,h=G.localContent!==null,P=G.remoteContent!==null,_=G.hasConflicts}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),w=o.value.toString(),P=!0);const j={content:w,localChange:h?2:0,remoteChange:P?2:0,hasConflicts:_};return[{fileContent:o,localResource:this.localResource,localContent:o?o.value.toString():null,localChange:j.localChange,remoteResource:this.remoteResource,remoteContent:c?c.settings:null,remoteChange:j.remoteChange,previewResource:this.previewResource,previewResult:j,acceptedResource:this.acceptedResource}]}async getMergeResult(t,i){const n=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return Object.assign(Object.assign({},t.previewResult),{content:t.previewResult.content?(0,m.updateIgnoredSettings)(t.previewResult.content,"{}",o,n):null})}async getAcceptResult(t,i,n,o){const a=await this.getFormattingOptions(),c=await this.getIgnoredSettings();if(this.extUri.isEqual(i,this.localResource))return{content:t.fileContent?(0,m.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",c,a):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(i,this.remoteResource))return{content:t.remoteContent!==null?(0,m.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",c,a):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(i,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,m.updateIgnoredSettings)(n,t.fileContent?t.fileContent.value.toString():"{}",c,a):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async applyResult(t,i,n,o){const{fileContent:a}=n[0][0];let{content:c,localChange:l,remoteChange:d}=n[0][1];if(l===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),c=c?c.trim():"{}",c=c||"{}",this.validateContent(c),l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),a&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(a.value.toString()))),await this.updateLocalFileContent(c,a,o),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),d!==0){const w=await this.getFormattingOptions(),h=this.getSettingsSyncContent(t),P=await this.getIgnoredSettings(c);c=(0,m.updateIgnoredSettings)(c,h?h.settings:"{}",P,w),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(c)),o?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(w){}(i==null?void 0:i.ref)!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const i=await this.getFormattingOptions(),n=(0,T.edit)(t.value.toString(),[k.CONFIGURATION_SYNC_STORE_KEY],void 0,i);return!(0,m.isEmpty)(n)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const i=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:i}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let i=await super.resolveContent(t);if(i)return i;if(i=await super.resolveContent(this.extUri.dirname(t)),i){const n=this.parseSyncData(i);if(n){const o=this.parseSettingsSyncContent(n.content);if(o)switch(this.extUri.basename(t)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(t){let i=await super.resolvePreviewContent(t);if(i){const n=await this.getFormattingOptions(),o=await this.getIgnoredSettings();i=(0,m.updateIgnoredSettings)(i,"{}",o,n)}return i}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return E(t)}catch(i){this.logService.error(i)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=U.Event.any(U.Event.filter(this.extensionManagementService.onDidInstallExtension,o=>!!o.gallery),U.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const i=await this._defaultIgnoredSettings;return(0,m.getIgnoredSettings)(i,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new k.UserDataSyncError((0,R.localize)(0,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const i=JSON.parse(t.value.toString());if(!s(i))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const n=this.parseSettingsSyncContent(i.content);if(!n||!n.settings)return;let o=n.settings;const a=await this.getFormattingOptions();for(const c in i)if(["version","content","machineId"].indexOf(c)===-1&&i[c]!==void 0){const l=(0,S.setProperty)(o,[c],i[c],a);l.length&&(o=(0,S.applyEdits)(o,l))}await this.fileService.writeFile(this.file,A.VSBuffer.fromString(o))}catch(t){}}};D=fe([Y(0,p.IFileService),Y(1,O.IEnvironmentService),Y(2,u.IStorageService),Y(3,k.IUserDataSyncStoreService),Y(4,k.IUserDataSyncBackupStoreService),Y(5,k.IUserDataSyncLogService),Y(6,k.IUserDataSyncUtilService),Y(7,g.IConfigurationService),Y(8,k.IUserDataSyncResourceEnablementService),Y(9,v.ITelemetryService),Y(10,b.IExtensionManagementService)],D),e.SettingsSynchroniser=D;let f=class extends y.AbstractInitializer{constructor(t,i,n){super("settings",i,n,t)}async doInitialize(t){const i=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!i){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,A.VSBuffer.fromString(i.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,m.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return E(t)}catch(i){this.logService.error(i)}return null}};f=fe([Y(0,p.IFileService),Y(1,O.IEnvironmentService),Y(2,k.IUserDataSyncLogService)],f),e.SettingsInitializer=f;function s(r){return!!(r&&r.version!==void 0&&typeof r.version=="number"&&r.content!==void 0&&typeof r.content=="string"&&r.machineId!==void 0&&typeof r.machineId=="string")}}),define(Z[186],ee([0,1,20,9,10,25,45,22,23,179,19,26,3]),function(K,e,p,k,A,R,U,O,g,m,T,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let b=class extends U.AbstractSynchroniser{constructor(C,E,D,f,s,r,t,i,n){super("snippets",E,C,D,f,s,i,n,r,t);this.version=1,this.snippetsFolder=C.snippetsHome,this._register(this.fileService.watch(C.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(v.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(C,E,D){const f=await this.getSnippetsFileContents(),s=this.toSnippetsContents(f),r=C.syncData?this.parseSnippets(C.syncData):null,t=E&&E.syncData?this.parseSnippets(E.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,m.merge)(s,r,t);return this.getResourcePreviews(i,f,r||{})}async getMergeResult(C,E){return C.previewResult}async getAcceptResult(C,E,D,f){if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:C.fileContent?C.fileContent.value.toString():null,localChange:0,remoteChange:C.fileContent?C.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:C.remoteContent,localChange:C.remoteContent!==null?C.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder))return D===void 0?{content:C.previewResult.content,localChange:C.previewResult.localChange,remoteChange:C.previewResult.remoteChange}:{content:D,localChange:D===null?C.fileContent!==null?3:0:2,remoteChange:D===null?C.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${E.toString()}`)}async applyResult(C,E,D,f){const s=D.map(([r,t])=>Object.assign(Object.assign({},r),{acceptResult:t}));s.every(({localChange:r,remoteChange:t})=>r===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),s.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(s),await this.updateLocalSnippets(s,f)),s.some(({remoteChange:r})=>r!==0)&&(C=await this.updateRemoteSnippets(s,C,f)),(E==null?void 0:E.ref)!==C.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(C),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of s)try{await this.fileService.del(r)}catch(t){}}getResourcePreviews(C,E,D){const f=new Map;for(const s of Object.keys(C.local.added)){const r={content:C.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};f.set(s,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(C.local.updated)){const r={content:C.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[s],localContent:E[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of C.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[s],localContent:E[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(C.remote.added)){const r={content:C.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[s],localContent:E[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(C.remote.updated)){const r={content:C.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[s],localContent:E[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of C.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of C.conflicts){const r={content:E[s]?E[s].value.toString():null,hasConflicts:!0,localChange:E[s]?2:1,remoteChange:D[s]?2:1};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[s]||null,localContent:E[s]?E[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(E))if(!f.has(s)){const r={content:E[s]?E[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[s]||null,localContent:E[s]?E[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...f.values()]}async getAssociatedResources({uri:C}){let E=await super.resolveContent(C);if(E){const D=this.parseSyncData(E);if(D){const f=this.parseSnippets(D),s=[];for(const r of Object.keys(f)){const t=this.extUri.joinPath(C,r),i=this.extUri.joinPath(this.snippetsFolder,r),n=await this.fileService.exists(i);s.push({resource:t,comparableResource:n?i:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})})}return s}}return[]}async resolveContent(C){if(this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(C,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(C);let E=await super.resolveContent(C);if(E)return E;if(E=await super.resolveContent(this.extUri.dirname(C)),E){const D=this.parseSyncData(E);if(D)return this.parseSnippets(D)[this.extUri.basename(C)]||null}return null}async hasLocalData(){try{const C=await this.getSnippetsFileContents();if(Object.keys(C).length)return!0}catch(C){}return!1}async updateLocalBackup(C){const E={};for(const D of C)D.fileContent&&(E[this.extUri.basename(D.localResource)]=D.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(E)))}async updateLocalSnippets(C,E){for(const{fileContent:D,acceptResult:f,localResource:s,remoteResource:r,localChange:t}of C)if(t!==0){const i=r?this.extUri.basename(r):this.extUri.basename(s),n=this.extUri.joinPath(this.snippetsFolder,i);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(n)),await this.fileService.del(n),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(n))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(n)),await this.fileService.createFile(n,g.VSBuffer.fromString(f.content),{overwrite:E}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(n))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(n)),await this.fileService.writeFile(n,g.VSBuffer.fromString(f.content),E?void 0:D),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(n)))}}async updateRemoteSnippets(C,E,D){const f=E.syncData?this.parseSnippets(E.syncData):{},s=(0,y.deepClone)(f);for(const{acceptResult:r,localResource:t,remoteResource:i,remoteChange:n}of C)if(n!==0){const o=t?this.extUri.basename(t):this.extUri.basename(i);n===3?delete s[o]:s[o]=r.content}return(0,m.areSame)(f,s)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),E=await this.updateRemoteUserData(JSON.stringify(s),D?null:E.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),E}parseSnippets(C){return JSON.parse(C.content)}toSnippetsContents(C){const E={};for(const D of Object.keys(C))E[D]=C[D].value.toString();return E}async getSnippetsFileContents(){const C={};let E;try{E=await this.fileService.resolve(this.snippetsFolder)}catch(D){if(D instanceof A.FileOperationError&&D.fileOperationResult===1)return C;throw D}for(const D of E.children||[]){const f=D.resource,s=this.extUri.extname(f);if(s===".json"||s===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,f),t=await this.fileService.readFile(f);C[r]=t}}return C}};b=fe([Y(0,k.IEnvironmentService),Y(1,A.IFileService),Y(2,T.IStorageService),Y(3,p.IUserDataSyncStoreService),Y(4,p.IUserDataSyncBackupStoreService),Y(5,p.IUserDataSyncLogService),Y(6,R.IConfigurationService),Y(7,p.IUserDataSyncResourceEnablementService),Y(8,O.ITelemetryService)],b),e.SnippetsSynchroniser=b;let u=class extends U.AbstractInitializer{constructor(C,E,D){super("snippets",E,D,C)}async doInitialize(C){const E=C.syncData?JSON.parse(C.syncData.content):null;if(!E){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const f of Object.keys(E)){const s=E[f];if(s){const r=this.extUri.joinPath(this.environmentService.snippetsHome,f);await this.fileService.createFile(r,g.VSBuffer.fromString(s)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(C)}async isEmpty(){var C;try{return!((C=(await this.fileService.resolve(this.environmentService.snippetsHome)).children)===null||C===void 0?void 0:C.length)}catch(E){return E.fileOperationResult===1}}};u=fe([Y(0,A.IFileService),Y(1,k.IEnvironmentService),Y(2,p.IUserDataSyncLogService)],u),e.SnippetsInitializer=u}),define(Z[59],ee([0,1,5,3,2,20]),function(K,e,p,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,p.createDecorator)("IUserDataSyncAccountService");let U=class extends A.Disposable{constructor(g){super();this.userDataSyncStoreService=g,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(g.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(g.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(g){(g&&this._account?g.token!==this._account.token||g.authenticationProviderId!==this._account.authenticationProviderId:g!==this._account)&&(this._account=g,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(g))}};U=fe([Y(0,R.IUserDataSyncStoreService)],U),e.UserDataSyncAccountService=U}),define(Z[187],ee([0,1,2,20,12,25,10,9,54,23,6]),function(K,e,p,k,A,R,U,O,g,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let y=class extends p.Disposable{constructor(b,u,S,C){super();this.environmentService=b,this.fileService=u,this.configurationService=S,this.logService=C,k.ALL_SYNC_RESOURCES.forEach(E=>this.cleanUpBackup(E))}async getAllRefs(b){const u=(0,A.joinPath)(this.environmentService.userDataSyncHome,b),S=await this.fileService.resolve(u);return S.children?S.children.filter(E=>E.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(E.name)).sort().reverse().map(E=>({ref:E.name,created:this.getCreationTime(E)})):[]}async resolveContent(b,u){if(!u){const S=await this.getAllRefs(b);S.length&&(u=S[S.length-1].ref)}if(u){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,b,u);return(await this.fileService.readFile(S)).value.toString()}return null}async backup(b,u){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,b),C=(0,A.joinPath)(S,`${(0,g.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(C,m.VSBuffer.fromString(u))}catch(E){this.logService.error(E)}try{this.cleanUpBackup(b)}catch(E){}}async cleanUpBackup(b){const u=(0,A.joinPath)(this.environmentService.userDataSyncHome,b);try{try{if(!await this.fileService.exists(u))return}catch(C){return}const S=await this.fileService.resolve(u);if(S.children){const C=S.children.filter(s=>s.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(s.name)).sort(),E=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let D=C.filter(s=>Date.now()-this.getCreationTime(s)>E);const f=C.length-D.length;f<10&&(D=D.slice(10-f)),await T.Promises.settled(D.map(async s=>{this.logService.info("Deleting from backup",s.resource.path),await this.fileService.del(s.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(b){return b.ctime||new Date(parseInt(b.name.substring(0,4)),parseInt(b.name.substring(4,6))-1,parseInt(b.name.substring(6,8)),parseInt(b.name.substring(9,11)),parseInt(b.name.substring(11,13)),parseInt(b.name.substring(13,15))).getTime()}};y=fe([Y(0,O.IEnvironmentService),Y(1,U.IFileService),Y(2,R.IConfigurationService),Y(3,k.IUserDataSyncLogService)],y),e.UserDataSyncBackupStoreService=y}),define(Z[188],ee([0,1,4,2]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class A{constructor(v){this.service=v}listen(v,b){switch(b){case"onError":return this.service.onError}throw new Error(`Event not found: ${b}`)}call(v,b,u){switch(b){case"triggerSync":return this.service.triggerSync(u[0],u[1],u[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(u[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=A;class R{constructor(v){this.service=v}listen(v,b){throw new Error(`Event not found: ${b}`)}call(v,b,u){switch(b){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(u[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(p.URI.revive(u[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=R;class U{constructor(v){this.channel=v}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(v){return this.channel.call("resolveUserKeybindings",[v])}async resolveFormattingOptions(v){return this.channel.call("resolveFormattingOptions",[v])}}e.UserDataSyncUtilServiceClient=U;class O{constructor(v){this.service=v}listen(v,b){switch(b){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${b}`)}async call(v,b,u){switch(b){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(u[0],u[1]);case"setEnablement":return this.service.setEnablement(u[0],u[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=O;class g{constructor(v){this.service=v}listen(v,b){switch(b){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${b}`)}call(v,b,u){switch(b){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(u)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=g;class m{constructor(v){this.service=v}listen(v,b){switch(b){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${b}`)}call(v,b,u){switch(b){case"switch":return this.service.switch(u[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=m;class T extends k.Disposable{constructor(v){super();this.channel=v,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(v){return this.channel.call("switch",[v])}async getPreviousUserDataSyncStore(){const v=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(v)}revive(v){return{url:p.URI.revive(v.url),type:v.type,defaultUrl:p.URI.revive(v.defaultUrl),insidersUrl:p.URI.revive(v.insidersUrl),stableUrl:p.URI.revive(v.stableUrl),canSwitch:v.canSwitch,authenticationProviders:v.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=T}),define(Z[189],ee([0,1,17,9]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let A=class extends p.AbstractLogger{constructor(U,O){super();this.logger=this._register(U.createLogger(O.userDataSyncLogResource,{name:"settingssync"}))}trace(U,...O){this.logger.trace(U,...O)}debug(U,...O){this.logger.debug(U,...O)}info(U,...O){this.logger.info(U,...O)}warn(U,...O){this.logger.warn(U,...O)}error(U,...O){this.logger.error(U,...O)}critical(U,...O){this.logger.critical(U,...O)}flush(){this.logger.flush()}};A=fe([Y(0,p.ILoggerService),Y(1,k.IEnvironmentService)],A),e.UserDataSyncLogService=A}),define(Z[60],ee([0,1,5,2,44,9,10,19,20,124,28,7,21,3]),function(K,e,p,k,A,R,U,O,g,m,T,y,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,p.createDecorator)("IUserDataSyncMachinesService");const u="sync.currentMachineName";let S=class He extends k.Disposable{constructor(E,D,f,s,r,t){super();this.storageService=f,this.userDataSyncStoreService=s,this.logService=r,this.productService=t,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,A.getServiceMachineId)(E,D,f)}async getMachines(E){const D=await this.currentMachineIdPromise;return(await this.readMachinesData(E)).machines.map(s=>Object.assign(Object.assign({},s),{isCurrent:s.id===D}))}async addCurrentMachine(E){const D=await this.currentMachineIdPromise,f=await this.readMachinesData(E);f.machines.some(({id:s})=>s===D)||(f.machines.push({id:D,name:this.computeCurrentMachineName(f.machines)}),await this.writeMachinesData(f))}async removeCurrentMachine(E){const D=await this.currentMachineIdPromise,f=await this.readMachinesData(E),s=f.machines.filter(({id:r})=>r!==D);s.length!==f.machines.length&&(f.machines=s,await this.writeMachinesData(f))}async renameMachine(E,D,f){const s=await this.currentMachineIdPromise,r=await this.readMachinesData(f),t=r.machines.find(({id:i})=>i===E);t&&(t.name=D,await this.writeMachinesData(r),r.machines.some(({id:i})=>i===s)&&this.storageService.store(u,D,0,1))}async setEnablement(E,D){const f=await this.readMachinesData(),s=f.machines.find(({id:r})=>r===E);s&&(s.disabled=D?void 0:!0,await this.writeMachinesData(f))}computeCurrentMachineName(E){const D=this.storageService.get(u,0);if(D)return D;const f=`${this.productService.nameLong} (${(0,y.PlatformToString)(y.isWeb?0:y.platform)})`,s=new RegExp(`${(0,v.escapeRegExpCharacters)(f)}\\s#(\\d+)`);let r=0;for(const t of E){const i=s.exec(t.name),n=i?parseInt(i[1]):0;r=n>r?n:r}return`${f} #${r+1}`}async readMachinesData(E){this.userData=await this.readUserData(E);const D=this.parse(this.userData);if(D.version!==He.VERSION)throw new Error((0,m.localize)(0,null,this.productService.nameLong));return D}async writeMachinesData(E){var D;const f=JSON.stringify(E),s=await this.userDataSyncStoreService.write(He.RESOURCE,f,((D=this.userData)===null||D===void 0?void 0:D.ref)||null);this.userData={ref:s,content:f},this._onDidChange.fire()}async readUserData(E){if(this.userData){const D=E&&E.latest?E.latest[He.RESOURCE]:void 0;if(this.userData.ref===D)return this.userData;if(D===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(He.RESOURCE,this.userData)}parse(E){if(E.content!==null)try{return JSON.parse(E.content)}catch(D){this.logService.error(D)}return{version:He.VERSION,machines:[]}}};S.VERSION=1,S.RESOURCE="machines",S=fe([Y(0,R.IEnvironmentService),Y(1,U.IFileService),Y(2,O.IStorageService),Y(3,g.IUserDataSyncStoreService),Y(4,g.IUserDataSyncLogService),Y(5,T.IProductService)],S),e.UserDataSyncMachinesService=S}),define(Z[84],ee([0,1,6,3,2,20,59,22,11,19,9,60,122,54,4,12,7,28]),function(K,e,p,k,A,R,U,O,g,m,T,y,v,b,u,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const D="sync.enable",f="sync.disableMachineEventually",s="sync.sessionId",r="sync.storeUrl",t="sync.productQuality";let i=class extends A.Disposable{constructor(c,l,d){super();this.storageService=c,this.environmentService=l,this.userDataSyncStoreManagementService=d,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(c.onDidChangeValue(w=>this.onDidStorageChange(w)))}isEnabled(c){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(D,0,!!c)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(c){c&&!this.canToggleEnablement()||this.storageService.store(D,c,0,1)}onDidStorageChange(c){if(c.scope===0&&D===c.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};i=fe([Y(0,m.IStorageService),Y(1,T.IEnvironmentService),Y(2,R.IUserDataSyncStoreManagementService)],i),e.UserDataAutoSyncEnablementService=i;let n=class extends A.Disposable{constructor(c,l,d,w,h,P,_,j,q,G,M){var z;super();this.userDataSyncStoreManagementService=l,this.userDataSyncStoreService=d,this.userDataSyncResourceEnablementService=w,this.userDataSyncService=h,this.logService=P,this.userDataSyncAccountService=_,this.telemetryService=j,this.userDataSyncMachinesService=q,this.storageService=G,this.autoSync=this._register(new A.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=M,this.syncTriggerDelayer=this._register(new p.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=(z=l.userDataSyncStore)===null||z===void 0?void 0:z.url,this.previousProductQuality=this.productQuality,this.productQuality=c.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(l.onDidChangeUserDataSyncStore(()=>{var $,V;(0,S.isEqual)(this.syncUrl,($=l.userDataSyncStore)===null||$===void 0?void 0:$.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=(V=l.userDataSyncStore)===null||V===void 0?void 0:V.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(_.onDidChangeAccount(()=>this.updateAutoSync())),this._register(d.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(k.Event.debounce(h.onDidChangeLocal,($,V)=>$?[...$,V]:[V],1e3)($=>this.triggerSync($,!1,!1))),this._register(k.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const c=this.storageService.get(r,0);return c?u.URI.parse(c):void 0}set syncUrl(c){c?this.storageService.store(r,c.toString(),0,1):this.storageService.remove(r,0)}get productQuality(){return this.storageService.get(t,0)}set productQuality(c){c?this.storageService.store(t,c,0,1):this.storageService.remove(t,0)}updateAutoSync(){const{enabled:c,message:l}=this.isAutoSyncEnabled();c?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(d=>this.onDidFinishSync(d))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(l&&this.logService.info(l),this.autoSync.clear()):l&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(l))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,b.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(c,l,d){try{this.userDataSyncAccountService.account&&!d&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(s,0),c?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(w){if(l)this.logService.error(w),this.updateEnablement(!1);else throw w}}updateEnablement(c){this.userDataAutoSyncEnablementService.isEnabled()!==c&&(this.telemetryService.publicLog2(D,{enabled:c}),this.userDataAutoSyncEnablementService.setEnablement(c),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(c){if(!c){this.successiveFailures=0;return}const l=R.UserDataSyncError.toUserDataSyncError(c);l instanceof R.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:l.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),l.code===R.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):l.code===R.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):l.code===R.UserDataSyncErrorCode.LocalTooManyRequests||l.code===R.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):l.code===R.UserDataSyncErrorCode.UpgradeRequired||l.code===R.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):l.code===R.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${l.resource} content with newer version than of client. Requires client upgrade.`)):l.code===R.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${l.resource} content with older version than of client. Requires server reset.`)):l.code===R.UserDataSyncErrorCode.ServiceChanged||l.code===R.UserDataSyncErrorCode.DefaultServiceChanged?C.isWeb&&l.code===R.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(l),this.successiveFailures++),this._onError.fire(l)}async disableMachineEventually(){this.storageService.store(f,!0,0,1),await(0,p.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(f,0,!1)}stopDisableMachineEventually(){this.storageService.remove(f,0)}async triggerSync(c,l,d){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(l&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...c),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",d)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};n=fe([Y(0,E.IProductService),Y(1,R.IUserDataSyncStoreManagementService),Y(2,R.IUserDataSyncStoreService),Y(3,R.IUserDataSyncResourceEnablementService),Y(4,R.IUserDataSyncService),Y(5,R.IUserDataSyncLogService),Y(6,U.IUserDataSyncAccountService),Y(7,O.ITelemetryService),Y(8,y.IUserDataSyncMachinesService),Y(9,m.IStorageService),Y(10,R.IUserDataAutoSyncEnablementService)],n),e.UserDataAutoSyncService=n;class o extends A.Disposable{constructor(c,l,d,w,h,P,_,j){super();this.lastSyncUrl=c,this.interval=l,this.userDataSyncStoreManagementService=d,this.userDataSyncStoreService=w,this.userDataSyncService=h,this.userDataSyncMachinesService=P,this.logService=_,this.storageService=j,this.intervalHandler=this._register(new A.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,A.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,p.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(c,l){const d=(0,p.createCancelablePromise)(async w=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(h){if((0,g.isPromiseCanceledError)(h))return}return this.doSync(c,l,w)});return this.syncPromise=d,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){var c;return this.lastSyncUrl!==void 0&&!(0,S.isEqual)(this.lastSyncUrl,(c=this.userDataSyncStoreManagementService.userDataSyncStore)===null||c===void 0?void 0:c.url)}async hasDefaultServiceChanged(){const c=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),l=this.userDataSyncStoreManagementService.userDataSyncStore;return!!l&&!!c&&(!(0,S.isEqual)(l.defaultUrl,c.defaultUrl)||!(0,S.isEqual)(l.insidersUrl,c.insidersUrl)||!(0,S.isEqual)(l.stableUrl,c.stableUrl))}async doSync(c,l,d){this.logService.info(`Auto Sync: Triggered by ${c}`),this._onDidStartSync.fire();let w;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(l),d.isCancellationRequested)return;let h=this.syncTask.manifest;if(h===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new R.UserDataAutoSyncError((0,v.localize)(0,null),R.UserDataSyncErrorCode.DefaultServiceChanged):new R.UserDataAutoSyncError((0,v.localize)(1,null),R.UserDataSyncErrorCode.ServiceChanged):new R.UserDataAutoSyncError((0,v.localize)(2,null),R.UserDataSyncErrorCode.TurnedOff);const P=this.storageService.get(s,0);if(P&&h&&P!==h.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new R.UserDataAutoSyncError((0,v.localize)(3,null),R.UserDataSyncErrorCode.DefaultServiceChanged):new R.UserDataAutoSyncError((0,v.localize)(4,null),R.UserDataSyncErrorCode.ServiceChanged):new R.UserDataAutoSyncError((0,v.localize)(5,null),R.UserDataSyncErrorCode.SessionExpired);const _=await this.userDataSyncMachinesService.getMachines(h||void 0);if(d.isCancellationRequested)return;const j=_.find(q=>q.isCurrent);if(j==null?void 0:j.disabled)throw new R.UserDataAutoSyncError((0,v.localize)(6,null),R.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),h===null&&(h=await this.userDataSyncStoreService.manifest()),h&&h.session!==P&&this.storageService.store(s,h.session,0,1),d.isCancellationRequested)return;j||await this.userDataSyncMachinesService.addCurrentMachine(h||void 0)}catch(h){this.logService.error(h),w=h}this._onDidFinishSync.fire(w)}register(c){return super._register(c)}}o.INTERVAL_SYNCING="Interval"}),define(Z[190],ee([0,1,20,2,3,19,22,7]),function(K,e,p,k,A,R,U,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let g=class extends k.Disposable{constructor(T,y){super();this.storageService=T,this.telemetryService=y,this._onDidChangeResourceEnablement=new A.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(T.onDidChangeValue(v=>this.onDidStorageChange(v)))}isResourceEnabled(T){return this.storageService.getBoolean((0,p.getEnablementKey)(T),0,!0)}setResourceEnablement(T,y){if(this.isResourceEnabled(T)!==y){const v=(0,p.getEnablementKey)(T);this.telemetryService.publicLog2(v,{enabled:y}),this.storeResourceEnablement(v,y)}}getResourceSyncStateVersion(T){}storeResourceEnablement(T,y){this.storageService.store(T,y,0,O.isWeb?0:1)}onDidStorageChange(T){if(T.scope===0){const y=p.ALL_SYNC_RESOURCES.filter(v=>(0,p.getEnablementKey)(v)===T.key)[0];if(y){this._onDidChangeResourceEnablement.fire([y,this.isResourceEnabled(y)]);return}}}};g=fe([Y(0,R.IStorageService),Y(1,U.ITelemetryService)],g),e.UserDataSyncResourceEnablementService=g}),define(Z[191],ee([0,1,20,2,5,3,180,183,182,43,22,18,19,185,12,186,31,6,11]),function(K,e,p,k,A,R,U,O,g,m,T,y,v,b,u,S,C,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const f="sync.lastSyncTime";let s=class extends k.Disposable{constructor(n,o,a,c,l,d){super();this.userDataSyncStoreService=n,this.userDataSyncStoreManagementService=o,this.instantiationService=a,this.logService=c,this.telemetryService=l,this.storageService=d,this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new R.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new R.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(b.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(O.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(S.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(g.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(U.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(R.Event.any(...this.synchronisers.map(w=>R.Event.map(w.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(R.Event.any(...this.synchronisers.map(w=>R.Event.map(w.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(f,0,void 0),this.onDidChangeLocal=R.Event.any(...this.synchronisers.map(w=>R.Event.map(w.onDidChangeLocal,()=>w.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(n){await this.checkEnablement();const o=(0,C.generateUuid)();let a;try{const w=(0,p.createSyncHeaders)(o);n&&(w["Cache-Control"]="no-cache"),a=await this.userDataSyncStoreService.manifest(w)}catch(w){const h=p.UserDataSyncError.toUserDataSyncError(w);throw this.reportUserDataSyncError(h,o),h}let c=!1;const l=this;let d;return{manifest:a,run(){if(c)throw new Error("Can run a task only once");return d=(0,E.createCancelablePromise)(w=>l.sync(a,o,w)),d.finally(()=>d=void 0)},async stop(){if(d&&d.cancel(),l.status!=="idle")return l.stop()}}}async createManualSyncTask(){await this.checkEnablement();const n=(0,C.generateUuid)(),o=(0,p.createSyncHeaders)(n);let a;try{a=await this.userDataSyncStoreService.manifest(o)}catch(c){const l=p.UserDataSyncError.toUserDataSyncError(c);throw this.reportUserDataSyncError(l,n),l}return new r(n,a,o,this.synchronisers,this.logService)}async sync(n,o,a){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),!a.isCancellationRequested){const c=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const l=(0,p.createSyncHeaders)(o);for(const d of this.synchronisers){if(a.isCancellationRequested)return;try{await d.sync(n,l)}catch(w){if(w instanceof p.UserDataSyncError)switch(w.code){case p.UserDataSyncErrorCode.TooLarge:throw new p.UserDataSyncError(w.message,w.code,d.resource);case p.UserDataSyncErrorCode.TooManyRequests:case p.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case p.UserDataSyncErrorCode.LocalTooManyRequests:case p.UserDataSyncErrorCode.Gone:case p.UserDataSyncErrorCode.UpgradeRequired:case p.UserDataSyncErrorCode.IncompatibleRemoteContent:case p.UserDataSyncErrorCode.IncompatibleLocalContent:throw w}const h=p.UserDataSyncError.toUserDataSyncError(w);this.reportUserDataSyncError(h,o),this.logService.error(w),this.logService.error(`${d.resource}: ${(0,m.toErrorMessage)(w)}`),this._syncErrors.push([d.resource,h])}}this.logService.info(`Sync done. Took ${new Date().getTime()-c}ms`),this.updateLastSyncTime()}catch(l){const d=p.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(d,o),d}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}}async stop(){if(this.status!=="idle")for(const n of this.synchronisers)try{n.status!=="idle"&&await n.stop()}catch(o){this.logService.error(o)}}async replace(n){await this.checkEnablement();for(const o of this.synchronisers)if(await o.replace(n))return}async accept(n,o,a,c){await this.checkEnablement();const l=this.getSynchroniser(n);await l.accept(o,a),c&&await l.apply(!1,(0,p.createSyncHeaders)((0,C.generateUuid)()))}async resolveContent(n){for(const o of this.synchronisers){const a=await o.resolveContent(n);if(a)return a}return null}getRemoteSyncResourceHandles(n){return this.getSynchroniser(n).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(n){return this.getSynchroniser(n).getLocalSyncResourceHandles()}getAssociatedResources(n,o){return this.getSynchroniser(n).getAssociatedResources(o)}getMachineId(n,o){return this.getSynchroniser(n).getMachineId(o)}async hasLocalData(){const n=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const o of n)if(await o.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(n){this.logService.error(n)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(f,0);for(const n of this.synchronisers)try{await n.resetLocal()}catch(o){this.logService.error(`${n.resource}: ${(0,m.toErrorMessage)(o)}`),this.logService.error(o)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const n of this.synchronisers)if(await n.hasPreviouslySynced())return!0;return!1}setStatus(n){const o=this._status;this._status!==n&&(this._status=n,this._onDidChangeStatus.fire(n),o==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const n=this.computeStatus();this.setStatus(n)}updateConflicts(){const n=this.computeConflicts();(0,y.equals)(this._conflicts,n,([o,a],[c,l])=>o===o&&(0,y.equals)(a,l,(d,w)=>(0,u.isEqual)(d.previewResource,w.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(n))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(f,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(n,o){this.telemetryService.publicLog2("sync/error",{code:n.code,url:n instanceof p.UserDataSyncStoreError?n.url:void 0,resource:n.resource,executionId:o,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(n=>n.status==="hasConflicts").map(n=>[n.resource,n.conflicts.map(t)])}getSynchroniser(n){return this.synchronisers.find(o=>o.resource===n)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};s=fe([Y(0,p.IUserDataSyncStoreService),Y(1,p.IUserDataSyncStoreManagementService),Y(2,A.IInstantiationService),Y(3,p.IUserDataSyncLogService),Y(4,T.ITelemetryService),Y(5,v.IStorageService)],s),e.UserDataSyncService=s;class r extends k.Disposable{constructor(n,o,a,c,l){super();this.id=n,this.manifest=o,this.syncHeaders=a,this.synchronisers=c,this.logService=l,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new R.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,E.createCancelablePromise)(n=>this.getPreviews(n))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(n){throw this.logService.error(n),n}}async accept(n,o){try{return await this.performAction(n,a=>a.accept(n,o))}catch(a){throw this.logService.error(a),a}}async merge(n){try{return n?await this.performAction(n,o=>o.merge(n)):await this.mergeAll()}catch(o){throw this.logService.error(o),o}}async discard(n){try{return await this.performAction(n,o=>o.discard(n))}catch(o){throw this.logService.error(o),o}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const n=[];for(const[,o]of this.previews)for(const a of o.resourcePreviews)a.mergeState==="conflict"&&n.push(a.previewResource);for(const o of n)await this.discard(o);return this.previews}catch(n){throw this.logService.error(n),n}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const n=[];for(const[o,a]of this.previews){this.synchronizingResources.push([o,a.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(d=>d.resource===o);for(const d of a.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&await c.merge(d.previewResource);const l=await c.apply(!1,this.syncHeaders);l&&n.push(this.toSyncResourcePreview(c.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}catch(n){throw this.logService.error(n),n}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,o]of this.previews){this.synchronizingResources.push([n,o.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const a=this.synchronisers.find(c=>c.resource===n);for(const c of o.resourcePreviews)await a.accept(c.remoteResource);await a.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,o]of this.previews){this.synchronizingResources.push([n,o.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const a=this.synchronisers.find(c=>c.resource===n);for(const c of o.resourcePreviews)await a.accept(c.localResource);await a.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async stop(){for(const n of this.synchronisers)try{await n.stop()}catch(o){(0,D.isPromiseCanceledError)(o)||this.logService.error(o)}this.reset()}async performAction(n,o){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const a=this.previews.findIndex(([,j])=>j.resourcePreviews.some(({localResource:q,previewResource:G,remoteResource:M})=>(0,u.isEqual)(n,q)||(0,u.isEqual)(n,G)||(0,u.isEqual)(n,M)));if(a===-1)return this.previews;const[c,l]=this.previews[a],d=l.resourcePreviews.find(({localResource:j,remoteResource:q,previewResource:G})=>(0,u.isEqual)(j,n)||(0,u.isEqual)(q,n)||(0,u.isEqual)(G,n));if(!d)return this.previews;let w=this.synchronizingResources.find(j=>j[0]===c);w||(w=[c,[]],this.synchronizingResources.push(w)),w[1].some(j=>(0,u.isEqual)(j,d.localResource))||(w[1].push(d.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const h=this.synchronisers.find(j=>j.resource===this.previews[a][0]),P=await o(h);P?this.previews.splice(a,1,this.toSyncResourcePreview(h.resource,P)):this.previews.splice(a,1);const _=this.synchronizingResources.findIndex(j=>j[0]===c);return this.synchronizingResources[_][1].splice(w[1].findIndex(j=>(0,u.isEqual)(j,d.localResource)),1),w[1].length||(this.synchronizingResources.splice(_,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const n=[];for(const[o,a]of this.previews){this.synchronizingResources.push([o,a.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(d=>d.resource===o);let l=a;for(const d of a.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&(l=await c.merge(d.previewResource));l&&n.push(this.toSyncResourcePreview(c.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}async getPreviews(n){const o=[];for(const a of this.synchronisers){if(n.isCancellationRequested)return[];const c=await a.preview(this.manifest,this.syncHeaders);c&&o.push(this.toSyncResourcePreview(a.resource,c))}return o}toSyncResourcePreview(n,o){return[n,{isLastSyncFromCurrentMachine:o.isLastSyncFromCurrentMachine,resourcePreviews:o.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(i){return{localResource:i.localResource,previewResource:i.previewResource,remoteResource:i.remoteResource,acceptedResource:i.acceptedResource,localChange:i.localChange,remoteChange:i.remoteChange,mergeState:i.mergeState}}}),define(Z[192],ee([0,1,3,20,4,2,15]),function(K,e,p,k,A,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class O{constructor(y,v){this.service=y,this.logService=v,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new p.Emitter}listen(y,v){switch(v){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${v}`)}async call(y,v,b){try{return await this._call(y,v,b)}catch(u){throw this.logService.error(u),u}}async _call(y,v,b){switch(v){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(A.URI.revive(b[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(b[0],A.URI.revive(b[1]),b[2],b[3]);case"resolveContent":return this.service.resolveContent(A.URI.revive(b[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(b[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(b[0]);case"getAssociatedResources":return this.service.getAssociatedResources(b[0],{created:b[1].created,uri:A.URI.revive(b[1].uri)});case"getMachineId":return this.service.getMachineId(b[0],{created:b[1].created,uri:A.URI.revive(b[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(v.startsWith("manualSync/")){const u=v.substring("manualSync/".length),S=b[0],C=this.getManualSyncTask(S);switch(b=b.slice(1),u){case"preview":return C.preview();case"accept":return C.accept(A.URI.revive(b[0]),b[1]);case"merge":return C.merge(A.URI.revive(b[0]));case"discard":return C.discard(A.URI.revive(b[0]));case"discardConflicts":return C.discardConflicts();case"apply":return C.apply();case"pull":return C.pull();case"push":return C.push();case"stop":return C.stop();case"_getStatus":return C.status;case"dispose":return this.disposeManualSyncTask(C)}}throw new Error("Invalid call")}getManualSyncTask(y){const v=this.manualSyncTasks.get(this.createKey(y));if(!v)throw new Error(`Manual sync taks not found: ${y}`);return v.manualSyncTask}async createManualSyncTask(){const y=new R.DisposableStore,v=y.add(await this.service.createManualSyncTask());return y.add(v.onSynchronizeResources(b=>this.onManualSynchronizeResources.fire({manualSyncTaskId:v.id,data:b}))),this.manualSyncTasks.set(this.createKey(v.id),{manualSyncTask:v,disposables:y}),{id:v.id,manifest:v.manifest,status:v.status}}disposeManualSyncTask(y){var v;y.dispose();const b=this.createKey(y.id);(v=this.manualSyncTasks.get(b))===null||v===void 0||v.disposables.dispose(),this.manualSyncTasks.delete(b)}createKey(y){return`manualSyncTask-${y}`}}e.UserDataSyncChannel=O;class g extends R.Disposable{constructor(y){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new p.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new p.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new p.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new p.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(v,b,u){return y.call(v,b,u).then(null,S=>{throw k.UserDataSyncError.toUserDataSyncError(S)})},listen(v,b){return y.listen(v,b)}},this.channel.call("_getInitialData").then(([v,b,u])=>{this.updateStatus(v),this.updateConflicts(b),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(S=>this.updateStatus(S))),this._register(this.channel.listen("onDidChangeLastSyncTime")(S=>this.updateLastSyncTime(S)))}),this._register(this.channel.listen("onDidChangeConflicts")(v=>this.updateConflicts(v))),this._register(this.channel.listen("onSyncErrors")(v=>this._onSyncErrors.fire(v.map(([b,u])=>[b,k.UserDataSyncError.toUserDataSyncError(u)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:y,manifest:v,status:b}=await this.channel.call("createManualSyncTask"),u=this,S=new m(y,v,b,{async call(C,E,D){return u.channel.call(`manualSync/${C}`,[y,...(0,U.isArray)(E)?E:[E]],D)},listen(C,E){return p.Event.map(p.Event.filter(u.channel.listen(`manualSync/${C}`,E),D=>!S.isDiposed()&&D.manualSyncTaskId===y),D=>D.data)}});return S}replace(y){return this.channel.call("replace",[y])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(y,v,b,u){return this.channel.call("accept",[y,v,b,u])}resolveContent(y){return this.channel.call("resolveContent",[y])}async getLocalSyncResourceHandles(y){return(await this.channel.call("getLocalSyncResourceHandles",[y])).map(({created:b,uri:u})=>({created:b,uri:A.URI.revive(u)}))}async getRemoteSyncResourceHandles(y){return(await this.channel.call("getRemoteSyncResourceHandles",[y])).map(({created:b,uri:u})=>({created:b,uri:A.URI.revive(u)}))}async getAssociatedResources(y,v){return(await this.channel.call("getAssociatedResources",[y,v])).map(({resource:u,comparableResource:S})=>({resource:A.URI.revive(u),comparableResource:A.URI.revive(S)}))}async getMachineId(y,v){return this.channel.call("getMachineId",[y,v])}async updateStatus(y){this._status=y,this._onDidChangeStatus.fire(y)}async updateConflicts(y){this._conflicts=y.map(([v,b])=>[v,b.map(u=>Object.assign(Object.assign({},u),{localResource:A.URI.revive(u.localResource),remoteResource:A.URI.revive(u.remoteResource),previewResource:A.URI.revive(u.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(y){this._lastSyncTime!==y&&(this._lastSyncTime=y,this._onDidChangeLastSyncTime.fire(y))}}e.UserDataSyncChannelClient=g;class m extends R.Disposable{constructor(y,v,b,u){super();this.id=y,this.manifest=v,this._disposed=!1,this._status=b;const S=this;this.channel={async call(C,E,D){try{const f=await u.call(C,E,D);return S.isDiposed()||(S._status=await u.call("_getStatus")),f}catch(f){throw k.UserDataSyncError.toUserDataSyncError(f)}},listen(C,E){return u.listen(C,E)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const y=await this.channel.call("preview");return this.deserializePreviews(y)}async accept(y,v){const b=await this.channel.call("accept",[y,v]);return this.deserializePreviews(b)}async merge(y){const v=await this.channel.call("merge",[y]);return this.deserializePreviews(v)}async discard(y){const v=await this.channel.call("discard",[y]);return this.deserializePreviews(v)}async discardConflicts(){const y=await this.channel.call("discardConflicts");return this.deserializePreviews(y)}async apply(){const y=await this.channel.call("apply");return this.deserializePreviews(y)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(y){return y.map(([v,b])=>[v,{isLastSyncFromCurrentMachine:b.isLastSyncFromCurrentMachine,resourcePreviews:b.resourcePreviews.map(u=>Object.assign(Object.assign({},u),{localResource:A.URI.revive(u.localResource),remoteResource:A.URI.revive(u.remoteResource),previewResource:A.URI.revive(u.previewResource),acceptedResource:A.URI.revive(u.acceptedResource)}))}])}}}),define(Z[193],ee([0,1,2,20,40,12,30,25,28,44,9,10,19,31,7,3,6,15,4,11]),function(K,e,p,k,A,R,U,O,g,m,T,y,v,b,u,S,C,E,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const s="sync.previous.store",r="sync.donot-make-requests-until",t="sync.user-session-id",i="sync.machine-session-id",n=100,o=1e3*60*5;let a=class extends p.Disposable{constructor(P,_,j){super();this.productService=P,this.configurationService=_,this.storageService=j,this._onDidChangeUserDataSyncStore=this._register(new S.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(S.Event.filter(j.onDidChangeValue,q=>{var G;return q.key===k.SYNC_SERVICE_URL_TYPE&&q.scope===0&&this.userDataSyncStoreType!==((G=this.userDataSyncStore)===null||G===void 0?void 0:G.type)})(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(k.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(P){this.storageService.store(k.SYNC_SERVICE_URL_TYPE,P,0,u.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[k.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(k.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(P,_){P=u.isWeb&&(P==null?void 0:P.web)?Object.assign(Object.assign({},P),P.web):P;const j=Object.assign(Object.assign({},P||{}),_||{});if(j&&(0,E.isString)(j.url)&&(0,E.isObject)(j.authenticationProviders)&&Object.keys(j.authenticationProviders).every(q=>(0,E.isArray)(j.authenticationProviders[q].scopes))){const q=j,G=!!q.canSwitch&&!(_==null?void 0:_.url),M=q.url===q.insidersUrl?"insiders":"stable",z=(G?this.userDataSyncStoreType:void 0)||M,$=(_==null?void 0:_.url)||(z==="insiders"?q.insidersUrl:z==="stable"?q.stableUrl:q.url);return{url:D.URI.parse($),type:z,defaultType:M,defaultUrl:D.URI.parse(q.url),stableUrl:D.URI.parse(q.stableUrl),insidersUrl:D.URI.parse(q.insidersUrl),canSwitch:G,authenticationProviders:Object.keys(q.authenticationProviders).reduce((V,H)=>(V.push({id:H,scopes:q.authenticationProviders[H].scopes}),V),[])}}}};a=fe([Y(0,g.IProductService),Y(1,O.IConfigurationService),Y(2,v.IStorageService)],a),e.AbstractUserDataSyncStoreManagementService=a;let c=class extends a{constructor(P,_,j){super(P,_,j);const q=this.storageService.get(s,0);q&&(this.previousConfigurationSyncStore=JSON.parse(q));const G=this.productService[k.CONFIGURATION_SYNC_STORE_KEY];G?this.storageService.store(s,JSON.stringify(G),0,1):this.storageService.remove(s,0)}async switch(P){P!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=P,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};c=fe([Y(0,g.IProductService),Y(1,O.IConfigurationService),Y(2,v.IStorageService)],c),e.UserDataSyncStoreManagementService=c;let l=class extends p.Disposable{constructor(P,_,j,q,G,M,z){super();this.requestService=j,this.logService=q,this.storageService=z,this._onTokenFailed=this._register(new S.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new S.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new S.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(P),this.commonHeadersPromise=(0,m.getServiceMachineId)(G,M,z).then($=>{const V={"X-Client-Name":`${_.applicationName}${u.isWeb?"-web":""}`,"X-Client-Version":_.version,"X-Machine-Id":$};return _.commit&&(V["X-Client-Commit"]=_.commit),V}),this.session=new w(n,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,p.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(P,_){this.authToken={token:P,type:_}}updateUserDataSyncStoreUrl(P){this.userDataSyncStoreUrl=P?(0,R.joinPath)(P,"v1"):void 0}initDonotMakeRequestsUntil(){const P=this.storageService.getNumber(r,0);P&&Date.now()<P&&this.setDonotMakeRequestsUntil(new Date(P))}setDonotMakeRequestsUntil(P){var _;((_=this._donotMakeRequestsUntil)===null||_===void 0?void 0:_.getTime())!==(P==null?void 0:P.getTime())&&(this._donotMakeRequestsUntil=P,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,C.createCancelablePromise)(j=>(0,C.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),j).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,j=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(P){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",P),j={},q=await this.request(_.toString(),{type:"GET",headers:j},[],U.CancellationToken.None);return(await(0,A.asJson)(q)||[]).map(({url:M,created:z})=>({ref:(0,R.relativePath)(_,_.with({path:M})),created:z*1e3}))}async resolveContent(P,_){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",P,_).toString(),q={};q["Cache-Control"]="no-cache";const G=await this.request(j,{type:"GET",headers:q},[],U.CancellationToken.None);return await(0,A.asText)(G)}async delete(P){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",P).toString(),j={};await this.request(_,{type:"DELETE",headers:j},[],U.CancellationToken.None)}async read(P,_,j={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",P,"latest").toString();j=Object.assign({},j),j["Cache-Control"]="no-cache",_&&(j["If-None-Match"]=_.ref);const G=await this.request(q,{type:"GET",headers:j},[304],U.CancellationToken.None);if(G.res.statusCode===304)return _;const M=G.res.headers.etag;if(!M)throw new k.UserDataSyncStoreError("Server did not return the ref",q,k.UserDataSyncErrorCode.NoRef,G.res.headers[k.HEADER_OPERATION_ID]);const z=await(0,A.asText)(G);return{ref:M,content:z}}async write(P,_,j,q={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const G=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",P).toString();q=Object.assign({},q),q["Content-Type"]="text/plain",j&&(q["If-Match"]=j);const M=await this.request(G,{type:"POST",data:_,headers:q},[],U.CancellationToken.None),z=M.res.headers.etag;if(!z)throw new k.UserDataSyncStoreError("Server did not return the ref",G,k.UserDataSyncErrorCode.NoRef,M.res.headers[k.HEADER_OPERATION_ID]);return z}async manifest(P={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,R.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();P=Object.assign({},P),P["Content-Type"]="application/json";const j=await this.request(_,{type:"GET",headers:P},[],U.CancellationToken.None),q=await(0,A.asJson)(j),G=this.storageService.get(t,0);return G&&q&&G!==q.session&&this.clearSession(),q===null&&G&&this.clearSession(),q&&this.storageService.store(t,q.session,0,1),q}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const P=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),_={"Content-Type":"text/plain"};await this.request(P,{type:"DELETE",headers:_},[],U.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(t,0),this.storageService.remove(i,0)}async request(P,_,j,q){if(!this.authToken)throw new k.UserDataSyncStoreError("No Auth Token Available",P,k.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too many requests (429).`,P,k.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const G=await this.commonHeadersPromise;_.headers=Object.assign(Object.assign(Object.assign({},_.headers||{}),G),{"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`}),this.addSessionHeaders(_.headers),this.logService.trace("Sending request to server",{url:P,type:_.type,headers:Object.assign(Object.assign({},_.headers),{authorization:void 0})});let M;try{M=await this.session.request(P,_,q)}catch(H){if(!(H instanceof k.UserDataSyncStoreError)){const L=(0,f.isPromiseCanceledError)(H)?k.UserDataSyncErrorCode.RequestCanceled:(0,f.getErrorMessage)(H).startsWith("XHR timeout")?k.UserDataSyncErrorCode.RequestTimeout:k.UserDataSyncErrorCode.RequestFailed;H=new k.UserDataSyncStoreError(`Connection refused for the request '${P}'.`,P,L,void 0)}throw this.logService.info("Request failed",P),H}const z=M.res.headers[k.HEADER_OPERATION_ID],$={url:P,status:M.res.statusCode,"execution-id":_.headers[k.HEADER_EXECUTION_ID],"operation-id":z},V=(0,A.isSuccess)(M)||M.res.statusCode&&j.indexOf(M.res.statusCode)!==-1;if(V?this.logService.trace("Request succeeded",$):this.logService.info("Request failed",$),M.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new k.UserDataSyncStoreError(`Request '${P}' failed because of Unauthorized (401).`,P,k.UserDataSyncErrorCode.Unauthorized,z);if(this._onTokenSucceed.fire(),M.res.statusCode===409)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,P,k.UserDataSyncErrorCode.Conflict,z);if(M.res.statusCode===410)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because the requested resource is not longer available (410).`,P,k.UserDataSyncErrorCode.Gone,z);if(M.res.statusCode===412)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,P,k.UserDataSyncErrorCode.PreconditionFailed,z);if(M.res.statusCode===413)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too large payload (413).`,P,k.UserDataSyncErrorCode.TooLarge,z);if(M.res.statusCode===426)throw new k.UserDataSyncStoreError(`${_.type} request '${P}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,P,k.UserDataSyncErrorCode.UpgradeRequired,z);if(M.res.statusCode===429){const H=M.res.headers["retry-after"];throw H?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(H)*1e3)),new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too many requests (429).`,P,k.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,z)):new k.UserDataSyncStoreError(`${_.type} request '${P}' failed because of too many requests (429).`,P,k.UserDataSyncErrorCode.TooManyRequests,z)}if(!V)throw new k.UserDataSyncStoreError("Server returned "+M.res.statusCode,P,k.UserDataSyncErrorCode.Unknown,z);return M}addSessionHeaders(P){let _=this.storageService.get(i,0);_===void 0&&(_=(0,b.generateUuid)(),this.storageService.store(i,_,0,1)),P["X-Machine-Session-Id"]=_;const j=this.storageService.get(t,0);j!==void 0&&(P["X-User-Session-Id"]=j)}};l=fe([Y(1,g.IProductService),Y(2,A.IRequestService),Y(3,k.IUserDataSyncLogService),Y(4,T.IEnvironmentService),Y(5,y.IFileService),Y(6,v.IStorageService)],l),e.UserDataSyncStoreClient=l;let d=class extends l{constructor(P,_,j,q,G,M,z){var $;super(($=P.userDataSyncStore)===null||$===void 0?void 0:$.url,_,j,q,G,M,z);this._register(P.onDidChangeUserDataSyncStore(()=>{var V;return this.updateUserDataSyncStoreUrl((V=P.userDataSyncStore)===null||V===void 0?void 0:V.url)}))}};d=fe([Y(0,k.IUserDataSyncStoreManagementService),Y(1,g.IProductService),Y(2,A.IRequestService),Y(3,k.IUserDataSyncLogService),Y(4,T.IEnvironmentService),Y(5,y.IFileService),Y(6,v.IStorageService)],d),e.UserDataSyncStoreService=d;class w{constructor(P,_,j,q){this.limit=P,this.interval=_,this.requestService=j,this.logService=q,this.requests=[],this.startTime=void 0}request(P,_,j){if(this.isExpired()&&this.reset(),_.url=P,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new k.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,P,k.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(P),this.requestService.request(_,j)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=w}),define(Z[194],ee([0,1,20,3,57,84,59,22,19,60,28]),function(K,e,p,k,A,R,U,O,g,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let y=class extends R.UserDataAutoSyncService{constructor(b,u,S,C,E,D,f,s,r,t,i,n){super(b,u,S,C,E,f,s,r,t,i,n);this._register(k.Event.debounce(k.Event.any(k.Event.map(D.onDidFocusWindow,()=>"windowFocus"),k.Event.map(D.onDidOpenWindow,()=>"windowOpen")),(o,a)=>o?[...o,a]:[a],1e3)(o=>this.triggerSync(o,!0,!1)))}};y=fe([Y(0,T.IProductService),Y(1,p.IUserDataSyncStoreManagementService),Y(2,p.IUserDataSyncStoreService),Y(3,p.IUserDataSyncResourceEnablementService),Y(4,p.IUserDataSyncService),Y(5,A.INativeHostService),Y(6,p.IUserDataSyncLogService),Y(7,U.IUserDataSyncAccountService),Y(8,O.ITelemetryService),Y(9,m.IUserDataSyncMachinesService),Y(10,g.IStorageService),Y(11,p.IUserDataAutoSyncEnablementService)],y),e.UserDataAutoSyncService=y}),define(Z[195],ee([0,1,3,2,6]),function(K,e,p,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends k.Disposable{constructor({onDidOpenWindow:O,onDidFocusWindow:g,getActiveWindowId:m}){super();this.disposables=this._register(new k.DisposableStore),p.Event.latch(p.Event.any(O,g))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,A.createCancelablePromise)(()=>m()),(async()=>{try{const y=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:y}catch(y){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(O){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=O}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(Z[61],ee([0,1,105,8,27,6,24,201,202,15]),function(K,e,p,k,A,R,U,O,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class T extends Error{constructor(t,i){let n=i.message;switch(t){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=t,this.cause=i}}e.ExtractError=T;function y(r){const t=r.externalFileAttributes>>16||33188;return[448,56,7].map(i=>t&i).reduce((i,n)=>i+n,t&61440)}function v(r){if(r instanceof T)return r;let t;return/end of central directory record signature not found/.test(r.message)&&(t="CorruptZip"),new T(t,r)}function b(r,t,i,n,o,a){const c=k.dirname(t),l=k.join(n,c);if(!l.startsWith(n))return Promise.reject(new Error(p.localize(0,null,t)));const d=k.join(n,t);let w;return a.onCancellationRequested(()=>{w&&w.destroy()}),Promise.resolve(A.promises.mkdir(l,{recursive:!0})).then(()=>new Promise((h,P)=>{if(!a.isCancellationRequested)try{w=(0,A.createWriteStream)(d,{mode:i}),w.once("close",()=>h()),w.once("error",P),r.once("error",P),r.pipe(w)}catch(_){P(_)}}))}function u(r,t,i,n){let o=(0,R.createCancelablePromise)(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{o.cancel(),r.close()}),new Promise((c,l)=>{const d=new R.Sequencer,w=h=>{h.isCancellationRequested||(a++,r.readEntry())};r.once("error",l),r.once("close",()=>o.then(()=>{n.isCancellationRequested||r.entryCount===a?c():l(new T("Incomplete",new Error(p.localize(1,null,a,r.entryCount))))},l)),r.readEntry(),r.on("entry",h=>{if(!n.isCancellationRequested){if(!i.sourcePathRegex.test(h.fileName)){w(n);return}const P=h.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(P)){const q=k.join(t,P);o=(0,R.createCancelablePromise)(G=>A.promises.mkdir(q,{recursive:!0}).then(()=>w(G)).then(void 0,l));return}const _=C(r,h),j=y(h);o=(0,R.createCancelablePromise)(q=>d.queue(()=>_.then(G=>b(G,P,j,t,i,q).then(()=>w(q)))).then(null,l))}})})}function S(r,t=!1){return new Promise((i,n)=>{(0,O.open)(r,t?{lazyEntries:!0}:void 0,(o,a)=>{o?n(v(o)):i((0,m.assertIsDefined)(a))})})}function C(r,t){return new Promise((i,n)=>{r.openReadStream(t,(o,a)=>{o?n(v(o)):i((0,m.assertIsDefined)(a))})})}function E(r,t){return new Promise((i,n)=>{const o=new g.ZipFile;t.forEach(c=>{c.contents?o.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&o.addFile(c.localPath,c.path)}),o.end();const a=(0,A.createWriteStream)(r);o.outputStream.pipe(a),o.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>i(r))})}e.zip=E;function D(r,t,i={},n){const o=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=S(r,!0);return i.overwrite&&(a=a.then(c=>(0,U.rimraf)(t).then(()=>c))),a.then(c=>u(c,t,{sourcePathRegex:o},n))}e.extract=D;function f(r,t){return S(r).then(i=>new Promise((n,o)=>{i.on("entry",a=>{a.fileName===t&&C(i,a).then(c=>n(c),c=>o(c))}),i.once("close",()=>o(new Error(p.localize(2,null,t))))}))}function s(r,t){return f(r,t).then(i=>new Promise((n,o)=>{const a=[];i.once("error",o),i.on("data",c=>a.push(c)),i.on("end",()=>n(Buffer.concat(a)))}))}e.buffer=s}),define(Z[196],ee([0,1,61,110]),function(K,e,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function A(R){return(0,p.buffer)(R,"extension/package.json").then(U=>{try{return JSON.parse(U.toString("utf8"))}catch(O){throw new Error((0,k.localize)(0,null))}})}e.getManifest=A}),define(Z[197],ee([0,1,27,56,2,24,8,17,29,33,6,4,9,130,111,28,61,7,18,16,10,12,31,11]),function(K,e,p,k,A,R,U,O,g,m,T,y,v,b,u,S,C,E,D,f,s,r,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const n="scanningSystem",o="scanningUser",a="extracting",c="deleting",l="renaming";let d=class extends A.Disposable{constructor(h,P,_,j,q){super();this.beforeRemovingExtension=h,this.fileService=P,this.logService=_,this.environmentService=j,this.productService=q,this._devSystemExtensionsPath=null,this.systemExtensionsPath=j.builtinExtensionsPath,this.extensionsPath=j.extensionsPath,this.uninstalledPath=U.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new T.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(h){const P=[];(h===null||h===0)&&P.push(this.scanSystemExtensions().then(null,_=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(_).message,n)))),(h===null||h===1)&&P.push(this.scanUserExtensions(!0).then(null,_=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(_).message,o))));try{const _=await Promise.all(P);return(0,D.flatten)(_)}catch(_){throw this.joinErrors(_)}}async scanUserExtensions(h){this.logService.trace("Started scanning user extensions");let[P,_]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return _=_.filter(j=>!P[new m.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version).key()]),h&&(_=(0,m.groupByExtension)(_,q=>q.identifier).map(q=>q.sort((G,M)=>k.rcompare(G.manifest.version,M.manifest.version))[0])),this.logService.trace("Scanned user extensions:",_.length),_}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(h,P,_){const j=h.key(),q=U.join(this.extensionsPath,`.${(0,t.generateUuid)()}`),G=U.join(this.extensionsPath,j);try{await R.rimraf(G)}catch(z){try{await R.rimraf(G)}catch($){}throw new g.ExtensionManagementError((0,u.localize)(0,null,G,h.id),c)}await this.extractAtLocation(h,P,q,_);let M=await this.scanExtension(y.URI.file(q),1);if(!M)throw new Error((0,u.localize)(1,null,q));await this.storeMetadata(M,{installedTimestamp:Date.now()});try{await this.rename(h,q,G,Date.now()+2*60*1e3),this.logService.info("Renamed to",G)}catch(z){try{await R.rimraf(q)}catch($){}if(z.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",h.id);else throw this.logService.info(`Rename failed because of ${(0,i.getErrorMessage)(z)}. Deleted from extracted location`,q),z}try{M=await this.scanExtension(y.URI.file(G),1)}catch(z){}if(M)return M;throw new Error((0,u.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(h,P){return this.setMetadata(h,P),await this.storeMetadata(h,Object.assign(Object.assign({},P),{installedTimestamp:h.installedTimestamp})),h}async storeMetadata(h,P){P.isMachineScoped=P.isMachineScoped||void 0,P.isBuiltin=P.isBuiltin||void 0,P.installedTimestamp=P.installedTimestamp||void 0;const _=U.join(h.location.fsPath,"package.json"),j=await p.promises.readFile(_,"utf8"),{manifest:q}=await this.parseManifest(j);return q.__metadata=P,await R.writeFile(_,JSON.stringify(q,null,"	")),h}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...h){const P=h.map(_=>new m.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version));await this.withUninstalledExtensions(_=>{P.forEach(j=>_[j.key()]=!0)})}async setInstalled(h){await this.withUninstalledExtensions(j=>delete j[h.key()]);const _=(await this.scanExtensions(1)).find(j=>new m.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version).equals(h))||null;return _?(await this.storeMetadata(_,{installedTimestamp:Date.now()}),this.scanExtension(_.location,1)):null}async withUninstalledExtensions(h){return this.uninstalledFileLimiter.queue(async()=>{let P;try{P=await p.promises.readFile(this.uninstalledPath,"utf8")}catch(j){if(j.code!=="ENOENT")throw j}let _={};if(P)try{_=JSON.parse(P)}catch(j){}return h&&(h(_),Object.keys(_).length?await R.writeFile(this.uninstalledPath,JSON.stringify(_)):await R.rimraf(this.uninstalledPath)),_})}async removeExtension(h,P){this.logService.trace(`Deleting ${P} extension from disk`,h.identifier.id,h.location.fsPath),await R.rimraf(h.location.fsPath),this.logService.info("Deleted from disk",h.identifier.id,h.location.fsPath)}async removeUninstalledExtension(h){await this.removeExtension(h,"uninstalled"),await this.withUninstalledExtensions(P=>delete P[new m.ExtensionIdentifierWithVersion(h.identifier,h.manifest.version).key()])}async extractAtLocation(h,P,_,j){this.logService.trace(`Started extracting the extension from ${P} to ${_}`);try{await R.rimraf(_)}catch(q){throw new g.ExtensionManagementError(this.joinErrors(q).message,c)}try{await(0,C.extract)(P,_,{sourcePath:"extension",overwrite:!0},j),this.logService.info(`Extracted extension to ${_}:`,h.id)}catch(q){try{await R.rimraf(_)}catch(G){}throw new g.ExtensionManagementError(q.message,q instanceof C.ExtractError&&q.type?q.type:a)}}async rename(h,P,_,j){try{await p.promises.rename(P,_)}catch(q){if(E.isWindows&&q&&q.code==="EPERM"&&Date.now()<j)return this.logService.info(`Failed renaming ${P} to ${_} with 'EPERM' error. Trying again...`,h.id),this.rename(h,P,_,j);throw new g.ExtensionManagementError(q.message||(0,u.localize)(3,null,P,_),q.code||l)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const h=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return h;const P=this.scanDevSystemExtensions(),[_,j]=await Promise.all([h,P]);return[..._,...j]}async scanExtensionsInDir(h,P){const _=new T.Limiter(10),j=await this.fileService.resolve(y.URI.file(h));return j.children?(await Promise.all(j.children.filter(G=>G.isDirectory).map(G=>_.queue(async()=>P===1&&(0,r.basename)(G.resource).indexOf(".")===0?null:this.scanExtension(G.resource,P))))).filter(G=>G&&G.identifier):[]}async scanExtension(h,P){var _,j;try{const q=await this.fileService.resolve(h);if(q.children){const{manifest:G,metadata:M}=await this.readManifest(h.fsPath),z=(_=q.children.find(({name:L})=>/^readme(\.txt|\.md|)$/i.test(L)))===null||_===void 0?void 0:_.resource,$=(j=q.children.find(({name:L})=>/^changelog(\.txt|\.md|)$/i.test(L)))===null||j===void 0?void 0:j.resource,V={id:(0,m.getGalleryExtensionId)(G.publisher,G.name)},H={type:P,identifier:V,manifest:G,location:h,readmeUrl:z,changelogUrl:$,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:P===0};return M&&(this.setMetadata(H,M),H.installedTimestamp=M.installedTimestamp),H}}catch(q){P!==0&&this.logService.trace(q)}return null}async scanDefaultSystemExtensions(){const h=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",h.length),h}async scanDevSystemExtensions(){const h=this.getDevSystemExtensionsList();if(h.length){const P=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",P.length),P.filter(_=>h.some(j=>(0,m.areSameExtensions)(_.identifier,{id:j})))}else return[]}setMetadata(h,P){h.publisherDisplayName=P.publisherDisplayName||null,h.publisherId=P.publisherId||null,h.identifier.uuid=P.id,h.isMachineScoped=!!P.isMachineScoped,h.isBuiltin=h.type===0||!!P.isBuiltin}async removeUninstalledExtensions(){const h=await this.getUninstalledExtensions(),P=await this.scanAllUserExtensions(),_=new Set;for(const G of P)h[new m.ExtensionIdentifierWithVersion(G.identifier,G.manifest.version).key()]||_.add(G.identifier.id.toLowerCase());const j=(0,m.groupByExtension)(P,G=>G.identifier);await T.Promises.settled(j.map(async G=>{const M=G.sort((z,$)=>k.rcompare(z.manifest.version,$.manifest.version))[0];_.has(M.identifier.id.toLowerCase())||await this.beforeRemovingExtension(M)}));const q=P.filter(G=>h[new m.ExtensionIdentifierWithVersion(G.identifier,G.manifest.version).key()]);await T.Promises.settled(q.map(G=>this.removeUninstalledExtension(G)))}async removeOutdatedExtensions(){const h=await this.scanAllUserExtensions(),P=[],_=(0,m.groupByExtension)(h,j=>j.identifier);P.push(...(0,D.flatten)(_.map(j=>j.sort((q,G)=>k.rcompare(q.manifest.version,G.manifest.version)).slice(1)))),await T.Promises.settled(P.map(j=>this.removeExtension(j,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(h=>h.name)}joinErrors(h){const P=Array.isArray(h)?h:[h];return P.length===1?P[0]instanceof Error?P[0]:new Error(P[0]):P.reduce((_,j)=>new Error(`${_.message}${_.message?",":""}${j instanceof Error?j.message:j}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=U.normalize(U.join(f.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(h){const P=[p.promises.readFile(U.join(h,"package.json"),"utf8").then(G=>this.parseManifest(G)),p.promises.readFile(U.join(h,"package.nls.json"),"utf8").then(void 0,G=>G.code!=="ENOENT"?Promise.reject(G):"{}").then(G=>JSON.parse(G))],[{manifest:_,metadata:j},q]=await Promise.all(P);return{manifest:(0,b.localizeManifest)(_,q),metadata:j}}parseManifest(h){return new Promise((P,_)=>{try{const j=JSON.parse(h),q=j.__metadata||null;P({manifest:j,metadata:q})}catch(j){_(new Error((0,u.localize)(4,null)))}})}};d=fe([Y(1,s.IFileService),Y(2,O.ILogService),Y(3,v.INativeEnvironmentService),Y(4,S.IProductService)],d),e.ExtensionsScanner=d}),define(Z[198],ee([0,1,27,109,8,24,2,18,61,29,33,9,6,3,56,4,51,7,17,143,43,22,69,12,31,71,5,16,30,196,151,197,152,153,10]),function(K,e,p,k,A,R,U,O,g,m,T,y,v,b,u,S,C,E,D,f,s,r,t,i,n,o,a,c,l,d,w,h,P,_,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const q="unsetUninstalled",G="downloading",M="validating",z="local",$="unknown";let V=class extends U.Disposable{constructor(L,I,F,N,W,x,X){super();this.environmentService=L,this.galleryService=I,this.logService=F,this.downloadService=N,this.telemetryService=W,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new b.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new b.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new b.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new b.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const Q=this._register(x.createInstance(P.ExtensionsLifecycle));this.extensionsScanner=this._register(x.createInstance(h.ExtensionsScanner,ie=>Q.postUninstall(ie))),this.manifestCache=this._register(new f.ExtensionsManifestCache(L,this)),this.extensionsDownloader=this._register(x.createInstance(w.ExtensionsDownloader));const ne=this._register(new _.ExtensionsWatcher(this,X,L,F));this._register(ne.onDidChangeExtensionsByAnotherSource(({added:ie,removed:ce})=>{ie.forEach(ue=>this._onDidInstallExtension.fire({identifier:ue.identifier,operation:0,local:ue})),ce.forEach(ue=>this._onDidUninstallExtension.fire({identifier:ue}))})),this._register((0,U.toDisposable)(()=>{this.installingExtensions.forEach(ie=>ie.cancel()),this.uninstallingExtensions.forEach(ie=>ie.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(L){this.logService.trace("ExtensionManagementService#zip",L.identifier.id);const I=await this.collectFiles(L),F=await(0,g.zip)((0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)()).fsPath,I);return S.URI.file(F)}async unzip(L){return this.logService.trace("ExtensionManagementService#unzip",L.toString()),(await this.install(L)).identifier}async getManifest(L){const I=await this.downloadVsix(L),F=A.resolve(I.fsPath);return(0,d.getManifest)(F)}async collectFiles(L){const I=async N=>{let W=await R.readdir(N);W=W.map(Q=>A.join(N,Q));const x=await Promise.all(W.map(Q=>p.promises.stat(Q)));let X=Promise.resolve([]);return x.forEach((Q,ne)=>{const ie=W[ne];Q.isFile()&&(X=X.then(ce=>[...ce,ie])),Q.isDirectory()&&(X=X.then(ce=>I(ie).then(ue=>[...ce,...ue])))}),X};return(await I(L.location.fsPath)).map(N=>({path:`extension/${A.relative(L.location.fsPath,N)}`,localPath:N}))}async install(L,I={}){return this.logService.trace("ExtensionManagementService#install",L.toString()),(0,v.createCancelablePromise)(async F=>{const N=await this.downloadVsix(L),W=A.resolve(N.fsPath),x=await(0,d.getManifest)(W),X={id:(0,T.getGalleryExtensionId)(x.publisher,x.name)};let Q=1;if(x.engines&&x.engines.vscode&&!(0,t.isEngineValid)(x.engines.vscode,C.default.version,C.default.date))throw new Error(k.localize(0,null,X.id,C.default.version));const ne=new T.ExtensionIdentifierWithVersion(X,x.version),ce=(await this.getInstalled(1)).find(ge=>(0,T.areSameExtensions)(X,ge.identifier));if(ce)if(I.isMachineScoped=I.isMachineScoped||ce.isMachineScoped,I.isBuiltin=I.isBuiltin||ce.isBuiltin,Q=2,ne.equals(new T.ExtensionIdentifierWithVersion(ce.identifier,ce.manifest.version)))try{await this.extensionsScanner.removeExtension(ce,"existing")}catch(ge){throw new Error(k.localize(1,null,x.displayName||x.name))}else u.gt(ce.manifest.version,x.version)&&await this.uninstallExtension(ce);else{const ge=await this.unsetUninstalledAndGetLocal(ne);if(ge)try{await this.extensionsScanner.removeExtension(ge,"existing")}catch(pe){throw new Error(k.localize(2,null,x.displayName||x.name))}}this.logService.info("Installing the extension:",X.id),this._onInstallExtension.fire({identifier:X,zipPath:W});let ue;try{ue=await this.getGalleryMetadata((0,T.getGalleryExtensionId)(x.publisher,x.name))}catch(ge){}try{const ge=await this.installFromZipPath(ne,W,Object.assign(Object.assign({},ue||{}),I),I,Q,F);return this.logService.info("Successfully installed the extension:",X.id),ge}catch(ge){throw this.logService.error("Failed to install the extension:",X.id,ge.message),ge}})}async downloadVsix(L){if(L.scheme===c.Schemas.file)return L;if(!this.downloadService)throw new Error("Download service is not available");const I=(0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)());return await this.downloadService.download(L,I),I}async installFromZipPath(L,I,F,N,W,x){try{const X=await this.installExtension({zipPath:I,identifierWithVersion:L,metadata:F},x);try{await this.installDependenciesAndPackExtensions(X,void 0,N)}catch(Q){(0,O.isNonEmptyArray)(X.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",X.identifier.id,Q.message),(0,O.isNonEmptyArray)(X.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",X.identifier.id,Q.message)}return this._onDidInstallExtension.fire({identifier:L,zipPath:I,local:X,operation:W}),X}catch(X){throw this._onDidInstallExtension.fire({identifier:L,zipPath:I,operation:W,error:X}),X}}async canInstall(L){return!0}async installFromGallery(L,I={}){if(!this.galleryService.isEnabled())throw new Error(k.localize(3,null));try{L=await this.checkAndGetCompatibleVersion(L)}catch(W){const x=W&&W.code?W.code:$;throw this.logService.error("Failed to install extension:",L.identifier.id,W?W.message:x),this.reportTelemetry(this.getTelemetryEvent(1),(0,T.getGalleryExtensionTelemetryData)(L),void 0,W),W instanceof Error&&(W.name=x),W}const F=new T.ExtensionIdentifierWithVersion(L.identifier,L.version).key();let N=this.installingExtensions.get(F);return N||(N=(0,v.createCancelablePromise)(W=>this.doInstallFromGallery(L,I,W)),this.installingExtensions.set(F,N),N.finally(()=>this.installingExtensions.delete(F))),N}async doInstallFromGallery(L,I,F){const N=new Date().getTime();let W=1;this.logService.info("Installing extension:",L.identifier.id),this._onInstallExtension.fire({identifier:L.identifier,gallery:L});try{const X=(await this.getInstalled(1)).find(ie=>(0,T.areSameExtensions)(ie.identifier,L.identifier));X&&(W=2);const Q=await this.downloadInstallableExtension(L,W);Q.metadata.isMachineScoped=I.isMachineScoped||(X==null?void 0:X.isMachineScoped),Q.metadata.isBuiltin=I.isBuiltin||(X==null?void 0:X.isBuiltin);const ne=await this.installExtension(Q,F);try{await this.extensionsDownloader.delete(S.URI.file(Q.zipPath))}catch(ie){}if(!I.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(ne,X,I)}catch(ie){try{await this.uninstall(ne)}catch(ce){}throw ie}return X&&u.neq(X.manifest.version,L.version)&&await this.extensionsScanner.setUninstalled(X),this.logService.info("Extensions installed successfully:",L.identifier.id),this._onDidInstallExtension.fire({identifier:L.identifier,gallery:L,local:ne,operation:W}),this.reportTelemetry(this.getTelemetryEvent(W),(0,T.getGalleryExtensionTelemetryData)(L),new Date().getTime()-N,void 0),ne}catch(x){const X=x&&x.code?x.code:$;throw this.logService.error("Failed to install extension:",L.identifier.id,x?x.message:X),this._onDidInstallExtension.fire({identifier:L.identifier,gallery:L,operation:W,error:X}),this.reportTelemetry(this.getTelemetryEvent(W),(0,T.getGalleryExtensionTelemetryData)(L),new Date().getTime()-N,x),x instanceof Error&&(x.name=X),x}}async checkAndGetCompatibleVersion(L){if(await this.isMalicious(L))throw new m.ExtensionManagementError(k.localize(4,null),m.INSTALL_ERROR_MALICIOUS);const I=await this.galleryService.getCompatibleExtension(L);if(!I)throw new m.ExtensionManagementError(k.localize(5,null,L.identifier.id,C.default.version),m.INSTALL_ERROR_INCOMPATIBLE);return I}async reinstallFromGallery(L){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",L.identifier.id),!this.galleryService.isEnabled())throw new Error(k.localize(6,null));const I=await this.findGalleryExtension(L);if(!I)throw new Error(k.localize(7,null));await this.extensionsScanner.setUninstalled(L);try{await this.extensionsScanner.removeUninstalledExtension(L)}catch(F){throw new Error(k.localize(8,null,(0,s.toErrorMessage)(F)))}await this.installFromGallery(I)}getTelemetryEvent(L){return L===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(L){const I=await this.getExtensionsReport();return(0,T.getMaliciousExtensionsSet)(I).has(L.identifier.id)}async downloadInstallableExtension(L,I){const F={id:L.identifier.uuid,publisherId:L.publisherId,publisherDisplayName:L.publisherDisplayName};let N;try{this.logService.trace("Started downloading extension:",L.identifier.id),N=(await this.extensionsDownloader.downloadExtension(L,I)).fsPath,this.logService.info("Downloaded extension:",L.identifier.id,N)}catch(W){throw new m.ExtensionManagementError(this.joinErrors(W).message,G)}try{const W=await(0,d.getManifest)(N);return{zipPath:N,identifierWithVersion:new T.ExtensionIdentifierWithVersion(L.identifier,W.version),metadata:F}}catch(W){throw new m.ExtensionManagementError(this.joinErrors(W).message,M)}}async installExtension(L,I){try{const F=await this.unsetUninstalledAndGetLocal(L.identifierWithVersion);if(F)return L.metadata?this.extensionsScanner.saveMetadataForLocalExtension(F,L.metadata):F}catch(F){throw E.isMacintosh?new m.ExtensionManagementError(k.localize(9,null),q):new m.ExtensionManagementError(k.localize(10,null),q)}return this.extractAndInstall(L,I)}async unsetUninstalledAndGetLocal(L){if(!await this.isUninstalled(L))return null;this.logService.trace("Removing the extension from uninstalled list:",L.id);const F=await this.extensionsScanner.setInstalled(L);return this.logService.info("Removed the extension from uninstalled list:",L.id),F}async extractAndInstall({zipPath:L,identifierWithVersion:I,metadata:F},N){let W=await this.extensionsScanner.extractUserExtension(I,L,N);return this.logService.info("Installation completed.",I.id),F&&(W=await this.extensionsScanner.saveMetadataForLocalExtension(W,F)),W}async installDependenciesAndPackExtensions(L,I,F){if(!!this.galleryService.isEnabled()){const N=L.manifest.extensionDependencies||[];if(L.manifest.extensionPack)for(const W of L.manifest.extensionPack)I&&I.manifest.extensionPack&&I.manifest.extensionPack.some(x=>(0,T.areSameExtensions)({id:x},{id:W}))||N.every(x=>!(0,T.areSameExtensions)({id:x},{id:W}))&&N.push(W);if(N.length){const W=await this.getInstalled(),x=N.filter(X=>W.every(({identifier:Q})=>!(0,T.areSameExtensions)(Q,{id:X})));if(x.length){const Q=(await this.galleryService.query({names:x,pageSize:N.length},l.CancellationToken.None)).firstPage;try{await v.Promises.settled(Q.map(ne=>this.installFromGallery(ne,F)))}catch(ne){try{await this.rollback(Q)}catch(ie){}throw ne}}}}}async rollback(L){const F=(await this.getInstalled(1)).filter(N=>L.some(W=>new T.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version).equals(new T.ExtensionIdentifierWithVersion(W.identifier,W.version))));await v.Promises.settled(F.map(N=>this.uninstall(N)))}async uninstall(L,I={}){this.logService.trace("ExtensionManagementService#uninstall",L.identifier.id);const F=await this.getInstalled(1),N=F.find(W=>(0,T.areSameExtensions)(W.identifier,L.identifier));if(!N)throw new Error(k.localize(11,null,L.manifest.displayName||L.manifest.name));try{await this.checkForDependenciesAndUninstall(N,F,I)}catch(W){throw this.joinErrors(W)}}async updateMetadata(L,I){return this.logService.trace("ExtensionManagementService#updateMetadata",L.identifier.id),L=await this.extensionsScanner.saveMetadataForLocalExtension(L,Object.assign(Object.assign({},L.manifest.__metadata||{}),I)),this.manifestCache.invalidate(),L}async updateExtensionScope(L,I){return this.logService.trace("ExtensionManagementService#updateExtensionScope",L.identifier.id),L=await this.extensionsScanner.saveMetadataForLocalExtension(L,Object.assign(Object.assign({},L.manifest.__metadata||{}),{isMachineScoped:I})),this.manifestCache.invalidate(),L}async getGalleryMetadata(L){const I=await this.findGalleryExtensionByName(L);return I?{id:I.identifier.uuid,publisherDisplayName:I.publisherDisplayName,publisherId:I.publisherId}:void 0}async findGalleryExtension(L){if(L.identifier.uuid){const I=await this.findGalleryExtensionById(L.identifier.uuid);return I||this.findGalleryExtensionByName(L.identifier.id)}return this.findGalleryExtensionByName(L.identifier.id)}async findGalleryExtensionById(L){return(await this.galleryService.query({ids:[L],pageSize:1},l.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(L){return(await this.galleryService.query({names:[L],pageSize:1},l.CancellationToken.None)).firstPage[0]}joinErrors(L){const I=Array.isArray(L)?L:[L];return I.length===1?I[0]instanceof Error?I[0]:new Error(I[0]):I.reduce((F,N)=>new Error(`${F.message}${F.message?",":""}${N instanceof Error?N.message:N}`),new Error(""))}async checkForDependenciesAndUninstall(L,I,F){try{await this.preUninstallExtension(L);const N=F.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(L,I);await this.uninstallExtensions(L,N,I,F)}catch(N){throw await this.postUninstallExtension(L,new m.ExtensionManagementError(N instanceof Error?N.message:N,z)),N}await this.postUninstallExtension(L)}async uninstallExtensions(L,I,F,N){const W=[L,...I];if(!N.donotCheckDependents)for(const x of W)this.checkForDependents(x,W,F,L);await v.Promises.settled([this.uninstallExtension(L),...I.map(x=>this.doUninstall(x))])}checkForDependents(L,I,F,N){const W=this.getDependents(L,F);if(W.length){const x=W.filter(X=>I.indexOf(X)===-1);if(x.length)throw new Error(this.getDependentsErrorMessage(L,x,N))}}getDependentsErrorMessage(L,I,F){return F===L?I.length===1?k.localize(12,null,F.manifest.displayName||F.manifest.name,I[0].manifest.displayName||I[0].manifest.name):I.length===2?k.localize(13,null,F.manifest.displayName||F.manifest.name,I[0].manifest.displayName||I[0].manifest.name,I[1].manifest.displayName||I[1].manifest.name):k.localize(14,null,F.manifest.displayName||F.manifest.name,I[0].manifest.displayName||I[0].manifest.name,I[1].manifest.displayName||I[1].manifest.name):I.length===1?k.localize(15,null,F.manifest.displayName||F.manifest.name,L.manifest.displayName||L.manifest.name,I[0].manifest.displayName||I[0].manifest.name):I.length===2?k.localize(16,null,F.manifest.displayName||F.manifest.name,L.manifest.displayName||L.manifest.name,I[0].manifest.displayName||I[0].manifest.name,I[1].manifest.displayName||I[1].manifest.name):k.localize(17,null,F.manifest.displayName||F.manifest.name,L.manifest.displayName||L.manifest.name,I[0].manifest.displayName||I[0].manifest.name,I[1].manifest.displayName||I[1].manifest.name)}getAllPackExtensionsToUninstall(L,I,F=[]){if(F.indexOf(L)!==-1)return[];F.push(L);const N=L.manifest.extensionPack?L.manifest.extensionPack:[];if(N.length){const W=I.filter(X=>!X.isBuiltin&&N.some(Q=>(0,T.areSameExtensions)({id:Q},X.identifier))),x=[];for(const X of W)x.push(...this.getAllPackExtensionsToUninstall(X,I,F));return[...W,...x]}return[]}getDependents(L,I){return I.filter(F=>F.manifest.extensionDependencies&&F.manifest.extensionDependencies.some(N=>(0,T.areSameExtensions)({id:N},L.identifier)))}async doUninstall(L){try{await this.preUninstallExtension(L),await this.uninstallExtension(L)}catch(I){throw await this.postUninstallExtension(L,new m.ExtensionManagementError(I instanceof Error?I.message:I,z)),I}await this.postUninstallExtension(L)}async preUninstallExtension(L){if(!await R.exists(L.location.fsPath))throw new Error(k.localize(18,null));this.logService.info("Uninstalling extension:",L.identifier.id),this._onUninstallExtension.fire(L.identifier)}async uninstallExtension(L){let I=this.uninstallingExtensions.get(L.identifier.id);return I||(I=(0,v.createCancelablePromise)(async()=>{const F=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...F.filter(N=>(0,T.areSameExtensions)(N.identifier,L.identifier)))}),this.uninstallingExtensions.set(L.identifier.id,I),I.finally(()=>this.uninstallingExtensions.delete(L.identifier.id))),I}async postUninstallExtension(L,I){if(I)this.logService.error("Failed to uninstall extension:",L.identifier.id,I.message);else if(this.logService.info("Successfully uninstalled extension:",L.identifier.id),L.identifier.uuid)try{await this.galleryService.reportStatistic(L.manifest.publisher,L.manifest.name,L.manifest.version,"uninstall")}catch(N){}this.reportTelemetry("extensionGallery:uninstall",(0,T.getLocalExtensionTelemetryData)(L),void 0,I);const F=I?I instanceof m.ExtensionManagementError?I.code:$:void 0;this._onDidUninstallExtension.fire({identifier:L.identifier,error:F})}getInstalled(L=null){return this.extensionsScanner.scanExtensions(L)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(L){return(await this.filterUninstalled(L)).length===1}async filterUninstalled(...L){const I=[],F=await this.extensionsScanner.getUninstalledExtensions();for(const N of L)F[N.key()]&&I.push(N.key());return I}getExtensionsReport(){const L=new Date().getTime();return(!this.reportedExtensions||L-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=L),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const L=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${L.length} reported extensions from service`),L}catch(L){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(L,I,F,N){const W=N?N instanceof m.ExtensionManagementError?N.code:$:void 0;this.telemetryService.publicLogError(L,Object.assign(Object.assign({},I),{success:!N,duration:F,errorcode:W}))}};V=fe([Y(0,y.INativeEnvironmentService),Y(1,m.IExtensionGalleryService),Y(2,D.ILogService),Y(3,(0,a.optional)(o.IDownloadService)),Y(4,r.ITelemetryService),Y(5,a.IInstantiationService),Y(6,j.IFileService)],V),e.ExtensionManagementService=V}),define(Z[203],ee([0,1,27,38,204,99,51,98,34,75,50,147,9,127,129,29,198,170,25,161,40,162,22,58,168,79,80,173,17,76,154,55,2,163,71,159,158,141,140,149,148,169,70,155,10,157,16,28,20,191,193,188,57,189,194,167,19,165,190,59,187,171,60,72,131,195,172,84,83,82,5,150,142,11,43,81,176,175,192,138,144,174,4,12]),function(K,e,p,k,A,R,U,O,g,m,T,y,v,b,u,S,C,E,D,f,s,r,t,i,n,o,a,c,l,d,w,h,P,_,j,q,G,M,z,$,V,H,L,I,F,N,W,x,X,Q,ne,ie,ce,ue,ge,pe,Ce,Oe,_e,Te,Le,Ne,Ie,Ae,Ge,Ke,$e,ze,J,re,se,ve,Se,Re,be,ke,De,B,te,oe,ae,he,me,de){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ye extends P.Disposable{constructor(le){super();this.configuration=le,this.server=this._register(new O.Server),(0,A.gracefulify)(p),this.registerListeners()}registerListeners(){const le=()=>this.dispose();process.once("exit",le),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",le)}async open(){const le=await this.initServices();(0,X.registerConfiguration)(),le.invokeFunction(Pe=>{const Ue=Pe.get(l.ILogService);Ue.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Pe),this.registerErrorHandler(Ue)}),this._register((0,P.combinedDisposable)(le.createInstance(q.NodeCachedDataCleaner,this.configuration.nodeCachedDataDir),le.createInstance(G.LanguagePackCachedDataCleaner),le.createInstance(M.StorageDataCleaner,this.configuration.backupWorkspacesPath),le.createInstance(z.LogsDataCleaner),le.createInstance(ve.LocalizationsUpdater),le.createInstance(Se.DeprecatedExtensionsCleaner)))}async initServices(){const le=new m.ServiceCollection,Pe=Object.assign({_serviceBrand:void 0},U.default);le.set(x.IProductService,Pe);const Ue=new g.StaticRouter(qe=>qe==="main"),Fe=new V.MessagePortMainProcessService(this.server,Ue);le.set($.IMainProcessService,Fe);const Me=new b.NativeEnvironmentService(this.configuration.args,Pe);le.set(v.INativeEnvironmentService,Me);const Ze=new d.LogLevelChannelClient(this.server.getChannel("logLevel",Ue)),Ye=new d.LoggerChannelClient(this.configuration.logLevel,Ze.onDidChangeLogLevel,Fe.getChannel("logger"));le.set(l.ILoggerService,Ye);const tt=this._register(new l.MultiplexLogService([this._register(new l.ConsoleLogger(this.configuration.logLevel)),this._register(Ye.createLogger((0,de.joinPath)(me.URI.file(Me.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Be=this._register(new d.FollowerLogService(Ze,tt));le.set(l.ILogService,Be);const We=this._register(new I.FileService(Be));le.set(F.IFileService,We);const it=this._register(new N.DiskFileSystemProvider(Be));We.registerProvider(W.Schemas.file,it);const Ve=this._register(new f.ConfigurationService(Me.settingsResource,We));le.set(D.IConfigurationService,Ve),await Ve.initialize();const Je=new pe.NativeStorageService(void 0,Fe,Me);le.set(Ce.IStorageService,Je),await Je.initialize(),this._register((0,P.toDisposable)(()=>Je.flush())),le.set(s.IRequestService,new T.SyncDescriptor(r.RequestService)),le.set(oe.IChecksumService,new T.SyncDescriptor(ae.ChecksumService));const et=g.ProxyChannel.toService(Fe.getChannel("nativeHost"),{context:this.configuration.windowId});le.set(ce.INativeHostService,et),le.set(j.IDownloadService,new T.SyncDescriptor(_.DownloadService));const nt=this._register(new Ke.ActiveWindowManager(et)),ut=new g.StaticRouter(qe=>nt.getActiveClientId().then(rt=>qe===rt));le.set(Ae.IExtensionRecommendationNotificationService,new Ge.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));let Xe,xe;if(!Me.isExtensionDevelopment&&!Me.disableTelemetry&&Pe.enableTelemetry){xe=new $e.TelemetryLogAppender(Ye,Me);const{appRoot:qe,extensionsPath:rt,isBuilt:dt,installSourcePath:ft}=Me;if(Pe.aiConfig&&Pe.aiConfig.asimovKey&&dt){const at=new c.AppInsightsAppender("monacoworkbench",null,Pe.aiConfig.asimovKey);this._register((0,P.toDisposable)(()=>at.flush())),xe=(0,i.combinedAppender)(at,xe)}Xe=new a.TelemetryService({appender:xe,commonProperties:(0,n.resolveCommonProperties)(We,(0,k.release)(),(0,k.hostname)(),process.arch,Pe.commit,Pe.version,this.configuration.machineId,Pe.msftInternalDomains,ft),sendErrorTelemetry:!0,piiPaths:[qe,rt]},Ve)}else Xe=i.NullTelemetryService,xe=i.NullAppender;this.server.registerChannel("telemetryAppender",new o.TelemetryAppenderChannel(xe)),le.set(t.ITelemetryService,Xe);const ht=new he.CustomEndpointTelemetryService(Ve,Xe);return le.set(t.ICustomEndpointTelemetryService,ht),le.set(S.IExtensionManagementService,new T.SyncDescriptor(C.ExtensionManagementService)),le.set(S.IExtensionGalleryService,new T.SyncDescriptor(E.ExtensionGalleryService)),le.set(S.IExtensionTipsService,new T.SyncDescriptor(Ne.ExtensionTipsService)),le.set(h.ILocalizationsService,new T.SyncDescriptor(w.LocalizationsService)),le.set(L.IDiagnosticsService,new T.SyncDescriptor(H.DiagnosticsService)),le.set(Te.IUserDataSyncAccountService,new T.SyncDescriptor(Te.UserDataSyncAccountService)),le.set(X.IUserDataSyncLogService,new T.SyncDescriptor(ue.UserDataSyncLogService)),le.set(X.IUserDataSyncUtilService,new ie.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",qe=>qe.ctx!=="main"))),le.set(S.IGlobalExtensionEnablementService,new T.SyncDescriptor(Oe.GlobalExtensionEnablementService)),le.set(J.IIgnoredExtensionsManagementService,new T.SyncDescriptor(J.IgnoredExtensionsManagementService)),le.set(re.IExtensionsStorageSyncService,new T.SyncDescriptor(re.ExtensionsStorageSyncService)),le.set(X.IUserDataSyncStoreManagementService,new T.SyncDescriptor(ne.UserDataSyncStoreManagementService)),le.set(X.IUserDataSyncStoreService,new T.SyncDescriptor(ne.UserDataSyncStoreService)),le.set(Ie.IUserDataSyncMachinesService,new T.SyncDescriptor(Ie.UserDataSyncMachinesService)),le.set(X.IUserDataSyncBackupStoreService,new T.SyncDescriptor(Le.UserDataSyncBackupStoreService)),le.set(X.IUserDataAutoSyncEnablementService,new T.SyncDescriptor(ze.UserDataAutoSyncEnablementService)),le.set(X.IUserDataSyncResourceEnablementService,new T.SyncDescriptor(_e.UserDataSyncResourceEnablementService)),le.set(X.IUserDataSyncService,new T.SyncDescriptor(Q.UserDataSyncService)),le.set(B.ILocalPtyService,this._register(new De.PtyHostService(Be,Xe))),new y.InstantiationService(le)}initChannels(le){const Pe=new u.ExtensionManagementChannel(le.get(S.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Pe);const Ue=g.ProxyChannel.fromService(le.get(h.ILocalizationsService));this.server.registerChannel("localizations",Ue);const Fe=g.ProxyChannel.fromService(le.get(L.IDiagnosticsService));this.server.registerChannel("diagnostics",Fe);const Me=new u.ExtensionTipsChannel(le.get(S.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Me);const Ze=g.ProxyChannel.fromService(le.get(oe.IChecksumService));this.server.registerChannel("checksum",Ze);const Ye=new ie.UserDataSyncMachinesServiceChannel(le.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ye);const tt=g.ProxyChannel.fromService(le.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",tt);const Be=new ie.UserDataSyncAccountServiceChannel(le.get(Te.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Be);const We=new ie.UserDataSyncStoreManagementServiceChannel(le.get(X.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",We);const it=new te.UserDataSyncChannel(le.get(X.IUserDataSyncService),le.get(l.ILogService));this.server.registerChannel("userDataSync",it);const Ve=this._register(le.get(se.IInstantiationService).createInstance(ge.UserDataAutoSyncService)),Je=new ie.UserDataAutoSyncChannel(Ve);this.server.registerChannel("userDataAutoSync",Je);const et=le.get(B.ILocalPtyService),nt=g.ProxyChannel.fromService(et);this.server.registerChannel(ke.TerminalIpcChannels.LocalPty,nt)}registerErrorHandler(le){window.addEventListener("unhandledrejection",Pe=>{(0,Re.onUnexpectedError)(Pe.reason),Pe.preventDefault()}),(0,Re.setUnexpectedErrorHandler)(Pe=>{const Ue=(0,be.toErrorMessage)(Pe,!0);!Ue||le.error(`[uncaught exception in sharedProcess]: ${Ue}`)})}}async function Ee(we){const le=new ye(we);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await le.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Ee})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/659175fa39b994fc39381b0af2874c85efeb2a01/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
