/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/errors","vs/base/common/buffer","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/base/common/strings","fs","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","os","vs/base/common/uuid","vs/platform/workspaces/common/workspaces","vs/base/common/extpath","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/arrays","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/labels","vs/platform/update/common/update","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","child_process","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/environment/common/environment","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/tunnel","vs/platform/sign/common/sign","vs/platform/webview/common/webviewManagerService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","vs/base/node/extpath","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.snap","vs/platform/update/electron-main/updateService.win32","vs/platform/issue/electron-main/issueMainService","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],J=function(j){for(var e=[],m=0,R=j.length;m<R;m++)e[m]=Q[j[m]];return e};define(Q[101],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(R,L){if(!R)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=m}),define(Q[46],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(P){return(r,w,p)=>{let n=null,b=null;if(typeof p.value=="function"?(n="value",b=p.value):typeof p.get=="function"&&(n="get",b=p.get),!b)throw new Error("not supported");p[n]=P(b,w)}}e.createDecorator=m;function R(P,r,w){let p=null,n=null;if(typeof w.value=="function"?(p="value",n=w.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(p="get",n=w.get),!n)throw new Error("not supported");const b=`$memoize$${r}`;w[p]=function(...I){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,I)}),this[b]}}e.memoize=R;function L(P,r,w){return m((p,n)=>{const b=`$debounce$${n}`,I=`$debounce$result$${n}`;return function(...y){this[I]||(this[I]=w?w():void 0),clearTimeout(this[b]),r&&(this[I]=r(this[I],...y),y=[this[I]]),this[b]=setTimeout(()=>{p.apply(this,y),this[I]=w?w():void 0},P)}})}e.debounce=L;function S(P,r,w){return m((p,n)=>{const b=`$throttle$timer$${n}`,I=`$throttle$result$${n}`,y=`$throttle$lastRun$${n}`,d=`$throttle$pending$${n}`;return function(...g){if(this[I]||(this[I]=w?w():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),r&&(this[I]=r(this[I],...g)),!this[d]){const M=this[y]+P;M<=Date.now()?(this[y]=Date.now(),p.apply(this,[this[I]]),this[I]=w?w():void 0):(this[d]=!0,this[b]=setTimeout(()=>{this[d]=!1,this[y]=Date.now(),p.apply(this,[this[I]]),this[I]=w?w():void 0},M-Date.now()))}}})}e.throttle=S}),define(Q[18],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function R(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=R;function L(c){w(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=L;function S(c){w(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=S;function P(c){if(c instanceof Error){let{name:t,message:i}=c;const s=c.stacktrace||c.stack;return{$isError:!0,name:t,message:i,stack:s}}return c}e.transformErrorForSerialization=P;const r="Canceled";function w(c){return c instanceof Error&&c.name===r&&c.message===r}e.isPromiseCanceledError=w;class p extends Error{constructor(){super(r);this.name=this.message}}e.CancellationError=p;function n(){const c=new Error(r);return c.name=c.message,c}e.canceled=n;function b(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=b;function I(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=I;function y(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function d(c){const t=new Error(`${c} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function g(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=g;class M extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=M;class E extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=E;class o extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=o;function u(c){const t=c;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function l(c,t=Object.create(null)){const i=new Error(c);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=l}),define(Q[35],J([0,1,18]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(C,z=0){return C[C.length-(1+z)]}e.tail=R;function L(C){if(C.length===0)throw new Error("Invalid tail call");return[C.slice(0,C.length-1),C[C.length-1]]}e.tail2=L;function S(C,z,V=(_,A)=>_===A){if(C===z)return!0;if(!C||!z||C.length!==z.length)return!1;for(let _=0,A=C.length;_<A;_++)if(!V(C[_],z[_]))return!1;return!0}e.equals=S;function P(C,z,V){let _=0,A=C.length-1;for(;_<=A;){const O=(_+A)/2|0,k=V(C[O],z);if(k<0)_=O+1;else if(k>0)A=O-1;else return O}return-(_+1)}e.binarySearch=P;function r(C,z){let V=0,_=C.length;if(_===0)return 0;for(;V<_;){const A=Math.floor((V+_)/2);z(C[A])?_=A:V=A+1}return V}e.findFirstInSorted=r;function w(C,z,V){if(C=C|0,C>=z.length)throw new TypeError("invalid index");let _=z[Math.floor(z.length*Math.random())],A=[],O=[],k=[];for(let F of z){const U=V(F,_);U<0?A.push(F):U>0?O.push(F):k.push(F)}return C<A.length?w(C,A,V):C<A.length+k.length?k[0]:w(C-(A.length+k.length),O,V)}e.quickSelect=w;function p(C,z){const V=[];let _;for(const A of C.slice(0).sort(z))!_||z(_[0],A)!==0?(_=[A],V.push(_)):_.push(A);return V}e.groupBy=p;function n(C,z,V){const _=[];function A(F,U,K){if(!(U===0&&K.length===0)){const G=_[_.length-1];G&&G.start+G.deleteCount===F?(G.deleteCount+=U,G.toInsert.push(...K)):_.push({start:F,deleteCount:U,toInsert:K})}}let O=0,k=0;for(;;){if(O===C.length){A(O,0,z.slice(k));break}if(k===z.length){A(O,C.length-O,[]);break}const F=C[O],U=z[k],K=V(F,U);K===0?(O+=1,k+=1):K<0?(A(O,1,[]),O+=1):K>0&&(A(O,0,[U]),k+=1)}return _}e.sortedDiff=n;function b(C,z,V){const _=n(C,z,V),A=[],O=[];for(const k of _)A.push(...C.slice(k.start,k.start+k.deleteCount)),O.push(...k.toInsert);return{removed:A,added:O}}e.delta=b;function I(C,z,V){if(V===0)return[];const _=C.slice(0,V).sort(z);return d(C,z,_,V,C.length),_}e.top=I;function y(C,z,V,_,A){return V===0?Promise.resolve([]):new Promise((O,k)=>{(async()=>{const F=C.length,U=C.slice(0,V).sort(z);for(let K=V,G=Math.min(V+_,F);K<F;K=G,G=Math.min(G+_,F)){if(K>V&&await new Promise(Y=>setTimeout(Y)),A&&A.isCancellationRequested)throw(0,m.canceled)();d(C,z,U,K,G)}return U})().then(O,k)})}e.topAsync=y;function d(C,z,V,_,A){for(const O=V.length;_<A;_++){const k=C[_];if(z(k,V[O-1])<0){V.pop();const F=r(V,U=>z(k,U)<0);V.splice(F,0,k)}}}function g(C){return C.filter(z=>!!z)}e.coalesce=g;function M(C){let z=0;for(let V=0;V<C.length;V++)C[V]&&(C[z]=C[V],z+=1);C.length=z}e.coalesceInPlace=M;function E(C,z,V){C.splice(V,0,C.splice(z,1)[0])}e.move=E;function o(C){return!Array.isArray(C)||C.length===0}e.isFalsyOrEmpty=o;function u(C){return Array.isArray(C)&&C.length>0}e.isNonEmptyArray=u;function l(C,z){if(!z)return C.filter((_,A)=>C.indexOf(_)===A);const V=Object.create(null);return C.filter(_=>{const A=z(_);return V[A]?!1:(V[A]=!0,!0)})}e.distinct=l;function c(C){const z=new Set;return C.filter(V=>z.has(V)?!1:(z.add(V),!0))}e.distinctES6=c;function t(C){const z=Object.create(null);return V=>{const _=C(V);return z[_]?!1:(z[_]=!0,!0)}}e.uniqueFilter=t;function i(C,z){for(let V=C.length-1;V>=0;V--){const _=C[V];if(z(_))return V}return-1}e.lastIndex=i;function s(C,z){return C.length>0?C[0]:z}e.firstOrDefault=s;function a(C,z,V=(_,A)=>_===A){let _=0;for(let A=0,O=Math.min(C.length,z.length);A<O&&V(C[A],z[A]);A++)_++;return _}e.commonPrefixLength=a;function h(C){return[].concat(...C)}e.flatten=h;function f(C,z){let V=typeof z=="number"?C:0;typeof z=="number"?V=C:(V=0,z=C);const _=[];if(V<=z)for(let A=V;A<z;A++)_.push(A);else for(let A=V;A>z;A--)_.push(A);return _}e.range=f;function v(C,z,V){return C.reduce((_,A)=>(_[z(A)]=V?V(A):A,_),Object.create(null))}e.index=v;function D(C,z){return C.push(z),()=>T(C,z)}e.insert=D;function T(C,z){const V=C.indexOf(z);if(V>-1)return C.splice(V,1),z}e.remove=T;function W(C,z,V){const _=C.slice(0,z),A=C.slice(z);return _.concat(V,A)}e.arrayInsert=W;function $(C,z){let V;if(typeof z=="number"){let _=z;V=()=>{const A=Math.sin(_++)*179426549;return A-Math.floor(A)}}else V=Math.random;for(let _=C.length-1;_>0;_-=1){const A=Math.floor(V()*(_+1)),O=C[_];C[_]=C[A],C[A]=O}}e.shuffle=$;function X(C,z){const V=C.indexOf(z);V>-1&&(C.splice(V,1),C.unshift(z))}e.pushToStart=X;function x(C,z){const V=C.indexOf(z);V>-1&&(C.splice(V,1),C.push(z))}e.pushToEnd=x;function oe(C,z){return Array.isArray(C)?C.map(z):z(C)}e.mapArrayOrNot=oe;function q(C){return Array.isArray(C)?C:[C]}e.asArray=q;function N(C){return C[Math.floor(Math.random()*C.length)]}e.getRandomElement=N;function B(C,z){for(const V of C){const _=z(V);if(_!==void 0)return _}}e.mapFind=B}),define(Q[42],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(R){const L=this;let S=!1,P;return function(){return S||(S=!0,P=R.apply(L,arguments)),P}}e.once=m}),define(Q[63],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(R){function L(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}R.is=L;const S=Object.freeze([]);function P(){return S}R.empty=P;function*r(c){yield c}R.single=r;function w(c){return c||S}R.from=w;function p(c){return!c||c[Symbol.iterator]().next().done===!0}R.isEmpty=p;function n(c){return c[Symbol.iterator]().next().value}R.first=n;function b(c,t){for(const i of c)if(t(i))return!0;return!1}R.some=b;function I(c,t){for(const i of c)if(t(i))return i}R.find=I;function*y(c,t){for(const i of c)t(i)&&(yield i)}R.filter=y;function*d(c,t){for(const i of c)yield t(i)}R.map=d;function*g(...c){for(const t of c)for(const i of t)yield i}R.concat=g;function*M(c){for(const t of c)for(const i of t)yield i}R.concatNested=M;function E(c,t,i){let s=i;for(const a of c)s=t(s,a);return s}R.reduce=E;function*o(c,t,i=c.length){for(t<0&&(t+=c.length),i<0?i+=c.length:i>c.length&&(i=c.length);t<i;t++)yield c[t]}R.slice=o;function u(c,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,c];const s=c[Symbol.iterator]();for(let a=0;a<t;a++){const h=s.next();if(h.done)return[i,R.empty()];i.push(h.value)}return[i,{[Symbol.iterator](){return s}}]}R.consume=u;function l(c,t,i=(s,a)=>s===a){const s=c[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const h=s.next(),f=a.next();if(h.done!==f.done)return!1;if(h.done)return!0;if(!i(h.value,f.value))return!1}}R.equals=l})(m=e.Iterable||(e.Iterable={}))}),define(Q[43],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(t){t.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function P(t,i=!1){let s=0,a=t.length,h="",f=0,v=16,D=0;function T(N){let B=0,C=0;for(;B<N;){const z=t.charCodeAt(s);if(z>=48&&z<=57)C=C*16+z-48;else if(z>=65&&z<=70)C=C*16+z-65+10;else if(z>=97&&z<=102)C=C*16+z-97+10;else break;s++,B++}return B<N&&(C=-1),C}function W(N){s=N,h="",f=0,v=16,D=0}function $(){const N=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&p(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&p(t.charCodeAt(s)))for(s++;s<t.length&&p(t.charCodeAt(s));)s++;else return D=3,t.substring(N,s);let B=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&p(t.charCodeAt(s))){for(s++;s<t.length&&p(t.charCodeAt(s));)s++;B=s}else D=3;return t.substring(N,B)}function X(){let N="",B=s;for(;;){if(s>=a){N+=t.substring(B,s),D=2;break}const C=t.charCodeAt(s);if(C===34){N+=t.substring(B,s),s++;break}if(C===92){if(N+=t.substring(B,s),s++,s>=a){D=2;break}switch(t.charCodeAt(s++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:const V=T(4);V>=0?N+=String.fromCharCode(V):D=4;break;default:D=5}B=s;continue}if(C>=0&&C<=31)if(w(C)){N+=t.substring(B,s),D=2;break}else D=6;s++}return N}function x(){if(h="",D=0,f=s,s>=a)return f=a,v=17;let N=t.charCodeAt(s);if(r(N)){do s++,h+=String.fromCharCode(N),N=t.charCodeAt(s);while(r(N));return v=15}if(w(N))return s++,h+=String.fromCharCode(N),N===13&&t.charCodeAt(s)===10&&(s++,h+=`
`),v=14;switch(N){case 123:return s++,v=1;case 125:return s++,v=2;case 91:return s++,v=3;case 93:return s++,v=4;case 58:return s++,v=6;case 44:return s++,v=5;case 34:return s++,h=X(),v=10;case 47:const B=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<a&&!w(t.charCodeAt(s));)s++;return h=t.substring(B,s),v=12}if(t.charCodeAt(s+1)===42){s+=2;const C=a-1;let z=!1;for(;s<C;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,z=!0;break}s++}return z||(s++,D=1),h=t.substring(B,s),v=13}return h+=String.fromCharCode(N),s++,v=16;case 45:if(h+=String.fromCharCode(N),s++,s===a||!p(t.charCodeAt(s)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=$(),v=11;default:for(;s<a&&oe(N);)s++,N=t.charCodeAt(s);if(f!==s){switch(h=t.substring(f,s),h){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return h+=String.fromCharCode(N),s++,v=16}}function oe(N){if(r(N)||w(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let N;do N=x();while(N>=12&&N<=15);return N}return{setPosition:W,getPosition:()=>s,scan:i?q:x,getToken:()=>v,getTokenValue:()=>h,getTokenOffset:()=>f,getTokenLength:()=>s-f,getTokenError:()=>D}}e.createScanner=P;function r(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function w(t){return t===10||t===13||t===8232||t===8233}function p(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function b(t,i){const s=[],a=new Object;let h;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function D(T,W,$,X){f.value=T,f.offset=W,f.length=$,f.type=X,f.colonOffset=void 0,h=f}try{u(t,{onObjectBegin:(T,W)=>{if(i<=T)throw a;h=void 0,v=i>T,s.push("")},onObjectProperty:(T,W,$)=>{if(i<W||(D(T,W,$,"property"),s[s.length-1]=T,i<=W+$))throw a},onObjectEnd:(T,W)=>{if(i<=T)throw a;h=void 0,s.pop()},onArrayBegin:(T,W)=>{if(i<=T)throw a;h=void 0,s.push(0)},onArrayEnd:(T,W)=>{if(i<=T)throw a;h=void 0,s.pop()},onLiteralValue:(T,W,$)=>{if(i<W||(D(T,W,$,c(T)),i<=W+$))throw a},onSeparator:(T,W,$)=>{if(i<=W)throw a;if(T===":"&&h&&h.type==="property")h.colonOffset=W,v=!1,h=void 0;else if(T===","){const X=s[s.length-1];typeof X=="number"?s[s.length-1]=X+1:(v=!0,s[s.length-1]=""),h=void 0}}})}catch(T){if(T!==a)throw T}return{path:s,previousNode:h,isAtPropertyKey:v,matches:T=>{let W=0;for(let $=0;W<T.length&&$<s.length;$++)if(T[W]===s[$]||T[W]==="*")W++;else if(T[W]!=="**")return!1;return W===T.length}}}e.getLocation=b;function I(t,i=[],s=S.DEFAULT){let a=null,h=[];const f=[];function v(T){Array.isArray(h)?h.push(T):a!==null&&(h[a]=T)}return u(t,{onObjectBegin:()=>{const T={};v(T),f.push(h),h=T,a=null},onObjectProperty:T=>{a=T},onObjectEnd:()=>{h=f.pop()},onArrayBegin:()=>{const T=[];v(T),f.push(h),h=T,a=null},onArrayEnd:()=>{h=f.pop()},onLiteralValue:v,onError:(T,W,$)=>{i.push({error:T,offset:W,length:$})}},s),h[0]}e.parse=I;function y(t,i=[],s=S.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(T){a.type==="property"&&(a.length=T-a.offset,a=a.parent)}function f(T){return a.children.push(T),T}u(t,{onObjectBegin:T=>{a=f({type:"object",offset:T,length:-1,parent:a,children:[]})},onObjectProperty:(T,W,$)=>{a=f({type:"property",offset:W,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:T,offset:W,length:$,parent:a})},onObjectEnd:(T,W)=>{a.length=T+W-a.offset,a=a.parent,h(T+W)},onArrayBegin:(T,W)=>{a=f({type:"array",offset:T,length:-1,parent:a,children:[]})},onArrayEnd:(T,W)=>{a.length=T+W-a.offset,a=a.parent,h(T+W)},onLiteralValue:(T,W,$)=>{f({type:c(T),offset:W,length:$,parent:a,value:T}),h(W+$)},onSeparator:(T,W,$)=>{a.type==="property"&&(T===":"?a.colonOffset=W:T===","&&h(W))},onError:(T,W,$)=>{i.push({error:T,offset:W,length:$})}},s);const D=a.children[0];return D&&delete D.parent,D}e.parseTree=y;function d(t,i){if(!!t){let s=t;for(let a of i)if(typeof a=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let h=!1;for(const f of s.children)if(Array.isArray(f.children)&&f.children[0].value===a){s=f.children[1],h=!0;break}if(!h)return}else{const h=a;if(s.type!=="array"||h<0||!Array.isArray(s.children)||h>=s.children.length)return;s=s.children[h]}return s}}e.findNodeAtLocation=d;function g(t){if(!t.parent||!t.parent.children)return[];const i=g(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;i.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&i.push(s)}return i}e.getNodePath=g;function M(t){switch(t.type){case"array":return t.children.map(M);case"object":const i=Object.create(null);for(let s of t.children){const a=s.children[1];a&&(i[s.children[0].value]=M(a))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=M;function E(t,i,s=!1){return i>=t.offset&&i<t.offset+t.length||s&&i===t.offset+t.length}e.contains=E;function o(t,i,s=!1){if(E(t,i,s)){const a=t.children;if(Array.isArray(a))for(let h=0;h<a.length&&a[h].offset<=i;h++){const f=o(a[h],i,s);if(f)return f}return t}}e.findNodeAtOffset=o;function u(t,i,s=S.DEFAULT){const a=P(t,!1);function h(U){return U?()=>U(a.getTokenOffset(),a.getTokenLength()):()=>!0}function f(U){return U?K=>U(K,a.getTokenOffset(),a.getTokenLength()):()=>!0}const v=h(i.onObjectBegin),D=f(i.onObjectProperty),T=h(i.onObjectEnd),W=h(i.onArrayBegin),$=h(i.onArrayEnd),X=f(i.onLiteralValue),x=f(i.onSeparator),oe=h(i.onComment),q=f(i.onError),N=s&&s.disallowComments,B=s&&s.allowTrailingComma;function C(){for(;;){const U=a.scan();switch(a.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:N||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(U){case 12:case 13:N?z(10):oe();break;case 16:z(1);break;case 15:case 14:break;default:return U}}}function z(U,K=[],G=[]){if(q(U),K.length+G.length>0){let Y=a.getToken();for(;Y!==17;){if(K.indexOf(Y)!==-1){C();break}else if(G.indexOf(Y)!==-1)break;Y=C()}}}function V(U){const K=a.getTokenValue();return U?X(K):D(K),C(),!0}function _(){switch(a.getToken()){case 11:let U=0;try{U=JSON.parse(a.getTokenValue()),typeof U!="number"&&(z(2),U=0)}catch(K){z(2)}X(U);break;case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return C(),!0}function A(){return a.getToken()!==10?(z(3,[],[2,5]),!1):(V(!1),a.getToken()===6?(x(":"),C(),F()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function O(){v(),C();let U=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(U||z(4,[],[]),x(","),C(),a.getToken()===2&&B)break}else U&&z(6,[],[]);A()||z(4,[],[2,5]),U=!0}return T(),a.getToken()!==2?z(7,[2],[]):C(),!0}function k(){W(),C();let U=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(U||z(4,[],[]),x(","),C(),a.getToken()===4&&B)break}else U&&z(6,[],[]);F()||z(4,[],[4,5]),U=!0}return $(),a.getToken()!==4?z(8,[4],[]):C(),!0}function F(){switch(a.getToken()){case 3:return k();case 1:return O();case 10:return V(!0);default:return _()}}return C(),a.getToken()===17?s.allowEmptyContent?!0:(z(4,[],[]),!1):F()?(a.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=u;function l(t,i){let s=P(t),a=[],h,f=0,v;do switch(v=s.getPosition(),h=s.scan(),h){case 12:case 13:case 17:f!==v&&a.push(t.substring(f,v)),i!==void 0&&a.push(s.getTokenValue().replace(/[^\r\n]/g,i)),f=s.getPosition();break}while(h!==17);return a.join("")}e.stripComments=l;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(Q[102],J([0,1,43]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(w,p,n){let b,I,y,d,g;if(p){for(d=p.offset,g=d+p.length,y=d;y>0&&!r(w,y-1);)y--;let f=g;for(;f<w.length&&!r(w,f);)f++;I=w.substring(y,f),b=S(I,n)}else I=w,b=0,y=0,d=0,g=w.length;const M=P(n,w);let E=!1,o=0,u;n.insertSpaces?u=L(" ",n.tabSize||4):u="	";const l=(0,m.createScanner)(I,!1);let c=!1;function t(){return M+L(u,b+o)}function i(){let f=l.scan();for(E=!1;f===15||f===14;)E=E||f===14,f=l.scan();return c=f===16||l.getTokenError()!==0,f}const s=[];function a(f,v,D){!c&&v<g&&D>d&&w.substring(v,D)!==f&&s.push({offset:v,length:D-v,content:f})}let h=i();if(h!==17){const f=l.getTokenOffset()+y,v=L(u,b);a(v,y,f)}for(;h!==17;){let f=l.getTokenOffset()+l.getTokenLength()+y,v=i(),D="";for(;!E&&(v===12||v===13);){const W=l.getTokenOffset()+y;a(" ",f,W),f=l.getTokenOffset()+l.getTokenLength()+y,D=v===12?t():"",v=i()}if(v===2)h!==1&&(o--,D=t());else if(v===4)h!==3&&(o--,D=t());else{switch(h){case 3:case 1:o++,D=t();break;case 5:case 12:D=t();break;case 13:E?D=t():D=" ";break;case 6:D=" ";break;case 10:if(v===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?D=" ":v!==5&&v!==17&&(c=!0);break;case 16:c=!0;break}E&&(v===12||v===13)&&(D=t())}const T=l.getTokenOffset()+y;a(D,f,T),h=v}return s}e.format=R;function L(w,p){let n="";for(let b=0;b<p;b++)n+=w;return n}function S(w,p){let n=0,b=0;const I=p.tabSize||4;for(;n<w.length;){const y=w.charAt(n);if(y===" ")b++;else if(y==="	")b+=I;else break;n++}return Math.floor(b/I)}function P(w,p){for(let n=0;n<p.length;n++){const b=p.charAt(n);if(b==="\r")return n+1<p.length&&p.charAt(n+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=P;function r(w,p){return`\r
`.indexOf(w.charAt(p))!==-1}e.isEOL=r}),define(Q[103],J([0,1,43,102]),function(j,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(p,n,b){return S(p,n,void 0,b)}e.removeProperty=L;function S(p,n,b,I,y){const d=n.slice(),g=[],M=(0,m.parseTree)(p,g);let E,o;for(;d.length>0&&(o=d.pop(),E=(0,m.findNodeAtLocation)(M,d),E===void 0&&b!==void 0);)typeof o=="string"?b={[o]:b}:b=[b];if(E)if(E.type==="object"&&typeof o=="string"&&Array.isArray(E.children)){const u=(0,m.findNodeAtLocation)(E,[o]);if(u!==void 0)if(b===void 0){if(!u.parent)throw new Error("Malformed AST");const l=E.children.indexOf(u.parent);let c,t=u.parent.offset+u.parent.length;if(l>0){const i=E.children[l-1];c=i.offset+i.length}else c=E.offset+1,E.children.length>1&&(t=E.children[1].offset);return P(p,{offset:c,length:t-c,content:""},I)}else return P(p,{offset:u.offset,length:u.length,content:JSON.stringify(b)},I);else{if(b===void 0)return[];const l=`${JSON.stringify(o)}: ${JSON.stringify(b)}`,c=y?y(E.children.map(i=>i.children[0].value)):E.children.length;let t;if(c>0){const i=E.children[c-1];t={offset:i.offset+i.length,length:0,content:","+l}}else E.children.length===0?t={offset:E.offset+1,length:0,content:l}:t={offset:E.offset+1,length:0,content:l+","};return P(p,t,I)}}else if(E.type==="array"&&typeof o=="number"&&Array.isArray(E.children))if(b!==void 0){const u=`${JSON.stringify(b)}`;let l;if(E.children.length===0||o===0)l={offset:E.offset+1,length:0,content:E.children.length===0?u:u+","};else{const c=o===-1||o>E.children.length?E.children.length:o,t=E.children[c-1];l={offset:t.offset+t.length,length:0,content:","+u}}return P(p,l,I)}else{const u=o,l=E.children[u];let c;if(E.children.length===1)c={offset:E.offset+1,length:E.length-2,content:""};else if(E.children.length-1===u){const t=E.children[u-1],i=t.offset+t.length,s=E.offset+E.length;c={offset:i,length:s-2-i,content:""}}else c={offset:l.offset,length:E.children[u+1].offset-l.offset,content:""};return P(p,c,I)}else throw new Error(`Can not add ${typeof o!="number"?"index":"property"} to parent of type ${E.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return P(p,{offset:M?M.offset:0,length:M?M.length:0,content:JSON.stringify(b)},I)}}e.setProperty=S;function P(p,n,b){let I=r(p,n),y=n.offset,d=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;y>0&&!(0,R.isEOL)(I,y-1);)y--;for(;d<I.length&&!(0,R.isEOL)(I,d);)d++}const g=(0,R.format)(I,{offset:y,length:d-y},b);for(let E=g.length-1;E>=0;E--){const o=g[E];I=r(I,o),y=Math.min(y,o.offset),d=Math.max(d,o.offset+o.length),d+=o.content.length-o.length}const M=p.length-(I.length-d)-y;return[{offset:y,length:M,content:I.substring(y,d)}]}e.withFormatting=P;function r(p,n){return p.substring(0,n.offset)+n.content+p.substring(n.offset+n.length)}e.applyEdit=r;function w(p,n){let b=n.slice(0).sort((y,d)=>{const g=y.offset-d.offset;return g===0?y.length-d.length:g}),I=p.length;for(let y=b.length-1;y>=0;y--){let d=b[y];if(d.offset+d.length<=I)p=r(p,d);else throw new Error("Overlapping edit");I=d.offset}return p}e.applyEdits=w}),define(Q[57],J([0,1,18]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var R;(function(o){o[o.DependsOnKbLayout=-1]="DependsOnKbLayout",o[o.Unknown=0]="Unknown",o[o.Backspace=1]="Backspace",o[o.Tab=2]="Tab",o[o.Enter=3]="Enter",o[o.Shift=4]="Shift",o[o.Ctrl=5]="Ctrl",o[o.Alt=6]="Alt",o[o.PauseBreak=7]="PauseBreak",o[o.CapsLock=8]="CapsLock",o[o.Escape=9]="Escape",o[o.Space=10]="Space",o[o.PageUp=11]="PageUp",o[o.PageDown=12]="PageDown",o[o.End=13]="End",o[o.Home=14]="Home",o[o.LeftArrow=15]="LeftArrow",o[o.UpArrow=16]="UpArrow",o[o.RightArrow=17]="RightArrow",o[o.DownArrow=18]="DownArrow",o[o.Insert=19]="Insert",o[o.Delete=20]="Delete",o[o.KEY_0=21]="KEY_0",o[o.KEY_1=22]="KEY_1",o[o.KEY_2=23]="KEY_2",o[o.KEY_3=24]="KEY_3",o[o.KEY_4=25]="KEY_4",o[o.KEY_5=26]="KEY_5",o[o.KEY_6=27]="KEY_6",o[o.KEY_7=28]="KEY_7",o[o.KEY_8=29]="KEY_8",o[o.KEY_9=30]="KEY_9",o[o.KEY_A=31]="KEY_A",o[o.KEY_B=32]="KEY_B",o[o.KEY_C=33]="KEY_C",o[o.KEY_D=34]="KEY_D",o[o.KEY_E=35]="KEY_E",o[o.KEY_F=36]="KEY_F",o[o.KEY_G=37]="KEY_G",o[o.KEY_H=38]="KEY_H",o[o.KEY_I=39]="KEY_I",o[o.KEY_J=40]="KEY_J",o[o.KEY_K=41]="KEY_K",o[o.KEY_L=42]="KEY_L",o[o.KEY_M=43]="KEY_M",o[o.KEY_N=44]="KEY_N",o[o.KEY_O=45]="KEY_O",o[o.KEY_P=46]="KEY_P",o[o.KEY_Q=47]="KEY_Q",o[o.KEY_R=48]="KEY_R",o[o.KEY_S=49]="KEY_S",o[o.KEY_T=50]="KEY_T",o[o.KEY_U=51]="KEY_U",o[o.KEY_V=52]="KEY_V",o[o.KEY_W=53]="KEY_W",o[o.KEY_X=54]="KEY_X",o[o.KEY_Y=55]="KEY_Y",o[o.KEY_Z=56]="KEY_Z",o[o.Meta=57]="Meta",o[o.ContextMenu=58]="ContextMenu",o[o.F1=59]="F1",o[o.F2=60]="F2",o[o.F3=61]="F3",o[o.F4=62]="F4",o[o.F5=63]="F5",o[o.F6=64]="F6",o[o.F7=65]="F7",o[o.F8=66]="F8",o[o.F9=67]="F9",o[o.F10=68]="F10",o[o.F11=69]="F11",o[o.F12=70]="F12",o[o.F13=71]="F13",o[o.F14=72]="F14",o[o.F15=73]="F15",o[o.F16=74]="F16",o[o.F17=75]="F17",o[o.F18=76]="F18",o[o.F19=77]="F19",o[o.NumLock=78]="NumLock",o[o.ScrollLock=79]="ScrollLock",o[o.US_SEMICOLON=80]="US_SEMICOLON",o[o.US_EQUAL=81]="US_EQUAL",o[o.US_COMMA=82]="US_COMMA",o[o.US_MINUS=83]="US_MINUS",o[o.US_DOT=84]="US_DOT",o[o.US_SLASH=85]="US_SLASH",o[o.US_BACKTICK=86]="US_BACKTICK",o[o.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",o[o.US_BACKSLASH=88]="US_BACKSLASH",o[o.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",o[o.US_QUOTE=90]="US_QUOTE",o[o.OEM_8=91]="OEM_8",o[o.OEM_102=92]="OEM_102",o[o.NUMPAD_0=93]="NUMPAD_0",o[o.NUMPAD_1=94]="NUMPAD_1",o[o.NUMPAD_2=95]="NUMPAD_2",o[o.NUMPAD_3=96]="NUMPAD_3",o[o.NUMPAD_4=97]="NUMPAD_4",o[o.NUMPAD_5=98]="NUMPAD_5",o[o.NUMPAD_6=99]="NUMPAD_6",o[o.NUMPAD_7=100]="NUMPAD_7",o[o.NUMPAD_8=101]="NUMPAD_8",o[o.NUMPAD_9=102]="NUMPAD_9",o[o.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",o[o.NUMPAD_ADD=104]="NUMPAD_ADD",o[o.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",o[o.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",o[o.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",o[o.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",o[o.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",o[o.ABNT_C1=110]="ABNT_C1",o[o.ABNT_C2=111]="ABNT_C2",o[o.MAX_VALUE=112]="MAX_VALUE"})(R=e.KeyCode||(e.KeyCode={}));class L{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(u,l){this._keyCodeToStr[u]=l,this._strToKeyCode[l.toLowerCase()]=u}keyCodeToStr(u){return this._keyCodeToStr[u]}strToKeyCode(u){return this._strToKeyCode[u.toLowerCase()]||0}}const S=new L,P=new L,r=new L;(function(){function o(u,l,c=l,t=c){S.define(u,l),P.define(u,c),r.define(u,t)}o(0,"unknown"),o(1,"Backspace"),o(2,"Tab"),o(3,"Enter"),o(4,"Shift"),o(5,"Ctrl"),o(6,"Alt"),o(7,"PauseBreak"),o(8,"CapsLock"),o(9,"Escape"),o(10,"Space"),o(11,"PageUp"),o(12,"PageDown"),o(13,"End"),o(14,"Home"),o(15,"LeftArrow","Left"),o(16,"UpArrow","Up"),o(17,"RightArrow","Right"),o(18,"DownArrow","Down"),o(19,"Insert"),o(20,"Delete"),o(21,"0"),o(22,"1"),o(23,"2"),o(24,"3"),o(25,"4"),o(26,"5"),o(27,"6"),o(28,"7"),o(29,"8"),o(30,"9"),o(31,"A"),o(32,"B"),o(33,"C"),o(34,"D"),o(35,"E"),o(36,"F"),o(37,"G"),o(38,"H"),o(39,"I"),o(40,"J"),o(41,"K"),o(42,"L"),o(43,"M"),o(44,"N"),o(45,"O"),o(46,"P"),o(47,"Q"),o(48,"R"),o(49,"S"),o(50,"T"),o(51,"U"),o(52,"V"),o(53,"W"),o(54,"X"),o(55,"Y"),o(56,"Z"),o(57,"Meta"),o(58,"ContextMenu"),o(59,"F1"),o(60,"F2"),o(61,"F3"),o(62,"F4"),o(63,"F5"),o(64,"F6"),o(65,"F7"),o(66,"F8"),o(67,"F9"),o(68,"F10"),o(69,"F11"),o(70,"F12"),o(71,"F13"),o(72,"F14"),o(73,"F15"),o(74,"F16"),o(75,"F17"),o(76,"F18"),o(77,"F19"),o(78,"NumLock"),o(79,"ScrollLock"),o(80,";",";","OEM_1"),o(81,"=","=","OEM_PLUS"),o(82,",",",","OEM_COMMA"),o(83,"-","-","OEM_MINUS"),o(84,".",".","OEM_PERIOD"),o(85,"/","/","OEM_2"),o(86,"`","`","OEM_3"),o(110,"ABNT_C1"),o(111,"ABNT_C2"),o(87,"[","[","OEM_4"),o(88,"\\","\\","OEM_5"),o(89,"]","]","OEM_6"),o(90,"'","'","OEM_7"),o(91,"OEM_8"),o(92,"OEM_102"),o(93,"NumPad0"),o(94,"NumPad1"),o(95,"NumPad2"),o(96,"NumPad3"),o(97,"NumPad4"),o(98,"NumPad5"),o(99,"NumPad6"),o(100,"NumPad7"),o(101,"NumPad8"),o(102,"NumPad9"),o(103,"NumPad_Multiply"),o(104,"NumPad_Add"),o(105,"NumPad_Separator"),o(106,"NumPad_Subtract"),o(107,"NumPad_Decimal"),o(108,"NumPad_Divide")})();var w;(function(o){function u(s){return S.keyCodeToStr(s)}o.toString=u;function l(s){return S.strToKeyCode(s)}o.fromString=l;function c(s){return P.keyCodeToStr(s)}o.toUserSettingsUS=c;function t(s){return r.keyCodeToStr(s)}o.toUserSettingsGeneral=t;function i(s){return P.strToKeyCode(s)||r.strToKeyCode(s)}o.fromUserSettings=i})(w=e.KeyCodeUtils||(e.KeyCodeUtils={}));var p;(function(o){o[o.CtrlCmd=2048]="CtrlCmd",o[o.Shift=1024]="Shift",o[o.Alt=512]="Alt",o[o.WinCtrl=256]="WinCtrl",o[o.KeyCode=255]="KeyCode"})(p||(p={}));var n;(function(o){o[o.CtrlCmd=2048]="CtrlCmd",o[o.Shift=1024]="Shift",o[o.Alt=512]="Alt",o[o.WinCtrl=256]="WinCtrl"})(n=e.KeyMod||(e.KeyMod={}));function b(o,u){const l=(u&65535)<<16>>>0;return(o|l)>>>0}e.KeyChord=b;function I(o,u){if(o===0)return null;const l=(o&65535)>>>0,c=(o&4294901760)>>>16;return c!==0?new g([y(l,u),y(c,u)]):new g([y(l,u)])}e.createKeybinding=I;function y(o,u){const l=!!(o&2048),c=!!(o&256),t=u===2?c:l,i=!!(o&1024),s=!!(o&512),a=u===2?l:c,h=o&255;return new d(t,i,s,a,h)}e.createSimpleKeybinding=y;class d{constructor(u,l,c,t,i){this.ctrlKey=u,this.shiftKey=l,this.altKey=c,this.metaKey=t,this.keyCode=i}equals(u){return this.ctrlKey===u.ctrlKey&&this.shiftKey===u.shiftKey&&this.altKey===u.altKey&&this.metaKey===u.metaKey&&this.keyCode===u.keyCode}getHashCode(){const u=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",c=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${u}${l}${c}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new g([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class g{constructor(u){if(u.length===0)throw(0,m.illegalArgument)("parts");this.parts=u}getHashCode(){let u="";for(let l=0,c=this.parts.length;l<c;l++)l!==0&&(u+=";"),u+=this.parts[l].getHashCode();return u}equals(u){if(u===null||this.parts.length!==u.parts.length)return!1;for(let l=0;l<this.parts.length;l++)if(!this.parts[l].equals(u.parts[l]))return!1;return!0}}e.ChordKeybinding=g;class M{constructor(u,l,c,t,i,s){this.ctrlKey=u,this.shiftKey=l,this.altKey=c,this.metaKey=t,this.keyLabel=i,this.keyAriaLabel=s}}e.ResolvedKeybindingPart=M;class E{}e.ResolvedKeybinding=E}),define(Q[2],J([0,1,42,63]),function(j,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const L=!1;let S=null;function P(u){S=u}if(e.setDisposableTracker=P,L){const u="__is_disposable_tracked__";S=new class{trackDisposable(l){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[u]||console.log(c)},3e3)}markTracked(l){if(l&&l!==g.None)try{l[u]=!0}catch(c){}}}}function r(u){!S||S.markTracked(u)}function w(u){return S&&S.trackDisposable(u),u}e.trackDisposable=w;class p extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=p;function n(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=n;function b(u){if(R.Iterable.is(u)){let l=[];for(const c of u)if(c){r(c);try{c.dispose()}catch(t){l.push(t)}}if(l.length===1)throw l[0];if(l.length>1)throw new p(l);return Array.isArray(u)?[]:u}else if(u)return r(u),u.dispose(),u}e.dispose=b;function I(...u){return u.forEach(r),y(()=>b(u))}e.combinedDisposable=I;function y(u){const l=w({dispose:()=>{r(l),u()}});return l}e.toDisposable=y;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(r(this),this._isDisposed=!0,this.clear())}clear(){try{b(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return r(l),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this._store=new d,w(this)}dispose(){r(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class M{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var c;this._isDisposed||l===this._value||((c=this._value)===null||c===void 0||c.dispose(),l&&r(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,r(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=M;class E{constructor(){this.references=new Map}acquire(l,...c){let t=this.references.get(l);t||(t={counter:0,object:this.createReferencedObject(l,...c)},this.references.set(l,t));const{object:i}=t,s=(0,m.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(l,t.object),this.references.delete(l))});return t.counter++,{object:i,dispose:s}}}e.ReferenceCollection=E;class o{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=o}),define(Q[78],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(S){this.element=S,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class R{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let S=this._first;for(;S!==m.Undefined;){const P=S.next;S.prev=m.Undefined,S.next=m.Undefined,S=P}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,P){const r=new m(S);if(this._first===m.Undefined)this._first=r,this._last=r;else if(P){const p=this._last;this._last=r,r.prev=p,p.next=r}else{const p=this._first;this._first=r,r.next=p,p.prev=r}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(r))}}shift(){if(this._first!==m.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==m.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==m.Undefined&&S.next!==m.Undefined){const P=S.prev;P.next=S.next,S.next.prev=P}else S.prev===m.Undefined&&S.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):S.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):S.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==m.Undefined;)yield S.element,S=S.next}}e.LinkedList=R});"use strict";(function(){function j(L){const S=[];typeof L=="number"&&S.push("code/timeOrigin",L);function P(w){S.push(w,Date.now())}function r(){const w=[];for(let p=0;p<S.length;p+=2)w.push({name:S[p],startTime:S[p+1]});return w}return{mark:P,getMarks:r}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const P of performance.getEntriesByType("mark"))S.push({name:P.name,startTime:Math.round(L+P.startTime)});return S}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function m(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=m(R))})(),define(Q[3],J([0,1]),function(j,e){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let L=!1,S=!1,P=!1,r=!1,w=!1,p=!1,n=!1,b,I=R,y,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?g=e.globals.vscode.process:typeof process!="undefined"&&(g=process);const M=typeof((m=g==null?void 0:g.versions)===null||m===void 0?void 0:m.electron)=="string"&&g.type==="renderer";if(e.isElectronSandboxed=M&&(g==null?void 0:g.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const a=g==null?void 0:g.env.VSCODE_BROWSER_CODE_LOADING;if(typeof a=="string")return a==="none"||a==="code"||a==="bypassHeatCheck"||a==="bypassHeatCheckAndEagerCompile"?a:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!M)d=navigator.userAgent,L=d.indexOf("Windows")>=0,S=d.indexOf("Macintosh")>=0,n=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=d.indexOf("Linux")>=0,p=!0,b=navigator.language,I=b;else if(typeof g=="object"){L=g.platform==="win32",S=g.platform==="darwin",P=g.platform==="linux",r=P&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,b=R,I=R;const a=g.env.VSCODE_NLS_CONFIG;if(a)try{const h=JSON.parse(a),f=h.availableLanguages["*"];b=h.locale,I=f||R,y=h._translationsConfigFile}catch(h){}w=!0}else console.error("Unable to resolve platform.");var E;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function o(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=o;let u=0;S?u=1:L?u=3:P&&(u=2),e.isWindows=L,e.isMacintosh=S,e.isLinux=P,e.isLinuxSnap=r,e.isNative=w,e.isWeb=p,e.isIOS=n,e.platform=u,e.userAgent=d,e.language=I;var l;(function(a){function h(){return e.language}a.value=h;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=f;function v(){return e.language==="en"}a.isDefault=v})(l=e.Language||(e.Language={})),e.locale=b,e.translationsConfigFile=y,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let f=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeSetImmediateId)for(let T=0,W=f.length;T<W;T++){const $=f[T];if($.id===D.data.vscodeSetImmediateId){f.splice(T,1),$.callback();return}}});let v=0;return D=>{const T=++v;f.push({id:T,callback:D}),e.globals.postMessage({vscodeSetImmediateId:T},"*")}}if(typeof(g==null?void 0:g.nextTick)=="function")return g.nextTick.bind(g);const h=Promise.resolve();return f=>h.then(f)}();var c;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=S||n?2:L?1:3;let t=!0,i=!1;function s(){if(!i){i=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,t=new Uint16Array(a.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(Q[32],J([0,1,3]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const L=m.globals.vscode.process;R={get platform(){return L.platform},get env(){return L.env},cwd(){return L.cwd()},nextTick(S){return(0,m.setImmediate)(S)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(L){return process.nextTick(L)}}:R={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},nextTick(L){return(0,m.setImmediate)(L)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(Q[8],J([0,1,32]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,L=97,S=90,P=122,r=46,w=47,p=92,n=58,b=63;class I extends Error{constructor(l,c,t){let i;typeof c=="string"&&c.indexOf("not ")===0?(i="must not be",c=c.replace(/^not /,"")):i="must be";const s=l.indexOf(".")!==-1?"property":"argument";let a=`The "${l}" ${s} ${i} of type ${c}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function y(u,l){if(typeof u!="string")throw new I(l,"string",u)}function d(u){return u===w||u===p}function g(u){return u===w}function M(u){return u>=R&&u<=S||u>=L&&u<=P}function E(u,l,c,t){let i="",s=0,a=-1,h=0,f=0;for(let v=0;v<=u.length;++v){if(v<u.length)f=u.charCodeAt(v);else{if(t(f))break;f=w}if(t(f)){if(!(a===v-1||h===1))if(h===2){if(i.length<2||s!==2||i.charCodeAt(i.length-1)!==r||i.charCodeAt(i.length-2)!==r){if(i.length>2){const D=i.lastIndexOf(c);D===-1?(i="",s=0):(i=i.slice(0,D),s=i.length-1-i.lastIndexOf(c)),a=v,h=0;continue}else if(i.length!==0){i="",s=0,a=v,h=0;continue}}l&&(i+=i.length>0?`${c}..`:"..",s=2)}else i.length>0?i+=`${c}${u.slice(a+1,v)}`:i=u.slice(a+1,v),s=v-a-1;a=v,h=0}else f===r&&h!==-1?++h:h=-1}return i}function o(u,l){if(l===null||typeof l!="object")throw new I("pathObject","Object",l);const c=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return c?c===l.root?`${c}${t}`:`${c}${u}${t}`:t}e.win32={resolve(...u){let l="",c="",t=!1;for(let i=u.length-1;i>=-1;i--){let s;if(i>=0){if(s=u[i],y(s,"path"),s.length===0)continue}else l.length===0?s=m.cwd():(s=m.env[`=${l}`]||m.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==l.toLowerCase()&&s.charCodeAt(2)===p)&&(s=`${l}\\`));const a=s.length;let h=0,f="",v=!1;const D=s.charCodeAt(0);if(a===1)d(D)&&(h=1,v=!0);else if(d(D))if(v=!0,d(s.charCodeAt(1))){let T=2,W=T;for(;T<a&&!d(s.charCodeAt(T));)T++;if(T<a&&T!==W){const $=s.slice(W,T);for(W=T;T<a&&d(s.charCodeAt(T));)T++;if(T<a&&T!==W){for(W=T;T<a&&!d(s.charCodeAt(T));)T++;(T===a||T!==W)&&(f=`\\\\${$}\\${s.slice(W,T)}`,h=T)}}}else h=1;else M(D)&&s.charCodeAt(1)===n&&(f=s.slice(0,2),h=2,a>2&&d(s.charCodeAt(2))&&(v=!0,h=3));if(f.length>0)if(l.length>0){if(f.toLowerCase()!==l.toLowerCase())continue}else l=f;if(t){if(l.length>0)break}else if(c=`${s.slice(h)}\\${c}`,t=v,v&&l.length>0)break}return c=E(c,!t,"\\",d),t?`${l}\\${c}`:`${l}${c}`||"."},normalize(u){y(u,"path");const l=u.length;if(l===0)return".";let c=0,t,i=!1;const s=u.charCodeAt(0);if(l===1)return g(s)?"\\":u;if(d(s))if(i=!0,d(u.charCodeAt(1))){let h=2,f=h;for(;h<l&&!d(u.charCodeAt(h));)h++;if(h<l&&h!==f){const v=u.slice(f,h);for(f=h;h<l&&d(u.charCodeAt(h));)h++;if(h<l&&h!==f){for(f=h;h<l&&!d(u.charCodeAt(h));)h++;if(h===l)return`\\\\${v}\\${u.slice(f)}\\`;h!==f&&(t=`\\\\${v}\\${u.slice(f,h)}`,c=h)}}}else c=1;else M(s)&&u.charCodeAt(1)===n&&(t=u.slice(0,2),c=2,l>2&&d(u.charCodeAt(2))&&(i=!0,c=3));let a=c<l?E(u.slice(c),!i,"\\",d):"";return a.length===0&&!i&&(a="."),a.length>0&&d(u.charCodeAt(l-1))&&(a+="\\"),t===void 0?i?`\\${a}`:a:i?`${t}\\${a}`:`${t}${a}`},isAbsolute(u){y(u,"path");const l=u.length;if(l===0)return!1;const c=u.charCodeAt(0);return d(c)||l>2&&M(c)&&u.charCodeAt(1)===n&&d(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let l,c;for(let s=0;s<u.length;++s){const a=u[s];y(a,"path"),a.length>0&&(l===void 0?l=c=a:l+=`\\${a}`)}if(l===void 0)return".";let t=!0,i=0;if(typeof c=="string"&&d(c.charCodeAt(0))){++i;const s=c.length;s>1&&d(c.charCodeAt(1))&&(++i,s>2&&(d(c.charCodeAt(2))?++i:t=!1))}if(t){for(;i<l.length&&d(l.charCodeAt(i));)i++;i>=2&&(l=`\\${l.slice(i)}`)}return e.win32.normalize(l)},relative(u,l){if(y(u,"from"),y(l,"to"),u===l)return"";const c=e.win32.resolve(u),t=e.win32.resolve(l);if(c===t||(u=c.toLowerCase(),l=t.toLowerCase(),u===l))return"";let i=0;for(;i<u.length&&u.charCodeAt(i)===p;)i++;let s=u.length;for(;s-1>i&&u.charCodeAt(s-1)===p;)s--;const a=s-i;let h=0;for(;h<l.length&&l.charCodeAt(h)===p;)h++;let f=l.length;for(;f-1>h&&l.charCodeAt(f-1)===p;)f--;const v=f-h,D=a<v?a:v;let T=-1,W=0;for(;W<D;W++){const X=u.charCodeAt(i+W);if(X!==l.charCodeAt(h+W))break;X===p&&(T=W)}if(W!==D){if(T===-1)return t}else{if(v>D){if(l.charCodeAt(h+W)===p)return t.slice(h+W+1);if(W===2)return t.slice(h+W)}a>D&&(u.charCodeAt(i+W)===p?T=W:W===2&&(T=3)),T===-1&&(T=0)}let $="";for(W=i+T+1;W<=s;++W)(W===s||u.charCodeAt(W)===p)&&($+=$.length===0?"..":"\\..");return h+=T,$.length>0?`${$}${t.slice(h,f)}`:(t.charCodeAt(h)===p&&++h,t.slice(h,f))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const l=e.win32.resolve(u);if(l.length<=2)return u;if(l.charCodeAt(0)===p){if(l.charCodeAt(1)===p){const c=l.charCodeAt(2);if(c!==b&&c!==r)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(M(l.charCodeAt(0))&&l.charCodeAt(1)===n&&l.charCodeAt(2)===p)return`\\\\?\\${l}`;return u},dirname(u){y(u,"path");const l=u.length;if(l===0)return".";let c=-1,t=0;const i=u.charCodeAt(0);if(l===1)return d(i)?u:".";if(d(i)){if(c=t=1,d(u.charCodeAt(1))){let h=2,f=h;for(;h<l&&!d(u.charCodeAt(h));)h++;if(h<l&&h!==f){for(f=h;h<l&&d(u.charCodeAt(h));)h++;if(h<l&&h!==f){for(f=h;h<l&&!d(u.charCodeAt(h));)h++;if(h===l)return u;h!==f&&(c=t=h+1)}}}}else M(i)&&u.charCodeAt(1)===n&&(c=l>2&&d(u.charCodeAt(2))?3:2,t=c);let s=-1,a=!0;for(let h=l-1;h>=t;--h)if(d(u.charCodeAt(h))){if(!a){s=h;break}}else a=!1;if(s===-1){if(c===-1)return".";s=c}return u.slice(0,s)},basename(u,l){l!==void 0&&y(l,"ext"),y(u,"path");let c=0,t=-1,i=!0,s;if(u.length>=2&&M(u.charCodeAt(0))&&u.charCodeAt(1)===n&&(c=2),l!==void 0&&l.length>0&&l.length<=u.length){if(l===u)return"";let a=l.length-1,h=-1;for(s=u.length-1;s>=c;--s){const f=u.charCodeAt(s);if(d(f)){if(!i){c=s+1;break}}else h===-1&&(i=!1,h=s+1),a>=0&&(f===l.charCodeAt(a)?--a==-1&&(t=s):(a=-1,t=h))}return c===t?t=h:t===-1&&(t=u.length),u.slice(c,t)}for(s=u.length-1;s>=c;--s)if(d(u.charCodeAt(s))){if(!i){c=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":u.slice(c,t)},extname(u){y(u,"path");let l=0,c=-1,t=0,i=-1,s=!0,a=0;u.length>=2&&u.charCodeAt(1)===n&&M(u.charCodeAt(0))&&(l=t=2);for(let h=u.length-1;h>=l;--h){const f=u.charCodeAt(h);if(d(f)){if(!s){t=h+1;break}continue}i===-1&&(s=!1,i=h+1),f===r?c===-1?c=h:a!==1&&(a=1):c!==-1&&(a=-1)}return c===-1||i===-1||a===0||a===1&&c===i-1&&c===t+1?"":u.slice(c,i)},format:o.bind(null,"\\"),parse(u){y(u,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return l;const c=u.length;let t=0,i=u.charCodeAt(0);if(c===1)return d(i)?(l.root=l.dir=u,l):(l.base=l.name=u,l);if(d(i)){if(t=1,d(u.charCodeAt(1))){let T=2,W=T;for(;T<c&&!d(u.charCodeAt(T));)T++;if(T<c&&T!==W){for(W=T;T<c&&d(u.charCodeAt(T));)T++;if(T<c&&T!==W){for(W=T;T<c&&!d(u.charCodeAt(T));)T++;T===c?t=T:T!==W&&(t=T+1)}}}}else if(M(i)&&u.charCodeAt(1)===n){if(c<=2)return l.root=l.dir=u,l;if(t=2,d(u.charCodeAt(2))){if(c===3)return l.root=l.dir=u,l;t=3}}t>0&&(l.root=u.slice(0,t));let s=-1,a=t,h=-1,f=!0,v=u.length-1,D=0;for(;v>=t;--v){if(i=u.charCodeAt(v),d(i)){if(!f){a=v+1;break}continue}h===-1&&(f=!1,h=v+1),i===r?s===-1?s=v:D!==1&&(D=1):s!==-1&&(D=-1)}return h!==-1&&(s===-1||D===0||D===1&&s===h-1&&s===a+1?l.base=l.name=u.slice(a,h):(l.name=u.slice(a,s),l.base=u.slice(a,h),l.ext=u.slice(s,h))),a>0&&a!==t?l.dir=u.slice(0,a-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let l="",c=!1;for(let t=u.length-1;t>=-1&&!c;t--){const i=t>=0?u[t]:m.cwd();y(i,"path"),i.length!==0&&(l=`${i}/${l}`,c=i.charCodeAt(0)===w)}return l=E(l,!c,"/",g),c?`/${l}`:l.length>0?l:"."},normalize(u){if(y(u,"path"),u.length===0)return".";const l=u.charCodeAt(0)===w,c=u.charCodeAt(u.length-1)===w;return u=E(u,!l,"/",g),u.length===0?l?"/":c?"./":".":(c&&(u+="/"),l?`/${u}`:u)},isAbsolute(u){return y(u,"path"),u.length>0&&u.charCodeAt(0)===w},join(...u){if(u.length===0)return".";let l;for(let c=0;c<u.length;++c){const t=u[c];y(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(u,l){if(y(u,"from"),y(l,"to"),u===l||(u=e.posix.resolve(u),l=e.posix.resolve(l),u===l))return"";const c=1,t=u.length,i=t-c,s=1,a=l.length-s,h=i<a?i:a;let f=-1,v=0;for(;v<h;v++){const T=u.charCodeAt(c+v);if(T!==l.charCodeAt(s+v))break;T===w&&(f=v)}if(v===h)if(a>h){if(l.charCodeAt(s+v)===w)return l.slice(s+v+1);if(v===0)return l.slice(s+v)}else i>h&&(u.charCodeAt(c+v)===w?f=v:v===0&&(f=0));let D="";for(v=c+f+1;v<=t;++v)(v===t||u.charCodeAt(v)===w)&&(D+=D.length===0?"..":"/..");return`${D}${l.slice(s+f)}`},toNamespacedPath(u){return u},dirname(u){if(y(u,"path"),u.length===0)return".";const l=u.charCodeAt(0)===w;let c=-1,t=!0;for(let i=u.length-1;i>=1;--i)if(u.charCodeAt(i)===w){if(!t){c=i;break}}else t=!1;return c===-1?l?"/":".":l&&c===1?"//":u.slice(0,c)},basename(u,l){l!==void 0&&y(l,"ext"),y(u,"path");let c=0,t=-1,i=!0,s;if(l!==void 0&&l.length>0&&l.length<=u.length){if(l===u)return"";let a=l.length-1,h=-1;for(s=u.length-1;s>=0;--s){const f=u.charCodeAt(s);if(f===w){if(!i){c=s+1;break}}else h===-1&&(i=!1,h=s+1),a>=0&&(f===l.charCodeAt(a)?--a==-1&&(t=s):(a=-1,t=h))}return c===t?t=h:t===-1&&(t=u.length),u.slice(c,t)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===w){if(!i){c=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":u.slice(c,t)},extname(u){y(u,"path");let l=-1,c=0,t=-1,i=!0,s=0;for(let a=u.length-1;a>=0;--a){const h=u.charCodeAt(a);if(h===w){if(!i){c=a+1;break}continue}t===-1&&(i=!1,t=a+1),h===r?l===-1?l=a:s!==1&&(s=1):l!==-1&&(s=-1)}return l===-1||t===-1||s===0||s===1&&l===t-1&&l===c+1?"":u.slice(l,t)},format:o.bind(null,"/"),parse(u){y(u,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return l;const c=u.charCodeAt(0)===w;let t;c?(l.root="/",t=1):t=0;let i=-1,s=0,a=-1,h=!0,f=u.length-1,v=0;for(;f>=t;--f){const D=u.charCodeAt(f);if(D===w){if(!h){s=f+1;break}continue}a===-1&&(h=!1,a=f+1),D===r?i===-1?i=f:v!==1&&(v=1):i!==-1&&(v=-1)}if(a!==-1){const D=s===0&&c?1:s;i===-1||v===0||v===1&&i===a-1&&i===s+1?l.base=l.name=u.slice(D,a):(l.name=u.slice(D,i),l.base=u.slice(D,a),l.ext=u.slice(i,a))}return s>0?l.dir=u.slice(0,s-1):c&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Q[104],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var R;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(S,...P){const r=P.reduce((n,b)=>(n[b]=!0,n),{}),w=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(n=>!r[n]).forEach(n=>{for(let b=0;b<w.length;b++)if(n.search(w[b])!==-1){delete S[n];break}})}e.sanitizeProcessEnvironment=L}),define(Q[79],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var m;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.None=0]="None",r[r.Hyper=1]="Hyper",r[r.Super=2]="Super",r[r.Fn=3]="Fn",r[r.FnLock=4]="FnLock",r[r.Suspend=5]="Suspend",r[r.Resume=6]="Resume",r[r.Turbo=7]="Turbo",r[r.Sleep=8]="Sleep",r[r.WakeUp=9]="WakeUp",r[r.KeyA=10]="KeyA",r[r.KeyB=11]="KeyB",r[r.KeyC=12]="KeyC",r[r.KeyD=13]="KeyD",r[r.KeyE=14]="KeyE",r[r.KeyF=15]="KeyF",r[r.KeyG=16]="KeyG",r[r.KeyH=17]="KeyH",r[r.KeyI=18]="KeyI",r[r.KeyJ=19]="KeyJ",r[r.KeyK=20]="KeyK",r[r.KeyL=21]="KeyL",r[r.KeyM=22]="KeyM",r[r.KeyN=23]="KeyN",r[r.KeyO=24]="KeyO",r[r.KeyP=25]="KeyP",r[r.KeyQ=26]="KeyQ",r[r.KeyR=27]="KeyR",r[r.KeyS=28]="KeyS",r[r.KeyT=29]="KeyT",r[r.KeyU=30]="KeyU",r[r.KeyV=31]="KeyV",r[r.KeyW=32]="KeyW",r[r.KeyX=33]="KeyX",r[r.KeyY=34]="KeyY",r[r.KeyZ=35]="KeyZ",r[r.Digit1=36]="Digit1",r[r.Digit2=37]="Digit2",r[r.Digit3=38]="Digit3",r[r.Digit4=39]="Digit4",r[r.Digit5=40]="Digit5",r[r.Digit6=41]="Digit6",r[r.Digit7=42]="Digit7",r[r.Digit8=43]="Digit8",r[r.Digit9=44]="Digit9",r[r.Digit0=45]="Digit0",r[r.Enter=46]="Enter",r[r.Escape=47]="Escape",r[r.Backspace=48]="Backspace",r[r.Tab=49]="Tab",r[r.Space=50]="Space",r[r.Minus=51]="Minus",r[r.Equal=52]="Equal",r[r.BracketLeft=53]="BracketLeft",r[r.BracketRight=54]="BracketRight",r[r.Backslash=55]="Backslash",r[r.IntlHash=56]="IntlHash",r[r.Semicolon=57]="Semicolon",r[r.Quote=58]="Quote",r[r.Backquote=59]="Backquote",r[r.Comma=60]="Comma",r[r.Period=61]="Period",r[r.Slash=62]="Slash",r[r.CapsLock=63]="CapsLock",r[r.F1=64]="F1",r[r.F2=65]="F2",r[r.F3=66]="F3",r[r.F4=67]="F4",r[r.F5=68]="F5",r[r.F6=69]="F6",r[r.F7=70]="F7",r[r.F8=71]="F8",r[r.F9=72]="F9",r[r.F10=73]="F10",r[r.F11=74]="F11",r[r.F12=75]="F12",r[r.PrintScreen=76]="PrintScreen",r[r.ScrollLock=77]="ScrollLock",r[r.Pause=78]="Pause",r[r.Insert=79]="Insert",r[r.Home=80]="Home",r[r.PageUp=81]="PageUp",r[r.Delete=82]="Delete",r[r.End=83]="End",r[r.PageDown=84]="PageDown",r[r.ArrowRight=85]="ArrowRight",r[r.ArrowLeft=86]="ArrowLeft",r[r.ArrowDown=87]="ArrowDown",r[r.ArrowUp=88]="ArrowUp",r[r.NumLock=89]="NumLock",r[r.NumpadDivide=90]="NumpadDivide",r[r.NumpadMultiply=91]="NumpadMultiply",r[r.NumpadSubtract=92]="NumpadSubtract",r[r.NumpadAdd=93]="NumpadAdd",r[r.NumpadEnter=94]="NumpadEnter",r[r.Numpad1=95]="Numpad1",r[r.Numpad2=96]="Numpad2",r[r.Numpad3=97]="Numpad3",r[r.Numpad4=98]="Numpad4",r[r.Numpad5=99]="Numpad5",r[r.Numpad6=100]="Numpad6",r[r.Numpad7=101]="Numpad7",r[r.Numpad8=102]="Numpad8",r[r.Numpad9=103]="Numpad9",r[r.Numpad0=104]="Numpad0",r[r.NumpadDecimal=105]="NumpadDecimal",r[r.IntlBackslash=106]="IntlBackslash",r[r.ContextMenu=107]="ContextMenu",r[r.Power=108]="Power",r[r.NumpadEqual=109]="NumpadEqual",r[r.F13=110]="F13",r[r.F14=111]="F14",r[r.F15=112]="F15",r[r.F16=113]="F16",r[r.F17=114]="F17",r[r.F18=115]="F18",r[r.F19=116]="F19",r[r.F20=117]="F20",r[r.F21=118]="F21",r[r.F22=119]="F22",r[r.F23=120]="F23",r[r.F24=121]="F24",r[r.Open=122]="Open",r[r.Help=123]="Help",r[r.Select=124]="Select",r[r.Again=125]="Again",r[r.Undo=126]="Undo",r[r.Cut=127]="Cut",r[r.Copy=128]="Copy",r[r.Paste=129]="Paste",r[r.Find=130]="Find",r[r.AudioVolumeMute=131]="AudioVolumeMute",r[r.AudioVolumeUp=132]="AudioVolumeUp",r[r.AudioVolumeDown=133]="AudioVolumeDown",r[r.NumpadComma=134]="NumpadComma",r[r.IntlRo=135]="IntlRo",r[r.KanaMode=136]="KanaMode",r[r.IntlYen=137]="IntlYen",r[r.Convert=138]="Convert",r[r.NonConvert=139]="NonConvert",r[r.Lang1=140]="Lang1",r[r.Lang2=141]="Lang2",r[r.Lang3=142]="Lang3",r[r.Lang4=143]="Lang4",r[r.Lang5=144]="Lang5",r[r.Abort=145]="Abort",r[r.Props=146]="Props",r[r.NumpadParenLeft=147]="NumpadParenLeft",r[r.NumpadParenRight=148]="NumpadParenRight",r[r.NumpadBackspace=149]="NumpadBackspace",r[r.NumpadMemoryStore=150]="NumpadMemoryStore",r[r.NumpadMemoryRecall=151]="NumpadMemoryRecall",r[r.NumpadMemoryClear=152]="NumpadMemoryClear",r[r.NumpadMemoryAdd=153]="NumpadMemoryAdd",r[r.NumpadMemorySubtract=154]="NumpadMemorySubtract",r[r.NumpadClear=155]="NumpadClear",r[r.NumpadClearEntry=156]="NumpadClearEntry",r[r.ControlLeft=157]="ControlLeft",r[r.ShiftLeft=158]="ShiftLeft",r[r.AltLeft=159]="AltLeft",r[r.MetaLeft=160]="MetaLeft",r[r.ControlRight=161]="ControlRight",r[r.ShiftRight=162]="ShiftRight",r[r.AltRight=163]="AltRight",r[r.MetaRight=164]="MetaRight",r[r.BrightnessUp=165]="BrightnessUp",r[r.BrightnessDown=166]="BrightnessDown",r[r.MediaPlay=167]="MediaPlay",r[r.MediaRecord=168]="MediaRecord",r[r.MediaFastForward=169]="MediaFastForward",r[r.MediaRewind=170]="MediaRewind",r[r.MediaTrackNext=171]="MediaTrackNext",r[r.MediaTrackPrevious=172]="MediaTrackPrevious",r[r.MediaStop=173]="MediaStop",r[r.Eject=174]="Eject",r[r.MediaPlayPause=175]="MediaPlayPause",r[r.MediaSelect=176]="MediaSelect",r[r.LaunchMail=177]="LaunchMail",r[r.LaunchApp2=178]="LaunchApp2",r[r.LaunchApp1=179]="LaunchApp1",r[r.SelectTask=180]="SelectTask",r[r.LaunchScreenSaver=181]="LaunchScreenSaver",r[r.BrowserSearch=182]="BrowserSearch",r[r.BrowserHome=183]="BrowserHome",r[r.BrowserBack=184]="BrowserBack",r[r.BrowserForward=185]="BrowserForward",r[r.BrowserStop=186]="BrowserStop",r[r.BrowserRefresh=187]="BrowserRefresh",r[r.BrowserFavorites=188]="BrowserFavorites",r[r.ZoomToggle=189]="ZoomToggle",r[r.MailReply=190]="MailReply",r[r.MailForward=191]="MailForward",r[r.MailSend=192]="MailSend",r[r.MAX_VALUE=193]="MAX_VALUE"})(m=e.ScanCode||(e.ScanCode={}));const R=[],L=Object.create(null),S=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:r=>S[r]||0,toEnum:r=>L[r]||0,toString:r=>R[r]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class P{constructor(w,p,n,b,I){this.ctrlKey=w,this.shiftKey=p,this.altKey=n,this.metaKey=b,this.scanCode=I}equals(w){return this.ctrlKey===w.ctrlKey&&this.shiftKey===w.shiftKey&&this.altKey===w.altKey&&this.metaKey===w.metaKey&&this.scanCode===w.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=P,function(){function r(w,p){R[w]=p,L[p]=w,S[p.toLowerCase()]=w}r(0,"None"),r(1,"Hyper"),r(2,"Super"),r(3,"Fn"),r(4,"FnLock"),r(5,"Suspend"),r(6,"Resume"),r(7,"Turbo"),r(8,"Sleep"),r(9,"WakeUp"),r(10,"KeyA"),r(11,"KeyB"),r(12,"KeyC"),r(13,"KeyD"),r(14,"KeyE"),r(15,"KeyF"),r(16,"KeyG"),r(17,"KeyH"),r(18,"KeyI"),r(19,"KeyJ"),r(20,"KeyK"),r(21,"KeyL"),r(22,"KeyM"),r(23,"KeyN"),r(24,"KeyO"),r(25,"KeyP"),r(26,"KeyQ"),r(27,"KeyR"),r(28,"KeyS"),r(29,"KeyT"),r(30,"KeyU"),r(31,"KeyV"),r(32,"KeyW"),r(33,"KeyX"),r(34,"KeyY"),r(35,"KeyZ"),r(36,"Digit1"),r(37,"Digit2"),r(38,"Digit3"),r(39,"Digit4"),r(40,"Digit5"),r(41,"Digit6"),r(42,"Digit7"),r(43,"Digit8"),r(44,"Digit9"),r(45,"Digit0"),r(46,"Enter"),r(47,"Escape"),r(48,"Backspace"),r(49,"Tab"),r(50,"Space"),r(51,"Minus"),r(52,"Equal"),r(53,"BracketLeft"),r(54,"BracketRight"),r(55,"Backslash"),r(56,"IntlHash"),r(57,"Semicolon"),r(58,"Quote"),r(59,"Backquote"),r(60,"Comma"),r(61,"Period"),r(62,"Slash"),r(63,"CapsLock"),r(64,"F1"),r(65,"F2"),r(66,"F3"),r(67,"F4"),r(68,"F5"),r(69,"F6"),r(70,"F7"),r(71,"F8"),r(72,"F9"),r(73,"F10"),r(74,"F11"),r(75,"F12"),r(76,"PrintScreen"),r(77,"ScrollLock"),r(78,"Pause"),r(79,"Insert"),r(80,"Home"),r(81,"PageUp"),r(82,"Delete"),r(83,"End"),r(84,"PageDown"),r(85,"ArrowRight"),r(86,"ArrowLeft"),r(87,"ArrowDown"),r(88,"ArrowUp"),r(89,"NumLock"),r(90,"NumpadDivide"),r(91,"NumpadMultiply"),r(92,"NumpadSubtract"),r(93,"NumpadAdd"),r(94,"NumpadEnter"),r(95,"Numpad1"),r(96,"Numpad2"),r(97,"Numpad3"),r(98,"Numpad4"),r(99,"Numpad5"),r(100,"Numpad6"),r(101,"Numpad7"),r(102,"Numpad8"),r(103,"Numpad9"),r(104,"Numpad0"),r(105,"NumpadDecimal"),r(106,"IntlBackslash"),r(107,"ContextMenu"),r(108,"Power"),r(109,"NumpadEqual"),r(110,"F13"),r(111,"F14"),r(112,"F15"),r(113,"F16"),r(114,"F17"),r(115,"F18"),r(116,"F19"),r(117,"F20"),r(118,"F21"),r(119,"F22"),r(120,"F23"),r(121,"F24"),r(122,"Open"),r(123,"Help"),r(124,"Select"),r(125,"Again"),r(126,"Undo"),r(127,"Cut"),r(128,"Copy"),r(129,"Paste"),r(130,"Find"),r(131,"AudioVolumeMute"),r(132,"AudioVolumeUp"),r(133,"AudioVolumeDown"),r(134,"NumpadComma"),r(135,"IntlRo"),r(136,"KanaMode"),r(137,"IntlYen"),r(138,"Convert"),r(139,"NonConvert"),r(140,"Lang1"),r(141,"Lang2"),r(142,"Lang3"),r(143,"Lang4"),r(144,"Lang5"),r(145,"Abort"),r(146,"Props"),r(147,"NumpadParenLeft"),r(148,"NumpadParenRight"),r(149,"NumpadBackspace"),r(150,"NumpadMemoryStore"),r(151,"NumpadMemoryRecall"),r(152,"NumpadMemoryClear"),r(153,"NumpadMemoryAdd"),r(154,"NumpadMemorySubtract"),r(155,"NumpadClear"),r(156,"NumpadClearEntry"),r(157,"ControlLeft"),r(158,"ShiftLeft"),r(159,"AltLeft"),r(160,"MetaLeft"),r(161,"ControlRight"),r(162,"ShiftRight"),r(163,"AltRight"),r(164,"MetaRight"),r(165,"BrightnessUp"),r(166,"BrightnessDown"),r(167,"MediaPlay"),r(168,"MediaRecord"),r(169,"MediaFastForward"),r(170,"MediaRewind"),r(171,"MediaTrackNext"),r(172,"MediaTrackPrevious"),r(173,"MediaStop"),r(174,"Eject"),r(175,"MediaPlayPause"),r(176,"MediaSelect"),r(177,"LaunchMail"),r(178,"LaunchApp2"),r(179,"LaunchApp1"),r(180,"SelectTask"),r(181,"LaunchScreenSaver"),r(182,"BrowserSearch"),r(183,"BrowserHome"),r(184,"BrowserBack"),r(185,"BrowserForward"),r(186,"BrowserStop"),r(187,"BrowserRefresh"),r(188,"BrowserFavorites"),r(189,"ZoomToggle"),r(190,"MailReply"),r(191,"MailForward"),r(192,"MailSend")}(),function(){for(let w=0;w<=193;w++)e.IMMUTABLE_CODE_TO_KEY_CODE[w]=-1;for(let w=0;w<=112;w++)e.IMMUTABLE_KEY_CODE_TO_CODE[w]=-1;function r(w,p){e.IMMUTABLE_CODE_TO_KEY_CODE[w]=p,p!==0&&p!==3&&p!==5&&p!==4&&p!==6&&p!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[p]=w)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,r(0,0),r(1,0),r(2,0),r(3,0),r(4,0),r(5,0),r(6,0),r(7,0),r(8,0),r(9,0),r(46,3),r(47,9),r(48,1),r(49,2),r(50,10),r(63,8),r(64,59),r(65,60),r(66,61),r(67,62),r(68,63),r(69,64),r(70,65),r(71,66),r(72,67),r(73,68),r(74,69),r(75,70),r(76,0),r(77,79),r(78,7),r(79,19),r(80,14),r(81,11),r(82,20),r(83,13),r(84,12),r(85,17),r(86,15),r(87,18),r(88,16),r(89,78),r(90,108),r(91,103),r(92,106),r(93,104),r(94,3),r(95,94),r(96,95),r(97,96),r(98,97),r(99,98),r(100,99),r(101,100),r(102,101),r(103,102),r(104,93),r(105,107),r(107,58),r(108,0),r(109,0),r(110,71),r(111,72),r(112,73),r(113,74),r(114,75),r(115,76),r(116,77),r(117,0),r(118,0),r(119,0),r(120,0),r(121,0),r(122,0),r(123,0),r(124,0),r(125,0),r(126,0),r(127,0),r(128,0),r(129,0),r(130,0),r(131,0),r(132,0),r(133,0),r(134,105),r(136,0),r(138,0),r(139,0),r(140,0),r(141,0),r(142,0),r(143,0),r(144,0),r(145,0),r(146,0),r(147,0),r(148,0),r(149,0),r(150,0),r(151,0),r(152,0),r(153,0),r(154,0),r(155,0),r(156,0),r(157,5),r(158,4),r(159,6),r(160,57),r(161,5),r(162,4),r(163,6),r(164,57),r(165,0),r(166,0),r(167,0),r(168,0),r(169,0),r(170,0),r(171,0),r(172,0),r(173,0),r(174,0),r(175,0),r(176,0),r(177,0),r(178,0),r(179,0),r(180,0),r(181,0),r(182,0),r(183,0),r(184,0),r(185,0),r(186,0),r(187,0),r(188,0),r(189,0),r(190,0),r(191,0),r(192,0)}()}),define(Q[105],J([0,1,57,79]),function(j,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class L{static _readModifiers(P){P=P.toLowerCase().trim();let r=!1,w=!1,p=!1,n=!1,b;do b=!1,/^ctrl(\+|\-)/.test(P)&&(r=!0,P=P.substr("ctrl-".length),b=!0),/^shift(\+|\-)/.test(P)&&(w=!0,P=P.substr("shift-".length),b=!0),/^alt(\+|\-)/.test(P)&&(p=!0,P=P.substr("alt-".length),b=!0),/^meta(\+|\-)/.test(P)&&(n=!0,P=P.substr("meta-".length),b=!0),/^win(\+|\-)/.test(P)&&(n=!0,P=P.substr("win-".length),b=!0),/^cmd(\+|\-)/.test(P)&&(n=!0,P=P.substr("cmd-".length),b=!0);while(b);let I;const y=P.indexOf(" ");return y>0?(I=P.substring(0,y),P=P.substring(y)):(I=P,P=""),{remains:P,ctrl:r,shift:w,alt:p,meta:n,key:I}}static parseSimpleKeybinding(P){const r=this._readModifiers(P),w=m.KeyCodeUtils.fromUserSettings(r.key);return[new m.SimpleKeybinding(r.ctrl,r.shift,r.alt,r.meta,w),r.remains]}static parseKeybinding(P,r){if(!P)return null;const w=[];let p;do[p,P]=this.parseSimpleKeybinding(P),w.push(p);while(P.length>0);return new m.ChordKeybinding(w)}static parseSimpleUserBinding(P){const r=this._readModifiers(P),w=r.key.match(/^\[([^\]]+)\]$/);if(w){const n=w[1],b=R.ScanCodeUtils.lowerCaseToEnum(n);return[new R.ScanCodeBinding(r.ctrl,r.shift,r.alt,r.meta,b),r.remains]}const p=m.KeyCodeUtils.fromUserSettings(r.key);return[new m.SimpleKeybinding(r.ctrl,r.shift,r.alt,r.meta,p),r.remains]}static parseUserBinding(P){if(!P)return[];const r=[];let w;for(;P.length>0;)[w,P]=this.parseSimpleUserBinding(P),r.push(w);return r}}e.KeybindingParser=L}),define(Q[106],J([0,1,3]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=m.globals.performance&&typeof m.globals.performance.now=="function";class L{constructor(P){this._highResolution=R&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new L(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=L}),define(Q[5],J([0,1,18,42,2,78,106]),function(j,e,m,R,L,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var r;(function(E){E.None=()=>L.Disposable.None;function o(N){return(B,C=null,z)=>{let V=!1,_;return _=N(A=>{if(!V)return _?_.dispose():V=!0,B.call(C,A)},null,z),V&&_.dispose(),_}}E.once=o;function u(N,B){return a((C,z=null,V)=>N(_=>C.call(z,B(_)),null,V))}E.map=u;function l(N,B){return a((C,z=null,V)=>N(_=>{B(_),C.call(z,_)},null,V))}E.forEach=l;function c(N,B){return a((C,z=null,V)=>N(_=>B(_)&&C.call(z,_),null,V))}E.filter=c;function t(N){return N}E.signal=t;function i(...N){return(B,C=null,z)=>(0,L.combinedDisposable)(...N.map(V=>V(_=>B.call(C,_),null,z)))}E.any=i;function s(N,B,C){let z=C;return u(N,V=>(z=B(z,V),z))}E.reduce=s;function a(N){let B;const C=new I({onFirstListenerAdd(){B=N(C.fire,C)},onLastListenerRemove(){B.dispose()}});return C.event}E.snapshot=a;function h(N,B,C=100,z=!1,V){let _,A,O,k=0;const F=new I({leakWarningThreshold:V,onFirstListenerAdd(){_=N(U=>{k++,A=B(A,U),z&&!O&&(F.fire(A),A=void 0),clearTimeout(O),O=setTimeout(()=>{const K=A;A=void 0,O=void 0,(!z||k>1)&&F.fire(K),k=0},C)})},onLastListenerRemove(){_.dispose()}});return F.event}E.debounce=h;function f(N){const B=new Date().getTime();return u(o(N),C=>new Date().getTime()-B)}E.stopwatch=f;function v(N,B=(C,z)=>C===z){let C=!0,z;return c(N,V=>{const _=C||!B(V,z);return C=!1,z=V,_})}E.latch=v;function D(N,B){return[E.filter(N,B),E.filter(N,C=>!B(C))]}E.split=D;function T(N,B=!1,C=[]){let z=C.slice(),V=N(O=>{z?z.push(O):A.fire(O)});const _=()=>{z&&z.forEach(O=>A.fire(O)),z=null},A=new I({onFirstListenerAdd(){V||(V=N(O=>A.fire(O)))},onFirstListenerDidAdd(){z&&(B?setTimeout(_):_())},onLastListenerRemove(){V&&V.dispose(),V=null}});return A.event}E.buffer=T;class W{constructor(B){this.event=B}map(B){return new W(u(this.event,B))}forEach(B){return new W(l(this.event,B))}filter(B){return new W(c(this.event,B))}reduce(B,C){return new W(s(this.event,B,C))}latch(){return new W(v(this.event))}debounce(B,C=100,z=!1,V){return new W(h(this.event,B,C,z,V))}on(B,C,z){return this.event(B,C,z)}once(B,C,z){return o(this.event)(B,C,z)}}function $(N){return new W(N)}E.chain=$;function X(N,B,C=z=>z){const z=(...O)=>A.fire(C(...O)),V=()=>N.on(B,z),_=()=>N.removeListener(B,z),A=new I({onFirstListenerAdd:V,onLastListenerRemove:_});return A.event}E.fromNodeEventEmitter=X;function x(N,B,C=z=>z){const z=(...O)=>A.fire(C(...O)),V=()=>N.addEventListener(B,z),_=()=>N.removeEventListener(B,z),A=new I({onFirstListenerAdd:V,onLastListenerRemove:_});return A.event}E.fromDOMEventEmitter=x;function oe(N){const B=new I;let C=!1;return N.then(void 0,()=>null).then(()=>{C?B.fire(void 0):setTimeout(()=>B.fire(void 0),0)}),C=!0,B.event}E.fromPromise=oe;function q(N){return new Promise(B=>o(N)(B))}E.toPromise=q})(r=e.Event||(e.Event={}));class w{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${w._idPool++}`}start(o){this._stopWatch=new P.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}w._idPool=0;let p=-1;function n(E){const o=p;return p=E,{dispose(){p=o}}}e.setGlobalLeakWarningThreshold=n;class b{constructor(o,u=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let u=p;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),!(u<=0||o<u)){this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),c=this._stacks.get(l)||0;if(this._stacks.set(l,c+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let t,i=0;for(const[s,a]of this._stacks)(!t||i<a)&&(t=s,i=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(l)||0;this._stacks.set(l,t-1)}}}}class I{constructor(o){var u;this._disposed=!1,this._options=o,this._leakageMon=p>0?new b(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((u=this._options)===null||u===void 0?void 0:u._profName)?new w(this._options._profName):void 0}get event(){return this._event||(this._event=(o,u,l)=>{var c;this._listeners||(this._listeners=new S.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(u?[o,u]:o);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,u);const s=(c=this._leakageMon)===null||c===void 0?void 0:c.check(this._listeners.size);let a;return a={dispose:()=>{s&&s(),a.dispose=I._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof L.DisposableStore?l.add(a):Array.isArray(l)&&l.push(a),a}),this._event}fire(o){var u,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let c of this._listeners)this._deliveryQueue.push([c,o]);for((u=this._perfMon)===null||u===void 0||u.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[c,t]=this._deliveryQueue.shift();try{typeof c=="function"?c.call(void 0,t):c[0].call(c[1],t)}catch(i){(0,m.onUnexpectedError)(i)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var o,u,l,c;(o=this._listeners)===null||o===void 0||o.clear(),(u=this._deliveryQueue)===null||u===void 0||u.clear(),((l=this._options)===null||l===void 0?void 0:l.onLastListenerRemove)&&this._options.onLastListenerRemove(),(c=this._leakageMon)===null||c===void 0||c.dispose(),this._disposed=!0}}e.Emitter=I,I._noop=function(){};class y extends I{constructor(o){super(o);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=o==null?void 0:o.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=y;class d{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new I({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const u={event:o,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const l=()=>{this.hasListeners&&this.unhook(u);const c=this.events.indexOf(u);this.events.splice(c,1)};return(0,L.toDisposable)((0,R.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(u=>this.emitter.fire(u))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=d;class g{constructor(){this.buffers=[]}wrapEvent(o){return(u,l,c)=>o(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>u.call(l,t)):u.call(l,t)},void 0,c)}bufferEvents(o){const u=[];this.buffers.push(u);const l=o();return this.buffers.pop(),u.forEach(c=>c()),l}}e.EventBufferer=g;class M{constructor(){this.listening=!1,this.inputEvent=r.None,this.inputEventListener=L.Disposable.None,this.emitter=new I({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=M}),define(Q[26],J([0,1,5]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(r,w){const p=setTimeout(r.bind(w),0);return{dispose(){clearTimeout(p)}}});var L;(function(r){function w(p){return p===r.None||p===r.Cancelled||p instanceof S?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}r.isCancellationToken=w,r.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),r.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(L=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=L.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=P}),define(Q[107],J([0,1,5]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(b){const I=this._icons.get(b.id);I?b.description?I.description=b.description:console.error(`Duplicate registration of codicon ${b.id}`):(this._icons.set(b.id,b),this._onDidRegister.fire(b))}get(b){return this._icons.get(b)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const L=new R;e.iconRegistry=L;function S(n,b){return new r(n,b)}e.registerCodicon=S;function P(n){return n?n.replace(/\$\((.*?)\)/g,(b,I)=>` ${I} `).trim():""}e.getCodiconAriaLabel=P;class r{constructor(b,I,y){this.id=b,this.definition=I,this.description=y,L.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=r;function w(n,b){const I=["codicon","codicon-"+n];return b&&I.push("codicon-modifier-"+b),I}e.getClassNamesArray=w;var p;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const b=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function I(g){if(g instanceof r)return["codicon","codicon-"+g.id];const M=b.exec(g.id);if(!M)return I(r.error);let[,E,o]=M;const u=["codicon","codicon-"+E];return o&&u.push("codicon-modifier-"+o.substr(1)),u}n.asClassNameArray=I;function y(g){return I(g).join(" ")}n.asClassName=y;function d(g){return"."+I(g).join(".")}n.asCSSSelector=d})(p=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(r=e.Codicon||(e.Codicon={}))}),define(Q[64],J([0,1,18,2]),function(j,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(u){const l=u;return l?[l.on,l.pause,l.resume,l.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=L;function S(u){const l=u;return l?L(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=S;function P(u,l){return new r(u,l)}e.newWriteableStream=P;class r{constructor(l,c){this.reducer=l,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){var c;if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof((c=this.options)===null||c===void 0?void 0:c.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(c=>c(l))}emitError(l){this.listeners.error.length===0?(0,m.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(c=>c(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,c){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(l,c){if(!this.state.destroyed){let t;switch(l){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(c);i>=0&&t.splice(i,1)}}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(u,l){const c=[];let t;for(;(t=u.read())!==null;)c.push(t);return l(c)}e.consumeReadable=w;function p(u,l,c){const t=[];let i;for(;(i=u.read())!==null&&t.length<c;)t.push(i);return i===null&&t.length>0?l(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const s=i;return i=void 0,s}return u.read()}}}e.peekReadable=p;function n(u,l){return new Promise((c,t)=>{const i=[];b(u,{onData:s=>{l&&i.push(s)},onError:s=>{l?t(s):c(void 0)},onEnd:()=>{c(l?l(i):void 0)}})})}e.consumeStream=n;function b(u,l){u.on("error",c=>l.onError(c)),u.on("end",()=>l.onEnd()),u.on("data",c=>l.onData(c))}e.listenStream=b;function I(u,l){return new Promise((c,t)=>{const i=new R.DisposableStore,s=[],a=v=>{if(s.push(v),s.length>l)return i.dispose(),u.pause(),c({stream:u,buffer:s,ended:!1})},h=v=>t(v),f=()=>c({stream:u,buffer:s,ended:!0});i.add((0,R.toDisposable)(()=>u.removeListener("error",h))),u.on("error",h),i.add((0,R.toDisposable)(()=>u.removeListener("end",f))),u.on("end",f),i.add((0,R.toDisposable)(()=>u.removeListener("data",a))),u.on("data",a)})}e.peekStream=I;function y(u,l){const c=P(l);return c.end(u),c}e.toStream=y;function d(){const u=P(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=d;function g(u){let l=!1;return{read:()=>l?null:(l=!0,u)}}e.toReadable=g;function M(u,l,c){const t=P(c);return b(u,{onData:i=>t.write(l.data(i)),onError:i=>t.error(l.error?l.error(i):i),onEnd:()=>t.end()}),t}e.transform=M;function E(u,l,c){let t=!1;return{read:()=>{const i=l.read();return t?i:(t=!0,i!==null?c([u,i]):u)}}}e.prefixedReadable=E;function o(u,l,c){let t=!1;const i=P(c);return b(l,{onData:s=>t?i.write(s):(t=!0,i.write(c([u,s]))),onError:s=>i.error(s),onEnd:()=>{t||(t=!0,i.write(u)),i.end()}}),i}e.prefixedStream=o}),define(Q[23],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function m(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=m;const R=/{(\d+)}/g;function L(H,...ie){return ie.length===0?H:H.replace(R,function(ae,ce){const de=parseInt(ce,10);return isNaN(de)||de<0||de>=ie.length?ae:ie[de]})}e.format=L;function S(H){return H.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=S;function P(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function r(H,ie){let ae=0;const ce=ie.charCodeAt(0);for(let de=H.length-1;de>=0;de--)H.charCodeAt(de)===ce&&ae++;return ae}e.count=r;function w(H,ie,ae="\u2026"){return H.length<=ie?H:`${H.substr(0,ie)}${ae}`}e.truncate=w;function p(H,ie=" "){const ae=n(H,ie);return b(ae,ie)}e.trim=p;function n(H,ie){if(!H||!ie)return H;const ae=ie.length;if(ae===0||H.length===0)return H;let ce=0;for(;H.indexOf(ie,ce)===ce;)ce=ce+ae;return H.substring(ce)}e.ltrim=n;function b(H,ie){if(!H||!ie)return H;const ae=ie.length,ce=H.length;if(ae===0||ce===0)return H;let de=ce,be=-1;for(;be=H.lastIndexOf(ie,de-1),!(be===-1||be+ae!==de);){if(be===0)return"";de=be}return H.substring(0,de)}e.rtrim=b;function I(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=I;function y(H){return H.replace(/\*/g,"")}e.stripWildcards=y;function d(H,ie,ae={}){if(!H)throw new Error("Cannot create regex from empty string");ie||(H=P(H)),ae.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let ce="";return ae.global&&(ce+="g"),ae.matchCase||(ce+="i"),ae.multiline&&(ce+="m"),ae.unicode&&(ce+="u"),new RegExp(H,ce)}e.createRegExp=d;function g(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=g;function M(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=M;function E(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=E;function o(H){return H.split(/\r\n|\r|\n/)}e.splitLines=o;function u(H){for(let ie=0,ae=H.length;ie<ae;ie++){const ce=H.charCodeAt(ie);if(ce!==32&&ce!==9)return ie}return-1}e.firstNonWhitespaceIndex=u;function l(H,ie=0,ae=H.length){for(let ce=ie;ce<ae;ce++){const de=H.charCodeAt(ce);if(de!==32&&de!==9)return H.substring(ie,ce)}return H.substring(ie,ae)}e.getLeadingWhitespace=l;function c(H,ie=H.length-1){for(let ae=ie;ae>=0;ae--){const ce=H.charCodeAt(ae);if(ce!==32&&ce!==9)return ae}return-1}e.lastNonWhitespaceIndex=c;function t(H,ie){return H<ie?-1:H>ie?1:0}e.compare=t;function i(H,ie,ae=0,ce=H.length,de=0,be=ie.length){for(;ae<ce&&de<be;ae++,de++){let We=H.charCodeAt(ae),Be=ie.charCodeAt(de);if(We<Be)return-1;if(We>Be)return 1}const Me=ce-ae,Te=be-de;return Me<Te?-1:Me>Te?1:0}e.compareSubstring=i;function s(H,ie){return a(H,ie,0,H.length,0,ie.length)}e.compareIgnoreCase=s;function a(H,ie,ae=0,ce=H.length,de=0,be=ie.length){for(;ae<ce&&de<be;ae++,de++){let We=H.charCodeAt(ae),Be=ie.charCodeAt(de);if(We!==Be){const he=We-Be;if(!(he===32&&f(Be))&&!(he===-32&&f(We)))return h(We)&&h(Be)?he:i(H.toLowerCase(),ie.toLowerCase(),ae,ce,de,be)}}const Me=ce-ae,Te=be-de;return Me<Te?-1:Me>Te?1:0}e.compareSubstringIgnoreCase=a;function h(H){return H>=97&&H<=122}e.isLowerAsciiLetter=h;function f(H){return H>=65&&H<=90}e.isUpperAsciiLetter=f;function v(H){return h(H)||f(H)}function D(H,ie){return H.length===ie.length&&T(H,ie)}e.equalsIgnoreCase=D;function T(H,ie,ae=H.length){for(let ce=0;ce<ae;ce++){const de=H.charCodeAt(ce),be=ie.charCodeAt(ce);if(de!==be){if(v(de)&&v(be)){const Me=Math.abs(de-be);if(Me!==0&&Me!==32)return!1}else if(String.fromCharCode(de).toLowerCase()!==String.fromCharCode(be).toLowerCase())return!1}}return!0}function W(H,ie){const ae=ie.length;return ie.length>H.length?!1:T(H,ie,ae)}e.startsWithIgnoreCase=W;function $(H,ie){let ae,ce=Math.min(H.length,ie.length);for(ae=0;ae<ce;ae++)if(H.charCodeAt(ae)!==ie.charCodeAt(ae))return ae;return ce}e.commonPrefixLength=$;function X(H,ie){let ae,ce=Math.min(H.length,ie.length);const de=H.length-1,be=ie.length-1;for(ae=0;ae<ce;ae++)if(H.charCodeAt(de-ae)!==ie.charCodeAt(be-ae))return ae;return ce}e.commonSuffixLength=X;function x(H){return 55296<=H&&H<=56319}e.isHighSurrogate=x;function oe(H){return 56320<=H&&H<=57343}e.isLowSurrogate=oe;function q(H,ie){return(H-55296<<10)+(ie-56320)+65536}e.computeCodePoint=q;function N(H,ie,ae){const ce=H.charCodeAt(ae);if(x(ce)&&ae+1<ie){const de=H.charCodeAt(ae+1);if(oe(de))return q(ce,de)}return ce}e.getNextCodePoint=N;function B(H,ie){const ae=H.charCodeAt(ie-1);if(oe(ae)&&ie>1){const ce=H.charCodeAt(ie-2);if(x(ce))return q(ce,ae)}return ae}function C(H,ie){const ae=ze.getInstance(),ce=ie,de=H.length,be=N(H,de,ie);ie+=be>=65536?2:1;let Me=ae.getGraphemeBreakType(be);for(;ie<de;){const Te=N(H,de,ie),We=ae.getGraphemeBreakType(Te);if(Ve(Me,We))break;ie+=Te>=65536?2:1,Me=We}return ie-ce}e.nextCharLength=C;function z(H,ie){const ae=ze.getInstance(),ce=ie,de=B(H,ie);ie-=de>=65536?2:1;let be=ae.getGraphemeBreakType(de);for(;ie>0;){const Me=B(H,ie),Te=ae.getGraphemeBreakType(Me);if(Ve(Te,be))break;ie-=Me>=65536?2:1,be=Te}return ce-ie}e.prevCharLength=z;function V(H,ie){const ae=ze.getInstance(),ce=H.length,de=ie,be=N(H,ce,ie),Me=ae.getGraphemeBreakType(be);ie+=be>=65536?2:1;let Te=Me;for(;ie<ce;){const Be=N(H,ce,ie),he=ae.getGraphemeBreakType(Be);if(Ve(Te,he))break;ie+=Be>=65536?2:1,Te=he}const We=ie;for(ie=de,Te=Me;ie>0;){const Be=B(H,ie),he=ae.getGraphemeBreakType(Be);if(Ve(he,Te))break;ie-=Be>=65536?2:1,Te=he}return[ie,We]}function _(H,ie){return ie>0&&oe(H.charCodeAt(ie))?V(H,ie-1):V(H,ie)}e.getCharContainingOffset=_;function A(H){const ie=H.length;let ae=0,ce=0;for(;ce<ie;){const Me=N(H,ie,ce);ce+=Me>=65536?2:1,Me<128?ae+=1:Me<2048?ae+=2:Me<65536?ae+=3:ae+=4}const de=new Uint8Array(ae);ce=0;let be=0;for(;ce<ie;){const Me=N(H,ie,ce);ce+=Me>=65536?2:1,Me<128?de[be++]=Me:Me<2048?(de[be++]=192|(Me&1984)>>>6,de[be++]=128|(Me&63)>>>0):Me<65536?(de[be++]=224|(Me&61440)>>>12,de[be++]=128|(Me&4032)>>>6,de[be++]=128|(Me&63)>>>0):(de[be++]=240|(Me&1835008)>>>18,de[be++]=128|(Me&258048)>>>12,de[be++]=128|(Me&4032)>>>6,de[be++]=128|(Me&63)>>>0)}return de}e.encodeUTF8=A;function O(H){const ie=H.byteLength,ae=[];let ce=0;for(;ce<ie;){const de=H[ce];let be;if(de>=240&&ce+3<ie?be=(H[ce++]&7)<<18>>>0|(H[ce++]&63)<<12>>>0|(H[ce++]&63)<<6>>>0|(H[ce++]&63)<<0>>>0:de>=224&&ce+2<ie?be=(H[ce++]&15)<<12>>>0|(H[ce++]&63)<<6>>>0|(H[ce++]&63)<<0>>>0:de>=192&&ce+1<ie?be=(H[ce++]&31)<<6>>>0|(H[ce++]&63)<<0>>>0:be=H[ce++],be>=0&&be<=55295||be>=57344&&be<=65535)ae.push(String.fromCharCode(be));else if(be>=65536&&be<=1114111){const Me=be-65536,Te=55296+((Me&1047552)>>>10),We=56320+((Me&1023)>>>0);ae.push(String.fromCharCode(Te)),ae.push(String.fromCharCode(We))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=O;const k=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function F(H){return k.test(H)}e.containsRTL=F;const U=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function K(H){return U.test(H)}e.containsEmoji=K;const G=/^[\t\n\r\x20-\x7E]*$/;function Y(H){return G.test(H)}e.isBasicASCII=Y,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=Z;function ne(H){for(let ie=0,ae=H.length;ie<ae;ie++)if(se(H.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=ne;function se(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=se;function re(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=re;function te(H,ie){if(H.length<ie)return H;const ae=/\b/g;let ce=0;for(;ae.test(H)&&!(H.length-ae.lastIndex<ie);)ce=ae.lastIndex,ae.lastIndex+=1;return H.substring(ce).replace(/^\s/,"")}e.lcut=te;const le=/\x1B\x5B[12]?K/g,ve=/\x1b\[\d+m/g,we=/\x1b\[0?m/g;function Se(H){return H&&(H=H.replace(le,""),H=H.replace(ve,""),H=H.replace(we,"")),H}e.removeAnsiEscapeCodes=Se,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ae(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ae;function ye(H){return Ae(H)?H.substr(1):H}e.stripUTF8BOM=ye;function me(H,ie){if(!H||!ie||H.length<ie.length)return!1;const ae=ie.length,ce=H.toLowerCase();let de=0,be=-1;for(;de<ae;){const Me=ce.indexOf(ie[de],be+1);if(Me<0)return!1;be=Me,de++}return!0}e.fuzzyContains=me;function Ie(H,ie=!1){return H?(ie&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=Ie;function Re(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=Re;function Fe(H,ie=1){if(ie===0)return"";let ae=-1;do ae=H.indexOf(`
`,ae+1),ie--;while(ie>0&&ae>=0);return ae===-1?H:(H[ae-1]==="\r"&&ae--,H.substr(0,ae))}e.getNLines=Fe;function Ne(H){const ie=90-65+1;return H=H%(2*ie),H<ie?String.fromCharCode(97+H):String.fromCharCode(65+H-ie)}e.singleLetterHash=Ne;function qe(H){return ze.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=qe;function Ve(H,ie){return H===0?ie!==5&&ie!==7:H===2&&ie===3?!1:H===4||H===2||H===3||ie===4||ie===2||ie===3?!0:!(H===8&&(ie===8||ie===9||ie===11||ie===12)||(H===11||H===9)&&(ie===9||ie===10)||(H===12||H===10)&&ie===10||ie===5||ie===13||ie===7||H===1||H===13&&ie===14||H===6&&ie===6)}e.breakBetweenGraphemeBreakType=Ve;var tt;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(tt=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=at()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const ae=this._data,ce=ae.length/3;let de=1;for(;de<=ce;)if(ie<ae[3*de])de=2*de;else if(ie>ae[3*de+1])de=2*de+1;else return ae[3*de+2];return 0}}ze._INSTANCE=null;function at(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function it(H,ie){if(H===0)return 0;const ae=dt(H,ie);if(ae!==void 0)return ae;const ce=B(ie,H);return H-=Ge(ce),H}e.getLeftDeleteOffset=it;function dt(H,ie){let ae=B(ie,H);for(H-=Ge(ae);ft(ae)||ae===65039||ae===8419;){if(H===0)return;ae=B(ie,H),H-=Ge(ae)}if(!!re(ae)){if(H>=0){const ce=B(ie,H);ce===8205&&(H-=Ge(ce))}return H}}function Ge(H){return H>=65536?2:1}function ft(H){return 127995<=H&&H<=127999}var lt;(function(H){H[H.zwj=8205]="zwj",H[H.emojiVariantSelector=65039]="emojiVariantSelector",H[H.enclosingKeyCap=8419]="enclosingKeyCap"})(lt||(lt={}))}),define(Q[19],J([0,1,23,64]),function(j,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined",S=typeof TextEncoder!="undefined",P=typeof TextDecoder!="undefined";let r,w;class p{constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}static alloc(v){return L?new p(Buffer.allocUnsafe(v)):new p(new Uint8Array(v))}static wrap(v){return L&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new p(v)}static fromString(v,D){return!((D==null?void 0:D.dontUseNodeBuffer)||!1)&&L?new p(Buffer.from(v)):S?(r||(r=new TextEncoder),new p(r.encode(v))):new p(m.encodeUTF8(v))}static concat(v,D){if(typeof D=="undefined"){D=0;for(let $=0,X=v.length;$<X;$++)D+=v[$].byteLength}const T=p.alloc(D);let W=0;for(let $=0,X=v.length;$<X;$++){const x=v[$];T.set(x,W),W+=x.byteLength}return T}toString(){return L?this.buffer.toString():P?(w||(w=new TextDecoder),w.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(v,D){return new p(this.buffer.subarray(v,D))}set(v,D){v instanceof p?this.buffer.set(v.buffer,D):this.buffer.set(v,D)}readUInt32BE(v){return I(this.buffer,v)}writeUInt32BE(v,D){y(this.buffer,v,D)}readUInt32LE(v){return d(this.buffer,v)}writeUInt32LE(v,D){g(this.buffer,v,D)}readUInt8(v){return M(this.buffer,v)}writeUInt8(v,D){E(this.buffer,v,D)}}e.VSBuffer=p;function n(f,v){return f[v+0]<<0>>>0|f[v+1]<<8>>>0}e.readUInt16LE=n;function b(f,v,D){f[D+0]=v&255,v=v>>>8,f[D+1]=v&255}e.writeUInt16LE=b;function I(f,v){return f[v]*2**24+f[v+1]*2**16+f[v+2]*2**8+f[v+3]}e.readUInt32BE=I;function y(f,v,D){f[D+3]=v,v=v>>>8,f[D+2]=v,v=v>>>8,f[D+1]=v,v=v>>>8,f[D]=v}e.writeUInt32BE=y;function d(f,v){return f[v+0]<<0>>>0|f[v+1]<<8>>>0|f[v+2]<<16>>>0|f[v+3]<<24>>>0}e.readUInt32LE=d;function g(f,v,D){f[D+0]=v&255,v=v>>>8,f[D+1]=v&255,v=v>>>8,f[D+2]=v&255,v=v>>>8,f[D+3]=v&255}e.writeUInt32LE=g;function M(f,v){return f[v]}e.readUInt8=M;function E(f,v,D){f[D]=v}e.writeUInt8=E;function o(f){return R.consumeReadable(f,v=>p.concat(v))}e.readableToBuffer=o;function u(f){return R.toReadable(f)}e.bufferToReadable=u;function l(f){return R.consumeStream(f,v=>p.concat(v))}e.streamToBuffer=l;async function c(f){return f.ended?p.concat(f.buffer):p.concat([...f.buffer,await l(f.stream)])}e.bufferedStreamToBuffer=c;function t(f){return R.toStream(f,v=>p.concat(v))}e.bufferToStream=t;function i(f){return R.transform(f,{data:v=>typeof v=="string"?p.fromString(v):p.wrap(v)},v=>p.concat(v))}e.streamToBufferReadableStream=i;function s(f){return R.newWriteableStream(v=>p.concat(v),f)}e.newWriteableBufferStream=s;function a(f,v){return R.prefixedReadable(f,v,D=>p.concat(D))}e.prefixedBufferReadable=a;function h(f,v){return R.prefixedStream(f,v,D=>p.concat(D))}e.prefixedBufferStream=h}),define(Q[80],J([0,1,23]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(E){return L(E,0)}e.hash=R;function L(E,o){switch(typeof E){case"object":return E===null?S(349,o):Array.isArray(E)?w(E,o):p(E,o);case"string":return r(E,o);case"boolean":return P(E,o);case"number":return S(E,o);case"undefined":return S(937,o);default:return S(617,o)}}e.doHash=L;function S(E,o){return(o<<5)-o+E|0}function P(E,o){return S(E?433:863,o)}function r(E,o){o=S(149417,o);for(let u=0,l=E.length;u<l;u++)o=S(E.charCodeAt(u),o);return o}e.stringHash=r;function w(E,o){return o=S(104579,o),E.reduce((u,l)=>L(l,u),o)}function p(E,o){return o=S(181387,o),Object.keys(E).sort().reduce((u,l)=>(u=r(l,u),L(E[l],u)),o)}class n{constructor(){this._value=0}get value(){return this._value}hash(o){return this._value=L(o,this._value),this._value}}e.Hasher=n;var b;(function(E){E[E.BLOCK_SIZE=64]="BLOCK_SIZE",E[E.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function I(E,o,u=32){const l=u-o,c=~((1<<l)-1);return(E<<o|(c&E)>>>l)>>>0}function y(E,o=0,u=E.byteLength,l=0){for(let c=0;c<u;c++)E[o+c]=l}function d(E,o,u="0"){for(;E.length<o;)E=u+E;return E}function g(E,o=32){return E instanceof ArrayBuffer?Array.from(new Uint8Array(E)).map(u=>u.toString(16).padStart(2,"0")).join(""):d((E>>>0).toString(16),o/4)}e.toHexString=g;class M{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(o){const u=o.length;if(u!==0){const l=this._buff;let c=this._buffLen,t=this._leftoverHighSurrogate,i,s;for(t!==0?(i=t,s=-1,t=0):(i=o.charCodeAt(0),s=0);;){let a=i;if(m.isHighSurrogate(i))if(s+1<u){const h=o.charCodeAt(s+1);m.isLowSurrogate(h)?(s++,a=m.computeCodePoint(i,h)):a=65533}else{t=i;break}else m.isLowSurrogate(i)&&(a=65533);if(c=this._push(l,c,a),s++,s<u)i=o.charCodeAt(s);else break}this._buffLen=c,this._leftoverHighSurrogate=t}}_push(o,u,l){return l<128?o[u++]=l:l<2048?(o[u++]=192|(l&1984)>>>6,o[u++]=128|(l&63)>>>0):l<65536?(o[u++]=224|(l&61440)>>>12,o[u++]=128|(l&4032)>>>6,o[u++]=128|(l&63)>>>0):(o[u++]=240|(l&1835008)>>>18,o[u++]=128|(l&258048)>>>12,o[u++]=128|(l&4032)>>>6,o[u++]=128|(l&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,o[0]=o[64+0],o[1]=o[64+1],o[2]=o[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const o=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(o/4294967296),!1),this._buffDV.setUint32(60,o%4294967296,!1),this._step()}_step(){const o=M._bigBlock32,u=this._buffDV;for(let v=0;v<64;v+=4)o.setUint32(v,u.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)o.setUint32(v,I(o.getUint32(v-12,!1)^o.getUint32(v-32,!1)^o.getUint32(v-56,!1)^o.getUint32(v-64,!1),1),!1);let l=this._h0,c=this._h1,t=this._h2,i=this._h3,s=this._h4,a,h,f;for(let v=0;v<80;v++)v<20?(a=c&t|~c&i,h=1518500249):v<40?(a=c^t^i,h=1859775393):v<60?(a=c&t|c&i|t&i,h=2400959708):(a=c^t^i,h=3395469782),f=I(l,5)+a+s+h+o.getUint32(v*4,!1)&4294967295,s=i,i=t,t=I(c,30),c=l,l=f;this._h0=this._h0+l&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=M,M._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[13],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(v){return Array.isArray(v)}e.isArray=m;function R(v){return typeof v=="string"}e.isString=R;function L(v){return Array.isArray(v)&&v.every(D=>R(D))}e.isStringArray=L;function S(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}e.isObject=S;function P(v){return typeof v=="number"&&!isNaN(v)}e.isNumber=P;function r(v){return!!v&&typeof v[Symbol.iterator]=="function"}e.isIterable=r;function w(v){return v===!0||v===!1}e.isBoolean=w;function p(v){return typeof v=="undefined"}e.isUndefined=p;function n(v){return!b(v)}e.isDefined=n;function b(v){return p(v)||v===null}e.isUndefinedOrNull=b;function I(v,D){if(!v)throw new Error(D?`Unexpected type, expected '${D}'`:"Unexpected type")}e.assertType=I;function y(v){if(b(v))throw new Error("Assertion Failed: argument is undefined or null");return v}e.assertIsDefined=y;function d(...v){const D=[];for(let T=0;T<v.length;T++){const W=v[T];if(b(W))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);D.push(W)}return D}e.assertAllDefined=d;const g=Object.prototype.hasOwnProperty;function M(v){if(!S(v))return!1;for(let D in v)if(g.call(v,D))return!1;return!0}e.isEmptyObject=M;function E(v){return typeof v=="function"}e.isFunction=E;function o(...v){return v.length>0&&v.every(E)}e.areFunctions=o;function u(v,D){const T=Math.min(v.length,D.length);for(let W=0;W<T;W++)l(v[W],D[W])}e.validateConstraints=u;function l(v,D){if(R(D)){if(typeof v!==D)throw new Error(`argument does not match constraint: typeof ${D}`)}else if(E(D)){try{if(v instanceof D)return}catch(T){}if(!b(v)&&v.constructor===D||D.length===1&&D.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function c(v){let D=[],T=Object.getPrototypeOf(v);for(;Object.prototype!==T;)D=D.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return D}e.getAllPropertyNames=c;function t(v){const D=[];for(const T of c(v))typeof v[T]=="function"&&D.push(T);return D}e.getAllMethodNames=t;function i(v,D){const T=$=>function(){const X=Array.prototype.slice.call(arguments,0);return D($,X)};let W={};for(const $ of v)W[$]=T($);return W}e.createProxyObject=i;function s(v){return v===null?void 0:v}e.withNullAsUndefined=s;function a(v){return typeof v=="undefined"?null:v}e.withUndefinedAsNull=a;function h(v){return class{constructor(){return new Proxy({},{get(D,T){if(D[T])return D[T];throw new Error(`Not Implemented: ${v}->${String(T)}`)}})}}}e.NotImplementedProxy=h;function f(v){throw new Error("Unreachable")}e.assertNever=f}),define(Q[30],J([0,1,3,23,8,13]),function(j,e,m,R,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function P(i){return i===47||i===92}e.isPathSeparator=P;function r(i){return i.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=r;function w(i,s=L.posix.sep){if(!i)return"";const a=i.length,h=i.charCodeAt(0);if(P(h)){if(P(i.charCodeAt(1))&&!P(i.charCodeAt(2))){let v=3;const D=v;for(;v<a&&!P(i.charCodeAt(v));v++);if(D!==v&&!P(i.charCodeAt(v+1))){for(v+=1;v<a;v++)if(P(i.charCodeAt(v)))return i.slice(0,v+1).replace(/[\\/]/g,s)}}return s}else if(M(h)&&i.charCodeAt(1)===58)return P(i.charCodeAt(2))?i.slice(0,2)+s:i.slice(0,2);let f=i.indexOf("://");if(f!==-1){for(f+=3;f<a;f++)if(P(i.charCodeAt(f)))return i.slice(0,f+1)}return""}e.getRoot=w;function p(i){if(!m.isWindows||!i||i.length<5)return!1;let s=i.charCodeAt(0);if(s!==92||(s=i.charCodeAt(1),s!==92))return!1;let a=2;const h=a;for(;a<i.length&&(s=i.charCodeAt(a),s!==92);a++);return!(h===a||(s=i.charCodeAt(a+1),isNaN(s)||s===92))}e.isUNC=p;const n=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,I=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(i,s=m.isWindows){const a=s?n:b;return!(!i||i.length===0||/^\s+$/.test(i)||(a.lastIndex=0,a.test(i))||s&&I.test(i)||i==="."||i===".."||s&&i[i.length-1]==="."||s&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=y;function d(i,s,a){const h=i===s;return!a||h?h:!i||!s?!1:(0,R.equalsIgnoreCase)(i,s)}e.isEqual=d;function g(i,s,a,h=L.sep){if(i===s)return!0;if(!i||!s||s.length>i.length)return!1;if(a){if(!(0,R.startsWithIgnoreCase)(i,s))return!1;if(s.length===i.length)return!0;let v=s.length;return s.charAt(s.length-1)===h&&v--,i.charAt(v)===h}return s.charAt(s.length-1)!==h&&(s+=h),i.indexOf(s)===0}e.isEqualOrParent=g;function M(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=M;function E(i,s){return m.isWindows&&i.endsWith(":")&&(i+=L.sep),(0,L.isAbsolute)(i)||(i=(0,L.join)(s,i)),i=(0,L.normalize)(i),m.isWindows?(i=(0,R.rtrim)(i,L.sep),i.endsWith(":")&&(i+=L.sep)):(i=(0,R.rtrim)(i,L.sep),i||(i=L.sep)),i}e.sanitizeFilePath=E;function o(i){const s=(0,L.normalize)(i);return m.isWindows?i.length>3?!1:u(s)&&(i.length===2||s.charCodeAt(2)===92):s===L.posix.sep}e.isRootOrDriveLetter=o;function u(i){return m.isWindows?M(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function l(i){return u(i)?i[0]:void 0}e.getDriveLetter=l;function c(i,s,a){return s.length>i.length?-1:i===s?0:(a&&(i=i.toLowerCase(),s=s.toLowerCase()),i.indexOf(s))}e.indexOfPath=c;function t(i){const s=i.split(":");let a,h,f;if(s.forEach(v=>{const D=Number(v);(0,S.isNumber)(D)?h===void 0?h=D:f===void 0&&(f=D):a=a?[a,v].join(":"):v}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:h!==void 0?h:void 0,column:f!==void 0?f:h!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(Q[44],J([0,1,13]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const M=Array.isArray(g)?[]:{};return Object.keys(g).forEach(E=>{g[E]&&typeof g[E]=="object"?M[E]=R(g[E]):M[E]=g[E]}),M}e.deepClone=R;function L(g){if(!g||typeof g!="object")return g;const M=[g];for(;M.length>0;){const E=M.shift();Object.freeze(E);for(const o in E)if(S.call(E,o)){const u=E[o];typeof u=="object"&&!Object.isFrozen(u)&&M.push(u)}}return g}e.deepFreeze=L;const S=Object.prototype.hasOwnProperty;function P(g,M){return r(g,M,new Set)}e.cloneAndChange=P;function r(g,M,E){if((0,m.isUndefinedOrNull)(g))return g;const o=M(g);if(typeof o!="undefined")return o;if((0,m.isArray)(g)){const u=[];for(const l of g)u.push(r(l,M,E));return u}if((0,m.isObject)(g)){if(E.has(g))throw new Error("Cannot clone recursive data-structure");E.add(g);const u={};for(let l in g)S.call(g,l)&&(u[l]=r(g[l],M,E));return E.delete(g),u}return g}function w(g,M,E=!0){return(0,m.isObject)(g)?((0,m.isObject)(M)&&Object.keys(M).forEach(o=>{o in g?E&&((0,m.isObject)(g[o])&&(0,m.isObject)(M[o])?w(g[o],M[o],E):g[o]=M[o]):g[o]=M[o]}),g):M}e.mixin=w;function p(g,M){if(g===M)return!0;if(g==null||M===null||M===void 0||typeof g!=typeof M||typeof g!="object"||Array.isArray(g)!==Array.isArray(M))return!1;let E,o;if(Array.isArray(g)){if(g.length!==M.length)return!1;for(E=0;E<g.length;E++)if(!p(g[E],M[E]))return!1}else{const u=[];for(o in g)u.push(o);u.sort();const l=[];for(o in M)l.push(o);if(l.sort(),!p(u,l))return!1;for(E=0;E<u.length;E++)if(!p(g[u[E]],M[u[E]]))return!1}return!0}e.equals=p;function n(g){const M=new Set;return JSON.stringify(g,(E,o)=>{if((0,m.isObject)(o)||Array.isArray(o)){if(M.has(o))return"[Circular]";M.add(o)}return o})}e.safeStringify=n;function b(g,M,E){const o=M(g);return typeof o=="undefined"?E:o}e.getOrDefault=b;function I(g,M){const E=Object.create(null);return!g||!M||Object.keys(M).forEach(u=>{const l=g[u],c=M[u];p(l,c)||(E[u]=c)}),E}e.distinct=I;function y(g,M){const E=M.toLowerCase(),o=Object.keys(g).find(u=>u.toLowerCase()===E);return o?g[o]:g[M]}e.getCaseInsensitive=y;function d(g,M){const E=Object.create(null);for(const o of Object.keys(g))M(o,g[o])&&(E[o]=g[o]);return E}e.filter=d}),define(Q[7],J([0,1,3,8]),function(j,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,S=/^\//,P=/^\/\//;function r(s,a){if(!s.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!L.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!S.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(s,a){return!s&&!a?"file":s}function p(s,a){switch(s){case"https":case"http":case"file":a?a[0]!==b&&(a=b+a):a=b;break}return a}const n="",b="/",I=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(a,h,f,v,D,T=!1){typeof a=="object"?(this.scheme=a.scheme||n,this.authority=a.authority||n,this.path=a.path||n,this.query=a.query||n,this.fragment=a.fragment||n):(this.scheme=w(a,T),this.authority=h||n,this.path=p(this.scheme,f||n),this.query=v||n,this.fragment=D||n,r(this,T))}static isUri(a){return a instanceof y?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return u(this,!1)}with(a){if(!a)return this;let{scheme:h,authority:f,path:v,query:D,fragment:T}=a;return h===void 0?h=this.scheme:h===null&&(h=n),f===void 0?f=this.authority:f===null&&(f=n),v===void 0?v=this.path:v===null&&(v=n),D===void 0?D=this.query:D===null&&(D=n),T===void 0?T=this.fragment:T===null&&(T=n),h===this.scheme&&f===this.authority&&v===this.path&&D===this.query&&T===this.fragment?this:new g(h,f,v,D,T)}static parse(a,h=!1){const f=I.exec(a);return f?new g(f[2]||n,i(f[4]||n),i(f[5]||n),i(f[7]||n),i(f[9]||n),h):new g(n,n,n,n,n)}static file(a){let h=n;if(m.isWindows&&(a=a.replace(/\\/g,b)),a[0]===b&&a[1]===b){const f=a.indexOf(b,2);f===-1?(h=a.substring(2),a=b):(h=a.substring(2,f),a=a.substring(f)||b)}return new g("file",h,a,n,n)}static from(a){return new g(a.scheme,a.authority,a.path,a.query,a.fragment)}static joinPath(a,...h){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return m.isWindows&&a.scheme==="file"?f=y.file(R.win32.join(u(a,!0),...h)).path:f=R.posix.join(a.path,...h),a.with({path:f})}toString(a=!1){return l(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof y)return a;{const h=new g(a);return h._formatted=a.external,h._fsPath=a._sep===d?a.fsPath:null,h}}else return a}}e.URI=y;const d=m.isWindows?1:void 0;class g extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(a=!1){return a?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=d),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const M={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(s,a){let h,f=-1;for(let v=0;v<s.length;v++){const D=s.charCodeAt(v);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||a&&D===47)f!==-1&&(h+=encodeURIComponent(s.substring(f,v)),f=-1),h!==void 0&&(h+=s.charAt(v));else{h===void 0&&(h=s.substr(0,v));const T=M[D];T!==void 0?(f!==-1&&(h+=encodeURIComponent(s.substring(f,v)),f=-1),h+=T):f===-1&&(f=v)}}return f!==-1&&(h+=encodeURIComponent(s.substring(f))),h!==void 0?h:s}function o(s){let a;for(let h=0;h<s.length;h++){const f=s.charCodeAt(h);f===35||f===63?(a===void 0&&(a=s.substr(0,h)),a+=M[f]):a!==void 0&&(a+=s[h])}return a!==void 0?a:s}function u(s,a){let h;return s.authority&&s.path.length>1&&s.scheme==="file"?h=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?a?h=s.path.substr(1):h=s.path[1].toLowerCase()+s.path.substr(2):h=s.path,m.isWindows&&(h=h.replace(/\//g,"\\")),h}e.uriToFsPath=u;function l(s,a){const h=a?o:E;let f="",{scheme:v,authority:D,path:T,query:W,fragment:$}=s;if(v&&(f+=v,f+=":"),(D||v==="file")&&(f+=b,f+=b),D){let X=D.indexOf("@");if(X!==-1){const x=D.substr(0,X);D=D.substr(X+1),X=x.indexOf(":"),X===-1?f+=h(x,!1):(f+=h(x.substr(0,X),!1),f+=":",f+=h(x.substr(X+1),!1)),f+="@"}D=D.toLowerCase(),X=D.indexOf(":"),X===-1?f+=h(D,!1):(f+=h(D.substr(0,X),!1),f+=D.substr(X))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const X=T.charCodeAt(1);X>=65&&X<=90&&(T=`/${String.fromCharCode(X+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const X=T.charCodeAt(0);X>=65&&X<=90&&(T=`${String.fromCharCode(X+32)}:${T.substr(2)}`)}f+=h(T,!0)}return W&&(f+="?",f+=h(W,!1)),$&&(f+="#",f+=a?$:E($,!1)),f}function c(s){try{return decodeURIComponent(s)}catch(a){return s.length>3?s.substr(0,3)+c(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(s){return s.match(t)?s.replace(t,a=>c(a)):s}}),define(Q[108],J([0,1,7]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(p){const n=p;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=R;function L(p){const n=[];let b;try{const I=JSON.parse(p.arguments),y=I[I.length-1];y&&y.__$stack&&(I.pop(),b=y.__$stack),n.push(...I)}catch(I){n.push("Unable to log remote console arguments",p.arguments)}return{args:n,stack:b}}e.parse=L;function S(p){if(typeof p!="string")return S(L(p).stack);const n=p;if(n){const b=P(n),I=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(I&&I.length===4)return{uri:m.URI.file(I[1]),line:Number(I[2]),column:Number(I[3])}}}e.getFirstFrame=S;function P(p){if(!p)return p;const n=p.indexOf(`
`);return n===-1?p:p.substring(0,n)}function r(p,n){const{args:b,stack:I}=L(p),y=typeof b[0]=="string"&&b.length===1;let d=P(I);d&&(d=`(${d.trim()})`);let g=[];if(typeof b[0]=="string"?d&&y?g=[`%c[${n}] %c${b[0]} %c${d}`,w("blue"),w(""),w("grey")]:g=[`%c[${n}] %c${b[0]}`,w("blue"),w(""),...b.slice(1)]:g=[`%c[${n}]%`,w("blue"),...b],d&&!y&&g.push(d),typeof console[p.severity]!="function")throw new Error("Unknown console method");console[p.severity].apply(console,g)}e.log=r;function w(p){return`color: ${p}`}});var Mt=this&&this.__classPrivateFieldSet||function(j,e,m,R,L){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?j!==e||!L:!e.has(j))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?L.call(j,m):L?L.value=m:e.set(j,m),m},Ke=this&&this.__classPrivateFieldGet||function(j,e,m,R){if(m==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?j!==e||!R:!e.has(j))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?R:m==="a"?R.call(j):R?R.value:e.get(j)};define(Q[36],J([0,1,7,23]),function(j,e,m,R){"use strict";var L,S,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function r(t,i,s){let a=t.get(i);return a===void 0&&(a=s,t.set(i,a)),a}e.getOrSet=r;function w(t){const i=[];return t.forEach((s,a)=>{i.push(`${a} => ${s}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=w;function p(t){const i=[];return t.forEach(s=>{i.push(s)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=p;class n{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),a=this._value.charCodeAt(this._pos);return s-a}value(){return this._value[this._pos]}}e.StringIterator=n;class b{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,R.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class I{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,R.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=I;var y;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(y||(y={}));class d{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new I(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,R.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class g{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class M{constructor(i){this._iter=i}static forUris(i=()=>!1){return new M(new d(i))}static forPaths(){return new M(new I)}static forStrings(){return new M(new n)}static forConfigKeys(){return new M(new b)}clear(){this._root=void 0}set(i,s){const a=this._iter.reset(i);let h;for(this._root||(this._root=new g,this._root.segment=a.value()),h=this._root;;){const v=a.cmp(h.segment);if(v>0)h.left||(h.left=new g,h.left.segment=a.value()),h=h.left;else if(v<0)h.right||(h.right=new g,h.right.segment=a.value()),h=h.right;else if(a.hasNext())a.next(),h.mid||(h.mid=new g,h.mid.segment=a.value()),h=h.mid;else break}const f=h.value;return h.value=s,h.key=i,f}get(i){var s;return(s=this._getNode(i))===null||s===void 0?void 0:s.value}_getNode(i){const s=this._iter.reset(i);let a=this._root;for(;a;){const h=s.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else break}return a}has(i){const s=this._getNode(i);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const a=this._iter.reset(i),h=[];let f=this._root;for(;f;){const v=a.cmp(f.segment);if(v>0)h.push([1,f]),f=f.left;else if(v<0)h.push([-1,f]),f=f.right;else if(a.hasNext())a.next(),h.push([0,f]),f=f.mid;else{for(s?(f.left=void 0,f.mid=void 0,f.right=void 0):f.value=void 0;h.length>0&&f.isEmpty();){let[D,T]=h.pop();switch(D){case 1:T.left=void 0;break;case 0:T.mid=void 0;break;case-1:T.right=void 0;break}f=T}break}}}findSubstr(i){const s=this._iter.reset(i);let a=this._root,h;for(;a;){const f=s.cmp(a.segment);if(f>0)a=a.left;else if(f<0)a=a.right;else if(s.hasNext())s.next(),h=a.value||h,a=a.mid;else break}return a&&a.value||h}findSuperstr(i){const s=this._iter.reset(i);let a=this._root;for(;a;){const h=s.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(i){for(const[s,a]of this)i(a,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){i&&(yield*this._entries(i.left),i.value&&(yield[i.key,i.value]),yield*this._entries(i.mid),yield*this._entries(i.right))}}e.TernarySearchTree=M;class E{constructor(i,s){this[L]="ResourceMap",i instanceof E?(this.map=new Map(i.map),this.toKey=s!=null?s:E.defaultToKey):(this.map=new Map,this.toKey=i!=null?i:E.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),s),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[a,h]of this.map)i(h,m.URI.parse(a),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield m.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[m.URI.parse(i[0]),i[1]]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[m.URI.parse(i[0]),i[1]]}}e.ResourceMap=E,E.defaultToKey=t=>t.toString();var o;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class u{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,s=0){const a=this._map.get(i);if(!!a)return s!==0&&this.touch(a,s),a.value}set(i,s,a=0){let h=this._map.get(i);if(h)h.value=s,a!==0&&this.touch(h,a);else{switch(h={key:i,value:s,next:void 0,previous:void 0},a){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(i,h),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}}forEach(i,s){const a=this._state;let h=this._head;for(;h;){if(s?i.bind(s)(h.value,h.key,this):i(h.value,h.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const i=this,s=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const f={value:a.key,done:!1};return a=a.next,f}else return{value:void 0,done:!0}}};return h}values(){const i=this,s=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const f={value:a.value,done:!1};return a=a.next,f}else return{value:void 0,done:!0}}};return h}entries(){const i=this,s=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const f={value:[a.key,a.value],done:!1};return a=a.next,f}else return{value:void 0,done:!0}}};return h}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(!(i>=this.size)){if(i===0){this.clear();return}let s=this._head,a=this.size;for(;s&&a>i;)this._map.delete(s.key),s=s.next,a--;this._head=s,this._size=a,s&&(s.previous=void 0),this._state++}}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,a=i.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const a=i.next,h=i.previous;i===this._tail?(h.next=void 0,this._tail=h):(a.previous=h,h.next=a),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const a=i.next,h=i.previous;i===this._head?(a.previous=void 0,this._head=a):(a.previous=h,h.next=a),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,a)=>{i.push([a,s])}),i}fromJSON(i){this.clear();for(const[s,a]of i)this.set(s,a)}}e.LinkedMap=u;class l extends u{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class c{constructor(i){P.set(this,void 0),Mt(this,P,i,"f")}get size(){return Ke(this,P,"f").size}forEach(i,s){Ke(this,P,"f").forEach(i,s)}get(i){return Ke(this,P,"f").get(i)}has(i){return Ke(this,P,"f").has(i)}entries(){return Ke(this,P,"f").entries()}keys(){return Ke(this,P,"f").keys()}values(){return Ke(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return Ke(this,P,"f").entries()}}e.ReadonlyMapView=c}),define(Q[109],J([0,1,19,23,7]),function(j,e,m,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function S(p){return JSON.stringify(p,r)}e.stringify=S;function P(p){let n=JSON.parse(p);return n=w(n),n}e.parse=P;function r(p,n){return n instanceof RegExp?{$mid:2,source:n.source,flags:(0,R.regExpFlags)(n)}:n}function w(p,n=0){if(!p||n>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return L.URI.revive(p);case 2:return new RegExp(p.source,p.flags)}if(p instanceof m.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let b=0;b<p.length;++b)p[b]=w(p[b],n+1);else for(const b in p)Object.hasOwnProperty.call(p,b)&&(p[b]=w(p[b],n+1))}return p}e.revive=w}),define(Q[10],J([0,1,7,3]),function(j,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var L;(function(r){r.inMemory="inmemory",r.vscode="vscode",r.internal="private",r.walkThrough="walkThrough",r.walkThroughSnippet="walkThroughSnippet",r.http="http",r.https="https",r.file="file",r.mailto="mailto",r.untitled="untitled",r.data="data",r.command="command",r.vscodeRemote="vscode-remote",r.vscodeRemoteResource="vscode-remote-resource",r.userData="vscode-userdata",r.vscodeCustomEditor="vscode-custom-editor",r.vscodeNotebook="vscode-notebook",r.vscodeNotebookCell="vscode-notebook-cell",r.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",r.vscodeNotebookCellOutput="vscode-notebook-cell-output",r.vscodeSettings="vscode-settings",r.vscodeWorkspaceTrust="vscode-workspace-trust",r.vscodeTerminal="vscode-terminal",r.webviewPanel="webview-panel",r.vscodeWebview="vscode-webview",r.extension="extension",r.vscodeFileResource="vscode-file",r.tmp="tmp"})(L=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}set(w,p,n){this._hosts[w]=p,this._ports[w]=n}setConnectionToken(w,p){this._connectionTokens[w]=p}rewrite(w){if(this._delegate)return this._delegate(w);const p=w.authority;let n=this._hosts[p];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const b=this._ports[p],I=this._connectionTokens[p];let y=`path=${encodeURIComponent(w.path)}`;return typeof I=="string"&&(y+=`&tkn=${encodeURIComponent(I)}`),m.URI.from({scheme:R.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${n}:${b}`,path:"/vscode-remote-resource",query:y})}}e.RemoteAuthorities=new S;class P{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(w,p,n){const b=this.toUri(w,p);return b.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(b):R.isNative&&(n||R.isPreferringBrowserCodeLoad)&&b.scheme===L.file?b.with({scheme:L.vscodeFileResource,authority:b.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(w,p){const n=this.toUri(w,p);return n.scheme===L.vscodeFileResource?n.with({scheme:L.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(w,p){return m.URI.isUri(w)?w:m.URI.parse(p.toUrl(w))}}e.FileAccess=new P}),define(Q[65],J([0,1,36]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new m.LRUCache(1e4);function L(p){return w(p,"NFC",R)}e.normalizeNFC=L;const S=new m.LRUCache(1e4);function P(p){return w(p,"NFD",S)}e.normalizeNFD=P;const r=/[^\u0000-\u0080]/;function w(p,n,b){if(!e.canNormalize||!p)return p;const I=b.get(p);if(I)return I;let y;return r.test(p)?y=p.normalize(n):y=p,b.set(p,y),y}e.removeAccents=function(){if(e.canNormalize){const p=/[\u0300-\u036f]/g;return function(n){return P(n).replace(p,"")}}else return function(p){return p}}()}),define(Q[15],J([0,1,30,8,7,23,10,3]),function(j,e,m,R,L,S,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(y){return(0,L.uriToFsPath)(y,!0)}e.originalFSPath=w;class p{constructor(d){this._ignorePathCasing=d}compare(d,g,M=!1){return d===g?0:(0,S.compare)(this.getComparisonKey(d,M),this.getComparisonKey(g,M))}isEqual(d,g,M=!1){return d===g?!0:!d||!g?!1:this.getComparisonKey(d,M)===this.getComparisonKey(g,M)}getComparisonKey(d,g=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,g,M=!1){if(d.scheme===g.scheme){if(d.scheme===P.Schemas.file)return m.isEqualOrParent(w(d),w(g),this._ignorePathCasing(d))&&d.query===g.query&&(M||d.fragment===g.fragment);if((0,e.isEqualAuthority)(d.authority,g.authority))return m.isEqualOrParent(d.path,g.path,this._ignorePathCasing(d),"/")&&d.query===g.query&&(M||d.fragment===g.fragment)}return!1}joinPath(d,...g){return L.URI.joinPath(d,...g)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return R.posix.basename(d.path)}extname(d){return R.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let g;return d.scheme===P.Schemas.file?g=L.URI.file(R.dirname(w(d))).path:(g=R.posix.dirname(d.path),d.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),g="/")),d.with({path:g})}normalizePath(d){if(!d.path.length)return d;let g;return d.scheme===P.Schemas.file?g=L.URI.file(R.normalize(w(d))).path:g=R.posix.normalize(d.path),d.with({path:g})}relativePath(d,g){if(!(d.scheme!==g.scheme||!(0,e.isEqualAuthority)(d.authority,g.authority))){if(d.scheme===P.Schemas.file){const o=R.relative(w(d),w(g));return r.isWindows?m.toSlashes(o):o}let M=d.path||"/",E=g.path||"/";if(this._ignorePathCasing(d)){let o=0;for(const u=Math.min(M.length,E.length);o<u&&!(M.charCodeAt(o)!==E.charCodeAt(o)&&M.charAt(o).toLowerCase()!==E.charAt(o).toLowerCase());o++);M=E.substr(0,o)+M.substr(o)}return R.posix.relative(M,E)}}resolvePath(d,g){if(d.scheme===P.Schemas.file){const M=L.URI.file(R.resolve(w(d),g));return d.with({authority:M.authority,path:M.path})}return g.indexOf("/")===-1&&(g=m.toSlashes(g),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g)),d.with({path:R.posix.resolve(d.path,g)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,g){return d===g||(0,S.equalsIgnoreCase)(d,g)}hasTrailingPathSeparator(d,g=R.sep){if(d.scheme===P.Schemas.file){const M=w(d);return M.length>m.getRoot(M).length&&M[M.length-1]===g}else{const M=d.path;return M.length>1&&M.charCodeAt(M.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,g=R.sep){return(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,g=R.sep){let M=!1;if(d.scheme===P.Schemas.file){const E=w(d);M=E!==void 0&&E.length===m.getRoot(E).length&&E[E.length-1]===g}else{g="/";const E=d.path;M=E.length===1&&E.charCodeAt(E.length-1)===47}return!M&&!(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path+"/"}):d}}e.ExtUri=p,e.extUri=new p(()=>!1),e.extUriBiasedIgnorePathCase=new p(y=>y.scheme===P.Schemas.file?!r.isLinux:!0),e.extUriIgnorePathCase=new p(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(y,d){const g=[];for(let M=0;M<y.length;M++){const E=d(y[M]);y.some((o,u)=>u===M?!1:(0,e.isEqualOrParent)(E,d(o)))||g.push(y[M])}return g}e.distinctParents=n;var b;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function d(g){const M=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(u=>{const[l,c]=u.split(":");l&&c&&M.set(l,c)});const o=g.path.substring(0,g.path.indexOf(";"));return o&&M.set(y.META_DATA_MIME,o),M}y.parseMetaData=d})(b=e.DataUri||(e.DataUri={}));function I(y,d,g){if(d){let M=y.path;return M&&M[0]!==R.posix.sep&&(M=R.posix.sep+M),y.with({scheme:g,authority:d,path:M})}return y.with({scheme:g})}e.toLocalResource=I}),define(Q[9],J([0,1,26,18,5,2,78,15]),function(j,e,m,R,L,S,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(V){return!!V&&typeof V.then=="function"}e.isThenable=w;function p(V){const _=new m.CancellationTokenSource,A=V(_.token),O=new Promise((k,F)=>{_.token.onCancellationRequested(()=>{F((0,R.canceled)())}),Promise.resolve(A).then(U=>{_.dispose(),k(U)},U=>{_.dispose(),F(U)})});return new class{cancel(){_.cancel()}then(k,F){return O.then(k,F)}catch(k){return this.then(void 0,k)}finally(k){return O.finally(k)}}}e.createCancelablePromise=p;function n(V,_,A){return Promise.race([V,new Promise(O=>_.onCancellationRequested(()=>O(A)))])}e.raceCancellation=n;async function b(V){let _=-1;const A=V.map((k,F)=>k.then(U=>(_=F,U))),O=await Promise.race(A);return V.forEach((k,F)=>{F!==_&&k.cancel()}),O}e.raceCancellablePromises=b;function I(V,_,A){let O;const k=setTimeout(()=>{O==null||O(void 0),A==null||A()},_);return Promise.race([V.finally(()=>clearTimeout(k)),new Promise(F=>O=F)])}e.raceTimeout=I;function y(V){return new Promise((_,A)=>{const O=V();w(O)?O.then(_,A):_(O)})}e.asPromise=y;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(_){if(this.activePromise){if(this.queuedPromiseFactory=_,!this.queuedPromise){const A=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(A,A).then(O)})}return new Promise((A,O)=>{this.queuedPromise.then(A,O)})}return this.activePromise=_(),new Promise((A,O)=>{this.activePromise.then(k=>{this.activePromise=null,A(k)},k=>{this.activePromise=null,O(k)})})}}e.Throttler=d;class g{constructor(){this.current=Promise.resolve(null)}queue(_){return this.current=this.current.then(()=>_(),()=>_())}}e.Sequencer=g;class M{constructor(){this.promiseMap=new Map}queue(_,A){var O;const F=((O=this.promiseMap.get(_))!==null&&O!==void 0?O:Promise.resolve()).catch(()=>{}).then(A).finally(()=>{this.promiseMap.get(_)===F&&this.promiseMap.delete(_)});return this.promiseMap.set(_,F),F}}e.SequencerByKey=M;class E{constructor(_){this.defaultDelay=_,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(_,A=this.defaultDelay){return this.task=_,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,k)=>{this.doResolve=O,this.doReject=k}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},A),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=E;class o{constructor(_){this.delayer=new E(_),this.throttler=new d}trigger(_,A){return this.delayer.trigger(()=>this.throttler.queue(_),A)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=o;class u{constructor(){this._isOpen=!1,this._promise=new Promise((_,A)=>{this._completePromise=_})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class l extends u{constructor(_){super();this._timeout=setTimeout(()=>this.open(),_)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function c(V,_){return _?new Promise((A,O)=>{const k=setTimeout(A,V);_.onCancellationRequested(()=>{clearTimeout(k),O((0,R.canceled)())})}):p(A=>c(V,A))}e.timeout=c;function t(V,_=0){const A=setTimeout(V,_);return(0,S.toDisposable)(()=>clearTimeout(A))}e.disposableTimeout=t;function i(V){return V.then(void 0,_=>{})}e.ignoreErrors=i;function s(V){const _=[];let A=0;const O=V.length;function k(){return A<O?V[A++]():null}function F(U){U!=null&&_.push(U);const K=k();return K?K.then(F):Promise.resolve(_)}return Promise.resolve(null).then(F)}e.sequence=s;function a(V,_=O=>!!O,A=null){let O=0;const k=V.length,F=()=>{if(O>=k)return Promise.resolve(A);const U=V[O++];return Promise.resolve(U()).then(G=>_(G)?Promise.resolve(G):F())};return F()}e.first=a;function h(V,_=O=>!!O,A=null){if(V.length===0)return Promise.resolve(A);let O=V.length;const k=()=>{var F,U;O=-1;for(const K of V)(U=(F=K).cancel)===null||U===void 0||U.call(F)};return new Promise((F,U)=>{for(const K of V)K.then(G=>{--O>=0&&_(G)?(k(),F(G)):O===0&&F(A)}).catch(G=>{--O>=0&&(k(),U(G))})})}e.firstParallel=h;class f{constructor(_){this._size=0,this.maxDegreeOfParalellism=_,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(_){return this._size++,new Promise((A,O)=>{this.outstandingPromises.push({factory:_,c:A,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const _=this.outstandingPromises.shift();this.runningPromises++;const A=_.factory();A.then(_.c,_.e),A.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class v extends f{constructor(){super(1)}}e.Queue=v;class D{constructor(){this.queues=new Map}queueFor(_,A=r.extUri){const O=A.getComparisonKey(_);let k=this.queues.get(O);return k||(k=new v,L.Event.once(k.onFinished)(()=>{k==null||k.dispose(),this.queues.delete(O)}),this.queues.set(O,k)),k}dispose(){this.queues.forEach(_=>_.dispose()),this.queues.clear()}}e.ResourceQueue=D;class T{constructor(_,A){this._token=-1,typeof _=="function"&&typeof A=="number"&&this.setIfNotSet(_,A)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(_,A){this.cancel(),this._token=setTimeout(()=>{this._token=-1,_()},A)}setIfNotSet(_,A){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,_()},A))}}e.TimeoutTimer=T;class W{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(_,A){this.cancel(),this._token=setInterval(()=>{_()},A)}}e.IntervalTimer=W;class ${constructor(_,A){this.timeoutToken=-1,this.runner=_,this.timeout=A,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(_=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,_)}get delay(){return this.timeout}set delay(_){this.timeout=_}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=$;class X extends ${constructor(_,A){super(_,A);this.units=[]}work(_){this.units.push(_),this.isScheduled()||this.schedule()}doRun(){const _=this.units;this.units=[],this.runner&&this.runner(_)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=X,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const V=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=_=>{const A=setTimeout(()=>_(V));let O=!1;return{dispose(){O||(O=!0,clearTimeout(A))}}}}else e.runWhenIdle=(V,_)=>{const A=requestIdleCallback(V,typeof _=="number"?{timeout:_}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(A))}}}}();class x{constructor(_){this._didRun=!1,this._executor=()=>{try{this._value=_()}catch(A){this._error=A}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=x;async function oe(V,_,A){let O;for(let k=0;k<A;k++)try{return await V()}catch(F){O=F,await c(_)}throw O}e.retry=oe;class q{hasPending(_){return this._pending?typeof _=="number"?this._pending.taskId===_:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var _;(_=this._pending)===null||_===void 0||_.cancel()}setPending(_,A,O){return this._pending={taskId:_,cancel:()=>O==null?void 0:O(),promise:A},A.then(()=>this.donePending(_),()=>this.donePending(_)),A}donePending(_){this._pending&&_===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const _=this._next;this._next=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this._next)this._next.run=_;else{let A,O;const k=new Promise((F,U)=>{A=F,O=U});this._next={run:_,promise:k,promiseResolve:A,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=q;class N{constructor(_){this.interval=_,this.lastIncrementTime=0,this.value=0}increment(){const _=Date.now();return _-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=_,this.value=0),this.value++,this.value}}e.IntervalCounter=N;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((_,A)=>{this.completeCallback=_,this.errorCallback=A})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(_){return new Promise(A=>{this.completeCallback(_),this.resolved=!0,A()})}error(_){return new Promise(A=>{this.errorCallback(_),this.rejected=!0,A()})}cancel(){new Promise(_=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,_()})}}e.DeferredPromise=B;class C extends L.Emitter{async fireAsync(_,A,O){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const k of this._listeners)this._asyncDeliveryQueue.push([k,_]);for(;this._asyncDeliveryQueue.size>0&&!A.isCancellationRequested;){const[k,F]=this._asyncDeliveryQueue.shift(),U=[],K=Object.assign(Object.assign({},F),{waitUntil:G=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");O&&(G=O(G,typeof k=="function"?k:k[0])),U.push(G)}});try{typeof k=="function"?k.call(void 0,K):k[0].call(k[1],K)}catch(G){(0,R.onUnexpectedError)(G);continue}Object.freeze(U),await z.settled(U).catch(G=>(0,R.onUnexpectedError)(G))}}}}e.AsyncEmitter=C;var z;(function(V){async function _(F){return typeof Promise.allSettled=="function"?A(F):O(F)}V.allSettled=_;async function A(F){return Promise.allSettled(F)}async function O(F){return Promise.all(F.map(U=>U.then(K=>({status:"fulfilled",value:K}),K=>({status:"rejected",reason:K}))))}async function k(F){let U;const K=await Promise.all(F.map(G=>G.then(Y=>Y,Y=>{U||(U=Y)})));if(typeof U!="undefined")throw U;return K}V.settled=k})(z=e.Promises||(e.Promises={}))}),define(Q[110],J([0,1,23,30,8,36,9]),function(j,e,m,R,L,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function r(){return Object.create(null)}e.getEmptyExpression=r;const w="**",p="/",n="[/\\\\]",b="[^/\\\\]",I=/\//g;function y(A){switch(A){case 0:return"";case 1:return`${b}*?`;default:return`(?:${n}|${b}+${n}|${n}${b}+)*?`}}function d(A,O){if(!A)return[];const k=[];let F=!1,U=!1,K="";for(const G of A){switch(G){case O:if(!F&&!U){k.push(K),K="";continue}break;case"{":F=!0;break;case"}":F=!1;break;case"[":U=!0;break;case"]":U=!1;break}K+=G}return K&&k.push(K),k}e.splitGlobAware=d;function g(A){if(!A)return"";let O="";const k=d(A,p);if(k.every(F=>F===w))O=".*";else{let F=!1;k.forEach((U,K)=>{if(U===w){F||(O+=y(2),F=!0);return}let G=!1,Y="",Z=!1,ne="";for(const se of U){if(se!=="}"&&G){Y+=se;continue}if(Z&&(se!=="]"||!ne)){let re;se==="-"?re=se:(se==="^"||se==="!")&&!ne?re="^":se===p?re="":re=m.escapeRegExpCharacters(se),ne+=re;continue}switch(se){case"{":G=!0;continue;case"[":Z=!0;continue;case"}":O+=`(?:${d(Y,",").map(le=>g(le)).join("|")})`,G=!1,Y="";break;case"]":O+="["+ne+"]",Z=!1,ne="";break;case"?":O+=b;continue;case"*":O+=y(1);continue;default:O+=m.escapeRegExpCharacters(se)}}K<k.length-1&&(k[K+1]!==w||K+2<k.length)&&(O+=n),F=!1})}return O}const M=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,o=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new S.LRUCache(1e4),i=function(){return!1},s=function(){return null};function a(A,O){if(!A)return s;let k;typeof A!="string"?k=A.pattern:k=A,k=k.trim();const F=`${k}_${!!O.trimForExclusions}`;let U=t.get(F);if(U)return h(U,A);let K;if(M.test(k)){const G=k.substr(4);U=function(Y,Z){return typeof Y=="string"&&Y.endsWith(G)?k:null}}else(K=E.exec(f(k,O)))?U=v(K[1],k):(O.trimForExclusions?u:o).test(k)?U=D(k,O):(K=l.exec(f(k,O)))?U=T(K[1].substr(1),k,!0):(K=c.exec(f(k,O)))?U=T(K[1],k,!1):U=W(k);return t.set(F,U),h(U,A)}function h(A,O){return typeof O=="string"?A:function(k,F){return R.isEqualOrParent(k,O.base)?A(L.relative(O.base,k),F):null}}function f(A,O){return O.trimForExclusions&&A.endsWith("/**")?A.substr(0,A.length-2):A}function v(A,O){const k=`/${A}`,F=`\\${A}`,U=function(G,Y){return typeof G!="string"?null:Y?Y===A?O:null:G===A||G.endsWith(k)||G.endsWith(F)?O:null},K=[A];return U.basenames=K,U.patterns=[O],U.allBasenames=K,U}function D(A,O){const k=_(A.slice(1,-1).split(",").map(Y=>a(Y,O)).filter(Y=>Y!==s),A),F=k.length;if(!F)return s;if(F===1)return k[0];const U=function(Y,Z){for(let ne=0,se=k.length;ne<se;ne++)if(k[ne](Y,Z))return A;return null},K=k.find(Y=>!!Y.allBasenames);K&&(U.allBasenames=K.allBasenames);const G=k.reduce((Y,Z)=>Z.allPaths?Y.concat(Z.allPaths):Y,[]);return G.length&&(U.allPaths=G),U}function T(A,O,k){const F=L.sep===L.posix.sep,U=F?A:A.replace(I,L.sep),K=L.sep+U,G=L.posix.sep+A,Y=k?function(Z,ne){return typeof Z=="string"&&(Z===U||Z.endsWith(K)||!F&&(Z===A||Z.endsWith(G)))?O:null}:function(Z,ne){return typeof Z=="string"&&(Z===U||!F&&Z===A)?O:null};return Y.allPaths=[(k?"*/":"./")+A],Y}function W(A){try{const O=new RegExp(`^${g(A)}$`);return function(k){return O.lastIndex=0,typeof k=="string"&&O.test(k)?A:null}}catch(O){return s}}function $(A,O,k){return!A||typeof O!="string"?!1:X(A)(O,void 0,k)}e.match=$;function X(A,O={}){if(!A)return i;if(typeof A=="string"||N(A)){const k=a(A,O);if(k===s)return i;const F=function(U,K){return!!k(U,K)};return k.allBasenames&&(F.allBasenames=k.allBasenames),k.allPaths&&(F.allPaths=k.allPaths),F}return z(A,O)}e.parse=X;function x(A){if(!!A){let O;return k=>(O||(O=(A()||Promise.resolve([])).then(F=>F?q(F):{})),O.then(F=>!!F[k]))}}e.hasSiblingPromiseFn=x;function oe(A){if(!!A){let O;return k=>{if(!O){const F=A();O=F?q(F):{}}return!!O[k]}}}e.hasSiblingFn=oe;function q(A){const O={};for(const k of A)O[k]=!0;return O}function N(A){const O=A;return O&&typeof O.base=="string"&&typeof O.pattern=="string"}e.isRelativePattern=N;function B(A){return A.allBasenames||[]}e.getBasenameTerms=B;function C(A){return A.allPaths||[]}e.getPathTerms=C;function z(A,O){const k=_(Object.getOwnPropertyNames(A).map(Y=>V(Y,A[Y],O)).filter(Y=>Y!==s)),F=k.length;if(!F)return s;if(!k.some(Y=>!!Y.requiresSiblings)){if(F===1)return k[0];const Y=function(se,re){for(let te=0,le=k.length;te<le;te++){const ve=k[te](se,re);if(ve)return ve}return null},Z=k.find(se=>!!se.allBasenames);Z&&(Y.allBasenames=Z.allBasenames);const ne=k.reduce((se,re)=>re.allPaths?se.concat(re.allPaths):se,[]);return ne.length&&(Y.allPaths=ne),Y}const U=function(Y,Z,ne){let se;for(let re=0,te=k.length;re<te;re++){const le=k[re];le.requiresSiblings&&ne&&(Z||(Z=L.basename(Y)),se||(se=Z.substr(0,Z.length-L.extname(Y).length)));const ve=le(Y,Z,se,ne);if(ve)return ve}return null},K=k.find(Y=>!!Y.allBasenames);K&&(U.allBasenames=K.allBasenames);const G=k.reduce((Y,Z)=>Z.allPaths?Y.concat(Z.allPaths):Y,[]);return G.length&&(U.allPaths=G),U}function V(A,O,k){if(O===!1)return s;const F=a(A,k);if(F===s)return s;if(typeof O=="boolean")return F;if(O){const U=O.when;if(typeof U=="string"){const K=(G,Y,Z,ne)=>{if(!ne||!F(G,Y))return null;const se=U.replace("$(basename)",Z),re=ne(se);return(0,P.isThenable)(re)?re.then(te=>te?A:null):re?A:null};return K.requiresSiblings=!0,K}}return F}function _(A,O){const k=A.filter(Y=>!!Y.basenames);if(k.length<2)return A;const F=k.reduce((Y,Z)=>{const ne=Z.basenames;return ne?Y.concat(ne):Y},[]);let U;if(O){U=[];for(let Y=0,Z=F.length;Y<Z;Y++)U.push(O)}else U=k.reduce((Y,Z)=>{const ne=Z.patterns;return ne?Y.concat(ne):Y},[]);const K=function(Y,Z){if(typeof Y!="string")return null;if(!Z){let se;for(se=Y.length;se>0;se--){const re=Y.charCodeAt(se-1);if(re===47||re===92)break}Z=Y.substr(se)}const ne=F.indexOf(Z);return ne!==-1?U[ne]:null};K.basenames=F,K.patterns=U,K.allBasenames=F;const G=A.filter(Y=>!Y.basenames);return G.push(K),G}}),define(Q[39],J([0,1,7,8,23,10,3,15,30]),function(j,e,m,R,L,S,P,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function p(a,h,f){if(typeof a=="string"&&(a=m.URI.file(a)),f){const D=f.getWorkspaceFolder(a);if(D){const T=f.getWorkspace().folders.length>1;let W;if((0,r.isEqual)(D.uri,a)?W="":W=(0,r.relativePath)(D.uri,a),T){const $=D.name?D.name:(0,r.basename)(D.uri);W=W?$+" \u2022 "+W:$}return W}}if(a.scheme!==S.Schemas.file&&a.scheme!==S.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if((0,w.hasDriveLetter)(a.fsPath))return(0,R.normalize)(b(a.fsPath));let v=(0,R.normalize)(a.fsPath);return!P.isWindows&&(h==null?void 0:h.userHome)&&(v=y(v,h.userHome.fsPath)),v}e.getPathLabel=p;function n(a){if(!!a){typeof a=="string"&&(a=m.URI.file(a));const h=(0,r.basename)(a)||(a.scheme===S.Schemas.file?a.fsPath:a.path);return P.isWindows&&(0,w.isRootOrDriveLetter)(h)?b(h):h}}e.getBaseLabel=n;function b(a){return(0,w.hasDriveLetter)(a)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=b;let I=Object.create(null);function y(a,h){if(P.isWindows||!a||!h)return a;let f=I.original===h?I.normalized:void 0;return f||(f=`${(0,L.rtrim)(h,R.posix.sep)}${R.posix.sep}`,I={original:h,normalized:f}),(P.isLinux?a.startsWith(f):(0,L.startsWithIgnoreCase)(a,f))&&(a=`~/${a.substr(f.length)}`),a}e.tildify=y;function d(a,h){return a.replace(/^~($|\/|\\)/,`${h}$1`)}e.untildify=d;const g="\u2026",M="\\\\",E="~";function o(a,h=R.sep){const f=new Array(a.length);let v=!1;for(let D=0;D<a.length;D++){let T=a[D];if(T===""){f[D]=`.${h}`;continue}if(!T){f[D]=T;continue}v=!0;let W="";T.indexOf(M)===0?(W=T.substr(0,T.indexOf(M)+M.length),T=T.substr(T.indexOf(M)+M.length)):T.indexOf(h)===0?(W=T.substr(0,T.indexOf(h)+h.length),T=T.substr(T.indexOf(h)+h.length)):T.indexOf(E)===0&&(W=T.substr(0,T.indexOf(E)+E.length),T=T.substr(T.indexOf(E)+E.length));const $=T.split(h);for(let X=1;v&&X<=$.length;X++)for(let x=$.length-X;v&&x>=0;x--){v=!1;let oe=$.slice(x,x+X).join(h);for(let q=0;!v&&q<a.length;q++)if(q!==D&&a[q]&&a[q].indexOf(oe)>-1){const N=x+X===$.length,B=x>0&&a[q].indexOf(h)>-1?h+oe:oe,C=a[q].endsWith(B);v=!N||C}if(!v){let q="";($[0].endsWith(":")||W!=="")&&(x===1&&(x=0,X++,oe=$[0]+h+oe),x>0&&(q=$[0]+h),q=W+q),x>0&&(q=q+g+h),q=q+oe,x+X<$.length&&(q=q+h+g),f[D]=q}}v&&(f[D]=T)}return f}e.shorten=o;var u;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function l(a,h=Object.create(null)){const f=[];let v=!1,D="";for(const T of a)if(T==="$"||v&&T==="{")D&&f.push({value:D,type:u.TEXT}),D="",v=!0;else if(T==="}"&&v){const W=h[D];if(typeof W=="string")W.length&&f.push({value:W,type:u.VARIABLE});else if(W){const $=f[f.length-1];(!$||$.type!==u.SEPARATOR)&&f.push({value:W.label,type:u.SEPARATOR})}D="",v=!1}else D+=T;return D&&!v&&f.push({value:D,type:u.TEXT}),f.filter((T,W)=>{if(T.type===u.SEPARATOR){const $=f[W-1],X=f[W+1];return[$,X].every(x=>x&&(x.type===u.VARIABLE||x.type===u.TEXT)&&x.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=l;function c(a,h){return P.isMacintosh||h?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):a.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function t(a,h){return P.isMacintosh||h?a.replace(/\(&&\w\)|&&/g,""):P.isWindows?a.replace(/&&|&/g,f=>f==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=i;function s(a){const h=a.indexOf("/")!==-1?R.posix:R.win32,f=h.basename(a),v=h.dirname(a);return f.length?{name:f,parentPath:v}:{name:v,parentPath:""}}e.splitName=s}),define(Q[28],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(w){return m.test(w)}e.isUUID=R;const L=new Uint8Array(16),S=[];for(let w=0;w<256;w++)S.push(w.toString(16).padStart(2,"0"));let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(w){for(let p=0;p<w.length;p++)w[p]=Math.floor(Math.random()*256);return w};function r(){P(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let w=0,p="";return p+=S[L[w++]],p+=S[L[w++]],p+=S[L[w++]],p+=S[L[w++]],p+="-",p+=S[L[w++]],p+=S[L[w++]],p+="-",p+=S[L[w++]],p+=S[L[w++]],p+="-",p+=S[L[w++]],p+=S[L[w++]],p+="-",p+=S[L[w++]],p+=S[L[w++]],p+=S[L[w++]],p+=S[L[w++]],p+=S[L[w++]],p+=S[L[w++]],p}e.generateUuid=r}),define(Q[111],J([0,1,24,58,42]),function(j,e,m,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function S(P,r){if(await new Promise((n,b)=>{const I=m.createReadStream(P),y=R.createHash("sha1");I.pipe(y);const d=(0,L.once)((g,M)=>{I.removeAllListeners(),y.removeAllListeners(),g?b(g):n(M)});I.once("error",d),I.once("end",d),y.once("error",d),y.once("data",g=>d(void 0,g.toString("hex")))})!==r)throw new Error("Hash mismatch")}e.checksum=S}),define(Q[81],J([0,1,236]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(S="utf8"){this.stringDecoder=new m.StringDecoder(S),this.remaining=null}write(S){const P=[],r=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(r.length<1)return P;let w=0,p,n=w;for(;n<r.length;)if(p=r.charCodeAt(n),p===13||p===10){if(P.push(r.substring(w,n)),n++,n<r.length){const b=p;p=r.charCodeAt(n),(b===13&&p===10||b===10&&p===13)&&n++}w=n}else n++;return this.remaining=w<r.length?r.substr(w):null,P}end(){return this.remaining}}e.LineDecoder=R}),define(Q[112],J([0,1,27]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(r){const w=r.replace(/\-/g,":").toLowerCase();return!R.has(w)}function S(){return new Promise(async(r,w)=>{const p=setTimeout(()=>w("Unable to retrieve mac address (timeout after 10s)"),1e4);try{r(await P())}catch(n){w(n)}finally{clearTimeout(p)}})}e.getMac=S;function P(){return new Promise((r,w)=>{try{const p=(0,m.networkInterfaces)();for(let n in p){const b=p[n];if(b){for(const{mac:I}of b)if(L(I))return r(I)}}w("Unable to retrieve mac address (unexpected format)")}catch(p){w(p)}})}}),define(Q[66],J([0,1,18,28,27,36,112]),function(j,e,m,R,L,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=S.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,b=0;const I=(0,L.networkInterfaces)();for(let y in I){const d=I[y];if(d)for(const{mac:g,internal:M}of d)M||(b+=1,this._isVirtualMachineMacAdress(g.toUpperCase())&&(n+=1))}this._value=b>0?n/b:0}return this._value}};let r;async function w(){return r||(r=(async()=>await p()||R.generateUuid())()),r}e.getMachineId=w;async function p(){try{const n=await new Promise((I,y)=>{j(["crypto"],I,y)}),b=await(0,P.getMac)();return n.createHash("sha256").update(b,"utf8").digest("hex")}catch(n){m.onUnexpectedError(n);return}}}),define(Q[20],J([0,1,24,27,8,9,3,30,28,65,15,7]),function(j,e,m,R,L,S,P,r,w,p,n,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var I;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(I=e.RimRafMode||(e.RimRafMode={}));async function y(B,C=I.UNLINK){if((0,r.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return C===I.UNLINK?g(B):d(B)}e.rimraf=y;async function d(B){try{const C=(0,L.join)((0,R.tmpdir)(),(0,w.generateUuid)());try{await m.promises.rename(B,C)}catch(z){return g(B)}g(C).catch(z=>{})}catch(C){if(C.code!=="ENOENT")throw C}}async function g(B){return m.promises.rmdir(B,{recursive:!0,maxRetries:3})}function M(B){if((0,r.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(B,{recursive:!0})}e.rimrafSync=M;async function E(B,C){return l(await(C?o(B):m.promises.readdir(B)))}e.readdir=E;async function o(B){try{return await m.promises.readdir(B,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const C=[],z=await E(B);for(const V of z){let _=!1,A=!1,O=!1;try{const k=await m.promises.lstat((0,L.join)(B,V));_=k.isFile(),A=k.isDirectory(),O=k.isSymbolicLink()}catch(k){console.warn("[node.js fs] unexpected error from lstat after readdir: ",k)}C.push({name:V,isFile:()=>_,isDirectory:()=>A,isSymbolicLink:()=>O})}return C}function u(B){return l(m.readdirSync(B))}e.readdirSync=u;function l(B){return B.map(C=>typeof C=="string"?P.isMacintosh?(0,p.normalizeNFC)(C):C:(C.name=P.isMacintosh?(0,p.normalizeNFC)(C.name):C.name,C))}async function c(B){const C=await E(B),z=[];for(const V of C)await i.existsDirectory((0,L.join)(B,V))&&z.push(V);return z}e.readDirsInDir=c;function t(B,C=1e3){return new Promise(z=>{let V=!1;const _=setInterval(()=>{V||(V=!0,m.access(B,A=>{V=!1,A&&(clearInterval(_),z(void 0))}))},C)})}e.whenDeleted=t;var i;(function(B){async function C(_){let A;try{if(A=await m.promises.lstat(_),!A.isSymbolicLink())return{stat:A}}catch(O){}try{return{stat:await m.promises.stat(_),symbolicLink:(A==null?void 0:A.isSymbolicLink())?{dangling:!1}:void 0}}catch(O){if(O.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};if(P.isWindows&&O.code==="EACCES")try{return{stat:await m.promises.stat(await m.promises.readlink(_)),symbolicLink:{dangling:!1}}}catch(k){if(k.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};throw k}throw O}}B.stat=C;async function z(_){try{const{stat:A,symbolicLink:O}=await B.stat(_);return A.isFile()&&(O==null?void 0:O.dangling)!==!0}catch(A){}return!1}B.existsFile=z;async function V(_){try{const{stat:A,symbolicLink:O}=await B.stat(_);return A.isDirectory()&&(O==null?void 0:O.dangling)!==!0}catch(A){}return!1}B.existsDirectory=V})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new S.ResourceQueue;function a(B,C,z){return s.queueFor(b.URI.file(B),n.extUriBiasedIgnorePathCase).queue(()=>{const V=D(z);return new Promise((_,A)=>f(B,C,V,O=>O?A(O):_()))})}e.writeFile=a;let h=!0;function f(B,C,z,V){if(!h)return m.writeFile(B,C,{mode:z.mode,flag:z.flag},V);m.open(B,z.flag,z.mode,(_,A)=>{if(_)return V(_);m.writeFile(A,C,O=>{if(O)return m.close(A,()=>V(O));m.fdatasync(A,k=>(k&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",k),h=!1),m.close(A,F=>V(F))))})})}function v(B,C,z){const V=D(z);if(!h)return m.writeFileSync(B,C,{mode:V.mode,flag:V.flag});const _=m.openSync(B,V.flag,V.mode);try{m.writeFileSync(_,C);try{m.fdatasyncSync(_)}catch(A){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",A),h=!1}}finally{m.closeSync(_)}}e.writeFileSync=v;function D(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function T(B,C){if(B!==C){async function z(V){try{const _=await m.promises.lstat(V);if(_.isDirectory()||_.isSymbolicLink())return;const A=await m.promises.open(V,"a");try{await A.utimes(_.atime,new Date)}finally{await A.close()}}catch(_){}}try{await m.promises.rename(B,C),await z(C)}catch(V){if(B.toLowerCase()!==C.toLowerCase()&&V.code==="EXDEV"||B.endsWith("."))await W(B,C,{preserveSymlinks:!1}),await y(B,I.MOVE),await z(C);else throw V}}}e.move=T;async function W(B,C,z){return X(B,C,{root:{source:B,target:C},options:z,handledSourcePaths:new Set})}e.copy=W;const $=511;async function X(B,C,z){if(!z.handledSourcePaths.has(B)){z.handledSourcePaths.add(B);const{stat:V,symbolicLink:_}=await i.stat(B);if(_){if(z.options.preserveSymlinks)try{return await q(B,C,z)}catch(A){console.warn("[node.js fs] copy of symlink failed: ",A)}if(_.dangling)return}return V.isDirectory()?x(B,C,V.mode&$,z):oe(B,C,V.mode&$)}}async function x(B,C,z,V){await m.promises.mkdir(C,{recursive:!0,mode:z});const _=await E(B);for(const A of _)await X((0,L.join)(B,A),(0,L.join)(C,A),V)}async function oe(B,C,z){await m.promises.copyFile(B,C),await m.promises.chmod(C,z)}async function q(B,C,z){let V=await m.promises.readlink(B);(0,r.isEqualOrParent)(V,z.root.source,!P.isLinux)&&(V=(0,L.join)(z.root.target,V.substr(z.root.source.length+1))),await m.promises.symlink(V,C)}async function N(B){try{return await m.promises.access(B),!0}catch(C){return!1}}e.exists=N}),define(Q[113],J([0,1,24,114,23,8,20]),function(j,e,m,R,L,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function r(b){const I=(0,S.dirname)(b);if(b===I)return b;const y=((0,S.basename)(b)||b).toLowerCase();try{const g=(0,P.readdirSync)(I).filter(M=>M.toLowerCase()===y);if(g.length===1){const M=r(I);if(M)return(0,S.join)(M,g[0])}else if(g.length>1){const M=g.indexOf(y);if(M>=0){const E=r(I);if(E)return(0,S.join)(E,g[M])}}}catch(d){}return null}e.realcaseSync=r;async function w(b){try{return await(0,R.promisify)(m.realpath)(b)}catch(I){const y=n(b);return await m.promises.access(y,m.constants.R_OK),y}}e.realpath=w;function p(b){try{return m.realpathSync(b)}catch(I){const y=n(b);return m.accessSync(y,m.constants.R_OK),y}}e.realpathSync=p;function n(b){return(0,L.rtrim)((0,S.normalize)(b),S.sep)}}),define(Q[115],J([0,1,59]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function R(r,w,p){let n=!1;return new Promise(b=>{const I=setTimeout(()=>{if(!n)return n=!0,b(0)},p);L(r,w,y=>{if(!n)return n=!0,clearTimeout(I),b(y)})})}e.findFreePort=R;function L(r,w,p){if(w===0)return p(0);const n=new m.Socket;n.once("connect",()=>(P(n),L(r+1,w-1,p))),n.once("data",()=>{}),n.once("error",b=>(P(n),b.code!=="ECONNREFUSED"?L(r+1,w-1,p):p(r))),n.connect(r,"127.0.0.1")}function S(r,w,p){let n=!1,b,I=1;const y=m.createServer({pauseOnConnect:!0});function d(g,M){n||(n=!0,y.removeAllListeners(),y.close(),b&&clearTimeout(b),M(g))}return new Promise(g=>{b=setTimeout(()=>{d(0,g)},p),y.on("listening",()=>{d(r,g)}),y.on("error",M=>{M&&(M.code==="EADDRINUSE"||M.code==="EACCES")&&I<w?(r++,I++,y.listen(r,"127.0.0.1")):d(0,g)}),y.on("close",()=>{d(0,g)}),y.listen(r,"127.0.0.1")})}e.findFreePortFaster=S;function P(r){try{r.removeAllListeners("connect"),r.removeAllListeners("error"),r.end(),r.destroy(),r.unref()}catch(w){console.error(w)}}});var _e=this&&this.__await||function(j){return this instanceof _e?(this.v=j,this):new _e(j)},pt=this&&this.__asyncGenerator||function(j,e,m){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var R=m.apply(j,e||[]),L,S=[];return L={},P("next"),P("throw"),P("return"),L[Symbol.asyncIterator]=function(){return this},L;function P(I){R[I]&&(L[I]=function(y){return new Promise(function(d,g){S.push([I,y,d,g])>1||r(I,y)})})}function r(I,y){try{w(R[I](y))}catch(d){b(S[0][3],d)}}function w(I){I.value instanceof _e?Promise.resolve(I.value.v).then(p,n):b(S[0][2],I)}function p(I){r("next",I)}function n(I){r("throw",I)}function b(I,y){I(y),S.shift(),S.length&&r(S[0][0],S[0][1])}},yt=this&&this.__asyncValues||function(j){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=j[Symbol.asyncIterator],m;return e?e.call(j):(j=typeof __values=="function"?__values(j):j[Symbol.iterator](),m={},R("next"),R("throw"),R("return"),m[Symbol.asyncIterator]=function(){return this},m);function R(S){m[S]=j[S]&&function(P){return new Promise(function(r,w){P=j[S](P),L(r,w,P.done,P.value)})}}function L(S,P,r,w){Promise.resolve(w).then(function(p){S({value:p,done:r})},P)}};define(Q[116],J([0,1,20,27,8]),function(j,e,m,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const S=/^\d+$/,P=/^Microsoft.PowerShell_.*/,r=/^Microsoft.PowerShellPreview_.*/;var w;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(w||(w={}));let p;switch(process.arch){case"ia32":case"x32":p=1;break;case"arm":case"arm64":p=2;break;default:p=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class b{constructor(c,t,i){this.exePath=c,this.displayName=t,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await m.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function I({useAlternateBitness:l=!1}={}){return l?p===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:l=!1,findPreview:c=!1}={}){const t=I({useAlternateBitness:l});if(!t)return null;const i=L.join(t,"PowerShell");if(!await m.SymlinkSupport.existsDirectory(i))return null;let s=-1,a=null;for(const v of await m.readdir(i)){let D=-1;if(c){const W=v.indexOf("-");if(W<0)continue;const $=v.substring(0,W);if(!S.test($)||v.substring(W+1)!=="preview")continue;D=parseInt($,10)}else{if(!S.test(v))continue;D=parseInt(v,10)}if(!(D<=s)){const T=L.join(i,v,"pwsh.exe");!await m.SymlinkSupport.existsFile(T)||(a=T,s=D)}}if(!a)return null;const h=t.includes("x86")?" (x86)":"",f=c?" Preview":"";return new b(a,`PowerShell${f}${h}`,!0)}async function d({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const c=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await m.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:t,pwshMsixName:i}=l?{pwshMsixDirRegex:r,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:P,pwshMsixName:"PowerShell (Store)"};for(const s of await m.readdir(c))if(t.test(s)){const a=L.join(c,s,"pwsh.exe");return new b(a,i)}return null}function g(){const l=L.join(R.homedir(),".dotnet","tools","pwsh.exe");return new b(l,".NET Core PowerShell Global Tool")}function M(){const l=L.join(process.env.windir,p===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(l,"Windows PowerShell",!0)}function E(){return pt(this,arguments,function*(){let c=yield _e(y());c&&(yield yield _e(c)),c=yield _e(y({useAlternateBitness:!0})),c&&(yield yield _e(c)),c=yield _e(d()),c&&(yield yield _e(c)),c=g(),c&&(yield yield _e(c)),c=yield _e(y({findPreview:!0})),c&&(yield yield _e(c)),c=yield _e(d({findPreview:!0})),c&&(yield yield _e(c)),c=yield _e(y({useAlternateBitness:!0,findPreview:!0})),c&&(yield yield _e(c)),c=M(),c&&(yield yield _e(c))})}function o(){return pt(this,arguments,function*(){var c,t;try{for(var i=yt(E()),s;s=yield _e(i.next()),!s.done;){const a=s.value;(yield _e(a.exists()))&&(yield yield _e(a))}}catch(a){c={error:a}}finally{try{s&&!s.done&&(t=i.return)&&(yield _e(t.call(i)))}finally{if(c)throw c.error}}})}e.enumeratePowerShellInstallations=o;async function u(){var l,c;try{for(var t=yt(o()),i;i=await t.next(),!i.done;)return i.value}catch(s){l={error:s}}finally{try{i&&!i.done&&(c=t.return)&&await c.call(t)}finally{if(l)throw l.error}}return null}e.getFirstAvailablePowerShellInstallation=u}),define(Q[82],J([0,1,45,10]),function(j,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(P){return new Promise((r,w)=>{let p;const n=new Map;function b(d,g,M,E,o){const u=n.get(g);if(d===P||u){const l={name:I(M),cmd:M,pid:d,ppid:g,load:E,mem:o};n.set(d,l),d===P&&(p=l),u&&(u.children||(u.children=[]),u.children.push(l),u.children.length>1&&(u.children=u.children.sort((c,t)=>c.pid-t.pid)))}}function I(d){const g=/--disable-blink-features=Auxclick/,M=/\\watcher\\win32\\CodeHelper\.exe/,E=/--crashes-directory/,o=/\\pipe\\winpty-control/,u=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(M.exec(d))return"watcherService ";if(E.exec(d))return"electron-crash-reporter";if(o.exec(d))return"winpty-process";if(u.exec(d))return"console-window-host (Windows internal process)";let c=l.exec(d);if(c&&c.length===2)return c[1]==="renderer"?g.exec(d)?"shared-process":"window":c[1];const t=/[a-zA-Z-]+\.js/g;let i="";do c=t.exec(d),c&&(i+=c+" ");while(c);return i&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron_node ${i}`:d}if(process.platform==="win32"){const d=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substr(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substr(5):g;new Promise((g,M)=>{j(["windows-process-tree"],g,M)}).then(g=>{g.getProcessList(P,M=>{g.getProcessCpuUsage(M,E=>{const o=new Map;E.forEach(u=>{const l=d(u.commandLine||"");o.set(u.pid,{name:I(l),cmd:l,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),p=o.get(P),p?(o.forEach(u=>{const l=o.get(u.ppid);l&&(l.children||(l.children=[]),l.children.push(u))}),o.forEach(u=>{u.children&&(u.children=u.children.sort((l,c)=>l.pid-c.pid))}),r(p)):w(new Error(`Root process ${P} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{function y(){let d=[p];const g=[];for(;d.length;){const E=d.shift();E&&(g.push(E.pid),E.children&&(d=d.concat(E.children)))}let M=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",j).fsPath);M+=" "+g.join(" "),(0,m.exec)(M,{},(E,o,u)=>{if(E||u)w(E||new Error(u.toString()));else{const l=o.toString().split(`
`);for(let c=0;c<g.length;c++){const t=n.get(g[c]);t.load=parseFloat(l[c])}if(!p){w(new Error(`Root process ${P} not found`));return}r(p)}})}(0,m.exec)("which ps",{},(d,g,M)=>{if(d||M)if(process.platform!=="linux")w(d||new Error(M.toString()));else{const E=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/ps.sh",j).fsPath);(0,m.exec)(E,{},(o,u,l)=>{o||l?w(o||new Error(l.toString())):(S(u,b),y())})}else{const E=g.toString().trim(),o="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,m.exec)(`${E} ${o}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,l,c)=>{u||c&&!c.includes("screen size is bogus")?w(u||new Error(c.toString())):(S(l,b),process.platform==="linux"?y():p?r(p):w(new Error(`Root process ${P} not found`)))})}})}})}e.listProcesses=L;function S(P,r){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,p=P.toString().split(`
`);for(const n of p){const b=w.exec(n.trim());b&&b.length===6&&r(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(Q[117],J([0,1,8,24,3,65,2,20]),function(j,e,m,R,L,S,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function w(b,I,y){return n({path:b,isDirectory:!1},I,y)}e.watchFile=w;function p(b,I,y){return n({path:b,isDirectory:!0},I,y)}e.watchFolder=p,e.CHANGE_BUFFER_DELAY=100;function n(b,I,y){const d=(0,m.basename)(b.path),g=new Map;let M=!1,E=[(0,P.toDisposable)(()=>{g.forEach(o=>(0,P.dispose)(o)),g.clear()})];try{const o=(0,R.watch)(b.path);E.push((0,P.toDisposable)(()=>{o.removeAllListeners(),o.close()}));const u=new Set;b.isDirectory&&(0,r.readdir)(b.path).then(l=>l.forEach(c=>u.add(c))),o.on("error",(l,c)=>{M||y(`Failed to watch ${b.path} for changes using fs.watch() (${l}, ${c})`)}),o.on("change",(l,c)=>{if(!M){let t="";if(c&&(t=c.toString(),L.isMacintosh&&(t=(0,S.normalizeNFC)(t))),!(!t||l!=="change"&&l!=="rename")){const i=b.isDirectory?(0,m.join)(b.path,t):b.path;if(b.isDirectory)if(l==="rename"){const s=g.get(i);s&&(0,P.dispose)(s);const a=setTimeout(async()=>{g.delete(i);const h=await(0,r.exists)(i);if(!M){let f;h?u.has(t)?f="changed":(f="added",u.add(t)):(u.delete(t),f="deleted"),I(f,i)}},e.CHANGE_BUFFER_DELAY);g.set(i,(0,P.toDisposable)(()=>clearTimeout(a)))}else{let s;u.has(t)?s="changed":(s="added",u.add(t)),I(s,i)}else if(l==="rename"||t!==d){const s=setTimeout(async()=>{const a=await(0,r.exists)(i);M||(a?(I("changed",i),E=[n(b,I,y)]):I("deleted",i))},e.CHANGE_BUFFER_DELAY);(0,P.dispose)(E),E=[(0,P.toDisposable)(()=>clearTimeout(s))]}else I("changed",i)}}})}catch(o){(0,r.exists)(b.path).then(u=>{u&&!M&&y(`Failed to watch ${b.path} for changes using fs.watch() (${o.toString()})`)})}return(0,P.toDisposable)(()=>{M=!0,E=(0,P.dispose)(E)})}}),define(Q[118],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Q[119],J([0,1,14,118,13]),function(j,e,m,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function S(){m.ipcMain.on(R.CONTEXT_MENU_CHANNEL,(r,w,p,n,b)=>{const I=P(r,n,p);I.popup({window:(0,L.withNullAsUndefined)(m.BrowserWindow.fromWebContents(r.sender)),x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{I&&r.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,w)}})})}e.registerContextMenuListener=S;function P(r,w,p){const n=new m.Menu;return p.forEach(b=>{let I;b.type==="separator"?I=new m.MenuItem({type:b.type}):Array.isArray(b.submenu)?I=new m.MenuItem({submenu:P(r,w,b.submenu),label:b.label}):I=new m.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(y,d,g)=>r.sender.send(w,b.id,g)}),n.append(I)}),n}});var ue=this&&this.__decorate||function(j,e,m,R){var L=arguments.length,S=L<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,m):R,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(j,e,m,R);else for(var r=j.length-1;r>=0;r--)(P=j[r])&&(S=(L<3?P(S):L>3?P(e,m,S):P(e,m))||S);return L>3&&S&&Object.defineProperty(e,m,S),S};define(Q[33],J([0,1,5,2,9,26,18,19,35,13,109,23,46]),function(j,e,m,R,L,S,P,r,w,p,n,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function d(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function M(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(E||(E={}));class o{constructor(A){this.buffer=A,this.pos=0}read(A){const O=this.buffer.slice(this.pos,this.pos+A);return this.pos+=O.byteLength,O}}class u{constructor(){this.buffers=[]}get buffer(){return r.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var l;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object"})(l||(l={}));function c(_){const A=r.VSBuffer.alloc(4);return A.writeUInt32BE(_,0),A}function t(_){return _.read(4).readUInt32BE(0)}function i(_){const A=r.VSBuffer.alloc(1);return A.writeUInt8(_,0),A}const s={Undefined:i(l.Undefined),String:i(l.String),Buffer:i(l.Buffer),VSBuffer:i(l.VSBuffer),Array:i(l.Array),Object:i(l.Object)},a=typeof Buffer!="undefined";function h(_,A){if(typeof A=="undefined")_.write(s.Undefined);else if(typeof A=="string"){const O=r.VSBuffer.fromString(A);_.write(s.String),_.write(c(O.byteLength)),_.write(O)}else if(a&&Buffer.isBuffer(A)){const O=r.VSBuffer.wrap(A);_.write(s.Buffer),_.write(c(O.byteLength)),_.write(O)}else if(A instanceof r.VSBuffer)_.write(s.VSBuffer),_.write(c(A.byteLength)),_.write(A);else if(Array.isArray(A)){_.write(s.Array),_.write(c(A.length));for(const O of A)h(_,O)}else{const O=r.VSBuffer.fromString(JSON.stringify(A));_.write(s.Object),_.write(c(O.byteLength)),_.write(O)}}function f(_){switch(_.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return _.read(t(_)).toString();case l.Buffer:return _.read(t(_)).buffer;case l.VSBuffer:return _.read(t(_));case l.Array:{const O=t(_),k=[];for(let F=0;F<O;F++)k.push(f(_));return k}case l.Object:return JSON.parse(_.read(t(_)).toString())}}class v{constructor(A,O,k=null,F=1e3){this.protocol=A,this.ctx=O,this.logger=k,this.timeoutDelay=F,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(U=>this.onRawMessage(U)),this.sendResponse({type:200})}registerChannel(A,O){this.channels.set(A,O),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const O=this.send([A.type]);this.logger&&this.logger.logOutgoing(O,0,1,M(A.type));return}case 201:case 202:case 204:case 203:{const O=this.send([A.type,A.id],A.data);this.logger&&this.logger.logOutgoing(O,A.id,1,M(A.type),A.data);return}}}send(A,O=void 0){const k=new u;return h(k,A),h(k,O),this.sendBuffer(k.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch(O){return 0}}onRawMessage(A){const O=new o(A),k=f(O),F=f(O),U=k[0];switch(U){case 100:return this.logger&&this.logger.logIncoming(A.byteLength,k[1],1,`${d(U)}: ${k[2]}.${k[3]}`,F),this.onPromise({type:U,id:k[1],channelName:k[2],name:k[3],arg:F});case 102:return this.logger&&this.logger.logIncoming(A.byteLength,k[1],1,`${d(U)}: ${k[2]}.${k[3]}`,F),this.onEventListen({type:U,id:k[1],channelName:k[2],name:k[3],arg:F});case 101:return this.logger&&this.logger.logIncoming(A.byteLength,k[1],1,`${d(U)}`),this.disposeActiveRequest({type:U,id:k[1]});case 103:return this.logger&&this.logger.logIncoming(A.byteLength,k[1],1,`${d(U)}`),this.disposeActiveRequest({type:U,id:k[1]})}}onPromise(A){const O=this.channels.get(A.channelName);if(!O){this.collectPendingRequest(A);return}const k=new S.CancellationTokenSource;let F;try{F=O.call(this.ctx,A.name,A.arg,k.token)}catch(G){F=Promise.reject(G)}const U=A.id;F.then(G=>{this.sendResponse({id:U,data:G,type:201}),this.activeRequests.delete(A.id)},G=>{G instanceof Error?this.sendResponse({id:U,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.sendResponse({id:U,data:G,type:203}),this.activeRequests.delete(A.id)});const K=(0,R.toDisposable)(()=>k.cancel());this.activeRequests.set(A.id,K)}onEventListen(A){const O=this.channels.get(A.channelName);if(!O){this.collectPendingRequest(A);return}const k=A.id,U=O.listen(this.ctx,A.name,A.arg)(K=>this.sendResponse({id:k,data:K,type:204}));this.activeRequests.set(A.id,U)}disposeActiveRequest(A){const O=this.activeRequests.get(A.id);O&&(O.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let O=this.pendingRequests.get(A.channelName);O||(O=[],this.pendingRequests.set(A.channelName,O));const k=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:A,timeoutTimer:k})}flushPendingRequests(A){const O=this.pendingRequests.get(A);if(O){for(const k of O)switch(clearTimeout(k.timeoutTimer),k.request.type){case 100:this.onPromise(k.request);break;case 102:this.onEventListen(k.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}e.ChannelServer=v;var D;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));class T{constructor(A,O=null){this.protocol=A,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(k=>this.onBuffer(k)),this.logger=O}getChannel(A){const O=this;return{call(k,F,U){return O.isDisposed?Promise.reject(P.canceled()):O.requestPromise(A,k,F,U)},listen(k,F){return O.isDisposed?Promise.reject(P.canceled()):O.requestEvent(A,k,F)}}}requestPromise(A,O,k,F=S.CancellationToken.None){const U=this.lastRequestId++,G={id:U,type:100,channelName:A,name:O,arg:k};if(F.isCancellationRequested)return Promise.reject(P.canceled());let Y;return new Promise((ne,se)=>{if(F.isCancellationRequested)return se(P.canceled());const re=()=>{const we=Se=>{switch(Se.type){case 201:this.handlers.delete(U),ne(Se.data);break;case 202:this.handlers.delete(U);const Ae=new Error(Se.data.message);Ae.stack=Se.data.stack,Ae.name=Se.data.name,se(Ae);break;case 203:this.handlers.delete(U),se(Se.data);break}};this.handlers.set(U,we),this.sendRequest(G)};let te=null;this.state===E.Idle?re():(te=(0,L.createCancelablePromise)(we=>this.whenInitialized()),te.then(()=>{te=null,re()}));const le=()=>{te?(te.cancel(),te=null):this.sendRequest({id:U,type:101}),se(P.canceled())},ve=F.onCancellationRequested(le);Y=(0,R.combinedDisposable)((0,R.toDisposable)(le),ve),this.activeRequests.add(Y)}).finally(()=>{this.activeRequests.delete(Y)})}requestEvent(A,O,k){const F=this.lastRequestId++,K={id:F,type:102,channelName:A,name:O,arg:k};let G=null;const Y=new m.Emitter({onFirstListenerAdd:()=>{G=(0,L.createCancelablePromise)(ne=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(Y),this.sendRequest(K)})},onLastListenerRemove:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(Y),this.sendRequest({id:F,type:103}))}}),Z=ne=>Y.fire(ne.data);return this.handlers.set(F,Z),Y.event}sendRequest(A){switch(A.type){case 100:case 102:{const O=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger&&this.logger.logOutgoing(O,A.id,0,`${d(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const O=this.send([A.type,A.id]);this.logger&&this.logger.logOutgoing(O,A.id,0,d(A.type));return}}}send(A,O=void 0){const k=new u;return h(k,A),h(k,O),this.sendBuffer(k.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch(O){return 0}}onBuffer(A){const O=new o(A),k=f(O),F=f(O),U=k[0];switch(U){case 200:return this.logger&&this.logger.logIncoming(A.byteLength,0,0,M(U)),this.onResponse({type:k[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(A.byteLength,k[1],0,M(U),F),this.onResponse({type:k[0],id:k[1],data:F})}}onResponse(A){if(A.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(A.id);O&&O(A)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===E.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}ue([I.memoize],T.prototype,"onDidInitializePromise",null),e.ChannelClient=T;class W{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:O,onDidClientDisconnect:k})=>{m.Event.once(O.onMessage)(U=>{const K=new o(U),G=f(K),Y=new v(O,G),Z=new T(O);this.channels.forEach((se,re)=>Y.registerChannel(re,se));const ne={channelServer:Y,channelClient:Z,ctx:G};this._connections.add(ne),this._onDidAddConnection.fire(ne),k(()=>{Y.dispose(),Z.dispose(),this._connections.delete(ne),this._onDidRemoveConnection.fire(ne)})})})}get connections(){const A=[];return this._connections.forEach(O=>A.push(O)),A}getChannel(A,O){const k=this;return{call(F,U,K){let G;if((0,p.isFunction)(O)){let Z=(0,w.getRandomElement)(k.connections.filter(O));G=Z?Promise.resolve(Z):m.Event.toPromise(m.Event.filter(k.onDidAddConnection,O))}else G=O.routeCall(k,F,U);const Y=G.then(Z=>Z.channelClient.getChannel(A));return X(Y).call(F,U,K)},listen(F,U){if((0,p.isFunction)(O))return k.getMulticastEvent(A,O,F,U);const K=O.routeEvent(k,F,U).then(G=>G.channelClient.getChannel(A));return X(K).listen(F,U)}}}getMulticastEvent(A,O,k,F){const U=this;let K=new R.DisposableStore;const G=new m.Emitter({onFirstListenerAdd:()=>{K=new R.DisposableStore;const Y=new m.EventMultiplexer,Z=new Map,ne=re=>{const le=re.channelClient.getChannel(A).listen(k,F),ve=Y.add(le);Z.set(re,ve)},se=re=>{const te=Z.get(re);!te||(te.dispose(),Z.delete(re))};U.connections.filter(O).forEach(ne),m.Event.filter(U.onDidAddConnection,O)(ne,void 0,K),U.onDidRemoveConnection(se,void 0,K),Y.event(G.fire,G,K),K.add(Y)},onLastListenerRemove:()=>{K.dispose()}});return G.event}registerChannel(A,O){this.channels.set(A,O),this._connections.forEach(k=>{k.channelServer.registerChannel(A,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=W;class ${constructor(A,O,k=null){const F=new u;h(F,O),A.send(F.buffer),this.channelClient=new T(A,k),this.channelServer=new v(A,O,k)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,O){this.channelServer.registerChannel(A,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=$;function X(_){return{call(A,O,k){return _.then(F=>F.call(A,O,k))},listen(A,O){const k=new m.Relay;return _.then(F=>k.input=F.listen(A,O)),k.event}}}e.getDelayedChannel=X;function x(_){let A=!1;return{call(O,k,F){return A?_.call(O,k,F):(0,L.timeout)(0).then(()=>A=!0).then(()=>_.call(O,k,F))},listen(O,k){if(A)return _.listen(O,k);const F=new m.Relay;return(0,L.timeout)(0).then(()=>A=!0).then(()=>F.input=_.listen(O,k)),F.event}}}e.getNextTickChannel=x;class oe{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const O of A.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await m.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=oe;var q;(function(_){function A(F,U){const K=F,G=U&&U.disableMarshalling,Y=new Map;for(const Z in K)k(Z)&&Y.set(Z,m.Event.buffer(K[Z],!0));return new class{listen(Z,ne){const se=Y.get(ne);if(se)return se;throw new Error(`Event not found: ${ne}`)}call(Z,ne,se){const re=K[ne];if(typeof re=="function"){if(!G&&Array.isArray(se))for(let te=0;te<se.length;te++)se[te]=(0,n.revive)(se[te]);return re.apply(K,se)}throw new Error(`Method not found: ${ne}`)}}}_.fromService=A;function O(F,U){const K=U&&U.disableMarshalling;return new Proxy({},{get(G,Y){var Z;if(typeof Y=="string")return((Z=U==null?void 0:U.properties)===null||Z===void 0?void 0:Z.has(Y))?U.properties.get(Y):k(Y)?F.listen(Y):async function(...ne){let se;U&&!(0,p.isUndefinedOrNull)(U.context)?se=[U.context,...ne]:se=ne;const re=await F.call(Y,se);return K?re:(0,n.revive)(re)};throw new Error(`Property not found: ${String(Y)}`)}})}_.toService=O;function k(F){return F[0]==="o"&&F[1]==="n"&&b.isUpperAsciiLetter(F.charCodeAt(2))}})(q=e.ProxyChannel||(e.ProxyChannel={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){let A=_.toString();if(A!=="[object Object]")return A}return _}function C(_){return Array.isArray(_)?_.map(B):B(_)}function z(_,A,O,k,F,U,K){K=C(K);const G=N[F],Y=G[k%G.length];let Z=[`%c[${_}]%c[${String(A).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(k).padStart(5," ")} - ${U}`,"color: darkgreen","color: grey","color: grey",`color: ${Y}`];/\($/.test(U)?(Z=Z.concat(K),Z.push(")")):Z.push(K),console.log.apply(console,Z)}e.logWithColors=z;class V{constructor(A,O){this._outgoingPrefix=A,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,O,k,F,U){this._totalOutgoing+=A,z(this._outgoingPrefix,this._totalOutgoing,A,O,k,F,U)}logIncoming(A,O,k,F,U){this._totalIncoming+=A,z(this._incomingPrefix,this._totalIncoming,A,O,k,F,U)}}e.IPCLogger=V}),define(Q[120],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class m{constructor(L,S){this.sender=L,this.onMessage=S}send(L){try{this.sender.send("vscode:message",L.buffer)}catch(S){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=m}),define(Q[121],J([0,1,5,33,19]),function(j,e,m,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class S{constructor(w){this.port=w,this.onMessage=m.Event.fromDOMEventEmitter(this.port,"message",p=>L.VSBuffer.wrap(p.data)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}e.Protocol=S;class P extends R.IPCClient{constructor(w,p){const n=new S(w);super(n,p);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=P}),define(Q[83],J([0,1,5,33,2,19,3,32]),function(j,e,m,R,L,S,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let w=null;function p(){return w||(w=S.VSBuffer.alloc(0)),w}class n{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,a){if(s===0)return p();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const D=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=s),D}if(this._chunks[0].byteLength>s){const D=this._chunks[0].slice(0,s);return a&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),D}let h=S.VSBuffer.alloc(s),f=0,v=0;for(;s>0;){const D=this._chunks[v];if(D.byteLength>s){const T=D.slice(0,s);h.set(T,f),f+=s,a&&(this._chunks[v]=D.slice(s),this._totalLength-=s),s-=s}else h.set(D,f),f+=D.byteLength,a?(this._chunks.shift(),this._totalLength-=D.byteLength):v++,s-=D.byteLength}return h}}e.ChunkStream=n;var b;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.KeepAlive=4]="KeepAlive",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest"})(b||(b={}));var I;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",i[i.KeepAliveTime=5e3]="KeepAliveTime",i[i.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(I=e.ProtocolConstants||(e.ProtocolConstants={}));class y{constructor(s,a,h,f){this.type=s,this.id=a,this.ack=h,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends L.Disposable{constructor(s){super();this._onMessage=this._register(new m.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new n,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const h=this._state.messageType,f=this._state.id,v=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new y(h,f,v,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(!this._isDisposed){s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=S.VSBuffer.alloc(13);a.writeUInt8(s.type,0),a.writeUInt32BE(s.id,1),a.writeUInt32BE(s.ack,5),a.writeUInt32BE(s.data.byteLength,9),this._writeSoon(a,s.data)}}_bufferAdd(s,a){const h=this._totalLength===0;return this._data.push(s,a),this._totalLength+=s.byteLength+a.byteLength,h}_bufferTake(){const s=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,a){this._bufferAdd(s,a)&&P.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class M extends L.Disposable{constructor(s){super();this._onMessage=new m.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new m.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new y(1,0,0,s))}}e.Protocol=M;class E extends R.IPCClient{constructor(s,a,h=null){super(s,a,h);this.protocol=s}static fromSocket(s,a){return new E(new M(s),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=E;class o{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new m.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,r.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=o;class u{constructor(s){this.data=s,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],a=0,h=this._first;for(;h;)s[a++]=h.data,h=h.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const a=new u(s);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class c{constructor(){this.lastRuns=[];const s=Date.now();for(let a=0;a<c._HISTORY_LENGTH;a++)this.lastRuns[a]=s-1e3*a;setInterval(()=>{for(let a=c._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return c._INSTANCE||(c._INSTANCE=new c),c._INSTANCE}load(){const s=Date.now(),a=(1+c._HISTORY_LENGTH)*1e3;let h=0;for(let f=0;f<c._HISTORY_LENGTH;f++)s-this.lastRuns[f]<=a&&h++;return 1-h/c._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}c._HISTORY_LENGTH=10,c._INSTANCE=null;class t{constructor(s,a=null){this._loadEstimator=c.getInstance(),this._onControlMessage=new o,this.onControlMessage=this._onControlMessage.event,this._onMessage=new o,this.onMessage=this._onMessage.event,this._onDidDispose=new o,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new o,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new o,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new y(5,0,0,p());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const a=new y(4,0,0,p());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,a){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let a=0,h=s.length;a<h;a++)this._socketWriter.write(s[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new y(6,0,0,p())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const a=this._outgoingUnackMsg.toArray();for(let h=0,f=a.length;h<f;h++)this._socketWriter.write(a[h]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const h=new y(1,a,this._incomingAckId,s);this._outgoingUnackMsg.push(h),this._isReconnecting||(this._socketWriter.write(h),this._recvAckCheck())}sendControl(s){const a=new y(2,0,0,s);this._socketWriter.write(a)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const s=this._outgoingUnackMsg.peek(),a=Date.now()-s.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const s=new y(3,0,this._incomingAckId,p());this._socketWriter.write(s)}}}e.PersistentProtocol=t}),define(Q[122],J([0,1,14,5,33,120,2,19]),function(j,e,m,R,L,S,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function w(n,b){const I=R.Event.fromNodeEventEmitter(m.ipcMain,b,(d,g)=>({event:d,message:g})),y=R.Event.filter(I,({event:d})=>d.sender.id===n);return R.Event.map(y,({message:d})=>d&&r.VSBuffer.wrap(d))}class p extends L.IPCServer{constructor(){super(p.getOnDidClientConnect())}static getOnDidClientConnect(){const b=R.Event.fromNodeEventEmitter(m.ipcMain,"vscode:hello",({sender:I})=>I);return R.Event.map(b,I=>{const y=I.id,d=p.Clients.get(y);d&&d.dispose();const g=new R.Emitter;p.Clients.set(y,(0,P.toDisposable)(()=>g.fire()));const M=w(y,"vscode:message"),E=R.Event.any(R.Event.signal(w(y,"vscode:disconnect")),g.event);return{protocol:new S.Protocol(I,M),onDidClientDisconnect:E}})}}e.Server=p,p.Clients=new Map}),define(Q[84],J([0,1,14,5,28,121]),function(j,e,m,R,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class P extends S.Client{constructor(p,n){super({addEventListener:(b,I)=>p.addListener(b,I),removeEventListener:(b,I)=>p.removeListener(b,I),postMessage:b=>p.postMessage(b),start:()=>p.start(),close:()=>p.close()},n)}}e.Client=P;async function r(w){if(w.isDestroyed()||w.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const p=(0,L.generateUuid)();w.webContents.send("vscode:createMessageChannel",p);const n=R.Event.fromNodeEventEmitter(m.ipcMain,"vscode:createMessageChannelResult",(I,y)=>({nonce:y,port:I.ports[0]})),{port:b}=await R.Event.toPromise(R.Event.once(R.Event.filter(n,I=>I.nonce===p)));return b}e.connect=r}),define(Q[85],J([0,1,2,5,9,13]),function(j,e,m,R,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var P;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(P=e.StorageHint||(e.StorageHint={}));var r;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(r||(r={}));class w extends m.Disposable{constructor(b,I=Object.create(null)){super();this.database=b,this.options=I,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=r.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(b=>this.onDidChangeItemsExternal(b)))}onDidChangeItemsExternal(b){var I,y;(I=b.changed)===null||I===void 0||I.forEach((d,g)=>this.accept(g,d)),(y=b.deleted)===null||y===void 0||y.forEach(d=>this.accept(d,void 0))}accept(b,I){if(this.state!==r.Closed){let y=!1;(0,S.isUndefinedOrNull)(I)?y=this.cache.delete(b):this.cache.get(b)!==I&&(this.cache.set(b,I),y=!0),y&&this._onDidChangeStorage.fire(b)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===r.None&&(this.state=r.Initialized,this.options.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(b,I){const y=this.cache.get(b);return(0,S.isUndefinedOrNull)(y)?I:y}getBoolean(b,I){const y=this.get(b);return(0,S.isUndefinedOrNull)(y)?I:y==="true"}getNumber(b,I){const y=this.get(b);return(0,S.isUndefinedOrNull)(y)?I:parseInt(y,10)}async set(b,I){if(this.state!==r.Closed){if((0,S.isUndefinedOrNull)(I))return this.delete(b);const y=String(I);if(this.cache.get(b)!==y)return this.cache.set(b,y),this.pendingInserts.set(b,y),this.pendingDeletes.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(b){if(this.state!==r.Closed&&!!this.cache.delete(b))return this.pendingDeletes.has(b)||this.pendingDeletes.add(b),this.pendingInserts.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=r.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(b){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const b={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(b).finally(()=>{var I;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(I=this.whenFlushedCallbacks.pop())===null||I===void 0||I()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(b=>this.whenFlushedCallbacks.push(b))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class p{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(b){b.insert&&b.insert.forEach((I,y)=>this.items.set(y,I)),b.delete&&b.delete.forEach(I=>this.items.delete(I))}async close(){}}e.InMemoryStorageDatabase=p}),define(Q[123],J([0,1,24,5,9,36,8,20]),function(j,e,m,R,L,S,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class w{constructor(b,I=Object.create(null)){this.path=b,this.options=I,this.name=(0,P.basename)(this.path),this.logger=new p(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return R.Event.None}async getItems(){const b=await this.whenConnected,I=new Map;return(await this.all(b,"SELECT * FROM ItemTable")).forEach(d=>I.set(d.key,d.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${I.size} rows`),I}async updateItems(b){const I=await this.whenConnected;return this.doUpdateItems(I,b)}doUpdateItems(b,I){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${I.insert?(0,S.mapToString)(I.insert):"0"}), delete(${I.delete?(0,S.setToString)(I.delete):"0"})`),this.transaction(b,()=>{const y=I.insert,d=I.delete;if(y&&y.size>0){const g=[];g.push([]);let M=0;y.forEach((E,o)=>{let u=g[M];u.length>w.MAX_HOST_PARAMETERS&&(M++,u=[],g.push(u)),u.push(o,E)}),g.forEach(E=>{this.prepare(b,`INSERT INTO ItemTable VALUES ${new Array(E.length/2).fill("(?,?)").join(",")}`,o=>o.run(E),()=>{const o=[];let u=0;return y.forEach((l,c)=>{o.push(c),u+=l.length}),`Keys: ${o.join(", ")} Length: ${u}`})})}if(d&&d.size){const g=[];g.push([]);let M=0;d.forEach(E=>{let o=g[M];o.length>w.MAX_HOST_PARAMETERS&&(M++,o=[],g.push(o)),o.push(E)}),g.forEach(E=>{this.prepare(b,`DELETE FROM ItemTable WHERE key IN (${new Array(E.length).fill("?").join(",")})`,o=>o.run(E),()=>{const o=[];return d.forEach(u=>{o.push(u)}),`Keys: ${o.join(", ")}`})})}})}async close(b){this.logger.trace(`[storage ${this.name}] close()`);const I=await this.whenConnected;return this.doClose(I,b)}doClose(b,I){return new Promise((y,d)=>{b.db.close(g=>(g&&this.handleSQLiteError(b,`[storage ${this.name}] close(): ${g}`),this.path===w.IN_MEMORY_PATH?y():!b.isErroneous&&!b.isInMemory?this.backup().then(y,M=>(this.logger.error(`[storage ${this.name}] backup(): ${M}`),y())):typeof I=="function"?m.promises.unlink(this.path).then(()=>this.doConnect(this.path).then(M=>{const E=()=>this.doClose(M,void 0);return this.doUpdateItems(M,{insert:I()}).then(()=>E(),o=>(E(),Promise.reject(o)))})).then(y,d):d(g||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const b=this.toBackupPath(this.path);return(0,r.copy)(this.path,b,{preserveSymlinks:!1})}toBackupPath(b){return`${b}.backup`}async checkIntegrity(b){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${b})`);const I=await this.whenConnected,y=await this.get(I,b?"PRAGMA integrity_check":"PRAGMA quick_check"),d=b?y.integrity_check:y.quick_check;return I.isErroneous?`${d} (last error: ${I.lastError})`:I.isInMemory?`${d} (in-memory!)`:d}async connect(b,I=!0){this.logger.trace(`[storage ${this.name}] open(${b}, retryOnBusy: ${I})`);try{return await this.doConnect(b)}catch(y){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&I)return await(0,L.timeout)(w.BUSY_OPEN_TIMEOUT),this.connect(b,!1);try{await m.promises.unlink(b);try{await m.promises.rename(this.toBackupPath(b),b)}catch(d){}return await this.doConnect(b)}catch(d){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${d}`),this.doConnect(w.IN_MEMORY_PATH)}}}handleSQLiteError(b,I){b.isErroneous=!0,b.lastError=I,this.logger.error(I)}doConnect(b){return new Promise((I,y)=>{new Promise((d,g)=>{j(["vscode-sqlite3"],d,g)}).then(d=>{const g={db:new(this.logger.isTracing?d.verbose().Database:d.Database)(b,M=>M?g.db?g.db.close(()=>y(M)):y(M):this.exec(g,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>I(g),E=>g.db.close(()=>y(E)))),isInMemory:b===w.IN_MEMORY_PATH};g.db.on("error",M=>this.handleSQLiteError(g,`[storage ${this.name}] Error (event): ${M}`)),this.logger.isTracing&&g.db.on("trace",M=>this.logger.trace(`[storage ${this.name}] Trace (event): ${M}`))},y)})}exec(b,I){return new Promise((y,d)=>{b.db.exec(I,g=>g?(this.handleSQLiteError(b,`[storage ${this.name}] exec(): ${g}`),d(g)):y())})}get(b,I){return new Promise((y,d)=>{b.db.get(I,(g,M)=>g?(this.handleSQLiteError(b,`[storage ${this.name}] get(): ${g}`),d(g)):y(M))})}all(b,I){return new Promise((y,d)=>{b.db.all(I,(g,M)=>g?(this.handleSQLiteError(b,`[storage ${this.name}] all(): ${g}`),d(g)):y(M))})}transaction(b,I){return new Promise((y,d)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),I(),b.db.run("END TRANSACTION",g=>g?(this.handleSQLiteError(b,`[storage ${this.name}] transaction(): ${g}`),d(g)):y())})})}prepare(b,I,y,d){const g=b.db.prepare(I),M=E=>{this.handleSQLiteError(b,`[storage ${this.name}] prepare(): ${E} (${I}). Details: ${d()}`)};g.on("error",M),y(g),g.finalize(E=>{E&&M(E),g.removeListener("error",M)})}}e.SQLiteStorageDatabase=w,w.IN_MEMORY_PATH=":memory:",w.BUSY_OPEN_TIMEOUT=2e3,w.MAX_HOST_PARAMETERS=256;class p{constructor(b){b&&typeof b.logTrace=="function"&&process.env[p.VSCODE_TRACE_STORAGE]&&(this.logTrace=b.logTrace),b&&typeof b.logError=="function"&&(this.logError=b.logError)}get isTracing(){return!!this.logTrace}trace(b){this.logTrace&&this.logTrace(b)}error(b){this.logError&&this.logError(b)}}p.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Q[124],J([12,11]),function(j,e){return j.create("vs/base/common/date",e)}),define(Q[125],J([0,1,124]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,L=R*60,S=L*24,P=S*7,r=S*30,w=S*365;function p(b,I){typeof b!="number"&&(b=b.getTime());const y=Math.round((new Date().getTime()-b)/1e3);if(y<-30)return(0,m.localize)(0,null,p(new Date().getTime()+y*1e3,!1));if(y<30)return(0,m.localize)(1,null);let d;return y<R?(d=y,I?d===1?(0,m.localize)(2,null,d):(0,m.localize)(3,null,d):d===1?(0,m.localize)(4,null,d):(0,m.localize)(5,null,d)):y<L?(d=Math.floor(y/R),I?d===1?(0,m.localize)(6,null,d):(0,m.localize)(7,null,d):d===1?(0,m.localize)(8,null,d):(0,m.localize)(9,null,d)):y<S?(d=Math.floor(y/L),I?d===1?(0,m.localize)(10,null,d):(0,m.localize)(11,null,d):d===1?(0,m.localize)(12,null,d):(0,m.localize)(13,null,d)):y<P?(d=Math.floor(y/S),I?d===1?(0,m.localize)(14,null,d):(0,m.localize)(15,null,d):d===1?(0,m.localize)(16,null,d):(0,m.localize)(17,null,d)):y<r?(d=Math.floor(y/P),I?d===1?(0,m.localize)(18,null,d):(0,m.localize)(19,null,d):d===1?(0,m.localize)(20,null,d):(0,m.localize)(21,null,d)):y<w?(d=Math.floor(y/r),I?d===1?(0,m.localize)(22,null,d):(0,m.localize)(23,null,d):d===1?(0,m.localize)(24,null,d):(0,m.localize)(25,null,d)):(d=Math.floor(y/w),I?d===1?(0,m.localize)(26,null,d):(0,m.localize)(27,null,d):d===1?(0,m.localize)(28,null,d):(0,m.localize)(29,null,d))}e.fromNow=p;function n(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(Q[126],J([12,11]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(Q[67],J([0,1,126,13,35]),function(j,e,m,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(p,n){return n&&(p.stack||p.stacktrace)?m.localize(0,null,r(p),P(p.stack)||P(p.stacktrace)):r(p)}function P(p){return Array.isArray(p)?p.join(`
`):p}function r(p){return typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?m.localize(1,null,p.message):p.message||m.localize(2,null)}function w(p=null,n=!1){if(!p)return m.localize(3,null);if(Array.isArray(p)){const b=L.coalesce(p),I=w(b[0],n);return b.length>1?m.localize(4,null,I,b.length):I}if(R.isString(p))return p;if(p.detail){const b=p.detail;if(b.error)return S(b.error,n);if(b.exception)return S(b.exception,n)}return p.stack?S(p,n):p.message?p.message:m.localize(5,null)}e.toErrorMessage=w}),define(Q[127],J([12,11]),function(j,e){return j.create("vs/base/common/keybindingLabels",e)}),define(Q[128],J([0,1,127]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class R{constructor(P,r,w=r){this.modifierLabels=[null],this.modifierLabels[2]=P,this.modifierLabels[1]=r,this.modifierLabels[3]=w}toLabel(P,r,w){if(r.length===0)return null;const p=[];for(let n=0,b=r.length;n<b;n++){const I=r[n],y=w(I);if(y===null)return null;p[n]=L(I,y,this.modifierLabels[P])}return p.join(" ")}}e.ModifierLabelProvider=R,e.UILabelProvider=new R({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:m.localize(0,null),shiftKey:m.localize(1,null),altKey:m.localize(2,null),metaKey:m.localize(3,null),separator:"+"},{ctrlKey:m.localize(4,null),shiftKey:m.localize(5,null),altKey:m.localize(6,null),metaKey:m.localize(7,null),separator:"+"}),e.AriaLabelProvider=new R({ctrlKey:m.localize(8,null),shiftKey:m.localize(9,null),altKey:m.localize(10,null),metaKey:m.localize(11,null),separator:"+"},{ctrlKey:m.localize(12,null),shiftKey:m.localize(13,null),altKey:m.localize(14,null),metaKey:m.localize(15,null),separator:"+"},{ctrlKey:m.localize(16,null),shiftKey:m.localize(17,null),altKey:m.localize(18,null),metaKey:m.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new R({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new R({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function L(S,P,r){if(P===null)return"";const w=[];return S.ctrlKey&&w.push(r.ctrlKey),S.shiftKey&&w.push(r.shiftKey),S.altKey&&w.push(r.altKey),S.metaKey&&w.push(r.metaKey),P!==""&&w.push(P),w.join(r.separator)}}),define(Q[129],J([12,11]),function(j,e){return j.create("vs/base/node/processes",e)}),define(Q[68],J([0,1,8,24,20,45,129,32,13,44,30,3,81,10]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function d(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(c,t){if(b.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};t&&(i.cwd=t);const s=S.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],i);return new Promise(a=>{s.once("error",h=>{a({success:!1,error:h})}),s.once("exit",(h,f)=>{a(h===0?{success:!0}:{success:!1,code:h!==null?h:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?d(i.status):1})}else if(b.isLinux||b.isMacintosh)try{const i=y.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(s=>{S.execFile(i,[c.pid.toString()],{encoding:"utf8",shell:!0},(a,h,f)=>{s(a?{success:!1,error:a}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function M(c=r.env){return c.comspec||"cmd.exe"}e.getWindowsShell=M;class E{constructor(t,i,s,a){if(i!==void 0&&s!==void 0&&a!==void 0)this.cmd=t,this.args=i,this.shell=s,this.options=a;else{const h=t;this.cmd=h.command,this.shell=h.isShellCommand,this.args=h.args.slice(0),this.options=h.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const h=Object.create(null);Object.keys(r.env).forEach(f=>{h[f]=r.env[f]}),Object.keys(this.options.env).forEach(f=>{h[f]=this.options.env[f]}),this.options.env=h}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const i=t.lastIndexOf(m.sep);return i!==-1&&(t=t.substring(i+1)),E.WellKnowCommands[t]?t:"other"}start(t){return b.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(r.cwd()))?Promise.reject(new Error(P.localize(0,null))):this.useExec().then(i=>{let s,a;const h=new Promise((f,v)=>{s=f,a=v});if(i){let f=this.cmd;this.args&&(f=f+" "+this.args.join(" ")),this.childProcess=S.exec(f,this.options,(v,D,T)=>{this.childProcess=null;const W=v;W&&W.killed?a({killed:this.terminateRequested,stdout:D.toString(),stderr:T.toString()}):this.handleExec(s,t,v,D,T)})}else{let f=null;const v=D=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(D,s,t,a);const T={terminated:this.terminateRequested};w.isNumber(D)&&(T.cmdCode=D),s(T)};if(this.shell&&b.isWindows){const D=p.deepClone(this.options);D.windowsVerbatimArguments=!0,D.detached=!1;let T=!1,W=!1;const $=[];let X=this.ensureQuotes(this.cmd);$.push(X.value),T=X.quoted,this.args&&this.args.forEach(oe=>{X=this.ensureQuotes(oe),$.push(X.value),W=W&&X.quoted});const x=["/s","/c"];T?W?x.push('"'+$.join(" ")+'"'):$.length>1?x.push('"'+$[0]+'" '+$.slice(1).join(" ")):x.push('"'+$[0]+'"'):x.push($.join(" ")),f=S.spawn(M(),x,D)}else this.cmd&&(f=S.spawn(this.cmd,this.args,this.options));f&&(this.childProcess=f,this.childProcessPromise=Promise.resolve(f),this.pidResolve&&(this.pidResolve(w.isNumber(f.pid)?f.pid:-1),this.pidResolve=void 0),f.on("error",D=>{this.childProcess=null,a({terminated:this.terminateRequested,error:D})}),f.pid&&(this.childProcess.on("close",v),this.handleSpawn(f,s,t,a,!0)))}return h})}handleClose(t,i,s,a){}ensureQuotes(t){return E.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,g(t,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!b.isWindows)return t(!1);const i=S.spawn(M(),["/s","/c"]);i.on("error",s=>t(!0)),i.on("exit",s=>t(!1))})}}e.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class o extends E{constructor(t,i,s,a){super(t,i,s,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,i,s,a,h){[a,h].forEach((f,v)=>{const D=new I.LineDecoder;D.write(f).forEach($=>{i({line:$,source:v===0?0:1})});const W=D.end();W&&i({line:W,source:v===0?0:1})}),t({terminated:this.terminateRequested,error:s})}handleSpawn(t,i,s,a,h){const f=new I.LineDecoder,v=new I.LineDecoder;t.stdout.on("data",D=>{f.write(D).forEach(W=>s({line:W,source:0}))}),t.stderr.on("data",D=>{v.write(D).forEach(W=>s({line:W,source:1}))}),this.stdoutLineDecoder=f,this.stderrLineDecoder=v}handleClose(t,i,s,a){const h=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;h&&s({line:h,source:0});const f=this.stderrLineDecoder?this.stderrLineDecoder.end():null;f&&s({line:f,source:1})}}e.LineProcess=o;function u(c){let t=[],i=!1;const s=function(a){if(i){t.push(a);return}(!c.send(a,f=>{if(f&&console.error(f),i=!1,t.length>0){const v=t.slice(0);t=[],v.forEach(D=>s(D))}})||b.isWindows)&&(i=!0)};return{send:s}}e.createQueuedSender=u;var l;(function(c){async function t(i,s,a){if(m.isAbsolute(i))return i;if(s===void 0&&(s=r.cwd()),m.dirname(i)!=="."||(a===void 0&&w.isString(r.env.PATH)&&(a=r.env.PATH.split(m.delimiter)),a===void 0||a.length===0))return m.join(s,i);async function f(v){return await L.exists(v)?!(await R.promises.stat(v)).isDirectory():!1}for(let v of a){let D;if(m.isAbsolute(v)?D=m.join(v,i):D=m.join(s,v,i),await f(D))return D;let T=D+".com";if(await f(T)||(T=D+".exe",await f(T)))return T}return m.join(s,i)}c.findExecutable=t})(l=e.win32||(e.win32={}))}),define(Q[130],J([0,1,27,3,116,68]),function(j,e,m,R,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function P(y,d){return y===1?R.isWindows?b():S.getWindowsShell(d):p(y,d)}e.getSystemShell=P;function r(y,d){return y===1?R.isWindows?I(d):S.getWindowsShell(d):p(y,d)}e.getSystemShellSync=r;let w=null;function p(y,d){if(R.isLinux&&y===2||R.isMacintosh&&y===3)return"/bin/bash";if(!w){let g;if(R.isWindows)g="/bin/bash";else{if(g=d.SHELL,!g)try{g=(0,m.userInfo)().shell}catch(M){}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}w=g}return w}let n=null;async function b(){return n||(n=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),n}function I(y){if(n)return n;const d=R.isWindows&&parseFloat((0,m.release)())>=10,g=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),M=`${y.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?M:S.getWindowsShell(y)}}),define(Q[86],J([0,1,45,2,9,44,5,68,33,108,26,18,19,3]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends w.ChannelServer{constructor(E){super({send:o=>{try{process.send&&process.send(o.buffer.toString("base64"))}catch(u){}},onMessage:P.Event.fromNodeEventEmitter(process,"message",o=>I.VSBuffer.wrap(Buffer.from(o,"base64")))},E);process.once("disconnect",()=>this.dispose())}}e.Server=d;class g{constructor(E,o){this.modulePath=E,this.options=o,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new P.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const u=o&&o.timeout?o.timeout:6e4;this.disposeDelayer=new L.Delayer(u),this.child=null,this._client=null}getChannel(E){const o=this;return{call(u,l,c){return o.requestPromise(E,u,l,c)},listen(u,l){return o.requestEvent(E,u,l)}}}requestPromise(E,o,u,l=n.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(E),t=(0,L.createCancelablePromise)(a=>c.call(o,u,a)),i=l.onCancellationRequested(()=>t.cancel()),s=(0,R.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{i.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(E,o,u){if(!this.disposeDelayer)return P.Event.None;this.disposeDelayer.cancel();let l;const c=new P.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(E).listen(o,u)(c.fire,c),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],o=Object.create(null);o.env=Object.assign(Object.assign({},(0,S.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(o.env=Object.assign(Object.assign({},o.env),this.options.env)),this.options&&this.options.freshExecArgv&&(o.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(o.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(o.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),o.execArgv===void 0&&(o.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h))),y.isMacintosh&&o.env&&delete o.env.DYLD_LIBRARY_PATH,this.child=(0,m.fork)(this.modulePath,E,o);const u=new P.Emitter;P.Event.fromNodeEventEmitter(this.child,"message",h=>h)(h=>{if((0,p.isRemoteConsoleLog)(h)){(0,p.log)(h,`IPC Library: ${this.options.serverName}`);return}u.fire(I.VSBuffer.wrap(Buffer.from(h,"base64")))});const c=this.options.useQueue?(0,r.createQueuedSender)(this.child):this.child,t=h=>this.child&&this.child.connected&&c.send(h.buffer.toString("base64")),i=u.event,s={send:t,onMessage:i};this._client=new w.ChannelClient(s);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",h=>console.warn('IPC "'+this.options.serverName+'" errored with '+h)),this.child.on("exit",(h,f)=>{process.removeListener("exit",a),this.activeRequests.forEach(v=>(0,R.dispose)(v)),this.activeRequests.clear(),h!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+h+" and signal "+f),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:h,signal:f})})}return this._client}getCachedChannel(E){let o=this.channels.get(E);return o||(o=this.client.getChannel(E),this.channels.set(E,o)),o}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(Q[131],J([12,11]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(Q[132],J([12,11]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[133],J([12,11]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Q[134],J([12,11]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(Q[135],J([12,11]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(Q[136],J([12,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[137],J([12,11]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[138],J([12,11]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Q[139],J([12,11]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(Q[140],J([12,11]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(Q[141],J([12,11]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(Q[142],J([12,11]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[143],J([12,11]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Q[144],J([12,11]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(Q[145],J([12,11]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(Q[146],J([12,11]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[147],J([12,11]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(Q[148],J([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/window",e)}),define(Q[149],J([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Q[150],J([12,11]),function(j,e){return j.create("vs/platform/workspaces/common/workspaces",e)}),define(Q[151],J([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Q[152],J([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Q[153],J([0,1,5,2]),function(j,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class L{constructor(){this._onCloseEmitter=new m.Emitter,this._onReloadEmitter=new m.Emitter,this._onTerminateEmitter=new m.Emitter,this._onAttachEmitter=new m.Emitter}call(r,w,p){switch(w){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:p[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:p[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:p[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:p[0],port:p[1],subId:p[2]}))}throw new Error("Method not implemented.")}listen(r,w,p){switch(w){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=L,L.ChannelName="extensionhostdebugservice";class S extends R.Disposable{constructor(r){super();this.channel=r}reload(r){this.channel.call("reload",[r])}get onReload(){return this.channel.listen("reload")}close(r){this.channel.call("close",[r])}get onClose(){return this.channel.listen("close")}attachSession(r,w,p){this.channel.call("attach",[r,w,p])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(r,w){this.channel.call("terminate",[r,w])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(r,w,p){return this.channel.call("openExtensionDevelopmentHostWindow",[r,w||{},p])}}e.ExtensionHostDebugChannelClient=S}),define(Q[154],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class m{constructor(P){this.driver=P}listen(P,r){throw new Error(`No event found: ${r}`)}call(P,r,w){switch(r){case"click":return this.driver.click(w[0],w[1],w[2]);case"doubleClick":return this.driver.doubleClick(w);case"setValue":return this.driver.setValue(w[0],w[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(w);case"getElements":return this.driver.getElements(w[0],w[1]);case"getElementXY":return this.driver.getElementXY(w[0],w[1],w[2]);case"typeInEditor":return this.driver.typeInEditor(w[0],w[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(w);case"writeInTerminal":return this.driver.writeInTerminal(w[0],w[1])}throw new Error(`Call not found: ${r}`)}}e.WindowDriverChannel=m;class R{constructor(P){this.channel=P}click(P,r,w){return this.channel.call("click",[P,r,w])}doubleClick(P){return this.channel.call("doubleClick",P)}setValue(P,r){return this.channel.call("setValue",[P,r])}getTitle(){return this.channel.call("getTitle")}isActiveElement(P){return this.channel.call("isActiveElement",P)}getElements(P,r){return this.channel.call("getElements",[P,r])}getElementXY(P,r,w){return this.channel.call("getElementXY",[P,r,w])}typeInEditor(P,r){return this.channel.call("typeInEditor",[P,r])}getTerminalBuffer(P){return this.channel.call("getTerminalBuffer",P)}writeInTerminal(P,r){return this.channel.call("writeInTerminal",[P,r])}}e.WindowDriverChannelClient=R;class L{constructor(P){this.channel=P}registerWindowDriver(P){return this.channel.call("registerWindowDriver",P)}reloadWindowDriver(P){return this.channel.call("reloadWindowDriver",P)}}e.WindowDriverRegistryChannelClient=L}),define(Q[155],J([0,1,8,15,46,125,10,7,32]),function(j,e,m,R,L,S,P,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class p{constructor(d,g,M){this._args=d,this.paths=g,this.productService=M}get appRoot(){return(0,m.dirname)(P.FileAccess.asFileUri("",j).fsPath)}get userHome(){return r.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return r.URI.file((0,m.join)(this.userDataPath,"User"))}get tmpDir(){return r.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,m.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return r.URI.file((0,m.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(r.URI.file((0,m.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return r.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return r.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=w.env.VSCODE_PORTABLE;return d?r.URI.file((0,m.join)(d,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return r.URI.file((0,m.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,m.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,m.resolve)(d):(0,m.normalize)((0,m.join)(P.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,m.resolve)(d):(0,m.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,m.resolve)(d);const g=w.env.VSCODE_EXTENSIONS;if(g)return g;const M=w.env.VSCODE_PORTABLE;return M?(0,m.join)(M,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(g=>/^[^:/?#]+?:\/\//.test(g)?r.URI.parse(g):r.URI.file((0,m.normalize)(g)))}get extensionDevelopmentKind(){var d;return(d=this.args.extensionDevelopmentKind)===null||d===void 0?void 0:d.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?r.URI.parse(d):r.URI.file((0,m.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!w.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(r.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return r.URI.file((0,m.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ue([L.memoize],p.prototype,"appRoot",null),ue([L.memoize],p.prototype,"userHome",null),ue([L.memoize],p.prototype,"userDataPath",null),ue([L.memoize],p.prototype,"appSettingsHome",null),ue([L.memoize],p.prototype,"tmpDir",null),ue([L.memoize],p.prototype,"userRoamingDataHome",null),ue([L.memoize],p.prototype,"settingsResource",null),ue([L.memoize],p.prototype,"userDataSyncHome",null),ue([L.memoize],p.prototype,"userDataSyncLogResource",null),ue([L.memoize],p.prototype,"sync",null),ue([L.memoize],p.prototype,"machineSettingsResource",null),ue([L.memoize],p.prototype,"globalStorageHome",null),ue([L.memoize],p.prototype,"workspaceStorageHome",null),ue([L.memoize],p.prototype,"keybindingsResource",null),ue([L.memoize],p.prototype,"keyboardLayoutResource",null),ue([L.memoize],p.prototype,"argvResource",null),ue([L.memoize],p.prototype,"snippetsHome",null),ue([L.memoize],p.prototype,"isExtensionDevelopment",null),ue([L.memoize],p.prototype,"untitledWorkspacesHome",null),ue([L.memoize],p.prototype,"installSourcePath",null),ue([L.memoize],p.prototype,"builtinExtensionsPath",null),ue([L.memoize],p.prototype,"extensionsPath",null),ue([L.memoize],p.prototype,"extensionDevelopmentLocationURI",null),ue([L.memoize],p.prototype,"extensionDevelopmentKind",null),ue([L.memoize],p.prototype,"extensionTestsLocationURI",null),ue([L.memoize],p.prototype,"debugExtensionHost",null),ue([L.memoize],p.prototype,"serviceMachineIdResource",null),ue([L.memoize],p.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=p;function n(y,d){return I(y["inspect-extensions"],y["inspect-brk-extensions"],5870,d,y.debugId)}e.parseExtensionHostPort=n;function b(y,d){return I(y["inspect-search"],y["inspect-brk-search"],5876,d)}e.parseSearchPort=b;function I(y,d,g,M,E){const u=Number(d||y)||(M?null:g),l=u?Boolean(!!d):!1;return{port:u,break:l,debugId:E}}}),define(Q[87],J([0,1,237,134,3]),function(j,e,m,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const S={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null)},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,R.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,R.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,R.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,R.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,R.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(30,null)},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const P={onUnknownOption:()=>{},onMultipleValues:()=>{}};function r(d,g,M=P){const E={},o=[],u=[];for(let i in g){const s=g[i];s.alias&&(E[i]=s.alias),s.type==="string"||s.type==="string[]"?(o.push(i),s.deprecates&&o.push(s.deprecates)):s.type==="boolean"&&(u.push(i),s.deprecates&&u.push(s.deprecates))}const l=m(d,{string:o,boolean:u,alias:E}),c={},t=l;c._=l._.map(i=>String(i)).filter(i=>i.length>0),delete t._;for(let i in g){const s=g[i];s.alias&&delete t[s.alias];let a=t[i];s.deprecates&&t.hasOwnProperty(s.deprecates)&&(a||(a=t[s.deprecates]),delete t[s.deprecates]),typeof a!="undefined"&&(s.type==="string[]"?a&&!Array.isArray(a)&&(a=[a]):s.type==="string"&&Array.isArray(a)&&(a=a.pop(),M.onMultipleValues(i,a)),c[i]=a),delete t[i]}for(let i in t)M.onUnknownOption(i);return c}e.parseArgs=r;function w(d,g){let M="";return g.args&&(Array.isArray(g.args)?M=` <${g.args.join("> <")}>`:M=` <${g.args}>`),g.alias?`-${g.alias} --${d}${M}`:`--${d}${M}`}function p(d,g){let M=0,E=[];for(const c in d){const t=d[c],i=w(c,t);M=Math.max(M,i.length),E.push([i,t.description])}let o=M+2+1;if(g-o<25)return E.reduce((c,t)=>c.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let u=g-o-1,l=[];for(const c of E){let t=c[0],i=b(c[1],u),s=n(o-t.length-2);l.push("  "+t+s+i[0]);for(let a=1;a<i.length;a++)l.push(n(o)+i[a])}return l}e.formatOptions=p;function n(d){return" ".repeat(d)}function b(d,g){let M=[];for(;d.length;){let E=d.length<g?d.length:d.lastIndexOf(" ",g),o=d.slice(0,E).trim();d=d.slice(E),M.push(o)}return M}function I(d,g,M,E,o=!0){const u=process.stdout.isTTY&&process.stdout.columns||80;let l=[`${d} ${M}`];l.push(""),l.push(`${(0,R.localize)(32,null)}: ${g} [${(0,R.localize)(33,null)}][${(0,R.localize)(34,null)}...]`),l.push(""),o&&(L.isWindows?l.push((0,R.localize)(35,null,g)):l.push((0,R.localize)(36,null,g)),l.push(""));const c={};for(const t in E){const i=E[t];if(i.description&&i.cat){let s=c[i.cat];s||(c[i.cat]=s={}),s[t]=i}}for(let t in c){const i=t;let s=c[i];s&&(l.push(S[i]),l.push(...p(s,u)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=I;function y(d,g){return`${d||(0,R.localize)(37,null)}
${g||(0,R.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=y}),define(Q[156],J([0,1,87,59,153]),function(j,e,m,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class S extends L.ExtensionHostDebugBroadcastChannel{constructor(r){super();this.windowsMainService=r}call(r,w,p){return w==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(p[0],p[1],p[2]):super.call(r,w,p)}async openExtensionDevelopmentHostWindow(r,w,p){const n=(0,m.parseArgs)(r,m.OPTIONS);n.debugRenderer=p;const b=n.extensionDevelopmentPath;if(!b)return{success:!1};let I;const y=Object.keys(w);for(let u of y){let l=w[u];l===null||(I||(I=Object.create(null)),I[u]=l)}const[d]=this.windowsMainService.openExtensionDevelopmentHostWindow(b,{context:5,cli:n,userEnv:I});if(!p)return{success:!0};const g=d.win;if(!g)return{success:!0};const M=g.webContents.debugger;let E=M.isAttached()?Infinity:0;const o=(0,R.createServer)(u=>{E++==0&&M.attach();let l=!1;const c=s=>{l||u.write(JSON.stringify(s)+"\0")},t=(s,a,h,f)=>c({method:a,params:h,sessionId:f});g.on("close",()=>{M.removeListener("message",t),u.end(),l=!0}),M.addListener("message",t);let i=Buffer.alloc(0);u.on("data",s=>{i=Buffer.concat([i,s]);for(let a=i.indexOf(0);a!==-1;a=i.indexOf(0)){let h;try{const f=i.slice(0,a).toString("utf8");i=i.slice(a+1),h=JSON.parse(f)}catch(f){console.error("error reading cdp line",f)}M.sendCommand(h.method,h.params,h.sessionId).then(f=>c({id:h.id,sessionId:h.sessionId,result:f})).catch(f=>c({id:h.id,sessionId:h.sessionId,error:{code:0,message:f.message}}))}}),u.on("error",s=>{console.error("error on cdp pipe:",s)}),u.on("close",()=>{l=!0,--E==0&&M.detach()})});return await new Promise(u=>o.listen(0,u)),g.on("close",()=>o.close()),{rendererDebugPort:o.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=S}),function(){"use strict";function j(e,m,R,L){function S(r){const w=P(r),p=[w];return e.isAbsolute(w)||p.unshift(L),e.resolve(...p)}function P(r){const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");const p=r["user-data-dir"];if(p)return p;let n=process.env.VSCODE_APPDATA;if(!n)switch(process.platform){case"win32":if(n=process.env.APPDATA,!n){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");n=e.join(b,"AppData","Roaming")}break;case"darwin":n=e.join(m.homedir(),"Library","Application Support");break;case"linux":n=process.env.XDG_CONFIG_HOME||e.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(n,R)}return{getUserDataPath:S}}if(typeof define=="function")define(Q[157],J([0,158,27,10,15,32]),function(e,m,R,L,S,P){const r=S.dirname(L.FileAccess.asFileUri("",e)),w=e.__$__nodeRequire(S.joinPath(r,"package.json").fsPath);return j(m,R,w.name,P.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),m=require("path"),R=require("os");module.exports=j(m,R,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[159],J([0,1,27,157,155]),function(j,e,m,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class S extends L.AbstractNativeEnvironmentService{constructor(r,w){super(r,{homeDir:(0,m.homedir)(),tmpDir:(0,m.tmpdir)(),userDataDir:(0,R.getUserDataPath)(r)},w)}}e.NativeEnvironmentService=S}),define(Q[160],J([0,1,24,27,8]),function(j,e,m,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function S(P){const r=(0,L.join)((0,R.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return m.writeFileSync(r,""),P&&console.log(`Marker file for --wait created: ${r}`),r}catch(w){P&&console.error(`Failed to create marker file for --wait: ${w}`);return}}e.createWaitMarkerFile=S}),define(Q[161],J([0,1,137]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,L=/^-(\d{4})(\d{2})(\d{2})$/;function S(I){return I=I.trim(),I==="*"||R.test(I)}e.isValidVersionStr=S;function P(I){if(!S(I))return null;if(I=I.trim(),I==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=I.match(R);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=P;function r(I){if(!I)return null;let y=I.majorBase,d=I.majorMustEqual,g=I.minorBase,M=I.minorMustEqual,E=I.patchBase,o=I.patchMustEqual;I.hasCaret&&(y===0||(M=!1),o=!1);let u=0;if(I.preRelease){const l=L.exec(I.preRelease);if(l){const[,c,t,i]=l;u=Date.UTC(Number(c),Number(t)-1,Number(i))}}return{majorBase:y,majorMustEqual:d,minorBase:g,minorMustEqual:M,patchBase:E,patchMustEqual:o,isMinimum:I.hasGreaterEquals,notBefore:u}}e.normalizeVersion=r;function w(I,y,d){let g;typeof I=="string"?g=r(P(I)):g=I;let M;y instanceof Date?M=y.getTime():typeof y=="string"&&(M=new Date(y).getTime());let E;if(typeof d=="string"?E=r(P(d)):E=d,!g||!E)return!1;let o=g.majorBase,u=g.minorBase,l=g.patchBase,c=E.majorBase,t=E.minorBase,i=E.patchBase,s=E.notBefore,a=E.majorMustEqual,h=E.minorMustEqual,f=E.patchMustEqual;return E.isMinimum?o>c?!0:o<c?!1:u>t?!0:u<t||M&&M<s?!1:l>=i:(o===1&&c===0&&(!a||!h||!f)&&(c=1,t=0,i=0,a=!0,h=!1,f=!1),o<c?!1:o>c?!a:u<t?!1:u>t?!h:l<i?!1:l>i?!f:!(M&&M<s))}e.isValidVersion=w;function p(I,y,d,g){return d.isBuiltin||typeof d.main=="undefined"?!0:b(I,y,d.engines.vscode,g)}e.isValidExtensionVersion=p;function n(I,y,d){return I==="*"||b(y,d,I)}e.isEngineValid=n;function b(I,y,d,g=[]){let M=r(P(d));if(!M)return g.push(m.localize(0,null,d)),!1;if(M.majorBase===0){if(!M.majorMustEqual||!M.minorMustEqual)return g.push(m.localize(1,null,d)),!1}else if(!M.majorMustEqual)return g.push(m.localize(2,null,d)),!1;return w(I,y,M)?!0:(g.push(m.localize(3,null,I,d)),!1)}}),define(Q[162],J([0,1,33,86,2,10]),function(j,e,m,R,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends L.Disposable{constructor(w,p,n,b){super();this.folders=w,this.onDidFilesChange=p,this.onLogMessage=n,this.verboseLogging=b,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const w=this._register(new R.Client(S.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=P.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(w.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(p=>!this.isDisposed&&this.onDidFilesChange(p))),this._register(this.service.onDidLogMessage(p=>this.onLogMessage(p))),this.setFolders(this.folders)}setVerboseLogging(w){this.verboseLogging=w,!this.isDisposed&&this.service&&this.service.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${w}`})}setFolders(w){this.folders=w,this.service&&this.service.setRoots(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P,P.MAX_RESTARTS=5}),define(Q[163],J([0,1,33,86,2,10]),function(j,e,m,R,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends L.Disposable{constructor(w,p,n,b,I={}){super();this.folders=w,this.onDidFilesChange=p,this.onLogMessage=n,this.verboseLogging=b,this.watcherOptions=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const w=this._register(new R.Client(S.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=P.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(w.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(p=>!this.isDisposed&&this.onDidFilesChange(p))),this._register(this.service.onDidLogMessage(p=>this.onLogMessage(p))),this.service.setRoots(this.folders)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${w}`})}setVerboseLogging(w){this.verboseLogging=w,this.service&&this.service.setVerboseLogging(w)}setFolders(w){this.folders=w,this.service&&this.service.setRoots(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P,P.MAX_RESTARTS=5}),define(Q[164],J([0,1,45,81,110,10]),function(j,e,m,R,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class P{constructor(w,p,n,b,I){this.watchedFolder=w,this.eventCallback=n,this.logCallback=b,this.verboseLogging=I,this.restartCounter=0,Array.isArray(p)?this.ignored=p.map(y=>L.parse(y)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${w}`),this.startWatcher()}startWatcher(){const w=[this.watchedFolder];this.verboseLogging&&w.push("-verbose"),this.handle=m.spawn(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",j).fsPath,w);const p=new R.LineDecoder;this.handle.stdout.on("data",n=>{const b=[];p.write(n).forEach(I=>{const y=I.split("|");if(y.length===2){const d=Number(y[0]),g=y[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(M=>M(g))){this.verboseLogging&&this.log(g);return}b.push({type:P.changeTypeMap[d],path:g})}else this.log(y[1])}}),b.length>0&&this.eventCallback(b)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,b)=>this.onExit(n,b))}onError(w){this.error("process error: "+w.toString())}onExit(w,p){this.handle&&(this.error(`terminated unexpectedly (code: ${w}, signal: ${p})`),this.restartCounter<=P.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(w){this.logCallback({type:"error",message:`[File Watcher (C#)] ${w}`})}log(w){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${w}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=P,P.MAX_RESTARTS=5,P.changeTypeMap=[0,1,2]}),define(Q[165],J([0,1,164,8,23]),function(j,e,m,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class S{constructor(r,w,p,n){this.onDidFilesChange=w,this.onLogMessage=p,this.verboseLogging=n,this.service=void 0,this.folder=r[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(R.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,R.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new m.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,r=>this.onFileEvents(r),r=>this.onLogMessage(r),this.verboseLogging)}setVerboseLogging(r){this.verboseLogging=r,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(r){this.isDisposed||r.length>0&&this.onDidFilesChange(r)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=S}),define(Q[69],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class m{constructor(S,P=[],r=!1){this.ctor=S,this.staticArguments=P,this.supportsDelayedInstantiation=r}}e.SyncDescriptor=m;const R=(L,...S)=>new m(L,S);e.createSyncDescriptor=R}),define(Q[166],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=m;class R{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let P of this._nodes.values())P.outgoing.size===0&&S.push(P);return S}insertEdge(S,P){const r=this.lookupOrInsertNode(S),w=this.lookupOrInsertNode(P);r.outgoing.set(this._hashFn(P),w),w.incoming.set(this._hashFn(S),r)}removeNode(S){const P=this._hashFn(S);this._nodes.delete(P);for(let r of this._nodes.values())r.outgoing.delete(P),r.incoming.delete(P)}lookupOrInsertNode(S){const P=this._hashFn(S);let r=this._nodes.get(P);return r||(r=new m(S),this._nodes.set(P,r)),r}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[P,r]of this._nodes)S.push(`${P}, (incoming)[${[...r.incoming.keys()].join(", ")}], (outgoing)[${[...r.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,P]of this._nodes){const r=new Set([S]),w=this._findCycle(P,r);if(w)return w}}_findCycle(S,P){for(let[r,w]of S.outgoing){if(P.has(r))return[...P,r].join(" -> ");P.add(r);const p=this._findCycle(w,P);if(p)return p;P.delete(r)}}}e.Graph=R}),define(Q[4],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(r){r.serviceIds=new Map,r.DI_TARGET="$di$target",r.DI_DEPENDENCIES="$di$dependencies";function w(p){return p[r.DI_DEPENDENCIES]||[]}r.getServiceDependencies=w})(m=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function R(r,w,p,n){w[m.DI_TARGET]===w?w[m.DI_DEPENDENCIES].push({id:r,index:p,optional:n}):(w[m.DI_DEPENDENCIES]=[{id:r,index:p,optional:n}],w[m.DI_TARGET]=w)}function L(r){if(m.serviceIds.has(r))return m.serviceIds.get(r);const w=function(p,n,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(w,p,b,!1)};return w.toString=()=>r,m.serviceIds.set(r,w),w}e.createDecorator=L;function S(r){return r}e.refineServiceDecorator=S;function P(r){return function(w,p,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(r,w,n,!0)}}e.optional=P}),define(Q[70],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,m.createDecorator)(e.ID);function R(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=R}),define(Q[88],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,m.createDecorator)("encryptionMainService");class R{constructor(S){this.machineId=S}encryption(){return new Promise((S,P)=>j(["vscode-encrypt"],S,P))}async encrypt(S){try{return(await this.encryption()).encrypt(this.machineId,S)}catch(P){return S}}async decrypt(S){try{return(await this.encryption()).decrypt(this.machineId,S)}catch(P){return S}}}e.EncryptionMainService=R}),define(Q[53],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(Q[167],J([0,1,136,4,10]),function(j,e,m,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function S(b){return b&&typeof b=="object"&&typeof b.id=="string"&&(!b.uuid||typeof b.uuid=="string")}e.isIExtensionIdentifier=S;var P;(function(b){b[b.NoneOrRelevance=0]="NoneOrRelevance",b[b.LastUpdatedDate=1]="LastUpdatedDate",b[b.Title=2]="Title",b[b.PublisherName=3]="PublisherName",b[b.InstallCount=4]="InstallCount",b[b.PublishedDate=5]="PublishedDate",b[b.AverageRating=6]="AverageRating",b[b.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var r;(function(b){b[b.Default=0]="Default",b[b.Ascending=1]="Ascending",b[b.Descending=2]="Descending"})(r=e.SortOrder||(e.SortOrder={}));var w;(function(b){b.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var p;(function(b){b[b.None=0]="None",b[b.Install=1]="Install",b[b.Update=2]="Update"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(I,y){super(I);this.code=y}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),e.ExtensionsLabel=(0,m.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,m.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")}),define(Q[168],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,m.createDecorator)("extensionUrlTrustService")}),define(Q[169],J([0,1,23,4]),function(j,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function L(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(S=e.ExtensionType||(e.ExtensionType={}));class P{constructor(n){this.value=n,this._lower=n.toLowerCase()}static equals(n,b){if(typeof n=="undefined"||n===null)return typeof b=="undefined"||b===null;if(typeof b=="undefined"||b===null)return!1;if(typeof n=="string"||typeof b=="string"){let I=typeof n=="string"?n:n.value,y=typeof b=="string"?b:b.value;return m.equalsIgnoreCase(I,y)}return n._lower===b._lower}static toKey(n){return typeof n=="string"?n.toLowerCase():n._lower}}e.ExtensionIdentifier=P;function r(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=r;function w(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=w,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[170],J([0,1,23,169]),function(j,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(y,d){return y.uuid&&d.uuid?y.uuid===d.uuid:y.id===d.id?!0:(0,m.compareIgnoreCase)(y.id,d.id)===0}e.areSameExtensions=L;class S{constructor(d,g){this.version=g,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof S?L(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=S;function P(y,d){return`${y}.${d}`}e.getExtensionId=P;function r(y){return y.toLocaleLowerCase()}e.adoptToGalleryExtensionId=r;function w(y,d){return r(P(y,d))}e.getGalleryExtensionId=w;function p(y,d){const g=[],M=E=>{for(const o of g)if(o.some(u=>L(d(u),d(E))))return o;return null};for(const E of y){const o=M(E);o?o.push(E):g.push([E])}return g}e.groupByExtension=p;function n(y){return{id:y.identifier.id,name:y.manifest.name,galleryId:null,publisherId:y.publisherId,publisherName:y.manifest.publisher,publisherDisplayName:y.publisherDisplayName,dependencies:y.manifest.extensionDependencies&&y.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function b(y){return Object.assign({id:y.identifier.id,name:y.name,galleryId:y.identifier.uuid,publisherId:y.publisherId,publisherName:y.publisher,publisherDisplayName:y.publisherDisplayName,dependencies:!!(y.properties.dependencies&&y.properties.dependencies.length>0)},y.telemetryData)}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function I(y){const d=new Set;for(const g of y)g.malicious&&d.add(g.id.id);return d}e.getMaliciousExtensionsSet=I}),define(Q[89],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(Q[21],J([0,1,140,8,7,4,23,13,36]),function(j,e,m,R,L,S,P,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function p(N){return N.create===!0}e.isFileOpenForWriteOptions=p;var n;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var b;(function(N){N[N.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var I;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=y;function d(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=d;function g(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function M(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=M;var E;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class o extends Error{constructor(B,C){super(B);this.code=C}}e.FileSystemProviderError=o;function u(N,B){const C=new o(N.toString(),B);return c(C,B),C}e.createFileSystemProviderError=u;function l(N){return N||u((0,m.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=l;function c(N,B){return N.name=B?`${B} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=c;function t(N){if(!N)return E.Unknown;if(N instanceof o)return N.code;const B=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!B)return E.Unknown;switch(B[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=t;function i(N){if(N instanceof D)return N.fileOperationResult;switch(t(N)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var s;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class a{constructor(B,C,z){this.resource=B,this.operation=C,this.target=z}isOperation(B){return this.operation===B}}e.FileOperationEvent=a;var h;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class f{constructor(B,C){this.ignorePathCasing=C,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=B;for(const z of B)switch(z.type){case 1:this.added||(this.added=w.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(z.resource,z);break;case 0:this.updated||(this.updated=w.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(z.resource,z);break;case 2:this.deleted||(this.deleted=w.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(z.resource,z);break}}contains(B,...C){return this.doContains(B,{includeChildren:!1},...C)}affects(B,...C){return this.doContains(B,{includeChildren:!0},...C)}doContains(B,C,...z){var V,_,A,O,k,F;if(!B)return!1;const U=z.length>0;return!!((!U||z.includes(1))&&(((V=this.added)===null||V===void 0?void 0:V.get(B))||C.includeChildren&&((_=this.added)===null||_===void 0?void 0:_.findSuperstr(B)))||(!U||z.includes(0))&&(((A=this.updated)===null||A===void 0?void 0:A.get(B))||C.includeChildren&&((O=this.updated)===null||O===void 0?void 0:O.findSuperstr(B)))||(!U||z.includes(2))&&(((k=this.deleted)===null||k===void 0?void 0:k.findSubstr(B))||C.includeChildren&&((F=this.deleted)===null||F===void 0?void 0:F.findSuperstr(B))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(B){const C=[],z=B===1?this.added:B===0?this.updated:this.deleted;if(z)for(const[,V]of z)C.push(V);return C}filter(B){return new f(this.changes.filter(C=>B(C)),this.ignorePathCasing)}}e.FileChangesEvent=f;function v(N,B,C){return!N||!B||N===B||B.length>N.length?!1:(B.charAt(B.length-1)!==R.sep&&(B+=R.sep),C?(0,P.startsWithIgnoreCase)(N,B):N.indexOf(B)===0)}e.isParent=v;class D extends Error{constructor(B,C,z){super(B);this.fileOperationResult=C,this.options=z}static isFileOperationError(B){return B instanceof Error&&!(0,r.isUndefinedOrNull)(B.fileOperationResult)}}e.FileOperationError=D;var T;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var W;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(W=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function $(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=$;async function X(N,B){if(!B.canHandleResource(L.URI.from({scheme:N.scheme})))return new Promise(C=>{const z=B.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===N.scheme&&V.added&&(z.dispose(),C())})})}e.whenProviderRegistered=X,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class x{static formatSize(B){return(0,r.isNumber)(B)||(B=0),B<x.KB?(0,m.localize)(1,null,B.toFixed(0)):B<x.MB?(0,m.localize)(2,null,(B/x.KB).toFixed(2)):B<x.GB?(0,m.localize)(3,null,(B/x.MB).toFixed(2)):B<x.TB?(0,m.localize)(4,null,(B/x.GB).toFixed(2)):(0,m.localize)(5,null,(B/x.TB).toFixed(2))}}e.ByteSize=x,x.KB=1024,x.MB=x.KB*x.KB,x.GB=x.MB*x.KB,x.TB=x.GB*x.KB;var oe;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(oe=e.Arch||(e.Arch={}));function q(N){return{maxFileSize:N===0?300*x.MB:16*x.GB,maxHeapSize:N===0?700*x.MB:2*700*x.MB}}e.getPlatformLimits=q}),define(Q[54],J([0,1,238,135,21,87]),function(j,e,m,R,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function P(I,y){const d={onUnknownOption:M=>{console.warn((0,R.localize)(0,null,M))},onMultipleValues:(M,E)=>{console.warn((0,R.localize)(1,null,M,E))}},g=(0,S.parseArgs)(I,S.OPTIONS,y?d:void 0);return g.goto&&g._.forEach(M=>m(/^(\w:)?[^:]+(:\d*){0,2}$/.test(M),(0,R.localize)(2,null))),g["max-memory"]&&m(parseInt(g["max-memory"])>=L.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${L.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function r(I){const y=I.findIndex(d=>!/^-/.test(d));if(y>-1)return[...I.slice(0,y),...I.slice(y+1)]}function w(I){let[,...y]=I;process.env.VSCODE_DEV&&(y=r(y)||[]);const d=!b(process.env);return P(y,d)}e.parseMainProcessArgv=w;function p(I){const[,,...y]=I;return P(y,!0)}e.parseCLIProcessArgv=p;function n(I,...y){const d=I.indexOf("--");return d===-1?I.push(...y):I.splice(d,0,...y),I}e.addArg=n;function b(I){return I.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),define(Q[90],J([0,1,158,45,28,3,54,67,130]),function(j,e,m,R,L,S,P,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function p(I,y,d){return y["force-disable-user-env"]?(I.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):S.isWindows?(I.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,P.isLaunchedFromCli)(d)&&!y["force-user-env"]?(I.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,P.isLaunchedFromCli)(d)?I.trace("resolveShellEnv(): running (--force-user-env)"):I.trace("resolveShellEnv(): running (macOS/Linux)"),n||(n=b(I)),n)}e.resolveShellEnv=p;let n;async function b(I){const y=new Promise(async(d,g)=>{const M=process.env.ELECTRON_RUN_AS_NODE;I.trace("getUnixShellEnvironment#runAsNode",M);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;I.trace("getUnixShellEnvironment#noAttach",E);const o=(0,L.generateUuid)().replace(/-/g,"").substr(0,12),u=new RegExp(o+"(.*)"+o),l=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});I.trace("getUnixShellEnvironment#env",l);const c=await(0,w.getSystemShell)(S.OS,l);I.trace("getUnixShellEnvironment#shell",c);const t=m.basename(c);let i,s;/^pwsh(-preview)?$/.test(t)?(i=`& '${process.execPath}' -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,s=["-Login","-Command"]):(i=`'${process.execPath}' -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,s=["-ilc"]),I.trace("getUnixShellEnvironment#spawn",JSON.stringify(s),i);const a=(0,R.spawn)(c,[...s,i],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});a.on("error",v=>{I.error("getUnixShellEnvironment#errorChildProcess",(0,r.toErrorMessage)(v)),d({})});const h=[];a.stdout.on("data",v=>h.push(v));const f=[];a.stderr.on("data",v=>f.push(v)),a.on("close",(v,D)=>{const T=Buffer.concat(h).toString("utf8");I.trace("getUnixShellEnvironment#raw",T);const W=Buffer.concat(f).toString("utf8");if(W.trim()&&I.trace("getUnixShellEnvironment#stderr",W),v||D)return g(new Error(`Failed to get environment (code ${v}, signal ${D})`));const $=u.exec(T),X=$?$[1]:"{}";try{const x=JSON.parse(X);M?x.ELECTRON_RUN_AS_NODE=M:delete x.ELECTRON_RUN_AS_NODE,E?x.ELECTRON_NO_ATTACH_CONSOLE=E:delete x.ELECTRON_NO_ATTACH_CONSOLE,delete x.XDG_RUNTIME_DIR,I.trace("getUnixShellEnvironment#result",x),d(x)}catch(x){I.error("getUnixShellEnvironment#errorCaught",(0,r.toErrorMessage)(x)),g(x)}})});try{return await y}catch(d){return I.error("getUnixShellEnvironment#error",(0,r.toErrorMessage)(d)),{}}}}),define(Q[91],J([0,1,7,21,3]),function(j,e,m,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function S(w){return w.map(p=>({type:p.type,resource:m.URI.file(p.path)}))}e.toFileChanges=S;function P(w){const p=new r;for(const n of w)p.processEvent(n);return p.normalize()}e.normalizeFileChanges=P;class r{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(p){const n=this.mapPathToChange.get(p.path);if(n){const b=n.type,I=p.type;b===1&&I===2?(this.mapPathToChange.delete(p.path),this.normalized.splice(this.normalized.indexOf(n),1)):b===2&&I===1?n.type=0:b===1&&I===0||(n.type=I)}else this.normalized.push(p),this.mapPathToChange.set(p.path,p)}normalize(){const p=[],n=[];return this.normalized.filter(b=>b.type!==2?(p.push(b),!1):!0).sort((b,I)=>b.path.length-I.path.length).filter(b=>n.some(I=>(0,R.isParent)(b.path,I,!L.isLinux))?!1:(n.push(b.path),!0)).concat(p)}}}),define(Q[171],J([0,1,91,2,20,113,117,9,8]),function(j,e,m,R,L,S,P,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class p extends R.Disposable{constructor(b,I,y,d){super();this.path=b,this.onDidFilesChange=I,this.onLogMessage=y,this.verboseLogging=d,this.fileChangesDelayer=this._register(new r.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(b){this.verboseLogging=b}async startWatching(){try{const{stat:b,symbolicLink:I}=await L.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let y=this.path;if(I)try{y=await(0,S.realpath)(y)}catch(d){if(this.onError(d),I.dangling)return}b.isDirectory()?this._register((0,P.watchFolder)(y,(d,g)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,w.join)(this.path,(0,w.basename)(g))})},d=>this.onError(d))):this._register((0,P.watchFile)(y,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(b){b.code!=="ENOENT"&&this.onError(b)}}onFileChange(b){this.fileChangesBuffer.push(b),this.verboseLogging&&this.onVerbose(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),this.fileChangesDelayer.trigger(async()=>{const I=this.fileChangesBuffer;this.fileChangesBuffer=[];const y=(0,m.normalizeFileChanges)(I);this.verboseLogging&&y.forEach(d=>{this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`)}),y.length>0&&this.onDidFilesChange(y)})}onError(b){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${b}`})}onVerbose(b){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=p}),define(Q[71],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...L){this._entries=new Map;for(let[S,P]of L)this.set(S,P)}set(L,S){const P=this._entries.get(L);return this._entries.set(L,S),P}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=m}),define(Q[172],J([0,1,18,166,69,4,71,9]),function(j,e,m,R,L,S,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const w=!1;class p extends Error{constructor(d){var g;super("cyclic dependency between services");this.message=(g=d.findCycleSlow())!==null&&g!==void 0?g:`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class n{constructor(d=new P.ServiceCollection,g=!1,M){this._activeInstantiations=new Set,this._services=d,this._strict=g,this._parent=M,this._services.set(S.IInstantiationService,this)}createChild(d){return new n(d,this._strict,this)}invokeFunction(d,...g){let M=I.traceInvocation(d),E=!1;try{return d({get:(u,l)=>{if(E)throw(0,m.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(u,M);if(!c&&l!==S.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return c}},...g)}finally{E=!0,M.stop()}}createInstance(d,...g){let M,E;return d instanceof L.SyncDescriptor?(M=I.traceCreation(d.ctor),E=this._createInstance(d.ctor,d.staticArguments.concat(g),M)):(M=I.traceCreation(d),E=this._createInstance(d,g,M)),M.stop(),E}_createInstance(d,g=[],M){let E=S._util.getServiceDependencies(d).sort((l,c)=>l.index-c.index),o=[];for(const l of E){let c=this._getOrCreateServiceInstance(l.id,M);if(!c&&this._strict&&!l.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${l.id}.`);o.push(c)}let u=E.length>0?E[0].index:g.length;if(g.length!==u){console.warn(`[createInstance] First service dependency of ${d.name} at position ${u+1} conflicts with ${g.length} static arguments`);let l=u-g.length;l>0?g=g.concat(new Array(l)):g=g.slice(0,u)}return new d(...[...g,...o])}_setServiceInstance(d,g){if(this._services.get(d)instanceof L.SyncDescriptor)this._services.set(d,g);else if(this._parent)this._parent._setServiceInstance(d,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let g=this._services.get(d);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):g}_getOrCreateServiceInstance(d,g){let M=this._getServiceInstanceOrDescriptor(d);return M instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,M,g.branch(d,!0)):(g.branch(d,!1),M)}_safeCreateAndCacheServiceInstance(d,g,M){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,g,M)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,g,M){const E=new R.Graph(l=>l.id.toString());let o=0;const u=[{id:d,desc:g,_trace:M}];for(;u.length;){const l=u.pop();if(E.lookupOrInsertNode(l),o++>1e3)throw new p(E);for(let c of S._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(c.id);if(!t&&!c.optional&&console.warn(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`),t instanceof L.SyncDescriptor){const i={id:c.id,desc:t,_trace:l._trace.branch(c.id,!0)};E.insertEdge(l,i),u.push(i)}}}for(;;){const l=E.roots();if(l.length===0){if(!E.isEmpty())throw new p(E);break}for(const{data:c}of l){if(this._getServiceInstanceOrDescriptor(c.id)instanceof L.SyncDescriptor){const i=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,i)}E.removeNode(c)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,g,M=[],E,o){if(this._services.get(d)instanceof L.SyncDescriptor)return this._createServiceInstance(g,M,E,o);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,g,M,E,o);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(d,g=[],M,E){if(M){const o=new r.IdleValue(()=>this._createInstance(d,g,E));return new Proxy(Object.create(null),{get(u,l){if(l in u)return u[l];let c=o.value,t=c[l];return typeof t!="function"||(t=t.bind(c),u[l]=t),t},set(u,l,c){return o.value[l]=c,!0}})}else return this._createInstance(d,g,E)}}e.InstantiationService=n;var b;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(b||(b={}));class I{constructor(d,g){this.type=d,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return w?new I(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):I._None}static traceCreation(d){return w?new I(0,d.name):I._None}branch(d,g){let M=new I(2,d.toString());return this._dep.push([d,g,M]),M}stop(){let d=Date.now()-this._start;I._totals+=d;let g=!1;function M(o,u){let l=[],c=new Array(o+1).join("	");for(const[t,i,s]of u._dep)if(i&&s){g=!0,l.push(`${c}CREATES -> ${t}`);let a=M(o+1,s);a&&l.push(a)}else l.push(`${c}uses -> ${t}`);return l.join(`
`)}let E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${M(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${I._totals.toFixed(2)}ms)`];(d>2||g)&&console.log(E.join(`
`))}}I._None=new class extends I{constructor(){super(-1,null)}stop(){}branch(){return this}},I._totals=0}),define(Q[173],J([0,1,18,128,57]),function(j,e,m,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class S extends L.ResolvedKeybinding{constructor(r,w){super();if(w.length===0)throw(0,m.illegalArgument)("parts");this._os=r,this._parts=w}getLabel(){return R.UILabelProvider.toLabel(this._os,this._parts,r=>this._getLabel(r))}getAriaLabel(){return R.AriaLabelProvider.toLabel(this._os,this._parts,r=>this._getAriaLabel(r))}getElectronAccelerator(){return this._parts.length>1?null:R.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,r=>this._getElectronAccelerator(r))}getUserSettingsLabel(){return R.UserSettingsLabelProvider.toLabel(this._os,this._parts,r=>this._getUserSettingsLabel(r))}isWYSIWYG(){return this._parts.every(r=>this._isWYSIWYG(r))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(r=>this._getPart(r))}_getPart(r){return new L.ResolvedKeybindingPart(r.ctrlKey,r.shiftKey,r.altKey,r.metaKey,this._getLabel(r),this._getAriaLabel(r))}getDispatchParts(){return this._parts.map(r=>this._getDispatchPart(r))}getSingleModifierDispatchParts(){return this._parts.map(r=>this._getSingleModifierDispatchPart(r))}}e.BaseResolvedKeybinding=S}),define(Q[174],J([0,1,57,173]),function(j,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class L extends R.BaseResolvedKeybinding{constructor(P,r){super(r,P.parts)}_keyCodeToUILabel(P){if(this._os===2)switch(P){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return m.KeyCodeUtils.toString(P)}_getLabel(P){return P.isDuplicateModifierCase()?"":this._keyCodeToUILabel(P.keyCode)}_getAriaLabel(P){return P.isDuplicateModifierCase()?"":m.KeyCodeUtils.toString(P.keyCode)}_keyCodeToElectronAccelerator(P){if(P>=93&&P<=108)return null;switch(P){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return m.KeyCodeUtils.toString(P)}_getElectronAccelerator(P){return P.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(P.keyCode)}_getUserSettingsLabel(P){if(P.isDuplicateModifierCase())return"";const r=m.KeyCodeUtils.toUserSettingsUS(P.keyCode);return r&&r.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(P){return L.getDispatchStr(P)}static getDispatchStr(P){if(P.isModifierKey())return null;let r="";return P.ctrlKey&&(r+="ctrl+"),P.shiftKey&&(r+="shift+"),P.altKey&&(r+="alt+"),P.metaKey&&(r+="meta+"),r+=m.KeyCodeUtils.toString(P.keyCode),r}_getSingleModifierDispatchPart(P){return P.keyCode===5&&!P.shiftKey&&!P.altKey&&!P.metaKey?"ctrl":P.keyCode===4&&!P.ctrlKey&&!P.altKey&&!P.metaKey?"shift":P.keyCode===6&&!P.ctrlKey&&!P.shiftKey&&!P.metaKey?"alt":P.keyCode===57&&!P.ctrlKey&&!P.shiftKey&&!P.altKey?"meta":null}}e.USLayoutResolvedKeybinding=L}),define(Q[175],J([0,1,9]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function R(L,S){if(L.length===0)return Promise.resolve(!1);const P=[];let r=!1;for(let w of L){if(w===!0)return Promise.resolve(!0);(0,m.isThenable)(w)&&P.push(w.then(p=>{p&&(r=!0)},p=>{S(p),r=!0}))}return m.Promises.settled(P).then(()=>r)}e.handleVetos=R}),define(Q[6],J([0,1,4,2,3,5,67]),function(j,e,m,R,L,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function r(){return new Date().toISOString()}var w;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;class p extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=p;class n extends p{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(w.Trace)&&this.log(w.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(w.Debug)&&this.log(w.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(w.Info)&&this.log(w.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(w.Warning)&&this.log(w.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(w.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(w.Error,this.format(s))}else this.log(w.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(w.Critical)&&this.log(w.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let s=0;s<t.length;s++){let a=t[s];if(typeof a=="object")try{a=JSON.stringify(a)}catch(h){}i+=(s>0?" ":"")+a}return i}}e.AbstractMessageLogger=n;class b extends p{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!L.isWindows}trace(t,...i){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${r()}][0m`,t,...i):console.log(`[main ${r()}]`,t,...i))}debug(t,...i){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${r()}][0m`,t,...i):console.log(`[main ${r()}]`,t,...i))}info(t,...i){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${r()}][0m`,t,...i):console.log(`[main ${r()}]`,t,...i))}warn(t,...i){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${r()}][0m`,t,...i):console.warn(`[main ${r()}]`,t,...i))}error(t,...i){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${r()}][0m`,t,...i):console.error(`[main ${r()}]`,t,...i))}critical(t,...i){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${r()}][0m`,t,...i):console.error(`[main ${r()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class I extends p{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=I;class y extends p{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,P.toErrorMessage)(t,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class d extends p{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const s of this.logServices)s.trace(t,...i)}debug(t,...i){for(const s of this.logServices)s.debug(t,...i)}info(t,...i){for(const s of this.logServices)s.info(t,...i)}warn(t,...i){for(const s of this.logServices)s.warn(t,...i)}error(t,...i){for(const s of this.logServices)s.error(t,...i)}critical(t,...i){for(const s of this.logServices)s.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class g extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=g;class M extends R.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(s))}))}createLogger(t,i){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(i==null?void 0:i.always)?w.Trace:this.logLevel,i),this.loggers.set(t.toString(),s),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=M;class E{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(t){}getLevel(){return w.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=E;function o(c){if(c.verbose)return w.Trace;if(typeof c.logLevel=="string"){const t=u(c.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function u(c){switch(c){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=u;function l(c){switch(c){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=l}),define(Q[92],J([0,1,6]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function R(S,P){switch(P){case m.LogLevel.Trace:return S.trace;case m.LogLevel.Debug:return S.debug;case m.LogLevel.Info:return S.info;case m.LogLevel.Warning:return S.warn;case m.LogLevel.Error:return S.error;case m.LogLevel.Critical:return S.critical;default:throw new Error("Invalid log level")}}class L extends m.AbstractLogger{constructor(P=m.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(P),this._register(this.onDidChangeLogLevel(r=>{this._logger&&this._logger.setLevel(r)}))}set logger(P){this._logger=P;for(const{level:r,args:w}of this.buffer)R(P,r).apply(P,w);this.buffer=[]}_log(P,...r){this._logger?R(this._logger,P).apply(this._logger,r):this.getLevel()<=P&&this.buffer.push({level:P,args:r})}trace(P,...r){this._log(m.LogLevel.Trace,P,...r)}debug(P,...r){this._log(m.LogLevel.Debug,P,...r)}info(P,...r){this._log(m.LogLevel.Info,P,...r)}warn(P,...r){this._log(m.LogLevel.Warning,P,...r)}error(P,...r){this._log(m.LogLevel.Error,P,...r)}critical(P,...r){this._log(m.LogLevel.Critical,P,...r)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=L});var ee=this&&this.__param||function(j,e){return function(m,R){e(m,R,j)}};define(Q[176],J([0,1,6,21,9,19,15,4,92]),function(j,e,m,R,L,S,P,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const p=5*R.ByteSize.MB;let n=class extends m.AbstractLogger{constructor(y,d,g,M){super();this.name=y,this.resource=d,this.fileService=M,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new L.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=m.LogLevel.Trace&&this._log(m.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=m.LogLevel.Debug&&this._log(m.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=m.LogLevel.Info&&this._log(m.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=m.LogLevel.Warning&&this._log(m.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=m.LogLevel.Error){const y=arguments[0];if(y instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=y.stack,this._log(m.LogLevel.Error,this.format(d))}else this._log(m.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=m.LogLevel.Critical&&this._log(m.LogLevel.Critical,this.format(arguments))}flush(){}log(y,d){this._log(y,this.format(d))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(y){if(y.fileOperationResult!==3)throw y}}_log(y,d){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>p&&(await this.fileService.writeFile(this.getBackupResource(),S.VSBuffer.fromString(g)),g=""),g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(y)}] ${d}
`,await this.fileService.writeFile(this.resource,S.VSBuffer.fromString(g))})}getCurrentTimestamp(){const y=M=>M<10?`0${M}`:M,d=M=>M<10?`00${M}`:M<100?`0${M}`:M,g=new Date;return`${g.getFullYear()}-${y(g.getMonth()+1)}-${y(g.getDate())} ${y(g.getHours())}:${y(g.getMinutes())}:${y(g.getSeconds())}.${d(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,P.joinPath)((0,P.dirname)(this.resource),`${(0,P.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(y){return""}}stringifyLogLevel(y){switch(y){case m.LogLevel.Critical:return"critical";case m.LogLevel.Debug:return"debug";case m.LogLevel.Error:return"error";case m.LogLevel.Info:return"info";case m.LogLevel.Trace:return"trace";case m.LogLevel.Warning:return"warning"}return""}format(y){let d="";for(let g=0;g<y.length;g++){let M=y[g];if(typeof M=="object")try{M=JSON.stringify(M)}catch(E){}d+=(g>0?" ":"")+M}return d}};n=ue([ee(3,R.IFileService)],n),e.FileLogger=n;let b=class extends m.AbstractLoggerService{constructor(y,d,g){super(y.getLevel(),y.onDidChangeLogLevel);this.instantiationService=d,this.fileService=g}doCreateLogger(y,d){const g=new w.BufferLogService(d);return(0,R.whenProviderRegistered)(y,this.fileService).then(()=>g.logger=this.instantiationService.createInstance(n,(0,P.basename)(y),y,g.getLevel())),g}};b=ue([ee(0,m.ILogService),ee(1,r.IInstantiationService),ee(2,R.IFileService)],b),e.FileLoggerService=b}),define(Q[177],J([0,1,6,5,7]),function(j,e,m,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class S{constructor(I){this.service=I,this.onDidChangeLogLevel=R.Event.buffer(I.onDidChangeLogLevel,!0)}listen(I,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(I,y,d){switch(y){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=S;class P{constructor(I){this.channel=I}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(I){P.setLevel(this.channel,I)}static setLevel(I,y){return I.call("setLevel",y)}}e.LogLevelChannelClient=P;class r{constructor(I){this.loggerService=I,this.loggers=new Map}listen(I,y){throw new Error(`Event not found: ${y}`)}async call(I,y,d){switch(y){case"createLogger":this.createLogger(L.URI.revive(d[0]),d[1]);return;case"log":return this.log(L.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${y}`)}createLogger(I,y){this.loggers.set(I.toString(),this.loggerService.createLogger(I,y))}consoleLog(I,y){let d=console.log;switch(I){case m.LogLevel.Error:d=console.error;break;case m.LogLevel.Warning:d=console.warn;break;case m.LogLevel.Info:d=console.info;break}d.call(console,...y)}log(I,y){const d=this.loggers.get(I.toString());if(!d)throw new Error("Create the logger before logging");for(const[g,M]of y)switch(g){case m.LogLevel.Trace:d.trace(M);break;case m.LogLevel.Debug:d.debug(M);break;case m.LogLevel.Info:d.info(M);break;case m.LogLevel.Warning:d.warn(M);break;case m.LogLevel.Error:d.error(M);break;case m.LogLevel.Critical:d.critical(M);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=r;class w extends m.AbstractLoggerService{constructor(I,y,d){super(I,y);this.channel=d}createConsoleMainLogger(){return new m.AdapterLogger({log:(I,y)=>{this.channel.call("consoleLog",[I,y])}})}doCreateLogger(I,y,d){return new p(this.channel,I,y,d)}}e.LoggerChannelClient=w;class p extends m.AbstractMessageLogger{constructor(I,y,d,g){super(g==null?void 0:g.always);this.channel=I,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[y,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(I,y){const d=[[I,y]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(I){this.channel.call("log",[this.file,I])}}class n extends m.LogService{constructor(I,y){super(y);this.parent=I,this._register(I.onDidChangeLogLevel(d=>y.setLevel(d)))}setLevel(I){super.setLevel(I),this.parent.setLevel(I)}}e.FollowerLogService=n}),define(Q[93],J([0,1,6,21]),function(j,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function L(w,p,n,b){try{return(await new Promise((y,d)=>{j(["spdlog"],y,d)})).createAsyncRotatingLogger(w,p,n,b)}catch(I){console.error(I)}return null}function S(w,p,n,b){return j.__$__nodeRequire("spdlog").createRotatingLogger(w,p,n,b)}e.createRotatingLogger=S;function P(w,p,n){switch(p){case m.LogLevel.Trace:w.trace(n);break;case m.LogLevel.Debug:w.debug(n);break;case m.LogLevel.Info:w.info(n);break;case m.LogLevel.Warning:w.warn(n);break;case m.LogLevel.Error:w.error(n);break;case m.LogLevel.Critical:w.critical(n);break;default:throw new Error("Invalid log level")}}class r extends m.AbstractMessageLogger{constructor(p,n,b,I){super();this.name=p,this.filepath=n,this.rotating=b,this.buffer=[],this.setLevel(I),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}_createSpdLogLogger(){const p=this.rotating?6:1,n=30/p*R.ByteSize.MB;return L(this.name,this.filepath,n,p).then(b=>{if(b){this._logger=b,this._logger.setLevel(this.getLevel());for(const{level:I,message:y}of this.buffer)P(this._logger,I,y);this.buffer=[]}})}log(p,n){this._logger?P(this._logger,p,n):this.getLevel()<=p&&this.buffer.push({level:p,message:n})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=r}),define(Q[178],J([0,1,6,15,10,176,93,21,28]),function(j,e,m,R,L,S,P,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let p=class extends m.AbstractLoggerService{constructor(b,I){super(b.getLevel(),b.onDidChangeLogLevel);this.fileService=I}doCreateLogger(b,I,y){var d;if(b.scheme===L.Schemas.file){const g=new P.SpdLogLogger((y==null?void 0:y.name)||(0,w.generateUuid)(),b.fsPath,!(y==null?void 0:y.donotRotate),I);return(y==null?void 0:y.donotUseFormatters)&&g.clearFormatters(),g}else return new S.FileLogger((d=y==null?void 0:y.name)!==null&&d!==void 0?d:(0,R.basename)(b),b,I,this.fileService)}};p=ue([ee(0,m.ILogService),ee(1,r.IFileService)],p),e.LoggerService=p}),define(Q[179],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function m(P){return P.submenu!==void 0}e.isMenubarMenuItemSubmenu=m;function R(P){return P.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=R;function L(P){return P.uri!==void 0}e.isMenubarMenuItemRecentAction=L;function S(P){return!m(P)&&!R(P)&&!L(P)}e.isMenubarMenuItemAction=S}),define(Q[47],J([0,1,10,3,32,15]),function(j,e,m,R,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const r=R.globals.vscode.context.configuration();if(r)P=r.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(j==null?void 0:j.__$__nodeRequire)=="function"){const r=(0,S.dirname)(m.FileAccess.asFileUri("",j));P=j.__$__nodeRequire((0,S.joinPath)(r,"product.json").fsPath);const w=j.__$__nodeRequire((0,S.joinPath)(r,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`}),Object.assign(P,{version:w.version})}else P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.57.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=P}),define(Q[94],J([0,1,141,19,21,18,47]),function(j,e,m,R,L,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function r(b,I,y,d,g,M){let E;try{await w(b,I,y,d,g,M)}catch(o){E=o}finally{E&&g.errorTransformer&&(E=g.errorTransformer(E)),typeof E!="undefined"&&y.error(E),y.end()}}e.readFileIntoStream=r;async function w(b,I,y,d,g,M){p(M);const E=await b.open(I,{create:!1});try{p(M);let o=0,u=0,l=g&&typeof g.length=="number"?g.length:void 0,c=R.VSBuffer.alloc(Math.min(g.bufferSize,typeof l=="number"?l:g.bufferSize)),t=g&&typeof g.position=="number"?g.position:0,i=0;do u=await b.read(E,t,c.buffer,i,c.byteLength-i),t+=u,i+=u,o+=u,typeof l=="number"&&(l-=u),i===c.byteLength&&(await y.write(d(c)),c=R.VSBuffer.alloc(Math.min(g.bufferSize,typeof l=="number"?l:g.bufferSize)),i=0);while(u>0&&(typeof l!="number"||l>0)&&p(M)&&n(o,g));if(i>0){let s=i;typeof l=="number"&&(s=Math.min(i,l)),y.write(d(c.slice(0,s)))}}catch(o){throw(0,L.ensureFileSystemProviderError)(o)}finally{await b.close(E)}}function p(b){if(b.isCancellationRequested)throw(0,S.canceled)();return!0}function n(b,I){if(I==null?void 0:I.limits){if(typeof I.limits.memory=="number"&&b>I.limits.memory)throw(0,L.createFileSystemProviderError)((0,m.localize)(0,null,P.default.nameShort),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&b>I.limits.size)throw(0,L.createFileSystemProviderError)((0,m.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[180],J([0,1,139,72,2,21,5,15,36,35,6,19,64,9,26,10,94,63]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d,g,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let o=class extends L.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new P.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new P.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new P.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new P.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new P.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new y.ResourceQueue)}registerProvider(l,c){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,R.mark)(`code/registerFilesystem/${l}`),this.provider.set(l,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:c});const t=new L.DisposableStore;return t.add(c.onDidChangeFile(i=>this._onDidFilesChange.fire(new S.FileChangesEvent(i,!this.isPathCaseSensitive(c))))),t.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:l}))),typeof c.onDidErrorOccur=="function"&&t.add(c.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,L.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:c}),this.provider.delete(l),(0,L.dispose)(t)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(t){c.push(t)}}),!this.provider.has(l)&&await y.Promises.settled(c)}canHandleResource(l){return this.provider.has(l.scheme)}hasCapability(l,c){const t=this.provider.get(l.scheme);return!!(t&&t.capabilities&c)}listCapabilities(){return E.Iterable.map(this.provider,([l,c])=>({scheme:l,capabilities:c.capabilities}))}async withProvider(l){if(!(0,r.isAbsolutePath)(l))throw new S.FileOperationError((0,m.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const c=this.provider.get(l.scheme);if(!c){const t=new Error;throw t.name="ENOPRO",t.message=(0,m.localize)(1,null,l.toString()),t}return c}async withReadProvider(l){const c=await this.withProvider(l);if((0,S.hasOpenReadWriteCloseCapability)(c)||(0,S.hasReadWriteCapability)(c)||(0,S.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const c=await this.withProvider(l);if((0,S.hasOpenReadWriteCloseCapability)(c)||(0,S.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,c){try{return await this.doResolveFile(l,c)}catch(t){throw(0,S.toFileSystemProviderErrorCode)(t)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,m.localize)(2,null,this.resourceForError(l)),1):(0,S.ensureFileSystemProviderError)(t)}}async doResolveFile(l,c){const t=await this.withProvider(l),i=this.isPathCaseSensitive(t),s=c==null?void 0:c.resolveTo,a=c==null?void 0:c.resolveSingleChildDescendants,h=c==null?void 0:c.resolveMetadata,f=await t.stat(l);let v;return this.toFileStat(t,l,f,void 0,!!h,(D,T)=>(v||(v=w.TernarySearchTree.forUris(()=>!i),v.set(l,!0),(0,p.isNonEmptyArray)(s)&&s.forEach(W=>v.set(W,!0))),Boolean(v.findSuperstr(D.resource)||v.get(D.resource))?!0:D.isDirectory&&a?T===1:!1))}async toFileStat(l,c,t,i,s,a){var h,f;const{providerExtUri:v}=this.getExtUri(l),D={resource:c,name:v.basename(c),isFile:(t.type&S.FileType.File)!=0,isDirectory:(t.type&S.FileType.Directory)!=0,isSymbolicLink:(t.type&S.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:(f=Boolean((h=t.permissions)!==null&&h!==void 0?h:0&S.FilePermission.Readonly))!==null&&f!==void 0?f:Boolean(l.capabilities&2048),etag:(0,S.etag)({mtime:t.mtime,size:t.size})};if(D.isDirectory&&a(D,i)){try{const T=await l.readdir(c),W=await y.Promises.settled(T.map(async([$,X])=>{try{const x=v.joinPath(c,$),oe=s?await l.stat(x):{type:X};return await this.toFileStat(l,x,oe,T.length,s,a)}catch(x){return this.logService.trace(x),null}}));D.children=(0,p.coalesce)(W)}catch(T){this.logService.trace(T),D.children=[]}return D}return D}async resolveAll(l){return y.Promises.settled(l.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(l){const c=await this.withProvider(l);try{return!!await c.stat(l)}catch(t){return!1}}async canCreateFile(l,c){try{await this.doValidateCreateFile(l,c)}catch(t){return t}return!0}async doValidateCreateFile(l,c){if(!(c==null?void 0:c.overwrite)&&await this.exists(l))throw new S.FileOperationError((0,m.localize)(3,null,this.resourceForError(l)),3,c)}async createFile(l,c=b.VSBuffer.fromString(""),t){await this.doValidateCreateFile(l,t);const i=await this.writeFile(l,c);return this._onDidRunOperation.fire(new S.FileOperationEvent(l,0,i)),i}async writeFile(l,c,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:s}=this.getExtUri(i);try{await this.validateWriteFile(i,l,t)||await this.mkdirp(i,s.dirname(l));let h;if((0,S.hasReadWriteCapability)(i)&&!(c instanceof b.VSBuffer))if((0,I.isReadableStream)(c)){const f=await(0,I.peekStream)(c,3);f.ended?h=b.VSBuffer.concat(f.buffer):h=f}else h=(0,I.peekReadable)(c,f=>b.VSBuffer.concat(f),3);else h=c;!(0,S.hasOpenReadWriteCloseCapability)(i)||(0,S.hasReadWriteCapability)(i)&&h instanceof b.VSBuffer?await this.doWriteUnbuffered(i,l,t,h):await this.doWriteBuffered(i,l,t,h instanceof b.VSBuffer?(0,b.bufferToReadable)(h):h)}catch(a){throw new S.FileOperationError((0,m.localize)(4,null,this.resourceForError(l),(0,S.ensureFileSystemProviderError)(a).toString()),(0,S.toFileOperationResult)(a),t)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,c,t){if(!!(t==null?void 0:t.unlock)&&!(l.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(c)));let s;try{s=await l.stat(c)}catch(a){return}if((s.type&S.FileType.Directory)!=0)throw new S.FileOperationError((0,m.localize)(6,null,this.resourceForError(c)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==(0,S.etag)({mtime:t.mtime,size:s.size}))throw new S.FileOperationError((0,m.localize)(7,null),3,t);return s}async readFile(l,c){const t=await this.withReadProvider(l);return(c==null?void 0:c.atomic)?this.doReadFileAtomic(t,l,c):this.doReadFile(t,l,c)}async doReadFileAtomic(l,c,t){return new Promise((i,s)=>{this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(l,c,t);i(a)}catch(a){s(a)}})})}async doReadFile(l,c,t){const i=await this.doReadFileStream(l,c,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await(0,b.streamToBuffer)(i.value)})}async readFileStream(l,c){const t=await this.withReadProvider(l);return this.doReadFileStream(t,l,c)}async doReadFileStream(l,c,t){const i=new d.CancellationTokenSource,s=this.validateReadFile(c,t).then(h=>h,h=>{throw i.cancel(),h});let a;try{t&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&await s,!((0,S.hasOpenReadWriteCloseCapability)(l)||(0,S.hasFileReadStreamCapability)(l))||(0,S.hasReadWriteCapability)(l)&&(t==null?void 0:t.preferUnbuffered)?a=this.readFileUnbuffered(l,c,t):(0,S.hasFileReadStreamCapability)(l)?a=this.readFileStreamed(l,c,i.token,t):a=this.readFileBuffered(l,c,i.token,t);const h=await s;return Object.assign(Object.assign({},h),{value:a})}catch(h){throw a&&await(0,I.consumeStream)(a),new S.FileOperationError((0,m.localize)(8,null,this.resourceForError(c),(0,S.ensureFileSystemProviderError)(h).toString()),(0,S.toFileOperationResult)(h),t)}}readFileStreamed(l,c,t,i=Object.create(null)){const s=l.readFileStream(c,i,t);return(0,I.transform)(s,{data:a=>a instanceof b.VSBuffer?a:b.VSBuffer.wrap(a),error:a=>new S.FileOperationError((0,m.localize)(9,null,this.resourceForError(c),(0,S.ensureFileSystemProviderError)(a).toString()),(0,S.toFileOperationResult)(a),i)},a=>b.VSBuffer.concat(a))}readFileBuffered(l,c,t,i=Object.create(null)){const s=(0,b.newWriteableBufferStream)();return(0,M.readFileIntoStream)(l,c,s,a=>a,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new S.FileOperationError((0,m.localize)(10,null,this.resourceForError(c),(0,S.ensureFileSystemProviderError)(a).toString()),(0,S.toFileOperationResult)(a),i)}),t),s}readFileUnbuffered(l,c,t){const i=(0,I.newWriteableStream)(s=>b.VSBuffer.concat(s));return(async()=>{try{let s=await l.readFile(c);t&&typeof t.position=="number"&&(s=s.slice(t.position)),t&&typeof t.length=="number"&&(s=s.slice(0,t.length)),this.validateReadFileLimits(c,s.byteLength,t),i.end(b.VSBuffer.wrap(s))}catch(s){i.error(s),i.end()}})(),i}async validateReadFile(l,c){const t=await this.resolve(l,{resolveMetadata:!0});if(t.isDirectory)throw new S.FileOperationError((0,m.localize)(11,null,this.resourceForError(l)),0,c);if(c&&typeof c.etag=="string"&&c.etag!==S.ETAG_DISABLED&&c.etag===t.etag)throw new S.FileOperationError((0,m.localize)(12,null),2,c);return this.validateReadFileLimits(l,t.size,c),t}validateReadFileLimits(l,c,t){if(t==null?void 0:t.limits){let i;if(typeof t.limits.memory=="number"&&c>t.limits.memory&&(i=9),typeof t.limits.size=="number"&&c>t.limits.size&&(i=7),typeof i=="number")throw new S.FileOperationError((0,m.localize)(13,null,this.resourceForError(l)),i)}}async canMove(l,c,t){return this.doCanMoveCopy(l,c,"move",t)}async canCopy(l,c,t){return this.doCanMoveCopy(l,c,"copy",t)}async doCanMoveCopy(l,c,t,i){if(l.toString()!==c.toString())try{const s=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(s,l,a,c,t,i)}catch(s){return s}return!0}async move(l,c,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),a=await this.doMoveCopy(i,l,s,c,"move",!!t),h=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(l,a==="move"?2:3,h)),h}async copy(l,c,t){const i=await this.withReadProvider(l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),a=await this.doMoveCopy(i,l,s,c,"copy",!!t),h=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(l,a==="copy"?3:2,h)),h}async doMoveCopy(l,c,t,i,s,a){if(c.toString()===i.toString())return s;const{exists:h,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(l,c,t,i,s,a);if(h&&!f&&a&&await this.del(i,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i)),s==="copy"){if(l===t&&(0,S.hasFileFolderCopyCapability)(l))await l.copy(c,i,{overwrite:a});else{const v=await this.resolve(c);v.isDirectory?await this.doCopyFolder(l,v,t,i):await this.doCopyFile(l,c,t,i)}return s}else return l===t?(await l.rename(c,i,{overwrite:a}),s):(await this.doMoveCopy(l,c,t,i,"copy",a),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(l,c,t,i){if((0,S.hasOpenReadWriteCloseCapability)(l)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(l,c,t,i);if((0,S.hasOpenReadWriteCloseCapability)(l)&&(0,S.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(l,c,t,i);if((0,S.hasReadWriteCapability)(l)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(l,c,t,i);if((0,S.hasReadWriteCapability)(l)&&(0,S.hasReadWriteCapability)(t))return this.doPipeUnbuffered(l,c,t,i)}async doCopyFolder(l,c,t,i){await t.mkdir(i),Array.isArray(c.children)&&await y.Promises.settled(c.children.map(async s=>{const a=this.getExtUri(t).providerExtUri.joinPath(i,s.name);return s.isDirectory?this.doCopyFolder(l,await this.resolve(s.resource),t,a):this.doCopyFile(l,s.resource,t,a)}))}async doValidateMoveCopy(l,c,t,i,s,a){let h=!1;if(l===t){const{providerExtUri:v,isPathCaseSensitive:D}=this.getExtUri(l);if(D||(h=v.isEqual(c,i)),h&&s==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(c),this.resourceForError(i)));if(!h&&v.isEqualOrParent(i,c))throw new Error((0,m.localize)(15,null,this.resourceForError(c),this.resourceForError(i)))}const f=await this.exists(i);if(f&&!h){if(!a)throw new S.FileOperationError((0,m.localize)(16,null,this.resourceForError(c),this.resourceForError(i)),4);if(l===t){const{providerExtUri:v}=this.getExtUri(l);if(v.isEqualOrParent(c,i))throw new Error((0,m.localize)(17,null,this.resourceForError(c),this.resourceForError(i)))}}return{exists:f,isSameResourceWithDifferentPathCase:h}}getExtUri(l){const c=this.isPathCaseSensitive(l);return{providerExtUri:c?r.extUri:r.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(c,l);const t=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(l,0,t)),t}async mkdirp(l,c){const t=[],{providerExtUri:i}=this.getExtUri(l);for(;!i.isEqual(c,i.dirname(c));)try{if(((await l.stat(c)).type&S.FileType.Directory)==0)throw new Error((0,m.localize)(18,null,this.resourceForError(c)));break}catch(s){if((0,S.toFileSystemProviderErrorCode)(s)!==S.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(i.basename(c)),c=i.dirname(c)}for(let s=t.length-1;s>=0;s--){c=i.joinPath(c,t[s]);try{await l.mkdir(c)}catch(a){if((0,S.toFileSystemProviderErrorCode)(a)!==S.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(l,c){try{await this.doValidateDelete(l,c)}catch(t){return t}return!0}async doValidateDelete(l,c){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!(c==null?void 0:c.useTrash)&&!(t.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(l)));const s=await this.exists(l);if(!s)throw new S.FileOperationError((0,m.localize)(20,null,this.resourceForError(l)),1);if(!!!(c==null?void 0:c.recursive)&&s){const h=await this.resolve(l);if(h.isDirectory&&Array.isArray(h.children)&&h.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(l)))}return t}async del(l,c){const t=await this.doValidateDelete(l,c),i=!!(c==null?void 0:c.useTrash),s=!!(c==null?void 0:c.recursive);await t.delete(l,{recursive:s,useTrash:i}),this._onDidRunOperation.fire(new S.FileOperationEvent(l,1))}watch(l,c={recursive:!1,excludes:[]}){let t=!1,i=()=>{t=!0};return this.doWatch(l,c).then(s=>{t?(0,L.dispose)(s):i=()=>(0,L.dispose)(s)},s=>this.logService.error(s)),(0,L.toDisposable)(()=>i())}async doWatch(l,c){const t=await this.withProvider(l),i=this.toWatchKey(t,l,c),s=this.activeWatchers.get(i)||{count:0,disposable:t.watch(l,c)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,s),s.count+=1,(0,L.toDisposable)(()=>{s.count--,s.count===0&&((0,L.dispose)(s.disposable),this.activeWatchers.delete(i))})}toWatchKey(l,c,t){const{providerExtUri:i}=this.getExtUri(l);return[i.getComparisonKey(c),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(l=>(0,L.dispose)(l.disposable)),this.activeWatchers.clear()}async doWriteBuffered(l,c,t,i){return this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(async()=>{var s;const a=await l.open(c,{create:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1});try{(0,I.isReadableStream)(i)||(0,I.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(l,a,i):await this.doWriteReadableBufferedQueued(l,a,i)}catch(h){throw(0,S.ensureFileSystemProviderError)(h)}finally{await l.close(a)}})}async doWriteStreamBufferedQueued(l,c,t){let i=0,s;if((0,I.isReadableBufferedStream)(t)){if(t.buffer.length>0){const a=b.VSBuffer.concat(t.buffer);await this.doWriteBuffer(l,c,a,a.byteLength,i,0),i+=a.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise(async(a,h)=>{(0,I.listenStream)(s,{onData:async f=>{s.pause();try{await this.doWriteBuffer(l,c,f,f.byteLength,i,0)}catch(v){return h(v)}i+=f.byteLength,setTimeout(()=>s.resume())},onError:f=>h(f),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(l,c,t){let i=0,s;for(;(s=t.read())!==null;)await this.doWriteBuffer(l,c,s,s.byteLength,i,0),i+=s.byteLength}async doWriteBuffer(l,c,t,i,s,a){let h=0;for(;h<i;)h+=await l.write(c,s+h,t.buffer,a+h,i-h)}async doWriteUnbuffered(l,c,t,i){return this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,c,t,i))}async doWriteUnbufferedQueued(l,c,t,i){var s;let a;i instanceof b.VSBuffer?a=i:(0,I.isReadableStream)(i)?a=await(0,b.streamToBuffer)(i):(0,I.isReadableBufferedStream)(i)?a=await(0,b.bufferedStreamToBuffer)(i):a=(0,b.readableToBuffer)(i),await l.writeFile(c,a.buffer,{create:!0,overwrite:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1})}async doPipeBuffered(l,c,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,c,t,i))}async doPipeBufferedQueued(l,c,t,i){let s,a;try{s=await l.open(c,{create:!1}),a=await t.open(i,{create:!0,unlock:!1});const h=b.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,v=0,D=0;do D=await l.read(s,f,h.buffer,v,h.byteLength-v),await this.doWriteBuffer(t,a,h,D,f,v),f+=D,v+=D,v===h.byteLength&&(v=0);while(D>0)}catch(h){throw(0,S.ensureFileSystemProviderError)(h)}finally{await y.Promises.settled([typeof s=="number"?l.close(s):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async doPipeUnbuffered(l,c,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,c,t,i))}async doPipeUnbufferedQueued(l,c,t,i){return t.writeFile(i,await l.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,c,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,c,t,i))}async doPipeUnbufferedToBufferedQueued(l,c,t,i){const s=await t.open(i,{create:!0,unlock:!1});try{const a=await l.readFile(c);await this.doWriteBuffer(t,s,b.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,S.ensureFileSystemProviderError)(a)}finally{await t.close(s)}}async doPipeBufferedToUnbuffered(l,c,t,i){const s=await(0,b.streamToBuffer)(this.readFileBuffered(l,c,d.CancellationToken.None));await this.doWriteUnbuffered(t,i,void 0,s)}throwIfFileSystemIsReadonly(l,c){if(l.capabilities&2048)throw new S.FileOperationError((0,m.localize)(22,null,this.resourceForError(c)),6);return l}resourceForError(l){return l.scheme===g.Schemas.file?l.fsPath:l.toString(!0)}};o=ue([ee(0,n.ILogService)],o),e.FileService=o}),define(Q[181],J([0,1,24,114,2,21,5,3,20,8,15,30,9,6,142,91,163,165,162,171,64,94,35,19]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d,g,M,E,o,u,l,c,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class s extends L.Disposable{constructor(h,f){var v;super();this.logService=h,this.options=f,this.BUFFER_SIZE=((v=this.options)===null||v===void 0?void 0:v.bufferSize)||64*1024,this.onDidChangeCapabilities=P.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new P.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new I.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,r.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(h){try{const{stat:f,symbolicLink:v}=await w.SymlinkSupport.stat(this.toFilePath(h));return{type:this.toType(f,v),ctime:f.birthtime.getTime(),mtime:f.mtime.getTime(),size:f.size}}catch(f){throw this.toFileSystemProviderError(f)}}async readdir(h){try{const f=await(0,w.readdir)(this.toFilePath(h),{withFileTypes:!0}),v=[];return await Promise.all(f.map(async D=>{try{let T;D.isSymbolicLink()?T=(await this.stat((0,n.joinPath)(h,D.name))).type:T=this.toType(D),v.push([D.name,T])}catch(T){this.logService.trace(T)}})),v}catch(f){throw this.toFileSystemProviderError(f)}}toType(h,f){let v;return(f==null?void 0:f.dangling)?v=S.FileType.Unknown:h.isFile()?v=S.FileType.File:h.isDirectory()?v=S.FileType.Directory:v=S.FileType.Unknown,f&&(v|=S.FileType.SymbolicLink),v}async readFile(h){try{const f=this.toFilePath(h);return await m.promises.readFile(f)}catch(f){throw this.toFileSystemProviderError(f)}}readFileStream(h,f,v){const D=(0,l.newWriteableStream)(T=>i.VSBuffer.concat(T.map(W=>i.VSBuffer.wrap(W))).buffer);return(0,c.readFileIntoStream)(this,h,D,T=>T.buffer,Object.assign(Object.assign({},f),{bufferSize:this.BUFFER_SIZE}),v),D}async writeFile(h,f,v){let D;try{const T=this.toFilePath(h);if(!v.create||!v.overwrite){if(await(0,w.exists)(T)){if(!v.overwrite)throw(0,S.createFileSystemProviderError)((0,d.localize)(0,null),S.FileSystemProviderErrorCode.FileExists)}else if(!v.create)throw(0,S.createFileSystemProviderError)((0,d.localize)(1,null),S.FileSystemProviderErrorCode.FileNotFound)}D=await this.open(h,{create:!0,unlock:v.unlock}),await this.write(D,0,f,0,f.byteLength)}catch(T){throw await this.toFileSystemProviderWriteError(h,T)}finally{typeof D=="number"&&await this.close(D)}}async open(h,f){try{const v=this.toFilePath(h);if((0,S.isFileOpenForWriteOptions)(f)&&f.unlock)try{const{stat:W}=await w.SymlinkSupport.stat(v);W.mode&128||await m.promises.chmod(v,W.mode|128)}catch(W){this.logService.trace(W)}let D;if((0,S.isFileOpenForWriteOptions)(f)){if(r.isWindows)try{await m.promises.truncate(v,0),D="r+"}catch(W){W.code!=="ENOENT"&&this.logService.trace(W)}D||(D="w")}else D="r";const T=await(0,R.promisify)(m.open)(v,D);return this.mapHandleToPos.set(T,0),(0,S.isFileOpenForWriteOptions)(f)&&this.writeHandles.set(T,h),T}catch(v){throw(0,S.isFileOpenForWriteOptions)(f)?await this.toFileSystemProviderWriteError(h,v):this.toFileSystemProviderError(v)}}async close(h){try{if(this.mapHandleToPos.delete(h),this.writeHandles.delete(h)&&this.canFlush)try{await(0,R.promisify)(m.fdatasync)(h)}catch(f){this.canFlush=!1,this.logService.error(f)}return await(0,R.promisify)(m.close)(h)}catch(f){throw this.toFileSystemProviderError(f)}}async read(h,f,v,D,T){const W=this.normalizePos(h,f);let $=null;try{const X=await(0,R.promisify)(m.read)(h,v,D,T,W);return typeof X=="number"?$=X:$=X.bytesRead,$}catch(X){throw this.toFileSystemProviderError(X)}finally{this.updatePos(h,W,$)}}normalizePos(h,f){return f===this.mapHandleToPos.get(h)?null:f}updatePos(h,f,v){const D=this.mapHandleToPos.get(h);typeof D=="number"&&(typeof f=="number"||(typeof v=="number"?this.mapHandleToPos.set(h,D+v):this.mapHandleToPos.delete(h)))}async write(h,f,v,D,T){return(0,I.retry)(()=>this.doWrite(h,f,v,D,T),100,3)}async doWrite(h,f,v,D,T){const W=this.normalizePos(h,f);let $=null;try{const X=await(0,R.promisify)(m.write)(h,v,D,T,W);return typeof X=="number"?$=X:$=X.bytesWritten,$}catch(X){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(h),X)}finally{this.updatePos(h,W,$)}}async mkdir(h){try{await m.promises.mkdir(this.toFilePath(h))}catch(f){throw this.toFileSystemProviderError(f)}}async delete(h,f){try{const v=this.toFilePath(h);await this.doDelete(v,f)}catch(v){throw this.toFileSystemProviderError(v)}}async doDelete(h,f){f.recursive?await(0,w.rimraf)(h,w.RimRafMode.MOVE):await m.promises.unlink(h)}async rename(h,f,v){const D=this.toFilePath(h),T=this.toFilePath(f);if(D!==T)try{await this.validateTargetDeleted(h,f,"move",v.overwrite),await(0,w.move)(D,T)}catch(W){throw(W.code==="EINVAL"||W.code==="EBUSY"||W.code==="ENAMETOOLONG")&&(W=new Error((0,d.localize)(2,null,(0,p.basename)(D),(0,p.basename)((0,p.dirname)(T)),W.toString()))),this.toFileSystemProviderError(W)}}async copy(h,f,v){const D=this.toFilePath(h),T=this.toFilePath(f);if(D!==T)try{await this.validateTargetDeleted(h,f,"copy",v.overwrite),await(0,w.copy)(D,T,{preserveSymlinks:!0})}catch(W){throw(W.code==="EINVAL"||W.code==="EBUSY"||W.code==="ENAMETOOLONG")&&(W=new Error((0,d.localize)(3,null,(0,p.basename)(D),(0,p.basename)((0,p.dirname)(T)),W.toString()))),this.toFileSystemProviderError(W)}}async validateTargetDeleted(h,f,v,D){const T=this.toFilePath(h),W=this.toFilePath(f);let $=!1;if(!!(this.capabilities&1024)||($=(0,b.isEqual)(T,W,!0)),$&&v==="copy")throw(0,S.createFileSystemProviderError)((0,d.localize)(4,null),S.FileSystemProviderErrorCode.FileExists);if(!$&&await(0,w.exists)(W)){if(!D)throw(0,S.createFileSystemProviderError)((0,d.localize)(5,null),S.FileSystemProviderErrorCode.FileExists);await this.delete(f,{recursive:!0,useTrash:!1})}}watch(h,f){return f.recursive?this.watchRecursive(h,f.excludes):this.watchNonRecursive(h)}watchRecursive(h,f){const v={path:this.toFilePath(h),excludes:f},D=(0,t.insert)(this.recursiveFoldersToWatch,v);return this.refreshRecursiveWatchers(),(0,L.toDisposable)(()=>{D(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var h,f,v;if(this.recursiveWatcher instanceof o.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,L.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let D,T;((f=(h=this.options)===null||h===void 0?void 0:h.watcher)===null||f===void 0?void 0:f.usePolling)?(D=M.FileWatcher,T=(v=this.options)===null||v===void 0?void 0:v.watcher):this.recursiveFoldersToWatch.length===1?r.isWindows?D=E.FileWatcher:D=M.FileWatcher:D=o.FileWatcher,this.recursiveWatcher=new D(this.recursiveFoldersToWatch,W=>this._onDidChangeFile.fire((0,g.toFileChanges)(W)),W=>{W.type==="error"&&this._onDidWatchErrorOccur.fire(W.message),this.logService[W.type](W.message)},this.logService.getLevel()===y.LogLevel.Trace,T),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)}))}}watchNonRecursive(h){const f=new u.FileWatcher(this.toFilePath(h),D=>this._onDidChangeFile.fire((0,g.toFileChanges)(D)),D=>{D.type==="error"&&this._onDidWatchErrorOccur.fire(D.message),this.logService[D.type](D.message)},this.logService.getLevel()===y.LogLevel.Trace),v=this.logService.onDidChangeLogLevel(()=>{f.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)});return(0,L.combinedDisposable)(f,v)}toFilePath(h){return(0,p.normalize)(h.fsPath)}toFileSystemProviderError(h){if(h instanceof S.FileSystemProviderError)return h;let f;switch(h.code){case"ENOENT":f=S.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":f=S.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":f=S.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":f=S.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":f=S.FileSystemProviderErrorCode.NoPermissions;break;default:f=S.FileSystemProviderErrorCode.Unknown}return(0,S.createFileSystemProviderError)(h,f)}async toFileSystemProviderWriteError(h,f){let v=this.toFileSystemProviderError(f);if(h&&v.code===S.FileSystemProviderErrorCode.NoPermissions)try{const{stat:D}=await w.SymlinkSupport.stat(this.toFilePath(h));D.mode&128||(v=(0,S.createFileSystemProviderError)(f,S.FileSystemProviderErrorCode.FileWriteLocked))}catch(D){this.logService.trace(D)}return v}dispose(){super.dispose(),(0,L.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,L.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=s}),define(Q[22],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,m.createDecorator)("productService")}),define(Q[182],J([0,1,58,6,22]),function(j,e,m,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let S=class{constructor(r,w){this.productService=r,this.logService=w,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(r,w){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const p=/^(.*)#([^#]+)$/.exec(w);if(!p)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",w),!1;const[,n,b]=p;let I=this.trustedExtensionUrlPublicKeys.get(r);if(!I){if(I=this.productService.trustedExtensionUrlPublicKeys[r],!I||I.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",r),!1;this.trustedExtensionUrlPublicKeys.set(r,[...I])}const y=Buffer.from(decodeURIComponent(b),"base64");if(y.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",w),!1;const d=y.slice(0,6),g=y.readUIntBE(0,6),M=Date.now()-g;if(M<0||M>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",w),!1;const E=y.slice(6),o=m.createVerify("SHA256");o.write(d),o.write(Buffer.from(n)),o.end();for(let u=0;u<I.length;u++){let l=I[u];if(l!==null){if(typeof l=="string")try{l=m.createPublicKey({key:Buffer.from(l,"base64"),format:"der",type:"spki"}),I[u]=l}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${u+1} for ${r}:`,c),I[u]=null;continue}if(o.verify(l,E))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",w),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",w),!1}};S=ue([ee(0,L.IProductService),ee(1,R.ILogService)],S),e.ExtensionUrlTrustService=S}),define(Q[55],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,m.createDecorator)("protocolMainService")}),define(Q[183],J([0,1,2,10,7,53,14,6,36,3,15,28]),function(j,e,m,R,L,S,P,r,w,p,n,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let I=class extends m.Disposable{constructor(d,g){super();this.logService=g,this.validRoots=w.TernarySearchTree.forUris(()=>!p.isLinux),this.validExtensions=new Set([".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(L.URI.file(d.appRoot)),this.addValidFileRoot(L.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=P.session;d.protocol.registerFileProtocol(R.Schemas.vscodeFileResource,(g,M)=>this.handleResourceRequest(g,M)),d.protocol.interceptFileProtocol(R.Schemas.file,(g,M)=>this.handleFileRequest(g,M)),this._register((0,m.toDisposable)(()=>{d.protocol.unregisterProtocol(R.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(R.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?m.Disposable.None:(this.validRoots.set(d,!0),(0,m.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(d,g){const M=L.URI.parse(d.url);return p.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${M.fsPath} from ${R.Schemas.file}: protocol (original URL: ${d.url})`),g({error:-3})):this.validRoots.findSubstr(M)?g({path:M.fsPath}):this.validExtensions.has((0,n.extname)(M))?g({path:M.fsPath}):(this.logService.error(`${R.Schemas.file}: Refused to load resource ${M.fsPath} from ${R.Schemas.file}: protocol (original URL: ${d.url})`),g({error:-3}))}handleResourceRequest(d,g){const M=L.URI.parse(d.url),E=R.FileAccess.asFileUri(M);return this.validRoots.findSubstr(E)?g({path:E.fsPath}):this.validExtensions.has((0,n.extname)(E))?g({path:E.fsPath}):(this.logService.error(`${R.Schemas.vscodeFileResource}: Refused to load resource ${E.fsPath} from ${R.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),g({error:-3}))}createIPCObjectUrl(){let d;const g=L.URI.from({scheme:"vscode",path:(0,b.generateUuid)()}),M=g.toString(),E=async()=>d;return P.ipcMain.handle(M,E),this.logService.trace(`IPC Object URL: Registered new channel ${M}.`),{resource:g,update:o=>d=o,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${M}.`),P.ipcMain.removeHandler(M)}}}};I=ue([ee(0,S.INativeEnvironmentService),ee(1,r.ILogService)],I),e.ProtocolMainService=I}),define(Q[37],J([0,1,13,101]),function(j,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(P,r){R.ok(m.isString(P)),R.ok(m.isObject(r)),R.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,r)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new L}),define(Q[184],J([0,1,37,5]),function(j,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(r){return r.length>0&&r.charAt(r.length-1)==="#"?r.substring(0,r.length-1):r}class S{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,p){this.schemasById[L(w)]=p,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new S;m.Registry.add(e.Extensions.JSONContribution,P)}),define(Q[48],J([0,1,132,5,37,13,184]),function(j,e,m,R,L,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var r;(function(M){M[M.APPLICATION=1]="APPLICATION",M[M.MACHINE=2]="MACHINE",M[M.WINDOW=3]="WINDOW",M[M.RESOURCE=4]="RESOURCE",M[M.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",M[M.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(r=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const w=L.Registry.as(P.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,o=!0){this.registerConfigurations([E],o)}registerConfigurations(E,o=!0){const u=[];E.forEach(l=>{u.push(...this.validateAndRegisterProperties(l,o,l.extensionInfo)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(E){const o=[],u=l=>{if(l.properties)for(const c in l.properties)o.push(c),delete this.configurationProperties[c],this.removeFromSchema(c,l.properties[c]);l.allOf&&l.allOf.forEach(c=>u(c))};for(const l of E){u(l);const c=this.configurationContributors.indexOf(l);c!==-1&&this.configurationContributors.splice(c,1)}w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}registerDefaultConfigurations(E){const o=[],u=[];for(const l of E)for(const c in l)if(o.push(c),e.OVERRIDE_PROPERTY_PATTERN.test(c)){this.defaultValues[c]=Object.assign(Object.assign({},this.defaultValues[c]||{}),l[c]);const t={type:"object",default:this.defaultValues[c],description:m.localize(1,null,c),$ref:e.resourceLanguageSettingsSchemaId};u.push(b(c)),this.configurationProperties[c]=t,this.defaultLanguageConfigurationOverridesNode.properties[c]=t}else{this.defaultValues[c]=l[c];const t=this.configurationProperties[c];t&&(this.updatePropertyDefaultValue(c,t),this.updateSchema(c,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(E){const o=[];for(const u of E)for(const l in u)if(o.push(l),delete this.defaultValues[l],e.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const c=this.configurationProperties[l];c&&(this.updatePropertyDefaultValue(l,c),this.updateSchema(l,c))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const o of E)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,o=!0,u,l=3){var c;l=S.isUndefinedOrNull(E.scope)?l:E.scope;let t=[],i=E.properties;if(i)for(let a in i){if(o&&d(a)){delete i[a];continue}const h=i[a];if(this.updatePropertyDefaultValue(a,h),e.OVERRIDE_PROPERTY_PATTERN.test(a)?h.scope=void 0:(h.scope=S.isUndefinedOrNull(h.scope)?l:h.scope,h.restricted=S.isUndefinedOrNull(h.restricted)?!!((c=u==null?void 0:u.restrictedConfigurations)===null||c===void 0?void 0:c.includes(a)):h.restricted),i[a].hasOwnProperty("included")&&!i[a].included){this.excludedConfigurationProperties[a]=i[a],delete i[a];continue}else this.configurationProperties[a]=i[a];!i[a].deprecationMessage&&i[a].markdownDeprecationMessage&&(i[a].deprecationMessage=i[a].markdownDeprecationMessage),t.push(a)}let s=E.allOf;if(s)for(let a of s)t.push(...this.validateAndRegisterProperties(a,o,u,l));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const o=u=>{let l=u.properties;if(l)for(const t in l)this.updateSchema(t,l[t]);let c=u.allOf;c&&c.forEach(o)};o(E)}updateSchema(E,o){switch(e.allSettings.properties[E]=o,o.scope){case 1:e.applicationSettings.properties[E]=o;break;case 2:e.machineSettings.properties[E]=o;break;case 6:e.machineOverridableSettings.properties[E]=o;break;case 3:e.windowSettings.properties[E]=o;break;case 4:e.resourceSettings.properties[E]=o;break;case 5:e.resourceSettings.properties[E]=o,this.resourceLanguageSettingsSchema.properties[E]=o;break}}removeFromSchema(E,o){switch(delete e.allSettings.properties[E],o.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const o=`[${E}]`,u={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,u),e.allSettings.properties[o]=u,e.applicationSettings.properties[o]=u,e.machineSettings.properties[o]=u,e.machineOverridableSettings.properties[o]=u,e.windowSettings.properties[o]=u,e.resourceSettings.properties[o]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,o){let u=this.defaultValues[E];S.isUndefined(u)&&(u=o.default),S.isUndefined(u)&&(u=I(o.type)),o.default=u}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function b(M){return M.substring(1,M.length-1)}e.overrideIdentifierFromKey=b;function I(M){switch(Array.isArray(M)?M[0]:M){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=I;const y=new p;L.Registry.add(e.Extensions.Configuration,y);function d(M){return M.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(M)?m.localize(5,null,M):y.getConfigurationProperties()[M]!==void 0?m.localize(6,null,M):null:m.localize(4,null)}e.validateProperty=d;function g(){const M=[],E=y.getConfigurationProperties();for(const o of Object.keys(E))M.push([o,E[o].scope]);return M.push(["launch",4]),M.push(["task",4]),M}e.getScopes=g}),define(Q[16],J([0,1,44,13,7,37,4,48]),function(j,e,m,R,L,S,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function w(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof L.URI)}e.isConfigurationOverrides=w;var p;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(p=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function b(i,s){const a=s?i?s.keys.filter($=>i.keys.indexOf($)===-1):[...s.keys]:[],h=i?s?i.keys.filter($=>s.keys.indexOf($)===-1):[...i.keys]:[],f=[];if(s&&i){for(const $ of i.keys)if(s.keys.indexOf($)!==-1){const X=E(i.contents,$),x=E(s.contents,$);m.equals(X,x)||f.push($)}}const v=[],D=$=>{const X={};for(const x of $)for(const oe of x.identifiers)X[c(oe)]=x;return X},T=s?D(s.overrides):{},W=i?D(i.overrides):{};if(Object.keys(T).length)for(const $ of a){const X=T[$];X&&v.push([(0,r.overrideIdentifierFromKey)($),X.keys])}if(Object.keys(W).length)for(const $ of h){const X=W[$];X&&v.push([(0,r.overrideIdentifierFromKey)($),X.keys])}if(Object.keys(T).length&&Object.keys(W).length)for(const $ of f){const X=W[$],x=T[$];if(X&&x){const oe=b({contents:X.contents,keys:X.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});v.push([(0,r.overrideIdentifierFromKey)($),[...oe.added,...oe.removed,...oe.updated]])}}return{added:a,removed:h,updated:f,overrides:v}}e.compare=b;function I(i,s){const a=[];for(const h of Object.keys(i))if(r.OVERRIDE_PROPERTY_PATTERN.test(h)){const f={};for(const v in i[h])f[v]=i[h][v];a.push({identifiers:[(0,r.overrideIdentifierFromKey)(h).trim()],keys:Object.keys(f),contents:y(f,s)})}return a}e.toOverrides=I;function y(i,s){const a=Object.create(null);for(let h in i)d(a,h,i[h],s);return a}e.toValuesTree=y;function d(i,s,a,h){const f=s.split("."),v=f.pop();let D=i;for(let T=0;T<f.length;T++){let W=f[T],$=D[W];switch(typeof $){case"undefined":$=D[W]=Object.create(null);break;case"object":break;default:h(`Ignoring ${s} as ${f.slice(0,T+1).join(".")} is ${JSON.stringify($)}`);return}D=$}if(typeof D=="object"&&D!==null)try{D[v]=a}catch(T){h(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(D)}`)}else h(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=d;function g(i,s){const a=s.split(".");M(i,a)}e.removeFromValueTree=g;function M(i,s){const a=s.shift();if(s.length===0){delete i[a];return}if(Object.keys(i).indexOf(a)!==-1){const h=i[a];typeof h=="object"&&!Array.isArray(h)&&(M(h,s),Object.keys(h).length===0&&delete i[a])}}function E(i,s,a){function h(D,T){let W=D;for(const $ of T){if(typeof W!="object"||W===null)return;W=W[$]}return W}const f=s.split("."),v=h(i,f);return typeof v=="undefined"?a:v}e.getConfigurationValue=E;function o(i,s,a){Object.keys(s).forEach(h=>{h!=="__proto__"&&(h in i?R.isObject(i[h])&&R.isObject(s[h])?o(i[h],s[h],a):a&&(i[h]=s[h]):i[h]=s[h])})}e.merge=o;function u(){const i=S.Registry.as(r.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=u;function l(){const i=Object.create(null),s=S.Registry.as(r.Extensions.Configuration).getConfigurationProperties();for(let a in s){let h=s[a].default;d(i,a,h,f=>console.error(`Conflict in default settings: ${f}`))}return i}e.getDefaultValues=l;function c(i){return`[${i}]`}e.keyFromOverrideIdentifier=c;function t(i,s,a){const h=i.inspect(s),f=i.inspect(a);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:h.defaultValue}e.getMigratedSettingValue=t}),define(Q[185],J([0,1,43,36,35,13,44,7,48,16,37,2,5]),function(j,e,m,R,L,S,P,r,w,p,n,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class y{constructor(t={},i=[],s=[]){this._contents=t,this._keys=i,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,p.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const s=this.getContentsForOverrideIdentifer(i);return s?t?(0,p.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const a of L.distinct([...Object.keys(this.contents),...Object.keys(i)])){let h=this.contents[a],f=i[a];f&&(typeof h=="object"&&typeof f=="object"?(h=P.deepClone(h),this.mergeContents(h,f)):h=f),s[a]=h}return new y(s,this.keys,this.overrides)}merge(...t){const i=P.deepClone(this.contents),s=P.deepClone(this.overrides),a=[...this.keys];for(const h of t){this.mergeContents(i,h.contents);for(const f of h.overrides){const[v]=s.filter(D=>L.equals(D.identifiers,f.identifiers));v?this.mergeContents(v.contents,f.contents):s.push(P.deepClone(f))}for(const f of h.keys)a.indexOf(f)===-1&&a.push(f)}return new y(i,a,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const s of Object.keys(i)){if(s in t&&S.isObject(t[s])&&S.isObject(i[s])){this.mergeContents(t[s],i[s]);continue}t[s]=P.deepClone(i[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,p.addToValueTree)(this.contents,t,i,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,p.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let s=0;s<i;s++)t.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=y;class d extends y{constructor(){const t=(0,p.getDefaultValues)(),i=(0,p.getConfigurationKeys)(),s=[];for(const a of Object.keys(t))w.OVERRIDE_PROPERTY_PATTERN.test(a)&&s.push({identifiers:[(0,w.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(t[a]),contents:(0,p.toValuesTree)(t[a],h=>console.error(`Conflict in default settings file: ${h}`))});super(t,i,s)}}e.DefaultConfigurationModel=d;class g{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!S.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:s,keys:a,overrides:h,restricted:f}=this.doParseRaw(t,i);this._configurationModel=new y(s,a,h),this._restrictedConfigurations=f||[]}doParseContent(t){let i={},s=null,a=[],h=[],f=[];function v(T){Array.isArray(a)?a.push(T):s&&(a[s]=T)}let D={onObjectBegin:()=>{let T={};v(T),h.push(a),a=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{let T=[];v(T),h.push(a),a=T,s=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:v,onError:(T,W,$)=>{f.push({error:T,offset:W,length:$})}};if(t)try{m.visit(t,D),i=a[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return i}doParseRaw(t,i){const s=n.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,s,!0,i);t=a.raw;const h=(0,p.toValuesTree)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),f=Object.keys(t),v=(0,p.toOverrides)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:h,keys:f,overrides:v,restricted:a.restricted}}filter(t,i,s,a){if(!(a==null?void 0:a.scopes)&&!(a==null?void 0:a.skipRestricted))return{raw:t,restricted:[]};const h={},f=[];for(let v in t)if(w.OVERRIDE_PROPERTY_PATTERN.test(v)&&s){const D=this.filter(t[v],i,!1,a);h[v]=D.raw,f.push(...D.restricted)}else{const D=i[v],T=D?typeof D.scope!="undefined"?D.scope:3:void 0;(D==null?void 0:D.restricted)&&f.push(v),(T===void 0||a.scopes===void 0||a.scopes.includes(T))&&(a.skipRestricted&&(D==null?void 0:D.restricted)||(h[v]=t[v]))}return{raw:h,restricted:f}}}e.ConfigurationModelParser=g;class M extends b.Disposable{constructor(t,i,s,a){super();this.userSettingsResource=t,this.scopes=i,this.fileService=a,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=M;class E{constructor(t,i,s=new y,a=new y,h=new R.ResourceMap,f=new y,v=new R.ResourceMap,D=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=h,this._memoryConfiguration=f,this._memoryConfigurationByResource=v,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(t)}updateValue(t,i,s={}){let a;s.resource?(a=this._memoryConfigurationByResource.get(s.resource),a||(a=new y,this._memoryConfigurationByResource.set(s.resource,a))):a=this._memoryConfiguration,i===void 0?a.removeValue(t):a.setValue(t,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,s){const a=this.getConsolidateConfigurationModel(i,s),h=this.getFolderConfigurationModelForResource(i.resource,s),f=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,v=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),D=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),T=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),W=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),$=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,X=h?i.overrideIdentifier?h.freeze().override(i.overrideIdentifier).getValue(t):h.freeze().getValue(t):void 0,x=i.overrideIdentifier?f.override(i.overrideIdentifier).getValue(t):f.getValue(t),oe=a.getValue(t),q=L.distinct(L.flatten(a.overrides.map(N=>N.identifiers))).filter(N=>a.getOverrideValue(t,N)!==void 0);return{defaultValue:v,userValue:D,userLocalValue:T,userRemoteValue:W,workspaceValue:$,workspaceFolderValue:X,memoryValue:x,value:oe,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:W!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:$!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:X!==void 0?{value:h==null?void 0:h.freeze().getValue(t),override:i.overrideIdentifier?h==null?void 0:h.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:f.getValue(t),override:i.overrideIdentifier?f.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=i.filter(a=>w.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const h=(0,w.overrideIdentifierFromKey)(a),f=this._defaultConfiguration.getKeysForOverrideIdentifier(h),v=t.getKeysForOverrideIdentifier(h),D=[...v.filter(T=>f.indexOf(T)===-1),...f.filter(T=>v.indexOf(T)===-1),...f.filter(T=>!P.equals(this._defaultConfiguration.override(h).getValue(T),t.override(h).getValue(T)))];return[h,D]});return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:a,overrides:h}=(0,p.compare)(this.localUserConfiguration,t),f=[...i,...s,...a];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:a,overrides:h}=(0,p.compare)(this.remoteUserConfiguration,t);let f=[...i,...s,...a];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:a,overrides:h}=(0,p.compare)(this.workspaceConfiguration,t);let f=[...i,...s,...a];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:h}}compareAndUpdateFolderConfiguration(t,i){const s=this.folderConfigurations.get(t),{added:a,updated:h,removed:f,overrides:v}=(0,p.compare)(s,i);let D=[...a,...h,...f];return(D.length||!s)&&this.updateFolderConfiguration(t,i),{keys:D,overrides:v}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:a,removed:h,overrides:f}=(0,p.compare)(i,void 0);return{keys:[...s,...a,...h],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let s=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const a=i.getFolder(t);a&&(s=this.getFolderConsolidatedConfiguration(a.uri)||s);const h=this._memoryConfigurationByResource.get(t);h&&(s=s.merge(h))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(i=s.merge(a),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=s}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:s,overrides:a,keys:h}=this._folderConfigurations.get(i);return t.push([i,{contents:s,overrides:a,keys:h}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(a=>i.add(a))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),h=t.folders.reduce((f,v)=>(f.set(r.URI.revive(v[0]),this.parseConfigurationModel(v[1])),f),new R.ResourceMap);return new E(i,s,new y,a,h,new y,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new y(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=E;function o(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const t=new Set,i=new Map;for(const a of c)a.keys.forEach(h=>t.add(h)),a.overrides.forEach(([h,f])=>{const v=(0,R.getOrSet)(i,h,new Set);f.forEach(D=>v.add(D))});const s=[];return i.forEach((a,h)=>s.push([h,[...a.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=o;class u{constructor(t,i,s,a){this.change=t,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=a,this._previousConfiguration=void 0;const h=new Set;t.keys.forEach(v=>h.add(v)),t.overrides.forEach(([,v])=>v.forEach(D=>h.add(D))),this.affectedKeys=[...h.values()];const f=new y;this.affectedKeys.forEach(v=>f.setValue(v,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,h=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!P.equals(a,h)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let s=(0,p.toValuesTree)({[i]:!0},()=>{}),a;for(;typeof s=="object"&&(a=Object.keys(s)[0]);){if(t=t[a],!t)return!1;s=s[a]}return!0}}e.ConfigurationChangeEvent=u;class l extends u{constructor(t,i,s,a){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=s,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=l}),define(Q[186],J([0,1,37,48,2,16,185,5,9,15]),function(j,e,m,R,L,S,P,r,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends L.Disposable{constructor(I,y){super();this.settingsResource=I,this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,p.extUriBiasedIgnorePathCase,y)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(R.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const I=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,I)}getConfigurationData(){return this.configuration.toData()}getValue(I,y){const d=typeof I=="string"?I:void 0,g=(0,S.isConfigurationOverrides)(I)?I:(0,S.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(d,g,void 0)}updateValue(I,y,d,g){return Promise.reject(new Error("not supported"))}inspect(I){return this.configuration.inspect(I,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const I=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(I)}onDidChangeUserConfiguration(I){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(I);this.trigger(d,y,1)}onDidDefaultConfigurationChange(I){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,I);this.trigger(d,y,6)}trigger(I,y,d){const g=new P.ConfigurationChangeEvent(I,{data:y},this.configuration);g.source=d,g.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(I){switch(I){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(Q[187],J([0,1,45,8,68,138,20,3,89,16,4,10,104]),function(j,e,m,R,L,S,P,r,w,p,n,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const y=S.localize(0,null);class d{async getDefaultTerminalForPlatforms(){const t=await E.getDefaultTerminalLinuxReady();return{windows:g.getDefaultTerminalWindows(),linux:t,osx:"xterm"}}}let g=class Je extends d{constructor(t){super();this._configurationService=t}openTerminal(t){const i=this._configurationService.getValue();return this.spawnTerminal(m,i,L.getWindowsShell(),t)}spawnTerminal(t,i,s,a){const h=i.terminal.external,f=(h==null?void 0:h.windowsExec)||Je.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const v=R.basename(f).toLowerCase();if(v==="cmder"||v==="cmder.exe")return t.spawn(f,a?[a]:void 0),Promise.resolve(void 0);const D=["/c","start","/wait"];return f.indexOf(" ")>=0&&D.push('""'),D.push(f),(v==="wt"||v==="wt.exe")&&D.push("-d ."),new Promise((T,W)=>{const $=o(process),X=t.spawn(s,D,{cwd:a,env:$});X.on("error",W),X.on("exit",()=>T())})}runInTerminal(t,i,s,a,h){const f=h.windowsExec||Je.getDefaultTerminalWindows();return new Promise((v,D)=>{const T=`"${i} - ${y}"`,W=`""${s.join('" "')}" & pause"`,$=["/c","start",T,"/wait",f,"/c",W],X=Object.assign({},o(process),a);Object.keys(X).filter(q=>X[q]===null).forEach(q=>delete X[q]);const x={cwd:i,env:X,windowsVerbatimArguments:!0};m.spawn(Je.CMD,$,x).on("error",q=>{D(u(q))}),v(void 0)})}static getDefaultTerminalWindows(){if(!Je._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");Je._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return Je._DEFAULT_TERMINAL_WINDOWS}};g.CMD="cmd.exe",g=ue([ee(0,(0,n.optional)(p.IConfigurationService))],g),e.WindowsExternalTerminalService=g;let M=class Et extends d{constructor(t){super();this._configurationService=t}openTerminal(t){const i=this._configurationService.getValue();return this.spawnTerminal(m,i,t)}runInTerminal(t,i,s,a,h){const f=h.osxExec||w.DEFAULT_TERMINAL_OSX;return new Promise((v,D)=>{if(f===w.DEFAULT_TERMINAL_OSX||f==="iTerm.app"){const T=f===w.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",$=[b.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${T}.scpt`,j).fsPath,"-t",t||y,"-w",i];for(let oe of s)$.push("-a"),$.push(oe);if(a)for(let oe in a){const q=a[oe];q===null?($.push("-u"),$.push(oe)):($.push("-e"),$.push(`${oe}=${q}`))}let X="";const x=m.spawn(Et.OSASCRIPT,$);x.on("error",oe=>{D(u(oe))}),x.stderr.on("data",oe=>{X+=oe.toString()}),x.on("exit",oe=>{if(oe===0)v(void 0);else if(X){const q=X.split(`
`,1);D(new Error(q[0]))}else D(new Error(S.localize(1,null,T,oe)))})}else D(new Error(S.localize(2,null,f)))})}spawnTerminal(t,i,s){const a=i.terminal.external,h=(a==null?void 0:a.osxExec)||w.DEFAULT_TERMINAL_OSX;return new Promise((f,v)=>{const D=["-a",h];s&&D.push(s);const T=t.spawn("/usr/bin/open",D);T.on("error",v),T.on("exit",()=>f())})}};M.OSASCRIPT="/usr/bin/osascript",M=ue([ee(0,(0,n.optional)(p.IConfigurationService))],M),e.MacExternalTerminalService=M;let E=class Ze extends d{constructor(t){super();this._configurationService=t}openTerminal(t){const i=this._configurationService.getValue();return this.spawnTerminal(m,i,t)}runInTerminal(t,i,s,a,h){const f=h.linuxExec?Promise.resolve(h.linuxExec):Ze.getDefaultTerminalLinuxReady();return new Promise((v,D)=>{let T=[];f.then(W=>{W.indexOf("gnome-terminal")>=0?T.push("-x"):T.push("-e"),T.push("bash"),T.push("-c");const $=`${l(s)}; echo; read -p "${Ze.WAIT_MESSAGE}" -n1;`;T.push(`''${$}''`);const X=Object.assign({},process.env,a);Object.keys(X).filter(N=>X[N]===null).forEach(N=>delete X[N]);const x={cwd:i,env:X};let oe="";const q=m.spawn(W,T,x);q.on("error",N=>{D(u(N))}),q.stderr.on("data",N=>{oe+=N.toString()}),q.on("exit",N=>{if(N===0)v(void 0);else if(oe){const B=oe.split(`
`,1);D(new Error(B[0]))}else D(new Error(S.localize(4,null,W,N)))})})})}static async getDefaultTerminalLinuxReady(){return Ze._DEFAULT_TERMINAL_LINUX_READY||(Ze._DEFAULT_TERMINAL_LINUX_READY=new Promise(async t=>{r.isLinux?await P.exists("/etc/debian_version")?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm"):t("xterm")})),Ze._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,i,s){const a=i.terminal.external,h=(a==null?void 0:a.linuxExec)?Promise.resolve(a.linuxExec):Ze.getDefaultTerminalLinuxReady();return new Promise((f,v)=>{h.then(D=>{const T=o(process),W=t.spawn(D,[],{cwd:s,env:T});W.on("error",v),W.on("exit",()=>f())})})}};E.WAIT_MESSAGE=S.localize(3,null),E=ue([ee(0,(0,n.optional)(p.IConfigurationService))],E),e.LinuxExternalTerminalService=E;function o(c){const t=c.env;return(0,I.sanitizeProcessEnvironment)(t),t}function u(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(S.localize(5,null,c.path)):c}function l(c){let t="";for(let i of c)i.indexOf(" ")>=0?t+='"'+i+'"':t+=i,t+=" ";return t}}),define(Q[188],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var R;(function(P){P[P.Unknown=0]="Unknown",P[P.DisableTrust=1]="DisableTrust",P[P.MachineTrusted=2]="MachineTrusted"})(R=e.RemoteTrustOption||(e.RemoteTrustOption={}));var L;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class S extends Error{constructor(r,w=L.Unknown,p){super(r);this._message=r,this._code=w,this._detail=p,this.isHandled=w===L.NotAvailable&&p===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,S.prototype)}static isTemporarilyNotAvailable(r){return r instanceof S&&r._code===L.TemporarilyNotAvailable}static isNoResolverFound(r){return r instanceof S&&r._code===L.NoResolverFound}static isHandled(r){return r instanceof S&&r.isHandled}}e.RemoteAuthorityResolverError=S}),define(Q[189],J([0,1,83,28,2,19,5,188,18,9,26]),function(j,e,m,R,L,S,P,r,w,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const b=30*1e3;var I;(function(k){k[k.Management=1]="Management",k[k.ExtensionHost=2]="ExtensionHost",k[k.Tunnel=3]="Tunnel"})(I=e.ConnectionType||(e.ConnectionType={}));function y(k){switch(k){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(k){const F=new n.CancellationTokenSource;return setTimeout(()=>F.cancel(),k),F.token}function g(k,F){if(k.isCancellationRequested||F.isCancellationRequested)return n.CancellationToken.Cancelled;const U=new n.CancellationTokenSource;return k.onCancellationRequested(()=>U.cancel()),F.onCancellationRequested(()=>U.cancel()),U.token}class M{constructor(F){this._state="pending",this._disposables=new L.DisposableStore,this.promise=new Promise((U,K)=>{this._resolvePromise=U,this._rejectPromise=K}),F.isCancellationRequested?this._timeout():this._disposables.add(F.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(F){this._state==="pending"?this._disposables.add(F):F.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const F=new Error("Time limit reached");return F.code="ETIMEDOUT",F.syscall="connect",F}resolve(F){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(F))}reject(F){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(F))}}function E(k,F){const U=new M(F);return U.registerDisposable(k.onControlMessage(K=>{const G=JSON.parse(K.toString()),Y=z(G);Y?U.reject(Y):U.resolve(G)})),U.promise}function o(k,F,U,K,G,Y){const Z=new M(Y);return F.connect(U,K,G,(ne,se)=>{Z.didTimeout?(ne&&k.error(ne),se==null||se.dispose()):ne||!se?Z.reject(ne):Z.resolve(se)}),Z.promise}function u(k,F){const U=new M(F);return k.then(K=>{U.didTimeout||U.resolve(K)},K=>{U.didTimeout||U.reject(K)}),U.promise}async function l(k,F,U,K){const G=A(k,F);k.logService.trace(`${G} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await o(k.logService,k.socketFactory,k.host,k.port,`reconnectionToken=${k.reconnectionToken}&reconnection=${k.reconnectionProtocol?"true":"false"}`,K)}catch(re){throw k.logService.error(`${G} socketFactory.connect() failed or timed out. Error:`),k.logService.error(re),re}k.logService.trace(`${G} 2/6. socketFactory.connect() was successful.`);let Z,ne;k.reconnectionProtocol?(k.reconnectionProtocol.beginAcceptReconnection(Y,null),Z=k.reconnectionProtocol,ne=!1):(Z=new m.PersistentProtocol(Y,null),ne=!0),k.logService.trace(`${G} 3/6. sending AuthRequest control message.`);const se={type:"auth",auth:k.connectionToken||"00000000000000000000"};Z.sendControl(S.VSBuffer.fromString(JSON.stringify(se)));try{const re=await E(Z,g(K,d(1e4)));if(re.type!=="sign"||typeof re.data!="string"){const ve=new Error("Unexpected handshake message");throw ve.code="VSCODE_CONNECTION_ERROR",ve}k.logService.trace(`${G} 4/6. received SignRequest control message.`);const te=await u(k.signService.sign(re.data),K),le={type:"connectionType",commit:k.commit,signedData:te,desiredConnectionType:F};return U&&(le.args=U),k.logService.trace(`${G} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(S.VSBuffer.fromString(JSON.stringify(le))),{protocol:Z,ownsProtocol:ne}}catch(re){throw re&&re.code==="ETIMEDOUT"&&(k.logService.error(`${G} the handshake timed out. Error:`),k.logService.error(re)),re&&re.code==="VSCODE_CONNECTION_ERROR"&&(k.logService.error(`${G} received error control message when negotiating connection. Error:`),k.logService.error(re)),ne&&C(Z),re}}async function c(k,F,U,K){const G=Date.now(),Y=A(k,F),{protocol:Z,ownsProtocol:ne}=await l(k,F,U,K),se=new M(K);return se.registerDisposable(Z.onControlMessage(re=>{const te=JSON.parse(re.toString()),le=z(te);le?(k.logService.error(`${Y} received error control message when negotiating connection. Error:`),k.logService.error(le),ne&&C(Z),se.reject(le)):(k.reconnectionProtocol&&k.reconnectionProtocol.endAcceptReconnection(),k.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${O(G)}!`),se.resolve({protocol:Z,firstMessage:te}))})),se.promise}async function t(k,F){const{protocol:U}=await c(k,1,void 0,F);return{protocol:U}}async function i(k,F,U){const{protocol:K,firstMessage:G}=await c(k,2,F,U),Y=G&&G.debugPort;return{protocol:K,debugPort:Y}}async function s(k,F,U){const K=Date.now(),G=A(k,3),{protocol:Y}=await l(k,3,F,U);return k.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${O(K)}!`),Y}async function a(k,F,U){const{host:K,port:G,connectionToken:Y}=await k.addressProvider.getAddress();return{commit:k.commit,host:K,port:G,connectionToken:Y,reconnectionToken:F,reconnectionProtocol:U,socketFactory:k.socketFactory,signService:k.signService,logService:k.logService}}async function h(k,F,U){try{const K=(0,R.generateUuid)(),G=await a(k,K,null),{protocol:Y}=await t(G,n.CancellationToken.None);return new N(k,F,U,K,Y)}catch(K){throw k.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),k.logService.error(K),q.triggerPermanentFailure(0,0,r.RemoteAuthorityResolverError.isHandled(K)),K}}e.connectRemoteAgentManagement=h;async function f(k,F){try{const U=(0,R.generateUuid)(),K=await a(k,U,null),{protocol:G,debugPort:Y}=await i(K,F,n.CancellationToken.None);return new B(k,F,U,G,Y)}catch(U){throw k.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),k.logService.error(U),q.triggerPermanentFailure(0,0,r.RemoteAuthorityResolverError.isHandled(U)),U}}e.connectRemoteAgentExtensionHost=f;async function v(k,F){const U=await a(k,(0,R.generateUuid)(),null);return await s(U,{port:F},n.CancellationToken.None)}e.connectRemoteAgentTunnel=v;function D(k){return(0,p.createCancelablePromise)(F=>new Promise((U,K)=>{const G=setTimeout(U,k*1e3);F.onCancellationRequested(()=>{clearTimeout(G),U()})}))}var T;(function(k){k[k.ConnectionLost=0]="ConnectionLost",k[k.ReconnectionWait=1]="ReconnectionWait",k[k.ReconnectionRunning=2]="ReconnectionRunning",k[k.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",k[k.ConnectionGain=4]="ConnectionGain"})(T=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class W{constructor(F,U){this.reconnectionToken=F,this.millisSinceLastIncomingData=U,this.type=0}}e.ConnectionLostEvent=W;class ${constructor(F,U,K,G){this.reconnectionToken=F,this.millisSinceLastIncomingData=U,this.durationSeconds=K,this.cancellableTimer=G,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=$;class X{constructor(F,U,K){this.reconnectionToken=F,this.millisSinceLastIncomingData=U,this.attempt=K,this.type=2}}e.ReconnectionRunningEvent=X;class x{constructor(F,U,K){this.reconnectionToken=F,this.millisSinceLastIncomingData=U,this.attempt=K,this.type=4}}e.ConnectionGainEvent=x;class oe{constructor(F,U,K,G){this.reconnectionToken=F,this.millisSinceLastIncomingData=U,this.attempt=K,this.handled=G,this.type=3}}e.ReconnectionPermanentFailureEvent=oe;class q extends L.Disposable{constructor(F,U,K,G){super();this._connectionType=F,this._onDidStateChange=this._register(new P.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=U,this.reconnectionToken=K,this.protocol=G,this._isReconnecting=!1,this._onDidStateChange.fire(new x(this.reconnectionToken,0,0)),this._register(G.onSocketClose(()=>this._beginReconnecting())),this._register(G.onSocketTimeout(()=>this._beginReconnecting())),q._instances.push(this),q._permanentFailure&&this._gotoPermanentFailure(q._permanentFailureMillisSinceLastIncomingData,q._permanentFailureAttempt,q._permanentFailureHandled)}static triggerPermanentFailure(F,U,K){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=F,this._permanentFailureAttempt=U,this._permanentFailureHandled=K,this._instances.forEach(G=>G._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(!q._permanentFailure){const F=_(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${F} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30],K=Date.now();let G=-1;do{G++;const Y=G<U.length?U[G]:U[U.length-1];try{if(Y>0){const ne=D(Y);this._onDidStateChange.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,ne)),this._options.logService.info(`${F} waiting for ${Y} seconds before reconnecting...`);try{await ne}catch(se){}}if(q._permanentFailure){this._options.logService.error(`${F} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this._options.logService.info(`${F} resolving connection...`);const Z=await a(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${F} connecting to ${Z.host}:${Z.port}...`),await this._reconnect(Z,d(b)),this._options.logService.info(`${F} reconnected!`),this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${F} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(Z),q.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(Date.now()-K>108e5){this._options.logService.error(`${F} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(Z),q.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(r.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Z)){this._options.logService.info(`${F} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this._options.logService.info(`${F} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if((0,w.isPromiseCanceledError)(Z)){this._options.logService.info(`${F} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if(Z instanceof r.RemoteAuthorityResolverError){this._options.logService.error(`${F} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(Z),q.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,r.RemoteAuthorityResolverError.isHandled(Z));break}this._options.logService.error(`${F} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(Z),q.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!q._permanentFailure)}}_gotoPermanentFailure(F,U,K){this._onDidStateChange.fire(new oe(this.reconnectionToken,F,U,K)),C(this.protocol)}}q._permanentFailure=!1,q._permanentFailureMillisSinceLastIncomingData=0,q._permanentFailureAttempt=0,q._permanentFailureHandled=!1,q._instances=[];class N extends q{constructor(F,U,K,G,Y){super(1,F,G,Y);this.client=this._register(new m.Client(Y,{remoteAuthority:U,clientId:K},F.ipcLogger))}async _reconnect(F,U){await t(F,U)}}e.ManagementPersistentConnection=N;class B extends q{constructor(F,U,K,G,Y){super(2,F,K,G);this._startArguments=U,this.debugPort=Y}async _reconnect(F,U){await i(F,this._startArguments,U)}}e.ExtensionHostPersistentConnection=B;function C(k){try{k.acceptDisconnect();const F=k.getSocket();k.dispose(),F.dispose()}catch(F){(0,w.onUnexpectedError)(F)}}function z(k){if(k&&k.type==="error"){const F=new Error(`Connection error: ${k.reason}`);return F.code="VSCODE_CONNECTION_ERROR",F}return null}function V(k,F){for(;k.length<F;)k+=" ";return k}function _(k,F,U){return`[remote-connection][${V(y(k),13)}][${F.substr(0,5)}\u2026][${U?"reconnect":"initial"}]`}function A(k,F){return`${_(F,k.reconnectionToken,!!k.reconnectionProtocol)}[${k.host}:${k.port}]`}function O(k){return`${Date.now()-k} ms`}}),define(Q[73],J([0,1,10]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function R(w){return w.scheme===m.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=R;function L(w){if(!!w){const p=w.indexOf("+");return p<0?w:w.substr(0,p)}}e.getRemoteName=L;function S(w){return w.scheme!==m.Schemas.file&&w.scheme!==m.Schemas.vscodeRemote}function P(w){if(w.folders.length)return w.folders.every(p=>S(p.uri))?w.folders[0].uri:void 0;if(w.configuration&&S(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=P;function r(w){var p;return(p=P(w))===null||p===void 0?void 0:p.scheme}e.getVirtualWorkspaceScheme=r}),define(Q[74],J([0,1,5,3,4,6]),function(j,e,m,R,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService");var P;(function(I){I[I.Notify=1]="Notify",I[I.OpenBrowser=2]="OpenBrowser",I[I.OpenPreview=3]="OpenPreview",I[I.Silent=4]="Silent",I[I.Ignore=5]="Ignore"})(P=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function r(I){if(!(I.scheme!=="http"&&I.scheme!=="https")){const y=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(I.authority);if(!!y)return{address:y[1],port:+y[2]}}}e.extractLocalHostUriMetaDataForPortMapping=r,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(I){return e.LOCALHOST_ADDRESSES.indexOf(I)>=0}e.isLocalhost=w,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(I){return e.ALL_INTERFACES_ADDRESSES.indexOf(I)>=0}e.isAllInterfaces=p;function n(I,y){return y?y!==1&&I<1024:!R.isWindows&&I<1024}e.isPortPrivileged=n;let b=class{constructor(y){this.logService=y,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(y,d){return this._tunnelProvider=y,y?(this._canElevate=d.elevation,this._canMakePublic=d.public,{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async y=>{const d=[],g=Array.from(this._tunnels.values());for(let M of g){const E=Array.from(M.values());for(let o of E){const u=await o.value;u&&d.push(u)}}y(d)})}async dispose(){for(const y of this._tunnels.values()){for(const{value:d}of y.values())await d.then(g=>g==null?void 0:g.dispose());y.clear()}this._tunnels.clear()}openTunnel(y,d,g,M,E=!1,o=!1){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${g} on local port ${M}.`),!!y){d||(d="localhost");const u=this.retainOrCreateTunnel(y,d,g,M,E,o);return u?u.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const c=this.makeTunnel(l);return(l.tunnelRemoteHost!==d||l.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(c),c}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}}makeTunnel(y){return{tunnelRemotePort:y.tunnelRemotePort,tunnelRemoteHost:y.tunnelRemoteHost,tunnelLocalPort:y.tunnelLocalPort,localAddress:y.localAddress,public:y.public,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${y.tunnelRemoteHost}:${y.tunnelRemotePort} `);const d=this._tunnels.get(y.tunnelRemoteHost);if(d){const g=d.get(y.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(y.tunnelRemoteHost,y.tunnelRemotePort,g))}}}}async tryDisposeTunnel(y,d,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${y}:${d}.`);const M=g.value.then(async E=>{E&&(await E.dispose(!0),this._onTunnelClosed.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this._tunnels.has(y)&&this._tunnels.get(y).delete(d),M}}async closeTunnel(y,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${y}:${d} `);const g=this._tunnels.get(y);if(g&&g.has(d)){const M=g.get(d);M.refcount=0,await this.tryDisposeTunnel(y,d,M)}}addTunnelToMap(y,d,g){this._tunnels.has(y)||this._tunnels.set(y,new Map),this._tunnels.get(y).set(d,{refcount:1,value:g})}async removeEmptyTunnelFromMap(y,d){const g=this._tunnels.get(y);g&&(await g.get(d)||g.delete(d),g.size===0&&this._tunnels.delete(y))}getTunnelFromMap(y,d){let g=[y];w(y)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):p(y)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const M=g.map(E=>this._tunnels.get(E));for(const E of M){const o=E==null?void 0:E.get(d);if(o)return o}}canTunnel(y){return!!r(y)}createWithProvider(y,d,g,M,E,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${g} on local port ${M}.`);const l={elevationRequired:E?n(M===void 0?g:M):!1},c={remoteAddress:{host:d,port:g},localAddressPort:M,public:o},t=y.forwardPort(c,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(d,g,t),t}};b=ue([ee(0,S.ILogService)],b),e.AbstractTunnelService=b}),define(Q[49],J([0,1,145,4,48,37,19]),function(j,e,m,R,L,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function r(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=r;function w(d){return d.res.statusCode===204}async function p(d){if(!r(d))throw new Error("Server returned "+d.res.statusCode);return w(d)?null:(await(0,P.streamToBuffer)(d.stream)).toString()}e.asText=p;async function n(d){if(!r(d))throw new Error("Server returned "+d.res.statusCode);if(w(d))return null;const M=(await(0,P.streamToBuffer)(d.stream)).toString();try{return JSON.parse(M)}catch(E){throw E.message+=`:
`+M,E}}e.asJson=n;function b(d){y(d)}e.updateProxyConfigurationsScope=b;let I;function y(d){const g=S.Registry.as(L.Extensions.Configuration);I&&g.deregisterConfigurations([I]),I={id:"http",order:15,title:(0,m.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,m.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,m.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,m.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,m.localize)(4,null),(0,m.localize)(5,null),(0,m.localize)(6,null),(0,m.localize)(7,null)],default:"override",description:(0,m.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,m.localize)(9,null),restricted:!0}}},g.registerConfiguration(I)}y(2)}),define(Q[190],J([0,1,191,13]),function(j,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function L(P,r){return P.protocol==="http:"?r.HTTP_PROXY||r.http_proxy||null:P.protocol==="https:"&&(r.HTTPS_PROXY||r.https_proxy||r.HTTP_PROXY||r.http_proxy)||null}async function S(P,r,w={}){const p=(0,m.parse)(P),n=w.proxyUrl||L(p,r);if(!n)return null;const b=(0,m.parse)(n);if(!/^https?:$/.test(b.protocol||""))return null;const I={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:(0,R.isBoolean)(w.strictSSL)?w.strictSSL:!0};return p.protocol==="http:"?new(await new Promise((y,d)=>{j(["http-proxy-agent"],y,d)}))(I):new(await new Promise((y,d)=>{j(["https-proxy-agent"],y,d)}))(I)}e.getProxyAgent=S}),define(Q[192],J([0,1,28,19]),function(j,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(S,P,r){let w=r&&r.get("storage.serviceMachineId",0)||null;if(w)return w;try{const n=(await P.readFile(S.serviceMachineIdResource)).value.toString();w=(0,m.isUUID)(n)?n:null}catch(p){w=null}if(!w){w=(0,m.generateUuid)();try{await P.writeFile(S.serviceMachineIdResource,R.VSBuffer.fromString(w))}catch(p){}}return r&&r.store("storage.serviceMachineId",w,0,1),w}e.getServiceMachineId=L}),define(Q[75],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,m.createDecorator)(e.SIGN_SERVICE_ID)}),define(Q[193],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{vsda(){return new Promise((L,S)=>j(["vsda"],L,S))}async sign(L){try{const S=await this.vsda(),P=new S.signer;if(P)return P.sign(L)}catch(S){}return L}}e.SignService=m}),define(Q[38],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,m.createDecorator)("stateMainService")}),define(Q[17],J([0,1,14,6,38,5,4,175,3,2,9,13,32]),function(j,e,m,R,L,S,P,r,w,p,n,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.UnloadReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,P.createDecorator)("lifecycleMainService");var y;(function(M){M[M.CLOSE=1]="CLOSE",M[M.QUIT=2]="QUIT",M[M.RELOAD=3]="RELOAD",M[M.LOAD=4]="LOAD"})(y=e.UnloadReason||(e.UnloadReason={}));var d;(function(M){M[M.Starting=1]="Starting",M[M.Ready=2]="Ready",M[M.AfterWindowOpen=3]="AfterWindowOpen"})(d=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let g=class ut extends p.Disposable{constructor(E,o){super();this.logService=E,this.stateMainService=o,this._onBeforeShutdown=this._register(new S.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new S.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new S.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new S.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new S.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(ut.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(ut.QUIT_AND_RESTART_KEY)}registerListeners(){const E=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),w.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};m.app.addListener("before-quit",E);const o=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!w.isMacintosh)&&m.app.quit()};m.app.addListener("window-all-closed",o),m.app.once("will-quit",u=>{this.logService.trace("Lifecycle#app.on(will-quit)"),u.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),m.app.removeListener("before-quit",E),m.app.removeListener("window-all-closed",o),m.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const E=[];return this._onWillShutdown.fire({join(o){E.push(o)}}),this.pendingWillShutdownPromise=(async()=>{try{await n.Promises.settled(E)}catch(o){this.logService.error(o)}try{await this.stateMainService.close()}catch(o){this.logService.error(o)}})(),this.pendingWillShutdownPromise}set phase(E){if(E<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase!==E){this.logService.trace(`lifecycle (main): phase changed (value: ${E})`),this._phase=E;const o=this.phaseWhen.get(this._phase);o&&(o.open(),this.phaseWhen.delete(this._phase))}}async when(E){if(!(E<=this._phase)){let o=this.phaseWhen.get(E);o||(o=new n.Barrier,this.phaseWhen.set(E,o)),await o.wait()}}registerWindow(E){const o=new p.DisposableStore;this.windowCounter++,o.add(E.onWillLoad(l=>this._onWillLoadWindow.fire({window:E,workspace:l.workspace})));const u=(0,b.assertIsDefined)(E.win);u.on("close",l=>{const c=E.id;if(this.windowToCloseRequest.has(c)){this.windowToCloseRequest.delete(c);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${E.id}`),l.preventDefault(),this.unload(E,1).then(t=>{if(t){this.windowToCloseRequest.delete(c);return}this.windowToCloseRequest.add(c),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${c}`),this._onBeforeCloseWindow.fire(E),E.close()})}),u.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${E.id}`),this.windowCounter--,o.dispose(),this.windowCounter===0&&(!w.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(E,o){await this.unload(E,3)||E.reload(o)}async unload(E,o){if(!E.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${E.id}`);const u=this._quitRequested?2:o;let l=await this.onBeforeUnloadWindowInRenderer(E,u);return l?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${E.id})`),this.handleWindowUnloadVeto(l)):(l=await this.onBeforeUnloadWindowInMain(E,u),l?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${E.id})`),this.handleWindowUnloadVeto(l)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${E.id})`),await this.onWillUnloadWindowInRenderer(E,u),!1))}handleWindowUnloadVeto(E){return E?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(E){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(E),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(E,o){return new Promise(u=>{const l=this.oneTimeListenerTokenGenerator++,c=`vscode:ok${l}`,t=`vscode:cancel${l}`;m.ipcMain.once(c,()=>{u(!1)}),m.ipcMain.once(t,()=>{u(!0)}),E.send("vscode:onBeforeUnload",{okChannel:c,cancelChannel:t,reason:o})})}onBeforeUnloadWindowInMain(E,o){const u=[];return this._onBeforeUnloadWindow.fire({reason:o,window:E,veto(l){u.push(l)}}),(0,r.handleVetos)(u,l=>this.logService.error(l))}onWillUnloadWindowInRenderer(E,o){return new Promise(u=>{const c=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;m.ipcMain.once(c,()=>u()),E.send("vscode:onWillUnload",{replyChannel:c,reason:o})})}quit(E){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${E}`),E&&this.stateMainService.setItem(ut.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(o=>{this.pendingQuitPromiseResolve=o,this.logService.trace("Lifecycle#quit() - calling app.quit()"),m.app.quit()}),this.pendingQuitPromise)}async relaunch(E){this.logService.trace("Lifecycle#relaunch()");const o=process.argv.slice(1);if((E==null?void 0:E.addArgs)&&o.push(...E.addArgs),E==null?void 0:E.removeArgs)for(const c of E.removeArgs){const t=o.indexOf(c);t>=0&&o.splice(t,1)}const u=()=>{try{if(w.isWindows){const c=(0,I.cwd)();c!==process.cwd()&&process.chdir(c)}}catch(c){this.logService.error(c)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),m.app.relaunch({args:o})};m.app.once("quit",u),await this.quit(!0)&&m.app.removeListener("quit",u)}async kill(E){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const o of m.BrowserWindow.getAllWindows())if(o&&!o.isDestroyed()){let u;o.webContents&&!o.webContents.isDestroyed()?u=new Promise(l=>o.once("closed",l)):u=Promise.resolve(),o.destroy(),await u}})()]),m.app.exit(E)}};g.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",g=ue([ee(0,R.ILogService),ee(1,L.IStateMainService)],g),e.LifecycleMainService=g}),define(Q[194],J([0,1,4,5,2,17]),function(j,e,m,R,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,m.createDecorator)("keyboardLayoutMainService");let P=class extends L.Disposable{constructor(p){super();this._onDidChangeKeyboardLayout=this._register(new R.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,p.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const p=await new Promise((n,b)=>{j(["native-keymap"],n,b)});this._keyboardLayoutData=r(p),p.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=r(p),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};P=ue([ee(0,S.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function r(w){const p=w.getKeyMap(),n=w.getCurrentKeyboardLayout();return{keyboardMapping:p,keyboardLayoutInfo:n}}}),define(Q[95],J([0,1,4,5,2,13,85,9]),function(j,e,m,R,L,S,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const w="__$__targetStorageMarker";e.IStorageService=(0,m.createDecorator)("storageService");var p;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(p=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var b;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(b=e.StorageTarget||(e.StorageTarget={}));class I extends L.Disposable{constructor(M={flushInterval:I.DEFAULT_FLUSH_INTERVAL}){super();this.options=M,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new r.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,r.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(M,E){E===w?(M===0?this._globalKeyTargets=void 0:M===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:M})):this._onDidChangeValue.fire({scope:M,key:E,target:this.getKeyTargets(M)[E]})}emitWillSaveState(M){this._onWillSaveState.fire({reason:M})}get(M,E,o){var u;return(u=this.getStorage(E))===null||u===void 0?void 0:u.get(M,o)}getBoolean(M,E,o){var u;return(u=this.getStorage(E))===null||u===void 0?void 0:u.getBoolean(M,o)}getNumber(M,E,o){var u;return(u=this.getStorage(E))===null||u===void 0?void 0:u.getNumber(M,o)}store(M,E,o,u){if((0,S.isUndefinedOrNull)(E)){this.remove(M,o);return}this.withPausedEmitters(()=>{var l;this.updateKeyTarget(M,o,u),(l=this.getStorage(o))===null||l===void 0||l.set(M,E)})}remove(M,E){this.withPausedEmitters(()=>{var o;this.updateKeyTarget(M,E,void 0),(o=this.getStorage(E))===null||o===void 0||o.delete(M)})}withPausedEmitters(M){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{M()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(M,E){const o=[],u=this.getKeyTargets(M);for(const l of Object.keys(u))u[l]===E&&o.push(l);return o}updateKeyTarget(M,E,o){var u,l;const c=this.getKeyTargets(E);typeof o=="number"?c[M]!==o&&(c[M]=o,(u=this.getStorage(E))===null||u===void 0||u.set(w,JSON.stringify(c))):typeof c[M]=="number"&&(delete c[M],(l=this.getStorage(E))===null||l===void 0||l.set(w,JSON.stringify(c)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(M){return M===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(M){const E=this.get(w,M);if(E)try{return JSON.parse(E)}catch(o){}return Object.create(null)}isNew(M){return this.getBoolean(e.IS_NEW_KEY,M)===!0}async flush(){var M,E,o,u;this._onWillSaveState.fire({reason:p.NONE}),await r.Promises.settled([(E=(M=this.getStorage(0))===null||M===void 0?void 0:M.whenFlushed())!==null&&E!==void 0?E:Promise.resolve(),(u=(o=this.getStorage(1))===null||o===void 0?void 0:o.whenFlushed())!==null&&u!==void 0?u:Promise.resolve()])}async logStorage(){var M,E,o,u,l,c;const t=(E=(M=this.getStorage(0))===null||M===void 0?void 0:M.items)!==null&&E!==void 0?E:new Map,i=(u=(o=this.getStorage(1))===null||o===void 0?void 0:o.items)!==null&&u!==void 0?u:new Map;return d(t,i,(l=this.getLogDetails(0))!==null&&l!==void 0?l:"",(c=this.getLogDetails(1))!==null&&c!==void 0?c:"")}}e.AbstractStorageService=I,I.DEFAULT_FLUSH_INTERVAL=60*1e3;class y extends I{constructor(){super();this.globalStorage=new P.Storage(new P.InMemoryStorageDatabase),this.workspaceStorage=new P.Storage(new P.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(M=>this.emitDidChangeValue(1,M))),this._register(this.globalStorage.onDidChangeStorage(M=>this.emitDidChangeValue(0,M)))}getStorage(M){return M===0?this.globalStorage:this.workspaceStorage}getLogDetails(M){return M===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(M){}}e.InMemoryStorageService=y;async function d(g,M,E,o){const u=h=>{try{return JSON.parse(h)}catch(f){return h}},l=new Map,c=new Map;g.forEach((h,f)=>{l.set(f,h),c.set(f,u(h))});const t=new Map,i=new Map;M.forEach((h,f)=>{t.set(f,h),i.set(f,u(h))}),console.group(`Storage: Global (path: ${E})`);let s=[];l.forEach((h,f)=>{s.push({key:f,value:h})}),console.table(s),console.groupEnd(),console.log(c),console.group(`Storage: Workspace (path: ${o})`);let a=[];t.forEach((h,f)=>{a.push({key:f,value:h})}),console.table(a),console.groupEnd(),console.log(i)}e.logStorage=d}),define(Q[195],J([0,1,3,32,28,7]),function(j,e,m,R,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function P(p){if(m.platform===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}async function r(p,n,b,I,y,d,g,M,E,o){const u=Object.create(null);u["common.machineId"]=g,u.sessionID=(0,L.generateUuid)()+Date.now(),u.commitHash=y,u.version=d,u["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,m.PlatformToString)(m.platform),u["common.nodePlatform"]=R.platform,u["common.nodeArch"]=I,u["common.product"]=o||"desktop";const l=w(M||[]);l&&(u["common.msftInternal"]=l);let c=0;const t=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),m.isLinuxSnap&&(u["common.snap"]="true");const i=P(b);i&&(u["common.platformDetail"]=i);try{const s=await p.readFile(S.URI.file(E));u["common.source"]=s.value.toString().slice(0,30)}catch(s){}return u}e.resolveCommonProperties=r;function w(p){const n=R.env.USERDNSDOMAIN;if(!n)return!1;const b=n.toLowerCase();return p.some(I=>b===I)}e.verifyMicrosoftInternalDomain=w}),define(Q[31],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,m.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,m.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Q[196],J([0,1,27,66,70,24,8,43,82,22,3,7,31,63,10,21,20]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function E(t,i){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],a=new Map,h=new Map,f=2e4;function v(W,$,X,x){const oe=$.substring(W.length+1);return new Promise(async q=>{var N,B,C;let z;try{z=await(0,M.readdir)($,{withFileTypes:!0})}catch(A){q();return}if(x.count>=f){x.count+=z.length,x.maxReached=!0,q();return}let V=z.length;if(V===0){q();return}let _=z;x.count+z.length>f&&(x.maxReached=!0,V=f-x.count,_=z.slice(0,V)),x.count+=z.length;for(const A of _)if(A.isDirectory()){if(X.includes(A.name)||await v(W,(0,P.join)($,A.name),X,x),--V==0){q();return}}else{const O=A.name.lastIndexOf(".");if(O>=0){const k=A.name.substring(O+1);k&&a.set(k,((N=a.get(k))!==null&&N!==void 0?N:0)+1)}for(const k of s)((B=k.relativePathPattern)===null||B===void 0?void 0:B.test(oe))!==!1&&k.filePattern.test(A.name)&&h.set(k.tag,((C=h.get(k.tag))!==null&&C!==void 0?C:0)+1);if(--V==0){q();return}}})}const D={count:0,maxReached:!1};await v(t,t,i,D);const T=await l(t);return{configFiles:o(h),fileTypes:o(a),fileCount:D.count,maxFilesReached:D.maxReached,launchConfigFiles:T}}e.collectWorkspaceStats=E;function o(t){return[...y.Iterable.map(t.entries(),([i,s])=>({name:i,count:s}))].sort((i,s)=>s.count-i.count)}function u(){const t={os:`${m.type()} ${m.arch()} ${m.release()}`,memory:`${(m.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(R.virtualMachineHint.value()*100)}%`},i=m.cpus();return i&&i.length>0&&(t.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),t}e.getMachineInfo=u;function l(t){let i=new Map,s=(0,P.join)(t,".vscode","launch.json");return new Promise((a,h)=>{(0,S.exists)(s,f=>{if(f)(0,S.readFile)(s,(v,D)=>{if(v)return a([]);const T=[],W=(0,r.parse)(D.toString(),T);if(T.length)return console.log(`Unable to parse ${s}`),a([]);if((0,r.getNodeType)(W)==="object"&&W.configurations)for(const $ of W.configurations){const X=$.type;X&&(i.has(X)?i.set(X,i.get(X)+1):i.set(X,1))}return a(o(i))});else return a([])})})}e.collectLaunchConfigs=l;let c=class{constructor(i,s){this.telemetryService=i,this.productService=s}formatMachineInfo(i){const s=[];return s.push(`OS Version:       ${i.os}`),s.push(`CPUs:             ${i.cpus}`),s.push(`Memory (System):  ${i.memory}`),s.push(`VM:               ${i.vmHint}`),s.join(`
`)}formatEnvironment(i){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${m.type()} ${m.arch()} ${m.release()}`);const a=m.cpus();return a&&a.length>0&&s.push(`CPUs:             ${a[0].model} (${a.length} x ${a[0].speed})`),s.push(`Memory (System):  ${(m.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`),n.isWindows||s.push(`Load (avg):       ${m.loadavg().map(h=>Math.round(h)).join(", ")}`),s.push(`VM:               ${Math.round(R.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${i.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(i,s){return Promise.all([(0,w.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async a=>{let[h,f]=a,v=this.formatProcessList(i,h);return s.forEach(D=>{if((0,L.isRemoteDiagnosticError)(D))v+=`
${D.errorMessage}`,f+=`
${D.errorMessage}`;else if(v+=`

Remote: ${D.hostName}`,D.processes&&(v+=`
${this.formatProcessList(i,D.processes)}`),D.workspaceMetadata){f+=`
|  Remote: ${D.hostName}`;for(const T of Object.keys(D.workspaceMetadata)){const W=D.workspaceMetadata[T];let $=`${W.fileCount} files`;W.maxFilesReached&&($=`more than ${$}`),f+=`|    Folder (${T}): ${$}`,f+=this.formatWorkspaceStats(W)}}}),{processInfo:v,workspaceInfo:f}})}async getSystemInfo(i,s){const{memory:a,vmHint:h,os:f,cpus:v}=u(),D={os:f,memory:a,cpus:v,vmHint:h,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:s};return n.isWindows||(D.load=`${m.loadavg().map(T=>Math.round(T)).join(", ")}`),n.isLinux&&(D.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(D)}async getDiagnostics(i,s){const a=[];return(0,w.listProcesses)(i.mainPID).then(async h=>(a.push(""),a.push(this.formatEnvironment(i)),a.push(""),a.push(this.formatProcessList(i,h)),i.windows.some(f=>f.folderURIs&&f.folderURIs.length>0&&!f.remoteAuthority)&&(a.push(""),a.push("Workspace Stats: "),a.push(await this.formatWorkspaceMetadata(i))),s.forEach(f=>{if((0,L.isRemoteDiagnosticError)(f))a.push(`
${f.errorMessage}`);else if(a.push(`

`),a.push(`Remote:           ${f.hostName}`),a.push(this.formatMachineInfo(f.machineInfo)),f.processes&&a.push(this.formatProcessList(i,f.processes)),f.workspaceMetadata)for(const v of Object.keys(f.workspaceMetadata)){const D=f.workspaceMetadata[v];let T=`${D.fileCount} files`;D.maxFilesReached&&(T=`more than ${T}`),a.push(`Folder (${v}): ${T}`),a.push(this.formatWorkspaceStats(D))}}),a.push(""),a.push(""),a.join(`
`)))}formatWorkspaceStats(i){const s=[],a=60;let h=0;const f=(W,$)=>{const X=` ${W}(${$})`;h+X.length>a?(s.push(v),v="|                 ",h=v.length):h+=X.length,v+=X};let v="|      File types:";const D=10;let T=i.fileTypes.length>D?D:i.fileTypes.length;for(let W=0;W<T;W++){const $=i.fileTypes[W];f($.name,$.count)}if(s.push(v),i.configFiles.length>=0&&(v="|      Conf files:",h=0,i.configFiles.forEach(W=>{f(W.name,W.count)}),s.push(v)),i.launchConfigFiles.length>0){let W="|      Launch Configs:";i.launchConfigFiles.forEach($=>{W+=$.count>1?` ${$.name}(${$.count})`:` ${$.name}`}),s.push(W)}return s.join(`
`)}expandGPUFeatures(i){const s=Math.max(...Object.keys(i).map(a=>a.length));return Object.keys(i).map(a=>`${a}:  ${" ".repeat(s-a.length)}  ${i[a]}`).join(`
                  `)}formatWorkspaceMetadata(i){const s=[],a=[];return i.windows.forEach(h=>{h.folderURIs.length===0||!!h.remoteAuthority||(s.push(`|  Window (${h.title})`),h.folderURIs.forEach(f=>{const v=b.URI.revive(f);if(v.scheme===d.Schemas.file){const D=v.fsPath;a.push(E(D,["node_modules",".git"]).then(T=>{let W=`${T.fileCount} files`;T.maxFilesReached&&(W=`more than ${W}`),s.push(`|    Folder (${(0,P.basename)(D)}): ${W}`),s.push(this.formatWorkspaceStats(T))}).catch(T=>{s.push(`|      Error: Unable to collect workspace stats for folder ${D} (${T.toString()})`)}))}else s.push(`|    Folder (${v.toString()}): Workspace stats not available.`)}))}),Promise.all(a).then(h=>s.join(`
`)).catch(h=>`Unable to collect workspace stats: ${h}`)}formatProcessList(i,s){const a=new Map;i.windows.forEach(f=>a.set(f.pid,f.title));const h=[];return h.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(i.mainPID,a,h,s,0),h.join(`
`)}formatProcessItem(i,s,a,h,f){const v=f===0;let D;v?D=h.pid===i?`${this.productService.applicationName} main`:"remote agent":(D=`${"  ".repeat(f)} ${h.name}`,h.name==="window"&&(D=`${D} (${s.get(h.pid)})`));const T=process.platform==="win32"?h.mem:m.totalmem()*(h.mem/100);a.push(`${h.load.toFixed(0).padStart(5," ")}	${(T/g.ByteSize.MB).toFixed(0).padStart(6," ")}	${h.pid.toFixed(0).padStart(6," ")}	${D}`),Array.isArray(h.children)&&h.children.forEach(W=>this.formatProcessItem(i,s,a,W,f+1))}async reportWorkspaceStats(i){for(const{uri:s}of i.folders){const a=b.URI.revive(s);if(a.scheme===d.Schemas.file){const h=a.fsPath;try{const f=await E(h,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),f.fileTypes.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:v.name,count:v.count})}),f.launchConfigFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:v.name,count:v.count})}),f.configFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:v.name,count:v.count})})}catch(f){}}}}};c=ue([ee(0,I.ITelemetryService),ee(1,p.IProductService)],c),e.DiagnosticsService=c}),define(Q[197],J([0,1,18,167,170,44,31,49,161,53,26,6,21,7,22,95,192,4,15]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d,g,M,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var u;(function(_){_[_.None=0]="None",_[_.IncludeVersions=1]="IncludeVersions",_[_.IncludeFiles=2]="IncludeFiles",_[_.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",_[_.IncludeSharedAccounts=8]="IncludeSharedAccounts",_[_.IncludeVersionProperties=16]="IncludeVersionProperties",_[_.ExcludeNonValidated=32]="ExcludeNonValidated",_[_.IncludeInstallationTargets=64]="IncludeInstallationTargets",_[_.IncludeAssetUri=128]="IncludeAssetUri",_[_.IncludeStatistics=256]="IncludeStatistics",_[_.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",_[_.Unpublished=4096]="Unpublished"})(u||(u={}));function l(..._){return String(_.reduce((A,O)=>A|O,0))}var c;(function(_){_[_.Tag=1]="Tag",_[_.ExtensionId=4]="ExtensionId",_[_.Category=5]="Category",_[_.ExtensionName=7]="ExtensionName",_[_.Target=8]="Target",_[_.Featured=9]="Featured",_[_.SearchText=10]="SearchText",_[_.ExcludeWithFlags=12]="ExcludeWithFlags"})(c||(c={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:u.None,criteria:[],assetTypes:[]};class h{constructor(A=a){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,O=this.state.pageSize){return new h(Object.assign(Object.assign({},this.state),{pageNumber:A,pageSize:O}))}withFilter(A,...O){const k=[...this.state.criteria,...O.length?O.map(F=>({filterType:A,value:F})):[{filterType:A}]];return new h(Object.assign(Object.assign({},this.state),{criteria:k}))}withSortBy(A){return new h(Object.assign(Object.assign({},this.state),{sortBy:A}))}withSortOrder(A){return new h(Object.assign(Object.assign({},this.state),{sortOrder:A}))}withFlags(...A){return new h(Object.assign(Object.assign({},this.state),{flags:A.reduce((O,k)=>O|k,0)}))}withAssetTypes(...A){return new h(Object.assign(Object.assign({},this.state),{assetTypes:A}))}get raw(){const{criteria:A,pageNumber:O,pageSize:k,sortBy:F,sortOrder:U,flags:K,assetTypes:G}=this.state;return{filters:[{criteria:A,pageNumber:O,pageSize:k,sortBy:F,sortOrder:U}],assetTypes:G,flags:K}}get searchText(){const A=this.state.criteria.filter(O=>O.filterType===c.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function f(_,A){const O=(_||[]).filter(k=>k.statisticName===A)[0];return O?O.value:0}function v(_){const A="Microsoft.VisualStudio.Code.Translation.";return _.files.filter(k=>k.assetType.indexOf(A)===0).reduce((k,F)=>{const U=$(_,F.assetType);return U&&k.push([F.assetType.substring(A.length),U]),k},[])}function D(_){if(_.properties){const A=_.properties.filter(F=>F.key===t.Repository),O=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),k=A.filter(F=>O.test(F.value))[0];return k?{uri:k.value,fallbackUri:k.value}:null}return $(_,t.Repository)}function T(_){return{uri:`${_.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${_.fallbackAssetUri}/${t.VSIX}`}}function W(_){const A=$(_,t.Icon);if(A)return A;const O=R.DefaultIconPath;return{uri:O,fallbackUri:O}}function $(_,A){return _.files.filter(k=>k.assetType===A)[0]?{uri:`${_.assetUri}/${A}`,fallbackUri:`${_.fallbackAssetUri}/${A}`}:null}function X(_,A){const O=_.properties?_.properties.filter(F=>F.key===A):[],k=O.length>0&&O[0].value;return k?k.split(",").map(F=>(0,L.adoptToGalleryExtensionId)(F)):[]}function x(_){const A=_.properties?_.properties.filter(O=>O.key===i.Engine):[];return A.length>0&&A[0].value||""}function oe(_){const A=_.properties?_.properties.filter(k=>k.key===i.LocalizedLanguages):[],O=A.length>0&&A[0].value||"";return O?O.split(","):[]}function q(_){return _.indexOf("preview")!==-1}function N(_){const A=_.properties?_.properties.find(O=>O.key===i.WebExtension):void 0;return!!A&&A.value==="true"}function B(_){return _.files.some(A=>A.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,o.joinPath)(y.URI.parse(_.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function C(_,A,O,k,F){const U={manifest:$(A,t.Manifest),readme:$(A,t.Details),changelog:$(A,t.Changelog),license:$(A,t.License),repository:D(A),download:T(A),icon:W(A),coreTranslations:v(A)};return{identifier:{id:(0,L.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},name:_.extensionName,version:A.version,date:A.lastUpdated,displayName:_.displayName,publisherId:_.publisher.publisherId,publisher:_.publisher.publisherName,publisherDisplayName:_.publisher.displayName,description:_.shortDescription||"",installCount:f(_.statistics,"install"),rating:f(_.statistics,"averagerating"),ratingCount:f(_.statistics,"ratingcount"),assetUri:y.URI.parse(A.assetUri),webResource:B(A),assetTypes:A.files.map(({assetType:K})=>K),assets:U,properties:{dependencies:X(A,i.Dependency),extensionPack:X(A,i.ExtensionPack),engine:x(A),localizedLanguages:oe(A),webExtension:N(A)},telemetryData:{index:(k.pageNumber-1)*k.pageSize+O,querySource:F},preview:q(_.flags)}}let z=class{constructor(A,O,k,F,U,K,G){this.requestService=A,this.logService=O,this.environmentService=k,this.telemetryService=F,this.fileService=U,this.productService=K;const Y=K.extensionsGallery;this.extensionsGalleryUrl=Y&&Y.serviceUrl,this.extensionsControlUrl=Y&&Y.controlUrl,this.commonHeadersPromise=V(K.version,this.environmentService,this.fileService,G)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,O){const k=[];let{total:F,firstPage:U,getPage:K}=await this.query({names:A,pageSize:A.length},O);k.push(...U);for(let G=1;k.length<F&&(U=await K(G,O),U.length);G++)k.push(...U);return k}async getCompatibleExtension(A,O){const k=await this.getCompatibleExtensionByEngine(A,O);return(k==null?void 0:k.properties.webExtension)?k.webResource?k:null:k}async getCompatibleExtensionByEngine(A,O){const k=(0,R.isIExtensionIdentifier)(A)?null:A;if(k&&k.properties.engine&&(0,w.isEngineValid)(k.properties.engine,this.productService.version,this.productService.date))return k;const{id:F,uuid:U}=k?k.identifier:A;let K=new h().withFlags(u.IncludeAssetUri,u.IncludeStatistics,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(c.Target,"Microsoft.VisualStudio.Code");U?K=K.withFilter(c.ExtensionId,U):K=K.withFilter(c.ExtensionName,F);const{galleryExtensions:G}=await this.queryGallery(K,n.CancellationToken.None),[Y]=G;if(!Y||!Y.versions.length)return null;if(O){const ne=Y.versions.filter(se=>se.version===O)[0];if(ne){const se=C(Y,ne,0,K);if(se.properties.engine&&(0,w.isEngineValid)(se.properties.engine,this.productService.version,this.productService.date))return se}return null}const Z=await this.getLastValidExtensionVersion(Y,Y.versions);return Z?C(Y,Z,0,K):null}async query(A,O){const k=n.CancellationToken.isCancellationToken(A)?{}:A,F=n.CancellationToken.isCancellationToken(A)?A:O;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let U=k.text||"";const K=(0,S.getOrDefault)(k,re=>re.pageSize,50);let G=new h().withFlags(u.IncludeLatestVersionOnly,u.IncludeAssetUri,u.IncludeStatistics,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,K).withFilter(c.Target,"Microsoft.VisualStudio.Code");U?(U=U.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,te,le)=>(G=G.withFilter(c.Category,le||te),"")),U=U.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,te,le)=>(G=G.withFilter(c.Tag,le||te),"")),U=U.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(c.Featured),"")),U=U.trim(),U&&(U=U.length<200?U:U.substring(0,200),G=G.withFilter(c.SearchText,U)),G=G.withSortBy(0)):k.ids?G=G.withFilter(c.ExtensionId,...k.ids):k.names?G=G.withFilter(c.ExtensionName,...k.names):G=G.withSortBy(4),typeof k.sortBy=="number"&&(G=G.withSortBy(k.sortBy)),typeof k.sortOrder=="number"&&(G=G.withSortOrder(k.sortOrder));const{galleryExtensions:Y,total:Z}=await this.queryGallery(G,F),ne=Y.map((re,te)=>C(re,re.versions[0],te,G,k.source)),se=async(re,te)=>{if(te.isCancellationRequested)throw(0,m.canceled)();const le=G.withPage(re+1),{galleryExtensions:ve}=await this.queryGallery(le,te);return ve.map((we,Se)=>C(we,we.versions[0],Se,le,k.source))};return{firstPage:ne,total:Z,pageSize:G.pageSize,getPage:se}}async queryGallery(A,O){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,u.ExcludeNonValidated).withFilter(c.ExcludeWithFlags,l(u.Unpublished));const k=await this.commonHeadersPromise,F=JSON.stringify(A.raw),U=Object.assign(Object.assign({},k),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(F.length)}),K=new Date().getTime();let G,Y,Z=0;try{if(G=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:F,headers:U},O),G.res.statusCode&&G.res.statusCode>=400&&G.res.statusCode<500)return{galleryExtensions:[],total:Z};const ne=await(0,r.asJson)(G);if(ne){const se=ne.results[0],re=se.extensions,te=se.resultMetadata&&se.resultMetadata.filter(le=>le.metadataType==="ResultCount")[0];return Z=te&&te.metadataItems.filter(le=>le.name==="TotalCount")[0].count||0,{galleryExtensions:re,total:Z}}return{galleryExtensions:[],total:Z}}catch(ne){throw Y=ne,ne}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},A.telemetryData),{requestBodySize:String(F.length),duration:new Date().getTime()-K,success:!!G&&(0,r.isSuccess)(G),responseBodySize:G==null?void 0:G.res.headers["Content-Length"],statusCode:G?String(G.res.statusCode):void 0,errorCode:Y?(0,m.isPromiseCanceledError)(Y)?"canceled":(0,m.getErrorMessage)(Y).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Z)}))}}async reportStatistic(A,O,k,F){if(!!this.isEnabled()){const U=await this.commonHeadersPromise,K=Object.assign(Object.assign({},U),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${A}/extensions/${O}/${k}/stats?statType=${F}`),headers:K},n.CancellationToken.None)}catch(G){}}}async download(A,O,k){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const F=(0,L.getGalleryExtensionTelemetryData)(A),U=new Date().getTime(),K=ne=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},F),{duration:ne})),G=k===1?"install":k===2?"update":"",Y=G?{uri:`${A.assets.download.uri}&${G}=true`,fallbackUri:`${A.assets.download.fallbackUri}?${G}=true`}:A.assets.download,Z=await this.getAsset(Y);await this.fileService.writeFile(O,Z.stream),K(new Date().getTime()-U)}async getReadme(A,O){if(A.assets.readme){const k=await this.getAsset(A.assets.readme,{},O);return await(0,r.asText)(k)||""}return""}async getManifest(A,O){if(A.assets.manifest){const k=await this.getAsset(A.assets.manifest,{},O),F=await(0,r.asText)(k);return F?JSON.parse(F):null}return null}async getCoreTranslation(A,O){const k=A.assets.coreTranslations.filter(F=>F[0]===O.toUpperCase())[0];if(k){const F=await this.getAsset(k[1]),U=await(0,r.asText)(F);return U?JSON.parse(U):null}return null}async getChangelog(A,O){if(A.assets.changelog){const k=await this.getAsset(A.assets.changelog,{},O);return await(0,r.asText)(k)||""}return""}async getAllVersions(A,O){let k=new h().withFlags(u.IncludeVersions,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(c.Target,"Microsoft.VisualStudio.Code");A.identifier.uuid?k=k.withFilter(c.ExtensionId,A.identifier.uuid):k=k.withFilter(c.ExtensionName,A.identifier.id);const F=[],{galleryExtensions:U}=await this.queryGallery(k,n.CancellationToken.None);return U.length&&(O?await Promise.all(U[0].versions.map(async K=>{let G;try{G=await this.getEngine(K)}catch(Y){}G&&(0,w.isEngineValid)(G,this.productService.version,this.productService.date)&&F.push({version:K.version,date:K.lastUpdated})})):F.push(...U[0].versions.map(K=>({version:K.version,date:K.lastUpdated})))),F}async getAsset(A,O={},k=n.CancellationToken.None){const F=await this.commonHeadersPromise,U={type:"GET"},K=Object.assign(Object.assign({},F),O.headers||{});O=Object.assign(Object.assign(Object.assign({},O),U),{headers:K});const G=A.uri,Y=A.fallbackUri,Z=Object.assign(Object.assign({},O),{url:G});try{const ne=await this.requestService.request(Z,k);if(ne.res.statusCode===200)return ne;const se=await(0,r.asText)(ne);throw new Error(`Expected 200, got back ${ne.res.statusCode} instead.

${se}`)}catch(ne){if((0,m.isPromiseCanceledError)(ne))throw ne;const se=(0,m.getErrorMessage)(ne);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:G,message:se});const re=Object.assign(Object.assign({},O),{url:Y});return this.requestService.request(re,k)}}async getLastValidExtensionVersion(A,O){const k=this.getLastValidExtensionVersionFromProperties(A,O);return k||this.getLastValidExtensionVersionRecursively(A,O)}getLastValidExtensionVersionFromProperties(A,O){for(const k of O){const F=x(k);if(!F)return null;if((0,w.isEngineValid)(F,this.productService.version,this.productService.date))return k}return null}async getEngine(A){const O=x(A);if(O)return O;const k=$(A,t.Manifest);if(!k)throw new Error("Manifest was not found");const F={"Accept-Encoding":"gzip"},U=await this.getAsset(k,{headers:F}),K=await(0,r.asJson)(U);if(K)return K.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(A,O){if(!O.length)return null;const k=O[0],F=await this.getEngine(k);return(0,w.isEngineValid)(F,this.productService.version,this.productService.date)?(k.properties=k.properties||[],k.properties.push({key:i.Engine,value:F}),k):this.getLastValidExtensionVersionRecursively(A,O.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const O=await(0,r.asJson)(A),k=new Map;if(O)for(const F of O.malicious){const U=k.get(F)||{id:{id:F},malicious:!0,slow:!1};U.malicious=!0,k.set(F,U)}return[...k.values()]}};z=ue([ee(0,r.IRequestService),ee(1,b.ILogService),ee(2,p.IEnvironmentService),ee(3,P.ITelemetryService),ee(4,I.IFileService),ee(5,d.IProductService),ee(6,(0,E.optional)(g.IStorageService))],z),e.ExtensionGalleryService=z;async function V(_,A,O,k){const F={"X-Market-Client-Id":`VSCode ${_}`,"User-Agent":`VSCode ${_}`},U=await(0,M.getServiceMachineId)(A,O,k);return F["X-Market-User-Id"]=U,F}e.resolveMarketplaceHeaders=V}),define(Q[198],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class m{constructor(S){this.appender=S}listen(S,P){throw new Error(`Event not found: ${P}`)}call(S,P,{eventName:r,data:w}){return this.appender.log(r,w),Promise.resolve(null)}}e.TelemetryAppenderChannel=m;class R{constructor(S){this.channel=S}log(S,P){return this.channel.call("log",{eventName:S,data:P}).then(void 0,r=>`Failed to log telemetry: ${console.warn(r)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=R}),define(Q[199],J([0,1,47,146,23,4,16,48,2,44,37]),function(j,e,m,R,L,S,P,r,w,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let b=class{constructor(d,g){this._configurationService=g,this._experimentProperties={},this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appender=d.appender,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let M of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(M),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(M=>{const E=/^[a-f0-9]+$/i.test(M["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!E})}))}setExperimentProperty(d,g){this._experimentProperties[d]=g}setEnabled(d){this._enabled=d}_updateUserOptIn(){var d;const g=(d=this._configurationService)===null||d===void 0?void 0:d.getValue(I);this._userOptIn=g?g.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const d=await this._commonProperties;let g=d.sessionID,M=d["common.instanceId"],E=d["common.machineId"],o=d["common.firstSessionDate"],u=d["common.msftInternal"];return{sessionId:g,instanceId:M,machineId:E,firstSessionDate:o,msftInternal:u}}dispose(){this._disposables.dispose()}publicLog(d,g,M){return this.isOptedIn?this._commonProperties.then(E=>{g=(0,p.mixin)(g,E),g=(0,p.mixin)(g,this._experimentProperties),g=(0,p.cloneAndChange)(g,o=>{if(typeof o=="string")return this._cleanupInfo(o,M)}),this._appender.log(d,g)},E=>{console.error(E)}):Promise.resolve(void 0)}publicLog2(d,g,M){return this.publicLog(d,g,M)}publicLogError(d,g){return this.sendErrorTelemetry?this.publicLog(d,g,!0):Promise.resolve(void 0)}publicLogError2(d,g){return this.publicLogError(d,g)}_cleanupInfo(d,g){let M=d;if(g){const E=[];for(let c of this._cleanupPatterns)for(;;){const t=c.exec(d);if(!t)break;E.push([t.index,c.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(M="";;){const c=u.exec(d);if(!c)break;!o.test(c[0])&&E.every(([t,i])=>c.index<t||c.index>=i)&&(M+=d.substring(l,c.index)+"<REDACTED: user-file-path>",l=u.lastIndex)}l<d.length&&(M+=d.substr(l))}for(let E of this._cleanupPatterns)M=M.replace(E,"");return M}};b.IDLE_START_EVENT_NAME="UserIdleStart",b.IDLE_STOP_EVENT_NAME="UserIdleStop",b=ue([ee(1,(0,S.optional)(P.IConfigurationService))],b),e.TelemetryService=b;const I="telemetry";n.Registry.as(r.Extensions.Configuration).registerConfiguration({id:I,order:110,type:"object",title:(0,R.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,R.localize)(2,null,m.default.privacyStatementUrl):(0,R.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(Q[96],J([0,1,16,44,13,9]),function(j,e,m,R,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(d,g){return Promise.resolve(void 0)}publicLog2(d,g){return this.publicLog(d,g)}publicLogError(d,g){return Promise.resolve(void 0)}publicLogError2(d,g){return this.publicLogError(d,g)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class P{async publicLog(g,M,E){}async publicLogError(g,M,E){}}e.NullEndpointTelemetryService=P;function r(...d){return{log:(g,M)=>d.forEach(E=>E.log(g,M)),flush:()=>S.Promises.settled(d.map(g=>g.flush()))}}e.combinedAppender=r,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(d,g){return g.onDidChangeConfiguration(M=>{M.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,m.ConfigurationTargetToString)(M.source),configurationKeys:I(M.sourceConfig)})})}e.configurationTelemetry=w;function p(d){const g=Object.create(null),M=Object.create(null),E=Object.create(null);b(d,E);for(let o in E){o=o.length>150?o.substr(o.length-149):o;const u=E[o];typeof u=="number"?M[o]=u:typeof u=="boolean"?M[o]=u?1:0:typeof u=="string"?g[o]=u.substring(0,1023):typeof u!="undefined"&&u!==null&&(g[o]=u)}return{properties:g,measurements:M}}e.validateTelemetryData=p;function n(d){if(!d)return"none";let g="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(E=>{d.indexOf(`${E}+`)===0&&(g=E)}),g}e.cleanRemoteAuthority=n;function b(d,g,M=0,E){if(!!d)for(let o of Object.getOwnPropertyNames(d)){const u=d[o],l=E?E+o:o;Array.isArray(u)?g[l]=(0,R.safeStringify)(u):u instanceof Date?g[l]=u.toISOString():(0,L.isObject)(u)?M<2?b(u,g,M+1,l+"."):g[l]=(0,R.safeStringify)(u):g[l]=u}}function I(d){if(!d)return[];const g=[];return y(g,"",d),g}function y(d,g,M){M&&typeof M=="object"&&!Array.isArray(M)?Object.keys(M).forEach(E=>y(d,g?`${g}.${E}`:E,M[E])):d.push(g)}}),define(Q[200],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(Q[201],J([0,1,4,2,37,5,200,107]),function(j,e,m,R,L,S,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,m.createDecorator)("themeService");var w;(function(M){function E(o){return o&&typeof o=="object"&&typeof o.id=="string"}M.isThemeColor=E})(w=e.ThemeColor||(e.ThemeColor={}));function p(M){return{id:M}}e.themeColorFromId=p;var n;(function(M){function E(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||w.isThemeColor(t.color))}M.isThemeIcon=E;const o=new RegExp(`^\\$\\((${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?)\\)$`);function u(t){const i=o.exec(t);if(!!i){let[,s]=i;return{id:s}}}M.fromString=u;function l(t,i){let s=t.id;const a=s.lastIndexOf("~");return a!==-1&&(s=s.substring(0,a)),i&&(s=`${s}~${i}`),{id:s}}M.modify=l;function c(t,i){var s,a;return t.id===i.id&&((s=t.color)===null||s===void 0?void 0:s.id)===((a=i.color)===null||a===void 0?void 0:a.id)}M.isEqual=c,M.asClassNameArray=r.CSSIcon.asClassNameArray,M.asClassName=r.CSSIcon.asClassName,M.asCSSSelector=r.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=r.Codicon.file,e.FolderThemeIcon=r.Codicon.folder;function b(M){switch(M){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class I{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new S.Emitter}onColorThemeChange(E){return this.themingParticipants.push(E),this.onThemingParticipantAddedEmitter.fire(E),(0,R.toDisposable)(()=>{const o=this.themingParticipants.indexOf(E);this.themingParticipants.splice(o,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new I;L.Registry.add(e.Extensions.ThemingContribution,y);function d(M){return y.onColorThemeChange(M)}e.registerThemingParticipant=d;class g extends R.Disposable{constructor(E){super();this.themeService=E,this.theme=E.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(o=>this.onThemeChange(o)))}onThemeChange(E){this.theme=E,this.updateStyles()}updateStyles(){}getColor(E,o){let u=this.theme.getColor(E);return u&&o&&(u=o(u,this.theme)),u?u.toString():null}}e.Themable=g}),define(Q[60],J([0,1,14,3,38,4]),function(j,e,m,R,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const P="#FFFFFF",r="#1E1E1E",w="#000000",p="theme",n="themeBackground",b="windowSplash";e.IThemeMainService=(0,S.createDecorator)("themeMainService");let I=class{constructor(d){this.stateMainService=d}getBackgroundColor(){if((R.isWindows||R.isMacintosh)&&m.nativeTheme.shouldUseInvertedColorScheme)return w;let d=this.stateMainService.getItem(n,null);if(!d){let g;(R.isWindows||R.isMacintosh)&&m.nativeTheme.shouldUseInvertedColorScheme?g="hc-black":g=this.stateMainService.getItem(p,"vs-dark").split(" ")[0],d=g==="hc-black"?w:g==="vs"?P:r}return R.isMacintosh&&d.toUpperCase()===r&&(d="#171717"),d}saveWindowSplash(d,g){this.stateMainService.setItems([{key:p,data:g.baseTheme},{key:n,data:g.colorInfo.background},{key:b,data:g}]),typeof d=="number"&&this.updateBackgroundColor(d,g)}updateBackgroundColor(d,g){for(const M of m.BrowserWindow.getAllWindows())if(M.id===d){M.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(b)}};I=ue([ee(0,L.IStateMainService)],I),e.ThemeMainService=I}),define(Q[40],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var R;(function(S){S.Uninitialized="uninitialized",S.Idle="idle",S.CheckingForUpdates="checking for updates",S.AvailableForDownload="available for download",S.Downloading="downloading",S.Downloaded="downloaded",S.Updating="updating",S.Ready="ready"})(R=e.StateType||(e.StateType={}));var L;(function(S){S[S.Setup=0]="Setup",S[S.Archive=1]="Archive",S[S.Snap=2]="Snap"})(L=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(S,P)=>({type:"idle",updateType:S,error:P}),CheckingForUpdates:S=>({type:"checking for updates",explicit:S}),AvailableForDownload:S=>({type:"available for download",update:S}),Downloading:S=>({type:"downloading",update:S}),Downloaded:S=>({type:"downloaded",update:S}),Updating:S=>({type:"updating",update:S}),Ready:S=>({type:"ready",update:S})},e.IUpdateService=(0,m.createDecorator)("updateService")}),define(Q[202],J([0,1,37,48,147,3]),function(j,e,m,R,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),m.Registry.as(R.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:S.isWindows&&!S.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Q[203],J([0,1,5,40]),function(j,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class L{constructor(r){this.service=r}listen(r,w){switch(w){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${w}`)}call(r,w,p){switch(w){case"checkForUpdates":return this.service.checkForUpdates(p);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${w}`)}}e.UpdateChannel=L;class S{constructor(r){this.channel=r,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,this._state=R.State.Uninitialized,this.channel.listen("onStateChange")(w=>this.state=w),this.channel.call("_getInitialState").then(w=>this.state=w)}get state(){return this._state}set state(r){this._state=r,this._onStateChange.fire(r)}checkForUpdates(r){return this.channel.call("checkForUpdates",r)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=S}),define(Q[97],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,m.createDecorator)("urlService")}),define(Q[204],J([0,1,7]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class R{constructor(r){this.handler=r}listen(r,w){throw new Error(`Event not found: ${w}`)}call(r,w,p){switch(w){case"handleURL":return this.handler.handleURL(m.URI.revive(p[0]),p[1])}throw new Error(`Call not found: ${w}`)}}e.URLHandlerChannel=R;class L{constructor(r){this.channel=r}handleURL(r,w){return this.channel.call("handleURL",[r.toJSON(),w])}}e.URLHandlerChannelClient=L;class S{constructor(r){this.next=r}async routeCall(r,w,p,n){if(w!=="handleURL")throw new Error(`Call not found: ${w}`);if(p){const b=m.URI.revive(p);if(b&&b.query){const I=/\bwindowId=(\d+)/.exec(b.query);if(I){const y=I[1],d=new RegExp(`window:${y}`),g=r.connections.find(M=>d.test(M.ctx));if(g)return g}}}return this.next.routeCall(r,w,p,n)}routeEvent(r,w){throw new Error(`Event not found: ${w}`)}}e.URLHandlerRouter=S}),define(Q[205],J([0,1,7,9,2,22]),function(j,e,m,R,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class P extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(p,n){const b=[...this.handlers.values()];return(0,R.first)(b.map(I=>()=>I.handleURL(p,n)),void 0,!1).then(I=>I||!1)}registerHandler(p){return this.handlers.add(p),(0,L.toDisposable)(()=>this.handlers.delete(p))}}e.AbstractURLService=P;let r=class extends P{constructor(p){super();this.productService=p}create(p){let{authority:n,path:b,query:I,fragment:y}=p||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return n&&b&&b.indexOf("/")!==0&&(b=`/${b}`),m.URI.from({scheme:this.productService.urlProtocol,authority:n,path:b,query:I,fragment:y})}};r=ue([ee(0,S.IProductService)],r),e.NativeURLService=r}),define(Q[206],J([0,1,5,14,7,2,3,9]),function(j,e,m,R,L,S,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function w(n){try{return L.URI.parse(n)}catch(b){return null}}class p{constructor(b,I,y,d,g){if(this.urlService=I,this.uris=[],this.retryCount=0,this.flushDisposable=S.Disposable.None,this.disposables=new S.DisposableStore,this.uris=b,P.isWindows){const o=d.isBuilt?[]:[`"${d.appRoot}"`];o.push("--open-url","--"),R.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,o)}const M=m.Event.map(m.Event.fromNodeEventEmitter(R.app,"open-url",(o,u)=>({event:o,url:u})),({event:o,url:u})=>(o.preventDefault(),u));this.disposables.add(M(o=>{const u=w(o);!u||this.urlService.open(u,{originalUrl:o})})),y.getWindows().filter(o=>o.isReady).length>0?this.flush():m.Event.once(y.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(!(this.retryCount++>10)){const b=[];for(const I of this.uris)await this.urlService.open(I.uri,{originalUrl:I.url})||b.push(I);b.length!==0&&(this.uris=b,this.flushDisposable=(0,r.disposableTimeout)(()=>this.flush(),500))}}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=p}),define(Q[76],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewPartitionId=e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,m.createDecorator)("webviewManagerService"),e.webviewPartitionId="webview"}),define(Q[207],J([0,1,14,2,10,7,76]),function(j,e,m,R,L,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class r extends R.Disposable{constructor(){super();const p=m.session.fromPartition(P.webviewPartitionId),n=this.handleWebviewRequest.bind(this);m.protocol.registerFileProtocol(L.Schemas.vscodeWebview,n),p.protocol.registerFileProtocol(L.Schemas.vscodeWebview,n)}async handleWebviewRequest(p,n){try{const b=S.URI.parse(p.url),I=r.validWebviewFilePaths.get(b.path);if(typeof I=="string"){const y=b.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${I}`:`vs/workbench/contrib/webview/browser/pre/${I}`,d=L.FileAccess.asFileUri(y,j);return n(decodeURIComponent(d.fsPath))}}catch(b){}n({error:-10})}}e.WebviewProtocolProvider=r,r.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/electron-browser-index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"],["/service-worker.js","service-worker.js"]])}),define(Q[61],J([0,1,3]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(p){return!!p.workspaceUri}e.isWorkspaceToOpen=R;function L(p){return!!p.folderUri}e.isFolderToOpen=L;function S(p){return!!p.fileUri}e.isFileToOpen=S;function P(p){const n=r(p),b=p.getValue("window.menuBarVisibility");return b==="default"||n==="native"&&b==="compact"||m.isMacintosh&&m.isNative?"classic":b}e.getMenuBarVisibility=P;function r(p){if(m.isWeb)return"custom";const n=p.getValue("window");if(n){if(m.isMacintosh&&n.nativeTabs===!0||m.isMacintosh&&n.nativeFullScreen===!1)return"native";const y=n.titleBarStyle;if(y==="native"||y==="custom")return y}return m.isLinux?"native":"custom"}e.getTitleBarStyle=r;function w(p=0){return Math.pow(1.2,p)}e.zoomLevelToZoomFactor=w}),define(Q[34],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=void 0;var R;(function(r){r[r.CLI=0]="CLI",r[r.DOCK=1]="DOCK",r[r.MENU=2]="MENU",r[r.DIALOG=3]="DIALOG",r[r.DESKTOP=4]="DESKTOP",r[r.API=5]="API"})(R=e.OpenContext||(e.OpenContext={}));const L=function(r=1){return{width:1024,height:768,mode:r}};e.defaultWindowState=L;var S;(function(r){r[r.Maximized=0]="Maximized",r[r.Normal=1]="Normal",r[r.Minimized=2]="Minimized",r[r.Fullscreen=3]="Fullscreen"})(S=e.WindowMode||(e.WindowMode={}));var P;(function(r){r[r.UNRESPONSIVE=1]="UNRESPONSIVE",r[r.CRASHED=2]="CRASHED",r[r.LOAD=3]="LOAD"})(P=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,m.createDecorator)("windowsMainService")}),define(Q[208],J([0,1,14,2,74,76,207,34]),function(j,e,m,R,L,S,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let w=class extends R.Disposable{constructor(n,b){super();this.windowsMainService=b,this._register(new P.WebviewProtocolProvider);const I=m.session.fromPartition(S.webviewPartitionId);I.setPermissionRequestHandler((y,d,g)=>g(d==="clipboard-read")),I.setPermissionCheckHandler((y,d)=>d==="clipboard-read")}async setIgnoreMenuShortcuts(n,b){let I;if(typeof n.windowId=="number"){const{windowId:y}=n,d=this.windowsMainService.getWindowById(y);if(!(d==null?void 0:d.win))throw new Error(`Invalid windowId: ${y}`);I=d.win.webContents}else{const{webContentsId:y}=n;if(I=m.webContents.fromId(y),!I)throw new Error(`Invalid webContentsId: ${y}`)}I.isDestroyed()||I.setIgnoreMenuShortcuts(b)}};w=ue([ee(0,L.ITunnelService),ee(1,r.IWindowsMainService)],w),e.WebviewMainService=w}),define(Q[209],J([0,1,5,2,9]),function(j,e,m,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class S extends R.Disposable{constructor({onDidOpenWindow:r,onDidFocusWindow:w,getActiveWindowId:p}){super();this.disposables=this._register(new R.DisposableStore),m.Event.latch(m.Event.any(r,w))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,L.createCancelablePromise)(()=>p()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch(b){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(r){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=r}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=S}),define(Q[210],J([0,1,7,15,4,36]),function(j,e,m,R,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,L.createDecorator)("contextService");var P;(function(I){I[I.EMPTY=1]="EMPTY",I[I.FOLDER=2]="FOLDER",I[I.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function r(I){const y=I;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.isWorkspace=r;function w(I){const y=I;return!!(y&&typeof y=="object"&&m.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.isWorkspaceFolder=w;class p{constructor(y,d,g,M){this._id=y,this._configuration=g,this._ignorePathCasing=M,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(y){this._id=y.id,this._configuration=y.configuration,this._ignorePathCasing=y._ignorePathCasing,this.folders=y.folders}get folders(){return this._folders}set folders(y){this._folders=y,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(y){this._configuration=y}getFolder(y){return y&&this._foldersMap.findSubstr(y.with({scheme:y.scheme,authority:y.authority,path:y.path}))||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing);for(const y of this.folders)this._foldersMap.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=p;class n{constructor(y,d){this.raw=d,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,R.joinPath)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function b(I){return new n({uri:I,index:0,name:(0,R.basenameOrAuthority)(I)},{uri:I.toString()})}e.toWorkspaceFolder=b}),define(Q[29],J([0,1,4,150,210,7,3,8,15,103,43,10,39,30,73]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function M(B){return(typeof B=="string"?(0,r.extname)(B):(0,w.extname)(B))===g}e.hasWorkspaceFileExtension=M,e.IWorkspacesService=(0,m.createDecorator)("workspacesService");function E(B){return B.hasOwnProperty("workspace")}e.isRecentWorkspace=E;function o(B){return B.hasOwnProperty("folderUri")}e.isRecentFolder=o;function u(B){return B.hasOwnProperty("fileUri")}e.isRecentFile=u;function l(B){const C=B;return typeof(C==null?void 0:C.id)=="string"&&S.URI.isUri(C.uri)}e.isSingleFolderWorkspaceIdentifier=l;function c(B){if(B.configuration)return{id:B.id,configPath:B.configuration};if(B.folders.length===1)return{id:B.id,uri:B.folders[0].uri}}e.toWorkspaceIdentifier=c;function t(B){const C=B;return typeof(C==null?void 0:C.id)=="string"&&S.URI.isUri(C.configPath)}e.isWorkspaceIdentifier=t;function i(B){const C=B;if(C==null?void 0:C.uri)return{id:C.id,uri:S.URI.revive(C.uri)};const z=B;if(z==null?void 0:z.configPath)return{id:z.id,configPath:S.URI.revive(z.configPath)};if(B==null?void 0:B.id)return{id:B.id}}e.reviveIdentifier=i;function s(B,C){return w.extUriBiasedIgnorePathCase.isEqualOrParent(B,C.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function a(B){return h(B)||f(B)}e.isStoredWorkspaceFolder=a;function h(B){const C=B;return typeof(C==null?void 0:C.path)=="string"&&(!C.name||typeof C.name=="string")}e.isRawFileWorkspaceFolder=h;function f(B){const C=B;return typeof(C==null?void 0:C.uri)=="string"&&(!C.name||typeof C.name=="string")}e.isRawUriWorkspaceFolder=f;function v(B,C,z,V,_=!P.isWindows,A){if(B.scheme!==V.scheme)return{name:z,uri:B.toString(!0)};let O=C?void 0:A.relativePath(V,B);if(O!==void 0)O.length===0?O=".":P.isWindows&&B.scheme===b.Schemas.file&&!_&&(O=O.replace(/\//g,"\\"));else if(B.scheme===b.Schemas.file)O=B.fsPath,P.isWindows&&(O=(0,I.normalizeDriveLetter)(O),_&&(O=(0,y.toSlashes)(O)));else{if(!A.isEqualAuthority(B.authority,V.authority))return{name:z,uri:B.toString(!0)};O=B.path}return{name:z,path:O}}e.getStoredWorkspaceFolder=v;function D(B,C,z){let V=[],_=new Set;const A=z.dirname(C);for(let O of B){let k;if(h(O))O.path&&(k=z.resolvePath(A,O.path));else if(f(O))try{k=S.URI.parse(O.uri),k.path[0]!=="/"&&(k=k.with({path:"/"+k.path}))}catch(F){console.warn(F)}if(k){let F=z.getComparisonKey(k);if(!_.has(F)){_.add(F);const U=O.name||z.basenameOrAuthority(k);V.push(new L.WorkspaceFolder({uri:k,name:U,index:V.length},O))}}}return V}e.toWorkspaceFolders=D;function T(B,C,z,V,_){let A=W(C,B);const O=_.dirname(C),k=_.dirname(V),F=[],U=$(A.folders);for(const Z of A.folders){const ne=h(Z)?_.resolvePath(O,Z.path):S.URI.parse(Z.uri);let se;z?se=!1:se=!h(Z)||(0,r.isAbsolute)(Z.path),F.push(v(ne,se,Z.name,k,U,_))}const K={insertSpaces:!1,tabSize:4,eol:P.isLinux||P.isMacintosh?`
`:`\r
`},G=p.setProperty(B,["folders"],F,K);let Y=p.applyEdits(B,G);return A.remoteAuthority===(0,d.getRemoteAuthority)(V)&&(Y=p.applyEdits(Y,p.removeProperty(Y,["remoteAuthority"],K))),Y}e.rewriteWorkspaceFileForNewLocation=T;function W(B,C){let z=n.parse(C);if(z&&Array.isArray(z.folders))z.folders=z.folders.filter(V=>a(V));else throw new Error(`${B} looks like an invalid workspace file.`);return z}function $(B){return P.isWindows?B.some(C=>h(C)&&C.path.indexOf("/")>=0):!0}e.useSlashForPath=$;function X(B){return B.workspace&&typeof B.workspace=="object"&&typeof B.workspace.id=="string"&&typeof B.workspace.configPath=="string"}function x(B){return typeof B.folderUri=="string"}function oe(B){return typeof B.fileUri=="string"}function q(B,C){const z={workspaces:[],files:[]};if(B){const V=function(A,O){for(let k=0;k<A.length;k++)try{O(A[k],k)}catch(F){C.warn(`Error restoring recent entry ${JSON.stringify(A[k])}: ${F.toString()}. Skip entry.`)}},_=B;if(Array.isArray(_.entries))V(_.entries,A=>{const O=A.label,k=A.remoteAuthority;X(A)?z.workspaces.push({label:O,remoteAuthority:k,workspace:{id:A.workspace.id,configPath:S.URI.parse(A.workspace.configPath)}}):x(A)?z.workspaces.push({label:O,remoteAuthority:k,folderUri:S.URI.parse(A.folderUri)}):oe(A)&&z.files.push({label:O,remoteAuthority:k,fileUri:S.URI.parse(A.fileUri)})});else{const A=B;Array.isArray(A.workspaces3)&&V(A.workspaces3,(O,k)=>{const F=Array.isArray(A.workspaceLabels)&&A.workspaceLabels[k]||void 0;typeof O=="object"&&typeof O.id=="string"&&typeof O.configURIPath=="string"?z.workspaces.push({label:F,workspace:{id:O.id,configPath:S.URI.parse(O.configURIPath)}}):typeof O=="string"&&z.workspaces.push({label:F,folderUri:S.URI.parse(O)})}),Array.isArray(A.files2)&&V(A.files2,(O,k)=>{const F=Array.isArray(A.fileLabels)&&A.fileLabels[k]||void 0;typeof O=="string"&&z.files.push({label:F,fileUri:S.URI.parse(O)})})}}return z}e.restoreRecentlyOpened=q;function N(B){const C={entries:[]};for(const z of B.workspaces)o(z)?C.entries.push({folderUri:z.folderUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority}):C.entries.push({workspace:{id:z.workspace.id,configPath:z.workspace.configPath.toString()},label:z.label,remoteAuthority:z.remoteAuthority});for(const z of B.files)C.entries.push({fileUri:z.fileUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority});return C}e.toStoreData=N}),define(Q[50],J([0,1,4,29]),function(j,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,m.createDecorator)("backupMainService");function L(S){const P=S;return P&&(0,R.isWorkspaceIdentifier)(P.workspace)}e.isWorkspaceBackupInfo=L}),define(Q[51],J([0,1,4,14,9,38,3,8,65,20,13,133,29,39,2,80]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,m.createDecorator)("dialogMainService");let M=class mt{constructor(o){this.stateMainService=o,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(o,u){return this.doPick(Object.assign(Object.assign({},o),{pickFolders:!0,pickFiles:!0,title:(0,b.localize)(0,null)}),u)}pickFolder(o,u){return this.doPick(Object.assign(Object.assign({},o),{pickFolders:!0,title:(0,b.localize)(1,null)}),u)}pickFile(o,u){return this.doPick(Object.assign(Object.assign({},o),{pickFiles:!0,title:(0,b.localize)(2,null)}),u)}pickWorkspace(o,u){const l=(0,b.localize)(3,null),c=(0,y.mnemonicButtonLabel)((0,b.localize)(4,null)),t=I.WORKSPACE_FILTER;return this.doPick(Object.assign(Object.assign({},o),{pickFiles:!0,title:l,filters:t,buttonLabel:c}),u)}async doPick(o,u){const l={title:o.title,buttonLabel:o.buttonLabel,filters:o.filters};l.defaultPath=o.defaultPath||this.stateMainService.getItem(mt.workingDirPickerStorageKey),(typeof o.pickFiles=="boolean"||typeof o.pickFolders=="boolean")&&(l.properties=void 0,o.pickFiles&&o.pickFolders&&(l.properties=["multiSelections","openDirectory","openFile","createDirectory"])),l.properties||(l.properties=["multiSelections",o.pickFolders?"openDirectory":"openFile","createDirectory"]),P.isMacintosh&&l.properties.push("treatPackageAsDirectory");const c=u||R.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(l,(0,n.withNullAsUndefined)(c));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateMainService.setItem(mt.workingDirPickerStorageKey,(0,r.dirname)(t.filePaths[0])),t.filePaths}getWindowDialogQueue(o){if(o){let u=this.windowDialogQueues.get(o.id);return u||(u=new L.Queue,this.windowDialogQueues.set(o.id,u)),u}else return this.noWindowDialogueQueue}showMessageBox(o,u){return this.getWindowDialogQueue(u).queue(async()=>u?R.dialog.showMessageBox(u,o):R.dialog.showMessageBox(o))}async showSaveDialog(o,u){const l=this.acquireFileDialogLock(o,u);if(!l)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(u).queue(async()=>{let c;return u?c=await R.dialog.showSaveDialog(u,o):c=await R.dialog.showSaveDialog(o),c.filePath=this.normalizePath(c.filePath),c})}finally{(0,d.dispose)(l)}}normalizePath(o){return o&&P.isMacintosh&&(o=(0,w.normalizeNFC)(o)),o}normalizePaths(o){return o.map(u=>this.normalizePath(u))}async showOpenDialog(o,u){o.defaultPath&&(await(0,p.exists)(o.defaultPath)||(o.defaultPath=void 0));const l=this.acquireFileDialogLock(o,u);if(!l)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(u).queue(async()=>{let c;return u?c=await R.dialog.showOpenDialog(u,o):c=await R.dialog.showOpenDialog(o),c.filePaths=this.normalizePaths(c.filePaths),c})}finally{(0,d.dispose)(l)}}acquireFileDialogLock(o,u){if(!u)return d.Disposable.None;let l=this.windowFileDialogLocks.get(u.id);l||(l=new Set,this.windowFileDialogLocks.set(u.id,l));const c=(0,g.hash)(o);if(!l.has(c))return l.add(c),(0,d.toDisposable)(()=>{l==null||l.delete(c),(l==null?void 0:l.size)===0&&this.windowFileDialogLocks.delete(u.id)})}};M.workingDirPickerStorageKey="pickerWorkingDir",M=ue([ee(0,S.IStateMainService)],M),e.DialogMainService=M}),define(Q[211],J([0,1,5,2,29]),function(j,e,m,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class S extends R.Disposable{constructor(r,w){super();this.logService=r,this.storageMainService=w,this._onDidChangeGlobalStorage=this._register(new m.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(m.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(r,w)=>(r?r.push(w):r=[w],r),S.STORAGE_CHANGE_DEBOUNCE_TIME)(r=>{r.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(r))}))}serializeGlobalStorageEvents(r){const w=new Map,p=new Set;return r.forEach(n=>{const b=this.storageMainService.globalStorage.get(n.key);typeof b=="string"?w.set(n.key,b):p.add(n.key)}),{changed:Array.from(w.entries()),deleted:Array.from(p.values())}}listen(r,w){switch(w){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${w}`)}async call(r,w,p){const n=(0,L.reviveIdentifier)(p.workspace),b=await this.withStorageInitialized(n);switch(w){case"getItems":return Array.from(b.items.entries());case"updateItems":{const I=p;if(I.insert)for(const[y,d]of I.insert)b.set(y,d);I.delete&&I.delete.forEach(y=>b.delete(y));break}case"close":{if(n)return b.close();break}default:throw new Error(`Call not found: ${w}`)}}async withStorageInitialized(r){const w=r?this.storageMainService.workspaceStorage(r):this.storageMainService.globalStorage;try{await w.init()}catch(p){this.logService.error(`StorageIPC#init: Unable to init ${r?"workspace":"global"} storage due to ${p}`)}return w}}e.StorageDatabaseChannel=S,S.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Q[212],J([0,1,24,20,5,2,6,123,85,8,95,31,28,29]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class d extends S.Disposable{constructor(o){super();this.logService=o,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new L.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new w.Storage(new w.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const o=await this.doCreate();this.storage.dispose(),this.storage=o,this._register(o.onDidChangeStorage(l=>this._onDidChangeStorage.fire({key:l}))),await this.doInit(o);const u=o.getBoolean(n.IS_NEW_KEY);u===void 0?o.set(n.IS_NEW_KEY,!0):u&&o.set(n.IS_NEW_KEY,!1)}catch(o){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${o}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===P.LogLevel.Trace?o=>this.logService.trace(o):void 0,logError:o=>this.logService.error(o)}}doInit(o){return o.init()}get items(){return this.storage.items}get(o,u){return this.storage.get(o,u)}set(o,u){return this.storage.set(o,u)}delete(o){return this.storage.delete(o)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class g extends d{constructor(o,u,l){super(u);this.options=o,this.environmentService=l}async doCreate(){let o;return this.options.useInMemoryStorage?o=r.SQLiteStorageDatabase.IN_MEMORY_PATH:o=(0,p.join)(this.environmentService.globalStorageHome.fsPath,g.STORAGE_NAME),new w.Storage(new r.SQLiteStorageDatabase(o,{logging:this.createLogginOptions()}))}async doInit(o){await super.doInit(o),this.updateTelemetryState(o)}updateTelemetryState(o){o.get(b.instanceStorageKey,void 0)===void 0&&o.set(b.instanceStorageKey,(0,I.generateUuid)()),o.get(b.firstSessionDateStorageKey,void 0)===void 0&&o.set(b.firstSessionDateStorageKey,new Date().toUTCString());const c=o.get(b.currentSessionDateStorageKey,void 0),t=new Date().toUTCString();o.set(b.lastSessionDateStorageKey,typeof c=="undefined"?null:c),o.set(b.currentSessionDateStorageKey,t)}}e.GlobalStorageMain=g,g.STORAGE_NAME="state.vscdb";class M extends d{constructor(o,u,l,c){super(l);this.workspace=o,this.options=u,this.environmentService=c}async doCreate(){const{storageFilePath:o,wasCreated:u}=await this.prepareWorkspaceStorageFolder();return new w.Storage(new r.SQLiteStorageDatabase(o,{logging:this.createLogginOptions()}),{hint:u?w.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:r.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const o=(0,p.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),u=(0,p.join)(o,M.WORKSPACE_STORAGE_NAME);return await(0,R.exists)(o)?{storageFilePath:u,wasCreated:!1}:(await m.promises.mkdir(o,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(o),{storageFilePath:u,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(o){let u;if((0,y.isSingleFolderWorkspaceIdentifier)(this.workspace)?u={folder:this.workspace.uri.toString()}:(0,y.isWorkspaceIdentifier)(this.workspace)&&(u={workspace:this.workspace.configPath.toString()}),u)try{const l=(0,p.join)(o,M.WORKSPACE_META_NAME);await(0,R.exists)(l)||await(0,R.writeFile)(l,JSON.stringify(u,void 0,2))}catch(l){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.WorkspaceStorageMain=M,M.WORKSPACE_STORAGE_NAME="state.vscdb",M.WORKSPACE_META_NAME="workspace.json"}),define(Q[98],J([0,1,42,2,53,4,17,6,212]),function(j,e,m,R,L,S,P,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,S.createDecorator)("storageMainService");let p=class extends R.Disposable{constructor(b,I,y){super();this.logService=b,this.environmentService=I,this.lifecycleMainService=y,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async b=>{b.workspace&&this.workspaceStorage(b.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(b=>{b.join(this.globalStorage.close());for(const[,I]of this.mapWorkspaceToStorage)b.join(I.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const b=new w.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,m.once)(b.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),b}createWorkspaceStorage(b){return new w.WorkspaceStorageMain(b,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(b){let I=this.mapWorkspaceToStorage.get(b.id);return I||(this.logService.trace(`StorageMainService: creating workspace storage (${b.id})`),I=this.createWorkspaceStorage(b),this.mapWorkspaceToStorage.set(b.id,I),(0,m.once)(I.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${b.id})`),this.mapWorkspaceToStorage.delete(b.id)})),I}};p=ue([ee(0,r.ILogService),ee(1,L.IEnvironmentService),ee(2,P.ILifecycleMainService)],p),e.StorageMainService=p}),define(Q[99],J([0,1,7,29,15]),function(j,e,m,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function S(w,p,n){for(const I of w){const y=I.openedWorkspace;if((0,R.isWorkspaceIdentifier)(y)){const d=n(y);if(d){if(d.folders.some(g=>L.extUriBiasedIgnorePathCase.isEqualOrParent(p,g.uri)))return I}else if(L.extUriBiasedIgnorePathCase.isEqualOrParent(p,y.configPath))return I}}const b=w.filter(I=>(0,R.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&L.extUriBiasedIgnorePathCase.isEqualOrParent(p,I.openedWorkspace.uri));if(b.length)return b.sort((I,y)=>-(I.openedWorkspace.uri.path.length-y.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=S;function P(w,p){for(const n of w)if((0,R.isWorkspaceIdentifier)(n.openedWorkspace)&&L.extUriBiasedIgnorePathCase.isEqual(n.openedWorkspace.configPath,p)||(0,R.isSingleFolderWorkspaceIdentifier)(n.openedWorkspace)&&L.extUriBiasedIgnorePathCase.isEqual(n.openedWorkspace.uri,p))return n}e.findWindowOnWorkspaceOrFolder=P;function r(w,p){var n,b;const I=y=>p.some(d=>L.extUriBiasedIgnorePathCase.isEqual(m.URI.file(d),m.URI.file(y)));for(const y of w)if((b=(n=y.config)===null||n===void 0?void 0:n.extensionDevelopmentPath)===null||b===void 0?void 0:b.some(d=>I(d)))return y}e.findWindowOnExtensionDevelopmentPath=r}),define(Q[213],J([0,1,14,2,3,15,7,16,17,6,38,34,29]),function(j,e,m,R,L,S,P,r,w,p,n,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let y=class vt extends R.Disposable{constructor(u,l,c,t,i){super();this.windowsMainService=u,this.stateMainService=l,this.lifecycleMainService=c,this.logService=t,this.configurationService=i,this._state=d(this.stateMainService.getItem(vt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){m.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(i=>!i.isExtensionDevelopmentHost)),t&&(u.lastActiveWindow=this.toWindowState(t))}const l=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);l&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(l)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const c=M(u);this.stateMainService.setItem(vt.windowsStateStorageKey,c),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",c)}onBeforeCloseWindow(u){if(!this.lifecycleMainService.quitRequested){const l=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=l:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(c=>{var t;const i=(0,I.isWorkspaceIdentifier)(u.openedWorkspace)&&((t=c.workspace)===null||t===void 0?void 0:t.id)===u.openedWorkspace.id,s=(0,I.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&c.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(c.folderUri,u.openedWorkspace.uri);(i||s)&&(c.uiState=l.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=l)}}toWindowState(u){return{workspace:(0,I.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,I.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const l=this.doGetNewWindowState(u),c=this.configurationService.getValue("window");let t;return l.hasDefaultState?t=!!((c==null?void 0:c.newWindowDimensions)&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):(t=!!(this.lifecycleMainService.wasRestarted||(c==null?void 0:c.restoreFullscreen)),t&&L.isMacintosh&&this.windowsMainService.getWindows().some(i=>i.isFullScreen)&&(t=!1)),l.mode===3&&!t&&(l.mode=1),l}doGetNewWindowState(u){const l=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const h=u.workspace;if((0,I.isWorkspaceIdentifier)(h)){const v=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===h.id).map(D=>D.uiState);if(v.length)return v[0]}if((0,I.isSingleFolderWorkspaceIdentifier)(h)){const v=this.state.openedWindows.filter(D=>D.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(D.folderUri,h.uri)).map(D=>D.uiState);if(v.length)return v[0]}else if(u.backupPath){const v=this.state.openedWindows.filter(D=>D.backupPath===u.backupPath).map(D=>D.uiState);if(v.length)return v[0]}const f=this.lastClosedState||this.state.lastActiveWindow;if(!l&&f)return f.uiState}let c;const t=m.screen.getAllDisplays();if(t.length===1)c=t[0];else{if(L.isMacintosh){const h=m.screen.getCursorScreenPoint();c=m.screen.getDisplayNearestPoint(h)}!c&&l&&(c=m.screen.getDisplayMatching(l.getBounds())),c||(c=m.screen.getPrimaryDisplay()||t[0])}let i=(0,b.defaultWindowState)();i.x=Math.round(c.bounds.x+c.bounds.width/2-i.width/2),i.y=Math.round(c.bounds.y+c.bounds.height/2-i.height/2);const s=this.configurationService.getValue("window");let a=!0;if(s==null?void 0:s.newWindowDimensions){if(s.newWindowDimensions==="maximized")i.mode=0,a=!1;else if(s.newWindowDimensions==="fullscreen")i.mode=3,a=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&l){const h=l.serializeWindowState();h.mode===3?i.mode=3:i=h,a=i.mode!==3&&s.newWindowDimensions==="offset"}}return a&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const l=this.windowsMainService.getWindows().map(c=>c.getBounds());for(;l.some(c=>c.x===u.x||c.y===u.y);)u.x+=30,u.y+=30;return u}};y.windowsStateStorageKey="windowsState",y=ue([ee(0,b.IWindowsMainService),ee(1,n.IStateMainService),ee(2,w.ILifecycleMainService),ee(3,p.ILogService),ee(4,r.IConfigurationService)],y),e.WindowsStateHandler=y;function d(o){const u={openedWindows:[]},l=o||{openedWindows:[]};return l.lastActiveWindow&&(u.lastActiveWindow=g(l.lastActiveWindow)),l.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=g(l.lastPluginDevelopmentHostWindow)),Array.isArray(l.openedWindows)&&(u.openedWindows=l.openedWindows.map(c=>g(c))),u}e.restoreWindowsState=d;function g(o){const u={uiState:o.uiState};return o.backupPath&&(u.backupPath=o.backupPath),o.remoteAuthority&&(u.remoteAuthority=o.remoteAuthority),o.folder&&(u.folderUri=P.URI.parse(o.folder)),o.workspaceIdentifier&&(u.workspace={id:o.workspaceIdentifier.id,configPath:P.URI.parse(o.workspaceIdentifier.configURIPath)}),u}function M(o){return{lastActiveWindow:o.lastActiveWindow&&E(o.lastActiveWindow),lastPluginDevelopmentHostWindow:o.lastPluginDevelopmentHostWindow&&E(o.lastPluginDevelopmentHostWindow),openedWindows:o.openedWindows.map(u=>E(u))}}e.getWindowsStateStoreData=M;function E(o){return{workspaceIdentifier:o.workspace&&{id:o.workspace.id,configURIPath:o.workspace.configPath.toString()},folder:o.folderUri&&o.folderUri.toString(),backupPath:o.backupPath,remoteAuthority:o.remoteAuthority,uiState:o.uiState}}}),define(Q[56],J([0,1,58,59,214,5,33,8,27,28,2,19,83,18,3]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(v){this.socket=v,this._errorListener=D=>{if(D){if(D.code==="EPIPE")return;(0,y.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(v){const D=T=>v(b.VSBuffer.wrap(T));return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(v){return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(v){return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(v){if(!this.socket.destroyed)try{this.socket.write(v.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,y.onUnexpectedError)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,y.onUnexpectedError)(D)}}end(){this.socket.end()}drain(){return new Promise((v,D)=>{if(this.socket.bufferSize===0){v();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),v()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=g;var M;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(M||(M={}));var E;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(E||(E={}));class o extends n.Disposable{constructor(v,D,T,W){super();this._onDidZlibFlush=this._register(new S.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=v,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=D,this._recordInflateBytes=W,D?(this._zlibInflate=L.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",$=>{console.error($),(0,y.onUnexpectedError)($),this._onClose.fire()}),this._zlibInflate.on("data",$=>{this._pendingInflateData.push($)}),T&&(this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=L.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",$=>{console.error($),(0,y.onUnexpectedError)($),this._onClose.fire()}),this._zlibDeflate.on("data",$=>{this._pendingDeflateData.push($)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new I.ChunkStream,this._register(this.socket.onData($=>this._acceptChunk($))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?b.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):b.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this._onData.event(v)}onClose(v){return this._onClose.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){this._totalOutgoingDataBytes+=v.byteLength,this._zlibDeflate?(this._zlibDeflate.write(v.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let D=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,D=D.slice(0,D.length-4),this._isEnded||this._write(b.VSBuffer.wrap(D),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(v,!1)}_write(v,D){let T=2;v.byteLength<126?T+=0:v.byteLength<2**16?T+=2:T+=8;const W=b.VSBuffer.alloc(T);if(D?W.writeUInt8(194,0):W.writeUInt8(130,0),v.byteLength<126)W.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){W.writeUInt8(126,1);let $=1;W.writeUInt8(v.byteLength>>>8&255,++$),W.writeUInt8(v.byteLength>>>0&255,++$)}else{W.writeUInt8(127,1);let $=1;W.writeUInt8(0,++$),W.writeUInt8(0,++$),W.writeUInt8(0,++$),W.writeUInt8(0,++$),W.writeUInt8(v.byteLength>>>24&255,++$),W.writeUInt8(v.byteLength>>>16&255,++$),W.writeUInt8(v.byteLength>>>8&255,++$),W.writeUInt8(v.byteLength>>>0&255,++$)}this._totalOutgoingWireBytes+=W.byteLength+v.byteLength,this.socket.write(b.VSBuffer.concat([W,v]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(v){if(v.byteLength!==0){for(this._totalIncomingWireBytes+=v.byteLength,this._incomingData.acceptChunk(v);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const D=this._incomingData.peek(this._state.readLen),W=(D.readUInt8(0)&128)>>>7,$=D.readUInt8(1),X=($&128)>>>7,x=$&127;this._state.state=2,this._state.readLen=2+(X?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=W,this._state.mask=0}else if(this._state.state===2){const D=this._incomingData.read(this._state.readLen),T=D.readUInt8(1),W=(T&128)>>>7;let $=T&127,X=1;$===126?$=D.readUInt8(++X)*2**8+D.readUInt8(++X):$===127&&($=D.readUInt8(++X)*0+D.readUInt8(++X)*0+D.readUInt8(++X)*0+D.readUInt8(++X)*0+D.readUInt8(++X)*2**24+D.readUInt8(++X)*2**16+D.readUInt8(++X)*2**8+D.readUInt8(++X));let x=0;W&&(x=D.readUInt8(++X)*2**24+D.readUInt8(++X)*2**16+D.readUInt8(++X)*2**8+D.readUInt8(++X)),this._state.state=3,this._state.readLen=$,this._state.mask=x}else if(this._state.state===3){const D=this._incomingData.read(this._state.readLen);u(D,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(D.buffer)),this._zlibInflate.write(D.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const T=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=T.length,this._onData.fire(b.VSBuffer.wrap(T))})):(this._totalIncomingDataBytes+=D.byteLength,this._onData.fire(D))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await S.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=o;function u(f,v){if(v!==0){let D=f.byteLength>>>2;for(let oe=0;oe<D;oe++){const q=f.readUInt32BE(oe*4);f.writeUInt32BE(q^v,oe*4)}let T=D*4,W=f.byteLength-T;const $=v>>>24&255,X=v>>>16&255,x=v>>>8&255;W>=1&&f.writeUInt8(f.readUInt8(T)^$,T),W>=2&&f.writeUInt8(f.readUInt8(T+1)^X,T+1),W>=3&&f.writeUInt8(f.readUInt8(T+2)^x,T+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function c(){const f=(0,p.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let v;return e.XDG_RUNTIME_DIR?v=(0,r.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):v=(0,r.join)((0,w.tmpdir)(),`vscode-ipc-${f}.sock`),i(v),v}e.createRandomIPCHandle=c;function t(f,v,D){const T=(0,m.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${D}-${v}-sock`;let W;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?W=(0,r.join)(e.XDG_RUNTIME_DIR,`vscode-${T.substr(0,8)}-${D}-${v}.sock`):W=(0,r.join)(f,`${D}-${v}.sock`),i(W),W}e.createStaticIPCHandle=t;function i(f){const v=l[d.platform];typeof v=="number"&&f.length>=v&&console.warn(`WARNING: IPC handle "${f}" is longer than ${v} chars, try a shorter --user-data-dir`)}class s extends P.IPCServer{constructor(v){super(s.toClientConnectionEvent(v));this.server=v}static toClientConnectionEvent(v){const D=S.Event.fromNodeEventEmitter(v,"connection");return S.Event.map(D,T=>({protocol:new I.Protocol(new g(T)),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(T,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function a(f){return new Promise((v,D)=>{const T=(0,R.createServer)();T.on("error",D),T.listen(f,()=>{T.removeListener("error",D),v(new s(T))})})}e.serve=a;function h(f,v){return new Promise((D,T)=>{const W=(0,R.createConnection)(f,()=>{W.removeListener("error",T),D(I.Client.fromSocket(new g(W),v))});W.once("error",T)})}e.connect=h}),define(Q[215],J([0,1,56]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class R{constructor(w){this.driver=w}listen(w,p){throw new Error("No event found")}call(w,p,n){switch(p){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(n);case"reloadWindow":return this.driver.reloadWindow(n);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(n[0],n[1]);case"click":return this.driver.click(n[0],n[1],n[2],n[3]);case"doubleClick":return this.driver.doubleClick(n[0],n[1]);case"setValue":return this.driver.setValue(n[0],n[1],n[2]);case"getTitle":return this.driver.getTitle(n[0]);case"isActiveElement":return this.driver.isActiveElement(n[0],n[1]);case"getElements":return this.driver.getElements(n[0],n[1],n[2]);case"getElementXY":return this.driver.getElementXY(n[0],n[1],n[2]);case"typeInEditor":return this.driver.typeInEditor(n[0],n[1],n[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(n[0],n[1]);case"writeInTerminal":return this.driver.writeInTerminal(n[0],n[1],n[2])}throw new Error(`Call not found: ${p}`)}}e.DriverChannel=R;class L{constructor(w){this.channel=w}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(w){return this.channel.call("capturePage",w)}reloadWindow(w){return this.channel.call("reloadWindow",w)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(w,p){return this.channel.call("dispatchKeybinding",[w,p])}click(w,p,n,b){return this.channel.call("click",[w,p,n,b])}doubleClick(w,p){return this.channel.call("doubleClick",[w,p])}setValue(w,p,n){return this.channel.call("setValue",[w,p,n])}getTitle(w){return this.channel.call("getTitle",[w])}isActiveElement(w,p){return this.channel.call("isActiveElement",[w,p])}getElements(w,p,n){return this.channel.call("getElements",[w,p,n])}getElementXY(w,p,n,b){return this.channel.call("getElementXY",[w,p,n,b])}typeInEditor(w,p,n){return this.channel.call("typeInEditor",[w,p,n])}getTerminalBuffer(w,p){return this.channel.call("getTerminalBuffer",[w,p])}writeInTerminal(w,p,n){return this.channel.call("writeInTerminal",[w,p,n])}}e.DriverChannelClient=L;class S{constructor(w){this.registry=w}listen(w,p){throw new Error(`Event not found: ${p}`)}call(w,p,n){switch(p){case"registerWindowDriver":return this.registry.registerWindowDriver(n);case"reloadWindowDriver":return this.registry.reloadWindowDriver(n)}throw new Error(`Call not found: ${p}`)}}e.WindowDriverRegistryChannel=S;async function P(r){const w=await(0,m.connect)(r,"driverClient"),p=w.getChannel("driver"),n=new L(p);return{client:w,driver:n}}e.connect=P}),define(Q[25],J([0,1,8,46,4,53,159,56]),function(j,e,m,R,L,S,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,L.refineServiceDecorator)(S.IEnvironmentService);class w extends P.NativeEnvironmentService{get cachedLanguagesPath(){return(0,m.join)(this.userDataPath,"clp")}get backupHome(){return(0,m.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,m.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,r.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get nodeCachedDataDir(){return process.env.VSCODE_NODE_CACHED_DATA_DIR||void 0}get chromeCachedDataDir(){return(0,m.join)(this.userDataPath,"Code Cache")}}ue([R.memoize],w.prototype,"cachedLanguagesPath",null),ue([R.memoize],w.prototype,"backupHome",null),ue([R.memoize],w.prototype,"backupWorkspacesPath",null),ue([R.memoize],w.prototype,"mainIPCHandle",null),ue([R.memoize],w.prototype,"sandbox",null),ue([R.memoize],w.prototype,"driverVerbose",null),ue([R.memoize],w.prototype,"disableUpdates",null),ue([R.memoize],w.prototype,"disableKeytar",null),ue([R.memoize],w.prototype,"nodeCachedDataDir",null),ue([R.memoize],w.prototype,"chromeCachedDataDir",null),e.EnvironmentMainService=w}),define(Q[216],J([0,1,24,58,8,3,20,50,25,16,21,6,29,7,30,10,15]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let E=class{constructor(u,l,c){this.configurationService=l,this.logService=c,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=M.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,i)=>(0,d.isEqual)(t,i,!S.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await m.promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){u=Object.create(null)}u.emptyWorkspaceInfos&&(this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos));let l=[];try{Array.isArray(u.rootURIWorkspaces)&&(l=u.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:y.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(l);let c=[];try{Array.isArray(u.folderURIWorkspaces)&&(c=u.folderURIWorkspaces.map(t=>y.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(c),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==n.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===n.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){var u;const l=this.configurationService.getValue();return((u=l==null?void 0:l.files)===null||u===void 0?void 0:u.hotExit)||n.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,l){this.workspaces.some(t=>u.workspace.id===t.workspace.id)||(this.workspaces.push(u),this.saveSync());const c=this.getBackupPath(u.workspace.id);return l&&this.moveBackupFolderSync(c,l),c}moveBackupFolderSync(u,l){if(m.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),m.existsSync(l))try{m.renameSync(l,u)}catch(c){this.logService.error(`Backup: Could not move backup folder to new location: ${c.toString()}`)}}unregisterWorkspaceBackupSync(u){const l=u.id,c=this.workspaces.findIndex(t=>t.workspace.id===l);c!==-1&&(this.workspaces.splice(c,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(l=>this.backupUriComparer.isEqual(u,l))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const l=this.folders.findIndex(c=>this.backupUriComparer.isEqual(u,c));l!==-1&&(this.folders.splice(l,1),this.saveSync())}registerEmptyWindowBackupSync(u,l){const c=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,c))||(this.emptyWindows.push({backupFolder:c,remoteAuthority:l}),this.saveSync()),this.getBackupPath(c)}unregisterEmptyWindowBackupSync(u){const l=this.emptyWindows.findIndex(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,u));l!==-1&&(this.emptyWindows.splice(l,1),this.saveSync())}getBackupPath(u){return(0,L.join)(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const l=new Set,c=[];for(let t of u){const i=t.workspace;if(!(0,I.isWorkspaceIdentifier)(i))return[];if(!l.has(i.id)){l.add(i.id);const s=this.getBackupPath(i.id);await this.doHasBackups(s)?i.configPath.scheme!==g.Schemas.file||await(0,P.exists)(i.configPath.fsPath)?c.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return c}async validateFolders(u){if(!Array.isArray(u))return[];const l=[],c=new Set;for(let t of u){const i=this.backupUriComparer.getComparisonKey(t);if(!c.has(i)){c.add(i);const s=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(s)?t.scheme!==g.Schemas.file||await(0,P.exists)(t.fsPath)?l.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return l}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const l=[],c=new Set;for(let t of u){const i=t.backupFolder;if(typeof i!="string")return[];if(!c.has(i)){c.add(i);const s=this.getBackupPath(i);await this.doHasBackups(s)?l.push(t):await this.deleteStaleBackup(s)}}return l}async deleteStaleBackup(u){try{await(0,P.exists)(u)&&await(0,P.rimraf)(u,P.RimRafMode.MOVE)}catch(l){this.logService.error(`Backup: Could not delete stale backup: ${l.toString()}`)}}async convertToEmptyWindowBackup(u){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,l));)l=this.getRandomEmptyWindowId();const c=this.getBackupPath(l);try{await m.promises.rename(u,c)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}convertToEmptyWindowBackupSync(u){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,l));)l=this.getRandomEmptyWindowId();const c=this.getBackupPath(l);try{m.renameSync(u,c)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}async getDirtyWorkspaces(){const u=[];for(const l of this.workspaces)await this.hasBackups(l)&&u.push(l.workspace);for(const l of this.folders)await this.hasBackups(l)&&u.push(l);return u}hasBackups(u){let l;return y.URI.isUri(u)?l=this.getBackupPath(this.getFolderHash(u)):(0,r.isWorkspaceBackupInfo)(u)?l=this.getBackupPath(u.workspace.id):l=u.backupFolder,this.doHasBackups(l)}async doHasBackups(u){try{const l=await(0,P.readdir)(u);for(const c of l)try{if((await(0,P.readdir)((0,L.join)(u,c))).length>0)return!0}catch(t){}}catch(l){}return!1}saveSync(){try{(0,P.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await(0,P.writeFile)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderURIWorkspaces:this.folders.map(u=>u.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){let l;return u.scheme===g.Schemas.file?l=S.isLinux?u.fsPath:u.fsPath.toLowerCase():l=u.toString().toLowerCase(),(0,R.createHash)("md5").update(l).digest("hex")}};E=ue([ee(0,w.IEnvironmentMainService),ee(1,p.IConfigurationService),ee(2,b.ILogService)],E),e.BackupMainService=E}),define(Q[41],J([0,1,5,34,14,17,3,25,51,20,7,31,4,27,66,6,8,22,46,2,60]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d,g,M,E,o,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,I.createDecorator)("nativeHostMainService");let c=class ht extends u.Disposable{constructor(i,s,a,h,f,v,D,T,W){super();this.sharedProcess=i,this.windowsMainService=s,this.dialogMainService=a,this.lifecycleMainService=h,this.environmentMainService=f,this.telemetryService=v,this.logService=D,this.productService=T,this.themeMainService=W,this.onDidOpenWindow=m.Event.map(this.windowsMainService.onDidOpenWindow,$=>$.id),this.onDidMaximizeWindow=m.Event.filter(m.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",($,X)=>X.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidUnmaximizeWindow=m.Event.filter(m.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",($,X)=>X.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidBlurWindow=m.Event.filter(m.Event.fromNodeEventEmitter(L.app,"browser-window-blur",($,X)=>X.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidFocusWindow=m.Event.any(m.Event.map(m.Event.filter(m.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),$=>!!$),$=>$.id),m.Event.filter(m.Event.fromNodeEventEmitter(L.app,"browser-window-focus",($,X)=>X.id),$=>!!this.windowsMainService.getWindowById($))),this.onDidResumeOS=m.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new m.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new m.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=m.Event.debounce(m.Event.any(m.Event.filter(m.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",($,X,x)=>x),$=>!(Array.isArray($)&&$.length===1&&$[0]==="workArea")),m.Event.fromNodeEventEmitter(L.screen,"display-added"),m.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(s=>{var a,h;return{id:s.id,workspace:s.openedWorkspace,title:(h=(a=s.win)===null||a===void 0?void 0:a.getTitle())!==null&&h!==void 0?h:"",filename:s.getRepresentedFilename(),dirty:s.isDocumentEdited()}})}async getWindowCount(i){return this.windowsMainService.getWindowCount()}async getActiveWindowId(i){const s=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(s)return s.id}openWindow(i,s,a){return Array.isArray(s)?this.doOpenWindow(i,s,a):this.doOpenEmptyWindow(i,s)}async doOpenWindow(i,s,a=Object.create(null)){s.length>0&&this.windowsMainService.open({context:5,contextWindowId:i,urisToOpen:s,cli:this.environmentMainService.args,forceNewWindow:a.forceNewWindow,forceReuseWindow:a.forceReuseWindow,preferNewWindow:a.preferNewWindow,diffMode:a.diffMode,addMode:a.addMode,gotoLineMode:a.gotoLineMode,noRecentEntry:a.noRecentEntry,waitMarkerFileURI:a.waitMarkerFileURI,remoteAuthority:a.remoteAuthority||void 0})}async doOpenEmptyWindow(i,s){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:i},s)}async toggleFullScreen(i){const s=this.windowById(i);s&&s.toggleFullScreen()}async handleTitleDoubleClick(i){const s=this.windowById(i);s&&s.handleTitleDoubleClick()}async isMaximized(i){const s=this.windowById(i);return(s==null?void 0:s.win)?s.win.isMaximized():!1}async maximizeWindow(i){const s=this.windowById(i);(s==null?void 0:s.win)&&s.win.maximize()}async unmaximizeWindow(i){const s=this.windowById(i);(s==null?void 0:s.win)&&s.win.unmaximize()}async minimizeWindow(i){const s=this.windowById(i);(s==null?void 0:s.win)&&s.win.minimize()}async focusWindow(i,s){var a;s&&typeof s.windowId=="number"&&(i=s.windowId);const h=this.windowById(i);h&&h.focus({force:(a=s==null?void 0:s.force)!==null&&a!==void 0?a:!1})}async setMinimumSize(i,s,a){const h=this.windowById(i);if(h==null?void 0:h.win){const[f,v]=h.win.getSize(),[D,T]=h.win.getMinimumSize(),[W,$]=[s!=null?s:D,a!=null?a:T],[X,x]=[Math.max(f,W),Math.max(v,$)];(D!==W||T!==$)&&h.win.setMinimumSize(W,$),(f!==X||v!==x)&&h.win.setSize(X,x)}}async saveWindowSplash(i,s){this.themeMainService.saveWindowSplash(i,s)}async showMessageBox(i,s){return this.dialogMainService.showMessageBox(s,this.toBrowserWindow(i))}async showSaveDialog(i,s){return this.dialogMainService.showSaveDialog(s,this.toBrowserWindow(i))}async showOpenDialog(i,s){return this.dialogMainService.showOpenDialog(s,this.toBrowserWindow(i))}toBrowserWindow(i){const s=this.windowById(i);if(s==null?void 0:s.win)return s.win}async pickFileFolderAndOpen(i,s){const a=await this.dialogMainService.pickFileFolder(s);a&&(this.sendPickerTelemetry(a,s.telemetryEventName||"openFileFolder",s.telemetryExtraData),this.doOpenPicked(await Promise.all(a.map(async h=>await p.SymlinkSupport.existsDirectory(h)?{folderUri:n.URI.file(h)}:{fileUri:n.URI.file(h)})),s,i))}async pickFolderAndOpen(i,s){const a=await this.dialogMainService.pickFolder(s);a&&(this.sendPickerTelemetry(a,s.telemetryEventName||"openFolder",s.telemetryExtraData),this.doOpenPicked(a.map(h=>({folderUri:n.URI.file(h)})),s,i))}async pickFileAndOpen(i,s){const a=await this.dialogMainService.pickFile(s);a&&(this.sendPickerTelemetry(a,s.telemetryEventName||"openFile",s.telemetryExtraData),this.doOpenPicked(a.map(h=>({fileUri:n.URI.file(h)})),s,i))}async pickWorkspaceAndOpen(i,s){const a=await this.dialogMainService.pickWorkspace(s);a&&(this.sendPickerTelemetry(a,s.telemetryEventName||"openWorkspace",s.telemetryExtraData),this.doOpenPicked(a.map(h=>({workspaceUri:n.URI.file(h)})),s,i))}doOpenPicked(i,s,a){this.windowsMainService.open({context:3,contextWindowId:a,cli:this.environmentMainService.args,urisToOpen:i,forceNewWindow:s.forceNewWindow})}sendPickerTelemetry(i,s,a){const h=i?i.length:0;this.telemetryService.publicLog(s,Object.assign(Object.assign({},a),{outcome:h?"success":"canceled",numberOfPaths:h}))}async showItemInFolder(i,s){L.shell.showItemInFolder(s)}async setRepresentedFilename(i,s){const a=this.windowById(i);a&&a.setRepresentedFilename(s)}async setDocumentEdited(i,s){const a=this.windowById(i);a&&a.setDocumentEdited(s)}async openExternal(i,s){return P.isLinuxSnap?this.safeSnapOpenExternal(s):L.shell.openExternal(s),!0}safeSnapOpenExternal(i){const s=process.env.GDK_PIXBUF_MODULE_FILE,a=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(i),process.env.GDK_PIXBUF_MODULE_FILE=s,process.env.GDK_PIXBUF_MODULEDIR=a}moveItemToTrash(i,s){return L.shell.trashItem(s)}async isAdmin(){let i;return P.isWindows?i=(await new Promise((s,a)=>{j(["native-is-elevated"],s,a)}))():i=process.getuid()===0,i}async writeElevated(i,s,a,h){const f=await new Promise((v,D)=>{j(["sudo-prompt"],v,D)});return new Promise((v,D)=>{const T=[`"${this.cliPath}"`];(h==null?void 0:h.unlock)&&T.push("--file-chmod"),T.push("--file-write",`"${s.fsPath}"`,`"${a.fsPath}"`);const W={name:this.productService.nameLong.replace("-",""),icns:P.isMacintosh&&this.environmentMainService.isBuilt?(0,M.join)((0,M.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};f.exec(T.join(" "),W,($,X,x)=>{X&&this.logService.trace(`[sudo-prompt] received stdout: ${X}`),x&&this.logService.trace(`[sudo-prompt] received stderr: ${x}`),$?D($):v(void 0)})})}get cliPath(){return P.isWindows?this.environmentMainService.isBuilt?(0,M.join)((0,M.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,M.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):P.isLinux?this.environmentMainService.isBuilt?(0,M.join)((0,M.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,M.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,M.join)(this.environmentMainService.appRoot,"bin","code"):(0,M.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,y.totalmem)(),freemem:(0,y.freemem)(),loadavg:(0,y.loadavg)()}}async getOSProperties(){return{arch:(0,y.arch)(),platform:(0,y.platform)(),release:(0,y.release)(),type:(0,y.type)(),cpus:(0,y.cpus)()}}async getOSVirtualMachineHint(){return d.virtualMachineHint.value()}async killProcess(i,s,a){process.kill(s,a)}async readClipboardText(i,s){return L.clipboard.readText(s)}async writeClipboardText(i,s,a){return L.clipboard.writeText(s,a)}async readClipboardFindText(i){return L.clipboard.readFindText()}async writeClipboardFindText(i,s){return L.clipboard.writeFindText(s)}async writeClipboardBuffer(i,s,a,h){return L.clipboard.writeBuffer(s,Buffer.from(a),h)}async readClipboardBuffer(i,s){return L.clipboard.readBuffer(s)}async hasClipboard(i,s,a){return L.clipboard.has(s,a)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(i,s){const a=this.windowById(i);a&&a.updateTouchBar(s)}async notifyReady(i){const s=this.windowById(i);s&&s.setReady()}async relaunch(i,s){return this.lifecycleMainService.relaunch(s)}async reload(i,s){const a=this.windowById(i);if(a)return this.lifecycleMainService.reload(a,(s==null?void 0:s.disableExtensions)!==void 0?{_:[],"disable-extensions":s==null?void 0:s.disableExtensions}:void 0)}async closeWindow(i){this.closeWindowById(i,i)}async closeWindowById(i,s){const a=this.windowById(s);if(a==null?void 0:a.win)return a.win.close()}async quit(i){const s=this.windowsMainService.getLastActiveWindow();(s==null?void 0:s.isExtensionDevelopmentHost)&&this.windowsMainService.getWindowCount()>1&&s.win?s.win.close():this.lifecycleMainService.quit()}async exit(i,s){await this.lifecycleMainService.kill(s)}async resolveProxy(i,s){var a,h;const f=this.windowById(i),v=(h=(a=f==null?void 0:f.win)===null||a===void 0?void 0:a.webContents)===null||h===void 0?void 0:h.session;if(v)return v.resolveProxy(s)}async openDevTools(i,s){const a=this.windowById(i);(a==null?void 0:a.win)&&a.win.webContents.openDevTools(s)}async toggleDevTools(i){const s=this.windowById(i);(s==null?void 0:s.win)&&s.win.webContents.toggleDevTools()}async sendInputEvent(i,s){const a=this.windowById(i);(a==null?void 0:a.win)&&(s.type==="mouseDown"||s.type==="mouseUp")&&a.win.webContents.sendInputEvent(s)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(i,s,a,h){if(!!P.isWindows){const f=await new Promise((v,D)=>{j(["vscode-windows-registry"],v,D)});try{return f.GetStringRegKey(s,a,h)}catch(v){return}}}async getPassword(i,s,a){const h=await this.withKeytar(),f=await h.getPassword(s,a);if(f)try{let{content:v,hasNextChunk:D}=JSON.parse(f);if(!v||!D)return f;let T=1;for(;D;){const W=await h.getPassword(s,`${a}-${T}`),$=JSON.parse(W);v+=$.content,D=$.hasNextChunk}return v}catch(v){return f}return f}async setPassword(i,s,a,h){const f=await this.withKeytar();if(P.isWindows&&h.length>ht.MAX_PASSWORD_LENGTH){let v=0,D=0,T=!0;for(;T;){const W=h.substring(v,v+ht.PASSWORD_CHUNK_SIZE);v+=ht.PASSWORD_CHUNK_SIZE,T=h.length-v>0;const $={content:W,hasNextChunk:T};await f.setPassword(s,D?`${a}-${D}`:a,JSON.stringify($)),D++}}else await f.setPassword(s,a,h);this._onDidChangePassword.fire({service:s,account:a})}async deletePassword(i,s,a){const f=await(await this.withKeytar()).deletePassword(s,a);return f&&this._onDidChangePassword.fire({service:s,account:a}),f}async findPassword(i,s){return(await this.withKeytar()).findPassword(s)}async findCredentials(i,s){return(await this.withKeytar()).findCredentials(s)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((i,s)=>{j(["keytar"],i,s)})}windowById(i){if(typeof i=="number")return this.windowsMainService.getWindowById(i)}};c.MAX_PASSWORD_LENGTH=2500,c.PASSWORD_CHUNK_SIZE=c.MAX_PASSWORD_LENGTH-100,ue([o.memoize],c.prototype,"cliPath",null),c=ue([ee(1,R.IWindowsMainService),ee(2,w.IDialogMainService),ee(3,S.ILifecycleMainService),ee(4,r.IEnvironmentMainService),ee(5,b.ITelemetryService),ee(6,g.ILogService),ee(7,E.IProductService),ee(8,l.IThemeMainService)],c),e.NativeHostMainService=c}),define(Q[217],J([0,1,2,5,80,14,6,34,41,88,28,22,26]),function(j,e,m,R,L,S,P,r,w,p,n,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var y;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let d=class extends m.Disposable{constructor(M,E,o,u,l){super();this.logService=M,this.windowsMainService=E,this.nativeHostMainService=o,this.encryptionMainService=u,this.productService=l,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=y.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const M=R.Event.fromNodeEventEmitter(S.app,"login",(E,o,u,l,c)=>({event:E,webContents:o,req:u,authInfo:l,callback:c}));this._register(M(this.onLogin,this))}async onLogin({event:M,authInfo:E,req:o,callback:u}){if(!!E.isProxy){if(!this.pendingProxyResolve&&this.state===y.LoginDialogShown&&o.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}M.preventDefault();let l;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),l=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(E);try{l=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}u(l==null?void 0:l.username,l==null?void 0:l.password)}}async resolveProxyCredentials(M){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const E=await this.doResolveProxyCredentials(M);if(E)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),E;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(M){var E,o,u,l;this.logService.trace("auth#doResolveProxyCredentials - enter",M);const c=String((0,L.hash)({scheme:M.scheme,host:M.host,port:M.port}));let t,i;try{const f=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,c);if(f){const v=JSON.parse(await this.encryptionMainService.decrypt(f));t=v.username,i=v.password}}catch(f){this.logService.error(f)}if(this.state!==y.StoredCredentialsUsed&&typeof t=="string"&&typeof i=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=y.StoredCredentialsUsed,{username:t,password:i};const s=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!s){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${s.id} to handle proxy login`);const a={authInfo:M,username:(o=(E=this.sessionCredentials)===null||E===void 0?void 0:E.username)!==null&&o!==void 0?o:t,password:(l=(u=this.sessionCredentials)===null||u===void 0?void 0:u.password)!==null&&l!==void 0?l:i,replyChannel:`vscode:proxyAuthResponse:${(0,n.generateUuid)()}`};s.sendWhenReady("vscode:openProxyAuthenticationDialog",I.CancellationToken.None,a),this.state=y.LoginDialogShown;const h=await new Promise(f=>{var v;const D=async(T,W,$)=>{var X;if(W===a.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${s.id}`),(X=s.win)===null||X===void 0||X.webContents.off("ipc-message",D),$){const x={username:$.username,password:$.password};try{if($.remember){const oe=await this.encryptionMainService.encrypt(JSON.stringify(x));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,c,oe)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,c)}catch(oe){this.logService.error(oe)}f({username:x.username,password:x.password})}else f(void 0)};(v=s.win)===null||v===void 0||v.webContents.on("ipc-message",D)});return this.sessionCredentials=h,h}};d=ue([ee(0,P.ILogService),ee(1,r.IWindowsMainService),ee(2,w.INativeHostMainService),ee(3,p.IEncryptionMainService),ee(4,b.IProductService)],d),e.ProxyAuthHandler=d}),define(Q[218],J([0,1,215,154,34,56,2,33,57,174,3,5,79,105,9,17,41]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function E(l){return l<21}let o=class{constructor(c,t,i,s,a){this.windowServer=c,this.options=t,this.windowsMainService=i,this.lifecycleMainService=s,this.nativeHostMainService=a,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new b.Emitter}async registerWindowDriver(c){return this.registeredWindowIds.add(c),this.reloadingWindowIds.delete(c),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(c){this.reloadingWindowIds.add(c)}async getWindowIds(){return this.windowsMainService.getWindows().map(c=>c.id).filter(c=>this.registeredWindowIds.has(c)&&!this.reloadingWindowIds.has(c))}async capturePage(c){await this.whenUnfrozen(c);const t=this.windowsMainService.getWindowById(c);if(!(t==null?void 0:t.win))throw new Error("Invalid window");return(await t.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(c){await this.whenUnfrozen(c);const t=this.windowsMainService.getWindowById(c);if(!t)throw new Error("Invalid window");this.reloadingWindowIds.add(c),this.lifecycleMainService.reload(t)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(c,t){await this.whenUnfrozen(c);const i=y.KeybindingParser.parseUserBinding(t);for(let s of i)await this._dispatchKeybinding(c,s)}async _dispatchKeybinding(c,t){if(t instanceof I.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const i=this.windowsMainService.getWindowById(c);if(!(i==null?void 0:i.win))throw new Error("Invalid window");const s=i.win.webContents,a=new w.SimpleKeybinding(!1,!1,!1,!1,t.keyCode),f=new p.USLayoutResolvedKeybinding(a.toChord(),n.OS).getElectronAccelerator(),v=[];t.ctrlKey&&v.push("ctrl"),t.metaKey&&v.push("meta"),t.shiftKey&&v.push("shift"),t.altKey&&v.push("alt"),s.sendInputEvent({type:"keyDown",keyCode:f,modifiers:v}),E(t.keyCode)||s.sendInputEvent({type:"char",keyCode:f,modifiers:v}),s.sendInputEvent({type:"keyUp",keyCode:f,modifiers:v}),await(0,d.timeout)(100)}async click(c,t,i,s){await(await this.getWindowDriver(c)).click(t,i,s)}async doubleClick(c,t){await(await this.getWindowDriver(c)).doubleClick(t)}async setValue(c,t,i){await(await this.getWindowDriver(c)).setValue(t,i)}async getTitle(c){return await(await this.getWindowDriver(c)).getTitle()}async isActiveElement(c,t){return await(await this.getWindowDriver(c)).isActiveElement(t)}async getElements(c,t,i){return await(await this.getWindowDriver(c)).getElements(t,i)}async getElementXY(c,t,i,s){return await(await this.getWindowDriver(c)).getElementXY(t,i,s)}async typeInEditor(c,t,i){await(await this.getWindowDriver(c)).typeInEditor(t,i)}async getTerminalBuffer(c,t){return await(await this.getWindowDriver(c)).getTerminalBuffer(t)}async writeInTerminal(c,t,i){await(await this.getWindowDriver(c)).writeInTerminal(t,i)}async getWindowDriver(c){await this.whenUnfrozen(c);const t=`window:${c}`,i=new r.StaticRouter(a=>a===t),s=this.windowServer.getChannel("windowDriver",i);return new R.WindowDriverChannelClient(s)}async whenUnfrozen(c){for(;this.reloadingWindowIds.has(c);)await b.Event.toPromise(this.onDidReloadingChange.event)}};o=ue([ee(2,L.IWindowsMainService),ee(3,g.ILifecycleMainService),ee(4,M.INativeHostMainService)],o),e.Driver=o;async function u(l,c,t,i){const s=t.driverVerbose,a=i.createInstance(o,l,{verbose:s}),h=new m.WindowDriverRegistryChannel(a);l.registerChannel("windowDriverRegistry",h);const f=await(0,S.serve)(c),v=new m.DriverChannel(a);return f.registerChannel("driver",v),(0,P.combinedDisposable)(f,l)}e.serve=u}),define(Q[219],J([0,1,59,56]),function(j,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,S,P,r){const w=n=>r(n,void 0),p=m.createConnection({host:L,port:S},()=>{p.removeListener("error",w);const n=Buffer.alloc(16);for(let d=0;d<16;d++)n[d]=Math.round(Math.random()*256);const b=n.toString("base64");let I=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${S}/?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${b}`];p.write(I.join(`\r
`)+`\r
\r
`);const y=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(p.off("data",y),r(void 0,new R.NodeSocket(p)))};p.on("data",y)});p.once("error",w)}}}),define(Q[220],J([0,1,59,9,2,115,6,22,189,74,219,75]),function(j,e,m,R,L,S,P,r,w,p,n,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function I(M,E,o,u){return new y(M,E,o,u).waitForReady()}class y extends L.Disposable{constructor(E,o,u,l){super();this.suggestedLocalPort=l,this.public=!1,this._socketsDispose=new Map,this._options=E,this._server=m.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=c=>this._onConnection(c),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=u,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(o=>{o()})}async waitForReady(){var E;let o=await(0,S.findFreePortFaster)((E=this.suggestedLocalPort)!==null&&E!==void 0?E:this.tunnelRemotePort,2,1e3),u=null;return u=this._server.listen(o).address(),u||(o=0,u=this._server.listen(o).address()),this.tunnelLocalPort=u.port,await this._barrier.wait(),this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async _onConnection(E){E.pause();const o=await(0,w.connectRemoteAgentTunnel)(this._options,this.tunnelRemotePort),u=o.getSocket().socket,l=o.readEntireBuffer();o.dispose(),l.byteLength>0&&E.write(l.buffer),E.on("end",()=>{this._socketsDispose.delete(E.localAddress),u.end()}),E.on("close",()=>u.end()),E.on("error",()=>{this._socketsDispose.delete(E.localAddress),u.destroy()}),u.on("end",()=>E.end()),u.on("close",()=>E.end()),u.on("error",()=>{E.destroy()}),E.pipe(u),u.pipe(E),this._socketsDispose.set(E.localAddress,()=>{E.end(),u.end()})}}let d=class extends p.AbstractTunnelService{constructor(E,o,u,l){super(o);this.socketFactory=E,this.signService=u,this.productService=l}retainOrCreateTunnel(E,o,u,l,c,t){const i=this.getTunnelFromMap(o,u);if(i)return++i.refcount,i.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,o,u,l,c,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${u} on local port ${l}.`);const s={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:E,signService:this.signService,logService:this.logService,ipcLogger:null},a=I(s,o,u,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(o,u,a),a}}};d=ue([ee(1,P.ILogService),ee(2,b.ISignService),ee(3,r.IProductService)],d),e.BaseTunnelService=d;let g=class extends d{constructor(E,o,u){super(n.nodeSocketFactory,E,o,u)}};g=ue([ee(0,P.ILogService),ee(1,b.ISignService),ee(2,r.IProductService)],g),e.TunnelService=g}),define(Q[221],J([0,1,214,191,2,13,18,190,16,6,19,53,90]),function(j,e,m,R,L,S,P,r,w,p,n,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let y=class extends L.Disposable{constructor(g,M,E){super();this.environmentService=M,this.logService=E,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,M){this.logService.trace("RequestService#request",g.url);const{proxyUrl:E,strictSSL:o}=this,u=Object.assign(Object.assign({},process.env),await(0,I.resolveShellEnv)(this.logService,this.environmentService.args,process.env)),l=g.agent?g.agent:await(0,r.getProxyAgent)(g.url||"",u,{proxyUrl:E,strictSSL:o});return g.agent=l,g.strictSSL=o,this.authorization&&(g.headers=Object.assign(Object.assign({},g.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(g,M)}async getNodeRequest(g){return((0,R.parse)(g.url).protocol==="https:"?await new Promise((o,u)=>{j(["https"],o,u)}):await new Promise((o,u)=>{j(["http"],o,u)})).request}_request(g,M){return new Promise(async(E,o)=>{let u;const l=(0,R.parse)(g.url),c=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),t={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,S.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(t.auth=g.user+":"+g.password),u=c(t,i=>{const s=(0,S.isNumber)(g.followRedirects)?g.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)this._request(Object.assign(Object.assign({},g),{url:i.headers.location,followRedirects:s-1}),M).then(E,o);else{let a=i;i.headers["content-encoding"]==="gzip"&&(a=i.pipe((0,m.createGunzip)())),E({res:i,stream:(0,n.streamToBufferReadableStream)(a)})}}),u.on("error",o),g.timeout&&u.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&u.write(g.data),u.end(),M.onCancellationRequested(()=>{u.abort(),o((0,P.canceled)())})})}async resolveProxy(g){}};y=ue([ee(0,w.IConfigurationService),ee(1,b.INativeEnvironmentService),ee(2,p.ILogService)],y),e.RequestService=y}),define(Q[222],J([0,1,221,14]),function(j,e,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function L(P){return R.net.request}class S extends m.RequestService{request(r,w){return super.request(Object.assign(Object.assign({},r||{}),{getRawRequest:L}),w)}}e.RequestMainService=S}),define(Q[223],J([0,1,47,14,25,9,6,17,60,10,3,2,84,13,5,55]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let M=class extends b.Disposable{constructor(o,u,l,c,t,i,s){super();this.machineId=o,this.userEnv=u,this.environmentMainService=l,this.lifecycleMainService=c,this.logService=t,this.themeMainService=i,this.protocolMainService=s,this.firstWindowConnectionBarrier=new S.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new d.Emitter),this.onDidError=d.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),R.ipcMain.on("vscode:createSharedProcessMessageChannel",async(o,u)=>this.onWindowConnection(o,u))}async onWindowConnection(o,u){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const l=await this.connect();if(o.sender.isDestroyed())return l.close();o.sender.postMessage("vscode:createSharedProcessMessageChannelResult",u,[l])}onWillShutdown(){const o=this.window;!o||(!o.isDestroyed()&&!o.webContents.isDestroyed()&&o.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(o.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{o.close()}catch(u){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(o=>R.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),o()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(o=>R.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),o()}))})()),this._whenIpcReady}createWindow(){const o=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new R.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:p.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${o.resource.toString()}`],v8CacheOptions:n.browserCodeLoadingCacheStrategy,nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),o.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:m.default}),this.window.loadURL(p.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",j).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=o=>{var u;this.logService.trace("SharedProcess#close prevented"),o.preventDefault(),((u=this.window)===null||u===void 0?void 0:u.isVisible())&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(o,u)=>this._onDidError.fire({type:2,details:u})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1,details:"SharedProcess: detected unresponsive window"})),this.window.webContents.on("did-fail-load",(o,u,l)=>this._onDidError.fire({type:3,details:`SharedProcess: failed to load: ${l}`})))}async connect(){await this.whenIpcReady;const o=(0,y.assertIsDefined)(this.window);return(0,I.connect)(o)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){var o,u;return(u=(o=this.window)===null||o===void 0?void 0:o.isVisible())!==null&&u!==void 0?u:!1}};M=ue([ee(2,L.IEnvironmentMainService),ee(3,r.ILifecycleMainService),ee(4,P.ILogService),ee(5,w.IThemeMainService),ee(6,g.IProtocolMainService)],M),e.SharedProcess=M}),define(Q[224],J([0,1,7,8,13,6,25,9,21,19]),function(j,e,m,R,L,S,P,r,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class n{constructor(y,d,g){this.storagePath=y,this.logService=d,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new r.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(y){y.code!=="ENOENT"&&this.logService.error(y)}}getItem(y,d){const g=this.storage[y];return(0,L.isUndefinedOrNull)(g)?d:g}setItem(y,d){this.setItems([{key:y,data:d}])}setItems(y){let d=!1;for(const{key:g,data:M}of y)this.storage[g]!==M&&((0,L.isUndefinedOrNull)(M)?(0,L.isUndefined)(this.storage[g])||(this.storage[g]=void 0,d=!0):(this.storage[g]=M,d=!0));d&&this.save()}removeItem(y){(0,L.isUndefined)(this.storage[y])||(this.storage[y]=void 0,this.save())}async save(y){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),y)}async doSave(){if(!!this.initializing){await this.initializing;const y=JSON.stringify(this.storage,null,4);if(y!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,p.VSBuffer.fromString(y)),this.lastSavedStorageContents=y}catch(d){this.logService.error(d)}}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=n;let b=class It{constructor(y,d,g){this.fileStorage=new n(m.URI.file((0,R.join)(y.userDataPath,It.STATE_FILE)),d,g)}async init(){return this.fileStorage.init()}getItem(y,d){return this.fileStorage.getItem(y,d)}setItem(y,d){this.fileStorage.setItem(y,d)}setItems(y){this.fileStorage.setItems(y)}removeItem(y){this.fileStorage.removeItem(y)}close(){return this.fileStorage.close()}};b.STATE_FILE="storage.json",b=ue([ee(0,P.IEnvironmentMainService),ee(1,S.ILogService),ee(2,w.IFileService)],b),e.StateMainService=b}),define(Q[77],J([0,1,5,9,16,17,22,40,25,6,49,26]),function(j,e,m,R,L,S,P,r,w,p,n,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function I(d,g,M){return`${M.updateUrl}/api/update/${d}/${g}/${M.commit}`}e.createUpdateURL=I;let y=class{constructor(g,M,E,o,u,l){this.lifecycleMainService=g,this.configurationService=M,this.environmentMainService=E,this.requestService=o,this.logService=u,this.productService=l,this._state=r.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!!this.environmentMainService.isBuilt){if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=(0,L.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),M=this.getProductQuality(g);if(!M){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(M),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(r.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,E=>this.logService.error(E))}}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return(0,R.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},b.CancellationToken.None).then(g=>g.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};y=ue([ee(0,S.ILifecycleMainService),ee(1,L.IConfigurationService),ee(2,w.IEnvironmentMainService),ee(3,n.IRequestService),ee(4,p.ILogService),ee(5,P.IProductService)],y),e.AbstractUpdateService=y}),define(Q[225],J([0,1,14,2,5,46,16,17,40,31,25,6,77,49,22]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends I.AbstractUpdateService{constructor(E,o,u,l,c,t,i){super(E,o,l,c,t,i);this.telemetryService=u,this.disposables=new R.DisposableStore}get onRawError(){return L.Event.fromNodeEventEmitter(m.autoUpdater,"error",(E,o)=>o)}get onRawUpdateNotAvailable(){return L.Event.fromNodeEventEmitter(m.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return L.Event.fromNodeEventEmitter(m.autoUpdater,"update-available",(E,o,u)=>({url:o,version:u,productVersion:u}))}get onRawUpdateDownloaded(){return L.Event.fromNodeEventEmitter(m.autoUpdater,"update-downloaded",(E,o,u,l)=>({releaseNotes:o,version:u,productVersion:u,date:l}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(E){this.logService.error("UpdateService error:",E);const u=(this.state.type==="checking for updates"?this.state.explicit:!0)?E:void 0;this.setState(w.State.Idle(1,u))}buildUpdateFeedUrl(E){let o;this.productService.darwinUniversalAssetId?o=this.productService.darwinUniversalAssetId:o=process.arch==="x64"?"darwin":"darwin-arm64";const u=(0,I.createUpdateURL)(o,E,this.productService);try{m.autoUpdater.setFeedURL({url:u})}catch(l){this.logService.error("Failed to set update feed URL",l);return}return u}doCheckForUpdates(E){this.setState(w.State.CheckingForUpdates(E)),m.autoUpdater.checkForUpdates()}onUpdateAvailable(E){this.state.type==="checking for updates"&&this.setState(w.State.Downloading(E))}onUpdateDownloaded(E){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:E.version}),this.setState(w.State.Ready(E)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(w.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),m.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ue([S.memoize],g.prototype,"onRawError",null),ue([S.memoize],g.prototype,"onRawUpdateNotAvailable",null),ue([S.memoize],g.prototype,"onRawUpdateAvailable",null),ue([S.memoize],g.prototype,"onRawUpdateDownloaded",null),g=ue([ee(0,r.ILifecycleMainService),ee(1,P.IConfigurationService),ee(2,p.ITelemetryService),ee(3,n.IEnvironmentMainService),ee(4,y.IRequestService),ee(5,b.ILogService),ee(6,d.IProductService)],g),e.DarwinUpdateService=g}),define(Q[226],J([0,1,22,16,17,40,31,25,6,77,49,26,41]),function(j,e,m,R,L,S,P,r,w,p,n,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let y=class extends p.AbstractUpdateService{constructor(g,M,E,o,u,l,c,t){super(g,M,o,u,l,t);this.telemetryService=E,this.nativeHostMainService=c}buildUpdateFeedUrl(g){return(0,p.createUpdateURL)(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(S.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},b.CancellationToken.None).then(n.asJson).then(M=>{!M||!M.url||!M.version||!M.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(S.State.Idle(1))):this.setState(S.State.AvailableForDownload(M))}).then(void 0,M=>{this.logService.error(M),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const E=g?M.message||M:void 0;this.setState(S.State.Idle(1,E))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(S.State.Idle(1))}};y=ue([ee(0,L.ILifecycleMainService),ee(1,R.IConfigurationService),ee(2,P.ITelemetryService),ee(3,r.IEnvironmentMainService),ee(4,n.IRequestService),ee(5,w.ILogService),ee(6,I.INativeHostMainService),ee(7,m.IProductService)],y),e.LinuxUpdateService=y}),define(Q[227],J([0,1,5,9,17,40,25,6,8,24,45,31]),function(j,e,m,R,L,S,P,r,w,p,n,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let I=class{constructor(g,M,E){if(this.lifecycleMainService=g,this.logService=E,this._state=S.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,M.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(S.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,o=>this.logService.error(o))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return(0,R.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};I=ue([ee(0,L.ILifecycleMainService),ee(1,P.IEnvironmentMainService),ee(2,r.ILogService)],I);let y=class extends I{constructor(g,M,E,o,u,l){super(E,o,u);this.snap=g,this.snapRevision=M,this.telemetryService=l;const c=(0,p.watch)(w.dirname(this.snap)),t=m.Event.fromNodeEventEmitter(c,"change",(h,f)=>f),i=m.Event.filter(t,h=>h==="current"),a=m.Event.debounce(i,(h,f)=>f,2e3)(()=>this.checkForUpdates(!1));E.onWillShutdown(()=>{a.dispose(),c.close()})}doCheckForUpdates(){this.setState(S.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(S.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+w.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((E,o)=>(0,p.realpath)(`${w.dirname(this.snap)}/current`,(u,l)=>u?o(u):E(l))),M=w.basename(g);return this.snapRevision!==M}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};y=ue([ee(2,L.ILifecycleMainService),ee(3,P.IEnvironmentMainService),ee(4,r.ILogService),ee(5,b.ITelemetryService)],y),e.SnapUpdateService=y}),define(Q[228],J([0,1,24,8,20,46,16,17,22,40,31,25,6,77,49,111,27,45,26,9,21,7,41]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d,g,M,E,o,u,l,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function i(f,v=1e3){for(;!f();)await(0,u.timeout)(v)}let s;function a(){return typeof s=="undefined"&&(s=m.existsSync(R.join(R.dirname(process.execPath),"unins000.exe"))?0:1),s}let h=class extends y.AbstractUpdateService{constructor(v,D,T,W,$,X,x,oe,q){super(v,D,W,$,X,q);this.telemetryService=T,this.fileService=x,this.nativeHostMainService=oe}get cachePath(){const v=R.join((0,M.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return m.promises.mkdir(v,{recursive:!0}).then(()=>v)}initialize(){super.initialize(),a()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(v){let D="win32";return process.arch!=="ia32"&&(D+=`-${process.arch}`),a()===1?D+="-archive":this.productService.target==="user"&&(D+="-user"),(0,y.createUpdateURL)(D,v,this.productService)}doCheckForUpdates(v){!this.url||(this.setState(p.State.CheckingForUpdates(v)),this.requestService.request({url:this.url},o.CancellationToken.None).then(d.asJson).then(D=>{const T=a();return!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v}),this.setState(p.State.Idle(T)),Promise.resolve(null)):T===1?(this.setState(p.State.AvailableForDownload(D)),Promise.resolve(null)):(this.setState(p.State.Downloading(D)),this.cleanup(D.version).then(()=>this.getUpdatePackagePath(D.version).then(W=>L.exists(W).then($=>{if($)return Promise.resolve(W);const X=D.url,x=D.hash,oe=`${W}.tmp`;return this.requestService.request({url:X},o.CancellationToken.None).then(q=>this.fileService.writeFile(c.URI.file(oe),q.stream)).then(x?()=>(0,g.checksum)(oe,D.hash):()=>{}).then(()=>m.promises.rename(oe,W)).then(()=>W)})).then(W=>{const $=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:W},$&&D.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(p.State.Downloaded(D)):this.setState(p.State.Ready(D))})))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v});const T=v?D.message||D:void 0;this.setState(p.State.Idle(a(),T))}))}async doDownloadUpdate(v){v.update.url&&this.nativeHostMainService.openExternal(void 0,v.update.url),this.setState(p.State.Idle(a()))}async getUpdatePackagePath(v){const D=await this.cachePath;return R.join(D,`CodeSetup-${this.productService.quality}-${v}.exe`)}async cleanup(v=null){const D=v?X=>!new RegExp(`${this.productService.quality}-${v}\\.exe$`).test(X):()=>!0,T=await this.cachePath,$=(await L.readdir(T)).filter(D).map(async X=>{try{await m.promises.unlink(R.join(T,X))}catch(x){}});await Promise.all($)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const v=this.state.update;this.setState(p.State.Updating(v));const D=await this.cachePath;this.availableUpdate.updateFilePath=R.join(D,`CodeSetup-${this.productService.quality}-${v.version}.flag`),await L.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,E.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(p.State.Idle(a()))});const W=`${this.productService.win32MutexName}-ready`,$=await new Promise((X,x)=>{j(["windows-mutex"],X,x)});i(()=>$.isActive(W)).then(()=>this.setState(p.State.Ready(v)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?m.unlinkSync(this.availableUpdate.updateFilePath):(0,E.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return a()}};ue([S.memoize],h.prototype,"cachePath",null),h=ue([ee(0,r.ILifecycleMainService),ee(1,P.IConfigurationService),ee(2,n.ITelemetryService),ee(3,b.IEnvironmentMainService),ee(4,d.IRequestService),ee(5,I.ILogService),ee(6,l.IFileService),ee(7,t.INativeHostMainService),ee(8,w.IProductService)],h),e.Win32UpdateService=h}),define(Q[52],J([0,1,29,25,8,20,24,3,5,6,58,43,10,2,15,4,152,22,14,13,50,51,99]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d,g,M,E,o,u,l,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,g.createDecorator)("workspacesManagementMainService");let i=class extends y.Disposable{constructor(f,v,D,T,W){super();this.environmentMainService=f,this.logService=v,this.backupMainService=D,this.dialogMainService=T,this.productService=W,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new w.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new w.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(f){if(!!this.isWorkspacePath(f)&&f.scheme===I.Schemas.file){let v;try{v=(0,P.readFileSync)(f.fsPath,"utf8")}catch(D){return}return this.doResolveWorkspace(f,v)}}isWorkspacePath(f){return(0,m.isUntitledWorkspace)(f,this.environmentMainService)||(0,m.hasWorkspaceFileExtension)(f)}doResolveWorkspace(f,v){try{const D=this.doParseStoredWorkspace(f,v),T=s(f);return{id:T.id,configPath:T.configPath,folders:(0,m.toWorkspaceFolders)(D.folders,T.configPath,d.extUriBiasedIgnorePathCase),remoteAuthority:D.remoteAuthority}}catch(D){this.logService.warn(D.toString())}}doParseStoredWorkspace(f,v){const D=(0,b.parse)(v);if(D&&Array.isArray(D.folders))D.folders=D.folders.filter(T=>(0,m.isStoredWorkspaceFolder)(T));else throw new Error(`${f.toString(!0)} looks like an invalid workspace file.`);return D}async createUntitledWorkspace(f,v){const{workspace:D,storedWorkspace:T}=this.newUntitledWorkspace(f,v),W=D.configPath.fsPath;return await P.promises.mkdir((0,L.dirname)(W),{recursive:!0}),await(0,S.writeFile)(W,JSON.stringify(T,null,"	")),D}createUntitledWorkspaceSync(f,v){const{workspace:D,storedWorkspace:T}=this.newUntitledWorkspace(f,v),W=D.configPath.fsPath;return(0,P.mkdirSync)((0,L.dirname)(W),{recursive:!0}),(0,S.writeFileSync)(W,JSON.stringify(T,null,"	")),D}newUntitledWorkspace(f=[],v){const D=(Date.now()+Math.round(Math.random()*1e3)).toString(),T=(0,d.joinPath)(this.untitledWorkspacesHome,D),W=(0,d.joinPath)(T,m.UNTITLED_WORKSPACE_NAME),$=[];for(const X of f)$.push((0,m.getStoredWorkspaceFolder)(X.uri,!0,X.name,T,!r.isWindows,d.extUriBiasedIgnorePathCase));return{workspace:s(W),storedWorkspace:{folders:$,remoteAuthority:v}}}async getWorkspaceIdentifier(f){return s(f)}isUntitledWorkspace(f){return(0,m.isUntitledWorkspace)(f.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(f){!this.isUntitledWorkspace(f)||(this.doDeleteUntitledWorkspaceSync(f),this._onDidDeleteUntitledWorkspace.fire(f))}async deleteUntitledWorkspace(f){this.deleteUntitledWorkspaceSync(f)}doDeleteUntitledWorkspaceSync(f){const v=(0,d.originalFSPath)(f.configPath);try{(0,S.rimrafSync)((0,L.dirname)(v));const D=(0,L.join)(this.environmentMainService.workspaceStorageHome.fsPath,f.id);(0,P.existsSync)(D)&&(0,S.writeFileSync)((0,L.join)(D,"obsolete"),"")}catch(D){this.logService.warn(`Unable to delete untitled workspace ${v} (${D}).`)}}getUntitledWorkspacesSync(){const f=[];try{const v=(0,S.readdirSync)(this.untitledWorkspacesHome.fsPath).map(D=>(0,d.joinPath)(this.untitledWorkspacesHome,D,m.UNTITLED_WORKSPACE_NAME));for(const D of v){const T=s(D),W=this.resolveLocalWorkspaceSync(D);W?f.push({workspace:T,remoteAuthority:W.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(T)}}catch(v){v.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${v}).`)}return f}async enterWorkspace(f,v,D){if(!(!f||!f.win||!f.isReady)&&!!await this.isValidTargetWorkspacePath(f,v,D)){const W=this.doEnterWorkspace(f,s(D));if(!!W)return this._onDidEnterWorkspace.fire({window:f,workspace:W.workspace}),W}}async isValidTargetWorkspacePath(f,v,D){if(!D)return!0;if((0,m.isWorkspaceIdentifier)(f.openedWorkspace)&&d.extUriBiasedIgnorePathCase.isEqual(f.openedWorkspace.configPath,D))return!1;if((0,t.findWindowOnWorkspaceOrFolder)(v,D)){const T={title:this.productService.nameLong,type:"info",buttons:[(0,M.localize)(0,null)],message:(0,M.localize)(1,null,(0,d.basename)(D)),detail:(0,M.localize)(2,null),noLink:!0};return await this.dialogMainService.showMessageBox(T,(0,u.withNullAsUndefined)(o.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(f,v){if(!!f.config){f.focus();let D;return f.config.extensionDevelopmentPath||(D=this.backupMainService.registerWorkspaceBackupSync({workspace:v,remoteAuthority:f.remoteAuthority},f.config.backupPath)),(0,m.isWorkspaceIdentifier)(f.openedWorkspace)&&this.isUntitledWorkspace(f.openedWorkspace)&&this.deleteUntitledWorkspaceSync(f.openedWorkspace),f.config.workspace=v,f.config.backupPath=D,{workspace:v,backupPath:D}}}};i=ue([ee(0,R.IEnvironmentMainService),ee(1,p.ILogService),ee(2,l.IBackupMainService),ee(3,c.IDialogMainService),ee(4,E.IProductService)],i),e.WorkspacesManagementMainService=i;function s(h){function f(){let v=h.scheme===I.Schemas.file?(0,d.originalFSPath)(h):h.toString();return r.isLinux||(v=v.toLowerCase()),(0,n.createHash)("md5").update(v).digest("hex")}return{id:f(),configPath:h}}e.getWorkspaceIdentifier=s;function a(h,f){function v(){if(h.scheme!==I.Schemas.file)return(0,n.createHash)("md5").update(h.toString()).digest("hex");if(!f)try{f=(0,P.statSync)(h.fsPath)}catch(W){return}let T;return r.isLinux?T=f.ino:r.isMacintosh?T=f.birthtime.getTime():r.isWindows&&(typeof f.birthtimeMs=="number"?T=Math.floor(f.birthtimeMs):T=f.birthtime.getTime()),(0,n.createHash)("md5").update(h.fsPath).update(T?String(T):"").digest("hex")}const D=v();if(typeof D=="string")return{id:D,uri:h}}e.getSingleFolderWorkspaceIdentifier=a}),define(Q[100],J([0,1,6,97,3,4,34,20,52,16,7,14,35,54,26,29,13]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,S.createDecorator)(e.ID);let E=class{constructor(u,l,c,t,i){this.logService=u,this.windowsMainService=l,this.urlService=c,this.workspacesManagementMainService=t,this.configurationService=i}async start(u,l){this.logService.trace("Received data from other instance: ",u,l),L.isMacintosh&&b.app.focus({steal:!0});const c=this.parseOpenUrl(u);if(c.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:i,url:s}of c)this.urlService.open(i,{originalUrl:s})})}else return this.startOpenWindow(u,l)}parseOpenUrl(u){return u["open-url"]&&u._urls&&u._urls.length>0?(0,I.coalesce)(u._urls.map(l=>{try{return{uri:n.URI.parse(l),url:l}}catch(c){return null}})):[]}async startOpenWindow(u,l){const c=(0,y.isLaunchedFromCli)(l)?0:4;let t=[];const i=u.wait&&u.waitMarkerFilePath?n.URI.file(u.waitMarkerFilePath):void 0,s=u.remote||void 0;if(u.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(u.extensionDevelopmentPath,{context:c,cli:u,userEnv:l,waitMarkerFileURI:i,remoteAuthority:s});else if(!u._.length&&!u["folder-uri"]&&!u["file-uri"]){let a=!1;if(u["new-window"]||u["unity-launch"])a=!0;else if(u["reuse-window"])a=!1;else{const h=this.configurationService.getValue("window");switch((h==null?void 0:h.openWithoutArgumentsInNewWindow)||"default"){case"on":a=!0;break;case"off":a=!1;break;default:a=!L.isMacintosh}}if(a)t=this.windowsMainService.open({context:c,cli:u,userEnv:l,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:i,remoteAuthority:s});else{const h=this.windowsMainService.getLastActiveWindow();h?(h.focus(),t=[h]):t=this.windowsMainService.open({context:c,cli:u,forceEmpty:!0,remoteAuthority:s})}}else t=this.windowsMainService.open({context:c,cli:u,userEnv:l,forceNewWindow:u["new-window"],preferNewWindow:!u["reuse-window"]&&!u.wait,forceReuseWindow:u["reuse-window"],diffMode:u.diff,addMode:u.add,noRecentEntry:!!u["skip-add-to-recently-opened"],waitMarkerFileURI:i,gotoLineMode:u.goto,remoteAuthority:s});if(i&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,(0,r.whenDeleted)(i.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const u=[];return b.BrowserWindow.getAllWindows().forEach(l=>{const c=this.windowsMainService.getWindowById(l.id);c?u.push(this.codeWindowToInfo(c)):u.push(this.browserWindowToInfo(l))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:u,screenReader:!!b.app.accessibilitySupportEnabled,gpuFeatureStatus:b.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(u){const l=this.windowsMainService.getWindows();return(await Promise.all(l.map(t=>new Promise(i=>{const s=t.remoteAuthority;if(s){const a=`vscode:getDiagnosticInfoResponse${t.id}`,h={includeProcesses:u.includeProcesses,folders:u.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",d.CancellationToken.None,{replyChannel:a,args:h}),b.ipcMain.once(a,(f,v)=>{v||i({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),i(v)}),setTimeout(()=>{i({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else i(void 0)})))).filter(t=>!!t)}getFolderURIs(u){const l=[],c=u.openedWorkspace;if((0,g.isSingleFolderWorkspaceIdentifier)(c))l.push(c.uri);else if((0,g.isWorkspaceIdentifier)(c)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.configPath);t&&t.folders.forEach(s=>{l.push(s.uri)})}return l}codeWindowToInfo(u){const l=this.getFolderURIs(u),c=(0,M.assertIsDefined)(u.win);return this.browserWindowToInfo(c,l,u.remoteAuthority)}browserWindowToInfo(u,l=[],c){return{pid:u.webContents.getOSProcessId(),title:u.getTitle(),folderURIs:l,remoteAuthority:c}}};E=ue([ee(0,m.ILogService),ee(1,P.IWindowsMainService),ee(2,R.IURLService),ee(3,w.IWorkspacesManagementMainService),ee(4,p.IConfigurationService)],E),e.LaunchMainService=E}),define(Q[229],J([0,1,143,27,47,14,100,70,25,3,6,82,51,4,61,10,41,55,2]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d,g,M,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,y.createDecorator)("issueMainService");let u=class Pt{constructor(c,t,i,s,a,h,f,v){this.userEnv=c,this.environmentMainService=t,this.launchMainService=i,this.logService=s,this.diagnosticsService=a,this.dialogMainService=h,this.nativeHostMainService=f,this.protocolMainService=v,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){S.ipcMain.on("vscode:issueSystemInfoRequest",async c=>{const[t,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),s=await this.diagnosticsService.getSystemInfo(t,i);this.safeSend(c,"vscode:issueSystemInfoResponse",s)}),S.ipcMain.on("vscode:listProcesses",async c=>{const t=[];try{const i=await this.launchMainService.getMainProcessId();t.push({name:(0,m.localize)(0,null),rootProcess:await(0,b.listProcesses)(i)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(a=>{(0,r.isRemoteDiagnosticError)(a)?t.push({name:a.hostName,rootProcess:a}):a.processes&&t.push({name:a.hostName,rootProcess:a.processes})})}catch(i){this.logService.error(`Listing processes failed: ${i}`)}this.safeSend(c,"vscode:listProcessesResponse",t)}),S.ipcMain.on("vscode:issueReporterClipboard",async c=>{const t={message:(0,m.localize)(1,null),type:"warning",buttons:[(0,m.localize)(2,null),(0,m.localize)(3,null)]};if(this.issueReporterWindow){const i=await this.dialogMainService.showMessageBox(t,this.issueReporterWindow);this.safeSend(c,"vscode:issueReporterClipboardResponse",i.response===0)}}),S.ipcMain.on("vscode:issuePerformanceInfoRequest",async c=>{const t=await this.getPerformanceInfo();this.safeSend(c,"vscode:issuePerformanceInfoResponse",t)}),S.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const c={message:(0,m.localize)(4,null),type:"warning",buttons:[(0,m.localize)(5,null),(0,m.localize)(6,null)]};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(c,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),S.ipcMain.on("vscode:workbenchCommand",(c,t)=>{const{id:i,from:s,args:a}=t;let h;switch(s){case"issueReporter":h=this.issueReporterParentWindow;break;case"processExplorer":h=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${s}`)}h&&h.webContents.send("vscode:runAction",{id:i,from:s,args:a})}),S.ipcMain.on("vscode:openExternal",(c,t)=>{this.nativeHostMainService.openExternal(void 0,t)}),S.ipcMain.on("vscode:closeIssueReporter",c=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),S.ipcMain.on("vscode:closeProcessExplorer",c=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),S.ipcMain.on("vscode:windowsInfoRequest",async c=>{const t=await this.launchMainService.getMainProcessInfo();this.safeSend(c,"vscode:windowsInfoResponse",t.windows)})}safeSend(c,t,...i){c.sender.isDestroyed()||c.sender.send(t,...i)}async openReporter(c){var t;if(!this.issueReporterWindow&&(this.issueReporterParentWindow=S.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const i=new o.DisposableStore,s=i.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(a,s,{backgroundColor:c.styles.backgroundColor,title:(0,m.localize)(7,null),zoomLevel:c.zoomLevel,alwaysOnTop:!1}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:c,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,R.type)(),arch:(0,R.arch)(),release:(0,R.release)()},product:L.default}),this.issueReporterWindow.loadURL(g.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",j,!0).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,i.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,i.dispose())})}(t=this.issueReporterWindow)===null||t===void 0||t.focus()}async openProcessExplorer(c){var t;if(!this.processExplorerWindow&&(this.processExplorerParentWindow=S.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const i=new o.DisposableStore,s=i.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(a,s,{backgroundColor:c.styles.backgroundColor,title:(0,m.localize)(8,null),zoomLevel:c.zoomLevel,alwaysOnTop:!0}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:c,product:L.default}),this.processExplorerWindow.loadURL(g.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",j,!0).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,i.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,i.dispose())})}(t=this.processExplorerWindow)===null||t===void 0||t.focus()}createBrowserWindow(c,t,i){const s=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:c.width,height:c.height,minWidth:300,minHeight:200,x:c.x,y:c.y,title:i.title,backgroundColor:i.backgroundColor||Pt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:g.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`,"--context-isolation"],v8CacheOptions:p.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,d.zoomLevelToZoomFactor)(i.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:i.alwaysOnTop});return s.setMenuBarVisibility(!1),s}async getSystemStatus(){const[c,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(c,t)}getWindowPosition(c,t,i){let s;const a=S.screen.getAllDisplays();if(a.length===1)s=a[0];else{if(p.isMacintosh){const v=S.screen.getCursorScreenPoint();s=S.screen.getDisplayNearestPoint(v)}!s&&c&&(s=S.screen.getDisplayMatching(c.getBounds())),s||(s=S.screen.getPrimaryDisplay()||a[0])}const h={width:t,height:i},f=s.bounds;return h.x=f.x+f.width/2-h.width/2,h.y=f.y+f.height/2-h.height/2,f.width>0&&f.height>0&&(h.x<f.x&&(h.x=f.x),h.y<f.y&&(h.y=f.y),h.x>f.x+f.width&&(h.x=f.x),h.y>f.y+f.height&&(h.y=f.y),h.width>f.width&&(h.width=f.width),h.height>f.height&&(h.height=f.height)),h}async getPerformanceInfo(){try{const[c,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(c,t)}catch(c){throw this.logService.warn("issueService#getPerformanceInfo ",c.message),c}}};u.DEFAULT_BACKGROUND_COLOR="#1E1E1E",u=ue([ee(1,w.IEnvironmentMainService),ee(2,P.ILaunchMainService),ee(3,n.ILogService),ee(4,r.IDiagnosticsService),ee(5,I.IDialogMainService),ee(6,M.INativeHostMainService),ee(7,E.IProtocolMainService)],u),e.IssueMainService=u}),define(Q[230],J([0,1,8,148,72,5,7,14,25,6,16,22,61,2,3,34,29,52,50,197,60,31,51,39,201,17,98,21,10,54,26,41,55]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d,g,M,E,o,u,l,c,t,i,s,a,h,f,v,D,T,W,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var X;(function(oe){oe[oe.NONE=0]="NONE",oe[oe.LOADING=1]="LOADING",oe[oe.NAVIGATING=2]="NAVIGATING",oe[oe.READY=3]="READY"})(X||(X={}));let x=class extends y.Disposable{constructor(q,N,B,C,z,V,_,A,O,k,F,U,K,G,Y){super();this.logService=N,this.environmentMainService=B,this.fileService=C,this.configurationService=V,this.themeMainService=_,this.workspacesManagementMainService=A,this.backupMainService=O,this.telemetryService=k,this.dialogMainService=F,this.lifecycleMainService=U,this.nativeHostMainService=K,this.productService=G,this.protocolMainService=Y,this._onWillLoad=this._register(new S.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new S.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new S.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new S.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this._lastFocusTime=-1,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.readyState=0;{const[Z,ne]=this.restoreWindowState(q.state);this.windowState=Z,this.logService.trace("window#ctor: using window state",Z);const se=this.windowState.mode===0||this.windowState.mode===3,re=this.configurationService.getValue("window"),te={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:I.WindowMinimumSize.WIDTH,minHeight:I.WindowMinimumSize.HEIGHT,show:!se,title:this.productService.nameLong,webPreferences:Object.assign({preload:v.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:this.environmentMainService.sandbox?[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`,"--context-isolation"]:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:d.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:(0,I.zoomLevelToZoomFactor)(re==null?void 0:re.zoomLevel)},this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1})};d.browserCodeLoadingCacheStrategy?this.logService.info(`window#ctor: using vscode-file:// protocol and V8 cache options: ${d.browserCodeLoadingCacheStrategy}`):this.logService.trace("window#ctor: vscode-file:// protocol is explicitly disabled"),d.isLinux?te.icon=(0,m.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):d.isWindows&&!this.environmentMainService.isBuilt&&(te.icon=(0,m.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),d.isMacintosh&&!this.useNativeFullScreen()&&(te.fullscreenable=!1),d.isMacintosh&&(te.acceptFirstMouse=!0,(re==null?void 0:re.clickThroughInactive)===!1&&(te.acceptFirstMouse=!1));const le=d.isMacintosh&&(re==null?void 0:re.nativeTabs)===!0;le&&(te.tabbingIdentifier=this.productService.nameShort);const ve=(0,I.getTitleBarStyle)(this.configurationService)==="custom";if(ve&&(te.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,d.isMacintosh||(te.frame=!1)),(0,L.mark)("code/willCreateCodeBrowserWindow"),this._win=new r.BrowserWindow(te),(0,L.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),d.isMacintosh&&ve&&this._win.setSheetOffset(22),d.isMacintosh&&ne&&(!le||r.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(we=>typeof we=="number")){const we=this.windowState;this._win.setBounds({width:we.width,height:we.height,x:we.x,y:we.y})}se&&((0,L.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,L.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,u.resolveMarketplaceHeaders)(this.productService.version,this.environmentMainService,this.fileService,{get:Z=>z.globalStorage.get(Z),store:(Z,ne)=>z.globalStorage.set(Z,ne)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){var q;return(q=this.currentConfig)===null||q===void 0?void 0:q.backupPath}get openedWorkspace(){var q;return(q=this.currentConfig)===null||q===void 0?void 0:q.workspace}get remoteAuthority(){var q;return(q=this.currentConfig)===null||q===void 0?void 0:q.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){var q;return!!((q=this.currentConfig)===null||q===void 0?void 0:q.extensionDevelopmentPath)}get isExtensionTestHost(){var q;return!!((q=this.currentConfig)===null||q===void 0?void 0:q.extensionTestsPath)}get isExtensionDevelopmentTestFromCli(){var q;return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!((q=this.currentConfig)===null||q===void 0?void 0:q.debugId)}setRepresentedFilename(q){d.isMacintosh?this._win.setRepresentedFilename(q):this.representedFilename=q}getRepresentedFilename(){return d.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(q){d.isMacintosh&&this._win.setDocumentEdited(q),this.documentEdited=q}isDocumentEdited(){return d.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(q){d.isMacintosh&&(q==null?void 0:q.force)&&r.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(q=>{if(this.isReady)return q(this);this.whenReadyCallbacks.push(q)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(q=>{function N(){B.dispose(),C.dispose(),q()}const B=this.onDidClose(()=>N()),C=this.onWillLoad(()=>N())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(C,z)=>this.onWindowError(2,z)),this._win.webContents.on("did-fail-load",(C,z,V)=>this.onWindowError(3,V)),this._win.webContents.on("will-prevent-unload",C=>{C.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const q=new Set([v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemoteResource,"devtools"]),N=C=>{for(let z=C;z;z=z.parent)if(z.url.startsWith(`${v.Schemas.vscodeWebview}://`))return!0;return!1};this._win.webContents.session.webRequest.onBeforeRequest((C,z)=>{const V=P.URI.parse(C.url);if(V.path.endsWith(".svg")&&!(q.has(V.scheme)||V.path.includes(v.Schemas.vscodeRemoteResource))){const A=N(C.frame);return z({cancel:!A})}return z({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((C,z)=>{const V=C.responseHeaders,_=V["content-type"]||V["Content-Type"];if(_&&Array.isArray(_)){const A=P.URI.parse(C.url);if(A.path.endsWith(".svg")&&q.has(A.scheme))return V["Content-Type"]=["image/svg+xml"],z({cancel:!1,responseHeaders:V});if(!A.path.includes(v.Schemas.vscodeRemoteResource)&&_.some(O=>O.toLowerCase().includes("image/svg"))){const O=N(C.frame);return z({cancel:!O})}}return z({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),d.isMacintosh&&this._register(this.nativeHostMainService.onDidChangeDisplay(()=>{!this._win||!this.useNativeFullScreen()&&this.isFullScreen&&(this.setFullScreen(!1),this.setFullScreen(!0))})),this._win.on("maximize",C=>{this.currentConfig&&(this.currentConfig.maximized=!0),r.app.emit("browser-window-maximize",C,this._win)}),this._win.on("unmaximize",C=>{this.currentConfig&&(this.currentConfig.maximized=!1),r.app.emit("browser-window-unmaximize",C,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",T.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",T.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(C=>this.onDidDeleteUntitledWorkspace(C)));const B=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:B},async(C,z)=>{const V=await this.marketplaceHeadersPromise;z({cancel:!1,requestHeaders:Object.assign(C.requestHeaders,V)})})}async onWindowError(q,N){var B;switch(q){case 2:this.logService.error(`CodeWindow: renderer process crashed (detail: ${typeof N=="string"?N:N==null?void 0:N.reason}, code: ${typeof N=="string"?"<unknown>":(B=N==null?void 0:N.exitCode)!==null&&B!==void 0?B:"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load workbench window: ${typeof N=="string"?N:N==null?void 0:N.reason}`);break}if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.telemetryService.publicLog2("windowerror",{type:q,reason:typeof N!="string"?N==null?void 0:N.reason:void 0}),q===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const C=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,i.mnemonicButtonLabel)((0,R.localize)(0,null)),(0,i.mnemonicButtonLabel)((0,R.localize)(1,null)),(0,i.mnemonicButtonLabel)((0,R.localize)(2,null))],message:(0,R.localize)(3,null),detail:(0,R.localize)(4,null),noLink:!0},this._win);if(!this._win)return;C.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):C.response===2&&this.destroyWindow()}else if(q===2){let C;typeof N=="string"||!N?C=(0,R.localize)(5,null):C=(0,R.localize)(6,null,N.reason);const z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,i.mnemonicButtonLabel)((0,R.localize)(7,null)),(0,i.mnemonicButtonLabel)((0,R.localize)(8,null))],message:C,detail:(0,R.localize)(9,null),noLink:!0},this._win);if(!this._win)return;z.response===0?this.reload():z.response===1&&this.destroyWindow()}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(q){var N;((N=this.openedWorkspace)===null||N===void 0?void 0:N.id)===q.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const q=this.getMenuBarVisibility();q!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=q,this.setMenuBarVisibility(q));let N=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;(N==null?void 0:N.endsWith("/"))&&(N=N.substr(0,N.length-1));const B=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((N||"").indexOf("@")===-1&&(N!==this.currentHttpProxy||B!==this.currentNoProxy)){this.currentHttpProxy=N,this.currentNoProxy=B;const C=N||"",z=B?`${B},<local>`:"<local>";this.logService.trace(`Setting proxy to '${C}', bypassing '${z}'`),this._win.webContents.session.setProxy({proxyRules:C,proxyBypassRules:z,pacScript:""})}}addTabbedWindow(q){d.isMacintosh&&q.win&&this._win.addTabbedWindow(q.win)}load(q,N=Object.create(null)){this.isDocumentEdited()&&(!N.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),N.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(q,N),this.readyState===0?this.currentConfig=q:(this.pendingLoadConfig=q,this.readyState=2),this._win.loadURL(v.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",j).toString(!0)),!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&(this.showTimeoutHandle=setTimeout(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onWillLoad.fire({workspace:q.workspace})}updateConfiguration(q,N){var B,C;const z=(C=(B=this.currentConfig)!==null&&B!==void 0?B:this.pendingLoadConfig)===null||C===void 0?void 0:C.userEnv;z&&(0,D.isLaunchedFromCli)(z)&&!(0,D.isLaunchedFromCli)(q.userEnv)&&(q.userEnv=Object.assign(Object.assign({},z),q.userEnv)),process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(q.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),N.disableExtensions!==void 0&&(q["disable-extensions"]=N.disableExtensions),q.fullscreen=this.isFullScreen,q.maximized=this._win.isMaximized(),q.partsSplash=this.themeMainService.getWindowSplash(),(0,L.mark)("code/willOpenNewWindow"),q.perfMarks=(0,L.getMarks)(),this.configObjectUrl.update(q)}async reload(q){const N=Object.assign({},this.currentConfig);N.workspace=await this.validateWorkspace(N),delete N.filesToOpenOrCreate,delete N.filesToDiff,delete N.filesToWait,this.isExtensionDevelopmentHost&&q&&(N.verbose=q.verbose,N.debugId=q.debugId,N["inspect-extensions"]=q["inspect-extensions"],N["inspect-brk-extensions"]=q["inspect-brk-extensions"],N["extensions-dir"]=q["extensions-dir"]),N.isInitialStartup=!1,this.load(N,{isReload:!0,disableExtensions:q==null?void 0:q["disable-extensions"]})}async validateWorkspace(q){if((0,M.isWorkspaceIdentifier)(q.workspace)){const N=q.workspace.configPath;if(N.scheme===v.Schemas.file&&!await this.fileService.exists(N))return}else if((0,M.isSingleFolderWorkspaceIdentifier)(q.workspace)){const N=q.workspace.uri;if(N.scheme===v.Schemas.file&&!await this.fileService.exists(N))return}return q.workspace}serializeWindowState(){if(!this._win)return(0,g.defaultWindowState)();if(this.isFullScreen){let B;try{B=r.screen.getDisplayMatching(this.getBounds())}catch(V){}const C=(0,g.defaultWindowState)();return{mode:3,display:B?B.id:void 0,width:this.windowState.width||C.width,height:this.windowState.height||C.height,x:this.windowState.x||0,y:this.windowState.y||0}}const q=Object.create(null);let N;if(!d.isMacintosh&&this._win.isMaximized()?N=0:N=1,N===0?q.mode=0:q.mode=1,N===1||N===0){let B;N===1?B=this.getBounds():B=this._win.getNormalBounds(),q.x=B.x,q.y=B.y,q.width=B.width,q.height=B.height}return q}restoreWindowState(q){(0,L.mark)("code/willRestoreCodeWindowState");let N=!1;if(q)try{const B=r.screen.getAllDisplays();N=B.length>1,q=this.validateWindowState(q,B)}catch(B){this.logService.warn(`Unexpected error validating window state: ${B}
${B.stack}`)}return(0,L.mark)("code/didRestoreCodeWindowState"),[q||(0,g.defaultWindowState)(),N]}validateWindowState(q,N){var B,C;if(this.logService.trace(`window#validateWindowState: validating window state on ${N.length} display(s)`,q),typeof q.x!="number"||typeof q.y!="number"||typeof q.width!="number"||typeof q.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(q.width<=0||q.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(N.length===1){const A=this.getWorkingArea(N[0]);if(A){this.logService.trace("window#validateWindowState: 1 monitor working area",A);function z(){!q||typeof q.x!="number"||typeof q.y!="number"||!A||(q.x<A.x&&(q.x=A.x),q.y<A.y&&(q.y=A.y))}z(),q.width>A.width&&(q.width=A.width),q.height>A.height&&(q.height=A.height),q.x>A.x+A.width-128&&(q.x=A.x+A.width-q.width),q.y>A.y+A.height-128&&(q.y=A.y+A.height-q.height),z()}return q}if(q.display&&q.mode===3){const A=N.find(O=>O.id===q.display);if(A&&typeof((B=A.bounds)===null||B===void 0?void 0:B.x)=="number"&&typeof((C=A.bounds)===null||C===void 0?void 0:C.y)=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const O=(0,g.defaultWindowState)(3);return O.x=A.bounds.x,O.y=A.bounds.y,O}}let V,_;try{V=r.screen.getDisplayMatching({x:q.x,y:q.y,width:q.width,height:q.height}),_=this.getWorkingArea(V)}catch(A){}if(V&&_&&q.x+q.width>_.x&&q.y+q.height>_.y&&q.x<_.x+_.width&&q.y<_.y+_.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",_),q}getWorkingArea(q){if(q.workArea.width>0&&q.workArea.height>0)return q.workArea;if(q.bounds.width>0&&q.bounds.height>0)return q.bounds}getBounds(){const[q,N]=this._win.getPosition(),[B,C]=this._win.getSize();return{x:q,y:N,width:B,height:C}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(q){this.useNativeFullScreen()?this.setNativeFullScreen(q):this.setSimpleFullScreen(q),this.sendWhenReady(q?"vscode:enterFullScreen":"vscode:leaveFullScreen",T.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(q){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(q)}setSimpleFullScreen(q){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(q),this._win.webContents.focus()}useNativeFullScreen(){const q=this.configurationService.getValue("window");return!q||typeof q.nativeFullScreen!="boolean"||q.nativeTabs?!0:q.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let q=(0,I.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(q)<0&&(q="classic"),q}setMenuBarVisibility(q,N=!0){d.isMacintosh||(q==="toggle"&&N&&this.send("vscode:showInfoMessage",(0,R.localize)(10,null)),q==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(q)}):this.doSetMenuBarVisibility(q))}doSetMenuBarVisibility(q){const N=this.isFullScreen;switch(q){case"classic":this._win.setMenuBarVisibility(!N),this._win.autoHideMenuBar=N;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(d.isMacintosh)switch(r.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(q,N,...B){this.isReady?this.send(q,...B):this.ready().then(()=>{N.isCancellationRequested||this.send(q,...B)})}send(q,...N){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${q} for window that is destroyed`);return}this._win.webContents.send(q,...N)}}updateTouchBar(q){!d.isMacintosh||this.touchBarGroups.forEach((N,B)=>{const C=q[B];N.segments=this.createTouchBarGroupSegments(C)})}createTouchBar(){if(!!d.isMacintosh){for(let q=0;q<10;q++){const N=this.createTouchBarGroup();this.touchBarGroups.push(N)}this._win.setTouchBar(new r.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(q=[]){const N=this.createTouchBarGroupSegments(q),B=new r.TouchBar.TouchBarSegmentedControl({segments:N,mode:"buttons",segmentStyle:"automatic",change:C=>{this.sendWhenReady("vscode:runAction",T.CancellationToken.None,{id:B.segments[C].id,from:"touchbar"})}});return B}createTouchBarGroupSegments(q=[]){return q.map(B=>{var C,z;let V;B.icon&&!s.ThemeIcon.isThemeIcon(B.icon)&&((z=(C=B.icon)===null||C===void 0?void 0:C.dark)===null||z===void 0?void 0:z.scheme)===v.Schemas.file&&(V=r.nativeImage.createFromPath(P.URI.revive(B.icon.dark).fsPath),V.isEmpty()&&(V=void 0));let _;return typeof B.title=="string"?_=B.title:_=B.title.value,{id:B.id,label:V?void 0:_,icon:V}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};x=ue([ee(1,p.ILogService),ee(2,w.IEnvironmentMainService),ee(3,f.IFileService),ee(4,h.IStorageMainService),ee(5,n.IConfigurationService),ee(6,l.IThemeMainService),ee(7,E.IWorkspacesManagementMainService),ee(8,o.IBackupMainService),ee(9,c.ITelemetryService),ee(10,t.IDialogMainService),ee(11,a.ILifecycleMainService),ee(12,W.INativeHostMainService),ee(13,b.IProductService),ee(14,$.IProtocolMainService)],x),e.CodeWindow=x}),define(Q[62],J([0,1,151,35,38,14,6,39,5,3,29,52,9,15,7,10,20,17,4,2]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d,g,M,E,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,o.createDecorator)("workspacesHistoryMainService");let l=class He extends u.Disposable{constructor(f,v,D,T){super();this.stateMainService=f,this.logService=v,this.workspacesManagementMainService=D,this.lifecycleMainService=T,this._onDidChangeRecentlyOpened=this._register(new w.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new I.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(f=>this.addRecentlyOpened([{workspace:f.workspace}])))}handleWindowsJumpList(){!p.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(f){const v=[],D=[];for(let T of f)if((0,n.isRecentWorkspace)(T))!this.workspacesManagementMainService.isUntitledWorkspace(T.workspace)&&i(v,T.workspace)===-1&&v.push(T);else if((0,n.isRecentFolder)(T))s(v,T.folderUri)===-1&&v.push(T);else{const W=a(D,T.fileUri)>=0,$=T.fileUri.scheme===g.Schemas.file&&He.COMMON_FILES_FILTER.indexOf((0,y.basename)(T.fileUri))>=0;!W&&!$&&(D.push(T),p.isWindows&&T.fileUri.scheme===g.Schemas.file&&S.app.addRecentDocument(T.fileUri.fsPath))}this.addEntriesFromStorage(v,D),v.length>He.MAX_TOTAL_RECENT_ENTRIES&&(v.length=He.MAX_TOTAL_RECENT_ENTRIES),D.length>He.MAX_TOTAL_RECENT_ENTRIES&&(D.length=He.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:v,files:D}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(f){const v=$=>{const X=t($);for(const x of f)if(y.extUriBiasedIgnorePathCase.isEqual(x,X))return!1;return!0},D=this.getRecentlyOpened(),T=D.workspaces.filter(v),W=D.files.filter(v);(T.length!==D.workspaces.length||W.length!==D.files.length)&&(this.saveRecentlyOpened({files:W,workspaces:T}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!!p.isMacintosh){S.app.clearRecentDocuments();const f=this.getRecentlyOpened(),v=[];let D=0;for(let W=0;W<f.workspaces.length&&D<He.MAX_MACOS_DOCK_RECENT_WORKSPACES;W++){const $=t(f.workspaces[W]);if($.scheme===g.Schemas.file){const X=(0,y.originalFSPath)($);await(0,M.exists)(X)&&(v.push(X),D++)}}const T=[];for(let W=0;W<f.files.length&&D<He.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;W++){const $=t(f.files[W]);if($.scheme===g.Schemas.file){const X=(0,y.originalFSPath)($);if(He.COMMON_FILES_FILTER.includes((0,y.basename)($))||v.includes(X))continue;await(0,M.exists)(X)&&(T.push(X),D++)}}T.reverse().forEach(W=>S.app.addRecentDocument(W)),v.reverse().forEach(W=>S.app.addRecentDocument(W))}}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(f){var v,D;const T=[],W=[],$=(v=f==null?void 0:f.config)===null||v===void 0?void 0:v.workspace;(0,n.isWorkspaceIdentifier)($)&&!this.workspacesManagementMainService.isUntitledWorkspace($)?T.push({workspace:$}):(0,n.isSingleFolderWorkspaceIdentifier)($)&&T.push({folderUri:$.uri});const X=(D=f==null?void 0:f.config)===null||D===void 0?void 0:D.filesToOpenOrCreate;if(X)for(let x of X){const oe=x.fileUri;oe&&a(W,oe)===-1&&W.push({fileUri:oe})}return this.addEntriesFromStorage(T,W),{workspaces:T,files:W}}addEntriesFromStorage(f,v){let D=this.getRecentlyOpenedFromStorage();for(let T of D.workspaces){let W=(0,n.isRecentFolder)(T)?s(f,T.folderUri):i(f,T.workspace);W>=0?f[W].label=f[W].label||T.label:f.push(T)}for(let T of D.files){let W=a(v,T.fileUri);W>=0?v[W].label=v[W].label||T.label:v.push(T)}}getRecentlyOpenedFromStorage(){const f=this.stateMainService.getItem(He.recentlyOpenedStorageKey);return(0,n.restoreRecentlyOpened)(f,this.logService)}saveRecentlyOpened(f){const v=(0,n.toStoreData)(f);this.stateMainService.setItem(He.recentlyOpenedStorageKey,v)}updateWindowsJumpList(){if(!!p.isWindows){const f=[];if(f.push({type:"tasks",items:[{type:"task",title:(0,m.localize)(0,null),description:(0,m.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let v=[];for(let W of S.app.getJumpListSettings().removedItems){const $=W.args;if($){const X=/^--(folder|file)-uri\s+"([^"]+)"$/.exec($);X&&v.push(d.URI.parse(X[2]))}}this.removeRecentlyOpened(v);let D=!1;const T=(0,R.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(W=>{const $=(0,n.isRecentWorkspace)(W)?W.workspace:W.folderUri,{title:X,description:x}=this.getWindowsJumpListLabel($,W.label);let oe;return d.URI.isUri($)?oe=`--folder-uri "${$.toString()}"`:(D=!0,oe=`--file-uri "${$.configPath.toString()}"`),{type:"task",title:X.substr(0,255),description:x.substr(0,255),program:process.execPath,args:oe,iconPath:"explorer.exe",iconIndex:0}}));T.length>0&&f.push({type:"custom",name:D?(0,m.localize)(2,null):(0,m.localize)(3,null),items:T})}f.push({type:"recent"});try{S.app.setJumpList(f)}catch(v){this.logService.warn("updateWindowsJumpList#setJumpList",v)}}}getWindowsJumpListLabel(f,v){if(v)return{title:(0,r.splitName)(v).name,description:v};if(d.URI.isUri(f))return{title:(0,y.basename)(f),description:c(f)};if(this.workspacesManagementMainService.isUntitledWorkspace(f))return{title:(0,m.localize)(4,null),description:""};let D=(0,y.basename)(f.configPath);return D.endsWith(n.WORKSPACE_EXTENSION)&&(D=D.substr(0,D.length-n.WORKSPACE_EXTENSION.length-1)),{title:(0,m.localize)(5,null,D),description:c(f.configPath)}}};l.MAX_TOTAL_RECENT_ENTRIES=100,l.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,l.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,l.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],l.recentlyOpenedStorageKey="openedPathsList",l=ue([ee(0,L.IStateMainService),ee(1,P.ILogService),ee(2,b.IWorkspacesManagementMainService),ee(3,E.ILifecycleMainService)],l),e.WorkspacesHistoryMainService=l;function c(h){return h.scheme==="file"?(0,r.normalizeDriveLetter)(h.fsPath):h.toString()}function t(h){return(0,n.isRecentFolder)(h)?h.folderUri:(0,n.isRecentFile)(h)?h.fileUri:h.workspace.configPath}function i(h,f){return h.findIndex(v=>(0,n.isRecentWorkspace)(v)&&v.workspace.id===f.id)}function s(h,f){return h.findIndex(v=>(0,n.isRecentFolder)(v)&&y.extUriBiasedIgnorePathCase.isEqual(v.folderUri,f))}function a(h,f){return h.findIndex(v=>y.extUriBiasedIgnorePathCase.isEqual(v.fileUri,f))}}),define(Q[231],J([0,1,144,3,25,14,61,16,31,40,22,9,6,39,34,62,179,7,38,17,41,26]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d,g,M,E,o,u,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let i=class wt{constructor(h,f,v,D,T,W,$,X,x,oe,q){this.updateService=h,this.configurationService=f,this.windowsMainService=v,this.environmentMainService=D,this.telemetryService=T,this.workspacesHistoryMainService=W,this.stateMainService=$,this.lifecycleMainService=X,this.logService=x,this.nativeHostMainService=oe,this.productService=q,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new b.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new b.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(R.isMacintosh||(0,P.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const h=this.stateMainService.getItem(wt.lastKnownMenubarStorageKey);h&&(h.menus&&(this.menubarMenus=h.menus),h.keybindings&&(this.keybindings=h.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(W,$,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:$==null?void 0:$.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(W,$,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:$==null?void 0:$.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(W,$,X)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(W,$,X)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const h=this.productService.twitterUrl;h&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(h,"openTwitterUrl"));const f=this.productService.requestFeatureUrl;f&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(f,"openUserVoiceUrl"));const v=this.productService.reportIssueUrl;v&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(v,"openReportIssues"));const D=this.productService.licenseUrl;D&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(R.language){const W=D.indexOf("?")>0?"&":"?";this.openUrl(`${D}${W}lang=${R.language}`,"openLicenseUrl")}else this.openUrl(D,"openLicenseUrl")});const T=this.productService.privacyStatementUrl;T&&D&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(R.language){const W=D.indexOf("?")>0?"&":"?";this.openUrl(`${T}${W}lang=${R.language}`,"openPrivacyStatement")}else this.openUrl(T,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(h=>this.onDidChangeWindowsCount(h)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let h=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof h!="boolean"&&(h=!0),h}get currentEnableNativeTabs(){if(!R.isMacintosh)return!1;let h=this.configurationService.getValue("window.nativeTabs");return typeof h!="boolean"&&(h=!1),h}updateMenu(h,f){this.menubarMenus=h.menus,this.keybindings=h.keybindings,this.stateMainService.setItem(wt.lastKnownMenubarStorageKey,h),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(h){!R.isMacintosh||(h.oldCount===0&&h.newCount>0||h.oldCount>0&&h.newCount===0)&&(this.closedLastWindow=h.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!R.isMacintosh||(this.noActiveWindow=!S.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const h=S.Menu.getApplicationMenu();if(h&&this.oldMenus.push(h),Object.keys(this.menubarMenus).length===0){S.Menu.setApplicationMenu(R.isMacintosh?new S.Menu:null);return}const f=new S.Menu;let v;if(R.isMacintosh){const F=new S.Menu;v=new S.MenuItem({label:this.productService.nameShort,submenu:F}),this.setMacApplicationMenu(F),f.append(v)}if(R.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const F=new S.Menu;F.append(new S.MenuItem({label:this.mnemonicLabel(m.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),S.app.dock.setMenu(F)}const D=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(m.localize(1,null)),submenu:D});this.setMenuById(D,"File"),f.append(T);const W=new S.Menu,$=new S.MenuItem({label:this.mnemonicLabel(m.localize(2,null)),submenu:W});this.setMenuById(W,"Edit"),f.append($);const X=new S.Menu,x=new S.MenuItem({label:this.mnemonicLabel(m.localize(3,null)),submenu:X});this.setMenuById(X,"Selection"),f.append(x);const oe=new S.Menu,q=new S.MenuItem({label:this.mnemonicLabel(m.localize(4,null)),submenu:oe});this.setMenuById(oe,"View"),f.append(q);const N=new S.Menu,B=new S.MenuItem({label:this.mnemonicLabel(m.localize(5,null)),submenu:N});this.setMenuById(N,"Go"),f.append(B);const C=new S.Menu,z=new S.MenuItem({label:this.mnemonicLabel(m.localize(6,null)),submenu:C});this.setMenuById(C,"Run"),f.append(z);const V=new S.Menu,_=new S.MenuItem({label:this.mnemonicLabel(m.localize(7,null)),submenu:V});this.setMenuById(V,"Terminal"),f.append(_);let A;if(this.shouldDrawMenu("Window")){const F=new S.Menu;A=new S.MenuItem({label:this.mnemonicLabel(m.localize(8,null)),submenu:F,role:"window"}),this.setMacWindowMenu(F)}A&&f.append(A);const O=new S.Menu,k=new S.MenuItem({label:this.mnemonicLabel(m.localize(9,null)),submenu:O,role:"help"});this.setMenuById(O,"Help"),f.append(k),f.items&&f.items.length>0?S.Menu.setApplicationMenu(f):S.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(h){const f=this.createMenuItem(m.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),v=this.getUpdateMenuItems();let D;if(this.shouldDrawMenu("Preferences")){const N=new S.Menu;this.setMenuById(N,"Preferences"),D=new S.MenuItem({label:this.mnemonicLabel(m.localize(11,null)),submenu:N})}const T=new S.Menu,W=new S.MenuItem({label:m.localize(12,null),role:"services",submenu:T}),$=new S.MenuItem({label:m.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),X=new S.MenuItem({label:m.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),x=new S.MenuItem({label:m.localize(15,null),role:"unhide"}),oe=new S.MenuItem(this.likeAction("workbench.action.quit",{label:m.localize(16,null,this.productService.nameLong),click:()=>{const N=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!S.BrowserWindow.getFocusedWindow()||(N==null?void 0:N.isMinimized()))&&this.nativeHostMainService.quit(void 0)}})),q=[f];q.push(...v),D&&q.push(s(),D),q.push(s(),W,s(),$,X,x,s(),oe),q.forEach(N=>h.append(N))}shouldDrawMenu(h){if(!R.isMacintosh&&(0,P.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(h){case"File":case"Help":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[h];case"Window":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[h]}}setMenu(h,f){f.forEach(v=>{if((0,M.isMenubarMenuItemSeparator)(v))h.append(s());else if((0,M.isMenubarMenuItemSubmenu)(v)){const D=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(v.label),submenu:D});this.setMenu(D,v.submenu.items),h.append(T)}else(0,M.isMenubarMenuItemRecentAction)(v)?h.append(this.createOpenRecentMenuItem(v)):(0,M.isMenubarMenuItemAction)(v)&&(v.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(h),R.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[v.id]?h.append(new S.MenuItem(this.likeAction(v.id,{label:this.mnemonicLabel(v.label),click:this.fallbackMenuHandlers[v.id]}))):h.append(this.createMenuItem(v.label,v.id,!1,v.checked)):h.append(this.createMenuItem(v.label,v.id,v.enabled!==!1,!!v.checked)):h.append(this.createMenuItem(v.label,v.id,v.enabled!==!1,!!v.checked)))})}setMenuById(h,f){this.menubarMenus&&this.menubarMenus[f]&&this.setMenu(h,this.menubarMenus[f].items)}insertCheckForUpdatesItems(h){const f=this.getUpdateMenuItems();f.length&&(f.forEach(v=>h.append(v)),h.append(s()))}createOpenRecentMenuItem(h){const f=E.URI.revive(h.uri),v=h.id,D=v==="openRecentFile"?{fileUri:f}:v==="openRecentWorkspace"?{workspaceUri:f}:{folderUri:f};return new S.MenuItem(this.likeAction(v,{label:h.label,click:(T,W,$)=>{const X=this.isOptionClick($);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[D],forceNewWindow:X,gotoLineMode:!1,remoteAuthority:h.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([f])}},!1))}isOptionClick(h){return!!(h&&(!R.isMacintosh&&(h.ctrlKey||h.shiftKey)||R.isMacintosh&&(h.metaKey||h.altKey)))}createRoleMenuItem(h,f,v){const D={label:this.mnemonicLabel(h),role:v,enabled:!0};return new S.MenuItem(this.withKeybinding(f,D))}setMacWindowMenu(h){const f=new S.MenuItem({label:m.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),v=new S.MenuItem({label:m.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),D=new S.MenuItem({label:m.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),T=this.createMenuItem(m.localize(20,null),"workbench.action.switchWindow"),W=[];this.currentEnableNativeTabs&&(W.push(s()),W.push(this.createMenuItem(m.localize(21,null),"workbench.action.newWindowTab")),W.push(this.createRoleMenuItem(m.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),W.push(this.createRoleMenuItem(m.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),W.push(this.createRoleMenuItem(m.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),W.push(this.createRoleMenuItem(m.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[f,v,s(),T,...W,s(),D].forEach($=>h.append($))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new S.MenuItem({label:this.mnemonicLabel(m.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:m.localize(27,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.mnemonicLabel(m.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:m.localize(29,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.mnemonicLabel(m.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new S.MenuItem({label:m.localize(31,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.mnemonicLabel(m.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(h,f,v,D){const T=this.mnemonicLabel(h),W=typeof f=="function"?f:(q,N,B)=>{const C=q?q.userSettingsLabel:null;let z=f;Array.isArray(f)&&(z=this.isOptionClick(B)?f[1]:f[0]),C&&B.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:C}):this.runActionInRenderer({type:"commandId",commandId:z})},$=typeof v=="boolean"?v:this.windowsMainService.getWindowCount()>0,X=typeof D=="boolean"?D:!1,x={label:T,click:W,enabled:$};X&&(x.type="checkbox",x.checked=X);let oe;return typeof f=="string"?oe=f:Array.isArray(f)&&(oe=f[0]),R.isMacintosh&&(oe==="editor.action.clipboardCutAction"?x.role="cut":oe==="editor.action.clipboardCopyAction"?x.role="copy":oe==="editor.action.clipboardPasteAction"&&(x.role="paste"),oe==="undo"?x.click=this.makeContextAwareClickHandler(W,{inDevTools:q=>q.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):oe==="redo"?x.click=this.makeContextAwareClickHandler(W,{inDevTools:q=>q.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):oe==="editor.action.selectAll"&&(x.click=this.makeContextAwareClickHandler(W,{inDevTools:q=>q.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.withKeybinding(oe,x))}makeContextAwareClickHandler(h,f){return(v,D,T)=>{const W=S.BrowserWindow.getFocusedWindow();if(!W)return f.inNoWindow();if(W.webContents.isDevToolsFocused()&&W.webContents.devToolsWebContents)return f.inDevTools(W.webContents.devToolsWebContents);h(v,D||W,T)}}runActionInRenderer(h){let f=S.BrowserWindow.getFocusedWindow();if(!f){const D=this.windowsMainService.getLastActiveWindow();(D==null?void 0:D.isMinimized())&&(f=D.win)}const v=f?this.windowsMainService.getWindowById(f.id):void 0;if(v){if(this.logService.trace("menubar#runActionInRenderer",h),R.isMacintosh&&!this.environmentMainService.isBuilt&&!v.isReady&&(h.type==="commandId"&&h.commandId==="workbench.action.toggleDevTools"||h.type!=="commandId"&&h.userSettingsLabel==="alt+cmd+i"))return;if(h.type==="commandId"){const D={id:h.commandId,from:"menu"};v.sendWhenReady("vscode:runAction",c.CancellationToken.None,D)}else{const D={userSettingsLabel:h.userSettingsLabel};v.sendWhenReady("vscode:runKeybinding",c.CancellationToken.None,D)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",h)}withKeybinding(h,f){const v=typeof h=="string"?this.keybindings[h]:void 0;if(v==null?void 0:v.label){if(v.isNative!==!1)f.accelerator=v.label,f.userSettingsLabel=v.userSettingsLabel;else if(typeof f.label=="string"){const D=f.label.indexOf("[");D>=0?f.label=`${f.label.substr(0,D)} [${v.label}]`:f.label=`${f.label} [${v.label}]`}}else f.accelerator=void 0;return f}likeAction(h,f,v=!f.accelerator){v&&(f=this.withKeybinding(h,f));const D=f.click;return f.click=(T,W,$)=>{this.reportMenuActionTelemetry(h),D&&D(T,W,$)},f}openUrl(h,f){this.nativeHostMainService.openExternal(void 0,h),this.reportMenuActionTelemetry(f)}reportMenuActionTelemetry(h){this.telemetryService.publicLog2("workbenchActionExecuted",{id:h,from:t})}mnemonicLabel(h){return(0,y.mnemonicMenuLabel)(h,!this.currentEnableMenuBarMnemonics)}};i.lastKnownMenubarStorageKey="lastKnownMenubarData",i=ue([ee(0,p.IUpdateService),ee(1,r.IConfigurationService),ee(2,d.IWindowsMainService),ee(3,L.IEnvironmentMainService),ee(4,w.ITelemetryService),ee(5,g.IWorkspacesHistoryMainService),ee(6,o.IStateMainService),ee(7,u.ILifecycleMainService),ee(8,I.ILogService),ee(9,l.INativeHostMainService),ee(10,n.IProductService)],i),e.Menubar=i;function s(){return new S.MenuItem({type:"separator"})}}),define(Q[232],J([0,1,231,6,4,17]),function(j,e,m,R,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,L.createDecorator)("menubarMainService");let P=class{constructor(w,p,n){this.instantiationService=w,this.lifecycleMainService=p,this.logService=n,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(m.Menubar)}async updateMenubar(w,p){this.logService.trace("menubarService#updateMenubar",w),(await this.menubar).updateMenu(p,w)}};P=ue([ee(0,L.IInstantiationService),ee(1,S.ILifecycleMainService),ee(2,R.ILogService)],P),e.MenubarMainService=P}),define(Q[233],J([0,1,24,27,47,72,8,149,35,50,25,38,230,14,17,16,6,61,99,5,22,62,3,29,4,10,7,15,73,213,52,42,2,51,13,30,39,26,21,32,55]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d,g,M,E,o,u,l,c,t,i,s,a,h,f,v,D,T,W,$,X,x,oe,q,N,B,C,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function V(O){return(0,i.isWorkspaceIdentifier)(O==null?void 0:O.workspace)}function _(O){return(0,i.isSingleFolderWorkspaceIdentifier)(O==null?void 0:O.workspace)}let A=class et extends $.Disposable{constructor(k,F,U,K,G,Y,Z,ne,se,re,te,le,ve,we,Se){super();this.machineId=k,this.initialUserEnv=F,this.logService=U,this.stateMainService=K,this.environmentMainService=G,this.lifecycleMainService=Y,this.backupMainService=Z,this.configurationService=ne,this.workspacesHistoryMainService=se,this.workspacesManagementMainService=re,this.instantiationService=te,this.dialogMainService=le,this.fileService=ve,this.productService=we,this.protocolMainService=Se,this._onDidOpenWindow=this._register(new u.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new u.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new u.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new u.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new D.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(k=>this._onDidSignalReadyWindow.fire(k.window))),this._register(this.onDidSignalReadyWindow(k=>{var F,U;if(((F=k.config)===null||F===void 0?void 0:F.extensionDevelopmentPath)||((U=k.config)===null||U===void 0?void 0:U.extensionTestsPath)){const K=new $.DisposableStore;if(K.add(u.Event.any(k.onDidClose,k.onDidDestroy)(()=>K.dispose())),k.config.extensionDevelopmentPath)for(const G of k.config.extensionDevelopmentPath)K.add(this.protocolMainService.addValidFileRoot(h.URI.file(G)));k.config.extensionTestsPath&&K.add(this.protocolMainService.addValidFileRoot(h.URI.file(k.config.extensionTestsPath)))}}))}openEmptyWindow(k,F){let U=this.environmentMainService.args;const K=(F==null?void 0:F.remoteAuthority)||void 0,G=!0,Y=F==null?void 0:F.forceReuseWindow,Z=!Y;return this.open(Object.assign(Object.assign({},k),{cli:U,forceEmpty:G,forceNewWindow:Z,forceReuseWindow:Y,remoteAuthority:K}))}open(k){this.logService.trace("windowsManager#open"),k.addMode&&(k.initialStartup||!this.getLastActiveWindow())&&(k.addMode=!1);const F=[],U=[],K=[],G=[],Y=[];let Z,ne=0;const se=this.getPathsToOpen(k);this.logService.trace("windowsManager#open pathsToOpen",se);for(const we of se)_(we)?k.addMode?F.push(we):U.push(we):V(we)?K.push(we):we.fileUri?(Z||(Z={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:we.remoteAuthority}),Z.filesToOpenOrCreate.push(we)):we.backupPath?Y.push({backupFolder:(0,P.basename)(we.backupPath),remoteAuthority:we.remoteAuthority}):ne++;k.diffMode&&(Z==null?void 0:Z.filesToOpenOrCreate.length)===2&&(Z.filesToDiff=Z.filesToOpenOrCreate,Z.filesToOpenOrCreate=[]),Z&&k.waitMarkerFileURI&&(Z.filesToWait={paths:[...Z.filesToDiff,...Z.filesToOpenOrCreate],waitMarkerFileUri:k.waitMarkerFileURI}),k.initialStartup?(G.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),K.push(...G),Y.push(...this.backupMainService.getEmptyWindowBackupPaths())):Y.length=0;const{windows:re,filesOpenedInWindow:te}=this.doOpen(k,K,U,Y,ne,Z,F);if(this.logService.trace(`windowsManager#open used window count ${re.length} (workspacesToOpen: ${K.length}, foldersToOpen: ${U.length}, emptyToRestore: ${Y.length}, emptyToOpen: ${ne})`),re.length>1)if(te)te.focus();else{const we=this.windowsStateHandler.state.lastActiveWindow&&!k.forceEmpty&&!k.cli._.length&&!k.cli["file-uri"]&&!k.cli["folder-uri"]&&!(k.urisToOpen&&k.urisToOpen.length);let Se=!0,Ae=!0;if(we){const ye=re.filter(me=>this.windowsStateHandler.state.lastActiveWindow&&me.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ye.length&&(ye[0].focus(),Se=!1,Ae=!1)}if(Se)for(let ye=re.length-1;ye>=0;ye--){const me=re[ye];if(!(me.openedWorkspace&&G.some(Ie=>me.openedWorkspace&&Ie.workspace.id===me.openedWorkspace.id)||me.backupPath&&Y.some(Ie=>me.backupPath&&Ie.backupFolder===(0,P.basename)(me.backupPath)))){me.focus(),Ae=!1;break}}Ae&&re[re.length-1].focus()}const le=Z&&Z.filesToDiff.length>0;if(!re.some(we=>we.isExtensionDevelopmentHost)&&!le&&!k.noRecentEntry){const we=[];for(const Se of se)V(Se)?we.push({label:Se.label,workspace:Se.workspace,remoteAuthority:Se.remoteAuthority}):_(Se)?we.push({label:Se.label,folderUri:Se.workspace.uri,remoteAuthority:Se.remoteAuthority}):Se.fileUri&&we.push({label:Se.label,fileUri:Se.fileUri,remoteAuthority:Se.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(we)}const ve=k.waitMarkerFileURI;return k.context===0&&ve&&re.length===1&&re[0]&&(async()=>{await re[0].whenClosedOrLoaded;try{await this.fileService.del(ve)}catch(we){}})(),re}doOpen(k,F,U,K,G,Y,Z){const ne=[];let se;function re(ye,me){ne.push(ye),me&&(se=ye,Y=void 0)}let{openFolderInNewWindow:te,openFilesInNewWindow:le}=this.shouldOpenNewWindow(k);if(!k.initialStartup&&Z.length>0){const ye=Z[0].remoteAuthority,me=this.getLastActiveWindowForAuthority(ye);me&&re(this.doAddFoldersToExistingWindow(me,Z.map(Ie=>Ie.workspace.uri)))}const ve=U.length+F.length+K.length;if(Y&&ve===0){const ye=Y.filesToOpenOrCreate[0]||Y.filesToDiff[0],me=this.getWindows().filter(Re=>Y&&Re.remoteAuthority===Y.remoteAuthority);let Ie;(ye==null?void 0:ye.fileUri)&&!le&&((k.context===4||k.context===0||k.context===1)&&(Ie=(0,o.findWindowOnFile)(me,ye.fileUri,Re=>Re.configPath.scheme===a.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Re.configPath):void 0)),Ie||(Ie=this.doGetLastActiveWindow(me))),Ie?(0,i.isWorkspaceIdentifier)(Ie.openedWorkspace)?F.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):(0,i.isSingleFolderWorkspaceIdentifier)(Ie.openedWorkspace)?U.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):re(this.doOpenFilesInExistingWindow(k,Ie,Y),!0):re(this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,filesToOpen:Y,forceNewWindow:!0,remoteAuthority:Y.remoteAuthority,forceNewTabbedWindow:k.forceNewTabbedWindow}),!0)}const we=(0,w.distinct)(F,ye=>ye.workspace.id);if(we.length>0){const ye=(0,w.coalesce)(we.map(me=>(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.configPath)));if(ye.length>0){const me=ye[0],Ie=(Y==null?void 0:Y.remoteAuthority)===me.remoteAuthority?Y:void 0;re(this.doOpenFilesInExistingWindow(k,me,Ie),!!Ie),te=!0}we.forEach(me=>{if(!ye.some(Fe=>Fe.openedWorkspace&&Fe.openedWorkspace.id===me.workspace.id)){const Ie=me.remoteAuthority,Re=(Y==null?void 0:Y.remoteAuthority)===Ie?Y:void 0;re(this.doOpenFolderOrWorkspace(k,me,te,Re),!!Re),te=!0}})}const Se=(0,w.distinct)(U,ye=>f.extUriBiasedIgnorePathCase.getComparisonKey(ye.workspace.uri));if(Se.length>0){const ye=(0,w.coalesce)(Se.map(me=>(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.uri)));if(ye.length>0){const me=ye[0],Ie=(Y==null?void 0:Y.remoteAuthority)===me.remoteAuthority?Y:void 0;re(this.doOpenFilesInExistingWindow(k,me,Ie),!!Ie),te=!0}Se.forEach(me=>{if(!ye.some(Fe=>(0,i.isSingleFolderWorkspaceIdentifier)(Fe.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(Fe.openedWorkspace.uri,me.workspace.uri))){const Ie=me.remoteAuthority,Re=(Y==null?void 0:Y.remoteAuthority)===Ie?Y:void 0;re(this.doOpenFolderOrWorkspace(k,me,te,Re),!!Re),te=!0}})}const Ae=(0,w.distinct)(K,ye=>ye.backupFolder);if(Ae.length>0&&Ae.forEach(ye=>{const me=ye.remoteAuthority,Ie=(Y==null?void 0:Y.remoteAuthority)===me?Y:void 0;re(this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,filesToOpen:Ie,remoteAuthority:me,forceNewWindow:!0,forceNewTabbedWindow:k.forceNewTabbedWindow,emptyWindowBackupInfo:ye}),!!Ie),te=!0}),ne.length===0||Y){Y&&!G&&G++;const ye=Y?Y.remoteAuthority:k.remoteAuthority;for(let me=0;me<G;me++)re(this.doOpenEmpty(k,te,ye,Y),!!Y),te=!0}return{windows:(0,w.distinct)(ne),filesOpenedInWindow:se}}doOpenFilesInExistingWindow(k,F,U){var K;this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),F.focus();const G={filesToOpenOrCreate:U==null?void 0:U.filesToOpenOrCreate,filesToDiff:U==null?void 0:U.filesToDiff,filesToWait:U==null?void 0:U.filesToWait,termProgram:(K=k==null?void 0:k.userEnv)===null||K===void 0?void 0:K.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",N.CancellationToken.None,G),F}doAddFoldersToExistingWindow(k,F){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),k.focus();const U={foldersToAdd:F};return k.sendWhenReady("vscode:addFolders",N.CancellationToken.None,U),k}doOpenEmpty(k,F,U,K,G){return!F&&!G&&typeof k.contextWindowId=="number"&&(G=this.getWindowById(k.contextWindowId)),this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,remoteAuthority:U,forceNewWindow:F,forceNewTabbedWindow:k.forceNewTabbedWindow,filesToOpen:K,windowToUse:G})}doOpenFolderOrWorkspace(k,F,U,K,G){return!U&&!G&&typeof k.contextWindowId=="number"&&(G=this.getWindowById(k.contextWindowId)),this.openInBrowserWindow({workspace:F.workspace,userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:U,forceNewTabbedWindow:k.forceNewTabbedWindow,filesToOpen:K,windowToUse:G})}getPathsToOpen(k){var F;let U,K=!1,G=!1;if(k.urisToOpen&&k.urisToOpen.length>0?(U=this.doExtractPathsFromAPI(k),K=!0):k.forceEmpty?U=[Object.create(null)]:k.cli._.length||k.cli["folder-uri"]||k.cli["file-uri"]?(U=this.doExtractPathsFromCLI(k.cli),U.length===0&&U.push(Object.create(null)),K=!0):(U=this.doGetPathsFromLastSession(),U.length===0&&U.push(Object.create(null)),G=!0),!k.addMode&&K){const Y=U.filter(Z=>_(Z));if(Y.length>1){const Z=Y[0].remoteAuthority;if(Y.every(ne=>ne.remoteAuthority===Z)){const ne=this.workspacesManagementMainService.createUntitledWorkspaceSync(Y.map(se=>({uri:se.workspace.uri})));U.push({workspace:ne,remoteAuthority:Z}),U=U.filter(se=>!_(se))}}}return k.initialStartup&&!G&&((F=this.configurationService.getValue("window"))===null||F===void 0?void 0:F.restoreWindows)==="preserve"&&U.unshift(...this.doGetPathsFromLastSession().filter(Y=>V(Y)||_(Y)||Y.backupPath)),U}doExtractPathsFromAPI(k){const F=[],U={gotoLineMode:k.gotoLineMode,remoteAuthority:k.remoteAuthority};for(const K of(0,w.coalesce)(k.urisToOpen||[])){const G=this.resolveOpenable(K,U);if(G)G.label=K.label,F.push(G);else{const Y=this.resourceFromOpenable(K),Z={title:this.productService.nameLong,type:"info",buttons:[(0,r.localize)(0,null)],message:Y.scheme===a.Schemas.file?(0,r.localize)(1,null):(0,r.localize)(2,null),detail:Y.scheme===a.Schemas.file?(0,r.localize)(3,null,(0,q.getPathLabel)(Y.fsPath,this.environmentMainService)):(0,r.localize)(4,null,Y.toString()),noLink:!0};this.dialogMainService.showMessageBox(Z,(0,x.withNullAsUndefined)(y.BrowserWindow.getFocusedWindow()))}}return F}doExtractPathsFromCLI(k){const F=[],U={ignoreFileNotFound:!0,gotoLineMode:k.goto,remoteAuthority:k.remote||void 0,forceOpenWorkspaceAsFile:!1},K=k["folder-uri"];if(K)for(const Z of K){const ne=this.cliArgToUri(Z);if(ne){const se=this.resolveOpenable({folderUri:ne},U);se&&F.push(se)}}const G=k["file-uri"];if(G)for(const Z of G){const ne=this.cliArgToUri(Z);if(ne){const se=this.resolveOpenable((0,i.hasWorkspaceFileExtension)(Z)?{workspaceUri:ne}:{fileUri:ne},U);se&&F.push(se)}}const Y=k._;for(const Z of Y){const ne=U.remoteAuthority?this.doResolvePathRemote(Z,U):this.doResolveFilePath(Z,U);ne&&F.push(ne)}return F}cliArgToUri(k){try{const F=h.URI.parse(k);if(!F.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${k}`);return}return F}catch(F){this.logService.error(`Invalid URI input string: ${k}, ${F.message}`)}}doGetPathsFromLastSession(){const k=this.getRestoreWindowsSetting();switch(k){case"none":return[];case"one":case"all":case"preserve":case"folders":const F=[];k!=="one"&&F.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&F.push(this.windowsStateHandler.state.lastActiveWindow);const U=[];for(const K of F)if(K.workspace){const G=this.resolveOpenable({workspaceUri:K.workspace.configPath},{remoteAuthority:K.remoteAuthority});V(G)&&U.push(G)}else if(K.folderUri){const G=this.resolveOpenable({folderUri:K.folderUri},{remoteAuthority:K.remoteAuthority});_(G)&&U.push(G)}else k!=="folders"&&K.backupPath&&U.push({backupPath:K.backupPath,remoteAuthority:K.remoteAuthority});return U}}getRestoreWindowsSetting(){let k;if(this.lifecycleMainService.wasRestarted)k="all";else{const F=this.configurationService.getValue("window");k=(F==null?void 0:F.restoreWindows)||"all",["preserve","all","folders","one","none"].includes(k)||(k="all")}return k}resolveOpenable(k,F={}){let U=this.resourceFromOpenable(k);return U.scheme===a.Schemas.file?((0,E.isFileToOpen)(k)&&(F=Object.assign(Object.assign({},F),{forceOpenWorkspaceAsFile:!0})),this.doResolveFilePath(U.fsPath,F)):this.doResolveRemoteOpenable(k,F)}doResolveRemoteOpenable(k,F){let U=this.resourceFromOpenable(k);const K=(0,v.getRemoteAuthority)(U)||F.remoteAuthority;if(U=(0,f.removeTrailingPathSeparator)((0,f.normalizePath)(U)),(0,E.isFileToOpen)(k)){if(F.gotoLineMode){const{path:G,line:Y,column:Z}=(0,oe.parseLineAndColumnAware)(U.path);return{fileUri:U.with({path:G}),lineNumber:Y,columnNumber:Z,remoteAuthority:K}}return{fileUri:U,remoteAuthority:K}}else if((0,E.isWorkspaceToOpen)(k))return{workspace:(0,T.getWorkspaceIdentifier)(U),remoteAuthority:K};return{workspace:(0,T.getSingleFolderWorkspaceIdentifier)(U),remoteAuthority:K}}resourceFromOpenable(k){return(0,E.isWorkspaceToOpen)(k)?k.workspaceUri:(0,E.isFolderToOpen)(k)?k.folderUri:k.fileUri}doResolveFilePath(k,F){let U,K;F.gotoLineMode&&({path:k,line:U,column:K}=(0,oe.parseLineAndColumnAware)(k)),k=(0,oe.sanitizeFilePath)((0,P.normalize)(k),(0,C.cwd)());try{const G=(0,m.statSync)(k);if(G.isFile()){if(!F.forceOpenWorkspaceAsFile){const Y=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(k));if(Y)return{workspace:{id:Y.id,configPath:Y.configPath},remoteAuthority:Y.remoteAuthority,exists:!0}}return{fileUri:h.URI.file(k),lineNumber:U,columnNumber:K,exists:!0}}else if(G.isDirectory())return{workspace:(0,T.getSingleFolderWorkspaceIdentifier)(h.URI.file(k),G),exists:!0}}catch(G){const Y=h.URI.file(k);if(this.workspacesHistoryMainService.removeRecentlyOpened([Y]),F.ignoreFileNotFound)return{fileUri:Y,exists:!1}}}doResolvePathRemote(k,F){const U=k.charCodeAt(0),K=F.remoteAuthority;let G,Y;F.gotoLineMode&&({path:k,line:G,column:Y}=(0,oe.parseLineAndColumnAware)(k)),U!==47&&((0,oe.isWindowsDriveLetter)(U)&&k.charCodeAt(k.charCodeAt(1))===58&&(k=(0,oe.toSlashes)(k)),k=`/${k}`);const Z=h.URI.from({scheme:a.Schemas.vscodeRemote,authority:K,path:k});if(k.charCodeAt(k.length-1)!==47){if((0,i.hasWorkspaceFileExtension)(k))return F.forceOpenWorkspaceAsFile?{fileUri:Z,lineNumber:G,columnNumber:Y,remoteAuthority:F.remoteAuthority}:{workspace:(0,T.getWorkspaceIdentifier)(Z),remoteAuthority:K};if(F.gotoLineMode||P.posix.basename(k).indexOf(".")!==-1)return{fileUri:Z,lineNumber:G,columnNumber:Y,remoteAuthority:K}}return{workspace:(0,T.getSingleFolderWorkspaceIdentifier)(Z),remoteAuthority:K}}shouldOpenNewWindow(k){const F=this.configurationService.getValue("window"),U=(F==null?void 0:F.openFoldersInNewWindow)||"default",K=(F==null?void 0:F.openFilesInNewWindow)||"off";let G=(k.preferNewWindow||k.forceNewWindow)&&!k.forceReuseWindow;!k.forceNewWindow&&!k.forceReuseWindow&&(U==="on"||U==="off")&&(G=U==="on");let Y=!1;return k.forceNewWindow||k.forceReuseWindow?Y=!!k.forceNewWindow&&!k.forceReuseWindow:(t.isMacintosh?k.context===1&&(Y=!0):k.context!==3&&k.context!==2&&!(k.userEnv&&k.userEnv.TERM_PROGRAM==="vscode")&&(Y=!0),!k.cli.extensionDevelopmentPath&&(K==="on"||K==="off")&&(Y=K==="on")),{openFolderInNewWindow:!!G,openFilesInNewWindow:Y}}openExtensionDevelopmentHostWindow(k,F){const U=(0,o.findWindowOnExtensionDevelopmentPath)(this.getWindows(),k);if(U)return this.lifecycleMainService.reload(U,F.cli),U.focus(),[U];let K=F.cli["folder-uri"]||[],G=F.cli["file-uri"]||[],Y=F.cli._;if(!Y.length&&!K.length&&!G.length&&!F.cli.extensionTestsPath){const re=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,te=re&&(re.workspace||re.folderUri);te&&(h.URI.isUri(te)?te.scheme===a.Schemas.file?Y=[te.fsPath]:K=[te.toString()]:te.configPath.scheme===a.Schemas.file?Y=[(0,f.originalFSPath)(te.configPath)]:G=[te.configPath.toString()])}let Z=F.remoteAuthority;for(const re of k)if(re.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const te=h.URI.parse(re),le=(0,v.getRemoteAuthority)(te);le&&(Z?le!==Z&&this.logService.error("more than one extension development path authority"):Z=le)}Y=Y.filter(re=>{const te=h.URI.file(re);return(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),te)?!1:(0,v.getRemoteAuthority)(te)===Z}),K=K.filter(re=>{const te=this.cliArgToUri(re);return te&&!!(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),te)?!1:te?(0,v.getRemoteAuthority)(te)===Z:!1}),G=G.filter(re=>{const te=this.cliArgToUri(re);return te&&!!(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),te)?!1:te?(0,v.getRemoteAuthority)(te)===Z:!1}),F.cli._=Y,F.cli["folder-uri"]=K,F.cli["file-uri"]=G;const ne=!Y.length&&!K.length&&!G.length,se={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:ne,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:Z};return this.open(se)}openInBrowserWindow(k){var F,U,K,G,Y;const Z=this.configurationService.getValue("window"),ne=Object.assign(Object.assign(Object.assign({},this.environmentMainService.args),k.cli),{machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,backupPath:k.emptyWindowBackupInfo?(0,P.join)(this.environmentMainService.backupHome,k.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:k.remoteAuthority,workspace:k.workspace,userEnv:Object.assign(Object.assign({},this.initialUserEnv),k.userEnv),filesToOpenOrCreate:(F=k.filesToOpen)===null||F===void 0?void 0:F.filesToOpenOrCreate,filesToDiff:(U=k.filesToOpen)===null||U===void 0?void 0:U.filesToDiff,filesToWait:(K=k.filesToOpen)===null||K===void 0?void 0:K.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:L.default,isInitialStartup:k.initialStartup,perfMarks:(0,S.getMarks)(),os:{release:(0,R.release)(),hostname:(0,R.hostname)()},zoomLevel:typeof(Z==null?void 0:Z.zoomLevel)=="number"?Z.zoomLevel:void 0,autoDetectHighContrast:(G=Z==null?void 0:Z.autoDetectHighContrast)!==null&&G!==void 0?G:!0,accessibilitySupport:y.app.accessibilitySupportEnabled,colorScheme:{dark:y.nativeTheme.shouldUseDarkColors,highContrast:y.nativeTheme.shouldUseInvertedColorScheme||y.nativeTheme.shouldUseHighContrastColors}});let se;if(!k.forceNewWindow&&!k.forceNewTabbedWindow&&(se=k.windowToUse||this.getLastActiveWindow(),se&&se.focus()),se){const re=se.config;!ne.extensionDevelopmentPath&&re&&!!re.extensionDevelopmentPath&&(ne.extensionDevelopmentPath=re.extensionDevelopmentPath,ne.verbose=re.verbose,ne["inspect-brk-extensions"]=re["inspect-brk-extensions"],ne.debugId=re.debugId,ne["inspect-extensions"]=re["inspect-extensions"],ne["extensions-dir"]=re["extensions-dir"])}else{const re=this.windowsStateHandler.getNewWindowState(ne);(0,S.mark)("code/willCreateCodeWindow");const te=se=this.instantiationService.createInstance(I.CodeWindow,{state:re,extensionDevelopmentPath:ne.extensionDevelopmentPath,isExtensionTestHost:!!ne.extensionTestsPath});if((0,S.mark)("code/didCreateCodeWindow"),k.forceNewTabbedWindow){const ve=this.getLastActiveWindow();ve&&ve.addTabbedWindow(te)}et.WINDOWS.push(te),this._onDidOpenWindow.fire(te),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,W.once)(te.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(te)),(0,W.once)(te.onDidClose)(()=>this.onWindowClosed(te)),(0,W.once)(te.onDidDestroy)(()=>this._onDidDestroyWindow.fire(te));const le=(0,x.assertIsDefined)((Y=te.win)===null||Y===void 0?void 0:Y.webContents);le.removeAllListeners("devtools-reload-page"),le.on("devtools-reload-page",()=>this.lifecycleMainService.reload(te)),this.lifecycleMainService.registerWindow(te)}return ne.windowId=se.id,se.isReady?this.lifecycleMainService.unload(se,4).then(re=>{re||this.doOpenInBrowserWindow(se,ne,k)}):this.doOpenInBrowserWindow(se,ne,k),se}doOpenInBrowserWindow(k,F,U){if(!F.extensionDevelopmentPath)if((0,i.isWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:F.workspace,remoteAuthority:F.remoteAuthority});else if((0,i.isSingleFolderWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerFolderBackupSync(F.workspace.uri);else{const K=U.emptyWindowBackupInfo&&U.emptyWindowBackupInfo.backupFolder;F.backupPath=this.backupMainService.registerEmptyWindowBackupSync(K,F.remoteAuthority)}k.load(F)}onWindowClosed(k){const F=et.WINDOWS.indexOf(k);et.WINDOWS.splice(F,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const k=y.BrowserWindow.getFocusedWindow();if(k)return this.getWindowById(k.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(k){return this.doGetLastActiveWindow(this.getWindows().filter(F=>F.remoteAuthority===k))}doGetLastActiveWindow(k){const F=Math.max.apply(Math,k.map(U=>U.lastFocusTime));return k.find(U=>U.lastFocusTime===F)}sendToFocused(k,...F){const U=this.getFocusedWindow()||this.getLastActiveWindow();U&&U.sendWhenReady(k,N.CancellationToken.None,...F)}sendToAll(k,F,U){for(const K of this.getWindows())U&&U.indexOf(K.id)>=0||K.sendWhenReady(k,N.CancellationToken.None,F)}getWindows(){return et.WINDOWS}getWindowCount(){return et.WINDOWS.length}getWindowById(k){const F=this.getWindows().filter(U=>U.id===k);return(0,w.firstOrDefault)(F)}getWindowByWebContents(k){const F=y.BrowserWindow.fromWebContents(k);if(!!F)return this.getWindowById(F.id)}};A.WINDOWS=[],A=ue([ee(2,M.ILogService),ee(3,b.IStateMainService),ee(4,n.IEnvironmentMainService),ee(5,d.ILifecycleMainService),ee(6,p.IBackupMainService),ee(7,g.IConfigurationService),ee(8,c.IWorkspacesHistoryMainService),ee(9,T.IWorkspacesManagementMainService),ee(10,s.IInstantiationService),ee(11,X.IDialogMainService),ee(12,B.IFileService),ee(13,l.IProductService),ee(14,z.IProtocolMainService)],A),e.WindowsMainService=A}),define(Q[234],J([0,1,52,34,62,50]),function(j,e,m,R,L,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let P=class{constructor(w,p,n,b){this.workspacesManagementMainService=w,this.windowsMainService=p,this.workspacesHistoryMainService=n,this.backupMainService=b,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(w,p){const n=this.windowsMainService.getWindowById(w);if(n)return this.workspacesManagementMainService.enterWorkspace(n,this.windowsMainService.getWindows(),p)}createUntitledWorkspace(w,p,n){return this.workspacesManagementMainService.createUntitledWorkspace(p,n)}deleteUntitledWorkspace(w,p){return this.workspacesManagementMainService.deleteUntitledWorkspace(p)}getWorkspaceIdentifier(w,p){return this.workspacesManagementMainService.getWorkspaceIdentifier(p)}async getRecentlyOpened(w){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(w))}async addRecentlyOpened(w,p){return this.workspacesHistoryMainService.addRecentlyOpened(p)}async removeRecentlyOpened(w,p){return this.workspacesHistoryMainService.removeRecentlyOpened(p)}async clearRecentlyOpened(w){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};P=ue([ee(0,m.IWorkspacesManagementMainService),ee(1,R.IWindowsMainService),ee(2,L.IWorkspacesHistoryMainService),ee(3,S.IBackupMainService)],P),e.WorkspacesMainService=P}),define(Q[235],J([0,1,27,24,14,3,233,17,90,40,203,33,122,84,223,100,4,71,69,6,38,25,16,97,204,31,96,198,199,195,22,217,2,34,7,29,234,66,228,226,225,229,177,18,206,218,232,119,8,15,131,10,227,98,211,216,50,62,205,52,70,156,41,51,13,39,208,76,21,43,28,19,88,209,194,54,30,9,168,182,42,73,75,89,187]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d,g,M,E,o,u,l,c,t,i,s,a,h,f,v,D,T,W,$,X,x,oe,q,N,B,C,z,V,_,A,O,k,F,U,K,G,Y,Z,ne,se,re,te,le,ve,we,Se,Ae,ye,me,Ie,Re,Fe,Ne,qe,Ve,tt,ze,at,it,dt,Ge,ft,lt,H,ie,ae,ce,de,be,Me,Te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let We=class extends $.Disposable{constructor(he,pe,fe,ge,Ee,Le,ke,De,Pe,Ue){super();this.mainProcessNodeIpcServer=he,this.userEnv=pe,this.mainInstantiationService=fe,this.logService=ge,this.environmentMainService=Ee,this.lifecycleMainService=Le,this.configurationService=ke,this.stateMainService=De,this.fileService=Pe,this.productService=Ue,this.registerListeners()}registerListeners(){(0,A.setUnexpectedErrorHandler)(fe=>this.onUnexpectedError(fe)),process.on("uncaughtException",fe=>this.onUnexpectedError(fe)),process.on("unhandledRejection",fe=>(0,A.onUnexpectedError)(fe)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,U.registerContextMenuListener)(),L.app.on("accessibility-support-changed",(fe,ge)=>{var Ee;(Ee=this.windowsMainService)===null||Ee===void 0||Ee.sendToAll("vscode:accessibilitySupportChanged",ge)}),L.app.on("activate",(fe,ge)=>{var Ee;this.logService.trace("app#activate"),ge||(Ee=this.windowsMainService)===null||Ee===void 0||Ee.openEmptyWindow({context:1})}),L.app.on("remote-require",(fe,ge,Ee)=>{this.logService.trace("app#on(remote-require): prevented"),fe.preventDefault()}),L.app.on("remote-get-global",(fe,ge,Ee)=>{this.logService.trace(`app#on(remote-get-global): prevented on ${Ee}`),fe.preventDefault()}),L.app.on("remote-get-builtin",(fe,ge,Ee)=>{this.logService.trace(`app#on(remote-get-builtin): prevented on ${Ee}`),Ee!=="clipboard"&&fe.preventDefault()}),L.app.on("remote-get-current-window",fe=>{this.logService.trace("app#on(remote-get-current-window): prevented"),fe.preventDefault()}),L.app.on("remote-get-current-web-contents",fe=>{this.environmentMainService.args.driver||(this.logService.trace("app#on(remote-get-current-web-contents): prevented"),fe.preventDefault())}),L.app.on("web-contents-created",(fe,ge)=>{ge.on("will-attach-webview",(Le,ke,De)=>{const Pe=Ue=>{if(!Ue)return!1;const $e=x.URI.parse(Ue);if($e.scheme===Z.Schemas.vscodeWebview)return $e.path==="/index.html"||$e.path==="/electron-browser-index.html";const Ye=$e.fsPath.toLowerCase(),Xe=x.URI.file(this.environmentMainService.appRoot).fsPath.toLowerCase();return Ye.startsWith(Xe+K.sep)};delete ke.preload,ke.nodeIntegration=!1,!(Pe(De.src)&&Pe(ke.preloadURL))&&(delete ke.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),Le.preventDefault())}),ge.on("will-navigate",Le=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Le.preventDefault()}),ge.on("new-window",(Le,ke)=>{var De;Le.preventDefault(),(De=this.nativeHostMainService)===null||De===void 0||De.openExternal(void 0,ke)});const Ee=Le=>Le.startsWith(`${Z.Schemas.vscodeWebview}://`);L.session.defaultSession.setPermissionRequestHandler((Le,ke,De,Pe)=>Ee(Pe.requestingUrl)?De(ke==="clipboard-read"):De(!1)),L.session.defaultSession.setPermissionCheckHandler((Le,ke,De,Pe)=>Ee(Pe.requestingUrl)?ke==="clipboard-read":!1)});let he=[],pe;L.app.on("open-file",(fe,ge)=>{this.logService.trace("app#open-file: ",ge),fe.preventDefault(),he.push(this.getWindowOpenableFromPathSync(ge)),pe!==void 0&&(clearTimeout(pe),pe=void 0),pe=setTimeout(()=>{var Ee;(Ee=this.windowsMainService)===null||Ee===void 0||Ee.open({context:1,cli:this.environmentMainService.args,urisToOpen:he,gotoLineMode:!1,preferNewWindow:!0}),he=[],pe=void 0},100)}),L.app.on("new-window-for-tab",()=>{var fe;(fe=this.windowsMainService)===null||fe===void 0||fe.openEmptyWindow({context:4})}),L.ipcMain.handle("vscode:fetchShellEnv",fe=>{var ge;const Ee=(ge=this.windowsMainService)===null||ge===void 0?void 0:ge.getWindowByWebContents(fe.sender);let Le,ke;return(Ee==null?void 0:Ee.config)?(Le=Ee.config,ke=Object.assign(Object.assign({},process.env),Ee.config.userEnv)):(Le=this.environmentMainService.args,ke=process.env),(0,w.resolveShellEnv)(this.logService,Le,ke)}),L.ipcMain.handle("vscode:writeNlsFile",(fe,ge,Ee)=>{const Le=this.validateNlsPath([ge]);if(!Le||typeof Ee!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Le,at.VSBuffer.fromString(Ee))}),L.ipcMain.handle("vscode:readNlsFile",async(fe,...ge)=>{const Ee=this.validateNlsPath(ge);if(!Ee)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ee)).value.toString()}),L.ipcMain.on("vscode:toggleDevTools",fe=>fe.sender.toggleDevTools()),L.ipcMain.on("vscode:openDevTools",fe=>fe.sender.openDevTools()),L.ipcMain.on("vscode:reloadWindow",fe=>fe.sender.reload())}validateNlsPath(he){let pe;for(const fe of he)typeof fe=="string"&&(typeof pe!="string"?pe=fe:pe=(0,K.join)(pe,fe));if(!(typeof pe!="string"||!(0,K.isAbsolute)(pe)||!(0,lt.isEqualOrParent)(pe,this.environmentMainService.cachedLanguagesPath,!S.isLinux)))return x.URI.file(pe)}onUnexpectedError(he){var pe;if(he){const fe={message:`[uncaught exception in main]: ${he.message}`,stack:he.stack};(pe=this.windowsMainService)===null||pe===void 0||pe.sendToFocused("vscode:reportError",JSON.stringify(fe))}this.logService.error(`[uncaught exception in main]: ${he}`),he.stack&&this.logService.error(he.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);try{const Pe=x.URI.file(this.environmentMainService.chromeCachedDataDir);this.logService.trace(`Deleting Chrome cached data path: ${Pe.fsPath}`),await this.fileService.del(Pe,{recursive:!0})}catch(Pe){Pe.fileOperationResult!==1&&this.logService.error(Pe)}const he=this.productService.win32AppUserModelId;S.isWindows&&he&&L.app.setAppUserModelId(he);try{S.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!L.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&L.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Pe){this.logService.error(Pe)}const pe=new I.Server;this.logService.trace("Resolving machine identifier...");const fe=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${fe}`);const{sharedProcess:ge,sharedProcessReady:Ee,sharedProcessClient:Le}=this.setupSharedProcess(fe),ke=await this.initServices(fe,ge,Ee);if(this.environmentMainService.driverHandle){const Pe=await(0,k.serve)(pe,this.environmentMainService.driverHandle,this.environmentMainService,ke);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Pe)}this._register(ke.createInstance(W.ProxyAuthHandler)),ke.invokeFunction(Pe=>this.initChannels(Pe,pe,Le));const De=ke.invokeFunction(Pe=>this.openFirstWindow(Pe,pe));ke.invokeFunction(Pe=>this.afterWindowOpen(Pe,ge)),this.environmentMainService.args.trace&&ke.invokeFunction(Pe=>this.stopTracingEventually(Pe,De))}async resolveMachineId(){let he=this.stateMainService.getItem(a.machineIdKey);return(!he||S.isMacintosh&&he==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(he=await(0,N.getMachineId)(),this.stateMainService.setItem(a.machineIdKey,he)),he}setupSharedProcess(he){const pe=this._register(this.mainInstantiationService.createInstance(d.SharedProcess,he,this.userEnv)),fe=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ee=await pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new y.Client(Ee,"main")})(),ge=(async()=>(await pe.whenReady(),fe))();return{sharedProcess:pe,sharedProcessReady:ge,sharedProcessClient:fe}}async initServices(he,pe,fe){const ge=new E.ServiceCollection;switch(process.platform){case"win32":ge.set(p.IUpdateService,new o.SyncDescriptor(B.Win32UpdateService));break;case"linux":S.isLinuxSnap?ge.set(p.IUpdateService,new o.SyncDescriptor(ne.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ge.set(p.IUpdateService,new o.SyncDescriptor(C.LinuxUpdateService));break;case"darwin":ge.set(p.IUpdateService,new o.SyncDescriptor(z.DarwinUpdateService));break}ge.set(X.IWindowsMainService,new o.SyncDescriptor(P.WindowsMainService,[he,this.userEnv])),ge.set(Ie.IDialogMainService,new o.SyncDescriptor(Ie.DialogMainService)),ge.set(g.ILaunchMainService,new o.SyncDescriptor(g.LaunchMainService)),ge.set(Ae.IDiagnosticsService,b.ProxyChannel.toService((0,b.getDelayedChannel)(fe.then(Le=>Le.getChannel("diagnostics"))))),ge.set(V.IIssueMainService,new o.SyncDescriptor(V.IssueMainService,[this.userEnv])),ge.set(it.IEncryptionMainService,new o.SyncDescriptor(it.EncryptionMainService,[he])),ge.set(Ge.IKeyboardLayoutMainService,new o.SyncDescriptor(Ge.KeyboardLayoutMainService)),ge.set(me.INativeHostMainService,new o.SyncDescriptor(me.NativeHostMainService,[pe])),ge.set(qe.IWebviewManagerService,new o.SyncDescriptor(Ne.WebviewMainService)),ge.set(oe.IWorkspacesService,new o.SyncDescriptor(q.WorkspacesMainService)),ge.set(Se.IWorkspacesManagementMainService,new o.SyncDescriptor(Se.WorkspacesManagementMainService)),ge.set(ve.IWorkspacesHistoryMainService,new o.SyncDescriptor(ve.WorkspacesHistoryMainService)),ge.set(F.IMenubarMainService,new o.SyncDescriptor(F.MenubarMainService)),ge.set(ie.IExtensionUrlTrustService,new o.SyncDescriptor(ae.ExtensionUrlTrustService)),ge.set(se.IStorageMainService,new o.SyncDescriptor(se.StorageMainService)),S.isWindows?ge.set(Me.IExternalTerminalMainService,new o.SyncDescriptor(Te.WindowsExternalTerminalService)):S.isMacintosh?ge.set(Me.IExternalTerminalMainService,new o.SyncDescriptor(Te.MacExternalTerminalService)):S.isLinux&&ge.set(Me.IExternalTerminalMainService,new o.SyncDescriptor(Te.LinuxExternalTerminalService));const Ee=new te.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ge.set(le.IBackupMainService,Ee),ge.set(i.IURLService,new o.SyncDescriptor(we.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const Le=(0,b.getDelayedChannel)(fe.then($e=>$e.getChannel("telemetryAppender"))),ke=new f.TelemetryAppenderClient(Le),De=(0,D.resolveCommonProperties)(this.fileService,(0,m.release)(),(0,m.hostname)(),process.arch,this.productService.commit,this.productService.version,he,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Pe=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Ue={appender:ke,commonProperties:De,piiPaths:Pe,sendErrorTelemetry:!0};ge.set(a.ITelemetryService,new o.SyncDescriptor(v.TelemetryService,[Ue]))}else ge.set(a.ITelemetryService,h.NullTelemetryService);return await Ee.initialize(),this.mainInstantiationService.createChild(ge)}initChannels(he,pe,fe){const ge=b.ProxyChannel.fromService(he.get(g.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ge);const Ee=new n.UpdateChannel(he.get(p.IUpdateService));pe.registerChannel("update",Ee);const Le=b.ProxyChannel.fromService(he.get(V.IIssueMainService));pe.registerChannel("issue",Le);const ke=b.ProxyChannel.fromService(he.get(it.IEncryptionMainService));pe.registerChannel("encryption",ke);const De=b.ProxyChannel.fromService(he.get(be.ISignService));pe.registerChannel("sign",De);const Pe=b.ProxyChannel.fromService(he.get(Ge.IKeyboardLayoutMainService));pe.registerChannel("keyboardLayout",Pe),this.nativeHostMainService=he.get(me.INativeHostMainService);const Ue=b.ProxyChannel.fromService(this.nativeHostMainService);pe.registerChannel("nativeHost",Ue),fe.then(je=>je.registerChannel("nativeHost",Ue));const $e=b.ProxyChannel.fromService(he.get(oe.IWorkspacesService));pe.registerChannel("workspaces",$e);const Ye=b.ProxyChannel.fromService(he.get(F.IMenubarMainService));pe.registerChannel("menubar",Ye);const Xe=b.ProxyChannel.fromService(he.get(i.IURLService));pe.registerChannel("url",Xe);const Oe=b.ProxyChannel.fromService(he.get(ie.IExtensionUrlTrustService));pe.registerChannel("extensionUrlTrust",Oe);const ct=b.ProxyChannel.fromService(he.get(qe.IWebviewManagerService));pe.registerChannel("webview",ct);const xe=this._register(new re.StorageDatabaseChannel(this.logService,he.get(se.IStorageMainService)));pe.registerChannel("storage",xe),fe.then(je=>je.registerChannel("storage",xe));const nt=b.ProxyChannel.fromService(he.get(Me.IExternalTerminalMainService));pe.registerChannel("externalTerminal",nt);const rt=new _.LogLevelChannel(he.get(u.ILogService));pe.registerChannel("logLevel",rt),fe.then(je=>je.registerChannel("logLevel",rt));const st=new _.LoggerChannel(he.get(u.ILoggerService));pe.registerChannel("logger",st),fe.then(je=>je.registerChannel("logger",st));const ot=new ye.ElectronExtensionHostDebugBroadcastChannel(he.get(X.IWindowsMainService));pe.registerChannel("extensionhostdebugservice",ot)}openFirstWindow(he,pe){const fe=this.windowsMainService=he.get(X.IWindowsMainService),ge=he.get(i.IURLService),Ee=he.get(me.INativeHostMainService);this.lifecycleMainService.phase=2;const Le=[],ke=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ce=>{try{return{uri:x.URI.parse(Ce),url:Ce}}catch(Qe){return null}}).filter(Ce=>{if(!Ce||this.shouldBlockURI(Ce.uri))return!1;const Qe=this.getWindowOpenableFromProtocolLink(Ce.uri);return Qe?(Le.push(Qe),!1):!0}),De=this,Pe=this.environmentMainService;ge.registerHandler({async handleURL(Ce,Qe){if(De.shouldBlockURI(Ce))return!0;const bt=De.getWindowOpenableFromProtocolLink(Ce);if(bt){const[gt]=fe.open({context:5,cli:Object.assign({},Pe.args),urisToOpen:[bt],gotoLineMode:!0});return gt.focus(),!0}if(S.isMacintosh&&fe.getWindowCount()===0){const[gt]=fe.open({context:5,cli:Object.assign({},Pe.args),forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,de.getRemoteAuthority)(Ce)});return await gt.ready(),ge.open(Ce,Qe)}return!1}});const Ue=this._register(new dt.ActiveWindowManager({onDidOpenWindow:Ee.onDidOpenWindow,onDidFocusWindow:Ee.onDidFocusWindow,getActiveWindowId:()=>Ee.getActiveWindowId(-1)})),$e=new b.StaticRouter(Ce=>Ue.getActiveClientId().then(Qe=>Ce===Qe)),Ye=new s.URLHandlerRouter($e),Xe=pe.getChannel("urlHandler",Ye);ge.registerHandler(new s.URLHandlerChannelClient(Xe)),this._register(new O.ElectronURLListener(ke,ge,fe,this.environmentMainService,this.productService));const Oe=this.environmentMainService.args,ct=global.macOpenFiles,xe=(0,ft.isLaunchedFromCli)(process.env)?0:4,nt=Oe._.length,rt=!!Oe["folder-uri"],st=!!Oe["file-uri"],ot=Oe["skip-add-to-recently-opened"]===!0,je=Oe.wait&&Oe.waitMarkerFilePath?x.URI.file(Oe.waitMarkerFilePath):void 0,St=Oe.remote||void 0;return Le.length>0?fe.open({context:xe,cli:Oe,urisToOpen:Le,gotoLineMode:!0,initialStartup:!0}):Oe["new-window"]&&!nt&&!rt&&!st?fe.open({context:xe,cli:Oe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:ot,waitMarkerFileURI:je,initialStartup:!0,remoteAuthority:St}):ct.length&&!nt&&!rt&&!st?fe.open({context:1,cli:Oe,urisToOpen:ct.map(Ce=>this.getWindowOpenableFromPathSync(Ce)),noRecentEntry:ot,waitMarkerFileURI:je,initialStartup:!0}):fe.open({context:xe,cli:Oe,forceNewWindow:Oe["new-window"]||!nt&&Oe["unity-launch"],diffMode:Oe.diff,noRecentEntry:ot,waitMarkerFileURI:je,gotoLineMode:Oe.goto,initialStartup:!0,remoteAuthority:St})}shouldBlockURI(he){return!!(he.authority===Z.Schemas.file&&S.isWindows&&L.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,Fe.mnemonicButtonLabel)((0,Y.localize)(0,null)),(0,Fe.mnemonicButtonLabel)((0,Y.localize)(1,null))],cancelId:1,message:(0,Y.localize)(2,null,(0,Fe.getPathLabel)(he.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,Y.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(he){if(!!he.path){if(he.authority===Z.Schemas.file)return{fileUri:x.URI.file(he.fsPath)};if(he.authority===Z.Schemas.vscodeRemote){const pe=he.path.indexOf(K.posix.sep,1);if(pe!==-1){const fe=he.path.substring(1,pe),ge=he.path.substring(pe),Ee=x.URI.from({scheme:Z.Schemas.vscodeRemote,authority:fe,path:ge,query:he.query,fragment:he.fragment});return(0,oe.hasWorkspaceFileExtension)(ge)?{workspaceUri:Ee}:/:[\d]+$/.test(ge)?{fileUri:Ee}:{folderUri:Ee}}}}}getWindowOpenableFromPathSync(he){try{if((0,R.statSync)(he).isDirectory())return{folderUri:x.URI.file(he)};if((0,oe.hasWorkspaceFileExtension)(he))return{workspaceUri:x.URI.file(he)}}catch(pe){}return{fileUri:x.URI.file(he)}}async afterWindowOpen(he,pe){var fe;this.lifecycleMainService.phase=3;let ge=!1;(0,ce.once)(this.lifecycleMainService.onWillShutdown)(()=>ge=!0);const Ee=he.get(a.ITelemetryService);this._register(pe.onDidError(({type:De,details:Pe})=>{let Ue;typeof Pe=="string"?Ue=Pe:Ue=`SharedProcess: crashed (detail: ${Pe.reason}, code: ${Pe.exitCode})`,(0,A.onUnexpectedError)(new Error(Ue)),Ee.publicLog2("sharedprocesserror",{type:De,reason:typeof Pe!="string"?Pe==null?void 0:Pe.reason:void 0,visible:pe.isVisible(),shuttingdown:ge})}));const Le=this.productService.win32MutexName;if(S.isWindows&&Le)try{const De=j.__$__nodeRequire("windows-mutex").Mutex,Pe=new De(Le);(0,ce.once)(this.lifecycleMainService.onWillShutdown)(()=>Pe.release())}catch(De){this.logService.error(De)}L.protocol.registerHttpProtocol(Z.Schemas.vscodeRemoteResource,(De,Pe)=>{Pe({url:De.url.replace(/^vscode-remote-resource:/,"http:"),method:De.method})});const ke=he.get(p.IUpdateService);(ke instanceof B.Win32UpdateService||ke instanceof C.LinuxUpdateService||ke instanceof z.DarwinUpdateService)&&ke.initialize(),(async()=>{const De=this._register(new H.RunOnceScheduler(()=>this.logService.warn("Resolving your shell environment is taking more than 10s. Please review your shell configuration. Learn more at https://go.microsoft.com/fwlink/?linkid=2149667."),1e4));De.schedule(),await(0,w.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env),De.dispose()})();try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,tt.stripComments)(Pe))["enable-crash-reporter"]===void 0){const $e=(fe=this.configurationService.getValue("telemetry.enableCrashReporter"))!==null&&fe!==void 0?fe:!0,Ye=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${$e},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,ze.generateUuid)()}"`,"}"],Xe=Pe.substring(0,Pe.length-2).concat(`,
`,Ye.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,at.VSBuffer.fromString(Xe))}}catch(De){this.logService.error(De)}}stopTracingEventually(he,pe){this.logService.info("Tracing: waiting for windows to get ready...");const fe=he.get(Ie.IDialogMainService);let ge=!1;const Ee=async ke=>{if(!ge){ge=!0;const De=await L.contentTracing.stopRecording((0,G.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);ke?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${De}`):fe.showMessageBox({type:"info",message:(0,Y.localize)(4,null),detail:(0,Y.localize)(5,null,De),buttons:[(0,Y.localize)(6,null)]},(0,Re.withNullAsUndefined)(L.BrowserWindow.getFocusedWindow()))}},Le=setTimeout(()=>Ee(!0),3e4);Promise.all(pe.map(ke=>ke.ready())).then(()=>{clearTimeout(Le),Ee(!1)})}};We=ue([ee(2,M.IInstantiationService),ee(3,u.ILogService),ee(4,c.IEnvironmentMainService),ee(5,r.ILifecycleMainService),ee(6,t.IConfigurationService),ee(7,l.IStateMainService),ee(8,Ve.IFileService),ee(9,T.IProductService)],We),e.CodeApplication=We}),define(Q[239],J([0,1,14,24,11,3,72,47,54,160,17,33,56,172,71,69,6,224,38,16,186,49,222,235,39,93,92,18,60,42,75,193,196,180,181,10,21,74,220,22,30,23,8,35,25,67,96,178,32,55,183,9,202]),function(j,e,m,R,L,S,P,r,w,p,n,b,I,y,d,g,M,E,o,u,l,c,t,i,s,a,h,f,v,D,T,W,$,X,x,oe,q,N,B,C,z,V,_,A,O,k,F,U,K,G,Y,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ne{main(){try{this.startup()}catch(te){console.error(te.message),m.app.exit(1)}}async startup(){(0,f.setUnexpectedErrorHandler)(me=>console.error(me));const[te,le,ve,we,Se,Ae,ye]=this.createServices();try{try{await this.initServices(ve,we,Se)}catch(me){throw this.handleStartupDataDirError(ve,ye.nameLong,me),me}await te.invokeFunction(async me=>{const Ie=me.get(M.ILogService),Re=me.get(n.ILifecycleMainService),Fe=me.get(q.IFileService),Ne=await this.claimInstance(Ie,ve,Re,te,ye,!0);return Ae.logger=new a.SpdLogLogger("main",(0,_.join)(ve.logsPath,"main.log"),!0,Ae.getLevel()),(0,D.once)(Re.onWillShutdown)(()=>{Fe.dispose(),we.dispose()}),te.createInstance(i.CodeApplication,Ne,le).startup()})}catch(me){te.invokeFunction(this.quit,me)}}createServices(){const te=new d.ServiceCollection,le=Object.assign({_serviceBrand:void 0},r.default);te.set(C.IProductService,le);const ve=new O.EnvironmentMainService(this.resolveArgs(),le),we=this.patchEnvironment(ve);te.set(O.IEnvironmentMainService,ve);const Se=new h.BufferLogService,Ae=new M.MultiplexLogService([new M.ConsoleMainLogger((0,M.getLogLevel)(ve)),Se]);process.once("exit",()=>Ae.dispose()),te.set(M.ILogService,Ae);const ye=new X.FileService(Ae);te.set(q.IFileService,ye);const me=new x.DiskFileSystemProvider(Ae);ye.registerProvider(oe.Schemas.file,me),te.set(M.ILoggerService,new U.LoggerService(Ae,ye));const Ie=new l.ConfigurationService(ve.settingsResource,ye);te.set(u.IConfigurationService,Ie),te.set(n.ILifecycleMainService,new g.SyncDescriptor(n.LifecycleMainService));const Re=new E.StateMainService(ve,Ae,ye);return te.set(o.IStateMainService,Re),te.set(c.IRequestService,new g.SyncDescriptor(t.RequestMainService)),te.set(v.IThemeMainService,new g.SyncDescriptor(v.ThemeMainService)),te.set(T.ISignService,new g.SyncDescriptor(W.SignService)),te.set(N.ITunnelService,new g.SyncDescriptor(B.TunnelService)),te.set(G.IProtocolMainService,new g.SyncDescriptor(Y.ProtocolMainService)),[new y.InstantiationService(te,!0),we,ve,Ie,Re,Se,le]}patchEnvironment(te){const le={VSCODE_IPC_HOOK:te.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ve=>{const we=process.env[ve];typeof we=="string"&&(le[ve]=we)}),Object.assign(process.env,le),le}initServices(te,le,ve){return Z.Promises.settled([Promise.all([te.extensionsPath,te.nodeCachedDataDir,te.logsPath,te.globalStorageHome.fsPath,te.workspaceStorageHome.fsPath,te.backupHome].map(we=>we?R.promises.mkdir(we,{recursive:!0}):void 0)),le.initialize(),ve.init()])}async claimInstance(te,le,ve,we,Se,Ae){let ye;try{(0,P.mark)("code/willStartMainServer"),ye=await(0,I.serve)(le.mainIPCHandle),(0,P.mark)("code/didStartMainServer"),(0,D.once)(ve.onWillShutdown)(()=>ye.dispose())}catch(me){if(me.code!=="EADDRINUSE")throw this.handleStartupDataDirError(le,Se.nameLong,me),me;let Ie;try{Ie=await(0,I.connect)(le.mainIPCHandle,"main")}catch(Ne){if(!Ae||S.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog((0,L.localize)(0,null,Se.nameShort),(0,L.localize)(1,null),Se.nameLong),Ne;try{(0,R.unlinkSync)(le.mainIPCHandle)}catch(qe){throw te.warn("Could not delete obsolete instance handle",qe),qe}return this.claimInstance(te,le,ve,we,Se,!1)}if(le.extensionTestsLocationURI&&!le.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw te.error(Ne),Ie.dispose(),new Error(Ne)}let Re;!le.args.wait&&!le.args.status&&(Re=setTimeout(()=>{this.showStartupWarningDialog((0,L.localize)(2,null,Se.nameShort),(0,L.localize)(3,null),Se.nameLong)},1e4));const Fe=b.ProxyChannel.toService(Ie.getChannel("launch"),{disableMarshalling:!0});if(le.args.status)return we.invokeFunction(async()=>{const Ne=new $.DiagnosticsService(F.NullTelemetryService,Se),qe=await Fe.getMainProcessInfo(),Ve=await Fe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),tt=await Ne.getDiagnostics(qe,Ve);throw console.log(tt),new f.ExpectedError});throw S.isWindows&&await this.windowsAllowSetForegroundWindow(Fe,te),te.trace("Sending env to running instance..."),await Fe.start(le.args,process.env),Ie.dispose(),Re&&clearTimeout(Re),new f.ExpectedError("Sent env to running instance. Terminating...")}if(le.args.status)throw te.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ye}handleStartupDataDirError(te,le,ve){if(ve.code==="EACCES"||ve.code==="EPERM"){const we=(0,A.coalesce)([te.userDataPath,te.extensionsPath,I.XDG_RUNTIME_DIR]).map(Se=>(0,s.getPathLabel)(Se,te));this.showStartupWarningDialog((0,L.localize)(4,null),(0,L.localize)(5,null,(0,k.toErrorMessage)(ve),we.join(`
`)),le)}}showStartupWarningDialog(te,le,ve){m.dialog.showMessageBoxSync({title:ve,type:"warning",buttons:[(0,s.mnemonicButtonLabel)((0,L.localize)(6,null))],message:te,detail:le,noLink:!0})}async windowsAllowSetForegroundWindow(te,le){if(S.isWindows){const ve=await te.getMainProcessId();le.trace("Sending some foreground love to the running instance:",ve);try{(await new Promise((we,Se)=>{j(["windows-foreground-love"],we,Se)})).allowSetForegroundWindow(ve)}catch(we){le.error(we)}}}quit(te,le){const ve=te.get(M.ILogService),we=te.get(n.ILifecycleMainService);let Se=0;le&&(le.isExpected?le.message&&ve.trace(le.message):(Se=1,le.stack?ve.error(le.stack):ve.error(`Startup error: ${le.toString()}`))),we.kill(Se)}resolveArgs(){const te=this.validatePaths((0,w.parseMainProcessArgv)(process.argv));if(te.wait&&!te.waitMarkerFilePath){const le=(0,p.createWaitMarkerFile)(te.verbose);le&&((0,w.addArg)(process.argv,"--waitMarkerFilePath",le),te.waitMarkerFilePath=le)}return te}validatePaths(te){if(te["open-url"]&&(te._urls=te._,te._=[]),!te.remote){const le=this.doValidatePaths(te._,te.goto);te._=le}return te}doValidatePaths(te,le){const ve=(0,K.cwd)(),we=te.map(ye=>{let me=String(ye),Ie;le&&(Ie=(0,z.parseLineAndColumnAware)(me),me=Ie.path),me&&(me=this.preparePath(ve,me));const Re=(0,z.sanitizeFilePath)(me,ve),Fe=(0,_.basename)(Re);return Fe&&!(0,z.isValidBasename)(Fe)?null:le&&Ie?(Ie.path=Re,this.toPath(Ie)):Re}),Se=S.isWindows||S.isMacintosh,Ae=(0,A.distinct)(we,ye=>ye&&Se?ye.toLowerCase():ye||"");return(0,A.coalesce)(Ae)}preparePath(te,le){return S.isWindows&&(le=(0,V.rtrim)(le,'"')),le=(0,V.trim)((0,V.trim)(le," "),"	"),S.isWindows&&(le=(0,_.resolve)(te,le),le=(0,V.rtrim)(le,".")),le}toPath(te){const le=[te.path];return typeof te.line=="number"&&le.push(String(te.line)),typeof te.column=="number"&&le.push(String(te.column)),le.join(":")}}new ne().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/659175fa39b994fc39381b0af2874c85efeb2a01/core/vs/code/electron-main/main.js.map
