/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/platform","vs/base/common/types","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/node/pfs","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/extpath","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/glob","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","fs","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/stopwatch","os","vs/editor/common/core/position","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/node/processes","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/processes","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalProfiles","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(K){for(var e=[],b=0,T=K.length;b<T;b++)e[b]=me[K[b]];return e};define(me[53],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function b(T,C){if(!T)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=b}),define(me[54],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupByNumber=e.groupBy=e.forEach=e.values=void 0;const b=Object.prototype.hasOwnProperty;function T(I){const m=[];for(let g in I)b.call(I,g)&&m.push(I[g]);return m}e.values=T;function C(I,m){for(let g in I)if(b.call(I,g)&&m({key:g,value:I[g]},function(){delete I[g]})===!1)return}e.forEach=C;function A(I,m){const g=Object.create(null);for(const a of I){const h=m(a);let S=g[h];S||(S=g[h]=[]),S.push(a)}return g}e.groupBy=A;function y(I,m){const g=new Map;for(const a of I){const h=m(a);let S=g.get(h);S||(S=[],g.set(h,S)),S.push(a)}return g}e.groupByNumber=y;function k(I){const m=Object.create(null);return I&&I.forEach((g,a)=>{m[a]=g}),m}e.fromMap=k;function D(I,m){const g=[],a=[];for(let h of I)m.has(h)||g.push(h);for(let h of m)I.has(h)||a.push(h);return{removed:g,added:a}}e.diffSets=D;function P(I,m){const g=[],a=[];for(let[h,S]of I)m.has(h)||g.push(S);for(let[h,S]of m)I.has(h)||a.push(S);return{removed:g,added:a}}e.diffMaps=P;class i{constructor(){this.map=new Map}add(m,g){let a=this.map.get(m);a||(a=new Set,this.map.set(m,a)),a.add(g)}delete(m,g){const a=this.map.get(m);!a||(a.delete(g),a.size===0&&this.map.delete(m))}forEach(m,g){const a=this.map.get(m);!a||a.forEach(g)}}e.SetMap=i}),define(me[55],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function b(y){return(k,D,P)=>{let i=null,I=null;if(typeof P.value=="function"?(i="value",I=P.value):typeof P.get=="function"&&(i="get",I=P.get),!I)throw new Error("not supported");P[i]=y(I,D)}}e.createDecorator=b;function T(y,k,D){let P=null,i=null;if(typeof D.value=="function"?(P="value",i=D.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(P="get",i=D.get),!i)throw new Error("not supported");const I=`$memoize$${k}`;D[P]=function(...m){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,m)}),this[I]}}e.memoize=T;function C(y,k,D){return b((P,i)=>{const I=`$debounce$${i}`,m=`$debounce$result$${i}`;return function(...g){this[m]||(this[m]=D?D():void 0),clearTimeout(this[I]),k&&(this[m]=k(this[m],...g),g=[this[m]]),this[I]=setTimeout(()=>{P.apply(this,g),this[m]=D?D():void 0},y)}})}e.debounce=C;function A(y,k,D){return b((P,i)=>{const I=`$throttle$timer$${i}`,m=`$throttle$result$${i}`,g=`$throttle$lastRun$${i}`,a=`$throttle$pending$${i}`;return function(...h){if(this[m]||(this[m]=D?D():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),k&&(this[m]=k(this[m],...h)),!this[a]){const S=this[g]+y;S<=Date.now()?(this[g]=Date.now(),P.apply(this,[this[m]]),this[m]=D?D():void 0):(this[a]=!0,this[I]=setTimeout(()=>{this[a]=!1,this[g]=Date.now(),P.apply(this,[this[m]]),this[m]=D?D():void 0},S-Date.now()))}}})}e.throttle=A}),define(me[17],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class b{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=b,e.errorHandler=new b;function T(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=T;function C(c){D(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=C;function A(c){D(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=A;function y(c){if(c instanceof Error){let{name:t,message:n}=c;const s=c.stacktrace||c.stack;return{$isError:!0,name:t,message:n,stack:s}}return c}e.transformErrorForSerialization=y;const k="Canceled";function D(c){return c instanceof Error&&c.name===k&&c.message===k}e.isPromiseCanceledError=D;class P extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=P;function i(){const c=new Error(k);return c.name=c.message,c}e.canceled=i;function I(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=I;function m(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=m;function g(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function a(c){const t=new Error(`${c} has been disposed`);return t.name="DISPOSED",t}e.disposed=a;function h(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=h;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function d(c){const t=c;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=d;function l(c,t=Object.create(null)){const n=new Error(c);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=l}),define(me[16],ge([0,1,17]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function T(x,L=0){return x[x.length-(1+L)]}e.tail=T;function C(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}e.tail2=C;function A(x,L,N=(F,M)=>F===M){if(x===L)return!0;if(!x||!L||x.length!==L.length)return!1;for(let F=0,M=x.length;F<M;F++)if(!N(x[F],L[F]))return!1;return!0}e.equals=A;function y(x,L,N){let F=0,M=x.length-1;for(;F<=M;){const $=(F+M)/2|0,q=N(x[$],L);if(q<0)F=$+1;else if(q>0)M=$-1;else return $}return-(F+1)}e.binarySearch=y;function k(x,L){let N=0,F=x.length;if(F===0)return 0;for(;N<F;){const M=Math.floor((N+F)/2);L(x[M])?F=M:N=M+1}return N}e.findFirstInSorted=k;function D(x,L,N){if(x=x|0,x>=L.length)throw new TypeError("invalid index");let F=L[Math.floor(L.length*Math.random())],M=[],$=[],q=[];for(let G of L){const le=N(G,F);le<0?M.push(G):le>0?$.push(G):q.push(G)}return x<M.length?D(x,M,N):x<M.length+q.length?q[0]:D(x-(M.length+q.length),$,N)}e.quickSelect=D;function P(x,L){const N=[];let F;for(const M of x.slice(0).sort(L))!F||L(F[0],M)!==0?(F=[M],N.push(F)):F.push(M);return N}e.groupBy=P;function i(x,L,N){const F=[];function M(G,le,ve){if(!(le===0&&ve.length===0)){const Re=F[F.length-1];Re&&Re.start+Re.deleteCount===G?(Re.deleteCount+=le,Re.toInsert.push(...ve)):F.push({start:G,deleteCount:le,toInsert:ve})}}let $=0,q=0;for(;;){if($===x.length){M($,0,L.slice(q));break}if(q===L.length){M($,x.length-$,[]);break}const G=x[$],le=L[q],ve=N(G,le);ve===0?($+=1,q+=1):ve<0?(M($,1,[]),$+=1):ve>0&&(M($,0,[le]),q+=1)}return F}e.sortedDiff=i;function I(x,L,N){const F=i(x,L,N),M=[],$=[];for(const q of F)M.push(...x.slice(q.start,q.start+q.deleteCount)),$.push(...q.toInsert);return{removed:M,added:$}}e.delta=I;function m(x,L,N){if(N===0)return[];const F=x.slice(0,N).sort(L);return a(x,L,F,N,x.length),F}e.top=m;function g(x,L,N,F,M){return N===0?Promise.resolve([]):new Promise(($,q)=>{(async()=>{const G=x.length,le=x.slice(0,N).sort(L);for(let ve=N,Re=Math.min(N+F,G);ve<G;ve=Re,Re=Math.min(Re+F,G)){if(ve>N&&await new Promise(Se=>setTimeout(Se)),M&&M.isCancellationRequested)throw(0,b.canceled)();a(x,L,le,ve,Re)}return le})().then($,q)})}e.topAsync=g;function a(x,L,N,F,M){for(const $=N.length;F<M;F++){const q=x[F];if(L(q,N[$-1])<0){N.pop();const G=k(N,le=>L(q,le)<0);N.splice(G,0,q)}}}function h(x){return x.filter(L=>!!L)}e.coalesce=h;function S(x){let L=0;for(let N=0;N<x.length;N++)x[N]&&(x[L]=x[N],L+=1);x.length=L}e.coalesceInPlace=S;function w(x,L,N){x.splice(N,0,x.splice(L,1)[0])}e.move=w;function E(x){return!Array.isArray(x)||x.length===0}e.isFalsyOrEmpty=E;function d(x){return Array.isArray(x)&&x.length>0}e.isNonEmptyArray=d;function l(x,L){if(!L)return x.filter((F,M)=>x.indexOf(F)===M);const N=Object.create(null);return x.filter(F=>{const M=L(F);return N[M]?!1:(N[M]=!0,!0)})}e.distinct=l;function c(x){const L=new Set;return x.filter(N=>L.has(N)?!1:(L.add(N),!0))}e.distinctES6=c;function t(x){const L=Object.create(null);return N=>{const F=x(N);return L[F]?!1:(L[F]=!0,!0)}}e.uniqueFilter=t;function n(x,L){for(let N=x.length-1;N>=0;N--){const F=x[N];if(L(F))return N}return-1}e.lastIndex=n;function s(x,L){return x.length>0?x[0]:L}e.firstOrDefault=s;function r(x,L,N=(F,M)=>F===M){let F=0;for(let M=0,$=Math.min(x.length,L.length);M<$&&N(x[M],L[M]);M++)F++;return F}e.commonPrefixLength=r;function o(x){return[].concat(...x)}e.flatten=o;function p(x,L){let N=typeof L=="number"?x:0;typeof L=="number"?N=x:(N=0,L=x);const F=[];if(N<=L)for(let M=N;M<L;M++)F.push(M);else for(let M=N;M>L;M--)F.push(M);return F}e.range=p;function f(x,L,N){return x.reduce((F,M)=>(F[L(M)]=N?N(M):M,F),Object.create(null))}e.index=f;function _(x,L){return x.push(L),()=>u(x,L)}e.insert=_;function u(x,L){const N=x.indexOf(L);if(N>-1)return x.splice(N,1),L}e.remove=u;function v(x,L,N){const F=x.slice(0,L),M=x.slice(L);return F.concat(N,M)}e.arrayInsert=v;function R(x,L){let N;if(typeof L=="number"){let F=L;N=()=>{const M=Math.sin(F++)*179426549;return M-Math.floor(M)}}else N=Math.random;for(let F=x.length-1;F>0;F-=1){const M=Math.floor(N()*(F+1)),$=x[F];x[F]=x[M],x[M]=$}}e.shuffle=R;function O(x,L){const N=x.indexOf(L);N>-1&&(x.splice(N,1),x.unshift(L))}e.pushToStart=O;function H(x,L){const N=x.indexOf(L);N>-1&&(x.splice(N,1),x.push(L))}e.pushToEnd=H;function ne(x,L){return Array.isArray(x)?x.map(L):L(x)}e.mapArrayOrNot=ne;function ie(x){return Array.isArray(x)?x:[x]}e.asArray=ie;function U(x){return x[Math.floor(Math.random()*x.length)]}e.getRandomElement=U;function B(x,L){for(const N of x){const F=L(N);if(F!==void 0)return F}}e.mapFind=B}),define(me[72],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function b(T){const C=this;let A=!1,y;return function(){return A||(A=!0,y=T.apply(C,arguments)),y}}e.once=b}),define(me[73],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class b{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=b,e.defaultGenerator=new b("id#")}),define(me[56],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var b;(function(T){function C(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}T.is=C;const A=Object.freeze([]);function y(){return A}T.empty=y;function*k(c){yield c}T.single=k;function D(c){return c||A}T.from=D;function P(c){return!c||c[Symbol.iterator]().next().done===!0}T.isEmpty=P;function i(c){return c[Symbol.iterator]().next().value}T.first=i;function I(c,t){for(const n of c)if(t(n))return!0;return!1}T.some=I;function m(c,t){for(const n of c)if(t(n))return n}T.find=m;function*g(c,t){for(const n of c)t(n)&&(yield n)}T.filter=g;function*a(c,t){for(const n of c)yield t(n)}T.map=a;function*h(...c){for(const t of c)for(const n of t)yield n}T.concat=h;function*S(c){for(const t of c)for(const n of t)yield n}T.concatNested=S;function w(c,t,n){let s=n;for(const r of c)s=t(s,r);return s}T.reduce=w;function*E(c,t,n=c.length){for(t<0&&(t+=c.length),n<0?n+=c.length:n>c.length&&(n=c.length);t<n;t++)yield c[t]}T.slice=E;function d(c,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,c];const s=c[Symbol.iterator]();for(let r=0;r<t;r++){const o=s.next();if(o.done)return[n,T.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return s}}]}T.consume=d;function l(c,t,n=(s,r)=>s===r){const s=c[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const o=s.next(),p=r.next();if(o.done!==p.done)return!1;if(o.done)return!0;if(!n(o.value,p.value))return!1}}T.equals=l})(b=e.Iterable||(e.Iterable={}))}),define(me[57],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var b;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(b=e.ScanError||(e.ScanError={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function y(t,n=!1){let s=0,r=t.length,o="",p=0,f=16,_=0;function u(U){let B=0,x=0;for(;B<U;){const L=t.charCodeAt(s);if(L>=48&&L<=57)x=x*16+L-48;else if(L>=65&&L<=70)x=x*16+L-65+10;else if(L>=97&&L<=102)x=x*16+L-97+10;else break;s++,B++}return B<U&&(x=-1),x}function v(U){s=U,o="",p=0,f=16,_=0}function R(){const U=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&P(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&P(t.charCodeAt(s)))for(s++;s<t.length&&P(t.charCodeAt(s));)s++;else return _=3,t.substring(U,s);let B=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&P(t.charCodeAt(s))){for(s++;s<t.length&&P(t.charCodeAt(s));)s++;B=s}else _=3;return t.substring(U,B)}function O(){let U="",B=s;for(;;){if(s>=r){U+=t.substring(B,s),_=2;break}const x=t.charCodeAt(s);if(x===34){U+=t.substring(B,s),s++;break}if(x===92){if(U+=t.substring(B,s),s++,s>=r){_=2;break}switch(t.charCodeAt(s++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:const N=u(4);N>=0?U+=String.fromCharCode(N):_=4;break;default:_=5}B=s;continue}if(x>=0&&x<=31)if(D(x)){U+=t.substring(B,s),_=2;break}else _=6;s++}return U}function H(){if(o="",_=0,p=s,s>=r)return p=r,f=17;let U=t.charCodeAt(s);if(k(U)){do s++,o+=String.fromCharCode(U),U=t.charCodeAt(s);while(k(U));return f=15}if(D(U))return s++,o+=String.fromCharCode(U),U===13&&t.charCodeAt(s)===10&&(s++,o+=`
`),f=14;switch(U){case 123:return s++,f=1;case 125:return s++,f=2;case 91:return s++,f=3;case 93:return s++,f=4;case 58:return s++,f=6;case 44:return s++,f=5;case 34:return s++,o=O(),f=10;case 47:const B=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<r&&!D(t.charCodeAt(s));)s++;return o=t.substring(B,s),f=12}if(t.charCodeAt(s+1)===42){s+=2;const x=r-1;let L=!1;for(;s<x;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,L=!0;break}s++}return L||(s++,_=1),o=t.substring(B,s),f=13}return o+=String.fromCharCode(U),s++,f=16;case 45:if(o+=String.fromCharCode(U),s++,s===r||!P(t.charCodeAt(s)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=R(),f=11;default:for(;s<r&&ne(U);)s++,U=t.charCodeAt(s);if(p!==s){switch(o=t.substring(p,s),o){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return o+=String.fromCharCode(U),s++,f=16}}function ne(U){if(k(U)||D(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let U;do U=H();while(U>=12&&U<=15);return U}return{setPosition:v,getPosition:()=>s,scan:n?ie:H,getToken:()=>f,getTokenValue:()=>o,getTokenOffset:()=>p,getTokenLength:()=>s-p,getTokenError:()=>_}}e.createScanner=y;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function P(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,n){const s=[],r=new Object;let o;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function _(u,v,R,O){p.value=u,p.offset=v,p.length=R,p.type=O,p.colonOffset=void 0,o=p}try{d(t,{onObjectBegin:(u,v)=>{if(n<=u)throw r;o=void 0,f=n>u,s.push("")},onObjectProperty:(u,v,R)=>{if(n<v||(_(u,v,R,"property"),s[s.length-1]=u,n<=v+R))throw r},onObjectEnd:(u,v)=>{if(n<=u)throw r;o=void 0,s.pop()},onArrayBegin:(u,v)=>{if(n<=u)throw r;o=void 0,s.push(0)},onArrayEnd:(u,v)=>{if(n<=u)throw r;o=void 0,s.pop()},onLiteralValue:(u,v,R)=>{if(n<v||(_(u,v,R,c(u)),n<=v+R))throw r},onSeparator:(u,v,R)=>{if(n<=v)throw r;if(u===":"&&o&&o.type==="property")o.colonOffset=v,f=!1,o=void 0;else if(u===","){const O=s[s.length-1];typeof O=="number"?s[s.length-1]=O+1:(f=!0,s[s.length-1]=""),o=void 0}}})}catch(u){if(u!==r)throw u}return{path:s,previousNode:o,isAtPropertyKey:f,matches:u=>{let v=0;for(let R=0;v<u.length&&R<s.length;R++)if(u[v]===s[R]||u[v]==="*")v++;else if(u[v]!=="**")return!1;return v===u.length}}}e.getLocation=I;function m(t,n=[],s=A.DEFAULT){let r=null,o=[];const p=[];function f(u){Array.isArray(o)?o.push(u):r!==null&&(o[r]=u)}return d(t,{onObjectBegin:()=>{const u={};f(u),p.push(o),o=u,r=null},onObjectProperty:u=>{r=u},onObjectEnd:()=>{o=p.pop()},onArrayBegin:()=>{const u=[];f(u),p.push(o),o=u,r=null},onArrayEnd:()=>{o=p.pop()},onLiteralValue:f,onError:(u,v,R)=>{n.push({error:u,offset:v,length:R})}},s),o[0]}e.parse=m;function g(t,n=[],s=A.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(u){r.type==="property"&&(r.length=u-r.offset,r=r.parent)}function p(u){return r.children.push(u),u}d(t,{onObjectBegin:u=>{r=p({type:"object",offset:u,length:-1,parent:r,children:[]})},onObjectProperty:(u,v,R)=>{r=p({type:"property",offset:v,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:u,offset:v,length:R,parent:r})},onObjectEnd:(u,v)=>{r.length=u+v-r.offset,r=r.parent,o(u+v)},onArrayBegin:(u,v)=>{r=p({type:"array",offset:u,length:-1,parent:r,children:[]})},onArrayEnd:(u,v)=>{r.length=u+v-r.offset,r=r.parent,o(u+v)},onLiteralValue:(u,v,R)=>{p({type:c(u),offset:v,length:R,parent:r,value:u}),o(v+R)},onSeparator:(u,v,R)=>{r.type==="property"&&(u===":"?r.colonOffset=v:u===","&&o(v))},onError:(u,v,R)=>{n.push({error:u,offset:v,length:R})}},s);const _=r.children[0];return _&&delete _.parent,_}e.parseTree=g;function a(t,n){if(!!t){let s=t;for(let r of n)if(typeof r=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let o=!1;for(const p of s.children)if(Array.isArray(p.children)&&p.children[0].value===r){s=p.children[1],o=!0;break}if(!o)return}else{const o=r;if(s.type!=="array"||o<0||!Array.isArray(s.children)||o>=s.children.length)return;s=s.children[o]}return s}}e.findNodeAtLocation=a;function h(t){if(!t.parent||!t.parent.children)return[];const n=h(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;n.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&n.push(s)}return n}e.getNodePath=h;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const n=Object.create(null);for(let s of t.children){const r=s.children[1];r&&(n[s.children[0].value]=S(r))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function w(t,n,s=!1){return n>=t.offset&&n<t.offset+t.length||s&&n===t.offset+t.length}e.contains=w;function E(t,n,s=!1){if(w(t,n,s)){const r=t.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const p=E(r[o],n,s);if(p)return p}return t}}e.findNodeAtOffset=E;function d(t,n,s=A.DEFAULT){const r=y(t,!1);function o(le){return le?()=>le(r.getTokenOffset(),r.getTokenLength()):()=>!0}function p(le){return le?ve=>le(ve,r.getTokenOffset(),r.getTokenLength()):()=>!0}const f=o(n.onObjectBegin),_=p(n.onObjectProperty),u=o(n.onObjectEnd),v=o(n.onArrayBegin),R=o(n.onArrayEnd),O=p(n.onLiteralValue),H=p(n.onSeparator),ne=o(n.onComment),ie=p(n.onError),U=s&&s.disallowComments,B=s&&s.allowTrailingComma;function x(){for(;;){const le=r.scan();switch(r.getTokenError()){case 4:L(14);break;case 5:L(15);break;case 3:L(13);break;case 1:U||L(11);break;case 2:L(12);break;case 6:L(16);break}switch(le){case 12:case 13:U?L(10):ne();break;case 16:L(1);break;case 15:case 14:break;default:return le}}}function L(le,ve=[],Re=[]){if(ie(le),ve.length+Re.length>0){let Se=r.getToken();for(;Se!==17;){if(ve.indexOf(Se)!==-1){x();break}else if(Re.indexOf(Se)!==-1)break;Se=x()}}}function N(le){const ve=r.getTokenValue();return le?O(ve):_(ve),x(),!0}function F(){switch(r.getToken()){case 11:let le=0;try{le=JSON.parse(r.getTokenValue()),typeof le!="number"&&(L(2),le=0)}catch(ve){L(2)}O(le);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return x(),!0}function M(){return r.getToken()!==10?(L(3,[],[2,5]),!1):(N(!1),r.getToken()===6?(H(":"),x(),G()||L(4,[],[2,5])):L(5,[],[2,5]),!0)}function $(){f(),x();let le=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(le||L(4,[],[]),H(","),x(),r.getToken()===2&&B)break}else le&&L(6,[],[]);M()||L(4,[],[2,5]),le=!0}return u(),r.getToken()!==2?L(7,[2],[]):x(),!0}function q(){v(),x();let le=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(le||L(4,[],[]),H(","),x(),r.getToken()===4&&B)break}else le&&L(6,[],[]);G()||L(4,[],[4,5]),le=!0}return R(),r.getToken()!==4?L(8,[4],[]):x(),!0}function G(){switch(r.getToken()){case 3:return q();case 1:return $();case 10:return N(!0);default:return F()}}return x(),r.getToken()===17?s.allowEmptyContent?!0:(L(4,[],[]),!1):G()?(r.getToken()!==17&&L(9,[],[]),!0):(L(4,[],[]),!1)}e.visit=d;function l(t,n){let s=y(t),r=[],o,p=0,f;do switch(f=s.getPosition(),o=s.scan(),o){case 12:case 13:case 17:p!==f&&r.push(t.substring(p,f)),n!==void 0&&r.push(s.getTokenValue().replace(/[^\r\n]/g,n)),p=s.getPosition();break}while(o!==17);return r.join("")}e.stripComments=l;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(me[134],ge([0,1,57]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function T(D,P,i){let I,m,g,a,h;if(P){for(a=P.offset,h=a+P.length,g=a;g>0&&!k(D,g-1);)g--;let p=h;for(;p<D.length&&!k(D,p);)p++;m=D.substring(g,p),I=A(m,i)}else m=D,I=0,g=0,a=0,h=D.length;const S=y(i,D);let w=!1,E=0,d;i.insertSpaces?d=C(" ",i.tabSize||4):d="	";const l=(0,b.createScanner)(m,!1);let c=!1;function t(){return S+C(d,I+E)}function n(){let p=l.scan();for(w=!1;p===15||p===14;)w=w||p===14,p=l.scan();return c=p===16||l.getTokenError()!==0,p}const s=[];function r(p,f,_){!c&&f<h&&_>a&&D.substring(f,_)!==p&&s.push({offset:f,length:_-f,content:p})}let o=n();if(o!==17){const p=l.getTokenOffset()+g,f=C(d,I);r(f,g,p)}for(;o!==17;){let p=l.getTokenOffset()+l.getTokenLength()+g,f=n(),_="";for(;!w&&(f===12||f===13);){const v=l.getTokenOffset()+g;r(" ",p,v),p=l.getTokenOffset()+l.getTokenLength()+g,_=f===12?t():"",f=n()}if(f===2)o!==1&&(E--,_=t());else if(f===4)o!==3&&(E--,_=t());else{switch(o){case 3:case 1:E++,_=t();break;case 5:case 12:_=t();break;case 13:w?_=t():_=" ";break;case 6:_=" ";break;case 10:if(f===6){_="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?_=" ":f!==5&&f!==17&&(c=!0);break;case 16:c=!0;break}w&&(f===12||f===13)&&(_=t())}const u=l.getTokenOffset()+g;r(_,p,u),o=f}return s}e.format=T;function C(D,P){let i="";for(let I=0;I<P;I++)i+=D;return i}function A(D,P){let i=0,I=0;const m=P.tabSize||4;for(;i<D.length;){const g=D.charAt(i);if(g===" ")I++;else if(g==="	")I+=m;else break;i++}return Math.floor(I/m)}function y(D,P){for(let i=0;i<P.length;i++){const I=P.charAt(i);if(I==="\r")return i+1<P.length&&P.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=y;function k(D,P){return`\r
`.indexOf(D.charAt(P))!==-1}e.isEOL=k}),define(me[135],ge([0,1,57,134]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(P,i,I){return A(P,i,void 0,I)}e.removeProperty=C;function A(P,i,I,m,g){const a=i.slice(),h=[],S=(0,b.parseTree)(P,h);let w,E;for(;a.length>0&&(E=a.pop(),w=(0,b.findNodeAtLocation)(S,a),w===void 0&&I!==void 0);)typeof E=="string"?I={[E]:I}:I=[I];if(w)if(w.type==="object"&&typeof E=="string"&&Array.isArray(w.children)){const d=(0,b.findNodeAtLocation)(w,[E]);if(d!==void 0)if(I===void 0){if(!d.parent)throw new Error("Malformed AST");const l=w.children.indexOf(d.parent);let c,t=d.parent.offset+d.parent.length;if(l>0){const n=w.children[l-1];c=n.offset+n.length}else c=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return y(P,{offset:c,length:t-c,content:""},m)}else return y(P,{offset:d.offset,length:d.length,content:JSON.stringify(I)},m);else{if(I===void 0)return[];const l=`${JSON.stringify(E)}: ${JSON.stringify(I)}`,c=g?g(w.children.map(n=>n.children[0].value)):w.children.length;let t;if(c>0){const n=w.children[c-1];t={offset:n.offset+n.length,length:0,content:","+l}}else w.children.length===0?t={offset:w.offset+1,length:0,content:l}:t={offset:w.offset+1,length:0,content:l+","};return y(P,t,m)}}else if(w.type==="array"&&typeof E=="number"&&Array.isArray(w.children))if(I!==void 0){const d=`${JSON.stringify(I)}`;let l;if(w.children.length===0||E===0)l={offset:w.offset+1,length:0,content:w.children.length===0?d:d+","};else{const c=E===-1||E>w.children.length?w.children.length:E,t=w.children[c-1];l={offset:t.offset+t.length,length:0,content:","+d}}return y(P,l,m)}else{const d=E,l=w.children[d];let c;if(w.children.length===1)c={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===d){const t=w.children[d-1],n=t.offset+t.length,s=w.offset+w.length;c={offset:n,length:s-2-n,content:""}}else c={offset:l.offset,length:w.children[d+1].offset-l.offset,content:""};return y(P,c,m)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${w.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return y(P,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(I)},m)}}e.setProperty=A;function y(P,i,I){let m=k(P,i),g=i.offset,a=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;g>0&&!(0,T.isEOL)(m,g-1);)g--;for(;a<m.length&&!(0,T.isEOL)(m,a);)a++}const h=(0,T.format)(m,{offset:g,length:a-g},I);for(let w=h.length-1;w>=0;w--){const E=h[w];m=k(m,E),g=Math.min(g,E.offset),a=Math.max(a,E.offset+E.length),a+=E.content.length-E.length}const S=P.length-(m.length-a)-g;return[{offset:g,length:S,content:m.substring(g,a)}]}e.withFormatting=y;function k(P,i){return P.substring(0,i.offset)+i.content+P.substring(i.offset+i.length)}e.applyEdit=k;function D(P,i){let I=i.slice(0).sort((g,a)=>{const h=g.offset-a.offset;return h===0?g.length-a.length:h}),m=P.length;for(let g=I.length-1;g>=0;g--){let a=I[g];if(a.offset+a.length<=m)P=k(P,a);else throw new Error("Overlapping edit");m=a.offset}return P}e.applyEdits=D}),define(me[136],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class b{constructor(C){this.executor=C,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(C){return new b(()=>C(this.getValue()))}}e.Lazy=b}),define(me[6],ge([0,1,72,56]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const C=!1;let A=null;function y(d){A=d}if(e.setDisposableTracker=y,C){const d="__is_disposable_tracked__";A=new class{trackDisposable(l){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[d]||console.log(c)},3e3)}markTracked(l){if(l&&l!==h.None)try{l[d]=!0}catch(c){}}}}function k(d){!A||A.markTracked(d)}function D(d){return A&&A.trackDisposable(d),d}e.trackDisposable=D;class P extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=P;function i(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=i;function I(d){if(T.Iterable.is(d)){let l=[];for(const c of d)if(c){k(c);try{c.dispose()}catch(t){l.push(t)}}if(l.length===1)throw l[0];if(l.length>1)throw new P(l);return Array.isArray(d)?[]:d}else if(d)return k(d),d.dispose(),d}e.dispose=I;function m(...d){return d.forEach(k),g(()=>I(d))}e.combinedDisposable=m;function g(d){const l=D({dispose:()=>{k(l),d()}});return l}e.toDisposable=g;class a{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(k(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return k(l),this._isDisposed?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this._store=new a,D(this)}dispose(){k(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=h,h.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var c;this._isDisposed||l===this._value||((c=this._value)===null||c===void 0||c.dispose(),l&&k(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,k(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=S;class w{constructor(){this.references=new Map}acquire(l,...c){let t=this.references.get(l);t||(t={counter:0,object:this.createReferencedObject(l,...c)},this.references.set(l,t));const{object:n}=t,s=(0,b.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(l,t.object),this.references.delete(l))});return t.counter++,{object:n,dispose:s}}}e.ReferenceCollection=w;class E{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=E}),define(me[58],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class b{constructor(A){this.element=A,this.next=b.Undefined,this.prev=b.Undefined}}b.Undefined=new b(void 0);class T{constructor(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===b.Undefined}clear(){let A=this._first;for(;A!==b.Undefined;){const y=A.next;A.prev=b.Undefined,A.next=b.Undefined,A=y}this._first=b.Undefined,this._last=b.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,y){const k=new b(A);if(this._first===b.Undefined)this._first=k,this._last=k;else if(y){const P=this._last;this._last=k,k.prev=P,P.next=k}else{const P=this._first;this._first=k,k.next=P,P.prev=k}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(k))}}shift(){if(this._first!==b.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==b.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==b.Undefined&&A.next!==b.Undefined){const y=A.prev;y.next=A.next,A.next.prev=y}else A.prev===b.Undefined&&A.next===b.Undefined?(this._first=b.Undefined,this._last=b.Undefined):A.next===b.Undefined?(this._last=this._last.prev,this._last.next=b.Undefined):A.prev===b.Undefined&&(this._first=this._first.next,this._first.prev=b.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==b.Undefined;)yield A.element,A=A.next}}e.LinkedList=T}),function(K,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(K=typeof globalThis!="undefined"?globalThis:K||self,K.marked=e())}(this,function(){"use strict";function K(De,ye){for(var Pe=0;Pe<ye.length;Pe++){var oe=ye[Pe];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(De,oe.key,oe)}}function e(De,ye,Pe){return ye&&K(De.prototype,ye),Pe&&K(De,Pe),De}function b(De,ye){if(!!De){if(typeof De=="string")return T(De,ye);var Pe=Object.prototype.toString.call(De).slice(8,-1);if(Pe==="Object"&&De.constructor&&(Pe=De.constructor.name),Pe==="Map"||Pe==="Set")return Array.from(De);if(Pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Pe))return T(De,ye)}}function T(De,ye){(ye==null||ye>De.length)&&(ye=De.length);for(var Pe=0,oe=new Array(ye);Pe<ye;Pe++)oe[Pe]=De[Pe];return oe}function C(De,ye){var Pe;if(typeof Symbol=="undefined"||De[Symbol.iterator]==null){if(Array.isArray(De)||(Pe=b(De))||ye&&De&&typeof De.length=="number"){Pe&&(De=Pe);var oe=0;return function(){return oe>=De.length?{done:!0}:{done:!1,value:De[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Pe=De[Symbol.iterator](),Pe.next.bind(Pe)}function A(De){var ye={exports:{}};return De(ye,ye.exports),ye.exports}var y=A(function(De){function ye(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Pe(oe){De.exports.defaults=oe}De.exports={defaults:ye(),getDefaults:ye,changeDefaults:Pe}}),k=/[&<>"']/,D=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(ye){return I[ye]};function g(De,ye){if(ye){if(k.test(De))return De.replace(D,m)}else if(P.test(De))return De.replace(i,m);return De}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(De){return De.replace(a,function(ye,Pe){return Pe=Pe.toLowerCase(),Pe==="colon"?":":Pe.charAt(0)==="#"?Pe.charAt(1)==="x"?String.fromCharCode(parseInt(Pe.substring(2),16)):String.fromCharCode(+Pe.substring(1)):""})}var S=/(^|[^\[])\^/g;function w(De,ye){De=De.source||De,ye=ye||"";var Pe={replace:function(ue,z){return z=z.source||z,z=z.replace(S,"$1"),De=De.replace(ue,z),Pe},getRegex:function(){return new RegExp(De,ye)}};return Pe}var E=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(De,ye,Pe){if(De){var oe;try{oe=decodeURIComponent(h(Pe)).replace(E,"").toLowerCase()}catch(ue){return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}ye&&!d.test(Pe)&&(Pe=r(ye,Pe));try{Pe=encodeURI(Pe).replace(/%25/g,"%")}catch(ue){return null}return Pe}var c={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(De,ye){c[" "+De]||(t.test(De)?c[" "+De]=De+"/":c[" "+De]=_(De,"/",!0)),De=c[" "+De];var Pe=De.indexOf(":")===-1;return ye.substring(0,2)==="//"?Pe?ye:De.replace(n,"$1")+ye:ye.charAt(0)==="/"?Pe?ye:De.replace(s,"$1")+ye:De+ye}var o={exec:function(){}};function p(De){for(var ye=1,Pe,oe;ye<arguments.length;ye++){Pe=arguments[ye];for(oe in Pe)Object.prototype.hasOwnProperty.call(Pe,oe)&&(De[oe]=Pe[oe])}return De}function f(De,ye){var Pe=De.replace(/\|/g,function(z,J,ce){for(var Ie=!1,Ae=J;--Ae>=0&&ce[Ae]==="\\";)Ie=!Ie;return Ie?"|":" |"}),oe=Pe.split(/ \|/),ue=0;if(oe.length>ye)oe.splice(ye);else for(;oe.length<ye;)oe.push("");for(;ue<oe.length;ue++)oe[ue]=oe[ue].trim().replace(/\\\|/g,"|");return oe}function _(De,ye,Pe){var oe=De.length;if(oe===0)return"";for(var ue=0;ue<oe;){var z=De.charAt(oe-ue-1);if(z===ye&&!Pe)ue++;else if(z!==ye&&Pe)ue++;else break}return De.substr(0,oe-ue)}function u(De,ye){if(De.indexOf(ye[1])===-1)return-1;for(var Pe=De.length,oe=0,ue=0;ue<Pe;ue++)if(De[ue]==="\\")ue++;else if(De[ue]===ye[0])oe++;else if(De[ue]===ye[1]&&(oe--,oe<0))return ue;return-1}function v(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(De,ye){if(ye<1)return"";for(var Pe="";ye>1;)ye&1&&(Pe+=De),ye>>=1,De+=De;return Pe+De}var O={escape:g,unescape:h,edit:w,cleanUrl:l,resolveUrl:r,noopTest:o,merge:p,splitCells:f,rtrim:_,findClosingBracket:u,checkSanitizeDeprecation:v,repeatString:R},H=y.defaults,ne=O.rtrim,ie=O.splitCells,U=O.escape,B=O.findClosingBracket;function x(De,ye,Pe){var oe=ye.href,ue=ye.title?U(ye.title):null,z=De[1].replace(/\\([\[\]])/g,"$1");return De[0].charAt(0)!=="!"?{type:"link",raw:Pe,href:oe,title:ue,text:z}:{type:"image",raw:Pe,href:oe,title:ue,text:U(z)}}function L(De,ye){var Pe=De.match(/^(\s+)(?:```)/);if(Pe===null)return ye;var oe=Pe[1];return ye.split(`
`).map(function(ue){var z=ue.match(/^\s+/);if(z===null)return ue;var J=z[0];return J.length>=oe.length?ue.slice(oe.length):ue}).join(`
`)}var N=function(){function De(Pe){this.options=Pe||H}var ye=De.prototype;return ye.space=function(oe){var ue=this.rules.block.newline.exec(oe);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},ye.code=function(oe){var ue=this.rules.block.code.exec(oe);if(ue){var z=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?z:ne(z,`
`)}}},ye.fences=function(oe){var ue=this.rules.block.fences.exec(oe);if(ue){var z=ue[0],J=L(z,ue[3]||"");return{type:"code",raw:z,lang:ue[2]?ue[2].trim():ue[2],text:J}}},ye.heading=function(oe){var ue=this.rules.block.heading.exec(oe);if(ue){var z=ue[2].trim();if(/#$/.test(z)){var J=ne(z,"#");(this.options.pedantic||!J||/ $/.test(J))&&(z=J.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:z}}},ye.nptable=function(oe){var ue=this.rules.block.nptable.exec(oe);if(ue){var z={type:"table",header:ie(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[],raw:ue[0]};if(z.header.length===z.align.length){var J=z.align.length,ce;for(ce=0;ce<J;ce++)/^ *-+: *$/.test(z.align[ce])?z.align[ce]="right":/^ *:-+: *$/.test(z.align[ce])?z.align[ce]="center":/^ *:-+ *$/.test(z.align[ce])?z.align[ce]="left":z.align[ce]=null;for(J=z.cells.length,ce=0;ce<J;ce++)z.cells[ce]=ie(z.cells[ce],z.header.length);return z}}},ye.hr=function(oe){var ue=this.rules.block.hr.exec(oe);if(ue)return{type:"hr",raw:ue[0]}},ye.blockquote=function(oe){var ue=this.rules.block.blockquote.exec(oe);if(ue){var z=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],text:z}}},ye.list=function(oe){var ue=this.rules.block.list.exec(oe);if(ue){var z=ue[0],J=ue[2],ce=J.length>1,Ie={type:"list",raw:z,ordered:ce,start:ce?+J.slice(0,-1):"",loose:!1,items:[]},Ae=ue[0].match(this.rules.block.item),Le=!1,$e,Xe,rt,tt,Qe,gt,wt,be,he=Ae.length;rt=this.rules.block.listItemStart.exec(Ae[0]);for(var ae=0;ae<he;ae++){if($e=Ae[ae],z=$e,ae!==he-1){if(tt=this.rules.block.listItemStart.exec(Ae[ae+1]),this.options.pedantic?tt[1].length>rt[1].length:tt[1].length>rt[0].length||tt[1].length>3){Ae.splice(ae,2,Ae[ae]+`
`+Ae[ae+1]),ae--,he--;continue}else(!this.options.pedantic||this.options.smartLists?tt[2][tt[2].length-1]!==J[J.length-1]:ce===(tt[2].length===1))&&(Qe=Ae.slice(ae+1).join(`
`),Ie.raw=Ie.raw.substring(0,Ie.raw.length-Qe.length),ae=he-1);rt=tt}Xe=$e.length,$e=$e.replace(/^ *([*+-]|\d+[.)]) ?/,""),~$e.indexOf(`
 `)&&(Xe-=$e.length,$e=this.options.pedantic?$e.replace(/^ {1,4}/gm,""):$e.replace(new RegExp("^ {1,"+Xe+"}","gm"),"")),gt=Le||/\n\n(?!\s*$)/.test($e),ae!==he-1&&(Le=$e.charAt($e.length-1)===`
`,gt||(gt=Le)),gt&&(Ie.loose=!0),this.options.gfm&&(wt=/^\[[ xX]\] /.test($e),be=void 0,wt&&(be=$e[1]!==" ",$e=$e.replace(/^\[[ xX]\] +/,""))),Ie.items.push({type:"list_item",raw:z,task:wt,checked:be,loose:gt,text:$e})}return Ie}},ye.html=function(oe){var ue=this.rules.block.html.exec(oe);if(ue)return{type:this.options.sanitize?"paragraph":"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):U(ue[0]):ue[0]}},ye.def=function(oe){var ue=this.rules.block.def.exec(oe);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var z=ue[1].toLowerCase().replace(/\s+/g," ");return{tag:z,raw:ue[0],href:ue[2],title:ue[3]}}},ye.table=function(oe){var ue=this.rules.block.table.exec(oe);if(ue){var z={type:"table",header:ie(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(z.header.length===z.align.length){z.raw=ue[0];var J=z.align.length,ce;for(ce=0;ce<J;ce++)/^ *-+: *$/.test(z.align[ce])?z.align[ce]="right":/^ *:-+: *$/.test(z.align[ce])?z.align[ce]="center":/^ *:-+ *$/.test(z.align[ce])?z.align[ce]="left":z.align[ce]=null;for(J=z.cells.length,ce=0;ce<J;ce++)z.cells[ce]=ie(z.cells[ce].replace(/^ *\| *| *\| *$/g,""),z.header.length);return z}}},ye.lheading=function(oe){var ue=this.rules.block.lheading.exec(oe);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1]}},ye.paragraph=function(oe){var ue=this.rules.block.paragraph.exec(oe);if(ue)return{type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1]}},ye.text=function(oe){var ue=this.rules.block.text.exec(oe);if(ue)return{type:"text",raw:ue[0],text:ue[0]}},ye.escape=function(oe){var ue=this.rules.inline.escape.exec(oe);if(ue)return{type:"escape",raw:ue[0],text:U(ue[1])}},ye.tag=function(oe,ue,z){var J=this.rules.inline.tag.exec(oe);if(J)return!ue&&/^<a /i.test(J[0])?ue=!0:ue&&/^<\/a>/i.test(J[0])&&(ue=!1),!z&&/^<(pre|code|kbd|script)(\s|>)/i.test(J[0])?z=!0:z&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(J[0])&&(z=!1),{type:this.options.sanitize?"text":"html",raw:J[0],inLink:ue,inRawBlock:z,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):U(J[0]):J[0]}},ye.link=function(oe){var ue=this.rules.inline.link.exec(oe);if(ue){var z=ue[2].trim();if(!this.options.pedantic&&/^</.test(z)){if(!/>$/.test(z))return;var J=ne(z.slice(0,-1),"\\");if((z.length-J.length)%2==0)return}else{var ce=B(ue[2],"()");if(ce>-1){var Ie=ue[0].indexOf("!")===0?5:4,Ae=Ie+ue[1].length+ce;ue[2]=ue[2].substring(0,ce),ue[0]=ue[0].substring(0,Ae).trim(),ue[3]=""}}var Le=ue[2],$e="";if(this.options.pedantic){var Xe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Le);Xe&&(Le=Xe[1],$e=Xe[3])}else $e=ue[3]?ue[3].slice(1,-1):"";return Le=Le.trim(),/^</.test(Le)&&(this.options.pedantic&&!/>$/.test(z)?Le=Le.slice(1):Le=Le.slice(1,-1)),x(ue,{href:Le&&Le.replace(this.rules.inline._escapes,"$1"),title:$e&&$e.replace(this.rules.inline._escapes,"$1")},ue[0])}},ye.reflink=function(oe,ue){var z;if((z=this.rules.inline.reflink.exec(oe))||(z=this.rules.inline.nolink.exec(oe))){var J=(z[2]||z[1]).replace(/\s+/g," ");if(J=ue[J.toLowerCase()],!J||!J.href){var ce=z[0].charAt(0);return{type:"text",raw:ce,text:ce}}return x(z,J,z[0])}},ye.emStrong=function(oe,ue,z){z===void 0&&(z="");var J=this.rules.inline.emStrong.lDelim.exec(oe);if(!!J&&!(J[3]&&z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ce=J[1]||J[2]||"";if(!ce||ce&&(z===""||this.rules.inline.punctuation.exec(z))){var Ie=J[0].length-1,Ae,Le,$e=Ie,Xe=0,rt=J[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,ue=ue.slice(-1*oe.length+Ie);(J=rt.exec(ue))!=null;)if(Ae=J[1]||J[2]||J[3]||J[4]||J[5]||J[6],!!Ae){if(Le=Ae.length,J[3]||J[4]){$e+=Le;continue}else if((J[5]||J[6])&&Ie%3&&!((Ie+Le)%3)){Xe+=Le;continue}if($e-=Le,!($e>0)){if($e+Xe-Le<=0&&!ue.slice(rt.lastIndex).match(rt)&&(Le=Math.min(Le,Le+$e+Xe)),Math.min(Ie,Le)%2)return{type:"em",raw:oe.slice(0,Ie+J.index+Le+1),text:oe.slice(1,Ie+J.index+Le)};if(Math.min(Ie,Le)%2==0)return{type:"strong",raw:oe.slice(0,Ie+J.index+Le+1),text:oe.slice(2,Ie+J.index+Le-1)}}}}}},ye.codespan=function(oe){var ue=this.rules.inline.code.exec(oe);if(ue){var z=ue[2].replace(/\n/g," "),J=/[^ ]/.test(z),ce=/^ /.test(z)&&/ $/.test(z);return J&&ce&&(z=z.substring(1,z.length-1)),z=U(z,!0),{type:"codespan",raw:ue[0],text:z}}},ye.br=function(oe){var ue=this.rules.inline.br.exec(oe);if(ue)return{type:"br",raw:ue[0]}},ye.del=function(oe){var ue=this.rules.inline.del.exec(oe);if(ue)return{type:"del",raw:ue[0],text:ue[2]}},ye.autolink=function(oe,ue){var z=this.rules.inline.autolink.exec(oe);if(z){var J,ce;return z[2]==="@"?(J=U(this.options.mangle?ue(z[1]):z[1]),ce="mailto:"+J):(J=U(z[1]),ce=J),{type:"link",raw:z[0],text:J,href:ce,tokens:[{type:"text",raw:J,text:J}]}}},ye.url=function(oe,ue){var z;if(z=this.rules.inline.url.exec(oe)){var J,ce;if(z[2]==="@")J=U(this.options.mangle?ue(z[0]):z[0]),ce="mailto:"+J;else{var Ie;do Ie=z[0],z[0]=this.rules.inline._backpedal.exec(z[0])[0];while(Ie!==z[0]);J=U(z[0]),z[1]==="www."?ce="http://"+J:ce=J}return{type:"link",raw:z[0],text:J,href:ce,tokens:[{type:"text",raw:J,text:J}]}}},ye.inlineText=function(oe,ue,z){var J=this.rules.inline.text.exec(oe);if(J){var ce;return ue?ce=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):U(J[0]):J[0]:ce=U(this.options.smartypants?z(J[0]):J[0]),{type:"text",raw:J[0],text:ce}}},De}(),F=O.noopTest,M=O.edit,$=O.merge,q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:F,table:F,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=M(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,q.item=M(q.item,"gm").replace(/bull/g,q.bullet).getRegex(),q.listItemStart=M(/^( *)(bull)/).replace("bull",q.bullet).getRegex(),q.list=M(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=M(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=M(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.blockquote=M(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=$({},q),q.gfm=$({},q.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.nptable=M(q.gfm.nptable).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.gfm.table=M(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.pedantic=$({},q.normal,{html:M(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:F,paragraph:M(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var G={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:F,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:F,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};G._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",G.punctuation=M(G.punctuation).replace(/punctuation/g,G._punctuation).getRegex(),G.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,G.escapedEmSt=/\\\*|\\_/g,G._comment=M(q._comment).replace("(?:-->|$)","-->").getRegex(),G.emStrong.lDelim=M(G.emStrong.lDelim).replace(/punct/g,G._punctuation).getRegex(),G.emStrong.rDelimAst=M(G.emStrong.rDelimAst,"g").replace(/punct/g,G._punctuation).getRegex(),G.emStrong.rDelimUnd=M(G.emStrong.rDelimUnd,"g").replace(/punct/g,G._punctuation).getRegex(),G._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,G._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,G._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,G.autolink=M(G.autolink).replace("scheme",G._scheme).replace("email",G._email).getRegex(),G._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,G.tag=M(G.tag).replace("comment",G._comment).replace("attribute",G._attribute).getRegex(),G._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,G._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,G._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,G.link=M(G.link).replace("label",G._label).replace("href",G._href).replace("title",G._title).getRegex(),G.reflink=M(G.reflink).replace("label",G._label).getRegex(),G.reflinkSearch=M(G.reflinkSearch,"g").replace("reflink",G.reflink).replace("nolink",G.nolink).getRegex(),G.normal=$({},G),G.pedantic=$({},G.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:M(/^!?\[(label)\]\((.*?)\)/).replace("label",G._label).getRegex(),reflink:M(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",G._label).getRegex()}),G.gfm=$({},G.normal,{escape:M(G.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),G.gfm.url=M(G.gfm.url,"i").replace("email",G.gfm._extended_email).getRegex(),G.breaks=$({},G.gfm,{br:M(G.br).replace("{2,}","*").getRegex(),text:M(G.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var le={block:q,inline:G},ve=y.defaults,Re=le.block,Se=le.inline,Oe=O.repeatString;function V(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function X(De){var ye="",Pe,oe,ue=De.length;for(Pe=0;Pe<ue;Pe++)oe=De.charCodeAt(Pe),Math.random()>.5&&(oe="x"+oe.toString(16)),ye+="&#"+oe+";";return ye}var Z=function(){function De(Pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=Pe||ve,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var oe={block:Re.normal,inline:Se.normal};this.options.pedantic?(oe.block=Re.pedantic,oe.inline=Se.pedantic):this.options.gfm&&(oe.block=Re.gfm,this.options.breaks?oe.inline=Se.breaks:oe.inline=Se.gfm),this.tokenizer.rules=oe}De.lex=function(oe,ue){var z=new De(ue);return z.lex(oe)},De.lexInline=function(oe,ue){var z=new De(ue);return z.inlineTokens(oe)};var ye=De.prototype;return ye.lex=function(oe){return oe=oe.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(oe,this.tokens,!0),this.inline(this.tokens),this.tokens},ye.blockTokens=function(oe,ue,z){ue===void 0&&(ue=[]),z===void 0&&(z=!0),this.options.pedantic&&(oe=oe.replace(/^ +$/gm,""));for(var J,ce,Ie,Ae;oe;){if(J=this.tokenizer.space(oe)){oe=oe.substring(J.raw.length),J.type&&ue.push(J);continue}if(J=this.tokenizer.code(oe)){oe=oe.substring(J.raw.length),Ae=ue[ue.length-1],Ae&&Ae.type==="paragraph"?(Ae.raw+=`
`+J.raw,Ae.text+=`
`+J.text):ue.push(J);continue}if(J=this.tokenizer.fences(oe)){oe=oe.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.heading(oe)){oe=oe.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.nptable(oe)){oe=oe.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.hr(oe)){oe=oe.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.blockquote(oe)){oe=oe.substring(J.raw.length),J.tokens=this.blockTokens(J.text,[],z),ue.push(J);continue}if(J=this.tokenizer.list(oe)){for(oe=oe.substring(J.raw.length),Ie=J.items.length,ce=0;ce<Ie;ce++)J.items[ce].tokens=this.blockTokens(J.items[ce].text,[],!1);ue.push(J);continue}if(J=this.tokenizer.html(oe)){oe=oe.substring(J.raw.length),ue.push(J);continue}if(z&&(J=this.tokenizer.def(oe))){oe=oe.substring(J.raw.length),this.tokens.links[J.tag]||(this.tokens.links[J.tag]={href:J.href,title:J.title});continue}if(J=this.tokenizer.table(oe)){oe=oe.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.lheading(oe)){oe=oe.substring(J.raw.length),ue.push(J);continue}if(z&&(J=this.tokenizer.paragraph(oe))){oe=oe.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.text(oe)){oe=oe.substring(J.raw.length),Ae=ue[ue.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+J.raw,Ae.text+=`
`+J.text):ue.push(J);continue}if(oe){var Le="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Le);break}else throw new Error(Le)}}return ue},ye.inline=function(oe){var ue,z,J,ce,Ie,Ae,Le=oe.length;for(ue=0;ue<Le;ue++)switch(Ae=oe[ue],Ae.type){case"paragraph":case"text":case"heading":{Ae.tokens=[],this.inlineTokens(Ae.text,Ae.tokens);break}case"table":{for(Ae.tokens={header:[],cells:[]},ce=Ae.header.length,z=0;z<ce;z++)Ae.tokens.header[z]=[],this.inlineTokens(Ae.header[z],Ae.tokens.header[z]);for(ce=Ae.cells.length,z=0;z<ce;z++)for(Ie=Ae.cells[z],Ae.tokens.cells[z]=[],J=0;J<Ie.length;J++)Ae.tokens.cells[z][J]=[],this.inlineTokens(Ie[J],Ae.tokens.cells[z][J]);break}case"blockquote":{this.inline(Ae.tokens);break}case"list":{for(ce=Ae.items.length,z=0;z<ce;z++)this.inline(Ae.items[z].tokens);break}}return oe},ye.inlineTokens=function(oe,ue,z,J){ue===void 0&&(ue=[]),z===void 0&&(z=!1),J===void 0&&(J=!1);var ce,Ie,Ae=oe,Le,$e,Xe;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Le=this.tokenizer.rules.inline.reflinkSearch.exec(Ae))!=null;)rt.includes(Le[0].slice(Le[0].lastIndexOf("[")+1,-1))&&(Ae=Ae.slice(0,Le.index)+"["+Oe("a",Le[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Le=this.tokenizer.rules.inline.blockSkip.exec(Ae))!=null;)Ae=Ae.slice(0,Le.index)+"["+Oe("a",Le[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Le=this.tokenizer.rules.inline.escapedEmSt.exec(Ae))!=null;)Ae=Ae.slice(0,Le.index)+"++"+Ae.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;){if($e||(Xe=""),$e=!1,ce=this.tokenizer.escape(oe)){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(ce=this.tokenizer.tag(oe,z,J)){oe=oe.substring(ce.raw.length),z=ce.inLink,J=ce.inRawBlock;var tt=ue[ue.length-1];tt&&ce.type==="text"&&tt.type==="text"?(tt.raw+=ce.raw,tt.text+=ce.text):ue.push(ce);continue}if(ce=this.tokenizer.link(oe)){oe=oe.substring(ce.raw.length),ce.type==="link"&&(ce.tokens=this.inlineTokens(ce.text,[],!0,J)),ue.push(ce);continue}if(ce=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(ce.raw.length);var Qe=ue[ue.length-1];ce.type==="link"?(ce.tokens=this.inlineTokens(ce.text,[],!0,J),ue.push(ce)):Qe&&ce.type==="text"&&Qe.type==="text"?(Qe.raw+=ce.raw,Qe.text+=ce.text):ue.push(ce);continue}if(ce=this.tokenizer.emStrong(oe,Ae,Xe)){oe=oe.substring(ce.raw.length),ce.tokens=this.inlineTokens(ce.text,[],z,J),ue.push(ce);continue}if(ce=this.tokenizer.codespan(oe)){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(ce=this.tokenizer.br(oe)){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(ce=this.tokenizer.del(oe)){oe=oe.substring(ce.raw.length),ce.tokens=this.inlineTokens(ce.text,[],z,J),ue.push(ce);continue}if(ce=this.tokenizer.autolink(oe,X)){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(!z&&(ce=this.tokenizer.url(oe,X))){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(ce=this.tokenizer.inlineText(oe,J,V)){oe=oe.substring(ce.raw.length),ce.raw.slice(-1)!=="_"&&(Xe=ce.raw.slice(-1)),$e=!0,Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=ce.raw,Ie.text+=ce.text):ue.push(ce);continue}if(oe){var gt="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(gt);break}else throw new Error(gt)}}return ue},e(De,null,[{key:"rules",get:function(){return{block:Re,inline:Se}}}]),De}(),se=y.defaults,fe=O.cleanUrl,Ee=O.escape,Be=function(){function De(Pe){this.options=Pe||se}var ye=De.prototype;return ye.code=function(oe,ue,z){var J=(ue||"").match(/\S*/)[0];if(this.options.highlight){var ce=this.options.highlight(oe,J);ce!=null&&ce!==oe&&(z=!0,oe=ce)}return oe=oe.replace(/\n$/,"")+`
`,J?'<pre><code class="'+this.options.langPrefix+Ee(J,!0)+'">'+(z?oe:Ee(oe,!0))+`</code></pre>
`:"<pre><code>"+(z?oe:Ee(oe,!0))+`</code></pre>
`},ye.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},ye.html=function(oe){return oe},ye.heading=function(oe,ue,z,J){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+J.slug(z)+'">'+oe+"</h"+ue+`>
`:"<h"+ue+">"+oe+"</h"+ue+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(oe,ue,z){var J=ue?"ol":"ul",ce=ue&&z!==1?' start="'+z+'"':"";return"<"+J+ce+`>
`+oe+"</"+J+`>
`},ye.listitem=function(oe){return"<li>"+oe+`</li>
`},ye.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(oe){return"<p>"+oe+`</p>
`},ye.table=function(oe,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+ue+`</table>
`},ye.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},ye.tablecell=function(oe,ue){var z=ue.header?"th":"td",J=ue.align?"<"+z+' align="'+ue.align+'">':"<"+z+">";return J+oe+"</"+z+`>
`},ye.strong=function(oe){return"<strong>"+oe+"</strong>"},ye.em=function(oe){return"<em>"+oe+"</em>"},ye.codespan=function(oe){return"<code>"+oe+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(oe){return"<del>"+oe+"</del>"},ye.link=function(oe,ue,z){if(oe=fe(this.options.sanitize,this.options.baseUrl,oe),oe===null)return z;var J='<a href="'+Ee(oe)+'"';return ue&&(J+=' title="'+ue+'"'),J+=">"+z+"</a>",J},ye.image=function(oe,ue,z){if(oe=fe(this.options.sanitize,this.options.baseUrl,oe),oe===null)return z;var J='<img src="'+oe+'" alt="'+z+'"';return ue&&(J+=' title="'+ue+'"'),J+=this.options.xhtml?"/>":">",J},ye.text=function(oe){return oe},De}(),pe=function(){function De(){}var ye=De.prototype;return ye.strong=function(oe){return oe},ye.em=function(oe){return oe},ye.codespan=function(oe){return oe},ye.del=function(oe){return oe},ye.html=function(oe){return oe},ye.text=function(oe){return oe},ye.link=function(oe,ue,z){return""+z},ye.image=function(oe,ue,z){return""+z},ye.br=function(){return""},De}(),Ce=function(){function De(){this.seen={}}var ye=De.prototype;return ye.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(oe,ue){var z=oe,J=0;if(this.seen.hasOwnProperty(z)){J=this.seen[oe];do J++,z=oe+"-"+J;while(this.seen.hasOwnProperty(z))}return ue||(this.seen[oe]=J,this.seen[z]=0),z},ye.slug=function(oe,ue){ue===void 0&&(ue={});var z=this.serialize(oe);return this.getNextSafeSlug(z,ue.dryrun)},De}(),Me=y.defaults,ze=O.unescape,_e=function(){function De(Pe){this.options=Pe||Me,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new pe,this.slugger=new Ce}De.parse=function(oe,ue){var z=new De(ue);return z.parse(oe)},De.parseInline=function(oe,ue){var z=new De(ue);return z.parseInline(oe)};var ye=De.prototype;return ye.parse=function(oe,ue){ue===void 0&&(ue=!0);var z="",J,ce,Ie,Ae,Le,$e,Xe,rt,tt,Qe,gt,wt,be,he,ae,Y,Ne,Fe,Ye=oe.length;for(J=0;J<Ye;J++)switch(Qe=oe[J],Qe.type){case"space":continue;case"hr":{z+=this.renderer.hr();continue}case"heading":{z+=this.renderer.heading(this.parseInline(Qe.tokens),Qe.depth,ze(this.parseInline(Qe.tokens,this.textRenderer)),this.slugger);continue}case"code":{z+=this.renderer.code(Qe.text,Qe.lang,Qe.escaped);continue}case"table":{for(rt="",Xe="",Ae=Qe.header.length,ce=0;ce<Ae;ce++)Xe+=this.renderer.tablecell(this.parseInline(Qe.tokens.header[ce]),{header:!0,align:Qe.align[ce]});for(rt+=this.renderer.tablerow(Xe),tt="",Ae=Qe.cells.length,ce=0;ce<Ae;ce++){for($e=Qe.tokens.cells[ce],Xe="",Le=$e.length,Ie=0;Ie<Le;Ie++)Xe+=this.renderer.tablecell(this.parseInline($e[Ie]),{header:!1,align:Qe.align[Ie]});tt+=this.renderer.tablerow(Xe)}z+=this.renderer.table(rt,tt);continue}case"blockquote":{tt=this.parse(Qe.tokens),z+=this.renderer.blockquote(tt);continue}case"list":{for(gt=Qe.ordered,wt=Qe.start,be=Qe.loose,Ae=Qe.items.length,tt="",ce=0;ce<Ae;ce++)ae=Qe.items[ce],Y=ae.checked,Ne=ae.task,he="",ae.task&&(Fe=this.renderer.checkbox(Y),be?ae.tokens.length>0&&ae.tokens[0].type==="text"?(ae.tokens[0].text=Fe+" "+ae.tokens[0].text,ae.tokens[0].tokens&&ae.tokens[0].tokens.length>0&&ae.tokens[0].tokens[0].type==="text"&&(ae.tokens[0].tokens[0].text=Fe+" "+ae.tokens[0].tokens[0].text)):ae.tokens.unshift({type:"text",text:Fe}):he+=Fe),he+=this.parse(ae.tokens,be),tt+=this.renderer.listitem(he,Ne,Y);z+=this.renderer.list(tt,gt,wt);continue}case"html":{z+=this.renderer.html(Qe.text);continue}case"paragraph":{z+=this.renderer.paragraph(this.parseInline(Qe.tokens));continue}case"text":{for(tt=Qe.tokens?this.parseInline(Qe.tokens):Qe.text;J+1<Ye&&oe[J+1].type==="text";)Qe=oe[++J],tt+=`
`+(Qe.tokens?this.parseInline(Qe.tokens):Qe.text);z+=ue?this.renderer.paragraph(tt):tt;continue}default:{var et='Token with "'+Qe.type+'" type was not found.';if(this.options.silent){console.error(et);return}else throw new Error(et)}}return z},ye.parseInline=function(oe,ue){ue=ue||this.renderer;var z="",J,ce,Ie=oe.length;for(J=0;J<Ie;J++)switch(ce=oe[J],ce.type){case"escape":{z+=ue.text(ce.text);break}case"html":{z+=ue.html(ce.text);break}case"link":{z+=ue.link(ce.href,ce.title,this.parseInline(ce.tokens,ue));break}case"image":{z+=ue.image(ce.href,ce.title,ce.text);break}case"strong":{z+=ue.strong(this.parseInline(ce.tokens,ue));break}case"em":{z+=ue.em(this.parseInline(ce.tokens,ue));break}case"codespan":{z+=ue.codespan(ce.text);break}case"br":{z+=ue.br();break}case"del":{z+=ue.del(this.parseInline(ce.tokens,ue));break}case"text":{z+=ue.text(ce.text);break}default:{var Ae='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}return z},De}(),Ke=O.merge,Q=O.checkSanitizeDeprecation,te=O.escape,we=y.getDefaults,xe=y.changeDefaults,je=y.defaults;function Ve(De,ye,Pe){if(typeof De=="undefined"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof ye=="function"&&(Pe=ye,ye=null),ye=Ke({},Ve.defaults,ye||{}),Q(ye),Pe){var oe=ye.highlight,ue;try{ue=Z.lex(De,ye)}catch(Ie){return Pe(Ie)}var z=function(Ae){var Le;if(!Ae)try{Le=_e.parse(ue,ye)}catch($e){Ae=$e}return ye.highlight=oe,Ae?Pe(Ae):Pe(null,Le)};if(!oe||oe.length<3||(delete ye.highlight,!ue.length))return z();var J=0;Ve.walkTokens(ue,function(Ie){Ie.type==="code"&&(J++,setTimeout(function(){oe(Ie.text,Ie.lang,function(Ae,Le){if(Ae)return z(Ae);Le!=null&&Le!==Ie.text&&(Ie.text=Le,Ie.escaped=!0),J--,J===0&&z()})},0))}),J===0&&z();return}try{var ce=Z.lex(De,ye);return ye.walkTokens&&Ve.walkTokens(ce,ye.walkTokens),_e.parse(ce,ye)}catch(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+te(Ie.message+"",!0)+"</pre>";throw Ie}}Ve.options=Ve.setOptions=function(De){return Ke(Ve.defaults,De),xe(Ve.defaults),Ve},Ve.getDefaults=we,Ve.defaults=je,Ve.use=function(De){var ye=Ke({},De);if(De.renderer&&function(){var oe=Ve.defaults.renderer||new Be,ue=function(ce){var Ie=oe[ce];oe[ce]=function(){for(var Ae=arguments.length,Le=new Array(Ae),$e=0;$e<Ae;$e++)Le[$e]=arguments[$e];var Xe=De.renderer[ce].apply(oe,Le);return Xe===!1&&(Xe=Ie.apply(oe,Le)),Xe}};for(var z in De.renderer)ue(z);ye.renderer=oe}(),De.tokenizer&&function(){var oe=Ve.defaults.tokenizer||new N,ue=function(ce){var Ie=oe[ce];oe[ce]=function(){for(var Ae=arguments.length,Le=new Array(Ae),$e=0;$e<Ae;$e++)Le[$e]=arguments[$e];var Xe=De.tokenizer[ce].apply(oe,Le);return Xe===!1&&(Xe=Ie.apply(oe,Le)),Xe}};for(var z in De.tokenizer)ue(z);ye.tokenizer=oe}(),De.walkTokens){var Pe=Ve.defaults.walkTokens;ye.walkTokens=function(oe){De.walkTokens(oe),Pe&&Pe(oe)}}Ve.setOptions(ye)},Ve.walkTokens=function(De,ye){for(var Pe=C(De),oe;!(oe=Pe()).done;){var ue=oe.value;switch(ye(ue),ue.type){case"table":{for(var z=C(ue.tokens.header),J;!(J=z()).done;){var ce=J.value;Ve.walkTokens(ce,ye)}for(var Ie=C(ue.tokens.cells),Ae;!(Ae=Ie()).done;)for(var Le=Ae.value,$e=C(Le),Xe;!(Xe=$e()).done;){var rt=Xe.value;Ve.walkTokens(rt,ye)}break}case"list":{Ve.walkTokens(ue.items,ye);break}default:ue.tokens&&Ve.walkTokens(ue.tokens,ye)}}},Ve.parseInline=function(De,ye){if(typeof De=="undefined"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");ye=Ke({},Ve.defaults,ye||{}),Q(ye);try{var Pe=Z.lexInline(De,ye);return ye.walkTokens&&Ve.walkTokens(Pe,ye.walkTokens),_e.parseInline(Pe,ye)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+te(oe.message+"",!0)+"</pre>";throw oe}},Ve.Parser=_e,Ve.parser=_e.parse,Ve.Renderer=Be,Ve.TextRenderer=pe,Ve.Lexer=Z,Ve.lexer=Z.lex,Ve.Tokenizer=N,Ve.Slugger=Ce,Ve.parse=Ve;var Je=Ve;return Je}),define(me[74],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function b(y,k,D){return Math.min(Math.max(y,k),D)}e.clamp=b;function T(y,k){return(k+y%k)%k}e.rot=T;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class A{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A});"use strict";(function(){function K(C){const A=[];typeof C=="number"&&A.push("code/timeOrigin",C);function y(D){A.push(D,Date.now())}function k(){const D=[];for(let P=0;P<A.length;P+=2)D.push({name:A[P],startTime:A[P+1]});return D}return{mark:y,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const y of performance.getEntriesByType("mark"))A.push({name:y.name,startTime:Math.round(C+y.startTime)});return A}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function b(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=b(T))})(),define(me[10],ge([0,1]),function(K,e){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const T="en";let C=!1,A=!1,y=!1,k=!1,D=!1,P=!1,i=!1,I,m=T,g,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const S=typeof((b=h==null?void 0:h.versions)===null||b===void 0?void 0:b.electron)=="string"&&h.type==="renderer";if(e.isElectronSandboxed=S&&(h==null?void 0:h.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=h==null?void 0:h.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!S)a=navigator.userAgent,C=a.indexOf("Windows")>=0,A=a.indexOf("Macintosh")>=0,i=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=a.indexOf("Linux")>=0,P=!0,I=navigator.language,m=I;else if(typeof h=="object"){C=h.platform==="win32",A=h.platform==="darwin",y=h.platform==="linux",k=y&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,I=T,m=T;const r=h.env.VSCODE_NLS_CONFIG;if(r)try{const o=JSON.parse(r),p=o.availableLanguages["*"];I=o.locale,m=p||T,g=o._translationsConfigFile}catch(o){}D=!0}else console.error("Unable to resolve platform.");var w;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function E(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let d=0;A?d=1:C?d=3:y&&(d=2),e.isWindows=C,e.isMacintosh=A,e.isLinux=y,e.isLinuxSnap=k,e.isNative=D,e.isWeb=P,e.isIOS=i,e.platform=d,e.userAgent=a,e.language=m;var l;(function(r){function o(){return e.language}r.value=o;function p(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=p;function f(){return e.language==="en"}r.isDefault=f})(l=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let p=[];e.globals.addEventListener("message",_=>{if(_.data&&_.data.vscodeSetImmediateId)for(let u=0,v=p.length;u<v;u++){const R=p[u];if(R.id===_.data.vscodeSetImmediateId){p.splice(u,1),R.callback();return}}});let f=0;return _=>{const u=++f;p.push({id:u,callback:_}),e.globals.postMessage({vscodeSetImmediateId:u},"*")}}if(typeof(h==null?void 0:h.nextTick)=="function")return h.nextTick.bind(h);const o=Promise.resolve();return p=>o.then(p)}();var c;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||i?2:C?1:3;let t=!0,n=!1;function s(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(me[36],ge([0,1,10]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let T;if(typeof b.globals.vscode!="undefined"&&typeof b.globals.vscode.process!="undefined"){const C=b.globals.vscode.process;T={get platform(){return C.platform},get env(){return C.env},cwd(){return C.cwd()},nextTick(A){return(0,b.setImmediate)(A)}}}else typeof process!="undefined"?T={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:T={get platform(){return b.isWindows?"win32":b.isMacintosh?"darwin":"linux"},nextTick(C){return(0,b.setImmediate)(C)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.platform=T.platform,e.nextTick=T.nextTick}),define(me[8],ge([0,1,36]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const T=65,C=97,A=90,y=122,k=46,D=47,P=92,i=58,I=63;class m extends Error{constructor(l,c,t){let n;typeof c=="string"&&c.indexOf("not ")===0?(n="must not be",c=c.replace(/^not /,"")):n="must be";const s=l.indexOf(".")!==-1?"property":"argument";let r=`The "${l}" ${s} ${n} of type ${c}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function g(d,l){if(typeof d!="string")throw new m(l,"string",d)}function a(d){return d===D||d===P}function h(d){return d===D}function S(d){return d>=T&&d<=A||d>=C&&d<=y}function w(d,l,c,t){let n="",s=0,r=-1,o=0,p=0;for(let f=0;f<=d.length;++f){if(f<d.length)p=d.charCodeAt(f);else{if(t(p))break;p=D}if(t(p)){if(!(r===f-1||o===1))if(o===2){if(n.length<2||s!==2||n.charCodeAt(n.length-1)!==k||n.charCodeAt(n.length-2)!==k){if(n.length>2){const _=n.lastIndexOf(c);_===-1?(n="",s=0):(n=n.slice(0,_),s=n.length-1-n.lastIndexOf(c)),r=f,o=0;continue}else if(n.length!==0){n="",s=0,r=f,o=0;continue}}l&&(n+=n.length>0?`${c}..`:"..",s=2)}else n.length>0?n+=`${c}${d.slice(r+1,f)}`:n=d.slice(r+1,f),s=f-r-1;r=f,o=0}else p===k&&o!==-1?++o:o=-1}return n}function E(d,l){if(l===null||typeof l!="object")throw new m("pathObject","Object",l);const c=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return c?c===l.root?`${c}${t}`:`${c}${d}${t}`:t}e.win32={resolve(...d){let l="",c="",t=!1;for(let n=d.length-1;n>=-1;n--){let s;if(n>=0){if(s=d[n],g(s,"path"),s.length===0)continue}else l.length===0?s=b.cwd():(s=b.env[`=${l}`]||b.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==l.toLowerCase()&&s.charCodeAt(2)===P)&&(s=`${l}\\`));const r=s.length;let o=0,p="",f=!1;const _=s.charCodeAt(0);if(r===1)a(_)&&(o=1,f=!0);else if(a(_))if(f=!0,a(s.charCodeAt(1))){let u=2,v=u;for(;u<r&&!a(s.charCodeAt(u));)u++;if(u<r&&u!==v){const R=s.slice(v,u);for(v=u;u<r&&a(s.charCodeAt(u));)u++;if(u<r&&u!==v){for(v=u;u<r&&!a(s.charCodeAt(u));)u++;(u===r||u!==v)&&(p=`\\\\${R}\\${s.slice(v,u)}`,o=u)}}}else o=1;else S(_)&&s.charCodeAt(1)===i&&(p=s.slice(0,2),o=2,r>2&&a(s.charCodeAt(2))&&(f=!0,o=3));if(p.length>0)if(l.length>0){if(p.toLowerCase()!==l.toLowerCase())continue}else l=p;if(t){if(l.length>0)break}else if(c=`${s.slice(o)}\\${c}`,t=f,f&&l.length>0)break}return c=w(c,!t,"\\",a),t?`${l}\\${c}`:`${l}${c}`||"."},normalize(d){g(d,"path");const l=d.length;if(l===0)return".";let c=0,t,n=!1;const s=d.charCodeAt(0);if(l===1)return h(s)?"\\":d;if(a(s))if(n=!0,a(d.charCodeAt(1))){let o=2,p=o;for(;o<l&&!a(d.charCodeAt(o));)o++;if(o<l&&o!==p){const f=d.slice(p,o);for(p=o;o<l&&a(d.charCodeAt(o));)o++;if(o<l&&o!==p){for(p=o;o<l&&!a(d.charCodeAt(o));)o++;if(o===l)return`\\\\${f}\\${d.slice(p)}\\`;o!==p&&(t=`\\\\${f}\\${d.slice(p,o)}`,c=o)}}}else c=1;else S(s)&&d.charCodeAt(1)===i&&(t=d.slice(0,2),c=2,l>2&&a(d.charCodeAt(2))&&(n=!0,c=3));let r=c<l?w(d.slice(c),!n,"\\",a):"";return r.length===0&&!n&&(r="."),r.length>0&&a(d.charCodeAt(l-1))&&(r+="\\"),t===void 0?n?`\\${r}`:r:n?`${t}\\${r}`:`${t}${r}`},isAbsolute(d){g(d,"path");const l=d.length;if(l===0)return!1;const c=d.charCodeAt(0);return a(c)||l>2&&S(c)&&d.charCodeAt(1)===i&&a(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let l,c;for(let s=0;s<d.length;++s){const r=d[s];g(r,"path"),r.length>0&&(l===void 0?l=c=r:l+=`\\${r}`)}if(l===void 0)return".";let t=!0,n=0;if(typeof c=="string"&&a(c.charCodeAt(0))){++n;const s=c.length;s>1&&a(c.charCodeAt(1))&&(++n,s>2&&(a(c.charCodeAt(2))?++n:t=!1))}if(t){for(;n<l.length&&a(l.charCodeAt(n));)n++;n>=2&&(l=`\\${l.slice(n)}`)}return e.win32.normalize(l)},relative(d,l){if(g(d,"from"),g(l,"to"),d===l)return"";const c=e.win32.resolve(d),t=e.win32.resolve(l);if(c===t||(d=c.toLowerCase(),l=t.toLowerCase(),d===l))return"";let n=0;for(;n<d.length&&d.charCodeAt(n)===P;)n++;let s=d.length;for(;s-1>n&&d.charCodeAt(s-1)===P;)s--;const r=s-n;let o=0;for(;o<l.length&&l.charCodeAt(o)===P;)o++;let p=l.length;for(;p-1>o&&l.charCodeAt(p-1)===P;)p--;const f=p-o,_=r<f?r:f;let u=-1,v=0;for(;v<_;v++){const O=d.charCodeAt(n+v);if(O!==l.charCodeAt(o+v))break;O===P&&(u=v)}if(v!==_){if(u===-1)return t}else{if(f>_){if(l.charCodeAt(o+v)===P)return t.slice(o+v+1);if(v===2)return t.slice(o+v)}r>_&&(d.charCodeAt(n+v)===P?u=v:v===2&&(u=3)),u===-1&&(u=0)}let R="";for(v=n+u+1;v<=s;++v)(v===s||d.charCodeAt(v)===P)&&(R+=R.length===0?"..":"\\..");return o+=u,R.length>0?`${R}${t.slice(o,p)}`:(t.charCodeAt(o)===P&&++o,t.slice(o,p))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const l=e.win32.resolve(d);if(l.length<=2)return d;if(l.charCodeAt(0)===P){if(l.charCodeAt(1)===P){const c=l.charCodeAt(2);if(c!==I&&c!==k)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(S(l.charCodeAt(0))&&l.charCodeAt(1)===i&&l.charCodeAt(2)===P)return`\\\\?\\${l}`;return d},dirname(d){g(d,"path");const l=d.length;if(l===0)return".";let c=-1,t=0;const n=d.charCodeAt(0);if(l===1)return a(n)?d:".";if(a(n)){if(c=t=1,a(d.charCodeAt(1))){let o=2,p=o;for(;o<l&&!a(d.charCodeAt(o));)o++;if(o<l&&o!==p){for(p=o;o<l&&a(d.charCodeAt(o));)o++;if(o<l&&o!==p){for(p=o;o<l&&!a(d.charCodeAt(o));)o++;if(o===l)return d;o!==p&&(c=t=o+1)}}}}else S(n)&&d.charCodeAt(1)===i&&(c=l>2&&a(d.charCodeAt(2))?3:2,t=c);let s=-1,r=!0;for(let o=l-1;o>=t;--o)if(a(d.charCodeAt(o))){if(!r){s=o;break}}else r=!1;if(s===-1){if(c===-1)return".";s=c}return d.slice(0,s)},basename(d,l){l!==void 0&&g(l,"ext"),g(d,"path");let c=0,t=-1,n=!0,s;if(d.length>=2&&S(d.charCodeAt(0))&&d.charCodeAt(1)===i&&(c=2),l!==void 0&&l.length>0&&l.length<=d.length){if(l===d)return"";let r=l.length-1,o=-1;for(s=d.length-1;s>=c;--s){const p=d.charCodeAt(s);if(a(p)){if(!n){c=s+1;break}}else o===-1&&(n=!1,o=s+1),r>=0&&(p===l.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=o))}return c===t?t=o:t===-1&&(t=d.length),d.slice(c,t)}for(s=d.length-1;s>=c;--s)if(a(d.charCodeAt(s))){if(!n){c=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":d.slice(c,t)},extname(d){g(d,"path");let l=0,c=-1,t=0,n=-1,s=!0,r=0;d.length>=2&&d.charCodeAt(1)===i&&S(d.charCodeAt(0))&&(l=t=2);for(let o=d.length-1;o>=l;--o){const p=d.charCodeAt(o);if(a(p)){if(!s){t=o+1;break}continue}n===-1&&(s=!1,n=o+1),p===k?c===-1?c=o:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||n===-1||r===0||r===1&&c===n-1&&c===t+1?"":d.slice(c,n)},format:E.bind(null,"\\"),parse(d){g(d,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return l;const c=d.length;let t=0,n=d.charCodeAt(0);if(c===1)return a(n)?(l.root=l.dir=d,l):(l.base=l.name=d,l);if(a(n)){if(t=1,a(d.charCodeAt(1))){let u=2,v=u;for(;u<c&&!a(d.charCodeAt(u));)u++;if(u<c&&u!==v){for(v=u;u<c&&a(d.charCodeAt(u));)u++;if(u<c&&u!==v){for(v=u;u<c&&!a(d.charCodeAt(u));)u++;u===c?t=u:u!==v&&(t=u+1)}}}}else if(S(n)&&d.charCodeAt(1)===i){if(c<=2)return l.root=l.dir=d,l;if(t=2,a(d.charCodeAt(2))){if(c===3)return l.root=l.dir=d,l;t=3}}t>0&&(l.root=d.slice(0,t));let s=-1,r=t,o=-1,p=!0,f=d.length-1,_=0;for(;f>=t;--f){if(n=d.charCodeAt(f),a(n)){if(!p){r=f+1;break}continue}o===-1&&(p=!1,o=f+1),n===k?s===-1?s=f:_!==1&&(_=1):s!==-1&&(_=-1)}return o!==-1&&(s===-1||_===0||_===1&&s===o-1&&s===r+1?l.base=l.name=d.slice(r,o):(l.name=d.slice(r,s),l.base=d.slice(r,o),l.ext=d.slice(s,o))),r>0&&r!==t?l.dir=d.slice(0,r-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let l="",c=!1;for(let t=d.length-1;t>=-1&&!c;t--){const n=t>=0?d[t]:b.cwd();g(n,"path"),n.length!==0&&(l=`${n}/${l}`,c=n.charCodeAt(0)===D)}return l=w(l,!c,"/",h),c?`/${l}`:l.length>0?l:"."},normalize(d){if(g(d,"path"),d.length===0)return".";const l=d.charCodeAt(0)===D,c=d.charCodeAt(d.length-1)===D;return d=w(d,!l,"/",h),d.length===0?l?"/":c?"./":".":(c&&(d+="/"),l?`/${d}`:d)},isAbsolute(d){return g(d,"path"),d.length>0&&d.charCodeAt(0)===D},join(...d){if(d.length===0)return".";let l;for(let c=0;c<d.length;++c){const t=d[c];g(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(d,l){if(g(d,"from"),g(l,"to"),d===l||(d=e.posix.resolve(d),l=e.posix.resolve(l),d===l))return"";const c=1,t=d.length,n=t-c,s=1,r=l.length-s,o=n<r?n:r;let p=-1,f=0;for(;f<o;f++){const u=d.charCodeAt(c+f);if(u!==l.charCodeAt(s+f))break;u===D&&(p=f)}if(f===o)if(r>o){if(l.charCodeAt(s+f)===D)return l.slice(s+f+1);if(f===0)return l.slice(s+f)}else n>o&&(d.charCodeAt(c+f)===D?p=f:f===0&&(p=0));let _="";for(f=c+p+1;f<=t;++f)(f===t||d.charCodeAt(f)===D)&&(_+=_.length===0?"..":"/..");return`${_}${l.slice(s+p)}`},toNamespacedPath(d){return d},dirname(d){if(g(d,"path"),d.length===0)return".";const l=d.charCodeAt(0)===D;let c=-1,t=!0;for(let n=d.length-1;n>=1;--n)if(d.charCodeAt(n)===D){if(!t){c=n;break}}else t=!1;return c===-1?l?"/":".":l&&c===1?"//":d.slice(0,c)},basename(d,l){l!==void 0&&g(l,"ext"),g(d,"path");let c=0,t=-1,n=!0,s;if(l!==void 0&&l.length>0&&l.length<=d.length){if(l===d)return"";let r=l.length-1,o=-1;for(s=d.length-1;s>=0;--s){const p=d.charCodeAt(s);if(p===D){if(!n){c=s+1;break}}else o===-1&&(n=!1,o=s+1),r>=0&&(p===l.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=o))}return c===t?t=o:t===-1&&(t=d.length),d.slice(c,t)}for(s=d.length-1;s>=0;--s)if(d.charCodeAt(s)===D){if(!n){c=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":d.slice(c,t)},extname(d){g(d,"path");let l=-1,c=0,t=-1,n=!0,s=0;for(let r=d.length-1;r>=0;--r){const o=d.charCodeAt(r);if(o===D){if(!n){c=r+1;break}continue}t===-1&&(n=!1,t=r+1),o===k?l===-1?l=r:s!==1&&(s=1):l!==-1&&(s=-1)}return l===-1||t===-1||s===0||s===1&&l===t-1&&l===c+1?"":d.slice(l,t)},format:E.bind(null,"/"),parse(d){g(d,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return l;const c=d.charCodeAt(0)===D;let t;c?(l.root="/",t=1):t=0;let n=-1,s=0,r=-1,o=!0,p=d.length-1,f=0;for(;p>=t;--p){const _=d.charCodeAt(p);if(_===D){if(!o){s=p+1;break}continue}r===-1&&(o=!1,r=p+1),_===k?n===-1?n=p:f!==1&&(f=1):n!==-1&&(f=-1)}if(r!==-1){const _=s===0&&c?1:s;n===-1||f===0||f===1&&n===r-1&&n===s+1?l.base=l.name=d.slice(_,r):(l.name=d.slice(_,n),l.base=d.slice(_,r),l.ext=d.slice(n,r))}return s>0?l.dir=d.slice(0,s-1):c&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=b.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b.platform==="win32"?e.win32.join:e.posix.join,e.resolve=b.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=b.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=b.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=b.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=b.platform==="win32"?e.win32.extname:e.posix.extname,e.format=b.platform==="win32"?e.win32.format:e.posix.format,e.parse=b.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=b.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=b.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[96],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var b;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(b=e.Source||(e.Source={}));var T;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(T=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(A,...y){const k=y.reduce((i,I)=>(i[I]=!0,i),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(i=>!k[i]).forEach(i=>{for(let I=0;I<D.length;I++)if(i.search(D[I])!==-1){delete A[i];break}})}e.sanitizeProcessEnvironment=C}),define(me[48],ge([0,1,10]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const T=b.globals.performance&&typeof b.globals.performance.now=="function";class C{constructor(y){this._highResolution=T&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new C(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?b.globals.performance.now():Date.now()}}e.StopWatch=C}),define(me[3],ge([0,1,17,72,6,58,48]),function(K,e,b,T,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(w){w.None=()=>C.Disposable.None;function E(U){return(B,x=null,L)=>{let N=!1,F;return F=U(M=>{if(!N)return F?F.dispose():N=!0,B.call(x,M)},null,L),N&&F.dispose(),F}}w.once=E;function d(U,B){return r((x,L=null,N)=>U(F=>x.call(L,B(F)),null,N))}w.map=d;function l(U,B){return r((x,L=null,N)=>U(F=>{B(F),x.call(L,F)},null,N))}w.forEach=l;function c(U,B){return r((x,L=null,N)=>U(F=>B(F)&&x.call(L,F),null,N))}w.filter=c;function t(U){return U}w.signal=t;function n(...U){return(B,x=null,L)=>(0,C.combinedDisposable)(...U.map(N=>N(F=>B.call(x,F),null,L)))}w.any=n;function s(U,B,x){let L=x;return d(U,N=>(L=B(L,N),L))}w.reduce=s;function r(U){let B;const x=new m({onFirstListenerAdd(){B=U(x.fire,x)},onLastListenerRemove(){B.dispose()}});return x.event}w.snapshot=r;function o(U,B,x=100,L=!1,N){let F,M,$,q=0;const G=new m({leakWarningThreshold:N,onFirstListenerAdd(){F=U(le=>{q++,M=B(M,le),L&&!$&&(G.fire(M),M=void 0),clearTimeout($),$=setTimeout(()=>{const ve=M;M=void 0,$=void 0,(!L||q>1)&&G.fire(ve),q=0},x)})},onLastListenerRemove(){F.dispose()}});return G.event}w.debounce=o;function p(U){const B=new Date().getTime();return d(E(U),x=>new Date().getTime()-B)}w.stopwatch=p;function f(U,B=(x,L)=>x===L){let x=!0,L;return c(U,N=>{const F=x||!B(N,L);return x=!1,L=N,F})}w.latch=f;function _(U,B){return[w.filter(U,B),w.filter(U,x=>!B(x))]}w.split=_;function u(U,B=!1,x=[]){let L=x.slice(),N=U($=>{L?L.push($):M.fire($)});const F=()=>{L&&L.forEach($=>M.fire($)),L=null},M=new m({onFirstListenerAdd(){N||(N=U($=>M.fire($)))},onFirstListenerDidAdd(){L&&(B?setTimeout(F):F())},onLastListenerRemove(){N&&N.dispose(),N=null}});return M.event}w.buffer=u;class v{constructor(B){this.event=B}map(B){return new v(d(this.event,B))}forEach(B){return new v(l(this.event,B))}filter(B){return new v(c(this.event,B))}reduce(B,x){return new v(s(this.event,B,x))}latch(){return new v(f(this.event))}debounce(B,x=100,L=!1,N){return new v(o(this.event,B,x,L,N))}on(B,x,L){return this.event(B,x,L)}once(B,x,L){return E(this.event)(B,x,L)}}function R(U){return new v(U)}w.chain=R;function O(U,B,x=L=>L){const L=(...$)=>M.fire(x(...$)),N=()=>U.on(B,L),F=()=>U.removeListener(B,L),M=new m({onFirstListenerAdd:N,onLastListenerRemove:F});return M.event}w.fromNodeEventEmitter=O;function H(U,B,x=L=>L){const L=(...$)=>M.fire(x(...$)),N=()=>U.addEventListener(B,L),F=()=>U.removeEventListener(B,L),M=new m({onFirstListenerAdd:N,onLastListenerRemove:F});return M.event}w.fromDOMEventEmitter=H;function ne(U){const B=new m;let x=!1;return U.then(void 0,()=>null).then(()=>{x?B.fire(void 0):setTimeout(()=>B.fire(void 0),0)}),x=!0,B.event}w.fromPromise=ne;function ie(U){return new Promise(B=>E(U)(B))}w.toPromise=ie})(k=e.Event||(e.Event={}));class D{constructor(E){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${E}_${D._idPool++}`}start(E){this._stopWatch=new y.StopWatch(!0),this._listenerCount=E}stop(){if(this._stopWatch){const E=this._stopWatch.elapsed();this._elapsedOverall+=E,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${E.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let P=-1;function i(w){const E=P;return P=w,{dispose(){P=E}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(E,d=Math.random().toString(18).slice(2,5)){this.customThreshold=E,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(E){let d=P;if(typeof this.customThreshold=="number"&&(d=this.customThreshold),!(d<=0||E<d)){this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),c=this._stacks.get(l)||0;if(this._stacks.set(l,c+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=d*.5;let t,n=0;for(const[s,r]of this._stacks)(!t||n<r)&&(t=s,n=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(l)||0;this._stacks.set(l,t-1)}}}}class m{constructor(E){var d;this._disposed=!1,this._options=E,this._leakageMon=P>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((d=this._options)===null||d===void 0?void 0:d._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(E,d,l)=>{var c;this._listeners||(this._listeners=new A.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(d?[E,d]:E);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,E,d);const s=(c=this._leakageMon)===null||c===void 0?void 0:c.check(this._listeners.size);let r;return r={dispose:()=>{s&&s(),r.dispose=m._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof C.DisposableStore?l.add(r):Array.isArray(l)&&l.push(r),r}),this._event}fire(E){var d,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let c of this._listeners)this._deliveryQueue.push([c,E]);for((d=this._perfMon)===null||d===void 0||d.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[c,t]=this._deliveryQueue.shift();try{typeof c=="function"?c.call(void 0,t):c[0].call(c[1],t)}catch(n){(0,b.onUnexpectedError)(n)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var E,d,l,c;(E=this._listeners)===null||E===void 0||E.clear(),(d=this._deliveryQueue)===null||d===void 0||d.clear(),((l=this._options)===null||l===void 0?void 0:l.onLastListenerRemove)&&this._options.onLastListenerRemove(),(c=this._leakageMon)===null||c===void 0||c.dispose(),this._disposed=!0}}e.Emitter=m,m._noop=function(){};class g extends m{constructor(E){super(E);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=E==null?void 0:E.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const E=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(E))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(E){this._listeners&&(this._isPaused!==0?this._eventQueue.push(E):super.fire(E))}}e.PauseableEmitter=g;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(E){const d={event:E,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const l=()=>{this.hasListeners&&this.unhook(d);const c=this.events.indexOf(d);this.events.splice(c,1)};return(0,C.toDisposable)((0,T.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(E=>this.hook(E))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(E=>this.unhook(E))}hook(E){E.listener=E.event(d=>this.emitter.fire(d))}unhook(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=a;class h{constructor(){this.buffers=[]}wrapEvent(E){return(d,l,c)=>E(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>d.call(l,t)):d.call(l,t)},void 0,c)}bufferEvents(E){const d=[];this.buffers.push(d);const l=E();return this.buffers.pop(),d.forEach(c=>c()),l}}e.EventBufferer=h;class S{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=C.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(E){this.inputEvent=E,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=E(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=S}),define(me[21],ge([0,1,3]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const T=Object.freeze(function(k,D){const P=setTimeout(k.bind(D),0);return{dispose(){clearTimeout(P)}}});var C;(function(k){function D(P){return P===k.None||P===k.Cancelled||P instanceof A?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}k.isCancellationToken=D,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:b.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(C=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new b.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=C.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=y}),define(me[43],ge([0,1,3]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class T{constructor(){this._icons=new Map,this._onDidRegister=new b.Emitter}add(I){const m=this._icons.get(I.id);m?I.description?m.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const C=new T;e.iconRegistry=C;function A(i,I){return new k(i,I)}e.registerCodicon=A;function y(i){return i?i.replace(/\$\((.*?)\)/g,(I,m)=>` ${m} `).trim():""}e.getCodiconAriaLabel=y;class k{constructor(I,m,g){this.id=I,this.definition=m,this.description=g,C.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=k;function D(i,I){const m=["codicon","codicon-"+i];return I&&m.push("codicon-modifier-"+I),m}e.getClassNamesArray=D;var P;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function m(h){if(h instanceof k)return["codicon","codicon-"+h.id];const S=I.exec(h.id);if(!S)return m(k.error);let[,w,E]=S;const d=["codicon","codicon-"+w];return E&&d.push("codicon-modifier-"+E.substr(1)),d}i.asClassNameArray=m;function g(h){return m(h).join(" ")}i.asClassName=g;function a(h){return"."+m(h).join(".")}i.asCSSSelector=a})(P=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(k=e.Codicon||(e.Codicon={}))}),define(me[97],ge([0,1,17,6]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function C(d){const l=d;return l?[l.on,l.pause,l.resume,l.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=C;function A(d){const l=d;return l?C(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=A;function y(d,l){return new k(d,l)}e.newWriteableStream=y;class k{constructor(l,c){this.reducer=l,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){var c;if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof((c=this.options)===null||c===void 0?void 0:c.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(c=>c(l))}emitError(l){this.listeners.error.length===0?(0,b.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(c=>c(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,c){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(l,c){if(!this.state.destroyed){let t;switch(l){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(c);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(d,l){const c=[];let t;for(;(t=d.read())!==null;)c.push(t);return l(c)}e.consumeReadable=D;function P(d,l,c){const t=[];let n;for(;(n=d.read())!==null&&t.length<c;)t.push(n);return n===null&&t.length>0?l(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const s=n;return n=void 0,s}return d.read()}}}e.peekReadable=P;function i(d,l){return new Promise((c,t)=>{const n=[];I(d,{onData:s=>{l&&n.push(s)},onError:s=>{l?t(s):c(void 0)},onEnd:()=>{c(l?l(n):void 0)}})})}e.consumeStream=i;function I(d,l){d.on("error",c=>l.onError(c)),d.on("end",()=>l.onEnd()),d.on("data",c=>l.onData(c))}e.listenStream=I;function m(d,l){return new Promise((c,t)=>{const n=new T.DisposableStore,s=[],r=f=>{if(s.push(f),s.length>l)return n.dispose(),d.pause(),c({stream:d,buffer:s,ended:!1})},o=f=>t(f),p=()=>c({stream:d,buffer:s,ended:!0});n.add((0,T.toDisposable)(()=>d.removeListener("error",o))),d.on("error",o),n.add((0,T.toDisposable)(()=>d.removeListener("end",p))),d.on("end",p),n.add((0,T.toDisposable)(()=>d.removeListener("data",r))),d.on("data",r)})}e.peekStream=m;function g(d,l){const c=y(l);return c.end(d),c}e.toStream=g;function a(){const d=y(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=a;function h(d){let l=!1;return{read:()=>l?null:(l=!0,d)}}e.toReadable=h;function S(d,l,c){const t=y(c);return I(d,{onData:n=>t.write(l.data(n)),onError:n=>t.error(l.error?l.error(n):n),onEnd:()=>t.end()}),t}e.transform=S;function w(d,l,c){let t=!1;return{read:()=>{const n=l.read();return t?n:(t=!0,n!==null?c([d,n]):d)}}}e.prefixedReadable=w;function E(d,l,c){let t=!1;const n=y(c);return I(l,{onData:s=>t?n.write(s):(t=!0,n.write(c([d,s]))),onError:s=>n.error(s),onEnd:()=>{t||(t=!0,n.write(d)),n.end()}}),n}e.prefixedStream=E}),define(me[9],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function b(z){return!z||typeof z!="string"?!0:z.trim().length===0}e.isFalsyOrWhitespace=b;const T=/{(\d+)}/g;function C(z,...J){return J.length===0?z:z.replace(T,function(ce,Ie){const Ae=parseInt(Ie,10);return isNaN(Ae)||Ae<0||Ae>=J.length?ce:J[Ae]})}e.format=C;function A(z){return z.replace(/[<>&]/g,function(J){switch(J){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return J}})}e.escape=A;function y(z){return z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function k(z,J){let ce=0;const Ie=J.charCodeAt(0);for(let Ae=z.length-1;Ae>=0;Ae--)z.charCodeAt(Ae)===Ie&&ce++;return ce}e.count=k;function D(z,J,ce="\u2026"){return z.length<=J?z:`${z.substr(0,J)}${ce}`}e.truncate=D;function P(z,J=" "){const ce=i(z,J);return I(ce,J)}e.trim=P;function i(z,J){if(!z||!J)return z;const ce=J.length;if(ce===0||z.length===0)return z;let Ie=0;for(;z.indexOf(J,Ie)===Ie;)Ie=Ie+ce;return z.substring(Ie)}e.ltrim=i;function I(z,J){if(!z||!J)return z;const ce=J.length,Ie=z.length;if(ce===0||Ie===0)return z;let Ae=Ie,Le=-1;for(;Le=z.lastIndexOf(J,Ae-1),!(Le===-1||Le+ce!==Ae);){if(Le===0)return"";Ae=Le}return z.substring(0,Ae)}e.rtrim=I;function m(z){return z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function g(z){return z.replace(/\*/g,"")}e.stripWildcards=g;function a(z,J,ce={}){if(!z)throw new Error("Cannot create regex from empty string");J||(z=y(z)),ce.wholeWord&&(/\B/.test(z.charAt(0))||(z="\\b"+z),/\B/.test(z.charAt(z.length-1))||(z=z+"\\b"));let Ie="";return ce.global&&(Ie+="g"),ce.matchCase||(Ie+="i"),ce.multiline&&(Ie+="m"),ce.unicode&&(Ie+="u"),new RegExp(z,Ie)}e.createRegExp=a;function h(z){return z.source==="^"||z.source==="^$"||z.source==="$"||z.source==="^\\s*$"?!1:!!(z.exec("")&&z.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function S(z){return!!z.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=S;function w(z){return(z.global?"g":"")+(z.ignoreCase?"i":"")+(z.multiline?"m":"")+(z.unicode?"u":"")}e.regExpFlags=w;function E(z){return z.split(/\r\n|\r|\n/)}e.splitLines=E;function d(z){for(let J=0,ce=z.length;J<ce;J++){const Ie=z.charCodeAt(J);if(Ie!==32&&Ie!==9)return J}return-1}e.firstNonWhitespaceIndex=d;function l(z,J=0,ce=z.length){for(let Ie=J;Ie<ce;Ie++){const Ae=z.charCodeAt(Ie);if(Ae!==32&&Ae!==9)return z.substring(J,Ie)}return z.substring(J,ce)}e.getLeadingWhitespace=l;function c(z,J=z.length-1){for(let ce=J;ce>=0;ce--){const Ie=z.charCodeAt(ce);if(Ie!==32&&Ie!==9)return ce}return-1}e.lastNonWhitespaceIndex=c;function t(z,J){return z<J?-1:z>J?1:0}e.compare=t;function n(z,J,ce=0,Ie=z.length,Ae=0,Le=J.length){for(;ce<Ie&&Ae<Le;ce++,Ae++){let rt=z.charCodeAt(ce),tt=J.charCodeAt(Ae);if(rt<tt)return-1;if(rt>tt)return 1}const $e=Ie-ce,Xe=Le-Ae;return $e<Xe?-1:$e>Xe?1:0}e.compareSubstring=n;function s(z,J){return r(z,J,0,z.length,0,J.length)}e.compareIgnoreCase=s;function r(z,J,ce=0,Ie=z.length,Ae=0,Le=J.length){for(;ce<Ie&&Ae<Le;ce++,Ae++){let rt=z.charCodeAt(ce),tt=J.charCodeAt(Ae);if(rt!==tt){const Qe=rt-tt;if(!(Qe===32&&p(tt))&&!(Qe===-32&&p(rt)))return o(rt)&&o(tt)?Qe:n(z.toLowerCase(),J.toLowerCase(),ce,Ie,Ae,Le)}}const $e=Ie-ce,Xe=Le-Ae;return $e<Xe?-1:$e>Xe?1:0}e.compareSubstringIgnoreCase=r;function o(z){return z>=97&&z<=122}e.isLowerAsciiLetter=o;function p(z){return z>=65&&z<=90}e.isUpperAsciiLetter=p;function f(z){return o(z)||p(z)}function _(z,J){return z.length===J.length&&u(z,J)}e.equalsIgnoreCase=_;function u(z,J,ce=z.length){for(let Ie=0;Ie<ce;Ie++){const Ae=z.charCodeAt(Ie),Le=J.charCodeAt(Ie);if(Ae!==Le){if(f(Ae)&&f(Le)){const $e=Math.abs(Ae-Le);if($e!==0&&$e!==32)return!1}else if(String.fromCharCode(Ae).toLowerCase()!==String.fromCharCode(Le).toLowerCase())return!1}}return!0}function v(z,J){const ce=J.length;return J.length>z.length?!1:u(z,J,ce)}e.startsWithIgnoreCase=v;function R(z,J){let ce,Ie=Math.min(z.length,J.length);for(ce=0;ce<Ie;ce++)if(z.charCodeAt(ce)!==J.charCodeAt(ce))return ce;return Ie}e.commonPrefixLength=R;function O(z,J){let ce,Ie=Math.min(z.length,J.length);const Ae=z.length-1,Le=J.length-1;for(ce=0;ce<Ie;ce++)if(z.charCodeAt(Ae-ce)!==J.charCodeAt(Le-ce))return ce;return Ie}e.commonSuffixLength=O;function H(z){return 55296<=z&&z<=56319}e.isHighSurrogate=H;function ne(z){return 56320<=z&&z<=57343}e.isLowSurrogate=ne;function ie(z,J){return(z-55296<<10)+(J-56320)+65536}e.computeCodePoint=ie;function U(z,J,ce){const Ie=z.charCodeAt(ce);if(H(Ie)&&ce+1<J){const Ae=z.charCodeAt(ce+1);if(ne(Ae))return ie(Ie,Ae)}return Ie}e.getNextCodePoint=U;function B(z,J){const ce=z.charCodeAt(J-1);if(ne(ce)&&J>1){const Ie=z.charCodeAt(J-2);if(H(Ie))return ie(Ie,ce)}return ce}function x(z,J){const ce=Ve.getInstance(),Ie=J,Ae=z.length,Le=U(z,Ae,J);J+=Le>=65536?2:1;let $e=ce.getGraphemeBreakType(Le);for(;J<Ae;){const Xe=U(z,Ae,J),rt=ce.getGraphemeBreakType(Xe);if(xe($e,rt))break;J+=Xe>=65536?2:1,$e=rt}return J-Ie}e.nextCharLength=x;function L(z,J){const ce=Ve.getInstance(),Ie=J,Ae=B(z,J);J-=Ae>=65536?2:1;let Le=ce.getGraphemeBreakType(Ae);for(;J>0;){const $e=B(z,J),Xe=ce.getGraphemeBreakType($e);if(xe(Xe,Le))break;J-=$e>=65536?2:1,Le=Xe}return Ie-J}e.prevCharLength=L;function N(z,J){const ce=Ve.getInstance(),Ie=z.length,Ae=J,Le=U(z,Ie,J),$e=ce.getGraphemeBreakType(Le);J+=Le>=65536?2:1;let Xe=$e;for(;J<Ie;){const tt=U(z,Ie,J),Qe=ce.getGraphemeBreakType(tt);if(xe(Xe,Qe))break;J+=tt>=65536?2:1,Xe=Qe}const rt=J;for(J=Ae,Xe=$e;J>0;){const tt=B(z,J),Qe=ce.getGraphemeBreakType(tt);if(xe(Qe,Xe))break;J-=tt>=65536?2:1,Xe=Qe}return[J,rt]}function F(z,J){return J>0&&ne(z.charCodeAt(J))?N(z,J-1):N(z,J)}e.getCharContainingOffset=F;function M(z){const J=z.length;let ce=0,Ie=0;for(;Ie<J;){const $e=U(z,J,Ie);Ie+=$e>=65536?2:1,$e<128?ce+=1:$e<2048?ce+=2:$e<65536?ce+=3:ce+=4}const Ae=new Uint8Array(ce);Ie=0;let Le=0;for(;Ie<J;){const $e=U(z,J,Ie);Ie+=$e>=65536?2:1,$e<128?Ae[Le++]=$e:$e<2048?(Ae[Le++]=192|($e&1984)>>>6,Ae[Le++]=128|($e&63)>>>0):$e<65536?(Ae[Le++]=224|($e&61440)>>>12,Ae[Le++]=128|($e&4032)>>>6,Ae[Le++]=128|($e&63)>>>0):(Ae[Le++]=240|($e&1835008)>>>18,Ae[Le++]=128|($e&258048)>>>12,Ae[Le++]=128|($e&4032)>>>6,Ae[Le++]=128|($e&63)>>>0)}return Ae}e.encodeUTF8=M;function $(z){const J=z.byteLength,ce=[];let Ie=0;for(;Ie<J;){const Ae=z[Ie];let Le;if(Ae>=240&&Ie+3<J?Le=(z[Ie++]&7)<<18>>>0|(z[Ie++]&63)<<12>>>0|(z[Ie++]&63)<<6>>>0|(z[Ie++]&63)<<0>>>0:Ae>=224&&Ie+2<J?Le=(z[Ie++]&15)<<12>>>0|(z[Ie++]&63)<<6>>>0|(z[Ie++]&63)<<0>>>0:Ae>=192&&Ie+1<J?Le=(z[Ie++]&31)<<6>>>0|(z[Ie++]&63)<<0>>>0:Le=z[Ie++],Le>=0&&Le<=55295||Le>=57344&&Le<=65535)ce.push(String.fromCharCode(Le));else if(Le>=65536&&Le<=1114111){const $e=Le-65536,Xe=55296+(($e&1047552)>>>10),rt=56320+(($e&1023)>>>0);ce.push(String.fromCharCode(Xe)),ce.push(String.fromCharCode(rt))}else ce.push(String.fromCharCode(65533))}return ce.join("")}e.decodeUTF8=$;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function G(z){return q.test(z)}e.containsRTL=G;const le=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ve(z){return le.test(z)}e.containsEmoji=ve;const Re=/^[\t\n\r\x20-\x7E]*$/;function Se(z){return Re.test(z)}e.isBasicASCII=Se,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Oe(z){return e.UNUSUAL_LINE_TERMINATORS.test(z)}e.containsUnusualLineTerminators=Oe;function V(z){for(let J=0,ce=z.length;J<ce;J++)if(X(z.charCodeAt(J)))return!0;return!1}e.containsFullWidthCharacter=V;function X(z){return z=+z,z>=11904&&z<=55215||z>=63744&&z<=64255||z>=65281&&z<=65374}e.isFullWidthCharacter=X;function Z(z){return z>=127462&&z<=127487||z===8986||z===8987||z===9200||z===9203||z>=9728&&z<=10175||z===11088||z===11093||z>=127744&&z<=128591||z>=128640&&z<=128764||z>=128992&&z<=129003||z>=129280&&z<=129535||z>=129648&&z<=129750}e.isEmojiImprecise=Z;function se(z,J){if(z.length<J)return z;const ce=/\b/g;let Ie=0;for(;ce.test(z)&&!(z.length-ce.lastIndex<J);)Ie=ce.lastIndex,ce.lastIndex+=1;return z.substring(Ie).replace(/^\s/,"")}e.lcut=se;const fe=/\x1B\x5B[12]?K/g,Ee=/\x1b\[\d+m/g,Be=/\x1b\[0?m/g;function pe(z){return z&&(z=z.replace(fe,""),z=z.replace(Ee,""),z=z.replace(Be,"")),z}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(z){return!!(z&&z.length>0&&z.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Me(z){return Ce(z)?z.substr(1):z}e.stripUTF8BOM=Me;function ze(z,J){if(!z||!J||z.length<J.length)return!1;const ce=J.length,Ie=z.toLowerCase();let Ae=0,Le=-1;for(;Ae<ce;){const $e=Ie.indexOf(J[Ae],Le+1);if($e<0)return!1;Le=$e,Ae++}return!0}e.fuzzyContains=ze;function _e(z,J=!1){return z?(J&&(z=z.replace(/\\./g,"")),z.toLowerCase()!==z):!1}e.containsUppercaseCharacter=_e;function Ke(z){return z.charAt(0).toUpperCase()+z.slice(1)}e.uppercaseFirstLetter=Ke;function Q(z,J=1){if(J===0)return"";let ce=-1;do ce=z.indexOf(`
`,ce+1),J--;while(J>0&&ce>=0);return ce===-1?z:(z[ce-1]==="\r"&&ce--,z.substr(0,ce))}e.getNLines=Q;function te(z){const J=90-65+1;return z=z%(2*J),z<J?String.fromCharCode(97+z):String.fromCharCode(65+z-J)}e.singleLetterHash=te;function we(z){return Ve.getInstance().getGraphemeBreakType(z)}e.getGraphemeBreakType=we;function xe(z,J){return z===0?J!==5&&J!==7:z===2&&J===3?!1:z===4||z===2||z===3||J===4||J===2||J===3?!0:!(z===8&&(J===8||J===9||J===11||J===12)||(z===11||z===9)&&(J===9||J===10)||(z===12||z===10)&&J===10||J===5||J===13||J===7||z===1||z===13&&J===14||z===6&&J===6)}e.breakBetweenGraphemeBreakType=xe;var je;(function(z){z[z.Other=0]="Other",z[z.Prepend=1]="Prepend",z[z.CR=2]="CR",z[z.LF=3]="LF",z[z.Control=4]="Control",z[z.Extend=5]="Extend",z[z.Regional_Indicator=6]="Regional_Indicator",z[z.SpacingMark=7]="SpacingMark",z[z.L=8]="L",z[z.V=9]="V",z[z.T=10]="T",z[z.LV=11]="LV",z[z.LVT=12]="LVT",z[z.ZWJ=13]="ZWJ",z[z.Extended_Pictographic=14]="Extended_Pictographic"})(je=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ve{constructor(){this._data=Je()}static getInstance(){return Ve._INSTANCE||(Ve._INSTANCE=new Ve),Ve._INSTANCE}getGraphemeBreakType(J){if(J<32)return J===10?3:J===13?2:4;if(J<127)return 0;const ce=this._data,Ie=ce.length/3;let Ae=1;for(;Ae<=Ie;)if(J<ce[3*Ae])Ae=2*Ae;else if(J>ce[3*Ae+1])Ae=2*Ae+1;else return ce[3*Ae+2];return 0}}Ve._INSTANCE=null;function Je(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function De(z,J){if(z===0)return 0;const ce=ye(z,J);if(ce!==void 0)return ce;const Ie=B(J,z);return z-=Pe(Ie),z}e.getLeftDeleteOffset=De;function ye(z,J){let ce=B(J,z);for(z-=Pe(ce);oe(ce)||ce===65039||ce===8419;){if(z===0)return;ce=B(J,z),z-=Pe(ce)}if(!!Z(ce)){if(z>=0){const Ie=B(J,z);Ie===8205&&(z-=Pe(Ie))}return z}}function Pe(z){return z>=65536?2:1}function oe(z){return 127995<=z&&z<=127999}var ue;(function(z){z[z.zwj=8205]="zwj",z[z.emojiVariantSelector=65039]="emojiVariantSelector",z[z.enclosingKeyCap=8419]="enclosingKeyCap"})(ue||(ue={}))}),define(me[23],ge([0,1,9,97]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer!="undefined",A=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let k,D;class P{constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}static alloc(f){return C?new P(Buffer.allocUnsafe(f)):new P(new Uint8Array(f))}static wrap(f){return C&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new P(f)}static fromString(f,_){return!((_==null?void 0:_.dontUseNodeBuffer)||!1)&&C?new P(Buffer.from(f)):A?(k||(k=new TextEncoder),new P(k.encode(f))):new P(b.encodeUTF8(f))}static concat(f,_){if(typeof _=="undefined"){_=0;for(let R=0,O=f.length;R<O;R++)_+=f[R].byteLength}const u=P.alloc(_);let v=0;for(let R=0,O=f.length;R<O;R++){const H=f[R];u.set(H,v),v+=H.byteLength}return u}toString(){return C?this.buffer.toString():y?(D||(D=new TextDecoder),D.decode(this.buffer)):b.decodeUTF8(this.buffer)}slice(f,_){return new P(this.buffer.subarray(f,_))}set(f,_){f instanceof P?this.buffer.set(f.buffer,_):this.buffer.set(f,_)}readUInt32BE(f){return m(this.buffer,f)}writeUInt32BE(f,_){g(this.buffer,f,_)}readUInt32LE(f){return a(this.buffer,f)}writeUInt32LE(f,_){h(this.buffer,f,_)}readUInt8(f){return S(this.buffer,f)}writeUInt8(f,_){w(this.buffer,f,_)}}e.VSBuffer=P;function i(p,f){return p[f+0]<<0>>>0|p[f+1]<<8>>>0}e.readUInt16LE=i;function I(p,f,_){p[_+0]=f&255,f=f>>>8,p[_+1]=f&255}e.writeUInt16LE=I;function m(p,f){return p[f]*2**24+p[f+1]*2**16+p[f+2]*2**8+p[f+3]}e.readUInt32BE=m;function g(p,f,_){p[_+3]=f,f=f>>>8,p[_+2]=f,f=f>>>8,p[_+1]=f,f=f>>>8,p[_]=f}e.writeUInt32BE=g;function a(p,f){return p[f+0]<<0>>>0|p[f+1]<<8>>>0|p[f+2]<<16>>>0|p[f+3]<<24>>>0}e.readUInt32LE=a;function h(p,f,_){p[_+0]=f&255,f=f>>>8,p[_+1]=f&255,f=f>>>8,p[_+2]=f&255,f=f>>>8,p[_+3]=f&255}e.writeUInt32LE=h;function S(p,f){return p[f]}e.readUInt8=S;function w(p,f,_){p[_]=f}e.writeUInt8=w;function E(p){return T.consumeReadable(p,f=>P.concat(f))}e.readableToBuffer=E;function d(p){return T.toReadable(p)}e.bufferToReadable=d;function l(p){return T.consumeStream(p,f=>P.concat(f))}e.streamToBuffer=l;async function c(p){return p.ended?P.concat(p.buffer):P.concat([...p.buffer,await l(p.stream)])}e.bufferedStreamToBuffer=c;function t(p){return T.toStream(p,f=>P.concat(f))}e.bufferToStream=t;function n(p){return T.transform(p,{data:f=>typeof f=="string"?P.fromString(f):P.wrap(f)},f=>P.concat(f))}e.streamToBufferReadableStream=n;function s(p){return T.newWriteableStream(f=>P.concat(f),p)}e.newWriteableBufferStream=s;function r(p,f){return T.prefixedReadable(p,f,_=>P.concat(_))}e.prefixedBufferReadable=r;function o(p,f){return T.prefixedStream(p,f,_=>P.concat(_))}e.prefixedBufferStream=o}),define(me[75],ge([0,1,9]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function T(w){return C(w,0)}e.hash=T;function C(w,E){switch(typeof w){case"object":return w===null?A(349,E):Array.isArray(w)?D(w,E):P(w,E);case"string":return k(w,E);case"boolean":return y(w,E);case"number":return A(w,E);case"undefined":return A(937,E);default:return A(617,E)}}e.doHash=C;function A(w,E){return(E<<5)-E+w|0}function y(w,E){return A(w?433:863,E)}function k(w,E){E=A(149417,E);for(let d=0,l=w.length;d<l;d++)E=A(w.charCodeAt(d),E);return E}e.stringHash=k;function D(w,E){return E=A(104579,E),w.reduce((d,l)=>C(l,d),E)}function P(w,E){return E=A(181387,E),Object.keys(w).sort().reduce((d,l)=>(d=k(l,d),C(w[l],d)),E)}class i{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=C(E,this._value),this._value}}e.Hasher=i;var I;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function m(w,E,d=32){const l=d-E,c=~((1<<l)-1);return(w<<E|(c&w)>>>l)>>>0}function g(w,E=0,d=w.byteLength,l=0){for(let c=0;c<d;c++)w[E+c]=l}function a(w,E,d="0"){for(;w.length<E;)w=d+w;return w}function h(w,E=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(d=>d.toString(16).padStart(2,"0")).join(""):a((w>>>0).toString(16),E/4)}e.toHexString=h;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const d=E.length;if(d!==0){const l=this._buff;let c=this._buffLen,t=this._leftoverHighSurrogate,n,s;for(t!==0?(n=t,s=-1,t=0):(n=E.charCodeAt(0),s=0);;){let r=n;if(b.isHighSurrogate(n))if(s+1<d){const o=E.charCodeAt(s+1);b.isLowSurrogate(o)?(s++,r=b.computeCodePoint(n,o)):r=65533}else{t=n;break}else b.isLowSurrogate(n)&&(r=65533);if(c=this._push(l,c,r),s++,s<d)n=E.charCodeAt(s);else break}this._buffLen=c,this._leftoverHighSurrogate=t}}_push(E,d,l){return l<128?E[d++]=l:l<2048?(E[d++]=192|(l&1984)>>>6,E[d++]=128|(l&63)>>>0):l<65536?(E[d++]=224|(l&61440)>>>12,E[d++]=128|(l&4032)>>>6,E[d++]=128|(l&63)>>>0):(E[d++]=240|(l&1835008)>>>18,E[d++]=128|(l&258048)>>>12,E[d++]=128|(l&4032)>>>6,E[d++]=128|(l&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=S._bigBlock32,d=this._buffDV;for(let f=0;f<64;f+=4)E.setUint32(f,d.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)E.setUint32(f,m(E.getUint32(f-12,!1)^E.getUint32(f-32,!1)^E.getUint32(f-56,!1)^E.getUint32(f-64,!1),1),!1);let l=this._h0,c=this._h1,t=this._h2,n=this._h3,s=this._h4,r,o,p;for(let f=0;f<80;f++)f<20?(r=c&t|~c&n,o=1518500249):f<40?(r=c^t^n,o=1859775393):f<60?(r=c&t|c&n|t&n,o=2400959708):(r=c^t^n,o=3395469782),p=m(l,5)+r+s+o+E.getUint32(f*4,!1)&4294967295,s=n,n=t,t=m(c,30),c=l,l=p;this._h0=this._h0+l&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[59],ge([0,1,9]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(T||(T={})),function(C){const A="error",y="warning",k="warn",D="info",P="ignore";function i(m){return m?b.equalsIgnoreCase(A,m)?C.Error:b.equalsIgnoreCase(y,m)||b.equalsIgnoreCase(k,m)?C.Warning:b.equalsIgnoreCase(D,m)?C.Info:C.Ignore:C.Ignore}C.fromValue=i;function I(m){switch(m){case C.Error:return A;case C.Warning:return y;case C.Info:return D;default:return P}}C.toString=I}(T||(T={})),e.default=T}),define(me[11],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function b(f){return Array.isArray(f)}e.isArray=b;function T(f){return typeof f=="string"}e.isString=T;function C(f){return Array.isArray(f)&&f.every(_=>T(_))}e.isStringArray=C;function A(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=A;function y(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=y;function k(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=k;function D(f){return f===!0||f===!1}e.isBoolean=D;function P(f){return typeof f=="undefined"}e.isUndefined=P;function i(f){return!I(f)}e.isDefined=i;function I(f){return P(f)||f===null}e.isUndefinedOrNull=I;function m(f,_){if(!f)throw new Error(_?`Unexpected type, expected '${_}'`:"Unexpected type")}e.assertType=m;function g(f){if(I(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=g;function a(...f){const _=[];for(let u=0;u<f.length;u++){const v=f[u];if(I(v))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);_.push(v)}return _}e.assertAllDefined=a;const h=Object.prototype.hasOwnProperty;function S(f){if(!A(f))return!1;for(let _ in f)if(h.call(f,_))return!1;return!0}e.isEmptyObject=S;function w(f){return typeof f=="function"}e.isFunction=w;function E(...f){return f.length>0&&f.every(w)}e.areFunctions=E;function d(f,_){const u=Math.min(f.length,_.length);for(let v=0;v<u;v++)l(f[v],_[v])}e.validateConstraints=d;function l(f,_){if(T(_)){if(typeof f!==_)throw new Error(`argument does not match constraint: typeof ${_}`)}else if(w(_)){try{if(f instanceof _)return}catch(u){}if(!I(f)&&f.constructor===_||_.length===1&&_.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function c(f){let _=[],u=Object.getPrototypeOf(f);for(;Object.prototype!==u;)_=_.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return _}e.getAllPropertyNames=c;function t(f){const _=[];for(const u of c(f))typeof f[u]=="function"&&_.push(u);return _}e.getAllMethodNames=t;function n(f,_){const u=R=>function(){const O=Array.prototype.slice.call(arguments,0);return _(R,O)};let v={};for(const R of f)v[R]=u(R);return v}e.createProxyObject=n;function s(f){return f===null?void 0:f}e.withNullAsUndefined=s;function r(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=r;function o(f){return class{constructor(){return new Proxy({},{get(_,u){if(_[u])return _[u];throw new Error(`Not Implemented: ${f}->${String(u)}`)}})}}}e.NotImplementedProxy=o;function p(f){throw new Error("Unreachable")}e.assertNever=p}),define(me[29],ge([0,1,10,9,8,11]),function(K,e,b,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function y(n){return n===47||n===92}e.isPathSeparator=y;function k(n){return n.replace(/[\\/]/g,C.posix.sep)}e.toSlashes=k;function D(n,s=C.posix.sep){if(!n)return"";const r=n.length,o=n.charCodeAt(0);if(y(o)){if(y(n.charCodeAt(1))&&!y(n.charCodeAt(2))){let f=3;const _=f;for(;f<r&&!y(n.charCodeAt(f));f++);if(_!==f&&!y(n.charCodeAt(f+1))){for(f+=1;f<r;f++)if(y(n.charCodeAt(f)))return n.slice(0,f+1).replace(/[\\/]/g,s)}}return s}else if(S(o)&&n.charCodeAt(1)===58)return y(n.charCodeAt(2))?n.slice(0,2)+s:n.slice(0,2);let p=n.indexOf("://");if(p!==-1){for(p+=3;p<r;p++)if(y(n.charCodeAt(p)))return n.slice(0,p+1)}return""}e.getRoot=D;function P(n){if(!b.isWindows||!n||n.length<5)return!1;let s=n.charCodeAt(0);if(s!==92||(s=n.charCodeAt(1),s!==92))return!1;let r=2;const o=r;for(;r<n.length&&(s=n.charCodeAt(r),s!==92);r++);return!(o===r||(s=n.charCodeAt(r+1),isNaN(s)||s===92))}e.isUNC=P;const i=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(n,s=b.isWindows){const r=s?i:I;return!(!n||n.length===0||/^\s+$/.test(n)||(r.lastIndex=0,r.test(n))||s&&m.test(n)||n==="."||n===".."||s&&n[n.length-1]==="."||s&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=g;function a(n,s,r){const o=n===s;return!r||o?o:!n||!s?!1:(0,T.equalsIgnoreCase)(n,s)}e.isEqual=a;function h(n,s,r,o=C.sep){if(n===s)return!0;if(!n||!s||s.length>n.length)return!1;if(r){if(!(0,T.startsWithIgnoreCase)(n,s))return!1;if(s.length===n.length)return!0;let f=s.length;return s.charAt(s.length-1)===o&&f--,n.charAt(f)===o}return s.charAt(s.length-1)!==o&&(s+=o),n.indexOf(s)===0}e.isEqualOrParent=h;function S(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=S;function w(n,s){return b.isWindows&&n.endsWith(":")&&(n+=C.sep),(0,C.isAbsolute)(n)||(n=(0,C.join)(s,n)),n=(0,C.normalize)(n),b.isWindows?(n=(0,T.rtrim)(n,C.sep),n.endsWith(":")&&(n+=C.sep)):(n=(0,T.rtrim)(n,C.sep),n||(n=C.sep)),n}e.sanitizeFilePath=w;function E(n){const s=(0,C.normalize)(n);return b.isWindows?n.length>3?!1:d(s)&&(n.length===2||s.charCodeAt(2)===92):s===C.posix.sep}e.isRootOrDriveLetter=E;function d(n){return b.isWindows?S(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function l(n){return d(n)?n[0]:void 0}e.getDriveLetter=l;function c(n,s,r){return s.length>n.length?-1:n===s?0:(r&&(n=n.toLowerCase(),s=s.toLowerCase()),n.indexOf(s))}e.indexOfPath=c;function t(n){const s=n.split(":");let r,o,p;if(s.forEach(f=>{const _=Number(f);(0,A.isNumber)(_)?o===void 0?o=_:p===void 0&&(p=_):r=r?[r,f].join(":"):f}),!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:o!==void 0?o:void 0,column:p!==void 0?p:o!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(me[24],ge([0,1,11]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const S=Array.isArray(h)?[]:{};return Object.keys(h).forEach(w=>{h[w]&&typeof h[w]=="object"?S[w]=T(h[w]):S[w]=h[w]}),S}e.deepClone=T;function C(h){if(!h||typeof h!="object")return h;const S=[h];for(;S.length>0;){const w=S.shift();Object.freeze(w);for(const E in w)if(A.call(w,E)){const d=w[E];typeof d=="object"&&!Object.isFrozen(d)&&S.push(d)}}return h}e.deepFreeze=C;const A=Object.prototype.hasOwnProperty;function y(h,S){return k(h,S,new Set)}e.cloneAndChange=y;function k(h,S,w){if((0,b.isUndefinedOrNull)(h))return h;const E=S(h);if(typeof E!="undefined")return E;if((0,b.isArray)(h)){const d=[];for(const l of h)d.push(k(l,S,w));return d}if((0,b.isObject)(h)){if(w.has(h))throw new Error("Cannot clone recursive data-structure");w.add(h);const d={};for(let l in h)A.call(h,l)&&(d[l]=k(h[l],S,w));return w.delete(h),d}return h}function D(h,S,w=!0){return(0,b.isObject)(h)?((0,b.isObject)(S)&&Object.keys(S).forEach(E=>{E in h?w&&((0,b.isObject)(h[E])&&(0,b.isObject)(S[E])?D(h[E],S[E],w):h[E]=S[E]):h[E]=S[E]}),h):S}e.mixin=D;function P(h,S){if(h===S)return!0;if(h==null||S===null||S===void 0||typeof h!=typeof S||typeof h!="object"||Array.isArray(h)!==Array.isArray(S))return!1;let w,E;if(Array.isArray(h)){if(h.length!==S.length)return!1;for(w=0;w<h.length;w++)if(!P(h[w],S[w]))return!1}else{const d=[];for(E in h)d.push(E);d.sort();const l=[];for(E in S)l.push(E);if(l.sort(),!P(d,l))return!1;for(w=0;w<d.length;w++)if(!P(h[d[w]],S[d[w]]))return!1}return!0}e.equals=P;function i(h){const S=new Set;return JSON.stringify(h,(w,E)=>{if((0,b.isObject)(E)||Array.isArray(E)){if(S.has(E))return"[Circular]";S.add(E)}return E})}e.safeStringify=i;function I(h,S,w){const E=S(h);return typeof E=="undefined"?w:E}e.getOrDefault=I;function m(h,S){const w=Object.create(null);return!h||!S||Object.keys(S).forEach(d=>{const l=h[d],c=S[d];P(l,c)||(w[d]=c)}),w}e.distinct=m;function g(h,S){const w=S.toLowerCase(),E=Object.keys(h).find(d=>d.toLowerCase()===w);return E?h[E]:h[S]}e.getCaseInsensitive=g;function a(h,S){const w=Object.create(null);for(const E of Object.keys(h))S(E,h[E])&&(w[E]=h[E]);return w}e.filter=a}),define(me[98],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var b;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(b=e.Constants||(e.Constants={}));function T(A){return A<0?0:A>255?255:A|0}e.toUint8=T;function C(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=C}),define(me[2],ge([0,1,10,8]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,A=/^\//,y=/^\/\//;function k(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!C.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!A.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(s,r){return!s&&!r?"file":s}function P(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==I&&(r=I+r):r=I;break}return r}const i="",I="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(r,o,p,f,_,u=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=D(r,u),this.authority=o||i,this.path=P(this.scheme,p||i),this.query=f||i,this.fragment=_||i,k(this,u))}static isUri(r){return r instanceof g?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return d(this,!1)}with(r){if(!r)return this;let{scheme:o,authority:p,path:f,query:_,fragment:u}=r;return o===void 0?o=this.scheme:o===null&&(o=i),p===void 0?p=this.authority:p===null&&(p=i),f===void 0?f=this.path:f===null&&(f=i),_===void 0?_=this.query:_===null&&(_=i),u===void 0?u=this.fragment:u===null&&(u=i),o===this.scheme&&p===this.authority&&f===this.path&&_===this.query&&u===this.fragment?this:new h(o,p,f,_,u)}static parse(r,o=!1){const p=m.exec(r);return p?new h(p[2]||i,n(p[4]||i),n(p[5]||i),n(p[7]||i),n(p[9]||i),o):new h(i,i,i,i,i)}static file(r){let o=i;if(b.isWindows&&(r=r.replace(/\\/g,I)),r[0]===I&&r[1]===I){const p=r.indexOf(I,2);p===-1?(o=r.substring(2),r=I):(o=r.substring(2,p),r=r.substring(p)||I)}return new h("file",o,r,i,i)}static from(r){return new h(r.scheme,r.authority,r.path,r.query,r.fragment)}static joinPath(r,...o){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return b.isWindows&&r.scheme==="file"?p=g.file(T.win32.join(d(r,!0),...o)).path:p=T.posix.join(r.path,...o),r.with({path:p})}toString(r=!1){return l(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof g)return r;{const o=new h(r);return o._formatted=r.external,o._fsPath=r._sep===a?r.fsPath:null,o}}else return r}}e.URI=g;const a=b.isWindows?1:void 0;class h extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(r=!1){return r?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=a),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(s,r){let o,p=-1;for(let f=0;f<s.length;f++){const _=s.charCodeAt(f);if(_>=97&&_<=122||_>=65&&_<=90||_>=48&&_<=57||_===45||_===46||_===95||_===126||r&&_===47)p!==-1&&(o+=encodeURIComponent(s.substring(p,f)),p=-1),o!==void 0&&(o+=s.charAt(f));else{o===void 0&&(o=s.substr(0,f));const u=S[_];u!==void 0?(p!==-1&&(o+=encodeURIComponent(s.substring(p,f)),p=-1),o+=u):p===-1&&(p=f)}}return p!==-1&&(o+=encodeURIComponent(s.substring(p))),o!==void 0?o:s}function E(s){let r;for(let o=0;o<s.length;o++){const p=s.charCodeAt(o);p===35||p===63?(r===void 0&&(r=s.substr(0,o)),r+=S[p]):r!==void 0&&(r+=s[o])}return r!==void 0?r:s}function d(s,r){let o;return s.authority&&s.path.length>1&&s.scheme==="file"?o=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?r?o=s.path.substr(1):o=s.path[1].toLowerCase()+s.path.substr(2):o=s.path,b.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=d;function l(s,r){const o=r?E:w;let p="",{scheme:f,authority:_,path:u,query:v,fragment:R}=s;if(f&&(p+=f,p+=":"),(_||f==="file")&&(p+=I,p+=I),_){let O=_.indexOf("@");if(O!==-1){const H=_.substr(0,O);_=_.substr(O+1),O=H.indexOf(":"),O===-1?p+=o(H,!1):(p+=o(H.substr(0,O),!1),p+=":",p+=o(H.substr(O+1),!1)),p+="@"}_=_.toLowerCase(),O=_.indexOf(":"),O===-1?p+=o(_,!1):(p+=o(_.substr(0,O),!1),p+=_.substr(O))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const O=u.charCodeAt(1);O>=65&&O<=90&&(u=`/${String.fromCharCode(O+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const O=u.charCodeAt(0);O>=65&&O<=90&&(u=`${String.fromCharCode(O+32)}:${u.substr(2)}`)}p+=o(u,!0)}return v&&(p+="?",p+=o(v,!1)),R&&(p+="#",p+=r?R:w(R,!1)),p}function c(s){try{return decodeURIComponent(s)}catch(r){return s.length>3?s.substr(0,3)+c(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(t)?s.replace(t,r=>c(r)):s}});var it=this&&this.__classPrivateFieldSet||function(K,e,b,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(K,b):C?C.value=b:e.set(K,b),b},We=this&&this.__classPrivateFieldGet||function(K,e,b,T){if(b==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?T:b==="a"?T.call(K):T?T.value:e.get(K)};define(me[22],ge([0,1,2,9]),function(K,e,b,T){"use strict";var C,A,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(t,n,s){let r=t.get(n);return r===void 0&&(r=s,t.set(n,r)),r}e.getOrSet=k;function D(t){const n=[];return t.forEach((s,r)=>{n.push(`${r} => ${s}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=D;function P(t){const n=[];return t.forEach(s=>{n.push(s)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=P;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),r=this._value.charCodeAt(this._pos);return s-r}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,T.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class m{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,T.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var g;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(g||(g={}));class a{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,T.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,T.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,T.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,T.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class h{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class S{constructor(n){this._iter=n}static forUris(n=()=>!1){return new S(new a(n))}static forPaths(){return new S(new m)}static forStrings(){return new S(new i)}static forConfigKeys(){return new S(new I)}clear(){this._root=void 0}set(n,s){const r=this._iter.reset(n);let o;for(this._root||(this._root=new h,this._root.segment=r.value()),o=this._root;;){const f=r.cmp(o.segment);if(f>0)o.left||(o.left=new h,o.left.segment=r.value()),o=o.left;else if(f<0)o.right||(o.right=new h,o.right.segment=r.value()),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new h,o.mid.segment=r.value()),o=o.mid;else break}const p=o.value;return o.value=s,o.key=n,p}get(n){var s;return(s=this._getNode(n))===null||s===void 0?void 0:s.value}_getNode(n){const s=this._iter.reset(n);let r=this._root;for(;r;){const o=s.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else break}return r}has(n){const s=this._getNode(n);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const r=this._iter.reset(n),o=[];let p=this._root;for(;p;){const f=r.cmp(p.segment);if(f>0)o.push([1,p]),p=p.left;else if(f<0)o.push([-1,p]),p=p.right;else if(r.hasNext())r.next(),o.push([0,p]),p=p.mid;else{for(s?(p.left=void 0,p.mid=void 0,p.right=void 0):p.value=void 0;o.length>0&&p.isEmpty();){let[_,u]=o.pop();switch(_){case 1:u.left=void 0;break;case 0:u.mid=void 0;break;case-1:u.right=void 0;break}p=u}break}}}findSubstr(n){const s=this._iter.reset(n);let r=this._root,o;for(;r;){const p=s.cmp(r.segment);if(p>0)r=r.left;else if(p<0)r=r.right;else if(s.hasNext())s.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(n){const s=this._iter.reset(n);let r=this._root;for(;r;){const o=s.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(n){for(const[s,r]of this)n(r,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=S;class w{constructor(n,s){this[C]="ResourceMap",n instanceof w?(this.map=new Map(n.map),this.toKey=s!=null?s:w.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:w.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),s),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(let[r,o]of this.map)n(o,b.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield b.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[b.URI.parse(n[0]),n[1]]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[b.URI.parse(n[0]),n[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var E;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class d{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,s=0){const r=this._map.get(n);if(!!r)return s!==0&&this.touch(r,s),r.value}set(n,s,r=0){let o=this._map.get(n);if(o)o.value=s,r!==0&&this.touch(o,r);else{switch(o={key:n,value:s,next:void 0,previous:void 0},r){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(n,o),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,s){const r=this._state;let o=this._head;for(;o;){if(s?n.bind(s)(o.value,o.key,this):n(o.value,o.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const n=this,s=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const p={value:r.key,done:!1};return r=r.next,p}else return{value:void 0,done:!0}}};return o}values(){const n=this,s=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const p={value:r.value,done:!1};return r=r.next,p}else return{value:void 0,done:!0}}};return o}entries(){const n=this,s=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const p={value:[r.key,r.value],done:!1};return r=r.next,p}else return{value:void 0,done:!0}}};return o}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let s=this._head,r=this.size;for(;s&&r>n;)this._map.delete(s.key),s=s.next,r--;this._head=s,this._size=r,s&&(s.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,r=n.previous;if(!s||!r)throw new Error("Invalid list");s.previous=r,r.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const r=n.next,o=n.previous;n===this._tail?(o.next=void 0,this._tail=o):(r.previous=o,o.next=r),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const r=n.next,o=n.previous;n===this._head?(r.previous=void 0,this._head=r):(r.previous=o,o.next=r),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,r)=>{n.push([r,s])}),n}fromJSON(n){this.clear();for(const[s,r]of n)this.set(s,r)}}e.LinkedMap=d;class l extends d{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class c{constructor(n){y.set(this,void 0),it(this,y,n,"f")}get size(){return We(this,y,"f").size}forEach(n,s){We(this,y,"f").forEach(n,s)}get(n){return We(this,y,"f").get(n)}has(n){return We(this,y,"f").has(n)}entries(){return We(this,y,"f").entries()}keys(){return We(this,y,"f").keys()}values(){return We(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return We(this,y,"f").entries()}}e.ReadonlyMapView=c}),define(me[99],ge([0,1,22,9]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...pe){return function(Ce,Me){for(let ze=0,_e=pe.length;ze<_e;ze++){const Ke=pe[ze](Ce,Me);if(Ke)return Ke}return null}}e.or=C,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(pe,Ce,Me){if(!Me||Me.length<Ce.length)return null;let ze;return pe?ze=T.startsWithIgnoreCase(Me,Ce):ze=Me.indexOf(Ce)===0,ze?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function y(pe,Ce){const Me=Ce.toLowerCase().indexOf(pe.toLowerCase());return Me===-1?null:[{start:Me,end:Me+pe.length}]}e.matchesContiguousSubString=y;function k(pe,Ce){return D(pe.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=k;function D(pe,Ce,Me,ze){if(Me===pe.length)return[];if(ze===Ce.length)return null;if(pe[Me]===Ce[ze]){let _e=null;return(_e=D(pe,Ce,Me+1,ze+1))?w({start:ze,end:ze+1},_e):null}return D(pe,Ce,Me,ze+1)}function P(pe){return 97<=pe&&pe<=122}function i(pe){return 65<=pe&&pe<=90}e.isUpper=i;function I(pe){return 48<=pe&&pe<=57}function m(pe){return pe===32||pe===9||pe===10||pe===13}const g=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(pe=>g.add(pe.charCodeAt(0)));function a(pe){return m(pe)||g.has(pe)}function h(pe,Ce){return pe===Ce||a(pe)&&a(Ce)}function S(pe){return P(pe)||i(pe)||I(pe)}function w(pe,Ce){return Ce.length===0?Ce=[pe]:pe.end===Ce[0].start?Ce[0].start=pe.start:Ce.unshift(pe),Ce}function E(pe,Ce){for(let Me=Ce;Me<pe.length;Me++){const ze=pe.charCodeAt(Me);if(i(ze)||I(ze)||Me>0&&!S(pe.charCodeAt(Me-1)))return Me}return pe.length}function d(pe,Ce,Me,ze){if(Me===pe.length)return[];if(ze===Ce.length)return null;if(pe[Me]!==Ce[ze].toLowerCase())return null;{let _e=null,Ke=ze+1;for(_e=d(pe,Ce,Me+1,ze+1);!_e&&(Ke=E(Ce,Ke))<Ce.length;)_e=d(pe,Ce,Me+1,Ke),Ke++;return _e===null?null:w({start:ze,end:ze+1},_e)}}function l(pe){let Ce=0,Me=0,ze=0,_e=0,Ke=0;for(let je=0;je<pe.length;je++)Ke=pe.charCodeAt(je),i(Ke)&&Ce++,P(Ke)&&Me++,S(Ke)&&ze++,I(Ke)&&_e++;const Q=Ce/pe.length,te=Me/pe.length,we=ze/pe.length,xe=_e/pe.length;return{upperPercent:Q,lowerPercent:te,alphaPercent:we,numericPercent:xe}}function c(pe){const{upperPercent:Ce,lowerPercent:Me}=pe;return Me===0&&Ce>.6}function t(pe){const{upperPercent:Ce,lowerPercent:Me,alphaPercent:ze,numericPercent:_e}=pe;return Me>.2&&Ce<.8&&ze>.6&&_e<.2}function n(pe){let Ce=0,Me=0,ze=0,_e=0;for(let Ke=0;Ke<pe.length;Ke++)ze=pe.charCodeAt(Ke),i(ze)&&Ce++,P(ze)&&Me++,m(ze)&&_e++;return(Ce===0||Me===0)&&_e===0?pe.length<=30:Ce<=5}function s(pe,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!n(pe)||Ce.length>60)return null;const Me=l(Ce);if(!t(Me)){if(!c(Me))return null;Ce=Ce.toLowerCase()}let ze=null,_e=0;for(pe=pe.toLowerCase();_e<Ce.length&&(ze=d(pe,Ce,0,_e))===null;)_e=E(Ce,_e+1);return ze}e.matchesCamelCase=s;function r(pe,Ce,Me=!1){if(!Ce||Ce.length===0)return null;let ze=null,_e=0;for(pe=pe.toLowerCase(),Ce=Ce.toLowerCase();_e<Ce.length&&(ze=o(pe,Ce,0,_e,Me))===null;)_e=p(Ce,_e+1);return ze}e.matchesWords=r;function o(pe,Ce,Me,ze,_e){if(Me===pe.length)return[];if(ze===Ce.length)return null;if(h(pe.charCodeAt(Me),Ce.charCodeAt(ze))){let Ke=null,Q=ze+1;if(Ke=o(pe,Ce,Me+1,ze+1,_e),!_e)for(;!Ke&&(Q=p(Ce,Q))<Ce.length;)Ke=o(pe,Ce,Me+1,Q,_e),Q++;return Ke===null?null:w({start:ze,end:ze+1},Ke)}else return null}function p(pe,Ce){for(let Me=Ce;Me<pe.length;Me++)if(a(pe.charCodeAt(Me))||Me>0&&a(pe.charCodeAt(Me-1)))return Me;return pe.length}const f=C(e.matchesPrefix,s,y),_=C(e.matchesPrefix,s,k),u=new b.LRUCache(1e4);function v(pe,Ce,Me=!1){if(typeof pe!="string"||typeof Ce!="string")return null;let ze=u.get(pe);ze||(ze=new RegExp(T.convertSimple2RegExpPattern(pe),"i"),u.set(pe,ze));const _e=ze.exec(Ce);return _e?[{start:_e.index,end:_e.index+_e[0].length}]:Me?_(pe,Ce):f(pe,Ce)}e.matchesFuzzy=v;function R(pe,Ce){const Me=V(pe,pe.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Me?H(Me):null}e.matchesFuzzy2=R;function O(pe,Ce,Me,ze,_e,Ke){const Q=Math.min(13,pe.length);for(;Me<Q;Me++){const te=V(pe,Ce,Me,ze,_e,Ke,!1);if(te)return te}return[0,Ke]}e.anyScore=O;function H(pe){if(typeof pe=="undefined")return[];const Ce=[],Me=pe[1];for(let ze=pe.length-1;ze>1;ze--){const _e=pe[ze]+Me,Ke=Ce[Ce.length-1];Ke&&Ke.end===_e?Ke.end=_e+1:Ce.push({start:_e,end:_e+1})}return Ce}e.createMatches=H;const ne=128;function ie(){const pe=[],Ce=[];for(let Me=0;Me<=ne;Me++)Ce[Me]=0;for(let Me=0;Me<=ne;Me++)pe.push(Ce.slice(0));return pe}function U(pe){const Ce=[];for(let Me=0;Me<=pe;Me++)Ce[Me]=0;return Ce}const B=U(2*ne),x=U(2*ne),L=ie(),N=ie(),F=ie(),M=!1;function $(pe,Ce,Me,ze,_e){function Ke(te,we,xe=" "){for(;te.length<we;)te=xe+te;return te}let Q=` |   |${ze.split("").map(te=>Ke(te,3)).join("|")}
`;for(let te=0;te<=Me;te++)te===0?Q+=" |":Q+=`${Ce[te-1]}|`,Q+=pe[te].slice(0,_e+1).map(we=>Ke(we.toString(),3)).join("|")+`
`;return Q}function q(pe,Ce,Me,ze){pe=pe.substr(Ce),Me=Me.substr(ze),console.log($(N,pe,pe.length,Me,Me.length)),console.log($(F,pe,pe.length,Me,Me.length)),console.log($(L,pe,pe.length,Me,Me.length))}function G(pe,Ce){if(Ce<0||Ce>=pe.length)return!1;const Me=pe.codePointAt(Ce);switch(Me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise(Me)}}function le(pe,Ce){if(Ce<0||Ce>=pe.length)return!1;switch(pe.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function ve(pe,Ce,Me){return Ce[pe]!==Me[pe]}function Re(pe,Ce,Me,ze,_e,Ke,Q=!1){for(;Ce<Me&&_e<Ke;)pe[Ce]===ze[_e]&&(Q&&(B[Ce]=_e),Ce+=1),_e+=1;return Ce===Me}e.isPatternInWord=Re;var Se;(function(pe){pe[pe.Diag=1]="Diag",pe[pe.Left=2]="Left",pe[pe.LeftLeft=3]="LeftLeft"})(Se||(Se={}));var Oe;(function(pe){pe.Default=[-100,0];function Ce(Me){return!Me||Me.length===2&&Me[0]===-100&&Me[1]===0}pe.isDefault=Ce})(Oe=e.FuzzyScore||(e.FuzzyScore={}));function V(pe,Ce,Me,ze,_e,Ke,Q){const te=pe.length>ne?ne:pe.length,we=ze.length>ne?ne:ze.length;if(!(Me>=te||Ke>=we||te-Me>we-Ke)&&!!Re(Ce,Me,te,_e,Ke,we,!0)){X(te,we,Me,Ke,Ce,_e);let xe=1,je=1,Ve=Me,Je=Ke;const De=[!1];for(xe=1,Ve=Me;Ve<te;xe++,Ve++){const z=B[Ve],J=x[Ve],ce=Ve+1<te?x[Ve+1]:we;for(je=z-Ke+1,Je=z;Je<ce;je++,Je++){let Ie=Number.MIN_SAFE_INTEGER,Ae=!1;Je<=J&&(Ie=Z(pe,Ce,Ve,Me,ze,_e,Je,we,Ke,L[xe-1][je-1]===0,De));let Le=0;Ie!==Number.MAX_SAFE_INTEGER&&(Ae=!0,Le=Ie+N[xe-1][je-1]);const $e=Je>z,Xe=$e?N[xe][je-1]+(L[xe][je-1]>0?-5:0):0,rt=Je>z+1&&L[xe][je-1]>0,tt=rt?N[xe][je-2]+(L[xe][je-2]>0?-5:0):0;if(rt&&(!$e||tt>=Xe)&&(!Ae||tt>=Le))N[xe][je]=tt,F[xe][je]=3,L[xe][je]=0;else if($e&&(!Ae||Xe>=Le))N[xe][je]=Xe,F[xe][je]=2,L[xe][je]=0;else if(Ae)N[xe][je]=Le,F[xe][je]=1,L[xe][je]=L[xe-1][je-1]+1;else throw new Error("not possible")}}if(M&&q(pe,Me,ze,Ke),!(!De[0]&&!Q)){xe--,je--;const ye=[N[xe][je],Ke];let Pe=0,oe=0;for(;xe>=1;){let z=je;do{const J=F[xe][z];if(J===3)z=z-2;else if(J===2)z=z-1;else break}while(z>=1);Pe>1&&Ce[Me+xe-1]===_e[Ke+je-1]&&!ve(z+Ke-1,ze,_e)&&Pe+1>L[xe][z]&&(z=je),z===je?Pe++:Pe=1,oe||(oe=z),xe--,je=z-1,ye.push(je)}we===te&&(ye[0]+=2);const ue=oe-te;return ye[0]-=ue,ye}}}e.fuzzyScore=V;function X(pe,Ce,Me,ze,_e,Ke){let Q=pe-1,te=Ce-1;for(;Q>=Me&&te>=ze;)_e[Q]===Ke[te]&&(x[Q]=te,Q--),te--}function Z(pe,Ce,Me,ze,_e,Ke,Q,te,we,xe,je){if(Ce[Me]!==Ke[Q])return Number.MIN_SAFE_INTEGER;let Ve=1,Je=!1;return Q===Me-ze?Ve=pe[Me]===_e[Q]?7:5:ve(Q,_e,Ke)&&(Q===0||!ve(Q-1,_e,Ke))?(Ve=pe[Me]===_e[Q]?7:5,Je=!0):G(Ke,Q)&&(Q===0||!G(Ke,Q-1))?Ve=5:(G(Ke,Q-1)||le(Ke,Q-1))&&(Ve=5,Je=!0),Ve>1&&Me===ze&&(je[0]=!0),Je||(Je=ve(Q,_e,Ke)||G(Ke,Q-1)||le(Ke,Q-1)),Me===ze?Q>we&&(Ve-=Je?3:5):xe?Ve+=Je?2:0:Ve+=Je?0:1,Q+1===te&&(Ve-=Je?3:5),Ve}function se(pe,Ce,Me,ze,_e,Ke,Q){return Ee(pe,Ce,Me,ze,_e,Ke,!0,Q)}e.fuzzyScoreGracefulAggressive=se;function fe(pe,Ce,Me,ze,_e,Ke,Q){return Ee(pe,Ce,Me,ze,_e,Ke,!1,Q)}e.fuzzyScoreGraceful=fe;function Ee(pe,Ce,Me,ze,_e,Ke,Q,te){let we=V(pe,Ce,Me,ze,_e,Ke,te);if(we&&!Q)return we;if(pe.length>=3){const xe=Math.min(7,pe.length-1);for(let je=Me+1;je<xe;je++){const Ve=Be(pe,je);if(Ve){const Je=V(Ve,Ve.toLowerCase(),Me,ze,_e,Ke,te);Je&&(Je[0]-=3,(!we||Je[0]>we[0])&&(we=Je))}}}return we}function Be(pe,Ce){if(!(Ce+1>=pe.length)){const Me=pe[Ce],ze=pe[Ce+1];if(Me!==ze)return pe.slice(0,Ce)+ze+Me+pe.slice(Ce+2)}}}),define(me[137],ge([0,1,43,99,9]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${b.CSSIcon.iconNameExpression}(?:${b.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${A.source}`,"g");function k(h){return h.replace(y,(S,w)=>w?S:`\\${S}`)}e.escapeIcons=k;const D=new RegExp(`\\\\${A.source}`,"g");function P(h){return h.replace(D,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=P;const i=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function I(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(i,(S,w,E,d)=>E?S:w||d||"")}e.stripIcons=I;function m(h){const S=h.indexOf(e.iconStartMarker);return S===-1?{text:h}:g(h,S)}e.parseLabelWithIcons=m;function g(h,S){const w=[];let E="";function d(p){if(p){E+=p;for(const f of p)w.push(t)}}let l=-1,c="",t=0,n,s,r=S;const o=h.length;for(d(h.substr(0,S));r<o;)n=h[r],s=h[r+1],n===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(l=r,d(c),c=e.iconStartMarker,r++):n===")"&&l!==-1?(t+=r-l+1,l=-1,c=""):l!==-1?/^[a-z0-9\-]$/i.test(n)?c+=n:(d(c),l=-1,c=""):d(n),r++;return d(c),{text:E,iconOffsets:w}}function a(h,S,w=!1){const{text:E,iconOffsets:d}=S;if(!d||d.length===0)return(0,T.matchesFuzzy)(h,E,w);const l=(0,C.ltrim)(E," "),c=E.length-l.length,t=(0,T.matchesFuzzy)(h,l,w);if(t)for(const n of t){const s=d[n.start+c]+c;n.start+=s,n.end+=s}return t}e.matchesFuzzyIconAware=a}),define(me[100],ge([0,1,16,137,17]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(h="",S=!1){var w,E;if(this.value=h,typeof this.value!="string")throw(0,C.illegalArgument)("value");typeof S=="boolean"?(this.isTrusted=S,this.supportThemeIcons=!1):(this.isTrusted=(w=S.isTrusted)!==null&&w!==void 0?w:void 0,this.supportThemeIcons=(E=S.supportThemeIcons)!==null&&E!==void 0?E:!1)}appendText(h,S=0){return this.value+=I(this.supportThemeIcons?(0,T.escapeIcons)(h):h).replace(/([ \t]+)/g,(w,E)=>"&nbsp;".repeat(E.length)).replace(/^>/gm,"\\>").replace(/\n/g,S===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,S){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=S,this.value+="\n```\n",this}}e.MarkdownString=y;function k(a){return D(a)?!a.value:Array.isArray(a)?a.every(k):!0}e.isEmptyMarkdownString=k;function D(a){return a instanceof y?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function P(a,h){return!a&&!h?!0:!a||!h?!1:Array.isArray(a)&&Array.isArray(h)?(0,b.equals)(a,h,i):D(a)&&D(h)?i(a,h):!1}e.markedStringsEquals=P;function i(a,h){return a===h?!0:!a||!h?!1:a.value===h.value&&a.isTrusted===h.isTrusted&&a.supportThemeIcons===h.supportThemeIcons}function I(a){return a.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function m(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=m;function g(a){const h=[],S=a.split("|").map(E=>E.trim());a=S[0];const w=S[1];if(w){const E=/height=(\d+)/.exec(w),d=/width=(\d+)/.exec(w),l=E?E[1]:"",c=d?d[1]:"",t=isFinite(parseInt(c)),n=isFinite(parseInt(l));t&&h.push(`width="${c}"`),n&&h.push(`height="${l}"`)}return{href:a,dimensions:h}}e.parseHrefAndDimensions=g}),define(me[60],ge([0,1,23,9,2]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(P){return JSON.stringify(P,k)}e.stringify=A;function y(P){let i=JSON.parse(P);return i=D(i),i}e.parse=y;function k(P,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:(0,T.regExpFlags)(i)}:i}function D(P,i=0){if(!P||i>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return C.URI.revive(P);case 2:return new RegExp(P.source,P.flags)}if(P instanceof b.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let I=0;I<P.length;++I)P[I]=D(P[I],i+1);else for(const I in P)Object.hasOwnProperty.call(P,I)&&(P[I]=D(P[I],i+1))}return P}e.revive=D}),define(me[13],ge([0,1,2,10]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var C;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp"})(C=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,P,i){this._hosts[D]=P,this._ports[D]=i}setConnectionToken(D,P){this._connectionTokens[D]=P}rewrite(D){if(this._delegate)return this._delegate(D);const P=D.authority;let i=this._hosts[P];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[P],m=this._connectionTokens[P];let g=`path=${encodeURIComponent(D.path)}`;return typeof m=="string"&&(g+=`&tkn=${encodeURIComponent(m)}`),b.URI.from({scheme:T.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new A;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,P,i){const I=this.toUri(D,P);return I.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(I):T.isNative&&(i||T.isPreferringBrowserCodeLoad)&&I.scheme===C.file?I.with({scheme:C.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(D,P){const i=this.toUri(D,P);return i.scheme===C.vscodeFileResource?i.with({scheme:C.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(D,P){return b.URI.isUri(D)?D:b.URI.parse(P.toUrl(D))}}e.FileAccess=new y}),define(me[76],ge([0,1,22]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const T=new b.LRUCache(1e4);function C(P){return D(P,"NFC",T)}e.normalizeNFC=C;const A=new b.LRUCache(1e4);function y(P){return D(P,"NFD",A)}e.normalizeNFD=y;const k=/[^\u0000-\u0080]/;function D(P,i,I){if(!e.canNormalize||!P)return P;const m=I.get(P);if(m)return m;let g;return k.test(P)?g=P.normalize(i):g=P,I.set(P,g),g}e.removeAccents=function(){if(e.canNormalize){const P=/[\u0300-\u036f]/g;return function(i){return y(i).replace(P,"")}}else return function(P){return P}}()}),define(me[25],ge([0,1,29,8,2,9,13,10]),function(K,e,b,T,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(g){return(0,C.uriToFsPath)(g,!0)}e.originalFSPath=D;class P{constructor(a){this._ignorePathCasing=a}compare(a,h,S=!1){return a===h?0:(0,A.compare)(this.getComparisonKey(a,S),this.getComparisonKey(h,S))}isEqual(a,h,S=!1){return a===h?!0:!a||!h?!1:this.getComparisonKey(a,S)===this.getComparisonKey(h,S)}getComparisonKey(a,h=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,h,S=!1){if(a.scheme===h.scheme){if(a.scheme===y.Schemas.file)return b.isEqualOrParent(D(a),D(h),this._ignorePathCasing(a))&&a.query===h.query&&(S||a.fragment===h.fragment);if((0,e.isEqualAuthority)(a.authority,h.authority))return b.isEqualOrParent(a.path,h.path,this._ignorePathCasing(a),"/")&&a.query===h.query&&(S||a.fragment===h.fragment)}return!1}joinPath(a,...h){return C.URI.joinPath(a,...h)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return T.posix.basename(a.path)}extname(a){return T.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let h;return a.scheme===y.Schemas.file?h=C.URI.file(T.dirname(D(a))).path:(h=T.posix.dirname(a.path),a.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),h="/")),a.with({path:h})}normalizePath(a){if(!a.path.length)return a;let h;return a.scheme===y.Schemas.file?h=C.URI.file(T.normalize(D(a))).path:h=T.posix.normalize(a.path),a.with({path:h})}relativePath(a,h){if(!(a.scheme!==h.scheme||!(0,e.isEqualAuthority)(a.authority,h.authority))){if(a.scheme===y.Schemas.file){const E=T.relative(D(a),D(h));return k.isWindows?b.toSlashes(E):E}let S=a.path||"/",w=h.path||"/";if(this._ignorePathCasing(a)){let E=0;for(const d=Math.min(S.length,w.length);E<d&&!(S.charCodeAt(E)!==w.charCodeAt(E)&&S.charAt(E).toLowerCase()!==w.charAt(E).toLowerCase());E++);S=w.substr(0,E)+S.substr(E)}return T.posix.relative(S,w)}}resolvePath(a,h){if(a.scheme===y.Schemas.file){const S=C.URI.file(T.resolve(D(a),h));return a.with({authority:S.authority,path:S.path})}return h.indexOf("/")===-1&&(h=b.toSlashes(h),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h)),a.with({path:T.posix.resolve(a.path,h)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,h){return a===h||(0,A.equalsIgnoreCase)(a,h)}hasTrailingPathSeparator(a,h=T.sep){if(a.scheme===y.Schemas.file){const S=D(a);return S.length>b.getRoot(S).length&&S[S.length-1]===h}else{const S=a.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,h=T.sep){return(0,e.hasTrailingPathSeparator)(a,h)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,h=T.sep){let S=!1;if(a.scheme===y.Schemas.file){const w=D(a);S=w!==void 0&&w.length===b.getRoot(w).length&&w[w.length-1]===h}else{h="/";const w=a.path;S=w.length===1&&w.charCodeAt(w.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(a,h)?a.with({path:a.path+"/"}):a}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(g=>g.scheme===y.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new P(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(g,a){const h=[];for(let S=0;S<g.length;S++){const w=a(g[S]);g.some((E,d)=>d===S?!1:(0,e.isEqualOrParent)(w,a(E)))||h.push(g[S])}return h}e.distinctParents=i;var I;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function a(h){const S=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(d=>{const[l,c]=d.split(":");l&&c&&S.set(l,c)});const E=h.path.substring(0,h.path.indexOf(";"));return E&&S.set(g.META_DATA_MIME,E),S}g.parseMetaData=a})(I=e.DataUri||(e.DataUri={}));function m(g,a,h){if(a){let S=g.path;return S&&S[0]!==T.posix.sep&&(S=T.posix.sep+S),g.with({scheme:h,authority:a,path:S})}return g.with({scheme:h})}e.toLocalResource=m}),define(me[14],ge([0,1,21,17,3,6,58,25]),function(K,e,b,T,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(N){return!!N&&typeof N.then=="function"}e.isThenable=D;function P(N){const F=new b.CancellationTokenSource,M=N(F.token),$=new Promise((q,G)=>{F.token.onCancellationRequested(()=>{G((0,T.canceled)())}),Promise.resolve(M).then(le=>{F.dispose(),q(le)},le=>{F.dispose(),G(le)})});return new class{cancel(){F.cancel()}then(q,G){return $.then(q,G)}catch(q){return this.then(void 0,q)}finally(q){return $.finally(q)}}}e.createCancelablePromise=P;function i(N,F,M){return Promise.race([N,new Promise($=>F.onCancellationRequested(()=>$(M)))])}e.raceCancellation=i;async function I(N){let F=-1;const M=N.map((q,G)=>q.then(le=>(F=G,le))),$=await Promise.race(M);return N.forEach((q,G)=>{G!==F&&q.cancel()}),$}e.raceCancellablePromises=I;function m(N,F,M){let $;const q=setTimeout(()=>{$==null||$(void 0),M==null||M()},F);return Promise.race([N.finally(()=>clearTimeout(q)),new Promise(G=>$=G)])}e.raceTimeout=m;function g(N){return new Promise((F,M)=>{const $=N();D($)?$.then(F,M):F($)})}e.asPromise=g;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const $=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,$};this.queuedPromise=new Promise($=>{this.activePromise.then(M,M).then($)})}return new Promise((M,$)=>{this.queuedPromise.then(M,$)})}return this.activePromise=F(),new Promise((M,$)=>{this.activePromise.then(q=>{this.activePromise=null,M(q)},q=>{this.activePromise=null,$(q)})})}}e.Throttler=a;class h{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=h;class S{constructor(){this.promiseMap=new Map}queue(F,M){var $;const G=(($=this.promiseMap.get(F))!==null&&$!==void 0?$:Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(F)===G&&this.promiseMap.delete(F)});return this.promiseMap.set(F,G),G}}e.SequencerByKey=S;class w{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,M=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise(($,q)=>{this.doResolve=$,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const $=this.task;return this.task=null,$()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},M),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,T.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=w;class E{constructor(F){this.delayer=new w(F),this.throttler=new a}trigger(F,M){return this.delayer.trigger(()=>this.throttler.queue(F),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class d{constructor(){this._isOpen=!1,this._promise=new Promise((F,M)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=d;class l extends d{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function c(N,F){return F?new Promise((M,$)=>{const q=setTimeout(M,N);F.onCancellationRequested(()=>{clearTimeout(q),$((0,T.canceled)())})}):P(M=>c(N,M))}e.timeout=c;function t(N,F=0){const M=setTimeout(N,F);return(0,A.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=t;function n(N){return N.then(void 0,F=>{})}e.ignoreErrors=n;function s(N){const F=[];let M=0;const $=N.length;function q(){return M<$?N[M++]():null}function G(le){le!=null&&F.push(le);const ve=q();return ve?ve.then(G):Promise.resolve(F)}return Promise.resolve(null).then(G)}e.sequence=s;function r(N,F=$=>!!$,M=null){let $=0;const q=N.length,G=()=>{if($>=q)return Promise.resolve(M);const le=N[$++];return Promise.resolve(le()).then(Re=>F(Re)?Promise.resolve(Re):G())};return G()}e.first=r;function o(N,F=$=>!!$,M=null){if(N.length===0)return Promise.resolve(M);let $=N.length;const q=()=>{var G,le;$=-1;for(const ve of N)(le=(G=ve).cancel)===null||le===void 0||le.call(G)};return new Promise((G,le)=>{for(const ve of N)ve.then(Re=>{--$>=0&&F(Re)?(q(),G(Re)):$===0&&G(M)}).catch(Re=>{--$>=0&&(q(),le(Re))})})}e.firstParallel=o;class p{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new C.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((M,$)=>{this.outstandingPromises.push({factory:F,c:M,e:$}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const M=F.factory();M.then(F.c,F.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=p;class f extends p{constructor(){super(1)}}e.Queue=f;class _{constructor(){this.queues=new Map}queueFor(F,M=k.extUri){const $=M.getComparisonKey(F);let q=this.queues.get($);return q||(q=new f,C.Event.once(q.onFinished)(()=>{q==null||q.dispose(),this.queues.delete($)}),this.queues.set($,q)),q}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=_;class u{constructor(F,M){this._token=-1,typeof F=="function"&&typeof M=="number"&&this.setIfNotSet(F,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},M)}setIfNotSet(F,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},M))}}e.TimeoutTimer=u;class v{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setInterval(()=>{F()},M)}}e.IntervalTimer=v;class R{constructor(F,M){this.timeoutToken=-1,this.runner=F,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class O extends R{constructor(F,M){super(F,M);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const M=setTimeout(()=>F(N));let $=!1;return{dispose(){$||($=!0,clearTimeout(M))}}}}else e.runWhenIdle=(N,F)=>{const M=requestIdleCallback(N,typeof F=="number"?{timeout:F}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(M))}}}}();class H{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=H;async function ne(N,F,M){let $;for(let q=0;q<M;q++)try{return await N()}catch(G){$=G,await c(F)}throw $}e.retry=ne;class ie{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var F;(F=this._pending)===null||F===void 0||F.cancel()}setPending(F,M,$){return this._pending={taskId:F,cancel:()=>$==null?void 0:$(),promise:M},M.then(()=>this.donePending(F),()=>this.donePending(F)),M}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let M,$;const q=new Promise((G,le)=>{M=G,$=le});this._next={run:F,promise:q,promiseResolve:M,promiseReject:$}}return this._next.promise}}e.TaskSequentializer=ie;class U{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=U;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,M)=>{this.completeCallback=F,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(M=>{this.completeCallback(F),this.resolved=!0,M()})}error(F){return new Promise(M=>{this.errorCallback(F),this.rejected=!0,M()})}cancel(){new Promise(F=>{this.errorCallback((0,T.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=B;class x extends C.Emitter{async fireAsync(F,M,$){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const q of this._listeners)this._asyncDeliveryQueue.push([q,F]);for(;this._asyncDeliveryQueue.size>0&&!M.isCancellationRequested;){const[q,G]=this._asyncDeliveryQueue.shift(),le=[],ve=Object.assign(Object.assign({},G),{waitUntil:Re=>{if(Object.isFrozen(le))throw new Error("waitUntil can NOT be called asynchronous");$&&(Re=$(Re,typeof q=="function"?q:q[0])),le.push(Re)}});try{typeof q=="function"?q.call(void 0,ve):q[0].call(q[1],ve)}catch(Re){(0,T.onUnexpectedError)(Re);continue}Object.freeze(le),await L.settled(le).catch(Re=>(0,T.onUnexpectedError)(Re))}}}}e.AsyncEmitter=x;var L;(function(N){async function F(G){return typeof Promise.allSettled=="function"?M(G):$(G)}N.allSettled=F;async function M(G){return Promise.allSettled(G)}async function $(G){return Promise.all(G.map(le=>le.then(ve=>({status:"fulfilled",value:ve}),ve=>({status:"rejected",reason:ve}))))}async function q(G){let le;const ve=await Promise.all(G.map(Re=>Re.then(Se=>Se,Se=>{le||(le=Se)})));if(typeof le!="undefined")throw le;return ve}N.settled=q})(L=e.Promises||(e.Promises={}))}),define(me[101],ge([0,1,8,14]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new T.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),A=new T.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new T.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(u,v,R=!1){const O=u||"",H=v||"",ne=C.value.collator.compare(O,H);return C.value.collatorIsNumeric&&ne===0&&O!==H?O<H?-1:1:ne}e.compareFileNames=k;function D(u,v){const R=A.value.collator;return u=u||"",v=v||"",c(R,u,v)}e.compareFileNamesDefault=D;function P(u,v){const R=A.value.collator;return u=u||"",v=v||"",r(u,v)||c(R,u,v)}e.compareFileNamesUpper=P;function i(u,v){const R=A.value.collator;return u=u||"",v=v||"",s(u,v)||c(R,u,v)}e.compareFileNamesLower=i;function I(u,v){return u=u||"",v=v||"",u===v?0:u<v?-1:1}e.compareFileNamesUnicode=I;function m(u,v,R=!1){R||(u=u&&u.toLowerCase(),v=v&&v.toLowerCase());const[O,H]=d(u),[ne,ie]=d(v);return O!==ne?O<ne?-1:1:H===ie?0:H<ie?-1:1}e.noIntlCompareFileNames=m;function g(u,v){const[R,O]=d(u),[H,ne]=d(v);let ie=C.value.collator.compare(O,ne);if(ie===0){if(C.value.collatorIsNumeric&&O!==ne)return O<ne?-1:1;if(ie=C.value.collator.compare(R,H),C.value.collatorIsNumeric&&ie===0&&R!==H)return R<H?-1:1}return ie}e.compareFileExtensions=g;function a(u,v){u=u||"",v=v||"";const R=l(u),O=l(v),H=A.value.collator,ne=y.value.collator;return c(ne,R,O)||c(H,u,v)}e.compareFileExtensionsDefault=a;function h(u,v){u=u||"",v=v||"";const R=l(u),O=l(v),H=A.value.collator,ne=y.value.collator;return c(ne,R,O)||r(u,v)||c(H,u,v)}e.compareFileExtensionsUpper=h;function S(u,v){u=u||"",v=v||"";const R=l(u),O=l(v),H=A.value.collator,ne=y.value.collator;return c(ne,R,O)||s(u,v)||c(H,u,v)}e.compareFileExtensionsLower=S;function w(u,v){u=u||"",v=v||"";const R=l(u).toLowerCase(),O=l(v).toLowerCase();return R!==O?R<O?-1:1:u!==v?u<v?-1:1:0}e.compareFileExtensionsUnicode=w;const E=/^(.*?)(\.([^.]*))?$/;function d(u,v=!1){const R=u?E.exec(u):[];let O=[R&&R[1]||"",R&&R[3]||""];return v&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function l(u){const v=u?E.exec(u):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function c(u,v,R){let O=u.compare(v,R);return O!==0?O:v.length!==R.length?v.length<R.length?-1:1:0}function t(u){const v=u.charAt(0);return v.toLocaleUpperCase()!==v}function n(u){const v=u.charAt(0);return v.toLocaleLowerCase()!==v}function s(u,v){return t(u)&&n(v)?-1:n(u)&&t(v)?1:0}function r(u,v){return n(u)&&t(v)?-1:t(u)&&n(v)?1:0}function o(u,v,R=!1){return R||(u=u&&u.toLowerCase(),v=v&&v.toLowerCase()),u===v?0:u<v?-1:1}function p(u,v,R=!1){const O=u.split(b.sep),H=v.split(b.sep),ne=O.length-1,ie=H.length-1;let U,B;for(let x=0;;x++){if(U=ne===x,B=ie===x,U&&B)return k(O[x],H[x],R);if(U)return-1;if(B)return 1;const L=o(O[x],H[x],R);if(L!==0)return L}}e.comparePaths=p;function f(u,v,R){const O=u.toLowerCase(),H=v.toLowerCase(),ne=_(u,v,R);if(ne)return ne;const ie=O.endsWith(R),U=H.endsWith(R);if(ie!==U)return ie?-1:1;const B=k(O,H);return B!==0?B:O.localeCompare(H)}e.compareAnything=f;function _(u,v,R){const O=u.toLowerCase(),H=v.toLowerCase(),ne=O.startsWith(R),ie=H.startsWith(R);if(ne!==ie)return ne?-1:1;if(ne&&ie){if(O.length<H.length)return-1;if(O.length>H.length)return 1}return 0}e.compareByPrefix=_}),define(me[102],ge([0,1,101,99,8,10,9]),function(K,e,b,T,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const k=0,D=[k,[]];function P(U,B,x,L){if(!U||!B)return D;const N=U.length,F=B.length;if(N<F)return D;const M=U.toLowerCase();return!L&&!M.includes(x)?D:i(B,x,F,U,M,N)}e.scoreFuzzy=P;function i(U,B,x,L,N,F){const M=[],$=[];for(let ve=0;ve<x;ve++){const Re=ve*F,Se=Re-F,Oe=ve>0,V=U[ve],X=B[ve];for(let Z=0;Z<F;Z++){const se=Z>0,fe=Re+Z,Ee=fe-1,Be=Se+Z-1,pe=se?M[Ee]:0,Ce=Oe&&se?M[Be]:0,Me=Oe&&se?$[Be]:0;let ze;!Ce&&Oe?ze=0:ze=I(V,X,L,N,Z,Me),ze&&Ce+ze>=pe?($[fe]=Me+1,M[fe]=Ce+ze):($[fe]=k,M[fe]=pe)}}const q=[];let G=x-1,le=F-1;for(;G>=0&&le>=0;){const ve=G*F+le;$[ve]===k||(q.push(le),G--),le--}return[M[x*F-1],q.reverse()]}function I(U,B,x,L,N,F){let M=0;if(!m(B,L[N]))return M;if(M+=1,F>0&&(M+=F*5),U===x[N]&&(M+=1),N===0)M+=8;else{const $=g(x.charCodeAt(N-1));$?M+=$:(0,T.isUpper)(x.charCodeAt(N))&&(M+=2)}return M}function m(U,B){return U===B?!0:U==="/"||U==="\\"?B==="/"||B==="\\":!1}function g(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function h(U,B,x=0,L=0){const N=B;return N.values&&N.values.length>1?S(U,N.values,x,L):w(U,B,x,L)}e.scoreFuzzy2=h;function S(U,B,x,L){let N=0;const F=[];for(const M of B){const[$,q]=w(U,M,x,L);if(typeof $!="number")return a;N+=$,F.push(...q)}return[N,p(F)]}function w(U,B,x,L){const N=(0,T.fuzzyScore)(B.original,B.originalLowercase,x,U,U.toLowerCase(),L,!0);return N?[N[0],(0,T.createMatches)(N)]:a}const E=Object.freeze({score:0}),d=1<<18,l=1<<17,c=1<<16;function t(U,B,x,L,N){if(!U||!B.normalized)return E;const F=L.getItemLabel(U);if(!F)return E;const M=L.getItemDescription(U);let $;M?$=`${F}${M}${B.normalized}${Array.isArray(B.values)?B.values.length:""}${x}`:$=`${F}${B.normalized}${Array.isArray(B.values)?B.values.length:""}${x}`;const q=N[$];if(q)return q;const G=n(F,M,L.getItemPath(U),B,x);return N[$]=G,G}e.scoreItemFuzzy=t;function n(U,B,x,L,N){const F=!x||!L.containsPathSeparator;return x&&(A.isLinux?L.pathNormalized===x:(0,y.equalsIgnoreCase)(L.pathNormalized,x))?{score:d,labelMatch:[{start:0,end:U.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:L.values&&L.values.length>1?s(U,B,x,L.values,F,N):r(U,B,x,L,F,N)}function s(U,B,x,L,N,F){let M=0;const $=[],q=[];for(const G of L){const{score:le,labelMatch:ve,descriptionMatch:Re}=r(U,B,x,G,N,F);if(le===k)return E;M+=le,ve&&$.push(...ve),Re&&q.push(...Re)}return{score:M,labelMatch:p($),descriptionMatch:p(q)}}function r(U,B,x,L,N,F){if(N||!B){const[M,$]=P(U,L.normalized,L.normalizedLowercase,F);if(M){const q=(0,T.matchesPrefix)(L.normalized,U);let G;return q?(G=l,G+=Math.round(L.normalized.length/U.length*100)):G=c,{score:G+M,labelMatch:q||o($)}}}if(B){let M=B;x&&(M=`${B}${C.sep}`);const $=M.length,q=`${M}${U}`,[G,le]=P(q,L.normalized,L.normalizedLowercase,F);if(G){const ve=o(le),Re=[],Se=[];return ve.forEach(Oe=>{Oe.start<$&&Oe.end>$?(Re.push({start:0,end:Oe.end-$}),Se.push({start:Oe.start,end:$})):Oe.start>=$?Re.push({start:Oe.start-$,end:Oe.end-$}):Se.push(Oe)}),{score:G,labelMatch:Re,descriptionMatch:Se}}}return E}function o(U){const B=[];if(!U)return B;let x;for(const L of U)x&&x.end===L?x.end+=1:(x={start:L,end:L+1},B.push(x));return B}function p(U){const B=U.sort((N,F)=>N.start-F.start),x=[];let L;for(const N of B)!L||!f(L,N)?(L=N,x.push(N)):(L.start=Math.min(L.start,N.start),L.end=Math.max(L.end,N.end));return x}function f(U,B){return!(U.end<B.start||B.end<U.start)}function _(U,B,x,L,N,F){const M=t(U,x,L,N,F),$=t(B,x,L,N,F),q=M.score,G=$.score;if((q===d||G===d)&&q!==G)return q===d?-1:1;if(q>c||G>c){if(q!==G)return q>G?-1:1;if(q<l&&G<l){const X=v(M.labelMatch,$.labelMatch);if(X!==0)return X}const Oe=N.getItemLabel(U)||"",V=N.getItemLabel(B)||"";if(Oe.length!==V.length)return Oe.length-V.length}if(q!==G)return q>G?-1:1;const le=Array.isArray(M.labelMatch)&&M.labelMatch.length>0,ve=Array.isArray($.labelMatch)&&$.labelMatch.length>0;if(le&&!ve)return-1;if(ve&&!le)return 1;const Re=u(U,M,N),Se=u(B,$,N);return Re&&Se&&Re!==Se?Se>Re?-1:1:R(U,B,x,N)}e.compareItemsByFuzzyScore=_;function u(U,B,x){let L=-1,N=-1;if(B.descriptionMatch&&B.descriptionMatch.length?L=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(L=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(N=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const F=x.getItemDescription(U);F&&(N+=F.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(N=B.descriptionMatch[B.descriptionMatch.length-1].end);return N-L}function v(U,B){if(!U&&!B||(!U||!U.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!U||!U.length)return 1;const x=U[0].start,N=U[U.length-1].end-x,F=B[0].start,$=B[B.length-1].end-F;return N===$?0:$<N?1:-1}function R(U,B,x,L){const N=L.getItemLabel(U)||"",F=L.getItemLabel(B)||"",M=L.getItemDescription(U),$=L.getItemDescription(B),q=N.length+(M?M.length:0),G=F.length+($?$.length:0);if(q!==G)return q-G;const le=L.getItemPath(U),ve=L.getItemPath(B);return le&&ve&&le.length!==ve.length?le.length-ve.length:N!==F?(0,b.compareAnything)(N,F,x.normalized):M&&$&&M!==$?(0,b.compareAnything)(M,$,x.normalized):le&&ve&&le!==ve?(0,b.compareAnything)(le,ve,x.normalized):0}const O=" ";function H(U){typeof U!="string"&&(U="");const B=U.toLowerCase(),{pathNormalized:x,normalized:L,normalizedLowercase:N}=ne(U),F=x.indexOf(C.sep)>=0;let M;const $=U.split(O);if($.length>1)for(const q of $){const{pathNormalized:G,normalized:le,normalizedLowercase:ve}=ne(q);le&&(M||(M=[]),M.push({original:q,originalLowercase:q.toLowerCase(),pathNormalized:G,normalized:le,normalizedLowercase:ve}))}return{original:U,originalLowercase:B,pathNormalized:x,normalized:L,normalizedLowercase:N,values:M,containsPathSeparator:F}}e.prepareQuery=H;function ne(U){let B;A.isWindows?B=U.replace(/\//g,C.sep):B=U.replace(/\\/g,C.sep);const x=(0,y.stripWildcards)(B).replace(/\s/g,"");return{pathNormalized:B,normalized:x,normalizedLowercase:x.toLowerCase()}}function ie(U){return Array.isArray(U)?H(U.map(B=>B.original).join(O)):H(U.original)}e.pieceToQuery=ie}),define(me[33],ge([0,1,9,29,8,22,14]),function(K,e,b,T,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const D="**",P="/",i="[/\\\\]",I="[^/\\\\]",m=/\//g;function g(M){switch(M){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function a(M,$){if(!M)return[];const q=[];let G=!1,le=!1,ve="";for(const Re of M){switch(Re){case $:if(!G&&!le){q.push(ve),ve="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":le=!0;break;case"]":le=!1;break}ve+=Re}return ve&&q.push(ve),q}e.splitGlobAware=a;function h(M){if(!M)return"";let $="";const q=a(M,P);if(q.every(G=>G===D))$=".*";else{let G=!1;q.forEach((le,ve)=>{if(le===D){G||($+=g(2),G=!0);return}let Re=!1,Se="",Oe=!1,V="";for(const X of le){if(X!=="}"&&Re){Se+=X;continue}if(Oe&&(X!=="]"||!V)){let Z;X==="-"?Z=X:(X==="^"||X==="!")&&!V?Z="^":X===P?Z="":Z=b.escapeRegExpCharacters(X),V+=Z;continue}switch(X){case"{":Re=!0;continue;case"[":Oe=!0;continue;case"}":$+=`(?:${a(Se,",").map(fe=>h(fe)).join("|")})`,Re=!1,Se="";break;case"]":$+="["+V+"]",Oe=!1,V="";break;case"?":$+=I;continue;case"*":$+=g(1);continue;default:$+=b.escapeRegExpCharacters(X)}}ve<q.length-1&&(q[ve+1]!==D||ve+2<q.length)&&($+=i),G=!1})}return $}const S=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),n=function(){return!1},s=function(){return null};function r(M,$){if(!M)return s;let q;typeof M!="string"?q=M.pattern:q=M,q=q.trim();const G=`${q}_${!!$.trimForExclusions}`;let le=t.get(G);if(le)return o(le,M);let ve;if(S.test(q)){const Re=q.substr(4);le=function(Se,Oe){return typeof Se=="string"&&Se.endsWith(Re)?q:null}}else(ve=w.exec(p(q,$)))?le=f(ve[1],q):($.trimForExclusions?d:E).test(q)?le=_(q,$):(ve=l.exec(p(q,$)))?le=u(ve[1].substr(1),q,!0):(ve=c.exec(p(q,$)))?le=u(ve[1],q,!1):le=v(q);return t.set(G,le),o(le,M)}function o(M,$){return typeof $=="string"?M:function(q,G){return T.isEqualOrParent(q,$.base)?M(C.relative($.base,q),G):null}}function p(M,$){return $.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function f(M,$){const q=`/${M}`,G=`\\${M}`,le=function(Re,Se){return typeof Re!="string"?null:Se?Se===M?$:null:Re===M||Re.endsWith(q)||Re.endsWith(G)?$:null},ve=[M];return le.basenames=ve,le.patterns=[$],le.allBasenames=ve,le}function _(M,$){const q=F(M.slice(1,-1).split(",").map(Se=>r(Se,$)).filter(Se=>Se!==s),M),G=q.length;if(!G)return s;if(G===1)return q[0];const le=function(Se,Oe){for(let V=0,X=q.length;V<X;V++)if(q[V](Se,Oe))return M;return null},ve=q.find(Se=>!!Se.allBasenames);ve&&(le.allBasenames=ve.allBasenames);const Re=q.reduce((Se,Oe)=>Oe.allPaths?Se.concat(Oe.allPaths):Se,[]);return Re.length&&(le.allPaths=Re),le}function u(M,$,q){const G=C.sep===C.posix.sep,le=G?M:M.replace(m,C.sep),ve=C.sep+le,Re=C.posix.sep+M,Se=q?function(Oe,V){return typeof Oe=="string"&&(Oe===le||Oe.endsWith(ve)||!G&&(Oe===M||Oe.endsWith(Re)))?$:null}:function(Oe,V){return typeof Oe=="string"&&(Oe===le||!G&&Oe===M)?$:null};return Se.allPaths=[(q?"*/":"./")+M],Se}function v(M){try{const $=new RegExp(`^${h(M)}$`);return function(q){return $.lastIndex=0,typeof q=="string"&&$.test(q)?M:null}}catch($){return s}}function R(M,$,q){return!M||typeof $!="string"?!1:O(M)($,void 0,q)}e.match=R;function O(M,$={}){if(!M)return n;if(typeof M=="string"||U(M)){const q=r(M,$);if(q===s)return n;const G=function(le,ve){return!!q(le,ve)};return q.allBasenames&&(G.allBasenames=q.allBasenames),q.allPaths&&(G.allPaths=q.allPaths),G}return L(M,$)}e.parse=O;function H(M){if(!!M){let $;return q=>($||($=(M()||Promise.resolve([])).then(G=>G?ie(G):{})),$.then(G=>!!G[q]))}}e.hasSiblingPromiseFn=H;function ne(M){if(!!M){let $;return q=>{if(!$){const G=M();$=G?ie(G):{}}return!!$[q]}}}e.hasSiblingFn=ne;function ie(M){const $={};for(const q of M)$[q]=!0;return $}function U(M){const $=M;return $&&typeof $.base=="string"&&typeof $.pattern=="string"}e.isRelativePattern=U;function B(M){return M.allBasenames||[]}e.getBasenameTerms=B;function x(M){return M.allPaths||[]}e.getPathTerms=x;function L(M,$){const q=F(Object.getOwnPropertyNames(M).map(Se=>N(Se,M[Se],$)).filter(Se=>Se!==s)),G=q.length;if(!G)return s;if(!q.some(Se=>!!Se.requiresSiblings)){if(G===1)return q[0];const Se=function(X,Z){for(let se=0,fe=q.length;se<fe;se++){const Ee=q[se](X,Z);if(Ee)return Ee}return null},Oe=q.find(X=>!!X.allBasenames);Oe&&(Se.allBasenames=Oe.allBasenames);const V=q.reduce((X,Z)=>Z.allPaths?X.concat(Z.allPaths):X,[]);return V.length&&(Se.allPaths=V),Se}const le=function(Se,Oe,V){let X;for(let Z=0,se=q.length;Z<se;Z++){const fe=q[Z];fe.requiresSiblings&&V&&(Oe||(Oe=C.basename(Se)),X||(X=Oe.substr(0,Oe.length-C.extname(Se).length)));const Ee=fe(Se,Oe,X,V);if(Ee)return Ee}return null},ve=q.find(Se=>!!Se.allBasenames);ve&&(le.allBasenames=ve.allBasenames);const Re=q.reduce((Se,Oe)=>Oe.allPaths?Se.concat(Oe.allPaths):Se,[]);return Re.length&&(le.allPaths=Re),le}function N(M,$,q){if($===!1)return s;const G=r(M,q);if(G===s)return s;if(typeof $=="boolean")return G;if($){const le=$.when;if(typeof le=="string"){const ve=(Re,Se,Oe,V)=>{if(!V||!G(Re,Se))return null;const X=le.replace("$(basename)",Oe),Z=V(X);return(0,y.isThenable)(Z)?Z.then(se=>se?M:null):Z?M:null};return ve.requiresSiblings=!0,ve}}return G}function F(M,$){const q=M.filter(Se=>!!Se.basenames);if(q.length<2)return M;const G=q.reduce((Se,Oe)=>{const V=Oe.basenames;return V?Se.concat(V):Se},[]);let le;if($){le=[];for(let Se=0,Oe=G.length;Se<Oe;Se++)le.push($)}else le=q.reduce((Se,Oe)=>{const V=Oe.patterns;return V?Se.concat(V):Se},[]);const ve=function(Se,Oe){if(typeof Se!="string")return null;if(!Oe){let X;for(X=Se.length;X>0;X--){const Z=Se.charCodeAt(X-1);if(Z===47||Z===92)break}Oe=Se.substr(X)}const V=G.indexOf(Oe);return V!==-1?le[V]:null};ve.basenames=G,ve.patterns=le,ve.allBasenames=G;const Re=M.filter(Se=>!Se.basenames);return Re.push(ve),Re}}),define(me[77],ge([0,1,2,8,9,13,10,25,29]),function(K,e,b,T,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(r,o,p){if(typeof r=="string"&&(r=b.URI.file(r)),p){const _=p.getWorkspaceFolder(r);if(_){const u=p.getWorkspace().folders.length>1;let v;if((0,k.isEqual)(_.uri,r)?v="":v=(0,k.relativePath)(_.uri,r),u){const R=_.name?_.name:(0,k.basename)(_.uri);v=v?R+" \u2022 "+v:R}return v}}if(r.scheme!==A.Schemas.file&&r.scheme!==A.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(r.fsPath))return(0,T.normalize)(I(r.fsPath));let f=(0,T.normalize)(r.fsPath);return!y.isWindows&&(o==null?void 0:o.userHome)&&(f=g(f,o.userHome.fsPath)),f}e.getPathLabel=P;function i(r){if(!!r){typeof r=="string"&&(r=b.URI.file(r));const o=(0,k.basename)(r)||(r.scheme===A.Schemas.file?r.fsPath:r.path);return y.isWindows&&(0,D.isRootOrDriveLetter)(o)?I(o):o}}e.getBaseLabel=i;function I(r){return(0,D.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=I;let m=Object.create(null);function g(r,o){if(y.isWindows||!r||!o)return r;let p=m.original===o?m.normalized:void 0;return p||(p=`${(0,C.rtrim)(o,T.posix.sep)}${T.posix.sep}`,m={original:o,normalized:p}),(y.isLinux?r.startsWith(p):(0,C.startsWithIgnoreCase)(r,p))&&(r=`~/${r.substr(p.length)}`),r}e.tildify=g;function a(r,o){return r.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=a;const h="\u2026",S="\\\\",w="~";function E(r,o=T.sep){const p=new Array(r.length);let f=!1;for(let _=0;_<r.length;_++){let u=r[_];if(u===""){p[_]=`.${o}`;continue}if(!u){p[_]=u;continue}f=!0;let v="";u.indexOf(S)===0?(v=u.substr(0,u.indexOf(S)+S.length),u=u.substr(u.indexOf(S)+S.length)):u.indexOf(o)===0?(v=u.substr(0,u.indexOf(o)+o.length),u=u.substr(u.indexOf(o)+o.length)):u.indexOf(w)===0&&(v=u.substr(0,u.indexOf(w)+w.length),u=u.substr(u.indexOf(w)+w.length));const R=u.split(o);for(let O=1;f&&O<=R.length;O++)for(let H=R.length-O;f&&H>=0;H--){f=!1;let ne=R.slice(H,H+O).join(o);for(let ie=0;!f&&ie<r.length;ie++)if(ie!==_&&r[ie]&&r[ie].indexOf(ne)>-1){const U=H+O===R.length,B=H>0&&r[ie].indexOf(o)>-1?o+ne:ne,x=r[ie].endsWith(B);f=!U||x}if(!f){let ie="";(R[0].endsWith(":")||v!=="")&&(H===1&&(H=0,O++,ne=R[0]+o+ne),H>0&&(ie=R[0]+o),ie=v+ie),H>0&&(ie=ie+h+o),ie=ie+ne,H+O<R.length&&(ie=ie+o+h),p[_]=ie}}f&&(p[_]=u)}return p}e.shorten=E;var d;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function l(r,o=Object.create(null)){const p=[];let f=!1,_="";for(const u of r)if(u==="$"||f&&u==="{")_&&p.push({value:_,type:d.TEXT}),_="",f=!0;else if(u==="}"&&f){const v=o[_];if(typeof v=="string")v.length&&p.push({value:v,type:d.VARIABLE});else if(v){const R=p[p.length-1];(!R||R.type!==d.SEPARATOR)&&p.push({value:v.label,type:d.SEPARATOR})}_="",f=!1}else _+=u;return _&&!f&&p.push({value:_,type:d.TEXT}),p.filter((u,v)=>{if(u.type===d.SEPARATOR){const R=p[v-1],O=p[v+1];return[R,O].every(H=>H&&(H.type===d.VARIABLE||H.type===d.TEXT)&&H.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=l;function c(r,o){return y.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):r.replace(/&&|&/g,p=>p==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function t(r,o){return y.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,""):y.isWindows?r.replace(/&&|&/g,p=>p==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=n;function s(r){const o=r.indexOf("/")!==-1?T.posix:T.win32,p=o.basename(r),f=o.dirname(r);return p.length?{name:p,parentPath:f}:{name:f,parentPath:""}}e.splitName=s}),define(me[103],ge([0,1,2]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(i){return i.toJSON()}class C{constructor(I){this._uriTransformer=I}transformIncoming(I){const m=this._uriTransformer.transformIncoming(I);return m===I?I:T(b.URI.from(m))}transformOutgoing(I){const m=this._uriTransformer.transformOutgoing(I);return m===I?I:T(b.URI.from(m))}transformOutgoingURI(I){const m=this._uriTransformer.transformOutgoing(I);return m===I?I:b.URI.from(m)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function A(i,I,m){if(!i||m>200)return null;if(typeof i=="object"){if(i instanceof b.URI)return I.transformOutgoing(i);for(let g in i)if(Object.hasOwnProperty.call(i,g)){const a=A(i[g],I,m+1);a!==null&&(i[g]=a)}}return null}function y(i,I){const m=A(i,I,0);return m===null?i:m}e.transformOutgoingURIs=y;function k(i,I,m,g){if(!i||g>200)return null;if(typeof i=="object"){if(i.$mid===1)return m?b.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let a in i)if(Object.hasOwnProperty.call(i,a)){const h=k(i[a],I,m,g+1);h!==null&&(i[a]=h)}}return null}function D(i,I){const m=k(i,I,!1,0);return m===null?i:m}e.transformIncomingURIs=D;function P(i,I){const m=k(i,I,!0,0);return m===null?i:m}e.transformAndReviveIncomingURIs=P}),define(me[30],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(D){return b.test(D)}e.isUUID=T;const C=new Uint8Array(16),A=[];for(let D=0;D<256;D++)A.push(D.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(D){for(let P=0;P<D.length;P++)D[P]=Math.floor(Math.random()*256);return D};function k(){y(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let D=0,P="";return P+=A[C[D++]],P+=A[C[D++]],P+=A[C[D++]],P+=A[C[D++]],P+="-",P+=A[C[D++]],P+=A[C[D++]],P+="-",P+=A[C[D++]],P+=A[C[D++]],P+="-",P+=A[C[D++]],P+=A[C[D++]],P+="-",P+=A[C[D++]],P+=A[C[D++]],P+=A[C[D++]],P+=A[C[D++]],P+=A[C[D++]],P+=A[C[D++]],P}e.generateUuid=k}),define(me[138],ge([0,1,104]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class T{constructor(A="utf8"){this.stringDecoder=new b.StringDecoder(A),this.remaining=null}write(A){const y=[],k=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(k.length<1)return y;let D=0,P,i=D;for(;i<k.length;)if(P=k.charCodeAt(i),P===13||P===10){if(y.push(k.substring(D,i)),i++,i<k.length){const I=P;P=k.charCodeAt(i),(I===13&&P===10||I===10&&P===13)&&i++}D=i}else i++;return this.remaining=D<k.length?k.substr(D):null,y}end(){return this.remaining}}e.LineDecoder=T}),define(me[26],ge([0,1,37,49,8,14,10,29,30,76,25,2]),function(K,e,b,T,C,A,y,k,D,P,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var m;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function g(B,x=m.UNLINK){if((0,k.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return x===m.UNLINK?h(B):a(B)}e.rimraf=g;async function a(B){try{const x=(0,C.join)((0,T.tmpdir)(),(0,D.generateUuid)());try{await b.promises.rename(B,x)}catch(L){return h(B)}h(x).catch(L=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function h(B){return b.promises.rmdir(B,{recursive:!0,maxRetries:3})}function S(B){if((0,k.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");b.rmdirSync(B,{recursive:!0})}e.rimrafSync=S;async function w(B,x){return l(await(x?E(B):b.promises.readdir(B)))}e.readdir=w;async function E(B){try{return await b.promises.readdir(B,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const x=[],L=await w(B);for(const N of L){let F=!1,M=!1,$=!1;try{const q=await b.promises.lstat((0,C.join)(B,N));F=q.isFile(),M=q.isDirectory(),$=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}x.push({name:N,isFile:()=>F,isDirectory:()=>M,isSymbolicLink:()=>$})}return x}function d(B){return l(b.readdirSync(B))}e.readdirSync=d;function l(B){return B.map(x=>typeof x=="string"?y.isMacintosh?(0,P.normalizeNFC)(x):x:(x.name=y.isMacintosh?(0,P.normalizeNFC)(x.name):x.name,x))}async function c(B){const x=await w(B),L=[];for(const N of x)await n.existsDirectory((0,C.join)(B,N))&&L.push(N);return L}e.readDirsInDir=c;function t(B,x=1e3){return new Promise(L=>{let N=!1;const F=setInterval(()=>{N||(N=!0,b.access(B,M=>{N=!1,M&&(clearInterval(F),L(void 0))}))},x)})}e.whenDeleted=t;var n;(function(B){async function x(F){let M;try{if(M=await b.promises.lstat(F),!M.isSymbolicLink())return{stat:M}}catch($){}try{return{stat:await b.promises.stat(F),symbolicLink:(M==null?void 0:M.isSymbolicLink())?{dangling:!1}:void 0}}catch($){if($.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};if(y.isWindows&&$.code==="EACCES")try{return{stat:await b.promises.stat(await b.promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};throw q}throw $}}B.stat=x;async function L(F){try{const{stat:M,symbolicLink:$}=await B.stat(F);return M.isFile()&&($==null?void 0:$.dangling)!==!0}catch(M){}return!1}B.existsFile=L;async function N(F){try{const{stat:M,symbolicLink:$}=await B.stat(F);return M.isDirectory()&&($==null?void 0:$.dangling)!==!0}catch(M){}return!1}B.existsDirectory=N})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new A.ResourceQueue;function r(B,x,L){return s.queueFor(I.URI.file(B),i.extUriBiasedIgnorePathCase).queue(()=>{const N=_(L);return new Promise((F,M)=>p(B,x,N,$=>$?M($):F()))})}e.writeFile=r;let o=!0;function p(B,x,L,N){if(!o)return b.writeFile(B,x,{mode:L.mode,flag:L.flag},N);b.open(B,L.flag,L.mode,(F,M)=>{if(F)return N(F);b.writeFile(M,x,$=>{if($)return b.close(M,()=>N($));b.fdatasync(M,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),o=!1),b.close(M,G=>N(G))))})})}function f(B,x,L){const N=_(L);if(!o)return b.writeFileSync(B,x,{mode:N.mode,flag:N.flag});const F=b.openSync(B,N.flag,N.mode);try{b.writeFileSync(F,x);try{b.fdatasyncSync(F)}catch(M){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",M),o=!1}}finally{b.closeSync(F)}}e.writeFileSync=f;function _(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function u(B,x){if(B!==x){async function L(N){try{const F=await b.promises.lstat(N);if(F.isDirectory()||F.isSymbolicLink())return;const M=await b.promises.open(N,"a");try{await M.utimes(F.atime,new Date)}finally{await M.close()}}catch(F){}}try{await b.promises.rename(B,x),await L(x)}catch(N){if(B.toLowerCase()!==x.toLowerCase()&&N.code==="EXDEV"||B.endsWith("."))await v(B,x,{preserveSymlinks:!1}),await g(B,m.MOVE),await L(x);else throw N}}}e.move=u;async function v(B,x,L){return O(B,x,{root:{source:B,target:x},options:L,handledSourcePaths:new Set})}e.copy=v;const R=511;async function O(B,x,L){if(!L.handledSourcePaths.has(B)){L.handledSourcePaths.add(B);const{stat:N,symbolicLink:F}=await n.stat(B);if(F){if(L.options.preserveSymlinks)try{return await ie(B,x,L)}catch(M){console.warn("[node.js fs] copy of symlink failed: ",M)}if(F.dangling)return}return N.isDirectory()?H(B,x,N.mode&R,L):ne(B,x,N.mode&R)}}async function H(B,x,L,N){await b.promises.mkdir(x,{recursive:!0,mode:L});const F=await w(B);for(const M of F)await O((0,C.join)(B,M),(0,C.join)(x,M),N)}async function ne(B,x,L){await b.promises.copyFile(B,x),await b.promises.chmod(x,L)}async function ie(B,x,L){let N=await b.promises.readlink(B);(0,k.isEqualOrParent)(N,L.root.source,!y.isLinux)&&(N=(0,C.join)(L.root.target,N.substr(L.root.source.length+1))),await b.promises.symlink(N,x)}async function U(B){try{return await b.promises.access(B),!0}catch(x){return!1}}e.exists=U}),define(me[105],ge([0,1,37,284,9,8,26]),function(K,e,b,T,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function k(I){const m=(0,A.dirname)(I);if(I===m)return I;const g=((0,A.basename)(I)||I).toLowerCase();try{const h=(0,y.readdirSync)(m).filter(S=>S.toLowerCase()===g);if(h.length===1){const S=k(m);if(S)return(0,A.join)(S,h[0])}else if(h.length>1){const S=h.indexOf(g);if(S>=0){const w=k(m);if(w)return(0,A.join)(w,h[S])}}}catch(a){}return null}e.realcaseSync=k;async function D(I){try{return await(0,T.promisify)(b.realpath)(I)}catch(m){const g=i(I);return await b.promises.access(g,b.constants.R_OK),g}}e.realpath=D;function P(I){try{return b.realpathSync(I)}catch(m){const g=i(I);return b.accessSync(g,b.constants.R_OK),g}}e.realpathSync=P;function i(I){return(0,C.rtrim)((0,A.normalize)(I),A.sep)}});var Et=this&&this.__await||function(K){return this instanceof Et?(this.v=K,this):new Et(K)},Mn=this&&this.__asyncGenerator||function(K,e,b){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var T=b.apply(K,e||[]),C,A=[];return C={},y("next"),y("throw"),y("return"),C[Symbol.asyncIterator]=function(){return this},C;function y(m){T[m]&&(C[m]=function(g){return new Promise(function(a,h){A.push([m,g,a,h])>1||k(m,g)})})}function k(m,g){try{D(T[m](g))}catch(a){I(A[0][3],a)}}function D(m){m.value instanceof Et?Promise.resolve(m.value.v).then(P,i):I(A[0][2],m)}function P(m){k("next",m)}function i(m){k("throw",m)}function I(m,g){m(g),A.shift(),A.length&&k(A[0][0],A[0][1])}},fn=this&&this.__asyncValues||function(K){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=K[Symbol.asyncIterator],b;return e?e.call(K):(K=typeof __values=="function"?__values(K):K[Symbol.iterator](),b={},T("next"),T("throw"),T("return"),b[Symbol.asyncIterator]=function(){return this},b);function T(A){b[A]=K[A]&&function(y){return new Promise(function(k,D){y=K[A](y),C(k,D,y.done,y.value)})}}function C(A,y,k,D){Promise.resolve(D).then(function(P){A({value:P,done:k})},y)}};define(me[106],ge([0,1,26,49,8]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,y=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var D;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(D||(D={}));let P;switch(process.arch){case"ia32":case"x32":P=1;break;case"arm":case"arm64":P=2;break;default:P=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class I{constructor(c,t,n){this.exePath=c,this.displayName=t,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:l=!1}={}){return l?P===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:l=!1,findPreview:c=!1}={}){const t=m({useAlternateBitness:l});if(!t)return null;const n=C.join(t,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(n))return null;let s=-1,r=null;for(const f of await b.readdir(n)){let _=-1;if(c){const v=f.indexOf("-");if(v<0)continue;const R=f.substring(0,v);if(!A.test(R)||f.substring(v+1)!=="preview")continue;_=parseInt(R,10)}else{if(!A.test(f))continue;_=parseInt(f,10)}if(!(_<=s)){const u=C.join(n,f,"pwsh.exe");!await b.SymlinkSupport.existsFile(u)||(r=u,s=_)}}if(!r)return null;const o=t.includes("x86")?" (x86)":"",p=c?" Preview":"";return new I(r,`PowerShell${p}${o}`,!0)}async function a({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const c=C.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=l?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:y,pwshMsixName:"PowerShell (Store)"};for(const s of await b.readdir(c))if(t.test(s)){const r=C.join(c,s,"pwsh.exe");return new I(r,n)}return null}function h(){const l=C.join(T.homedir(),".dotnet","tools","pwsh.exe");return new I(l,".NET Core PowerShell Global Tool")}function S(){const l=C.join(process.env.windir,P===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(l,"Windows PowerShell",!0)}function w(){return Mn(this,arguments,function*(){let c=yield Et(g());c&&(yield yield Et(c)),c=yield Et(g({useAlternateBitness:!0})),c&&(yield yield Et(c)),c=yield Et(a()),c&&(yield yield Et(c)),c=h(),c&&(yield yield Et(c)),c=yield Et(g({findPreview:!0})),c&&(yield yield Et(c)),c=yield Et(a({findPreview:!0})),c&&(yield yield Et(c)),c=yield Et(g({useAlternateBitness:!0,findPreview:!0})),c&&(yield yield Et(c)),c=S(),c&&(yield yield Et(c))})}function E(){return Mn(this,arguments,function*(){var c,t;try{for(var n=fn(w()),s;s=yield Et(n.next()),!s.done;){const r=s.value;(yield Et(r.exists()))&&(yield yield Et(r))}}catch(r){c={error:r}}finally{try{s&&!s.done&&(t=n.return)&&(yield Et(t.call(n)))}finally{if(c)throw c.error}}})}e.enumeratePowerShellInstallations=E;async function d(){var l,c;try{for(var t=fn(E()),n;n=await t.next(),!n.done;)return n.value}catch(s){l={error:s}}finally{try{n&&!n.done&&(c=t.return)&&await c.call(t)}finally{if(l)throw l.error}}return null}e.getFirstAvailablePowerShellInstallation=d});var qe=this&&this.__decorate||function(K,e,b,T){var C=arguments.length,A=C<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,b):T,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(K,e,b,T);else for(var k=K.length-1;k>=0;k--)(y=K[k])&&(A=(C<3?y(A):C>3?y(e,b,A):y(e,b))||A);return C>3&&A&&Object.defineProperty(e,b,A),A};define(me[107],ge([0,1,3,6,14,21,17,23,16,11,60,9,55]),function(K,e,b,T,C,A,y,k,D,P,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var g;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(g=e.RequestType||(e.RequestType={}));function a(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function S(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(w||(w={}));class E{constructor(M){this.buffer=M,this.pos=0}read(M){const $=this.buffer.slice(this.pos,this.pos+M);return this.pos+=$.byteLength,$}}class d{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}var l;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(l||(l={}));function c(F){const M=k.VSBuffer.alloc(4);return M.writeUInt32BE(F,0),M}function t(F){return F.read(4).readUInt32BE(0)}function n(F){const M=k.VSBuffer.alloc(1);return M.writeUInt8(F,0),M}const s={Undefined:n(l.Undefined),String:n(l.String),Buffer:n(l.Buffer),VSBuffer:n(l.VSBuffer),Array:n(l.Array),Object:n(l.Object)},r=typeof Buffer!="undefined";function o(F,M){if(typeof M=="undefined")F.write(s.Undefined);else if(typeof M=="string"){const $=k.VSBuffer.fromString(M);F.write(s.String),F.write(c($.byteLength)),F.write($)}else if(r&&Buffer.isBuffer(M)){const $=k.VSBuffer.wrap(M);F.write(s.Buffer),F.write(c($.byteLength)),F.write($)}else if(M instanceof k.VSBuffer)F.write(s.VSBuffer),F.write(c(M.byteLength)),F.write(M);else if(Array.isArray(M)){F.write(s.Array),F.write(c(M.length));for(const $ of M)o(F,$)}else{const $=k.VSBuffer.fromString(JSON.stringify(M));F.write(s.Object),F.write(c($.byteLength)),F.write($)}}function p(F){switch(F.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return F.read(t(F)).toString();case l.Buffer:return F.read(t(F)).buffer;case l.VSBuffer:return F.read(t(F));case l.Array:{const $=t(F),q=[];for(let G=0;G<$;G++)q.push(p(F));return q}case l.Object:return JSON.parse(F.read(t(F)).toString())}}class f{constructor(M,$,q=null,G=1e3){this.protocol=M,this.ctx=$,this.logger=q,this.timeoutDelay=G,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(le=>this.onRawMessage(le)),this.sendResponse({type:200})}registerChannel(M,$){this.channels.set(M,$),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const $=this.send([M.type]);this.logger&&this.logger.logOutgoing($,0,1,S(M.type));return}case 201:case 202:case 204:case 203:{const $=this.send([M.type,M.id],M.data);this.logger&&this.logger.logOutgoing($,M.id,1,S(M.type),M.data);return}}}send(M,$=void 0){const q=new d;return o(q,M),o(q,$),this.sendBuffer(q.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch($){return 0}}onRawMessage(M){const $=new E(M),q=p($),G=p($),le=q[0];switch(le){case 100:return this.logger&&this.logger.logIncoming(M.byteLength,q[1],1,`${a(le)}: ${q[2]}.${q[3]}`,G),this.onPromise({type:le,id:q[1],channelName:q[2],name:q[3],arg:G});case 102:return this.logger&&this.logger.logIncoming(M.byteLength,q[1],1,`${a(le)}: ${q[2]}.${q[3]}`,G),this.onEventListen({type:le,id:q[1],channelName:q[2],name:q[3],arg:G});case 101:return this.logger&&this.logger.logIncoming(M.byteLength,q[1],1,`${a(le)}`),this.disposeActiveRequest({type:le,id:q[1]});case 103:return this.logger&&this.logger.logIncoming(M.byteLength,q[1],1,`${a(le)}`),this.disposeActiveRequest({type:le,id:q[1]})}}onPromise(M){const $=this.channels.get(M.channelName);if(!$){this.collectPendingRequest(M);return}const q=new A.CancellationTokenSource;let G;try{G=$.call(this.ctx,M.name,M.arg,q.token)}catch(Re){G=Promise.reject(Re)}const le=M.id;G.then(Re=>{this.sendResponse({id:le,data:Re,type:201}),this.activeRequests.delete(M.id)},Re=>{Re instanceof Error?this.sendResponse({id:le,data:{message:Re.message,name:Re.name,stack:Re.stack?Re.stack.split?Re.stack.split(`
`):Re.stack:void 0},type:202}):this.sendResponse({id:le,data:Re,type:203}),this.activeRequests.delete(M.id)});const ve=(0,T.toDisposable)(()=>q.cancel());this.activeRequests.set(M.id,ve)}onEventListen(M){const $=this.channels.get(M.channelName);if(!$){this.collectPendingRequest(M);return}const q=M.id,le=$.listen(this.ctx,M.name,M.arg)(ve=>this.sendResponse({id:q,data:ve,type:204}));this.activeRequests.set(M.id,le)}disposeActiveRequest(M){const $=this.activeRequests.get(M.id);$&&($.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let $=this.pendingRequests.get(M.channelName);$||($=[],this.pendingRequests.set(M.channelName,$));const q=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);$.push({request:M,timeoutTimer:q})}flushPendingRequests(M){const $=this.pendingRequests.get(M);if($){for(const q of $)switch(clearTimeout(q.timeoutTimer),q.request.type){case 100:this.onPromise(q.request);break;case 102:this.onEventListen(q.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var _;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(_=e.RequestInitiator||(e.RequestInitiator={}));class u{constructor(M,$=null){this.protocol=M,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(q=>this.onBuffer(q)),this.logger=$}getChannel(M){const $=this;return{call(q,G,le){return $.isDisposed?Promise.reject(y.canceled()):$.requestPromise(M,q,G,le)},listen(q,G){return $.isDisposed?Promise.reject(y.canceled()):$.requestEvent(M,q,G)}}}requestPromise(M,$,q,G=A.CancellationToken.None){const le=this.lastRequestId++,Re={id:le,type:100,channelName:M,name:$,arg:q};if(G.isCancellationRequested)return Promise.reject(y.canceled());let Se;return new Promise((V,X)=>{if(G.isCancellationRequested)return X(y.canceled());const Z=()=>{const Be=pe=>{switch(pe.type){case 201:this.handlers.delete(le),V(pe.data);break;case 202:this.handlers.delete(le);const Ce=new Error(pe.data.message);Ce.stack=pe.data.stack,Ce.name=pe.data.name,X(Ce);break;case 203:this.handlers.delete(le),X(pe.data);break}};this.handlers.set(le,Be),this.sendRequest(Re)};let se=null;this.state===w.Idle?Z():(se=(0,C.createCancelablePromise)(Be=>this.whenInitialized()),se.then(()=>{se=null,Z()}));const fe=()=>{se?(se.cancel(),se=null):this.sendRequest({id:le,type:101}),X(y.canceled())},Ee=G.onCancellationRequested(fe);Se=(0,T.combinedDisposable)((0,T.toDisposable)(fe),Ee),this.activeRequests.add(Se)}).finally(()=>{this.activeRequests.delete(Se)})}requestEvent(M,$,q){const G=this.lastRequestId++,ve={id:G,type:102,channelName:M,name:$,arg:q};let Re=null;const Se=new b.Emitter({onFirstListenerAdd:()=>{Re=(0,C.createCancelablePromise)(V=>this.whenInitialized()),Re.then(()=>{Re=null,this.activeRequests.add(Se),this.sendRequest(ve)})},onLastListenerRemove:()=>{Re?(Re.cancel(),Re=null):(this.activeRequests.delete(Se),this.sendRequest({id:G,type:103}))}}),Oe=V=>Se.fire(V.data);return this.handlers.set(G,Oe),Se.event}sendRequest(M){switch(M.type){case 100:case 102:{const $=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger&&this.logger.logOutgoing($,M.id,0,`${a(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const $=this.send([M.type,M.id]);this.logger&&this.logger.logOutgoing($,M.id,0,a(M.type));return}}}send(M,$=void 0){const q=new d;return o(q,M),o(q,$),this.sendBuffer(q.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch($){return 0}}onBuffer(M){const $=new E(M),q=p($),G=p($),le=q[0];switch(le){case 200:return this.logger&&this.logger.logIncoming(M.byteLength,0,0,S(le)),this.onResponse({type:q[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(M.byteLength,q[1],0,S(le),G),this.onResponse({type:q[0],id:q[1],data:G})}}onResponse(M){if(M.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const $=this.handlers.get(M.id);$&&$(M)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}qe([m.memoize],u.prototype,"onDidInitializePromise",null),e.ChannelClient=u;class v{constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:$,onDidClientDisconnect:q})=>{b.Event.once($.onMessage)(le=>{const ve=new E(le),Re=p(ve),Se=new f($,Re),Oe=new u($);this.channels.forEach((X,Z)=>Se.registerChannel(Z,X));const V={channelServer:Se,channelClient:Oe,ctx:Re};this._connections.add(V),this._onDidAddConnection.fire(V),q(()=>{Se.dispose(),Oe.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const M=[];return this._connections.forEach($=>M.push($)),M}getChannel(M,$){const q=this;return{call(G,le,ve){let Re;if((0,P.isFunction)($)){let Oe=(0,D.getRandomElement)(q.connections.filter($));Re=Oe?Promise.resolve(Oe):b.Event.toPromise(b.Event.filter(q.onDidAddConnection,$))}else Re=$.routeCall(q,G,le);const Se=Re.then(Oe=>Oe.channelClient.getChannel(M));return O(Se).call(G,le,ve)},listen(G,le){if((0,P.isFunction)($))return q.getMulticastEvent(M,$,G,le);const ve=$.routeEvent(q,G,le).then(Re=>Re.channelClient.getChannel(M));return O(ve).listen(G,le)}}}getMulticastEvent(M,$,q,G){const le=this;let ve=new T.DisposableStore;const Re=new b.Emitter({onFirstListenerAdd:()=>{ve=new T.DisposableStore;const Se=new b.EventMultiplexer,Oe=new Map,V=Z=>{const fe=Z.channelClient.getChannel(M).listen(q,G),Ee=Se.add(fe);Oe.set(Z,Ee)},X=Z=>{const se=Oe.get(Z);!se||(se.dispose(),Oe.delete(Z))};le.connections.filter($).forEach(V),b.Event.filter(le.onDidAddConnection,$)(V,void 0,ve),le.onDidRemoveConnection(X,void 0,ve),Se.event(Re.fire,Re,ve),ve.add(Se)},onLastListenerRemove:()=>{ve.dispose()}});return Re.event}registerChannel(M,$){this.channels.set(M,$),this._connections.forEach(q=>{q.channelServer.registerChannel(M,$)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=v;class R{constructor(M,$,q=null){const G=new d;o(G,$),M.send(G.buffer),this.channelClient=new u(M,q),this.channelServer=new f(M,$,q)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,$){this.channelServer.registerChannel(M,$)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function O(F){return{call(M,$,q){return F.then(G=>G.call(M,$,q))},listen(M,$){const q=new b.Relay;return F.then(G=>q.input=G.listen(M,$)),q.event}}}e.getDelayedChannel=O;function H(F){let M=!1;return{call($,q,G){return M?F.call($,q,G):(0,C.timeout)(0).then(()=>M=!0).then(()=>F.call($,q,G))},listen($,q){if(M)return F.listen($,q);const G=new b.Relay;return(0,C.timeout)(0).then(()=>M=!0).then(()=>G.input=F.listen($,q)),G.event}}}e.getNextTickChannel=H;class ne{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const $ of M.connections)if(await Promise.resolve(this.fn($.ctx)))return Promise.resolve($);return await b.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=ne;var ie;(function(F){function M(G,le){const ve=G,Re=le&&le.disableMarshalling,Se=new Map;for(const Oe in ve)q(Oe)&&Se.set(Oe,b.Event.buffer(ve[Oe],!0));return new class{listen(Oe,V){const X=Se.get(V);if(X)return X;throw new Error(`Event not found: ${V}`)}call(Oe,V,X){const Z=ve[V];if(typeof Z=="function"){if(!Re&&Array.isArray(X))for(let se=0;se<X.length;se++)X[se]=(0,i.revive)(X[se]);return Z.apply(ve,X)}throw new Error(`Method not found: ${V}`)}}}F.fromService=M;function $(G,le){const ve=le&&le.disableMarshalling;return new Proxy({},{get(Re,Se){var Oe;if(typeof Se=="string")return((Oe=le==null?void 0:le.properties)===null||Oe===void 0?void 0:Oe.has(Se))?le.properties.get(Se):q(Se)?G.listen(Se):async function(...V){let X;le&&!(0,P.isUndefinedOrNull)(le.context)?X=[le.context,...V]:X=V;const Z=await G.call(Se,X);return ve?Z:(0,i.revive)(Z)};throw new Error(`Property not found: ${String(Se)}`)}})}F.toService=$;function q(G){return G[0]==="o"&&G[1]==="n"&&I.isUpperAsciiLetter(G.charCodeAt(2))}})(ie=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let M=F.toString();if(M!=="[object Object]")return M}return F}function x(F){return Array.isArray(F)?F.map(B):B(F)}function L(F,M,$,q,G,le,ve){ve=x(ve);const Re=U[G],Se=Re[q%Re.length];let Oe=[`%c[${F}]%c[${String(M).padStart(7," ")}]%c[len: ${String($).padStart(5," ")}]%c${String(q).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${Se}`];/\($/.test(le)?(Oe=Oe.concat(ve),Oe.push(")")):Oe.push(ve),console.log.apply(console,Oe)}e.logWithColors=L;class N{constructor(M,$){this._outgoingPrefix=M,this._incomingPrefix=$,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,$,q,G,le){this._totalOutgoing+=M,L(this._outgoingPrefix,this._totalOutgoing,M,$,q,G,le)}logIncoming(M,$,q,G,le){this._totalIncoming+=M,L(this._incomingPrefix,this._totalIncoming,M,$,q,G,le)}}e.IPCLogger=N}),define(me[108],ge([0,1,3,107,6,23,10,36]),function(K,e,b,T,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let D=null;function P(){return D||(D=A.VSBuffer.alloc(0)),D}class i{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,r){if(s===0)return P();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const _=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=s),_}if(this._chunks[0].byteLength>s){const _=this._chunks[0].slice(0,s);return r&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),_}let o=A.VSBuffer.alloc(s),p=0,f=0;for(;s>0;){const _=this._chunks[f];if(_.byteLength>s){const u=_.slice(0,s);o.set(u,p),p+=s,r&&(this._chunks[f]=_.slice(s),this._totalLength-=s),s-=s}else o.set(_,p),p+=_.byteLength,r?(this._chunks.shift(),this._totalLength-=_.byteLength):f++,s-=_.byteLength}return o}}e.ChunkStream=i;var I;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(I||(I={}));var m;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(s,r,o,p){this.type=s,this.id=r,this.ack=o,this.data=p,this.writtenTime=0}get size(){return this.data.byteLength}}class a extends C.Disposable{constructor(s){super();this._onMessage=this._register(new b.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new i,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5);else{const o=this._state.messageType,p=this._state.id,f=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new g(o,p,f,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class h{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(!this._isDisposed){s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=A.VSBuffer.alloc(13);r.writeUInt8(s.type,0),r.writeUInt32BE(s.id,1),r.writeUInt32BE(s.ack,5),r.writeUInt32BE(s.data.byteLength,9),this._writeSoon(r,s.data)}}_bufferAdd(s,r){const o=this._totalLength===0;return this._data.push(s,r),this._totalLength+=s.byteLength+r.byteLength,o}_bufferTake(){const s=A.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,r){this._bufferAdd(s,r)&&y.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends C.Disposable{constructor(s){super();this._onMessage=new b.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new b.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new h(this._socket)),this._socketReader=this._register(new a(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new g(1,0,0,s))}}e.Protocol=S;class w extends T.IPCClient{constructor(s,r,o=null){super(s,r,o);this.protocol=s}static fromSocket(s,r){return new w(new S(s),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=w;class E{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new b.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,k.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=E;class d{constructor(s){this.data=s,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],r=0,o=this._first;for(;o;)s[r++]=o.data,o=o.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const r=new d(s);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class c{constructor(){this.lastRuns=[];const s=Date.now();for(let r=0;r<c._HISTORY_LENGTH;r++)this.lastRuns[r]=s-1e3*r;setInterval(()=>{for(let r=c._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return c._INSTANCE||(c._INSTANCE=new c),c._INSTANCE}load(){const s=Date.now(),r=(1+c._HISTORY_LENGTH)*1e3;let o=0;for(let p=0;p<c._HISTORY_LENGTH;p++)s-this.lastRuns[p]<=r&&o++;return 1-o/c._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}c._HISTORY_LENGTH=10,c._INSTANCE=null;class t{constructor(s,r=null){this._loadEstimator=c.getInstance(),this._onControlMessage=new E,this.onControlMessage=this._onControlMessage.event,this._onMessage=new E,this.onMessage=this._onMessage.event,this._onDidDispose=new E,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new E,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new E,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),r&&this._socketReader.acceptChunk(r),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,C.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new g(5,0,0,P());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const r=new g(4,0,0,P());this._socketWriter.write(r),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,r){this._isReconnecting=!0,this._socketDisposables=(0,C.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new a(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let r=0,o=s.length;r<o;r++)this._socketWriter.write(s[r]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new g(6,0,0,P())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const r=this._outgoingUnackMsg.toArray();for(let o=0,p=r.length;o<p;o++)this._socketWriter.write(r[o]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new g(1,r,this._incomingAckId,s);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(s){const r=new g(2,0,0,s);this._socketWriter.write(r)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const s=this._outgoingUnackMsg.peek(),r=Date.now()-s.writtenTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-r,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const s=new g(3,0,this._incomingAckId,P());this._socketWriter.write(s)}}}e.PersistentProtocol=t}),define(me[109],ge([0,1,98]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class T{constructor(k){let D=(0,b.toUint8)(k);this._defaultValue=D,this._asciiMap=T._createAsciiMap(D),this._map=new Map}static _createAsciiMap(k){let D=new Uint8Array(256);for(let P=0;P<256;P++)D[P]=k;return D}set(k,D){let P=(0,b.toUint8)(D);k>=0&&k<256?this._asciiMap[k]=P:this._map.set(k,P)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=T;var C;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(C||(C={}));class A{constructor(){this._actual=new T(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=A}),define(me[139],ge([0,1,109]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var T;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(T=e.WordCharacterClass||(e.WordCharacterClass={}));class C extends b.CharacterClassifier{constructor(k){super(0);for(let D=0,P=k.length;D<P;D++)this.set(k.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=C;function A(y){let k={};return D=>(k.hasOwnProperty(D)||(k[D]=y(D)),k[D])}e.getMapForWordSeparators=A(y=>new C(y))}),define(me[50],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class b{constructor(C,A){this.lineNumber=C,this.column=A}with(C=this.lineNumber,A=this.column){return C===this.lineNumber&&A===this.column?this:new b(C,A)}delta(C=0,A=0){return this.with(this.lineNumber+C,this.column+A)}equals(C){return b.equals(this,C)}static equals(C,A){return!C&&!A?!0:!!C&&!!A&&C.lineNumber===A.lineNumber&&C.column===A.column}isBefore(C){return b.isBefore(this,C)}static isBefore(C,A){return C.lineNumber<A.lineNumber?!0:A.lineNumber<C.lineNumber?!1:C.column<A.column}isBeforeOrEqual(C){return b.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,A){return C.lineNumber<A.lineNumber?!0:A.lineNumber<C.lineNumber?!1:C.column<=A.column}static compare(C,A){let y=C.lineNumber|0,k=A.lineNumber|0;if(y===k){let D=C.column|0,P=A.column|0;return D-P}return y-k}clone(){return new b(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new b(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=b}),define(me[44],ge([0,1,50]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class T{constructor(A,y,k,D){A>k||A===k&&y>D?(this.startLineNumber=k,this.startColumn=D,this.endLineNumber=A,this.endColumn=y):(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=k,this.endColumn=D)}isEmpty(){return T.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return T.containsPosition(this,A)}static containsPosition(A,y){return!(y.lineNumber<A.startLineNumber||y.lineNumber>A.endLineNumber||y.lineNumber===A.startLineNumber&&y.column<A.startColumn||y.lineNumber===A.endLineNumber&&y.column>A.endColumn)}containsRange(A){return T.containsRange(this,A)}static containsRange(A,y){return!(y.startLineNumber<A.startLineNumber||y.endLineNumber<A.startLineNumber||y.startLineNumber>A.endLineNumber||y.endLineNumber>A.endLineNumber||y.startLineNumber===A.startLineNumber&&y.startColumn<A.startColumn||y.endLineNumber===A.endLineNumber&&y.endColumn>A.endColumn)}strictContainsRange(A){return T.strictContainsRange(this,A)}static strictContainsRange(A,y){return!(y.startLineNumber<A.startLineNumber||y.endLineNumber<A.startLineNumber||y.startLineNumber>A.endLineNumber||y.endLineNumber>A.endLineNumber||y.startLineNumber===A.startLineNumber&&y.startColumn<=A.startColumn||y.endLineNumber===A.endLineNumber&&y.endColumn>=A.endColumn)}plusRange(A){return T.plusRange(this,A)}static plusRange(A,y){let k,D,P,i;return y.startLineNumber<A.startLineNumber?(k=y.startLineNumber,D=y.startColumn):y.startLineNumber===A.startLineNumber?(k=y.startLineNumber,D=Math.min(y.startColumn,A.startColumn)):(k=A.startLineNumber,D=A.startColumn),y.endLineNumber>A.endLineNumber?(P=y.endLineNumber,i=y.endColumn):y.endLineNumber===A.endLineNumber?(P=y.endLineNumber,i=Math.max(y.endColumn,A.endColumn)):(P=A.endLineNumber,i=A.endColumn),new T(k,D,P,i)}intersectRanges(A){return T.intersectRanges(this,A)}static intersectRanges(A,y){let k=A.startLineNumber,D=A.startColumn,P=A.endLineNumber,i=A.endColumn,I=y.startLineNumber,m=y.startColumn,g=y.endLineNumber,a=y.endColumn;return k<I?(k=I,D=m):k===I&&(D=Math.max(D,m)),P>g?(P=g,i=a):P===g&&(i=Math.min(i,a)),k>P||k===P&&D>i?null:new T(k,D,P,i)}equalsRange(A){return T.equalsRange(this,A)}static equalsRange(A,y){return!!A&&!!y&&A.startLineNumber===y.startLineNumber&&A.startColumn===y.startColumn&&A.endLineNumber===y.endLineNumber&&A.endColumn===y.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(A){return new b.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(A){return new b.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,y){return new T(this.startLineNumber,this.startColumn,A,y)}setStartPosition(A,y){return new T(A,y,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(A){return new T(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,y=A){return new T(A.lineNumber,A.column,y.lineNumber,y.column)}static lift(A){return A?new T(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,y){return!(A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<y.startColumn||y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<A.startColumn)}static areIntersecting(A,y){return!(A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<=y.startColumn||y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,y){if(A&&y){const P=A.startLineNumber|0,i=y.startLineNumber|0;if(P===i){const I=A.startColumn|0,m=y.startColumn|0;if(I===m){const g=A.endLineNumber|0,a=y.endLineNumber|0;if(g===a){const h=A.endColumn|0,S=y.endColumn|0;return h-S}return g-a}return I-m}return P-i}return(A?1:0)-(y?1:0)}static compareRangesUsingEnds(A,y){return A.endLineNumber===y.endLineNumber?A.endColumn===y.endColumn?A.startLineNumber===y.startLineNumber?A.startColumn-y.startColumn:A.startLineNumber-y.startLineNumber:A.endColumn-y.endColumn:A.endLineNumber-y.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}}e.Range=T}),define(me[140],ge([0,1,50,44]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var C;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(C=e.SelectionDirection||(e.SelectionDirection={}));class A extends T.Range{constructor(k,D,P,i){super(k,D,P,i);this.selectionStartLineNumber=k,this.selectionStartColumn=D,this.positionLineNumber=P,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return A.selectionsEqual(this,k)}static selectionsEqual(k,D){return k.selectionStartLineNumber===D.selectionStartLineNumber&&k.selectionStartColumn===D.selectionStartColumn&&k.positionLineNumber===D.positionLineNumber&&k.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,D){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,k,D):new A(k,D,this.startLineNumber,this.startColumn)}getPosition(){return new b.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(k,D){return this.getDirection()===0?new A(k,D,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,k,D)}static fromPositions(k,D=k){return new A(k.lineNumber,k.column,D.lineNumber,D.column)}static liftSelection(k){return new A(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,D){if(k&&!D||!k&&D)return!1;if(!k&&!D)return!0;if(k.length!==D.length)return!1;for(let P=0,i=k.length;P<i;P++)if(!this.selectionsEqual(k[P],D[P]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,D,P,i,I){return I===0?new A(k,D,P,i):new A(P,i,k,D)}}e.Selection=A}),define(me[110],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var b;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=4]="Right",a[a.Full=7]="Full"})(b=e.OverviewRulerLane||(e.OverviewRulerLane={}));var T;(function(a){a[a.Inline=1]="Inline",a[a.Gutter=2]="Gutter"})(T=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(a){a[a.TextDefined=0]="TextDefined",a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(a){a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(a){a[a.LF=0]="LF",a[a.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class k{constructor(h){this.tabSize=Math.max(1,h.tabSize|0),this.indentSize=h.tabSize|0,this.insertSpaces=Boolean(h.insertSpaces),this.defaultEOL=h.defaultEOL|0,this.trimAutoWhitespace=Boolean(h.trimAutoWhitespace)}equals(h){return this.tabSize===h.tabSize&&this.indentSize===h.indentSize&&this.insertSpaces===h.insertSpaces&&this.defaultEOL===h.defaultEOL&&this.trimAutoWhitespace===h.trimAutoWhitespace}createChangeEvent(h){return{tabSize:this.tabSize!==h.tabSize,indentSize:this.indentSize!==h.indentSize,insertSpaces:this.insertSpaces!==h.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==h.trimAutoWhitespace}}}e.TextModelResolvedOptions=k;class D{constructor(h,S){this.range=h,this.matches=S}}e.FindMatch=D;var P;(function(a){a[a.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",a[a.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",a[a.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",a[a.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(a){a[a.Left=0]="Left",a[a.Right=1]="Right"})(i=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var I;(function(a){a[a.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class m{constructor(h,S,w,E,d,l){this.identifier=h,this.range=S,this.text=w,this.forceMoveMarkers=E,this.isAutoWhitespaceEdit=d,this._isTracked=l}}e.ValidAnnotatedEditOperation=m;class g{constructor(h,S,w){this.reverseEdits=h,this.changes=S,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=g}),define(me[141],ge([0,1,9,139,50,44,110]),function(K,e,b,T,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class D{constructor(d,l,c,t){this.searchString=d,this.isRegex=l,this.matchCase=c,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let d;this.isRegex?d=P(this.searchString):d=this.searchString.indexOf(`
`)>=0;let l=null;try{l=b.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:d,global:!0,unicode:!0})}catch(t){return null}if(!l)return null;let c=!this.isRegex&&!d;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new i(l,this.wordSeparators?(0,T.getMapForWordSeparators)(this.wordSeparators):null,c?this.searchString:null)}}e.SearchParams=D;function P(E){if(!E||E.length===0)return!1;for(let d=0,l=E.length;d<l;d++)if(E.charCodeAt(d)===92){if(d++,d>=l)break;const t=E.charCodeAt(d);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=P;class i{constructor(d,l,c){this.regex=d,this.wordSeparators=l,this.simpleSearch=c}}e.SearchData=i;function I(E,d,l){if(!l)return new y.FindMatch(E,null);let c=[];for(let t=0,n=d.length;t<n;t++)c[t]=d[t];return new y.FindMatch(E,c)}e.createFindMatch=I;class m{constructor(d){let l=[],c=0;for(let t=0,n=d.length;t<n;t++)d.charCodeAt(t)===10&&(l[c++]=t);this._lineFeedsOffsets=l}findLineFeedCountBeforeOffset(d){const l=this._lineFeedsOffsets;let c=0,t=l.length-1;if(t===-1||d<=l[0])return 0;for(;c<t;){const n=c+((t-c)/2>>0);l[n]>=d?t=n-1:l[n+1]>=d?(c=n,t=n):c=n+1}return c+1}}class g{static findMatches(d,l,c,t,n){const s=l.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(d,c,new w(s.wordSeparators,s.regex),t,n):this._doFindMatchesLineByLine(d,c,s,t,n):[]}static _getMultilineMatchRange(d,l,c,t,n,s){let r,o=0;t?(o=t.findLineFeedCountBeforeOffset(n),r=l+n+o):r=l+n;let p;if(t){let v=t.findLineFeedCountBeforeOffset(n+s.length)-o;p=r+s.length+v}else p=r+s.length;const f=d.getPositionAt(r),_=d.getPositionAt(p);return new A.Range(f.lineNumber,f.column,_.lineNumber,_.column)}static _doFindMatchesMultiline(d,l,c,t,n){const s=d.getOffsetAt(l.getStartPosition()),r=d.getValueInRange(l,1),o=d.getEOL()===`\r
`?new m(r):null,p=[];let f=0,_;for(c.reset(0);_=c.next(r);)if(p[f++]=I(this._getMultilineMatchRange(d,s,r,o,_.index,_[0]),_,t),f>=n)return p;return p}static _doFindMatchesLineByLine(d,l,c,t,n){const s=[];let r=0;if(l.startLineNumber===l.endLineNumber){const p=d.getLineContent(l.startLineNumber).substring(l.startColumn-1,l.endColumn-1);return r=this._findMatchesInLine(c,p,l.startLineNumber,l.startColumn-1,r,s,t,n),s}const o=d.getLineContent(l.startLineNumber).substring(l.startColumn-1);r=this._findMatchesInLine(c,o,l.startLineNumber,l.startColumn-1,r,s,t,n);for(let p=l.startLineNumber+1;p<l.endLineNumber&&r<n;p++)r=this._findMatchesInLine(c,d.getLineContent(p),p,0,r,s,t,n);if(r<n){const p=d.getLineContent(l.endLineNumber).substring(0,l.endColumn-1);r=this._findMatchesInLine(c,p,l.endLineNumber,0,r,s,t,n)}return s}static _findMatchesInLine(d,l,c,t,n,s,r,o){const p=d.wordSeparators;if(!r&&d.simpleSearch){const u=d.simpleSearch,v=u.length,R=l.length;let O=-v;for(;(O=l.indexOf(u,O+v))!==-1;)if((!p||S(p,l,R,O,v))&&(s[n++]=new y.FindMatch(new A.Range(c,O+1+t,c,O+1+v+t),null),n>=o))return n;return n}const f=new w(d.wordSeparators,d.regex);let _;f.reset(0);do if(_=f.next(l),_&&(s[n++]=I(new A.Range(c,_.index+1+t,c,_.index+1+_[0].length+t),_,r),n>=o))return n;while(_);return n}static findNextMatch(d,l,c,t){const n=l.parseSearchRequest();if(!n)return null;const s=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(d,c,s,t):this._doFindNextMatchLineByLine(d,c,s,t)}static _doFindNextMatchMultiline(d,l,c,t){const n=new C.Position(l.lineNumber,1),s=d.getOffsetAt(n),r=d.getLineCount(),o=d.getValueInRange(new A.Range(n.lineNumber,n.column,r,d.getLineMaxColumn(r)),1),p=d.getEOL()===`\r
`?new m(o):null;c.reset(l.column-1);let f=c.next(o);return f?I(this._getMultilineMatchRange(d,s,o,p,f.index,f[0]),f,t):l.lineNumber!==1||l.column!==1?this._doFindNextMatchMultiline(d,new C.Position(1,1),c,t):null}static _doFindNextMatchLineByLine(d,l,c,t){const n=d.getLineCount(),s=l.lineNumber,r=d.getLineContent(s),o=this._findFirstMatchInLine(c,r,s,l.column,t);if(o)return o;for(let p=1;p<=n;p++){const f=(s+p-1)%n,_=d.getLineContent(f+1),u=this._findFirstMatchInLine(c,_,f+1,1,t);if(u)return u}return null}static _findFirstMatchInLine(d,l,c,t,n){d.reset(t-1);const s=d.next(l);return s?I(new A.Range(c,s.index+1,c,s.index+1+s[0].length),s,n):null}static findPreviousMatch(d,l,c,t){const n=l.parseSearchRequest();if(!n)return null;const s=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(d,c,s,t):this._doFindPreviousMatchLineByLine(d,c,s,t)}static _doFindPreviousMatchMultiline(d,l,c,t){const n=this._doFindMatchesMultiline(d,new A.Range(1,1,l.lineNumber,l.column),c,t,10*k);if(n.length>0)return n[n.length-1];const s=d.getLineCount();return l.lineNumber!==s||l.column!==d.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(d,new C.Position(s,d.getLineMaxColumn(s)),c,t):null}static _doFindPreviousMatchLineByLine(d,l,c,t){const n=d.getLineCount(),s=l.lineNumber,r=d.getLineContent(s).substring(0,l.column-1),o=this._findLastMatchInLine(c,r,s,t);if(o)return o;for(let p=1;p<=n;p++){const f=(n+s-p-1)%n,_=d.getLineContent(f+1),u=this._findLastMatchInLine(c,_,f+1,t);if(u)return u}return null}static _findLastMatchInLine(d,l,c,t){let n=null,s;for(d.reset(0);s=d.next(l);)n=I(new A.Range(c,s.index+1,c,s.index+1+s[0].length),s,t);return n}}e.TextModelSearch=g;function a(E,d,l,c,t){if(c===0)return!0;const n=d.charCodeAt(c-1);if(E.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=d.charCodeAt(c);if(E.get(s)!==0)return!0}return!1}function h(E,d,l,c,t){if(c+t===l)return!0;const n=d.charCodeAt(c+t);if(E.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=d.charCodeAt(c+t-1);if(E.get(s)!==0)return!0}return!1}function S(E,d,l,c,t){return a(E,d,l,c,t)&&h(E,d,l,c,t)}e.isValidMatch=S;class w{constructor(d,l){this._wordSeparators=d,this._searchRegex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(d){this._searchRegex.lastIndex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(d){const l=d.length;let c;do{if(this._prevMatchStartIndex+this._prevMatchLength===l||(c=this._searchRegex.exec(d),!c))return null;const t=c.index,n=c[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){b.getNextCodePoint(d,l,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||S(this._wordSeparators,d,l,t,n))return c}while(c);return null}}e.Searcher=w}),define(me[111],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function b(k=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)k.indexOf(P)>=0||(D+="\\"+P);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=b();function T(k){let D=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)D=k;else{let P="g";k.ignoreCase&&(P+="i"),k.multiline&&(P+="m"),k.unicode&&(P+="u"),D=new RegExp(k.source,P)}return D.lastIndex=0,D}e.ensureValidWordDefinition=T;const C={maxLen:1e3,windowSize:15,timeBudget:150};function A(k,D,P,i,I=C){if(P.length>I.maxLen){let S=k-I.maxLen/2;return S<0?S=0:i+=S,P=P.substring(S,k+I.maxLen/2),A(k,D,P,i,I)}const m=Date.now(),g=k-1-i;let a=-1,h=null;for(let S=1;!(Date.now()-m>=I.timeBudget);S++){const w=g-I.windowSize*S;D.lastIndex=Math.max(0,w);const E=y(D,P,g,a);if(!E&&h||(h=E,w<=0))break;a=w}if(h){let S={word:h[0],startColumn:i+1+h.index,endColumn:i+1+h.index+h[0].length};return D.lastIndex=0,S}return null}e.getWordAtText=A;function y(k,D,P,i){let I;for(;I=k.exec(D);){const m=I.index||0;if(m<=P&&k.lastIndex>=P)return I;if(i>0&&m>i)return null}return null}}),define(me[142],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var b;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(b=e.IndentAction||(e.IndentAction={}));class T{constructor(k){if(this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let D=0,P=k.notIn.length;D<P;D++)switch(k.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=T;class C{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of k)A(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),A(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),A(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),A(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&A(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=C;function A(y,k,D){y.has(k)?y.get(k).push(D):y.set(k,[D])}}),define(me[78],ge([0,1,33,8]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(A,y,k,D){if(Array.isArray(A)){let P=0;for(const i of A){const I=C(i,y,k,D);if(I===10)return I;I>P&&(P=I)}return P}else{if(typeof A=="string")return D?A==="*"?5:A===k?10:0:0;if(A){const{language:P,pattern:i,scheme:I,hasAccessToAllModels:m}=A;if(!D&&!m)return 0;let g=0;if(I)if(I===y.scheme)g=10;else if(I==="*")g=5;else return 0;if(P)if(P===k)g=10;else if(P==="*")g=Math.max(g,5);else return 0;if(i){let a;if(typeof i=="string"?a=i:a=Object.assign(Object.assign({},i),{base:(0,T.normalize)(i.base)}),a===y.fsPath||(0,b.match)(a,y.fsPath))g=10;else return 0}return g}else return 0}}e.score=C}),define(me[143],ge([0,1,109]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var T;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(T=e.State||(e.State={}));class C{constructor(a,h,S){const w=new Uint8Array(a*h);for(let E=0,d=a*h;E<d;E++)w[E]=S;this._data=w,this.rows=a,this.cols=h}get(a,h){return this._data[a*this.cols+h]}set(a,h,S){this._data[a*this.cols+h]=S}}e.Uint8Matrix=C;class A{constructor(a){let h=0,S=0;for(let E=0,d=a.length;E<d;E++){let[l,c,t]=a[E];c>h&&(h=c),l>S&&(S=l),t>S&&(S=t)}h++,S++;let w=new C(S,h,0);for(let E=0,d=a.length;E<d;E++){let[l,c,t]=a[E];w.set(l,c,t)}this._states=w,this._maxCharCode=h}nextState(a,h){return h<0||h>=this._maxCharCode?0:this._states.get(a,h)}}e.StateMachine=A;let y=null;function k(){return y===null&&(y=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var D;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let P=null;function i(){if(P===null){P=new b.CharacterClassifier(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<g.length;h++)P.set(g.charCodeAt(h),1);const a=".,;";for(let h=0;h<a.length;h++)P.set(a.charCodeAt(h),2)}return P}class I{static _createLink(a,h,S,w,E){let d=E-1;do{const l=h.charCodeAt(d);if(a.get(l)!==2)break;d--}while(d>w);if(w>0){const l=h.charCodeAt(w-1),c=h.charCodeAt(d);(l===40&&c===41||l===91&&c===93||l===123&&c===125)&&d--}return{range:{startLineNumber:S,startColumn:w+1,endLineNumber:S,endColumn:d+2},url:h.substring(w,d+1)}}static computeLinks(a,h=k()){const S=i();let w=[];for(let E=1,d=a.getLineCount();E<=d;E++){const l=a.getLineContent(E),c=l.length;let t=0,n=0,s=0,r=1,o=!1,p=!1,f=!1,_=!1;for(;t<c;){let u=!1;const v=l.charCodeAt(t);if(r===13){let R;switch(v){case 40:o=!0,R=0;break;case 41:R=o?0:1;break;case 91:f=!0,p=!0,R=0;break;case 93:f=!1,R=p?0:1;break;case 123:_=!0,R=0;break;case 125:R=_?0:1;break;case 39:R=s===34||s===96?0:1;break;case 34:R=s===39||s===96?0:1;break;case 96:R=s===39||s===34?0:1;break;case 42:R=s===42?1:0;break;case 124:R=s===124?1:0;break;case 32:R=f?0:1;break;default:R=S.get(v)}R===1&&(w.push(I._createLink(S,l,E,n,t)),u=!0)}else if(r===12){let R;v===91?(p=!0,R=0):R=S.get(v),R===1?u=!0:r=13}else r=h.nextState(r,v),r===0&&(u=!0);u&&(r=1,o=!1,p=!1,_=!1,n=t+1,s=v),t++}r===13&&w.push(I._createLink(S,l,E,n,c))}return w}}e.LinkComputer=I;function m(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:I.computeLinks(g)}e.computeLinks=m}),define(me[144],ge([0,1,3,6]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class C{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new b.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,k){return this._map.set(y,k),this.fire([y]),(0,T.toDisposable)(()=>{this._map.get(y)===k&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,k){let D=null,P=!1;return this._promises.set(y,k.then(i=>{this._promises.delete(y),!(P||!i)&&(D=this.register(y,i))})),(0,T.toDisposable)(()=>{P=!0,D&&D.dispose()})}getPromise(y){const k=this.get(y);if(k)return Promise.resolve(k);const D=this._promises.get(y);return D?D.then(P=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=C}),define(me[112],ge([0,1,23,10]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(C||(C={}));function A(I){for(let m=0,g=I.length;m<g;m+=4){const a=I[m+0],h=I[m+1],S=I[m+2],w=I[m+3];I[m+0]=w,I[m+1]=S,I[m+2]=h,I[m+3]=a}}function y(I){const m=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return T.isLittleEndian()||A(m),b.VSBuffer.wrap(m)}function k(I){const m=I.buffer;if(T.isLittleEndian()||A(m),m.byteOffset%4==0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const g=new Uint8Array(m.byteLength);return g.set(m),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function D(I){const m=new Uint32Array(P(I));let g=0;if(m[g++]=I.id,I.type==="full")m[g++]=1,m[g++]=I.data.length,m.set(I.data,g),g+=I.data.length;else{m[g++]=2,m[g++]=I.deltas.length;for(const a of I.deltas)m[g++]=a.start,m[g++]=a.deleteCount,a.data?(m[g++]=a.data.length,m.set(a.data,g),g+=a.data.length):m[g++]=0}return y(m)}e.encodeSemanticTokensDto=D;function P(I){let m=0;if(m+=1+1,I.type==="full")m+=1+I.data.length;else{m+=1,m+=(1+1+1)*I.deltas.length;for(const g of I.deltas)g.data&&(m+=g.data.length)}return m}function i(I){const m=k(I);let g=0;const a=m[g++];if(m[g++]===1){const E=m[g++],d=m.subarray(g,g+E);return g+=E,{id:a,type:"full",data:d}}const S=m[g++];let w=[];for(let E=0;E<S;E++){const d=m[g++],l=m[g++],c=m[g++];let t;c>0&&(t=m.subarray(g,g+c),g+=c),w[E]={start:d,deleteCount:l,data:t}}return{id:a,type:"delta",deltas:w}}e.decodeSemanticTokensDto=i}),define(me[113],ge([0,1,98]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class T{constructor(y,k){this.index=y,this.remainder=k}}e.PrefixSumIndexOfResult=T;class C{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,k){y=(0,b.toUint32)(y);const D=this.values,P=this.prefixSum,i=k.length;return i===0?!1:(this.values=new Uint32Array(D.length+i),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y),y+i),this.values.set(k,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,k){return y=(0,b.toUint32)(y),k=(0,b.toUint32)(k),this.values[y]===k?!1:(this.values[y]=k,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,k){y=(0,b.toUint32)(y),k=(0,b.toUint32)(k);const D=this.values,P=this.prefixSum;if(y>=D.length)return!1;let i=D.length-y;return k>=i&&(k=i),k===0?!1:(this.values=new Uint32Array(D.length-k),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y+k),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,b.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let k=this.prefixSumValidIndex[0]+1;k===0&&(this.prefixSum[0]=this.values[0],k++),y>=this.values.length&&(y=this.values.length-1);for(let D=k;D<=y;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let k=0,D=this.values.length-1,P=0,i=0,I=0;for(;k<=D;)if(P=k+(D-k)/2|0,i=this.prefixSum[P],I=i-this.values[P],y<I)D=P-1;else if(y>=i)k=P+1;else break;return new T(P,y-I)}}e.PrefixSumComputer=C}),define(me[145],ge([0,1,9,50,113]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(k,D,P,i){this._uri=k,this._lines=D,this._eol=P,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const D=k.changes;for(const P of D)this._acceptDeleteRange(P.range),this._acceptInsertText(new T.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,D=this._lines.length,P=new Uint32Array(D);for(let i=0;i<D;i++)P[i]=this._lines[i].length+k;this._lineStarts=new C.PrefixSumComputer(P)}}_setLineText(k,D){this._lines[k]=D,this._lineStarts&&this._lineStarts.changeValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,D){if(D.length!==0){let P=(0,b.splitLines)(D);if(P.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+P[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}P[P.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+P[0]);let i=new Uint32Array(P.length-1);for(let I=1;I<P.length;I++)this._lines.splice(k.lineNumber+I-1,0,P[I]),i[I-1]=P[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,i)}}}e.MirrorTextModel=A}),define(me[146],ge([18,19]),function(K,e){return K.create("vs/base/common/date",e)}),define(me[147],ge([0,1,146]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,C=T*60,A=C*24,y=A*7,k=A*30,D=A*365;function P(I,m){typeof I!="number"&&(I=I.getTime());const g=Math.round((new Date().getTime()-I)/1e3);if(g<-30)return(0,b.localize)(0,null,P(new Date().getTime()+g*1e3,!1));if(g<30)return(0,b.localize)(1,null);let a;return g<T?(a=g,m?a===1?(0,b.localize)(2,null,a):(0,b.localize)(3,null,a):a===1?(0,b.localize)(4,null,a):(0,b.localize)(5,null,a)):g<C?(a=Math.floor(g/T),m?a===1?(0,b.localize)(6,null,a):(0,b.localize)(7,null,a):a===1?(0,b.localize)(8,null,a):(0,b.localize)(9,null,a)):g<A?(a=Math.floor(g/C),m?a===1?(0,b.localize)(10,null,a):(0,b.localize)(11,null,a):a===1?(0,b.localize)(12,null,a):(0,b.localize)(13,null,a)):g<y?(a=Math.floor(g/A),m?a===1?(0,b.localize)(14,null,a):(0,b.localize)(15,null,a):a===1?(0,b.localize)(16,null,a):(0,b.localize)(17,null,a)):g<k?(a=Math.floor(g/y),m?a===1?(0,b.localize)(18,null,a):(0,b.localize)(19,null,a):a===1?(0,b.localize)(20,null,a):(0,b.localize)(21,null,a)):g<D?(a=Math.floor(g/k),m?a===1?(0,b.localize)(22,null,a):(0,b.localize)(23,null,a):a===1?(0,b.localize)(24,null,a):(0,b.localize)(25,null,a)):(a=Math.floor(g/D),m?a===1?(0,b.localize)(26,null,a):(0,b.localize)(27,null,a):a===1?(0,b.localize)(28,null,a):(0,b.localize)(29,null,a))}e.fromNow=P;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(me[148],ge([18,19]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(me[61],ge([0,1,148,11,16]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(P,i){return i&&(P.stack||P.stacktrace)?b.localize(0,null,k(P),y(P.stack)||y(P.stacktrace)):k(P)}function y(P){return Array.isArray(P)?P.join(`
`):P}function k(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?b.localize(1,null,P.message):P.message||b.localize(2,null)}function D(P=null,i=!1){if(!P)return b.localize(3,null);if(Array.isArray(P)){const I=C.coalesce(P),m=D(I[0],i);return I.length>1?b.localize(4,null,m,I.length):m}if(T.isString(P))return P;if(P.detail){const I=P.detail;if(I.error)return A(I.error,i);if(I.exception)return A(I.exception,i)}return P.stack?A(P,i):P.message?P.message:b.localize(5,null)}e.toErrorMessage=D}),define(me[149],ge([18,19]),function(K,e){return K.create("vs/base/node/processes",e)}),define(me[79],ge([0,1,8,37,26,38,149,36,11,24,29,10,138,13]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function a(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(c,t){if(I.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};t&&(n.cwd=t);const s=A.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],n);return new Promise(r=>{s.once("error",o=>{r({success:!1,error:o})}),s.once("exit",(o,p)=>{r(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?a(n.status):1})}else if(I.isLinux||I.isMacintosh)try{const n=g.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(s=>{A.execFile(n,[c.pid.toString()],{encoding:"utf8",shell:!0},(r,o,p)=>{s(r?{success:!1,error:r}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function S(c=k.env){return c.comspec||"cmd.exe"}e.getWindowsShell=S;class w{constructor(t,n,s,r){if(n!==void 0&&s!==void 0&&r!==void 0)this.cmd=t,this.args=n,this.shell=s,this.options=r;else{const o=t;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(k.env).forEach(p=>{o[p]=k.env[p]}),Object.keys(this.options.env).forEach(p=>{o[p]=this.options.env[p]}),this.options.env=o}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const n=t.lastIndexOf(b.sep);return n!==-1&&(t=t.substring(n+1)),w.WellKnowCommands[t]?t:"other"}start(t){return I.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(k.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(n=>{let s,r;const o=new Promise((p,f)=>{s=p,r=f});if(n){let p=this.cmd;this.args&&(p=p+" "+this.args.join(" ")),this.childProcess=A.exec(p,this.options,(f,_,u)=>{this.childProcess=null;const v=f;v&&v.killed?r({killed:this.terminateRequested,stdout:_.toString(),stderr:u.toString()}):this.handleExec(s,t,f,_,u)})}else{let p=null;const f=_=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(_,s,t,r);const u={terminated:this.terminateRequested};D.isNumber(_)&&(u.cmdCode=_),s(u)};if(this.shell&&I.isWindows){const _=P.deepClone(this.options);_.windowsVerbatimArguments=!0,_.detached=!1;let u=!1,v=!1;const R=[];let O=this.ensureQuotes(this.cmd);R.push(O.value),u=O.quoted,this.args&&this.args.forEach(ne=>{O=this.ensureQuotes(ne),R.push(O.value),v=v&&O.quoted});const H=["/s","/c"];u?v?H.push('"'+R.join(" ")+'"'):R.length>1?H.push('"'+R[0]+'" '+R.slice(1).join(" ")):H.push('"'+R[0]+'"'):H.push(R.join(" ")),p=A.spawn(S(),H,_)}else this.cmd&&(p=A.spawn(this.cmd,this.args,this.options));p&&(this.childProcess=p,this.childProcessPromise=Promise.resolve(p),this.pidResolve&&(this.pidResolve(D.isNumber(p.pid)?p.pid:-1),this.pidResolve=void 0),p.on("error",_=>{this.childProcess=null,r({terminated:this.terminateRequested,error:_})}),p.pid&&(this.childProcess.on("close",f),this.handleSpawn(p,s,t,r,!0)))}return o})}handleClose(t,n,s,r){}ensureQuotes(t){return w.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,h(t,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!I.isWindows)return t(!1);const n=A.spawn(S(),["/s","/c"]);n.on("error",s=>t(!0)),n.on("exit",s=>t(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class E extends w{constructor(t,n,s,r){super(t,n,s,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,n,s,r,o){[r,o].forEach((p,f)=>{const _=new m.LineDecoder;_.write(p).forEach(R=>{n({line:R,source:f===0?0:1})});const v=_.end();v&&n({line:v,source:f===0?0:1})}),t({terminated:this.terminateRequested,error:s})}handleSpawn(t,n,s,r,o){const p=new m.LineDecoder,f=new m.LineDecoder;t.stdout.on("data",_=>{p.write(_).forEach(v=>s({line:v,source:0}))}),t.stderr.on("data",_=>{f.write(_).forEach(v=>s({line:v,source:1}))}),this.stdoutLineDecoder=p,this.stderrLineDecoder=f}handleClose(t,n,s,r){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&s({line:o,source:0});const p=this.stderrLineDecoder?this.stderrLineDecoder.end():null;p&&s({line:p,source:1})}}e.LineProcess=E;function d(c){let t=[],n=!1;const s=function(r){if(n){t.push(r);return}(!c.send(r,p=>{if(p&&console.error(p),n=!1,t.length>0){const f=t.slice(0);t=[],f.forEach(_=>s(_))}})||I.isWindows)&&(n=!0)};return{send:s}}e.createQueuedSender=d;var l;(function(c){async function t(n,s,r){if(b.isAbsolute(n))return n;if(s===void 0&&(s=k.cwd()),b.dirname(n)!=="."||(r===void 0&&D.isString(k.env.PATH)&&(r=k.env.PATH.split(b.delimiter)),r===void 0||r.length===0))return b.join(s,n);async function p(f){return await C.exists(f)?!(await T.promises.stat(f)).isDirectory():!1}for(let f of r){let _;if(b.isAbsolute(f)?_=b.join(f,n):_=b.join(s,f,n),await p(_))return _;let u=_+".com";if(await p(u)||(u=_+".exe",await p(u)))return u}return b.join(s,n)}c.findExecutable=t})(l=e.win32||(e.win32={}))}),define(me[150],ge([0,1,49,10,106,79]),function(K,e,b,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function y(g,a){return g===1?T.isWindows?I():A.getWindowsShell(a):P(g,a)}e.getSystemShell=y;function k(g,a){return g===1?T.isWindows?m(a):A.getWindowsShell(a):P(g,a)}e.getSystemShellSync=k;let D=null;function P(g,a){if(T.isLinux&&g===2||T.isMacintosh&&g===3)return"/bin/bash";if(!D){let h;if(T.isWindows)h="/bin/bash";else{if(h=a.SHELL,!h)try{h=(0,b.userInfo)().shell}catch(S){}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}D=h}return D}let i=null;async function I(){return i||(i=(await(0,C.getFirstAvailablePowerShellInstallation)()).exePath),i}function m(g){if(i)return i;const a=T.isWindows&&parseFloat((0,b.release)())>=10,h=g.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${g.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return a?S:A.getWindowsShell(g)}}),define(me[151],ge([18,19]),function(K,e){return K.create("vs/editor/common/config/editorOptions",e)}),define(me[152],ge([0,1,151,10,111]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=y;class k{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,we){this._values[te]=we}}e.ValidatedEditorOptions=k;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class P{constructor(te,we,xe,je){this.id=te,this.name=we,this.defaultValue=xe,this.schema=je}compute(te,we,xe){return xe}}class i{constructor(te,we=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=we}validate(te){return this.defaultValue}}class I{constructor(te,we,xe,je){this.id=te,this.name=we,this.defaultValue=xe,this.schema=je}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,we,xe){return xe}}function m(Q,te){return typeof Q=="undefined"?te:Q==="false"?!1:Boolean(Q)}e.boolean=m;class g extends I{constructor(te,we,xe,je=void 0){typeof je!="undefined"&&(je.type="boolean",je.default=xe),super(te,we,xe,je)}validate(te){return m(te,this.defaultValue)}}class a extends I{constructor(te,we,xe,je,Ve,Je=void 0){typeof Je!="undefined"&&(Je.type="integer",Je.default=xe,Je.minimum=je,Je.maximum=Ve),super(te,we,xe,Je),this.minimum=je,this.maximum=Ve}static clampedInt(te,we,xe,je){if(typeof te=="undefined")return we;let Ve=parseInt(te,10);return isNaN(Ve)?we:(Ve=Math.max(xe,Ve),Ve=Math.min(je,Ve),Ve|0)}validate(te){return a.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class h extends I{constructor(te,we,xe,je,Ve){typeof Ve!="undefined"&&(Ve.type="number",Ve.default=xe),super(te,we,xe,Ve),this.validationFn=je}static clamp(te,we,xe){return te<we?we:te>xe?xe:te}static float(te,we){if(typeof te=="number")return te;if(typeof te=="undefined")return we;const xe=parseFloat(te);return isNaN(xe)?we:xe}validate(te){return this.validationFn(h.float(te,this.defaultValue))}}class S extends I{static string(te,we){return typeof te!="string"?we:te}constructor(te,we,xe,je=void 0){typeof je!="undefined"&&(je.type="string",je.default=xe),super(te,we,xe,je)}validate(te){return S.string(te,this.defaultValue)}}function w(Q,te,we){return typeof Q!="string"||we.indexOf(Q)===-1?te:Q}e.stringSet=w;class E extends I{constructor(te,we,xe,je,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.enum=je,Ve.default=xe),super(te,we,xe,Ve),this._allowedValues=je}validate(te){return w(te,this.defaultValue,this._allowedValues)}}class d extends P{constructor(te,we,xe,je,Ve,Je,De=void 0){typeof De!="undefined"&&(De.type="string",De.enum=Ve,De.default=je),super(te,we,xe,De),this._allowedValues=Ve,this._convert=Je}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function l(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",description:b.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,we,xe){return xe===0?te.accessibilitySupport:xe}}class t extends P{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:b.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{insertSpace:m(we.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(we.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function o(Q){switch(Q){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=o;function p(Q){switch(Q){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class f extends i{constructor(){super(124,[62,31])}compute(te,we,xe){const je=["monaco-editor"];return we.get(31)&&je.push(we.get(31)),te.extraEditorClassName&&je.push(te.extraEditorClassName),we.get(62)==="default"?je.push("mouse-default"):we.get(62)==="copy"&&je.push("mouse-copy"),we.get(97)&&je.push("showUnused"),we.get(122)&&je.push("showDeprecated"),je.join(" ")}}class _ extends g{constructor(){super(30,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(te,we,xe){return xe&&te.emptySelectionClipboard}}class u extends P{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:te.seedSearchStringFromSelection,description:b.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[b.localize(9,null),b.localize(10,null),b.localize(11,null)],description:b.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:b.localize(13,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:b.localize(14,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:b.localize(15,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{cursorMoveOnType:m(we.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:m(we.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":w(we.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(we.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(we.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(we.loop,this.defaultValue.loop)}}}class v extends P{constructor(){super(41,"fontLigatures",v.OFF,{anyOf:[{type:"boolean",description:b.localize(16,null)},{type:"string",description:b.localize(17,null)}],description:b.localize(18,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?v.OFF:te==="true"?v.ON:te:Boolean(te)?v.ON:v.OFF}}e.EditorFontLigatures=v,v.OFF='"liga" off, "calt" off',v.ON='"liga" on, "calt" on';class R extends i{constructor(){super(40)}compute(te,we,xe){return te.fontInfo}}class O extends I{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(19,null)})}validate(te){let we=h.float(te,this.defaultValue);return we===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(we,6,100)}compute(te,we,xe){return te.fontInfo.fontSize}}class H extends P{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.MINIMUM_VALUE,maximum:H.MAXIMUM_VALUE,errorMessage:b.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(21,null)})}validate(te){return te==="normal"||te==="bold"?te:String(a.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,H.MINIMUM_VALUE,H.MAXIMUM_VALUE))}}H.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],H.MINIMUM_VALUE=1,H.MAXIMUM_VALUE=1e3;class ne extends P{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},we={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[b.localize(22,null),b.localize(23,null),b.localize(24,null)]},xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:b.localize(26,null)},we),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:b.localize(27,null)},we),"editor.gotoLocation.multipleDeclarations":Object.assign({description:b.localize(28,null)},we),"editor.gotoLocation.multipleImplementations":Object.assign({description:b.localize(29,null)},we),"editor.gotoLocation.multipleReferences":Object.assign({description:b.localize(30,null)},we),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:xe,description:b.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:xe,description:b.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:xe,description:b.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:xe,description:b.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:xe,description:b.localize(35,null)}})}validate(te){var we,xe,je,Ve,Je;if(!te||typeof te!="object")return this.defaultValue;const De=te;return{multiple:w(De.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(we=De.multipleDefinitions)!==null&&we!==void 0?we:w(De.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(xe=De.multipleTypeDefinitions)!==null&&xe!==void 0?xe:w(De.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(je=De.multipleDeclarations)!==null&&je!==void 0?je:w(De.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Ve=De.multipleImplementations)!==null&&Ve!==void 0?Ve:w(De.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Je=De.multipleReferences)!==null&&Je!==void 0?Je:w(De.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(De.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(De.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(De.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(De.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(De.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ie extends P{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(50,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:b.localize(36,null)},"editor.hover.delay":{type:"number",default:te.delay,description:b.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:b.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{enabled:m(we.enabled,this.defaultValue.enabled),delay:a.clampedInt(we.delay,this.defaultValue.delay,0,1e4),sticky:m(we.sticky,this.defaultValue.sticky)}}}var U;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(U=e.RenderMinimap||(e.RenderMinimap={}));class B extends i{constructor(){super(127,[46,54,35,61,89,56,57,91,114,117,118,119,2])}compute(te,we,xe){return B.computeLayout(we,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const we=te.height/te.lineHeight,xe=te.scrollBeyondLastLine?we-1:0,je=(te.viewLineCount+xe)/(te.pixelRatio*te.height),Ve=Math.floor(te.viewLineCount/je);return{typicalViewportLineCount:we,extraLinesBeyondLastLine:xe,desiredRatio:je,minimapLineCount:Ve}}static _computeMinimapLayout(te,we){const xe=te.outerWidth,je=te.outerHeight,Ve=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ve*je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:je};const Je=we.stableMinimapLayoutInput,De=Je&&te.outerHeight===Je.outerHeight&&te.lineHeight===Je.lineHeight&&te.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&te.pixelRatio===Je.pixelRatio&&te.scrollBeyondLastLine===Je.scrollBeyondLastLine&&te.minimap.enabled===Je.minimap.enabled&&te.minimap.side===Je.minimap.side&&te.minimap.size===Je.minimap.size&&te.minimap.showSlider===Je.minimap.showSlider&&te.minimap.renderCharacters===Je.minimap.renderCharacters&&te.minimap.maxColumn===Je.minimap.maxColumn&&te.minimap.scale===Je.minimap.scale&&te.verticalScrollbarWidth===Je.verticalScrollbarWidth&&te.isViewportWrapping===Je.isViewportWrapping,ye=te.lineHeight,Pe=te.typicalHalfwidthCharacterWidth,oe=te.scrollBeyondLastLine,ue=te.minimap.renderCharacters;let z=Ve>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const J=te.minimap.maxColumn,ce=te.minimap.size,Ie=te.minimap.side,Ae=te.verticalScrollbarWidth,Le=te.viewLineCount,$e=te.remainingWidth,Xe=te.isViewportWrapping,rt=ue?2:3;let tt=Math.floor(Ve*je);const Qe=tt/Ve;let gt=!1,wt=!1,be=rt*z,he=z/Ve,ae=1;if(ce==="fill"||ce==="fit"){const{typicalViewportLineCount:ut,extraLinesBeyondLastLine:Ze,desiredRatio:mt,minimapLineCount:ht}=B.computeContainedMinimapLineCount({viewLineCount:Le,scrollBeyondLastLine:oe,height:je,lineHeight:ye,pixelRatio:Ve});if(Le/ht>1)gt=!0,wt=!0,z=1,be=1,he=z/Ve;else{let at=!1,yt=z+1;if(ce==="fit"){const St=Math.ceil((Le+Ze)*be);Xe&&De&&$e<=we.stableFitRemainingWidth?(at=!0,yt=we.stableFitMaxMinimapScale):(at=St>tt,Xe&&at?(we.stableMinimapLayoutInput=te,we.stableFitRemainingWidth=$e):(we.stableMinimapLayoutInput=null,we.stableFitRemainingWidth=0))}if(ce==="fill"||at){gt=!0;const St=z;be=Math.min(ye*Ve,Math.max(1,Math.floor(1/mt))),z=Math.min(yt,Math.max(1,Math.floor(be/rt))),z>St&&(ae=Math.min(2,z/St)),he=z/Ve/ae,tt=Math.ceil(Math.max(ut,Le+Ze)*be),Xe&&at&&(we.stableFitMaxMinimapScale=z)}}}const Y=Math.floor(J*he),Ne=Math.min(Y,Math.max(0,Math.floor(($e-Ae-2)*he/(Pe+he)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor(Ve*Ne);const Ye=Fe/Ve;Fe=Math.floor(Fe*ae);const et=ue?1:2,ct=Ie==="left"?0:xe-Ne-Ae;return{renderMinimap:et,minimapLeft:ct,minimapWidth:Ne,minimapHeightIsEditorHeight:gt,minimapIsSampling:wt,minimapScale:z,minimapLineHeight:be,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:tt,minimapCanvasOuterWidth:Ye,minimapCanvasOuterHeight:Qe}}static computeLayout(te,we){const xe=we.outerWidth|0,je=we.outerHeight|0,Ve=we.lineHeight|0,Je=we.lineNumbersDigitCount|0,De=we.typicalHalfwidthCharacterWidth,ye=we.maxDigitWidth,Pe=we.pixelRatio,oe=we.viewLineCount,ue=te.get(119),z=ue==="inherit"?te.get(118):ue,J=z==="inherit"?te.get(114):z,ce=te.get(117),Ie=te.get(2),Ae=we.isDominatedByLongLines,Le=te.get(46),$e=te.get(56).renderType!==0,Xe=te.get(57),rt=te.get(91),tt=te.get(61),Qe=te.get(89),gt=Qe.verticalScrollbarSize,wt=Qe.verticalHasArrows,be=Qe.arrowSize,he=Qe.horizontalScrollbarSize,ae=te.get(54),Y=te.get(35);let Ne;if(typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)){const _t=parseFloat(ae.substr(0,ae.length-2));Ne=a.clampedInt(_t*De,0,0,1e3)}else Ne=a.clampedInt(ae,0,0,1e3);Y&&(Ne+=16);let Fe=0;if($e){const _t=Math.max(Je,Xe);Fe=Math.round(_t*ye)}let Ye=0;Le&&(Ye=Ve);let et=0,ct=et+Ye,ut=ct+Fe,Ze=ut+Ne;const mt=xe-Ye-Fe-Ne;let ht=!1,ft=!1,at=-1;Ie!==2&&(z==="inherit"&&Ae?(ht=!0,ft=!0):J==="on"||J==="bounded"?ft=!0:J==="wordWrapColumn"&&(at=ce));const yt=B._computeMinimapLayout({outerWidth:xe,outerHeight:je,lineHeight:Ve,typicalHalfwidthCharacterWidth:De,pixelRatio:Pe,scrollBeyondLastLine:rt,minimap:tt,verticalScrollbarWidth:gt,viewLineCount:oe,remainingWidth:mt,isViewportWrapping:ft},we.memory||new D);yt.renderMinimap!==0&&yt.minimapLeft===0&&(et+=yt.minimapWidth,ct+=yt.minimapWidth,ut+=yt.minimapWidth,Ze+=yt.minimapWidth);const St=mt-yt.minimapWidth,Nt=Math.max(1,Math.floor((St-gt-2)/De)),Rt=wt?be:0;return ft&&(at=Math.max(1,Nt),J==="bounded"&&(at=Math.min(at,ce))),{width:xe,height:je,glyphMarginLeft:et,glyphMarginWidth:Ye,lineNumbersLeft:ct,lineNumbersWidth:Fe,decorationsLeft:ut,decorationsWidth:Ne,contentLeft:Ze,contentWidth:St,minimap:yt,viewportColumn:Nt,isWordWrapMinified:ht,isViewportWrapping:ft,wrappingColumn:at,verticalScrollbarWidth:gt,horizontalScrollbarHeight:he,overviewRuler:{top:Rt,width:gt,height:je-2*Rt,right:0}}}}e.EditorLayoutInfoComputer=B;class x extends P{constructor(){const te={enabled:!0};super(53,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:b.localize(39,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:m(te.enabled,this.defaultValue.enabled)}}}class L extends P{constructor(){const te={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(123,"inlayHints",te,{"editor.inlayHints.enabled":{type:"boolean",default:te.enabled,description:b.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:te.fontSize,description:b.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:te.fontFamily,description:b.localize(42,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{enabled:m(we.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(we.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(we.fontFamily,this.defaultValue.fontFamily)}}}class N extends a{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:b.localize(43,null)})}compute(te,we,xe){return te.fontInfo.lineHeight}}class F extends P{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:b.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(45,null),b.localize(46,null),b.localize(47,null)],default:te.size,description:b.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:b.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:b.localize(50,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:b.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:b.localize(53,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{enabled:m(we.enabled,this.defaultValue.enabled),size:w(we.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(we.side,this.defaultValue.side,["right","left"]),showSlider:w(we.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(we.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(we.scale,1,1,3),maxColumn:a.clampedInt(we.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function M(Q){return Q==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class $ extends P{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(55,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{top:a.clampedInt(we.top,0,0,1e3),bottom:a.clampedInt(we.bottom,0,0,1e3)}}}class q extends P{constructor(){const te={enabled:!0,cycle:!1};super(72,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:b.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:b.localize(57,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{enabled:m(we.enabled,this.defaultValue.enabled),cycle:m(we.cycle,this.defaultValue.cycle)}}}class G extends i{constructor(){super(125)}compute(te,we,xe){return te.pixelRatio}}class le extends P{constructor(){const te={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:b.localize(58,null)},comments:{type:"boolean",default:te.comments,description:b.localize(59,null)},other:{type:"boolean",default:te.other,description:b.localize(60,null)}}}],default:te,description:b.localize(61,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const we=te,xe={other:m(we.other,this.defaultValue.other),comments:m(we.comments,this.defaultValue.comments),strings:m(we.strings,this.defaultValue.strings)};return xe.other&&xe.comments&&xe.strings?!0:!xe.other&&!xe.comments&&!xe.strings?!1:xe}return this.defaultValue}}var ve;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(ve=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Re extends P{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(62,null),b.localize(63,null),b.localize(64,null),b.localize(65,null)],default:"on",description:b.localize(66,null)})}validate(te){let we=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(we=4,xe=te):te==="interval"?we=3:te==="relative"?we=2:te==="on"?we=1:we=0),{renderType:we,renderFn:xe}}}function Se(Q){const te=Q.get(84);return te==="editable"?Q.get(77):te!=="on"}e.filterValidationDecorations=Se;class Oe extends P{constructor(){const te=[],we={type:"number",description:b.localize(67,null)};super(88,"rulers",te,{type:"array",items:{anyOf:[we,{type:["object"],properties:{column:we,color:{type:"string",description:b.localize(68,null),format:"color-hex"}}}]},default:te,description:b.localize(69,null)})}validate(te){if(Array.isArray(te)){let we=[];for(let xe of te)if(typeof xe=="number")we.push({column:a.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const je=xe;we.push({column:a.clampedInt(je.column,0,0,1e4),color:je.color})}return we.sort((xe,je)=>xe.column-je.column),we}return this.defaultValue}}function V(Q,te){if(typeof Q!="string")return te;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class X extends P{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te,xe=a.clampedInt(we.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),je=a.clampedInt(we.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(we.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:V(we.vertical,this.defaultValue.vertical),horizontal:V(we.horizontal,this.defaultValue.horizontal),useShadows:m(we.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(we.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(we.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(we.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(we.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:a.clampedInt(we.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:je,verticalSliderSize:a.clampedInt(we.verticalSliderSize,je,0,1e3),scrollByPage:m(we.scrollByPage,this.defaultValue.scrollByPage)}}}class Z extends P{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(70,null),b.localize(71,null)],default:te.insertMode,description:b.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:b.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:b.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:b.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:b.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:b.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:b.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:b.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(109,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const we=te;return{insertMode:w(we.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(we.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(we.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(we.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(we.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:m(we.showIcons,this.defaultValue.showIcons),showStatusBar:m(we.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:m(we.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(we.showMethods,this.defaultValue.showMethods),showFunctions:m(we.showFunctions,this.defaultValue.showFunctions),showConstructors:m(we.showConstructors,this.defaultValue.showConstructors),showFields:m(we.showFields,this.defaultValue.showFields),showVariables:m(we.showVariables,this.defaultValue.showVariables),showClasses:m(we.showClasses,this.defaultValue.showClasses),showStructs:m(we.showStructs,this.defaultValue.showStructs),showInterfaces:m(we.showInterfaces,this.defaultValue.showInterfaces),showModules:m(we.showModules,this.defaultValue.showModules),showProperties:m(we.showProperties,this.defaultValue.showProperties),showEvents:m(we.showEvents,this.defaultValue.showEvents),showOperators:m(we.showOperators,this.defaultValue.showOperators),showUnits:m(we.showUnits,this.defaultValue.showUnits),showValues:m(we.showValues,this.defaultValue.showValues),showConstants:m(we.showConstants,this.defaultValue.showConstants),showEnums:m(we.showEnums,this.defaultValue.showEnums),showEnumMembers:m(we.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(we.showKeywords,this.defaultValue.showKeywords),showWords:m(we.showWords,this.defaultValue.showWords),showColors:m(we.showColors,this.defaultValue.showColors),showFiles:m(we.showFiles,this.defaultValue.showFiles),showReferences:m(we.showReferences,this.defaultValue.showReferences),showFolders:m(we.showFolders,this.defaultValue.showFolders),showTypeParameters:m(we.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(we.showSnippets,this.defaultValue.showSnippets),showUsers:m(we.showUsers,this.defaultValue.showUsers),showIssues:m(we.showIssues,this.defaultValue.showIssues)}}}class se extends P{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(110,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class fe extends i{constructor(){super(126,[77])}compute(te,we,xe){return we.get(77)?!0:te.tabFocusMode}}var Ee;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(Ee=e.WrappingIndent||(e.WrappingIndent={}));function Be(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class pe extends i{constructor(){super(128,[127])}compute(te,we,xe){const je=we.get(127);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:je.isWordWrapMinified,isViewportWrapping:je.isViewportWrapping,wrappingColumn:je.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Me="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?Me:T.isLinux?ze:Ce,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function _e(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var Ke;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.codeLens=12]="codeLens",Q[Q.codeLensFontFamily=13]="codeLensFontFamily",Q[Q.codeLensFontSize=14]="codeLensFontSize",Q[Q.colorDecorators=15]="colorDecorators",Q[Q.columnSelection=16]="columnSelection",Q[Q.comments=17]="comments",Q[Q.contextmenu=18]="contextmenu",Q[Q.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=20]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=22]="cursorStyle",Q[Q.cursorSurroundingLines=23]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=25]="cursorWidth",Q[Q.disableLayerHinting=26]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",Q[Q.domReadOnly=28]="domReadOnly",Q[Q.dragAndDrop=29]="dragAndDrop",Q[Q.emptySelectionClipboard=30]="emptySelectionClipboard",Q[Q.extraEditorClassName=31]="extraEditorClassName",Q[Q.fastScrollSensitivity=32]="fastScrollSensitivity",Q[Q.find=33]="find",Q[Q.fixedOverflowWidgets=34]="fixedOverflowWidgets",Q[Q.folding=35]="folding",Q[Q.foldingStrategy=36]="foldingStrategy",Q[Q.foldingHighlight=37]="foldingHighlight",Q[Q.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=39]="fontFamily",Q[Q.fontInfo=40]="fontInfo",Q[Q.fontLigatures=41]="fontLigatures",Q[Q.fontSize=42]="fontSize",Q[Q.fontWeight=43]="fontWeight",Q[Q.formatOnPaste=44]="formatOnPaste",Q[Q.formatOnType=45]="formatOnType",Q[Q.glyphMargin=46]="glyphMargin",Q[Q.gotoLocation=47]="gotoLocation",Q[Q.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",Q[Q.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",Q[Q.hover=50]="hover",Q[Q.inDiffEditor=51]="inDiffEditor",Q[Q.letterSpacing=52]="letterSpacing",Q[Q.lightbulb=53]="lightbulb",Q[Q.lineDecorationsWidth=54]="lineDecorationsWidth",Q[Q.lineHeight=55]="lineHeight",Q[Q.lineNumbers=56]="lineNumbers",Q[Q.lineNumbersMinChars=57]="lineNumbersMinChars",Q[Q.linkedEditing=58]="linkedEditing",Q[Q.links=59]="links",Q[Q.matchBrackets=60]="matchBrackets",Q[Q.minimap=61]="minimap",Q[Q.mouseStyle=62]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=64]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=66]="multiCursorModifier",Q[Q.multiCursorPaste=67]="multiCursorPaste",Q[Q.occurrencesHighlight=68]="occurrencesHighlight",Q[Q.overviewRulerBorder=69]="overviewRulerBorder",Q[Q.overviewRulerLanes=70]="overviewRulerLanes",Q[Q.padding=71]="padding",Q[Q.parameterHints=72]="parameterHints",Q[Q.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=75]="quickSuggestions",Q[Q.quickSuggestionsDelay=76]="quickSuggestionsDelay",Q[Q.readOnly=77]="readOnly",Q[Q.renameOnType=78]="renameOnType",Q[Q.renderControlCharacters=79]="renderControlCharacters",Q[Q.renderIndentGuides=80]="renderIndentGuides",Q[Q.renderFinalNewline=81]="renderFinalNewline",Q[Q.renderLineHighlight=82]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=84]="renderValidationDecorations",Q[Q.renderWhitespace=85]="renderWhitespace",Q[Q.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",Q[Q.roundedSelection=87]="roundedSelection",Q[Q.rulers=88]="rulers",Q[Q.scrollbar=89]="scrollbar",Q[Q.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=91]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=92]="scrollPredominantAxis",Q[Q.selectionClipboard=93]="selectionClipboard",Q[Q.selectionHighlight=94]="selectionHighlight",Q[Q.selectOnLineNumbers=95]="selectOnLineNumbers",Q[Q.showFoldingControls=96]="showFoldingControls",Q[Q.showUnused=97]="showUnused",Q[Q.snippetSuggestions=98]="snippetSuggestions",Q[Q.smartSelect=99]="smartSelect",Q[Q.smoothScrolling=100]="smoothScrolling",Q[Q.stickyTabStops=101]="stickyTabStops",Q[Q.stopRenderingLineAfter=102]="stopRenderingLineAfter",Q[Q.suggest=103]="suggest",Q[Q.suggestFontSize=104]="suggestFontSize",Q[Q.suggestLineHeight=105]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",Q[Q.suggestSelection=107]="suggestSelection",Q[Q.tabCompletion=108]="tabCompletion",Q[Q.tabIndex=109]="tabIndex",Q[Q.unusualLineTerminators=110]="unusualLineTerminators",Q[Q.useShadowDOM=111]="useShadowDOM",Q[Q.useTabStops=112]="useTabStops",Q[Q.wordSeparators=113]="wordSeparators",Q[Q.wordWrap=114]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=115]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=116]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=117]="wordWrapColumn",Q[Q.wordWrapOverride1=118]="wordWrapOverride1",Q[Q.wordWrapOverride2=119]="wordWrapOverride2",Q[Q.wrappingIndent=120]="wrappingIndent",Q[Q.wrappingStrategy=121]="wrappingStrategy",Q[Q.showDeprecated=122]="showDeprecated",Q[Q.inlayHints=123]="inlayHints",Q[Q.editorClassName=124]="editorClassName",Q[Q.pixelRatio=125]="pixelRatio",Q[Q.tabFocusMode=126]="tabFocusMode",Q[Q.layoutInfo=127]="layoutInfo",Q[Q.wrappingInfo=128]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(111,null)})),acceptSuggestionOnEnter:_e(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(112,null),""],markdownDescription:b.localize(113,null)})),accessibilitySupport:_e(new c),accessibilityPageSize:_e(new a(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(114,null)})),ariaLabel:_e(new S(4,"ariaLabel",b.localize(115,null))),autoClosingBrackets:_e(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(116,null),b.localize(117,null),""],description:b.localize(118,null)})),autoClosingDelete:_e(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(119,null),""],description:b.localize(120,null)})),autoClosingOvertype:_e(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(121,null),""],description:b.localize(122,null)})),autoClosingQuotes:_e(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(123,null),b.localize(124,null),""],description:b.localize(125,null)})),autoIndent:_e(new d(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[b.localize(126,null),b.localize(127,null),b.localize(128,null),b.localize(129,null),b.localize(130,null)],description:b.localize(131,null)})),automaticLayout:_e(new g(10,"automaticLayout",!1)),autoSurround:_e(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(132,null),b.localize(133,null),b.localize(134,null),""],description:b.localize(135,null)})),stickyTabStops:_e(new g(101,"stickyTabStops",!1,{description:b.localize(136,null)})),codeLens:_e(new g(12,"codeLens",!0,{description:b.localize(137,null)})),codeLensFontFamily:_e(new S(13,"codeLensFontFamily","",{description:b.localize(138,null)})),codeLensFontSize:_e(new a(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:b.localize(139,null)})),colorDecorators:_e(new g(15,"colorDecorators",!0,{description:b.localize(140,null)})),columnSelection:_e(new g(16,"columnSelection",!1,{description:b.localize(141,null)})),comments:_e(new t),contextmenu:_e(new g(18,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new g(19,"copyWithSyntaxHighlighting",!0,{description:b.localize(142,null)})),cursorBlinking:_e(new d(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:b.localize(143,null)})),cursorSmoothCaretAnimation:_e(new g(21,"cursorSmoothCaretAnimation",!1,{description:b.localize(144,null)})),cursorStyle:_e(new d(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],p,{description:b.localize(145,null)})),cursorSurroundingLines:_e(new a(23,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(146,null)})),cursorSurroundingLinesStyle:_e(new E(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(147,null),b.localize(148,null)],description:b.localize(149,null)})),cursorWidth:_e(new a(25,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(150,null)})),disableLayerHinting:_e(new g(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new g(27,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new g(28,"domReadOnly",!1)),dragAndDrop:_e(new g(29,"dragAndDrop",!0,{description:b.localize(151,null)})),emptySelectionClipboard:_e(new _),extraEditorClassName:_e(new S(31,"extraEditorClassName","")),fastScrollSensitivity:_e(new h(32,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:b.localize(152,null)})),find:_e(new u),fixedOverflowWidgets:_e(new g(34,"fixedOverflowWidgets",!1)),folding:_e(new g(35,"folding",!0,{description:b.localize(153,null)})),foldingStrategy:_e(new E(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(154,null),b.localize(155,null)],description:b.localize(156,null)})),foldingHighlight:_e(new g(37,"foldingHighlight",!0,{description:b.localize(157,null)})),unfoldOnClickAfterEndOfLine:_e(new g(38,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(158,null)})),fontFamily:_e(new S(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(159,null)})),fontInfo:_e(new R),fontLigatures2:_e(new v),fontSize:_e(new O),fontWeight:_e(new H),formatOnPaste:_e(new g(44,"formatOnPaste",!1,{description:b.localize(160,null)})),formatOnType:_e(new g(45,"formatOnType",!1,{description:b.localize(161,null)})),glyphMargin:_e(new g(46,"glyphMargin",!0,{description:b.localize(162,null)})),gotoLocation:_e(new ne),hideCursorInOverviewRuler:_e(new g(48,"hideCursorInOverviewRuler",!1,{description:b.localize(163,null)})),highlightActiveIndentGuide:_e(new g(49,"highlightActiveIndentGuide",!0,{description:b.localize(164,null)})),hover:_e(new ie),inDiffEditor:_e(new g(51,"inDiffEditor",!1)),letterSpacing:_e(new h(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>h.clamp(Q,-5,20),{description:b.localize(165,null)})),lightbulb:_e(new x),lineDecorationsWidth:_e(new I(54,"lineDecorationsWidth",10)),lineHeight:_e(new N),lineNumbers:_e(new Re),lineNumbersMinChars:_e(new a(57,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new g(58,"linkedEditing",!1,{description:b.localize(166,null)})),links:_e(new g(59,"links",!0,{description:b.localize(167,null)})),matchBrackets:_e(new E(60,"matchBrackets","always",["always","near","never"],{description:b.localize(168,null)})),minimap:_e(new F),mouseStyle:_e(new E(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new h(63,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:b.localize(169,null)})),mouseWheelZoom:_e(new g(64,"mouseWheelZoom",!1,{markdownDescription:b.localize(170,null)})),multiCursorMergeOverlapping:_e(new g(65,"multiCursorMergeOverlapping",!0,{description:b.localize(171,null)})),multiCursorModifier:_e(new d(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],M,{markdownEnumDescriptions:[b.localize(172,null),b.localize(173,null)],markdownDescription:b.localize(174,null)})),multiCursorPaste:_e(new E(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(175,null),b.localize(176,null)],markdownDescription:b.localize(177,null)})),occurrencesHighlight:_e(new g(68,"occurrencesHighlight",!0,{description:b.localize(178,null)})),overviewRulerBorder:_e(new g(69,"overviewRulerBorder",!0,{description:b.localize(179,null)})),overviewRulerLanes:_e(new a(70,"overviewRulerLanes",3,0,3)),padding:_e(new $),parameterHints:_e(new q),peekWidgetDefaultFocus:_e(new E(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(180,null),b.localize(181,null)],description:b.localize(182,null)})),definitionLinkOpensInPeek:_e(new g(74,"definitionLinkOpensInPeek",!1,{description:b.localize(183,null)})),quickSuggestions:_e(new le),quickSuggestionsDelay:_e(new a(76,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(184,null)})),readOnly:_e(new g(77,"readOnly",!1)),renameOnType:_e(new g(78,"renameOnType",!1,{description:b.localize(185,null),markdownDeprecationMessage:b.localize(186,null)})),renderControlCharacters:_e(new g(79,"renderControlCharacters",!1,{description:b.localize(187,null)})),renderIndentGuides:_e(new g(80,"renderIndentGuides",!0,{description:b.localize(188,null)})),renderFinalNewline:_e(new g(81,"renderFinalNewline",!0,{description:b.localize(189,null)})),renderLineHighlight:_e(new E(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(190,null)],description:b.localize(191,null)})),renderLineHighlightOnlyWhenFocus:_e(new g(83,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(192,null)})),renderValidationDecorations:_e(new E(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new E(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(193,null),b.localize(194,null),b.localize(195,null),""],description:b.localize(196,null)})),revealHorizontalRightPadding:_e(new a(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:_e(new g(87,"roundedSelection",!0,{description:b.localize(197,null)})),rulers:_e(new Oe),scrollbar:_e(new X),scrollBeyondLastColumn:_e(new a(90,"scrollBeyondLastColumn",5,0,1073741824,{description:b.localize(198,null)})),scrollBeyondLastLine:_e(new g(91,"scrollBeyondLastLine",!0,{description:b.localize(199,null)})),scrollPredominantAxis:_e(new g(92,"scrollPredominantAxis",!0,{description:b.localize(200,null)})),selectionClipboard:_e(new g(93,"selectionClipboard",!0,{description:b.localize(201,null),included:T.isLinux})),selectionHighlight:_e(new g(94,"selectionHighlight",!0,{description:b.localize(202,null)})),selectOnLineNumbers:_e(new g(95,"selectOnLineNumbers",!0)),showFoldingControls:_e(new E(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[b.localize(203,null),b.localize(204,null)],description:b.localize(205,null)})),showUnused:_e(new g(97,"showUnused",!0,{description:b.localize(206,null)})),showDeprecated:_e(new g(122,"showDeprecated",!0,{description:b.localize(207,null)})),inlayHints:_e(new L),snippetSuggestions:_e(new E(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(208,null),b.localize(209,null),b.localize(210,null),b.localize(211,null)],description:b.localize(212,null)})),smartSelect:_e(new se),smoothScrolling:_e(new g(100,"smoothScrolling",!1,{description:b.localize(213,null)})),stopRenderingLineAfter:_e(new a(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new Z),suggestFontSize:_e(new a(104,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(214,null)})),suggestLineHeight:_e(new a(105,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(215,null)})),suggestOnTriggerCharacters:_e(new g(106,"suggestOnTriggerCharacters",!0,{description:b.localize(216,null)})),suggestSelection:_e(new E(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(217,null),b.localize(218,null),b.localize(219,null)],description:b.localize(220,null)})),tabCompletion:_e(new E(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(221,null),b.localize(222,null),b.localize(223,null)],description:b.localize(224,null)})),tabIndex:_e(new a(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:_e(new E(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(225,null),b.localize(226,null),b.localize(227,null)],description:b.localize(228,null)})),useShadowDOM:_e(new g(111,"useShadowDOM",!0)),useTabStops:_e(new g(112,"useTabStops",!0,{description:b.localize(229,null)})),wordSeparators:_e(new S(113,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:b.localize(230,null)})),wordWrap:_e(new E(114,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(231,null),b.localize(232,null),b.localize(233,null),b.localize(234,null)],description:b.localize(235,null)})),wordWrapBreakAfterCharacters:_e(new S(115,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new S(116,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new a(117,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(236,null)})),wordWrapOverride1:_e(new E(118,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new E(119,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:_e(new d(120,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Be,{enumDescriptions:[b.localize(237,null),b.localize(238,null),b.localize(239,null),b.localize(240,null)],description:b.localize(241,null)})),wrappingStrategy:_e(new E(121,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[b.localize(242,null),b.localize(243,null)],description:b.localize(244,null)})),editorClassName:_e(new f),pixelRatio:_e(new G),tabFocusMode:_e(new fe),layoutInfo:_e(new B),wrappingInfo:_e(new pe)}}),define(me[153],ge([18,19]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[154],ge([18,19]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[155],ge([18,19]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[156],ge([18,19]),function(K,e){return K.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[157],ge([18,19]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(me[158],ge([18,19]),function(K,e){return K.create("vs/platform/markers/common/markers",e)}),define(me[159],ge([18,19]),function(K,e){return K.create("vs/platform/theme/common/iconRegistry",e)}),define(me[160],ge([18,19]),function(K,e){return K.create("vs/platform/workspaces/common/workspaces",e)}),define(me[161],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHost.api.impl",e)}),define(me[162],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[163],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[164],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHostProgress",e)}),define(me[165],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[166],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[167],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[168],ge([18,19]),function(K,e){return K.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[169],ge([18,19]),function(K,e){return K.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[170],ge([18,19]),function(K,e){return K.create("vs/workbench/common/views",e)}),define(me[171],ge([18,19]),function(K,e){return K.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[172],ge([18,19]),function(K,e){return K.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[173],ge([18,19]),function(K,e){return K.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[174],ge([18,19]),function(K,e){return K.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[175],ge([18,19]),function(K,e){return K.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[176],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var b;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(b=e.EditorActivation||(e.EditorActivation={}));var T;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(T=e.EditorOverride||(e.EditorOverride={}));var C;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(C=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[177],ge([0,1,155]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function A(m){return m=m.trim(),m==="*"||T.test(m)}e.isValidVersionStr=A;function y(m){if(!A(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=m.match(T);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=y;function k(m){if(!m)return null;let g=m.majorBase,a=m.majorMustEqual,h=m.minorBase,S=m.minorMustEqual,w=m.patchBase,E=m.patchMustEqual;m.hasCaret&&(g===0||(S=!1),E=!1);let d=0;if(m.preRelease){const l=C.exec(m.preRelease);if(l){const[,c,t,n]=l;d=Date.UTC(Number(c),Number(t)-1,Number(n))}}return{majorBase:g,majorMustEqual:a,minorBase:h,minorMustEqual:S,patchBase:w,patchMustEqual:E,isMinimum:m.hasGreaterEquals,notBefore:d}}e.normalizeVersion=k;function D(m,g,a){let h;typeof m=="string"?h=k(y(m)):h=m;let S;g instanceof Date?S=g.getTime():typeof g=="string"&&(S=new Date(g).getTime());let w;if(typeof a=="string"?w=k(y(a)):w=a,!h||!w)return!1;let E=h.majorBase,d=h.minorBase,l=h.patchBase,c=w.majorBase,t=w.minorBase,n=w.patchBase,s=w.notBefore,r=w.majorMustEqual,o=w.minorMustEqual,p=w.patchMustEqual;return w.isMinimum?E>c?!0:E<c?!1:d>t?!0:d<t||S&&S<s?!1:l>=n:(E===1&&c===0&&(!r||!o||!p)&&(c=1,t=0,n=0,r=!0,o=!1,p=!1),E<c?!1:E>c?!r:d<t?!1:d>t?!o:l<n?!1:l>n?!p:!(S&&S<s))}e.isValidVersion=D;function P(m,g,a,h){return a.isBuiltin||typeof a.main=="undefined"?!0:I(m,g,a.engines.vscode,h)}e.isValidExtensionVersion=P;function i(m,g,a){return m==="*"||I(g,a,m)}e.isEngineValid=i;function I(m,g,a,h=[]){let S=k(y(a));if(!S)return h.push(b.localize(0,null,a)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return h.push(b.localize(1,null,a)),!1}else if(!S.majorMustEqual)return h.push(b.localize(2,null,a)),!1;return D(m,g,S)?!0:(h.push(b.localize(3,null,m,a)),!1)}}),define(me[114],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class b{constructor(A,y=[],k=!1){this.ctor=A,this.staticArguments=y,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=b;const T=(C,...A)=>new b(C,A);e.createSyncDescriptor=T}),define(me[80],ge([0,1,114]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const T=[];function C(y,k,D){k instanceof b.SyncDescriptor||(k=new b.SyncDescriptor(k,[],D)),T.push([y,k])}e.registerSingleton=C;function A(){return T}e.getSingletonServiceDescriptors=A}),define(me[178],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class b{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=b;class T{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let y of this._nodes.values())y.outgoing.size===0&&A.push(y);return A}insertEdge(A,y){const k=this.lookupOrInsertNode(A),D=this.lookupOrInsertNode(y);k.outgoing.set(this._hashFn(y),D),D.incoming.set(this._hashFn(A),k)}removeNode(A){const y=this._hashFn(A);this._nodes.delete(y);for(let k of this._nodes.values())k.outgoing.delete(y),k.incoming.delete(y)}lookupOrInsertNode(A){const y=this._hashFn(A);let k=this._nodes.get(y);return k||(k=new b(A),this._nodes.set(y,k)),k}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[y,k]of this._nodes)A.push(`${y}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,y]of this._nodes){const k=new Set([A]),D=this._findCycle(y,k);if(D)return D}}_findCycle(A,y){for(let[k,D]of A.outgoing){if(y.has(k))return[...y,k].join(" -> ");y.add(k);const P=this._findCycle(D,y);if(P)return P;y.delete(k)}}}e.Graph=T}),define(me[4],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var b;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function D(P){return P[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=D})(b=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function T(k,D,P,i){D[b.DI_TARGET]===D?D[b.DI_DEPENDENCIES].push({id:k,index:P,optional:i}):(D[b.DI_DEPENDENCIES]=[{id:k,index:P,optional:i}],D[b.DI_TARGET]=D)}function C(k){if(b.serviceIds.has(k))return b.serviceIds.get(k);const D=function(P,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(D,P,I,!1)};return D.toString=()=>k,b.serviceIds.set(k,D),D}e.createDecorator=C;function A(k){return k}e.refineServiceDecorator=A;function y(k){return function(D,P,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");T(k,D,i,!0)}}e.optional=y}),define(me[179],ge([0,1,4]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,b.createDecorator)("modelService");function T(C){return!C.isTooLargeForSyncing()&&!C.isForSimpleWidget}e.shouldSynchronizeModel=T}),define(me[180],ge([0,1,3,75,6,22,74,78,179]),function(K,e,b,T,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(m){return typeof m=="string"?!1:Array.isArray(m)?m.every(P):!!m.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new b.Emitter}get onDidChange(){return this._onDidChange.event}register(g,a){let h={selector:g,provider:a,_score:-1,_time:this._clock++};return this._entries.push(h),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,C.toDisposable)(()=>{if(h){let S=this._entries.indexOf(h);S>=0&&(this._entries.splice(S,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),h=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const a=[];for(let h of this._entries)h._score>0&&a.push(h.provider);return a}ordered(g){const a=[];return this._orderedForEach(g,h=>a.push(h.provider)),a}orderedGroups(g){const a=[];let h,S;return this._orderedForEach(g,w=>{h&&S===w._score?h.push(w.provider):(S=w._score,h=[w.provider],a.push(h))}),a}_orderedForEach(g,a){if(!!g){this._updateScores(g);for(const h of this._entries)h._score>0&&a(h)}}_updateScores(g){let a={uri:g.uri.toString(),language:g.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===a.language&&this._lastCandidate.uri===a.uri)){this._lastCandidate=a;for(let h of this._entries)if(h._score=(0,k.score)(h.selector,g.uri,g.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(g)),P(h.selector)&&h._score>0){for(let S of this._entries)S._score=0;h._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(g,a){return g._score<a._score?1:g._score>a._score?-1:g._time<a._time?1:g._time>a._time?-1:0}}e.LanguageFeatureRegistry=i;class I{constructor(g,a,h=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=a,this.max=h,this._cache=new A.LRUCache(50,.7)}_key(g){return g.id+(0,T.hash)(this._registry.all(g))}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const a=this._key(g),h=this._cache.get(a);return this._clamp(h==null?void 0:h.value)}update(g,a){const h=this._key(g);let S=this._cache.get(h);return S||(S=new y.MovingAverage,this._cache.set(h,S)),S.update(a),this.get(g)}}e.LanguageFeatureRequestDelays=I}),define(me[81],ge([0,1,2,44,180,144,43]),function(K,e,b,T,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var k;(function(u){u[u.Null=0]="Null",u[u.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));class D{constructor(v,R){this.language=v,this.id=R}}e.LanguageIdentifier=D;var P;(function(u){u[u.NotSet=-1]="NotSet",u[u.None=0]="None",u[u.Italic=1]="Italic",u[u.Bold=2]="Bold",u[u.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var i;(function(u){u[u.None=0]="None",u[u.DefaultForeground=1]="DefaultForeground",u[u.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var I;(function(u){u[u.Other=0]="Other",u[u.Comment=1]="Comment",u[u.String=2]="String",u[u.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var m;(function(u){u[u.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",u[u.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",u[u.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",u[u.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",u[u.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",u[u.ITALIC_MASK=2048]="ITALIC_MASK",u[u.BOLD_MASK=4096]="BOLD_MASK",u[u.UNDERLINE_MASK=8192]="UNDERLINE_MASK",u[u.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",u[u.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",u[u.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",u[u.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",u[u.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",u[u.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",u[u.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",u[u.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",u[u.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",u[u.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(m=e.MetadataConsts||(e.MetadataConsts={}));class g{static getLanguageId(v){return(v&255)>>>0}static getTokenType(v){return(v&1792)>>>8}static getFontStyle(v){return(v&14336)>>>11}static getForeground(v){return(v&8372224)>>>14}static getBackground(v){return(v&4286578688)>>>23}static getClassNameFromMetadata(v){let R=this.getForeground(v),O="mtk"+R,H=this.getFontStyle(v);return H&1&&(O+=" mtki"),H&2&&(O+=" mtkb"),H&4&&(O+=" mtku"),O}static getInlineStyleFromMetadata(v,R){const O=this.getForeground(v),H=this.getFontStyle(v);let ne=`color: ${R[O]};`;return H&1&&(ne+="font-style: italic;"),H&2&&(ne+="font-weight: bold;"),H&4&&(ne+="text-decoration: underline;"),ne}}e.TokenMetadata=g;var a;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let u=Object.create(null);return u[0]="symbol-method",u[1]="symbol-function",u[2]="symbol-constructor",u[3]="symbol-field",u[4]="symbol-variable",u[5]="symbol-class",u[6]="symbol-struct",u[7]="symbol-interface",u[8]="symbol-module",u[9]="symbol-property",u[10]="symbol-event",u[11]="symbol-operator",u[12]="symbol-unit",u[13]="symbol-value",u[14]="symbol-constant",u[15]="symbol-enum",u[16]="symbol-enum-member",u[17]="symbol-keyword",u[27]="symbol-snippet",u[18]="symbol-text",u[19]="symbol-color",u[20]="symbol-file",u[21]="symbol-reference",u[22]="symbol-customcolor",u[23]="symbol-folder",u[24]="symbol-type-parameter",u[25]="account",u[26]="issues",function(v){const R=u[v];let O=R&&y.iconRegistry.get(R);return O||(console.info("No codicon found for CompletionItemKind "+v),O=y.Codicon.symbolProperty),O.classNames}}(),e.completionKindFromString=function(){let u=Object.create(null);return u.method=0,u.function=1,u.constructor=2,u.field=3,u.variable=4,u.class=5,u.struct=6,u.interface=7,u.module=8,u.property=9,u.event=10,u.operator=11,u.unit=12,u.value=13,u.constant=14,u.enum=15,u["enum-member"]=16,u.enumMember=16,u.keyword=17,u.snippet=27,u.text=18,u.color=19,u.file=20,u.reference=21,u.customcolor=22,u.folder=23,u["type-parameter"]=24,u.typeParameter=24,u.account=25,u.issue=26,function(v,R){let O=u[v];return typeof O=="undefined"&&!R&&(O=9),O}}();var h;(function(u){u[u.Deprecated=1]="Deprecated"})(h=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(E=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var l;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(l=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function c(u){return u&&b.URI.isUri(u.uri)&&T.Range.isIRange(u.range)&&(T.Range.isIRange(u.originSelectionRange)||T.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=c;var t;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(u){u[u.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var s;(function(u){const v=new Map;v.set("file",0),v.set("module",1),v.set("namespace",2),v.set("package",3),v.set("class",4),v.set("method",5),v.set("property",6),v.set("field",7),v.set("constructor",8),v.set("enum",9),v.set("interface",10),v.set("function",11),v.set("variable",12),v.set("constant",13),v.set("string",14),v.set("number",15),v.set("boolean",16),v.set("array",17),v.set("object",18),v.set("key",19),v.set("null",20),v.set("enum-member",21),v.set("struct",22),v.set("event",23),v.set("operator",24),v.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function O(ie){return v.get(ie)}u.fromString=O;function H(ie){return R.get(ie)}u.toString=H;function ne(ie,U){const B=R.get(ie);let x=B&&y.iconRegistry.get("symbol-"+B);return x||(console.info("No codicon found for SymbolKind "+ie),x=y.Codicon.symbolProperty),`${U?"inline":"block"} ${x.classNames}`}u.toCssClassName=ne})(s=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(v){this.value=v}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var o;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(o=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var p;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(p=e.CommentMode||(e.CommentMode={}));var f;(function(u){u[u.Other=0]="Other",u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(f=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new C.LanguageFeatureRegistry,e.RenameProviderRegistry=new C.LanguageFeatureRegistry,e.CompletionProviderRegistry=new C.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new C.LanguageFeatureRegistry,e.HoverProviderRegistry=new C.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new C.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new C.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new C.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new C.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new C.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.LinkProviderRegistry=new C.LanguageFeatureRegistry,e.ColorProviderRegistry=new C.LanguageFeatureRegistry,e.SelectionRangeRegistry=new C.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var _;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(_=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[181],ge([0,1,6,11,4,3,58,56]),function(K,e,b,T,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,C.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new A.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(D,P){if(!D)throw new Error("invalid command");if(typeof D=="string"){if(!P)throw new Error("invalid command");return this.registerCommand({id:D,handler:P})}if(D.description){const a=[];for(let S of D.description.args)a.push(S.constraint);const h=D.handler;D.handler=function(S,...w){return(0,T.validateConstraints)(w,a),h(S,...w)}}const{id:i}=D;let I=this._commands.get(i);I||(I=new y.LinkedList,this._commands.set(i,I));let m=I.unshift(D),g=(0,b.toDisposable)(()=>{m();const a=this._commands.get(i);(a==null?void 0:a.isEmpty())&&this._commands.delete(i)});return this._onDidRegisterCommand.fire(i),g}registerCommandAlias(D,P){return e.CommandsRegistry.registerCommand(D,(i,...I)=>i.get(e.ICommandService).executeCommand(P,...I))}getCommand(D){const P=this._commands.get(D);if(!(!P||P.isEmpty()))return k.Iterable.first(P)}getCommands(){const D=new Map;for(const P of this._commands.keys()){const i=this.getCommand(P);i&&D.set(P,i)}return D}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>b.Disposable.None,onDidExecuteCommand:()=>b.Disposable.None,executeCommand(){return Promise.resolve(void 0)}},e.CommandsRegistry.registerCommand("noop",()=>{})}),define(me[82],ge([0,1,9,4,10]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=C.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",C.isMacintosh),y.set("isLinux",C.isLinux),y.set("isWindows",C.isWindows),y.set("isWeb",C.isWeb),y.set("isMacNative",C.isMacintosh&&!C.isWeb),y.set("isEdge",A.indexOf("Edg/")>=0),y.set("isFirefox",A.indexOf("Firefox")>=0),y.set("isChrome",A.indexOf("Chrome")>=0),y.set("isSafari",A.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var D;(function(u){u[u.False=0]="False",u[u.True=1]="True",u[u.Defined=2]="Defined",u[u.Not=3]="Not",u[u.Equals=4]="Equals",u[u.NotEquals=5]="NotEquals",u[u.And=6]="And",u[u.Regex=7]="Regex",u[u.NotRegex=8]="NotRegex",u[u.Or=9]="Or",u[u.In=10]="In",u[u.NotIn=11]="NotIn",u[u.Greater=12]="Greater",u[u.GreaterEquals=13]="GreaterEquals",u[u.Smaller=14]="Smaller",u[u.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return I.INSTANCE}static true(){return m.INSTANCE}static has(v){return g.create(v)}static equals(v,R){return a.create(v,R)}static notEquals(v,R){return w.create(v,R)}static regex(v,R){return n.create(v,R)}static in(v,R){return h.create(v,R)}static not(v){return E.create(v)}static and(...v){return r.create(v)}static or(...v){return o.create(v)}static greater(v,R){return d.create(v,R)}static less(v,R){return c.create(v,R)}static deserialize(v,R=!1){if(!!v)return this._deserializeOrExpression(v,R)}static _deserializeOrExpression(v,R){let O=v.split("||");return o.create(O.map(H=>this._deserializeAndExpression(H,R)))}static _deserializeAndExpression(v,R){let O=v.split("&&");return r.create(O.map(H=>this._deserializeOne(H,R)))}static _deserializeOne(v,R){if(v=v.trim(),v.indexOf("!=")>=0){let O=v.split("!=");return w.create(O[0].trim(),this._deserializeValue(O[1],R))}if(v.indexOf("==")>=0){let O=v.split("==");return a.create(O[0].trim(),this._deserializeValue(O[1],R))}if(v.indexOf("=~")>=0){let O=v.split("=~");return n.create(O[0].trim(),this._deserializeRegexValue(O[1],R))}if(v.indexOf(" in ")>=0){let O=v.split(" in ");return h.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(v)){const O=v.split(">=");return l.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(v)){const O=v.split(">");return d.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(v)){const O=v.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(v)){const O=v.split("<");return c.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(v)?E.create(v.substr(1).trim()):g.create(v)}static _deserializeValue(v,R){if(v=v.trim(),v==="true")return!0;if(v==="false")return!1;let O=/^'([^']*)'$/.exec(v);return O?O[1].trim():v}static _deserializeRegexValue(v,R){if((0,b.isFalsyOrWhitespace)(v)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=v.indexOf("/"),H=v.lastIndexOf("/");if(O===H||O<0){if(R)throw new Error(`bad regexp-value '${v}', missing /-enclosure`);return console.warn(`bad regexp-value '${v}', missing /-enclosure`),null}let ne=v.slice(O+1,H),ie=v[H+1]==="i"?"i":"";try{return new RegExp(ne,ie)}catch(U){if(R)throw new Error(`bad regexp-value '${v}', parse error: ${U}`);return console.warn(`bad regexp-value '${v}', parse error: ${U}`),null}}}e.ContextKeyExpr=P;function i(u,v){return u.cmp(v)}class I{constructor(){this.type=0}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}evaluate(v){return!1}serialize(){return"false"}keys(){return[]}map(v){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class m{constructor(){this.type=1}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}evaluate(v){return!0}serialize(){return"true"}keys(){return[]}map(v){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class g{constructor(v){this.key=v,this.type=2}static create(v){const R=y.get(v);return typeof R=="boolean"?R?m.INSTANCE:I.INSTANCE:new g(v)}cmp(v){return v.type!==this.type?this.type-v.type:f(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}evaluate(v){return!!v.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(v){return v.mapDefined(this.key)}negate(){return E.create(this.key)}}e.ContextKeyDefinedExpr=g;class a{constructor(v,R){this.key=v,this.value=R,this.type=4}static create(v,R){if(typeof R=="boolean")return R?g.create(v):E.create(v);const O=y.get(v);return typeof O=="boolean"?R===(O?"true":"false")?m.INSTANCE:I.INSTANCE:new a(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:_(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return v.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(v){return v.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class h{constructor(v,R){this.key=v,this.valueKey=R,this.type=10}static create(v,R){return new h(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:_(this.key,this.valueKey,v.key,v.valueKey)}equals(v){return v.type===this.type?this.key===v.key&&this.valueKey===v.valueKey:!1}evaluate(v){const R=v.getValue(this.valueKey),O=v.getValue(this.key);return Array.isArray(R)?R.indexOf(O)>=0:typeof O=="string"&&typeof R=="object"&&R!==null?k.call(R,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(v){return v.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=h;class S{constructor(v){this._actual=v,this.type=11}static create(v){return new S(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new S(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class w{constructor(v,R){this.key=v,this.value=R,this.type=5}static create(v,R){if(typeof R=="boolean")return R?E.create(v):g.create(v);const O=y.get(v);return typeof O=="boolean"?R===(O?"true":"false")?I.INSTANCE:m.INSTANCE:new w(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:_(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return v.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(v){return v.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class E{constructor(v){this.key=v,this.type=3}static create(v){const R=y.get(v);return typeof R=="boolean"?R?I.INSTANCE:m.INSTANCE:new E(v)}cmp(v){return v.type!==this.type?this.type-v.type:f(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}evaluate(v){return!v.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(v){return v.mapNot(this.key)}negate(){return g.create(this.key)}}e.ContextKeyNotExpr=E;class d{constructor(v,R){this.key=v,this.value=R,this.type=12}static create(v,R){return new d(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:_(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=d;class l{constructor(v,R){this.key=v,this.value=R,this.type=13}static create(v,R){return new l(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:_(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreaterEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=l;class c{constructor(v,R){this.key=v,this.value=R,this.type=14}static create(v,R){return new c(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:_(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmaller(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerExpr=c;class t{constructor(v,R){this.key=v,this.value=R,this.type=15}static create(v,R){return new t(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:_(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmallerEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(v,R){this.key=v,this.regexp=R,this.type=7}static create(v,R){return new n(v,R)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.key<v.key)return-1;if(this.key>v.key)return 1;const R=this.regexp?this.regexp.source:"",O=v.regexp?v.regexp.source:"";return R<O?-1:R>O?1:0}equals(v){if(v.type===this.type){const R=this.regexp?this.regexp.source:"",O=v.regexp?v.regexp.source:"";return this.key===v.key&&R===O}return!1}evaluate(v){let R=v.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const v=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${v}`}keys(){return[this.key]}map(v){return v.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=n;class s{constructor(v){this._actual=v,this.type=8}static create(v){return new s(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new s(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class r{constructor(v){this.expr=v,this.type=6}static create(v){return r._normalizeArr(v)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let R=0,O=this.expr.length;R<O;R++){const H=i(this.expr[R],v.expr[R]);if(H!==0)return H}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let R=0,O=this.expr.length;R<O;R++)if(!this.expr[R].equals(v.expr[R]))return!1;return!0}return!1}evaluate(v){for(let R=0,O=this.expr.length;R<O;R++)if(!this.expr[R].evaluate(v))return!1;return!0}static _normalizeArr(v){const R=[];let O=!1;for(const H of v)if(!!H){if(H.type===1){O=!0;continue}if(H.type===0)return I.INSTANCE;if(H.type===6){R.push(...H.expr);continue}R.push(H)}if(R.length===0&&O)return m.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(i);R.length>1;){const H=R[R.length-1];if(H.type!==9)break;R.pop();const ne=R.pop(),ie=o.create(H.expr.map(U=>r.create([U,ne])));ie&&(R.push(ie),R.sort(i))}return R.length===1?R[0]:new r(R)}}serialize(){return this.expr.map(v=>v.serialize()).join(" && ")}keys(){const v=[];for(let R of this.expr)v.push(...R.keys());return v}map(v){return new r(this.expr.map(R=>R.map(v)))}negate(){let v=[];for(let R of this.expr)v.push(R.negate());return o.create(v)}}e.ContextKeyAndExpr=r;class o{constructor(v){this.expr=v,this.type=9}static create(v){const R=o._normalizeArr(v);if(R.length!==0)return R.length===1?R[0]:new o(R)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let R=0,O=this.expr.length;R<O;R++){const H=i(this.expr[R],v.expr[R]);if(H!==0)return H}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let R=0,O=this.expr.length;R<O;R++)if(!this.expr[R].equals(v.expr[R]))return!1;return!0}return!1}evaluate(v){for(let R=0,O=this.expr.length;R<O;R++)if(this.expr[R].evaluate(v))return!0;return!1}static _normalizeArr(v){let R=[],O=!1;if(v){for(let H=0,ne=v.length;H<ne;H++){const ie=v[H];if(!!ie){if(ie.type===0){O=!0;continue}if(ie.type===1)return[m.INSTANCE];if(ie.type===9){R=R.concat(ie.expr);continue}R.push(ie)}}if(R.length===0&&O)return[I.INSTANCE];R.sort(i)}return R}serialize(){return this.expr.map(v=>v.serialize()).join(" || ")}keys(){const v=[];for(let R of this.expr)v.push(...R.keys());return v}map(v){return new o(this.expr.map(R=>R.map(v)))}negate(){let v=[];for(let O of this.expr)v.push(O.negate());const R=O=>O.type===9?O.expr:[O];for(;v.length>1;){const O=v.shift(),H=v.shift(),ne=[];for(const ie of R(O))for(const U of R(H))ne.push(P.and(ie,U));v.unshift(P.or(...ne))}return v[0]}}e.ContextKeyOrExpr=o;class p extends g{constructor(v,R,O){super(v);this._defaultValue=R,typeof O=="object"?p._info.push(Object.assign(Object.assign({},O),{key:v})):O!==!0&&p._info.push({key:v,description:O,type:R!=null?typeof R:void 0})}static all(){return p._info.values()}bindTo(v){return v.createKey(this.key,this._defaultValue)}getValue(v){return v.getContextKeyValue(this.key)}toNegated(){return P.not(this.key)}isEqualTo(v){return P.equals(this.key,v)}notEqualsTo(v){return P.notEquals(this.key,v)}}e.RawContextKey=p,p._info=[],e.IContextKeyService=(0,T.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(u,v){return u<v?-1:u>v?1:0}function _(u,v,R,O){return u<R?-1:u>R?1:v<O?-1:v>O?1:0}}),define(me[182],ge([0,1,4]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,b.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,b.refineServiceDecorator)(e.IEnvironmentService)}),define(me[183],ge([0,1,154,4,13]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function A(I){return I&&typeof I=="object"&&typeof I.id=="string"&&(!I.uuid||typeof I.uuid=="string")}e.isIExtensionIdentifier=A;var y;(function(I){I[I.NoneOrRelevance=0]="NoneOrRelevance",I[I.LastUpdatedDate=1]="LastUpdatedDate",I[I.Title=2]="Title",I[I.PublisherName=3]="PublisherName",I[I.InstallCount=4]="InstallCount",I[I.PublishedDate=5]="PublishedDate",I[I.AverageRating=6]="AverageRating",I[I.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var k;(function(I){I[I.Default=0]="Default",I[I.Ascending=1]="Ascending",I[I.Descending=2]="Descending"})(k=e.SortOrder||(e.SortOrder={}));var D;(function(I){I.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var P;(function(I){I[I.None=0]="None",I[I.Install=1]="Install",I[I.Update=2]="Update"})(P=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(m,g){super(m);this.code=g}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,b.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,b.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,T.createDecorator)("IExtensionManagementCLIService")}),define(me[27],ge([0,1,9,4]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function C(P){return P&&typeof P=="object"&&typeof P.id=="string"&&(!P.uuid||typeof P.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(P){P[P.System=0]="System",P[P.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class y{constructor(i){this.value=i,this._lower=i.toLowerCase()}static equals(i,I){if(typeof i=="undefined"||i===null)return typeof I=="undefined"||I===null;if(typeof I=="undefined"||I===null)return!1;if(typeof i=="string"||typeof I=="string"){let m=typeof i=="string"?i:i.value,g=typeof I=="string"?I:I.value;return b.equalsIgnoreCase(m,g)}return i._lower===I._lower}static toKey(i){return typeof i=="string"?i.toLowerCase():i._lower}}e.ExtensionIdentifier=y;function k(P){return P.contributes&&P.contributes.localizations?P.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function D(P){return P.contributes&&P.contributes.authentication?P.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=D,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[184],ge([0,1,9,27]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function C(g,a){return g.uuid&&a.uuid?g.uuid===a.uuid:g.id===a.id?!0:(0,b.compareIgnoreCase)(g.id,a.id)===0}e.areSameExtensions=C;class A{constructor(a,h){this.version=h,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof A?C(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=A;function y(g,a){return`${g}.${a}`}e.getExtensionId=y;function k(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function D(g,a){return k(y(g,a))}e.getGalleryExtensionId=D;function P(g,a){const h=[],S=w=>{for(const E of h)if(E.some(d=>C(a(d),a(w))))return E;return null};for(const w of g){const E=S(w);E?E.push(w):h.push([w])}return h}e.groupByExtension=P;function i(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(g){return Object.assign({id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0)},g.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function m(g){const a=new Set;for(const h of g)h.malicious&&a.add(h.id.id);return a}e.getMaliciousExtensionsSet=m}),define(me[185],ge([0,1,4]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,b.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,b.createDecorator)("externalTerminal")}),define(me[45],ge([0,1,157,8,2,4,9,11,22]),function(K,e,b,T,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,A.createDecorator)("fileService");function P(U){return U.create===!0}e.isFileOpenForWriteOptions=P;var i;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(U){U[U.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var m;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=g;function a(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=a;function h(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function S(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=S;var w;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(B,x){super(B);this.code=x}}e.FileSystemProviderError=E;function d(U,B){const x=new E(U.toString(),B);return c(x,B),x}e.createFileSystemProviderError=d;function l(U){return U||d((0,b.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=l;function c(U,B){return U.name=B?`${B} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=c;function t(U){if(!U)return w.Unknown;if(U instanceof E)return U.code;const B=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!B)return w.Unknown;switch(B[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function n(U){if(U instanceof _)return U.fileOperationResult;switch(t(U)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var s;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class r{constructor(B,x,L){this.resource=B,this.operation=x,this.target=L}isOperation(B){return this.operation===B}}e.FileOperationEvent=r;var o;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class p{constructor(B,x){this.ignorePathCasing=x,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=B;for(const L of B)switch(L.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(L.resource,L);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(L.resource,L);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(L.resource,L);break}}contains(B,...x){return this.doContains(B,{includeChildren:!1},...x)}affects(B,...x){return this.doContains(B,{includeChildren:!0},...x)}doContains(B,x,...L){var N,F,M,$,q,G;if(!B)return!1;const le=L.length>0;return!!((!le||L.includes(1))&&(((N=this.added)===null||N===void 0?void 0:N.get(B))||x.includeChildren&&((F=this.added)===null||F===void 0?void 0:F.findSuperstr(B)))||(!le||L.includes(0))&&(((M=this.updated)===null||M===void 0?void 0:M.get(B))||x.includeChildren&&(($=this.updated)===null||$===void 0?void 0:$.findSuperstr(B)))||(!le||L.includes(2))&&(((q=this.deleted)===null||q===void 0?void 0:q.findSubstr(B))||x.includeChildren&&((G=this.deleted)===null||G===void 0?void 0:G.findSuperstr(B))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(B){const x=[],L=B===1?this.added:B===0?this.updated:this.deleted;if(L)for(const[,N]of L)x.push(N);return x}filter(B){return new p(this.changes.filter(x=>B(x)),this.ignorePathCasing)}}e.FileChangesEvent=p;function f(U,B,x){return!U||!B||U===B||B.length>U.length?!1:(B.charAt(B.length-1)!==T.sep&&(B+=T.sep),x?(0,y.startsWithIgnoreCase)(U,B):U.indexOf(B)===0)}e.isParent=f;class _ extends Error{constructor(B,x,L){super(B);this.fileOperationResult=x,this.options=L}static isFileOperationError(B){return B instanceof Error&&!(0,k.isUndefinedOrNull)(B.fileOperationResult)}}e.FileOperationError=_;var u;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(u=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var v;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(v=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=R;async function O(U,B){if(!B.canHandleResource(C.URI.from({scheme:U.scheme})))return new Promise(x=>{const L=B.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===U.scheme&&N.added&&(L.dispose(),x())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class H{static formatSize(B){return(0,k.isNumber)(B)||(B=0),B<H.KB?(0,b.localize)(1,null,B.toFixed(0)):B<H.MB?(0,b.localize)(2,null,(B/H.KB).toFixed(2)):B<H.GB?(0,b.localize)(3,null,(B/H.MB).toFixed(2)):B<H.TB?(0,b.localize)(4,null,(B/H.GB).toFixed(2)):(0,b.localize)(5,null,(B/H.TB).toFixed(2))}}e.ByteSize=H,H.KB=1024,H.MB=H.KB*H.KB,H.GB=H.MB*H.KB,H.TB=H.GB*H.KB;var ne;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(ne=e.Arch||(e.Arch={}));function ie(U){return{maxFileSize:U===0?300*H.MB:16*H.GB,maxHeapSize:U===0?700*H.MB:2*700*H.MB}}e.getPlatformLimits=ie}),define(me[83],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class b{constructor(...C){this._entries=new Map;for(let[A,y]of C)this.set(A,y)}set(C,A){const y=this._entries.get(C);return this._entries.set(C,A),y}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=b}),define(me[186],ge([0,1,17,178,114,4,83,14]),function(K,e,b,T,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class P extends Error{constructor(a){var h;super("cyclic dependency between services");this.message=(h=a.findCycleSlow())!==null&&h!==void 0?h:`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class i{constructor(a=new y.ServiceCollection,h=!1,S){this._activeInstantiations=new Set,this._services=a,this._strict=h,this._parent=S,this._services.set(A.IInstantiationService,this)}createChild(a){return new i(a,this._strict,this)}invokeFunction(a,...h){let S=m.traceInvocation(a),w=!1;try{return a({get:(d,l)=>{if(w)throw(0,b.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(d,S);if(!c&&l!==A.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return c}},...h)}finally{w=!0,S.stop()}}createInstance(a,...h){let S,w;return a instanceof C.SyncDescriptor?(S=m.traceCreation(a.ctor),w=this._createInstance(a.ctor,a.staticArguments.concat(h),S)):(S=m.traceCreation(a),w=this._createInstance(a,h,S)),S.stop(),w}_createInstance(a,h=[],S){let w=A._util.getServiceDependencies(a).sort((l,c)=>l.index-c.index),E=[];for(const l of w){let c=this._getOrCreateServiceInstance(l.id,S);if(!c&&this._strict&&!l.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${l.id}.`);E.push(c)}let d=w.length>0?w[0].index:h.length;if(h.length!==d){console.warn(`[createInstance] First service dependency of ${a.name} at position ${d+1} conflicts with ${h.length} static arguments`);let l=d-h.length;l>0?h=h.concat(new Array(l)):h=h.slice(0,d)}return new a(...[...h,...E])}_setServiceInstance(a,h){if(this._services.get(a)instanceof C.SyncDescriptor)this._services.set(a,h);else if(this._parent)this._parent._setServiceInstance(a,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let h=this._services.get(a);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):h}_getOrCreateServiceInstance(a,h){let S=this._getServiceInstanceOrDescriptor(a);return S instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,S,h.branch(a,!0)):(h.branch(a,!1),S)}_safeCreateAndCacheServiceInstance(a,h,S){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,h,S)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,h,S){const w=new T.Graph(l=>l.id.toString());let E=0;const d=[{id:a,desc:h,_trace:S}];for(;d.length;){const l=d.pop();if(w.lookupOrInsertNode(l),E++>1e3)throw new P(w);for(let c of A._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(c.id);if(!t&&!c.optional&&console.warn(`[createInstance] ${a} depends on ${c.id} which is NOT registered.`),t instanceof C.SyncDescriptor){const n={id:c.id,desc:t,_trace:l._trace.branch(c.id,!0)};w.insertEdge(l,n),d.push(n)}}}for(;;){const l=w.roots();if(l.length===0){if(!w.isEmpty())throw new P(w);break}for(const{data:c}of l){if(this._getServiceInstanceOrDescriptor(c.id)instanceof C.SyncDescriptor){const n=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,n)}w.removeNode(c)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,h,S=[],w,E){if(this._services.get(a)instanceof C.SyncDescriptor)return this._createServiceInstance(h,S,w,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,h,S,w,E);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(a,h=[],S,w){if(S){const E=new k.IdleValue(()=>this._createInstance(a,h,w));return new Proxy(Object.create(null),{get(d,l){if(l in d)return d[l];let c=E.value,t=c[l];return typeof t!="function"||(t=t.bind(c),d[l]=t),t},set(d,l,c){return E.value[l]=c,!0}})}else return this._createInstance(a,h,w)}}e.InstantiationService=i;var I;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(I||(I={}));class m{constructor(a,h){this.type=a,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return D?new m(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(a){return D?new m(0,a.name):m._None}branch(a,h){let S=new m(2,a.toString());return this._dep.push([a,h,S]),S}stop(){let a=Date.now()-this._start;m._totals+=a;let h=!1;function S(E,d){let l=[],c=new Array(E+1).join("	");for(const[t,n,s]of d._dep)if(n&&s){h=!0,l.push(`${c}CREATES -> ${t}`);let r=S(E+1,s);r&&l.push(r)}else l.push(`${c}uses -> ${t}`);return l.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(a>2||h)&&console.log(w.join(`
`))}}m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(me[12],ge([0,1,4,6,10,3,61]),function(K,e,b,T,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function k(){return new Date().toISOString()}var D;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class P extends T.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class i extends P{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(D.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(D.Error,this.format(s))}else this.log(D.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let s=0;s<t.length;s++){let r=t[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch(o){}n+=(s>0?" ":"")+r}return n}}e.AbstractMessageLogger=i;class I extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!C.isWindows}trace(t,...n){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...n):console.log(`[main ${k()}]`,t,...n))}debug(t,...n){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...n):console.log(`[main ${k()}]`,t,...n))}info(t,...n){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...n):console.log(`[main ${k()}]`,t,...n))}warn(t,...n){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,t,...n):console.warn(`[main ${k()}]`,t,...n))}error(t,...n){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,t,...n):console.error(`[main ${k()}]`,t,...n))}critical(t,...n){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,t,...n):console.error(`[main ${k()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class m extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=m;class g extends P{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,y.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class a extends P{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const s of this.logServices)s.trace(t,...n)}debug(t,...n){for(const s of this.logServices)s.debug(t,...n)}info(t,...n){for(const s of this.logServices)s.info(t,...n)}warn(t,...n){for(const s of this.logServices)s.warn(t,...n)}error(t,...n){for(const s of this.logServices)s.error(t,...n)}critical(t,...n){for(const s of this.logServices)s.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=a;class h extends T.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=h;class S extends T.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(s))}))}createLogger(t,n){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(n==null?void 0:n.always)?D.Trace:this.logLevel,n),this.loggers.set(t.toString(),s),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class w{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=w;function E(c){if(c.verbose)return D.Trace;if(typeof c.logLevel=="string"){const t=d(c.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function d(c){switch(c){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=d;function l(c){switch(c){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=l}),define(me[115],ge([0,1,12,45]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function C(D,P,i,I){try{return(await new Promise((g,a)=>{K(["spdlog"],g,a)})).createAsyncRotatingLogger(D,P,i,I)}catch(m){console.error(m)}return null}function A(D,P,i,I){return K.__$__nodeRequire("spdlog").createRotatingLogger(D,P,i,I)}e.createRotatingLogger=A;function y(D,P,i){switch(P){case b.LogLevel.Trace:D.trace(i);break;case b.LogLevel.Debug:D.debug(i);break;case b.LogLevel.Info:D.info(i);break;case b.LogLevel.Warning:D.warn(i);break;case b.LogLevel.Error:D.error(i);break;case b.LogLevel.Critical:D.critical(i);break;default:throw new Error("Invalid log level")}}class k extends b.AbstractMessageLogger{constructor(P,i,I,m){super();this.name=P,this.filepath=i,this.rotating=I,this.buffer=[],this.setLevel(m),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(g=>{this._logger&&this._logger.setLevel(g)}))}_createSpdLogLogger(){const P=this.rotating?6:1,i=30/P*T.ByteSize.MB;return C(this.name,this.filepath,i,P).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:m,message:g}of this.buffer)y(this._logger,m,g);this.buffer=[]}})}log(P,i){this._logger?y(this._logger,P,i):this.getLevel()<=P&&this.buffer.push({level:P,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(me[116],ge([0,1,4,158,59]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var y;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function P(a,h){return h-a}D.compare=P;const i=Object.create(null);i[D.Error]=(0,T.localize)(0,null),i[D.Warning]=(0,T.localize)(1,null),i[D.Info]=(0,T.localize)(2,null);function I(a){return i[a]||""}D.toString=I;function m(a){switch(a){case C.default.Error:return D.Error;case C.default.Warning:return D.Warning;case C.default.Info:return D.Info;case C.default.Ignore:return D.Hint}}D.fromSeverity=m;function g(a){switch(a){case D.Error:return C.default.Error;case D.Warning:return C.default.Warning;case D.Info:return C.default.Info;case D.Hint:return C.default.Ignore}}D.toSeverity=g}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(D){const P="";function i(m){return I(m,!0)}D.makeKey=i;function I(m,g){let a=[P];return m.source?a.push(m.source.replace("\xA6","\\\xA6")):a.push(P),m.code?typeof m.code=="string"?a.push(m.code.replace("\xA6","\\\xA6")):a.push(m.code.value.replace("\xA6","\\\xA6")):a.push(P),m.severity!==void 0&&m.severity!==null?a.push(y.toString(m.severity)):a.push(P),m.message&&g?a.push(m.message.replace("\xA6","\\\xA6")):a.push(P),m.startLineNumber!==void 0&&m.startLineNumber!==null?a.push(m.startLineNumber.toString()):a.push(P),m.startColumn!==void 0&&m.startColumn!==null?a.push(m.startColumn.toString()):a.push(P),m.endLineNumber!==void 0&&m.endLineNumber!==null?a.push(m.endLineNumber.toString()):a.push(P),m.endColumn!==void 0&&m.endColumn!==null?a.push(m.endColumn.toString()):a.push(P),a.push(P),a.join("\xA6")}D.makeKeyOptionalMessage=I})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(me[187],ge([0,1,59,4,3]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=b.default,e.INotificationService=(0,T.createDecorator)("notificationService");var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new D,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=k;class D{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=D}),define(me[188],ge([0,1,13,10,36,25]),function(K,e,b,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof T.globals.vscode!="undefined"&&typeof T.globals.vscode.context!="undefined"){const k=T.globals.vscode.context.configuration();if(k)y=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(K==null?void 0:K.__$__nodeRequire)=="function"){const k=(0,A.dirname)(b.FileAccess.asFileUri("",K));y=K.__$__nodeRequire((0,A.joinPath)(k,"product.json").fsPath);const D=K.__$__nodeRequire((0,A.joinPath)(k,"package.json").fsPath);C.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`}),Object.assign(y,{version:D.version})}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.57.0-dev",nameShort:T.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:T.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=y});var He=this&&this.__param||function(K,e){return function(b,T){e(b,T,K)}};define(me[117],ge([0,1,4,21,6,14]),function(K,e,b,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,b.createDecorator)("progressService");var y;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let D=class extends C.Disposable{constructor(I,m){super();this.deferred=new A.DeferredPromise,m.withProgress(I,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register((0,C.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};D=qe([He(1,e.IProgressService)],D),e.UnmanagedProgress=D;class P extends C.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(I){this.stop();const m=++this.currentOperationId,g=new T.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{m===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,C.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,C.toDisposable)(()=>g.cancel())),this.currentOperationDisposables.add((0,C.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:m,token:g.token,stop:()=>this.doStop(m),isCurrent:()=>this.currentOperationId===m}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,b.createDecorator)("editorProgressService")}),define(me[40],ge([0,1,11,53]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(y,k){T.ok(b.isString(y)),T.ok(b.isObject(k)),T.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,k)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new C}),define(me[118],ge([0,1,40,3]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class A{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,P){this.schemasById[C(D)]=P,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new A;b.Registry.add(e.Extensions.JSONContribution,y)}),define(me[84],ge([0,1,153,3,40,11,118]),function(K,e,b,T,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=C.Registry.as(y.Extensions.JSONContribution);class P{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:b.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,E=!0){this.registerConfigurations([w],E)}registerConfigurations(w,E=!0){const d=[];w.forEach(l=>{d.push(...this.validateAndRegisterProperties(l,E,l.extensionInfo)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterConfigurations(w){const E=[],d=l=>{if(l.properties)for(const c in l.properties)E.push(c),delete this.configurationProperties[c],this.removeFromSchema(c,l.properties[c]);l.allOf&&l.allOf.forEach(c=>d(c))};for(const l of w){d(l);const c=this.configurationContributors.indexOf(l);c!==-1&&this.configurationContributors.splice(c,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}registerDefaultConfigurations(w){const E=[],d=[];for(const l of w)for(const c in l)if(E.push(c),e.OVERRIDE_PROPERTY_PATTERN.test(c)){this.defaultValues[c]=Object.assign(Object.assign({},this.defaultValues[c]||{}),l[c]);const t={type:"object",default:this.defaultValues[c],description:b.localize(1,null,c),$ref:e.resourceLanguageSettingsSchemaId};d.push(I(c)),this.configurationProperties[c]=t,this.defaultLanguageConfigurationOverridesNode.properties[c]=t}else{this.defaultValues[c]=l[c];const t=this.configurationProperties[c];t&&(this.updatePropertyDefaultValue(c,t),this.updateSchema(c,t))}this.registerOverrideIdentifiers(d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}deregisterDefaultConfigurations(w){const E=[];for(const d of w)for(const l in d)if(E.push(l),delete this.defaultValues[l],e.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const c=this.configurationProperties[l];c&&(this.updatePropertyDefaultValue(l,c),this.updateSchema(l,c))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const E of w)this.overrideIdentifiers.add(E);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,E=!0,d,l=3){var c;l=A.isUndefinedOrNull(w.scope)?l:w.scope;let t=[],n=w.properties;if(n)for(let r in n){if(E&&a(r)){delete n[r];continue}const o=n[r];if(this.updatePropertyDefaultValue(r,o),e.OVERRIDE_PROPERTY_PATTERN.test(r)?o.scope=void 0:(o.scope=A.isUndefinedOrNull(o.scope)?l:o.scope,o.restricted=A.isUndefinedOrNull(o.restricted)?!!((c=d==null?void 0:d.restrictedConfigurations)===null||c===void 0?void 0:c.includes(r)):o.restricted),n[r].hasOwnProperty("included")&&!n[r].included){this.excludedConfigurationProperties[r]=n[r],delete n[r];continue}else this.configurationProperties[r]=n[r];!n[r].deprecationMessage&&n[r].markdownDeprecationMessage&&(n[r].deprecationMessage=n[r].markdownDeprecationMessage),t.push(r)}let s=w.allOf;if(s)for(let r of s)t.push(...this.validateAndRegisterProperties(r,E,d,l));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const E=d=>{let l=d.properties;if(l)for(const t in l)this.updateSchema(t,l[t]);let c=d.allOf;c&&c.forEach(E)};E(w)}updateSchema(w,E){switch(e.allSettings.properties[w]=E,E.scope){case 1:e.applicationSettings.properties[w]=E;break;case 2:e.machineSettings.properties[w]=E;break;case 6:e.machineOverridableSettings.properties[w]=E;break;case 3:e.windowSettings.properties[w]=E;break;case 4:e.resourceSettings.properties[w]=E;break;case 5:e.resourceSettings.properties[w]=E,this.resourceLanguageSettingsSchema.properties[w]=E;break}}removeFromSchema(w,E){switch(delete e.allSettings.properties[w],E.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const E=`[${w}]`,d={type:"object",description:b.localize(2,null),errorMessage:b.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(E,d),e.allSettings.properties[E]=d,e.applicationSettings.properties[E]=d,e.machineSettings.properties[E]=d,e.machineOverridableSettings.properties[E]=d,e.windowSettings.properties[E]=d,e.resourceSettings.properties[E]=d}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,E){let d=this.defaultValues[w];A.isUndefined(d)&&(d=E.default),A.isUndefined(d)&&(d=m(E.type)),E.default=d}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function I(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=I;function m(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const g=new P;C.Registry.add(e.Extensions.Configuration,g);function a(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?b.localize(5,null,S):g.getConfigurationProperties()[S]!==void 0?b.localize(6,null,S):null:b.localize(4,null)}e.validateProperty=a;function h(){const S=[],w=g.getConfigurationProperties();for(const E of Object.keys(w))S.push([E,w[E].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=h}),define(me[85],ge([0,1,24,11,2,40,4,84]),function(K,e,b,T,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function D(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof C.URI)}e.isConfigurationOverrides=D;var P;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(n,s){const r=s?n?s.keys.filter(R=>n.keys.indexOf(R)===-1):[...s.keys]:[],o=n?s?n.keys.filter(R=>s.keys.indexOf(R)===-1):[...n.keys]:[],p=[];if(s&&n){for(const R of n.keys)if(s.keys.indexOf(R)!==-1){const O=w(n.contents,R),H=w(s.contents,R);b.equals(O,H)||p.push(R)}}const f=[],_=R=>{const O={};for(const H of R)for(const ne of H.identifiers)O[c(ne)]=H;return O},u=s?_(s.overrides):{},v=n?_(n.overrides):{};if(Object.keys(u).length)for(const R of r){const O=u[R];O&&f.push([(0,k.overrideIdentifierFromKey)(R),O.keys])}if(Object.keys(v).length)for(const R of o){const O=v[R];O&&f.push([(0,k.overrideIdentifierFromKey)(R),O.keys])}if(Object.keys(u).length&&Object.keys(v).length)for(const R of p){const O=v[R],H=u[R];if(O&&H){const ne=I({contents:O.contents,keys:O.keys,overrides:[]},{contents:H.contents,keys:H.keys,overrides:[]});f.push([(0,k.overrideIdentifierFromKey)(R),[...ne.added,...ne.removed,...ne.updated]])}}return{added:r,removed:o,updated:p,overrides:f}}e.compare=I;function m(n,s){const r=[];for(const o of Object.keys(n))if(k.OVERRIDE_PROPERTY_PATTERN.test(o)){const p={};for(const f in n[o])p[f]=n[o][f];r.push({identifiers:[(0,k.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(p),contents:g(p,s)})}return r}e.toOverrides=m;function g(n,s){const r=Object.create(null);for(let o in n)a(r,o,n[o],s);return r}e.toValuesTree=g;function a(n,s,r,o){const p=s.split("."),f=p.pop();let _=n;for(let u=0;u<p.length;u++){let v=p[u],R=_[v];switch(typeof R){case"undefined":R=_[v]=Object.create(null);break;case"object":break;default:o(`Ignoring ${s} as ${p.slice(0,u+1).join(".")} is ${JSON.stringify(R)}`);return}_=R}if(typeof _=="object"&&_!==null)try{_[f]=r}catch(u){o(`Ignoring ${s} as ${p.join(".")} is ${JSON.stringify(_)}`)}else o(`Ignoring ${s} as ${p.join(".")} is ${JSON.stringify(_)}`)}e.addToValueTree=a;function h(n,s){const r=s.split(".");S(n,r)}e.removeFromValueTree=h;function S(n,s){const r=s.shift();if(s.length===0){delete n[r];return}if(Object.keys(n).indexOf(r)!==-1){const o=n[r];typeof o=="object"&&!Array.isArray(o)&&(S(o,s),Object.keys(o).length===0&&delete n[r])}}function w(n,s,r){function o(_,u){let v=_;for(const R of u){if(typeof v!="object"||v===null)return;v=v[R]}return v}const p=s.split("."),f=o(n,p);return typeof f=="undefined"?r:f}e.getConfigurationValue=w;function E(n,s,r){Object.keys(s).forEach(o=>{o!=="__proto__"&&(o in n?T.isObject(n[o])&&T.isObject(s[o])?E(n[o],s[o],r):r&&(n[o]=s[o]):n[o]=s[o])})}e.merge=E;function d(){const n=A.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=d;function l(){const n=Object.create(null),s=A.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let r in s){let o=s[r].default;a(n,r,o,p=>console.error(`Conflict in default settings: ${p}`))}return n}e.getDefaultValues=l;function c(n){return`[${n}]`}e.keyFromOverrideIdentifier=c;function t(n,s,r){const o=n.inspect(s),p=n.inspect(r);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:o.defaultValue}e.getMigratedSettingValue=t}),define(me[189],ge([0,1,57,22,16,11,24,2,84,85,40,6,3]),function(K,e,b,T,C,A,y,k,D,P,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(t={},n=[],s=[]){this._contents=t,this._keys=n,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,P.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const s=this.getContentsForOverrideIdentifer(n);return s?t?(0,P.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const r of C.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[r],p=n[r];p&&(typeof o=="object"&&typeof p=="object"?(o=y.deepClone(o),this.mergeContents(o,p)):o=p),s[r]=o}return new g(s,this.keys,this.overrides)}merge(...t){const n=y.deepClone(this.contents),s=y.deepClone(this.overrides),r=[...this.keys];for(const o of t){this.mergeContents(n,o.contents);for(const p of o.overrides){const[f]=s.filter(_=>C.equals(_.identifiers,p.identifiers));f?this.mergeContents(f.contents,p.contents):s.push(y.deepClone(p))}for(const p of o.keys)r.indexOf(p)===-1&&r.push(p)}return new g(n,r,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const s of Object.keys(n)){if(s in t&&A.isObject(t[s])&&A.isObject(n[s])){this.mergeContents(t[s],n[s]);continue}t[s]=y.deepClone(n[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,P.addToValueTree)(this.contents,t,n,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,P.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let s=0;s<n;s++)t.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=g;class a extends g{constructor(){const t=(0,P.getDefaultValues)(),n=(0,P.getConfigurationKeys)(),s=[];for(const r of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(r)&&s.push({identifiers:[(0,D.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,P.toValuesTree)(t[r],o=>console.error(`Conflict in default settings file: ${o}`))});super(t,n,s)}}e.DefaultConfigurationModel=a;class h{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!A.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:s,keys:r,overrides:o,restricted:p}=this.doParseRaw(t,n);this._configurationModel=new g(s,r,o),this._restrictedConfigurations=p||[]}doParseContent(t){let n={},s=null,r=[],o=[],p=[];function f(u){Array.isArray(r)?r.push(u):s&&(r[s]=u)}let _={onObjectBegin:()=>{let u={};f(u),o.push(r),r=u,s=null},onObjectProperty:u=>{s=u},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{let u=[];f(u),o.push(r),r=u,s=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:f,onError:(u,v,R)=>{p.push({error:u,offset:v,length:R})}};if(t)try{b.visit(t,_),n=r[0]||{}}catch(u){console.error(`Error while parsing settings file ${this._name}: ${u}`),this._parseErrors=[u]}return n}doParseRaw(t,n){const s=i.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,s,!0,n);t=r.raw;const o=(0,P.toValuesTree)(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),p=Object.keys(t),f=(0,P.toOverrides)(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:o,keys:p,overrides:f,restricted:r.restricted}}filter(t,n,s,r){if(!(r==null?void 0:r.scopes)&&!(r==null?void 0:r.skipRestricted))return{raw:t,restricted:[]};const o={},p=[];for(let f in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(f)&&s){const _=this.filter(t[f],n,!1,r);o[f]=_.raw,p.push(..._.restricted)}else{const _=n[f],u=_?typeof _.scope!="undefined"?_.scope:3:void 0;(_==null?void 0:_.restricted)&&p.push(f),(u===void 0||r.scopes===void 0||r.scopes.includes(u))&&(r.skipRestricted&&(_==null?void 0:_.restricted)||(o[f]=t[f]))}return{raw:o,restricted:p}}}e.ConfigurationModelParser=h;class S extends I.Disposable{constructor(t,n,s,r){super();this.userSettingsResource=t,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new m.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(m.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class w{constructor(t,n,s=new g,r=new g,o=new T.ResourceMap,p=new g,f=new T.ResourceMap,_=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=r,this._folderConfigurations=o,this._memoryConfiguration=p,this._memoryConfigurationByResource=f,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(t,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(t)}updateValue(t,n,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new g,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(t):r.setValue(t,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,s){const r=this.getConsolidateConfigurationModel(n,s),o=this.getFolderConfigurationModelForResource(n.resource,s),p=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,f=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),_=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),u=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),v=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=o?n.overrideIdentifier?o.freeze().override(n.overrideIdentifier).getValue(t):o.freeze().getValue(t):void 0,H=n.overrideIdentifier?p.override(n.overrideIdentifier).getValue(t):p.getValue(t),ne=r.getValue(t),ie=C.distinct(C.flatten(r.overrides.map(U=>U.identifiers))).filter(U=>r.getOverrideValue(t,U)!==void 0);return{defaultValue:f,userValue:_,userLocalValue:u,userRemoteValue:v,workspaceValue:R,workspaceFolderValue:O,memoryValue:H,value:ne,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:u!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:v!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:o==null?void 0:o.freeze().getValue(t),override:n.overrideIdentifier?o==null?void 0:o.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:H!==void 0?{value:p.getValue(t),override:n.overrideIdentifier?p.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ie.length?ie:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=n.filter(r=>D.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const o=(0,D.overrideIdentifierFromKey)(r),p=this._defaultConfiguration.getKeysForOverrideIdentifier(o),f=t.getKeysForOverrideIdentifier(o),_=[...f.filter(u=>p.indexOf(u)===-1),...p.filter(u=>f.indexOf(u)===-1),...p.filter(u=>!y.equals(this._defaultConfiguration.override(o).getValue(u),t.override(o).getValue(u)))];return[o,_]});return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:r,overrides:o}=(0,P.compare)(this.localUserConfiguration,t),p=[...n,...s,...r];return p.length&&this.updateLocalUserConfiguration(t),{keys:p,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:r,overrides:o}=(0,P.compare)(this.remoteUserConfiguration,t);let p=[...n,...s,...r];return p.length&&this.updateRemoteUserConfiguration(t),{keys:p,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:r,overrides:o}=(0,P.compare)(this.workspaceConfiguration,t);let p=[...n,...s,...r];return p.length&&this.updateWorkspaceConfiguration(t),{keys:p,overrides:o}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:r,updated:o,removed:p,overrides:f}=(0,P.compare)(s,n);let _=[...r,...o,...p];return(_.length||!s)&&this.updateFolderConfiguration(t,n),{keys:_,overrides:f}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:r,removed:o,overrides:p}=(0,P.compare)(n,void 0);return{keys:[...s,...r,...o],overrides:p}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let s=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const r=n.getFolder(t);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const o=this._memoryConfigurationByResource.get(t);o&&(s=s.merge(o))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(n=s.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=s}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:s,overrides:r,keys:o}=this._folderConfigurations.get(n);return t.push([n,{contents:s,overrides:r,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((p,f)=>(p.set(k.URI.revive(f[0]),this.parseConfigurationModel(f[1])),p),new T.ResourceMap);return new w(n,s,new g,r,o,new g,new T.ResourceMap,!1)}static parseConfigurationModel(t){return new g(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function E(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const t=new Set,n=new Map;for(const r of c)r.keys.forEach(o=>t.add(o)),r.overrides.forEach(([o,p])=>{const f=(0,T.getOrSet)(n,o,new Set);p.forEach(_=>f.add(_))});const s=[];return n.forEach((r,o)=>s.push([o,[...r.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=E;class d{constructor(t,n,s,r){this.change=t,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(f=>o.add(f)),t.overrides.forEach(([,f])=>f.forEach(_=>o.add(_))),this.affectedKeys=[...o.values()];const p=new g;this.affectedKeys.forEach(f=>p.setValue(f,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,o=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!y.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let s=(0,P.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(t=t[r],!t)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=d;class l extends d{constructor(t,n,s,r){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=s,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=l}),define(me[190],ge([0,1,38,8,79,156,26,10,185,85,4,13,96]),function(K,e,b,T,C,A,y,k,D,P,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const g=A.localize(0,null);class a{async getDefaultTerminalForPlatforms(){const t=await w.getDefaultTerminalLinuxReady();return{windows:h.getDefaultTerminalWindows(),linux:t,osx:"xterm"}}}let h=class Vt extends a{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(b,n,C.getWindowsShell(),t)}spawnTerminal(t,n,s,r){const o=n.terminal.external,p=(o==null?void 0:o.windowsExec)||Vt.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const f=T.basename(p).toLowerCase();if(f==="cmder"||f==="cmder.exe")return t.spawn(p,r?[r]:void 0),Promise.resolve(void 0);const _=["/c","start","/wait"];return p.indexOf(" ")>=0&&_.push('""'),_.push(p),(f==="wt"||f==="wt.exe")&&_.push("-d ."),new Promise((u,v)=>{const R=E(process),O=t.spawn(s,_,{cwd:r,env:R});O.on("error",v),O.on("exit",()=>u())})}runInTerminal(t,n,s,r,o){const p=o.windowsExec||Vt.getDefaultTerminalWindows();return new Promise((f,_)=>{const u=`"${n} - ${g}"`,v=`""${s.join('" "')}" & pause"`,R=["/c","start",u,"/wait",p,"/c",v],O=Object.assign({},E(process),r);Object.keys(O).filter(ie=>O[ie]===null).forEach(ie=>delete O[ie]);const H={cwd:n,env:O,windowsVerbatimArguments:!0};b.spawn(Vt.CMD,R,H).on("error",ie=>{_(d(ie))}),f(void 0)})}static getDefaultTerminalWindows(){if(!Vt._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");Vt._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return Vt._DEFAULT_TERMINAL_WINDOWS}};h.CMD="cmd.exe",h=qe([He(0,(0,i.optional)(P.IConfigurationService))],h),e.WindowsExternalTerminalService=h;let S=class Nn extends a{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(b,n,t)}runInTerminal(t,n,s,r,o){const p=o.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((f,_)=>{if(p===D.DEFAULT_TERMINAL_OSX||p==="iTerm.app"){const u=p===D.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[I.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${u}.scpt`,K).fsPath,"-t",t||g,"-w",n];for(let ne of s)R.push("-a"),R.push(ne);if(r)for(let ne in r){const ie=r[ne];ie===null?(R.push("-u"),R.push(ne)):(R.push("-e"),R.push(`${ne}=${ie}`))}let O="";const H=b.spawn(Nn.OSASCRIPT,R);H.on("error",ne=>{_(d(ne))}),H.stderr.on("data",ne=>{O+=ne.toString()}),H.on("exit",ne=>{if(ne===0)f(void 0);else if(O){const ie=O.split(`
`,1);_(new Error(ie[0]))}else _(new Error(A.localize(1,null,u,ne)))})}else _(new Error(A.localize(2,null,p)))})}spawnTerminal(t,n,s){const r=n.terminal.external,o=(r==null?void 0:r.osxExec)||D.DEFAULT_TERMINAL_OSX;return new Promise((p,f)=>{const _=["-a",o];s&&_.push(s);const u=t.spawn("/usr/bin/open",_);u.on("error",f),u.on("exit",()=>p())})}};S.OSASCRIPT="/usr/bin/osascript",S=qe([He(0,(0,i.optional)(P.IConfigurationService))],S),e.MacExternalTerminalService=S;let w=class jt extends a{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(b,n,t)}runInTerminal(t,n,s,r,o){const p=o.linuxExec?Promise.resolve(o.linuxExec):jt.getDefaultTerminalLinuxReady();return new Promise((f,_)=>{let u=[];p.then(v=>{v.indexOf("gnome-terminal")>=0?u.push("-x"):u.push("-e"),u.push("bash"),u.push("-c");const R=`${l(s)}; echo; read -p "${jt.WAIT_MESSAGE}" -n1;`;u.push(`''${R}''`);const O=Object.assign({},process.env,r);Object.keys(O).filter(U=>O[U]===null).forEach(U=>delete O[U]);const H={cwd:n,env:O};let ne="";const ie=b.spawn(v,u,H);ie.on("error",U=>{_(d(U))}),ie.stderr.on("data",U=>{ne+=U.toString()}),ie.on("exit",U=>{if(U===0)f(void 0);else if(ne){const B=ne.split(`
`,1);_(new Error(B[0]))}else _(new Error(A.localize(4,null,v,U)))})})})}static async getDefaultTerminalLinuxReady(){return jt._DEFAULT_TERMINAL_LINUX_READY||(jt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async t=>{k.isLinux?await y.exists("/etc/debian_version")?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm"):t("xterm")})),jt._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,n,s){const r=n.terminal.external,o=(r==null?void 0:r.linuxExec)?Promise.resolve(r.linuxExec):jt.getDefaultTerminalLinuxReady();return new Promise((p,f)=>{o.then(_=>{const u=E(process),v=t.spawn(_,[],{cwd:s,env:u});v.on("error",f),v.on("exit",()=>p())})})}};w.WAIT_MESSAGE=A.localize(3,null),w=qe([He(0,(0,i.optional)(P.IConfigurationService))],w),e.LinuxExternalTerminalService=w;function E(c){const t=c.env;return(0,m.sanitizeProcessEnvironment)(t),t}function d(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(A.localize(5,null,c.path)):c}function l(c){let t="";for(let n of c)n.indexOf(" ")>=0?t+='"'+n+'"':t+=n,t+=" ";return t}}),define(me[86],ge([0,1,4]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,b.createDecorator)("remoteAuthorityResolverService");var T;(function(y){y[y.Unknown=0]="Unknown",y[y.DisableTrust=1]="DisableTrust",y[y.MachineTrusted=2]="MachineTrusted"})(T=e.RemoteTrustOption||(e.RemoteTrustOption={}));var C;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(C=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends Error{constructor(k,D=C.Unknown,P){super(k);this._message=k,this._code=D,this._detail=P,this.isHandled=D===C.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(k){return k instanceof A&&k._code===C.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof A&&k._code===C.NoResolverFound}static isHandled(k){return k instanceof A&&k.isHandled}}e.RemoteAuthorityResolverError=A}),define(me[119],ge([0,1,13]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function T(D){return D.scheme===b.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=T;function C(D){if(!!D){const P=D.indexOf("+");return P<0?D:D.substr(0,P)}}e.getRemoteName=C;function A(D){return D.scheme!==b.Schemas.file&&D.scheme!==b.Schemas.vscodeRemote}function y(D){if(D.folders.length)return D.folders.every(P=>A(P.uri))?D.folders[0].uri:void 0;if(D.configuration&&A(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=y;function k(D){var P;return(P=y(D))===null||P===void 0?void 0:P.scheme}e.getVirtualWorkspaceScheme=k}),define(me[191],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class b{vsda(){return new Promise((C,A)=>K(["vsda"],C,A))}async sign(C){try{const A=await this.vsda(),y=new A.signer;if(y)return y.sign(C)}catch(A){}return C}}e.SignService=b}),define(me[192],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class b{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,A,y=5){let k;return k=A(D=>{const P=typeof D=="string"?D:D.data;let i=this._terminalBufferMap.get(C);if(i){i.data.push(P);return}const I=setTimeout(()=>this.flushBuffer(C),y);i={data:[P],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(C),k.dispose()}},this._terminalBufferMap.set(C,i)}),k}stopBuffering(C){const A=this._terminalBufferMap.get(C);A&&A.dispose()}flushBuffer(C){const A=this._terminalBufferMap.get(C);A&&(this._terminalBufferMap.delete(C),this._callback(C,A.data.join("")))}}e.TerminalDataBufferer=b}),define(me[193],ge([0,1,49,8,36,26,11,24,10]),function(K,e,b,T,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function P(){const I=/(\d+)\.(\d+)\.(\d+)/g.exec(b.release());let m=0;return I&&I.length===4&&(m=parseInt(I[3])),m}e.getWindowsBuildNumber=P;async function i(I,m,g,a=C.env,h=A.exists){if(T.isAbsolute(I))return await h(I)?I:void 0;if(m===void 0&&(m=C.cwd()),T.dirname(I)!=="."){const d=T.join(m,I);return await h(d)?d:void 0}const w=(0,k.getCaseInsensitive)(a,"PATH");if(g===void 0&&(0,y.isString)(w)&&(g=w.split(T.delimiter)),g===void 0||g.length===0){const d=T.join(m,I);return await h(d)?d:void 0}for(let d of g){let l;if(T.isAbsolute(d)?l=T.join(d,I):l=T.join(m,d,I),await h(l))return l;if(D.isWindows){let c=l+".com";if(await h(c)||(c=l+".exe",await h(c)))return c}}const E=T.join(m,I);return await h(E)?E:void 0}e.findExecutable=i}),define(me[194],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var b;(function(T){T.DARK="dark",T.LIGHT="light",T.HIGH_CONTRAST="hc"})(b=e.ColorScheme||(e.ColorScheme={}))}),define(me[195],ge([0,1,4,6,40,3,194,43]),function(K,e,b,T,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,b.createDecorator)("themeService");var D;(function(S){function w(E){return E&&typeof E=="object"&&typeof E.id=="string"}S.isThemeColor=w})(D=e.ThemeColor||(e.ThemeColor={}));function P(S){return{id:S}}e.themeColorFromId=P;var i;(function(S){function w(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||D.isThemeColor(t.color))}S.isThemeIcon=w;const E=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function d(t){const n=E.exec(t);if(!!n){let[,s]=n;return{id:s}}}S.fromString=d;function l(t,n){let s=t.id;const r=s.lastIndexOf("~");return r!==-1&&(s=s.substring(0,r)),n&&(s=`${s}~${n}`),{id:s}}S.modify=l;function c(t,n){var s,r;return t.id===n.id&&((s=t.color)===null||s===void 0?void 0:s.id)===((r=n.color)===null||r===void 0?void 0:r.id)}S.isEqual=c,S.asClassNameArray=k.CSSIcon.asClassNameArray,S.asClassName=k.CSSIcon.asClassName,S.asCSSSelector=k.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function I(S){switch(S){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,T.toDisposable)(()=>{const E=this.themingParticipants.indexOf(w);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new m;C.Registry.add(e.Extensions.ThemingContribution,g);function a(S){return g.onColorThemeChange(S)}e.registerThemingParticipant=a;class h extends T.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,E){let d=this.theme.getColor(w);return d&&E&&(d=E(d,this.theme)),d?d.toString():null}}e.Themable=h}),define(me[196],ge([0,1,40,195,3,159,118,14,43]),function(K,e,b,T,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(w,E,d,l){const c=this.iconsById[w];if(c){if(d&&!c.description){c.description=d,this.iconSchema.properties[w].markdownDescription=`${d} $(${w})`;const s=this.iconReferenceSchema.enum.indexOf(w);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=d),this._onDidChange.fire()}return c}let t={id:w,description:d,defaults:E,deprecationMessage:l};this.iconsById[w]=t;let n={$ref:"#/definitions/icons"};return l&&(n.deprecationMessage=l),d&&(n.markdownDescription=`${d}: $(${w})`),this.iconSchema.properties[w]=n,this.iconReferenceSchema.enum.push(w),this.iconReferenceSchema.enumDescriptions.push(d||""),this._onDidChange.fire(),{id:w}}deregisterIcon(w){delete this.iconsById[w],delete this.iconSchema.properties[w];const E=this.iconReferenceSchema.enum.indexOf(w);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(w=>this.iconsById[w])}getIcon(w){return this.iconsById[w]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(w,E){const d=this.iconFontsById[w];if(d)return d;let l={id:w,definition:E};return this.iconFontsById[w]=l,this._onDidChange.fire(),l}deregisterIconFont(w){delete this.iconFontsById[w]}getIconFonts(){return Object.keys(this.iconFontsById).map(w=>this.iconFontsById[w])}getIconFont(w){return this.iconFontsById[w]}toString(){const w=(c,t)=>c.id.localeCompare(t.id),E=c=>{for(;T.ThemeIcon.isThemeIcon(c.defaults);)c=this.iconsById[c.defaults.id];return`codicon codicon-${c?c.id:""}`};let d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.iconsById).map(c=>this.iconsById[c]);for(const c of l.filter(t=>!!t.description).sort(w))d.push(`|<i class="${E(c)}"></i>|${c.id}|${T.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const c of l.filter(t=>!T.ThemeIcon.isThemeIcon(t.defaults)).sort(w))d.push(`|<i class="${E(c)}"></i>|${c.id}|`);return d.join(`
`)}}const i=new P;b.Registry.add(e.Extensions.IconContribution,i);function I(S,w,E,d){return i.registerIcon(S,w,E,d)}e.registerIcon=I;function m(){return i}e.getIconRegistry=m;function g(){for(const S of D.iconRegistry.all)i.registerIcon(S.id,S.definition,S.description);D.iconRegistry.onDidRegister(S=>i.registerIcon(S.id,S.definition,S.description))}g(),e.iconsSchemaId="vscode://schemas/icons";let a=b.Registry.as(y.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,i.getIconSchema());const h=new k.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{h.isScheduled()||h.schedule()}),e.widgetClose=I("widget-close",D.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",D.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",D.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=T.ThemeIcon.modify(D.Codicon.sync,"spin")}),define(me[62],ge([0,1,2,25,4,22]),function(K,e,b,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var y;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function k(m){const g=m;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=k;function D(m){const g=m;return!!(g&&typeof g=="object"&&b.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=D;class P{constructor(g,a,h,S){this._id=g,this._configuration=h,this._ignorePathCasing=S,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(g){this._id=g.id,this._configuration=g.configuration,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g.with({scheme:g.scheme,authority:g.authority,path:g.path}))||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=P;class i{constructor(g,a){this.raw=a,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,T.joinPath)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(m){return new i({uri:m,index:0,name:(0,T.basenameOrAuthority)(m)},{uri:m.toString()})}e.toWorkspaceFolder=I}),define(me[120],ge([0,1,4,160,62,2,10,8,25,135,57,13,77,29,119]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const h=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(B){return(typeof B=="string"?(0,k.extname)(B):(0,D.extname)(B))===h}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function w(B){return B.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function E(B){return B.hasOwnProperty("folderUri")}e.isRecentFolder=E;function d(B){return B.hasOwnProperty("fileUri")}e.isRecentFile=d;function l(B){const x=B;return typeof(x==null?void 0:x.id)=="string"&&A.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=l;function c(B){if(B.configuration)return{id:B.id,configPath:B.configuration};if(B.folders.length===1)return{id:B.id,uri:B.folders[0].uri}}e.toWorkspaceIdentifier=c;function t(B){const x=B;return typeof(x==null?void 0:x.id)=="string"&&A.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=t;function n(B){const x=B;if(x==null?void 0:x.uri)return{id:x.id,uri:A.URI.revive(x.uri)};const L=B;if(L==null?void 0:L.configPath)return{id:L.id,configPath:A.URI.revive(L.configPath)};if(B==null?void 0:B.id)return{id:B.id}}e.reviveIdentifier=n;function s(B,x){return D.extUriBiasedIgnorePathCase.isEqualOrParent(B,x.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function r(B){return o(B)||p(B)}e.isStoredWorkspaceFolder=r;function o(B){const x=B;return typeof(x==null?void 0:x.path)=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=o;function p(B){const x=B;return typeof(x==null?void 0:x.uri)=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=p;function f(B,x,L,N,F=!y.isWindows,M){if(B.scheme!==N.scheme)return{name:L,uri:B.toString(!0)};let $=x?void 0:M.relativePath(N,B);if($!==void 0)$.length===0?$=".":y.isWindows&&B.scheme===I.Schemas.file&&!F&&($=$.replace(/\//g,"\\"));else if(B.scheme===I.Schemas.file)$=B.fsPath,y.isWindows&&($=(0,m.normalizeDriveLetter)($),F&&($=(0,g.toSlashes)($)));else{if(!M.isEqualAuthority(B.authority,N.authority))return{name:L,uri:B.toString(!0)};$=B.path}return{name:L,path:$}}e.getStoredWorkspaceFolder=f;function _(B,x,L){let N=[],F=new Set;const M=L.dirname(x);for(let $ of B){let q;if(o($))$.path&&(q=L.resolvePath(M,$.path));else if(p($))try{q=A.URI.parse($.uri),q.path[0]!=="/"&&(q=q.with({path:"/"+q.path}))}catch(G){console.warn(G)}if(q){let G=L.getComparisonKey(q);if(!F.has(G)){F.add(G);const le=$.name||L.basenameOrAuthority(q);N.push(new C.WorkspaceFolder({uri:q,name:le,index:N.length},$))}}}return N}e.toWorkspaceFolders=_;function u(B,x,L,N,F){let M=v(x,B);const $=F.dirname(x),q=F.dirname(N),G=[],le=R(M.folders);for(const Oe of M.folders){const V=o(Oe)?F.resolvePath($,Oe.path):A.URI.parse(Oe.uri);let X;L?X=!1:X=!o(Oe)||(0,k.isAbsolute)(Oe.path),G.push(f(V,X,Oe.name,q,le,F))}const ve={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},Re=P.setProperty(B,["folders"],G,ve);let Se=P.applyEdits(B,Re);return M.remoteAuthority===(0,a.getRemoteAuthority)(N)&&(Se=P.applyEdits(Se,P.removeProperty(Se,["remoteAuthority"],ve))),Se}e.rewriteWorkspaceFileForNewLocation=u;function v(B,x){let L=i.parse(x);if(L&&Array.isArray(L.folders))L.folders=L.folders.filter(N=>r(N));else throw new Error(`${B} looks like an invalid workspace file.`);return L}function R(B){return y.isWindows?B.some(x=>o(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function O(B){return B.workspace&&typeof B.workspace=="object"&&typeof B.workspace.id=="string"&&typeof B.workspace.configPath=="string"}function H(B){return typeof B.folderUri=="string"}function ne(B){return typeof B.fileUri=="string"}function ie(B,x){const L={workspaces:[],files:[]};if(B){const N=function(M,$){for(let q=0;q<M.length;q++)try{$(M[q],q)}catch(G){x.warn(`Error restoring recent entry ${JSON.stringify(M[q])}: ${G.toString()}. Skip entry.`)}},F=B;if(Array.isArray(F.entries))N(F.entries,M=>{const $=M.label,q=M.remoteAuthority;O(M)?L.workspaces.push({label:$,remoteAuthority:q,workspace:{id:M.workspace.id,configPath:A.URI.parse(M.workspace.configPath)}}):H(M)?L.workspaces.push({label:$,remoteAuthority:q,folderUri:A.URI.parse(M.folderUri)}):ne(M)&&L.files.push({label:$,remoteAuthority:q,fileUri:A.URI.parse(M.fileUri)})});else{const M=B;Array.isArray(M.workspaces3)&&N(M.workspaces3,($,q)=>{const G=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[q]||void 0;typeof $=="object"&&typeof $.id=="string"&&typeof $.configURIPath=="string"?L.workspaces.push({label:G,workspace:{id:$.id,configPath:A.URI.parse($.configURIPath)}}):typeof $=="string"&&L.workspaces.push({label:G,folderUri:A.URI.parse($)})}),Array.isArray(M.files2)&&N(M.files2,($,q)=>{const G=Array.isArray(M.fileLabels)&&M.fileLabels[q]||void 0;typeof $=="string"&&L.files.push({label:G,fileUri:A.URI.parse($)})})}}return L}e.restoreRecentlyOpened=ie;function U(B){const x={entries:[]};for(const L of B.workspaces)E(L)?x.entries.push({folderUri:L.folderUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority}):x.entries.push({workspace:{id:L.workspace.id,configPath:L.workspace.configPath.toString()},label:L.label,remoteAuthority:L.remoteAuthority});for(const L of B.files)x.entries.push({fileUri:L.fileUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority});return x}e.toStoreData=U}),define(me[87],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class b{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const A=this._idPool++;return this._data.set(A,C),this.logDebugInfo(),A}get(C,A){return this._data.has(C)?this._data.get(C)[A]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!b.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=b,b.enableDebugLogging=!1}),define(me[46],ge([0,1,2,3,4]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class A{constructor(){this._onDidChangeTabs=new T.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(k){this._tabs=k.map(D=>({name:D.name,group:D.group,resource:b.URI.revive(D.resource),isActive:D.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(me[63],ge([0,1,13,4]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(b.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,k){k===null?this._providerInfo.delete(y):this._providerInfo.set(y,k)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,T.createDecorator)("IExtHostFileSystemInfo")}),define(me[28],ge([0,1,4]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,b.createDecorator)("IExtHostInitDataService")}),define(me[197],ge([0,1,14]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(y,k,D){this._deferredPromises=new Map,this._id=y,this._shared=k,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new b.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of P.values())i.complete()}catch(i){for(const I of P.values())I.error(i)}})()},0)}get whenReady(){return this._init}get(y,k){let D=this._value[y];return typeof D=="undefined"&&(D=k),D}update(y,k){this._value[y]=k;let D=this._deferredPromises.get(y);if(D!==void 0)return D.p;const P=new b.DeferredPromise;return this._deferredPromises.set(y,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=T;class C extends T{constructor(y,k){super(y.identifier.value,!0,k);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=C}),define(me[15],ge([0,1,4]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,b.createDecorator)("IExtHostRpcService");class T{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=T});var it=this&&this.__classPrivateFieldSet||function(K,e,b,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(K,b):C?C.value=b:e.set(K,b),b},We=this&&this.__classPrivateFieldGet||function(K,e,b,T){if(b==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?T:b==="a"?T.call(K):T?T.value:e.get(K)};define(me[198],ge([0,1,27,3]),function(K,e,b,T){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(k,D){C.set(this,void 0),this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._id=b.ExtensionIdentifier.toKey(k.identifier),it(this,C,D,"f"),We(this,C,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(k){return We(this,C,"f").get(this._id,k)}store(k,D){return We(this,C,"f").store(this._id,k,D)}delete(k){return We(this,C,"f").delete(this._id,k)}}e.ExtensionSecrets=A,C=new WeakMap}),define(me[121],ge([0,1,4,3]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class C{constructor(){this._onDidChangeTelemetryEnabled=new T.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=C,e.IExtHostTelemetry=(0,b.createDecorator)("IExtHostTelemetry")}),define(me[88],ge([0,1,3]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var T;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(T=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const C=new WeakMap,A=y=>{let k=C.get(y);return k||(k={children:new Map,bus:new b.Emitter},C.set(y,k)),k};e.getPrivateApiFor=A}),define(me[51],ge([0,1,4,3,15]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(k){function D(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public}}k.fromApiTunnel=D;function P(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public}}k.fromServiceTunnel=P})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,b.createDecorator)("IExtHostTunnelService");let y=class{constructor(D){this.onDidChangeTunnels=new T.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,P){return{dispose:()=>{}}}async $providePortAttributes(D,P,i,I,m){return[]}async $forwardPort(D,P){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=qe([He(0,C.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var it=this&&this.__classPrivateFieldSet||function(K,e,b,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(K,b):C?C.value=b:e.set(K,b),b},We=this&&this.__classPrivateFieldGet||function(K,e,b,T){if(b==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?T:b==="a"?T.call(K):T?T.value:e.get(K)},Yt=this&&this.__rest||function(K,e){var b={};for(var T in K)Object.prototype.hasOwnProperty.call(K,T)&&e.indexOf(T)<0&&(b[T]=K[T]);if(K!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,T=Object.getOwnPropertySymbols(K);C<T.length;C++)e.indexOf(T[C])<0&&Object.prototype.propertyIsEnumerable.call(K,T[C])&&(b[T[C]]=K[T[C]]);return b};define(me[7],ge([0,1,16,17,100,22,9,11,2,30,45,86,88]),function(K,e,b,T,C,A,y,k,D,P,i,I,m){"use strict";var g,a,h,S,w,E,d,l,c,t,n,s,r,o,p,f;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelPreload=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function _(j){function W(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf(W,j),Object.setPrototypeOf(W.prototype,j.prototype),W}let u=h=class{constructor(W){g.set(this,void 0),it(this,g,W,"f")}static from(...W){let re=W;return new h(function(){if(re){for(const ke of re)ke&&typeof ke.dispose=="function"&&ke.dispose();re=void 0}})}dispose(){typeof We(this,g,"f")=="function"&&(We(this,g,"f").call(this),it(this,g,void 0,"f"))}};g=new WeakMap,u=h=qe([_],u),e.Disposable=u;let v=S=class{constructor(W,re){if(W<0)throw(0,T.illegalArgument)("line must be non-negative");if(re<0)throw(0,T.illegalArgument)("character must be non-negative");this._line=W,this._character=re}static Min(...W){if(W.length===0)throw new TypeError;let re=W[0];for(let ke=1;ke<W.length;ke++){const Ge=W[ke];Ge.isBefore(re)&&(re=Ge)}return re}static Max(...W){if(W.length===0)throw new TypeError;let re=W[0];for(let ke=1;ke<W.length;ke++){const Ge=W[ke];Ge.isAfter(re)&&(re=Ge)}return re}static isPosition(W){if(!W)return!1;if(W instanceof S)return!0;let{line:re,character:ke}=W;return typeof re=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,re=0){if(W===null||re===null)throw(0,T.illegalArgument)();let ke;return typeof W=="undefined"?ke=0:typeof W=="number"?ke=W:(ke=typeof W.lineDelta=="number"?W.lineDelta:0,re=typeof W.characterDelta=="number"?W.characterDelta:0),ke===0&&re===0?this:new S(this.line+ke,this.character+re)}with(W,re=this.character){if(W===null||re===null)throw(0,T.illegalArgument)();let ke;return typeof W=="undefined"?ke=this.line:typeof W=="number"?ke=W:(ke=typeof W.line=="number"?W.line:this.line,re=typeof W.character=="number"?W.character:this.character),ke===this.line&&re===this.character?this:new S(ke,re)}toJSON(){return{line:this.line,character:this.character}}};v=S=qe([_],v),e.Position=v;let R=w=class{constructor(W,re,ke,Ge){let nt,ot;if(typeof W=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof Ge=="number"?(nt=new v(W,re),ot=new v(ke,Ge)):W instanceof v&&re instanceof v&&(nt=W,ot=re),!nt||!ot)throw new Error("Invalid arguments");nt.isBefore(ot)?(this._start=nt,this._end=ot):(this._start=ot,this._end=nt)}static isRange(W){return W instanceof w?!0:W?v.isPosition(W.start)&&v.isPosition(W.end):!1}get start(){return this._start}get end(){return this._end}contains(W){return W instanceof w?this.contains(W._start)&&this.contains(W._end):W instanceof v?!(W.isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const re=v.Max(W.start,this._start),ke=v.Min(W.end,this._end);if(!re.isAfter(ke))return new w(re,ke)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const re=v.Min(W.start,this._start),ke=v.Max(W.end,this.end);return new w(re,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,re=this.end){if(W===null||re===null)throw(0,T.illegalArgument)();let ke;return W?v.isPosition(W)?ke=W:(ke=W.start||this.start,re=W.end||this.end):ke=this.start,ke.isEqual(this._start)&&re.isEqual(this.end)?this:new w(ke,re)}toJSON(){return[this.start,this.end]}};R=w=qe([_],R),e.Range=R;let O=E=class extends R{constructor(W,re,ke,Ge){let nt,ot;if(typeof W=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof Ge=="number"?(nt=new v(W,re),ot=new v(ke,Ge)):W instanceof v&&re instanceof v&&(nt=W,ot=re),!nt||!ot)throw new Error("Invalid arguments");super(nt,ot);this._anchor=nt,this._active=ot}static isSelection(W){return W instanceof E?!0:W?R.isRange(W)&&v.isPosition(W.anchor)&&v.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};O=E=qe([_],O),e.Selection=O;class H{constructor(W,re,ke){if(typeof W!="string"||W.length===0)throw(0,T.illegalArgument)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,T.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,T.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(re),this.connectionToken=ke}}e.ResolvedAuthority=H;class ne extends Error{constructor(W,re=I.RemoteAuthorityResolverErrorCode.Unknown,ke){super(W);this._message=W,this._code=re,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ne.prototype)}static NotAvailable(W,re){return new ne(W,I.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(W){return new ne(W,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=ne;var ie;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(ie=e.EndOfLine||(e.EndOfLine={}));var U;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(U=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=d=class{constructor(W,re){this._range=W,this._newText=re}static isTextEdit(W){return W instanceof d?!0:W?R.isRange(W)&&typeof W.newText=="string":!1}static replace(W,re){return new d(W,re)}static insert(W,re){return d.replace(new R(W,W),re)}static delete(W){return d.replace(W,"")}static setEndOfLine(W){const re=new d(new R(new v(0,0),new v(0,0)),"");return re.newEol=W,re}get range(){return this._range}set range(W){if(W&&!R.isRange(W))throw(0,T.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,T.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,T.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};B=d=qe([_],B),e.TextEdit=B;var x;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellOutput=4]="CellOutput",j[j.CellReplace=5]="CellReplace",j[j.CellOutputItem=6]="CellOutputItem"})(x=e.FileEditType||(e.FileEditType={}));let L=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,re,ke,Ge){this._edits.push({_type:1,from:W,to:re,options:ke,metadata:Ge})}createFile(W,re,ke){this._edits.push({_type:1,from:void 0,to:W,options:re,metadata:ke})}deleteFile(W,re,ke){this._edits.push({_type:1,from:W,to:void 0,options:re,metadata:ke})}replaceNotebookMetadata(W,re,ke){this._edits.push({_type:3,metadata:ke,uri:W,edit:{editType:5,metadata:re},notebookMetadata:re})}replaceNotebookCells(W,re,ke,Ge,nt){let ot,dt,Dt=[],Pt;if(Ht.isNotebookRange(re)&&At.isNotebookCellDataArray(ke)&&!At.isNotebookCellDataArray(Ge)?(ot=re.start,dt=re.end,Dt=ke,Pt=Ge):typeof re=="number"&&typeof ke=="number"&&At.isNotebookCellDataArray(Ge)&&(ot=re,dt=ke,Dt=Ge,Pt=nt),ot===void 0||dt===void 0)throw new Error("Invalid arguments");(ot!==dt||Dt.length>0)&&this._edits.push({_type:5,uri:W,index:ot,count:dt-ot,cells:Dt,metadata:Pt})}replaceNotebookCellMetadata(W,re,ke,Ge){this._edits.push({_type:3,metadata:Ge,uri:W,edit:{editType:8,index:re,metadata:ke}})}replace(W,re,ke,Ge){this._edits.push({_type:2,uri:W,edit:new B(re,ke),metadata:Ge})}insert(W,re,ke,Ge){this.replace(W,new R(re,re),ke,Ge)}delete(W,re,ke){this.replace(W,re,"",ke)}has(W){return this._edits.some(re=>re._type===2&&re.uri.toString()===W.toString())}set(W,re){if(re)for(const ke of re)ke&&this._edits.push({_type:2,uri:W,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Ge=this._edits[ke];Ge._type===2&&Ge.uri.toString()===W.toString()&&(this._edits[ke]=void 0)}(0,b.coalesceInPlace)(this._edits)}}get(W){const re=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===W.toString()&&re.push(ke.edit);return re}entries(){const W=new A.ResourceMap;for(let re of this._edits)if(re._type===2){let ke=W.get(re.uri);ke||(ke=[re.uri,[]],W.set(re.uri,ke)),ke[1].push(re.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};L=qe([_],L),e.WorkspaceEdit=L;let N=l=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof l?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=l._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,re=this._tabstop++){if(typeof W=="function"){const ke=new l;ke._tabstop=this._tabstop,W(ke),this._tabstop=ke._tabstop,W=ke.value}else W=l._escape(W);return this.value+="${",this.value+=re,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,re=this._tabstop++){const ke=W.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(W,re){if(typeof re=="function"){const ke=new l;ke._tabstop=this._tabstop,re(ke),this._tabstop=ke._tabstop,re=ke.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,re&&(this.value+=":",this.value+=re),this.value+="}",this}};N=l=qe([_],N),e.SnippetString=N;var F;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(F=e.DiagnosticTag||(e.DiagnosticTag={}));var M;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(M=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let $=c=class{constructor(W,re){if(this.uri=W,re)if(re instanceof R)this.range=re;else if(re instanceof v)this.range=new R(re,re);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof c?!0:W?R.isRange(W.range)&&D.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};$=c=qe([_],$),e.Location=$;let q=class{constructor(W,re){this.location=W,this.message=re}static is(W){return W?typeof W.message=="string"&&W.location&&R.isRange(W.location.range)&&D.URI.isUri(W.location.uri):!1}static isEqual(W,re){return W===re?!0:!W||!re?!1:W.message===re.message&&W.location.range.isEqual(re.location.range)&&W.location.uri.toString()===re.location.uri.toString()}};q=qe([_],q),e.DiagnosticRelatedInformation=q;let G=class{constructor(W,re,ke=M.Error){if(!R.isRange(W))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=W,this.message=re,this.severity=ke}toJSON(){return{severity:M[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,re){return W===re?!0:!W||!re?!1:W.message===re.message&&W.severity===re.severity&&W.code===re.code&&W.severity===re.severity&&W.source===re.source&&W.range.isEqual(re.range)&&(0,b.equals)(W.tags,re.tags)&&(0,b.equals)(W.relatedInformation,re.relatedInformation,q.isEqual)}};G=qe([_],G),e.Diagnostic=G;let le=class{constructor(W,re){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:(0,C.isMarkdownString)(W)?this.contents=[W]:this.contents=[W],this.range=re}};le=qe([_],le),e.Hover=le;var ve;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(ve=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Re=class{constructor(W,re=ve.Text){this.range=W,this.kind=re}toJSON(){return{range:this.range,kind:ve[this.kind]}}};Re=qe([_],Re),e.DocumentHighlight=Re;var Se;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Se=e.SymbolKind||(e.SymbolKind={}));var Oe;(function(j){j[j.Deprecated=1]="Deprecated"})(Oe=e.SymbolTag||(e.SymbolTag={}));let V=t=class{constructor(W,re,ke,Ge,nt){this.name=W,this.kind=re,this.containerName=nt,typeof ke=="string"&&(this.containerName=ke),Ge instanceof $?this.location=Ge:ke instanceof R&&(this.location=new $(Ge,ke)),t.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Se[this.kind],location:this.location,containerName:this.containerName}}};V=t=qe([_],V),e.SymbolInformation=V;let X=n=class{constructor(W,re,ke,Ge,nt){this.name=W,this.detail=re,this.kind=ke,this.range=Ge,this.selectionRange=nt,this.children=[],n.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children&&W.children.forEach(n.validate)}};X=n=qe([_],X),e.DocumentSymbol=X;var Z;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(Z=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let se=class{constructor(W,re){this.title=W,this.kind=re}};se=qe([_],se),e.CodeAction=se;let fe=s=class{constructor(W){this.value=W}append(W){return new s(this.value?this.value+s.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+s.sep)}};fe.sep=".",fe=s=qe([_],fe),e.CodeActionKind=fe,fe.Empty=new fe(""),fe.QuickFix=fe.Empty.append("quickfix"),fe.Refactor=fe.Empty.append("refactor"),fe.RefactorExtract=fe.Refactor.append("extract"),fe.RefactorInline=fe.Refactor.append("inline"),fe.RefactorRewrite=fe.Refactor.append("rewrite"),fe.Source=fe.Empty.append("source"),fe.SourceOrganizeImports=fe.Source.append("organizeImports"),fe.SourceFixAll=fe.Source.append("fixAll");let Ee=class{constructor(W,re){if(this.range=W,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ee=qe([_],Ee),e.SelectionRange=Ee;class Be{constructor(W,re,ke,Ge,nt,ot){this.kind=W,this.name=re,this.detail=ke,this.uri=Ge,this.range=nt,this.selectionRange=ot}}e.CallHierarchyItem=Be;class pe{constructor(W,re){this.fromRanges=re,this.from=W}}e.CallHierarchyIncomingCall=pe;class Ce{constructor(W,re){this.fromRanges=re,this.to=W}}e.CallHierarchyOutgoingCall=Ce;let Me=class{constructor(W,re){this.range=W,this.command=re}get isResolved(){return!!this.command}};Me=qe([_],Me),e.CodeLens=Me;let ze=r=class{constructor(W,re=!1){a.set(this,void 0),it(this,a,new C.MarkdownString(W,{supportThemeIcons:re}),"f")}static isMarkdownString(W){return W instanceof r?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return We(this,a,"f").value}set value(W){We(this,a,"f").value=W}get isTrusted(){return We(this,a,"f").isTrusted}set isTrusted(W){We(this,a,"f").isTrusted=W}get supportThemeIcons(){return We(this,a,"f").supportThemeIcons}appendText(W){return We(this,a,"f").appendText(W),this}appendMarkdown(W){return We(this,a,"f").appendMarkdown(W),this}appendCodeblock(W,re){return We(this,a,"f").appendCodeblock(re!=null?re:"",W),this}};a=new WeakMap,ze=r=qe([_],ze),e.MarkdownString=ze;let _e=class{constructor(W,re){this.label=W,this.documentation=re}};_e=qe([_],_e),e.ParameterInformation=_e;let Ke=class{constructor(W,re){this.label=W,this.documentation=re,this.parameters=[]}};Ke=qe([_],Ke),e.SignatureInformation=Ke;let Q=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Q=qe([_],Q),e.SignatureHelp=Q;var te;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(te=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var we;(function(j){j[j.Other=0]="Other",j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(we=e.InlayHintKind||(e.InlayHintKind={}));let xe=class{constructor(W,re,ke){this.text=W,this.position=re,this.kind=ke}};xe=qe([_],xe),e.InlayHint=xe;var je;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ve;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Ve=e.CompletionItemKind||(e.CompletionItemKind={}));var Je;(function(j){j[j.Deprecated=1]="Deprecated"})(Je=e.CompletionItemTag||(e.CompletionItemTag={}));let De=class{constructor(W,re){this.label=W,this.kind=re}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Ve[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};De=qe([_],De),e.CompletionItem=De;let ye=class{constructor(W=[],re=!1){this.items=W,this.isIncomplete=re}};ye=qe([_],ye),e.CompletionList=ye;var Pe;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(Pe=e.ViewColumn||(e.ViewColumn={}));var oe;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(oe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ue;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(ue=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var z;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(z=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var J;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(J=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ce;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ie;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Ie=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function W(re){switch(re){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=W}(ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ae=class{constructor(W,re){if(re&&!D.URI.isUri(re))throw(0,T.illegalArgument)("target");if(!R.isRange(W)||W.isEmpty)throw(0,T.illegalArgument)("range");this.range=W,this.target=re}};Ae=qe([_],Ae),e.DocumentLink=Ae;let Le=class{constructor(W,re,ke,Ge){this.red=W,this.green=re,this.blue=ke,this.alpha=Ge}};Le=qe([_],Le),e.Color=Le;let $e=class{constructor(W,re){if(re&&!(re instanceof Le))throw(0,T.illegalArgument)("color");if(!R.isRange(W)||W.isEmpty)throw(0,T.illegalArgument)("range");this.range=W,this.color=re}};$e=qe([_],$e),e.ColorInformation=$e;let Xe=class{constructor(W){if(!W||typeof W!="string")throw(0,T.illegalArgument)("label");this.label=W}};Xe=qe([_],Xe),e.ColorPresentation=Xe;var rt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(rt=e.ColorFormat||(e.ColorFormat={}));var tt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(tt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Qe;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(Qe=e.TaskRevealKind||(e.TaskRevealKind={}));var gt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(gt=e.TaskPanelKind||(e.TaskPanelKind={}));let wt=o=class{constructor(W,re){if(typeof W!="string"||typeof re!="string")throw(0,T.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return o.Clean;case"build":return o.Build;case"rebuild":return o.Rebuild;case"test":return o.Test;default:return}}get id(){return this._id}};wt.Clean=new o("clean","Clean"),wt.Build=new o("build","Build"),wt.Rebuild=new o("rebuild","Rebuild"),wt.Test=new o("test","Test"),wt=o=qe([_],wt),e.TaskGroup=wt;function be(j){let W="";for(let re=0;re<j.length;re++)W+=j[re].replace(/,/g,",,")+",";return W}let he=class{constructor(W,re,ke){if(typeof W!="string")throw(0,T.illegalArgument)("process");this._args=[],this._process=W,re!==void 0&&(Array.isArray(re)?(this._args=re,this._options=ke):this._options=re)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,T.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(let re of this._args)W.push(re);return be(W)}};he=qe([_],he),e.ProcessExecution=he;let ae=class{constructor(W,re,ke){if(this._args=[],Array.isArray(re)){if(!W)throw(0,T.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,T.illegalArgument)("command");this._command=W,this._args=re,this._options=ke}else{if(typeof W!="string")throw(0,T.illegalArgument)("commandLine");this._commandLine=W,this._options=re}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,T.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,T.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let re of this._args)W.push(typeof re=="string"?re:re.value);return be(W)}};ae=qe([_],ae),e.ShellExecution=ae;var Y;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Y=e.ShellQuoting||(e.ShellQuoting={}));var Ne;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Ne=e.TaskScope||(e.TaskScope={}));class Fe{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=Fe;let Ye=p=class{constructor(W,re,ke,Ge,nt,ot){this.__deprecated=!1,this._definition=this.definition=W;let dt;typeof re=="string"?(this._name=this.name=re,this._source=this.source=ke,this.execution=Ge,dt=nt,this.__deprecated=!0):re===Ne.Global||re===Ne.Workspace?(this.target=re,this._name=this.name=ke,this._source=this.source=Ge,this.execution=nt,dt=ot):(this.target=re,this._name=this.name=ke,this._source=this.source=Ge,this.execution=nt,dt=ot),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof he?this._definition={type:p.ProcessType,id:this._execution.computeId()}:this._execution instanceof ae?this._definition={type:p.ShellType,id:this._execution.computeId()}:this._execution instanceof Fe?this._definition={type:p.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:p.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,T.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,T.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const re=this._definition.type;(p.EmptyType===re||p.ProcessType===re||p.ShellType===re||p.ExtensionCallbackType===re)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,T.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};Ye.ExtensionCallbackType="customExecution",Ye.ProcessType="process",Ye.ShellType="shell",Ye.EmptyType="$empty",Ye=p=qe([_],Ye),e.Task=Ye;var et;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(et=e.ProgressLocation||(e.ProgressLocation={}));let ct=class{constructor(W,re=ut.None){this.collapsibleState=re,D.URI.isUri(W)?this.resourceUri=W:this.label=W}};ct=qe([_],ct),e.TreeItem=ct;var ut;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ze=class{constructor(W,re){this.id=W,this.color=re}};Ze=qe([_],Ze),e.ThemeIcon=Ze,Ze.File=new Ze("file"),Ze.Folder=new Ze("folder");let mt=class{constructor(W){this.id=W}};mt=qe([_],mt),e.ThemeColor=mt;var ht;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(ht=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ft=class{constructor(W,re){if(typeof W!="string"&&(!W||!D.URI.isUri(W)&&!D.URI.isUri(W.uri)))throw(0,T.illegalArgument)("base");if(typeof re!="string")throw(0,T.illegalArgument)("pattern");typeof W=="string"?(this.baseFolder=D.URI.file(W),this.base=W):D.URI.isUri(W)?(this.baseFolder=W,this.base=W.fsPath):(this.baseFolder=W.uri,this.base=W.uri.fsPath),this.pattern=re}};ft=qe([_],ft),e.RelativePattern=ft;let at=class{constructor(W,re,ke,Ge){this.enabled=typeof W=="boolean"?W:!0,typeof re=="string"&&(this.condition=re),typeof ke=="string"&&(this.hitCondition=ke),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};at=qe([_],at),e.Breakpoint=at;let yt=class extends at{constructor(W,re,ke,Ge,nt){super(re,ke,Ge,nt);if(W===null)throw(0,T.illegalArgument)("location");this.location=W}};yt=qe([_],yt),e.SourceBreakpoint=yt;let St=class extends at{constructor(W,re,ke,Ge,nt){super(re,ke,Ge,nt);this.functionName=W}};St=qe([_],St),e.FunctionBreakpoint=St;let Nt=class extends at{constructor(W,re,ke,Ge,nt,ot,dt){super(Ge,nt,ot,dt);if(!re)throw(0,T.illegalArgument)("dataId");this.label=W,this.dataId=re,this.canPersist=ke}};Nt=qe([_],Nt),e.DataBreakpoint=Nt;let Rt=class{constructor(W,re,ke){this.command=W,this.args=re||[],this.options=ke}};Rt=qe([_],Rt),e.DebugAdapterExecutable=Rt;let _t=class{constructor(W,re){this.port=W,this.host=re}};_t=qe([_],_t),e.DebugAdapterServer=_t;let Jt=class{constructor(W){this.path=W}};Jt=qe([_],Jt),e.DebugAdapterNamedPipeServer=Jt;let Zt=class{constructor(W){this.implementation=W}};Zt=qe([_],Zt),e.DebugAdapterInlineImplementation=Zt;let pt=class{constructor(W,re){this.range=W,this.expression=re}};pt=qe([_],pt),e.EvaluatableExpression=pt;let en=class{constructor(W,re){this.range=W,this.text=re}};en=qe([_],en),e.InlineValueText=en;let Ct=class{constructor(W,re,ke=!0){this.range=W,this.variableName=re,this.caseSensitiveLookup=ke}};Ct=qe([_],Ct),e.InlineValueVariableLookup=Ct;let Kt=class{constructor(W,re){this.range=W,this.expression=re}};Kt=qe([_],Kt),e.InlineValueEvaluatableExpression=Kt;let tn=class{constructor(W,re){this.frameId=W,this.stoppedLocation=re}};tn=qe([_],tn),e.InlineValueContext=tn;var Gt;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Gt=e.FileChangeType||(e.FileChangeType={}));let lt=f=class extends Error{constructor(W,re=i.FileSystemProviderErrorCode.Unknown,ke){var Ge;super(D.URI.isUri(W)?W.toString(!0):W);this.code=(Ge=ke==null?void 0:ke.name)!==null&&Ge!==void 0?Ge:"Unknown",(0,i.markAsFileSystemProviderError)(this,re),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(W){return new f(W,i.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(W){return new f(W,i.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(W){return new f(W,i.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(W){return new f(W,i.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(W){return new f(W,i.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(W){return new f(W,i.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}};lt=f=qe([_],lt),e.FileSystemError=lt;let nn=class{constructor(W,re,ke){this.start=W,this.end=re,this.kind=ke}};nn=qe([_],nn),e.FoldingRange=nn;var Lt;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Lt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $t;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})($t=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mn;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(mn=e.CommentMode||(e.CommentMode={}));class yn{constructor(W,re=[]){this.tokenTypes=W,this.tokenModifiers=re}}e.SemanticTokensLegend=yn;function gn(j){return typeof j=="undefined"||(0,k.isStringArray)(j)}class rn{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let re=0,ke=W.tokenTypes.length;re<ke;re++)this._tokenTypeStrToInt.set(W.tokenTypes[re],re);for(let re=0,ke=W.tokenModifiers.length;re<ke;re++)this._tokenModifierStrToInt.set(W.tokenModifiers[re],re)}}push(W,re,ke,Ge,nt){if(typeof W=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof Ge=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(W,re,ke,Ge,nt);if(R.isRange(W)&&typeof re=="string"&&gn(ke))return this._push(W,re,ke);throw(0,T.illegalArgument)()}_push(W,re,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(re))throw new Error("`tokenType` is not in the provided legend");const Ge=W.start.line,nt=W.start.character,ot=W.end.character-W.start.character,dt=this._tokenTypeStrToInt.get(re);let Dt=0;if(ke)for(const Pt of ke){if(!this._tokenModifierStrToInt.has(Pt))throw new Error("`tokenModifier` is not in the provided legend");const It=this._tokenModifierStrToInt.get(Pt);Dt|=1<<It>>>0}this._pushEncoded(Ge,nt,ot,dt,Dt)}_pushEncoded(W,re,ke,Ge,nt){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&re<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let Pt=0,It=0;for(let Tt=0;Tt<Dt;Tt++){let Mt=this._data[5*Tt],dn=this._data[5*Tt+1];Mt===0?(Mt=Pt,dn+=It):Mt+=Pt,this._data[5*Tt]=Mt,this._data[5*Tt+1]=dn,Pt=Mt,It=dn}}let ot=W,dt=re;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=nt,this._prevLine=W,this._prevChar=re}static _sortAndDeltaEncode(W){let re=[];const ke=W.length/5|0;for(let dt=0;dt<ke;dt++)re[dt]=dt;re.sort((dt,Dt)=>{const Pt=W[5*dt],It=W[5*Dt];if(Pt===It){const Tt=W[5*dt+1],Mt=W[5*Dt+1];return Tt-Mt}return Pt-It});const Ge=new Uint32Array(W.length);let nt=0,ot=0;for(let dt=0;dt<ke;dt++){const Dt=5*re[dt],Pt=W[Dt+0],It=W[Dt+1],Tt=W[Dt+2],Mt=W[Dt+3],dn=W[Dt+4],On=Pt-nt,$n=On===0?It-ot:It,hn=5*dt;Ge[hn+0]=On,Ge[hn+1]=$n,Ge[hn+2]=Tt,Ge[hn+3]=Mt,Ge[hn+4]=dn,nt=Pt,ot=It}return Ge}build(W){return this._dataIsSortedAndDeltaEncoded?new Qt(new Uint32Array(this._data),W):new Qt(rn._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=rn;class Qt{constructor(W,re){this.resultId=re,this.data=W}}e.SemanticTokens=Qt;class Ut{constructor(W,re,ke){this.start=W,this.deleteCount=re,this.data=ke}}e.SemanticTokensEdit=Ut;class Dn{constructor(W,re){this.resultId=re,this.edits=W}}e.SemanticTokensEdits=Dn;var sn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(sn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var on;(function(j){j[j.Initial=1]="Initial",j[j.Dynamic=2]="Dynamic"})(on=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Xt=class{constructor(){}};Xt.Back={iconPath:new Ze("arrow-left")},Xt=qe([_],Xt),e.QuickInputButtons=Xt;var Cn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Cn=e.ExtensionKind||(e.ExtensionKind={}));class Ft{constructor(W,re,ke){this.badge=W,this.tooltip=re,this.color=ke}static validate(W){if(W.badge&&W.badge.length!==1&&W.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Ft;let an=class{constructor(W){this.kind=W}};an=qe([_],an),e.ColorTheme=an;var kn;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast"})(kn=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{constructor(W,re){if(W<0)throw(0,T.illegalArgument)("start must be positive");if(re<0)throw(0,T.illegalArgument)("end must be positive");W<=re?(this._start=W,this._end=re):(this._start=re,this._end=W)}static isNotebookRange(W){return W instanceof Ht?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(W){let re=this._start,ke=this._end;return W.start!==void 0&&(re=W.start),W.end!==void 0&&(ke=W.end),re===this._start&&ke===this._end?this:new Ht(re,ke)}}e.NotebookRange=Ht;class ln{constructor(W,re){typeof W=="object"?Object.assign(this,W):(this.inputCollapsed=W,this.outputCollapsed=re)}with(W){let{inputCollapsed:re,outputCollapsed:ke}=W,Ge=Yt(W,["inputCollapsed","outputCollapsed"]);return re===void 0?re=this.inputCollapsed:re===null&&(re=void 0),ke===void 0?ke=this.outputCollapsed:ke===null&&(ke=void 0),re===this.inputCollapsed&&ke===this.outputCollapsed&&Object.keys(Ge).length===0?this:new ln(Object.assign({inputCollapsed:re,outputCollapsed:ke},Ge))}}e.NotebookCellMetadata=ln;class xt{constructor(W={}){Object.assign(this,W)}with(W){return new xt(W)}}e.NotebookDocumentMetadata=xt;class At{constructor(W,re,ke,Ge,nt,ot){this.kind=W,this.value=re,this.languageId=ke,this.outputs=Ge!=null?Ge:[],this.metadata=nt,this.executionSummary=ot,At.validate(this)}static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(re=>At.isNotebookCellData(re))}static isNotebookCellData(W){return!0}}e.NotebookCellData=At;class pn{constructor(W,re){this.cells=W,this.metadata=re!=null?re:new xt}}e.NotebookData=pn;class Bt{constructor(W,re,ke){if(this.mime=W,this.value=re,this.metadata=ke,(0,y.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(W){return W instanceof Bt?!0:W?typeof W.mime=="string":!1}static error(W){return new Bt("application/x.notebook.error",JSON.stringify({name:W.name,message:W.message,stack:W.stack}))}}e.NotebookCellOutputItem=Bt;class Ue{constructor(W,re,ke){this.outputs=W,typeof re=="string"?(this.id=re,this.metadata=ke):(this.id=(0,P.generateUuid)(),this.metadata=re!=null?re:ke)}}e.NotebookCellOutput=Ue;var cn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(cn=e.NotebookCellKind||(e.NotebookCellKind={}));var un;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(un=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var vt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(vt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pn;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Pn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class In{constructor(W,re,ke,Ge,nt,ot){this.text=W,this.alignment=re,this.command=ke,this.tooltip=Ge,this.priority=nt,this.accessibilityInformation=ot}}e.NotebookCellStatusBarItem=In;var vn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(vn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class wn{constructor(W,re=[]){this.uri=W,this.provides=typeof re=="string"?[re]:re}}e.NotebookKernelPreload=wn;let zt=class{constructor(W,re){this.label=W,this.timestamp=re}};zt=qe([_],zt),e.TimelineItem=zt;var An;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(An=e.ExtensionMode||(e.ExtensionMode={}));var Tn;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(Tn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Rn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=4]="RegEx"})(Rn=e.StandardTokenType||(e.StandardTokenType={}));class bn{constructor(W,re){this.ranges=W,this.wordPattern=re}}e.LinkedEditingRanges=bn;class Ln{constructor(W,re){this._port=W,this._autoForwardAction=re}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ln;var Fn;(function(j){j[j.Unset=0]="Unset",j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Fn=e.TestResultState||(e.TestResultState={}));var _n;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information",j[j.Hint=3]="Hint"})(_n=e.TestMessageSeverity||(e.TestMessageSeverity={}));var En;(function(j){j[j.Pending=0]="Pending",j[j.Resolved=1]="Resolved"})(En=e.TestItemStatus||(e.TestItemStatus={}));const Wt=(j,W,re,ke)=>{let Ge=re;return{enumerable:!0,configurable:!1,get(){return Ge},set(nt){ke(Ge,nt)||(Ge=nt,j.bus.fire([3,W,nt]))}}},ee=(j,W)=>j===W,de=(j,W)=>j===W?!0:!j||!W?!1:j.isEqual(W);class Te{constructor(W,re,ke,Ge){this.label=re,this.data=Ge;const nt=(0,m.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:W,enumerable:!0,writable:!1},uri:{value:ke,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>nt.parent},children:{value:new A.ReadonlyMapView(nt.children),enumerable:!0,writable:!1},range:Wt(nt,"range",void 0,de),description:Wt(nt,"description",void 0,ee),runnable:Wt(nt,"runnable",!0,ee),debuggable:Wt(nt,"debuggable",!1,ee),status:Wt(nt,"status",En.Resolved,ee),error:Wt(nt,"error",void 0,ee)})}invalidate(){(0,m.getPrivateApiFor)(this).bus.fire([2])}dispose(){const W=(0,m.getPrivateApiFor)(this);W.parent&&(0,m.getPrivateApiFor)(W.parent).children.delete(this.id),W.bus.fire([1])}addChild(W){if(!(W instanceof Te))throw new Error("Test child must be created through vscode.test.createTestItem()");const re=(0,m.getPrivateApiFor)(this);if(re.children.has(W.id))throw new Error(`Attempted to insert a duplicate test item ID ${W.id}`);re.children.set(W.id,W),re.bus.fire([0,W])}}e.TestItemImpl=Te;class st{constructor(W){this.message=W,this.severity=_n.Error}static diff(W,re,ke){const Ge=new st(W);return Ge.expectedOutput=re,Ge.actualOutput=ke,Ge}}e.TestMessage=st;var bt;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(bt=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var kt;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(kt=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Wn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore"})(Wn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(me[122],ge([0,1,53,13,9,145,111,7,16]),function(K,e,b,T,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function i(a,h){h?P.set(a,h):P.delete(a)}e.setWordDefinitionFor=i;function I(a){return P.get(a)}e.getWordDefinitionFor=I;class m extends A.MirrorTextModel{constructor(h,S,w,E,d,l,c,t){super(S,w,E,d);this._proxy=h,this._languageId=l,this._isDirty=c,this._notebook=t,this._isDisposed=!1}dispose(){(0,b.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return(0,D.equals)(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===T.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},get notebook(){return h._notebook},save(){return h._save()},getText(S){return S?h._getTextInRange(S):h.getText()},get eol(){return h._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(S){return h._lineAt(S)},offsetAt(S){return h._offsetAt(S)},positionAt(S){return h._positionAt(S)},validateRange(S){return h._validateRange(S)},validatePosition(S){return h._validatePosition(S)},getWordRangeAtPosition(S,w){return h._getWordRangeAtPosition(S,w)}}}return Object.freeze(this._document)}_acceptLanguageId(h){(0,b.ok)(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){(0,b.ok)(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const S=this._validateRange(h);if(S.isEmpty)return"";if(S.isSingleLine)return this._lines[S.start.line].substring(S.start.character,S.end.character);const w=this._eol,E=S.start.line,d=S.end.line,l=[];l.push(this._lines[E].substring(S.start.character));for(let c=E+1;c<d;c++)l.push(this._lines[c]);return l.push(this._lines[d].substring(0,S.end.character)),l.join(w)}_lineAt(h){let S;if(h instanceof k.Position?S=h.line:typeof h=="number"&&(S=h),typeof S!="number"||S<0||S>=this._lines.length||Math.floor(S)!==S)throw new Error("Illegal value for `line`");return new g(S,this._lines[S],S===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(h),w=this._lines[S.index].length;return new k.Position(S.index,Math.min(S.remainder,w))}_validateRange(h){if(!(h instanceof k.Range))throw new Error("Invalid argument");const S=this._validatePosition(h.start),w=this._validatePosition(h.end);return S===h.start&&w===h.end?h:new k.Range(S.line,S.character,w.line,w.character)}_validatePosition(h){if(!(h instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:S,character:w}=h,E=!1;if(S<0)S=0,w=0,E=!0;else if(S>=this._lines.length)S=this._lines.length-1,w=this._lines[S].length,E=!0;else{const d=this._lines[S].length;w<0?(w=0,E=!0):w>d&&(w=d,E=!0)}return E?new k.Position(S,w):h}_getWordRangeAtPosition(h,S){const w=this._validatePosition(h);if(!S)S=I(this._languageId);else if((0,C.regExpLeadsToEndlessLoop)(S))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${S.source}' because it matches the empty string.`);const E=(0,y.getWordAtText)(w.character+1,(0,y.ensureValidWordDefinition)(S),this._lines[w.line],0);if(E)return new k.Range(w.line,E.startColumn-1,w.line,E.endColumn-1)}}e.ExtHostDocumentData=m;class g{constructor(h,S,w){this._line=h,this._text=S,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(me[199],ge([0,1,7,3,113,6,78,22,2,30]),function(K,e,b,T,C,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(m,g,a,h){this._notebook=a,this._selector=h,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(g.onDidChangeDocument(w=>{const E=this._cellUris.get(w.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const S=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(m.onDidChangeNotebookCells(w=>S(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const m=[],g=[];for(const a of this._notebook.getCells())a.kind===b.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),m.push(a.document.getText().length+1),g.push(a.document.lineCount));this._cellLengths=new C.PrefixSumComputer(new Uint32Array(m)),this._cellLines=new C.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(m){var g,a;if(!m){let d="";for(const l of this._cells)d+=l.document.getText()+`
`;return d=d.slice(0,-1),d}if(m.isEmpty)return"";const h=this.locationAt(m.start),S=this.locationAt(m.end),w=this._cells[(g=this._cellUris.get(h.uri))!==null&&g!==void 0?g:-1],E=this._cells[(a=this._cellUris.get(S.uri))!==null&&a!==void 0?a:-1];if(!w||!E)return"";if(w===E)return w.document.getText(new b.Range(h.range.start,S.range.end));{const d=w.document.getText(new b.Range(h.range.start,new b.Position(w.document.lineCount,0))),l=E.document.getText(new b.Range(new b.Position(0,0),S.range.end));return d+`
`+l}}offsetAt(m){const g=this._cellLines.getIndexOf(m.line),a=this._cellLengths.getAccumulatedValue(g.index-1),h=this._cells[g.index].document.offsetAt(m.with(g.remainder));return a+h}positionAt(m){if(typeof m=="number"){const a=this._cellLengths.getIndexOf(m),h=this._cellLines.getAccumulatedValue(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(h)}const g=this._cellUris.get(m.uri);if(g!==void 0){const a=this._cellLines.getAccumulatedValue(g-1);return new b.Position(a+m.range.start.line,m.range.start.character)}return new b.Position(0,0)}locationAt(m){b.Range.isRange(m)||(m=new b.Range(m,m));const g=this._cellLines.getIndexOf(m.start.line);let a=g;m.isEmpty||(a=this._cellLines.getIndexOf(m.end.line));const h=new b.Position(g.remainder,m.start.character),S=new b.Position(a.remainder,m.end.character),w=new b.Range(h,S),E=this._cells[g.index];return new b.Location(E.document.uri,E.document.validateRange(w))}contains(m){return this._cellUris.has(m)}validateRange(m){const g=this.validatePosition(m.start),a=this.validatePosition(m.end);return m.with(g,a)}validatePosition(m){const g=this._cellLines.getIndexOf(m.line),a=new b.Position(g.remainder,m.character),h=this._cells[g.index].document.validatePosition(a),S=this._cellLines.getAccumulatedValue(g.index-1);return new b.Position(S+h.line,h.character)}}e.ExtHostNotebookConcatDocument=i}),define(me[200],ge([0,1,7,15,3]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(k){this._actual=new b.ColorTheme(b.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let D=k==="light"?b.ColorThemeKind.Light:k==="dark"?b.ColorThemeKind.Dark:b.ColorThemeKind.HighContrast;this._actual=new b.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=qe([He(0,T.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(me[64],ge([0,1,4]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,b.createDecorator)("IURITransformerService");class T{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=T}),define(me[201],ge([0,1,23]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(D){let P=this.buffers.indexOf(D);return P<0&&(P=this.buffers.length,this.buffers.push(D)),P}}function C(k,D){if(D.serializeBuffersForPostMessage){const P=new T,i=(g,a)=>{if(a instanceof ArrayBuffer){const h=P.add(a);return{$$vscode_array_buffer_reference$$:!0,index:h}}else if(ArrayBuffer.isView(a)){const h=A(a);if(h){const S=P.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:S,view:{type:h,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},I=JSON.stringify(k,i),m=P.buffers.map(g=>{const a=new Uint8Array(g);return b.VSBuffer.wrap(a)});return{message:I,buffers:m}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=C;function A(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(k,D){const P=D.map(m=>{const g=new ArrayBuffer(m.byteLength);return new Uint8Array(g).set(m.buffer),g}),i=D.length?(m,g)=>{if(typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const a=g,{index:h}=a,S=P[h];if(a.view)switch(a.view.type){case 1:return new Int8Array(S,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(S,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(S,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(S,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(S,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(S,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(S,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(S,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(S,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(S,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(S,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return S}return g}:void 0;return{message:JSON.parse(k,i),arrayBuffers:P}}e.deserializeWebviewMessage=y}),define(me[89],ge([0,1,2]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function T(C,A,y){var k;const D=C.webviewResourceRoot.replace("{{resource}}",((k=C.remote.authority)!==null&&k!==void 0?k:"")+"/"+y.scheme+"/"+encodeURIComponent(y.authority)+y.path).replace("{{uuid}}",A);return b.URI.parse(D).with({fragment:y.fragment,query:y.query})}e.asWebviewUri=T}),define(me[202],ge([0,1,3,6,89,30]),function(K,e,b,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(D,P,i){this._proxy=D,this._editors=P,this._initData=i,this._handlePool=0,this._disposables=new T.DisposableStore,this._insets=new Map,this._disposables.add(P.onDidChangeVisibleTextEditors(()=>{const I=P.getVisibleTextEditors();for(const m of this._insets.values())I.indexOf(m.editor)<0&&m.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,P,i,I,m){let g;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===D){g=l;break}if(!g)throw new Error("not a visible editor");const a=this,h=this._handlePool++,S=new b.Emitter,w=new b.Emitter,E=new class{constructor(){this._uuid=(0,A.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,C.asWebviewUri)(a._initData,this._uuid,l)}get cspSource(){return a._initData.webviewCspSource}set options(l){this._options=l,a._proxy.$setOptions(h,l)}get options(){return this._options}set html(l){this._html=l,a._proxy.$setHtml(h,l)}get html(){return this._html}get onDidReceiveMessage(){return S.event}postMessage(l){return a._proxy.$postMessage(h,l)}},d=new class{constructor(){this.editor=D,this.line=P,this.height=i,this.webview=E,this.onDidDispose=w.event}dispose(){a._insets.has(h)&&(a._insets.delete(h),a._proxy.$disposeEditorInset(h),w.fire(),w.dispose(),S.dispose())}};return this._proxy.$createEditorInset(h,g.id,g.value.document.uri,P+1,i,I||{},m.identifier,m.extensionLocation),this._insets.set(h,{editor:D,inset:d,onDidReceiveMessage:S}),d}$onDidDispose(D){const P=this._insets.get(D);P&&P.inset.dispose()}$onDidReceiveMessage(D,P){const i=this._insets.get(D);i&&i.onDidReceiveMessage.fire(P)}}e.ExtHostEditorInsets=y}),define(me[203],ge([0,1,3,82,170,4,6,22,40,16,54,24,43,196]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,g.registerIcon)("default-view-icon",m.Codicon.window,(0,C.localize)(0,null));var a;(function(o){o.ViewContainersRegistry="workbench.registry.view.containers",o.ViewsRegistry="workbench.registry.view"})(a=e.Extensions||(e.Extensions={}));var h;(function(o){o[o.Sidebar=0]="Sidebar",o[o.Panel=1]="Panel"})(h=e.ViewContainerLocation||(e.ViewContainerLocation={}));function S(o){switch(o){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=S;function w(o){return`viewContainer.${o}.enabled`}e.getEnabledViewContainerContextKey=w;class E extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new b.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new b.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(p,f,_){var u;const v=this.get(p.id);if(v)return v;const R=p;return R.openCommandActionDescriptor=(_==null?void 0:_.donotRegisterOpenCommand)?void 0:(u=R.openCommandActionDescriptor)!==null&&u!==void 0?u:{id:R.id},(0,k.getOrSet)(this.viewContainers,f,[]).push(R),(_==null?void 0:_.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:f}),R}deregisterViewContainer(p){for(const f of this.viewContainers.keys()){const _=this.viewContainers.get(f),u=_==null?void 0:_.indexOf(p);if(u!==-1){_==null||_.splice(u,1),_.length===0&&this.viewContainers.delete(f),this._onDidDeregister.fire({viewContainer:p,viewContainerLocation:f});return}}}get(p){return this.all.filter(f=>f.id===p)[0]}getViewContainers(p){return[...this.viewContainers.get(p)||[]]}getViewContainerLocation(p){return[...this.viewContainers.keys()].filter(f=>this.getViewContainers(f).filter(_=>(_==null?void 0:_.id)===p.id).length>0)[0]}getDefaultViewContainer(p){return this.defaultViewContainers.find(f=>this.getViewContainerLocation(f)===p)}}D.Registry.add(a.ViewContainersRegistry,new E);var d;(function(o){o.Open="2_open",o.Debug="4_debug",o.SCM="5_scm",o.More="9_more"})(d=e.ViewContentGroups||(e.ViewContentGroups={}));function l(o,p){var f,_,u,v;const R=(f=o.group)!==null&&f!==void 0?f:d.More,O=(_=p.group)!==null&&_!==void 0?_:d.More;return R!==O?R.localeCompare(O):((u=o.order)!==null&&u!==void 0?u:5)-((v=p.order)!==null&&v!==void 0?v:5)}class c extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new b.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new b.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new b.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new b.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(p,f){this.registerViews2([{views:p,viewContainer:f}])}registerViews2(p){p.forEach(({views:f,viewContainer:_})=>this.addViews(f,_)),this._onViewsRegistered.fire(p)}deregisterViews(p,f){const _=this.removeViews(p,f);_.length&&this._onViewsDeregistered.fire({views:_,viewContainer:f})}moveViews(p,f){for(const _ of this._views.keys())if(_!==f){const u=this.removeViews(p,_);u.length&&(this.addViews(u,f),this._onDidChangeContainer.fire({views:u,from:_,to:f}))}}getViews(p){return this._views.get(p)||[]}getView(p){for(const f of this._viewContainers){const _=(this._views.get(f)||[]).filter(u=>u.id===p)[0];if(_)return _}return null}getViewContainer(p){for(const f of this._viewContainers)if((this._views.get(f)||[]).filter(u=>u.id===p)[0])return f;return null}registerViewWelcomeContent(p,f){return this._viewWelcomeContents.add(p,f),this._onDidChangeViewWelcomeContent.fire(p),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(p,f),this._onDidChangeViewWelcomeContent.fire(p)})}registerViewWelcomeContent2(p,f){const _=new Map;for(const[u,v]of f)this._viewWelcomeContents.add(p,v),_.set(u,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(p,v),this._onDidChangeViewWelcomeContent.fire(p)}));return this._onDidChangeViewWelcomeContent.fire(p),_}getViewWelcomeContent(p){const f=[];return this._viewWelcomeContents.forEach(p,_=>f.push(_)),f.sort(l)}addViews(p,f){let _=this._views.get(f);_||(_=[],this._views.set(f,_),this._viewContainers.push(f));for(const u of p){if(this.getView(u.id)!==null)throw new Error((0,C.localize)(1,null,u.id));_.push(u)}}removeViews(p,f){const _=this._views.get(f);if(!_)return[];const u=[],v=[];for(const R of _)p.includes(R)?u.push(R):v.push(R);return u.length&&(v.length?this._views.set(f,v):(this._views.delete(f),this._viewContainers.splice(this._viewContainers.indexOf(f),1))),u}}D.Registry.add(a.ViewsRegistry,new c),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new T.RawContextKey("focusedView","",(0,C.localize)(2,null));function t(o){return`view.${o}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var n;(function(o){o[o.Default=0]="Default",o[o.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(p,f){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,p),this._hasResolve=!!f,this.resolve=async _=>{var u,v;if(f&&!this.resolved){const R=await f(_);R&&(this.tooltip=(u=this.tooltip)!==null&&u!==void 0?u:R.tooltip,this.command=(v=this.command)!==null&&v!==void 0?v:R.command)}_.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r}),define(me[204],ge([0,1,2,181,120,12,182,203]),function(K,e,b,T,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function D(h){return(S,...w)=>h(S.get(T.ICommandService),...w)}class P{static execute(S,w){const E={forceReuseWindow:w&&w.reuseWindow,remoteAuthority:w&&w.remoteAuthority};return S.executeCommand("_files.newWindow",E)}}e.NewWindowAPICommand=P,P.ID="vscode.newWindow",T.CommandsRegistry.registerCommand({id:P.ID,handler:D(P.execute),description:{description:"Opens an new window",args:[]}}),T.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(h,S){return h.get(C.IWorkspacesService).removeRecentlyOpened([S])});class i{static execute(S,w){return typeof w=="string"?w=w.match(/^[^:/?#]+:\/\//)?b.URI.parse(w):b.URI.file(w):w=b.URI.revive(w),S.executeCommand("_workbench.removeFromRecentlyOpened",w)}}e.RemoveFromRecentlyOpenedAPICommand=i,i.ID="vscode.removeFromRecentlyOpened",T.CommandsRegistry.registerCommand(i.ID,D(i.execute));class I{static execute(S,w){const E=typeof w=="string"?{extensionId:w}:w;return S.executeCommand("workbench.action.openIssueReporter",E)}}e.OpenIssueReporter=I,I.ID="vscode.openIssueReporter",T.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(h,S){const w=h.get(C.IWorkspacesService);let E;const d=S.uri,l=S.label,c=S.remoteAuthority;return S.type==="workspace"?E={workspace:await w.getWorkspaceIdentifier(d),label:l,remoteAuthority:c}:S.type==="folder"?E={folderUri:d,label:l,remoteAuthority:c}:E={fileUri:d,label:l,remoteAuthority:c},w.addRecentlyOpened([E])}),T.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(h){return h.get(C.IWorkspacesService).getRecentlyOpened()}),T.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(h,S){const w=h.get(A.ILogService),E=h.get(y.IEnvironmentService);E.isExtensionDevelopment&&!!E.extensionTestsLocationURI&&w.setLevel(S)}),T.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(h){return h.get(A.ILogService).getLevel()}),T.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(h,S){const w=h.get(k.IViewDescriptorService),E=w.getViewContainerById(S.destinationId);if(!!E){for(const d of S.viewIds){const l=w.getViewDescriptorById(d);(l==null?void 0:l.canMoveView)&&w.moveViewsToContainer([l],E,k.ViewVisibilityState.Default)}await h.get(k.IViewsService).openViewContainer(E.id,!0)}});class m{static execute(S,w){return!Array.isArray(w==null?void 0:w.viewIds)||typeof(w==null?void 0:w.destinationId)!="string"?Promise.reject("Invalid arguments"):S.executeCommand("_workbench.action.moveViews",w)}}e.MoveViewsAPICommand=m,m.ID="vscode.moveViews",T.CommandsRegistry.registerCommand({id:m.ID,handler:D(m.execute),description:{description:"Move Views",args:[]}});class g{static execute(S,w){return S.executeCommand("_workbench.open",w)}}g.ID="vscode.open",T.CommandsRegistry.registerCommand(g.ID,D(g.execute));class a{static execute(S,w,E,d,l){return S.executeCommand("_workbench.diff",[w,E,d])}}a.ID="vscode.diff",T.CommandsRegistry.registerCommand(a.ID,D(a.execute))}),define(me[123],ge([0,1,3,14,171]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new b.Emitter,this._onExit=new b.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,D,P,i){const I={command:k};if(D&&Object.keys(D).length>0&&(I.arguments=D),this.internalSend("request",I),typeof i=="number"){const m=setTimeout(()=>{clearTimeout(m);const g=this.pendingRequests.get(I.seq);if(g){this.pendingRequests.delete(I.seq);const a={type:"response",seq:0,request_seq:I.seq,success:!1,command:k,message:(0,C.localize)(0,null,i,k)};g(a)}},i)}return P&&this.pendingRequests.set(I.seq,P),I.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,D){return k.type!=="event"||D.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,T.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const D=k,P=this.pendingRequests.get(D.request_seq);P&&(this.pendingRequests.delete(D.request_seq),P(D));break}}}internalSend(k,D){D.type=k,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((D,P)=>k.set(P,D)),await(0,T.timeout)(500),k.forEach((D,P)=>{D({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(me[205],ge([0,1,9,2,8,24,13]),function(K,e,b,T,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function D(n,s,r){return n.replace(k,function(o,p){return s&&p.length>0&&p[0]!=="_"?o:r&&r.hasOwnProperty(p)?r[p]:o})}e.formatPII=D;function P(n){const s={};for(const r of Object.keys(n))r.startsWith("!")||(s[r]=n[r]);return s}e.filterExceptionsFromTelemetry=P;function i(n){return n.configuration.request==="attach"&&!I(n)}e.isSessionAttach=i;function I(n){let s=n.configuration.type;if(!!s)return s==="vslsShare"&&(s=n.configuration.adapterProxy.configuration.type),(0,b.equalsIgnoreCase)(s,"extensionhost")||(0,b.equalsIgnoreCase)(s,"pwa-extensionhost")?n:n.parentSession?I(n.parentSession):void 0}e.getExtensionHostDebugSession=I;function m(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=m;function g(n,s,r){let o,p=0,f=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,_=null;for(;_=f.exec(n);){let u=_.index+1,v=u+_[0].length;if(u<=s&&v>=r){o=_[0],p=u;break}}if(o){let u=/\w+/g,v=null;for(;(v=u.exec(o))&&!(v.index+1+p+v[0].length>=r););v&&(o=o.substring(0,u.lastIndex))}return o?{start:p,end:p+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(n){return!!(n&&n.match(a))}e.isUri=h;function S(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(h(n.path))return T.URI.parse(n.path);if((0,C.isAbsolute)(n.path))return T.URI.file(n.path)}return n.path}function w(n){if(typeof n.path=="object"){const s=T.URI.revive(n.path);if(s)return s.scheme===y.Schemas.file?s.fsPath:s.toString()}return n.path}function E(n,s){const r=s?S:w,o=(0,A.deepClone)(n);return l(o,(p,f)=>{p&&f&&(f.path=r(f))}),o}e.convertToDAPaths=E;function d(n,s){const r=s?S:w,o=(0,A.deepClone)(n);return l(o,(p,f)=>{!p&&f&&(f.path=r(f))}),o}e.convertToVSCPaths=d;function l(n,s){switch(n.type){case"event":const r=n;switch(r.event){case"output":s(!1,r.body.source);break;case"loadedSource":s(!1,r.body.source);break;case"breakpoint":s(!1,r.body.breakpoint.source);break;default:break}break;case"request":const o=n;switch(o.command){case"setBreakpoints":s(!0,o.arguments.source);break;case"breakpointLocations":s(!0,o.arguments.source);break;case"source":s(!0,o.arguments.source);break;case"gotoTargets":s(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(f=>s(!1,f));break;default:break}break;case"response":const p=n;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(f=>s(!1,f.source));break;case"loadedSources":p.body.sources.forEach(f=>s(!1,f));break;case"scopes":p.body.scopes.forEach(f=>s(!1,f.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(f=>s(!1,f.source));break;case"setBreakpoints":p.body.breakpoints.forEach(f=>s(!1,f.source));break;default:break}break}}function c(n){return n.filter(s=>{var r;return!((r=s.presentation)===null||r===void 0?void 0:r.hidden)}).sort((s,r)=>s.presentation?r.presentation?s.presentation.group?r.presentation.group?s.presentation.group!==r.presentation.group?s.presentation.group.localeCompare(r.presentation.group):t(s.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(s.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=c;function t(n,s){return typeof n!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:n-s}}),define(me[206],ge([0,1,26,38,172,124,8,9,24,10,183,123]),function(K,e,b,T,C,A,y,k,D,P,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class m extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(E,d){this.outputStream=d,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,E.on("data",l=>this.handleData(l))}sendMessage(E){if(this.outputStream){const d=JSON.stringify(E);this.outputStream.write(`Content-Length: ${Buffer.byteLength(d,"utf8")}${m.TWO_CRLF}${d}`,"utf8")}}handleData(E){for(this.rawData=Buffer.concat([this.rawData,E]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const d=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,d.length>0)try{this.acceptMessage(JSON.parse(d))}catch(l){this._onError.fire(new Error((l.message||l)+`
`+d))}continue}}else{const d=this.rawData.indexOf(m.TWO_CRLF);if(d!==-1){const c=this.rawData.toString("utf8",0,d).split(m.HEADER_LINESEPARATOR);for(const t of c){const n=t.split(m.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(d+m.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=m,m.TWO_CRLF=`\r
\r
`,m.HEADER_LINESEPARATOR=/\r?\n/,m.HEADER_FIELDSEPARATOR=/: */;class g extends m{startSession(){return new Promise((E,d)=>{let l=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),E(),l=!0}),this.socket.on("close",()=>{l?this._onError.fire(new Error("connection closed")):d(new Error("connection closed"))}),this.socket.on("error",c=>{l?this._onError.fire(c):d(c)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=g;class a extends g{constructor(E){super();this.adapterServer=E}createConnection(E){return A.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",E)}}e.SocketDebugAdapter=a;class h extends g{constructor(E){super();this.adapterServer=E}createConnection(E){return A.createConnection(this.adapterServer.path,E)}}e.NamedPipeDebugAdapter=h;class S extends m{constructor(E,d,l){super();this.adapterExecutable=E,this.debugType=d,this.outputService=l}async startSession(){const E=this.adapterExecutable.command,d=this.adapterExecutable.args,l=this.adapterExecutable.options||{};try{if(E)if(y.isAbsolute(E)){if(!await(0,b.exists)(E))throw new Error(C.localize(0,null,E))}else E.indexOf("/")<0&&E.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.debugType));let c=process.env;if(l.env&&Object.keys(l.env).length>0&&(c=D.mixin(D.deepClone(process.env),l.env)),E==="node")if(Array.isArray(d)&&d.length>0){const n=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:c,execArgv:n?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};l.cwd&&(s.cwd=l.cwd);const r=T.fork(d[0],d.slice(1),s);if(!r.pid)throw new Error(C.localize(2,null,d[0]));this.serverProcess=r}else throw new Error(C.localize(3,null));else{const n={env:c};l.cwd&&(n.cwd=l.cwd),this.serverProcess=T.spawn(E,d,n)}this.serverProcess.on("error",n=>{this._onError.fire(n)}),this.serverProcess.on("exit",(n,s)=>{this._onExit.fire(n)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",n=>{this._onError.fire(n)}),this.serverProcess.stdin.on("error",n=>{this._onError.fire(n)});const t=this.outputService;if(t){const n=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const r=t.getChannel(i.ExtensionsChannelId);r&&r.append(n(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(c){this._onError.fire(c)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((E,d)=>{const l=T.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(c,t,n){if(c)return d(c)});l.on("exit",E),l.on("error",d)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(E,d){if(!!E){const l=Object.create(null);E.runtime&&(E.runtime.indexOf("./")===0?l.runtime=y.join(d,E.runtime):l.runtime=E.runtime),E.runtimeArgs&&(l.runtimeArgs=E.runtimeArgs),E.program&&(y.isAbsolute(E.program)?l.program=E.program:l.program=y.join(d,E.program)),E.args&&(l.args=E.args);const c=E;return c.win&&(l.win=S.extract(c.win,d)),c.winx86&&(l.winx86=S.extract(c.winx86,d)),c.windows&&(l.windows=S.extract(c.windows,d)),c.osx&&(l.osx=S.extract(c.osx,d)),c.linux&&(l.linux=S.extract(c.linux,d)),l}}static platformAdapterExecutable(E,d){let l=Object.create(null);d=d.toLowerCase();for(const o of E)if(o.contributes){const p=o.contributes.debuggers;p&&p.length>0&&p.filter(f=>typeof f.type=="string"&&k.equalsIgnoreCase(f.type,d)).forEach(f=>{const _=S.extract(f,o.extensionLocation.fsPath);l=D.mixin(l,_,o.isBuiltin)})}let c;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?c=l.winx86||l.win||l.windows:P.isWindows?c=l.win||l.windows:P.isMacintosh?c=l.osx:P.isLinux&&(c=l.linux),c=c||l;let t=c.program||l.program;const n=c.args||l.args;let s=c.runtime||l.runtime;const r=c.runtimeArgs||l.runtimeArgs;if(s)return{type:"executable",command:s,args:(r||[]).concat(typeof t=="string"?[t]:[]).concat(n||[])};if(t)return{type:"executable",command:t,args:n||[]}}}e.ExecutableDebugAdapter=S}),define(me[207],ge([0,1,38,10,29,190]),function(K,e,b,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function y(m,g){return new Promise((a,h)=>{let S="";const w=b.spawn(m,g);w.pid&&w.stdout.on("data",E=>{S+=E.toString()}),w.on("error",E=>{h(E)}),w.on("close",E=>{a(S)})})}let k;function D(m,g){if(!k)if(T.isWindows)k=new A.WindowsExternalTerminalService(void 0);else if(T.isMacintosh)k=new A.MacExternalTerminalService(void 0);else if(T.isLinux)k=new A.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const a=g.getConfiguration("terminal");return k.runInTerminal(m.title,m.cwd,m.args,m.env||{},a.external||{})}e.runInExternalTerminal=D;function P(m){return m?T.isWindows?y("wmic",["process","get","ParentProcessId"]).then(g=>g.split(`\r
`).some(h=>parseInt(h)===m),g=>!0):y("/usr/bin/pgrep",["-lP",String(m)]).then(g=>{const a=g.trim();return!(a.length===0||a.indexOf(" tmux")>=0)},g=>!0):Promise.resolve(!0)}e.hasChildProcesses=P;var i;(function(m){m[m.cmd=0]="cmd",m[m.powershell=1]="powershell",m[m.bash=2]="bash"})(i||(i={}));function I(m,g,a,h){m=m.trim().toLowerCase();let S;m.indexOf("powershell")>=0||m.indexOf("pwsh")>=0?S=1:m.indexOf("cmd.exe")>=0?S=0:m.indexOf("bash")>=0?S=2:T.isWindows?S=0:S=2;let w,E=" ";switch(S){case 1:if(w=l=>(l=l.replace(/\'/g,"''"),l.length>0&&l.charAt(l.length-1)==="\\"?`'${l}\\'`:`'${l}'`),a){const l=(0,C.getDriveLetter)(a);l&&(E+=`${l}:; `),E+=`cd ${w(a)}; `}if(h)for(let l in h){const c=h[l];c===null?E+=`Remove-Item env:${l}; `:E+=`\${env:${l}}='${c}'; `}if(g.length>0){const l=w(g.shift());E+=l[0]==="'"?`& ${l} `:`${l} `;for(let c of g)E+=`${w(c)} `}break;case 0:if(w=l=>(l=l.replace(/\"/g,'""'),l.indexOf(" ")>=0||l.indexOf('"')>=0||l.length===0?`"${l}"`:l),a){const l=(0,C.getDriveLetter)(a);l&&(E+=`${l}: && `),E+=`cd ${w(a)} && `}if(h){E+='cmd /C "';for(let l in h){let c=h[l];c===null?E+=`set "${l}=" && `:(c=c.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),E+=`set "${l}=${c}" && `)}}for(let l of g)E+=`${w(l)} `;h&&(E+='"');break;case 2:w=l=>(l=l.replace(/(["'\\\$])/g,"\\$1"),l.indexOf(" ")>=0||l.indexOf(";")>=0||l.length===0?`"${l}"`:l);const d=l=>/[^\w@%\/+=,.:^-]/.test(l)?`'${l.replace(/'/g,"'\\''")}'`:l;if(a&&(E+=`cd ${w(a)} ; `),h){E+="/usr/bin/env";for(let l in h){const c=h[l];c===null?E+=` -u ${d(l)}`:E+=` ${d(`${l}=${c}`)}`}E+=" "}for(let l of g)E+=`${w(l)} `;break}return E}e.prepareCommand=I}),define(me[90],ge([0,1,33,13,8,10,82]),function(K,e,b,T,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarVisibility=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var k;(function(u){u[u.Markup=1]="Markup",u[u.Code=2]="Code"})(k=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(u){u[u.Running=1]="Running",u[u.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var P;(function(u){u[u.Idle=1]="Idle",u[u.Pending=2]="Pending",u[u.Executing=3]="Executing"})(P=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var i;(function(u){u[u.WithHardKernelDependency=0]="WithHardKernelDependency",u[u.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",u[u.Pure=2]="Pure",u[u.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var I;(function(u){u[u.ModelChange=1]="ModelChange",u[u.Move=2]="Move",u[u.CellClearOutput=3]="CellClearOutput",u[u.CellsClearOutput=4]="CellsClearOutput",u[u.ChangeLanguage=5]="ChangeLanguage",u[u.Initialize=6]="Initialize",u[u.ChangeCellMetadata=7]="ChangeCellMetadata",u[u.Output=8]="Output",u[u.OutputItem=9]="OutputItem",u[u.ChangeCellContent=10]="ChangeCellContent",u[u.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",u[u.Unknown=12]="Unknown"})(I=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var m;(function(u){u[u.Handle=0]="Handle",u[u.Index=1]="Index"})(m=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(u){u[u.Replace=1]="Replace",u[u.Output=2]="Output",u[u.Metadata=3]="Metadata",u[u.CellLanguage=4]="CellLanguage",u[u.DocumentMetadata=5]="DocumentMetadata",u[u.Move=6]="Move",u[u.OutputItems=7]="OutputItems",u[u.PartialMetadata=8]="PartialMetadata"})(g=e.CellEditType||(e.CellEditType={}));function a(u){const v=h.parse(u);return v?v.notebook.toString():u.toString()}e.getCellUndoRedoComparisonKey=a;var h;(function(u){u.scheme=T.Schemas.vscodeNotebookCell;const v=/^ch(\d{7,})/;function R(U,B){return U.with({scheme:u.scheme,fragment:`ch${B.toString().padStart(7,"0")}${U.scheme!==T.Schemas.file?U.scheme:""}`})}u.generate=R;function O(U){if(U.scheme===u.scheme){const B=v.exec(U.fragment);if(!!B)return{handle:Number(B[1]),notebook:U.with({scheme:U.fragment.substr(B[0].length)||T.Schemas.file,fragment:null})}}}u.parse=O;function H(U){if(U.scheme===T.Schemas.vscodeNotebookCellMetadata){const B=v.exec(U.fragment);if(!!B)return{handle:Number(B[1]),notebook:U.with({scheme:U.fragment.substr(B[0].length)||T.Schemas.file,fragment:null})}}}u.parseCellMetadataUri=H;function ne(U,B,x){return U.with({scheme:x,fragment:`ch${B.toString().padStart(7,"0")}${U.scheme!==T.Schemas.file?U.scheme:""}`})}u.generateCellUri=ne;function ie(U,B){if(U.scheme===B){const x=v.exec(U.fragment);if(!!x)return{handle:Number(x[1]),notebook:U.with({scheme:U.fragment.substr(x[0].length)||T.Schemas.file,fragment:null})}}}u.parseCellUri=ie})(h=e.CellUri||(e.CellUri={}));const S=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function w(u){var v,R;return(R=(v=S.get(u))===null||v===void 0?void 0:v.alwaysSecure)!==null&&R!==void 0?R:!1}e.mimeTypeIsAlwaysSecure=w;function E(u){var v,R;return(R=(v=S.get(u))===null||v===void 0?void 0:v.supportedByCore)!==null&&R!==void 0?R:!1}e.mimeTypeSupportedByCore=E;function d(u){var v,R;return(R=(v=S.get(u))===null||v===void 0?void 0:v.mergeable)!==null&&R!==void 0?R:!1}e.mimeTypeIsMergeable=d;function l(u,v){return A.isWindows&&(u=u.replace(/\//g,"\\"),v=v.replace(/\//g,"\\")),b.match(u,v)}function c(u,v,R){let O=0;for(let H=0;H<v.length;H++){if(l(v[H],u))return O;O++}for(let H=0;H<R.length;H++){if(l(R[H],u))return O;O++}return O}function t(u,v,R){return u.sort((O,H)=>c(O,v,R)-c(H,v,R))}e.sortMimeTypes=t;function n(u,v,R,O=(H,ne)=>H===ne){const H=[];function ne(B,x,L){if(!(x===0&&L.length===0)){const N=H[H.length-1];N&&N.start+N.deleteCount===B?(N.deleteCount+=x,N.toInsert.push(...L)):H.push({start:B,deleteCount:x,toInsert:L})}}let ie=0,U=0;for(;;){if(ie===u.length){ne(ie,0,v.slice(U));break}if(U===v.length){ne(ie,u.length-ie,[]);break}const B=u[ie],x=v[U];if(O(B,x)){ie+=1,U+=1;continue}R(x)?(ne(ie,1,[]),ie+=1):(ne(ie,0,[x]),U+=1)}return H}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(u){u.default="default",u.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(u){const v=u;return!!((typeof v.include=="string"||b.isRelativePattern(v.include))&&(typeof v.exclude=="string"||b.isRelativePattern(v.exclude)))}e.isDocumentExcludePattern=r;function o(u,v,R){if(Array.isArray(u.viewType)&&u.viewType.indexOf(v)>=0||u.viewType===v)return!0;if(u.filenamePattern){let O=r(u.filenamePattern)?u.filenamePattern.include:u.filenamePattern,H=r(u.filenamePattern)?u.filenamePattern.exclude:void 0;if(b.match(O,(0,C.basename)(R.fsPath).toLowerCase()))return!(H&&b.match(H,(0,C.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class p{constructor(v){this.textModel=v}getElements(){const v=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)v[R]=this.textModel.cells[R].getHashValue();return v}}e.CellSequence=p,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var f;(function(u){u[u.Left=1]="Left",u[u.Right=2]="Right"})(f=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class _{static create(v){return`${_._prefix}/${v}`}static parse(v){if(v.startsWith(_._prefix))return v.substr(_._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=_,_._prefix="notebook/"}),define(me[208],ge([0,1,174,4,82]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new C.RawContextKey("customExecutionSupported",!0,b.localize(0,null)),e.ShellExecutionSupportedContext=new C.RawContextKey("shellExecutionSupported",!1,b.localize(1,null)),e.ProcessExecutionSupportedContext=new C.RawContextKey("processExecutionSupported",!1,b.localize(2,null)),e.ITaskService=(0,T.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[209],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function b(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=b;function T(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=T}),define(me[210],ge([0,1,8,96,10]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function A(l,c){if(!!c)if(C.isWindows)for(const t in c){let n=t;for(const r in l)if(t.toLowerCase()===r.toLowerCase()){n=r;break}const s=c[t];s!==void 0&&y(l,n,s)}else Object.keys(c).forEach(t=>{const n=c[t];n!==void 0&&y(l,t,n)})}e.mergeEnvironments=A;function y(l,c,t){typeof t=="string"?l[c]=t:delete l[c]}function k(l,c,t,n){l.TERM_PROGRAM="vscode",c&&(l.TERM_PROGRAM_VERSION=c),i(l,n)&&(l.LANG=I(t)),l.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=k;function D(l,c){if(!!c)for(const t of Object.keys(c)){const n=c[t];n&&(l[t]=n)}}function P(l,c){return Object.keys(c).forEach(t=>{const n=c[t];if(typeof n=="string")try{c[t]=l(n)}catch(s){c[t]=n}}),c}function i(l,c){if(c==="on")return!0;if(c==="auto"){const t=l.LANG;return!t||t.search(/\.UTF\-8$/)===-1&&t.search(/\.utf8$/)===-1&&t.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=i;function I(l){const c=l?l.split("-"):[],t=c.length;if(t===0)return"en_US.UTF-8";if(t===1){const n={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};c[0]in n&&c.push(n[c[0]])}else c[1]=c[1].toUpperCase();return c.join("_")+".UTF-8"}e.getLangEnvVariable=I;function m(l,c,t,n,s,r){if(l.cwd){const p=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,f=g(p,t);return a(f||p)}let o;return!l.ignoreConfigurationCwd&&s&&(t&&(s=g(s,t,r)),s&&(b.isAbsolute(s)?o=s:n&&(o=b.join(n.fsPath,s)))),o||(o=n?n.fsPath:c||""),a(o)}e.getCwd=m;function g(l,c,t){if(c)try{return c(l)}catch(n){t==null||t.error("Could not resolve terminal cwd",n);return}return l}function a(l){return C.OS===1&&l&&l[1]===":"?l[0].toUpperCase()+l.substr(1):l}function h(l,c,t){if(!!t)return n=>t.resolveWithEnvironment(c,l,n)}e.createVariableResolver=h;function S(l,c,t,n,s,r,o,p=C.platform){let f;o&&(f=E(l,"automationShell",p)),f||(f=E(l,"shell",p));let _=f||c;if(p===3&&!t&&n){const u=b.join(n,"Sysnative").replace(/\//g,"\\").toLowerCase();_&&_.toLowerCase().indexOf(u)===0&&(_=b.join(n,"System32",_.substr(u.length+1)))}if(_&&p===3&&(_=_.replace(/\//g,"\\")),s)try{_=s(_)}catch(u){r.error("Could not resolve shell",u)}return _}e.getDefaultShell=S;function w(l,c,t,n,s=C.platform){if(c&&E(l,"automationShell",s))return[];const r=s===3?"windows":s===1?"osx":"linux";let o=l(`terminal.integrated.shellArgs.${r}`);if(!o)return[];if(typeof o=="string"&&s===3)return t?t(o):o;if(t){const p=[];for(const f of o)try{p.push(t(f))}catch(_){n.error(`Could not resolve terminal.integrated.shellArgs.${r}`,_),p.push(f)}o=p}return o}e.getDefaultShellArgs=w;function E(l,c,t=C.platform){return l(`terminal.integrated.${c}.${t===3?"windows":t===1?"osx":"linux"}`)}function d(l,c,t,n,s,r){const o={};if(l.strictEnv)D(o,l.env);else{D(o,r);const p=Object.assign({},c);t&&(p&&P(t,p),l.env&&P(t,l.env)),(0,T.sanitizeProcessEnvironment)(o,"VSCODE_IPC_HOOK_CLI"),A(o,p),A(o,l.env),k(o,n,C.locale,s)}return o}e.createTerminalEnvironment=d});var fn=this&&this.__asyncValues||function(K){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=K[Symbol.asyncIterator],b;return e?e.call(K):(K=typeof __values=="function"?__values(K):K[Symbol.iterator](),b={},T("next"),T("throw"),T("return"),b[Symbol.asyncIterator]=function(){return this},b);function T(A){b[A]=K[A]&&function(y){return new Promise(function(k,D){y=K[A](y),C(k,D,y.done,y.value)})}}function C(A,y,k,D){Promise.resolve(D).then(function(P){A({value:P,done:k})},y)}};define(me[211],ge([0,1,37,8,106,193,38,26,43,10]),function(K,e,b,T,C,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let i;function I(l,c,t,n,s,r,o){return t=t||{existsFile:k.SymlinkSupport.existsFile,readFile:b.promises.readFile},P.isWindows?m(l,t,n,c("terminal.integrated.useWslProfiles")||!0,c("terminal.integrated.profiles.windows"),c("terminal.integrated.defaultProfile.windows"),s,r):w(t,n,l,c(P.isMacintosh?"terminal.integrated.profiles.osx":"terminal.integrated.profiles.linux"),c(P.isMacintosh?"terminal.integrated.defaultProfile.osx":"terminal.integrated.defaultProfile.linux"),o,s,r)}e.detectAvailableProfiles=I;async function m(l,c,t,n,s,r,o,p){const f=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),_=`${process.env.windir}\\${f?"Sysnative":"System32"}`;let u=!1;(0,A.getWindowsBuildNumber)()>=16299&&(u=!0),await a();const v=new Map;l||(v.set("PowerShell",{source:"PowerShell",icon:D.Codicon.terminalPowershell.id,isAutoDetected:!0}),v.set("Windows PowerShell",{path:`${_}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:D.Codicon.terminalPowershell.id,isAutoDetected:!0}),v.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),v.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),v.set("Command Prompt",{path:`${_}\\cmd.exe`,icon:D.Codicon.terminalCmd.id,isAutoDetected:!0})),E(s,v);const R=await g(v.entries(),r,c,t,o,p);if(!l||l&&n)try{const O=await S(`${_}\\${u?"wsl":"bash"}.exe`,r);O&&R.push(...O)}catch(O){t==null||t.info("WSL is not installed, so could not detect WSL profiles")}return R}async function g(l,c,t,n,s,r){const o=[];for(const[p,f]of l)if(f!==null){let _,u,v;if("source"in f){const H=i==null?void 0:i.get(f.source);if(!H)continue;_=H.paths,u=f.args||H.args,v=f.icon||H.icon}else _=Array.isArray(f.path)?f.path:[f.path],u=P.isWindows||Array.isArray(f.args)?f.args:void 0,v=f.icon;const R=_.slice();for(let H=0;H<R.length;H++)R[H]=await(s==null?void 0:s.resolveAsync(r,R[H]))||R[H];const O=await d(p,c,R,t,u,f.env,f.overrideName,f.isAutoDetected,n);O?(O.isAutoDetected=f.isAutoDetected,O.icon=v,o.push(O)):n==null||n.trace("profile not validated",p,_)}return o}async function a(){i||(i=new Map,i.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),i.set("PowerShell",{profileName:"PowerShell",paths:await h(),icon:"terminal-powershell"}))}async function h(){var l,c;const t=[];try{for(var n=fn((0,C.enumeratePowerShellInstallations)()),s;s=await n.next(),!s.done;){const r=s.value;t.push(r.exePath)}}catch(r){l={error:r}}finally{try{s&&!s.done&&(c=n.return)&&await c.call(n)}finally{if(l)throw l.error}}return t}async function S(l,c){const t=[],n=await new Promise((o,p)=>{y.exec("wsl.exe -l -q",{encoding:"utf16le"},(f,_)=>{if(f)return p("Problem occurred when getting wsl distros");o(_)})});if(!n)return[];const s=new RegExp(/[\r?\n]/),r=n.split(s).filter(o=>o.trim().length>0&&o!=="");for(const o of r)if(o!==""&&!o.startsWith("docker-desktop")){const p=`${o} (WSL)`,f={profileName:p,path:l,args:["-d",`${o}`],isDefault:p===c};o.includes("Ubuntu")?f.icon="terminal-ubuntu":o.includes("Debian")?f.icon="terminal-debian":f.icon="terminal-linux",t.push(f)}return t}async function w(l,c,t,n,s,r,o,p){const f=new Map;if(!t){const _=await l.readFile("/etc/shells","utf8"),u=r||_.split(`
`).filter(R=>R.trim().indexOf("#")!==0&&R.trim().length>0),v=new Map;for(const R of u){let O=(0,T.basename)(R),H=v.get(O)||0;H++,H>1&&(O=`${O} (${H})`),v.set(O,H),f.set(O,{path:R,isAutoDetected:!0})}}return E(n,f),await g(f.entries(),s,l,c,o,p)}function E(l,c){if(!!l)for(const[t,n]of Object.entries(l))n===null||!("path"in n)&&!("source"in n)?c.delete(t):c.set(t,n)}async function d(l,c,t,n,s,r,o,p,f){if(t.length===0)return Promise.resolve(void 0);const _=t.shift();if(_==="")return d(l,c,t,n,s,r,o,p);const u={profileName:l,path:_,args:s,env:r,overrideName:o,isAutoDetected:p,isDefault:l===c};if((0,T.basename)(_)===_){const R=process.env.PATH?process.env.PATH.split(T.delimiter):void 0;return await(0,A.findExecutable)(_,void 0,R,void 0,n.existsFile)?u:d(l,c,t,n,s)}return await n.existsFile((0,T.normalize)(_))?u:d(l,c,t,n,s,r,o,p)}}),define(me[125],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var b;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(D,P)=>{P.expand!==void 0&&(D.expand=P.expand),P.item!==void 0&&(D.item=D.item?Object.assign(D.item,P.item):P.item)};e.applyTestItemUpdate=T;var C;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",D[D.Retire=4]="Retire"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));const A=(D,P)=>`${D}:${P.toString()}`;e.getTestSubscriptionKey=A;class y{add(P){}update(P){}remove(P,i){}complete(){}}e.IncrementalChangeCollector=y;class k{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(P){const i=this.createChangeCollector();for(const I of P)switch(I[0]){case 0:{const m=I[1];if(m.parent){if(this.items.has(m.parent)){const g=this.items.get(m.parent);g.children.add(m.item.extId);const a=this.createItem(m,g);this.items.set(m.item.extId,a),i.add(a)}}else{this.roots.add(m.item.extId);const g=this.createItem(m);this.items.set(m.item.extId,g),i.add(g)}m.expand===2&&this.busyControllerCount++;break}case 1:{const m=I[1],g=this.items.get(m.extId);if(!g)break;m.expand!==void 0&&(g.expand===2&&this.busyControllerCount--,m.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(g,m),i.update(g);break}case 2:{const m=this.items.get(I[1]);if(!m)break;m.parent?this.items.get(m.parent).children.delete(m.item.extId):this.roots.delete(m.item.extId);const g=[[I[1]]];for(;g.length;)for(const a of g.pop()){const h=this.items.get(a);h&&(g.push(h.children),this.items.delete(a),i.remove(h,h!==m),h.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(I[1]);break;case 3:this.updatePendingRoots(I[1]);break}i.complete()}retireTest(P){}updatePendingRoots(P){this.pendingRootCount+=P}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=k}),define(me[212],ge([0,1,8,36,11,24,10,77,175]),function(K,e,b,T,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(I,m,g){this._contributedVariables=new Map,this._context=I,this._labelService=m,g&&(this._envVariablesPromise=g.then(a=>this.prepareEnv(a)))}prepareEnv(I){if(y.isWindows){const m=Object.create(null);return Object.keys(I).forEach(g=>{m[g.toLowerCase()]=I[g]}),m}return I}resolveWithEnvironment(I,m,g){return this.recursiveResolve(this.prepareEnv(I),m?m.uri:void 0,g)}async resolveAsync(I,m){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,m)}async resolveAnyBase(I,m,g,a){const h=A.deepClone(m);return y.isWindows&&h.windows?Object.keys(h.windows).forEach(S=>h[S]=h.windows[S]):y.isMacintosh&&h.osx?Object.keys(h.osx).forEach(S=>h[S]=h.osx[S]):y.isLinux&&h.linux&&Object.keys(h.linux).forEach(S=>h[S]=h.linux[S]),delete h.windows,delete h.osx,delete h.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,h,g,a)}async resolveAnyAsync(I,m,g){return this.resolveAnyBase(I,m,g)}async resolveAnyMap(I,m,g){const a=new Map;return{newConfig:await this.resolveAnyBase(I,m,g,a),resolvedVariables:a}}resolveWithInteractionReplace(I,m,g,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,m,g,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,m){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,m)}recursiveResolve(I,m,g,a,h){if(C.isString(g))return this.resolveString(I,m,g,a,h);if(C.isArray(g))return g.map(S=>this.recursiveResolve(I,m,S,a,h));if(C.isObject(g)){let S=Object.create(null);return Object.keys(g).forEach(w=>{const E=this.resolveString(I,m,w,a,h);S[E]=this.recursiveResolve(I,m,g[w],a,h)}),S}return g}resolveString(I,m,g,a,h){return g.replace(P.VARIABLE_REGEXP,(w,E)=>{if(E.includes(P.VARIABLE_LHS))return w;let d=this.evaluateSingleVariable(I,w,E,m,a);return h&&h.set(E,d),d})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,m,g,a,h){let S;const w=g.split(":");w.length>1&&(g=w[0],S=w[1]);const E=()=>{const c=this._context.getFilePath();if(c)return c;throw new Error((0,D.localize)(0,null,m))},d=()=>{const c=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,m,b.basename(c)))},l=()=>{if(S){const c=this._context.getFolderUri(S);if(c)return c;throw new Error((0,D.localize)(2,null,m,S))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,m)):new Error((0,D.localize)(4,null,m))};switch(g){case"env":if(S){if(I){const c=I[y.isWindows?S.toLowerCase():S];if(C.isString(c))return c}return""}throw new Error((0,D.localize)(5,null,m));case"config":if(S){const c=this._context.getConfigurationValue(a,S);if(C.isUndefinedOrNull(c))throw new Error((0,D.localize)(6,null,m,S));if(C.isObject(c))throw new Error((0,D.localize)(7,null,m,S));return c}throw new Error((0,D.localize)(8,null,m));case"command":return this.resolveFromMap(m,S,h,"command");case"input":return this.resolveFromMap(m,S,h,"input");default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(l()));case"cwd":return a||S?(0,k.normalizeDriveLetter)(this.fsPath(l())):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return b.basename(this.fsPath(l()));case"lineNumber":const c=this._context.getLineNumber();if(c)return c;throw new Error((0,D.localize)(9,null,m));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,m));case"file":return E();case"fileWorkspaceFolder":return d();case"relativeFile":return a||S?b.relative(this.fsPath(l()),E()):E();case"relativeFileDirname":const n=b.dirname(E());if(a||S){const p=b.relative(this.fsPath(l()),n);return p.length===0?".":p}return n;case"fileDirname":return b.dirname(E());case"fileExtname":return b.extname(E());case"fileBasename":return b.basename(E());case"fileBasenameNoExtension":const s=b.basename(E());return s.slice(0,s.length-b.extname(s).length);case"fileDirnameBasename":return b.basename(b.dirname(E()));case"execPath":const r=this._context.getExecPath();return r||m;case"execInstallFolder":const o=this._context.getAppRoot();return o||m;case"pathSeparator":return b.sep;default:try{const p=S?`${g}:${S}`:g;return this.resolveFromMap(m,p,h,void 0)}catch(p){return m}}}}resolveFromMap(I,m,g,a){if(m&&g){const h=a===void 0?g[m]:g[a+":"+m];if(typeof h=="string")return h;throw new Error((0,D.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[213],ge([0,1,4]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,b.createDecorator)("editorGroupsService");var T;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(T=e.GroupDirection||(e.GroupDirection={}));var C;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var y;(function(m){m[m.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var k;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(k=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(m){m[m.GROUP_ACTIVE=0]="GROUP_ACTIVE",m[m.GROUP_INDEX=1]="GROUP_INDEX",m[m.EDITOR_OPEN=2]="EDITOR_OPEN",m[m.EDITOR_CLOSE=3]="EDITOR_CLOSE",m[m.EDITOR_MOVE=4]="EDITOR_MOVE",m[m.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",m[m.EDITOR_LABEL=6]="EDITOR_LABEL",m[m.EDITOR_PIN=7]="EDITOR_PIN",m[m.EDITOR_STICKY=8]="EDITOR_STICKY",m[m.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(P=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function I(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(me[214],ge([0,1,4]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,b.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(me[20],ge([0,1,16,100,285,60,24,11,2,44,81,176,116,90,214,7]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var S;(function(be){function he(Y){const{selectionStartLineNumber:Ne,selectionStartColumn:Fe,positionLineNumber:Ye,positionColumn:et}=Y,ct=new h.Position(Ne-1,Fe-1),ut=new h.Position(Ye-1,et-1);return new h.Selection(ct,ut)}be.to=he;function ae(Y){const{anchor:Ne,active:Fe}=Y;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:Fe.line+1,positionColumn:Fe.character+1}}be.from=ae})(S=e.Selection||(e.Selection={}));var w;(function(be){function he(Y){if(!!Y){const{start:Ne,end:Fe}=Y;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:Fe.line+1,endColumn:Fe.character+1}}}be.from=he;function ae(Y){if(!!Y){const{startLineNumber:Ne,startColumn:Fe,endLineNumber:Ye,endColumn:et}=Y;return new h.Range(Ne-1,Fe-1,Ye-1,et-1)}}be.to=ae})(w=e.Range||(e.Range={}));var E;(function(be){function he(ae){switch(ae){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 4:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}be.to=he})(E=e.TokenType||(e.TokenType={}));var d;(function(be){function he(Y){return new h.Position(Y.lineNumber-1,Y.column-1)}be.to=he;function ae(Y){return{lineNumber:Y.line+1,column:Y.character+1}}be.from=ae})(d=e.Position||(e.Position={}));var l;(function(be){function he(Y){switch(Y){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}be.from=he;function ae(Y){switch(Y){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}be.to=ae})(l=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(be){function he(Y){let Ne;return Y.code&&((0,k.isString)(Y.code)||(0,k.isNumber)(Y.code)?Ne=String(Y.code):Ne={value:String(Y.code.value),target:Y.code.target}),Object.assign(Object.assign({},w.from(Y.range)),{message:Y.message,source:Y.source,code:Ne,severity:n.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(t.from),tags:Array.isArray(Y.tags)?(0,b.coalesce)(Y.tags.map(l.from)):void 0})}be.from=he;function ae(Y){var Ne;const Fe=new h.Diagnostic(w.to(Y),Y.message,n.to(Y.severity));return Fe.source=Y.source,Fe.code=(0,k.isString)(Y.code)?Y.code:(Ne=Y.code)===null||Ne===void 0?void 0:Ne.value,Fe.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(t.to),Fe.tags=Y.tags&&(0,b.coalesce)(Y.tags.map(l.to)),Fe}be.to=ae})(c=e.Diagnostic||(e.Diagnostic={}));var t;(function(be){function he(Y){return Object.assign(Object.assign({},w.from(Y.location.range)),{message:Y.message,resource:Y.location.uri})}be.from=he;function ae(Y){return new h.DiagnosticRelatedInformation(new h.Location(Y.resource,w.to(Y)),Y.message)}be.to=ae})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(be){function he(Y){switch(Y){case h.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}be.from=he;function ae(Y){switch(Y){case m.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}be.to=ae})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(be){function he(Y){return typeof Y=="number"&&Y>=h.ViewColumn.One?Y-1:Y===h.ViewColumn.Beside?a.SIDE_GROUP:a.ACTIVE_GROUP}be.from=he;function ae(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=ae})(s=e.ViewColumn||(e.ViewColumn={}));function r(be){return typeof be.range!="undefined"}function o(be){return be.length===0?!0:!!r(be[0])}e.isDecorationOptionsArr=o;var p;(function(be){function he(et){return et.map(be.from)}be.fromMany=he;function ae(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function Y(et){let ct;if(ae(et)){const{language:ht,value:ft}=et;ct={value:"```"+ht+`
`+ft+"\n```\n"}}else h.MarkdownString.isMarkdownString(et)?ct={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?ct={value:et}:ct={value:""};const ut=Object.create(null);ct.uris=ut;const Ze=ht=>{try{let ft=D.URI.parse(ht,!0);ft=ft.with({query:Ne(ft.query,ut)}),ut[ht]=ft}catch(ft){}return""},mt=new C.Renderer;return mt.link=Ze,mt.image=ht=>Ze(T.parseHrefAndDimensions(ht).href),C(ct.value,{renderer:mt}),ct}be.from=Y;function Ne(et,ct){if(!et)return et;let ut;try{ut=(0,A.parse)(et)}catch(mt){}if(!ut)return et;let Ze=!1;return ut=(0,y.cloneAndChange)(ut,mt=>{if(D.URI.isUri(mt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[ht]=mt,Ze=!0,ht}else return}),Ze?JSON.stringify(ut):et}function Fe(et){const ct=new h.MarkdownString(et.value,et.supportThemeIcons);return ct.isTrusted=et.isTrusted,ct}be.to=Fe;function Ye(et){if(!!et)return typeof et=="string"?et:be.from(et)}be.fromStrict=Ye})(p=e.MarkdownString||(e.MarkdownString={}));function f(be){return o(be)?be.map(he=>({range:w.from(he.range),hoverMessage:Array.isArray(he.hoverMessage)?p.fromMany(he.hoverMessage):he.hoverMessage?p.from(he.hoverMessage):void 0,renderOptions:he.renderOptions})):be.map(he=>({range:w.from(he)}))}e.fromRangeOrRangeWithMessage=f;function _(be){return typeof be=="undefined"?be:typeof be=="string"?D.URI.file(be):be}e.pathOrURIToURI=_;var u;(function(be){function he(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?_(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}be.from=he})(u=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var v;(function(be){function he(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?_(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?u.from(ae.before):void 0,after:ae.after?u.from(ae.after):void 0}}be.from=he})(v=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(be){function he(ae){if(typeof ae=="undefined")return ae;switch(ae){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=he})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(be){function he(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?R.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?v.from(ae.light):void 0,dark:ae.dark?v.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?_(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?u.from(ae.before):void 0,after:ae.after?u.from(ae.after):void 0}}be.from=he})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var H;(function(be){function he(Y){return{text:Y.newText,eol:Y.newEol&&te.from(Y.newEol),range:w.from(Y.range)}}be.from=he;function ae(Y){const Ne=new h.TextEdit(w.to(Y.range),Y.text);return Ne.newEol=typeof Y.eol=="undefined"?void 0:te.to(Y.eol),Ne}be.to=ae})(H=e.TextEdit||(e.TextEdit={}));var ne;(function(be){function he(Y,Ne,Fe){var Ye,et,ct;const ut={edits:[]};if(Y instanceof h.WorkspaceEdit)for(let Ze of Y._allEntries())if(Ze._type===1)ut.edits.push({_type:1,oldUri:Ze.from,newUri:Ze.to,options:Ze.options,metadata:Ze.metadata});else if(Ze._type===2){const mt=Ne==null?void 0:Ne.getDocument(Ze.uri);ut.edits.push({_type:2,resource:Ze.uri,edit:H.from(Ze.edit),modelVersionId:mt==null?void 0:mt.version,metadata:Ze.metadata})}else Ze._type===3?ut.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,edit:Ze.edit,notebookMetadata:Ze.notebookMetadata,notebookVersionId:(Ye=Fe==null?void 0:Fe.getNotebookDocument(Ze.uri,!0))===null||Ye===void 0?void 0:Ye.apiNotebook.version}):Ze._type===4?(Ze.newOutputs&&ut.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,edit:{editType:2,index:Ze.index,append:Ze.append,outputs:Ze.newOutputs.map(Ie.from)}}),Ze.newMetadata&&ut.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,edit:{editType:8,index:Ze.index,metadata:Ze.newMetadata}})):Ze._type===5?ut.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,notebookVersionId:(et=Fe==null?void 0:Fe.getNotebookDocument(Ze.uri,!0))===null||et===void 0?void 0:et.apiNotebook.version,edit:{editType:1,index:Ze.index,count:Ze.count,cells:Ze.cells.map(J.from)}}):Ze._type===6&&ut.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,edit:{editType:7,outputId:Ze.outputId,items:((ct=Ze.newOutputItems)===null||ct===void 0?void 0:ct.map(ce.from))||[],append:Ze.append}});return ut}be.from=he;function ae(Y){const Ne=new h.WorkspaceEdit;for(const Fe of Y.edits)Fe.edit?Ne.replace(D.URI.revive(Fe.resource),w.to(Fe.edit.range),Fe.edit.text):Ne.renameFile(D.URI.revive(Fe.oldUri),D.URI.revive(Fe.newUri),Fe.options);return Ne}be.to=ae})(ne=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ie;(function(be){const he=Object.create(null);he[h.SymbolKind.File]=0,he[h.SymbolKind.Module]=1,he[h.SymbolKind.Namespace]=2,he[h.SymbolKind.Package]=3,he[h.SymbolKind.Class]=4,he[h.SymbolKind.Method]=5,he[h.SymbolKind.Property]=6,he[h.SymbolKind.Field]=7,he[h.SymbolKind.Constructor]=8,he[h.SymbolKind.Enum]=9,he[h.SymbolKind.Interface]=10,he[h.SymbolKind.Function]=11,he[h.SymbolKind.Variable]=12,he[h.SymbolKind.Constant]=13,he[h.SymbolKind.String]=14,he[h.SymbolKind.Number]=15,he[h.SymbolKind.Boolean]=16,he[h.SymbolKind.Array]=17,he[h.SymbolKind.Object]=18,he[h.SymbolKind.Key]=19,he[h.SymbolKind.Null]=20,he[h.SymbolKind.EnumMember]=21,he[h.SymbolKind.Struct]=22,he[h.SymbolKind.Event]=23,he[h.SymbolKind.Operator]=24,he[h.SymbolKind.TypeParameter]=25;function ae(Ne){return typeof he[Ne]=="number"?he[Ne]:6}be.from=ae;function Y(Ne){for(const Fe in he)if(he[Fe]===Ne)return Number(Fe);return h.SymbolKind.Property}be.to=Y})(ie=e.SymbolKind||(e.SymbolKind={}));var U;(function(be){function he(Y){switch(Y){case h.SymbolTag.Deprecated:return 1}}be.from=he;function ae(Y){switch(Y){case 1:return h.SymbolTag.Deprecated}}be.to=ae})(U=e.SymbolTag||(e.SymbolTag={}));var B;(function(be){function he(Y){return{name:Y.name,kind:ie.from(Y.kind),tags:Y.tags&&Y.tags.map(U.from),containerName:Y.containerName,location:M.from(Y.location)}}be.from=he;function ae(Y){const Ne=new h.SymbolInformation(Y.name,ie.to(Y.kind),Y.containerName,M.to(Y.location));return Ne.tags=Y.tags&&Y.tags.map(U.to),Ne}be.to=ae})(B=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var x;(function(be){function he(Y){var Ne,Fe;const Ye={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:w.from(Y.range),selectionRange:w.from(Y.selectionRange),kind:ie.from(Y.kind),tags:(Fe=(Ne=Y.tags)===null||Ne===void 0?void 0:Ne.map(U.from))!==null&&Fe!==void 0?Fe:[]};return Y.children&&(Ye.children=Y.children.map(he)),Ye}be.from=he;function ae(Y){const Ne=new h.DocumentSymbol(Y.name,Y.detail,ie.to(Y.kind),w.to(Y.range),w.to(Y.selectionRange));return(0,b.isNonEmptyArray)(Y.tags)&&(Ne.tags=Y.tags.map(U.to)),Y.children&&(Ne.children=Y.children.map(ae)),Ne}be.to=ae})(x=e.DocumentSymbol||(e.DocumentSymbol={}));var L;(function(be){function he(ae){const Y=new h.CallHierarchyItem(ie.to(ae.kind),ae.name,ae.detail||"",D.URI.revive(ae.uri),w.to(ae.range),w.to(ae.selectionRange));return Y._sessionId=ae._sessionId,Y._itemId=ae._itemId,Y}be.to=he})(L=e.CallHierarchyItem||(e.CallHierarchyItem={}));var N;(function(be){function he(ae){return new h.CallHierarchyIncomingCall(L.to(ae.from),ae.fromRanges.map(Y=>w.to(Y)))}be.to=he})(N=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var F;(function(be){function he(ae){return new h.CallHierarchyOutgoingCall(L.to(ae.to),ae.fromRanges.map(Y=>w.to(Y)))}be.to=he})(F=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var M;(function(be){function he(Y){return{range:Y.range&&w.from(Y.range),uri:Y.uri}}be.from=he;function ae(Y){return new h.Location(D.URI.revive(Y.uri),w.to(Y.range))}be.to=ae})(M=e.location||(e.location={}));var $;(function(be){function he(Y){const Ne=Y,Fe=Y;return{originSelectionRange:Ne.originSelectionRange?w.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:Fe.uri,range:w.from(Ne.targetRange?Ne.targetRange:Fe.range),targetSelectionRange:Ne.targetSelectionRange?w.from(Ne.targetSelectionRange):void 0}}be.from=he;function ae(Y){return{targetUri:D.URI.revive(Y.uri),targetRange:w.to(Y.range),targetSelectionRange:Y.targetSelectionRange?w.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?w.to(Y.originSelectionRange):void 0}}be.to=ae})($=e.DefinitionLink||(e.DefinitionLink={}));var q;(function(be){function he(Y){return{range:w.from(Y.range),contents:p.fromMany(Y.contents)}}be.from=he;function ae(Y){return new h.Hover(Y.contents.map(p.to),w.to(Y.range))}be.to=ae})(q=e.Hover||(e.Hover={}));var G;(function(be){function he(Y){return{range:w.from(Y.range),expression:Y.expression}}be.from=he;function ae(Y){return new h.EvaluatableExpression(w.to(Y.range),Y.expression)}be.to=ae})(G=e.EvaluatableExpression||(e.EvaluatableExpression={}));var le;(function(be){function he(Y){if(Y instanceof h.InlineValueText)return{type:"text",range:w.from(Y.range),text:Y.text};if(Y instanceof h.InlineValueVariableLookup)return{type:"variable",range:w.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof h.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}be.from=he;function ae(Y){switch(Y.type){case"text":return{range:w.to(Y.range),text:Y.text};case"variable":return{range:w.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:w.to(Y.range),expression:Y.expression}}}be.to=ae})(le=e.InlineValue||(e.InlineValue={}));var ve;(function(be){function he(Y){return{frameId:Y.frameId,stoppedLocation:w.from(Y.stoppedLocation)}}be.from=he;function ae(Y){return new h.InlineValueContext(Y.frameId,w.to(Y.stoppedLocation))}be.to=ae})(ve=e.InlineValueContext||(e.InlineValueContext={}));var Re;(function(be){function he(Y){return{range:w.from(Y.range),kind:Y.kind}}be.from=he;function ae(Y){return new h.DocumentHighlight(w.to(Y.range),Y.kind)}be.to=ae})(Re=e.DocumentHighlight||(e.DocumentHighlight={}));var Se;(function(be){function he(ae){switch(ae){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}be.to=he})(Se=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Oe;(function(be){function he(ae){return{triggerKind:Se.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}be.to=he})(Oe=e.CompletionContext||(e.CompletionContext={}));var V;(function(be){function he(Y){switch(Y){case h.CompletionItemTag.Deprecated:return 1}}be.from=he;function ae(Y){switch(Y){case 1:return h.CompletionItemTag.Deprecated}}be.to=ae})(V=e.CompletionItemTag||(e.CompletionItemTag={}));var X;(function(be){const he=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function ae(Fe){var Ye;return(Ye=he.get(Fe))!==null&&Ye!==void 0?Ye:9}be.from=ae;const Y=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function Ne(Fe){var Ye;return(Ye=Y.get(Fe))!==null&&Ye!==void 0?Ye:h.CompletionItemKind.Property}be.to=Ne})(X=e.CompletionItemKind||(e.CompletionItemKind={}));var Z;(function(be){function he(ae,Y){var Ne;const Fe=new h.CompletionItem(typeof ae.label=="string"?ae.label:ae.label.name);return typeof ae.label!="string"&&(Fe.label2=ae.label),Fe.insertText=ae.insertText,Fe.kind=X.to(ae.kind),Fe.tags=(Ne=ae.tags)===null||Ne===void 0?void 0:Ne.map(V.to),Fe.detail=ae.detail,Fe.documentation=T.isMarkdownString(ae.documentation)?p.to(ae.documentation):ae.documentation,Fe.sortText=ae.sortText,Fe.filterText=ae.filterText,Fe.preselect=ae.preselect,Fe.commitCharacters=ae.commitCharacters,P.Range.isIRange(ae.range)?Fe.range=w.to(ae.range):typeof ae.range=="object"&&(Fe.range={inserting:w.to(ae.range.insert),replacing:w.to(ae.range.replace)}),Fe.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Fe.insertText=new h.SnippetString(ae.insertText):(Fe.insertText=ae.insertText,Fe.textEdit=Fe.range instanceof h.Range?new h.TextEdit(Fe.range,Fe.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Fe.additionalTextEdits=ae.additionalTextEdits.map(Ye=>H.to(Ye))),Fe.command=Y&&ae.command?Y.fromInternal(ae.command):void 0,Fe}be.to=he})(Z=e.CompletionItem||(e.CompletionItem={}));var se;(function(be){function he(Y){return{label:Y.label,documentation:Y.documentation?p.fromStrict(Y.documentation):void 0}}be.from=he;function ae(Y){return{label:Y.label,documentation:T.isMarkdownString(Y.documentation)?p.to(Y.documentation):Y.documentation}}be.to=ae})(se=e.ParameterInformation||(e.ParameterInformation={}));var fe;(function(be){function he(Y){return{label:Y.label,documentation:Y.documentation?p.fromStrict(Y.documentation):void 0,parameters:Array.isArray(Y.parameters)?Y.parameters.map(se.from):[],activeParameter:Y.activeParameter}}be.from=he;function ae(Y){return{label:Y.label,documentation:T.isMarkdownString(Y.documentation)?p.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(se.to):[],activeParameter:Y.activeParameter}}be.to=ae})(fe=e.SignatureInformation||(e.SignatureInformation={}));var Ee;(function(be){function he(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(fe.from):[]}}be.from=he;function ae(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(fe.to):[]}}be.to=ae})(Ee=e.SignatureHelp||(e.SignatureHelp={}));var Be;(function(be){function he(Y){var Ne;return{text:Y.text,position:d.from(Y.position),kind:pe.from((Ne=Y.kind)!==null&&Ne!==void 0?Ne:h.InlayHintKind.Other),whitespaceBefore:Y.whitespaceBefore,whitespaceAfter:Y.whitespaceAfter}}be.from=he;function ae(Y){const Ne=new h.InlayHint(Y.text,d.to(Y.position),pe.to(Y.kind));return Ne.whitespaceAfter=Y.whitespaceAfter,Ne.whitespaceBefore=Y.whitespaceBefore,Ne}be.to=ae})(Be=e.InlayHint||(e.InlayHint={}));var pe;(function(be){function he(Y){return Y}be.from=he;function ae(Y){return Y}be.to=ae})(pe=e.InlayHintKind||(e.InlayHintKind={}));var Ce;(function(be){function he(Y){return{range:w.from(Y.range),url:Y.target,tooltip:Y.tooltip}}be.from=he;function ae(Y){let Ne;if(Y.url)try{Ne=typeof Y.url=="string"?D.URI.parse(Y.url,!0):D.URI.revive(Y.url)}catch(Fe){}return new h.DocumentLink(w.to(Y.range),Ne)}be.to=ae})(Ce=e.DocumentLink||(e.DocumentLink={}));var Me;(function(be){function he(Y){const Ne=new h.ColorPresentation(Y.label);return Y.textEdit&&(Ne.textEdit=H.to(Y.textEdit)),Y.additionalTextEdits&&(Ne.additionalTextEdits=Y.additionalTextEdits.map(Fe=>H.to(Fe))),Ne}be.to=he;function ae(Y){return{label:Y.label,textEdit:Y.textEdit?H.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(Ne=>H.from(Ne)):void 0}}be.from=ae})(Me=e.ColorPresentation||(e.ColorPresentation={}));var ze;(function(be){function he(Y){return new h.Color(Y[0],Y[1],Y[2],Y[3])}be.to=he;function ae(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}be.from=ae})(ze=e.Color||(e.Color={}));var _e;(function(be){function he(Y){return{range:w.from(Y.range)}}be.from=he;function ae(Y){return new h.SelectionRange(w.to(Y.range))}be.to=ae})(_e=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(be){function he(ae){switch(ae){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}be.to=he})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Q;(function(be){function he(Y){switch(Y){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.On:default:return 1}}be.from=he;function ae(Y){switch(Y){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 1:default:return h.TextEditorLineNumbersStyle.On}}be.to=ae})(Q=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var te;(function(be){function he(Y){if(Y===h.EndOfLine.CRLF)return 1;if(Y===h.EndOfLine.LF)return 0}be.from=he;function ae(Y){if(Y===1)return h.EndOfLine.CRLF;if(Y===0)return h.EndOfLine.LF}be.to=ae})(te=e.EndOfLine||(e.EndOfLine={}));var we;(function(be){function he(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=he})(we=e.ProgressLocation||(e.ProgressLocation={}));var xe;(function(be){function he(ae){const Y={start:ae.start+1,end:ae.end+1};return ae.kind&&(Y.kind=je.from(ae.kind)),Y}be.from=he})(xe=e.FoldingRange||(e.FoldingRange={}));var je;(function(be){function he(ae){if(ae)switch(ae){case h.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case h.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case h.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}be.from=he})(je=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ve;(function(be){function he(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?w.from(ae.selection):void 0,override:typeof ae.override=="boolean"?I.EditorOverride.DISABLED:void 0}}be.from=he})(Ve=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Je;(function(be){function he(Y){return Y instanceof h.RelativePattern||typeof Y=="string"?Y:ae(Y)?new h.RelativePattern(Y.base,Y.pattern):Y}be.from=he;function ae(Y){const Ne=Y;return Ne&&typeof Ne.base=="string"&&typeof Ne.pattern=="string"}})(Je=e.GlobPattern||(e.GlobPattern={}));var De;(function(be){function he(ae){if(ae){if(Array.isArray(ae))return ae.map(he);if(typeof ae=="string")return ae;{const Y=ae;return{language:Y.language,scheme:Y.scheme,pattern:typeof Y.pattern=="undefined"?void 0:Je.from(Y.pattern),exclusive:Y.exclusive}}}else return}be.from=he})(De=e.LanguageSelector||(e.LanguageSelector={}));var ye;(function(be){function he(Y){return{start:Y.start,end:Y.end}}be.from=he;function ae(Y){return new h.NotebookRange(Y.start,Y.end)}be.to=ae})(ye=e.NotebookRange||(e.NotebookRange={}));var Pe;(function(be){function he(ae){return new h.NotebookCellMetadata().with(Object.assign(Object.assign({},ae),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}be.to=he})(Pe=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var oe;(function(be){function he(Y){return Y}be.from=he;function ae(Y){return new h.NotebookDocumentMetadata().with(Y)}be.to=ae})(oe=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ue;(function(be){function he(Y){return{startTime:Y.runStartTime,endTime:Y.runEndTime,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}be.to=he;function ae(Y){return{lastRunSuccess:Y.success,runStartTime:Y.startTime,runEndTime:Y.endTime,executionOrder:Y.executionOrder}}be.from=ae})(ue=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var z;(function(be){function he(Y){switch(Y){case h.NotebookCellKind.Markup:return g.CellKind.Markup;case h.NotebookCellKind.Code:default:return g.CellKind.Code}}be.from=he;function ae(Y){switch(Y){case g.CellKind.Markup:return h.NotebookCellKind.Markup;case g.CellKind.Code:default:return h.NotebookCellKind.Code}}be.to=ae})(z=e.NotebookCellKind||(e.NotebookCellKind={}));var J;(function(be){function he(Y){var Ne;return{cellKind:z.from(Y.kind),language:Y.languageId,source:Y.value,metadata:Object.assign(Object.assign({},Y.metadata),ue.from((Ne=Y.executionSummary)!==null&&Ne!==void 0?Ne:{})),outputs:Y.outputs?Y.outputs.map(Ie.from):[]}}be.from=he;function ae(Y){return new h.NotebookCellData(z.to(Y.cellKind),Y.source,Y.language,Y.outputs?Y.outputs.map(Ie.to):void 0,Y.metadata?Pe.to(Y.metadata):void 0)}be.to=ae})(J=e.NotebookCellData||(e.NotebookCellData={}));var ce;(function(be){function he(Y){return{mime:Y.mime,value:Y.value,metadata:Y.metadata}}be.from=he;function ae(Y){return new h.NotebookCellOutputItem(Y.mime,Y.value,Y.metadata)}be.to=ae})(ce=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ie;(function(be){function he(Y){return{outputId:Y.id,outputs:Y.outputs.map(ce.from),metadata:Y.metadata}}be.from=he;function ae(Y){const Ne=Y.outputs.map(ce.to);return new h.NotebookCellOutput(Ne,Y.outputId,Y.metadata)}be.to=ae})(Ie=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ae;(function(be){function he(Fe){if(Fe!=null){if(Fe instanceof h.RelativePattern||typeof Fe=="string")return Fe;if(Ne(Fe))return new h.RelativePattern(Fe.base,Fe.pattern);if(Y(Fe))return{include:Je.from(Fe.include)||void 0,exclude:Je.from(Fe.exclude)||void 0}}}be.from=he;function ae(Fe){return typeof Fe=="string"?Fe:Ne(Fe)?{base:Fe.base,pattern:Fe.pattern}:{include:Fe.include,exclude:Fe.exclude}}be.to=ae;function Y(Fe){const Ye=Fe,et=Je.from(Ye.include);if(!(et&&et instanceof h.RelativePattern||typeof et=="string"))return!1;const ct=Je.from(Ye.exclude);return!!(ct&&ct instanceof h.RelativePattern||typeof ct=="string")}function Ne(Fe){const Ye=Fe;return Ye&&typeof Ye.base=="string"&&typeof Ye.pattern=="string"}})(Ae=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Le;(function(be){function he(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?u.from(ae.top):void 0}}be.from=he})(Le=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var $e;(function(be){function he(ae,Y,Ne){const Fe=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(Fe,Ne),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}be.from=he})($e=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Xe;(function(be){function he(ae){var Y,Ne;return{transientOutputs:(Y=ae==null?void 0:ae.transientOutputs)!==null&&Y!==void 0?Y:!1,transientCellMetadata:Object.assign(Object.assign({},ae==null?void 0:ae.transientCellMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Ne=ae==null?void 0:ae.transientDocumentMetadata)!==null&&Ne!==void 0?Ne:{}}}be.from=he})(Xe=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var rt;(function(be){function he(Y){var Ne;return{uri:Y.uri,provides:typeof Y.provides=="string"?[Y.provides]:(Ne=Y.provides)!==null&&Ne!==void 0?Ne:[]}}be.from=he;function ae(Y){return new h.NotebookKernelPreload(D.URI.revive(Y.uri),Y.provides)}be.to=ae})(rt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var tt;(function(be){function he(Y){return{message:p.fromStrict(Y.message)||"",severity:Y.severity,expectedOutput:Y.expectedOutput,actualOutput:Y.actualOutput,location:Y.location?M.from(Y.location):void 0}}be.from=he;function ae(Y){const Ne=new h.TestMessage(typeof Y.message=="string"?Y.message:p.to(Y.message));return Ne.severity=Y.severity,Ne.actualOutput=Y.actualOutput,Ne.expectedOutput=Y.expectedOutput,Ne}be.to=ae})(tt=e.TestMessage||(e.TestMessage={}));var Qe;(function(be){function he(Fe){var Ye,et;return{extId:Fe.id,label:Fe.label,uri:Fe.uri,range:w.from(Fe.range)||null,debuggable:(Ye=Fe.debuggable)!==null&&Ye!==void 0?Ye:!1,description:Fe.description||null,runnable:(et=Fe.runnable)!==null&&et!==void 0?et:!0,error:Fe.error&&p.fromStrict(Fe.error)||null}}be.from=he;function ae(Fe){return{extId:Fe.id,label:Fe.label,uri:Fe.uri,range:w.from(Fe.range)||null,debuggable:!1,description:Fe.description||null,error:null,runnable:!0}}be.fromResultSnapshot=ae;function Y(Fe){return{id:Fe.extId,label:Fe.label,uri:D.URI.revive(Fe.uri),range:w.to(Fe.range||void 0),addChild:()=>{},dispose:()=>{},status:h.TestItemStatus.Pending,data:void 0,debuggable:Fe.debuggable,description:Fe.description||void 0,runnable:Fe.runnable}}be.toPlain=Y;function Ne(Fe){const Ye=new h.TestItemImpl(Fe.extId,Fe.label,D.URI.revive(Fe.uri),void 0);return Ye.range=w.to(Fe.range||void 0),Ye.debuggable=Fe.debuggable,Ye.description=Fe.description||void 0,Ye.runnable=Fe.runnable,Ye}be.to=Ne})(Qe=e.TestItem||(e.TestItem={}));var gt;(function(be){const he=(Y,Ne)=>Object.assign(Object.assign({},Qe.toPlain(Y.item)),{taskStates:Y.tasks.map(Fe=>({state:Fe.state,duration:Fe.duration,messages:Fe.messages.map(tt.to)})),children:Y.children.map(Fe=>Ne.get(Fe)).filter(k.isDefined).map(Fe=>he(Fe,Ne))});function ae(Y){const Ne=[],Fe=new Map;for(const Ye of Y.items)Fe.set(Ye.item.extId,Ye),Ye.direct&&Ne.push(Ye);return{completedAt:Y.completedAt,results:Ne.map(Ye=>he(Ye,Fe))}}be.to=ae})(gt=e.TestResults||(e.TestResults={}));var wt;(function(be){function he(ae){switch(ae){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}be.to=he})(wt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(me[215],ge([0,1,2,17,7,20,58]),function(K,e,b,T,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(P,i,I,m={timeout:1500,errors:3}){this._logService=P,this._documents=i,this._mainThreadBulkEdits=I,this._thresholds=m,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(i,I,m)=>{const a={dispose:this._callbacks.push([i,I,P])};return Array.isArray(m)&&m.push(a),a}}async $participateInSave(P,i){const I=b.URI.revive(P);let m=!1;const g=setTimeout(()=>m=!0,this._thresholds.timeout),a=[];try{for(let h of[...this._callbacks]){if(m)break;const S=this._documents.getDocument(I),w=await this._deliverEventAsyncAndBlameBadListeners(h,{document:S,reason:A.TextDocumentSaveReason.to(i)});a.push(w)}}finally{clearTimeout(g)}return a}_deliverEventAsyncAndBlameBadListeners([P,i,I],m){const g=this._badListeners.get(P);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,P,i,m).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const h=this._badListeners.get(P);this._badListeners.set(P,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,i,I,m){const g=[],a=Date.now(),{document:h,reason:S}=m,{version:w}=h,E=Object.freeze({document:h,reason:S,waitUntil(d){if(Object.isFrozen(g))throw(0,T.illegalState)("waitUntil can not be called async");g.push(Promise.resolve(d))}});try{i.apply(I,[E])}catch(d){return Promise.reject(d)}return Object.freeze(g),new Promise((d,l)=>{const c=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(c),d(t)}).catch(t=>{clearTimeout(c),l(t)})}).then(d=>{const l={edits:[]};for(const c of d)if(Array.isArray(c)&&c.every(t=>t instanceof C.TextEdit))for(const{newText:t,newEol:n,range:s}of c)l.edits.push({_type:2,resource:h.uri,edit:{range:s&&A.Range.from(s),text:t,eol:n&&A.EndOfLine.from(n)}});if(l.edits.length!==0)return w===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(me[216],ge([0,1,3,14,33,2,20,7]),function(K,e,b,T,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(I,m,g,a,h){this._onDidCreate=new b.Emitter,this._onDidChange=new b.Emitter,this._onDidDelete=new b.Emitter,this._config=0,g&&(this._config+=1),a&&(this._config+=2),h&&(this._config+=4);const S=(0,C.parse)(m),w=I(E=>{if(!g)for(let d of E.created){const l=A.URI.revive(d);S(l.fsPath)&&this._onDidCreate.fire(l)}if(!a)for(let d of E.changed){const l=A.URI.revive(d);S(l.fsPath)&&this._onDidChange.fire(l)}if(!h)for(let d of E.deleted){const l=A.URI.revive(d);S(l.fsPath)&&this._onDidDelete.fire(l)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(I,m,g){this._logService=m,this._extHostDocumentsAndEditors=g,this._onFileSystemEvent=new b.Emitter,this._onDidRenameFile=new b.Emitter,this._onDidCreateFile=new b.Emitter,this._onDidDeleteFile=new b.Emitter,this._onWillRenameFile=new T.AsyncEmitter,this._onWillCreateFile=new T.AsyncEmitter,this._onWillDeleteFile=new T.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,m,g,a){return new D(this._onFileSystemEvent.event,I,m,g,a)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,m){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:m.map(g=>({oldUri:A.URI.revive(g.source),newUri:A.URI.revive(g.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:m.map(g=>A.URI.revive(g.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:m.map(g=>A.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,m){return(g,a,h)=>{const S=function(E){g.call(a,E)};return S.extension=I,m.event(S,void 0,h)}}async $onWillRunFileOperation(I,m,g,a){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:m.map(h=>({oldUri:A.URI.revive(h.source),newUri:A.URI.revive(h.target)}))},g,a);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:m.map(h=>A.URI.revive(h.target))},g,a);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:m.map(h=>A.URI.revive(h.target))},g,a)}}async _fireWillEvent(I,m,g,a){const h=new Set,S=[];if(await I.fireAsync(m,a,async(E,d)=>{var l;const c=Date.now(),t=await Promise.resolve(E);t instanceof k.WorkspaceEdit&&(S.push(t),h.add((l=d.extension.displayName)!==null&&l!==void 0?l:d.extension.identifier.value)),Date.now()-c>g&&this._logService.warn("SLOW file-participant",d.extension.identifier)}),!a.isCancellationRequested&&S.length!==0){const w={edits:[]};for(let E of S){let{edits:d}=y.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(d)}return{edit:w,extensionNames:Array.from(h)}}}}e.ExtHostFileSystemEventService=P}),define(me[217],ge([0,1,13,24,2,20,7,90]),function(K,e,b,T,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(m,g,a,h){this.start=m,this.deletedCount=g,this.deletedItems=a,this.items=h}static asApiEvents(m){return m.map(g=>({start:g.start,deletedCount:g.deletedCount,deletedItems:g.deletedItems,items:g.items.map(a=>a.apiCell)}))}}class P{constructor(m,g,a){var h;this.notebook=m,this._extHostDocument=g,this._cellData=a,this.handle=a.handle,this.uri=C.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=(h=a.metadata)!==null&&h!==void 0?h:{},this._metadata=A.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=A.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(m,g){return{EOL:g.eol,lines:g.source,modeId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:m}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const m=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return m.notebook.getCellIndex(m)},notebook:m.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get outputs(){return m._outputs.slice(0)},get metadata(){return m._metadata},get executionSummary(){return m._previousResult}})}return this._apiCell}setOutputs(m){this._outputs=m.map(A.NotebookCellOutput.to)}setOutputItems(m,g,a){const h=a.map(A.NotebookCellOutputItem.to),S=this._outputs.find(w=>w.id===m);S&&(g||(S.outputs.length=0),S.outputs.push(...h))}setMetadata(m){this._internalMetadata=m,this._metadata=A.NotebookCellMetadata.to(m),this._previousResult=A.NotebookCellPreviousExecutionResult.to(m)}}e.ExtHostCell=P;class i{constructor(m,g,a,h,S,w,E){this._proxy=m,this._textDocumentsAndEditors=g,this._textDocuments=a,this._emitter=h,this._viewType=S,this._metadata=w,this.uri=E,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const m=this;this._notebook={get uri(){return m.uri},get version(){return m._versionId},get viewType(){return m._viewType},get isDirty(){return m._isDirty},get isUntitled(){return m.uri.scheme===b.Schemas.untitled},get isClosed(){return m._disposed},get metadata(){return m._metadata},get cellCount(){return m._cells.length},cellAt(g){return g=m._validateIndex(g),m._cells[g].apiCell},getCells(g){return(g?m._getCells(g):m._cells).map(h=>h.apiCell)},save(){return m._save()}}}return this._notebook}updateBackup(m){var g;(g=this._backup)===null||g===void 0||g.delete(),this._backup=m}disposeBackup(){var m;(m=this._backup)===null||m===void 0||m.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(m){m.metadata&&(this._metadata=this._metadata.with(m.metadata))}acceptModelChanged(m,g){this._versionId=m.versionId,this._isDirty=g;for(const a of m.rawEvents)a.kind===k.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(a.changes,!0),a.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===k.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===k.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(a.index,a.metadata)}_validateIndex(m){return m=m|0,m<0?0:m>=this._cells.length?this._cells.length-1:m}_validateRange(m){let g=m.start|0,a=m.end|0;return g<0&&(g=0),a>this._cells.length&&(a=this._cells.length),m.with({start:g,end:a})}_getCells(m){m=this._validateRange(m);const g=[];for(let a=m.start;a<m.end;a++)g.push(this._cells[a]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(m,g){if(!this._disposed){const a=[],h=[],S=[];m.reverse().forEach(w=>{const d=w[2].map(t=>{const n=new P(this,this._textDocumentsAndEditors,t);return g||h.push(P.asModelAddData(this.apiNotebook,t)),n}),l=new D(w[0],w[1],[],d),c=this._cells.splice(w[0],w[1],...d);for(const t of c)S.push(t.uri),l.deletedItems.push(t.apiCell);a.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:S}),g||this._emitter.emitModelChange((0,T.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(a)}))}}_moveCell(m,g){const a=this._cells.splice(m,1);this._cells.splice(g,0,...a);const h=[new D(m,1,a.map(S=>S.apiCell),[]),new D(g,0,[],a)];this._emitter.emitModelChange((0,T.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(h)}))}_setCellOutputs(m,g){const a=this._cells[m];a.setOutputs(g),this._emitter.emitCellOutputsChange((0,T.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_setCellOutputItems(m,g,a,h){const S=this._cells[m];S.setOutputItems(g,a,h),this._emitter.emitCellOutputsChange((0,T.deepFreeze)({document:this.apiNotebook,cells:[S.apiCell]}))}_changeCellLanguage(m,g){const a=this._cells[m];a.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelModeChanged(a.uri,g)}_changeCellMetadata(m,g){var a;const h=this._cells[m],S=h.internalMetadata,w=h.apiCell.metadata;h.setMetadata(g);const E=h.apiCell.metadata;if((0,T.equals)(w,E)||this._emitter.emitCellMetadataChange((0,T.deepFreeze)({document:this.apiNotebook,cell:h.apiCell})),S.runState!==g.runState){const d=(a=g.runState)!==null&&a!==void 0?a:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,T.deepFreeze)({document:this.apiNotebook,cell:h.apiCell,executionState:d}))}}getCellFromApiCell(m){return this._cells.find(g=>g.apiCell===m)}getCellFromIndex(m){return this._cells[m]}getCell(m){return this._cells.find(g=>g.handle===m)}getCellIndex(m){return this._cells.indexOf(m)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(me[218],ge([0,1,7,20]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(k){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=k}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(k){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:k})}replaceCellMetadata(k,D){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:k,metadata:D})}replaceCells(k,D,P){this._throwIfFinalized(),!(k===D&&P.length===0)&&this._collectedEdits.push({editType:1,index:k,count:D-k,cells:P.map(T.NotebookCellData.from)})}}class A{constructor(k,D,P,i,I,m){this.id=k,this._proxy=D,this.notebookData=P,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=I,this._visibleRanges=i,this._viewColumn=m}get apiEditor(){if(!this._editor){const k=this;this._editor={get document(){return k.notebookData.apiNotebook},get selections(){return k._selections},get visibleRanges(){return k._visibleRanges},revealRange(D,P){k._proxy.$tryRevealRange(k.id,T.NotebookRange.from(D),P!=null?P:b.NotebookEditorRevealType.Default)},get viewColumn(){return k._viewColumn},edit(D){const P=new C(this.document.version);return D(P),k._applyEdit(P.finalize())},setDecorations(D,P){return k.setDecorations(D,P)}}}return this._editor}get visible(){return this._visible}_acceptVisibility(k){this._visible=k}_acceptVisibleRanges(k){this._visibleRanges=k}_acceptSelections(k){this._selections=k}_acceptViewColumn(k){this._viewColumn=k}_applyEdit(k){if(k.cellEdits.length===0)return Promise.resolve(!0);const D=[];let P=-1;for(let i=0;i<k.cellEdits.length;i++){if(P<0){D.push(k.cellEdits[i]),P++;continue}const m=D[P],g=k.cellEdits[i];if(m.editType===1&&g.editType===1&&m.index===g.index){m.cells.push(...k.cellEdits[i].cells),m.count+=k.cellEdits[i].count;continue}D.push(k.cellEdits[i]),P++}return this._proxy.$tryApplyEdits(this.id,k.documentVersionId,D)}setDecorations(k,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(k.key)))return D.isEmpty?this._hasDecorationsForKey.delete(k.key):this._hasDecorationsForKey.add(k.key),this._proxy.$trySetDecorations(this.id,T.NotebookRange.from(D),k.key)}}e.ExtHostNotebookEditor=A}),define(me[219],ge([0,1,20,117,164,21,55]),function(K,e,b,T,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class k{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,m,g){const a=this._handles++,{title:h,location:S,cancellable:w}=m,E={label:(0,C.localize)(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(a,{location:b.ProgressLocation.from(S),title:h,source:E,cancellable:w},I),this._withProgress(a,g,!!w)}_withProgress(I,m,g){let a;g&&(a=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,a));const h=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),a&&a.dispose()};let S;try{S=m(new P(this._proxy,I),g&&a?a.token:A.CancellationToken.None)}catch(w){throw h(I),w}return S.then(w=>h(I),w=>h(I)),S}$acceptProgressCanceled(I){const m=this._mapHandleToCancellationSource.get(I);m&&(m.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=k;function D(i,I){return i.message=I.message,typeof I.increment=="number"&&(typeof i.increment=="number"?i.increment+=I.increment:i.increment=I.increment),i}class P extends T.Progress{constructor(I,m){super(g=>this.throttledReport(g));this._proxy=I,this._handle=m}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}qe([(0,y.throttle)(100,(i,I)=>D(i,I),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(me[126],ge([0,1,53,17,73,20,7]),function(K,e,b,T,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(m,g){const a=k._Keys.nextId();m.$registerTextEditorDecorationType(a,A.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:a,dispose(){m.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=k,k._Keys=new C.IdGenerator("TextEditorDecorationType");class D{constructor(m,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=m,this._documentVersionId=m.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(m,g){this._throwIfFinalized();let a=null;if(m instanceof y.Position)a=new y.Range(m,m);else if(m instanceof y.Range)a=m;else throw new Error("Unrecognized location");this._pushEdit(a,g,!1)}insert(m,g){this._throwIfFinalized(),this._pushEdit(new y.Range(m,m),g,!0)}delete(m){this._throwIfFinalized();let g=null;if(m instanceof y.Range)g=m;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(m,g,a){const h=this._document.validateRange(m);this._collectedEdits.push({range:h,text:g,forceMoveMarkers:a})}setEndOfLine(m){if(this._throwIfFinalized(),m!==y.EndOfLine.LF&&m!==y.EndOfLine.CRLF)throw(0,T.illegalArgument)("endOfLine");this._setEndOfLine=m}}e.TextEditorEdit=D;class P{constructor(m,g,a,h){this._proxy=m,this._id=g,this._accept(a),this._logService=h;const S=this;this.value={get tabSize(){return S._tabSize},set tabSize(w){S._setTabSize(w)},get insertSpaces(){return S._insertSpaces},set insertSpaces(w){S._setInsertSpaces(w)},get cursorStyle(){return S._cursorStyle},set cursorStyle(w){S._setCursorStyle(w)},get lineNumbers(){return S._lineNumbers},set lineNumbers(w){S._setLineNumbers(w)}}}_accept(m){this._tabSize=m.tabSize,this._insertSpaces=m.insertSpaces,this._cursorStyle=m.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(m.lineNumbers)}_validateTabSize(m){if(m==="auto")return"auto";if(typeof m=="number"){const g=Math.floor(m);return g>0?g:null}if(typeof m=="string"){const g=parseInt(m,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(m){const g=this._validateTabSize(m);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}_setInsertSpaces(m){const g=this._validateInsertSpaces(m);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(m){this._cursorStyle!==m&&(this._cursorStyle=m,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:m})))}_setLineNumbers(m){this._lineNumbers!==m&&(this._lineNumbers=m,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(m)})))}assign(m){const g={};let a=!1;if(typeof m.tabSize!="undefined"){const h=this._validateTabSize(m.tabSize);h==="auto"?(a=!0,g.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,a=!0,g.tabSize=h)}if(typeof m.insertSpaces!="undefined"){const h=this._validateInsertSpaces(m.insertSpaces);h==="auto"?(a=!0,g.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,a=!0,g.insertSpaces=h)}typeof m.cursorStyle!="undefined"&&this._cursorStyle!==m.cursorStyle&&(this._cursorStyle=m.cursorStyle,a=!0,g.cursorStyle=m.cursorStyle),typeof m.lineNumbers!="undefined"&&this._lineNumbers!==m.lineNumbers&&(this._lineNumbers=m.lineNumbers,a=!0,g.lineNumbers=A.TextEditorLineNumbersStyle.from(m.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,g))}_warnOnError(m){m.catch(g=>this._logService.warn(g))}}e.ExtHostTextEditorOptions=P;class i{constructor(m,g,a,h,S,w,E,d){this.id=m,this._proxy=g,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._options=new P(this._proxy,this.id,w,a),this._visibleRanges=E,this._viewColumn=d;const l=this;this.value=Object.freeze({get document(){return h.getValue()},set document(c){throw(0,T.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(c){if(!(c instanceof y.Selection))throw(0,T.illegalArgument)("selection");l._selections=[c],l._trySetSelection()},get selections(){return l._selections},set selections(c){if(!Array.isArray(c)||c.some(t=>!(t instanceof y.Selection)))throw(0,T.illegalArgument)("selections");l._selections=c,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(c){throw(0,T.readonly)("visibleRanges")},get options(){return l._options.value},set options(c){l._disposed||l._options.assign(c)},get viewColumn(){return l._viewColumn},set viewColumn(c){throw(0,T.readonly)("viewColumn")},edit(c,t={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new D(h.getValue(),t);return c(n),l._applyEdit(n)},insertSnippet(c,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=l._selections.map(r=>A.Range.from(r));else if(t instanceof y.Position){const{lineNumber:r,column:o}=A.Position.from(t);s=[{startLineNumber:r,startColumn:o,endLineNumber:r,endColumn:o}]}else if(t instanceof y.Range)s=[A.Range.from(t)];else{s=[];for(const r of t)if(r instanceof y.Range)s.push(A.Range.from(r));else{const{lineNumber:o,column:p}=A.Position.from(r);s.push({startLineNumber:o,startColumn:p,endLineNumber:o,endColumn:p})}}return g.$tryInsertSnippet(m,c.value,s,n)},setDecorations(c,t){const n=t.length===0;n&&!l._hasDecorationsForKey.has(c.key)||(n?l._hasDecorationsForKey.delete(c.key):l._hasDecorationsForKey.add(c.key),l._runOnProxy(()=>{if(A.isDecorationOptionsArr(t))return g.$trySetDecorations(m,c.key,A.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let r=0,o=t.length;r<o;r++){const p=t[r];s[4*r]=p.start.line+1,s[4*r+1]=p.start.character+1,s[4*r+2]=p.end.line+1,s[4*r+3]=p.end.character+1}return g.$trySetDecorationsFast(m,c.key,s)}}))},revealRange(c,t){l._runOnProxy(()=>g.$tryRevealRange(m,A.Range.from(c),t||y.TextEditorRevealType.Default))},show(c){g.$tryShowEditor(m,A.ViewColumn.from(c))},hide(){g.$tryHideEditor(m)}})}dispose(){(0,b.ok)(!this._disposed),this._disposed=!0}_acceptOptions(m){(0,b.ok)(!this._disposed),this._options._accept(m)}_acceptVisibleRanges(m){(0,b.ok)(!this._disposed),this._visibleRanges=m}_acceptViewColumn(m){(0,b.ok)(!this._disposed),this._viewColumn=m}_acceptSelections(m){(0,b.ok)(!this._disposed),this._selections=m}async _trySetSelection(){const m=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,m)),this.value}_applyEdit(m){const g=m.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const a=g.edits.map(S=>S.range);a.sort((S,w)=>S.end.line===w.end.line?S.end.character===w.end.character?S.start.line===w.start.line?S.start.character-w.start.character:S.start.line-w.start.line:S.end.character-w.end.character:S.end.line-w.end.line);for(let S=0,w=a.length-1;S<w;S++){const E=a[S].end;if(a[S+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=g.edits.map(S=>({range:A.Range.from(S.range),text:S.text,forceMoveMarkers:S.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,h,{setEndOfLine:typeof g.setEndOfLine=="number"?A.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(m){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=i}),define(me[220],ge([0,1,167,25,2,3,6,14,7,11,16,20,21]),function(K,e,b,T,C,A,y,k,D,P,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(S,w){if((0,P.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let E;return Array.isArray(S.highlights)&&(E=S.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),E=E.length?E:void 0),{label:S.label,highlights:E}}}class a{constructor(w,E,d){this._proxy=w,this.commands=E,this.logService=d,this.treeViews=new Map;function l(c){return c&&c.$treeViewId&&c.$treeItemHandle}E.registerArgumentProcessor({processArgument:c=>l(c)?this.convertArgument(c):Array.isArray(c)&&c.length>0?c.map(t=>l(t)?this.convertArgument(t):t):c})}registerTreeDataProvider(w,E,d){const l=this.createTreeView(w,{treeDataProvider:E},d);return{dispose:()=>l.dispose()}}createTreeView(w,E,d){if(!E||!E.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!E.showCollapseAll,canSelectMany:!!E.canSelectMany,canDragAndDrop:!!E.canDragAndDrop}),c=this.createExtHostTreeView(w,E,d);return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get message(){return c.message},set message(t){c.message=t},get title(){return c.title},set title(t){c.title=t},get description(){return c.description},set description(t){c.description=t},reveal:(t,n)=>c.reveal(t,n),dispose:async()=>{await l,this.treeViews.delete(w),c.dispose()}}}$getChildren(w,E){const d=this.treeViews.get(w);return d?d.getChildren(E):Promise.reject(new Error((0,b.localize)(0,null,w)))}$setParent(w,E,d){const l=this.treeViews.get(w);return l?l.setParent(E,d):Promise.reject(new Error((0,b.localize)(1,null,w)))}async $hasResolve(w){const E=this.treeViews.get(w);if(!E)throw new Error((0,b.localize)(2,null,w));return E.hasResolve}$resolve(w,E,d){const l=this.treeViews.get(w);if(!l)throw new Error((0,b.localize)(3,null,w));return l.resolveTreeItem(E,d)}$setExpanded(w,E,d){const l=this.treeViews.get(w);if(!l)throw new Error((0,b.localize)(4,null,w));l.setExpanded(E,d)}$setSelection(w,E){const d=this.treeViews.get(w);if(!d)throw new Error((0,b.localize)(5,null,w));d.setSelection(E)}$setVisible(w,E){const d=this.treeViews.get(w);if(!d)throw new Error((0,b.localize)(6,null,w));d.setVisible(E)}createExtHostTreeView(w,E,d){const l=new h(w,E,this._proxy,this.commands.converter,this.logService,d);return this.treeViews.set(w,l),l}convertArgument(w){const E=this.treeViews.get(w.$treeViewId);return E?E.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=a;class h extends y.Disposable{constructor(w,E,d,l,c,t){super();if(this.viewId=w,this.proxy=d,this.commands=l,this.logService=c,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new m.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const o of t.contributes.views[r])o.id===w&&(this._title=o.name);this.dataProvider=E.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let n,s;this._register(A.Event.debounce(this._onDidChangeData.event,(r,o)=>(r||(r={message:!1,elements:[]}),o.element!==!1&&(n||(n=new Promise(p=>s=p),this.refreshPromise=this.refreshPromise.then(()=>n)),r.elements.push(o.element)),o.message&&(r.message=!0),r),200,!0)(({message:r,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=s;return n=null,this.refresh(o).then(()=>p())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!(0,P.isUndefinedOrNull)(w))}getChildren(w){const E=w?this.getExtensionElement(w):void 0;if(w&&!E)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);const d=this.getChildrenNodes(w);return(d?Promise.resolve(d):this.fetchChildrenNodes(E)).then(l=>l.map(c=>c.item))}getExtensionElement(w){return this.elements.get(w)}reveal(w,E){E=E||{select:!0,focus:!1};const d=(0,P.isUndefinedOrNull)(E.select)?!0:E.select,l=(0,P.isUndefinedOrNull)(E.focus)?!1:E.focus,c=(0,P.isUndefinedOrNull)(E.expand)?!1:E.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(s=>s.item)},{select:d,focus:l,expand:c})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:d,focus:l,expand:c})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,E){const d=this.getExtensionElement(w);d&&(E?this._onDidExpandElement.fire(Object.freeze({element:d})):this._onDidCollapseElement.fire(Object.freeze({element:d})))}setSelection(w){(0,i.equals)(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}setParent(w,E){const d=w.map(c=>this.getExtensionElement(c)).filter(c=>!(0,P.isUndefinedOrNull)(c)),l=this.getExtensionElement(E);return this.dataProvider.setParent&&d&&l?(0,k.asPromise)(()=>this.dataProvider.setParent(d,l)):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,E){var d;if(!!this.dataProvider.resolveTreeItem){const l=this.elements.get(w);if(l){const c=this.nodes.get(l);if(c){const t=(d=await this.dataProvider.resolveTreeItem(c.extensionItem,l,E))!==null&&d!==void 0?d:c.extensionItem;return c.item.tooltip=this.getTooltip(t.tooltip),c.item.command=this.getCommand(c.disposableStore,t.command),c.item}}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(E=>E?this.resolveUnknownParentChain(E).then(d=>this.resolveTreeNode(E,d[d.length-1]).then(l=>(d.push(l),d))):Promise.resolve([]))}resolveParent(w){const E=this.nodes.get(w);return E?Promise.resolve(E.parent?this.elements.get(E.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,E){const d=this.nodes.get(w);return d?Promise.resolve(d):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(l=>this.createHandle(w,l,E,!0)).then(l=>this.getChildren(E?E.item.handle:void 0).then(()=>{const c=this.getExtensionElement(l);if(c){const t=this.nodes.get(c);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${l}`)}))}getChildrenNodes(w){if(w){let E;if(typeof w=="string"){const d=this.getExtensionElement(w);E=d?this.nodes.get(d):void 0}else E=w;return E&&E.children||null}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const E=new m.CancellationTokenSource(this._refreshCancellationSource.token);try{const d=w?this.nodes.get(w):void 0,l=await this.dataProvider.getChildren(w);if(E.token.isCancellationRequested)return[];const c=await Promise.all((0,i.coalesce)(l||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!E.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,d):null}));return E.token.isCancellationRequested?[]:(0,i.coalesce)(c)}finally{E.dispose()}}refresh(w){if(w.some(d=>!d))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new m.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const d=this.getHandlesToRefresh(w);if(d.length)return this.refreshHandles(d)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const E=new Set,d=w.map(c=>this.nodes.get(c));for(const c of d)if(c&&!E.has(c.item.handle)){let t=c;for(;t&&t.parent&&d.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&E.add(c.item.handle)}const l=[];return E.forEach(c=>{const t=this.elements.get(c);if(t){const n=this.nodes.get(t);n&&(!n.parent||!E.has(n.parent.item.handle))&&l.push(c)}}),l}refreshHandles(w){const E={};return Promise.all(w.map(d=>this.refreshNode(d).then(l=>{l&&(E[d]=l.item)}))).then(()=>Object.keys(E).length?this.proxy.$refresh(this.viewId,E):void 0)}refreshNode(w){const E=this.getExtensionElement(w);if(E){const d=this.nodes.get(E);if(d)return this.clearChildren(E),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(E)).then(l=>{if(l){const c=this.createTreeNode(E,l,d.parent);return this.updateNodeCache(E,c,d,d.parent),d.dispose(),c}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,E,d){const l=this.createTreeNode(w,E,d);if(E.id&&this.elements.has(l.item.handle))throw new Error((0,b.localize)(7,null,E.id));return this.addNodeToCache(w,l),this.addNodeToParentCache(l,d),l}getTooltip(w){return D.MarkdownString.isMarkdownString(w)?I.MarkdownString.from(w):w}getCommand(w,E){return E?this.commands.toInternal(E,w):void 0}createTreeNode(w,E,d){const l=new y.DisposableStore,c=this.createHandle(w,E,d),t=this.getLightIconPath(E);return{item:{handle:c,parentHandle:d?d.item.handle:void 0,label:g(E.label,this.extension),description:E.description,resourceUri:E.resourceUri,tooltip:this.getTooltip(E.tooltip),command:this.getCommand(l,E.command),contextValue:E.contextValue,icon:t,iconDark:this.getDarkIconPath(E)||t,themeIcon:this.getThemeIcon(E),collapsibleState:(0,P.isUndefinedOrNull)(E.collapsibleState)?D.TreeItemCollapsibleState.None:E.collapsibleState,accessibilityInformation:E.accessibilityInformation},extensionItem:E,parent:d,children:void 0,disposableStore:l,dispose(){l.dispose()}}}getThemeIcon(w){return w.iconPath instanceof D.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:E,label:d,resourceUri:l},c,t){if(E)return`${h.ID_HANDLE_PREFIX}/${E}`;const n=g(d,this.extension),s=c?c.item.handle:h.LABEL_HANDLE_PREFIX;let r=n?n.label:l?(0,T.basename)(l):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const o=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,p=this.getChildrenNodes(c)||[];let f,_=0;do{if(f=`${s}/${_}:${r}`,t||!this.elements.has(f)||o===f)break;_++}while(_<=p.length);return f}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon))return typeof w.iconPath=="string"||C.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return C.URI.isUri(w)?w:C.URI.file(w)}addNodeToCache(w,E){this.elements.set(E.item.handle,w),this.nodes.set(w,E)}updateNodeCache(w,E,d,l){this.elements.delete(E.item.handle),this.nodes.delete(w),E.item.handle!==d.item.handle&&this.elements.delete(d.item.handle),this.addNodeToCache(w,E);const c=this.getChildrenNodes(l)||[],t=c.filter(n=>n.item.handle===d.item.handle)[0];t&&c.splice(c.indexOf(t),1,E)}addNodeToParentCache(w,E){E?(E.children||(E.children=[]),E.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const E=this.nodes.get(w);if(E){if(E.children)for(const d of E.children){const l=this.elements.get(d.item.handle);l&&this.clear(l)}E.children=void 0}}else this.clearAll()}clear(w){const E=this.nodes.get(w);if(E){if(E.children)for(const d of E.children){const l=this.elements.get(d.item.handle);l&&this.clear(l)}this.nodes.delete(w),this.elements.delete(E.item.handle),E.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}h.LABEL_HANDLE_PREFIX="0",h.ID_HANDLE_PREFIX="1"}),define(me[221],ge([0,1,16,14,21,11,88,20,7,125]),function(K,e,b,T,C,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class i{constructor(){this.testIdsToInternal=new Map}getTestById(S,w){if(w!==void 0){const E=this.testIdsToInternal.get(w),d=E==null?void 0:E.get(S);if(d)return[E,d]}return(0,b.mapFind)(this.testIdsToInternal.values(),E=>{const d=E.get(S);return d&&[E,d]})}createForHierarchy(S=()=>{}){return new a(this.createIdMap(m++),S)}createIdMap(S){const w=new g(S);return this.testIdsToInternal.set(w.id,w),{object:w,dispose:()=>this.testIdsToInternal.delete(w.id)}}}e.OwnedTestCollection=i;var I;(function(h){h[h.Disconnected=0]="Disconnected",h[h.IsChild=1]="IsChild",h[h.IsParent=2]="IsParent",h[h.IsSame=3]="IsSame"})(I=e.TestPosition||(e.TestPosition={}));let m=0;class g{constructor(S){this.id=S,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(S){if(this.map.has(S.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${S.item.extId}`);this.map.set(S.item.extId,S),S.parent||this._roots.add(S)}has(S){return this.map.has(S)}delete(S){const w=this.map.get(S);return w?(this.map.delete(S),this._roots.delete(w),!0):!1}get(S){return this.map.get(S)}comparePositions(S,w){const E=typeof S=="string"?this.map.get(S):S,d=typeof w=="string"?this.map.get(w):w;if(!E||!d)return 0;if(E===d)return 3;for(let l=this.map.get(d.parent);l;l=this.map.get(l.parent))if(l===E)return 1;for(let l=this.map.get(E.parent);l;l=this.map.get(l.parent))if(l===d)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=g;class a{constructor(S,w){this.testIdToInternal=S,this.publishDiff=w,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new T.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(S,w){this.addItem(S,w,null)}getTestByReference(S){return this.testItemToInternal.get(S)}collectDiff(){const S=this.diff;return this.diff=[],S}pushDiff(S){const w=this.diff[this.diff.length-1];if(w&&S[0]===1){if(w[0]===1&&w[1].extId===S[1].extId){(0,P.applyTestItemUpdate)(w[1],S[1]);return}if(w[0]===0&&w[1].item.extId===S[1].extId){(0,P.applyTestItemUpdate)(w[1],S[1]);return}}this.diff.push(S),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(S,w){var E;const d=this.testIdToInternal.object.get(S);if(!!d){if((d.expandLevels===void 0||w>d.expandLevels)&&(d.expandLevels=w),d.expand===1){const l=this.refreshChildren(d);return l.isSettled?this.expandChildren(d,w-1):l.p.then(()=>this.expandChildren(d,w-1))}else if(d.expand===3)return((E=d.initialExpand)===null||E===void 0?void 0:E.isSettled)===!1?d.initialExpand.p.then(()=>this.expandChildren(d,w-1)):this.expandChildren(d,w-1)}}dispose(){var S;for(const w of this.testItemToInternal.values())(S=w.discoverCts)===null||S===void 0||S.dispose(!0),(0,y.getPrivateApiFor)(w.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(S,w){const E=S==null?void 0:S.actual.id;switch(w[0]){case 2:this.pushDiff([4,E]);break;case 1:this.removeItem(S);break;case 0:this.addItem(w[1],S.src.controller,S);break;case 3:const[d,l,c]=w;switch(l){case"status":this.updateExpandability(S);break;case"range":this.pushDiff([1,{extId:E,item:{range:k.Range.from(c)}}]);break;case"error":this.pushDiff([1,{extId:E,item:{error:k.MarkdownString.fromStrict(c)||null}}]);break;default:this.pushDiff([1,{extId:E,item:{[l]:c!=null?c:null}}]);break}break;default:(0,A.assertNever)(w[0])}}addItem(S,w,E){if(!(S instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${S.id} did not`);if(this.testItemToInternal.has(S))throw new Error(`Attempted to add a single TestItem ${S.id} multiple times to the tree`);if(this.testIdToInternal.object.has(S.id))throw new Error(`Attempted to insert a duplicate test item ID ${S.id}`);const d=E?E.item.extId:null,l=S.resolveHandler?1:0,c=E?E.expandLevels:1,t={controller:w,tree:this.testIdToInternal.object.id},n={actual:S,parent:d,item:k.TestItem.from(S),expandLevels:c?c-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(S,n),this.pushDiff([0,{parent:d,src:t,expand:l,item:n.item}]);const s=(0,y.getPrivateApiFor)(S);s.parent=E==null?void 0:E.actual,s.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const r of s.children.values())this.testItemToInternal.has(r)||this.addItem(r,w,n)}updateExpandability(S){var w;let E;S.actual.resolveHandler?S.actual.status===D.TestItemStatus.Pending?E=S.discoverCts?2:1:((w=S.initialExpand)===null||w===void 0||w.complete(),E=3):E=0,E!==S.expand&&(S.expand=E,this.pushDiff([1,{extId:S.actual.id,expand:E}]),E===1&&S.expandLevels!==void 0&&this.refreshChildren(S))}expandChildren(S,w){if(!(w<0)){const E=[...S.actual.children.values()].map(d=>this.expand(d.id,w)).filter(T.isThenable);if(E.length)return Promise.all(E).then(()=>{})}}refreshChildren(S){if(S.discoverCts&&S.discoverCts.dispose(!0),!S.actual.resolveHandler){const w=new T.DeferredPromise;return w.complete(),w}return S.expand=2,S.discoverCts=new C.CancellationTokenSource,this.pushExpandStateUpdate(S),S.initialExpand=new T.DeferredPromise,S.actual.resolveHandler(S.discoverCts.token),S.initialExpand}pushExpandStateUpdate(S){this.pushDiff([1,{extId:S.actual.id,expand:S.expand}])}removeItem(S){var w;this.pushDiff([2,S.actual.id]);const E=[S];for(;E.length;){const d=E.pop();if(!!d){(w=d.discoverCts)===null||w===void 0||w.dispose(!0),this.testIdToInternal.object.delete(d.item.extId),this.testItemToInternal.delete(d.actual);for(const l of d.actual.children.values())E.push(this.testIdToInternal.object.get(l.id))}}}flushDiff(){const S=this.collectDiff();S.length&&this.publishDiff(S)}}e.SingleUseTestCollection=a}),define(me[222],ge([0,1,27,3,8]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=A;class y{constructor(i){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(b.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(b.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let I of i.activationEvents)I==="onUri"&&(I=`onUri:${b.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(i)}}keepOnly(i){const I=new Set;i.forEach(m=>I.add(b.ExtensionIdentifier.toKey(m))),this._extensionDescriptions=this._extensionDescriptions.filter(m=>I.has(b.ExtensionIdentifier.toKey(m.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,I){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const m=y._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(m.map(g=>g.identifier)),I.length>0){const g=new Set;I.forEach(a=>g.add(b.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!g.has(b.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(m)}static _findLoopingExtensions(i){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(S){this._nodesSet.has(S)||(this._nodesSet.add(S),this._nodesArr.push(S))}addArc(S,w){this.addNode(S),this.addNode(w),this._arcs.has(S)?this._arcs.get(S).push(w):this._arcs.set(S,[w])}getArcs(S){return this._arcs.has(S)?this._arcs.get(S):[]}hasOnlyGoodArcs(S,w){const E=I.getArcs(S);for(let d=0;d<E.length;d++)if(!w.has(E[d]))return!1;return!0}getNodes(){return this._nodesArr}};let m=new Map;for(let S of i){const w=b.ExtensionIdentifier.toKey(S.identifier);if(m.set(w,S),S.extensionDependencies)for(let E of S.extensionDependencies){const d=b.ExtensionIdentifier.toKey(E);I.addArc(w,d)}}let g=new Set;I.getNodes().filter(S=>I.getArcs(S).length===0).forEach(S=>g.add(S));let a=I.getNodes().filter(S=>!g.has(S)),h;do{h=!1;for(let S=0;S<a.length;S++){const w=a[S];I.hasOnlyGoodArcs(w,g)&&(a.splice(S,1),S--,g.add(w),h=!0)}}while(h);return a.map(S=>m.get(S))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(b.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const I=this._activationMap.get(i);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const I=this._extensionsMap.get(b.ExtensionIdentifier.toKey(i));return I||void 0}}e.ExtensionDescriptionRegistry=y;var k;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(k||(k={}));function D(P,i){const I=P.isBuiltin?0:P.isUnderDevelopment?2:1,m=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(I!==m)return I-m;const g=C.posix.basename(P.extensionLocation.path),a=C.posix.basename(i.extensionLocation.path);return g<a?-1:g>a?1:0}}),define(me[223],ge([0,1,23]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var T;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(T=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var C;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(C=e.MessageType||(e.MessageType={}));function A(k){const D=b.VSBuffer.alloc(1);switch(k){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=A;function y(k,D){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=y}),define(me[41],ge([0,1,3,2,4,27,184]),function(K,e,b,T,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,C.createDecorator)("extensionService");class k{constructor(E){this.dependency=E}}e.MissingExtensionDependency=k;var D;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class P{constructor(E,d,l,c){this.codeLoadingTime=E,this.activateCallTime=d,this.activateResolvedTime=l,this.activationReason=c}}e.ActivationTimes=P;class i{constructor(E,d){this.description=E,this.value=d}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var I;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function m(w){w.enableProposedApi||g(w)}e.checkProposedApiEnabled=m;function g(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=g;function a(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=a;function h(w){return Object.assign(Object.assign({identifier:new A.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!1,extensionLocation:w.location},w.manifest),{uuid:w.identifier.uuid})}e.toExtensionDescription=h;class S{constructor(){this.onDidRegisterExtensions=b.Event.None,this.onDidChangeExtensionsStatus=b.Event.None,this.onDidChangeExtensions=b.Event.None,this.onWillActivateByEvent=b.Event.None,this.onDidChangeResponsiveChange=b.Event.None}activateByEvent(E){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(E){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(E){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(E){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(E,d){return Promise.resolve()}_onWillActivateExtension(E){}_onDidActivateExtension(E,d,l,c,t){}_onDidActivateExtensionError(E,d){}_onExtensionRuntimeError(E,d){}_onExtensionHostExit(E){}}e.NullExtensionService=S}),define(me[224],ge([0,1,27,41,12]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class y{constructor(a,h,S,w){this.startup=a,this.codeLoadingTime=h,this.activateCallTime=S,this.activateResolvedTime=w}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class k{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,h){return a===-1||h===-1?-1:h-a}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=k;class D{constructor(a,h,S,w,E,d){this.activationFailed=a,this.activationFailedError=h,this.activationTimes=S,this.module=w,this.exports=E,this.subscriptions=d}}e.ActivatedExtension=D;class P extends D{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class i extends D{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class I extends D{constructor(a){super(!0,a,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let m=class{constructor(a,h,S,w,E){this._logService=E,this._registry=a,this._resolvedExtensionsSet=new Set,h.forEach(d=>this._resolvedExtensionsSet.add(b.ExtensionIdentifier.toKey(d))),this._hostExtensionsMap=new Map,S.forEach(d=>this._hostExtensionsMap.set(b.ExtensionIdentifier.toKey(d),d)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(a){const h=b.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(h)}getActivatedExtension(a){const h=b.ExtensionIdentifier.toKey(a),S=this._activatedExtensions.get(h);if(!S)throw new Error("Extension `"+a.value+"` is not known or not activated");return S}activateByEvent(a,h){if(this._alreadyActivatedEvents[a])return A;const S=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(S.map(w=>({id:w.identifier,reason:{startup:h,extensionId:w.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,h){const S=this._registry.getExtensionDescription(a);if(!S)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:S.identifier,reason:h}])}_handleActivateRequest(a,h,S){if(this._hostExtensionsMap.has(b.ExtensionIdentifier.toKey(a.id))){h[b.ExtensionIdentifier.toKey(a.id)]=a;return}const w=this._registry.getExtensionDescription(a.id);if(!w){const l=new Error(`Cannot activate unknown extension '${a.id.value}'`);this._host.onExtensionActivationError(a.id,l,new T.MissingExtensionDependency(a.id.value)),this._activatedExtensions.set(b.ExtensionIdentifier.toKey(a.id),new I(l));return}const E=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let d=!0;for(let l=0,c=E.length;l<c;l++){const t=E[l];if(!this._resolvedExtensionsSet.has(b.ExtensionIdentifier.toKey(t))){const n=this._activatedExtensions.get(b.ExtensionIdentifier.toKey(t));if(!(n&&!n.activationFailed)){if(n&&n.activationFailed){const p=w.displayName||w.identifier.value,f=this._registry.getExtensionDescription(t),_=f&&f.displayName||t,u=new Error(`Cannot activate the '${p}' extension because its dependency '${_}' failed to activate`);u.detail=n.activationFailedError,this._host.onExtensionActivationError(w.identifier,u,null),this._activatedExtensions.set(b.ExtensionIdentifier.toKey(w.identifier),new I(u));return}if(this._hostExtensionsMap.has(b.ExtensionIdentifier.toKey(t))){d=!1,h[b.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(b.ExtensionIdentifier.toKey(t)),reason:a.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){d=!1,h[b.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:a.reason};continue}const r=w.displayName||w.identifier.value,o=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,o,new T.MissingExtensionDependency(t)),this._activatedExtensions.set(b.ExtensionIdentifier.toKey(w.identifier),new I(o));return}}}d?h[b.ExtensionIdentifier.toKey(w.identifier)]=a:S.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(E=>!this._activatedExtensions.has(b.ExtensionIdentifier.toKey(E.id))),a.length===0))return Promise.resolve(void 0);const h=Object.create(null),S=[];for(let E=0,d=a.length;E<d;E++)this._handleActivateRequest(a[E],h,S);for(let E=0,d=S.length;E<d;E++){const l=b.ExtensionIdentifier.toKey(S[E].id);h[l]&&delete h[l]}const w=Object.keys(h).map(E=>h[E]);return S.length===0?Promise.all(w.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(w).then(E=>this._activateExtensions(S))}_activateExtension(a,h){const S=b.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(S))return Promise.resolve(void 0);const w=this._activatingExtensions.get(S);if(w)return w;const E=this._host.actualActivateExtension(a,h).then(void 0,d=>{const l=new Error;return d&&d.name&&(l.name=d.name),d&&d.message?l.message=`Activating extension '${a.value}' failed: ${d.message}.`:l.message=`Activating extension '${a.value}' failed: ${d}.`,d&&d.stack&&(l.stack=d.stack),this._host.onExtensionActivationError(a,l,null),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(d),new I(d)}).then(d=>{this._activatedExtensions.set(S,d),this._activatingExtensions.delete(S)});return this._activatingExtensions.set(S,E),E}};m=qe([He(4,C.ILogService)],m),e.ExtensionsActivator=m}),define(me[225],ge([0,1,12,41,28,13,115]),function(K,e,b,T,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let k=class extends b.LogService{constructor(P){if(P.logFile.scheme!==A.Schemas.file)throw new Error("Only file-logging supported");super(new y.SpdLogLogger(T.ExtensionHostLogFileName,P.logFile.fsPath,!0,P.logLevel))}$setLevel(P){this.setLevel(P)}};k=qe([He(0,C.IExtHostInitDataService)],k),e.ExtHostLogService=k}),define(me[226],ge([0,1,17]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class T{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,y)=>{this._actualOk=A,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,b.onUnexpectedError)(A))}then(A,y){return this._ensureActual().then(A,y)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=T}),define(me[127],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class b{constructor(D,P){this.isMain=D,this.sid=P,this.nid=++b.count}}e.ProxyIdentifier=b,b.count=0;const T=[];function C(k){const D=new b(!0,k);return T[D.nid]=D,D}e.createMainContextProxyIdentifier=C;function A(k){const D=new b(!1,k);return T[D.nid]=D,D}e.createExtHostContextProxyIdentifier=A;function y(k){return T[k].sid}e.getStringIdentifierForProxy=y}),define(me[5],ge([0,1,60,2,127]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(d){d[d.Desktop=1]="Desktop",d[d.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var y;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var m;(function(d){d.name="$ident";function l(t,n){return Object.defineProperty(t,d.name,{value:n,enumerable:!0}),t}d.mixin=l;function c(t){return t[d.name]}d.of=c})(m=e.ObjectIdentifier||(e.ObjectIdentifier={}));class g{static mixin(l){return l._id=g._n++,l}}e.IdObject=g,g._n=0;var a;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.command="m",d.kindModifier="n",d.label2="o"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var h;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(h=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(d){d[d.File=1]="File",d[d.Text=2]="Text",d[d.Cell=3]="Cell"})(S=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(d){if(d&&d.edits)for(const l of d.edits)typeof l.resource=="object"?l.resource=T.URI.revive(l.resource):(l.newUri=T.URI.revive(l.newUri),l.oldUri=T.URI.revive(l.oldUri)),l.metadata&&l.metadata.iconPath&&(l.metadata=(0,b.revive)(l.metadata));return d}e.reviveWorkspaceEditDto=w;var E;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,C.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,C.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,C.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,C.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,C.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,C.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,C.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,C.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,C.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,C.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,C.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,C.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,C.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,C.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,C.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,C.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,C.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,C.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,C.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,C.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,C.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,C.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,C.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,C.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,C.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,C.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,C.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,C.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,C.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,C.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,C.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,C.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,C.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,C.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,C.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,C.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,C.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,C.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,C.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,C.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,C.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,C.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,C.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,C.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,C.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,C.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,C.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,C.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,C.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,C.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,C.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,C.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,C.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,C.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,C.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,C.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,C.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,C.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,C.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,C.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,C.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[91],ge([0,1,5,3,4]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(k){this._onDidChangePassword=new T.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(b.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,D){return this._proxy.$getPassword(k,D)}store(k,D,P){return this._proxy.$setPassword(k,D,P)}delete(k,D){return this._proxy.$deletePassword(k,D)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")}),define(me[65],ge([0,1,4,12,5,15]),function(K,e,b,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,b.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(D,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(C.MainContext.MainThreadTelemetry)}report(D,P,i){const I=this.getUsageKey(D,P);this._reportedUsages.has(I)||(this._reportedUsages.add(I),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:D}))}getUsageKey(D,P){return`${D}-${P.identifier.value}`}};y=qe([He(0,A.IExtHostRpcService),He(1,T.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(k,D,P){}})}),define(me[227],ge([0,1,3,5,7,27]),function(K,e,b,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new b.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new b.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,P,i,I={}){const m=A.ExtensionIdentifier.toKey(D.identifier),g=this._inFlightRequests.get(m)||[],a=i.sort().join(" ");let h=g.find(S=>S.scopes===a);if(h)return h.result;{const S=this._getSession(D,m,P,i,I);h={scopes:a,result:S},g.push(h),this._inFlightRequests.set(m,g);try{await S}finally{const w=g.findIndex(E=>E.scopes===a);w>-1&&(g.splice(w),this._inFlightRequests.set(m,g))}return S}}async _getSession(D,P,i,I,m={}){await this._proxy.$ensureProvider(i);const g=D.displayName||D.name;return this._proxy.$getSession(i,I,P,g,m)}async removeSession(D,P){const i=this._authenticationProviders.get(D);return i?i.provider.removeSession(P):this._proxy.$removeSession(D,P)}registerAuthenticationProvider(D,P,i,I){var m;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:P,provider:i,options:I!=null?I:{supportsMultipleAccounts:!1}}),this._providers.find(a=>a.id===D)||this._providers.push({id:D,label:P});const g=i.onDidChangeSessions(a=>{var h,S,w;this._proxy.$sendDidChangeSessions(D,{added:(h=a.added)!==null&&h!==void 0?h:[],changed:(S=a.changed)!==null&&S!==void 0?S:[],removed:(w=a.removed)!==null&&w!==void 0?w:[]})});return this._proxy.$registerAuthenticationProvider(D,P,(m=I==null?void 0:I.supportsMultipleAccounts)!==null&&m!==void 0?m:!1),new C.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(D);const a=this._providers.findIndex(h=>h.id===D);a>-1&&this._providers.splice(a),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,P){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,P){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,P){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,P){return this._onDidChangeSessions.fire({provider:{id:D,label:P}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,P){return D.forEach(i=>{this._providers.some(I=>I.id===i.id)||this._providers.push(i)}),P.forEach(i=>{const I=this._providers.findIndex(m=>m.id===i.id);I>-1&&this._providers.splice(I)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:P}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(me[228],ge([0,1,5,15,20]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(k,D){this._extHostDocumentsAndEditors=D,this._proxy=k.getProxy(b.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const D=C.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};A=qe([He(0,T.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(me[229],ge([0,1,5]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(A){const y=A.getProxy(b.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(k){return y.$writeText(k)}})}}e.ExtHostClipboard=T}),define(me[52],ge([0,1,11,7,20,24,5,16,12,60,44,50,2,6,4,15]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=n,this.converter=new w(this,s=>{const r=this._apiCommands.get(s);return(r==null?void 0:r.result)===d.Void?r:void 0},n),this._argumentProcessors=[{processArgument(s){return(0,P.revive)(s)}},{processArgument(s){return(0,A.cloneAndChange)(s,function(r){if(i.Range.isIRange(r))return C.Range.to(r);if(I.Position.isIPosition(r))return C.Position.to(r);if(i.Range.isIRange(r.range)&&m.URI.isUri(r.uri))return C.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...s)=>{const r=t.args.map((p,f)=>{if(!p.validate(s[f]))throw new Error(`Invalid argument '${p.name}' when running '${t.id}', received: ${s[f]}`);return p.convert(s[f])}),o=await this.executeCommand(t.internalId,...r);return t.result.convert(o,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new T.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,s,r,o){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:s,thisArg:r,description:o}),t&&this._proxy.$registerCommand(n),new T.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,s){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const r=(0,A.cloneAndChange)(n,function(o){if(o instanceof T.Position)return C.Position.from(o);if(o instanceof T.Range)return C.Range.from(o);if(o instanceof T.Location)return C.location.from(o);if(T.NotebookRange.isNotebookRange(o))return C.NotebookRange.from(o);if(!Array.isArray(o))return o});try{const o=await this._proxy.$executeCommand(t,r,s);return(0,P.revive)(o)}catch(o){if(o instanceof Error&&o.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw o}}}async _executeContributedCommand(t,n){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:r,thisArg:o,description:p}=s;if(p)for(let f=0;f<p.args.length;f++)try{(0,b.validateConstraint)(n[f],p.args[f].constraint)}catch(_){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${p.args[f].name}' - ${p.args[f].description}`)}try{return await r.apply(o,n)}catch(f){if(t===this.converter.delegatingCommandId){const _=this.converter.getActualCommand(...n);_&&(t=_.command)}throw this._logService.error(f,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(s=>this._argumentProcessors.reduce((r,o)=>o.processArgument(r),s)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(s=>s[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,s]of this._commands){let{description:r}=s;r&&(t[n]=r)}return Promise.resolve(t)}};S=qe([He(0,h.IExtHostRpcService),He(1,D.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class w{constructor(t,n,s){this._commands=t,this._lookupApiCommand=n,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const r=this._lookupApiCommand(t.command);if(r)s.id=r.internalId,s.arguments=r.args.map((o,p)=>o.convert(t.arguments&&t.arguments[p]));else if((0,k.isNonEmptyArray)(t.arguments)){const o=++this._cachIdPool;this._cache.set(o,t),n.add((0,g.toDisposable)(()=>{this._cache.delete(o),this._logService.trace("CommandsConverter#DISPOSE",o)})),s.$ident=o,s.id=this.delegatingCommandId,s.arguments=[o],this._logService.trace("CommandsConverter#CREATE",t.command,o)}return s}}fromInternal(t){const n=y.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class E{constructor(t,n,s,r){this.name=t,this.description=n,this.validate=s,this.convert=r}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new E(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",c=>m.URI.isUri(c),c=>c),E.Position=new E("position","A position in a text document",c=>T.Position.isPosition(c),C.Position.from),E.Range=new E("range","A range in a text document",c=>T.Range.isRange(c),C.Range.from),E.Selection=new E("selection","A selection in a text document",c=>T.Selection.isSelection(c),C.Selection.from),E.Number=new E("number","",c=>typeof c=="number",c=>c),E.String=new E("string","",c=>typeof c=="string",c=>c),E.CallHierarchyItem=new E("item","A call hierarchy item",c=>c instanceof T.CallHierarchyItem,C.CallHierarchyItem.to);class d{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=d,d.Void=new d("no result",c=>c);class l{constructor(t,n,s,r,o){this.id=t,this.internalId=n,this.description=s,this.args=r,this.result=o}}e.ApiCommand=l}),define(me[230],ge([0,1,6,20,7,81,52,204,16,112]),function(K,e,b,T,C,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const i=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",m(T.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,h)=>{if(!(0,D.isFalsyOrEmpty)(a)){class S extends C.SymbolInformation{static to(E){const d=new S(E.name,T.SymbolKind.to(E.kind),E.containerName||"",new C.Location(h[0],T.Range.to(E.range)));return d.detail=E.detail,d.range=d.location.range,d.selectionRange=T.Range.to(E.selectionRange),d.children=E.children?E.children.map(S.to):[],d}}return a.map(S.to)}})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",m(T.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",m(T.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",m(T.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",m(T.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",m(T.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(h=>C.Position.isPosition(h)),a=>a.map(T.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(h=>{let S;for(const w of h.reverse())S=new C.SelectionRange(T.Range.to(w),S);return S}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>{const h=[];if(Array.isArray(a))for(let S of a)h.push(...S[1].map(T.WorkspaceSymbol.to));return h})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(T.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(T.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(T.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return T.WorkspaceEdit.to(a)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(T.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new C.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const h=(0,P.decodeSemanticTokensDto)(a);if(h.type==="full")return new C.SemanticTokens(h.data,void 0)}})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new C.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!!a){const h=(0,P.decodeSemanticTokensDto)(a);if(h.type==="full")return new C.SemanticTokens(h.data,void 0)}})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,h,S)=>{if(!a)return new C.CompletionList([]);const w=a.suggestions.map(E=>T.CompletionItem.to(E,S));return new C.CompletionList(w,a.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return T.SignatureHelp.to(a)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,h,S)=>m(w=>new C.CodeLens(T.Range.to(w.range),w.command&&S.fromInternal(w.command)))(a))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>C.Range.isRange(a),a=>C.Selection.isSelection(a)?T.Selection.from(a):T.Range.from(a)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,h,S)=>m(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return S.fromInternal(w.command)}else{const E=new C.CodeAction(w.title,w.kind?new C.CodeActionKind(w.kind):void 0);return w.edit&&(E.edit=T.WorkspaceEdit.to(w.edit)),w.command&&(E.command=S.fromInternal(w.command)),E.isPreferred=w.isPreferred,E}})(a))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(h=>new C.ColorInformation(T.Range.to(h.range),T.Color.to(h.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",a=>a instanceof C.Color,T.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:T.Range.from(a.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(T.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",a=>a.map(T.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",m(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(h=>T.NotebookExclusiveDocumentPattern.to(h))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(T.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[T.ViewColumn.from(a.viewColumn),T.TextEditorOpenOptions.from(a)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[T.ViewColumn.from(a.viewColumn),T.TextEditorOpenOptions.from(a)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[T.ViewColumn.from(a.viewColumn),T.TextEditorOpenOptions.from(a)]).optional()],y.ApiCommandResult.Void)];class I{constructor(h){this._disposables=new b.DisposableStore,this._commands=h}static register(h){return i.forEach(h.registerApiCommand,h),new I(h).registerCommands()}registerCommands(){const h=S=>(...w)=>S(this._commands,...w);this._register(k.RemoveFromRecentlyOpenedAPICommand.ID,h(k.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:S=>typeof S=="string"}]}),this._register(k.OpenIssueReporter.ID,h(k.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:S=>typeof S=="string"||typeof S=="object"&&typeof S.extensionId=="string"}]})}_register(h,S,w){const E=this._commands.registerCommand(!1,h,S,this,w);this._disposables.add(E)}}e.ExtHostApiCommands=I;function m(a){return h=>{if(Array.isArray(h))return h.map(a)}}function g(a){if(!!Array.isArray(a)){const h=[];for(const S of a)A.isLocationLink(S)?h.push(T.DefinitionLink.to(S)):h.push(T.location.to(S));return h}}}),define(me[231],ge([0,1,14,55,3,6,2,81,27,20,7,5]),function(K,e,b,T,C,A,y,k,D,P,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class m{constructor(l,c,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=l.getProxy(I.MainContext.MainThreadComments),c.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const s=this._commentControllers.get(n.handle);return s||n}else if(n&&n.$mid===7){const s=this._commentControllers.get(n.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.commentThreadHandle);return r||n}else if(n&&n.$mid===8){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);return r?{thread:r,text:n.text}:n}else if(n&&n.$mid===9){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let o=n.commentUniqueId,p=r.getCommentByUniqueId(o);return p||n}else if(n&&n.$mid===10){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const r=s.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let o=n.text,p=n.commentUniqueId,f=r.getCommentByUniqueId(p);return f?(f.body=o,f):n}return n}})}createCommentController(l,c,t){const n=m.handlePool++,s=new a(l,n,this._proxy,c,t);this._commentControllers.set(s.handle,s);const r=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(l.identifier))||[];return r.push(s),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(l.identifier),r),s}$createCommentThreadTemplate(l,c,t){const n=this._commentControllers.get(l);!n||n.$createCommentThreadTemplate(c,t)}async $updateCommentThreadTemplate(l,c,t){const n=this._commentControllers.get(l);!n||n.$updateCommentThreadTemplate(c,t)}$deleteCommentThread(l,c){const t=this._commentControllers.get(l);t&&t.$deleteCommentThread(c)}$provideCommentingRanges(l,c,t){const n=this._commentControllers.get(l);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(y.URI.revive(c));return(0,b.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(s,t)).then(r=>r?r.map(o=>P.Range.from(o)):void 0)}$toggleReaction(l,c,t,n,s){const r=this._commentControllers.get(l);return!r||!r.reactionHandler?Promise.resolve(void 0):(0,b.asPromise)(()=>{const o=r.getCommentThread(c);if(o){const p=o.getCommentByUniqueId(n.uniqueIdInThread);if(r!==void 0&&p&&r.reactionHandler)return r.reactionHandler(p,w(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=m,m.handlePool=0;class g{constructor(l,c,t,n,s,r,o){this._proxy=l,this._commentController=c,this._id=t,this._uri=n,this._range=s,this._comments=r,this.handle=g._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${c.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,P.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(l){this._id=l}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(l){l.isEqual(this._range)||(this._range=l,this.modifications.range=l,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(l){this._canReply!==l&&(this._canReply=l,this.modifications.canReply=l,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(l){this._label=l,this.modifications.label=l,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(l){this._contextValue=l,this.modifications.contextValue=l,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(l){this._comments=l,this.modifications.comments=l,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(l){this._collapseState=l,this.modifications.collapsibleState=l,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const l=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),c={};l("range")&&(c.range=P.Range.from(this._range)),l("label")&&(c.label=this.label),l("contextValue")&&(c.contextValue=this.contextValue),l("comments")&&(c.comments=this._comments.map(t=>h(this,this._commentController,t,this._commentsMap))),l("collapsibleState")&&(c.collapseState=E(this._collapseState)),l("canReply")&&(c.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,c)}}getCommentByUniqueId(l){for(let c of this._commentsMap){let t=c[0],n=c[1];if(l===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(l=>l.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}g._handlePool=0,qe([(0,T.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=g;class a{constructor(l,c,t,n,s){this._extension=l,this._handle=c,this._proxy=t,this._id=n,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(l){this._reactionHandler=l,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this._options}set options(l){this._options=l,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(l,c,t,n){if(typeof l=="string"){const s=new g(this._proxy,this,l,c,t,n,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new g(this._proxy,this,void 0,l,c,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(l,c){const t=new g(this._proxy,this,void 0,y.URI.revive(l),P.Range.to(c),[],this._extension.identifier);return t.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(l,c){let t=this._threads.get(l);t&&(t.range=P.Range.to(c))}$deleteCommentThread(l){let c=this._threads.get(l);c&&c.dispose(),this._threads.delete(l)}getCommentThread(l){return this._threads.get(l)}dispose(){this._threads.forEach(l=>{l.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function h(d,l,c,t){let n=t.get(c);n||(n=++d.commentHandle,t.set(c,n));const s=c.author&&c.author.iconPath?c.author.iconPath.toString():void 0;return{mode:c.mode,contextValue:c.contextValue,uniqueIdInThread:n,body:P.MarkdownString.from(c.body),userName:c.author.name,userIconPath:s,label:c.label,commentReactions:c.reactions?c.reactions.map(r=>S(r)):void 0}}function S(d){return{label:d.label,iconPath:d.iconPath?P.pathOrURIToURI(d.iconPath):void 0,count:d.count,hasReacted:d.authorHasReacted}}function w(d){return{label:d.label||"",count:d.count||0,iconPath:d.iconPath?y.URI.revive(d.iconPath):"",authorHasReacted:d.hasReacted||!1}}function E(d){if(d!==void 0)switch(d){case i.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}}),define(me[128],ge([0,1,2,5,7,4,15,12,16,9,8]),function(K,e,b,T,C,A,y,k,D,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class Sn{constructor(g,a){this._logService=a,this._provider=new Map,this._proxy=g.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,a){const h=Sn._handlePool++;this._provider.set(h,{provider:g,extensionId:a}),this._proxy.$registerDecorationProvider(h,a.value);const S=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(h,null);return}let E=(0,D.asArray)(w);if(E.length<=Sn._maxEventSize){this._proxy.$onDidChange(h,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,E.length);const d=E.map(t=>({uri:t,rank:(0,P.count)(t.path,"/")})),l=(0,D.groupBy)(d,(t,n)=>t.rank-n.rank||(0,P.compare)(t.uri.path,n.uri.path));let c=[];e:for(let t of l){let n;for(let s of t){let r=(0,i.dirname)(s.uri.path);if(n!==r&&(n=r,c.push(s.uri)>=Sn._maxEventSize))break e}}this._proxy.$onDidChange(h,c)});return new C.Disposable(()=>{S==null||S.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(g,a,h){if(!this._provider.has(g))return Object.create(null);const S=Object.create(null),{provider:w,extensionId:E}=this._provider.get(g);return await Promise.all(a.map(async d=>{try{const{uri:l,id:c}=d,t=await Promise.resolve(w.provideFileDecoration(b.URI.revive(l),h));if(!t)return;try{C.FileDecoration.validate(t),S[c]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${E.value}': ${n}`)}}catch(l){this._logService.error(l)}})),S}};I._handlePool=0,I._maxEventSize=250,I=qe([He(0,y.IExtHostRpcService),He(1,k.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(me[232],ge([0,1,162,116,2,5,7,20,3,12,22]),function(K,e,b,T,C,A,y,k,D,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(a,h,S,w,E){this._name=a,this._owner=h,this._maxDiagnosticsPerFile=S,this._proxy=w,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,h){if(!a){this.clear();return}this._checkDisposed();let S=[];if(C.URI.isUri(a)){if(!h){this.delete(a);return}this._data.set(a,h.slice()),S=[a]}else if(Array.isArray(a)){S=[];let E;a=[...a].sort(I._compareIndexedTuplesByUri);for(const d of a){const[l,c]=d;if((!E||l.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=l,S.push(l),this._data.set(l,[])),c){const t=this._data.get(l);t&&t.push(...c)}else{const t=this._data.get(l);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(S),!!this._proxy){const w=[];for(let E of S){let d=[];const l=this._data.get(E);if(l)if(l.length>this._maxDiagnosticsPerFile){d=[];const c=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of l)if(n.severity===c[t]&&d.push(k.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;d.push({severity:T.MarkerSeverity.Info,message:(0,b.localize)(0,null,l.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=l.map(c=>k.Diagnostic.from(c));w.push([E,d])}this._proxy.$changeMany(this._owner,w)}}delete(a){this._checkDisposed(),this._onDidChangeDiagnostics.fire([a]),this._data.delete(a),this._proxy&&this._proxy.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(a,h){this._checkDisposed();for(let S of this._data.keys())a.apply(h,[S,this.get(S),this])}get(a){this._checkDisposed();const h=this._data.get(a);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this._data.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,h){return a[0].toString()<h[0].toString()?-1:a[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=I;let m=class qt{constructor(a,h){this._logService=h,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,qt._debouncer,50),qt._mapper),this._proxy=a.getProxy(A.MainContext.MainThreadDiagnostics)}static _debouncer(a,h){return a?a.concat(h):h}static _mapper(a){const h=new i.ResourceMap;for(const S of a)h.set(S,S);return{uris:Object.freeze(Array.from(h.values()))}}createDiagnosticCollection(a,h){const{_collections:S,_proxy:w,_onDidChangeDiagnostics:E,_logService:d}=this,l=new class{$changeMany(n,s){w.$changeMany(n,s),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,n,s.length===0?"CLEARING":s)}$clear(n){w.$clear(n),d.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,n)}dispose(){w.dispose()}};let c;if(!h)h="_generated_diagnostic_collection_name_#"+qt._idPool++,c=h;else if(!S.has(h))c=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do c=h+qt._idPool++;while(S.has(c))}return new class extends I{constructor(){super(h,c,qt._maxDiagnosticsPerFile,l,E);S.set(c,this)}dispose(){super.dispose(),S.delete(c)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const h=new Map,S=[];for(const w of this._collections.values())w.forEach((E,d)=>{let l=h.get(E.toString());typeof l=="undefined"&&(l=S.length,h.set(E.toString(),l),S.push([E,[]])),S[l][1]=S[l][1].concat(...d)});return S}}_getDiagnostics(a){let h=[];for(let S of this._collections.values())S.has(a)&&(h=h.concat(S.get(a)));return h}$acceptMarkersChange(a){if(!this._mirrorCollection){const h="_generated_mirror",S=new I(h,h,qt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(h,S),this._mirrorCollection=S}for(const[h,S]of a)this._mirrorCollection.set(C.URI.revive(h),S.map(k.Diagnostic.to))}};m._idPool=0,m._maxDiagnosticsPerFile=1e3,m=qe([He(1,P.ILogService)],m),e.ExtHostDiagnostics=m}),define(me[233],ge([0,1,2,5]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class C{constructor(y){this._proxy=y.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(k=>k?k.map(D=>b.URI.revive(D)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(k=>k?b.URI.revive(k):void 0)}}e.ExtHostDialogs=C}),define(me[234],ge([0,1,17,2,7,5,13,21,9]),function(K,e,b,T,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(I,m,g){this._documentsAndEditors=m,this._logService=g,this._documentContentProviders=new Map,this._proxy=I.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,m){if(Object.keys(y.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const g=P._handlePool++;this._documentContentProviders.set(g,m),this._proxy.$registerTextContentProvider(g,I);let a;return typeof m.onDidChange=="function"&&(a=m.onDidChange(h=>{if(h.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(g,h).then(S=>{if(!(!S&&typeof S!="string")){const w=this._documentsAndEditors.getDocument(h);if(!!w){const E=(0,D.splitLines)(S);if(!w.equalLines(E))return this._proxy.$onVirtualDocumentChange(h,S)}}},b.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(I,m){const g=this._documentContentProviders.get(I);return g?Promise.resolve(g.provideTextDocumentContent(T.URI.revive(m),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(me[235],ge([0,1,3,6,2,5,122,20,11,24]),function(K,e,b,T,C,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class i{constructor(m,g){this._onDidAddDocument=new b.Emitter,this._onDidRemoveDocument=new b.Emitter,this._onDidChangeDocument=new b.Emitter,this._onDidSaveDocument=new b.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new T.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const h of a)this._onDidRemoveDocument.fire(h.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const h of a)this._onDidAddDocument.fire(h.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!!m){const g=this._documentsAndEditors.getDocument(m);if(g)return g}}getDocument(m){const g=this.getDocumentData(m);if(!(g==null?void 0:g.document))throw new Error(`Unable to retrieve document from URI '${m}'`);return g.document}ensureDocumentData(m){const g=this._documentsAndEditors.getDocument(m);if(g)return Promise.resolve(g);let a=this._documentLoader.get(m.toString());return a||(a=this._proxy.$tryOpenDocument(m).then(h=>{this._documentLoader.delete(m.toString());const S=C.URI.revive(h);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(S))},h=>(this._documentLoader.delete(m.toString()),Promise.reject(h))),this._documentLoader.set(m.toString(),a)),a}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(g=>C.URI.revive(g))}$acceptModelModeChanged(m,g){const a=C.URI.revive(m),h=this._documentsAndEditors.getDocument(a);if(!h)throw new Error("unknown document");this._onDidRemoveDocument.fire(h.document),h._acceptLanguageId(g),this._onDidAddDocument.fire(h.document)}$acceptModelSaved(m){const g=C.URI.revive(m),a=this._documentsAndEditors.getDocument(g);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(m,g){const a=C.URI.revive(m),h=this._documentsAndEditors.getDocument(a);if(!h)throw new Error("unknown document");h._acceptIsDirty(g),this._onDidChangeDocument.fire({document:h.document,contentChanges:[]})}$acceptModelChanged(m,g,a){const h=C.URI.revive(m),S=this._documentsAndEditors.getDocument(h);if(!S)throw new Error("unknown document");S._acceptIsDirty(a),S.onEvents(g),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:S.document,contentChanges:g.changes.map(w=>({range:k.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text}))}))}setWordDefinitionFor(m,g){(0,y.setWordDefinitionFor)(m,g)}}e.ExtHostDocuments=i}),define(me[39],ge([0,1,53,3,6,2,4,5,122,15,126,20,12,22,13,56,136]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(l,c){this._extHostRpc=l,this._logService=c,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new T.Emitter,this._onDidRemoveDocuments=new T.Emitter,this._onDidChangeVisibleTextEditors=new T.Emitter,this._onDidChangeActiveTextEditor=new T.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const c=[],t=[],n=[];if(l.removedDocuments)for(const s of l.removedDocuments){const r=A.URI.revive(s),o=this._documents.get(r);(o==null?void 0:o.unref())&&(this._documents.delete(r),c.push(o.value))}if(l.addedDocuments)for(const s of l.addedDocuments){const r=A.URI.revive(s.uri);let o=this._documents.get(r);if(o&&r.scheme!==a.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);o||(o=new w(new D.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),r,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(r,o),t.push(o.value)),o.ref()}if(l.removedEditors)for(const s of l.removedEditors){const r=this._editors.get(s);this._editors.delete(s),r&&n.push(r)}if(l.addedEditors)for(const s of l.addedEditors){const r=A.URI.revive(s.documentUri);b.ok(this._documents.has(r),`document '${r}' does not exist`),b.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const o=this._documents.get(r).value,p=new i.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new S.Lazy(()=>o.document),s.selections.map(I.Selection.to),s.options,s.visibleRanges.map(f=>I.Range.to(f)),typeof s.editorPosition=="number"?I.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,p)}l.newActiveEditor!==void 0&&(b.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,C.dispose)(c),(0,C.dispose)(n),l.removedDocuments&&this._onDidRemoveDocuments.fire(c),l.addedDocuments&&this._onDidAddDocuments.fire(t),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){var c;return(c=this._documents.get(l))===null||c===void 0?void 0:c.value}allDocuments(){return h.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!!this._activeEditorId){const c=this._editors.get(this._activeEditorId);return l?c:c==null?void 0:c.value}}allEditors(){return[...this._editors.values()]}};E=qe([He(0,P.IExtHostRpcService),He(1,m.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[236],ge([0,1,2,5,6,7,20,143,9,23]),function(K,e,b,T,C,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const a=this._schemes.indexOf(g);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),a=[];let h,S,w=14,E=14;for(const d of g){let l=h?(0,D.commonPrefixLength)(h,d):0;for(l===0?S=1:S=E;l<d.length;l++)l+1===d.length?(w=E,E=9):E+=1,a.push([S,d.toUpperCase().charCodeAt(l),E]),a.push([S,d.toLowerCase().charCodeAt(l),E]),S=E;h=d,E=w}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new k.StateMachine(a)}}provideDocumentLinks(g){this._initStateMachine();const a=[],h=k.LinkComputer.computeLinks({getLineContent(S){return g.lineAt(S-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const S of h){const w=y.DocumentLink.to(S);w.target&&a.push(w)}return a}}class I{constructor(g,a){this._extHostLanguageFeatures=a,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=g.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){var g;(g=this._linkProviderRegistration)===null||g===void 0||g.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(g,a,h,S={},w){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const E=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(E,h),this._enableProposedApi.set(E,w!=null?w:!1);let d=2;S.isCaseSensitive&&(d+=1024),S.isReadonly&&(d+=2048),typeof h.copy=="function"&&(d+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&(d+=4),this._proxy.$registerFileSystemProvider(E,a,d).catch(c=>{console.error(`FAILED to register filesystem provider of ${g.value}-extension for the scheme ${a}`),console.error(c)});const l=h.onDidChangeFile(c=>{const t=[];for(const n of c){let{uri:s,type:r}=n;if(s.scheme===a){let o;switch(r){case A.FileChangeType.Changed:o=0;break;case A.FileChangeType.Created:o=1;break;case A.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:o})}}this._proxy.$onFileSystemChange(E,t)});return(0,C.toDisposable)(()=>{l.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(E),this._enableProposedApi.delete(E),this._proxy.$unregisterProvider(E)})}static _asIStat(g,a){const{type:h,ctime:S,mtime:w,size:E,permissions:d}=g;return a?{type:h,ctime:S,mtime:w,size:E,permissions:d}:{type:h,ctime:S,mtime:w,size:E}}$stat(g,a){return Promise.resolve(this._getFsProvider(g).stat(b.URI.revive(a))).then(h=>{var S;return I._asIStat(h,(S=this._enableProposedApi.get(g))!==null&&S!==void 0?S:!1)})}$readdir(g,a){return Promise.resolve(this._getFsProvider(g).readDirectory(b.URI.revive(a)))}$readFile(g,a){return Promise.resolve(this._getFsProvider(g).readFile(b.URI.revive(a))).then(h=>P.VSBuffer.wrap(h))}$writeFile(g,a,h,S){return Promise.resolve(this._getFsProvider(g).writeFile(b.URI.revive(a),h.buffer,S))}$delete(g,a,h){return Promise.resolve(this._getFsProvider(g).delete(b.URI.revive(a),h))}$rename(g,a,h,S){return Promise.resolve(this._getFsProvider(g).rename(b.URI.revive(a),b.URI.revive(h),S))}$copy(g,a,h,S){const w=this._getFsProvider(g);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(b.URI.revive(a),b.URI.revive(h),S))}$mkdir(g,a){return Promise.resolve(this._getFsProvider(g).createDirectory(b.URI.revive(a)))}$watch(g,a,h,S){const w=this._getFsProvider(g).watch(b.URI.revive(h),S);this._watches.set(a,w)}$unwatch(g,a){const h=this._watches.get(a);h&&(h.dispose(),this._watches.delete(a))}$open(g,a,h){const S=this._getFsProvider(g);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(b.URI.revive(a),h))}$close(g,a){const h=this._getFsProvider(g);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(a))}$read(g,a,h,S){const w=this._getFsProvider(g);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const E=P.VSBuffer.alloc(S);return Promise.resolve(w.read(a,h,E.buffer,0,S)).then(d=>E.slice(0,d))}$write(g,a,h,S){const w=this._getFsProvider(g);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(a,h,S.buffer,0,S.byteLength))}_getFsProvider(g){const a=this._fsProvider.get(g);if(!a){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return a}}e.ExtHostFileSystem=I}),define(me[92],ge([0,1,5,45,7,23,4,15,63]),function(K,e,b,T,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class Ot{constructor(I,m){const g=I.getProxy(b.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return g.$stat(a).catch(Ot._handleError)},readDirectory(a){return g.$readdir(a).catch(Ot._handleError)},createDirectory(a){return g.$mkdir(a).catch(Ot._handleError)},async readFile(a){return g.$readFile(a).then(h=>h.buffer).catch(Ot._handleError)},writeFile(a,h){return g.$writeFile(a,A.VSBuffer.wrap(h)).catch(Ot._handleError)},delete(a,h){return g.$delete(a,Object.assign({recursive:!1,useTrash:!1},h)).catch(Ot._handleError)},rename(a,h,S){return g.$rename(a,h,Object.assign({overwrite:!1},S)).catch(Ot._handleError)},copy(a,h,S){return g.$copy(a,h,Object.assign({overwrite:!1},S)).catch(Ot._handleError)},isWritableFileSystem(a){const h=m.getCapabilities(a);if(typeof h=="number")return!(h&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new C.FileSystemError(String(I));if(I.name==="ENOPRO")throw C.FileSystemError.Unavailable(I.message);switch(I.name){case T.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(I.message);case T.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(I.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(I.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(I.message);case T.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(I.message);case T.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(I.message);default:throw new C.FileSystemError(I.message,I.name)}}};P=qe([He(0,k.IExtHostRpcService),He(1,D.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(me[237],ge([0,1,6,5]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(y){this._handlePool=0,this._proxy=y.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,y),(0,b.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=C}),define(me[238],ge([0,1,2,24,20,7,14,5,9,44,16,11,140,6,112,73,87,48,17]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h,S,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class d{constructor(V,X){this._documents=V,this._provider=X}provideDocumentSymbols(V,X){const Z=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(Z,X)).then(se=>{if(!(0,i.isFalsyOrEmpty)(se))return se[0]instanceof A.DocumentSymbol?se.map(C.DocumentSymbol.from):d._asDocumentSymbolTree(se)})}static _asDocumentSymbolTree(V){var X;V=V.slice(0).sort((fe,Ee)=>{let Be=fe.location.range.start.compareTo(Ee.location.range.start);return Be===0&&(Be=Ee.location.range.end.compareTo(fe.location.range.end)),Be});const Z=[],se=[];for(const fe of V){const Ee={name:fe.name||"!!MISSING: name!!",kind:C.SymbolKind.from(fe.kind),tags:((X=fe.tags)===null||X===void 0?void 0:X.map(C.SymbolTag.from))||[],detail:"",containerName:fe.containerName,range:C.Range.from(fe.location.range),selectionRange:C.Range.from(fe.location.range),children:[]};for(;;){if(se.length===0){se.push(Ee),Z.push(Ee);break}const Be=se[se.length-1];if(P.Range.containsRange(Be.range,Ee.range)&&!P.Range.equalsRange(Be.range,Ee.range)){Be.children&&Be.children.push(Ee),se.push(Ee);break}se.pop()}}return Z}}class l{constructor(V,X,Z){this._documents=V,this._commands=X,this._provider=Z,this._cache=new S.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(V,X){const Z=this._documents.getDocument(V),se=await this._provider.provideCodeLenses(Z,X);if(!(!se||X.isCancellationRequested)){const fe=this._cache.add(se),Ee=new g.DisposableStore;this._disposables.set(fe,Ee);const Be={cacheId:fe,lenses:[]};for(let pe=0;pe<se.length;pe++)Be.lenses.push({cacheId:[fe,pe],range:C.Range.from(se[pe].range),command:this._commands.toInternal(se[pe].command,Ee)});return Be}}async resolveCodeLens(V,X){var Z;const se=V.cacheId&&this._cache.get(...V.cacheId);if(!!se){let fe;if(typeof this._provider.resolveCodeLens!="function"||se.isResolved?fe=se:fe=await this._provider.resolveCodeLens(se,X),fe||(fe=se),!X.isCancellationRequested){const Ee=V.cacheId&&this._disposables.get(V.cacheId[0]);if(!!Ee)return V.command=this._commands.toInternal((Z=fe.command)!==null&&Z!==void 0?Z:l._badCmd,Ee),V}}}releaseCodeLenses(V){var X;(X=this._disposables.get(V))===null||X===void 0||X.dispose(),this._disposables.delete(V),this._cache.delete(V)}}l._badCmd={command:"missing",title:"!!MISSING: command!!"};function c(Oe){return Array.isArray(Oe)?Oe.map(C.DefinitionLink.from):Oe?[C.DefinitionLink.from(Oe)]:[]}class t{constructor(V,X){this._documents=V,this._provider=X}provideDefinition(V,X,Z){const se=this._documents.getDocument(V),fe=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideDefinition(se,fe,Z)).then(c)}}class n{constructor(V,X){this._documents=V,this._provider=X}provideDeclaration(V,X,Z){const se=this._documents.getDocument(V),fe=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideDeclaration(se,fe,Z)).then(c)}}class s{constructor(V,X){this._documents=V,this._provider=X}provideImplementation(V,X,Z){const se=this._documents.getDocument(V),fe=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideImplementation(se,fe,Z)).then(c)}}class r{constructor(V,X){this._documents=V,this._provider=X}provideTypeDefinition(V,X,Z){const se=this._documents.getDocument(V),fe=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(se,fe,Z)).then(c)}}class o{constructor(V,X){this._documents=V,this._provider=X}provideHover(V,X,Z){const se=this._documents.getDocument(V),fe=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideHover(se,fe,Z)).then(Ee=>{if(!(!Ee||(0,i.isFalsyOrEmpty)(Ee.contents)))return Ee.range||(Ee.range=se.getWordRangeAtPosition(fe)),Ee.range||(Ee.range=new A.Range(fe,fe)),C.Hover.from(Ee)})}}class p{constructor(V,X){this._documents=V,this._provider=X}provideEvaluatableExpression(V,X,Z){const se=this._documents.getDocument(V),fe=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(se,fe,Z)).then(Ee=>{if(Ee)return C.EvaluatableExpression.from(Ee)})}}class f{constructor(V,X){this._documents=V,this._provider=X}provideInlineValues(V,X,Z,se){const fe=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideInlineValues(fe,C.Range.to(X),C.InlineValueContext.to(Z),se)).then(Ee=>{if(Array.isArray(Ee))return Ee.map(Be=>C.InlineValue.from(Be))})}}class _{constructor(V,X){this._documents=V,this._provider=X}provideDocumentHighlights(V,X,Z){const se=this._documents.getDocument(V),fe=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(se,fe,Z)).then(Ee=>{if(Array.isArray(Ee))return Ee.map(C.DocumentHighlight.from)})}}class u{constructor(V,X){this._documents=V,this._provider=X}provideLinkedEditingRanges(V,X,Z){const se=this._documents.getDocument(V),fe=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(se,fe,Z)).then(Ee=>{if(Ee&&Array.isArray(Ee.ranges))return{ranges:(0,i.coalesce)(Ee.ranges.map(C.Range.from)),wordPattern:Ee.wordPattern}})}}class v{constructor(V,X){this._documents=V,this._provider=X}provideReferences(V,X,Z,se){const fe=this._documents.getDocument(V),Ee=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideReferences(fe,Ee,Z,se)).then(Be=>{if(Array.isArray(Be))return Be.map(C.location.from)})}}class R{constructor(V,X,Z,se,fe,Ee,Be){this._documents=V,this._commands=X,this._diagnostics=Z,this._provider=se,this._logService=fe,this._extension=Ee,this._apiDeprecation=Be,this._cache=new S.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(V,X,Z,se){const fe=this._documents.getDocument(V),Ee=m.Selection.isISelection(X)?C.Selection.to(X):C.Range.to(X),Be=[];for(const Ce of this._diagnostics.getDiagnostics(V))if(Ee.intersection(Ce.range)&&Be.push(Ce)>R._maxCodeActionsPerFile)break;const pe={diagnostics:Be,only:Z.only?new A.CodeActionKind(Z.only):void 0,triggerKind:C.CodeActionTriggerKind.to(Z.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(fe,Ee,pe,se)).then(Ce=>{var Me;if(!(!(0,i.isNonEmptyArray)(Ce)||se.isCancellationRequested)){const ze=this._cache.add(Ce),_e=new g.DisposableStore;this._disposables.set(ze,_e);const Ke=[];for(let Q=0;Q<Ce.length;Q++){const te=Ce[Q];!te||(R._isCommand(te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:te.title,command:this._commands.toInternal(te,_e)})):(pe.only&&(te.kind?pe.only.contains(te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[ze,Q],title:te.title,command:te.command&&this._commands.toInternal(te.command,_e),diagnostics:te.diagnostics&&te.diagnostics.map(C.Diagnostic.from),edit:te.edit&&C.WorkspaceEdit.from(te.edit),kind:te.kind&&te.kind.value,isPreferred:te.isPreferred,disabled:(Me=te.disabled)===null||Me===void 0?void 0:Me.reason})))}return{cacheId:ze,actions:Ke}}})}async resolveCodeAction(V,X){var Z;const[se,fe]=V,Ee=this._cache.get(se,fe);if(!(!Ee||R._isCommand(Ee))&&!!this._provider.resolveCodeAction){const Be=(Z=await this._provider.resolveCodeAction(Ee,X))!==null&&Z!==void 0?Z:Ee;return(Be==null?void 0:Be.edit)?C.WorkspaceEdit.from(Be.edit):void 0}}releaseCodeActions(V){var X;(X=this._disposables.get(V))===null||X===void 0||X.dispose(),this._disposables.delete(V),this._cache.delete(V)}static _isCommand(V){return typeof V.command=="string"&&typeof V.title=="string"}}R._maxCodeActionsPerFile=1e3;class O{constructor(V,X){this._documents=V,this._provider=X}provideDocumentFormattingEdits(V,X,Z){const se=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(se,X,Z)).then(fe=>{if(Array.isArray(fe))return fe.map(C.TextEdit.from)})}}class H{constructor(V,X){this._documents=V,this._provider=X}provideDocumentRangeFormattingEdits(V,X,Z,se){const fe=this._documents.getDocument(V),Ee=C.Range.to(X);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(fe,Ee,Z,se)).then(Be=>{if(Array.isArray(Be))return Be.map(C.TextEdit.from)})}}class ne{constructor(V,X){this._documents=V,this._provider=X,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(V,X,Z,se,fe){const Ee=this._documents.getDocument(V),Be=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Ee,Be,Z,se,fe)).then(pe=>{if(Array.isArray(pe))return pe.map(C.TextEdit.from)})}}class ie{constructor(V,X){this._provider=V,this._logService=X,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(V,X){const Z=k.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(V,X)).then(se=>{if((0,i.isNonEmptyArray)(se)){for(const fe of se)if(!!fe){if(!fe.name){this._logService.warn("INVALID SymbolInformation, lacks name",fe);continue}const Ee=k.IdObject.mixin(C.WorkspaceSymbol.from(fe));this._symbolCache.set(Ee._id,fe),Z.symbols.push(Ee)}}}).then(()=>(Z.symbols.length>0&&this._resultCache.set(Z._id,[Z.symbols[0]._id,Z.symbols[Z.symbols.length-1]._id]),Z))}async resolveWorkspaceSymbol(V,X){if(typeof this._provider.resolveWorkspaceSymbol!="function")return V;const Z=this._symbolCache.get(V._id);if(Z){const se=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(Z,X));return se&&(0,T.mixin)(V,C.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(V){const X=this._resultCache.get(V);if(X){for(let[Z,se]=X;Z<=se;Z++)this._symbolCache.delete(Z);this._resultCache.delete(V)}}}class U{constructor(V,X,Z){this._documents=V,this._provider=X,this._logService=Z}static supportsResolving(V){return typeof V.prepareRename=="function"}provideRenameEdits(V,X,Z,se){const fe=this._documents.getDocument(V),Ee=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(fe,Ee,Z,se)).then(Be=>{if(!!Be)return C.WorkspaceEdit.from(Be)},Be=>{const pe=U._asMessage(Be);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Be)})}resolveRenameLocation(V,X,Z){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument(V),fe=C.Position.to(X);return(0,y.asPromise)(()=>this._provider.prepareRename(se,fe,Z)).then(Ee=>{let Be,pe;if(A.Range.isRange(Ee)?(Be=Ee,pe=se.getText(Ee)):(0,I.isObject)(Ee)&&(Be=Ee.range,pe=Ee.placeholder),!!Be){if(Be.start.line>fe.line||Be.end.line<fe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(Be),text:pe}}},Ee=>{const Be=U._asMessage(Ee);return Be?{rejectReason:Be,range:void 0,text:void 0}:Promise.reject(Ee)})}static _asMessage(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class B{constructor(V,X){this.resultId=V,this.tokens=X}}class x{constructor(V,X){this._documents=V,this._provider=X,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(V,X,Z){const se=this._documents.getDocument(V),fe=X!==0?this._previousResults.get(X):null;return(0,y.asPromise)(()=>fe&&typeof fe.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(se,fe.resultId,Z):this._provider.provideDocumentSemanticTokens(se,Z)).then(Ee=>(fe&&this._previousResults.delete(X),Ee?(Ee=x._fixProvidedSemanticTokens(Ee),this._send(x._convertToEdits(fe,Ee),Ee)):null))}async releaseDocumentSemanticColoring(V){this._previousResults.delete(V)}static _fixProvidedSemanticTokens(V){return x._isSemanticTokens(V)?x._isCorrectSemanticTokens(V)?V:new A.SemanticTokens(new Uint32Array(V.data),V.resultId):x._isSemanticTokensEdits(V)?x._isCorrectSemanticTokensEdits(V)?V:new A.SemanticTokensEdits(V.edits.map(X=>new A.SemanticTokensEdit(X.start,X.deleteCount,X.data?new Uint32Array(X.data):X.data)),V.resultId):V}static _isSemanticTokens(V){return V&&!!V.data}static _isCorrectSemanticTokens(V){return V.data instanceof Uint32Array}static _isSemanticTokensEdits(V){return V&&Array.isArray(V.edits)}static _isCorrectSemanticTokensEdits(V){for(const X of V.edits)if(!(X.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(V,X){if(!x._isSemanticTokens(X)||!V||!V.tokens)return X;const Z=V.tokens,se=Z.length,fe=X.data,Ee=fe.length;let Be=0;const pe=Math.min(se,Ee);for(;Be<pe&&Z[Be]===fe[Be];)Be++;if(Be===se&&Be===Ee)return new A.SemanticTokensEdits([],X.resultId);let Ce=0;const Me=pe-Be;for(;Ce<Me&&Z[se-Ce-1]===fe[Ee-Ce-1];)Ce++;return new A.SemanticTokensEdits([{start:Be,deleteCount:se-Be-Ce,data:fe.subarray(Be,Ee-Ce)}],X.resultId)}_send(V,X){if(x._isSemanticTokens(V)){const Z=this._nextResultId++;return this._previousResults.set(Z,new B(V.resultId,V.data)),(0,a.encodeSemanticTokensDto)({id:Z,type:"full",data:V.data})}if(x._isSemanticTokensEdits(V)){const Z=this._nextResultId++;return x._isSemanticTokens(X)?this._previousResults.set(Z,new B(X.resultId,X.data)):this._previousResults.set(Z,new B(V.resultId)),(0,a.encodeSemanticTokensDto)({id:Z,type:"delta",deltas:(V.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=x;class L{constructor(V,X){this._documents=V,this._provider=X}provideDocumentRangeSemanticTokens(V,X,Z){const se=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(se,C.Range.to(X),Z)).then(fe=>fe?this._send(fe):null)}_send(V){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:V.data})}}e.DocumentRangeSemanticTokensAdapter=L;class N{constructor(V,X,Z,se,fe){this._documents=V,this._commands=X,this._provider=Z,this._apiDeprecation=se,this._extension=fe,this._cache=new S.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}async provideCompletionItems(V,X,Z,se){const fe=this._documents.getDocument(V),Ee=C.Position.to(X),Be=fe.getWordRangeAtPosition(Ee)||new A.Range(Ee,Ee),pe=Be.with({end:Ee}),Ce=new w.StopWatch(!0),Me=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(fe,Ee,se,C.CompletionContext.to(Z)));if(!!Me&&!se.isCancellationRequested){const ze=Array.isArray(Me)?new A.CompletionList(Me):Me,_e=N.supportsResolving(this._provider)?this._cache.add(ze.items):this._cache.add([]),Ke=new g.DisposableStore;this._disposables.set(_e,Ke);const Q=[],te={x:_e,b:Q,a:{replace:C.Range.from(Be),insert:C.Range.from(pe)},c:ze.isIncomplete||void 0,d:Ce.elapsed()};for(let we=0;we<ze.items.length;we++){const xe=ze.items[we],je=this._convertCompletionItem(xe,[_e,we],pe,Be);Q.push(je)}return te}}async resolveCompletionItem(V,X){if(typeof this._provider.resolveCompletionItem=="function"){const Z=this._cache.get(...V);if(!!Z){const se=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(Z,X));if(!!se)return this._convertCompletionItem(se,V)}}}releaseCompletionItems(V){var X;(X=this._disposables.get(V))===null||X===void 0||X.dispose(),this._disposables.delete(V),this._cache.delete(V)}_convertCompletionItem(V,X,Z,se){var fe;const Ee=this._disposables.get(X[0]);if(!Ee)throw Error("DisposableStore is missing...");const Be={x:X,a:(fe=V.label)!==null&&fe!==void 0?fe:"",o:V.label2,b:V.kind!==void 0?C.CompletionItemKind.from(V.kind):void 0,n:V.tags&&V.tags.map(C.CompletionItemTag.from),c:V.detail,d:typeof V.documentation=="undefined"?void 0:C.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters,l:V.additionalTextEdits&&V.additionalTextEdits.map(C.TextEdit.from),m:this._commands.toInternal(V.command,Ee)};V.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Be.h=V.textEdit.newText):typeof V.insertText=="string"?Be.h=V.insertText:V.insertText instanceof A.SnippetString&&(Be.h=V.insertText.value,Be.i|=4);let pe;return V.textEdit?pe=V.textEdit.range:V.range&&(pe=V.range),A.Range.isRange(pe)?Be.j=C.Range.from(pe):pe&&(!(Z==null?void 0:Z.isEqual(pe.inserting))||!(se==null?void 0:se.isEqual(pe.replacing)))&&(Be.j={insert:C.Range.from(pe.inserting),replace:C.Range.from(pe.replacing)}),Be}}class F{constructor(V,X){this._documents=V,this._provider=X,this._cache=new S.Cache("SignatureHelp")}provideSignatureHelp(V,X,Z,se){const fe=this._documents.getDocument(V),Ee=C.Position.to(X),Be=this.reviveContext(Z);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(fe,Ee,se,Be)).then(pe=>{if(pe){const Ce=this._cache.add([pe]);return Object.assign(Object.assign({},C.SignatureHelp.from(pe)),{id:Ce})}})}reviveContext(V){let X;if(V.activeSignatureHelp){const Z=C.SignatureHelp.to(V.activeSignatureHelp),se=this._cache.get(V.activeSignatureHelp.id,0);se?(X=se,X.activeSignature=Z.activeSignature,X.activeParameter=Z.activeParameter):X=Z}return Object.assign(Object.assign({},V),{activeSignatureHelp:X})}releaseSignatureHelp(V){this._cache.delete(V)}}class M{constructor(V,X){this._documents=V,this._provider=X}provideInlayHints(V,X,Z){const se=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideInlayHints(se,C.Range.to(X),Z)).then(fe=>fe?{hints:fe.map(C.InlayHint.from)}:void 0)}}class ${constructor(V,X){this._documents=V,this._provider=X,this._cache=new S.Cache("DocumentLink")}provideLinks(V,X){const Z=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(Z,X)).then(se=>{if(!(!Array.isArray(se)||se.length===0)&&!X.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.map(C.DocumentLink.from)};{const fe=this._cache.add(se),Ee={links:[],id:fe};for(let Be=0;Be<se.length;Be++){const pe=C.DocumentLink.from(se[Be]);pe.cacheId=[fe,Be],Ee.links.push(pe)}return Ee}}})}resolveLink(V,X){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const Z=this._cache.get(...V);return Z?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(Z,X)).then(se=>se&&C.DocumentLink.from(se)||void 0):Promise.resolve(void 0)}releaseLinks(V){this._cache.delete(V)}}class q{constructor(V,X){this._documents=V,this._provider=X}provideColors(V,X){const Z=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(Z,X)).then(se=>Array.isArray(se)?se.map(Ee=>({color:C.Color.from(Ee.color),range:C.Range.from(Ee.range)})):[])}provideColorPresentations(V,X,Z){const se=this._documents.getDocument(V),fe=C.Range.to(X.range),Ee=C.Color.to(X.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(Ee,{document:se,range:fe},Z)).then(Be=>{if(!!Array.isArray(Be))return Be.map(C.ColorPresentation.from)})}}class G{constructor(V,X){this._documents=V,this._provider=X}provideFoldingRanges(V,X,Z){const se=this._documents.getDocument(V);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(se,X,Z)).then(fe=>{if(!!Array.isArray(fe))return fe.map(C.FoldingRange.from)})}}class le{constructor(V,X,Z){this._documents=V,this._provider=X,this._logService=Z}provideSelectionRanges(V,X,Z){const se=this._documents.getDocument(V),fe=X.map(C.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(se,fe,Z)).then(Ee=>{if(!(0,i.isNonEmptyArray)(Ee))return[];if(Ee.length!==fe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Be=[];for(let pe=0;pe<fe.length;pe++){const Ce=[];Be.push(Ce);let Me=fe[pe],ze=Ee[pe];for(;;){if(!ze.range.contains(Me))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(C.SelectionRange.from(ze)),!ze.parent)break;Me=ze.range,ze=ze.parent}}return Be})}}class ve{constructor(V,X){this._documents=V,this._provider=X,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(V,X,Z){const se=this._documents.getDocument(V),fe=C.Position.to(X),Ee=await this._provider.prepareCallHierarchy(se,fe,Z);if(!!Ee){const Be=this._idPool.nextId();return this._cache.set(Be,new Map),Array.isArray(Ee)?Ee.map(pe=>this._cacheAndConvertItem(Be,pe)):[this._cacheAndConvertItem(Be,Ee)]}}async provideCallsTo(V,X,Z){const se=this._itemFromCache(V,X);if(!se)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyIncomingCalls(se,Z);if(!!fe)return fe.map(Ee=>({from:this._cacheAndConvertItem(V,Ee.from),fromRanges:Ee.fromRanges.map(Be=>C.Range.from(Be))}))}async provideCallsFrom(V,X,Z){const se=this._itemFromCache(V,X);if(!se)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyOutgoingCalls(se,Z);if(!!fe)return fe.map(Ee=>({to:this._cacheAndConvertItem(V,Ee.to),fromRanges:Ee.fromRanges.map(Be=>C.Range.from(Be))}))}releaseSession(V){this._cache.delete(V)}_cacheAndConvertItem(V,X){var Z;const se=this._cache.get(V),fe={_sessionId:V,_itemId:se.size.toString(36),name:X.name,detail:X.detail,kind:C.SymbolKind.from(X.kind),uri:X.uri,range:C.Range.from(X.range),selectionRange:C.Range.from(X.selectionRange),tags:(Z=X.tags)===null||Z===void 0?void 0:Z.map(C.SymbolTag.from)};return se.set(fe._itemId,X),fe}_itemFromCache(V,X){const Z=this._cache.get(V);return Z==null?void 0:Z.get(X)}}class Re{constructor(V,X){this.adapter=V,this.extension=X}}class Se{constructor(V,X,Z,se,fe,Ee,Be){this._adapter=new Map,this._uriTransformer=X,this._proxy=V.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=Z,this._commands=se,this._diagnostics=fe,this._logService=Ee,this._apiDeprecation=Be}_transformDocumentSelector(V){return(0,i.coalesce)((0,i.asArray)(V).map(X=>this._doTransformDocumentSelector(X)))}_doTransformDocumentSelector(V){if(typeof V=="string")return{$serialized:!0,language:V};if(V)return{$serialized:!0,language:V.language,scheme:this._transformScheme(V.scheme),pattern:typeof V.pattern=="undefined"?void 0:C.GlobPattern.from(V.pattern),exclusive:V.exclusive}}_transformScheme(V){return this._uriTransformer&&typeof V=="string"?this._uriTransformer.transformOutgoingScheme(V):V}_createDisposable(V){return new A.Disposable(()=>{this._adapter.delete(V),this._proxy.$unregister(V)})}_nextHandle(){return Se._handlePool++}_withAdapter(V,X,Z,se,fe=!1){const Ee=this._adapter.get(V);if(!Ee)return Promise.resolve(se);if(Ee.adapter instanceof X){let Be;Ee.extension&&(Be=Date.now(),this._logService.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${X.name}'`));const pe=Z(Ee.adapter,Ee.extension),Ce=Ee.extension;return Ce&&Promise.resolve(pe).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Be}ms`),Me=>{fe&&Me instanceof E.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Me))}),pe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(V,X){const Z=this._nextHandle();return this._adapter.set(Z,new Re(V,X)),Z}static _extLabel(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,X,Z,se){const fe=this._addNewAdapter(new d(this._documents,Z),V),Ee=se&&se.label||Se._extLabel(V);return this._proxy.$registerDocumentSymbolProvider(fe,this._transformDocumentSelector(X),Ee),this._createDisposable(fe)}$provideDocumentSymbols(V,X,Z){return this._withAdapter(V,d,se=>se.provideDocumentSymbols(b.URI.revive(X),Z),void 0)}registerCodeLensProvider(V,X,Z){const se=this._nextHandle(),fe=typeof Z.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new Re(new l(this._documents,this._commands.converter,Z),V)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(X),fe);let Ee=this._createDisposable(se);if(fe!==void 0){const Be=Z.onDidChangeCodeLenses(pe=>this._proxy.$emitCodeLensEvent(fe));Ee=A.Disposable.from(Ee,Be)}return Ee}$provideCodeLenses(V,X,Z){return this._withAdapter(V,l,se=>se.provideCodeLenses(b.URI.revive(X),Z),void 0)}$resolveCodeLens(V,X,Z){return this._withAdapter(V,l,se=>se.resolveCodeLens(X,Z),void 0)}$releaseCodeLenses(V,X){this._withAdapter(V,l,Z=>Promise.resolve(Z.releaseCodeLenses(X)),void 0)}registerDefinitionProvider(V,X,Z){const se=this._addNewAdapter(new t(this._documents,Z),V);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(X)),this._createDisposable(se)}$provideDefinition(V,X,Z,se){return this._withAdapter(V,t,fe=>fe.provideDefinition(b.URI.revive(X),Z,se),[])}registerDeclarationProvider(V,X,Z){const se=this._addNewAdapter(new n(this._documents,Z),V);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(X)),this._createDisposable(se)}$provideDeclaration(V,X,Z,se){return this._withAdapter(V,n,fe=>fe.provideDeclaration(b.URI.revive(X),Z,se),[])}registerImplementationProvider(V,X,Z){const se=this._addNewAdapter(new s(this._documents,Z),V);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(X)),this._createDisposable(se)}$provideImplementation(V,X,Z,se){return this._withAdapter(V,s,fe=>fe.provideImplementation(b.URI.revive(X),Z,se),[])}registerTypeDefinitionProvider(V,X,Z){const se=this._addNewAdapter(new r(this._documents,Z),V);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(X)),this._createDisposable(se)}$provideTypeDefinition(V,X,Z,se){return this._withAdapter(V,r,fe=>fe.provideTypeDefinition(b.URI.revive(X),Z,se),[])}registerHoverProvider(V,X,Z,se){const fe=this._addNewAdapter(new o(this._documents,Z),V);return this._proxy.$registerHoverProvider(fe,this._transformDocumentSelector(X)),this._createDisposable(fe)}$provideHover(V,X,Z,se){return this._withAdapter(V,o,fe=>fe.provideHover(b.URI.revive(X),Z,se),void 0)}registerEvaluatableExpressionProvider(V,X,Z,se){const fe=this._addNewAdapter(new p(this._documents,Z),V);return this._proxy.$registerEvaluatableExpressionProvider(fe,this._transformDocumentSelector(X)),this._createDisposable(fe)}$provideEvaluatableExpression(V,X,Z,se){return this._withAdapter(V,p,fe=>fe.provideEvaluatableExpression(b.URI.revive(X),Z,se),void 0)}registerInlineValuesProvider(V,X,Z,se){const fe=typeof Z.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Ee=this._addNewAdapter(new f(this._documents,Z),V);this._proxy.$registerInlineValuesProvider(Ee,this._transformDocumentSelector(X),fe);let Be=this._createDisposable(Ee);if(fe!==void 0){const pe=Z.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(fe));Be=A.Disposable.from(Be,pe)}return Be}$provideInlineValues(V,X,Z,se,fe){return this._withAdapter(V,f,Ee=>Ee.provideInlineValues(b.URI.revive(X),Z,se,fe),void 0)}registerDocumentHighlightProvider(V,X,Z){const se=this._addNewAdapter(new _(this._documents,Z),V);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(X)),this._createDisposable(se)}$provideDocumentHighlights(V,X,Z,se){return this._withAdapter(V,_,fe=>fe.provideDocumentHighlights(b.URI.revive(X),Z,se),void 0)}registerLinkedEditingRangeProvider(V,X,Z){const se=this._addNewAdapter(new u(this._documents,Z),V);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(X)),this._createDisposable(se)}$provideLinkedEditingRanges(V,X,Z,se){return this._withAdapter(V,u,async fe=>{const Ee=await fe.provideLinkedEditingRanges(b.URI.revive(X),Z,se);if(Ee)return{ranges:Ee.ranges,wordPattern:Ee.wordPattern?Se._serializeRegExp(Ee.wordPattern):void 0}},void 0)}registerReferenceProvider(V,X,Z){const se=this._addNewAdapter(new v(this._documents,Z),V);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(X)),this._createDisposable(se)}$provideReferences(V,X,Z,se,fe){return this._withAdapter(V,v,Ee=>Ee.provideReferences(b.URI.revive(X),Z,se,fe),void 0)}registerCodeActionProvider(V,X,Z,se){var fe,Ee;const Be=new g.DisposableStore,pe=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,Z,this._logService,V,this._apiDeprecation),V);return this._proxy.$registerQuickFixSupport(pe,this._transformDocumentSelector(X),{providedKinds:(fe=se==null?void 0:se.providedCodeActionKinds)===null||fe===void 0?void 0:fe.map(Ce=>Ce.value),documentation:(Ee=se==null?void 0:se.documentation)===null||Ee===void 0?void 0:Ee.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Be)}))},Se._extLabel(V),Boolean(Z.resolveCodeAction)),Be.add(this._createDisposable(pe)),Be}$provideCodeActions(V,X,Z,se,fe){return this._withAdapter(V,R,Ee=>Ee.provideCodeActions(b.URI.revive(X),Z,se,fe),void 0)}$resolveCodeAction(V,X,Z){return this._withAdapter(V,R,se=>se.resolveCodeAction(X,Z),void 0)}$releaseCodeActions(V,X){this._withAdapter(V,R,Z=>Promise.resolve(Z.releaseCodeActions(X)),void 0)}registerDocumentFormattingEditProvider(V,X,Z){const se=this._addNewAdapter(new O(this._documents,Z),V);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(X),V.identifier,V.displayName||V.name),this._createDisposable(se)}$provideDocumentFormattingEdits(V,X,Z,se){return this._withAdapter(V,O,fe=>fe.provideDocumentFormattingEdits(b.URI.revive(X),Z,se),void 0)}registerDocumentRangeFormattingEditProvider(V,X,Z){const se=this._addNewAdapter(new H(this._documents,Z),V);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(X),V.identifier,V.displayName||V.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits(V,X,Z,se,fe){return this._withAdapter(V,H,Ee=>Ee.provideDocumentRangeFormattingEdits(b.URI.revive(X),Z,se,fe),void 0)}registerOnTypeFormattingEditProvider(V,X,Z,se){const fe=this._addNewAdapter(new ne(this._documents,Z),V);return this._proxy.$registerOnTypeFormattingSupport(fe,this._transformDocumentSelector(X),se,V.identifier),this._createDisposable(fe)}$provideOnTypeFormattingEdits(V,X,Z,se,fe,Ee){return this._withAdapter(V,ne,Be=>Be.provideOnTypeFormattingEdits(b.URI.revive(X),Z,se,fe,Ee),void 0)}registerWorkspaceSymbolProvider(V,X){const Z=this._addNewAdapter(new ie(X,this._logService),V);return this._proxy.$registerNavigateTypeSupport(Z),this._createDisposable(Z)}$provideWorkspaceSymbols(V,X,Z){return this._withAdapter(V,ie,se=>se.provideWorkspaceSymbols(X,Z),{symbols:[]})}$resolveWorkspaceSymbol(V,X,Z){return this._withAdapter(V,ie,se=>se.resolveWorkspaceSymbol(X,Z),void 0)}$releaseWorkspaceSymbols(V,X){this._withAdapter(V,ie,Z=>Z.releaseWorkspaceSymbols(X),void 0)}registerRenameProvider(V,X,Z){const se=this._addNewAdapter(new U(this._documents,Z,this._logService),V);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(X),U.supportsResolving(Z)),this._createDisposable(se)}$provideRenameEdits(V,X,Z,se,fe){return this._withAdapter(V,U,Ee=>Ee.provideRenameEdits(b.URI.revive(X),Z,se,fe),void 0)}$resolveRenameLocation(V,X,Z,se){return this._withAdapter(V,U,fe=>fe.resolveRenameLocation(b.URI.revive(X),Z,se),void 0)}registerDocumentSemanticTokensProvider(V,X,Z,se){const fe=this._nextHandle(),Ee=typeof Z.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(fe,new Re(new x(this._documents,Z),V)),this._proxy.$registerDocumentSemanticTokensProvider(fe,this._transformDocumentSelector(X),se,Ee);let Be=this._createDisposable(fe);if(Ee){const pe=Z.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(Ee));Be=A.Disposable.from(Be,pe)}return Be}$provideDocumentSemanticTokens(V,X,Z,se){return this._withAdapter(V,x,fe=>fe.provideDocumentSemanticTokens(b.URI.revive(X),Z,se),null,!0)}$releaseDocumentSemanticTokens(V,X){this._withAdapter(V,x,Z=>Z.releaseDocumentSemanticColoring(X),void 0)}registerDocumentRangeSemanticTokensProvider(V,X,Z,se){const fe=this._addNewAdapter(new L(this._documents,Z),V);return this._proxy.$registerDocumentRangeSemanticTokensProvider(fe,this._transformDocumentSelector(X),se),this._createDisposable(fe)}$provideDocumentRangeSemanticTokens(V,X,Z,se){return this._withAdapter(V,L,fe=>fe.provideDocumentRangeSemanticTokens(b.URI.revive(X),Z,se),null,!0)}registerCompletionItemProvider(V,X,Z,se){const fe=this._addNewAdapter(new N(this._documents,this._commands.converter,Z,this._apiDeprecation,V),V);return this._proxy.$registerSuggestSupport(fe,this._transformDocumentSelector(X),se,N.supportsResolving(Z),`${V.identifier.value}(${se.join("")})`),this._createDisposable(fe)}$provideCompletionItems(V,X,Z,se,fe){return this._withAdapter(V,N,Ee=>Ee.provideCompletionItems(b.URI.revive(X),Z,se,fe),void 0)}$resolveCompletionItem(V,X,Z){return this._withAdapter(V,N,se=>se.resolveCompletionItem(X,Z),void 0)}$releaseCompletionItems(V,X){this._withAdapter(V,N,Z=>Z.releaseCompletionItems(X),void 0)}registerSignatureHelpProvider(V,X,Z,se){const fe=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,Ee=this._addNewAdapter(new F(this._documents,Z),V);return this._proxy.$registerSignatureHelpProvider(Ee,this._transformDocumentSelector(X),fe),this._createDisposable(Ee)}$provideSignatureHelp(V,X,Z,se,fe){return this._withAdapter(V,F,Ee=>Ee.provideSignatureHelp(b.URI.revive(X),Z,se,fe),void 0)}$releaseSignatureHelp(V,X){this._withAdapter(V,F,Z=>Z.releaseSignatureHelp(X),void 0)}registerInlayHintsProvider(V,X,Z){const se=typeof Z.onDidChangeInlayHints=="function"?this._nextHandle():void 0,fe=this._addNewAdapter(new M(this._documents,Z),V);this._proxy.$registerInlayHintsProvider(fe,this._transformDocumentSelector(X),se);let Ee=this._createDisposable(fe);if(se!==void 0){const Be=Z.onDidChangeInlayHints(pe=>this._proxy.$emitInlayHintsEvent(se));Ee=A.Disposable.from(Ee,Be)}return Ee}$provideInlayHints(V,X,Z,se){return this._withAdapter(V,M,fe=>fe.provideInlayHints(b.URI.revive(X),Z,se),void 0)}registerDocumentLinkProvider(V,X,Z){const se=this._addNewAdapter(new $(this._documents,Z),V);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(X),typeof Z.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks(V,X,Z){return this._withAdapter(V,$,se=>se.provideLinks(b.URI.revive(X),Z),void 0)}$resolveDocumentLink(V,X,Z){return this._withAdapter(V,$,se=>se.resolveLink(X,Z),void 0)}$releaseDocumentLinks(V,X){this._withAdapter(V,$,Z=>Z.releaseLinks(X),void 0)}registerColorProvider(V,X,Z){const se=this._addNewAdapter(new q(this._documents,Z),V);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(X)),this._createDisposable(se)}$provideDocumentColors(V,X,Z){return this._withAdapter(V,q,se=>se.provideColors(b.URI.revive(X),Z),[])}$provideColorPresentations(V,X,Z,se){return this._withAdapter(V,q,fe=>fe.provideColorPresentations(b.URI.revive(X),Z,se),void 0)}registerFoldingRangeProvider(V,X,Z){const se=this._nextHandle(),fe=typeof Z.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new Re(new G(this._documents,Z),V)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(X),fe);let Ee=this._createDisposable(se);if(fe!==void 0){const Be=Z.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(fe));Ee=A.Disposable.from(Ee,Be)}return Ee}$provideFoldingRanges(V,X,Z,se){return this._withAdapter(V,G,fe=>fe.provideFoldingRanges(b.URI.revive(X),Z,se),void 0)}registerSelectionRangeProvider(V,X,Z){const se=this._addNewAdapter(new le(this._documents,Z,this._logService),V);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(X)),this._createDisposable(se)}$provideSelectionRanges(V,X,Z,se){return this._withAdapter(V,le,fe=>fe.provideSelectionRanges(b.URI.revive(X),Z,se),[])}registerCallHierarchyProvider(V,X,Z){const se=this._addNewAdapter(new ve(this._documents,Z),V);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(X)),this._createDisposable(se)}$prepareCallHierarchy(V,X,Z,se){return this._withAdapter(V,ve,fe=>Promise.resolve(fe.prepareSession(b.URI.revive(X),Z,se)),void 0)}$provideCallHierarchyIncomingCalls(V,X,Z,se){return this._withAdapter(V,ve,fe=>fe.provideCallsTo(X,Z,se),void 0)}$provideCallHierarchyOutgoingCalls(V,X,Z,se){return this._withAdapter(V,ve,fe=>fe.provideCallsFrom(X,Z,se),void 0)}$releaseCallHierarchy(V,X){this._withAdapter(V,ve,Z=>Promise.resolve(Z.releaseSession(X)),void 0)}static _serializeRegExp(V){return{pattern:V.source,flags:(0,D.regExpFlags)(V)}}static _serializeIndentationRule(V){return{decreaseIndentPattern:Se._serializeRegExp(V.decreaseIndentPattern),increaseIndentPattern:Se._serializeRegExp(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Se._serializeRegExp(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Se._serializeRegExp(V.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(V){return{beforeText:Se._serializeRegExp(V.beforeText),afterText:V.afterText?Se._serializeRegExp(V.afterText):void 0,previousLineText:V.previousLineText?Se._serializeRegExp(V.previousLineText):void 0,action:V.action}}static _serializeOnEnterRules(V){return V.map(Se._serializeOnEnterRule)}setLanguageConfiguration(V,X,Z){let{wordPattern:se}=Z;if(se&&(0,D.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(X,se):this._documents.setWordDefinitionFor(X,void 0),Z.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),Z.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const fe=this._nextHandle(),Ee={comments:Z.comments,brackets:Z.brackets,wordPattern:Z.wordPattern?Se._serializeRegExp(Z.wordPattern):void 0,indentationRules:Z.indentationRules?Se._serializeIndentationRule(Z.indentationRules):void 0,onEnterRules:Z.onEnterRules?Se._serializeOnEnterRules(Z.onEnterRules):void 0,__electricCharacterSupport:Z.__electricCharacterSupport,__characterPairSupport:Z.__characterPairSupport};return this._proxy.$setLanguageConfiguration(fe,X,Ee),this._createDisposable(fe)}$setWordDefinitions(V){for(const X of V)this._documents.setWordDefinitionFor(X.languageId,new RegExp(X.regexSource,X.regexFlags))}}e.ExtHostLanguageFeatures=Se,Se._handlePool=0}),define(me[239],ge([0,1,5,20,7]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class A{constructor(k,D){this._proxy=k.getProxy(b.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(k,D){await this._proxy.$changeLanguage(k,D);const P=this._documents.getDocumentData(k);if(!P)throw new Error(`document '${k.toString}' NOT found`);return P.document}async tokenAtPosition(k,D){var P;const i=k.version,I=T.Position.from(D),m=await this._proxy.$tokensAtPosition(k.uri,I),g={type:C.StandardTokenType.Other,range:(P=k.getWordRangeAtPosition(D))!==null&&P!==void 0?P:new C.Range(D.line,D.character,D.line,D.character)};if(!m)return g;const a={range:T.Range.to(m.range),type:T.TokenType.to(m.type)};return!a.range.contains(D)||i!==k.version?g:a}}e.ExtHostLanguages=A}),define(me[240],ge([0,1,5,12,41]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(k){return k&&k.title}let y=class{constructor(D,P){this._logService=P,this._proxy=D.getProxy(b.MainContext.MainThreadMessageService)}showMessage(D,P,i,I,m){const g={extension:D};let a;typeof I=="string"||A(I)?a=[I,...m]:(g.modal=I&&I.modal,g.useCustom=I&&I.useCustom,a=m),g.useCustom&&(0,C.checkProposedApiEnabled)(D);const h=[];for(let S=0;S<a.length;S++){const w=a[S];if(typeof w=="string")h.push({title:w,handle:S,isCloseAffordance:!1});else if(typeof w=="object"){let{title:E,isCloseAffordance:d}=w;h.push({title:E,isCloseAffordance:!!d,handle:S})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(P,i,g,h).then(S=>{if(typeof S=="number")return a[S]})}};y=qe([He(1,T.ILogService)],y),e.ExtHostMessageService=y}),define(me[241],ge([0,1,23,3,75,73,6,22,9,11,2,87,5,20,7,90,217,218]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class E{constructor(c,t){const n=E._Keys.nextId();c.$registerNotebookEditorDecorationType(n,g.NotebookDecorationRenderOptions.from(t)),this.value={key:n,dispose(){c.$removeNotebookEditorDecorationType(n)}}}}e.NotebookEditorDecorationType=E,E._Keys=new A.IdGenerator("NotebookEditorDecorationType");class d{constructor(c,t,n,s,r,o){this._textDocumentsAndEditors=n,this._textDocuments=s,this.logService=r,this._extensionStoragePaths=o,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new T.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new T.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new T.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new T.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new T.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new T.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new T.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new T.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new I.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=c.getProxy(m.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=c.getProxy(m.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=c.getProxy(m.MainContext.MainThreadNotebookEditors),this._commandsConverter=t.converter,t.registerArgumentProcessor({processArgument:p=>{var f;if(p&&p.$mid===12){const _=(f=p.notebookEditor)===null||f===void 0?void 0:f.notebookUri,u=p.cell.handle,v=this._documents.get(_),R=v==null?void 0:v.getCell(u);if(R)return R.apiCell}return p}})}get activeNotebookEditor(){var c;return(c=this._activeNotebookEditor)===null||c===void 0?void 0:c.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(c=>c.apiEditor)}getEditorById(c){return this._editors.get(c)}getIdByEditor(c){for(const[t,n]of this._editors)if(n.apiEditor===c)return t}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(c,t){const n=this._documents.get(c);if(!n&&!t)throw new Error(`NO notebook document for '${c}'`);return n}_getProviderData(c){const t=this._notebookContentProviders.get(c);if(!t)throw new Error(`NO provider for '${c}'`);return t}registerNotebookContentProvider(c,t,n,s,r){if((0,D.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(t))throw new Error(`Notebook provider for '${t}' already registered`);this._notebookContentProviders.set(t,{extension:c,provider:n});let o;return n.onDidChangeNotebookContentOptions&&(o=n.onDidChangeNotebookContentOptions(()=>{const p=g.NotebookDocumentContentOptions.from(n.options);this._notebookProxy.$updateNotebookProviderOptions(t,p)})),this._notebookProxy.$registerNotebookProvider({id:c.identifier,location:c.extensionLocation},t,g.NotebookDocumentContentOptions.from(s),d._convertNotebookRegistrationData(c,r)),new a.Disposable(()=>{o==null||o.dispose(),this._notebookContentProviders.delete(t),this._notebookProxy.$unregisterNotebookProvider(t)})}static _convertNotebookRegistrationData(c,t){if(!!t){const n=t.filenamePattern.map(s=>g.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(t.filenamePattern&&!n){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:t.displayName,filenamePattern:n,exclusive:t.exclusive||!1}}}registerNotebookCellStatusBarItemProvider(c,t,n){const s=d._notebookStatusBarItemProviderHandlePool++,r=typeof n.onDidChangeCellStatusBarItems=="function"?d._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(s,n),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(s,r,t);let o;return r!==void 0&&(o=n.onDidChangeCellStatusBarItems(p=>this._notebookProxy.$emitCellStatusBarEvent(r))),new a.Disposable(()=>{this._notebookStatusBarItemProviders.delete(s),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(s,r),o&&o.dispose()})}createNotebookEditorDecorationType(c){return new E(this._notebookEditorsProxy,c).value}async openNotebookDocument(c){const t=this._documents.get(c);if(t)return t.apiNotebook;const n=await this._notebookDocumentsProxy.$tryOpenDocument(c),s=this._documents.get(i.URI.revive(n));return(0,P.assertIsDefined)(s==null?void 0:s.apiNotebook)}async showNotebookDocument(c,t){var n;i.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let s;typeof t=="object"?s={position:g.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(g.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:s={preserveFocus:!1};const r=await this._notebookEditorsProxy.$tryShowNotebookDocument(c.uri,c.viewType,s),o=r&&((n=this._editors.get(r))===null||n===void 0?void 0:n.apiEditor);if(o)return o;throw r?new Error(`Could NOT open editor for "${c.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.toString()}".`)}async $provideNotebookCellStatusBarItems(c,t,n,s){var r;const o=this._notebookStatusBarItemProviders.get(c),p=i.URI.revive(t),f=this._documents.get(p);if(!(!f||!o)){const _=f.getCellFromIndex(n);if(!!_){const u=await o.provideCellStatusBarItems(_.apiCell,s);if(!!u){const v=new y.DisposableStore,R=this._statusBarCache.add([v]),O=(r=u&&u.map(H=>g.NotebookStatusBarItem.from(H,this._commandsConverter,v)))!==null&&r!==void 0?r:void 0;return{cacheId:R,items:O}}}}}$releaseNotebookCellStatusBarItems(c){this._statusBarCache.delete(c)}registerNotebookSerializer(c,t,n,s,r){if((0,D.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,n),this._notebookProxy.$registerNotebookSerializer(o,{id:c.identifier,location:c.extensionLocation},t,g.NotebookDocumentContentOptions.from(s),d._convertNotebookRegistrationData(c,r)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(c,t,n){const s=this._notebookSerializer.get(c);if(!s)throw new Error("NO serializer found");const r=await s.deserializeNotebook(t.buffer,n),o={metadata:g.NotebookDocumentMetadata.from(r.metadata),cells:[]};for(let p of r.cells)a.NotebookCellData.validate(p),o.cells.push(g.NotebookCellData.from(p));return o}async $notebookToData(c,t,n){const s=this._notebookSerializer.get(c);if(!s)throw new Error("NO serializer found");const r=await s.serializeNotebook({metadata:g.NotebookDocumentMetadata.to(t.metadata),cells:t.cells.map(g.NotebookCellData.to)},n);return b.VSBuffer.wrap(r)}async $openNotebook(c,t,n,s,r){const{provider:o}=this._getProviderData(c),p=await o.openNotebook(i.URI.revive(t),{backupId:n,untitledDocumentData:s==null?void 0:s.buffer},r);return{metadata:g.NotebookDocumentMetadata.from(p.metadata),cells:p.cells.map(g.NotebookCellData.from)}}async $saveNotebook(c,t,n){const s=this.getNotebookDocument(i.URI.revive(t)),{provider:r}=this._getProviderData(c);return await r.saveNotebook(s.apiNotebook,n),!0}async $saveNotebookAs(c,t,n,s){const r=this.getNotebookDocument(i.URI.revive(t)),{provider:o}=this._getProviderData(c);return await o.saveNotebookAs(i.URI.revive(n),r.apiNotebook,s),!0}async $backupNotebook(c,t,n){var s;const r=this.getNotebookDocument(i.URI.revive(t)),o=this._getProviderData(c),p=(s=this._extensionStoragePaths.workspaceValue(o.extension))!==null&&s!==void 0?s:this._extensionStoragePaths.globalValue(o.extension),f=String((0,C.hash)([r.uri.toString(),this._backupIdPool++])),_=i.URI.joinPath(p,f),u=await o.provider.backupNotebook(r.apiNotebook,{destination:_},n);return r.updateBackup(u),u.id}$acceptModelChanged(c,t,n){this.getNotebookDocument(i.URI.revive(c)).acceptModelChanged(t,n)}$acceptDirtyStateChanged(c,t){const n=this.getNotebookDocument(i.URI.revive(c));n.acceptModelChanged({rawEvents:[],versionId:n.apiNotebook.version},t)}$acceptModelSaved(c){const t=this.getNotebookDocument(i.URI.revive(c));this._onDidSaveNotebookDocument.fire(t.apiNotebook)}$acceptEditorPropertiesChanged(c,t){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",c,t);const n=this._editors.get(c);if(!n)throw new Error(`unknown text editor: ${c}. known editors: ${[...this._editors.keys()]} `);t.visibleRanges&&n._acceptVisibleRanges(t.visibleRanges.ranges.map(g.NotebookRange.to)),t.selections&&n._acceptSelections(t.selections.selections.map(g.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:n.apiEditor,visibleRanges:n.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:n.apiEditor,selections:n.apiEditor.selections}))}$acceptEditorViewColumns(c){for(const t in c){const n=this._editors.get(t);if(!n)throw new Error(`unknown text editor: ${t}. known editors: ${[...this._editors.keys()]} `);n._acceptViewColumn(g.ViewColumn.to(c[t]))}}$acceptDocumentPropertiesChanged(c,t){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",c.path,t);const n=this.getNotebookDocument(i.URI.revive(c));n.acceptDocumentPropertiesChanged(t),t.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:n.apiNotebook})}_createExtHostEditor(c,t,n){if(this._editors.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const s=new w.ExtHostNotebookEditor(t,this._notebookEditorsProxy,c,n.visibleRanges.map(g.NotebookRange.to),n.selections.map(g.NotebookRange.to),typeof n.viewColumn=="number"?g.ViewColumn.to(n.viewColumn):void 0);this._editors.set(t,s)}$acceptDocumentAndEditorsDelta(c){var t,n,s;if(c.removedDocuments)for(const o of c.removedDocuments){const p=i.URI.revive(o),f=this._documents.get(p);f&&(f.dispose(),this._documents.delete(p),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(_=>_.document.uri)}),this._onDidCloseNotebookDocument.fire(f.apiNotebook));for(const _ of this._editors.values())_.notebookData.uri.toString()===p.toString()&&this._editors.delete(_.id)}if(c.addedDocuments){const o=[];for(const p of c.addedDocuments){const f=i.URI.revive(p.uri),_=p.viewType;if(this._documents.has(f))throw new Error(`adding EXISTING notebook ${f} `);const u=this,v=new S.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(R){u._onDidChangeNotebookCells.fire(R)},emitCellOutputsChange(R){u._onDidChangeCellOutputs.fire(R)},emitCellMetadataChange(R){u._onDidChangeCellMetadata.fire(R)},emitCellExecutionStateChange(R){u._onDidChangeCellExecutionState.fire(R)}},_,p.metadata?g.NotebookDocumentMetadata.to(p.metadata):new a.NotebookDocumentMetadata,f);v.acceptModelChanged({versionId:p.versionId,rawEvents:[{kind:h.NotebookCellsChangeType.Initialize,changes:[[0,0,p.cells]]}]},!1),o.push(...p.cells.map(R=>S.ExtHostCell.asModelAddData(v.apiNotebook,R))),(t=this._documents.get(f))===null||t===void 0||t.dispose(),this._documents.set(f,v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:o}),this._onDidOpenNotebookDocument.fire(v.apiNotebook)}}if(c.addedEditors)for(const o of c.addedEditors){if(this._editors.has(o.id))return;const p=i.URI.revive(o.documentUri),f=this._documents.get(p);f&&this._createExtHostEditor(f,o.id,o)}const r=[];if(c.removedEditors)for(const o of c.removedEditors){const p=this._editors.get(o);p&&(this._editors.delete(o),((n=this._activeNotebookEditor)===null||n===void 0?void 0:n.id)===p.id&&(this._activeNotebookEditor=void 0),r.push(p))}if(c.visibleEditors){this._visibleNotebookEditors=c.visibleEditors.map(p=>this._editors.get(p)).filter(p=>!!p);const o=new Set;this._visibleNotebookEditors.forEach(p=>o.add(p.id));for(const p of this._editors.values()){const f=o.has(p.id);p._acceptVisibility(f)}this._visibleNotebookEditors=[...this._editors.values()].map(p=>p).filter(p=>p.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}c.newActiveEditor===null?this._activeNotebookEditor=void 0:c.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(c.newActiveEditor)),c.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((s=this._activeNotebookEditor)===null||s===void 0?void 0:s.apiEditor)}}e.ExtHostNotebookController=d,d._notebookStatusBarItemProviderHandlePool=0}),define(me[242],ge([0,1,3,6,5,27,2,20,89,22,14,21,7,16,12]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let h=class{constructor(l,c,t,n){this._mainContext=l,this._initData=c,this._extHostNotebook=t,this._logService=n,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=l.getProxy(C.MainContext.MainThreadNotebookKernels)}createNotebookController(l,c,t,n,s,r){for(let L of this._kernelData.values())if(L.controller.id===c&&A.ExtensionIdentifier.equals(l.identifier,L.extensionId))throw new Error(`notebook controller with id '${c}' ALREADY exist`);const o=this._handlePool++,p=this;this._logService.trace(`NotebookController[${o}], CREATED by ${l.identifier.value}, ${c}`);const f=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${l.identifier}'`);let _=!1;const u=new T.DisposableStore,v=new b.Emitter,R=new b.Emitter,O={id:`${l.identifier.value}/${c}`,viewType:t,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:n||l.identifier.value,preloads:r?r.map(k.NotebookKernelPreload.from):[]};let H=s!=null?s:f,ne;this._proxy.$addKernel(o,O).catch(L=>{console.log(L),_=!0});let ie=0;const U=()=>{if(!_){const L=++ie;Promise.resolve().then(()=>{L===ie&&this._proxy.$updateKernel(o,O)})}},B=new P.ResourceMap,x={get id(){return c},get viewType(){return O.viewType},onDidChangeNotebookAssociation:v.event,get label(){return O.label},set label(L){var N;O.label=(N=L!=null?L:l.displayName)!==null&&N!==void 0?N:l.name,U()},get detail(){var L;return(L=O.detail)!==null&&L!==void 0?L:""},set detail(L){O.detail=L,U()},get description(){var L;return(L=O.description)!==null&&L!==void 0?L:""},set description(L){O.description=L,U()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(L){O.supportedLanguages=L,U()},get hasExecutionOrder(){var L;return(L=O.hasExecutionOrder)!==null&&L!==void 0?L:!1},set hasExecutionOrder(L){O.hasExecutionOrder=L,U()},get preloads(){return O.preloads?O.preloads.map(k.NotebookKernelPreload.to):[]},get executeHandler(){return H},set executeHandler(L){H=L!=null?L:f},get interruptHandler(){return ne},set interruptHandler(L){ne=L,O.supportsInterrupt=Boolean(L),U()},createNotebookCellExecutionTask(L){if(_)throw new Error("notebook controller is DISPOSED");if(!B.has(L.notebook.uri))throw p._logService.trace(`NotebookController[${o}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(B.keys()).map(N=>N.toString())),new Error(`notebook controller is NOT associated to notebook: ${L.notebook.uri.toString()}`);return p._createNotebookCellExecution(L)},dispose:()=>{_||(this._logService.trace(`NotebookController[${o}], DISPOSED`),_=!0,this._kernelData.delete(o),u.dispose(),v.dispose(),R.dispose(),this._proxy.$removeKernel(o))},onDidReceiveMessage:R.event,postMessage(L,N){return p._proxy.$postMessage(o,N&&p._extHostNotebook.getIdByEditor(N),L)},asWebviewUri(L){return(0,D.asWebviewUri)(Object.assign(Object.assign({},p._initData.environment),{remote:p._initData.remote}),String(o),L)},updateNotebookAffinity(L,N){p._proxy.$updateNotebookPriority(o,L.uri,N)}};return this._kernelData.set(o,{extensionId:l.identifier,controller:x,onDidReceiveMessage:R,onDidChangeSelection:v,associatedNotebooks:B}),x}$acceptNotebookAssociation(l,c,t){const n=this._kernelData.get(l);if(n){const s=this._extHostNotebook.getNotebookDocument(y.URI.revive(c));t?n.associatedNotebooks.set(s.uri,!0):n.associatedNotebooks.delete(s.uri),this._logService.trace(`NotebookController[${l}] ASSOCIATE notebook`,s.uri.toString(),t),n.onDidChangeSelection.fire({selected:t,notebook:s.apiNotebook})}}async $executeCells(l,c,t){const n=this._kernelData.get(l);if(!!n){const s=this._extHostNotebook.getNotebookDocument(y.URI.revive(c)),r=[];for(let o of t){const p=s.getCell(o);p&&r.push(p.apiCell)}try{this._logService.trace(`NotebookController[${l}] EXECUTE cells`,s.uri.toString(),r.length),await n.controller.executeHandler.call(n.controller,r,s.apiNotebook,n.controller)}catch(o){this._logService.error(`NotebookController[${l}] execute cells FAILED`,o),console.error(o)}}}async $cancelCells(l,c,t){var n;const s=this._kernelData.get(l);if(!!s){const r=this._extHostNotebook.getNotebookDocument(y.URI.revive(c));s.controller.interruptHandler&&await s.controller.interruptHandler.call(s.controller,r.apiNotebook);for(let o of t){const p=r.getCell(o);p&&((n=this._activeExecutions.get(p.uri))===null||n===void 0||n.cancel())}}}$acceptKernelMessageFromRenderer(l,c,t){const n=this._kernelData.get(l);if(!!n){const s=this._extHostNotebook.getEditorById(c);if(!s)throw new Error(`send message for UNKNOWN editor: ${c}`);n.onDidReceiveMessage.fire(Object.freeze({editor:s.apiEditor,message:t}))}}_createNotebookCellExecution(l){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const t=this._extHostNotebook.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!t)throw new Error("invalid cell");if(this._activeExecutions.has(t.uri))throw new Error(`duplicate execution for ${t.uri}`);const n=new w(t.notebook,t,this._mainContext.getProxy(C.MainContext.MainThreadNotebookDocuments));this._activeExecutions.set(t.uri,n);const s=n.onDidChangeState(()=>{n.state===S.Resolved&&(n.dispose(),s.dispose(),this._activeExecutions.delete(t.uri))});return n.asApiObject()}};h=qe([He(3,a.ILogService)],h),e.ExtHostNotebookKernels=h;var S;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(S||(S={}));class w extends T.Disposable{constructor(l,c,t){super();this._document=l,this._cell=c,this._proxy=t,this._onDidChangeState=new b.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=S.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new E(10,n=>this.applyEdits(n)),this._executionOrder=c.internalMetadata.executionOrder,this.mixinMetadata({runState:m.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(l){await this._collector.addItem(l)}async applyEdits(l){return this._proxy.$applyEdits(this._document.uri,l,!1)}verifyStateForOutput(){if(this._state===S.Init)throw new Error("Must call start before modifying cell output");if(this._state===S.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(l){const c={editType:8,handle:this._cell.handle,metadata:l};this.applyEdits([c])}cellIndexToHandle(l){if(typeof l!="number")return this._cell.handle;const c=this._document.getCellFromIndex(l);if(!c)throw new Error("INVALID cell index");return c.handle}asApiObject(){const l=this;return Object.freeze({get document(){return l._document.apiNotebook},get cell(){return l._cell.apiCell},get executionOrder(){return l._executionOrder},set executionOrder(c){l._executionOrder=c,l.mixinMetadata({executionOrder:c})},start(c){var t;if(l._state===S.Resolved||l._state===S.Started)throw new Error("Cannot call start again");l._state=S.Started,l._onDidChangeState.fire(),l.mixinMetadata({runState:m.NotebookCellExecutionState.Executing,runStartTime:(t=c==null?void 0:c.startTime)!==null&&t!==void 0?t:null})},end(c){var t,n;if(l._state===S.Resolved)throw new Error("Cannot call resolve twice");l._state=S.Resolved,l._onDidChangeState.fire(),l.mixinMetadata({runState:m.NotebookCellExecutionState.Idle,lastRunSuccess:(t=c==null?void 0:c.success)!==null&&t!==void 0?t:null,runEndTime:(n=c==null?void 0:c.endTime)!==null&&n!==void 0?n:null})},clearOutput(c){return l.verifyStateForOutput(),this.replaceOutput([],c)},async appendOutput(c,t){l.verifyStateForOutput();const n=l.cellIndexToHandle(t);return c=(0,g.asArray)(c),l.applyEditSoon({editType:2,handle:n,append:!0,outputs:c.map(k.NotebookCellOutput.from)})},async replaceOutput(c,t){l.verifyStateForOutput();const n=l.cellIndexToHandle(t);return c=(0,g.asArray)(c),l.applyEditSoon({editType:2,handle:n,outputs:c.map(k.NotebookCellOutput.from)})},async appendOutputItems(c,t){return l.verifyStateForOutput(),c=(0,g.asArray)(c),l.applyEditSoon({editType:7,append:!0,items:c.map(k.NotebookCellOutputItem.from),outputId:t})},async replaceOutputItems(c,t){return l.verifyStateForOutput(),c=(0,g.asArray)(c),l.applyEditSoon({editType:7,items:c.map(k.NotebookCellOutputItem.from),outputId:t})},token:l._tokenSource.token})}}class E{constructor(l,c){this.delay=l,this.callback=c,this.batch=[]}addItem(l){return this.batch.push(l),this.waitPromise||(this.waitPromise=(0,i.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const c=this.batch;return this.batch=[],this.callback(c)})),this.waitPromise}}}),define(me[66],ge([0,1,5,3,6,23,4,15]),function(K,e,b,T,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends C.Disposable{constructor(a,h,S,w){super();this._onDidAppend=this._register(new T.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=w,this._id=w.$register(this.name,h,S),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?A.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(h=>this._proxy.$clear(h,a))}show(a,h){this.validate(),this._id.then(S=>this._proxy.$reveal(S,!!(typeof a=="boolean"?a:h)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class P extends D{constructor(a,h){super(a,!1,void 0,h)}append(a){super.append(a),this._id.then(h=>this._proxy.$append(h,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class i extends D{constructor(a,h,S){super(a,!0,h,S)}append(a){throw new Error("Not supported")}}class I{constructor(a,h){this.name=a,this._channel=h}append(a){this._channel.then(h=>h.append(a))}appendLine(a){this._channel.then(h=>h.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,h){this._channel.then(S=>S.show(a,h))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=I;let m=class{constructor(a){this._proxy=a.getProxy(b.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new P(a,this._proxy)}createOutputChannelFromLogFile(a,h){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!h)throw new Error("illegal argument `file`. must not be falsy");return new i(a,h,this._proxy)}};m=qe([He(0,k.IExtHostRpcService)],m),e.ExtHostOutputService=m,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(me[243],ge([0,1,14,21,3,6,5,2,7,17,16,59]),function(K,e,b,T,C,A,y,k,D,P,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(g,a,h){const S=g.getProxy(y.MainContext.MainThreadQuickOpen);class w{constructor(r,o){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=o}showQuickPick(r,o,p,f=T.CancellationToken.None){this._onDidSelectItem=void 0;const _=Promise.resolve(r),u=++this._instances,v=S.$show(u,{title:p==null?void 0:p.title,placeHolder:p==null?void 0:p.placeHolder,matchOnDescription:p==null?void 0:p.matchOnDescription,matchOnDetail:p==null?void 0:p.matchOnDetail,ignoreFocusLost:p==null?void 0:p.ignoreFocusOut,canPickMany:p==null?void 0:p.canPickMany},f),R={},O=v.then(()=>R);return Promise.race([O,_]).then(H=>{if(H!==R)return _.then(ne=>{const ie=[];for(let U=0;U<ne.length;U++){const B=ne[U];let x,L,N,F,M;typeof B=="string"?x=B:(x=B.label,L=B.description,N=B.detail,F=B.picked,M=B.alwaysShow),ie.push({label:x,description:L,handle:U,detail:N,picked:F,alwaysShow:M})}return p&&typeof p.onDidSelectItem=="function"&&(this._onDidSelectItem=U=>{p.onDidSelectItem(ne[U])}),S.$setItems(u,ie),v.then(U=>{if(typeof U=="number")return ne[U];if(Array.isArray(U))return U.map(B=>ne[B])})})}).then(void 0,H=>{if(!(0,P.isPromiseCanceledError)(H))return S.$setError(u,H),Promise.reject(H)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,o=T.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,S.$input(r,typeof this._validateInput=="function",o).then(void 0,p=>{if(!(0,P.isPromiseCanceledError)(p))return Promise.reject(p)})}$validateInput(r){return this._validateInput?(0,b.asPromise)(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,o=T.CancellationToken.None){const p=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!!p){const f=await this._workspace.getWorkspaceFolders2();if(!!f)return f.find(_=>_.uri.toString()===p.uri.toString())}}createQuickPick(r,o){const p=new t(r,o,()=>this._sessions.delete(p._id));return this._sessions.set(p._id,p),p}createInputBox(r){const o=new n(r,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(r,o){const p=this._sessions.get(r);p&&p._fireDidChangeValue(o)}$onDidAccept(r){const o=this._sessions.get(r);o&&o._fireDidAccept()}$onDidChangeActive(r,o){const p=this._sessions.get(r);p instanceof t&&p._fireDidChangeActive(o)}$onDidChangeSelection(r,o){const p=this._sessions.get(r);p instanceof t&&p._fireDidChangeSelection(o)}$onDidTriggerButton(r,o){const p=this._sessions.get(r);p&&p._fireDidTriggerButton(o)}$onDidHide(r){const o=this._sessions.get(r);o&&o._fireDidHide()}}class E{constructor(r,o){this._extensionId=r,this._onDidDispose=o,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((o,p)=>{const f=o===D.QuickInputButtons.Back?-1:p;this._handlesToButtons.set(f,o)}),this.update({buttons:r.map((o,p)=>({iconPath:d(o.iconPath),tooltip:o.tooltip,handle:o===D.QuickInputButtons.Back?-1:p}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const o=this._handlesToButtons.get(r);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(r){if(!this._disposed){for(const o of Object.keys(r)){const p=r[o];this._pendingUpdate[o]=p===void 0?null:p}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function d(s){if(s instanceof D.ThemeIcon)return{id:s.id};const r=c(s),o=l(s);return{dark:typeof r=="string"?k.URI.file(r):r,light:typeof o=="string"?k.URI.file(o):o}}function l(s){return typeof s=="object"&&"light"in s?s.light:s}function c(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends E{constructor(r,o,p){super(r,p);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((o,p)=>{this._handlesToItems.set(p,o),this._itemsToHandles.set(o,p)}),this.update({items:r.map((o,p)=>({label:o.label,description:o.description,handle:p,detail:o.detail,picked:o.picked,alwaysShow:o.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(r){const o=(0,i.coalesce)(r.map(p=>this._handlesToItems.get(p)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(r){const o=(0,i.coalesce)(r.map(p=>this._handlesToItems.get(p)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}}class n extends E{constructor(r,o){super(r,o);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?I.default.Error:I.default.Ignore})}}return new w(a,h)}e.createExtHostQuickOpen=m}),define(me[244],ge([0,1,2,3,55,6,14,5,16,101,12,27,41]),function(K,e,b,T,C,A,y,k,D,P,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(r){if(r)return typeof r.iconPath=="string"?b.URI.file(r.iconPath):r.iconPath}function a(r,o){if(!r.iconPath&&!o.iconPath)return 0;if(r.iconPath){if(!o.iconPath)return 1}else return-1;const p=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,f=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath;return(0,P.comparePaths)(p,f)}function h(r,o){let p=0;if(r.strikeThrough!==o.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==o.faded)return r.faded?1:-1;if(r.tooltip!==o.tooltip)return(r.tooltip||"").localeCompare(o.tooltip||"");if(p=a(r,o),p!==0)return p;if(r.light&&o.light)p=a(r.light,o.light);else{if(r.light)return 1;if(o.light)return-1}if(p!==0)return p;if(r.dark&&o.dark)p=a(r.dark,o.dark);else{if(r.dark)return 1;if(o.dark)return-1}return p}function S(r,o){if(r.command!==o.command)return r.command<o.command?-1:1;if(r.title!==o.title)return r.title<o.title?-1:1;if(r.tooltip!==o.tooltip){if(r.tooltip!==void 0&&o.tooltip!==void 0)return r.tooltip<o.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(r.arguments===o.arguments)return 0;if(r.arguments)if(o.arguments){if(r.arguments.length!==o.arguments.length)return r.arguments.length-o.arguments.length}else return 1;else return-1;for(let p=0;p<r.arguments.length;p++){const f=r.arguments[p],_=o.arguments[p];if(f!==_)return f<_?-1:1}return 0}function w(r,o){let p=(0,P.comparePaths)(r.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(p!==0)return p;if(r.command&&o.command)p=S(r.command,o.command);else{if(r.command)return 1;if(o.command)return-1}if(p!==0)return p;if(r.decorations&&o.decorations)p=h(r.decorations,o.decorations);else{if(r.decorations)return 1;if(o.decorations)return-1}return p}function E(r,o){for(let p=0;p<r.length;p++)if(r[p]!==o[p])return!1;return!0}function d(r,o){return r.command===o.command&&r.title===o.title&&r.tooltip===o.tooltip&&(r.arguments&&o.arguments?E(r.arguments,o.arguments):r.arguments===o.arguments)}function l(r,o){return(0,D.equals)(r,o,d)}class c{constructor(o,p,f){this._extension=o,this._proxy=p,this._sourceControlHandle=f,this._value="",this._onDidChange=new T.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return(0,m.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(o){if((0,m.checkProposedApiEnabled)(this._extension),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}focus(){(0,m.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(o,p){(0,m.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,o,p)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=c;class t{constructor(o,p,f,_,u){this._proxy=o,this._commands=p,this._sourceControlHandle=f,this._id=_,this._label=u,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new T.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new T.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,p){const f=this._resourceStatesCommandsMap.get(o);return f?(0,y.asPromise)(()=>this._commands.executeCommand(f.command,...f.arguments||[],p)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var o;const p=[...this._resourceStates].sort(w),_=(0,D.sortedDiff)(this._resourceSnapshot,p,w).map(R=>{const O=R.toInsert.map(H=>{const ne=this._resourceHandlePool++;this._resourceStatesMap.set(ne,H);const ie=H.resourceUri,U=g(H.decorations),B=H.decorations&&g(H.decorations.light)||U,x=H.decorations&&g(H.decorations.dark)||U,L=[];let N;if(H.command)if(H.command.command==="vscode.open"||H.command.command==="vscode.diff"){const le=new A.DisposableStore;N=this._commands.converter.toInternal(H.command,le),this._resourceStatesDisposablesMap.set(ne,le)}else this._resourceStatesCommandsMap.set(ne,H.command);B&&L.push(B),x&&x.toString()!==(B==null?void 0:B.toString())&&L.push(x);const F=H.decorations&&H.decorations.tooltip||"",M=H.decorations&&!!H.decorations.strikeThrough,$=H.decorations&&!!H.decorations.faded,q=H.contextValue||"";return{rawResource:[ne,ie,L,F,M,$,q,N],handle:ne}});return{start:R.start,deleteCount:R.deleteCount,toInsert:O}}),u=_.map(({start:R,deleteCount:O,toInsert:H})=>[R,O,H.map(ne=>ne.rawResource)]),v=_.reverse();for(const{start:R,deleteCount:O,toInsert:H}of v){const ne=H.map(U=>U.handle),ie=this._handlesSnapshot.splice(R,O,...ne);for(const U of ie)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),(o=this._resourceStatesDisposablesMap.get(U))===null||o===void 0||o.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=p,u}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(o,p,f,_,u,v){this._proxy=p,this._commands=f,this._id=_,this._label=u,this._rootUri=v,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new T.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new c(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,_,u,v)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=o;const p=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:p})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(!(this._statusBarCommands&&o&&l(this._statusBarCommands,o))){this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=o;const p=(o||[]).map(f=>this._commands.converter.toInternal(f,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:p})}}get selected(){return this._selected}createResourceGroup(o,p){const f=new t(this._proxy,this._commands,this.handle,o,p),_=T.Event.once(f.onDidDispose)(()=>this.createdResourceGroups.delete(f));return this.createdResourceGroups.set(f,_),this.eventuallyAddResourceGroups(),f}eventuallyAddResourceGroups(){const o=[],p=[];for(const[f,_]of this.createdResourceGroups){_.dispose();const u=f.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(f),this.eventuallyUpdateResourceStates()});T.Event.once(f.onDidDispose)(()=>{this.updatedResourceGroups.delete(f),u.dispose(),this._groups.delete(f.handle),this._proxy.$unregisterGroup(this.handle,f.handle)}),o.push([f.handle,f.id,f.label,f.features]);const v=f._takeResourceStateSnapshot();v.length>0&&p.push([f.handle,v]),this._groups.set(f.handle,f)}this._proxy.$registerGroups(this.handle,o,p),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(p=>{const f=p._takeResourceStateSnapshot();f.length!==0&&o.push([p.handle,f])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,qe([(0,C.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),qe([(0,C.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let s=class Un{constructor(o,p,f){this._commands=p,this.logService=f,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new T.Emitter,this._proxy=o.getProxy(k.MainContext.MainThreadSCM),this._telemetry=o.getProxy(k.MainContext.MainThreadTelemetry),p.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===3){const u=this._sourceControls.get(_.sourceControlHandle);if(!u)return _;const v=u.getResourceGroup(_.groupHandle);return v?v.getResourceState(_.handle):_}else if(_&&_.$mid===4){const u=this._sourceControls.get(_.sourceControlHandle);return u?u.getResourceGroup(_.groupHandle):_}else if(_&&_.$mid===5){const u=this._sourceControls.get(_.handle);return u||_}return _}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,p,f,_){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,p,f,_),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const u=Un._handlePool++,v=new n(o,this._proxy,this._commands,p,f,_);this._sourceControls.set(u,v);const R=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(o.identifier))||[];return R.push(v),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(o.identifier),R),v}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const p=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(o.identifier)),f=p&&p[p.length-1];return f&&f.inputBox}$provideOriginalResource(o,p,f){const _=b.URI.revive(p);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,_.toString());const u=this._sourceControls.get(o);return!u||!u.quickDiffProvider||!u.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>u.quickDiffProvider.provideOriginalResource(_,f)).then(v=>v||null)}$onInputBoxValueChange(o,p){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const f=this._sourceControls.get(o);return f&&f.inputBox.$onInputBoxValueChange(p),Promise.resolve(void 0)}$executeResourceCommand(o,p,f,_){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,p,f);const u=this._sourceControls.get(o);if(!u)return Promise.resolve(void 0);const v=u.getResourceGroup(p);return v?v.$executeResourceCommand(f,_):Promise.resolve(void 0)}$validateInput(o,p,f){this.logService.trace("ExtHostSCM#$validateInput",o);const _=this._sourceControls.get(o);return!_||!_.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>_.inputBox.validateInput(p,f)).then(u=>u?Promise.resolve([u.message,u.type]):Promise.resolve(void 0))}$setSelectedSourceControl(o){var p,f;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&((p=this._sourceControls.get(o))===null||p===void 0||p.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((f=this._sourceControls.get(this._selectedSourceControlHandle))===null||f===void 0||f.setSelectionState(!1)),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};s._handlePool=0,s=qe([He(2,i.ILogService)],s),e.ExtHostSCM=s});var it=this&&this.__classPrivateFieldSet||function(K,e,b,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(K,b):C?C.value=b:e.set(K,b),b},We=this&&this.__classPrivateFieldGet||function(K,e,b,T){if(b==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?T:b==="a"?T.call(K):T?T.value:e.get(K)};define(me[245],ge([0,1,7,5,165,6]),function(K,e,b,T,C,A){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(m,g,a,h,S=b.StatusBarAlignment.Left,w,E){y.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,it(this,y,m,"f"),it(this,k,g,"f"),this._id=D.ID_GEN++,this._statusId=a,this._statusName=h,this._alignment=S,this._priority=w,this._accessibilityInformation=E}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var m;return(m=this._command)===null||m===void 0?void 0:m.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(m){this._text=m,this.update()}set tooltip(m){this._tooltip=m,this.update()}set color(m){this._color=m,this.update()}set backgroundColor(m){m&&!D.ALLOWED_BACKGROUND_COLORS.has(m.id)&&(m=void 0),this._backgroundColor=m,this.update()}set command(m){var g;((g=this._command)===null||g===void 0?void 0:g.fromApi)!==m&&(this._internalCommandRegistration.clear(),typeof m=="string"?this._command={fromApi:m,internal:We(this,k,"f").toInternal({title:"",command:m},this._internalCommandRegistration)}:m?this._command={fromApi:m,internal:We(this,k,"f").toInternal(m,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(m){this._accessibilityInformation=m,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,We(this,y,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var m;this._timeoutHandle=void 0;let g=this._color;this._backgroundColor&&(g=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),We(this,y,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(m=this._command)===null||m===void 0?void 0:m.internal,g,this._backgroundColor,this._alignment===b.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,y=new WeakMap,k=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new b.ThemeColor("statusBarItem.errorForeground")]]);class P{constructor(m){this._messages=[],this._item=m.createStatusBarEntry("status.extensionMessage",(0,C.localize)(0,null),b.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(m){const g={message:m};return this._messages.unshift(g),this._update(),new b.Disposable(()=>{const a=this._messages.indexOf(g);a>=0&&(this._messages.splice(a,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(m,g){this._proxy=m.getProxy(T.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new P(this)}createStatusBarEntry(m,g,a,h,S){return new D(this._proxy,this._commands,m,g,a,h,S)}setStatusBarMessage(m,g){const a=this._statusMessage.setMessage(m);let h;return typeof g=="number"?h=setTimeout(()=>a.dispose(),g):typeof g!="undefined"&&g.then(()=>a.dispose(),()=>a.dispose()),new b.Disposable(()=>{a.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=i}),define(me[93],ge([0,1,5,3,4]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(k){this._onDidChangeStorage=new T.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(b.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,D){this._proxy.$registerExtensionStorageKeysToSync(k,D)}getValue(k,D,P){return this._proxy.$getValue(k,D).then(i=>i||P)}setValue(k,D,P){return this._proxy.$setValue(k,D,P)}$acceptValue(k,D,P){this._onDidChangeStorage.fire({shared:k,key:D,value:P})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(me[94],ge([0,1,4,28,12,92,2]),function(K,e,b,T,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,b.createDecorator)("IExtensionStoragePaths");let k=class{constructor(P,i,I){var m;this._logService=i,this._extHostFileSystem=I,this._workspace=(m=P.workspace)!==null&&m!==void 0?m:void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getOrCreateWorkspaceStoragePath(){var P;if(!this._workspace)return Promise.resolve(void 0);const i=this._workspace.id,I=y.URI.joinPath(this._environment.workspaceStorageHome,i);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch(m){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(P=y.URI.revive(this._workspace.configuration))===null||P===void 0?void 0:P.toString(),name:this._workspace.name},void 0,2))),I}catch(m){this._logService.error("[ExtHostStorage]",m);return}}workspaceValue(P){if(this._value)return y.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return y.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}};k=qe([He(0,T.IExtHostInitDataService),He(1,C.ILogService),He(2,A.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(me[34],ge([0,1,3,5,4,2,15,6,7,166,17,209,21,30,192]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class h{constructor(t,n,s,r){this._proxy=t,this._id=n,this._creationOptions=s,this._name=r,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(p=>this._pidPromiseComplete=p);const o=this;this.value={get name(){return o._name||""},get processId(){return o._pidPromise},get creationOptions(){return o._creationOptions},get exitStatus(){return o._exitStatus},sendText(p,f=!0){o._checkDisposed(),o._proxy.$sendText(o._id,p,f)},show(p){o._checkDisposed(),o._proxy.$show(o._id,p)},hide(){o._checkDisposed(),o._proxy.$hide(o._id)},dispose(){o._disposed||(o._disposed=!0,o._proxy.$dispose(o._id))},get dimensions(){if(!(o._cols===void 0||o._rows===void 0))return{columns:o._cols,rows:o._rows}}}}async create(t,n,s,r,o,p,f,_,u,v,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:s,env:r,icon:o,initialText:p,waitOnExit:f,strictEnv:_,hideFromUser:u,isFeatureTerminal:v,isExtensionOwnedTerminal:R})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=h;class S{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new b.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new b.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new b.Emitter,this._onProcessTitleChanged=new b.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new b.Emitter,this._onProcessShellTypeChanged=new b.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=S;let w=1,E=class extends k.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new b.Emitter,this._onDidOpenTerminal=new b.Emitter,this._onDidChangeActiveTerminal=new b.Emitter,this._onDidChangeTerminalDimensions=new b.Emitter,this._proxy=n.getProxy(T.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new b.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[s,r]of this._terminalProcesses)r.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const n=new h(this._proxy,(0,g.generateUuid)(),t,t.name),s=new S(t.pty);return n.createExtensionTerminal().then(r=>{const o=this._setupExtHostProcessListeners(r,s);this._terminalProcessDisposables[r]=o}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const r=new S(n),o=this._setupExtHostProcessListeners(t,r);this._terminalProcessDisposables[t]=o}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const s=this._getTerminalById(t);s&&(this._activeTerminal=s,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const s=this._getTerminalById(t);s&&this._onDidWriteTerminalData.fire({terminal:s.value,data:n})}async $acceptTerminalDimensions(t,n,s){const r=this._getTerminalById(t);r&&r.setDimensions(n,s)&&this._onDidChangeTerminalDimensions.fire({terminal:r.value,dimensions:r.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,s){var r;(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,s)}async $acceptTerminalTitleChange(t,n){const s=this._getTerminalById(t);s&&(s.name=n)}async $acceptTerminalClosed(t,n){const s=this._getTerminalObjectIndexById(this._terminals,t);if(s!==null){const r=this._terminals.splice(s,1)[0];r.setExitCode(n),this._onDidCloseTerminal.fire(r.value)}}$acceptTerminalOpened(t,n,s,r){if(n){const f=this._getTerminalObjectIndexById(this._terminals,n);if(f!==null){this._terminals[f]._id=t,this._onDidOpenTerminal.fire(this.terminals[f]),this._terminals[f].isOpen=!0;return}}const o={name:r.name,shellPath:r.executable,shellArgs:r.args,cwd:typeof r.cwd=="string"?r.cwd:A.URI.revive(r.cwd),env:r.env,hideFromUser:r.hideFromUser},p=new h(this._proxy,t,o,s);this._terminals.push(p),this._onDidOpenTerminal.fire(p.value),p.isOpen=!0}async $acceptTerminalProcessId(t,n){const s=this._getTerminalById(t);s&&s._setProcessId(n)}async $startExtensionTerminal(t,n){const s=this._getTerminalById(t);if(!s)return{message:(0,P.localize)(0,null,t)};s.isOpen||await new Promise(o=>{const p=this.onDidOpenTerminal(async f=>{f===s.value&&(p.dispose(),o())})});const r=this._terminalProcesses.get(t);r?r.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const s=new k.DisposableStore;s.add(n.onProcessReady(o=>this._proxy.$sendProcessReady(t,o.pid,o.cwd))),s.add(n.onProcessTitleChanged(o=>this._proxy.$sendProcessTitle(t,o))),this._bufferer.startBuffering(t,n.onProcessData),s.add(n.onProcessExit(o=>this._onProcessExit(t,o))),n.onProcessOverrideDimensions&&s.add(n.onProcessOverrideDimensions(o=>this._proxy.$sendOverrideDimensions(t,o))),this._terminalProcesses.set(t,n);const r=this._extensionTerminalAwaitingStart[t];return r&&n instanceof S&&(n.startSendingEvents(r.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),s}$acceptProcessAckDataEvent(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.input(n)}$acceptProcessResize(t,n,s){var r;try{(r=this._terminalProcesses.get(t))===null||r===void 0||r.resize(n,s)}catch(o){if(o.code!=="EPIPE"&&o.code!=="ERR_IPC_CHANNEL_CLOSED")throw o}}$acceptProcessShutdown(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(s=>this._proxy.$sendProcessInitialCwd(t,s))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(s=>this._proxy.$sendProcessCwd(t,s))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const s=this._getTerminalById(t);if(!s)return[];this._terminalLinkCache.delete(t);const r=this._terminalLinkCancellationSource.get(t);r&&r.dispose(!0);const o=new m.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,o);const p=[],f={terminal:s.value,line:n},_=[];for(const R of this._linkProviders)_.push(new Promise(async O=>{o.token.onCancellationRequested(()=>O({provider:R,links:[]}));const H=await R.provideTerminalLinks(f,o.token)||[];o.token.isCancellationRequested||O({provider:R,links:H})}));const u=await Promise.all(_);if(o.token.isCancellationRequested)return[];const v=new Map;for(const R of u)R&&R.links.length>0&&p.push(...R.links.map(O=>{const H={id:w++,startIndex:O.startIndex,length:O.length,label:O.tooltip};return v.set(H.id,{provider:R.provider,link:O}),H}));return this._terminalLinkCache.set(t,v),p}$activateLink(t,n){var s;const r=(s=this._terminalLinkCache.get(t))===null||s===void 0?void 0:s.get(n);!r||r.provider.handleTerminalLink(r.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const s=this._terminalProcessDisposables[t];s&&(s.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const s=this._getTerminalObjectIndexById(t,n);return s!==null?t[s]:null}_getTerminalObjectIndexById(t,n){let s=null;return t.some((r,o)=>r._id===n?(s=o,!0):!1),s}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new d,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const s=(0,I.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,s.length===0?void 0:s)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const s=n[0],r=new d(n[1]);this._setEnvironmentVariableCollection(s,r)})}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};E=qe([He(1,y.IExtHostRpcService)],E),e.BaseExtHostTerminalService=E;class d{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new b.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const s=this.map.get(t);(!s||s.value!==n.value||s.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((s,r)=>t.call(n,r,s,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=d;let l=class extends E{constructor(t){super(!1,t)}createTerminal(t,n,s){throw new i.NotSupportedError}createTerminalFromOptions(t){throw new i.NotSupportedError}getDefaultShell(t,n){throw new i.NotSupportedError}getDefaultShellArgs(t,n){throw new i.NotSupportedError}async getDefaultShellAndArgs(t){throw new i.NotSupportedError}$getAvailableProfiles(t){throw new i.NotSupportedError}};l=qe([He(0,y.IExtHostRpcService)],l),e.WorkerExtHostTerminalService=l}),define(me[246],ge([0,1,3,16,5,126,20,7]),function(K,e,b,T,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(i,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new b.Emitter,this._onDidChangeTextEditorOptions=new b.Emitter,this._onDidChangeTextEditorVisibleRanges=new b.Emitter,this._onDidChangeTextEditorViewColumn=new b.Emitter,this._onDidChangeActiveTextEditor=new b.Emitter,this._onDidChangeVisibleTextEditors=new b.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(m=>this._onDidChangeVisibleTextEditors.fire(m)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(m=>this._onDidChangeActiveTextEditor.fire(m))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const I=this._extHostDocumentsAndEditors.allEditors();return i?I:I.map(m=>m.value)}async showTextDocument(i,I,m){let g;typeof I=="number"?g={position:y.ViewColumn.from(I),preserveFocus:m}:typeof I=="object"?g={position:y.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?y.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:g={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(i.uri,g),h=a&&this._extHostDocumentsAndEditors.getEditor(a);if(h)return h.value;throw a?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i){return new A.TextEditorDecorationType(this._proxy,i).value}$acceptEditorPropertiesChanged(i,I){const m=this._extHostDocumentsAndEditors.getEditor(i);if(!m)throw new Error("unknown text editor");if(I.options&&m._acceptOptions(I.options),I.selections){const g=I.selections.selections.map(y.Selection.to);m._acceptSelections(g)}if(I.visibleRanges){const g=T.coalesce(I.visibleRanges.map(y.Range.to));m._acceptVisibleRanges(g)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:m.value,options:Object.assign(Object.assign({},I.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(I.options.lineNumbers)})}),I.selections){const g=k.TextEditorSelectionChangeKind.fromValue(I.selections.source),a=I.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:m.value,selections:a,kind:g})}if(I.visibleRanges){const g=T.coalesce(I.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:m.value,visibleRanges:g})}}$acceptEditorPositionData(i){for(const I in i){const m=this._extHostDocumentsAndEditors.getEditor(I);if(!m)throw new Error("Unknown text editor");const g=y.ViewColumn.to(i[I]);m.value.viewColumn!==g&&(m._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:m.value,viewColumn:g}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=D});var Yt=this&&this.__rest||function(K,e){var b={};for(var T in K)Object.prototype.hasOwnProperty.call(K,T)&&e.indexOf(T)<0&&(b[T]=K[T]);if(K!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,T=Object.getOwnPropertySymbols(K);C<T.length;C++)e.indexOf(T[C])<0&&Object.prototype.propertyIsEnumerable.call(K,T[C])&&(b[T[C]]=K[T[C]]);return b};define(me[247],ge([0,1,2,4,5,6,7]),function(K,e,b,T,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,T.createDecorator)("IExtHostTimeline");class k{constructor(i,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(C.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:m=>{var g,a;if(m&&m.$mid===11){const h=m.uri===void 0?void 0:b.URI.revive(m.uri);return(a=(g=this._itemsBySourceAndUriMap.get(m.source))===null||g===void 0?void 0:g.get(D(h)))===null||a===void 0?void 0:a.get(m.handle)}return m}})}async $getTimeline(i,I,m,g,a){const h=this._providers.get(i);return h==null?void 0:h.provideTimeline(b.URI.revive(I),m,g,a)}registerTimelineProvider(i,I,m,g){const a=new A.DisposableStore,h=this.convertTimelineItem(I.id,g,a).bind(this);let S;I.onDidChange&&(S=I.onDidChange(E=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},E),{id:I.id})),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},I),{scheme:i,onDidChange:void 0,async provideTimeline(E,d,l,c){var t;(c==null?void 0:c.resetCache)&&(a.clear(),(t=w.get(I.id))===null||t===void 0||t.clear());const n=await I.provideTimeline(E,d,l);if(n!=null){const s=h(E,c);return Object.assign(Object.assign({},n),{source:I.id,items:n.items.map(s)})}},dispose(){var E;for(const d of w.values())(E=d.get(I.id))===null||E===void 0||E.clear();S==null||S.dispose(),a.dispose()}}))}convertTimelineItem(i,I,m){return(g,a)=>{let h;if(a==null?void 0:a.cacheResults){let S=this._itemsBySourceAndUriMap.get(i);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(i,S));const w=D(g);h=S.get(w),h===void 0&&(h=new Map,S.set(w,h))}return S=>{var w,E;const{iconPath:d}=S,l=Yt(S,["iconPath"]),c=`${i}|${(w=S.id)!==null&&w!==void 0?w:S.timestamp}`;h==null||h.set(c,S);let t,n,s;return S.iconPath&&(d instanceof y.ThemeIcon?s={id:d.id}:b.URI.isUri(d)?(t=d,n=d):{light:t,dark:n}=d),Object.assign(Object.assign({},l),{id:(E=l.id)!==null&&E!==void 0?E:void 0,handle:c,source:i,command:S.command?I.toInternal(S.command,m):void 0,icon:t,iconDark:n,themeIcon:s,accessibilityInformation:S.accessibilityInformation})}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,A.toDisposable)(()=>{var m;for(const g of this._itemsBySourceAndUriMap.values())(m=g.get(i.id))===null||m===void 0||m.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=k;function D(P){return P==null?void 0:P.toString()}}),define(me[248],ge([0,1,6,13,2,5]),function(K,e,b,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(D){this._openers=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,P,i,I){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const m=I.schemes.find(g=>!y.supportedSchemes.has(g));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,i),this._proxy.$registerUriOpener(P,I.schemes,D,I.label),(0,b.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(D,P,i){const I=this._openers.get(D);if(!I)throw new Error(`Unknown opener with id: ${D}`);const m=C.URI.revive(P);return I.canOpenExternalUri(m,i)}async $openUri(D,P,i){const I=this._openers.get(D);if(!I)throw new Error(`Unknown opener id: '${D}'`);return I.openExternalUri(C.URI.revive(P.resolvedUri),{sourceUri:C.URI.revive(P.sourceUri)},i)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([T.Schemas.http,T.Schemas.https])}),define(me[249],ge([0,1,5,2,6,17,27]),function(K,e,b,T,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(b.MainContext.MainThreadUrls)}registerUriHandler(P,i){if(this.handles.has(y.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const I=k.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(P)),this.handlers.set(I,i),this._proxy.$registerUriHandler(I,P),(0,C.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(P)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(P,i){const I=this.handlers.get(P);if(!I)return Promise.resolve(void 0);try{I.handleUri(T.URI.revive(i))}catch(m){(0,A.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(P){return T.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=k,k.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(K,e,b,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(K,b):C?C.value=b:e.set(K,b),b},We=this&&this.__classPrivateFieldGet||function(K,e,b,T){if(b==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?T:b==="a"?T.call(K):T?T.value:e.get(K)};define(me[67],ge([0,1,3,2,177,201,89,5]),function(K,e,b,T,C,A,y,k){"use strict";var D,P,i,I,m,g,a,h,S,w,E,d;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class l{constructor(f,_,u,v,R,O,H){D.set(this,void 0),P.set(this,void 0),i.set(this,void 0),I.set(this,void 0),m.set(this,void 0),g.set(this,void 0),a.set(this,""),h.set(this,void 0),S.set(this,!1),w.set(this,!1),E.set(this,!1),this._onMessageEmitter=new b.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,d.set(this,new b.Emitter),this._onDidDispose=We(this,d,"f").event,it(this,D,f,"f"),it(this,P,_,"f"),it(this,h,u,"f"),it(this,I,v,"f"),it(this,m,R,"f"),it(this,g,O,"f"),it(this,E,c(O),"f"),it(this,i,H,"f")}dispose(){it(this,S,!0,"f"),We(this,d,"f").fire(),We(this,d,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return it(this,w,!0,"f"),(0,y.asWebviewUri)(We(this,I,"f"),We(this,D,"f"),f)}get cspSource(){return We(this,I,"f").webviewCspSource.replace("{{uuid}}",We(this,D,"f"))}get html(){return this.assertNotDisposed(),We(this,a,"f")}set html(f){this.assertNotDisposed(),We(this,a,"f")!==f&&(it(this,a,f,"f"),!We(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(it(this,w,!0,"f"),We(this,i,"f").report("Webview vscode-resource: uris",We(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),We(this,P,"f").$setHtml(We(this,D,"f"),f))}get options(){return this.assertNotDisposed(),We(this,h,"f")}set options(f){this.assertNotDisposed(),We(this,P,"f").$setOptions(We(this,D,"f"),s(We(this,g,"f"),We(this,m,"f"),f)),it(this,h,f,"f")}async postMessage(f){if(We(this,S,"f"))return!1;const _=(0,A.serializeWebviewMessage)(f,{serializeBuffersForPostMessage:We(this,E,"f")});return We(this,P,"f").$postMessage(We(this,D,"f"),_.message,..._.buffers)}assertNotDisposed(){if(We(this,S,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=l,D=new WeakMap,P=new WeakMap,i=new WeakMap,I=new WeakMap,m=new WeakMap,g=new WeakMap,a=new WeakMap,h=new WeakMap,S=new WeakMap,w=new WeakMap,E=new WeakMap,d=new WeakMap;function c(p){try{const f=(0,C.normalizeVersion)((0,C.parseVersion)(p.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch(f){return!1}}e.shouldSerializeBuffersForPostMessage=c;class t{constructor(f,_,u,v,R){this.initData=_,this.workspace=u,this._logService=v,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=f.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(f,_,...u){const v=this.getWebview(f);if(v){const{message:R}=(0,A.deserializeWebviewMessage)(_,u);v._onMessageEmitter.fire(R)}}$onMissingCsp(f,_){this._logService.warn(`${_} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,_,u){const v=new l(f,this._webviewProxy,r(_),this.initData,this.workspace,u,this._deprecationService);return this._webviews.set(f,v),v._onDidDispose(()=>{this._webviews.delete(f)}),v}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=t;function n(p){return{id:p.identifier,location:p.extensionLocation}}e.toExtensionData=n;function s(p,f,_){return{enableCommandUris:_.enableCommandUris,enableScripts:_.enableScripts,portMapping:_.portMapping,localResourceRoots:_.localResourceRoots||o(p,f)}}e.serializeWebviewOptions=s;function r(p){var f;return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,portMapping:p.portMapping,localResourceRoots:(f=p.localResourceRoots)===null||f===void 0?void 0:f.map(_=>T.URI.from(_))}}e.reviveOptions=r;function o(p,f){return[...((f==null?void 0:f.getWorkspaceFolders())||[]).map(_=>_.uri),p.extensionLocation]}}),define(me[250],ge([0,1,21,75,6,13,25,2,20,67,87,5,7]),function(K,e,b,T,C,A,y,k,D,P,i,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=l(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class a{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,s){const r=this.key(t,n.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const o=new g(n,s);return this._documents.set(r,o),o}delete(t,n){const s=this.key(t,n.uri);this._documents.delete(s)}key(t,n){return`${t}@@@${n}`}}var h;(function(c){c[c.Text=0]="Text",c[c.Custom=1]="Custom"})(h||(h={}));class S{constructor(){this._providers=new Map}addTextProvider(t,n,s){return this.add(0,t,n,s)}addCustomProvider(t,n,s){return this.add(1,t,n,s)}get(t){return this._providers.get(t)}add(t,n,s,r){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:s,provider:r}),new m.Disposable(()=>this._providers.delete(n))}}class w{constructor(t,n,s,r,o){this._extHostDocuments=n,this._extensionStoragePaths=s,this._extHostWebview=r,this._extHostWebviewPanels=o,this._editorProviders=new S,this._documents=new a,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,s,r){const o=new C.DisposableStore;return E(s)?(o.add(this._editorProviders.addTextProvider(n,t,s)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(t),n,r.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(t))):(o.add(this._editorProviders.addCustomProvider(n,t,s)),this.supportEditing(s)&&o.add(s.onDidChangeCustomDocument(p=>{const f=this.getCustomDocumentEntry(n,p.document.uri);if(d(p)){const _=f.addEdit(p);this._proxy.$onDidEdit(p.document.uri,n,_,p.label)}else this._proxy.$onContentChange(p.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(t),n,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(t))),m.Disposable.from(o,new m.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,s,r,o){var p;const f=this._editorProviders.get(n);if(!f)throw new Error(`No provider found for '${n}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${n}'`);const _=k.URI.revive(t),u=await f.provider.openCustomDocument(_,{backupId:s,untitledDocumentData:r==null?void 0:r.buffer},o);let v;return this.supportEditing(f.provider)&&this._extensionStoragePaths&&(v=(p=this._extensionStoragePaths.workspaceValue(f.extension))!==null&&p!==void 0?p:this._extensionStoragePaths.globalValue(f.extension)),this._documents.add(n,u,v),{editable:this.supportEditing(f.provider)}}async $disposeCustomDocument(t,n){const s=this._editorProviders.get(n);if(!s)throw new Error(`No provider found for '${n}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${n}'`);const r=k.URI.revive(t),{document:o}=this.getCustomDocumentEntry(n,r);this._documents.delete(n,o),o.dispose()}async $resolveWebviewEditor(t,n,s,r,o,p){const f=this._editorProviders.get(s);if(!f)throw new Error(`No provider found for '${s}'`);const _=D.ViewColumn.to(o),u=this._extHostWebview.createNewWebview(n,r.webviewOptions,f.extension),v=this._extHostWebviewPanels.createNewWebviewPanel(n,s,r.title,_,r.panelOptions,u),R=k.URI.revive(t);switch(f.type){case 1:{const{document:O}=this.getCustomDocumentEntry(s,R);return f.provider.resolveCustomEditor(O,v,p)}case 0:{const O=this._extHostDocuments.getDocument(R);return f.provider.resolveCustomTextEditor(O,v,p)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,s){this.getCustomDocumentEntry(n,t).disposeEdits(s)}async $onMoveCustomEditor(t,n,s){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const o=this._extHostWebviewPanels.getWebviewPanel(t);if(!o)throw new Error("No webview found");const p=k.URI.revive(n),f=this._extHostDocuments.getDocument(p);await r.provider.moveCustomTextEditor(f,o,b.CancellationToken.None)}async $undo(t,n,s,r){return this.getCustomDocumentEntry(n,t).undo(s,r)}async $redo(t,n,s,r){return this.getCustomDocumentEntry(n,t).redo(s,r)}async $revert(t,n,s){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(r.document,s),r.disposeBackup()}async $onSave(t,n,s){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(r.document,s),r.disposeBackup()}async $onSaveAs(t,n,s,r){const o=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(o.document,k.URI.revive(s),r)}async $backup(t,n,s){const r=this.getCustomDocumentEntry(n,t),p=await this.getCustomEditorProvider(n).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},s);return r.updateBackup(p),p.id}getCustomDocumentEntry(t,n){const s=this._documents.get(t,k.URI.revive(n));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const n=this._editorProviders.get(t),s=n==null?void 0:n.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function E(c){return typeof c.resolveCustomTextEditor=="function"}function d(c){return typeof c.undo=="function"&&typeof c.redo=="function"}function l(c){const t=c.scheme===A.Schemas.file||c.scheme===A.Schemas.untitled?c.fsPath:c.toString();return(0,T.hash)(t)+""}});var it=this&&this.__classPrivateFieldSet||function(K,e,b,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(K,b):C?C.value=b:e.set(K,b),b},We=this&&this.__classPrivateFieldGet||function(K,e,b,T){if(b==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?T:b==="a"?T.call(K):T?T.value:e.get(K)};define(me[251],ge([0,1,3,6,2,30,20,67,5,7]),function(K,e,b,T,C,A,y,k,D,P){"use strict";var i,I,m,g,a,h,S,w,E,d,l,c,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends T.Disposable{constructor(p,f,_,u,v,R,O){super();i.set(this,void 0),I.set(this,void 0),m.set(this,void 0),g.set(this,void 0),a.set(this,void 0),h.set(this,void 0),S.set(this,void 0),w.set(this,void 0),E.set(this,!0),d.set(this,!0),l.set(this,!1),c.set(this,this._register(new b.Emitter)),this.onDidDispose=We(this,c,"f").event,t.set(this,this._register(new b.Emitter)),this.onDidChangeViewState=We(this,t,"f").event,it(this,i,p,"f"),it(this,I,f,"f"),it(this,m,_,"f"),it(this,a,R,"f"),it(this,w,v,"f"),it(this,h,u,"f"),it(this,g,O,"f")}dispose(){We(this,l,"f")||(it(this,l,!0,"f"),We(this,c,"f").fire(),We(this,I,"f").$disposeWebview(We(this,i,"f")),We(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),We(this,g,"f")}get viewType(){return this.assertNotDisposed(),We(this,m,"f")}get title(){return this.assertNotDisposed(),We(this,h,"f")}set title(p){this.assertNotDisposed(),We(this,h,"f")!==p&&(it(this,h,p,"f"),We(this,I,"f").$setTitle(We(this,i,"f"),p))}get iconPath(){return this.assertNotDisposed(),We(this,S,"f")}set iconPath(p){this.assertNotDisposed(),We(this,S,"f")!==p&&(it(this,S,p,"f"),We(this,I,"f").$setIconPath(We(this,i,"f"),C.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return We(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof We(this,w,"f")=="number"&&We(this,w,"f")<0))return We(this,w,"f")}get active(){return this.assertNotDisposed(),We(this,d,"f")}get visible(){return this.assertNotDisposed(),We(this,E,"f")}_updateViewState(p){We(this,l,"f")||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(it(this,d,p.active,"f"),it(this,E,p.visible,"f"),it(this,w,p.viewColumn,"f"),We(this,t,"f").fire({webviewPanel:this}))}reveal(p,f){this.assertNotDisposed(),We(this,I,"f").$reveal(We(this,i,"f"),{viewColumn:p?y.ViewColumn.from(p):void 0,preserveFocus:!!f})}assertNotDisposed(){if(We(this,l,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,I=new WeakMap,m=new WeakMap,g=new WeakMap,a=new WeakMap,h=new WeakMap,S=new WeakMap,w=new WeakMap,E=new WeakMap,d=new WeakMap,l=new WeakMap,c=new WeakMap,t=new WeakMap;class s{constructor(p,f,_){this.webviews=f,this.workspace=_,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=p.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(p,f,_,u,v={}){const R=typeof u=="object"?u.viewColumn:u,O={viewColumn:y.ViewColumn.from(R),preserveFocus:typeof u=="object"&&!!u.preserveFocus},H=(0,k.shouldSerializeBuffersForPostMessage)(p),ne=s.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(p),ne,f,{title:_,panelOptions:r(v),webviewOptions:(0,k.serializeWebviewOptions)(p,this.workspace,v),serializeBuffersForPostMessage:H},O);const ie=this.webviews.createNewWebview(ne,v,p);return this.createNewWebviewPanel(ne,f,_,R,v,ie)}$onDidChangeWebviewPanelViewStates(p){const f=Object.keys(p);f.sort((_,u)=>{const v=p[_],R=p[u];return v.active?1:R.active?-1:+v.visible-+R.visible});for(const _ of f){const u=this.getWebviewPanel(_);if(!!u){const v=p[_];u._updateViewState({active:v.active,visible:v.visible,viewColumn:y.ViewColumn.to(v.position)})}}}async $onDidDisposeWebviewPanel(p){const f=this.getWebviewPanel(p);f==null||f.dispose(),this._webviewPanels.delete(p),this.webviews.deleteWebview(p)}registerWebviewPanelSerializer(p,f,_){if(this._serializers.has(f))throw new Error(`Serializer for '${f}' already registered`);return this._serializers.set(f,{serializer:_,extension:p}),this._proxy.$registerSerializer(f,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(p)}),new P.Disposable(()=>{this._serializers.delete(f),this._proxy.$unregisterSerializer(f)})}async $deserializeWebviewPanel(p,f,_,u){const v=this._serializers.get(f);if(!v)throw new Error(`No serializer found for '${f}'`);const{serializer:R,extension:O}=v,H=this.webviews.createNewWebview(p,_.webviewOptions,O),ne=this.createNewWebviewPanel(p,f,_.title,u,_.panelOptions,H);await R.deserializeWebviewPanel(ne,_.state)}createNewWebviewPanel(p,f,_,u,v,R){const O=new n(p,this._proxy,f,_,u,v,R);return this._webviewPanels.set(p,O),O}getWebviewPanel(p){return this._webviewPanels.get(p)}}e.ExtHostWebviewPanels=s;function r(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(K,e,b,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(K,b):C?C.value=b:e.set(K,b),b},We=this&&this.__classPrivateFieldGet||function(K,e,b,T){if(b==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?T:b==="a"?T.call(K):T?T.value:e.get(K)};define(me[252],ge([0,1,3,6,67,5,7]),function(K,e,b,T,C,A,y){"use strict";var k,D,P,i,I,m,g,a,h,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends T.Disposable{constructor(l,c,t,n,s,r){super();k.set(this,void 0),D.set(this,void 0),P.set(this,void 0),i.set(this,void 0),I.set(this,!1),m.set(this,void 0),g.set(this,void 0),a.set(this,void 0),h.set(this,this._register(new b.Emitter)),this.onDidChangeVisibility=We(this,h,"f").event,S.set(this,this._register(new b.Emitter)),this.onDidDispose=We(this,S,"f").event,it(this,P,t,"f"),it(this,g,n,"f"),it(this,k,l,"f"),it(this,D,c,"f"),it(this,i,s,"f"),it(this,m,r,"f")}dispose(){We(this,I,"f")||(it(this,I,!0,"f"),We(this,S,"f").fire(),We(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),We(this,g,"f")}set title(l){this.assertNotDisposed(),We(this,g,"f")!==l&&(it(this,g,l,"f"),We(this,D,"f").$setWebviewViewTitle(We(this,k,"f"),l))}get description(){return this.assertNotDisposed(),We(this,a,"f")}set description(l){this.assertNotDisposed(),We(this,a,"f")!==l&&(it(this,a,l,"f"),We(this,D,"f").$setWebviewViewDescription(We(this,k,"f"),l))}get visible(){return We(this,m,"f")}get webview(){return We(this,i,"f")}get viewType(){return We(this,P,"f")}_setVisible(l){l===We(this,m,"f")||We(this,I,"f")||(it(this,m,l,"f"),We(this,h,"f").fire())}show(l){this.assertNotDisposed(),We(this,D,"f").$show(We(this,k,"f"),!!l)}assertNotDisposed(){if(We(this,I,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,D=new WeakMap,P=new WeakMap,i=new WeakMap,I=new WeakMap,m=new WeakMap,g=new WeakMap,a=new WeakMap,h=new WeakMap,S=new WeakMap;class E{constructor(l,c){this._extHostWebview=c,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=l.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(l,c,t,n){if(this._viewProviders.has(c))throw new Error(`View provider for '${c}' already registered`);return this._viewProviders.set(c,{provider:t,extension:l}),this._proxy.$registerWebviewViewProvider((0,C.toExtensionData)(l),c,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(c),this._proxy.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(l,c,t,n,s){const r=this._viewProviders.get(c);if(!r)throw new Error(`No view provider found for '${c}'`);const{provider:o,extension:p}=r,f=this._extHostWebview.createNewWebview(l,{},p),_=new w(l,this._proxy,c,t,f,!0);this._webviewViews.set(l,_),await o.resolveWebviewView(_,{state:n},s)}async $onDidChangeWebviewViewVisibility(l,c){this.getWebviewView(l)._setVisible(c)}async $disposeWebviewView(l){const c=this.getWebviewView(l);this._webviewViews.delete(l),c.dispose(),this._extHostWebview.deleteWebview(l)}getWebviewView(l){const c=this._webviewViews.get(l);if(!c)throw new Error("No webview found");return c}}e.ExtHostWebviewViews=E}),define(me[129],ge([0,1,3,5,2,13,9,4,15]),function(K,e,b,T,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class xn{constructor(I){this._onDidChangeWindowState=new b.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=xn.InitialState,this._proxy=I.getProxy(T.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:I}),this._onDidChangeWindowState.fire(this._state))}openUri(I,m){let g;if(typeof I=="string"){g=I;try{I=C.URI.parse(I)}catch(a){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,y.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,g,m)}async asExternalUri(I,m){if((0,y.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([A.Schemas.http,A.Schemas.https]).has(I.scheme))return Promise.reject(`Invalid scheme '${I.scheme}'`);const g=await this._proxy.$asExternalUri(I,m);return C.URI.from(g)}};P.InitialState={focused:!0},P=qe([He(0,D.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(me[253],ge([0,1,8,49,30,52,6,5,2,15]),function(K,e,b,T,C,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends y.Disposable{constructor(m,g){super();const a=m.getProxy(k.MainContext.MainThreadDownloadService);g.registerCommand(!1,"_workbench.downloadResource",async h=>{const S=D.URI.file((0,b.join)((0,T.tmpdir)(),(0,C.generateUuid)()));return await a.$download(h,S),S})}};i=qe([He(0,P.IExtHostRpcService),He(1,A.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(me[254],ge([0,1,2,8,147,26,37,66,28,15,6,12,115,45]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class a{constructor(E,d,l){this.name=E,this.file=d,this.appender=l}static async create(E,d){const l=await(0,m.createRotatingLogger)(E,d,30*g.ByteSize.MB,1);return l.clearFormatters(),new a(E,d,l)}append(E){this.appender.critical(E)}flush(){this.appender.flush()}}class h extends k.AbstractExtHostOutputChannel{constructor(E,d,l){super(E,!1,b.URI.file(d.file),l);this._appender=d}append(E){super.append(E),this._appender.append(E),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(E,d){this._appender.flush(),super.show(E,d)}clear(){this._appender.flush(),super.clear()}}let S=class extends k.ExtHostOutputService{constructor(E,d,l){super(E);this.logService=d,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new i.MutableDisposable,this._logsLocation=l.logsLocation}$setVisibleChannel(E){if(E){const d=this._channels.get(E);d&&(this._visibleChannelDisposable.value=d.onDidAppend(()=>d.update()))}}createOutputChannel(E){if(E=E.trim(),!E)throw new Error("illegal argument `name`. must not be falsy");const d=this._doCreateOutChannel(E);return d.then(l=>l._id.then(c=>this._channels.set(c,l))),new k.LazyOutputChannel(E,d)}async _doCreateOutChannel(E){try{const d=(0,T.join)(this._logsLocation.fsPath,`output_logging_${(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await A.SymlinkSupport.existsDirectory(d)||await y.promises.mkdir(d,{recursive:!0});const c=`${this._namePool++}-${E.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=b.URI.file((0,T.join)(d,`${c}.log`)),n=await a.create(c,t.fsPath);return new h(E,n,this._proxy)}catch(d){return this.logService.error(d),new k.ExtHostPushOutputChannel(E,this._proxy)}}};S=qe([He(0,P.IExtHostRpcService),He(1,I.ILogService),He(2,D.IExtHostInitDataService)],S),e.ExtHostOutputService2=S}),define(me[255],ge([0,1,5,15,6,28,2,38,25,37,26,7,10,51,3,74,12]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class w{constructor(f,_,u){this.remoteAddress=f,this.localAddress=_,this._dispose=u,this._onDispose=new a.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function E(p){const f=p.trim().split(`
`),_=[];return f.forEach(v=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(v);R&&R.length>=3&&_.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),_.reduce((v,R)=>(v[R.socket]=R,v),{})}e.getSockets=E;function d(...p){const f=[].concat(...p.map(c));return[...new Map(f.filter(_=>_.st==="0A").map(_=>{const u=_.local_address.split(":");return{socket:parseInt(_.inode,10),ip:l(u[0]),port:parseInt(u[1],16)}}).map(_=>[_.ip+":"+_.port,_])).values()]}e.loadListeningPorts=d;function l(p){let f="";if(p.length===8)for(let _=p.length-2;_>=0;_-=2)f+=parseInt(p.substr(_,2),16),_!==0&&(f+=".");else for(let _=p.length-4;_>=0;_-=4)f+=parseInt(p.substr(_,4),16).toString(16),_!==0&&(f+=":");return f}e.parseIpAddress=l;function c(p){const f=p.trim().split(`
`),_=f.shift().trim().split(/\s+/).filter(v=>v!=="rx_queue"&&v!=="tm->when");return f.map(v=>v.trim().split(/\s+/).reduce((R,O,H)=>(R[_[H]||H]=O,R),{}))}e.loadConnectionTable=c;function t(p){return!!p.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||p.indexOf("out/vs/server/main.js")!==-1||p.indexOf("_productName=VSCode")!==-1}function n(p){const f=p.trim().split(`
`),_=[];return f.forEach(u=>{const v=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(u);v&&v.length>=4&&_.push({pid:parseInt(v[1],10),ppid:parseInt(v[2]),cmd:v[3]})}),_}e.getRootProcesses=n;async function s(p,f,_){const u=_.reduce((R,O)=>(R[O.pid]=O,R),{}),v=[];return p.forEach(({socket:R,ip:O,port:H})=>{var ne;const ie=f[R]?f[R].pid:void 0,U=ie?(ne=u[ie])===null||ne===void 0?void 0:ne.cmd:void 0;ie&&U&&!t(U)&&v.push({host:O,port:H,detail:U,pid:ie})}),v}e.findPorts=s;function r(p,f,_){const u=new Map,v=n(f);for(const R of p){const O=_.get(R.port);if(O){u.set(R.port,O);continue}const H=v.find(ne=>ne.cmd.includes(`${R.port}`));if(H){let ne=H,ie;do ie=v.find(U=>U.ppid===ne.pid),ie&&(ne=ie);while(ie);u.set(R.port,{host:R.ip,port:R.port,pid:ne.pid,detail:ne.cmd,ppid:ne.ppid})}else u.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return u}e.tryFindRootPorts=r;let o=class extends C.Disposable{constructor(f,_,u){super();this.logService=u,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new a.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=f.getProxy(b.MainContext.MainThreadTunnelService),m.isLinux&&_.remote.isRemote&&_.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(f,_){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${f.identifier.value} called openTunnel API for ${_.remoteAddress.host}:${_.remoteAddress.port}.`);const u=await this._proxy.$openTunnel(_,f.displayName);if(u){const v=new w(u.remoteAddress,u.localAddress,()=>this._proxy.$closeTunnel(u.remoteAddress));return this._register(v),v}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(f){return Math.max(f*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(f,_){const u=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(u,{selector:f,provider:_}),this._proxy.$registerPortsAttributesProvider(f,u),new I.Disposable(()=>{this._portAttributesProviders.delete(u),this._proxy.$unregisterPortsAttributesProvider(u)})}async $providePortAttributes(f,_,u,v,R){const O=[];for(const ne of f){const ie=this._portAttributesProviders.get(ne);if(!ie)return[];O.push(...await Promise.all(_.map(async U=>ie.provider.providePortAttributes(U,u,v,R))))}const H=O.filter(ne=>!!ne);return H.length>0?H.map(ne=>({autoForwardAction:ne.autoForwardAction,port:ne.port})):[]}async $registerCandidateFinder(f){if(!(f&&this._candidateFindingEnabled)){this._candidateFindingEnabled=f;let _=new h.MovingAverage,u;for(;this._candidateFindingEnabled;){const v=new Date().getTime(),R=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(H=>H.port).join(", ")}`);const O=new Date().getTime()-v;_.update(O),(!u||JSON.stringify(u)!==JSON.stringify(R))&&(u=R,await this._proxy.$onFoundNewCandidates(u)),await new Promise(H=>setTimeout(()=>H(),this.calculateDelay(_.value)))}}}async setTunnelExtensionFunctions(f){var _;return f?(f.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(f.candidatePortSource),f.showCandidatePort&&(this._showCandidatePort=f.showCandidatePort,this._proxy.$setCandidateFilter()),f.tunnelFactory&&(this._forwardPortProvider=f.tunnelFactory,this._proxy.$setTunnelProvider((_=f.tunnelFeatures)!==null&&_!==void 0?_:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(f,_){if(this._extensionTunnels.has(f.host)){const u=this._extensionTunnels.get(f.host);u.has(f.port)&&(_&&u.get(f.port).disposeListener.dispose(),await u.get(f.port).tunnel.dispose(),u.delete(f.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(f,_){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const u=this._forwardPortProvider(f,_);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),u!==void 0){const v=await u;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(f.remoteAddress.host)||this._extensionTunnels.set(f.remoteAddress.host,new Map);const R=this._register(v.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(v.remoteAddress))));return this._extensionTunnels.get(f.remoteAddress.host).set(f.remoteAddress.port,{tunnel:v,disposeListener:R}),g.TunnelDto.fromApiTunnel(v)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(u){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(f){const _=await Promise.all(f.map(v=>{var R;return this._showCandidatePort(v.host,v.port,(R=v.detail)!==null&&R!==void 0?R:"")})),u=f.filter((v,R)=>_[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${f.map(v=>v.port).join(", ")} to ${u.map(v=>v.port).join(", ")}`),u}async findCandidatePorts(){let f="",_="";try{f=await P.promises.readFile("/proc/net/tcp","utf8"),_=await P.promises.readFile("/proc/net/tcp6","utf8")}catch(x){}const u=d(f,_),v=await new Promise(x=>{(0,k.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(L,N,F)=>{x(N)})}),R=E(v),O=await i.readdir("/proc"),H=[];for(let x of O)try{const L=Number(x),N=D.joinPath(y.URI.file("/proc"),x);if((await P.promises.stat(N.fsPath)).isDirectory()&&!isNaN(L)){const M=await P.promises.readlink(D.joinPath(N,"cwd").fsPath),$=await P.promises.readFile(D.joinPath(N,"cmdline").fsPath,"utf8");H.push({pid:L,cwd:M,cmd:$})}}catch(L){}const ne=[],ie=u.filter(x=>{const L=R[x.socket];return L||ne.push(x),L}),U=s(ie,R,H);let B;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${ne.length}`),ne.length>0){const x=await new Promise(L=>{(0,k.exec)("ps -F -A -l | grep root",(N,F,M)=>{L(F)})});this._foundRootPorts=r(ne,x,this._foundRootPorts),B=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${B.join(", ")}`)}return U.then(x=>B?x.concat(B):x)}};o=qe([He(0,T.IExtHostRpcService),He(1,A.IExtHostInitDataService),He(2,S.ILogService)],o),e.ExtHostTunnelService=o}),define(me[256],ge([0,1,14,21,17,3,6,103,226,127,23]),function(K,e,b,T,C,A,y,k,D,P,i){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function m(r,o){try{return JSON.stringify(r,o)}catch(p){return"null"}}function g(r,o){return JSON.stringify(r,o)}function a(r){return r?(o,p)=>p&&p.$mid===1?r.transformOutgoing(p):p:null}var h;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},E=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class l extends y.Disposable{constructor(o,p=null,f=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=o,this._logger=p,this._uriTransformer=f,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let _=0,u=P.ProxyIdentifier.count;_<u;_++)this._locals[_]=null,this._proxies[_]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new b.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(_=>this._receiveOneMessage(_))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(o=>{this._pendingRPCReplies[o].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(o){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(o){this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(o){this._responsiveState!==o&&(this._responsiveState=o,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(o){return this._uriTransformer?(0,k.transformIncomingURIs)(o,this._uriTransformer):o}getProxy(o){const{nid:p,sid:f}=o;return this._proxies[p]||(this._proxies[p]=this._createProxy(p,f)),this._proxies[p]}_createProxy(o,p){let f={get:(_,u)=>(typeof u=="string"&&!_[u]&&u.charCodeAt(0)===36&&(_[u]=(...v)=>this._remoteCall(o,u,v)),u===d?p:_[u])};return new Proxy(Object.create(null),f)}set(o,p){return this._locals[o.nid]=p,p}assertRegistered(o){for(let p=0,f=o.length;p<f;p++){const _=o[p];if(!this._locals[_.nid])throw new Error(`Missing actor ${_.sid} (isMain: ${_.isMain})`)}}_receiveOneMessage(o){if(!this._isDisposed){const p=o.byteLength,f=c.read(o,0),_=f.readUInt8(),u=f.readUInt32();switch(_){case 1:case 2:{let{rpcId:v,method:R,args:O}=t.deserializeRequestJSONArgs(f);this._uriTransformer&&(O=(0,k.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(p,u,v,R,O,_===2);break}case 3:case 4:{let{rpcId:v,method:R,args:O}=t.deserializeRequestMixedArgs(f);this._uriTransformer&&(O=(0,k.transformIncomingURIs)(O,this._uriTransformer)),this._receiveRequest(p,u,v,R,O,_===4);break}case 5:{this._logger&&this._logger.logIncoming(p,u,0,"ack"),this._onDidReceiveAcknowledge(u);break}case 6:{this._receiveCancel(p,u);break}case 7:{this._receiveReply(p,u,void 0);break}case 9:{let v=t.deserializeReplyOKJSON(f);this._uriTransformer&&(v=(0,k.transformIncomingURIs)(v,this._uriTransformer)),this._receiveReply(p,u,v);break}case 8:{let v=t.deserializeReplyOKVSBuffer(f);this._receiveReply(p,u,v);break}case 10:{let v=t.deserializeReplyErrError(f);this._uriTransformer&&(v=(0,k.transformIncomingURIs)(v,this._uriTransformer)),this._receiveReplyErr(p,u,v);break}case 11:{this._receiveReplyErr(p,u,void 0);break}default:console.error("received unexpected message"),console.error(o)}}}_receiveRequest(o,p,f,_,u,v){this._logger&&this._logger.logIncoming(o,p,1,`receiveRequest ${(0,P.getStringIdentifierForProxy)(f)}.${_}(`,u);const R=String(p);let O,H;if(v){const ie=new T.CancellationTokenSource;u.push(ie.token),O=this._invokeHandler(f,_,u),H=()=>ie.cancel()}else O=this._invokeHandler(f,_,u),H=w;this._cancelInvokedHandlers[R]=H;const ne=t.serializeAcknowledged(p);this._logger&&this._logger.logOutgoing(ne.byteLength,p,1,"ack"),this._protocol.send(ne),O.then(ie=>{delete this._cancelInvokedHandlers[R];const U=t.serializeReplyOK(p,ie,this._uriReplacer);this._logger&&this._logger.logOutgoing(U.byteLength,p,1,"reply:",ie),this._protocol.send(U)},ie=>{delete this._cancelInvokedHandlers[R];const U=t.serializeReplyErr(p,ie);this._logger&&this._logger.logOutgoing(U.byteLength,p,1,"replyErr:",ie),this._protocol.send(U)})}_receiveCancel(o,p){this._logger&&this._logger.logIncoming(o,p,1,"receiveCancel");const f=String(p);this._cancelInvokedHandlers[f]&&this._cancelInvokedHandlers[f]()}_receiveReply(o,p,f){this._logger&&this._logger.logIncoming(o,p,0,"receiveReply:",f);const _=String(p);if(!!this._pendingRPCReplies.hasOwnProperty(_)){const u=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_],u.resolveOk(f)}}_receiveReplyErr(o,p,f){this._logger&&this._logger.logIncoming(o,p,0,"receiveReplyErr:",f);const _=String(p);if(!!this._pendingRPCReplies.hasOwnProperty(_)){const u=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_];let v;f&&(f.$isError?(v=new Error,v.name=f.name,v.message=f.message,v.stack=f.stack):v=f),u.resolveErr(v)}}_invokeHandler(o,p,f){try{return Promise.resolve(this._doInvokeHandler(o,p,f))}catch(_){return Promise.reject(_)}}_doInvokeHandler(o,p,f){const _=this._locals[o];if(!_)throw new Error("Unknown actor "+(0,P.getStringIdentifierForProxy)(o));let u=_[p];if(typeof u!="function")throw new Error("Unknown method "+p+" on actor "+(0,P.getStringIdentifierForProxy)(o));return u.apply(_,f)}_remoteCall(o,p,f){if(this._isDisposed)return Promise.reject(C.canceled());let _=null;if(f.length>0&&T.CancellationToken.isCancellationToken(f[f.length-1])&&(_=f.pop()),_&&_.isCancellationRequested)return Promise.reject(C.canceled());const u=t.serializeRequestArguments(f,this._uriReplacer),v=++this._lastMessageId,R=String(v),O=new D.LazyPromise;_&&_.onCancellationRequested(()=>{const ne=t.serializeCancel(v);this._logger&&this._logger.logOutgoing(ne.byteLength,v,0,"cancel"),this._protocol.send(t.serializeCancel(v))}),this._pendingRPCReplies[R]=O,this._onWillSendRequest(v);const H=t.serializeRequest(v,o,p,u,!!_);return this._logger&&this._logger.logOutgoing(H.byteLength,v,0,`request: ${(0,P.getStringIdentifierForProxy)(o)}.${p}(`,f),this._protocol.send(H),O}}e.RPCProtocol=l,I=E,l.UNRESPONSIVE_TIME=3*1e3;class c{constructor(o,p){this._buff=o,this._offset=p}static alloc(o,p,f){let _=new c(i.VSBuffer.alloc(f+1+4),0);return _.writeUInt8(o),_.writeUInt32(p),_}static read(o,p){return new c(o,p)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(o){this._buff.writeUInt8(o,this._offset),this._offset+=1}readUInt8(){const o=this._buff.readUInt8(this._offset);return this._offset+=1,o}writeUInt32(o){this._buff.writeUInt32BE(o,this._offset),this._offset+=4}readUInt32(){const o=this._buff.readUInt32BE(this._offset);return this._offset+=4,o}static sizeShortString(o){return 1+o.byteLength}writeShortString(o){this._buff.writeUInt8(o.byteLength,this._offset),this._offset+=1,this._buff.set(o,this._offset),this._offset+=o.byteLength}readShortString(){const o=this._buff.readUInt8(this._offset);this._offset+=1;const f=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,f}static sizeLongString(o){return 4+o.byteLength}writeLongString(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readLongString(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const f=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,f}writeBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}static sizeVSBuffer(o){return 4+o.byteLength}writeVSBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readVSBuffer(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+o);return this._offset+=o,p}static sizeMixedArray(o,p){let f=0;f+=1;for(let _=0,u=o.length;_<u;_++){const v=o[_],R=p[_];switch(f+=1,R){case 1:f+=this.sizeLongString(v);break;case 2:f+=this.sizeVSBuffer(v);break;case 3:break}}return f}writeMixedArray(o,p){this._buff.writeUInt8(o.length,this._offset),this._offset+=1;for(let f=0,_=o.length;f<_;f++){const u=o[f];switch(p[f]){case 1:this.writeUInt8(1),this.writeLongString(u);break;case 2:this.writeUInt8(2),this.writeVSBuffer(u);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const o=this._buff.readUInt8(this._offset);this._offset+=1;let p=new Array(o);for(let f=0;f<o;f++)switch(this.readUInt8()){case 1:p[f]=this.readLongString();break;case 2:p[f]=this.readVSBuffer();break;case 3:p[f]=void 0;break}return p}}class t{static _arrayContainsBufferOrUndefined(o){for(let p=0,f=o.length;p<f;p++)if(o[p]instanceof i.VSBuffer||typeof o[p]=="undefined")return!0;return!1}static serializeRequestArguments(o,p){if(this._arrayContainsBufferOrUndefined(o)){let f=[],_=[];for(let u=0,v=o.length;u<v;u++){const R=o[u];R instanceof i.VSBuffer?(f[u]=R,_[u]=2):typeof R=="undefined"?(f[u]=i.VSBuffer.alloc(0),_[u]=3):(f[u]=i.VSBuffer.fromString(g(R,p)),_[u]=1)}return{type:"mixed",args:f,argsType:_}}return{type:"simple",args:g(o,p)}}static serializeRequest(o,p,f,_,u){return _.type==="mixed"?this._requestMixedArgs(o,p,f,_.args,_.argsType,u):this._requestJSONArgs(o,p,f,_.args,u)}static _requestJSONArgs(o,p,f,_,u){const v=i.VSBuffer.fromString(f),R=i.VSBuffer.fromString(_);let O=0;O+=c.sizeUInt8(),O+=c.sizeShortString(v),O+=c.sizeLongString(R);let H=c.alloc(u?2:1,o,O);return H.writeUInt8(p),H.writeShortString(v),H.writeLongString(R),H.buffer}static deserializeRequestJSONArgs(o){const p=o.readUInt8(),f=o.readShortString(),_=o.readLongString();return{rpcId:p,method:f,args:JSON.parse(_)}}static _requestMixedArgs(o,p,f,_,u,v){const R=i.VSBuffer.fromString(f);let O=0;O+=c.sizeUInt8(),O+=c.sizeShortString(R),O+=c.sizeMixedArray(_,u);let H=c.alloc(v?4:3,o,O);return H.writeUInt8(p),H.writeShortString(R),H.writeMixedArray(_,u),H.buffer}static deserializeRequestMixedArgs(o){const p=o.readUInt8(),f=o.readShortString(),_=o.readMixedArray(),u=new Array(_.length);for(let v=0,R=_.length;v<R;v++){const O=_[v];typeof O=="string"?u[v]=JSON.parse(O):u[v]=O}return{rpcId:p,method:f,args:u}}static serializeAcknowledged(o){return c.alloc(5,o,0).buffer}static serializeCancel(o){return c.alloc(6,o,0).buffer}static serializeReplyOK(o,p,f){return typeof p=="undefined"?this._serializeReplyOKEmpty(o):p instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(o,p):this._serializeReplyOKJSON(o,m(p,f))}static _serializeReplyOKEmpty(o){return c.alloc(7,o,0).buffer}static _serializeReplyOKVSBuffer(o,p){let f=0;f+=c.sizeVSBuffer(p);let _=c.alloc(8,o,f);return _.writeVSBuffer(p),_.buffer}static deserializeReplyOKVSBuffer(o){return o.readVSBuffer()}static _serializeReplyOKJSON(o,p){const f=i.VSBuffer.fromString(p);let _=0;_+=c.sizeLongString(f);let u=c.alloc(9,o,_);return u.writeLongString(f),u.buffer}static deserializeReplyOKJSON(o){const p=o.readLongString();return JSON.parse(p)}static serializeReplyErr(o,p){return p?this._serializeReplyErrEror(o,p):this._serializeReplyErrEmpty(o)}static _serializeReplyErrEror(o,p){const f=i.VSBuffer.fromString(m(C.transformErrorForSerialization(p),null));let _=0;_+=c.sizeLongString(f);let u=c.alloc(10,o,_);return u.writeLongString(f),u.buffer}static deserializeReplyErrError(o){const p=o.readLongString();return JSON.parse(p)}static _serializeReplyErrEmpty(o){return c.alloc(11,o,0).buffer}}var n;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var s;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(s||(s={}))}),define(me[257],ge([0,1,4]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,b.createDecorator)("remoteAgentService")}),define(me[258],ge([0,1,13,8,10,2,4,257]),function(K,e,b,T,C,A,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let D=class{constructor(i,I){this.localUserHome=i,this.remoteAgentService=I,this.resolveOS=(async()=>{const m=await this.remoteAgentService.getEnvironment();return(m==null?void 0:m.os)||C.OS})(),this.resolveUserHome=(async()=>{const m=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(m==null?void 0:m.userHome)||i})()}async userHome(i){return(i==null?void 0:i.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?T.win32:T.posix)}async fileURI(i){let I="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const g=i.indexOf("/",2);g===-1?(I=i.substring(2),i="/"):(I=i.substring(2,g),i=i.substring(g)||"/")}return A.URI.from({scheme:b.Schemas.file,authority:I,path:i,query:"",fragment:""})}};D=qe([He(1,k.IRemoteAgentService)],D),e.AbstractPathService=D}),define(me[68],ge([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class b{constructor(y,k){this.line=y,this.character=k}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,k){return new b(0,0)}with(y){return new b(0,0)}}e.Position=b;class T{constructor(y,k,D,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new b(y,k),this.end=new b(D,P)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new T(0,0,0,0)}with(y){return new T(0,0,0,0)}}e.Range=T;var C;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[31],ge([0,1,16,33,24,29,9,4,8,17,68]),function(K,e,b,T,C,A,y,k,D,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",m=" characters skipped \u27EB",g=(I.length+m.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var a;(function(L){L[L.file=0]="file",L[L.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var h;(function(L){L[L.File=1]="File",L[L.Text=2]="Text"})(h=e.QueryType||(e.QueryType={}));function S(L){return!!L.preview}e.resultIsMatch=S;function w(L){return!!L.resource}e.isFileMatch=w;function E(L){return!!L.message}e.isProgressMessage=E;var d;(function(L){L[L.Normal=0]="Normal",L[L.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class l{constructor(N){this.resource=N,this.results=[]}}e.FileMatch=l;class c{constructor(N,F,M){this.ranges=F;const $=Array.isArray(F)?F:[F];if(M&&M.matchLines===1&&t($)){N=(0,y.getNLines)(N,M.matchLines);let q="",G=0,le=0;const ve=Math.floor(M.charsPerLine/5),Re=[];for(const Se of $){const Oe=Math.max(Se.startColumn-ve,0),V=Se.startColumn+M.charsPerLine;if(Oe>le+ve+g){const X=I+(Oe-le)+m;q+=X+N.slice(Oe,V),G+=Oe-(le+X.length)}else q+=N.slice(le,V);Re.push(new s(0,Se.startColumn-G,Se.endColumn-G)),le=V}this.preview={text:q,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const q=Array.isArray(F)?F[0].startLineNumber:F.startLineNumber;this.preview={text:N,matches:(0,b.mapArrayOrNot)(F,G=>new n(G.startLineNumber-q,G.startColumn,G.endLineNumber-q,G.endColumn))}}}}e.TextSearchMatch=c;function t(L){const N=L[0].startLineNumber;for(const F of L)if(F.startLineNumber!==N||F.endLineNumber!==N)return!1;return!0}class n{constructor(N,F,M,$){this.startLineNumber=N,this.startColumn=F,this.endLineNumber=M,this.endColumn=$}}e.SearchRange=n;class s extends n{constructor(N,F,M){super(N,F,N,M)}}e.OneLineRange=s;var r;(function(L){L.Default="default",L.FileNames="fileNames",L.Type="type",L.Modified="modified",L.CountDescending="countDescending",L.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function o(L,N=!0){const F=L&&L.files&&L.files.exclude,M=N&&L&&L.search&&L.search.exclude;if(!(!F&&!M)){if(!F||!M)return F||M;let $=Object.create(null);return $=C.mixin($,C.deepClone(F)),$=C.mixin($,C.deepClone(M),!0),$}}e.getExcludes=o;function p(L,N){return L.excludePattern&&T.match(L.excludePattern,N)?!1:L.includePattern||L.usingSearchPaths?L.includePattern&&T.match(L.includePattern,N)?!0:L.usingSearchPaths?!!L.folderQueries&&L.folderQueries.some(F=>{const M=F.folder.fsPath;if(A.isEqualOrParent(N,M)){const $=D.relative(M,N);return!F.includePattern||!!T.match(F.includePattern,$)}else return!1}):!1:!0}e.pathIncludedInQuery=p;var f;(function(L){L[L.unknownEncoding=1]="unknownEncoding",L[L.regexParseError=2]="regexParseError",L[L.globParseError=3]="globParseError",L[L.invalidLiteral=4]="invalidLiteral",L[L.rgProcessError=5]="rgProcessError",L[L.other=6]="other",L[L.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class _ extends Error{constructor(N,F){super(N);this.code=F}}e.SearchError=_;function u(L){const N=L.message;if((0,P.isPromiseCanceledError)(L))return new _(N,f.canceled);try{const F=JSON.parse(N);return new _(F.message,F.code)}catch(F){return new _(N,f.other)}}e.deserializeSearchError=u;function v(L){const N={message:L.message,code:L.code};return new Error(JSON.stringify(N))}e.serializeSearchError=v;function R(L){return L.type==="error"?!0:L.type==="success"}e.isSerializedSearchComplete=R;function O(L){return L.type==="success"}e.isSerializedSearchSuccess=O;function H(L){return!!L.path}e.isSerializedFileMatch=H;function ne(L,N){const F=L.searchPath?L.searchPath:L.relativePath;return(0,y.fuzzyContains)(F,N)}e.isFilePatternMatch=ne;class ie{constructor(N){this.path=N,this.results=[]}addMatch(N){this.results.push(N)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ie;function U(L,N){const F=Object.assign(Object.assign({},L||{}),N||{});return Object.keys(F).filter(M=>{const $=F[M];return typeof $=="boolean"&&$})}e.resolvePatternsForProvider=U;class B{constructor(N,F){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},N.excludePattern||{}),F.excludePattern||{}),this._parsedExcludeExpression=T.parse(this._excludeExpression);let M=N.includePattern;F.includePattern&&(M?M=Object.assign(Object.assign({},M),F.includePattern):M=F.includePattern),M&&(this._parsedIncludeExpression=T.parse(M))}includedInQuerySync(N,F,M){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(N,F,M)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(N,F,M))}includedInQuery(N,F,M){return Promise.resolve(this._parsedExcludeExpression(N,F,M)).then(q=>!!q).then(q=>q?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(N,F,M)).then(G=>!!G):Promise.resolve(!0)).then(q=>q)}hasSiblingExcludeClauses(){return x(this._excludeExpression)}}e.QueryGlobTester=B;function x(L){for(const N in L)if(typeof L[N]!="boolean")return!0;return!1}}),define(me[32],ge([0,1,16,14,21,3,22,13,74,25,9,11,2,168,4,12,187,62,63,28,15,7,31,5]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h,S,w,E,d,l,c,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(R,O,H){return new P.ExtUri(ne=>f(ne,H)).isEqual(R,O)}function r(R,O,H){return s(R.uri,O.uri,H)?0:(0,i.compare)(R.uri.toString(),O.uri.toString())}function o(R,O,H){return R.index!==O.index?R.index<O.index?-1:1:s(R.uri,O.uri,H)?(0,i.compare)(R.name,O.name):(0,i.compare)(R.uri.toString(),O.uri.toString())}function p(R,O,H,ne){const ie=R.slice(0).sort((B,x)=>H(B,x,ne)),U=O.slice(0).sort((B,x)=>H(B,x,ne));return(0,b.delta)(ie,U,(B,x)=>H(B,x,ne))}function f(R,O){const H=O.getCapabilities(R.scheme);return!(H&&H&1024)}class _ extends w.Workspace{constructor(O,H,ne,ie,U,B){super(O,ne.map(x=>new w.WorkspaceFolder(x)),ie,B);this._name=H,this._isUntitled=U,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(B),ne.forEach(x=>{this._workspaceFolders.push(x),this._structure.set(x.uri,x)})}static toExtHostWorkspace(O,H,ne,ie){if(!O)return{workspace:null,added:[],removed:[]};const{id:U,name:B,folders:x,configuration:L,isUntitled:N}=O,F=[],M=H;H?x.forEach((le,ve)=>{const Re=m.URI.revive(le.uri),Se=_._findFolder(ne||H,Re,ie);Se?(Se.name=le.name,Se.index=le.index,F.push(Se)):F.push({uri:Re,name:le.name,index:ve})}):F.push(...x.map(({uri:le,name:ve,index:Re})=>({uri:m.URI.revive(le),name:ve,index:Re}))),F.sort((le,ve)=>le.index<ve.index?-1:1);const $=new _(U,B,F,L?m.URI.revive(L):null,!!N,le=>f(le,ie)),{added:q,removed:G}=p(M?M.workspaceFolders:[],$.workspaceFolders,r,ie);return{workspace:$,added:q,removed:G}}static _findFolder(O,H,ne){for(let ie=0;ie<O.folders.length;ie++){const U=O.workspaceFolders[ie];if(s(U.uri,H,ne))return U}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,H){return H&&this._structure.get(O)&&(O=(0,P.dirname)(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let u=class{constructor(O,H,ne,ie){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=ie,this._extHostFileSystemInfo=ne,this._requestIdProvider=new D.Counter,this._barrier=new T.Barrier,this._proxy=O.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(n.MainContext.MainThreadMessageService);const U=H.workspace;this._confirmedWorkspace=U?new _(U.id,U.name,[],U.configuration?m.URI.revive(U.configuration):null,!!U.isUntitled,B=>f(B,ne)):void 0}$initializeWorkspace(O,H){this._trusted=H,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?m.URI.from({scheme:k.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,H,ne,...ie){const U=[];if(Array.isArray(ie)&&ie.forEach(F=>{m.URI.isUri(F.uri)&&!U.some(M=>s(M.uri,F.uri,this._extHostFileSystemInfo))&&U.push({uri:F.uri,name:F.name||(0,P.basenameOrAuthority)(F.uri)})}),this._unconfirmedWorkspace||[H,ne].some(F=>typeof F!="number"||F<0)||ne===0&&U.length===0)return!1;const B=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(H+ne>B.length)return!1;const x=B.slice(0);x.splice(H,ne,...U.map(F=>({uri:F.uri,name:F.name||(0,P.basenameOrAuthority)(F.uri),index:void 0})));for(let F=0;F<x.length;F++){const M=x[F];if(x.some(($,q)=>q!==F&&s(M.uri,$.uri,this._extHostFileSystemInfo)))return!1}x.forEach((F,M)=>F.index=M);const{added:L,removed:N}=p(B,x,o,this._extHostFileSystemInfo);if(L.length===0&&N.length===0)return!1;if(this._proxy){const F=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(F,H,ne,U).then(void 0,M=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(S.Severity.Error,(0,g.localize)(0,null,F,M.toString()),{extension:O},[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(O,H){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,H)}async getWorkspaceFolder2(O,H){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,H)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!!this._actualWorkspace){const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}}getRelativePath(O,H){let ne,ie="";if(typeof O=="string"?(ne=m.URI.file(O),ie=O):typeof O!="undefined"&&(ne=O,ie=O.fsPath),!ne)return ie;const U=this.getWorkspaceFolder(ne,!0);if(!U)return ie;typeof H=="undefined"&&this._actualWorkspace&&(H=this._actualWorkspace.folders.length>1);let B=(0,P.relativePath)(U.uri,ne);return H&&U.name&&(B=`${U.name}/${B}`),B}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=_.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:H,added:ne,removed:ie}=_.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=H||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ne,removed:ie}))}findFiles(O,H,ne,ie,U=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${ie.value}, entryPoint: findFiles`);let B;if(H===null?B=!1:H&&(typeof H=="string"?B=H:B=H.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:L}=v(O);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(x),(0,I.withUndefinedAsNull)(L),(0,I.withUndefinedAsNull)(B),(0,I.withUndefinedAsNull)(ne),U).then(N=>Array.isArray(N)?N.map(F=>m.URI.revive(F)):[])}async findTextInFiles(O,H,ne,ie,U=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${ie.value}, entryPoint: findTextInFiles`);const B=this._requestIdProvider.getNext(),x=typeof H.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:H.previewOptions,{includePattern:L,folder:N}=v(H.include),F=typeof H.exclude=="string"?H.exclude:H.exclude?H.exclude.pattern:void 0,M={ignoreSymlinks:typeof H.followSymlinks=="boolean"?!H.followSymlinks:void 0,disregardIgnoreFiles:typeof H.useIgnoreFiles=="boolean"?!H.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof H.useGlobalIgnoreFiles=="boolean"?!H.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof H.useDefaultExcludes=="boolean"?!H.useDefaultExcludes:!0,fileEncoding:H.encoding,maxResults:H.maxResults,previewOptions:x,afterContext:H.afterContext,beforeContext:H.beforeContext,includePattern:L,excludePattern:F},$=!1;if(this._activeSearchCallbacks[B]=q=>{if(!$){const G=m.URI.revive(q.resource);q.results.forEach(le=>{(0,t.resultIsMatch)(le)?ne({uri:G,preview:{text:le.preview.text,matches:(0,b.mapArrayOrNot)(le.preview.matches,ve=>new c.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,b.mapArrayOrNot)(le.ranges,ve=>new c.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):ne({uri:G,text:le.text,lineNumber:le.lineNumber})})}},U.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(O,(0,I.withUndefinedAsNull)(N),M,B,U);return delete this._activeSearchCallbacks[B],q||{}}catch(q){throw delete this._activeSearchCallbacks[B],q}}$handleTextSearchResult(O,H){this._activeSearchCallbacks[H]&&this._activeSearchCallbacks[H](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};u=qe([He(0,l.IExtHostRpcService),He(1,d.IExtHostInitDataService),He(2,E.IExtHostFileSystemInfo),He(3,h.ILogService)],u),e.ExtHostWorkspace=u,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function v(R){let O,H;return R&&(typeof R=="string"?O=R:(O=R.pattern,H=R.baseFolder||m.URI.file(R.base))),{includePattern:O,folder:H}}}),define(me[35],ge([0,1,24,3,32,5,7,189,84,11,14,4,15,12,2]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(n,s){if(s){const r=s.split(".");let o=n;for(let p=0;o&&p<r.length;p++)o=o[r[p]];return o}}function S(n){return n instanceof a.URI}function w(n){return n&&n.uri instanceof a.URI&&n.languageId&&typeof n.languageId=="string"}function E(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function d(n){return n&&n.uri instanceof a.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function l(n){if(S(n))return{resource:n};if(w(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(E(n))return{overrideIdentifier:n.languageId};if(d(n))return{resource:n.uri};if(n===null)return{resource:null}}let c=class{constructor(s,r,o){this._proxy=s.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=o,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,r){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(s,r))}};c=qe([He(0,m.IExtHostRpcService),He(1,C.IExtHostWorkspace),He(2,g.ILogService)],c),e.ExtHostConfiguration=c;class t{constructor(s,r,o,p){this._onDidChangeConfiguration=new T.Emitter,this._proxy=s,this._logService=p,this._extHostWorkspace=r,this._configuration=k.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,r){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,o))}getConfiguration(s,r,o){const p=l(r)||{},f=this._toReadonlyValue(s?h(this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,p,o==null?void 0:o.identifier);function _(v){if(v==null)return null;if(typeof v=="boolean")return v?1:4;switch(v){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const u={has(v){return typeof h(f,v)!="undefined"},get:(v,R)=>{this._validateConfigurationAccess(s?`${s}.${v}`:v,p,o==null?void 0:o.identifier);let O=h(f,v);if(typeof O=="undefined")O=R;else{let H;const ne=(ie,U)=>{let B;const x=()=>{H=H||(0,b.deepClone)(f),B=B||h(H,U)};return(0,P.isObject)(ie)?new Proxy(ie,{get:(L,N)=>{if(typeof N=="string"&&N.toLowerCase()==="tojson")return x(),()=>B;if(H)return B=B||h(H,U),B[N];const F=L[N];return typeof N=="string"?ne(F,`${U}.${N}`):F},set:(L,N,F)=>(x(),B&&(B[N]=F),!0),deleteProperty:(L,N)=>(x(),B&&delete B[N],!0),defineProperty:(L,N,F)=>(x(),B&&Object.defineProperty(B,N,F),!0)}):ie};O=ne(O,v)}return O},update:(v,R,O,H)=>{v=s?`${s}.${v}`:v;const ne=_(O);return R!==void 0?this._proxy.$updateConfigurationOption(ne,v,R,p,H):this._proxy.$removeConfigurationOption(ne,v,p,H)},inspect:v=>{var R,O,H,ne,ie,U,B,x;v=s?`${s}.${v}`:v;const L=(0,b.deepClone)(this._configuration.inspect(v,p,this._extHostWorkspace.workspace));if(L)return{key:v,defaultValue:(R=L.default)===null||R===void 0?void 0:R.value,globalValue:(O=L.user)===null||O===void 0?void 0:O.value,workspaceValue:(H=L.workspace)===null||H===void 0?void 0:H.value,workspaceFolderValue:(ne=L.workspaceFolder)===null||ne===void 0?void 0:ne.value,defaultLanguageValue:(ie=L.default)===null||ie===void 0?void 0:ie.override,globalLanguageValue:(U=L.user)===null||U===void 0?void 0:U.override,workspaceLanguageValue:(B=L.workspace)===null||B===void 0?void 0:B.override,workspaceFolderLanguageValue:(x=L.workspaceFolder)===null||x===void 0?void 0:x.override,languageIds:L.overrideIdentifiers}}};return typeof f=="object"&&(0,b.mixin)(u,f,!1),Object.freeze(u)}_toReadonlyValue(s){const r=o=>(0,P.isObject)(o)?new Proxy(o,{get:(p,f)=>r(p[f]),set:(p,f,_)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(f)}' of object`)},deleteProperty:(p,f)=>{throw new Error(`TypeError: Cannot delete read only property '${String(f)}' of object`)},defineProperty:(p,f)=>{throw new Error(`TypeError: Cannot define property '${String(f)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return r(s)}_validateConfigurationAccess(s,r,o){const p=D.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),f=o?`[${o.value}] `:"";if(p===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${f}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){(r==null?void 0:r.resource)&&this._logService.warn(`${f}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,r){const o=new k.ConfigurationChangeEvent(s,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(p,f)=>o.affectsConfiguration(p,l(f))})}_toMap(s){return s.reduce((r,o)=>(r.set(o[0],o[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(K,e,b,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(K,b):C?C.value=b:e.set(K,b),b},We=this&&this.__classPrivateFieldGet||function(K,e,b,T){if(b==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?T:b==="a"?T.call(K):T?T.value:e.get(K)};define(me[69],ge([0,1,2,14,3,5,7,32,39,35,21,34,15,28,4,13,10,12,65,208,17]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h,S,w,E,d,l){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(ie){function U(x){if(x!=null)return x}ie.from=U;function B(x){if(x!=null)return x}ie.to=B})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(ie){function U(x){if(x!=null)return x}ie.from=U;function B(x){if(x!=null)return x}ie.to=B})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(ie){function U(x){if(x!=null)return x}ie.from=U;function B(x){if(x!=null)return x}ie.to=B})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(ie){function U(L){if(L){const N=L;return N&&!!N.process}else return!1}ie.is=U;function B(L){if(L!=null){const N={process:L.process,args:L.args};return L.options&&(N.options=s.from(L.options)),N}}ie.from=B;function x(L){if(L!=null)return new y.ProcessExecution(L.process,L.args,L.options)}ie.to=x})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(ie){function U(x){if(x!=null)return x}ie.from=U;function B(x){if(x!=null)return x}ie.to=B})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var p;(function(ie){function U(L){if(L){const N=L;return N&&(!!N.commandLine||!!N.command)}else return!1}ie.is=U;function B(L){if(L!=null){const N={};return L.commandLine!==void 0?N.commandLine=L.commandLine:(N.command=L.command,N.args=L.args),L.options&&(N.options=o.from(L.options)),N}}ie.from=B;function x(L){if(!(L==null||L.command===void 0&&L.commandLine===void 0))return L.commandLine?new y.ShellExecution(L.commandLine,L.options):new y.ShellExecution(L.command,L.args?L.args:[],L.options)}ie.to=x})(p=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var f;(function(ie){function U(L){if(L){let N=L;return N&&N.customExecution==="customExecution"}else return!1}ie.is=U;function B(L){return{customExecution:"customExecution"}}ie.from=B;function x(L,N){return N.get(L)}ie.to=x})(f=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var _;(function(ie){function U(B,x){let L;return B.scope!==void 0&&typeof B.scope!="number"?L=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===y.TaskScope.Workspace&&x&&x.workspaceFile?L=x.workspaceFile:L=d.USER_TASKS_GROUP_KEY),{id:B._id,workspaceFolder:L}}ie.from=U})(_=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function(ie){function U(L,N){if(L==null)return[];const F=[];for(let M of L){const $=B(M,N);$&&F.push($)}return F}ie.fromMany=U;function B(L,N){if(L!=null){let F;L.execution instanceof y.ProcessExecution?F=r.from(L.execution):L.execution instanceof y.ShellExecution?F=p.from(L.execution):L.execution&&L.execution instanceof y.CustomExecution&&(F=f.from(L.execution));const M=t.from(L.definition);let $;if(L.scope?typeof L.scope=="number"?$=L.scope:$=L.scope.uri:$=y.TaskScope.Workspace,!(!M||!$)){const q=L.group?L.group.id:void 0;return{_id:L._id,definition:M,name:L.name,source:{extensionId:N.identifier.value,label:L.source,scope:$},execution:F,isBackground:L.isBackground,group:q,presentationOptions:n.from(L.presentationOptions),problemMatchers:L.problemMatchers,hasDefinedMatchers:L.hasDefinedMatchers,runOptions:L.runOptions?L.runOptions:{reevaluateOnRerun:!0},detail:L.detail}}}}ie.from=B;async function x(L,N,F){if(L!=null){let M;r.is(L.execution)?M=r.to(L.execution):p.is(L.execution)?M=p.to(L.execution):f.is(L.execution)&&(M=f.to(L._id,F));const $=t.to(L.definition);let q;if(L.source&&(L.source.scope!==void 0?typeof L.source.scope=="number"?q=L.source.scope:q=await N.resolveWorkspaceFolder(b.URI.revive(L.source.scope)):q=y.TaskScope.Workspace),!(!$||!q)){const G=new y.Task($,q,L.name,L.source.label,M,L.problemMatchers);return L.isBackground!==void 0&&(G.isBackground=L.isBackground),L.group!==void 0&&(G.group=y.TaskGroup.from(L.group)),L.presentationOptions&&(G.presentationOptions=n.to(L.presentationOptions)),L._id&&(G._id=L._id),L.detail&&(G.detail=L.detail),G}}}ie.to=x})(u=e.TaskDTO||(e.TaskDTO={}));var v;(function(ie){function U(x){return x}ie.from=U;function B(x){if(!!x)return Object.assign(Object.create(null),x)}ie.to=B})(v=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(U,B,x){this._id=B,this._task=x,c.set(this,void 0),it(this,c,U,"f")}get task(){return this._task}terminate(){We(this,c,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}c=new WeakMap;var O;(function(ie){function U(B){return{id:B._id,task:void 0}}ie.from=U})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let H=class{constructor(U,B,x,L,N,F,M,$){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=U.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=x,this._editorService=L,this._configurationService=N,this._terminalService=F,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=M,this._deprecationService=$,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(U,B,x){if(!x)return new y.Disposable(()=>{});const L=this.nextHandle();return this._handlers.set(L,{type:B,provider:x,extension:U}),this._proxy.$registerTaskProvider(L,B),new y.Disposable(()=>{this._handlers.delete(L),this._proxy.$unregisterTaskProvider(L)})}registerTaskSystem(U,B){this._proxy.$registerTaskSystem(U,B)}fetchTasks(U){return this._proxy.$fetchTasks(v.from(U)).then(async B=>{const x=[];for(let L of B){const N=await u.to(L,this._workspaceProvider,this._providedCustomExecutions2);N&&x.push(N)}return x})}get taskExecutions(){const U=[];return this._taskExecutions.forEach(B=>U.push(B)),U}terminateTask(U){if(!(U instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(U._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(U,B,x){const L=this._providedCustomExecutions2.get(U.id);if(L){if(this._activeCustomExecutions2.get(U.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(U.id,L),this._terminalService.attachPtyToTerminal(B,await L.callback(x))}this._lastStartedTask=U.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(U)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(U){const B=await this.getTaskExecution(U);this._taskExecutionPromises.delete(U.id),this._taskExecutions.delete(U.id),this.customExecutionComplete(U),this._onDidTerminateTask.fire({execution:B})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(U){const B=await this.getTaskExecution(U.id);this._onDidTaskProcessStarted.fire({execution:B,processId:U.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(U){const B=await this.getTaskExecution(U.id);this._onDidTaskProcessEnded.fire({execution:B,exitCode:U.exitCode})}$provideTasks(U,B){const x=this._handlers.get(U);if(!x)return Promise.reject(new Error("no handler found"));const L=[],N=(0,T.asPromise)(()=>x.provider.provideTasks(i.CancellationToken.None)).then(F=>this.provideTasksInternal(B,L,x,F));return new Promise(F=>{N.then(M=>{Promise.all(L).then(()=>{F(M)})})})}async $resolveTask(U,B){const x=this._handlers.get(U);if(!x)return Promise.reject(new Error("no handler found"));if(B.definition.type!==x.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${x.type}].`);const L=await u.to(B,this._workspaceProvider,this._providedCustomExecutions2);if(!L)throw new Error("Unexpected: Task cannot be resolved.");const N=await x.provider.resolveTask(L,i.CancellationToken.None);if(!!N){this.checkDeprecation(N,x);const F=u.from(N,x.extension);if(!F)throw new Error("Unexpected: Task cannot be resolved.");if(N.definition!==L.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(F.execution)&&await this.addCustomExecution(F,N,!0),await this.resolveTaskInternal(F)}}nextHandle(){return this._handleCounter++}async addCustomExecution(U,B,x){const L=await this._proxy.$createTaskId(U);!x&&!this._providedCustomExecutions2.has(L)&&this._notProvidedCustomExecutions.add(L),this._providedCustomExecutions2.set(L,B.execution)}async getTaskExecution(U,B){if(typeof U=="string"){const N=this._taskExecutionPromises.get(U);if(!N)throw new Error("Unexpected: The specified task is missing an execution");return N}let x=this._taskExecutionPromises.get(U.id);if(x)return x;const L=new Promise(async(N,F)=>{const M=B||await u.to(U.task,this._workspaceProvider,this._providedCustomExecutions2);M?N(new R(this,U.id,M)):F("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(U.id,L),L.then(N=>(this._taskExecutions.set(U.id,N),N),N=>Promise.reject(N))}checkDeprecation(U,B){U._deprecated&&this._deprecationService.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(U){this._activeCustomExecutions2.get(U.id)&&this._activeCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.has(U.id)&&this._lastStartedTask!==U.id&&(this._providedCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.delete(U.id));let x=this._notProvidedCustomExecutions.values(),L=x.next();for(;!L.done;)!this._activeCustomExecutions2.has(L.value)&&this._lastStartedTask!==L.value&&(this._providedCustomExecutions2.delete(L.value),this._notProvidedCustomExecutions.delete(L.value)),L=x.next()}};H=qe([He(0,m.IExtHostRpcService),He(1,g.IExtHostInitDataService),He(2,k.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,I.IExtHostTerminalService),He(6,w.ILogService),He(7,E.IExtHostApiDeprecationService)],H),e.ExtHostTaskBase=H;let ne=class extends H{constructor(U,B,x,L,N,F,M,$){super(U,B,x,L,N,F,M,$);this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:S.PlatformToString(0)})}async executeTask(U,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const x=u.from(B,U);if(x===void 0)throw new Error("Task is not valid");if(f.is(x.execution))await this.addCustomExecution(x,B,!1);else throw new l.NotSupportedError;const L=await this.getTaskExecution(await this._proxy.$getTaskExecution(x),B);return this._proxy.$executeTask(x).catch(N=>{throw new Error(N)}),L}provideTasksInternal(U,B,x,L){const N=[];if(L)for(let F of L){this.checkDeprecation(F,x),(!F.definition||!U[F.definition.type])&&this._logService.warn(`The task [${F.source}, ${F.name}] uses an undefined task type. The task will be ignored in the future.`);const M=u.from(F,x.extension);M&&f.is(M.execution)?(N.push(M),B.push(this.addCustomExecution(M,F,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:N,extension:x.extension}}async resolveTaskInternal(U){if(f.is(U.execution))return U;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(U,B){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(U,B,x){}};ne=qe([He(0,m.IExtHostRpcService),He(1,g.IExtHostInitDataService),He(2,k.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,I.IExtHostTerminalService),He(6,w.ILogService),He(7,E.IExtHostApiDeprecationService)],ne),e.WorkerExtHostTask=ne,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")});var it=this&&this.__classPrivateFieldSet||function(K,e,b,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(K,b):C?C.value=b:e.set(K,b),b},We=this&&this.__classPrivateFieldGet||function(K,e,b,T){if(b==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?T:b==="a"?T.call(K):T?T.value:e.get(K)},Yt=this&&this.__rest||function(K,e){var b={};for(var T in K)Object.prototype.hasOwnProperty.call(K,T)&&e.indexOf(T)<0&&(b[T]=K[T]);if(K!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,T=Object.getOwnPropertySymbols(K);C<T.length;C++)e.indexOf(T[C])<0&&Object.prototype.propertyIsEnumerable.call(K,T[C])&&(b[T[C]]=K[T[C]]);return b};define(me[259],ge([0,1,16,14,23,21,3,72,56,6,24,11,2,30,5,39,15,88,20,7,32,221,125]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h,S,w,E,d,l,c,t){"use strict";var n,s,r,o;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const p=(x,L)=>`${x}:${L.toString()}`;let f=class{constructor(L,N,F){this.documents=N,this.workspace=F,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new c.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(a.MainContext.MainThreadTesting),this.runQueue=new _(this.proxy),this.workspaceObservers=new U(this.proxy),this.textDocumentObservers=new B(this.proxy,N)}registerTestController(L,N){const F=(0,g.generateUuid)();this.controllers.set(F,{instance:N,extensionId:L}),this.proxy.$registerTestController(F);const M=[...this.testControllers.keys()];return setTimeout(()=>{var $;for(const q of M)($=this.testControllers.get(q))===null||$===void 0||$.subscribeFn(F,N)},0),new d.Disposable(()=>{this.controllers.delete(F),this.proxy.$unregisterTestController(F)})}createTextDocumentTestObserver(L){return this.textDocumentObservers.checkout(L.uri)}createWorkspaceTestObserver(L){return this.workspaceObservers.checkout(L.uri)}async runTests(L,N=A.CancellationToken.None){const F=M=>M.map(this.getInternalTestForReference,this).filter(I.isDefined).map($=>({src:$.src,testId:$.item.extId}));await this.proxy.$runTests({exclude:L.exclude?F(L.exclude).map(M=>M.testId):void 0,tests:F(L.tests),debug:L.debug},N)}createTestRun(L,N,F,M=!0){return this.runQueue.createTestRun(L,N,F,M)}$publishTestResults(L){this.results=Object.freeze(L.map(N=>(0,i.deepFreeze)(E.TestResults.to(N))).concat(this.results).sort((N,F)=>F.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(L,N){const F=m.URI.revive(N),M=p(L,F);if(!this.testControllers.has(M)){const $=new A.CancellationTokenSource;let q;if(L===1){let Se=this.documents.getDocument(F);if(!Se){const Oe=new P.DisposableStore;Se=await new Promise(V=>{Oe.add((0,T.disposableTimeout)(()=>V(void 0),5e3)),Oe.add(this.documents.onDidAddDocuments(X=>{const Z=X.find(se=>se.document.uri.toString()===F.toString());Z&&V(Z)}))}).finally(()=>Oe.dispose())}if(Se){const Oe=await this.workspace.getWorkspaceFolder2(F,!1);q=V=>V.createDocumentTestRoot?V.createDocumentTestRoot(Se.document,$.token):(0,e.createDefaultDocumentTestRoot)(V,Se.document,Oe,$.token)}}else{const Se=await this.workspace.getWorkspaceFolder2(F,!1);Se&&(q=Oe=>Oe.createWorkspaceTestRoot(Se,$.token))}if(!!q){const G=async(Se,Oe)=>{try{const V=await q(Oe);V&&ve.addRoot(V,Se)}catch(V){console.error(V)}},le=new P.DisposableStore,ve=le.add(this.ownedTests.createForHierarchy(Se=>this.proxy.$publishDiff(L,N,Se)));le.add((0,P.toDisposable)(()=>$.dispose(!0)));const Re=[];for(const[Se,Oe]of this.controllers)Re.push(G(Se,Oe.instance));Promise.all(Re).then(()=>ve.pushDiff([3,-1])),this.testControllers.set(M,{store:le,collection:ve,subscribeFn:G})}}}async $expandTest(L,N){const F=(0,b.mapFind)(this.testControllers.values(),M=>M.collection.treeId===L.src.tree?M:void 0);await(F==null?void 0:F.collection.expand(L.testId,N<0?Infinity:N)),this.flushCollectionDiffs()}$unsubscribeFromTests(L,N){var F;const M=m.URI.revive(N),$=p(L,M);(F=this.testControllers.get($))===null||F===void 0||F.store.dispose(),this.testControllers.delete($)}$acceptDiff(L,N,F){L===1?this.textDocumentObservers.acceptDiff(m.URI.revive(N),F):this.workspaceObservers.acceptDiff(m.URI.revive(N),F)}async $runTestsForProvider(L,N){const F=this.controllers.get(L.tests[0].src.controller);if(!!F){const M=L.tests.map(({testId:G,src:le})=>this.ownedTests.getTestById(G,le==null?void 0:le.tree)).filter(I.isDefined).map(([G,le])=>le),$=L.excludeExtIds.map(G=>this.ownedTests.getTestById(G)).filter(I.isDefined).filter(([G,le])=>M.some(ve=>G.comparePositions(ve,le)===1));if(!!M.length){const q={tests:M.map(G=>O.unwrap(G.actual)),exclude:$.map(([,G])=>O.unwrap(G.actual)),debug:L.debug};await this.runQueue.enqueueRun({dto:u.fromInternal(L),token:N,extensionId:F.extensionId,req:q,doRun:()=>F.instance.runTests(q,N)})}}}$lookupTest(L){const N=this.ownedTests.getTestById(L.testId);if(!N)return Promise.resolve(void 0);const F=N[1],{actual:M,discoverCts:$,expandLevels:q}=F,G=Yt(F,["actual","discoverCts","expandLevels"]);return Promise.resolve(G)}flushCollectionDiffs(){for(const{collection:L}of this.testControllers.values())L.flushDiff()}getInternalTestForReference(L){var N,F;return(F=(N=this.workspaceObservers.getMirroredTestDataByReference(L))!==null&&N!==void 0?N:(0,b.mapFind)(this.testControllers.values(),M=>M.collection.getTestByReference(L)))!==null&&F!==void 0?F:this.textDocumentObservers.getMirroredTestDataByReference(L)}};f=qe([He(0,S.IExtHostRpcService),He(1,h.IExtHostDocumentsAndEditors),He(2,l.IExtHostWorkspace)],f),e.ExtHostTesting=f;class _{constructor(L){this.proxy=L,this.state=new Map}enqueueRun(L){let N=this.state.get(L.extensionId);N||(N={queue:[],current:void 0},this.state.set(L.extensionId,N));const F=new T.DeferredPromise,M=()=>{const $=[],q=new Set;N.current={publicReq:L.req,factory:G=>{const le=new v(G,L.dto,q,this.proxy);return $.push(le),L.token.onCancellationRequested(()=>le.end()),le}},this.invokeRunner(L.extensionId,L.dto.id,L.doRun,$).finally(()=>F.complete())};return N.queue.push(M),N.queue.length===1&&M(),F.p}createTestRun(L,N,F,M){var $,q;const G=this.state.get(L);if((G==null?void 0:G.current.publicReq)===N)return G.current.factory(F);const le=u.fromPublic(N),ve=new v(F,le,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:N.debug,exclude:(q=($=N.exclude)===null||$===void 0?void 0:$.map(Re=>Re.id))!==null&&q!==void 0?q:[],id:le.id,tests:N.tests.map(Re=>Re.id),persist:M}),ve.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(le.id)),ve}invokeRunner(L,N,F,M){try{const $=F();return(0,T.isThenable)($)?$.then(()=>this.handleInvokeResult(L,N,M,void 0)).catch(q=>this.handleInvokeResult(L,N,M,q)):this.handleInvokeResult(L,N,M,void 0)}catch($){return this.handleInvokeResult(L,N,M,$)}}async handleInvokeResult(L,N,F,M){const $=this.state.get(L);!$||($.queue.shift(),$.queue.length>0?$.queue[0]():this.state.delete(L),await Promise.all(F.map(q=>q.onEnd.wait())))}}class u{constructor(L,N,F){this.id=L,this.include=N,this.exclude=F}static fromPublic(L){var N,F;return new u((0,g.generateUuid)(),new Set(L.tests.map(M=>M.id)),new Set((F=(N=L.exclude)===null||N===void 0?void 0:N.map(M=>M.id))!==null&&F!==void 0?F:D.Iterable.empty()))}static fromInternal(L){return new u(L.runId,new Set(L.tests.map(N=>N.testId)),new Set(L.excludeExtIds))}isIncluded(L){for(let N=L;N;N=N.parent){if(this.include.has(N.id))return!0;if(this.exclude.has(N.id))return!1}return!0}}class v{constructor(L,N,F,M){this.name=L,n.set(this,void 0),s.set(this,void 0),r.set(this,(0,g.generateUuid)()),o.set(this,void 0),this.onEnd=new T.Barrier,it(this,n,M,"f"),it(this,s,N,"f"),it(this,o,F,"f"),M.$startedTestRunTask(N.id,{id:We(this,r,"f"),name:L,running:!0})}setState(L,N,F){We(this,s,"f").isIncluded(L)&&(this.ensureTestIsKnown(L),We(this,n,"f").$updateTestStateInRun(We(this,s,"f").id,We(this,r,"f"),L.id,N,F))}appendMessage(L,N){We(this,s,"f").isIncluded(L)&&(this.ensureTestIsKnown(L),We(this,n,"f").$appendTestMessageInRun(We(this,s,"f").id,We(this,r,"f"),L.id,E.TestMessage.from(N)))}appendOutput(L){We(this,n,"f").$appendOutputToRun(We(this,s,"f").id,We(this,r,"f"),C.VSBuffer.fromString(L))}end(){We(this,n,"f").$finishedTestRunTask(We(this,s,"f").id,We(this,r,"f")),this.onEnd.open()}ensureTestIsKnown(L){const N=We(this,o,"f");if(!N.has(L.id)){const F=[];for(;F.unshift(E.TestItem.from(L)),!(N.has(L.id)||(N.add(L.id),!L.parent));)L=L.parent;We(this,n,"f").$addTestsToRun(We(this,s,"f").id,F)}}}n=new WeakMap,s=new WeakMap,r=new WeakMap,o=new WeakMap;const R=async(x,L,N,F)=>{if(!!N){const M=await x.createWorkspaceTestRoot(N,F);if(!!M){F.onCancellationRequested(()=>{O.removeFilter(L)});const $=O.getWrapperForTestItem(M,L);return $.refreshMatch(),$}}};e.createDefaultDocumentTestRoot=R;class O extends d.TestItemImpl{constructor(L,N,F){super(L.id,L.label,L.uri,void 0);if(this.actual=L,this.filterDocument=N,this.actualParent=F,!(L instanceof d.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${L.id} did not`);this.debuggable=L.debuggable,this.runnable=L.runnable,this.description=L.description,this.error=L.error,this.status=L.status,this.range=L.range,this.resolveHandler=L.resolveHandler;const M=(0,w.getPrivateApiFor)(this);(0,w.getPrivateApiFor)(L).bus.event(q=>{switch(q[0]){case 3:this[q[1]]=q[2];break;case 0:const G=O.getWrapperForTestItem(q[1],this.filterDocument,this);(0,w.getPrivateApiFor)(G).parent=L,G.refreshMatch();break;default:M.bus.fire(q)}})}static removeFilter(L){this.wrapperMap.delete(L)}static getWrapperForTestItem(L,N,F){let M=this.wrapperMap.get(N);if(M==null?void 0:M.has(L))return M.get(L);M||(M=new WeakMap,this.wrapperMap.set(N,M));const $=new O(L,N,F);return M.set(L,$),$}static unwrap(L){return L instanceof O?L.actual:L}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var L,N;const F=this._cachedMatchesFilter;for(const $ of this.actual.children.values()){const q=O.getWrapperForTestItem($,this.filterDocument,this);q.hasNodeMatchingFilter?this.children.has(q.id)||this.addChild(q):q.dispose()}const M=this.children.size>0||((L=this.actual.uri)===null||L===void 0?void 0:L.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=M,M!==F&&((N=this.actualParent)===null||N===void 0||N.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,w.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,w.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=O,O.wrapperMap=new WeakMap;class H extends t.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,E.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:N,removed:F}=this;return{get added(){return[...L].map(M=>M.revived)},get updated(){return[...N].map(M=>M.revived)},get removed(){return[...F].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class ne extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(L){let N=[];for(const F of L){const M=this.items.get(F);M&&N.push(M.revived)}return N}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,N){return Object.assign(Object.assign({},L),{revived:E.TestItem.toPlain(L.item),depth:N?N.depth+1:0,children:new Set})}createChangeCollector(){return new H(this.changeEmitter)}}e.MirroredTestCollection=ne;class ie{constructor(){this.resources=new Map}checkout(L){var N,F;const M=L.toString(),$=(N=this.resources.get(M))!==null&&N!==void 0?N:this.createObserverData(L);return(F=$.pendingDeletion)===null||F===void 0||F.dispose(),$.observers++,{onDidChangeTest:$.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return $.tests.rootTestItems},dispose:(0,k.once)(()=>{--$.observers||($.pendingDeletion=this.eventuallyDispose(L))})}}getMirroredTestDataByReference(L){for(const{tests:N}of this.resources.values()){const F=N.getMirroredTestDataByReference(L);if(F)return F}}eventuallyDispose(L){return(0,T.disposableTimeout)(()=>this.unlisten(L),10*1e3)}createObserverData(L){const N=new ne,F=this.listen(L,$=>N.apply($)),M={observers:0,tests:N,listener:F};return this.resources.set(L.toString(),M),M}unlisten(L){var N;const F=L.toString(),M=this.resources.get(F);M&&(M.observers=-1,(N=M.pendingDeletion)===null||N===void 0||N.dispose(),M.listener.dispose(),this.resources.delete(F))}}class U extends ie{constructor(L){super();this.proxy=L,this.diffListeners=new Map}acceptDiff(L,N){var F;(F=this.diffListeners.get(L.toString()))===null||F===void 0||F(N)}listen(L,N){this.proxy.$subscribeToDiffs(0,L);const F=L.toString();return this.diffListeners.set(F,N),new d.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,L),this.diffListeners.delete(F)})}}class B extends ie{constructor(L,N){super();this.proxy=L,this.documents=N,this.diffListeners=new Map}acceptDiff(L,N){var F;(F=this.diffListeners.get(L.toString()))===null||F===void 0||F(N)}listen(L,N){if(!this.documents.getDocument(L))return new d.Disposable(()=>{});const M=L.toString();return this.diffListeners.set(M,N),this.proxy.$subscribeToDiffs(1,L),new d.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,L),this.diffListeners.delete(M)})}}}),define(me[260],ge([0,1,16,54,33,77,22,13,8,25,9,11,2,141,173,85,62,213,258,31]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h,S,w,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let l=class{constructor(_,u,v,R){this.configurationService=_,this.workspaceContextService=u,this.editorGroupsService=v,this.pathService=R}text(_,u,v={}){_=this.getContentPattern(_,v);const R=this.configurationService.getValue(),O=u&&u.some(ne=>!this.configurationService.getValue({resource:ne}).search.useRipgrep),H=this.commonQuery(u==null?void 0:u.map(S.toWorkspaceFolder),v);return Object.assign(Object.assign({},H),{type:2,contentPattern:_,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:R.search.usePCRE2||O||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles})}getContentPattern(_,u){const v=this.configurationService.getValue();_.isRegExp&&(_.pattern=_.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},_),{wordSeparators:v.editor.wordSeparators});return this.isCaseSensitive(_,u)&&(R.isCaseSensitive=!0),this.isMultiline(_)&&(R.isMultiline=!0),R}file(_,u={}){const v=this.commonQuery(_,u);return Object.assign(Object.assign({},v),{type:1,filePattern:u.filePattern?u.filePattern.trim():u.filePattern,exists:u.exists,sortByScore:u.sortByScore,cacheKey:u.cacheKey})}handleIncludeExclude(_,u){return _?(_=Array.isArray(_)?_.map(r):r(_),u?this.parseSearchPaths(_):{pattern:t(...Array.isArray(_)?_:[_])}):{}}commonQuery(_=[],u={}){const v=this.handleIncludeExclude(u.includePattern,u.expandPatterns),R=this.handleIncludeExclude(u.excludePattern,u.expandPatterns),O=_.length>1,H=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(U=>this.getFolderQueryForSearchPath(U,u,R)):_.map(U=>this.getFolderQueryForRoot(U,u,R,O))).filter(U=>!!U),ne={_reason:u._reason,folderQueries:H,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:u.extraFileResources,excludePattern:R.pattern,includePattern:v.pattern,onlyOpenEditors:u.onlyOpenEditors,maxResults:u.maxResults};if(u.onlyOpenEditors){const B=b.coalesce(b.flatten(this.editorGroupsService.groups.map(L=>L.editors.map(N=>N.resource)))).filter(L=>(0,d.pathIncludedInQuery)(ne,L.fsPath)),x=this.commonQueryFromFileList(B);return Object.assign(Object.assign({},ne),x)}const ie=u.extraFileResources&&u.extraFileResources.filter(U=>(0,d.pathIncludedInQuery)(ne,U.fsPath));return ne.extraFileResources=ie&&ie.length?ie:void 0,ne}commonQueryFromFileList(_){const u=[],v=new y.ResourceMap,R={};let O=!1;return _.forEach(H=>{var ne,ie;if(H.scheme!==k.Schemas.walkThrough)if((0,P.isAbsolutePath)(H)){const B=(ie=(ne=this.workspaceContextService.getWorkspaceFolder(H))===null||ne===void 0?void 0:ne.uri)!==null&&ie!==void 0?ie:H.with({path:D.dirname(H.fsPath)});let x=v.get(B);x||(O=!0,x={folder:B,includePattern:{}},u.push(x),v.set(B,x));const L=D.relative(B.fsPath,H.fsPath);(0,I.assertIsDefined)(x.includePattern)[L.replace(/\\/g,"/")]=!0}else H.fsPath&&(O=!0,R[H.fsPath]=!0)}),{folderQueries:u,includePattern:R,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(_,u){if(u.isSmartCase){if(_.isRegExp){if(i.containsUppercaseCharacter(_.pattern,!0))return!0}else if(i.containsUppercaseCharacter(_.pattern))return!0}return!!_.isCaseSensitive}isMultiline(_){return _.isMultiline||_.isRegExp&&(0,g.isMultilineRegexSource)(_.pattern)||_.pattern.indexOf(`
`)>=0?!0:!!_.isMultiline}parseSearchPaths(_){const u=x=>D.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),R=(Array.isArray(_)?_:n(_)).map(x=>{const L=this.pathService.resolvedUserHome;return L?(0,A.untildify)(x,L.scheme===k.Schemas.file?L.fsPath:L.path):x}),O=T.groupBy(R,x=>u(x)?"searchPaths":"exprSegments"),H=(O.exprSegments||[]).map(x=>i.rtrim(x,"/")).map(x=>i.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),s(x))),ne={},ie=this.expandSearchPathPatterns(O.searchPaths||[]);ie&&ie.length&&(ne.searchPaths=ie);const U=b.flatten(H),B=t(...U);return B&&(ne.pattern=B),ne}getExcludesForFolder(_,u){return u.disregardExcludeSettings?void 0:(0,d.getExcludes)(_,!u.disregardSearchExcludeSettings)}expandSearchPathPatterns(_){if(!_||!_.length)return[];const u=b.flatten(_.map(R=>{let{pathPortion:O,globPortion:H}=c(R);H&&(H=o(H));const ne=this.expandOneSearchPath(O);return b.flatten(ne.map(ie=>this.resolveOneSearchPathPattern(ie,H)))})),v=new Map;return u.forEach(R=>{const O=R.searchPath.toString(),H=v.get(O);H?R.pattern&&(H.pattern=H.pattern||{},H.pattern[R.pattern]=!0):v.set(O,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(v.values())}expandOneSearchPath(_){if(D.isAbsolute(_)){const u=this.workspaceContextService.getWorkspace().folders;return u[0]&&u[0].uri.scheme!==k.Schemas.file?[{searchPath:u[0].uri.with({path:_})}]:[{searchPath:m.URI.file(D.normalize(_))}]}if(this.workspaceContextService.getWorkbenchState()===2){const u=this.workspaceContextService.getWorkspace().folders[0].uri;if(_=r(_),_.startsWith("../")||_===".."){const R=D.posix.resolve(u.path,_);return[{searchPath:u.with({path:R})}]}const v=o(_);return[{searchPath:u,pattern:v}]}else{if(_==="./"||_===".\\")return[];{const u=_.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(O=>{const H=u.match(new RegExp(`^${O.name}(?:/(.*))?`));return H?{match:H,folder:O}:null}).filter(I.isDefined);if(R.length)return R.map(O=>{const H=O.match[1];return{searchPath:O.folder.uri,pattern:H&&o(H)}});{const O=_.match(/\.[\/\\](.+)[\/\\]?/),H=O?O[1]:_,ne=a.localize(0,null,H);throw new Error(ne)}}}}resolveOneSearchPathPattern(_,u){const v=_.pattern&&u?`${_.pattern}/${u}`:_.pattern||u,R=[{searchPath:_.searchPath,pattern:v}];return v&&!v.endsWith("**")&&R.push({searchPath:_.searchPath,pattern:v+"/**"}),R}getFolderQueryForSearchPath(_,u,v){const R=this.getFolderQueryForRoot((0,S.toWorkspaceFolder)(_.searchPath),u,v,!1);return R?Object.assign(Object.assign({},R),{includePattern:_.pattern}):null}getFolderQueryForRoot(_,u,v,R){let O;const H=m.URI.isUri(_)?_:_.uri;if(v.searchPaths){const x=v.searchPaths.filter(L=>(0,P.isEqual)(L.searchPath,H))[0];if(x&&!x.pattern)return null;x&&(O=x.pattern)}const ne=this.configurationService.getValue({resource:H}),ie=this.getExcludesForFolder(ne,u),U=Object.assign(Object.assign({},ie||{}),O||{}),B=m.URI.isUri(_)?(0,P.basename)(_):_.name;return{folder:H,folderName:R?B:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:ne.files&&ne.files.encoding,disregardIgnoreFiles:typeof u.disregardIgnoreFiles=="boolean"?u.disregardIgnoreFiles:!ne.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof u.disregardGlobalIgnoreFiles=="boolean"?u.disregardGlobalIgnoreFiles:!ne.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof u.ignoreSymlinks=="boolean"?u.ignoreSymlinks:!ne.search.followSymlinks}}};l=qe([He(0,h.IConfigurationService),He(1,S.IWorkspaceContextService),He(2,w.IEditorGroupsService),He(3,E.IPathService)],l),e.QueryBuilder=l;function c(f){const _=f.match(/[\*\{\}\(\)\[\]\?]/);if(_){const u=_.index,v=f.substr(0,u).match(/[/|\\][^/\\]*$/);if(v){let R=f.substr(0,v.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:f.substr((v.index||0)+1)}}}return{pathPortion:f}}function t(...f){return f.length?f.reduce((_,u)=>(_[u]=!0,_),Object.create(null)):void 0}function n(f){return C.splitGlobAware(f,",").map(_=>_.trim()).filter(_=>!!_.length)}function s(f){return[`**/${f}/**`,`**/${f}`].map(u=>u.replace(/\*\*\/\*\*/g,"**"))}function r(f){return f.replace(/\\/g,"/")}function o(f){return r(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function p(f,_){f=b.distinct(f,R=>R.toString());const u=[],v=_.getWorkspace();return f&&f.forEach(R=>{let O;if(_.getWorkbenchState()===2)O=(0,P.relativePath)(v.folders[0].uri,R),O&&O!=="."&&(O="./"+O);else{const H=_.getWorkspaceFolder(R);if(H){const ne=H.name;if(v.folders.filter(U=>U.name===ne).length===1){const U=(0,P.relativePath)(H.uri,R);U===""?O=`./${H.name}`:O=`./${H.name}/${U}`}else O=R.fsPath}}O&&u.push(O)}),u}e.resolveResourcesForSearchIncludes=p}),define(me[261],ge([0,1,25,2,21,17,4,260,31,62]),function(K,e,b,T,C,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function I(h,S){const w=S.activationEvents;if(!w)return Promise.resolve(void 0);const E=[],d=[];for(const r of w)if(/^workspaceContains:/.test(r)){const o=r.substr("workspaceContains:".length);o.indexOf("*")>=0||o.indexOf("?")>=0||h.forceUsingSearch?d.push(o):E.push(o)}if(E.length===0&&d.length===0)return Promise.resolve(void 0);let l;const c=new Promise((r,o)=>{l=r}),t=r=>l({activationEvent:r}),n=Promise.all(E.map(r=>m(h,r,t))).then(()=>{}),s=g(h,S.identifier,d,t);return Promise.all([n,s]).then(()=>{l(void 0)}),c}e.checkActivateWorkspaceContainsExtension=I;async function m(h,S,w){for(const E of h.folders)if(await h.exists(b.joinPath(T.URI.revive(E),S))){w(`workspaceContains:${S}`);return}}async function g(h,S,w,E){if(w.length===0)return Promise.resolve(void 0);const d=new C.CancellationTokenSource,l=h.checkExists(h.folders,w,d.token),c=setTimeout(async()=>{d.cancel(),E(`workspaceContainsTimeout:${w.join(",")}`)},i);let t=!1;try{t=await l}catch(n){A.isPromiseCanceledError(n)||A.onUnexpectedError(n)}d.dispose(),clearTimeout(c),t&&E(`workspaceContains:${w.join(",")}`)}function a(h,S,w,E){const d=h.get(y.IInstantiationService),l=h.get(D.ISearchService),t=d.createInstance(k.QueryBuilder).file(S.map(n=>(0,P.toWorkspaceFolder)(T.URI.revive(n))),{_reason:"checkExists",includePattern:w,exists:!0});return l.fileSearch(t,E).then(n=>!!n.limitHit,n=>A.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=a});var it=this&&this.__classPrivateFieldSet||function(K,e,b,T,C){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!C:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?C.call(K,b):C?C.value=b:e.set(K,b),b},We=this&&this.__classPrivateFieldGet||function(K,e,b,T){if(b==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!T:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?T:b==="a"?T.call(K):T?T.value:e.get(K)};define(me[42],ge([0,1,163,8,70,25,14,6,22,2,12,5,35,224,93,32,41,222,17,27,23,197,7,86,4,28,94,15,83,51,34,3,261,91,198]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h,S,w,E,d,l,c,t,n,s,r,o,p,f,_,u,v,R,O,H){"use strict";var ne,ie,U;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let B=class Bn extends k.Disposable{constructor(F,M,$,q,G,le,ve,Re,Se,Oe){super();this._onDidChangeRemoteConnectionData=this._register(new v.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=M,this._extHostContext=$,this._initData=ve,this._extHostWorkspace=q,this._extHostConfiguration=G,this._logService=le,this._extHostTunnelService=Se,this._extHostTerminalService=Oe,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=Re,this._instaService=F.createChild(new f.ServiceCollection([a.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState]));const V=new Set;this._initData.hostExtensions.forEach(X=>V.add(d.ExtensionIdentifier.toKey(X))),this._activator=new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(X,Z,se)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(X,E.transformErrorForSerialization(Z),se)},actualActivateExtension:async(X,Z)=>{if(V.has(d.ExtensionIdentifier.toKey(X)))return await this._mainThreadExtensionsProxy.$activateExtension(X,Z),new g.HostExtension;const se=this._registry.getExtensionDescription(X);return this._activateExtension(se,Z)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(F){E.onUnexpectedError(F)}}async deactivateAll(){let F=[];try{F=this._registry.getAllExtensionDescriptions().map(G=>G.identifier).filter(G=>this.isActivated(G)).map(G=>this._deactivate(G))}catch(M){}await Promise.all(F)}isActivated(F){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(F):!1}_activateByEvent(F,M){return this._activator.activateByEvent(F,M)}_activateById(F,M){return this._activator.activateById(F,M)}activateByIdWithErrors(F,M){return this._activateById(F,M).then(()=>{const $=this._activator.getActivatedExtension(F);if($.activationFailed)return Promise.reject($.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(F=>this._registry)}getExtensionExports(F){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(F).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const F=D.TernarySearchTree.forPaths(),M=this._registry.getAllExtensionDescriptions().map($=>{if(!!this._getEntryPoint($))return this._hostUtils.realpath($.extensionLocation.fsPath).then(q=>F.set(P.URI.file(q).fsPath,$))});this._extensionPathIndex=Promise.all(M).then(()=>F)}return this._extensionPathIndex}_deactivate(F){let M=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(F))return M;const $=this._activator.getActivatedExtension(F);if(!$)return M;try{typeof $.module.deactivate=="function"&&(M=Promise.resolve($.module.deactivate()).then(void 0,q=>Promise.resolve(void 0)))}catch(q){}try{(0,k.dispose)($.subscriptions)}catch(q){}return M}async _activateExtension(F,M){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier),this._doActivateExtension(F,M).then($=>{const q=$.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(F.identifier,q.codeLoadingTime,q.activateCallTime,q.activateResolvedTime,M),this._logExtensionActivationTimes(F,M,"success",q),$},$=>{throw this._logExtensionActivationTimes(F,M,"failure"),$})}_logExtensionActivationTimes(F,M,$,q){const G=x(F,M);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},G),q||{}),{outcome:$}))}_doActivateExtension(F,M){const $=x(F,M);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",$);const q=this._getEntryPoint(F);if(!q)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${F.identifier.value} ${JSON.stringify(M)}`),this._logService.flush();const G=new g.ExtensionActivationTimesBuilder(M.startup);return Promise.all([this._loadCommonJSModule(F.identifier,(0,A.joinPath)(F.extensionLocation,q),G),this._loadExtensionContext(F)]).then(le=>(C.mark(`code/extHost/willActivateExtension/${F.identifier.value}`),Bn._callActivate(this._logService,F.identifier,le[0],le[1],G))).then(le=>(C.mark(`code/extHost/didActivateExtension/${F.identifier.value}`),le))}_loadExtensionContext(F){const M=new c.ExtensionGlobalMemento(F,this._storage),$=new c.ExtensionMemento(F.identifier.value,!1,this._storage),q=new H.ExtensionSecrets(F,this._secretState),G=F.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,le=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${F.identifier.value}`),Promise.all([M.whenReady,$.whenReady,this._storagePath.whenReady]).then(()=>{const ve=this;let Re;return Object.freeze({globalState:M,workspaceState:$,secrets:q,subscriptions:[],get extensionUri(){return F.extensionLocation},get extensionPath(){return F.extensionLocation.fsPath},asAbsolutePath(Se){return T.join(F.extensionLocation.fsPath,Se)},get storagePath(){var Se;return(Se=ve._storagePath.workspaceValue(F))===null||Se===void 0?void 0:Se.fsPath},get globalStoragePath(){return ve._storagePath.globalValue(F).fsPath},get logPath(){return T.join(ve._initData.logsLocation.fsPath,F.identifier.value)},get logUri(){return P.URI.joinPath(ve._initData.logsLocation,F.identifier.value)},get storageUri(){return ve._storagePath.workspaceValue(F)},get globalStorageUri(){return ve._storagePath.globalValue(F)},get extensionMode(){return G},get extension(){return Re===void 0&&(Re=new L(ve,F.identifier,F,le)),Re},get extensionRuntime(){return(0,S.checkProposedApiEnabled)(F),ve.extensionRuntime},get environmentVariableCollection(){return ve._extHostTerminalService.getEnvironmentVariableCollection(F)}})})}static _callActivate(F,M,$,q,G){return $=$||{activate:void 0,deactivate:void 0},this._callActivateOptional(F,M,$,q,G).then(le=>new g.ActivatedExtension(!1,null,G.build(),$,le,q.subscriptions))}static _callActivateOptional(F,M,$,q,G){if(typeof $.activate=="function")try{G.activateCallStart(),F.trace(`ExtensionService#_callActivateOptional ${M.value}`);const le=typeof global=="object"?global:self,ve=$.activate.apply(le,[q]);return G.activateCallStop(),G.activateResolveStart(),Promise.resolve(ve).then(Re=>(G.activateResolveStop(),Re))}catch(le){return Promise.reject(le)}else return Promise.resolve($)}_activateOneStartupFinished(F,M){this._activateById(F.identifier,{startup:!1,extensionId:F.identifier,activationEvent:M}).then(void 0,$=>{this._logService.error($)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks());for(const F of this._registry.getAllExtensionDescriptions())if(F.activationEvents)for(const M of F.activationEvents)M==="onStartupFinished"&&this._activateOneStartupFinished(F,M)}_handleEagerExtensions(){const F=this._activateByEvent("*",!0).then(void 0,G=>{this._logService.error(G)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(G=>this._handleWorkspaceContainsEagerExtensions(G.added)));const M=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],$=this._handleWorkspaceContainsEagerExtensions(M),q=Promise.all([F,$]).then(()=>{});return Promise.race([q,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),q}_handleWorkspaceContainsEagerExtensions(F){return F.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(M=>this._handleWorkspaceContainsEagerExtension(F,M))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(F,M){if(!this.isActivated(M.identifier)){const $=!this._initData.remote.isRemote&&!!this._initData.remote.authority,q={folders:F.map(le=>le.uri),forceUsingSearch:$,exists:le=>this._hostUtils.exists(le.fsPath),checkExists:(le,ve,Re)=>this._mainThreadWorkspaceProxy.$checkExists(le,ve,Re)},G=await(0,R.checkActivateWorkspaceContainsExtension)(q,M);if(!!G)return this._activateById(M.identifier,{startup:!0,extensionId:M.identifier,activationEvent:G.activationEvent}).then(void 0,le=>this._logService.error(le))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(F){throw console.error(F),F}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:F,extensionTestsLocationURI:M}=this._initData.environment;if(!F||!M)throw new Error(b.localize(0,null));const $=await this._loadCommonJSModule(null,M,new g.ExtensionActivationTimesBuilder(!1));if(!$||typeof $.run!="function")throw new Error(b.localize(1,null,M.toString()));return new Promise((q,G)=>{const le=(Se,Oe)=>{Se?G(Se):q(typeof Oe=="number"&&Oe>0?1:0)},ve=(0,A.originalFSPath)(M),Re=$.run(ve,le);Re&&Re.then&&Re.then(()=>{q(0)}).catch(Se=>{G(Se.toString())})})}async $extensionTestsExit(F){this._logService.info(`extension host terminating: test runner requested exit with code ${F}`),this._logService.info(`exiting with code ${F}`),this._logService.flush(),this._hostUtils.exit(F)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(F,M){return this._resolvers[F]=M,(0,k.toDisposable)(()=>{delete this._resolvers[F]})}async $resolveAuthority(F,M){const $=F.indexOf("+");if($===-1)throw new Error("Not an authority that can be resolved!");const q=F.substr(0,$);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${q}`,!1);const G=this._resolvers[q];if(!G)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${q}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(G)),C.mark(`code/extHost/willResolveAuthority/${q}`);const le=await G.resolve(F,{resolveAttempt:M});C.mark(`code/extHost/didResolveAuthorityOK/${q}`);const ve={authority:F,host:le.host,port:le.port,connectionToken:le.connectionToken},Re={extensionHostEnv:le.extensionHostEnv,trust:le.trust};return{type:"ok",value:{authority:ve,options:Re,tunnelInformation:{environmentTunnels:le.environmentTunnels}}}}catch(le){if(C.mark(`code/extHost/didResolveAuthorityError/${q}`),le instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:le._code,message:le._message,detail:le._detail}};throw le}}$startExtensionHost(F){return this._registry.keepOnly(F),this._startExtensionHost()}$activateByEvent(F,M){return M===1?this._activateByEvent(F,!1):this._readyToRunExtensions.wait().then($=>this._activateByEvent(F,!1))}async $activate(F,M){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(F)?(await this._activateById(F,M),!0):!1}async $deltaExtensions(F,M){F.forEach(q=>q.extensionLocation=P.URI.revive(q.extensionLocation));const $=await this.getExtensionPathIndex();return await Promise.all(M.map(async q=>{const G=this._registry.getExtensionDescription(q);if(!!G){const le=await this._hostUtils.realpath(G.extensionLocation.fsPath);$.delete(P.URI.file(le).fsPath)}})),await Promise.all(F.map(async q=>{const G=await this._hostUtils.realpath(q.extensionLocation.fsPath);$.set(P.URI.file(G).fsPath,q)})),this._registry.deltaExtensions(F,M),Promise.resolve(void 0)}async $test_latency(F){return F}async $test_up(F){return F.byteLength}async $test_down(F){let M=l.VSBuffer.alloc(F),$=Math.random()%256;for(let q=0;q<F;q++)M.writeUInt8($,q);return M}async $updateRemoteConnectionData(F){this._remoteConnectionData=F,this._onDidChangeRemoteConnectionData.fire()}};B=qe([He(0,s.IInstantiationService),He(1,e.IHostUtils),He(2,p.IExtHostRpcService),He(3,h.IExtHostWorkspace),He(4,m.IExtHostConfiguration),He(5,i.ILogService),He(6,r.IExtHostInitDataService),He(7,o.IExtensionStoragePaths),He(8,_.IExtHostTunnelService),He(9,u.IExtHostTerminalService)],B),e.AbstractExtHostExtensionService=B;function x(N,F){return{id:N.identifier.value,name:N.name,extensionVersion:N.version,publisherDisplayName:N.publisher,activationEvents:N.activationEvents?N.activationEvents.join(","):null,isBuiltin:N.isBuiltin,reason:F.activationEvent,reasonId:F.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class L{constructor(F,M,$,q){ne.set(this,void 0),ie.set(this,void 0),U.set(this,void 0),it(this,ne,F,"f"),it(this,ie,M,"f"),it(this,U,$.identifier,"f"),this.id=$.identifier.value,this.extensionUri=$.extensionLocation,this.extensionPath=T.normalize((0,A.originalFSPath)($.extensionLocation)),this.packageJSON=$,this.extensionKind=q}get isActive(){return We(this,ne,"f").isActivated(We(this,U,"f"))}get exports(){if(this.packageJSON.api!=="none")return We(this,ne,"f").getExtensionExports(We(this,U,"f"))}activate(){return We(this,ne,"f").activateByIdWithErrors(We(this,U,"f"),{startup:!1,extensionId:We(this,ie,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=L,ne=new WeakMap,ie=new WeakMap,U=new WeakMap}),define(me[47],ge([0,1,8,2,3,14,5,7,123,32,42,39,212,35,205,15,4,11,36,46]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h,S,w,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let l=class{constructor(f,_,u,v,R,O){this._workspaceService=_,this._extensionService=u,this._editorsService=v,this._configurationService=R,this._editorTabs=O,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=f.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(H=>{H.onDidChange(ne=>{this.registerAllDebugTypes(H)}),this.registerAllDebugTypes(H)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(f,_){const u=f;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let v=`debug:${encodeURIComponent(u.path||"")}`,R="?";return _&&(v+=`${R}session=${encodeURIComponent(_.id)}`,R="&"),v+=`${R}ref=${u.sourceReference}`,T.URI.parse(v)}else{if(u.path)return T.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(f){const _=[];for(const u of f.getAllExtensionDescriptions())if(u.contributes){const v=u.contributes.debuggers;if(v&&v.length>0)for(const R of v)(0,a.isDebuggerMainContribution)(R)&&_.push(R.type)}this._debugServiceProxy.$registerDebugTypes(_)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const f=[];return this._breakpoints.forEach(_=>f.push(_)),f}addBreakpoints(f){this.startBreakpoints();const _=f.filter(R=>{const O=R.id;return this._breakpoints.has(O)?!1:(this._breakpoints.set(O,R),!0)});this.fireBreakpointChanges(_,[],[]);const u=[],v=new Map;for(const R of _)if(R instanceof k.SourceBreakpoint){let O=v.get(R.location.uri.toString());O||(O={type:"sourceMulti",uri:R.location.uri,lines:[]},v.set(R.location.uri.toString(),O),u.push(O)),O.lines.push({id:R.id,enabled:R.enabled,condition:R.condition,hitCondition:R.hitCondition,logMessage:R.logMessage,line:R.location.range.start.line,character:R.location.range.start.character})}else R instanceof k.FunctionBreakpoint&&u.push({type:"function",id:R.id,enabled:R.enabled,hitCondition:R.hitCondition,logMessage:R.logMessage,condition:R.condition,functionName:R.functionName});return this._debugServiceProxy.$registerBreakpoints(u)}removeBreakpoints(f){this.startBreakpoints();const _=f.filter(O=>this._breakpoints.delete(O.id));this.fireBreakpointChanges([],_,[]);const u=_.filter(O=>O instanceof k.SourceBreakpoint).map(O=>O.id),v=_.filter(O=>O instanceof k.FunctionBreakpoint).map(O=>O.id),R=_.filter(O=>O instanceof k.DataBreakpoint).map(O=>O.id);return this._debugServiceProxy.$unregisterBreakpoints(u,v,R)}startDebugging(f,_,u){return this._debugServiceProxy.$startDebugging(f?f.uri:void 0,_,{parentSessionID:u.parentSession?u.parentSession.id:void 0,repl:u.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact})}stopDebugging(f){return this._debugServiceProxy.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,_,u){if(!_)return new k.Disposable(()=>{});const v=this._configProviderHandleCounter++;return this._configProviders.push({type:f,handle:v,provider:_}),this._debugServiceProxy.$registerDebugConfigurationProvider(f,u,!!_.provideDebugConfigurations,!!_.resolveDebugConfiguration,!!_.resolveDebugConfigurationWithSubstitutedVariables,v),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(R=>R.provider!==_),this._debugServiceProxy.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(f,_,u){if(!u)return new k.Disposable(()=>{});if(!this.definesDebugType(f,_))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${_}' debugger.`);if(this.getAdapterDescriptorFactoryByType(_))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:_,handle:v,factory:u}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(_,v),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(R=>R.factory!==u),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(f,_){if(!_)return new k.Disposable(()=>{});const u=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:f,handle:u,factory:_}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(v=>v.factory!==_)})}async $runInTerminal(f,_){return Promise.resolve(void 0)}async $substituteVariables(f,_){if(!this._variableResolver){const[R,O]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(R||[],this._editorsService,O)}let u;const v=await this.getFolder(f);return v&&(u={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(u,_)}createDebugAdapter(f,_){if(f.type==="implementation")return new r(f.implementation)}createSignService(){}async $startDASession(f,_){const u=this,v=await this.getSession(_);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(v.type),v).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const O=this.convertToDto(R),H=this.createDebugAdapter(O,v);if(!H)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const ne=H;return this._debugAdapters.set(f,ne),this.getDebugAdapterTrackers(v).then(ie=>(ie&&this._debugAdaptersTrackers.set(f,ie),ne.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const B=U,x={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const L=await this._signService.sign(B.arguments.value);x.body={signature:L},ne.sendResponse(x)}else throw new Error("no signer")}catch(L){x.success=!1,x.message=L.message,ne.sendResponse(x)}}else ie&&ie.onDidSendMessage&&ie.onDidSendMessage(U),U=(0,a.convertToVSCPaths)(U,!0),u._debugServiceProxy.$acceptDAMessage(f,U)}),ne.onError(U=>{ie&&ie.onError&&ie.onError(U),this._debugServiceProxy.$acceptDAError(f,U.name,U.message,U.stack)}),ne.onExit(U=>{ie&&ie.onExit&&ie.onExit((0,w.withNullAsUndefined)(U),void 0),this._debugServiceProxy.$acceptDAExit(f,(0,w.withNullAsUndefined)(U),void 0)}),ie&&ie.onWillStartSession&&ie.onWillStartSession(),ne.startSession()))})}$sendDAMessage(f,_){_=(0,a.convertToDAPaths)(_,!1);const u=this._debugAdaptersTrackers.get(f);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(_);const v=this._debugAdapters.get(f);v&&v.sendMessage(_)}$stopDASession(f){const _=this._debugAdaptersTrackers.get(f);this._debugAdaptersTrackers.delete(f),_&&_.onWillStopSession&&_.onWillStopSession();const u=this._debugAdapters.get(f);return this._debugAdapters.delete(f),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const _=[],u=[],v=[];if(f.added)for(const R of f.added){const O=R.id;if(O&&!this._breakpoints.has(O)){let H;if(R.type==="function")H=new k.FunctionBreakpoint(R.functionName,R.enabled,R.condition,R.hitCondition,R.logMessage);else if(R.type==="data")H=new k.DataBreakpoint(R.label,R.dataId,R.canPersist,R.enabled,R.hitCondition,R.condition,R.logMessage);else{const ne=T.URI.revive(R.uri);H=new k.SourceBreakpoint(new k.Location(ne,new k.Position(R.line,R.character)),R.enabled,R.condition,R.hitCondition,R.logMessage)}H._id=O,this._breakpoints.set(O,H),_.push(H)}}if(f.removed)for(const R of f.removed){const O=this._breakpoints.get(R);O&&(this._breakpoints.delete(R),u.push(O))}if(f.changed){for(const R of f.changed)if(R.id){const O=this._breakpoints.get(R.id);if(O){if(O instanceof k.FunctionBreakpoint&&R.type==="function"){const H=O;H.enabled=R.enabled,H.condition=R.condition,H.hitCondition=R.hitCondition,H.logMessage=R.logMessage,H.functionName=R.functionName}else if(O instanceof k.SourceBreakpoint&&R.type==="source"){const H=O;H.enabled=R.enabled,H.condition=R.condition,H.hitCondition=R.hitCondition,H.logMessage=R.logMessage,H.location=new k.Location(T.URI.revive(R.uri),new k.Position(R.line,R.character))}v.push(O)}}}this.fireBreakpointChanges(_,u,v)}$provideDebugConfigurations(f,_,u){return(0,A.asPromise)(async()=>{const v=this.getConfigProviderByHandle(f);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const R=await this.getFolder(_);return v.provideDebugConfigurations(R,u)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(f,_,u,v){return(0,A.asPromise)(async()=>{const R=this.getConfigProviderByHandle(f);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.getFolder(_);return R.resolveDebugConfiguration(O,u,v)})}$resolveDebugConfigurationWithSubstitutedVariables(f,_,u,v){return(0,A.asPromise)(async()=>{const R=this.getConfigProviderByHandle(f);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.getFolder(_);return R.resolveDebugConfigurationWithSubstitutedVariables(O,u,v)})}async $provideDebugAdapter(f,_){const u=this.getAdapterDescriptorFactoryByHandle(f);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.getSession(_);return this.getAdapterDescriptor(u,v).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.convertToDto(R)})}async $acceptDebugSessionStarted(f){const _=await this.getSession(f);this._onDidStartDebugSession.fire(_)}async $acceptDebugSessionTerminated(f){const _=await this.getSession(f);_&&(this._onDidTerminateDebugSession.fire(_),this._debugSessions.delete(_.id))}async $acceptDebugSessionActiveChanged(f){this._activeDebugSession=f?await this.getSession(f):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(f,_){const u=await this.getSession(f);u&&u._acceptNameChanged(_)}async $acceptDebugSessionCustomEvent(f,_){const v={session:await this.getSession(f),event:_.event,body:_.body};this._onDidReceiveDebugSessionCustomEvent.fire(v)}convertToDto(f){if(f instanceof k.DebugAdapterExecutable)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof k.DebugAdapterServer)return{type:"server",port:f.port,host:f.host};if(f instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:f.path};if(f instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(f){const _=this._adapterFactories.filter(u=>u.type===f);if(_.length>0)return _[0].factory}getAdapterDescriptorFactoryByHandle(f){const _=this._adapterFactories.filter(u=>u.handle===f);if(_.length>0)return _[0].factory}getConfigProviderByHandle(f){const _=this._configProviders.filter(u=>u.handle===f);if(_.length>0)return _[0].provider}definesDebugType(f,_){if(f.contributes){const u=f.contributes.debuggers;if(u&&u.length>0){for(const v of u)if(v.label&&v.type&&v.type===_)return!0}}return!1}getDebugAdapterTrackers(f){const u=f.configuration.type,v=this._trackerFactories.filter(R=>R.type===u||R.type==="*").map(R=>(0,A.asPromise)(()=>R.factory.createDebugAdapterTracker(f)).then(O=>O,O=>null));return Promise.race([Promise.all(v).then(R=>{const O=R.filter(H=>!!H);if(O.length>0)return new s(O)}),new Promise((R,O)=>{const H=setTimeout(()=>{clearTimeout(H),O(new Error("timeout"))},1e3)})]).catch(R=>{})}async getAdapterDescriptor(f,_){const u=_.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new k.DebugAdapterServer(u));if(f){const R=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>f.createDebugAdapterDescriptor(_,this.daExecutableFromPackage(_,R))).then(O=>{if(O)return O})}const v=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(_,v))}daExecutableFromPackage(f,_){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(f,_,u){(f.length>0||_.length>0||u.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:f,removed:_,changed:u}))}async getSession(f){if(f)if(typeof f=="string"){const _=this._debugSessions.get(f);if(_)return _}else{let _=this._debugSessions.get(f.id);if(!_){const u=await this.getFolder(f.folderUri);_=new c(this._debugServiceProxy,f.id,f.type,f.name,u,f.configuration),this._debugSessions.set(_.id,_),this._debugServiceProxy.$sessionCached(_.id)}return _}throw new Error("cannot find session")}getFolder(f){if(f){const _=T.URI.revive(f);return this._workspaceService.resolveWorkspaceFolder(_)}return Promise.resolve(void 0)}};l=qe([He(0,h.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,i.IExtHostExtensionService),He(3,I.IExtHostDocumentsAndEditors),He(4,g.IExtHostConfiguration),He(5,d.IExtHostEditorTabs)],l),e.ExtHostDebugServiceBase=l;class c{constructor(f,_,u,v,R,O){this._debugServiceProxy=f,this._id=_,this._type=u,this._name=v,this._workspaceFolder=R,this._configuration=O}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(f){this._name=f,this._debugServiceProxy.$setDebugSessionName(this._id,f)}_acceptNameChanged(f){this._name=f}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(f,_){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,f,_)}getDebugProtocolBreakpoint(f){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,f.id)}}e.ExtHostDebugSession=c;class t{constructor(f){this.value=Object.freeze({append(_){f.$appendDebugConsole(_)},appendLine(_){this.append(_+`
`)}})}}e.ExtHostDebugConsole=t;class n extends m.AbstractVariableResolverService{constructor(f,_,u,v,R){function O(){if(_){const H=_.activeEditor();if(H)return H.document.uri;const ne=v.tabs.filter(ie=>ie.isActive);if(ne.length>0)return ne[0].resource}}super({getFolderUri:H=>{const ne=f.filter(ie=>ie.name===H);if(ne&&ne.length>0)return ne[0].uri},getWorkspaceFolderCount:()=>f.length,getConfigurationValue:(H,ne)=>u.getConfiguration(void 0,H).get(ne),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const H=O();if(H)return b.normalize(H.fsPath)},getWorkspaceFolderPathForFile:()=>{if(R){const H=O();if(H){const ne=R.getWorkspaceFolder(H);if(ne)return b.normalize(ne.uri.fsPath)}}},getSelectedText:()=>{if(_){const H=_.activeEditor();if(H&&!H.selection.isEmpty)return H.document.getText(H.selection)}},getLineNumber:()=>{if(_){const H=_.activeEditor();if(H)return String(H.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=n;class s{constructor(f){this.trackers=f}onWillStartSession(){this.trackers.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.trackers.forEach(_=>_.onWillReceiveMessage?_.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.trackers.forEach(_=>_.onDidSendMessage?_.onDidSendMessage(f):void 0)}onWillStopSession(){this.trackers.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.trackers.forEach(_=>_.onError?_.onError(f):void 0)}onExit(f,_){this.trackers.forEach(u=>u.onExit?u.onExit(f,_):void 0)}}class r extends D.AbstractDebugAdapter{constructor(f){super();this.implementation=f,f.onDidSendMessage(_=>{this.acceptMessage(_)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.implementation.handleMessage(f)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends l{constructor(f,_,u,v,R,O){super(f,_,u,v,R,O)}createVariableResolver(f,_,u){return new n(f,_,u,this._editorTabs)}};o=qe([He(0,h.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,i.IExtHostExtensionService),He(3,I.IExtHostDocumentsAndEditors),He(4,g.IExtHostConfiguration),He(5,d.IExtHostEditorTabs)],o),e.WorkerExtHostDebugService=o}),define(me[262],ge([0,1,70,2,5,35,41,27,15,28,4,42,36,12]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(d,l,c,t,n,s,r){this._apiFactory=d,this._extensionRegistry=l,this._instaService=c,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=s,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),b.mark("code/extHost/willWaitForConfig");const d=await this._extHostConfiguration.getConfigProvider();b.mark("code/extHost/didWaitForConfig");const l=await this._extHostExtensionService.getExtensionPathIndex();this.register(new h(this._apiFactory,l,this._extensionRegistry,d,this._logService)),this.register(this._instaService.createInstance(S)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,l,this._initData.environment.appUriScheme))}register(d){if(Array.isArray(d.nodeModuleName))for(let l of d.nodeModuleName)this._factories.set(l,d);else this._factories.set(d.nodeModuleName,d);typeof d.alternativeModuleName=="function"&&this._alternatives.push(l=>d.alternativeModuleName(l))}};a=qe([He(2,i.IInstantiationService),He(3,A.IExtHostConfiguration),He(4,I.IExtHostExtensionService),He(5,P.IExtHostInitDataService),He(6,g.ILogService)],a),e.RequireInterceptor=a;class h{constructor(d,l,c,t,n){this._apiFactory=d,this._extensionPaths=l,this._extensionRegistry=c,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(d,l){const c=this._extensionPaths.findSubstr(l.fsPath);if(c){let t=this._extApiImpl.get(k.ExtensionIdentifier.toKey(c.identifier));return t||(t=this._apiFactory(c,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(c.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,s)=>t+=`	${s} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${l.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(d,l){this.nodeModuleName="keytar";const{environment:c}=l,t=d.getProxy(C.MainContext.MainThreadKeytar);if(c.appRoot){let n=c.appRoot.fsPath;m.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,s)=>t.$getPassword(n,s),setPassword:(n,s,r)=>t.$setPassword(n,s,r),deletePassword:(n,s)=>t.$deletePassword(n,s),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(d,l){return this._impl}alternativeModuleName(d){const l=d.length;if(!(l<=7||!this.alternativeNames)){const c=l-7;if((d.charAt(c)==="/"||d.charAt(c)==="\\")&&d.endsWith("keytar")&&(d=d.replace(/\\/g,"/"),this.alternativeNames.has(d)))return"keytar"}}};S=qe([He(0,D.IExtHostRpcService),He(1,P.IExtHostInitDataService)],S);let w=class{constructor(d,l,c){this._extensionPaths=d,this._appUriScheme=l,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=c.getProxy(C.MainContext.MainThreadTelemetry);const t=c.getProxy(C.MainContext.MainThreadWindow);this._impl=(n,s)=>{const r=T.URI.parse(n);return s?this.callOriginal(n,s):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,n,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,n,{}):this.callOriginal(n,s)}}load(d,l,c){const t=this._extensionPaths.findSubstr(l.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=c(d),this._impl}callOriginal(d,l){return this.sendNoForwardTelemetry(),this._original(d,l)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=qe([He(2,D.IExtHostRpcService)],w)}),define(me[263],ge([0,1,169,10,7,206,32,42,39,35,34,15,47,191,14,207,46]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let w=class extends m.ExtHostDebugServiceBase{constructor(l,c,t,n,s,r,o){super(l,c,t,n,s,o);this._terminalService=r,this._integratedTerminalInstances=new E}createDebugAdapter(l,c){switch(l.type){case"server":return new A.SocketDebugAdapter(l);case"pipeServer":return new A.NamedPipeDebugAdapter(l);case"executable":return new A.ExecutableDebugAdapter(l,c.type)}return super.createDebugAdapter(l,c)}daExecutableFromPackage(l,c){const t=A.ExecutableDebugAdapter.platformAdapterExecutable(c.getAllExtensionDescriptions(),l.type);if(t)return new C.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new g.SignService}async $runInTerminal(l,c){if(l.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(R=>{this._integratedTerminalInstances.onTerminalClosed(R)}));const t=await this._configurationService.getConfigProvider(),n=this._terminalService.getDefaultShell(!0,t),s=this._terminalService.getDefaultShellArgs(!0,t),r=JSON.stringify({shell:n,shellArgs:s});let o=await this._integratedTerminalInstances.checkout(r),p,f=!1;if(o)p=l.cwd;else{const R={shellPath:n,shellArgs:s,cwd:l.cwd,name:l.title||b.localize(0,null)};f=!0,o=this._terminalService.createTerminalFromOptions(R,!0),this._integratedTerminalInstances.insert(o,r)}o.show(!0);const _=await o.processId;f?await new Promise(R=>setTimeout(R,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(n.indexOf("powershell")>=0||n.indexOf("pwsh")>=0||n.indexOf("cmd.exe")>=0?o.sendText("cls"):n.indexOf("bash")>=0?o.sendText("clear"):T.isWindows?o.sendText("cls"):o.sendText("clear"));const u=(0,h.prepareCommand)(n,l.args,p,l.env);o.sendText(u);const v=this.onDidTerminateDebugSession(R=>{R.id===c&&(this._integratedTerminalInstances.free(o),v.dispose())});return _}else if(l.kind==="external")return(0,h.runInExternalTerminal)(l,await this._configurationService.getConfigProvider());return super.$runInTerminal(l,c)}createVariableResolver(l,c,t){return new m.ExtHostVariableResolverService(l,c,t,this._editorTabs,this._workspaceService)}};w=qe([He(0,I.IExtHostRpcService),He(1,y.IExtHostWorkspace),He(2,k.IExtHostExtensionService),He(3,D.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,i.IExtHostTerminalService),He(6,S.IExtHostEditorTabs)],w),e.ExtHostDebugService=w;class E{constructor(){this._terminalInstances=new Map}async checkout(l){const t=[...this._terminalInstances.entries()].map(([n,s])=>(0,a.createCancelablePromise)(async r=>{if(s.lastUsedAt!==-1&&await(0,h.hasChildProcesses)(await n.processId))return null;const o=Date.now();return s.lastUsedAt+E.minUseDelay>o||r.isCancellationRequested||s.config!==l?null:(s.lastUsedAt=o,n)}));return await(0,a.firstParallel)(t,n=>!!n)}insert(l,c){this._terminalInstances.set(l,{lastUsedAt:Date.now(),config:c})}free(l){const c=this._terminalInstances.get(l);c&&(c.lastUsedAt=-1)}onTerminalClosed(l){this._terminalInstances.delete(l)}}E.minUseDelay=1e3}),define(me[264],ge([0,1,8,2,79,32,47,39,35,34,15,28,69,13,12,65,46]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let w=class extends m.ExtHostTaskBase{constructor(d,l,c,t,n,s,r,o,p){super(d,l,c,t,n,s,r,o);this.workspaceService=c,this.editorTabs=p,l.remote.isRemote&&l.remote.authority?this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:l.remote.authority,platform:process.platform}):this.registerTaskSystem(g.Schemas.file,{scheme:g.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(d,l){const c=l;if(!l.execution&&c._id===void 0)throw new Error("Tasks to execute must include an execution");if(c._id!==void 0){const t=m.TaskHandleDTO.from(c,this.workspaceService),n=await this._proxy.$getTaskExecution(t);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.getTaskExecution(n,l);return this._proxy.$executeTask(t).catch(()=>{}),s}else{const t=m.TaskDTO.from(l,d);if(t===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,l,!1);const n=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),l);return this._proxy.$executeTask(t).catch(()=>{}),n}}provideTasksInternal(d,l,c,t){const n=[];if(t)for(let s of t){this.checkDeprecation(s,c),(!s.definition||!d[s.definition.type])&&this._logService.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const r=m.TaskDTO.from(s,c.extension);r&&(n.push(r),m.CustomExecutionDTO.is(r.execution)&&l.push(this.addCustomExecution(r,s,!0)))}return{tasks:n,extension:c.extension}}async resolveTaskInternal(d){return d}async getVariableResolver(d){if(this._variableResolver===void 0){const l=await this._configurationService.getConfigProvider();this._variableResolver=new y.ExtHostVariableResolverService(d,this._editorService,l,this.editorTabs,this.workspaceService)}return this._variableResolver}async $resolveVariables(d,l){const c=T.URI.revive(d),t={process:void 0,variables:Object.create(null)},n=await this._workspaceProvider.resolveWorkspaceFolder(c),s=await this._workspaceProvider.getWorkspaceFolders2();if(!s||!n)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const r=await this.getVariableResolver(s),o={uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}};for(let p of l.variables)t.variables[p]=await r.resolveAsync(o,p);if(l.process!==void 0){let p;if(l.process.path!==void 0){p=l.process.path.split(b.delimiter);for(let f=0;f<p.length;f++)p[f]=await r.resolveAsync(o,p[f])}t.process=await C.win32.findExecutable(await r.resolveAsync(o,l.process.name),l.process.cwd!==void 0?await r.resolveAsync(o,l.process.cwd):void 0,p)}return t}$getDefaultShellAndArgs(){return this._terminalService.getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}async $findExecutable(d,l,c){return C.win32.findExecutable(d,l,c)}};w=qe([He(0,i.IExtHostRpcService),He(1,I.IExtHostInitDataService),He(2,A.IExtHostWorkspace),He(3,k.IExtHostDocumentsAndEditors),He(4,D.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,a.ILogService),He(7,h.IExtHostApiDeprecationService),He(8,S.IExtHostEditorTabs)],w),e.ExtHostTask=w}),define(me[265],ge([0,1,10,11,30,150,12,35,47,39,46,15,34,32,210,211]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let S=class extends m.BaseExtHostTerminalService{constructor(E,d,l,c,t,n){super(!0,E);this._extHostConfiguration=d,this._extHostWorkspace=l,this._extHostDocumentsAndEditors=c,this._logService=t,this._extHostEditorTabs=n,(0,A.getSystemShell)(b.OS,process.env).then(s=>this._defaultShell=s),this._updateLastActiveWorkspace(),this._variableResolverPromise=this._updateVariableResolver(),this._registerListeners()}createTerminal(E,d,l){const c=new m.ExtHostTerminal(this._proxy,(0,C.generateUuid)(),{name:E,shellPath:d,shellArgs:l},E);return this._terminals.push(c),c.create(d,l),c.value}createTerminalFromOptions(E,d){const l=new m.ExtHostTerminal(this._proxy,(0,C.generateUuid)(),E,E.name);return this._terminals.push(l),l.create((0,T.withNullAsUndefined)(E.shellPath),(0,T.withNullAsUndefined)(E.shellArgs),(0,T.withNullAsUndefined)(E.cwd),(0,T.withNullAsUndefined)(E.env),(0,T.withNullAsUndefined)(E.icon),(0,T.withNullAsUndefined)(E.message),void 0,(0,T.withNullAsUndefined)(E.strictEnv),(0,T.withNullAsUndefined)(E.hideFromUser),(0,T.withNullAsUndefined)(d),!0),l.value}getDefaultShell(E,d){var l;return a.getDefaultShell(this._buildSafeConfigProvider(d),(l=this._defaultShell)!==null&&l!==void 0?l:(0,A.getSystemShellSync)(b.OS,process.env),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,a.createVariableResolver(this._lastActiveWorkspace,process.env,this._variableResolver),this._logService,E)}getDefaultShellArgs(E,d){return a.getDefaultShellArgs(this._buildSafeConfigProvider(d),E,a.createVariableResolver(this._lastActiveWorkspace,process.env,this._variableResolver),this._logService)}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>{this._variableResolverPromise=this._updateVariableResolver()})}_updateLastActiveWorkspace(){const E=this._extHostDocumentsAndEditors.activeEditor();E&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(E.document.uri))}async _updateVariableResolver(){const E=await this._extHostConfiguration.getConfigProvider(),d=await this._extHostWorkspace.getWorkspaceFolders2();return this._variableResolver=new D.ExtHostVariableResolverService(d||[],this._extHostDocumentsAndEditors,E,this._extHostEditorTabs),this._variableResolver}async $getAvailableProfiles(E){const d=this._buildSafeConfigProvider(await this._extHostConfiguration.getConfigProvider());return(0,h.detectAvailableProfiles)(E,d,void 0,this._logService,await this._variableResolverPromise,this._lastActiveWorkspace)}async getDefaultShellAndArgs(E){const d=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(E,d),args:this.getDefaultShellArgs(E,d)}}_buildSafeConfigProvider(E){const d=E.getConfiguration();return l=>{if(d.get("terminal.integrated.allowWorkspaceConfiguration"))return d.get(l);const t=d.inspect(l);return(t==null?void 0:t.globalValue)||(t==null?void 0:t.defaultValue)}}};S=qe([He(0,I.IExtHostRpcService),He(1,k.IExtHostConfiguration),He(2,g.IExtHostWorkspace),He(3,P.IExtHostDocumentsAndEditors),He(4,y.ILogService),He(5,i.IExtHostEditorTabs)],S),e.ExtHostTerminalService=S}),define(me[266],ge([0,1,14,17,70,6,2,5,256,12,80,83,28,186,15,64,42,34]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(l,c,t,n){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const s=new D.RPCProtocol(l,null,n);c=E._transform(c,s);const r=new I.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());r.set(m.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},c)),r.set(a.IExtHostRpcService,new a.ExtHostRpcService(s)),r.set(h.IURITransformerService,new h.URITransformerService(n)),r.set(S.IHostUtils,t);const o=new g.InstantiationService(r,!0),p=o.invokeFunction(v=>v.get(w.IExtHostTerminalService));this._disposables.add(p),this._logService=o.invokeFunction(v=>v.get(P.ILogService)),C.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",c),this._extensionService=o.invokeFunction(v=>v.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const f=new WeakMap;this._extensionService.getExtensionPathIndex().then(v=>{Error.prepareStackTrace=(R,O)=>{let H="",ne,ie;for(const U of O)H+=`
	at ${U.toString()}`,ie=U.getFileName(),!ne&&ie&&(ne=v.findSubstr(ie));return f.set(R,ne),`${R.name||"Error"}: ${R.message||""}${H}`}});const _=s.getProxy(k.MainContext.MainThreadExtensionService),u=s.getProxy(k.MainContext.MainThreadErrors);T.setUnexpectedErrorHandler(v=>{const R=T.transformErrorForSerialization(v),O=f.get(v);O?_.$onExtensionRuntimeError(O.identifier,R):u.$onUnexpectedError(R)})}terminate(l){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${l}`),this._logService.flush(),this._disposables.dispose(),T.setUnexpectedErrorHandler(t=>{});const c=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,b.timeout)(4e3),c]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(l,c){l.extensions.forEach(n=>n.extensionLocation=y.URI.revive(c.transformIncomingURIs(n.extensionLocation))),l.environment.appRoot=y.URI.revive(c.transformIncomingURIs(l.environment.appRoot));const t=l.environment.extensionDevelopmentLocationURI;return t&&(l.environment.extensionDevelopmentLocationURI=t.map(n=>y.URI.revive(c.transformIncomingURIs(n)))),l.environment.extensionTestsLocationURI=y.URI.revive(c.transformIncomingURIs(l.environment.extensionTestsLocationURI)),l.environment.globalStorageHome=y.URI.revive(c.transformIncomingURIs(l.environment.globalStorageHome)),l.environment.workspaceStorageHome=y.URI.revive(c.transformIncomingURIs(l.environment.workspaceStorageHome)),l.logsLocation=y.URI.revive(c.transformIncomingURIs(l.logsLocation)),l.logFile=y.URI.revive(c.transformIncomingURIs(l.logFile)),l.workspace=c.transformIncomingURIs(l.workspace),l}}e.ExtensionHostMain=E}),define(me[267],ge([0,1,8,21,61,33,25,48,31]),function(K,e,b,T,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(m,g,a){this.config=m,this.provider=g,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&A.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&A.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const g=this.config.folderQueries||[];return new Promise((a,h)=>{const S=w=>{this.resultCount++,m(w)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const E=w.toString(),d=b.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,d)||this.matchFile(S,{base:w,basename:d})}),Promise.all(g.map(w=>this.searchInFolder(w,S))).then(w=>{a({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{h(new Error((0,C.toErrorMessage)(w)))})})}async searchInFolder(m,g){const a=new T.CancellationTokenSource,h=this.getSearchOptionsForFolder(m),S=this.initDirectoryTree(),w=new D.QueryGlobTester(this.config,m),E=!w.hasSiblingExcludeClauses();let d;try{this.activeCancellationTokens.add(a),d=k.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},h,a.token),c=d.elapsed(),t=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(n=>{const s=b.posix.relative(m.folder.path,n.path);if(E){const r=b.basename(n.path);this.matchFile(g,{base:m.folder,relativePath:s,basename:r});return}this.addDirectoryEntries(S,m.folder,s,g)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(S,w,g),{providerTime:c,postProcessTime:t.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(m){const g=(0,D.resolvePatternsForProvider)(this.config.includePattern,m.includePattern),a=(0,D.resolvePatternsForProvider)(this.config.excludePattern,m.excludePattern);return{folder:m.folder,excludes:a,includes:g,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},g,a,h){if(a===this.filePattern){const w=b.basename(this.filePattern);this.matchFile(h,{base:g,relativePath:this.filePattern,basename:w})}function S(w){const E=b.basename(w),d=b.dirname(w);let l=m[d];l||(l=m[d]=[],S(d)),l.push({base:g,relativePath:w,basename:E})}S(a)}matchDirectoryTree({rootEntries:m,pathToEntries:g},a,h){const S=this,w=this.filePattern;function E(d){const l=A.hasSiblingFn(()=>d.map(c=>c.basename));for(let c=0,t=d.length;c<t;c++){const n=d[c],{relativePath:s,basename:r}=n;if(!!a.includedInQuerySync(s,r,w!==r?l:void 0)){const o=g[s];if(o)E(o);else{if(s===w)continue;S.matchFile(h,n)}if(S.isLimitHit)break}}}E(m)}matchFile(m,g){(!this.includePattern||g.relativePath&&this.includePattern(g.relativePath,g.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(g))}}class i{constructor(){this.sessions=new Map}fileSearch(m,g,a,h){const S=this.getSessionTokenSource(m.cacheKey),w=new P(m,g,S&&S.token);let E=0;const d=l=>{E+=l.length,a(l.map(c=>this.rawMatchToSearchItem(c)))};return this.doSearch(w,i.BATCH_SIZE,d,h).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:l.stats}}))}clearCache(m){const g=this.getSessionTokenSource(m);g&&g.cancel()}getSessionTokenSource(m){if(!!m)return this.sessions.has(m)||this.sessions.set(m,new T.CancellationTokenSource),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:y.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,g,a,h){h.onCancellationRequested(()=>{m.cancel()});const S=E=>{E&&(w.push(E),g>0&&w.length>=g&&(a(w),w=[]))};let w=[];return m.search(S).then(E=>(w.length&&a(w),E),E=>(w.length&&a(w),Promise.reject(E)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(me[130],ge([0,1,8,16,21,61,25,33,2,31,13,11]),function(K,e,b,T,C,A,y,k,D,P,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class m{constructor(d,l,c){this.query=d,this.provider=l,this.fileUtils=c,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(d,l){const c=this.query.folderQueries||[],t=new C.CancellationTokenSource;return l.onCancellationRequested(()=>t.cancel()),new Promise((n,s)=>{this.collector=new a(d);let r=!1;const o=(p,f)=>{if(!r&&!this.isLimitHit){const _=this.resultSize(p);S(p)&&typeof this.query.maxResults=="number"&&this.resultCount+_>this.query.maxResults&&(this.isLimitHit=!0,r=!0,t.cancel(),p=this.trimResultToSize(p,this.query.maxResults-this.resultCount));const u=this.resultSize(p);this.resultCount+=u,(u>0||!S(p))&&this.collector.add(p,f)}};Promise.all(c.map((p,f)=>this.searchInFolder(p,_=>o(_,f),t.token))).then(p=>{t.dispose(),this.collector.flush();const f=p.some(_=>!!_&&!!_.limitHit);n({limitHit:this.isLimitHit||f,messages:(0,T.flatten)(p.map(_=>(_==null?void 0:_.message)?(0,I.isArray)(_.message)?_.message:[_.message]:[])),stats:{type:"textSearchProvider"}})},p=>{t.dispose();const f=(0,A.toErrorMessage)(p);s(new Error(f))})})}resultSize(d){return S(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,l){const c=Array.isArray(d.ranges)?d.ranges:[d.ranges],t=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:c.slice(0,l),preview:{matches:t.slice(0,l),text:d.preview.text},uri:d.uri}}async searchInFolder(d,l,c){const t=new P.QueryGlobTester(this.query,d),n=[],s={report:p=>{if(!!this.validateProviderResult(p)){const f=d.folder.scheme===i.Schemas.file?k.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(p.uri))):void 0,_=y.relativePath(d.folder,p.uri);_&&n.push(t.includedInQuery(_,b.basename(_),f).then(u=>{u&&l(p)}))}}},r=this.getSearchOptionsForFolder(d),o=await this.provider.provideTextSearchResults(g(this.query.contentPattern),r,s,c);return await Promise.all(n),o}validateProviderResult(d){if(S(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const l=(0,P.resolvePatternsForProvider)(this.query.includePattern,d.includePattern),c=(0,P.resolvePatternsForProvider)(this.query.excludePattern,d.excludePattern),t={folder:D.URI.from(d.folder),excludes:c,includes:l,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=m;function g(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class a{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,l=>this.sendItems(l))}add(d,l){this._currentFileMatch&&(this._currentFolderIdx!==l||!y.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=l,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(h(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=a;function h(E){return S(E)?{preview:{matches:(0,T.mapArrayOrNot)(E.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:E.preview.text},ranges:(0,T.mapArrayOrNot)(E.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function S(E){return!!E.preview}e.extensionResultIsMatch=S;class w{constructor(d,l){this.maxBatchSize=d,this.cb=l,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,l){!d||this.addItemToBatch(d,l)}addItems(d,l){!d||this.addItemsToBatch(d,l)}addItemToBatch(d,l){this.batch.push(d),this.batchSize+=l,this.onUpdate()}addItemsToBatch(d,l){this.batch=this.batch.concat(d),this.batchSize+=l,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(me[71],ge([0,1,6,5,4,267,15,64,12,2,130]),function(K,e,b,T,C,A,y,k,D,P,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let I=class{constructor(h,S,w){this.extHostRpc=h,this._uriTransformer=S,this._logService=w,this._proxy=this.extHostRpc.getProxy(T.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,S){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const w=this._handlePool++;return this._textSearchProvider.set(w,S),this._proxy.$registerTextSearchProvider(w,this._transformScheme(h)),(0,b.toDisposable)(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(h,S){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const w=this._handlePool++;return this._fileSearchProvider.set(w,S),this._proxy.$registerFileSearchProvider(w,this._transformScheme(h)),(0,b.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(h,S,w,E){const d=m(w),l=this._fileSearchProvider.get(h);if(l)return this._fileSearchManager.fileSearch(d,l,c=>{this._proxy.$handleFileMatch(h,S,c.map(t=>t.resource))},E);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,S,w,E){const d=this._textSearchProvider.get(h);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const l=m(w);return this.createTextSearchManager(l,d).search(t=>this._proxy.$handleTextMatch(h,S,t),E)}createTextSearchManager(h,S){return new i.TextSearchManager(h,S,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};I=qe([He(0,y.IExtHostRpcService),He(1,k.IURITransformerService),He(2,D.ILogService)],I),e.ExtHostSearch=I;function m(a){return Object.assign(Object.assign({},a),{folderQueries:a.folderQueries&&a.folderQueries.map(g),extraFileResources:a.extraFileResources&&a.extraFileResources.map(h=>P.URI.revive(h))})}e.reviveQuery=m;function g(a){return Object.assign(Object.assign({},a),{folder:P.URI.revive(a.folder)})}}),define(me[268],ge([0,1,161,21,17,3,59,2,152,110,142,78,45,5,230,229,52,231,35,232,233,234,215,235,39,42,236,216,238,239,240,66,219,243,244,245,93,34,246,220,20,7,249,67,129,32,41,54,202,237,119,128,69,47,71,12,64,15,28,241,200,51,65,227,247,199,94,92,252,250,251,228,63,259,248,91,46,121,242,86,68]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h,S,w,E,d,l,c,t,n,s,r,o,p,f,_,u,v,R,O,H,ne,ie,U,B,x,L,N,F,M,$,q,G,le,ve,Re,Se,Oe,V,X,Z,se,fe,Ee,Be,pe,Ce,Me,ze,_e,Ke,Q,te,we,xe,je,Ve,Je,De,ye,Pe,oe,ue,z,J,ce,Ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ae(Le){const $e=Le.get(Be.IExtHostInitDataService),Xe=Le.get(De.IExtHostFileSystemInfo),rt=Le.get(we.IExtHostConsumerFileSystem),tt=Le.get(r.IExtHostExtensionService),Qe=Le.get(q.IExtHostWorkspace),gt=Le.get(z.IExtHostTelemetry),wt=Le.get(E.IExtHostConfiguration),be=Le.get(fe.IURITransformerService),he=Le.get(Ee.IExtHostRpcService),ae=Le.get(ie.IExtHostStorage),Y=Le.get(te.IExtensionStoragePaths),Ne=Le.get(se.ILogService),Fe=Le.get(Me.IExtHostTunnelService),Ye=Le.get(ze.IExtHostApiDeprecationService),et=Le.get($.IExtHostWindow),ct=Le.get(oe.IExtHostSecretState),ut=Le.get(ue.IExtHostEditorTabs);he.set(g.ExtHostContext.ExtHostFileSystemInfo,Xe),he.set(g.ExtHostContext.ExtHostLogService,Ne),he.set(g.ExtHostContext.ExtHostWorkspace,Qe),he.set(g.ExtHostContext.ExtHostConfiguration,wt),he.set(g.ExtHostContext.ExtHostExtensionService,tt),he.set(g.ExtHostContext.ExtHostStorage,ae),he.set(g.ExtHostContext.ExtHostTunnelService,Fe),he.set(g.ExtHostContext.ExtHostWindow,et),he.set(g.ExtHostContext.ExtHostSecretState,ct),he.set(g.ExtHostContext.ExtHostTelemetry,gt),he.set(g.ExtHostContext.ExtHostEditorTabs,ut);const Ze=he.set(g.ExtHostContext.ExtHostDecorations,Le.get(Oe.IExtHostDecorations)),mt=he.set(g.ExtHostContext.ExtHostDocumentsAndEditors,Le.get(s.IExtHostDocumentsAndEditors)),ht=he.set(g.ExtHostContext.ExtHostCommands,Le.get(S.IExtHostCommands)),ft=he.set(g.ExtHostContext.ExtHostTerminalService,Le.get(U.IExtHostTerminalService)),at=he.set(g.ExtHostContext.ExtHostDebugService,Le.get(X.IExtHostDebugService)),yt=he.set(g.ExtHostContext.ExtHostSearch,Le.get(Z.IExtHostSearch)),St=he.set(g.ExtHostContext.ExtHostTask,Le.get(V.IExtHostTask)),Nt=he.set(g.ExtHostContext.ExtHostOutputService,Le.get(v.IExtHostOutputService)),Rt=he.set(g.ExtHostContext.ExtHostUrls,new F.ExtHostUrls(he)),_t=he.set(g.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(he,mt)),Jt=he.set(g.ExtHostContext.ExtHostDocumentContentProviders,new c.ExtHostDocumentContentProvider(he,mt,Ne)),Zt=he.set(g.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Ne,_t,he.getProxy(g.MainContext.MainThreadBulkEdits))),pt=he.set(g.ExtHostContext.ExtHostNotebook,new pe.ExtHostNotebookController(he,ht,mt,_t,Ne,Y)),en=he.set(g.ExtHostContext.ExtHostNotebookKernels,new J.ExtHostNotebookKernels(he,$e,pt,Ne)),Ct=he.set(g.ExtHostContext.ExtHostEditors,new B.ExtHostEditors(he,mt)),Kt=he.set(g.ExtHostContext.ExtHostTreeViews,new x.ExtHostTreeViews(he.getProxy(g.MainContext.MainThreadTreeViews),ht,Ne)),tn=he.set(g.ExtHostContext.ExtHostEditorInsets,new ve.ExtHostEditorInsets(he.getProxy(g.MainContext.MainThreadEditorInsets),Ct,Object.assign(Object.assign({},$e.environment),{remote:$e.remote}))),Gt=he.set(g.ExtHostContext.ExtHostDiagnostics,new d.ExtHostDiagnostics(he,Ne)),lt=he.set(g.ExtHostContext.ExtHostLanguageFeatures,new f.ExtHostLanguageFeatures(he,be,_t,ht,Gt,Ne,Ye)),nn=he.set(g.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(he,lt)),Lt=he.set(g.ExtHostContext.ExtHostFileSystemEventService,new p.ExtHostFileSystemEventService(he,Ne,mt)),$t=he.set(g.ExtHostContext.ExtHostQuickOpen,(0,O.createExtHostQuickOpen)(he,Qe,ht)),mn=he.set(g.ExtHostContext.ExtHostSCM,new H.ExtHostSCM(he,ht,Ne)),yn=he.set(g.ExtHostContext.ExtHostComments,new w.ExtHostComments(he,ht,_t)),gn=he.set(g.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(he.getProxy(g.MainContext.MainThreadProgress))),rn=he.set(g.ExtHostContext.ExtHosLabelService,new Re.ExtHostLabelService(he)),Qt=he.set(g.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(he)),Ut=he.set(g.ExtHostContext.ExtHostAuthentication,new _e.ExtHostAuthentication(he)),Dn=he.set(g.ExtHostContext.ExtHostTimeline,new Ke.ExtHostTimeline(he,ht)),sn=he.set(g.ExtHostContext.ExtHostWebviews,new M.ExtHostWebviews(he,Object.assign(Object.assign({},$e.environment),{remote:$e.remote}),Qe,Ne,Ye)),on=he.set(g.ExtHostContext.ExtHostWebviewPanels,new Ve.ExtHostWebviewPanels(he,sn,Qe)),Xt=he.set(g.ExtHostContext.ExtHostCustomEditors,new je.ExtHostCustomEditors(he,_t,Y,sn,on)),Cn=he.set(g.ExtHostContext.ExtHostWebviewViews,new xe.ExtHostWebviewViews(he,sn)),Ft=he.set(g.ExtHostContext.ExtHostTesting,new ye.ExtHostTesting(he,mt,Qe)),an=he.set(g.ExtHostContext.ExtHostUriOpeners,new Pe.ExtHostUriOpeners(he)),kn=(0,le.values)(g.ExtHostContext);he.assertRegistered(kn);const Ht=new Je.ExtHostBulkEdits(he,mt),ln=new h.ExtHostClipboard(he),xt=new u.ExtHostMessageService(he,Ne),At=new l.ExtHostDialogs(he),pn=new ne.ExtHostStatusBar(he,ht.converter),Bt=new _.ExtHostLanguages(he,_t);return a.ExtHostApiCommands.register(ht),function(Ue,cn,un){const vt=function(){let ee=!Ue.isUnderDevelopment;function de(Te){ee||(Ne.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Te(st){if(Array.isArray(st))st.forEach(Te);else if(typeof st=="string")de(st);else{const bt=st;typeof bt.scheme=="undefined"&&de(st),!Ue.enableProposedApi&&typeof bt.exclusive=="boolean"&&(0,G.throwProposedApiError)(Ue)}return st}}(),Pn={getSession(ee,de,Te){return Ut.getSession(Ue,ee,de,Te)},get onDidChangeSessions(){return Ut.onDidChangeSessions},registerAuthenticationProvider(ee,de,Te,st){return Ut.registerAuthenticationProvider(ee,de,Te,st)},get onDidChangeAuthenticationProviders(){return(0,G.checkProposedApiEnabled)(Ue),Ut.onDidChangeAuthenticationProviders},get providers(){return(0,G.checkProposedApiEnabled)(Ue),Ut.providers},logout(ee,de){return(0,G.checkProposedApiEnabled)(Ue),Ut.removeSession(ee,de)}},In={registerCommand(ee,de,Te){return ht.registerCommand(!0,ee,de,Te)},registerTextEditorCommand(ee,de,Te){return ht.registerCommand(!0,ee,(...st)=>{const bt=Ct.getActiveTextEditor();if(!bt){Ne.warn("Cannot execute "+ee+" because there is no active text editor.");return}return bt.edit(kt=>{de.apply(Te,[bt,kt,...st])}).then(kt=>{kt||Ne.warn("Edits from command "+ee+" were not applied.")},kt=>{Ne.warn("An error occurred while running command "+ee,kt)})})},registerDiffInformationCommand:(ee,de,Te)=>((0,G.checkProposedApiEnabled)(Ue),ht.registerCommand(!0,ee,async(...st)=>{const bt=mt.activeEditor(!0);if(!bt){Ne.warn("Cannot execute "+ee+" because there is no active text editor.");return}const kt=await Ct.getDiffInformation(bt.id);de.apply(Te,[kt,...st])})),executeCommand(ee,...de){return ht.executeCommand(ee,...de)},getCommands(ee=!1){return ht.getCommands(ee)}},vn={get machineId(){return $e.telemetryInfo.machineId},get sessionId(){return $e.telemetryInfo.sessionId},get language(){return $e.environment.appLanguage},get appName(){return $e.environment.appName},get appRoot(){var ee,de;return(de=(ee=$e.environment.appRoot)===null||ee===void 0?void 0:ee.fsPath)!==null&&de!==void 0?de:""},get uriScheme(){return $e.environment.appUriScheme},get clipboard(){return ln.value},get shell(){return ft.getDefaultShell(!1,un)},get isTelemetryEnabled(){return gt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return gt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ee=Date.now()-new Date($e.telemetryInfo.firstSessionDate).getTime();return isNaN(ee)?!1:ee<1e3*60*60*24},openExternal(ee,de){return et.openUri(ee,{allowTunneling:!!$e.remote.authority,allowContributedOpeners:de==null?void 0:de.allowContributedOpeners})},asExternalUri(ee){return ee.scheme===$e.environment.appUriScheme?Rt.createAppUri(ee):et.asExternalUri(ee,{allowTunneling:!!$e.remote.authority})},get remoteName(){return(0,Se.getRemoteName)($e.remote.authority)},get uiKind(){return $e.uiKind}};$e.environment.extensionTestsLocationURI||Object.freeze(vn);const wn=$e.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,zt={registerTestController(ee){return(0,G.checkProposedApiEnabled)(Ue),Ft.registerTestController(Ue.identifier.value,ee)},createDocumentTestObserver(ee){return(0,G.checkProposedApiEnabled)(Ue),Ft.createTextDocumentTestObserver(ee)},createWorkspaceTestObserver(ee){return(0,G.checkProposedApiEnabled)(Ue),Ft.createWorkspaceTestObserver(ee)},runTests(ee){return(0,G.checkProposedApiEnabled)(Ue),Ft.runTests(ee)},createTestItem(ee,de){return new N.TestItemImpl(ee.id,ee.label,ee.uri,de)},createTestRun(ee,de,Te){return(0,G.checkProposedApiEnabled)(Ue),Ft.createTestRun(Ue.identifier.value,ee,de,Te)},get onDidChangeTestResults(){return(0,G.checkProposedApiEnabled)(Ue),Ft.onResultsChanged},get testResults(){return(0,G.checkProposedApiEnabled)(Ue),Ft.results}};zt.createTestRunTask=zt.createTestRun;const An={getExtension(ee){const de=cn.getExtensionDescription(ee);if(de)return new r.Extension(tt,Ue.identifier,de,wn)},get all(){return cn.getAllExtensionDescriptions().map(ee=>new r.Extension(tt,Ue.identifier,ee,wn))},get onDidChange(){return cn.onDidChange}},Tn={createDiagnosticCollection(ee){return Gt.createDiagnosticCollection(Ue.identifier,ee)},get onDidChangeDiagnostics(){return Gt.onDidChangeDiagnostics},getDiagnostics:ee=>Gt.getDiagnostics(ee),getLanguages(){return Bt.getLanguages()},setTextDocumentLanguage(ee,de){return Bt.changeLanguage(ee.uri,de)},match(ee,de){return(0,I.score)(L.LanguageSelector.from(ee),de.uri,de.languageId,!0)},registerCodeActionsProvider(ee,de,Te){return lt.registerCodeActionProvider(Ue,vt(ee),de,Te)},registerCodeLensProvider(ee,de){return lt.registerCodeLensProvider(Ue,vt(ee),de)},registerDefinitionProvider(ee,de){return lt.registerDefinitionProvider(Ue,vt(ee),de)},registerDeclarationProvider(ee,de){return lt.registerDeclarationProvider(Ue,vt(ee),de)},registerImplementationProvider(ee,de){return lt.registerImplementationProvider(Ue,vt(ee),de)},registerTypeDefinitionProvider(ee,de){return lt.registerTypeDefinitionProvider(Ue,vt(ee),de)},registerHoverProvider(ee,de){return lt.registerHoverProvider(Ue,vt(ee),de,Ue.identifier)},registerEvaluatableExpressionProvider(ee,de){return lt.registerEvaluatableExpressionProvider(Ue,vt(ee),de,Ue.identifier)},registerInlineValuesProvider(ee,de){return lt.registerInlineValuesProvider(Ue,vt(ee),de,Ue.identifier)},registerDocumentHighlightProvider(ee,de){return lt.registerDocumentHighlightProvider(Ue,vt(ee),de)},registerLinkedEditingRangeProvider(ee,de){return lt.registerLinkedEditingRangeProvider(Ue,vt(ee),de)},registerReferenceProvider(ee,de){return lt.registerReferenceProvider(Ue,vt(ee),de)},registerRenameProvider(ee,de){return lt.registerRenameProvider(Ue,vt(ee),de)},registerDocumentSymbolProvider(ee,de,Te){return lt.registerDocumentSymbolProvider(Ue,vt(ee),de,Te)},registerWorkspaceSymbolProvider(ee){return lt.registerWorkspaceSymbolProvider(Ue,ee)},registerDocumentFormattingEditProvider(ee,de){return lt.registerDocumentFormattingEditProvider(Ue,vt(ee),de)},registerDocumentRangeFormattingEditProvider(ee,de){return lt.registerDocumentRangeFormattingEditProvider(Ue,vt(ee),de)},registerOnTypeFormattingEditProvider(ee,de,Te,...st){return lt.registerOnTypeFormattingEditProvider(Ue,vt(ee),de,[Te].concat(st))},registerDocumentSemanticTokensProvider(ee,de,Te){return lt.registerDocumentSemanticTokensProvider(Ue,vt(ee),de,Te)},registerDocumentRangeSemanticTokensProvider(ee,de,Te){return lt.registerDocumentRangeSemanticTokensProvider(Ue,vt(ee),de,Te)},registerSignatureHelpProvider(ee,de,Te,...st){return typeof Te=="object"?lt.registerSignatureHelpProvider(Ue,vt(ee),de,Te):lt.registerSignatureHelpProvider(Ue,vt(ee),de,typeof Te=="undefined"?[]:[Te,...st])},registerCompletionItemProvider(ee,de,...Te){return lt.registerCompletionItemProvider(Ue,vt(ee),de,Te)},registerDocumentLinkProvider(ee,de){return lt.registerDocumentLinkProvider(Ue,vt(ee),de)},registerColorProvider(ee,de){return lt.registerColorProvider(Ue,vt(ee),de)},registerFoldingRangeProvider(ee,de){return lt.registerFoldingRangeProvider(Ue,vt(ee),de)},registerSelectionRangeProvider(ee,de){return lt.registerSelectionRangeProvider(Ue,ee,de)},registerCallHierarchyProvider(ee,de){return lt.registerCallHierarchyProvider(Ue,ee,de)},setLanguageConfiguration:(ee,de)=>lt.setLanguageConfiguration(Ue,ee,de),getTokenInformationAtPosition(ee,de){return(0,G.checkProposedApiEnabled)(Ue),Bt.tokenAtPosition(ee,de)},registerInlayHintsProvider(ee,de){return(0,G.checkProposedApiEnabled)(Ue),lt.registerInlayHintsProvider(Ue,ee,de)}},Rn={get activeTextEditor(){return Ct.getActiveTextEditor()},get visibleTextEditors(){return Ct.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(ee,de,Te){const st=await(k.URI.isUri(ee)?Promise.resolve(bn.openTextDocument(ee)):Promise.resolve(ee));return Ct.showTextDocument(st,de,Te)},createTextEditorDecorationType(ee){return Ct.createTextEditorDecorationType(ee)},onDidChangeActiveTextEditor(ee,de,Te){return Ct.onDidChangeActiveTextEditor(ee,de,Te)},onDidChangeVisibleTextEditors(ee,de,Te){return Ct.onDidChangeVisibleTextEditors(ee,de,Te)},onDidChangeTextEditorSelection(ee,de,Te){return Ct.onDidChangeTextEditorSelection(ee,de,Te)},onDidChangeTextEditorOptions(ee,de,Te){return Ct.onDidChangeTextEditorOptions(ee,de,Te)},onDidChangeTextEditorVisibleRanges(ee,de,Te){return Ct.onDidChangeTextEditorVisibleRanges(ee,de,Te)},onDidChangeTextEditorViewColumn(ee,de,Te){return Ct.onDidChangeTextEditorViewColumn(ee,de,Te)},onDidCloseTerminal(ee,de,Te){return ft.onDidCloseTerminal(ee,de,Te)},onDidOpenTerminal(ee,de,Te){return ft.onDidOpenTerminal(ee,de,Te)},onDidChangeActiveTerminal(ee,de,Te){return ft.onDidChangeActiveTerminal(ee,de,Te)},onDidChangeTerminalDimensions(ee,de,Te){return(0,G.checkProposedApiEnabled)(Ue),ft.onDidChangeTerminalDimensions(ee,de,Te)},onDidWriteTerminalData(ee,de,Te){return(0,G.checkProposedApiEnabled)(Ue),ft.onDidWriteTerminalData(ee,de,Te)},get state(){return et.state},onDidChangeWindowState(ee,de,Te){return et.onDidChangeWindowState(ee,de,Te)},showInformationMessage(ee,...de){return xt.showMessage(Ue,y.default.Info,ee,de[0],de.slice(1))},showWarningMessage(ee,...de){return xt.showMessage(Ue,y.default.Warning,ee,de[0],de.slice(1))},showErrorMessage(ee,...de){return xt.showMessage(Ue,y.default.Error,ee,de[0],de.slice(1))},showQuickPick(ee,de,Te){return $t.showQuickPick(ee,!!Ue.enableProposedApi,de,Te)},showWorkspaceFolderPick(ee){return $t.showWorkspaceFolderPick(ee)},showInputBox(ee,de){return $t.showInput(ee,de)},showOpenDialog(ee){return At.showOpenDialog(ee)},showSaveDialog(ee){return At.showSaveDialog(ee)},createStatusBarItem(ee,de){let Te,st,bt,kt;return ee&&typeof ee!="number"?(Te=ee.id,st=ee.name,bt=ee.alignment,de=ee.priority,kt=ee.accessibilityInformation):(Te=Ue.identifier.value,st=b.localize(0,null,Ue.displayName||Ue.name),bt=ee),pn.createStatusBarEntry(Te,st,bt,de,kt)},setStatusBarMessage(ee,de){return pn.setStatusBarMessage(ee,de)},withScmProgress(ee){return Ye.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),gn.withProgress(Ue,{location:N.ProgressLocation.SourceControl},(de,Te)=>ee({report(st){}}))},withProgress(ee,de){return gn.withProgress(Ue,ee,de)},createOutputChannel(ee){return Nt.createOutputChannel(ee)},createWebviewPanel(ee,de,Te,st){return on.createWebviewPanel(Ue,ee,de,Te,st)},createWebviewTextEditorInset(ee,de,Te,st){return(0,G.checkProposedApiEnabled)(Ue),tn.createWebviewEditorInset(ee,de,Te,st,Ue)},createTerminal(ee,de,Te){return typeof ee=="object"?"pty"in ee?ft.createExtensionTerminal(ee):(ee.icon&&(0,G.checkProposedApiEnabled)(Ue),ft.createTerminalFromOptions(ee)):ft.createTerminal(ee,de,Te)},registerTerminalLinkProvider(ee){return ft.registerLinkProvider(ee)},registerTreeDataProvider(ee,de){return Kt.registerTreeDataProvider(ee,de,Ue)},createTreeView(ee,de){return Kt.createTreeView(ee,de,Ue)},registerWebviewPanelSerializer:(ee,de)=>on.registerWebviewPanelSerializer(Ue,ee,de),registerCustomEditorProvider:(ee,de,Te={})=>Xt.registerCustomEditorProvider(Ue,ee,de,Te),registerFileDecorationProvider(ee){return Ze.registerFileDecorationProvider(ee,Ue.identifier)},registerUriHandler(ee){return Rt.registerUriHandler(Ue.identifier,ee)},createQuickPick(){return $t.createQuickPick(Ue.identifier,!!Ue.enableProposedApi)},createInputBox(){return $t.createInputBox(Ue.identifier)},get activeColorTheme(){return Qt.activeColorTheme},onDidChangeActiveColorTheme(ee,de,Te){return Qt.onDidChangeActiveColorTheme(ee,de,Te)},registerWebviewViewProvider(ee,de,Te){return Cn.registerWebviewViewProvider(Ue,ee,de,Te==null?void 0:Te.webviewOptions)},get activeNotebookEditor(){return(0,G.checkProposedApiEnabled)(Ue),pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,de,Te){return(0,G.checkProposedApiEnabled)(Ue),pt.onDidChangeActiveNotebookEditor(ee,de,Te)},get visibleNotebookEditors(){return(0,G.checkProposedApiEnabled)(Ue),pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,G.checkProposedApiEnabled)(Ue),pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ee,de,Te){return(0,G.checkProposedApiEnabled)(Ue),pt.onDidChangeNotebookEditorSelection(ee,de,Te)},onDidChangeNotebookEditorVisibleRanges(ee,de,Te){return(0,G.checkProposedApiEnabled)(Ue),pt.onDidChangeNotebookEditorVisibleRanges(ee,de,Te)},showNotebookDocument(ee,de){return(0,G.checkProposedApiEnabled)(Ue),pt.showNotebookDocument(ee,de)},registerExternalUriOpener(ee,de,Te){return(0,G.checkProposedApiEnabled)(Ue),an.registerExternalUriOpener(Ue.identifier,ee,de,Te)},get openEditors(){return(0,G.checkProposedApiEnabled)(Ue),ut.tabs},get onDidChangeOpenEditors(){return(0,G.checkProposedApiEnabled)(Ue),ut.onDidChangeTabs}},bn={get rootPath(){return Ye.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Qe.getPath()},set rootPath(ee){throw C.readonly()},getWorkspaceFolder(ee){return Qe.getWorkspaceFolder(ee)},get workspaceFolders(){return Qe.getWorkspaceFolders()},get name(){return Qe.name},set name(ee){throw C.readonly()},get workspaceFile(){return Qe.workspaceFile},set workspaceFile(ee){throw C.readonly()},updateWorkspaceFolders:(ee,de,...Te)=>Qe.updateWorkspaceFolders(Ue,ee,de||0,...Te),onDidChangeWorkspaceFolders:function(ee,de,Te){return Qe.onDidChangeWorkspace(ee,de,Te)},asRelativePath:(ee,de)=>Qe.getRelativePath(ee,de),findFiles:(ee,de,Te,st)=>Qe.findFiles(L.GlobPattern.from(ee),L.GlobPattern.from(de),Te,Ue.identifier,st),findTextInFiles:(ee,de,Te,st)=>{let bt,kt;return typeof de=="object"?(bt=de,kt=Te):(bt={},kt=de,st=Te),Qe.findTextInFiles(ee,bt||{},kt,Ue.identifier,st)},saveAll:ee=>Qe.saveAll(ee),applyEdit(ee){return Ht.applyWorkspaceEdit(ee)},createFileSystemWatcher:(ee,de,Te,st)=>Lt.createFileSystemWatcher(L.GlobPattern.from(ee),de,Te,st),get textDocuments(){return _t.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw C.readonly()},openTextDocument(ee){let de;const Te=ee;if(typeof ee=="string")de=Promise.resolve(k.URI.file(ee));else if(k.URI.isUri(ee))de=Promise.resolve(ee);else if(!Te||typeof Te=="object")de=_t.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(st=>_t.ensureDocumentData(st).then(bt=>bt.document))},onDidOpenTextDocument:(ee,de,Te)=>_t.onDidAddDocument(ee,de,Te),onDidCloseTextDocument:(ee,de,Te)=>_t.onDidRemoveDocument(ee,de,Te),onDidChangeTextDocument:(ee,de,Te)=>_t.onDidChangeDocument(ee,de,Te),onDidSaveTextDocument:(ee,de,Te)=>_t.onDidSaveDocument(ee,de,Te),onWillSaveTextDocument:(ee,de,Te)=>Zt.getOnWillSaveTextDocumentEvent(Ue)(ee,de,Te),onDidChangeConfiguration:(ee,de,Te)=>un.onDidChangeConfiguration(ee,de,Te),getConfiguration(ee,de){return de=arguments.length===1?void 0:de,un.getConfiguration(ee,de,Ue)},registerTextDocumentContentProvider(ee,de){return Jt.registerTextDocumentContentProvider(ee,de)},registerTaskProvider:(ee,de)=>(Ye.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(Ue,ee,de)),registerFileSystemProvider(ee,de,Te){return nn.registerFileSystemProvider(Ue.identifier,ee,de,Te,Ue.enableProposedApi)},get fs(){return rt.value},registerFileSearchProvider:(ee,de)=>((0,G.checkProposedApiEnabled)(Ue),yt.registerFileSearchProvider(ee,de)),registerTextSearchProvider:(ee,de)=>((0,G.checkProposedApiEnabled)(Ue),yt.registerTextSearchProvider(ee,de)),registerRemoteAuthorityResolver:(ee,de)=>((0,G.checkProposedApiEnabled)(Ue),tt.registerRemoteAuthorityResolver(ee,de)),registerResourceLabelFormatter:ee=>((0,G.checkProposedApiEnabled)(Ue),rn.$registerResourceLabelFormatter(ee)),onDidCreateFiles:(ee,de,Te)=>Lt.onDidCreateFile(ee,de,Te),onDidDeleteFiles:(ee,de,Te)=>Lt.onDidDeleteFile(ee,de,Te),onDidRenameFiles:(ee,de,Te)=>Lt.onDidRenameFile(ee,de,Te),onWillCreateFiles:(ee,de,Te)=>Lt.getOnWillCreateFileEvent(Ue)(ee,de,Te),onWillDeleteFiles:(ee,de,Te)=>Lt.getOnWillDeleteFileEvent(Ue)(ee,de,Te),onWillRenameFiles:(ee,de,Te)=>Lt.getOnWillRenameFileEvent(Ue)(ee,de,Te),openTunnel:ee=>((0,G.checkProposedApiEnabled)(Ue),Fe.openTunnel(Ue,ee).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,G.checkProposedApiEnabled)(Ue),Fe.getTunnels()},onDidChangeTunnels:(ee,de,Te)=>((0,G.checkProposedApiEnabled)(Ue),Fe.onDidChangeTunnels(ee,de,Te)),registerPortAttributesProvider:(ee,de)=>((0,G.checkProposedApiEnabled)(Ue),Fe.registerPortsAttributesProvider(ee,de)),registerTimelineProvider:(ee,de)=>((0,G.checkProposedApiEnabled)(Ue),Dn.registerTimelineProvider(ee,de,Ue.identifier,ht.converter)),get isTrusted(){return Qe.trusted},requestWorkspaceTrust:ee=>((0,G.checkProposedApiEnabled)(Ue),Qe.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,de,Te)=>Qe.onDidGrantWorkspaceTrust(ee,de,Te)},Ln={get inputBox(){return Ye.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),mn.getLastInputBox(Ue)},createSourceControl(ee,de,Te){return mn.createSourceControl(Ue,ee,de,Te)}},Fn={createCommentController(ee,de){return yn.createCommentController(Ue,ee,de)}},_n={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(ee,de,Te){return at.onDidStartDebugSession(ee,de,Te)},onDidTerminateDebugSession(ee,de,Te){return at.onDidTerminateDebugSession(ee,de,Te)},onDidChangeActiveDebugSession(ee,de,Te){return at.onDidChangeActiveDebugSession(ee,de,Te)},onDidReceiveDebugSessionCustomEvent(ee,de,Te){return at.onDidReceiveDebugSessionCustomEvent(ee,de,Te)},onDidChangeBreakpoints(ee,de,Te){return at.onDidChangeBreakpoints(ee,de,Te)},registerDebugConfigurationProvider(ee,de,Te){return at.registerDebugConfigurationProvider(ee,de,Te||N.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,de){return at.registerDebugAdapterDescriptorFactory(Ue,ee,de)},registerDebugAdapterTrackerFactory(ee,de){return at.registerDebugAdapterTrackerFactory(ee,de)},startDebugging(ee,de,Te){return!Te||typeof Te=="object"&&"configuration"in Te?at.startDebugging(ee,de,{parentSession:Te}):at.startDebugging(ee,de,Te||{})},stopDebugging(ee){return at.stopDebugging(ee)},addBreakpoints(ee){return at.addBreakpoints(ee)},removeBreakpoints(ee){return at.removeBreakpoints(ee)},asDebugSourceUri(ee,de){return at.asDebugSourceUri(ee,de)}},En={registerTaskProvider:(ee,de)=>St.registerTaskProvider(Ue,ee,de),fetchTasks:ee=>St.fetchTasks(ee),executeTask:ee=>St.executeTask(Ue,ee),get taskExecutions(){return St.taskExecutions},onDidStartTask:(ee,de,Te)=>St.onDidStartTask(ee,de,Te),onDidEndTask:(ee,de,Te)=>St.onDidEndTask(ee,de,Te),onDidStartTaskProcess:(ee,de,Te)=>St.onDidStartTaskProcess(ee,de,Te),onDidEndTaskProcess:(ee,de,Te)=>St.onDidEndTaskProcess(ee,de,Te)},Wt={openNotebookDocument:ee=>((0,G.checkProposedApiEnabled)(Ue),pt.openNotebookDocument(ee)),get onDidOpenNotebookDocument(){return(0,G.checkProposedApiEnabled)(Ue),pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,G.checkProposedApiEnabled)(Ue),pt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,G.checkProposedApiEnabled)(Ue),pt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,G.checkProposedApiEnabled)(Ue),pt.notebookDocuments.map(ee=>ee.apiNotebook)},registerNotebookSerializer(ee,de,Te,st){return(0,G.checkProposedApiEnabled)(Ue),pt.registerNotebookSerializer(Ue,ee,de,Te,Ue.enableProposedApi?st:void 0)},registerNotebookContentProvider:(ee,de,Te,st)=>((0,G.checkProposedApiEnabled)(Ue),pt.registerNotebookContentProvider(Ue,ee,de,Te,Ue.enableProposedApi?st:void 0)),registerNotebookCellStatusBarItemProvider:(ee,de)=>((0,G.checkProposedApiEnabled)(Ue),pt.registerNotebookCellStatusBarItemProvider(Ue,ee,de)),createNotebookEditorDecorationType(ee){return(0,G.checkProposedApiEnabled)(Ue),pt.createNotebookEditorDecorationType(ee)},onDidChangeNotebookDocumentMetadata(ee,de,Te){return(0,G.checkProposedApiEnabled)(Ue),pt.onDidChangeNotebookDocumentMetadata(ee,de,Te)},onDidChangeNotebookCells(ee,de,Te){return(0,G.checkProposedApiEnabled)(Ue),pt.onDidChangeNotebookCells(ee,de,Te)},onDidChangeNotebookCellExecutionState(ee,de,Te){return(0,G.checkProposedApiEnabled)(Ue),pt.onDidChangeNotebookCellExecutionState(ee,de,Te)},onDidChangeCellOutputs(ee,de,Te){return(0,G.checkProposedApiEnabled)(Ue),pt.onDidChangeCellOutputs(ee,de,Te)},onDidChangeCellMetadata(ee,de,Te){return(0,G.checkProposedApiEnabled)(Ue),pt.onDidChangeCellMetadata(ee,de,Te)},createConcatTextDocument(ee,de){return(0,G.checkProposedApiEnabled)(Ue),new Q.ExtHostNotebookConcatDocument(pt,_t,ee,de)},createNotebookController(ee,de,Te,st,bt){return(0,G.checkProposedApiEnabled)(Ue),en.createNotebookController(Ue,ee,de,Te,st,bt)}};return{version:$e.version,authentication:Pn,commands:In,comments:Fn,debug:_n,env:vn,extensions:An,languages:Tn,notebook:Wt,scm:Ln,tasks:En,test:zt,window:Rn,workspace:bn,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:C.CancellationError,CancellationTokenSource:T.CancellationTokenSource,CandidatePortSource:g.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:N.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,EventEmitter:A.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:m.FileType,FilePermission:m.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,Hover:N.Hover,IndentAction:i.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:P.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,UIKind:g.UIKind,Uri:k.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlayHint:N.InlayHint,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,RemoteTrustOption:ce.RemoteTrustOption,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookDocumentMetadata:N.NotebookDocumentMetadata,NotebookCellMetadata:N.NotebookCellMetadata,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookKernelPreload:N.NotebookKernelPreload,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestItemStatus:N.TestItemStatus,TestResultState:N.TestResultState,TestMessage:N.TestMessage,TextSearchCompleteMessageType:Ie.TextSearchCompleteMessageType,TestMessageSeverity:N.TestMessageSeverity,WorkspaceTrustState:N.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ae}),define(me[269],ge([0,1,80,66,32,128,35,52,39,34,69,47,71,94,93,51,65,129,92,63,91,121,46]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h,S,w,E,d,l,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(g.IExtensionStoragePaths,g.ExtensionStoragePaths),(0,b.registerSingleton)(S.IExtHostApiDeprecationService,S.ExtHostApiDeprecationService),(0,b.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,b.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,b.registerSingleton)(E.IExtHostConsumerFileSystem,E.ExtHostConsumerFileSystem),(0,b.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,b.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,b.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,b.registerSingleton)(d.IExtHostFileSystemInfo,d.ExtHostFileSystemInfo),(0,b.registerSingleton)(T.IExtHostOutputService,T.ExtHostOutputService),(0,b.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch),(0,b.registerSingleton)(a.IExtHostStorage,a.ExtHostStorage),(0,b.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,b.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,b.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService),(0,b.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,b.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace),(0,b.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,b.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry),(0,b.registerSingleton)(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(me[95],ge([0,1,16,12,31,68]),function(K,e,b,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=y;function k(I,m,g,a){const h=(0,b.mapArrayOrNot)(g,D),S=new C.TextSearchMatch(m,h,a),w=S.preview.matches;return{ranges:(0,b.mapArrayOrNot)(h,P),uri:I,preview:{text:S.preview.text,matches:(0,b.mapArrayOrNot)(w,P)}}}e.createTextSearchResult=k;function D(I){return new C.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function P(I){return new A.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let i=class{constructor(m,g){this.prefix=m,this.logService=g}appendLine(m){this.logService.debug(`${this.prefix}#search`,m)}};i=qe([He(1,T.ILogService)],i),e.OutputChannel=i}),define(me[270],ge([0,1,97,23]),function(K,e,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function C(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(n=>n===t)}e.isUTFEncoding=C,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,y=512,k=512*8,D=512*128;class P{constructor(n){this.iconvLiteDecoder=n}static async create(n){let s;if(n!==e.UTF8)s=(await new Promise((o,p)=>{K(["iconv-lite-umd"],o,p)})).getDecoder(g(n));else{const r=new TextDecoder;s={write(o){return r.decode(o,{stream:!0})},end(){return r.decode()}}}return new P(s)}write(n){return this.iconvLiteDecoder.write(n)}end(){return this.iconvLiteDecoder.end()}}function i(t,n){var s;const r=((s=n.minBytesRequiredForDetection)!==null&&s!==void 0?s:n.guessEncoding)?k:y;return new Promise((o,p)=>{const f=(0,b.newWriteableStream)(O=>O.join("")),_=[];let u=0,v;const R=async()=>{try{const O=await c({buffer:T.VSBuffer.concat(_),bytesRead:u},n.guessEncoding);O.encoding=await n.overwriteEncoding(O.encoding),v=await P.create(O.encoding);const H=v.write(T.VSBuffer.concat(_).buffer);f.write(H),_.length=0,u=0,o({stream:f,detected:O})}catch(O){p(O)}};(0,b.listenStream)(t,{onData:async O=>{v?f.write(v.write(O.buffer)):(_.push(O),u+=O.byteLength,u>=r&&(t.pause(),await R(),setTimeout(()=>t.resume())))},onError:O=>f.error(O),onEnd:async()=>{v||await R(),f.end(v==null?void 0:v.end())}})})}e.toDecodeStream=i;async function I(t,n,s){const o=(await new Promise((_,u)=>{K(["iconv-lite-umd"],_,u)})).getEncoder(g(n),s);let p=!1,f=!1;return{read(){if(f)return null;const _=t.read();if(typeof _!="string"){if(f=!0,!p&&(s==null?void 0:s.addBOM))switch(n){case e.UTF8:case e.UTF8_with_bom:return T.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return T.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return T.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const u=o.end();return u&&u.length>0?(p=!0,T.VSBuffer.wrap(u)):null}return p=!0,T.VSBuffer.wrap(o.write(_))}}}e.toEncodeReadable=I;async function m(t){return(await new Promise((s,r)=>{K(["iconv-lite-umd"],s,r)})).encodingExists(g(t))}e.encodingExists=m;function g(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=g;function a(t,n){if(!t||n<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),r=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&r===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&r===e.UTF16le_BOM[1])return e.UTF16le;if(n<e.UTF8_BOM.length)return null;const o=t.readUInt8(2);return s===e.UTF8_BOM[0]&&r===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=a;const h=["ascii","utf-16","utf-32"];async function S(t){const n=await new Promise((f,_)=>{K(["jschardet"],f,_)}),s=t.slice(0,D),r=d(s.buffer),o=n.detect(r);if(!o||!o.encoding)return null;const p=o.encoding.toLowerCase();return 0<=h.indexOf(p)?null:E(o.encoding)}const w={ibm866:"cp866",big5:"cp950"};function E(t){const n=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[n]||n}function d(t){let n="";for(let s=0;s<t.length;s++)n+=String.fromCharCode(t[s]);return n}function l(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const n=t.match(/windows(\d+)/);return n?"windows-"+n[1]:t}}e.toCanonicalName=l;function c({buffer:t,bytesRead:n},s){let r=a(t,n),o=!1;if(r!==e.UTF16be&&r!==e.UTF16le&&t){let p=!0,f=!0,_=!1;for(let u=0;u<n&&u<A;u++){const v=u%2==1,R=t.readUInt8(u)===0;if(R&&(_=!0),p&&(v&&!R||!v&&R)&&(p=!1),f&&(v&&R||!v&&!R)&&(f=!1),R&&!p&&!f)break}_&&(p?r=e.UTF16le:f?r=e.UTF16be:o=!0)}return s&&!o&&!r&&t?S(t.slice(0,n)).then(p=>({seemsBinary:!1,encoding:p})):{seemsBinary:o,encoding:r}}e.detectEncodingFromBuffer=c,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[131],ge([0,1,270,26,130]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends C.TextSearchManager{constructor(k,D,P=T){super(k,D,{readdir:i=>P.readdir(i.fsPath),toCanonicalName:i=>(0,b.toCanonicalName)(i)})}}e.NativeTextSearchManager=A}),define(me[271],ge([0,1,272,286,287,2,288]),function(K,e,b,T,C,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(I,m,g,a,h,S){const w=S.environment.useHostProxy,E=typeof w=="boolean"?w:!S.remote.isRemote,d=(0,y.createProxyResolver)({resolveProxy:c=>I.resolveProxy(c),getHttpProxySetting:()=>m.getConfiguration("http").get("proxy"),log:(c,t,...n)=>{switch(c){case y.LogLevel.Trace:a.trace(t,...n);break;case y.LogLevel.Debug:a.debug(t,...n);break;case y.LogLevel.Info:a.info(t,...n);break;case y.LogLevel.Warning:a.warn(t,...n);break;case y.LogLevel.Error:a.error(t,...n);break;case y.LogLevel.Critical:a.critical(t,...n);break;case y.LogLevel.Off:break;default:s(c,t,n);break}function s(r,o,...p){a.error("Unknown log level",r),a.error(o,...p)}},getLogLevel:()=>a.getLevel(),proxyResolveTelemetry:c=>{h.$publicLog2("resolveProxy",c)},useHostProxy:E,env:process.env}),l=D(m,d);return i(g,l)}e.connectProxyResolver=k;function D(I,m){const g={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(h=>{g.config=I.getConfiguration("http").get("proxySupport")||"off"});const a={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(h=>{a.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},b,(0,y.createHttpPatch)(b,m,{config:"off"},a,!0)),on:Object.assign({},b,(0,y.createHttpPatch)(b,m,{config:"on"},a,!0)),override:Object.assign({},b,(0,y.createHttpPatch)(b,m,{config:"override"},a,!0)),onRequest:Object.assign({},b,(0,y.createHttpPatch)(b,m,g,a,!0)),default:Object.assign(b,(0,y.createHttpPatch)(b,m,g,a,!1))},https:{off:Object.assign({},T,(0,y.createHttpPatch)(T,m,{config:"off"},a,!0)),on:Object.assign({},T,(0,y.createHttpPatch)(T,m,{config:"on"},a,!0)),override:Object.assign({},T,(0,y.createHttpPatch)(T,m,{config:"override"},a,!0)),onRequest:Object.assign({},T,(0,y.createHttpPatch)(T,m,g,a,!0)),default:Object.assign(T,(0,y.createHttpPatch)(T,m,g,a,!1))},tls:Object.assign(C,(0,y.createTlsPatch)(C))}}const P=new Map;function i(I,m){return I.getExtensionPathIndex().then(g=>{const a=K.__$__nodeRequire("module"),h=a._load;a._load=function(w,E,d){if(w==="tls")return m.tls;if(w!=="http"&&w!=="https")return h.apply(this,arguments);const l=m[w],c=g.findSubstr(A.URI.file(E.filename).fsPath);let t=P.get(c);if(t||P.set(c,t={}),!t[w]){let n=l.default;c&&c.enableProposedApi&&(n=l[c.proxySupport]||l.onRequest),t[w]=Object.assign({},n)}return t[w]}})}}),define(me[273],ge([0,1,38,8,76,29,10,9,95,274]),function(K,e,b,T,C,A,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(d,l,c,t){const n=m(d,l,c,t),s=l.folder.fsPath;return{cmd:b.spawn(i,n.args,{cwd:s}),rgDiskPath:i,siblingClauses:n.siblingClauses,rgArgs:n,cwd:s}}e.spawnRipgrepCmd=I;function m(d,l,c,t){const n=["--files","--hidden","--case-sensitive"];a([l],c,!1).forEach(r=>{const o=(0,D.anchorGlob)(r);if(n.push("-g",o),y.isMacintosh){const p=(0,C.normalizeNFD)(o);p!==o&&n.push("-g",p)}});const s=g([l],t,void 0,!1);return s.globArgs.forEach(r=>{const o=`!${(0,D.anchorGlob)(r)}`;if(n.push("-g",o),y.isMacintosh){const p=(0,C.normalizeNFD)(o);p!==o&&n.push("-g",p)}}),l.disregardIgnoreFiles!==!1?n.push("--no-ignore"):n.push("--no-ignore-parent"),l.ignoreSymlinks||n.push("--follow"),d.exists&&n.push("--quiet"),n.push("--no-config"),l.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:s.siblingClauses}}function g(d,l,c,t=!0){const n=[];let s={};return d.forEach(r=>{const o=Object.assign({},r.excludePattern||{},l||{}),p=h(o,t?r.folder.fsPath:void 0,c);n.push(...p.globArgs),p.siblingClauses&&(s=Object.assign(s,p.siblingClauses))}),{globArgs:n,siblingClauses:s}}e.foldersToRgExcludeGlobs=g;function a(d,l,c=!0){const t=[];return d.forEach(n=>{const s=Object.assign({},l||{},n.includePattern||{}),r=h(s,c?n.folder.fsPath:void 0);t.push(...r.globArgs)}),t}e.foldersToIncludeGlobs=a;function h(d,l,c){const t=[],n={};return Object.keys(d).forEach(s=>{if(!(c&&c.has(s))&&!!s){const r=d[s];s=w(l?S(l,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof r=="boolean"&&r?(s.startsWith("\\\\")&&(s+="**"),t.push(E(s))):r&&r.when&&(n[s]=r)}}),{globArgs:t,siblingClauses:n}}function S(d,l){return T.isAbsolute(l)?l:T.join(d,l)}e.getAbsoluteGlob=S;function w(d){return d=k.rtrim(d,"\\"),k.rtrim(d,"/")}function E(d){return A.getRoot(d).toLowerCase()==="c:/"?d.replace(/^c:[/\\]/i,"/"):d}e.fixDriveC=E}),define(me[275],ge([0,1,38,37,8,104,16,61,33,76,29,10,48,9,11,26,31,273,102]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h,S,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const d=new Set;process.on("exit",()=>{d.forEach(s=>s())});class l{constructor(r){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=r,this.filePattern=r.filePattern||"",this.includePattern=r.includePattern&&D.parse(r.includePattern),this.maxResults=r.maxResults||null,this.exists=!!r.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,E.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=r.excludePattern&&D.parse(r.excludePattern),this.folderExcludePatterns=new Map,r.folderQueries.forEach(o=>{const p=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),f=o.folder.fsPath;r.folderQueries.map(_=>_.folder.fsPath).filter(_=>_!==f).forEach(_=>{(0,i.isEqualOrParent)(_,f)&&(p[C.relative(f,_)]=!0)}),this.folderExcludePatterns.set(f,new t(p,f))})}cancel(){this.isCanceled=!0}walk(r,o,p,f,_){if(this.fileWalkSW=m.StopWatch.create(!1),this.isCanceled)return _(null,this.isLimitHit);o.forEach(u=>{const v=C.basename(u.fsPath);this.globalExcludePattern&&this.globalExcludePattern(u.fsPath,v)||this.matchFile(p,{relativePath:u.fsPath,searchPath:void 0})}),this.cmdSW=m.StopWatch.create(!1),this.parallel(r,(u,v)=>{this.call(this.cmdTraversal,this,u,p,f,R=>{if(R){const O=(0,k.toErrorMessage)(R);console.error(O),this.errors.push(O),v(R,void 0)}else v(null,void 0)})},(u,v)=>{this.fileWalkSW.stop();const R=u?y.coalesce(u)[0]:null;_(R,this.isLimitHit)})}parallel(r,o,p){const f=new Array(r.length),_=new Array(r.length);let u=!1,v=0;if(r.length===0)return p(null,[]);r.forEach((R,O)=>{o(R,(H,ne)=>{if(H?(u=!0,f[O]=null,_[O]=H):(f[O]=ne,_[O]=null),++v===r.length)return p(u?_:null,f)})})}call(r,o,...p){try{r.apply(o,p)}catch(f){p[p.length-1](f)}}cmdTraversal(r,o,p,f){const _=r.folder.fsPath,u=I.isMacintosh;let v;const R=()=>v&&v.kill();d.add(R);let O=L=>{d.delete(R),O=()=>{},f(L)},H="";const ne=this.initDirectoryTree();let ie;const U=(0,w.spawnRipgrepCmd)(this.config,r,this.config.includePattern,this.folderExcludePatterns.get(r.folder.fsPath).expression);v=U.cmd,ie=!Object.keys(U.siblingClauses).length;const B=U.rgArgs.args.map(L=>L.match(/^-/)?L:`'${L}'`).join(" ");let x=`${U.rgDiskPath} ${B}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(x+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),p({message:x}),this.cmdResultCount=0,this.collectStdout(v,"utf8",p,(L,N,F)=>{if(L){O(L);return}if(this.isLimitHit){O();return}const $=(H+(u?P.normalizeNFC(N||""):N)).split(`
`);if(F){const q=$.length;$[q-1]=$[q-1].trim(),$[q-1]||$.pop()}else H=$.pop()||"";if($.length&&$[0].indexOf(`
`)!==-1){O(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=$.length,ie){for(const q of $)if(this.matchFile(o,{base:_,relativePath:q,searchPath:this.getSearchPath(r,q)}),this.isLimitHit){R();break}(F||this.isLimitHit)&&O();return}this.addDirectoryEntries(r,ne,_,$,o),F&&(this.matchDirectoryTree(ne,_,o),O())})}spawnFindCmd(r){const o=this.folderExcludePatterns.get(r.folder.fsPath),p=o.getBasenameTerms(),f=o.getPathTerms(),_=["-L","."];if(p.length||f.length){_.push("-not","(","(");for(const u of p)_.push("-name",u),_.push("-o");for(const u of f)_.push("-path",u),_.push("-o");_.pop(),_.push(")","-prune",")")}return _.push("-type","f"),b.spawn("find",_,{cwd:r.folder.fsPath})}readStdout(r,o,p){let f="";this.collectStdout(r,o,()=>{},(_,u,v)=>{if(_){p(_);return}f+=u,v&&p(null,f)})}collectStdout(r,o,p,f){let _=(R,O,H)=>{(R||H)&&(_=()=>{},this.cmdSW&&this.cmdSW.stop()),f(R,O,H)},u=!1;r.stdout?(this.forwardData(r.stdout,o,_),r.stdout.once("data",()=>u=!0)):p({message:"stdout is null"});let v;r.stderr?v=this.collectData(r.stderr):p({message:"stderr is null"}),r.on("error",R=>{_(R)}),r.on("close",R=>{let O;!u&&(O=this.decodeData(v,o))&&n(O)?_(new Error(`command failed with error code ${R}: ${this.decodeData(v,o)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),_(null,"",!0))})}forwardData(r,o,p){const f=new A.StringDecoder(o);return r.on("data",_=>{p(null,f.write(_))}),f}collectData(r){const o=[];return r.on("data",p=>{o.push(p)}),o}decodeData(r,o){const p=new A.StringDecoder(o);return r.map(f=>p.write(f)).join("")}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries(r,{pathToEntries:o},p,f,_){f.indexOf(this.filePattern)!==-1&&this.matchFile(_,{base:p,relativePath:this.filePattern,searchPath:this.getSearchPath(r,this.filePattern)});const u=v=>{const R=C.basename(v),O=C.dirname(v);let H=o[O];H||(H=o[O]=[],u(O)),H.push({base:p,relativePath:v,basename:R,searchPath:this.getSearchPath(r,v)})};f.forEach(u)}matchDirectoryTree({rootEntries:r,pathToEntries:o},p,f){const _=this,u=this.folderExcludePatterns.get(p),v=this.filePattern;function R(O){_.directoriesWalked++;const H=D.hasSiblingFn(()=>O.map(ne=>ne.basename));for(let ne=0,ie=O.length;ne<ie;ne++){const U=O[ne],{relativePath:B,basename:x}=U;if(!u.test(B,x,v!==x?H:void 0)){const L=o[B];if(L)R(L);else{if(_.filesWalked++,B===v)continue;_.matchFile(f,U)}if(_.isLimitHit)break}}}R(r)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(r,o,p,f,_){const u=r.folder,v=D.hasSiblingFn(()=>p);this.parallel(p,(R,O)=>{if(this.isCanceled||this.isLimitHit)return O(null);const H=o?[o,R].join(C.sep):R;if(this.folderExcludePatterns.get(r.folder.fsPath).test(H,R,this.config.filePattern!==R?v:void 0))return O(null);const ne=[u.fsPath,H].join(C.sep);T.lstat(ne,(ie,U)=>{if(ie||this.isCanceled||this.isLimitHit)return O(null);this.statLinkIfNeeded(ne,U,(B,x)=>B||this.isCanceled||this.isLimitHit?O(null):x.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(ne,U,(L,N)=>L||this.isCanceled||this.isLimitHit||(N=N||"",this.walkedPaths[N])?O(null):(this.walkedPaths[N]=!0,(0,h.readdir)(ne).then(F=>{if(this.isCanceled||this.isLimitHit)return O(null);this.doWalk(r,H,F,f,M=>O(M||null))},F=>{O(null)})))):(this.filesWalked++,H===this.filePattern||this.maxFilesize&&a.isNumber(x.size)&&x.size>this.maxFilesize||this.matchFile(f,{base:u.fsPath,relativePath:H,searchPath:this.getSearchPath(r,H)}),O(null,void 0)))})},R=>{const O=R&&y.coalesce(R);return _(O&&O.length>0?O[0]:void 0)})}matchFile(r,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,C.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||r(o))}isFileMatch(r){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,S.isFilePatternMatch)(r,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(r,o,p){return o.isSymbolicLink()?T.stat(r,p):p(null,o)}realPathIfNeeded(r,o,p){return o.isSymbolicLink()?T.realpath(r,(f,_)=>f?p(f):p(null,_)):p(null,r)}getSearchPath(r,o){return r.folderName?C.join(r.folderName,o):o}}e.FileWalker=l;class c{constructor(r){this.folderQueries=r.folderQueries,this.extraFiles=r.extraFileResources||[],this.walker=new l(r)}search(r,o,p){this.walker.walk(this.folderQueries,this.extraFiles,r,o,(f,_)=>{p(f,{limitHit:_,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=c;class t{constructor(r,o){this.expression=r,this.root=o,this.init(r)}init(r){let o,p;Object.keys(r).filter(f=>r[f]).forEach(f=>{C.isAbsolute(f)?(o=o||D.getEmptyExpression(),o[f]=r[f]):(p=p||D.getEmptyExpression(),p[f]=r[f])}),this.absoluteParsedExpr=o&&D.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=p&&D.parse(p,{trimForExclusions:!0})}test(r,o,p){return this.relativeParsedExpr&&this.relativeParsedExpr(r,o,p)||this.absoluteParsedExpr&&this.absoluteParsedExpr(C.join(this.root,r),o,p)}getBasenameTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getBasenameTerms(this.relativeParsedExpr)),r}getPathTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getPathTerms(this.relativeParsedExpr)),r}}function n(s){const r=s.trim().split(`
`),o=r[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return g.uppercaseFirstLetter(r[r.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}e.rgErrorMsgForDisplay=n}),define(me[132],ge([0,1,38,289,104,16,54,33,8,9,2,31,68,290,274,95]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const S=a.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class w{constructor(u){this.outputChannel=u}provideTextSearchResults(u,v,R,O){return this.outputChannel.appendLine(`provideTextSearchResults ${u.pattern}, ${JSON.stringify(Object.assign(Object.assign({},v),{folder:v.folder.toString()}))}`),new Promise((H,ne)=>{O.onCancellationRequested(()=>M());const ie=n(u,v),U=v.folder.fsPath,B=ie.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.outputChannel.appendLine(`${S} ${B}
 - cwd: ${U}`);let x=b.spawn(S,ie,{cwd:U});x.on("error",ve=>{console.error(ve),this.outputChannel.appendLine("Error: "+(ve&&ve.message)),ne((0,I.serializeSearchError)(new I.SearchError(ve&&ve.message,I.SearchErrorCode.rgProcessError)))});let L=!1;const N=new l(v.maxResults,U,v.previewOptions);N.on("result",ve=>{L=!0,q="",R.report(ve)});let F=!1;const M=()=>{F=!0,x&&x.kill(),N&&N.cancel()};let $=!1;N.on("hitLimit",()=>{$=!0,M()});let q="";x.stdout.on("data",ve=>{N.handleData(ve),L||(q+=ve)});let G=!1;x.stdout.once("data",()=>G=!0);let le="";x.stderr.on("data",ve=>{const Re=ve.toString();this.outputChannel.appendLine(Re),le+=Re}),x.on("close",()=>{if(this.outputChannel.appendLine(G?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(L?"Got result from parser":"No result from parser"),q&&this.outputChannel.appendLine(`Got data without result: ${q}`),this.outputChannel.appendLine(""),F)H({limitHit:$});else{N.flush(),x=null;let ve;le&&!G&&(ve=E(le))?ne((0,I.serializeSearchError)(new I.SearchError(ve.message,ve.code))):H({limitHit:$})}})})}}e.RipgrepTextSearchEngine=w;function E(_){const u=_.split(`
`),v=u[0].trim();if(u.some(O=>O.startsWith("regex parse error")))return new I.SearchError(d(u),I.SearchErrorCode.regexParseError);const R=v.match(/grep config error: unknown encoding: (.*)/);if(R)return new I.SearchError(`Unknown encoding: ${R[1]}`,I.SearchErrorCode.unknownEncoding);if(v.startsWith("error parsing glob"))return new I.SearchError(v.charAt(0).toUpperCase()+v.substr(1),I.SearchErrorCode.globParseError);if(v.startsWith("the literal"))return new I.SearchError(v.charAt(0).toUpperCase()+v.substr(1),I.SearchErrorCode.invalidLiteral);if(v.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(v,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=E;function d(_){const u=["Regex parse error"],v=_.filter(R=>R.startsWith("PCRE2:"));if(v.length>=1){const R=v[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const O=R.split(":")[1];u.push(":"+O)}}return u.join("")}e.buildRegexParseError=d;class l extends T.EventEmitter{constructor(u,v,R){super();this.maxResults=u,this.rootFolder=v,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new C.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(u,v){return super.on(u,v),this}handleData(u){if(!this.isDone){const v=typeof u=="string"?u:this.stringDecoder.write(u);this.handleDecodedData(v)}}handleDecodedData(u){let v=u.indexOf(`
`);const R=this.remainder+u;if(v>=0)v+=this.remainder.length;else{this.remainder=R;return}let O=0;for(;v>=0;)this.handleLine(R.substring(O,v).trim()),O=v+1,v=R.indexOf(`
`,O);this.remainder=R.substring(O)}handleLine(u){if(!(this.isDone||!u)){let v;try{v=JSON.parse(u)}catch(R){throw new Error(`malformed line from rg: ${u}`)}if(v.type==="match"){const R=c(v.data.path),O=i.URI.file(D.join(this.rootFolder,R)),H=this.createTextSearchMatch(v.data,O);this.onResult(H),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(v.type==="context"){const R=c(v.data.path),O=i.URI.file(D.join(this.rootFolder,R));this.createTextSearchContext(v.data,O).forEach(ne=>this.onResult(ne))}}}createTextSearchMatch(u,v){const R=u.line_number-1;let O=!1,H=c(u.lines);R===0&&(0,P.startsWithUTF8BOM)(H)&&(O=!0,H=(0,P.stripUTF8BOM)(H));const ne=Buffer.from(H);let ie=0,U=0,B=R;u.submatches.length===0&&u.submatches.push(H.length?{start:0,end:1,match:{text:H[0]}}:{start:0,end:0,match:{text:""}});const x=(0,A.coalesce)(u.submatches.map((L,N)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let F=c(L.match);R===0&&N===0&&O&&(F=(0,P.stripUTF8BOM)(F),L.start=L.start<=3?0:L.start-3,L.end=L.end<=3?0:L.end-3);const M=ne.slice(ie,L.start).toString().length,$=U+M,q=t(F),G=B,le=q.numLines+G,ve=q.numLines>0?q.lastLineLength:q.lastLineLength+$;return ie=L.end,U=ve,B=le,new m.Range(G,$,le,ve)}));return(0,h.createTextSearchResult)(v,H,x,this.previewOptions)}createTextSearchContext(u,v){const R=c(u.lines),O=u.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((H,ne)=>({text:H,uri:v,lineNumber:O+ne}))}onResult(u){this.emit("result",u)}}e.RipgrepParser=l;function c(_){return _.bytes?Buffer.from(_.bytes,"base64").toString():_.text}function t(_){const u=/\n/g;let v=0,R=-1,O;for(;O=u.exec(_);)v++,R=O.index;const H=R>=0?_.length-R-1:_.length;return{numLines:v,lastLineLength:H}}function n(_,u){const v=["--hidden"];v.push(_.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:O}=(0,y.groupBy)(u.includes,ne=>ne.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const ne=new Set;O.forEach(ie=>{ne.add(ie)}),v.push("-g","!*"),ne.forEach(ie=>{s(ie).map(h.anchorGlob).forEach(U=>{v.push("-g",U)})})}R&&R.length&&R.forEach(ne=>{v.push("-g",ne)}),u.excludes.map(h.anchorGlob).forEach(ne=>v.push("-g",`!${ne}`)),u.maxFileSize&&v.push("--max-filesize",u.maxFileSize+""),u.useIgnoreFiles?v.push("--no-ignore-parent"):v.push("--no-ignore"),u.followSymlinks&&v.push("--follow"),u.encoding&&u.encoding!=="utf8"&&v.push("--encoding",u.encoding),_.pattern==="--"&&(_.isRegExp=!0,_.pattern="\\-\\-"),_.isMultiline&&!_.isRegExp&&(_.pattern=(0,P.escapeRegExpCharacters)(_.pattern),_.isRegExp=!0),u.usePCRE2&&v.push("--pcre2"),v.push("--crlf"),_.isRegExp&&(_.pattern=r(_.pattern),v.push("--auto-hybrid-regex"));let H;if(_.isWordMatch){const ie=(0,P.createRegExp)(_.pattern,!!_.isRegExp,{wholeWord:_.isWordMatch}).source.replace(/\\\//g,"/");v.push("--regexp",ie)}else if(_.isRegExp){let ne=p(_.pattern);ne=f(ne),v.push("--regexp",ne)}else H=_.pattern,v.push("--fixed-strings");return v.push("--no-config"),u.useGlobalIgnoreFiles||v.push("--no-ignore-global"),v.push("--json"),_.isMultiline&&v.push("--multiline"),u.beforeContext&&v.push("--before-context",u.beforeContext+""),u.afterContext&&v.push("--after-context",u.afterContext+""),v.push("--"),H&&v.push(H),v.push("."),v}function s(_){const u=(0,k.splitGlobAware)(_,"/");return u.map((v,R)=>u.slice(0,R+1).join("/"))}e.spreadGlobComponents=s;function r(_){const u=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;_.match(u);)_=_.replace(u,"$1\\x{$2}");const v=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;_.match(v);)_=_.replace(v,"$1\\x{$2}");return _}e.unicodeEscapesToPCRE2=r;const o=_=>_.type==="Assertion"&&_.kind==="lookbehind";function p(_){let u;try{u=new g.RegExpParser().parsePattern(_)}catch(ie){return _}let v="",R=0;const O=(ie,U,B)=>{v+=_.slice(R,ie)+B,R=U},H=[];return new g.RegExpVisitor({onCharacterEnter(ie){if(ie.raw==="\\n"){const U=H[0];if(!U)O(ie.start,ie.end,"\\r?\\n");else if(!H.some(o))if(U.type==="CharacterClass")if(U.negate){const B=_.slice(U.start+2,ie.start)+_.slice(ie.end,U.end-1);O(U.start,U.end,"(?!\\r?\\n"+(B?`|[${B}]`:"")+")")}else{const B=_.slice(U.start+1,ie.start)+_.slice(ie.end,U.end-1);O(U.start,U.end,B===""?"\\r?\\n":`(?:[${B}]|\\r?\\n)`)}else U.type==="Quantifier"&&O(ie.start,ie.end,"(?:\\r?\\n)")}},onQuantifierEnter(ie){H.unshift(ie)},onQuantifierLeave(){H.shift()},onCharacterClassRangeEnter(ie){H.unshift(ie)},onCharacterClassRangeLeave(){H.shift()},onCharacterClassEnter(ie){H.unshift(ie)},onCharacterClassLeave(){H.shift()},onAssertionEnter(ie){o(ie)&&H.push(ie)},onAssertionLeave(ie){H[0]===ie&&H.shift()}}).visit(u),v+=_.slice(R),v}e.fixRegexNewline=p;function f(_){return _.replace(/\n/g,"\\r?\\n")}e.fixNewline=f}),define(me[276],ge([0,1,21,132,117,13]),function(K,e,b,T,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,i,I,m){const g=new T.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===A.Schemas.userData){const a=Object.assign(Object.assign({},i),{folder:i.folder.with({scheme:A.Schemas.file})}),h=new C.Progress(S=>I.report(Object.assign(Object.assign({},S),{uri:S.uri.with({scheme:i.folder.scheme})})));return this.withToken(m,S=>g.provideTextSearchResults(P,a,h,S))}else return this.withToken(m,a=>g.provideTextSearchResults(P,i,I,a))}async withToken(P,i){const I=k(P);this.inProgress.add(I);const m=await i(I.token);return this.inProgress.delete(I),m}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=y;function k(D){const P=new b.CancellationTokenSource;return D.onCancellationRequested(()=>P.cancel()),P}}),define(me[277],ge([0,1,26,132,131]),function(K,e,b,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(D){this.query=D}search(D,P,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(g){i({message:g})}},m=new C.NativeTextSearchManager(this.query,new T.RipgrepTextSearchEngine(I),b);return new Promise((g,a)=>m.search(h=>{P(h.map(y))},D).then(h=>g({limitHit:h.limitHit,type:"success"}),a))}}e.TextSearchEngineAdapter=A;function y(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((D,P)=>{if(P.ranges){const i=P;return D+(Array.isArray(i.ranges)?i.ranges.length:1)}else return D+1},0)}}}),define(me[278],ge([0,1,37,291,16,14,17,3,102,8,48,2,45,31,275,277]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,T.gracefulify(b);class S{constructor(){this.caches=Object.create(null)}fileSearch(t){let n;const s=d(t),r=new k.Emitter({onFirstListenerDidAdd:()=>{n=(0,A.createCancelablePromise)(o=>this.doFileSearchWithEngine(a.Engine,s,p=>r.fire(p),o)),n.then(o=>r.fire(o),o=>r.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}textSearch(t){let n;const s=d(t),r=new k.Emitter({onFirstListenerDidAdd:()=>{n=(0,A.createCancelablePromise)(o=>this.ripgrepTextSearch(s,p=>r.fire(p),o)),n.then(o=>r.fire(o),o=>r.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}ripgrepTextSearch(t,n,s){return t.maxFileSize=(0,m.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new h.TextSearchEngineAdapter(t).search(s,n,n)}doFileSearch(t,n,s){return this.doFileSearchWithEngine(a.Engine,t,n,s)}doFileSearchWithEngine(t,n,s,r,o=S.BATCH_SIZE){let p=0;const f=u=>{Array.isArray(u)?(p+=u.length,s(u.map(v=>this.rawMatchToSearchItem(v)))):u.relativePath?(p++,s(this.rawMatchToSearchItem(u))):s(u)};if(n.sortByScore){let u=this.trySortedSearchFromCache(n,f,r);if(!u){const v=n.maxResults?Object.assign({},n,{maxResults:null}):n,R=new t(v);u=this.doSortedSearch(R,n,s,f,r)}return new Promise((v,R)=>{u.then(([O,H])=>{const ne=H.map(ie=>this.rawMatchToSearchItem(ie));this.sendProgress(ne,s,o),v(O)},R)})}const _=new t(n);return this.doSearch(_,f,o,r).then(u=>({limitHit:u.limitHit,type:"success",stats:{detailStats:u.stats,type:"searchProcess",fromCache:!1,resultCount:p,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,P.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,n,s,r,o){const p=new k.Emitter;let f=(0,A.createCancelablePromise)(u=>{let v=[];const R=O=>{Array.isArray(O)?v=O:(r(O),p.fire(O))};return this.doSearch(t,R,-1,u).then(O=>[O,v])}),_;if(n.cacheKey){_=this.getOrCreateCache(n.cacheKey);const u={promise:f,event:p.event,resolved:!1};_.resultsToSearchCache[n.filePattern||""]=u,f.then(()=>{u.resolved=!0},v=>{delete _.resultsToSearchCache[n.filePattern||""]}),f=this.preventCancellation(f)}return f.then(([u,v])=>{const R=_?_.scorerCache:Object.create(null),O=(typeof n.maxResults!="number"||n.maxResults>0)&&i.StopWatch.create(!1);return this.sortResults(n,v,R,o).then(H=>{const ne=O?O.elapsed():-1;return[{type:"success",stats:{detailStats:u.stats,sortingTime:ne,fromCache:!1,type:"searchProcess",workspaceFolderCount:n.folderQueries.length,resultCount:H.length},messages:u.messages,limitHit:u.limitHit||typeof n.maxResults=="number"&&v.length>n.maxResults},H]})})}getOrCreateCache(t){const n=this.caches[t];return n||(this.caches[t]=new w)}trySortedSearchFromCache(t,n,s){const r=t.cacheKey&&this.caches[t.cacheKey];if(!!r){const o=this.getResultsFromCache(r,t.filePattern||"",n,s);if(o)return o.then(([p,f,_])=>{const u=i.StopWatch.create(!1);return this.sortResults(t,f,r.scorerCache,s).then(v=>{const R=u.elapsed(),O={fromCache:!0,detailStats:_,type:"searchProcess",resultCount:f.length,sortingTime:R};return[{type:"success",limitHit:p.limitHit||typeof t.maxResults=="number"&&f.length>t.maxResults,stats:O},v]})})}}sortResults(t,n,s,r){const o=(0,D.prepareQuery)(t.filePattern||""),p=(_,u)=>(0,D.compareItemsByFuzzyScore)(_,u,o,!0,E,s),f=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return C.topAsync(n,p,f,1e4,r)}sendProgress(t,n,s){if(s&&s>0)for(let r=0;r<t.length;r+=s)n(t.slice(r,r+s));else n(t)}getResultsFromCache(t,n,s,r){const o=i.StopWatch.create(!1),p=n.indexOf(P.sep)>=0;let f;for(const R in t.resultsToSearchCache)if(n.startsWith(R)){if(p&&R.indexOf(P.sep)<0&&R!=="")continue;const O=t.resultsToSearchCache[R];f={promise:this.preventCancellation(O.promise),event:O.event,resolved:O.resolved};break}if(!f)return null;const _=o.elapsed(),u=i.StopWatch.create(!1),v=f.event(s);return r&&r.onCancellationRequested(()=>{v.dispose()}),f.promise.then(([R,O])=>{if(r&&r.isCancellationRequested)throw(0,y.canceled)();const H=[],ne=(0,D.prepareQuery)(n).normalizedLowercase;for(const ie of O)!(0,g.isFilePatternMatch)(ie,ne)||H.push(ie);return[R,H,{cacheWasResolved:f.resolved,cacheLookupTime:_,cacheFilterTime:u.elapsed(),cacheEntryCount:O.length}]})}doSearch(t,n,s,r){return new Promise((o,p)=>{let f=[];r&&r.onCancellationRequested(()=>t.cancel()),t.search(_=>{_&&(s?(f.push(_),s>0&&f.length>=s&&(n(f),f=[])):n(_))},_=>{n(_)},(_,u)=>{f.length&&n(f),_?p(_):o(u)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(n,s){return t.then(n,s)}catch(n){return this.then(void 0,n)}finally(n){return t.finally(n)}}}}e.SearchService=S,S.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const E=new class{getItemLabel(c){return(0,P.basename)(c.relativePath)}getItemDescription(c){return(0,P.dirname)(c.relativePath)}getItemPath(c){return c.relativePath}};function d(c){return Object.assign(Object.assign({},c),{folderQueries:c.folderQueries&&c.folderQueries.map(l),extraFileResources:c.extraFileResources&&c.extraFileResources.map(t=>I.URI.revive(t))})}function l(c){return Object.assign(Object.assign({},c),{folder:I.URI.revive(c.folder)})}}),define(me[279],ge([0,1,6,2,26,12,31,278,276,95,15,64,28,71,13,131]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let S=class extends g.ExtHostSearch{constructor(E,d,l,c){super(E,l,c);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new P.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(a.Schemas.userData,new D.RipgrepSearchProvider(t)),d.remote.isRemote&&d.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const E=new P.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(a.Schemas.file,new D.RipgrepSearchProvider(E)),this.registerInternalFileSearchProvider(a.Schemas.file,new k.SearchService)}registerInternalFileSearchProvider(E,d){const l=this._handlePool++;return this._internalFileSearchProvider=d,this._internalFileSearchHandle=l,this._proxy.$registerFileSearchProvider(l,this._transformScheme(E)),(0,b.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(l)})}$provideFileSearchResults(E,d,l,c){const t=(0,g.reviveQuery)(l);return E===this._internalFileSearchHandle?this.doInternalFileSearch(E,d,t,c):super.$provideFileSearchResults(E,d,l,c)}doInternalFileSearch(E,d,l,c){const t=n=>{if((0,y.isSerializedFileMatch)(n)&&(n=[n]),Array.isArray(n)){this._proxy.$handleFileMatch(E,d,n.map(s=>T.URI.file(s.path)));return}n.message&&this._logService.debug("ExtHostSearch",n.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(l,t,c)}$clearCache(E){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(E),super.$clearCache(E)}createTextSearchManager(E,d){return new h.NativeTextSearchManager(E,d)}};S=qe([He(0,i.IExtHostRpcService),He(1,m.IExtHostInitDataService),He(2,I.IURITransformerService),He(3,A.ILogService)],S),e.NativeExtHostSearch=S}),define(me[133],ge([0,1,292,124,293,3,107,8,49,30,6,23,108,17,10]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(f){this.socket=f,this._errorListener=_=>{if(_){if(_.code==="EPIPE")return;(0,g.onUnexpectedError)(_)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(f){const _=u=>f(I.VSBuffer.wrap(u));return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(f){return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(f){return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(f){if(!this.socket.destroyed)try{this.socket.write(f.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,g.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,g.onUnexpectedError)(_)}}end(){this.socket.end()}drain(){return new Promise((f,_)=>{if(this.socket.bufferSize===0){f();return}const u=()=>{this.socket.off("close",u),this.socket.off("end",u),this.socket.off("error",u),this.socket.off("timeout",u),this.socket.off("drain",u),f()};this.socket.on("close",u),this.socket.on("end",u),this.socket.on("error",u),this.socket.on("timeout",u),this.socket.on("drain",u)})}}e.NodeSocket=h;var S;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var w;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(w||(w={}));class E extends i.Disposable{constructor(f,_,u,v){super();this._onDidZlibFlush=this._register(new A.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new A.Emitter),this._onClose=this._register(new A.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=f,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=_,this._recordInflateBytes=v,_?(this._zlibInflate=C.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",R=>{console.error(R),(0,g.onUnexpectedError)(R),this._onClose.fire()}),this._zlibInflate.on("data",R=>{this._pendingInflateData.push(R)}),u&&(this._zlibInflate.write(u.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=C.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",R=>{console.error(R),(0,g.onUnexpectedError)(R),this._onClose.fire()}),this._zlibDeflate.on("data",R=>{this._pendingDeflateData.push(R)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new m.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?I.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):I.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this._onData.event(f)}onClose(f){return this._onClose.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){this._totalOutgoingDataBytes+=f.byteLength,this._zlibDeflate?(this._zlibDeflate.write(f.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let _=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.length-4),this._isEnded||this._write(I.VSBuffer.wrap(_),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(f,!1)}_write(f,_){let u=2;f.byteLength<126?u+=0:f.byteLength<2**16?u+=2:u+=8;const v=I.VSBuffer.alloc(u);if(_?v.writeUInt8(194,0):v.writeUInt8(130,0),f.byteLength<126)v.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){v.writeUInt8(126,1);let R=1;v.writeUInt8(f.byteLength>>>8&255,++R),v.writeUInt8(f.byteLength>>>0&255,++R)}else{v.writeUInt8(127,1);let R=1;v.writeUInt8(0,++R),v.writeUInt8(0,++R),v.writeUInt8(0,++R),v.writeUInt8(0,++R),v.writeUInt8(f.byteLength>>>24&255,++R),v.writeUInt8(f.byteLength>>>16&255,++R),v.writeUInt8(f.byteLength>>>8&255,++R),v.writeUInt8(f.byteLength>>>0&255,++R)}this._totalOutgoingWireBytes+=v.byteLength+f.byteLength,this.socket.write(I.VSBuffer.concat([v,f]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(f){if(f.byteLength!==0){for(this._totalIncomingWireBytes+=f.byteLength,this._incomingData.acceptChunk(f);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),v=(_.readUInt8(0)&128)>>>7,R=_.readUInt8(1),O=(R&128)>>>7,H=R&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(H===126?2:0)+(H===127?8:0),this._state.fin=v,this._state.mask=0}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),u=_.readUInt8(1),v=(u&128)>>>7;let R=u&127,O=1;R===126?R=_.readUInt8(++O)*2**8+_.readUInt8(++O):R===127&&(R=_.readUInt8(++O)*0+_.readUInt8(++O)*0+_.readUInt8(++O)*0+_.readUInt8(++O)*0+_.readUInt8(++O)*2**24+_.readUInt8(++O)*2**16+_.readUInt8(++O)*2**8+_.readUInt8(++O));let H=0;v&&(H=_.readUInt8(++O)*2**24+_.readUInt8(++O)*2**16+_.readUInt8(++O)*2**8+_.readUInt8(++O)),this._state.state=3,this._state.readLen=R,this._state.mask=H}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);d(_,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(_.buffer)),this._zlibInflate.write(_.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const u=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=u.length,this._onData.fire(I.VSBuffer.wrap(u))})):(this._totalIncomingDataBytes+=_.byteLength,this._onData.fire(_))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await A.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=E;function d(p,f){if(f!==0){let _=p.byteLength>>>2;for(let ne=0;ne<_;ne++){const ie=p.readUInt32BE(ne*4);p.writeUInt32BE(ie^f,ne*4)}let u=_*4,v=p.byteLength-u;const R=f>>>24&255,O=f>>>16&255,H=f>>>8&255;v>=1&&p.writeUInt8(p.readUInt8(u)^R,u),v>=2&&p.writeUInt8(p.readUInt8(u+1)^O,u+1),v>=3&&p.writeUInt8(p.readUInt8(u+2)^H,u+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function c(){const p=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;let f;return e.XDG_RUNTIME_DIR?f=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${p}.sock`):f=(0,k.join)((0,D.tmpdir)(),`vscode-ipc-${p}.sock`),n(f),f}e.createRandomIPCHandle=c;function t(p,f,_){const u=(0,b.createHash)("md5").update(p).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${u}-${_}-${f}-sock`;let v;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?v=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-${u.substr(0,8)}-${_}-${f}.sock`):v=(0,k.join)(p,`${_}-${f}.sock`),n(v),v}e.createStaticIPCHandle=t;function n(p){const f=l[a.platform];typeof f=="number"&&p.length>=f&&console.warn(`WARNING: IPC handle "${p}" is longer than ${f} chars, try a shorter --user-data-dir`)}class s extends y.IPCServer{constructor(f){super(s.toClientConnectionEvent(f));this.server=f}static toClientConnectionEvent(f){const _=A.Event.fromNodeEventEmitter(f,"connection");return A.Event.map(_,u=>({protocol:new m.Protocol(new h(u)),onDidClientDisconnect:A.Event.once(A.Event.fromNodeEventEmitter(u,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function r(p){return new Promise((f,_)=>{const u=(0,T.createServer)();u.on("error",_),u.listen(p,()=>{u.removeListener("error",_),f(new s(u))})})}e.serve=r;function o(p,f){return new Promise((_,u)=>{const v=(0,T.createConnection)(p,()=>{v.removeListener("error",u),_(m.Client.fromSocket(new h(v),f))});v.once("error",u)})}e.connect=o}),define(me[280],ge([0,1,133,272,37,52,2,120,12]),function(K,e,b,T,C,A,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(m,g,a){this._commands=m,this.logService=g,this._ipcHandlePath=a,this._server=T.createServer((h,S)=>this.onRequest(h,S)),this.setup().catch(h=>(g.error(h),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",m=>this.logService.error(m))}catch(m){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(m,g){const a=[];m.setEncoding("utf8"),m.on("data",h=>a.push(h)),m.on("end",()=>{const h=JSON.parse(a.join(""));switch(h.type){case"open":this.open(h,g);break;case"openExternal":this.openExternal(h,g);break;case"status":this.getStatus(h,g);break;case"extensionManagement":this.manageExtensions(h,g).catch(this.logService.error);break;default:g.writeHead(404),g.write(`Unknown message type: ${h.type}`,S=>{S&&this.logService.error(S)}),g.end();break}})}open(m,g){let{fileURIs:a,folderURIs:h,forceNewWindow:S,diffMode:w,addMode:E,forceReuseWindow:d,gotoLineMode:l,waitMarkerFilePath:c}=m;const t=[];if(Array.isArray(h))for(const n of h)try{t.push({folderUri:y.URI.parse(n)})}catch(s){}if(Array.isArray(a))for(const n of a)try{(0,k.hasWorkspaceFileExtension)(n)?t.push({workspaceUri:y.URI.parse(n)}):t.push({fileUri:y.URI.parse(n)})}catch(s){}if(t.length){const n=c?y.URI.file(c):void 0,r={forceNewWindow:S,diffMode:w,addMode:E,gotoLineMode:l,forceReuseWindow:d,preferNewWindow:!d&&!n&&!E,waitMarkerFileURI:n};this._commands.executeCommand("_remoteCLI.windowOpen",t,r)}g.writeHead(200),g.end()}async openExternal(m,g){for(const a of m.uris){const h=y.URI.parse(a),S=h.scheme==="file"?h:a;await this._commands.executeCommand("_remoteCLI.openExternal",S)}g.writeHead(200),g.end()}async manageExtensions(m,g){try{const a=w=>w==null?void 0:w.map(E=>/\.vsix$/i.test(E)?y.URI.parse(E):E),h={list:m.list,install:a(m.install),uninstall:a(m.uninstall),force:m.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",h);g.writeHead(200),g.write(S)}catch(a){g.writeHead(500),g.write(String(a),h=>{h&&this.logService.error(h)})}g.end()}async getStatus(m,g){try{const a=await this._commands.executeCommand("_remoteCLI.getSystemStatus");g.writeHead(200),g.write(a),g.end()}catch(a){g.writeHead(500),g.write(String(a),h=>{h&&this.logService.error(h)}),g.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&C.existsSync(this._ipcHandlePath)&&C.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let i=class extends P{constructor(m,g){super(m,g,(0,b.createRandomIPCHandle)())}};i=qe([He(0,A.IExtHostCommands),He(1,D.ILogService)],i),e.CLIServer=i}),define(me[281],ge([0,1,70,268,262,5,271,42,253,2,13,7,280,105]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class a extends C.RequireInterceptor{_installInterceptor(){const w=this,E=K.__$__nodeRequire("module"),d=E._load;E._load=function(c,t,n){for(let s of w._alternatives){let r=s(c);if(r){c=r;break}}return w._factories.has(c)?w._factories.get(c).load(c,P.URI.file((0,g.realpathSync)(t.filename)),s=>d.apply(this,[s,t,n])):d.apply(this,arguments)}}}class h extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const w=this._instaService.invokeFunction(T.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(m.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(a,w,this._registry).install(),b.mark("code/extHost/didInitAPI");const d=await this._extHostConfiguration.getConfigProvider();await(0,y.connectProxyResolver)(this._extHostWorkspace,d,this,this._logService,this._mainThreadTelemetryProxy,this._initData),b.mark("code/extHost/didInitProxyResolver");const l=process.send,c=this._extHostContext.getProxy(A.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?l.apply(process,t):(c.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(w){return w.main}_loadCommonJSModule(w,E,d){if(E.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${E}', must be of file-scheme`);let l=null;d.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${E.toString(!0)}`),this._logService.flush();try{w&&b.mark(`code/extHost/willLoadExtensionCode/${w.value}`),l=K.__$__nodeRequire(E.fsPath)}catch(c){return Promise.reject(c)}finally{w&&b.mark(`code/extHost/didLoadExtensionCode/${w.value}`),d.codeLoadingStop()}return Promise.resolve(l)}async $setRemoteEnvironment(w){if(!!this._initData.remote.isRemote)for(const E in w){const d=w[E];d===null?delete process.env[E]:process.env[E]=d}}}e.ExtHostExtensionService=h}),define(me[282],ge([0,1,80,254,265,264,263,279,281,225,255,47,42,66,71,69,34,51,12]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h,S,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(m.IExtHostExtensionService,D.ExtHostExtensionService),(0,b.registerSingleton)(E.ILogService,P.ExtHostLogService),(0,b.registerSingleton)(I.IExtHostDebugService,y.ExtHostDebugService),(0,b.registerSingleton)(g.IExtHostOutputService,T.ExtHostOutputService2),(0,b.registerSingleton)(a.IExtHostSearch,k.NativeExtHostSearch),(0,b.registerSingleton)(h.IExtHostTask,A.ExtHostTask),(0,b.registerSingleton)(S.IExtHostTerminalService,C.ExtHostTerminalService),(0,b.registerSingleton)(w.IExtHostTunnelService,i.ExtHostTunnelService)}),define(me[283],ge([0,1,124,294,70,17,108,133,188,223,266,23,103,26,105,14,269,282]),function(K,e,b,T,C,A,y,k,D,P,i,I,m,g,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const S=T(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const s=K.__$__nodeRequire("module"),r=s._load;s._load=function(o){if(o==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return r.apply(this,arguments)}})();const w=process.exit.bind(process);function E(s){process.exit=function(r){if(s)w(r);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let d=function(s){w()};function l(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((s,r)=>{let o=null,p=setTimeout(()=>{d("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const f=108e5,_=3e5,u=new h.RunOnceScheduler(()=>d("renderer disconnected for too long (1)"),f),v=new h.RunOnceScheduler(()=>d("renderer disconnected for too long (2)"),_);process.on("message",(O,H)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){const ne=I.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let ie;if(O.skipWebSocketFrames)ie=new k.NodeSocket(H);else{const U=I.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));ie=new k.WebSocketNodeSocket(new k.NodeSocket(H),O.permessageDeflate,U,!1)}o?(u.cancel(),v.cancel(),o.beginAcceptReconnection(ie,ne),o.endAcceptReconnection()):(clearTimeout(p),o=new y.PersistentProtocol(ie,ne),o.onDidDispose(()=>d("renderer disconnected")),s(o),o.onSocketClose(()=>{u.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(v.isScheduled())return;u.isScheduled()&&v.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const s=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,o)=>{const p=b.createConnection(s,()=>{p.removeListener("error",o),r(new y.PersistentProtocol(new k.NodeSocket(p)))});p.once("error",o)})}}async function c(){const s=await l();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,s.onMessage(r=>{(0,P.isMessageOfType)(r,2)?(this._terminating=!0,d("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||s.send(r)}drain(){return s.drain()}}}function t(s){return new Promise(r=>{const o=s.onMessage(p=>{o.dispose();const f=JSON.parse(p.toString()),_=f.commit,u=D.default.commit;_&&u&&_!==u&&w(55);const v=[];process.on("unhandledRejection",(H,ne)=>{v.push(ne),setTimeout(()=>{const ie=v.indexOf(ne);ie>=0&&ne.catch(U=>{v.splice(ie,1),console.warn(`rejected promise not handled within 1 second: ${U}`),U&&U.stack&&console.warn(`stack trace: ${U.stack}`),(0,A.onUnexpectedError)(H)})},1e3)}),process.on("rejectionHandled",H=>{const ne=v.indexOf(H);ne>=0&&v.splice(ne,1)}),process.on("uncaughtException",function(H){(0,A.onUnexpectedError)(H)});let R=0;setInterval(function(){try{process.kill(f.parentPid,0),R=0}catch(H){H&&H.code==="EPERM"?(R++,R>=3&&d(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${H.message} (code: ${H.code}) (errno: ${H.errno})`)):d(`parent process ${f.parentPid} does not exist anymore: ${H.message} (code: ${H.code}) (errno: ${H.errno})`)}},1e3);let O;try{O=K.__$__nodeRequire("native-watchdog"),O.start(f.parentPid)}catch(H){(0,A.onUnexpectedError)(H)}s.send((0,P.createMessageOfType)(0)),r({protocol:s,initData:f})});s.send((0,P.createMessageOfType)(1))})}async function n(){C.mark("code/extHost/willConnectToRenderer");const s=await c();C.mark("code/extHost/didConnectToRenderer");const r=await t(s);C.mark("code/extHost/didWaitForInitData");const{initData:o}=r;E(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=S.useHostProxy!==void 0?S.useHostProxy!=="false":void 0;const p=new class{exit(v){w(v)}exists(v){return(0,g.exists)(v)}realpath(v){return(0,a.realpath)(v)}};let f=null;if(o.remote.authority&&S.uriTransformerPath)try{const v=K.__$__nodeRequire(S.uriTransformerPath)(o.remote.authority);f=new m.URITransformer(v)}catch(u){console.error(u)}const _=new i.ExtensionHostMain(r.protocol,o,p,f);d=u=>_.terminate(u)}e.startExtensionHostProcess=n}),define(me[295],ge([0,1,283]),function(K,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.startExtensionHostProcess)().catch(T=>console.log(T))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/659175fa39b994fc39381b0af2874c85efeb2a01/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
