/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/async","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/workbench/api/common/extHostRpcService","vs/platform/log/common/log","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/network","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/base/common/uuid","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/process","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],we=function(Y){for(var e=[],v=0,T=Y.length;v<T;v++)e[v]=ve[Y[v]];return e};define(ve[42],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(T,D){if(!T)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=v}),define(ve[51],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupByNumber=e.groupBy=e.forEach=e.values=void 0;const v=Object.prototype.hasOwnProperty;function T(P){const h=[];for(let g in P)v.call(P,g)&&h.push(P[g]);return h}e.values=T;function D(P,h){for(let g in P)if(v.call(P,g)&&h({key:g,value:P[g]},function(){delete P[g]})===!1)return}e.forEach=D;function A(P,h){const g=Object.create(null);for(const r of P){const o=h(r);let p=g[o];p||(p=g[o]=[]),p.push(r)}return g}e.groupBy=A;function y(P,h){const g=new Map;for(const r of P){const o=h(r);let p=g.get(o);p||(p=[],g.set(o,p)),p.push(r)}return g}e.groupByNumber=y;function C(P){const h=Object.create(null);return P&&P.forEach((g,r)=>{h[r]=g}),h}e.fromMap=C;function S(P,h){const g=[],r=[];for(let o of P)h.has(o)||g.push(o);for(let o of h)P.has(o)||r.push(o);return{removed:g,added:r}}e.diffSets=S;function k(P,h){const g=[],r=[];for(let[o,p]of P)h.has(o)||g.push(p);for(let[o,p]of h)P.has(o)||r.push(p);return{removed:g,added:r}}e.diffMaps=k;class i{constructor(){this.map=new Map}add(h,g){let r=this.map.get(h);r||(r=new Set,this.map.set(h,r)),r.add(g)}delete(h,g){const r=this.map.get(h);!r||(r.delete(g),r.size===0&&this.map.delete(h))}forEach(h,g){const r=this.map.get(h);!r||r.forEach(g)}}e.SetMap=i}),define(ve[52],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(y){return(C,S,k)=>{let i=null,P=null;if(typeof k.value=="function"?(i="value",P=k.value):typeof k.get=="function"&&(i="get",P=k.get),!P)throw new Error("not supported");k[i]=y(P,S)}}e.createDecorator=v;function T(y,C,S){let k=null,i=null;if(typeof S.value=="function"?(k="value",i=S.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(k="get",i=S.get),!i)throw new Error("not supported");const P=`$memoize$${C}`;S[k]=function(...h){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,h)}),this[P]}}e.memoize=T;function D(y,C,S){return v((k,i)=>{const P=`$debounce$${i}`,h=`$debounce$result$${i}`;return function(...g){this[h]||(this[h]=S?S():void 0),clearTimeout(this[P]),C&&(this[h]=C(this[h],...g),g=[this[h]]),this[P]=setTimeout(()=>{k.apply(this,g),this[h]=S?S():void 0},y)}})}e.debounce=D;function A(y,C,S){return v((k,i)=>{const P=`$throttle$timer$${i}`,h=`$throttle$result$${i}`,g=`$throttle$lastRun$${i}`,r=`$throttle$pending$${i}`;return function(...o){if(this[h]||(this[h]=S?S():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),C&&(this[h]=C(this[h],...o)),!this[r]){const p=this[g]+y;p<=Date.now()?(this[g]=Date.now(),k.apply(this,[this[h]]),this[h]=S?S():void 0):(this[r]=!0,this[P]=setTimeout(()=>{this[r]=!1,this[g]=Date.now(),k.apply(this,[this[h]]),this[h]=S?S():void 0},p-Date.now()))}}})}e.throttle=A}),define(ve[12],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function T(d){e.errorHandler.setUnexpectedErrorHandler(d)}e.setUnexpectedErrorHandler=T;function D(d){S(d)||e.errorHandler.onUnexpectedError(d)}e.onUnexpectedError=D;function A(d){S(d)||e.errorHandler.onUnexpectedExternalError(d)}e.onUnexpectedExternalError=A;function y(d){if(d instanceof Error){let{name:t,message:n}=d;const a=d.stacktrace||d.stack;return{$isError:!0,name:t,message:n,stack:a}}return d}e.transformErrorForSerialization=y;const C="Canceled";function S(d){return d instanceof Error&&d.name===C&&d.message===C}e.isPromiseCanceledError=S;class k extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=k;function i(){const d=new Error(C);return d.name=d.message,d}e.canceled=i;function P(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}e.illegalArgument=P;function h(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}e.illegalState=h;function g(d){return d?new Error(`readonly property '${d} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function r(d){const t=new Error(`${d} has been disposed`);return t.name="DISPOSED",t}e.disposed=r;function o(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}e.getErrorMessage=o;class p extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=p;class m extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=m;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function l(d){const t=d;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=l;function c(d,t=Object.create(null)){const n=new Error(d);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=c}),define(ve[13],we([0,1,12]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function T(H,R=0){return H[H.length-(1+R)]}e.tail=T;function D(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.tail2=D;function A(H,R,L=(M,$)=>M===$){if(H===R)return!0;if(!H||!R||H.length!==R.length)return!1;for(let M=0,$=H.length;M<$;M++)if(!L(H[M],R[M]))return!1;return!0}e.equals=A;function y(H,R,L){let M=0,$=H.length-1;for(;M<=$;){const G=(M+$)/2|0,J=L(H[G],R);if(J<0)M=G+1;else if(J>0)$=G-1;else return G}return-(M+1)}e.binarySearch=y;function C(H,R){let L=0,M=H.length;if(M===0)return 0;for(;L<M;){const $=Math.floor((L+M)/2);R(H[$])?M=$:L=$+1}return L}e.findFirstInSorted=C;function S(H,R,L){if(H=H|0,H>=R.length)throw new TypeError("invalid index");let M=R[Math.floor(R.length*Math.random())],$=[],G=[],J=[];for(let te of R){const me=L(te,M);me<0?$.push(te):me>0?G.push(te):J.push(te)}return H<$.length?S(H,$,L):H<$.length+J.length?J[0]:S(H-($.length+J.length),G,L)}e.quickSelect=S;function k(H,R){const L=[];let M;for(const $ of H.slice(0).sort(R))!M||R(M[0],$)!==0?(M=[$],L.push(M)):M.push($);return L}e.groupBy=k;function i(H,R,L){const M=[];function $(te,me,Le){if(!(me===0&&Le.length===0)){const We=M[M.length-1];We&&We.start+We.deleteCount===te?(We.deleteCount+=me,We.toInsert.push(...Le)):M.push({start:te,deleteCount:me,toInsert:Le})}}let G=0,J=0;for(;;){if(G===H.length){$(G,0,R.slice(J));break}if(J===R.length){$(G,H.length-G,[]);break}const te=H[G],me=R[J],Le=L(te,me);Le===0?(G+=1,J+=1):Le<0?($(G,1,[]),G+=1):Le>0&&($(G,0,[me]),J+=1)}return M}e.sortedDiff=i;function P(H,R,L){const M=i(H,R,L),$=[],G=[];for(const J of M)$.push(...H.slice(J.start,J.start+J.deleteCount)),G.push(...J.toInsert);return{removed:$,added:G}}e.delta=P;function h(H,R,L){if(L===0)return[];const M=H.slice(0,L).sort(R);return r(H,R,M,L,H.length),M}e.top=h;function g(H,R,L,M,$){return L===0?Promise.resolve([]):new Promise((G,J)=>{(async()=>{const te=H.length,me=H.slice(0,L).sort(R);for(let Le=L,We=Math.min(L+M,te);Le<te;Le=We,We=Math.min(We+M,te)){if(Le>L&&await new Promise(Fe=>setTimeout(Fe)),$&&$.isCancellationRequested)throw(0,v.canceled)();r(H,R,me,Le,We)}return me})().then(G,J)})}e.topAsync=g;function r(H,R,L,M,$){for(const G=L.length;M<$;M++){const J=H[M];if(R(J,L[G-1])<0){L.pop();const te=C(L,me=>R(J,me)<0);L.splice(te,0,J)}}}function o(H){return H.filter(R=>!!R)}e.coalesce=o;function p(H){let R=0;for(let L=0;L<H.length;L++)H[L]&&(H[R]=H[L],R+=1);H.length=R}e.coalesceInPlace=p;function m(H,R,L){H.splice(L,0,H.splice(R,1)[0])}e.move=m;function E(H){return!Array.isArray(H)||H.length===0}e.isFalsyOrEmpty=E;function l(H){return Array.isArray(H)&&H.length>0}e.isNonEmptyArray=l;function c(H,R){if(!R)return H.filter((M,$)=>H.indexOf(M)===$);const L=Object.create(null);return H.filter(M=>{const $=R(M);return L[$]?!1:(L[$]=!0,!0)})}e.distinct=c;function d(H){const R=new Set;return H.filter(L=>R.has(L)?!1:(R.add(L),!0))}e.distinctES6=d;function t(H){const R=Object.create(null);return L=>{const M=H(L);return R[M]?!1:(R[M]=!0,!0)}}e.uniqueFilter=t;function n(H,R){for(let L=H.length-1;L>=0;L--){const M=H[L];if(R(M))return L}return-1}e.lastIndex=n;function a(H,R){return H.length>0?H[0]:R}e.firstOrDefault=a;function s(H,R,L=(M,$)=>M===$){let M=0;for(let $=0,G=Math.min(H.length,R.length);$<G&&L(H[$],R[$]);$++)M++;return M}e.commonPrefixLength=s;function u(H){return[].concat(...H)}e.flatten=u;function w(H,R){let L=typeof R=="number"?H:0;typeof R=="number"?L=H:(L=0,R=H);const M=[];if(L<=R)for(let $=L;$<R;$++)M.push($);else for(let $=L;$>R;$--)M.push($);return M}e.range=w;function b(H,R,L){return H.reduce((M,$)=>(M[R($)]=L?L($):$,M),Object.create(null))}e.index=b;function I(H,R){return H.push(R),()=>f(H,R)}e.insert=I;function f(H,R){const L=H.indexOf(R);if(L>-1)return H.splice(L,1),R}e.remove=f;function _(H,R,L){const M=H.slice(0,R),$=H.slice(R);return M.concat(L,$)}e.arrayInsert=_;function F(H,R){let L;if(typeof R=="number"){let M=R;L=()=>{const $=Math.sin(M++)*179426549;return $-Math.floor($)}}else L=Math.random;for(let M=H.length-1;M>0;M-=1){const $=Math.floor(L()*(M+1)),G=H[M];H[M]=H[$],H[$]=G}}e.shuffle=F;function U(H,R){const L=H.indexOf(R);L>-1&&(H.splice(L,1),H.unshift(R))}e.pushToStart=U;function z(H,R){const L=H.indexOf(R);L>-1&&(H.splice(L,1),H.push(R))}e.pushToEnd=z;function he(H,R){return Array.isArray(H)?H.map(R):R(H)}e.mapArrayOrNot=he;function de(H){return Array.isArray(H)?H:[H]}e.asArray=de;function x(H){return H[Math.floor(Math.random()*H.length)]}e.getRandomElement=x;function j(H,R){for(const L of H){const M=R(L);if(M!==void 0)return M}}e.mapFind=j}),define(ve[53],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(T){const D=this;let A=!1,y;return function(){return A||(A=!0,y=T.apply(D,arguments)),y}}e.once=v}),define(ve[54],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class v{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=v,e.defaultGenerator=new v("id#")}),define(ve[43],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(T){function D(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}T.is=D;const A=Object.freeze([]);function y(){return A}T.empty=y;function*C(d){yield d}T.single=C;function S(d){return d||A}T.from=S;function k(d){return!d||d[Symbol.iterator]().next().done===!0}T.isEmpty=k;function i(d){return d[Symbol.iterator]().next().value}T.first=i;function P(d,t){for(const n of d)if(t(n))return!0;return!1}T.some=P;function h(d,t){for(const n of d)if(t(n))return n}T.find=h;function*g(d,t){for(const n of d)t(n)&&(yield n)}T.filter=g;function*r(d,t){for(const n of d)yield t(n)}T.map=r;function*o(...d){for(const t of d)for(const n of t)yield n}T.concat=o;function*p(d){for(const t of d)for(const n of t)yield n}T.concatNested=p;function m(d,t,n){let a=n;for(const s of d)a=t(a,s);return a}T.reduce=m;function*E(d,t,n=d.length){for(t<0&&(t+=d.length),n<0?n+=d.length:n>d.length&&(n=d.length);t<n;t++)yield d[t]}T.slice=E;function l(d,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,d];const a=d[Symbol.iterator]();for(let s=0;s<t;s++){const u=a.next();if(u.done)return[n,T.empty()];n.push(u.value)}return[n,{[Symbol.iterator](){return a}}]}T.consume=l;function c(d,t,n=(a,s)=>a===s){const a=d[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const u=a.next(),w=s.next();if(u.done!==w.done)return!1;if(u.done)return!0;if(!n(u.value,w.value))return!1}}T.equals=c})(v=e.Iterable||(e.Iterable={}))}),define(ve[44],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function y(t,n=!1){let a=0,s=t.length,u="",w=0,b=16,I=0;function f(x){let j=0,H=0;for(;j<x;){const R=t.charCodeAt(a);if(R>=48&&R<=57)H=H*16+R-48;else if(R>=65&&R<=70)H=H*16+R-65+10;else if(R>=97&&R<=102)H=H*16+R-97+10;else break;a++,j++}return j<x&&(H=-1),H}function _(x){a=x,u="",w=0,b=16,I=0}function F(){const x=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&k(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&k(t.charCodeAt(a)))for(a++;a<t.length&&k(t.charCodeAt(a));)a++;else return I=3,t.substring(x,a);let j=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&k(t.charCodeAt(a))){for(a++;a<t.length&&k(t.charCodeAt(a));)a++;j=a}else I=3;return t.substring(x,j)}function U(){let x="",j=a;for(;;){if(a>=s){x+=t.substring(j,a),I=2;break}const H=t.charCodeAt(a);if(H===34){x+=t.substring(j,a),a++;break}if(H===92){if(x+=t.substring(j,a),a++,a>=s){I=2;break}switch(t.charCodeAt(a++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const L=f(4);L>=0?x+=String.fromCharCode(L):I=4;break;default:I=5}j=a;continue}if(H>=0&&H<=31)if(S(H)){x+=t.substring(j,a),I=2;break}else I=6;a++}return x}function z(){if(u="",I=0,w=a,a>=s)return w=s,b=17;let x=t.charCodeAt(a);if(C(x)){do a++,u+=String.fromCharCode(x),x=t.charCodeAt(a);while(C(x));return b=15}if(S(x))return a++,u+=String.fromCharCode(x),x===13&&t.charCodeAt(a)===10&&(a++,u+=`
`),b=14;switch(x){case 123:return a++,b=1;case 125:return a++,b=2;case 91:return a++,b=3;case 93:return a++,b=4;case 58:return a++,b=6;case 44:return a++,b=5;case 34:return a++,u=U(),b=10;case 47:const j=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<s&&!S(t.charCodeAt(a));)a++;return u=t.substring(j,a),b=12}if(t.charCodeAt(a+1)===42){a+=2;const H=s-1;let R=!1;for(;a<H;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,R=!0;break}a++}return R||(a++,I=1),u=t.substring(j,a),b=13}return u+=String.fromCharCode(x),a++,b=16;case 45:if(u+=String.fromCharCode(x),a++,a===s||!k(t.charCodeAt(a)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=F(),b=11;default:for(;a<s&&he(x);)a++,x=t.charCodeAt(a);if(w!==a){switch(u=t.substring(w,a),u){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return u+=String.fromCharCode(x),a++,b=16}}function he(x){if(C(x)||S(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function de(){let x;do x=z();while(x>=12&&x<=15);return x}return{setPosition:_,getPosition:()=>a,scan:n?de:z,getToken:()=>b,getTokenValue:()=>u,getTokenOffset:()=>w,getTokenLength:()=>a-w,getTokenError:()=>I}}e.createScanner=y;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function P(t,n){const a=[],s=new Object;let u;const w={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function I(f,_,F,U){w.value=f,w.offset=_,w.length=F,w.type=U,w.colonOffset=void 0,u=w}try{l(t,{onObjectBegin:(f,_)=>{if(n<=f)throw s;u=void 0,b=n>f,a.push("")},onObjectProperty:(f,_,F)=>{if(n<_||(I(f,_,F,"property"),a[a.length-1]=f,n<=_+F))throw s},onObjectEnd:(f,_)=>{if(n<=f)throw s;u=void 0,a.pop()},onArrayBegin:(f,_)=>{if(n<=f)throw s;u=void 0,a.push(0)},onArrayEnd:(f,_)=>{if(n<=f)throw s;u=void 0,a.pop()},onLiteralValue:(f,_,F)=>{if(n<_||(I(f,_,F,d(f)),n<=_+F))throw s},onSeparator:(f,_,F)=>{if(n<=_)throw s;if(f===":"&&u&&u.type==="property")u.colonOffset=_,b=!1,u=void 0;else if(f===","){const U=a[a.length-1];typeof U=="number"?a[a.length-1]=U+1:(b=!0,a[a.length-1]=""),u=void 0}}})}catch(f){if(f!==s)throw f}return{path:a,previousNode:u,isAtPropertyKey:b,matches:f=>{let _=0;for(let F=0;_<f.length&&F<a.length;F++)if(f[_]===a[F]||f[_]==="*")_++;else if(f[_]!=="**")return!1;return _===f.length}}}e.getLocation=P;function h(t,n=[],a=A.DEFAULT){let s=null,u=[];const w=[];function b(f){Array.isArray(u)?u.push(f):s!==null&&(u[s]=f)}return l(t,{onObjectBegin:()=>{const f={};b(f),w.push(u),u=f,s=null},onObjectProperty:f=>{s=f},onObjectEnd:()=>{u=w.pop()},onArrayBegin:()=>{const f=[];b(f),w.push(u),u=f,s=null},onArrayEnd:()=>{u=w.pop()},onLiteralValue:b,onError:(f,_,F)=>{n.push({error:f,offset:_,length:F})}},a),u[0]}e.parse=h;function g(t,n=[],a=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(f){s.type==="property"&&(s.length=f-s.offset,s=s.parent)}function w(f){return s.children.push(f),f}l(t,{onObjectBegin:f=>{s=w({type:"object",offset:f,length:-1,parent:s,children:[]})},onObjectProperty:(f,_,F)=>{s=w({type:"property",offset:_,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:f,offset:_,length:F,parent:s})},onObjectEnd:(f,_)=>{s.length=f+_-s.offset,s=s.parent,u(f+_)},onArrayBegin:(f,_)=>{s=w({type:"array",offset:f,length:-1,parent:s,children:[]})},onArrayEnd:(f,_)=>{s.length=f+_-s.offset,s=s.parent,u(f+_)},onLiteralValue:(f,_,F)=>{w({type:d(f),offset:_,length:F,parent:s,value:f}),u(_+F)},onSeparator:(f,_,F)=>{s.type==="property"&&(f===":"?s.colonOffset=_:f===","&&u(_))},onError:(f,_,F)=>{n.push({error:f,offset:_,length:F})}},a);const I=s.children[0];return I&&delete I.parent,I}e.parseTree=g;function r(t,n){if(!!t){let a=t;for(let s of n)if(typeof s=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let u=!1;for(const w of a.children)if(Array.isArray(w.children)&&w.children[0].value===s){a=w.children[1],u=!0;break}if(!u)return}else{const u=s;if(a.type!=="array"||u<0||!Array.isArray(a.children)||u>=a.children.length)return;a=a.children[u]}return a}}e.findNodeAtLocation=r;function o(t){if(!t.parent||!t.parent.children)return[];const n=o(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;n.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&n.push(a)}return n}e.getNodePath=o;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":const n=Object.create(null);for(let a of t.children){const s=a.children[1];s&&(n[a.children[0].value]=p(s))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=p;function m(t,n,a=!1){return n>=t.offset&&n<t.offset+t.length||a&&n===t.offset+t.length}e.contains=m;function E(t,n,a=!1){if(m(t,n,a)){const s=t.children;if(Array.isArray(s))for(let u=0;u<s.length&&s[u].offset<=n;u++){const w=E(s[u],n,a);if(w)return w}return t}}e.findNodeAtOffset=E;function l(t,n,a=A.DEFAULT){const s=y(t,!1);function u(me){return me?()=>me(s.getTokenOffset(),s.getTokenLength()):()=>!0}function w(me){return me?Le=>me(Le,s.getTokenOffset(),s.getTokenLength()):()=>!0}const b=u(n.onObjectBegin),I=w(n.onObjectProperty),f=u(n.onObjectEnd),_=u(n.onArrayBegin),F=u(n.onArrayEnd),U=w(n.onLiteralValue),z=w(n.onSeparator),he=u(n.onComment),de=w(n.onError),x=a&&a.disallowComments,j=a&&a.allowTrailingComma;function H(){for(;;){const me=s.scan();switch(s.getTokenError()){case 4:R(14);break;case 5:R(15);break;case 3:R(13);break;case 1:x||R(11);break;case 2:R(12);break;case 6:R(16);break}switch(me){case 12:case 13:x?R(10):he();break;case 16:R(1);break;case 15:case 14:break;default:return me}}}function R(me,Le=[],We=[]){if(de(me),Le.length+We.length>0){let Fe=s.getToken();for(;Fe!==17;){if(Le.indexOf(Fe)!==-1){H();break}else if(We.indexOf(Fe)!==-1)break;Fe=H()}}}function L(me){const Le=s.getTokenValue();return me?U(Le):I(Le),H(),!0}function M(){switch(s.getToken()){case 11:let me=0;try{me=JSON.parse(s.getTokenValue()),typeof me!="number"&&(R(2),me=0)}catch(Le){R(2)}U(me);break;case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return H(),!0}function $(){return s.getToken()!==10?(R(3,[],[2,5]),!1):(L(!1),s.getToken()===6?(z(":"),H(),te()||R(4,[],[2,5])):R(5,[],[2,5]),!0)}function G(){b(),H();let me=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(me||R(4,[],[]),z(","),H(),s.getToken()===2&&j)break}else me&&R(6,[],[]);$()||R(4,[],[2,5]),me=!0}return f(),s.getToken()!==2?R(7,[2],[]):H(),!0}function J(){_(),H();let me=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(me||R(4,[],[]),z(","),H(),s.getToken()===4&&j)break}else me&&R(6,[],[]);te()||R(4,[],[4,5]),me=!0}return F(),s.getToken()!==4?R(8,[4],[]):H(),!0}function te(){switch(s.getToken()){case 3:return J();case 1:return G();case 10:return L(!0);default:return M()}}return H(),s.getToken()===17?a.allowEmptyContent?!0:(R(4,[],[]),!1):te()?(s.getToken()!==17&&R(9,[],[]),!0):(R(4,[],[]),!1)}e.visit=l;function c(t,n){let a=y(t),s=[],u,w=0,b;do switch(b=a.getPosition(),u=a.scan(),u){case 12:case 13:case 17:w!==b&&s.push(t.substring(w,b)),n!==void 0&&s.push(a.getTokenValue().replace(/[^\r\n]/g,n)),w=a.getPosition();break}while(u!==17);return s.join("")}e.stripComments=c;function d(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=d}),define(ve[107],we([0,1,44]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function T(S,k,i){let P,h,g,r,o;if(k){for(r=k.offset,o=r+k.length,g=r;g>0&&!C(S,g-1);)g--;let w=o;for(;w<S.length&&!C(S,w);)w++;h=S.substring(g,w),P=A(h,i)}else h=S,P=0,g=0,r=0,o=S.length;const p=y(i,S);let m=!1,E=0,l;i.insertSpaces?l=D(" ",i.tabSize||4):l="	";const c=(0,v.createScanner)(h,!1);let d=!1;function t(){return p+D(l,P+E)}function n(){let w=c.scan();for(m=!1;w===15||w===14;)m=m||w===14,w=c.scan();return d=w===16||c.getTokenError()!==0,w}const a=[];function s(w,b,I){!d&&b<o&&I>r&&S.substring(b,I)!==w&&a.push({offset:b,length:I-b,content:w})}let u=n();if(u!==17){const w=c.getTokenOffset()+g,b=D(l,P);s(b,g,w)}for(;u!==17;){let w=c.getTokenOffset()+c.getTokenLength()+g,b=n(),I="";for(;!m&&(b===12||b===13);){const _=c.getTokenOffset()+g;s(" ",w,_),w=c.getTokenOffset()+c.getTokenLength()+g,I=b===12?t():"",b=n()}if(b===2)u!==1&&(E--,I=t());else if(b===4)u!==3&&(E--,I=t());else{switch(u){case 3:case 1:E++,I=t();break;case 5:case 12:I=t();break;case 13:m?I=t():I=" ";break;case 6:I=" ";break;case 10:if(b===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:b===12||b===13?I=" ":b!==5&&b!==17&&(d=!0);break;case 16:d=!0;break}m&&(b===12||b===13)&&(I=t())}const f=c.getTokenOffset()+g;s(I,w,f),u=b}return a}e.format=T;function D(S,k){let i="";for(let P=0;P<k;P++)i+=S;return i}function A(S,k){let i=0,P=0;const h=k.tabSize||4;for(;i<S.length;){const g=S.charAt(i);if(g===" ")P++;else if(g==="	")P+=h;else break;i++}return Math.floor(P/h)}function y(S,k){for(let i=0;i<k.length;i++){const P=k.charAt(i);if(P==="\r")return i+1<k.length&&k.charAt(i+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=y;function C(S,k){return`\r
`.indexOf(S.charAt(k))!==-1}e.isEOL=C}),define(ve[108],we([0,1,44,107]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(k,i,P){return A(k,i,void 0,P)}e.removeProperty=D;function A(k,i,P,h,g){const r=i.slice(),o=[],p=(0,v.parseTree)(k,o);let m,E;for(;r.length>0&&(E=r.pop(),m=(0,v.findNodeAtLocation)(p,r),m===void 0&&P!==void 0);)typeof E=="string"?P={[E]:P}:P=[P];if(m)if(m.type==="object"&&typeof E=="string"&&Array.isArray(m.children)){const l=(0,v.findNodeAtLocation)(m,[E]);if(l!==void 0)if(P===void 0){if(!l.parent)throw new Error("Malformed AST");const c=m.children.indexOf(l.parent);let d,t=l.parent.offset+l.parent.length;if(c>0){const n=m.children[c-1];d=n.offset+n.length}else d=m.offset+1,m.children.length>1&&(t=m.children[1].offset);return y(k,{offset:d,length:t-d,content:""},h)}else return y(k,{offset:l.offset,length:l.length,content:JSON.stringify(P)},h);else{if(P===void 0)return[];const c=`${JSON.stringify(E)}: ${JSON.stringify(P)}`,d=g?g(m.children.map(n=>n.children[0].value)):m.children.length;let t;if(d>0){const n=m.children[d-1];t={offset:n.offset+n.length,length:0,content:","+c}}else m.children.length===0?t={offset:m.offset+1,length:0,content:c}:t={offset:m.offset+1,length:0,content:c+","};return y(k,t,h)}}else if(m.type==="array"&&typeof E=="number"&&Array.isArray(m.children))if(P!==void 0){const l=`${JSON.stringify(P)}`;let c;if(m.children.length===0||E===0)c={offset:m.offset+1,length:0,content:m.children.length===0?l:l+","};else{const d=E===-1||E>m.children.length?m.children.length:E,t=m.children[d-1];c={offset:t.offset+t.length,length:0,content:","+l}}return y(k,c,h)}else{const l=E,c=m.children[l];let d;if(m.children.length===1)d={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===l){const t=m.children[l-1],n=t.offset+t.length,a=m.offset+m.length;d={offset:n,length:a-2-n,content:""}}else d={offset:c.offset,length:m.children[l+1].offset-c.offset,content:""};return y(k,d,h)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${m.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return y(k,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(P)},h)}}e.setProperty=A;function y(k,i,P){let h=C(k,i),g=i.offset,r=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;g>0&&!(0,T.isEOL)(h,g-1);)g--;for(;r<h.length&&!(0,T.isEOL)(h,r);)r++}const o=(0,T.format)(h,{offset:g,length:r-g},P);for(let m=o.length-1;m>=0;m--){const E=o[m];h=C(h,E),g=Math.min(g,E.offset),r=Math.max(r,E.offset+E.length),r+=E.content.length-E.length}const p=k.length-(h.length-r)-g;return[{offset:g,length:p,content:h.substring(g,r)}]}e.withFormatting=y;function C(k,i){return k.substring(0,i.offset)+i.content+k.substring(i.offset+i.length)}e.applyEdit=C;function S(k,i){let P=i.slice(0).sort((g,r)=>{const o=g.offset-r.offset;return o===0?g.length-r.length:o}),h=k.length;for(let g=P.length-1;g>=0;g--){let r=P[g];if(r.offset+r.length<=h)k=C(k,r);else throw new Error("Overlapping edit");h=r.offset}return k}e.applyEdits=S}),define(ve[109],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new v(()=>D(this.getValue()))}}e.Lazy=v}),define(ve[6],we([0,1,53,43]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const D=!1;let A=null;function y(l){A=l}if(e.setDisposableTracker=y,D){const l="__is_disposable_tracked__";A=new class{trackDisposable(c){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[l]||console.log(d)},3e3)}markTracked(c){if(c&&c!==o.None)try{c[l]=!0}catch(d){}}}}function C(l){!A||A.markTracked(l)}function S(l){return A&&A.trackDisposable(l),l}e.trackDisposable=S;class k extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=k;function i(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=i;function P(l){if(T.Iterable.is(l)){let c=[];for(const d of l)if(d){C(d);try{d.dispose()}catch(t){c.push(t)}}if(c.length===1)throw c[0];if(c.length>1)throw new k(c);return Array.isArray(l)?[]:l}else if(l)return C(l),l.dispose(),l}e.dispose=P;function h(...l){return l.forEach(C),g(()=>P(l))}e.combinedDisposable=h;function g(l){const c=S({dispose:()=>{C(c),l()}});return c}e.toDisposable=g;class r{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}clear(){try{P(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return C(c),this._isDisposed?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=r,r.DISABLE_DISPOSED_WARNING=!1;class o{constructor(){this._store=new r,S(this)}dispose(){C(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=o,o.None=Object.freeze({dispose(){}});class p{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var d;this._isDisposed||c===this._value||((d=this._value)===null||d===void 0||d.dispose(),c&&C(c),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,C(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}}e.MutableDisposable=p;class m{constructor(){this.references=new Map}acquire(c,...d){let t=this.references.get(c);t||(t={counter:0,object:this.createReferencedObject(c,...d)},this.references.set(c,t));const{object:n}=t,a=(0,v.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(c,t.object),this.references.delete(c))});return t.counter++,{object:n,dispose:a}}}e.ReferenceCollection=m;class E{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=E}),define(ve[45],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(A){this.element=A,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class T{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let A=this._first;for(;A!==v.Undefined;){const y=A.next;A.prev=v.Undefined,A.next=v.Undefined,A=y}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,y){const C=new v(A);if(this._first===v.Undefined)this._first=C,this._last=C;else if(y){const k=this._last;this._last=C,C.prev=k,k.next=C}else{const k=this._first;this._first=C,C.next=k,k.prev=C}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(C))}}shift(){if(this._first!==v.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==v.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==v.Undefined&&A.next!==v.Undefined){const y=A.prev;y.next=A.next,A.next.prev=y}else A.prev===v.Undefined&&A.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):A.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):A.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==v.Undefined;)yield A.element,A=A.next}}e.LinkedList=T}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(ye,Ee){for(var Ce=0;Ce<Ee.length;Ce++){var ie=Ee[Ce];ie.enumerable=ie.enumerable||!1,ie.configurable=!0,"value"in ie&&(ie.writable=!0),Object.defineProperty(ye,ie.key,ie)}}function e(ye,Ee,Ce){return Ee&&Y(ye.prototype,Ee),Ce&&Y(ye,Ce),ye}function v(ye,Ee){if(!!ye){if(typeof ye=="string")return T(ye,Ee);var Ce=Object.prototype.toString.call(ye).slice(8,-1);if(Ce==="Object"&&ye.constructor&&(Ce=ye.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(ye);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return T(ye,Ee)}}function T(ye,Ee){(Ee==null||Ee>ye.length)&&(Ee=ye.length);for(var Ce=0,ie=new Array(Ee);Ce<Ee;Ce++)ie[Ce]=ye[Ce];return ie}function D(ye,Ee){var Ce;if(typeof Symbol=="undefined"||ye[Symbol.iterator]==null){if(Array.isArray(ye)||(Ce=v(ye))||Ee&&ye&&typeof ye.length=="number"){Ce&&(ye=Ce);var ie=0;return function(){return ie>=ye.length?{done:!0}:{done:!1,value:ye[ie++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Ce=ye[Symbol.iterator](),Ce.next.bind(Ce)}function A(ye){var Ee={exports:{}};return ye(Ee,Ee.exports),Ee.exports}var y=A(function(ye){function Ee(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Ce(ie){ye.exports.defaults=ie}ye.exports={defaults:Ee(),getDefaults:Ee,changeDefaults:Ce}}),C=/[&<>"']/,S=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,P={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(Ee){return P[Ee]};function g(ye,Ee){if(Ee){if(C.test(ye))return ye.replace(S,h)}else if(k.test(ye))return ye.replace(i,h);return ye}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ye){return ye.replace(r,function(Ee,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var p=/(^|[^\[])\^/g;function m(ye,Ee){ye=ye.source||ye,Ee=Ee||"";var Ce={replace:function(ae,N){return N=N.source||N,N=N.replace(p,"$1"),ye=ye.replace(ae,N),Ce},getRegex:function(){return new RegExp(ye,Ee)}};return Ce}var E=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(ye,Ee,Ce){if(ye){var ie;try{ie=decodeURIComponent(o(Ce)).replace(E,"").toLowerCase()}catch(ae){return null}if(ie.indexOf("javascript:")===0||ie.indexOf("vbscript:")===0||ie.indexOf("data:")===0)return null}Ee&&!l.test(Ce)&&(Ce=s(Ee,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(ae){return null}return Ce}var d={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(ye,Ee){d[" "+ye]||(t.test(ye)?d[" "+ye]=ye+"/":d[" "+ye]=I(ye,"/",!0)),ye=d[" "+ye];var Ce=ye.indexOf(":")===-1;return Ee.substring(0,2)==="//"?Ce?Ee:ye.replace(n,"$1")+Ee:Ee.charAt(0)==="/"?Ce?Ee:ye.replace(a,"$1")+Ee:ye+Ee}var u={exec:function(){}};function w(ye){for(var Ee=1,Ce,ie;Ee<arguments.length;Ee++){Ce=arguments[Ee];for(ie in Ce)Object.prototype.hasOwnProperty.call(Ce,ie)&&(ye[ie]=Ce[ie])}return ye}function b(ye,Ee){var Ce=ye.replace(/\|/g,function(N,Q,oe){for(var ke=!1,Ie=Q;--Ie>=0&&oe[Ie]==="\\";)ke=!ke;return ke?"|":" |"}),ie=Ce.split(/ \|/),ae=0;if(ie.length>Ee)ie.splice(Ee);else for(;ie.length<Ee;)ie.push("");for(;ae<ie.length;ae++)ie[ae]=ie[ae].trim().replace(/\\\|/g,"|");return ie}function I(ye,Ee,Ce){var ie=ye.length;if(ie===0)return"";for(var ae=0;ae<ie;){var N=ye.charAt(ie-ae-1);if(N===Ee&&!Ce)ae++;else if(N!==Ee&&Ce)ae++;else break}return ye.substr(0,ie-ae)}function f(ye,Ee){if(ye.indexOf(Ee[1])===-1)return-1;for(var Ce=ye.length,ie=0,ae=0;ae<Ce;ae++)if(ye[ae]==="\\")ae++;else if(ye[ae]===Ee[0])ie++;else if(ye[ae]===Ee[1]&&(ie--,ie<0))return ae;return-1}function _(ye){ye&&ye.sanitize&&!ye.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(ye,Ee){if(Ee<1)return"";for(var Ce="";Ee>1;)Ee&1&&(Ce+=ye),Ee>>=1,ye+=ye;return Ce+ye}var U={escape:g,unescape:o,edit:m,cleanUrl:c,resolveUrl:s,noopTest:u,merge:w,splitCells:b,rtrim:I,findClosingBracket:f,checkSanitizeDeprecation:_,repeatString:F},z=y.defaults,he=U.rtrim,de=U.splitCells,x=U.escape,j=U.findClosingBracket;function H(ye,Ee,Ce){var ie=Ee.href,ae=Ee.title?x(Ee.title):null,N=ye[1].replace(/\\([\[\]])/g,"$1");return ye[0].charAt(0)!=="!"?{type:"link",raw:Ce,href:ie,title:ae,text:N}:{type:"image",raw:Ce,href:ie,title:ae,text:x(N)}}function R(ye,Ee){var Ce=ye.match(/^(\s+)(?:```)/);if(Ce===null)return Ee;var ie=Ce[1];return Ee.split(`
`).map(function(ae){var N=ae.match(/^\s+/);if(N===null)return ae;var Q=N[0];return Q.length>=ie.length?ae.slice(ie.length):ae}).join(`
`)}var L=function(){function ye(Ce){this.options=Ce||z}var Ee=ye.prototype;return Ee.space=function(ie){var ae=this.rules.block.newline.exec(ie);if(ae)return ae[0].length>1?{type:"space",raw:ae[0]}:{raw:`
`}},Ee.code=function(ie){var ae=this.rules.block.code.exec(ie);if(ae){var N=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?N:he(N,`
`)}}},Ee.fences=function(ie){var ae=this.rules.block.fences.exec(ie);if(ae){var N=ae[0],Q=R(N,ae[3]||"");return{type:"code",raw:N,lang:ae[2]?ae[2].trim():ae[2],text:Q}}},Ee.heading=function(ie){var ae=this.rules.block.heading.exec(ie);if(ae){var N=ae[2].trim();if(/#$/.test(N)){var Q=he(N,"#");(this.options.pedantic||!Q||/ $/.test(Q))&&(N=Q.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:N}}},Ee.nptable=function(ie){var ae=this.rules.block.nptable.exec(ie);if(ae){var N={type:"table",header:de(ae[1].replace(/^ *| *\| *$/g,"")),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ae[3]?ae[3].replace(/\n$/,"").split(`
`):[],raw:ae[0]};if(N.header.length===N.align.length){var Q=N.align.length,oe;for(oe=0;oe<Q;oe++)/^ *-+: *$/.test(N.align[oe])?N.align[oe]="right":/^ *:-+: *$/.test(N.align[oe])?N.align[oe]="center":/^ *:-+ *$/.test(N.align[oe])?N.align[oe]="left":N.align[oe]=null;for(Q=N.cells.length,oe=0;oe<Q;oe++)N.cells[oe]=de(N.cells[oe],N.header.length);return N}}},Ee.hr=function(ie){var ae=this.rules.block.hr.exec(ie);if(ae)return{type:"hr",raw:ae[0]}},Ee.blockquote=function(ie){var ae=this.rules.block.blockquote.exec(ie);if(ae){var N=ae[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ae[0],text:N}}},Ee.list=function(ie){var ae=this.rules.block.list.exec(ie);if(ae){var N=ae[0],Q=ae[2],oe=Q.length>1,ke={type:"list",raw:N,ordered:oe,start:oe?+Q.slice(0,-1):"",loose:!1,items:[]},Ie=ae[0].match(this.rules.block.item),Ae=!1,Be,Ye,rt,tt,Qe,gt,bt,pe,ue=Ie.length;rt=this.rules.block.listItemStart.exec(Ie[0]);for(var re=0;re<ue;re++){if(Be=Ie[re],N=Be,re!==ue-1){if(tt=this.rules.block.listItemStart.exec(Ie[re+1]),this.options.pedantic?tt[1].length>rt[1].length:tt[1].length>rt[0].length||tt[1].length>3){Ie.splice(re,2,Ie[re]+`
`+Ie[re+1]),re--,ue--;continue}else(!this.options.pedantic||this.options.smartLists?tt[2][tt[2].length-1]!==Q[Q.length-1]:oe===(tt[2].length===1))&&(Qe=Ie.slice(re+1).join(`
`),ke.raw=ke.raw.substring(0,ke.raw.length-Qe.length),re=ue-1);rt=tt}Ye=Be.length,Be=Be.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Be.indexOf(`
 `)&&(Ye-=Be.length,Be=this.options.pedantic?Be.replace(/^ {1,4}/gm,""):Be.replace(new RegExp("^ {1,"+Ye+"}","gm"),"")),gt=Ae||/\n\n(?!\s*$)/.test(Be),re!==ue-1&&(Ae=Be.charAt(Be.length-1)===`
`,gt||(gt=Ae)),gt&&(ke.loose=!0),this.options.gfm&&(bt=/^\[[ xX]\] /.test(Be),pe=void 0,bt&&(pe=Be[1]!==" ",Be=Be.replace(/^\[[ xX]\] +/,""))),ke.items.push({type:"list_item",raw:N,task:bt,checked:pe,loose:gt,text:Be})}return ke}},Ee.html=function(ie){var ae=this.rules.block.html.exec(ie);if(ae)return{type:this.options.sanitize?"paragraph":"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):x(ae[0]):ae[0]}},Ee.def=function(ie){var ae=this.rules.block.def.exec(ie);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var N=ae[1].toLowerCase().replace(/\s+/g," ");return{tag:N,raw:ae[0],href:ae[2],title:ae[3]}}},Ee.table=function(ie){var ae=this.rules.block.table.exec(ie);if(ae){var N={type:"table",header:de(ae[1].replace(/^ *| *\| *$/g,"")),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ae[3]?ae[3].replace(/\n$/,"").split(`
`):[]};if(N.header.length===N.align.length){N.raw=ae[0];var Q=N.align.length,oe;for(oe=0;oe<Q;oe++)/^ *-+: *$/.test(N.align[oe])?N.align[oe]="right":/^ *:-+: *$/.test(N.align[oe])?N.align[oe]="center":/^ *:-+ *$/.test(N.align[oe])?N.align[oe]="left":N.align[oe]=null;for(Q=N.cells.length,oe=0;oe<Q;oe++)N.cells[oe]=de(N.cells[oe].replace(/^ *\| *| *\| *$/g,""),N.header.length);return N}}},Ee.lheading=function(ie){var ae=this.rules.block.lheading.exec(ie);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1]}},Ee.paragraph=function(ie){var ae=this.rules.block.paragraph.exec(ie);if(ae)return{type:"paragraph",raw:ae[0],text:ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1]}},Ee.text=function(ie){var ae=this.rules.block.text.exec(ie);if(ae)return{type:"text",raw:ae[0],text:ae[0]}},Ee.escape=function(ie){var ae=this.rules.inline.escape.exec(ie);if(ae)return{type:"escape",raw:ae[0],text:x(ae[1])}},Ee.tag=function(ie,ae,N){var Q=this.rules.inline.tag.exec(ie);if(Q)return!ae&&/^<a /i.test(Q[0])?ae=!0:ae&&/^<\/a>/i.test(Q[0])&&(ae=!1),!N&&/^<(pre|code|kbd|script)(\s|>)/i.test(Q[0])?N=!0:N&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Q[0])&&(N=!1),{type:this.options.sanitize?"text":"html",raw:Q[0],inLink:ae,inRawBlock:N,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):x(Q[0]):Q[0]}},Ee.link=function(ie){var ae=this.rules.inline.link.exec(ie);if(ae){var N=ae[2].trim();if(!this.options.pedantic&&/^</.test(N)){if(!/>$/.test(N))return;var Q=he(N.slice(0,-1),"\\");if((N.length-Q.length)%2==0)return}else{var oe=j(ae[2],"()");if(oe>-1){var ke=ae[0].indexOf("!")===0?5:4,Ie=ke+ae[1].length+oe;ae[2]=ae[2].substring(0,oe),ae[0]=ae[0].substring(0,Ie).trim(),ae[3]=""}}var Ae=ae[2],Be="";if(this.options.pedantic){var Ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);Ye&&(Ae=Ye[1],Be=Ye[3])}else Be=ae[3]?ae[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(N)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),H(ae,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Be&&Be.replace(this.rules.inline._escapes,"$1")},ae[0])}},Ee.reflink=function(ie,ae){var N;if((N=this.rules.inline.reflink.exec(ie))||(N=this.rules.inline.nolink.exec(ie))){var Q=(N[2]||N[1]).replace(/\s+/g," ");if(Q=ae[Q.toLowerCase()],!Q||!Q.href){var oe=N[0].charAt(0);return{type:"text",raw:oe,text:oe}}return H(N,Q,N[0])}},Ee.emStrong=function(ie,ae,N){N===void 0&&(N="");var Q=this.rules.inline.emStrong.lDelim.exec(ie);if(!!Q&&!(Q[3]&&N.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var oe=Q[1]||Q[2]||"";if(!oe||oe&&(N===""||this.rules.inline.punctuation.exec(N))){var ke=Q[0].length-1,Ie,Ae,Be=ke,Ye=0,rt=Q[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,ae=ae.slice(-1*ie.length+ke);(Q=rt.exec(ae))!=null;)if(Ie=Q[1]||Q[2]||Q[3]||Q[4]||Q[5]||Q[6],!!Ie){if(Ae=Ie.length,Q[3]||Q[4]){Be+=Ae;continue}else if((Q[5]||Q[6])&&ke%3&&!((ke+Ae)%3)){Ye+=Ae;continue}if(Be-=Ae,!(Be>0)){if(Be+Ye-Ae<=0&&!ae.slice(rt.lastIndex).match(rt)&&(Ae=Math.min(Ae,Ae+Be+Ye)),Math.min(ke,Ae)%2)return{type:"em",raw:ie.slice(0,ke+Q.index+Ae+1),text:ie.slice(1,ke+Q.index+Ae)};if(Math.min(ke,Ae)%2==0)return{type:"strong",raw:ie.slice(0,ke+Q.index+Ae+1),text:ie.slice(2,ke+Q.index+Ae-1)}}}}}},Ee.codespan=function(ie){var ae=this.rules.inline.code.exec(ie);if(ae){var N=ae[2].replace(/\n/g," "),Q=/[^ ]/.test(N),oe=/^ /.test(N)&&/ $/.test(N);return Q&&oe&&(N=N.substring(1,N.length-1)),N=x(N,!0),{type:"codespan",raw:ae[0],text:N}}},Ee.br=function(ie){var ae=this.rules.inline.br.exec(ie);if(ae)return{type:"br",raw:ae[0]}},Ee.del=function(ie){var ae=this.rules.inline.del.exec(ie);if(ae)return{type:"del",raw:ae[0],text:ae[2]}},Ee.autolink=function(ie,ae){var N=this.rules.inline.autolink.exec(ie);if(N){var Q,oe;return N[2]==="@"?(Q=x(this.options.mangle?ae(N[1]):N[1]),oe="mailto:"+Q):(Q=x(N[1]),oe=Q),{type:"link",raw:N[0],text:Q,href:oe,tokens:[{type:"text",raw:Q,text:Q}]}}},Ee.url=function(ie,ae){var N;if(N=this.rules.inline.url.exec(ie)){var Q,oe;if(N[2]==="@")Q=x(this.options.mangle?ae(N[0]):N[0]),oe="mailto:"+Q;else{var ke;do ke=N[0],N[0]=this.rules.inline._backpedal.exec(N[0])[0];while(ke!==N[0]);Q=x(N[0]),N[1]==="www."?oe="http://"+Q:oe=Q}return{type:"link",raw:N[0],text:Q,href:oe,tokens:[{type:"text",raw:Q,text:Q}]}}},Ee.inlineText=function(ie,ae,N){var Q=this.rules.inline.text.exec(ie);if(Q){var oe;return ae?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):x(Q[0]):Q[0]:oe=x(this.options.smartypants?N(Q[0]):Q[0]),{type:"text",raw:Q[0],text:oe}}},ye}(),M=U.noopTest,$=U.edit,G=U.merge,J={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:M,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};J._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,J._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,J.def=$(J.def).replace("label",J._label).replace("title",J._title).getRegex(),J.bullet=/(?:[*+-]|\d{1,9}[.)])/,J.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,J.item=$(J.item,"gm").replace(/bull/g,J.bullet).getRegex(),J.listItemStart=$(/^( *)(bull)/).replace("bull",J.bullet).getRegex(),J.list=$(J.list).replace(/bull/g,J.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+J.def.source+")").getRegex(),J._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",J._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,J.html=$(J.html,"i").replace("comment",J._comment).replace("tag",J._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),J.paragraph=$(J._paragraph).replace("hr",J.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",J._tag).getRegex(),J.blockquote=$(J.blockquote).replace("paragraph",J.paragraph).getRegex(),J.normal=G({},J),J.gfm=G({},J.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),J.gfm.nptable=$(J.gfm.nptable).replace("hr",J.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",J._tag).getRegex(),J.gfm.table=$(J.gfm.table).replace("hr",J.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",J._tag).getRegex(),J.pedantic=G({},J.normal,{html:$(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",J._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:$(J.normal._paragraph).replace("hr",J.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",J.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=$(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=$(J._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=$(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=$(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=$(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=$(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=$(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=$(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=$(te.reflink).replace("label",te._label).getRegex(),te.reflinkSearch=$(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=G({},te),te.pedantic=G({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:$(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:$(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=G({},te.normal,{escape:$(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),te.gfm.url=$(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=G({},te.gfm,{br:$(te.br).replace("{2,}","*").getRegex(),text:$(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var me={block:J,inline:te},Le=y.defaults,We=me.block,Fe=me.inline,ze=U.repeatString;function W(ye){return ye.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(ye){var Ee="",Ce,ie,ae=ye.length;for(Ce=0;Ce<ae;Ce++)ie=ye.charCodeAt(Ce),Math.random()>.5&&(ie="x"+ie.toString(16)),Ee+="&#"+ie+";";return Ee}var ee=function(){function ye(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Le,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ie={block:We.normal,inline:Fe.normal};this.options.pedantic?(ie.block=We.pedantic,ie.inline=Fe.pedantic):this.options.gfm&&(ie.block=We.gfm,this.options.breaks?ie.inline=Fe.breaks:ie.inline=Fe.gfm),this.tokenizer.rules=ie}ye.lex=function(ie,ae){var N=new ye(ae);return N.lex(ie)},ye.lexInline=function(ie,ae){var N=new ye(ae);return N.inlineTokens(ie)};var Ee=ye.prototype;return Ee.lex=function(ie){return ie=ie.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ie,this.tokens,!0),this.inline(this.tokens),this.tokens},Ee.blockTokens=function(ie,ae,N){ae===void 0&&(ae=[]),N===void 0&&(N=!0),this.options.pedantic&&(ie=ie.replace(/^ +$/gm,""));for(var Q,oe,ke,Ie;ie;){if(Q=this.tokenizer.space(ie)){ie=ie.substring(Q.raw.length),Q.type&&ae.push(Q);continue}if(Q=this.tokenizer.code(ie)){ie=ie.substring(Q.raw.length),Ie=ae[ae.length-1],Ie&&Ie.type==="paragraph"?(Ie.raw+=`
`+Q.raw,Ie.text+=`
`+Q.text):ae.push(Q);continue}if(Q=this.tokenizer.fences(ie)){ie=ie.substring(Q.raw.length),ae.push(Q);continue}if(Q=this.tokenizer.heading(ie)){ie=ie.substring(Q.raw.length),ae.push(Q);continue}if(Q=this.tokenizer.nptable(ie)){ie=ie.substring(Q.raw.length),ae.push(Q);continue}if(Q=this.tokenizer.hr(ie)){ie=ie.substring(Q.raw.length),ae.push(Q);continue}if(Q=this.tokenizer.blockquote(ie)){ie=ie.substring(Q.raw.length),Q.tokens=this.blockTokens(Q.text,[],N),ae.push(Q);continue}if(Q=this.tokenizer.list(ie)){for(ie=ie.substring(Q.raw.length),ke=Q.items.length,oe=0;oe<ke;oe++)Q.items[oe].tokens=this.blockTokens(Q.items[oe].text,[],!1);ae.push(Q);continue}if(Q=this.tokenizer.html(ie)){ie=ie.substring(Q.raw.length),ae.push(Q);continue}if(N&&(Q=this.tokenizer.def(ie))){ie=ie.substring(Q.raw.length),this.tokens.links[Q.tag]||(this.tokens.links[Q.tag]={href:Q.href,title:Q.title});continue}if(Q=this.tokenizer.table(ie)){ie=ie.substring(Q.raw.length),ae.push(Q);continue}if(Q=this.tokenizer.lheading(ie)){ie=ie.substring(Q.raw.length),ae.push(Q);continue}if(N&&(Q=this.tokenizer.paragraph(ie))){ie=ie.substring(Q.raw.length),ae.push(Q);continue}if(Q=this.tokenizer.text(ie)){ie=ie.substring(Q.raw.length),Ie=ae[ae.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+Q.raw,Ie.text+=`
`+Q.text):ae.push(Q);continue}if(ie){var Ae="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return ae},Ee.inline=function(ie){var ae,N,Q,oe,ke,Ie,Ae=ie.length;for(ae=0;ae<Ae;ae++)switch(Ie=ie[ae],Ie.type){case"paragraph":case"text":case"heading":{Ie.tokens=[],this.inlineTokens(Ie.text,Ie.tokens);break}case"table":{for(Ie.tokens={header:[],cells:[]},oe=Ie.header.length,N=0;N<oe;N++)Ie.tokens.header[N]=[],this.inlineTokens(Ie.header[N],Ie.tokens.header[N]);for(oe=Ie.cells.length,N=0;N<oe;N++)for(ke=Ie.cells[N],Ie.tokens.cells[N]=[],Q=0;Q<ke.length;Q++)Ie.tokens.cells[N][Q]=[],this.inlineTokens(ke[Q],Ie.tokens.cells[N][Q]);break}case"blockquote":{this.inline(Ie.tokens);break}case"list":{for(oe=Ie.items.length,N=0;N<oe;N++)this.inline(Ie.items[N].tokens);break}}return ie},Ee.inlineTokens=function(ie,ae,N,Q){ae===void 0&&(ae=[]),N===void 0&&(N=!1),Q===void 0&&(Q=!1);var oe,ke,Ie=ie,Ae,Be,Ye;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)rt.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Ae.index)+"["+ze("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"["+ze("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ie;){if(Be||(Ye=""),Be=!1,oe=this.tokenizer.escape(ie)){ie=ie.substring(oe.raw.length),ae.push(oe);continue}if(oe=this.tokenizer.tag(ie,N,Q)){ie=ie.substring(oe.raw.length),N=oe.inLink,Q=oe.inRawBlock;var tt=ae[ae.length-1];tt&&oe.type==="text"&&tt.type==="text"?(tt.raw+=oe.raw,tt.text+=oe.text):ae.push(oe);continue}if(oe=this.tokenizer.link(ie)){ie=ie.substring(oe.raw.length),oe.type==="link"&&(oe.tokens=this.inlineTokens(oe.text,[],!0,Q)),ae.push(oe);continue}if(oe=this.tokenizer.reflink(ie,this.tokens.links)){ie=ie.substring(oe.raw.length);var Qe=ae[ae.length-1];oe.type==="link"?(oe.tokens=this.inlineTokens(oe.text,[],!0,Q),ae.push(oe)):Qe&&oe.type==="text"&&Qe.type==="text"?(Qe.raw+=oe.raw,Qe.text+=oe.text):ae.push(oe);continue}if(oe=this.tokenizer.emStrong(ie,Ie,Ye)){ie=ie.substring(oe.raw.length),oe.tokens=this.inlineTokens(oe.text,[],N,Q),ae.push(oe);continue}if(oe=this.tokenizer.codespan(ie)){ie=ie.substring(oe.raw.length),ae.push(oe);continue}if(oe=this.tokenizer.br(ie)){ie=ie.substring(oe.raw.length),ae.push(oe);continue}if(oe=this.tokenizer.del(ie)){ie=ie.substring(oe.raw.length),oe.tokens=this.inlineTokens(oe.text,[],N,Q),ae.push(oe);continue}if(oe=this.tokenizer.autolink(ie,q)){ie=ie.substring(oe.raw.length),ae.push(oe);continue}if(!N&&(oe=this.tokenizer.url(ie,q))){ie=ie.substring(oe.raw.length),ae.push(oe);continue}if(oe=this.tokenizer.inlineText(ie,Q,W)){ie=ie.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(Ye=oe.raw.slice(-1)),Be=!0,ke=ae[ae.length-1],ke&&ke.type==="text"?(ke.raw+=oe.raw,ke.text+=oe.text):ae.push(oe);continue}if(ie){var gt="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(gt);break}else throw new Error(gt)}}return ae},e(ye,null,[{key:"rules",get:function(){return{block:We,inline:Fe}}}]),ye}(),se=y.defaults,ce=U.cleanUrl,_e=U.escape,$e=function(){function ye(Ce){this.options=Ce||se}var Ee=ye.prototype;return Ee.code=function(ie,ae,N){var Q=(ae||"").match(/\S*/)[0];if(this.options.highlight){var oe=this.options.highlight(ie,Q);oe!=null&&oe!==ie&&(N=!0,ie=oe)}return ie=ie.replace(/\n$/,"")+`
`,Q?'<pre><code class="'+this.options.langPrefix+_e(Q,!0)+'">'+(N?ie:_e(ie,!0))+`</code></pre>
`:"<pre><code>"+(N?ie:_e(ie,!0))+`</code></pre>
`},Ee.blockquote=function(ie){return`<blockquote>
`+ie+`</blockquote>
`},Ee.html=function(ie){return ie},Ee.heading=function(ie,ae,N,Q){return this.options.headerIds?"<h"+ae+' id="'+this.options.headerPrefix+Q.slug(N)+'">'+ie+"</h"+ae+`>
`:"<h"+ae+">"+ie+"</h"+ae+`>
`},Ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ee.list=function(ie,ae,N){var Q=ae?"ol":"ul",oe=ae&&N!==1?' start="'+N+'"':"";return"<"+Q+oe+`>
`+ie+"</"+Q+`>
`},Ee.listitem=function(ie){return"<li>"+ie+`</li>
`},Ee.checkbox=function(ie){return"<input "+(ie?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ee.paragraph=function(ie){return"<p>"+ie+`</p>
`},Ee.table=function(ie,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+ie+`</thead>
`+ae+`</table>
`},Ee.tablerow=function(ie){return`<tr>
`+ie+`</tr>
`},Ee.tablecell=function(ie,ae){var N=ae.header?"th":"td",Q=ae.align?"<"+N+' align="'+ae.align+'">':"<"+N+">";return Q+ie+"</"+N+`>
`},Ee.strong=function(ie){return"<strong>"+ie+"</strong>"},Ee.em=function(ie){return"<em>"+ie+"</em>"},Ee.codespan=function(ie){return"<code>"+ie+"</code>"},Ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ee.del=function(ie){return"<del>"+ie+"</del>"},Ee.link=function(ie,ae,N){if(ie=ce(this.options.sanitize,this.options.baseUrl,ie),ie===null)return N;var Q='<a href="'+_e(ie)+'"';return ae&&(Q+=' title="'+ae+'"'),Q+=">"+N+"</a>",Q},Ee.image=function(ie,ae,N){if(ie=ce(this.options.sanitize,this.options.baseUrl,ie),ie===null)return N;var Q='<img src="'+ie+'" alt="'+N+'"';return ae&&(Q+=' title="'+ae+'"'),Q+=this.options.xhtml?"/>":">",Q},Ee.text=function(ie){return ie},ye}(),fe=function(){function ye(){}var Ee=ye.prototype;return Ee.strong=function(ie){return ie},Ee.em=function(ie){return ie},Ee.codespan=function(ie){return ie},Ee.del=function(ie){return ie},Ee.html=function(ie){return ie},Ee.text=function(ie){return ie},Ee.link=function(ie,ae,N){return""+N},Ee.image=function(ie,ae,N){return""+N},Ee.br=function(){return""},ye}(),De=function(){function ye(){this.seen={}}var Ee=ye.prototype;return Ee.serialize=function(ie){return ie.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ee.getNextSafeSlug=function(ie,ae){var N=ie,Q=0;if(this.seen.hasOwnProperty(N)){Q=this.seen[ie];do Q++,N=ie+"-"+Q;while(this.seen.hasOwnProperty(N))}return ae||(this.seen[ie]=Q,this.seen[N]=0),N},Ee.slug=function(ie,ae){ae===void 0&&(ae={});var N=this.serialize(ie);return this.getNextSafeSlug(N,ae.dryrun)},ye}(),Re=y.defaults,He=U.unescape,be=function(){function ye(Ce){this.options=Ce||Re,this.options.renderer=this.options.renderer||new $e,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new fe,this.slugger=new De}ye.parse=function(ie,ae){var N=new ye(ae);return N.parse(ie)},ye.parseInline=function(ie,ae){var N=new ye(ae);return N.parseInline(ie)};var Ee=ye.prototype;return Ee.parse=function(ie,ae){ae===void 0&&(ae=!0);var N="",Q,oe,ke,Ie,Ae,Be,Ye,rt,tt,Qe,gt,bt,pe,ue,re,K,Me,Te,Je=ie.length;for(Q=0;Q<Je;Q++)switch(Qe=ie[Q],Qe.type){case"space":continue;case"hr":{N+=this.renderer.hr();continue}case"heading":{N+=this.renderer.heading(this.parseInline(Qe.tokens),Qe.depth,He(this.parseInline(Qe.tokens,this.textRenderer)),this.slugger);continue}case"code":{N+=this.renderer.code(Qe.text,Qe.lang,Qe.escaped);continue}case"table":{for(rt="",Ye="",Ie=Qe.header.length,oe=0;oe<Ie;oe++)Ye+=this.renderer.tablecell(this.parseInline(Qe.tokens.header[oe]),{header:!0,align:Qe.align[oe]});for(rt+=this.renderer.tablerow(Ye),tt="",Ie=Qe.cells.length,oe=0;oe<Ie;oe++){for(Be=Qe.tokens.cells[oe],Ye="",Ae=Be.length,ke=0;ke<Ae;ke++)Ye+=this.renderer.tablecell(this.parseInline(Be[ke]),{header:!1,align:Qe.align[ke]});tt+=this.renderer.tablerow(Ye)}N+=this.renderer.table(rt,tt);continue}case"blockquote":{tt=this.parse(Qe.tokens),N+=this.renderer.blockquote(tt);continue}case"list":{for(gt=Qe.ordered,bt=Qe.start,pe=Qe.loose,Ie=Qe.items.length,tt="",oe=0;oe<Ie;oe++)re=Qe.items[oe],K=re.checked,Me=re.task,ue="",re.task&&(Te=this.renderer.checkbox(K),pe?re.tokens.length>0&&re.tokens[0].type==="text"?(re.tokens[0].text=Te+" "+re.tokens[0].text,re.tokens[0].tokens&&re.tokens[0].tokens.length>0&&re.tokens[0].tokens[0].type==="text"&&(re.tokens[0].tokens[0].text=Te+" "+re.tokens[0].tokens[0].text)):re.tokens.unshift({type:"text",text:Te}):ue+=Te),ue+=this.parse(re.tokens,pe),tt+=this.renderer.listitem(ue,Me,K);N+=this.renderer.list(tt,gt,bt);continue}case"html":{N+=this.renderer.html(Qe.text);continue}case"paragraph":{N+=this.renderer.paragraph(this.parseInline(Qe.tokens));continue}case"text":{for(tt=Qe.tokens?this.parseInline(Qe.tokens):Qe.text;Q+1<Je&&ie[Q+1].type==="text";)Qe=ie[++Q],tt+=`
`+(Qe.tokens?this.parseInline(Qe.tokens):Qe.text);N+=ae?this.renderer.paragraph(tt):tt;continue}default:{var et='Token with "'+Qe.type+'" type was not found.';if(this.options.silent){console.error(et);return}else throw new Error(et)}}return N},Ee.parseInline=function(ie,ae){ae=ae||this.renderer;var N="",Q,oe,ke=ie.length;for(Q=0;Q<ke;Q++)switch(oe=ie[Q],oe.type){case"escape":{N+=ae.text(oe.text);break}case"html":{N+=ae.html(oe.text);break}case"link":{N+=ae.link(oe.href,oe.title,this.parseInline(oe.tokens,ae));break}case"image":{N+=ae.image(oe.href,oe.title,oe.text);break}case"strong":{N+=ae.strong(this.parseInline(oe.tokens,ae));break}case"em":{N+=ae.em(this.parseInline(oe.tokens,ae));break}case"codespan":{N+=ae.codespan(oe.text);break}case"br":{N+=ae.br();break}case"del":{N+=ae.del(this.parseInline(oe.tokens,ae));break}case"text":{N+=ae.text(oe.text);break}default:{var Ie='Token with "'+oe.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}return N},ye}(),Ke=U.merge,V=U.checkSanitizeDeprecation,Z=U.escape,ge=y.getDefaults,Ne=y.changeDefaults,Ve=y.defaults;function xe(ye,Ee,Ce){if(typeof ye=="undefined"||ye===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");if(typeof Ee=="function"&&(Ce=Ee,Ee=null),Ee=Ke({},xe.defaults,Ee||{}),V(Ee),Ce){var ie=Ee.highlight,ae;try{ae=ee.lex(ye,Ee)}catch(ke){return Ce(ke)}var N=function(Ie){var Ae;if(!Ie)try{Ae=be.parse(ae,Ee)}catch(Be){Ie=Be}return Ee.highlight=ie,Ie?Ce(Ie):Ce(null,Ae)};if(!ie||ie.length<3||(delete Ee.highlight,!ae.length))return N();var Q=0;xe.walkTokens(ae,function(ke){ke.type==="code"&&(Q++,setTimeout(function(){ie(ke.text,ke.lang,function(Ie,Ae){if(Ie)return N(Ie);Ae!=null&&Ae!==ke.text&&(ke.text=Ae,ke.escaped=!0),Q--,Q===0&&N()})},0))}),Q===0&&N();return}try{var oe=ee.lex(ye,Ee);return Ee.walkTokens&&xe.walkTokens(oe,Ee.walkTokens),be.parse(oe,Ee)}catch(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+Z(ke.message+"",!0)+"</pre>";throw ke}}xe.options=xe.setOptions=function(ye){return Ke(xe.defaults,ye),Ne(xe.defaults),xe},xe.getDefaults=ge,xe.defaults=Ve,xe.use=function(ye){var Ee=Ke({},ye);if(ye.renderer&&function(){var ie=xe.defaults.renderer||new $e,ae=function(oe){var ke=ie[oe];ie[oe]=function(){for(var Ie=arguments.length,Ae=new Array(Ie),Be=0;Be<Ie;Be++)Ae[Be]=arguments[Be];var Ye=ye.renderer[oe].apply(ie,Ae);return Ye===!1&&(Ye=ke.apply(ie,Ae)),Ye}};for(var N in ye.renderer)ae(N);Ee.renderer=ie}(),ye.tokenizer&&function(){var ie=xe.defaults.tokenizer||new L,ae=function(oe){var ke=ie[oe];ie[oe]=function(){for(var Ie=arguments.length,Ae=new Array(Ie),Be=0;Be<Ie;Be++)Ae[Be]=arguments[Be];var Ye=ye.tokenizer[oe].apply(ie,Ae);return Ye===!1&&(Ye=ke.apply(ie,Ae)),Ye}};for(var N in ye.tokenizer)ae(N);Ee.tokenizer=ie}(),ye.walkTokens){var Ce=xe.defaults.walkTokens;Ee.walkTokens=function(ie){ye.walkTokens(ie),Ce&&Ce(ie)}}xe.setOptions(Ee)},xe.walkTokens=function(ye,Ee){for(var Ce=D(ye),ie;!(ie=Ce()).done;){var ae=ie.value;switch(Ee(ae),ae.type){case"table":{for(var N=D(ae.tokens.header),Q;!(Q=N()).done;){var oe=Q.value;xe.walkTokens(oe,Ee)}for(var ke=D(ae.tokens.cells),Ie;!(Ie=ke()).done;)for(var Ae=Ie.value,Be=D(Ae),Ye;!(Ye=Be()).done;){var rt=Ye.value;xe.walkTokens(rt,Ee)}break}case"list":{xe.walkTokens(ae.items,Ee);break}default:ae.tokens&&xe.walkTokens(ae.tokens,Ee)}}},xe.parseInline=function(ye,Ee){if(typeof ye=="undefined"||ye===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");Ee=Ke({},xe.defaults,Ee||{}),V(Ee);try{var Ce=ee.lexInline(ye,Ee);return Ee.walkTokens&&xe.walkTokens(Ce,Ee.walkTokens),be.parseInline(Ce,Ee)}catch(ie){if(ie.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+Z(ie.message+"",!0)+"</pre>";throw ie}},xe.Parser=be,xe.parser=be.parse,xe.Renderer=$e,xe.TextRenderer=fe,xe.Lexer=ee,xe.lexer=ee.lex,xe.Tokenizer=L,xe.Slugger=De,xe.parse=xe;var Xe=xe;return Xe}),define(ve[82],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function v(y,C,S){return Math.min(Math.max(y,C),S)}e.clamp=v;function T(y,C){return(C+y%C)%C}e.rot=T;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class A{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A});"use strict";(function(){function Y(D){const A=[];typeof D=="number"&&A.push("code/timeOrigin",D);function y(S){A.push(S,Date.now())}function C(){const S=[];for(let k=0;k<A.length;k+=2)S.push({name:A[k],startTime:A[k+1]});return S}return{mark:y,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const y of performance.getEntriesByType("mark"))A.push({name:y.name,startTime:Math.round(D+y.startTime)});return A}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function v(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=v(T))})(),define(ve[21],we([0,1]),function(Y,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const T="en";let D=!1,A=!1,y=!1,C=!1,S=!1,k=!1,i=!1,P,h=T,g,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let o;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?o=e.globals.vscode.process:typeof process!="undefined"&&(o=process);const p=typeof((v=o==null?void 0:o.versions)===null||v===void 0?void 0:v.electron)=="string"&&o.type==="renderer";if(e.isElectronSandboxed=p&&(o==null?void 0:o.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const s=o==null?void 0:o.env.VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!p)r=navigator.userAgent,D=r.indexOf("Windows")>=0,A=r.indexOf("Macintosh")>=0,i=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=r.indexOf("Linux")>=0,k=!0,P=navigator.language,h=P;else if(typeof o=="object"){D=o.platform==="win32",A=o.platform==="darwin",y=o.platform==="linux",C=y&&!!o.env.SNAP&&!!o.env.SNAP_REVISION,P=T,h=T;const s=o.env.VSCODE_NLS_CONFIG;if(s)try{const u=JSON.parse(s),w=u.availableLanguages["*"];P=u.locale,h=w||T,g=u._translationsConfigFile}catch(u){}S=!0}else console.error("Unable to resolve platform.");var m;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(m=e.Platform||(e.Platform={}));function E(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let l=0;A?l=1:D?l=3:y&&(l=2),e.isWindows=D,e.isMacintosh=A,e.isLinux=y,e.isLinuxSnap=C,e.isNative=S,e.isWeb=k,e.isIOS=i,e.platform=l,e.userAgent=r,e.language=h;var c;(function(s){function u(){return e.language}s.value=u;function w(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=w;function b(){return e.language==="en"}s.isDefault=b})(c=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let w=[];e.globals.addEventListener("message",I=>{if(I.data&&I.data.vscodeSetImmediateId)for(let f=0,_=w.length;f<_;f++){const F=w[f];if(F.id===I.data.vscodeSetImmediateId){w.splice(f,1),F.callback();return}}});let b=0;return I=>{const f=++b;w.push({id:f,callback:I}),e.globals.postMessage({vscodeSetImmediateId:f},"*")}}if(typeof(o==null?void 0:o.nextTick)=="function")return o.nextTick.bind(o);const u=Promise.resolve();return w=>u.then(w)}();var d;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(d=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||i?2:D?1:3;let t=!0,n=!1;function a(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,t=new Uint16Array(s.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=a}),define(ve[46],we([0,1,21]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let T;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const D=v.globals.vscode.process;T={get platform(){return D.platform},get env(){return D.env},cwd(){return D.cwd()},nextTick(A){return(0,v.setImmediate)(A)}}}else typeof process!="undefined"?T={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:T={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(D){return(0,v.setImmediate)(D)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.platform=T.platform,e.nextTick=T.nextTick}),define(ve[14],we([0,1,46]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const T=65,D=97,A=90,y=122,C=46,S=47,k=92,i=58,P=63;class h extends Error{constructor(c,d,t){let n;typeof d=="string"&&d.indexOf("not ")===0?(n="must not be",d=d.replace(/^not /,"")):n="must be";const a=c.indexOf(".")!==-1?"property":"argument";let s=`The "${c}" ${a} ${n} of type ${d}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function g(l,c){if(typeof l!="string")throw new h(c,"string",l)}function r(l){return l===S||l===k}function o(l){return l===S}function p(l){return l>=T&&l<=A||l>=D&&l<=y}function m(l,c,d,t){let n="",a=0,s=-1,u=0,w=0;for(let b=0;b<=l.length;++b){if(b<l.length)w=l.charCodeAt(b);else{if(t(w))break;w=S}if(t(w)){if(!(s===b-1||u===1))if(u===2){if(n.length<2||a!==2||n.charCodeAt(n.length-1)!==C||n.charCodeAt(n.length-2)!==C){if(n.length>2){const I=n.lastIndexOf(d);I===-1?(n="",a=0):(n=n.slice(0,I),a=n.length-1-n.lastIndexOf(d)),s=b,u=0;continue}else if(n.length!==0){n="",a=0,s=b,u=0;continue}}c&&(n+=n.length>0?`${d}..`:"..",a=2)}else n.length>0?n+=`${d}${l.slice(s+1,b)}`:n=l.slice(s+1,b),a=b-s-1;s=b,u=0}else w===C&&u!==-1?++u:u=-1}return n}function E(l,c){if(c===null||typeof c!="object")throw new h("pathObject","Object",c);const d=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return d?d===c.root?`${d}${t}`:`${d}${l}${t}`:t}e.win32={resolve(...l){let c="",d="",t=!1;for(let n=l.length-1;n>=-1;n--){let a;if(n>=0){if(a=l[n],g(a,"path"),a.length===0)continue}else c.length===0?a=v.cwd():(a=v.env[`=${c}`]||v.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==c.toLowerCase()&&a.charCodeAt(2)===k)&&(a=`${c}\\`));const s=a.length;let u=0,w="",b=!1;const I=a.charCodeAt(0);if(s===1)r(I)&&(u=1,b=!0);else if(r(I))if(b=!0,r(a.charCodeAt(1))){let f=2,_=f;for(;f<s&&!r(a.charCodeAt(f));)f++;if(f<s&&f!==_){const F=a.slice(_,f);for(_=f;f<s&&r(a.charCodeAt(f));)f++;if(f<s&&f!==_){for(_=f;f<s&&!r(a.charCodeAt(f));)f++;(f===s||f!==_)&&(w=`\\\\${F}\\${a.slice(_,f)}`,u=f)}}}else u=1;else p(I)&&a.charCodeAt(1)===i&&(w=a.slice(0,2),u=2,s>2&&r(a.charCodeAt(2))&&(b=!0,u=3));if(w.length>0)if(c.length>0){if(w.toLowerCase()!==c.toLowerCase())continue}else c=w;if(t){if(c.length>0)break}else if(d=`${a.slice(u)}\\${d}`,t=b,b&&c.length>0)break}return d=m(d,!t,"\\",r),t?`${c}\\${d}`:`${c}${d}`||"."},normalize(l){g(l,"path");const c=l.length;if(c===0)return".";let d=0,t,n=!1;const a=l.charCodeAt(0);if(c===1)return o(a)?"\\":l;if(r(a))if(n=!0,r(l.charCodeAt(1))){let u=2,w=u;for(;u<c&&!r(l.charCodeAt(u));)u++;if(u<c&&u!==w){const b=l.slice(w,u);for(w=u;u<c&&r(l.charCodeAt(u));)u++;if(u<c&&u!==w){for(w=u;u<c&&!r(l.charCodeAt(u));)u++;if(u===c)return`\\\\${b}\\${l.slice(w)}\\`;u!==w&&(t=`\\\\${b}\\${l.slice(w,u)}`,d=u)}}}else d=1;else p(a)&&l.charCodeAt(1)===i&&(t=l.slice(0,2),d=2,c>2&&r(l.charCodeAt(2))&&(n=!0,d=3));let s=d<c?m(l.slice(d),!n,"\\",r):"";return s.length===0&&!n&&(s="."),s.length>0&&r(l.charCodeAt(c-1))&&(s+="\\"),t===void 0?n?`\\${s}`:s:n?`${t}\\${s}`:`${t}${s}`},isAbsolute(l){g(l,"path");const c=l.length;if(c===0)return!1;const d=l.charCodeAt(0);return r(d)||c>2&&p(d)&&l.charCodeAt(1)===i&&r(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let c,d;for(let a=0;a<l.length;++a){const s=l[a];g(s,"path"),s.length>0&&(c===void 0?c=d=s:c+=`\\${s}`)}if(c===void 0)return".";let t=!0,n=0;if(typeof d=="string"&&r(d.charCodeAt(0))){++n;const a=d.length;a>1&&r(d.charCodeAt(1))&&(++n,a>2&&(r(d.charCodeAt(2))?++n:t=!1))}if(t){for(;n<c.length&&r(c.charCodeAt(n));)n++;n>=2&&(c=`\\${c.slice(n)}`)}return e.win32.normalize(c)},relative(l,c){if(g(l,"from"),g(c,"to"),l===c)return"";const d=e.win32.resolve(l),t=e.win32.resolve(c);if(d===t||(l=d.toLowerCase(),c=t.toLowerCase(),l===c))return"";let n=0;for(;n<l.length&&l.charCodeAt(n)===k;)n++;let a=l.length;for(;a-1>n&&l.charCodeAt(a-1)===k;)a--;const s=a-n;let u=0;for(;u<c.length&&c.charCodeAt(u)===k;)u++;let w=c.length;for(;w-1>u&&c.charCodeAt(w-1)===k;)w--;const b=w-u,I=s<b?s:b;let f=-1,_=0;for(;_<I;_++){const U=l.charCodeAt(n+_);if(U!==c.charCodeAt(u+_))break;U===k&&(f=_)}if(_!==I){if(f===-1)return t}else{if(b>I){if(c.charCodeAt(u+_)===k)return t.slice(u+_+1);if(_===2)return t.slice(u+_)}s>I&&(l.charCodeAt(n+_)===k?f=_:_===2&&(f=3)),f===-1&&(f=0)}let F="";for(_=n+f+1;_<=a;++_)(_===a||l.charCodeAt(_)===k)&&(F+=F.length===0?"..":"\\..");return u+=f,F.length>0?`${F}${t.slice(u,w)}`:(t.charCodeAt(u)===k&&++u,t.slice(u,w))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const c=e.win32.resolve(l);if(c.length<=2)return l;if(c.charCodeAt(0)===k){if(c.charCodeAt(1)===k){const d=c.charCodeAt(2);if(d!==P&&d!==C)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(p(c.charCodeAt(0))&&c.charCodeAt(1)===i&&c.charCodeAt(2)===k)return`\\\\?\\${c}`;return l},dirname(l){g(l,"path");const c=l.length;if(c===0)return".";let d=-1,t=0;const n=l.charCodeAt(0);if(c===1)return r(n)?l:".";if(r(n)){if(d=t=1,r(l.charCodeAt(1))){let u=2,w=u;for(;u<c&&!r(l.charCodeAt(u));)u++;if(u<c&&u!==w){for(w=u;u<c&&r(l.charCodeAt(u));)u++;if(u<c&&u!==w){for(w=u;u<c&&!r(l.charCodeAt(u));)u++;if(u===c)return l;u!==w&&(d=t=u+1)}}}}else p(n)&&l.charCodeAt(1)===i&&(d=c>2&&r(l.charCodeAt(2))?3:2,t=d);let a=-1,s=!0;for(let u=c-1;u>=t;--u)if(r(l.charCodeAt(u))){if(!s){a=u;break}}else s=!1;if(a===-1){if(d===-1)return".";a=d}return l.slice(0,a)},basename(l,c){c!==void 0&&g(c,"ext"),g(l,"path");let d=0,t=-1,n=!0,a;if(l.length>=2&&p(l.charCodeAt(0))&&l.charCodeAt(1)===i&&(d=2),c!==void 0&&c.length>0&&c.length<=l.length){if(c===l)return"";let s=c.length-1,u=-1;for(a=l.length-1;a>=d;--a){const w=l.charCodeAt(a);if(r(w)){if(!n){d=a+1;break}}else u===-1&&(n=!1,u=a+1),s>=0&&(w===c.charCodeAt(s)?--s==-1&&(t=a):(s=-1,t=u))}return d===t?t=u:t===-1&&(t=l.length),l.slice(d,t)}for(a=l.length-1;a>=d;--a)if(r(l.charCodeAt(a))){if(!n){d=a+1;break}}else t===-1&&(n=!1,t=a+1);return t===-1?"":l.slice(d,t)},extname(l){g(l,"path");let c=0,d=-1,t=0,n=-1,a=!0,s=0;l.length>=2&&l.charCodeAt(1)===i&&p(l.charCodeAt(0))&&(c=t=2);for(let u=l.length-1;u>=c;--u){const w=l.charCodeAt(u);if(r(w)){if(!a){t=u+1;break}continue}n===-1&&(a=!1,n=u+1),w===C?d===-1?d=u:s!==1&&(s=1):d!==-1&&(s=-1)}return d===-1||n===-1||s===0||s===1&&d===n-1&&d===t+1?"":l.slice(d,n)},format:E.bind(null,"\\"),parse(l){g(l,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return c;const d=l.length;let t=0,n=l.charCodeAt(0);if(d===1)return r(n)?(c.root=c.dir=l,c):(c.base=c.name=l,c);if(r(n)){if(t=1,r(l.charCodeAt(1))){let f=2,_=f;for(;f<d&&!r(l.charCodeAt(f));)f++;if(f<d&&f!==_){for(_=f;f<d&&r(l.charCodeAt(f));)f++;if(f<d&&f!==_){for(_=f;f<d&&!r(l.charCodeAt(f));)f++;f===d?t=f:f!==_&&(t=f+1)}}}}else if(p(n)&&l.charCodeAt(1)===i){if(d<=2)return c.root=c.dir=l,c;if(t=2,r(l.charCodeAt(2))){if(d===3)return c.root=c.dir=l,c;t=3}}t>0&&(c.root=l.slice(0,t));let a=-1,s=t,u=-1,w=!0,b=l.length-1,I=0;for(;b>=t;--b){if(n=l.charCodeAt(b),r(n)){if(!w){s=b+1;break}continue}u===-1&&(w=!1,u=b+1),n===C?a===-1?a=b:I!==1&&(I=1):a!==-1&&(I=-1)}return u!==-1&&(a===-1||I===0||I===1&&a===u-1&&a===s+1?c.base=c.name=l.slice(s,u):(c.name=l.slice(s,a),c.base=l.slice(s,u),c.ext=l.slice(a,u))),s>0&&s!==t?c.dir=l.slice(0,s-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let c="",d=!1;for(let t=l.length-1;t>=-1&&!d;t--){const n=t>=0?l[t]:v.cwd();g(n,"path"),n.length!==0&&(c=`${n}/${c}`,d=n.charCodeAt(0)===S)}return c=m(c,!d,"/",o),d?`/${c}`:c.length>0?c:"."},normalize(l){if(g(l,"path"),l.length===0)return".";const c=l.charCodeAt(0)===S,d=l.charCodeAt(l.length-1)===S;return l=m(l,!c,"/",o),l.length===0?c?"/":d?"./":".":(d&&(l+="/"),c?`/${l}`:l)},isAbsolute(l){return g(l,"path"),l.length>0&&l.charCodeAt(0)===S},join(...l){if(l.length===0)return".";let c;for(let d=0;d<l.length;++d){const t=l[d];g(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(l,c){if(g(l,"from"),g(c,"to"),l===c||(l=e.posix.resolve(l),c=e.posix.resolve(c),l===c))return"";const d=1,t=l.length,n=t-d,a=1,s=c.length-a,u=n<s?n:s;let w=-1,b=0;for(;b<u;b++){const f=l.charCodeAt(d+b);if(f!==c.charCodeAt(a+b))break;f===S&&(w=b)}if(b===u)if(s>u){if(c.charCodeAt(a+b)===S)return c.slice(a+b+1);if(b===0)return c.slice(a+b)}else n>u&&(l.charCodeAt(d+b)===S?w=b:b===0&&(w=0));let I="";for(b=d+w+1;b<=t;++b)(b===t||l.charCodeAt(b)===S)&&(I+=I.length===0?"..":"/..");return`${I}${c.slice(a+w)}`},toNamespacedPath(l){return l},dirname(l){if(g(l,"path"),l.length===0)return".";const c=l.charCodeAt(0)===S;let d=-1,t=!0;for(let n=l.length-1;n>=1;--n)if(l.charCodeAt(n)===S){if(!t){d=n;break}}else t=!1;return d===-1?c?"/":".":c&&d===1?"//":l.slice(0,d)},basename(l,c){c!==void 0&&g(c,"ext"),g(l,"path");let d=0,t=-1,n=!0,a;if(c!==void 0&&c.length>0&&c.length<=l.length){if(c===l)return"";let s=c.length-1,u=-1;for(a=l.length-1;a>=0;--a){const w=l.charCodeAt(a);if(w===S){if(!n){d=a+1;break}}else u===-1&&(n=!1,u=a+1),s>=0&&(w===c.charCodeAt(s)?--s==-1&&(t=a):(s=-1,t=u))}return d===t?t=u:t===-1&&(t=l.length),l.slice(d,t)}for(a=l.length-1;a>=0;--a)if(l.charCodeAt(a)===S){if(!n){d=a+1;break}}else t===-1&&(n=!1,t=a+1);return t===-1?"":l.slice(d,t)},extname(l){g(l,"path");let c=-1,d=0,t=-1,n=!0,a=0;for(let s=l.length-1;s>=0;--s){const u=l.charCodeAt(s);if(u===S){if(!n){d=s+1;break}continue}t===-1&&(n=!1,t=s+1),u===C?c===-1?c=s:a!==1&&(a=1):c!==-1&&(a=-1)}return c===-1||t===-1||a===0||a===1&&c===t-1&&c===d+1?"":l.slice(c,t)},format:E.bind(null,"/"),parse(l){g(l,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return c;const d=l.charCodeAt(0)===S;let t;d?(c.root="/",t=1):t=0;let n=-1,a=0,s=-1,u=!0,w=l.length-1,b=0;for(;w>=t;--w){const I=l.charCodeAt(w);if(I===S){if(!u){a=w+1;break}continue}s===-1&&(u=!1,s=w+1),I===C?n===-1?n=w:b!==1&&(b=1):n!==-1&&(b=-1)}if(s!==-1){const I=a===0&&d?1:a;n===-1||b===0||b===1&&n===s-1&&n===a+1?c.base=c.name=l.slice(I,s):(c.name=l.slice(I,n),c.base=l.slice(I,s),c.ext=l.slice(n,s))}return a>0?c.dir=l.slice(0,a-1):d&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[55],we([0,1,21]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const T=v.globals.performance&&typeof v.globals.performance.now=="function";class D{constructor(y){this._highResolution=T&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new D(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=D}),define(ve[3],we([0,1,12,53,6,45,55]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(m){m.None=()=>D.Disposable.None;function E(x){return(j,H=null,R)=>{let L=!1,M;return M=x($=>{if(!L)return M?M.dispose():L=!0,j.call(H,$)},null,R),L&&M.dispose(),M}}m.once=E;function l(x,j){return s((H,R=null,L)=>x(M=>H.call(R,j(M)),null,L))}m.map=l;function c(x,j){return s((H,R=null,L)=>x(M=>{j(M),H.call(R,M)},null,L))}m.forEach=c;function d(x,j){return s((H,R=null,L)=>x(M=>j(M)&&H.call(R,M),null,L))}m.filter=d;function t(x){return x}m.signal=t;function n(...x){return(j,H=null,R)=>(0,D.combinedDisposable)(...x.map(L=>L(M=>j.call(H,M),null,R)))}m.any=n;function a(x,j,H){let R=H;return l(x,L=>(R=j(R,L),R))}m.reduce=a;function s(x){let j;const H=new h({onFirstListenerAdd(){j=x(H.fire,H)},onLastListenerRemove(){j.dispose()}});return H.event}m.snapshot=s;function u(x,j,H=100,R=!1,L){let M,$,G,J=0;const te=new h({leakWarningThreshold:L,onFirstListenerAdd(){M=x(me=>{J++,$=j($,me),R&&!G&&(te.fire($),$=void 0),clearTimeout(G),G=setTimeout(()=>{const Le=$;$=void 0,G=void 0,(!R||J>1)&&te.fire(Le),J=0},H)})},onLastListenerRemove(){M.dispose()}});return te.event}m.debounce=u;function w(x){const j=new Date().getTime();return l(E(x),H=>new Date().getTime()-j)}m.stopwatch=w;function b(x,j=(H,R)=>H===R){let H=!0,R;return d(x,L=>{const M=H||!j(L,R);return H=!1,R=L,M})}m.latch=b;function I(x,j){return[m.filter(x,j),m.filter(x,H=>!j(H))]}m.split=I;function f(x,j=!1,H=[]){let R=H.slice(),L=x(G=>{R?R.push(G):$.fire(G)});const M=()=>{R&&R.forEach(G=>$.fire(G)),R=null},$=new h({onFirstListenerAdd(){L||(L=x(G=>$.fire(G)))},onFirstListenerDidAdd(){R&&(j?setTimeout(M):M())},onLastListenerRemove(){L&&L.dispose(),L=null}});return $.event}m.buffer=f;class _{constructor(j){this.event=j}map(j){return new _(l(this.event,j))}forEach(j){return new _(c(this.event,j))}filter(j){return new _(d(this.event,j))}reduce(j,H){return new _(a(this.event,j,H))}latch(){return new _(b(this.event))}debounce(j,H=100,R=!1,L){return new _(u(this.event,j,H,R,L))}on(j,H,R){return this.event(j,H,R)}once(j,H,R){return E(this.event)(j,H,R)}}function F(x){return new _(x)}m.chain=F;function U(x,j,H=R=>R){const R=(...G)=>$.fire(H(...G)),L=()=>x.on(j,R),M=()=>x.removeListener(j,R),$=new h({onFirstListenerAdd:L,onLastListenerRemove:M});return $.event}m.fromNodeEventEmitter=U;function z(x,j,H=R=>R){const R=(...G)=>$.fire(H(...G)),L=()=>x.addEventListener(j,R),M=()=>x.removeEventListener(j,R),$=new h({onFirstListenerAdd:L,onLastListenerRemove:M});return $.event}m.fromDOMEventEmitter=z;function he(x){const j=new h;let H=!1;return x.then(void 0,()=>null).then(()=>{H?j.fire(void 0):setTimeout(()=>j.fire(void 0),0)}),H=!0,j.event}m.fromPromise=he;function de(x){return new Promise(j=>E(x)(j))}m.toPromise=de})(C=e.Event||(e.Event={}));class S{constructor(E){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${E}_${S._idPool++}`}start(E){this._stopWatch=new y.StopWatch(!0),this._listenerCount=E}stop(){if(this._stopWatch){const E=this._stopWatch.elapsed();this._elapsedOverall+=E,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${E.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let k=-1;function i(m){const E=k;return k=m,{dispose(){k=E}}}e.setGlobalLeakWarningThreshold=i;class P{constructor(E,l=Math.random().toString(18).slice(2,5)){this.customThreshold=E,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(E){let l=k;if(typeof this.customThreshold=="number"&&(l=this.customThreshold),!(l<=0||E<l)){this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),d=this._stacks.get(c)||0;if(this._stacks.set(c,d+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=l*.5;let t,n=0;for(const[a,s]of this._stacks)(!t||n<s)&&(t=a,n=s);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}}class h{constructor(E){var l;this._disposed=!1,this._options=E,this._leakageMon=k>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((l=this._options)===null||l===void 0?void 0:l._profName)?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(E,l,c)=>{var d;this._listeners||(this._listeners=new A.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(l?[E,l]:E);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,E,l);const a=(d=this._leakageMon)===null||d===void 0?void 0:d.check(this._listeners.size);let s;return s={dispose:()=>{a&&a(),s.dispose=h._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof D.DisposableStore?c.add(s):Array.isArray(c)&&c.push(s),s}),this._event}fire(E){var l,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let d of this._listeners)this._deliveryQueue.push([d,E]);for((l=this._perfMon)===null||l===void 0||l.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[d,t]=this._deliveryQueue.shift();try{typeof d=="function"?d.call(void 0,t):d[0].call(d[1],t)}catch(n){(0,v.onUnexpectedError)(n)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var E,l,c,d;(E=this._listeners)===null||E===void 0||E.clear(),(l=this._deliveryQueue)===null||l===void 0||l.clear(),((c=this._options)===null||c===void 0?void 0:c.onLastListenerRemove)&&this._options.onLastListenerRemove(),(d=this._leakageMon)===null||d===void 0||d.dispose(),this._disposed=!0}}e.Emitter=h,h._noop=function(){};class g extends h{constructor(E){super(E);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=E==null?void 0:E.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const E=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(E))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(E){this._listeners&&(this._isPaused!==0?this._eventQueue.push(E):super.fire(E))}}e.PauseableEmitter=g;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(E){const l={event:E,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const c=()=>{this.hasListeners&&this.unhook(l);const d=this.events.indexOf(l);this.events.splice(d,1)};return(0,D.toDisposable)((0,T.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(E=>this.hook(E))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(E=>this.unhook(E))}hook(E){E.listener=E.event(l=>this.emitter.fire(l))}unhook(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class o{constructor(){this.buffers=[]}wrapEvent(E){return(l,c,d)=>E(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>l.call(c,t)):l.call(c,t)},void 0,d)}bufferEvents(E){const l=[];this.buffers.push(l);const c=E();return this.buffers.pop(),l.forEach(d=>d()),c}}e.EventBufferer=o;class p{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=D.Disposable.None,this.emitter=new h({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(E){this.inputEvent=E,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=E(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=p}),define(ve[20],we([0,1,3]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const T=Object.freeze(function(C,S){const k=setTimeout(C.bind(S),0);return{dispose(){clearTimeout(k)}}});var D;(function(C){function S(k){return k===C.None||k===C.Cancelled||k instanceof A?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}C.isCancellationToken=S,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(D=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=D.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=y}),define(ve[36],we([0,1,3]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class T{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(P){const h=this._icons.get(P.id);h?P.description?h.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new T;e.iconRegistry=D;function A(i,P){return new C(i,P)}e.registerCodicon=A;function y(i){return i?i.replace(/\$\((.*?)\)/g,(P,h)=>` ${h} `).trim():""}e.getCodiconAriaLabel=y;class C{constructor(P,h,g){this.id=P,this.definition=h,this.description=g,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function S(i,P){const h=["codicon","codicon-"+i];return P&&h.push("codicon-modifier-"+P),h}e.getClassNamesArray=S;var k;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function h(o){if(o instanceof C)return["codicon","codicon-"+o.id];const p=P.exec(o.id);if(!p)return h(C.error);let[,m,E]=p;const l=["codicon","codicon-"+m];return E&&l.push("codicon-modifier-"+E.substr(1)),l}i.asClassNameArray=h;function g(o){return h(o).join(" ")}i.asClassName=g;function r(o){return"."+h(o).join(".")}i.asCSSSelector=r})(k=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(ve[110],we([0,1,12,6]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(l){const c=l;return c?[c.on,c.pause,c.resume,c.destroy].every(d=>typeof d=="function"):!1}e.isReadableStream=D;function A(l){const c=l;return c?D(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=A;function y(l,c){return new C(l,c)}e.newWriteableStream=y;class C{constructor(c,d){this.reducer=c,this.options=d,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){var d;if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof((d=this.options)===null||d===void 0?void 0:d.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(d=>d(c))}emitError(c){this.listeners.error.length===0?(0,v.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(d=>d(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,d){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(d),this.resume();break;case"end":this.listeners.end.push(d),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(d),this.state.flowing&&this.flowErrors();break}}removeListener(c,d){if(!this.state.destroyed){let t;switch(c){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(d);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const d=[...this.pendingWritePromises];this.pendingWritePromises.length=0,d.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(l,c){const d=[];let t;for(;(t=l.read())!==null;)d.push(t);return c(d)}e.consumeReadable=S;function k(l,c,d){const t=[];let n;for(;(n=l.read())!==null&&t.length<d;)t.push(n);return n===null&&t.length>0?c(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const a=n;return n=void 0,a}return l.read()}}}e.peekReadable=k;function i(l,c){return new Promise((d,t)=>{const n=[];P(l,{onData:a=>{c&&n.push(a)},onError:a=>{c?t(a):d(void 0)},onEnd:()=>{d(c?c(n):void 0)}})})}e.consumeStream=i;function P(l,c){l.on("error",d=>c.onError(d)),l.on("end",()=>c.onEnd()),l.on("data",d=>c.onData(d))}e.listenStream=P;function h(l,c){return new Promise((d,t)=>{const n=new T.DisposableStore,a=[],s=b=>{if(a.push(b),a.length>c)return n.dispose(),l.pause(),d({stream:l,buffer:a,ended:!1})},u=b=>t(b),w=()=>d({stream:l,buffer:a,ended:!0});n.add((0,T.toDisposable)(()=>l.removeListener("error",u))),l.on("error",u),n.add((0,T.toDisposable)(()=>l.removeListener("end",w))),l.on("end",w),n.add((0,T.toDisposable)(()=>l.removeListener("data",s))),l.on("data",s)})}e.peekStream=h;function g(l,c){const d=y(c);return d.end(l),d}e.toStream=g;function r(){const l=y(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=r;function o(l){let c=!1;return{read:()=>c?null:(c=!0,l)}}e.toReadable=o;function p(l,c,d){const t=y(d);return P(l,{onData:n=>t.write(c.data(n)),onError:n=>t.error(c.error?c.error(n):n),onEnd:()=>t.end()}),t}e.transform=p;function m(l,c,d){let t=!1;return{read:()=>{const n=c.read();return t?n:(t=!0,n!==null?d([l,n]):l)}}}e.prefixedReadable=m;function E(l,c,d){let t=!1;const n=y(d);return P(c,{onData:a=>t?n.write(a):(t=!0,n.write(d([l,a]))),onError:a=>n.error(a),onEnd:()=>{t||(t=!0,n.write(l)),n.end()}}),n}e.prefixedStream=E}),define(ve[8],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(N){return!N||typeof N!="string"?!0:N.trim().length===0}e.isFalsyOrWhitespace=v;const T=/{(\d+)}/g;function D(N,...Q){return Q.length===0?N:N.replace(T,function(oe,ke){const Ie=parseInt(ke,10);return isNaN(Ie)||Ie<0||Ie>=Q.length?oe:Q[Ie]})}e.format=D;function A(N){return N.replace(/[<>&]/g,function(Q){switch(Q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Q}})}e.escape=A;function y(N){return N.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function C(N,Q){let oe=0;const ke=Q.charCodeAt(0);for(let Ie=N.length-1;Ie>=0;Ie--)N.charCodeAt(Ie)===ke&&oe++;return oe}e.count=C;function S(N,Q,oe="\u2026"){return N.length<=Q?N:`${N.substr(0,Q)}${oe}`}e.truncate=S;function k(N,Q=" "){const oe=i(N,Q);return P(oe,Q)}e.trim=k;function i(N,Q){if(!N||!Q)return N;const oe=Q.length;if(oe===0||N.length===0)return N;let ke=0;for(;N.indexOf(Q,ke)===ke;)ke=ke+oe;return N.substring(ke)}e.ltrim=i;function P(N,Q){if(!N||!Q)return N;const oe=Q.length,ke=N.length;if(oe===0||ke===0)return N;let Ie=ke,Ae=-1;for(;Ae=N.lastIndexOf(Q,Ie-1),!(Ae===-1||Ae+oe!==Ie);){if(Ae===0)return"";Ie=Ae}return N.substring(0,Ie)}e.rtrim=P;function h(N){return N.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function g(N){return N.replace(/\*/g,"")}e.stripWildcards=g;function r(N,Q,oe={}){if(!N)throw new Error("Cannot create regex from empty string");Q||(N=y(N)),oe.wholeWord&&(/\B/.test(N.charAt(0))||(N="\\b"+N),/\B/.test(N.charAt(N.length-1))||(N=N+"\\b"));let ke="";return oe.global&&(ke+="g"),oe.matchCase||(ke+="i"),oe.multiline&&(ke+="m"),oe.unicode&&(ke+="u"),new RegExp(N,ke)}e.createRegExp=r;function o(N){return N.source==="^"||N.source==="^$"||N.source==="$"||N.source==="^\\s*$"?!1:!!(N.exec("")&&N.lastIndex===0)}e.regExpLeadsToEndlessLoop=o;function p(N){return!!N.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function m(N){return(N.global?"g":"")+(N.ignoreCase?"i":"")+(N.multiline?"m":"")+(N.unicode?"u":"")}e.regExpFlags=m;function E(N){return N.split(/\r\n|\r|\n/)}e.splitLines=E;function l(N){for(let Q=0,oe=N.length;Q<oe;Q++){const ke=N.charCodeAt(Q);if(ke!==32&&ke!==9)return Q}return-1}e.firstNonWhitespaceIndex=l;function c(N,Q=0,oe=N.length){for(let ke=Q;ke<oe;ke++){const Ie=N.charCodeAt(ke);if(Ie!==32&&Ie!==9)return N.substring(Q,ke)}return N.substring(Q,oe)}e.getLeadingWhitespace=c;function d(N,Q=N.length-1){for(let oe=Q;oe>=0;oe--){const ke=N.charCodeAt(oe);if(ke!==32&&ke!==9)return oe}return-1}e.lastNonWhitespaceIndex=d;function t(N,Q){return N<Q?-1:N>Q?1:0}e.compare=t;function n(N,Q,oe=0,ke=N.length,Ie=0,Ae=Q.length){for(;oe<ke&&Ie<Ae;oe++,Ie++){let rt=N.charCodeAt(oe),tt=Q.charCodeAt(Ie);if(rt<tt)return-1;if(rt>tt)return 1}const Be=ke-oe,Ye=Ae-Ie;return Be<Ye?-1:Be>Ye?1:0}e.compareSubstring=n;function a(N,Q){return s(N,Q,0,N.length,0,Q.length)}e.compareIgnoreCase=a;function s(N,Q,oe=0,ke=N.length,Ie=0,Ae=Q.length){for(;oe<ke&&Ie<Ae;oe++,Ie++){let rt=N.charCodeAt(oe),tt=Q.charCodeAt(Ie);if(rt!==tt){const Qe=rt-tt;if(!(Qe===32&&w(tt))&&!(Qe===-32&&w(rt)))return u(rt)&&u(tt)?Qe:n(N.toLowerCase(),Q.toLowerCase(),oe,ke,Ie,Ae)}}const Be=ke-oe,Ye=Ae-Ie;return Be<Ye?-1:Be>Ye?1:0}e.compareSubstringIgnoreCase=s;function u(N){return N>=97&&N<=122}e.isLowerAsciiLetter=u;function w(N){return N>=65&&N<=90}e.isUpperAsciiLetter=w;function b(N){return u(N)||w(N)}function I(N,Q){return N.length===Q.length&&f(N,Q)}e.equalsIgnoreCase=I;function f(N,Q,oe=N.length){for(let ke=0;ke<oe;ke++){const Ie=N.charCodeAt(ke),Ae=Q.charCodeAt(ke);if(Ie!==Ae){if(b(Ie)&&b(Ae)){const Be=Math.abs(Ie-Ae);if(Be!==0&&Be!==32)return!1}else if(String.fromCharCode(Ie).toLowerCase()!==String.fromCharCode(Ae).toLowerCase())return!1}}return!0}function _(N,Q){const oe=Q.length;return Q.length>N.length?!1:f(N,Q,oe)}e.startsWithIgnoreCase=_;function F(N,Q){let oe,ke=Math.min(N.length,Q.length);for(oe=0;oe<ke;oe++)if(N.charCodeAt(oe)!==Q.charCodeAt(oe))return oe;return ke}e.commonPrefixLength=F;function U(N,Q){let oe,ke=Math.min(N.length,Q.length);const Ie=N.length-1,Ae=Q.length-1;for(oe=0;oe<ke;oe++)if(N.charCodeAt(Ie-oe)!==Q.charCodeAt(Ae-oe))return oe;return ke}e.commonSuffixLength=U;function z(N){return 55296<=N&&N<=56319}e.isHighSurrogate=z;function he(N){return 56320<=N&&N<=57343}e.isLowSurrogate=he;function de(N,Q){return(N-55296<<10)+(Q-56320)+65536}e.computeCodePoint=de;function x(N,Q,oe){const ke=N.charCodeAt(oe);if(z(ke)&&oe+1<Q){const Ie=N.charCodeAt(oe+1);if(he(Ie))return de(ke,Ie)}return ke}e.getNextCodePoint=x;function j(N,Q){const oe=N.charCodeAt(Q-1);if(he(oe)&&Q>1){const ke=N.charCodeAt(Q-2);if(z(ke))return de(ke,oe)}return oe}function H(N,Q){const oe=xe.getInstance(),ke=Q,Ie=N.length,Ae=x(N,Ie,Q);Q+=Ae>=65536?2:1;let Be=oe.getGraphemeBreakType(Ae);for(;Q<Ie;){const Ye=x(N,Ie,Q),rt=oe.getGraphemeBreakType(Ye);if(Ne(Be,rt))break;Q+=Ye>=65536?2:1,Be=rt}return Q-ke}e.nextCharLength=H;function R(N,Q){const oe=xe.getInstance(),ke=Q,Ie=j(N,Q);Q-=Ie>=65536?2:1;let Ae=oe.getGraphemeBreakType(Ie);for(;Q>0;){const Be=j(N,Q),Ye=oe.getGraphemeBreakType(Be);if(Ne(Ye,Ae))break;Q-=Be>=65536?2:1,Ae=Ye}return ke-Q}e.prevCharLength=R;function L(N,Q){const oe=xe.getInstance(),ke=N.length,Ie=Q,Ae=x(N,ke,Q),Be=oe.getGraphemeBreakType(Ae);Q+=Ae>=65536?2:1;let Ye=Be;for(;Q<ke;){const tt=x(N,ke,Q),Qe=oe.getGraphemeBreakType(tt);if(Ne(Ye,Qe))break;Q+=tt>=65536?2:1,Ye=Qe}const rt=Q;for(Q=Ie,Ye=Be;Q>0;){const tt=j(N,Q),Qe=oe.getGraphemeBreakType(tt);if(Ne(Qe,Ye))break;Q-=tt>=65536?2:1,Ye=Qe}return[Q,rt]}function M(N,Q){return Q>0&&he(N.charCodeAt(Q))?L(N,Q-1):L(N,Q)}e.getCharContainingOffset=M;function $(N){const Q=N.length;let oe=0,ke=0;for(;ke<Q;){const Be=x(N,Q,ke);ke+=Be>=65536?2:1,Be<128?oe+=1:Be<2048?oe+=2:Be<65536?oe+=3:oe+=4}const Ie=new Uint8Array(oe);ke=0;let Ae=0;for(;ke<Q;){const Be=x(N,Q,ke);ke+=Be>=65536?2:1,Be<128?Ie[Ae++]=Be:Be<2048?(Ie[Ae++]=192|(Be&1984)>>>6,Ie[Ae++]=128|(Be&63)>>>0):Be<65536?(Ie[Ae++]=224|(Be&61440)>>>12,Ie[Ae++]=128|(Be&4032)>>>6,Ie[Ae++]=128|(Be&63)>>>0):(Ie[Ae++]=240|(Be&1835008)>>>18,Ie[Ae++]=128|(Be&258048)>>>12,Ie[Ae++]=128|(Be&4032)>>>6,Ie[Ae++]=128|(Be&63)>>>0)}return Ie}e.encodeUTF8=$;function G(N){const Q=N.byteLength,oe=[];let ke=0;for(;ke<Q;){const Ie=N[ke];let Ae;if(Ie>=240&&ke+3<Q?Ae=(N[ke++]&7)<<18>>>0|(N[ke++]&63)<<12>>>0|(N[ke++]&63)<<6>>>0|(N[ke++]&63)<<0>>>0:Ie>=224&&ke+2<Q?Ae=(N[ke++]&15)<<12>>>0|(N[ke++]&63)<<6>>>0|(N[ke++]&63)<<0>>>0:Ie>=192&&ke+1<Q?Ae=(N[ke++]&31)<<6>>>0|(N[ke++]&63)<<0>>>0:Ae=N[ke++],Ae>=0&&Ae<=55295||Ae>=57344&&Ae<=65535)oe.push(String.fromCharCode(Ae));else if(Ae>=65536&&Ae<=1114111){const Be=Ae-65536,Ye=55296+((Be&1047552)>>>10),rt=56320+((Be&1023)>>>0);oe.push(String.fromCharCode(Ye)),oe.push(String.fromCharCode(rt))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=G;const J=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function te(N){return J.test(N)}e.containsRTL=te;const me=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Le(N){return me.test(N)}e.containsEmoji=Le;const We=/^[\t\n\r\x20-\x7E]*$/;function Fe(N){return We.test(N)}e.isBasicASCII=Fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ze(N){return e.UNUSUAL_LINE_TERMINATORS.test(N)}e.containsUnusualLineTerminators=ze;function W(N){for(let Q=0,oe=N.length;Q<oe;Q++)if(q(N.charCodeAt(Q)))return!0;return!1}e.containsFullWidthCharacter=W;function q(N){return N=+N,N>=11904&&N<=55215||N>=63744&&N<=64255||N>=65281&&N<=65374}e.isFullWidthCharacter=q;function ee(N){return N>=127462&&N<=127487||N===8986||N===8987||N===9200||N===9203||N>=9728&&N<=10175||N===11088||N===11093||N>=127744&&N<=128591||N>=128640&&N<=128764||N>=128992&&N<=129003||N>=129280&&N<=129535||N>=129648&&N<=129750}e.isEmojiImprecise=ee;function se(N,Q){if(N.length<Q)return N;const oe=/\b/g;let ke=0;for(;oe.test(N)&&!(N.length-oe.lastIndex<Q);)ke=oe.lastIndex,oe.lastIndex+=1;return N.substring(ke).replace(/^\s/,"")}e.lcut=se;const ce=/\x1B\x5B[12]?K/g,_e=/\x1b\[\d+m/g,$e=/\x1b\[0?m/g;function fe(N){return N&&(N=N.replace(ce,""),N=N.replace(_e,""),N=N.replace($e,"")),N}e.removeAnsiEscapeCodes=fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function De(N){return!!(N&&N.length>0&&N.charCodeAt(0)===65279)}e.startsWithUTF8BOM=De;function Re(N){return De(N)?N.substr(1):N}e.stripUTF8BOM=Re;function He(N,Q){if(!N||!Q||N.length<Q.length)return!1;const oe=Q.length,ke=N.toLowerCase();let Ie=0,Ae=-1;for(;Ie<oe;){const Be=ke.indexOf(Q[Ie],Ae+1);if(Be<0)return!1;Ae=Be,Ie++}return!0}e.fuzzyContains=He;function be(N,Q=!1){return N?(Q&&(N=N.replace(/\\./g,"")),N.toLowerCase()!==N):!1}e.containsUppercaseCharacter=be;function Ke(N){return N.charAt(0).toUpperCase()+N.slice(1)}e.uppercaseFirstLetter=Ke;function V(N,Q=1){if(Q===0)return"";let oe=-1;do oe=N.indexOf(`
`,oe+1),Q--;while(Q>0&&oe>=0);return oe===-1?N:(N[oe-1]==="\r"&&oe--,N.substr(0,oe))}e.getNLines=V;function Z(N){const Q=90-65+1;return N=N%(2*Q),N<Q?String.fromCharCode(97+N):String.fromCharCode(65+N-Q)}e.singleLetterHash=Z;function ge(N){return xe.getInstance().getGraphemeBreakType(N)}e.getGraphemeBreakType=ge;function Ne(N,Q){return N===0?Q!==5&&Q!==7:N===2&&Q===3?!1:N===4||N===2||N===3||Q===4||Q===2||Q===3?!0:!(N===8&&(Q===8||Q===9||Q===11||Q===12)||(N===11||N===9)&&(Q===9||Q===10)||(N===12||N===10)&&Q===10||Q===5||Q===13||Q===7||N===1||N===13&&Q===14||N===6&&Q===6)}e.breakBetweenGraphemeBreakType=Ne;var Ve;(function(N){N[N.Other=0]="Other",N[N.Prepend=1]="Prepend",N[N.CR=2]="CR",N[N.LF=3]="LF",N[N.Control=4]="Control",N[N.Extend=5]="Extend",N[N.Regional_Indicator=6]="Regional_Indicator",N[N.SpacingMark=7]="SpacingMark",N[N.L=8]="L",N[N.V=9]="V",N[N.T=10]="T",N[N.LV=11]="LV",N[N.LVT=12]="LVT",N[N.ZWJ=13]="ZWJ",N[N.Extended_Pictographic=14]="Extended_Pictographic"})(Ve=e.GraphemeBreakType||(e.GraphemeBreakType={}));class xe{constructor(){this._data=Xe()}static getInstance(){return xe._INSTANCE||(xe._INSTANCE=new xe),xe._INSTANCE}getGraphemeBreakType(Q){if(Q<32)return Q===10?3:Q===13?2:4;if(Q<127)return 0;const oe=this._data,ke=oe.length/3;let Ie=1;for(;Ie<=ke;)if(Q<oe[3*Ie])Ie=2*Ie;else if(Q>oe[3*Ie+1])Ie=2*Ie+1;else return oe[3*Ie+2];return 0}}xe._INSTANCE=null;function Xe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function ye(N,Q){if(N===0)return 0;const oe=Ee(N,Q);if(oe!==void 0)return oe;const ke=j(Q,N);return N-=Ce(ke),N}e.getLeftDeleteOffset=ye;function Ee(N,Q){let oe=j(Q,N);for(N-=Ce(oe);ie(oe)||oe===65039||oe===8419;){if(N===0)return;oe=j(Q,N),N-=Ce(oe)}if(!!ee(oe)){if(N>=0){const ke=j(Q,N);ke===8205&&(N-=Ce(ke))}return N}}function Ce(N){return N>=65536?2:1}function ie(N){return 127995<=N&&N<=127999}var ae;(function(N){N[N.zwj=8205]="zwj",N[N.emojiVariantSelector=65039]="emojiVariantSelector",N[N.enclosingKeyCap=8419]="enclosingKeyCap"})(ae||(ae={}))}),define(ve[24],we([0,1,8,110]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined",A=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let C,S;class k{constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}static alloc(b){return D?new k(Buffer.allocUnsafe(b)):new k(new Uint8Array(b))}static wrap(b){return D&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new k(b)}static fromString(b,I){return!((I==null?void 0:I.dontUseNodeBuffer)||!1)&&D?new k(Buffer.from(b)):A?(C||(C=new TextEncoder),new k(C.encode(b))):new k(v.encodeUTF8(b))}static concat(b,I){if(typeof I=="undefined"){I=0;for(let F=0,U=b.length;F<U;F++)I+=b[F].byteLength}const f=k.alloc(I);let _=0;for(let F=0,U=b.length;F<U;F++){const z=b[F];f.set(z,_),_+=z.byteLength}return f}toString(){return D?this.buffer.toString():y?(S||(S=new TextDecoder),S.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(b,I){return new k(this.buffer.subarray(b,I))}set(b,I){b instanceof k?this.buffer.set(b.buffer,I):this.buffer.set(b,I)}readUInt32BE(b){return h(this.buffer,b)}writeUInt32BE(b,I){g(this.buffer,b,I)}readUInt32LE(b){return r(this.buffer,b)}writeUInt32LE(b,I){o(this.buffer,b,I)}readUInt8(b){return p(this.buffer,b)}writeUInt8(b,I){m(this.buffer,b,I)}}e.VSBuffer=k;function i(w,b){return w[b+0]<<0>>>0|w[b+1]<<8>>>0}e.readUInt16LE=i;function P(w,b,I){w[I+0]=b&255,b=b>>>8,w[I+1]=b&255}e.writeUInt16LE=P;function h(w,b){return w[b]*2**24+w[b+1]*2**16+w[b+2]*2**8+w[b+3]}e.readUInt32BE=h;function g(w,b,I){w[I+3]=b,b=b>>>8,w[I+2]=b,b=b>>>8,w[I+1]=b,b=b>>>8,w[I]=b}e.writeUInt32BE=g;function r(w,b){return w[b+0]<<0>>>0|w[b+1]<<8>>>0|w[b+2]<<16>>>0|w[b+3]<<24>>>0}e.readUInt32LE=r;function o(w,b,I){w[I+0]=b&255,b=b>>>8,w[I+1]=b&255,b=b>>>8,w[I+2]=b&255,b=b>>>8,w[I+3]=b&255}e.writeUInt32LE=o;function p(w,b){return w[b]}e.readUInt8=p;function m(w,b,I){w[I]=b}e.writeUInt8=m;function E(w){return T.consumeReadable(w,b=>k.concat(b))}e.readableToBuffer=E;function l(w){return T.toReadable(w)}e.bufferToReadable=l;function c(w){return T.consumeStream(w,b=>k.concat(b))}e.streamToBuffer=c;async function d(w){return w.ended?k.concat(w.buffer):k.concat([...w.buffer,await c(w.stream)])}e.bufferedStreamToBuffer=d;function t(w){return T.toStream(w,b=>k.concat(b))}e.bufferToStream=t;function n(w){return T.transform(w,{data:b=>typeof b=="string"?k.fromString(b):k.wrap(b)},b=>k.concat(b))}e.streamToBufferReadableStream=n;function a(w){return T.newWriteableStream(b=>k.concat(b),w)}e.newWriteableBufferStream=a;function s(w,b){return T.prefixedReadable(w,b,I=>k.concat(I))}e.prefixedBufferReadable=s;function u(w,b){return T.prefixedStream(w,b,I=>k.concat(I))}e.prefixedBufferStream=u}),define(ve[56],we([0,1,8]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function T(m){return D(m,0)}e.hash=T;function D(m,E){switch(typeof m){case"object":return m===null?A(349,E):Array.isArray(m)?S(m,E):k(m,E);case"string":return C(m,E);case"boolean":return y(m,E);case"number":return A(m,E);case"undefined":return A(937,E);default:return A(617,E)}}e.doHash=D;function A(m,E){return(E<<5)-E+m|0}function y(m,E){return A(m?433:863,E)}function C(m,E){E=A(149417,E);for(let l=0,c=m.length;l<c;l++)E=A(m.charCodeAt(l),E);return E}e.stringHash=C;function S(m,E){return E=A(104579,E),m.reduce((l,c)=>D(c,l),E)}function k(m,E){return E=A(181387,E),Object.keys(m).sort().reduce((l,c)=>(l=C(c,l),D(m[c],l)),E)}class i{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=D(E,this._value),this._value}}e.Hasher=i;var P;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function h(m,E,l=32){const c=l-E,d=~((1<<c)-1);return(m<<E|(d&m)>>>c)>>>0}function g(m,E=0,l=m.byteLength,c=0){for(let d=0;d<l;d++)m[E+d]=c}function r(m,E,l="0"){for(;m.length<E;)m=l+m;return m}function o(m,E=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(l=>l.toString(16).padStart(2,"0")).join(""):r((m>>>0).toString(16),E/4)}e.toHexString=o;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const l=E.length;if(l!==0){const c=this._buff;let d=this._buffLen,t=this._leftoverHighSurrogate,n,a;for(t!==0?(n=t,a=-1,t=0):(n=E.charCodeAt(0),a=0);;){let s=n;if(v.isHighSurrogate(n))if(a+1<l){const u=E.charCodeAt(a+1);v.isLowSurrogate(u)?(a++,s=v.computeCodePoint(n,u)):s=65533}else{t=n;break}else v.isLowSurrogate(n)&&(s=65533);if(d=this._push(c,d,s),a++,a<l)n=E.charCodeAt(a);else break}this._buffLen=d,this._leftoverHighSurrogate=t}}_push(E,l,c){return c<128?E[l++]=c:c<2048?(E[l++]=192|(c&1984)>>>6,E[l++]=128|(c&63)>>>0):c<65536?(E[l++]=224|(c&61440)>>>12,E[l++]=128|(c&4032)>>>6,E[l++]=128|(c&63)>>>0):(E[l++]=240|(c&1835008)>>>18,E[l++]=128|(c&258048)>>>12,E[l++]=128|(c&4032)>>>6,E[l++]=128|(c&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),o(this._h0)+o(this._h1)+o(this._h2)+o(this._h3)+o(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=p._bigBlock32,l=this._buffDV;for(let b=0;b<64;b+=4)E.setUint32(b,l.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)E.setUint32(b,h(E.getUint32(b-12,!1)^E.getUint32(b-32,!1)^E.getUint32(b-56,!1)^E.getUint32(b-64,!1),1),!1);let c=this._h0,d=this._h1,t=this._h2,n=this._h3,a=this._h4,s,u,w;for(let b=0;b<80;b++)b<20?(s=d&t|~d&n,u=1518500249):b<40?(s=d^t^n,u=1859775393):b<60?(s=d&t|d&n|t&n,u=2400959708):(s=d^t^n,u=3395469782),w=h(c,5)+s+a+u+E.getUint32(b*4,!1)&4294967295,a=n,n=t,t=h(d,30),d=c,c=w;this._h0=this._h0+c&4294967295,this._h1=this._h1+d&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+a&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ve[47],we([0,1,8]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(T||(T={})),function(D){const A="error",y="warning",C="warn",S="info",k="ignore";function i(h){return h?v.equalsIgnoreCase(A,h)?D.Error:v.equalsIgnoreCase(y,h)||v.equalsIgnoreCase(C,h)?D.Warning:v.equalsIgnoreCase(S,h)?D.Info:D.Ignore:D.Ignore}D.fromValue=i;function P(h){switch(h){case D.Error:return A;case D.Warning:return y;case D.Info:return S;default:return k}}D.toString=P}(T||(T={})),e.default=T}),define(ve[10],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(b){return Array.isArray(b)}e.isArray=v;function T(b){return typeof b=="string"}e.isString=T;function D(b){return Array.isArray(b)&&b.every(I=>T(I))}e.isStringArray=D;function A(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}e.isObject=A;function y(b){return typeof b=="number"&&!isNaN(b)}e.isNumber=y;function C(b){return!!b&&typeof b[Symbol.iterator]=="function"}e.isIterable=C;function S(b){return b===!0||b===!1}e.isBoolean=S;function k(b){return typeof b=="undefined"}e.isUndefined=k;function i(b){return!P(b)}e.isDefined=i;function P(b){return k(b)||b===null}e.isUndefinedOrNull=P;function h(b,I){if(!b)throw new Error(I?`Unexpected type, expected '${I}'`:"Unexpected type")}e.assertType=h;function g(b){if(P(b))throw new Error("Assertion Failed: argument is undefined or null");return b}e.assertIsDefined=g;function r(...b){const I=[];for(let f=0;f<b.length;f++){const _=b[f];if(P(_))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);I.push(_)}return I}e.assertAllDefined=r;const o=Object.prototype.hasOwnProperty;function p(b){if(!A(b))return!1;for(let I in b)if(o.call(b,I))return!1;return!0}e.isEmptyObject=p;function m(b){return typeof b=="function"}e.isFunction=m;function E(...b){return b.length>0&&b.every(m)}e.areFunctions=E;function l(b,I){const f=Math.min(b.length,I.length);for(let _=0;_<f;_++)c(b[_],I[_])}e.validateConstraints=l;function c(b,I){if(T(I)){if(typeof b!==I)throw new Error(`argument does not match constraint: typeof ${I}`)}else if(m(I)){try{if(b instanceof I)return}catch(f){}if(!P(b)&&b.constructor===I||I.length===1&&I.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function d(b){let I=[],f=Object.getPrototypeOf(b);for(;Object.prototype!==f;)I=I.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return I}e.getAllPropertyNames=d;function t(b){const I=[];for(const f of d(b))typeof b[f]=="function"&&I.push(f);return I}e.getAllMethodNames=t;function n(b,I){const f=F=>function(){const U=Array.prototype.slice.call(arguments,0);return I(F,U)};let _={};for(const F of b)_[F]=f(F);return _}e.createProxyObject=n;function a(b){return b===null?void 0:b}e.withNullAsUndefined=a;function s(b){return typeof b=="undefined"?null:b}e.withUndefinedAsNull=s;function u(b){return class{constructor(){return new Proxy({},{get(I,f){if(I[f])return I[f];throw new Error(`Not Implemented: ${b}->${String(f)}`)}})}}}e.NotImplementedProxy=u;function w(b){throw new Error("Unreachable")}e.assertNever=w}),define(ve[37],we([0,1,21,8,14,10]),function(Y,e,v,T,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function y(n){return n===47||n===92}e.isPathSeparator=y;function C(n){return n.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=C;function S(n,a=D.posix.sep){if(!n)return"";const s=n.length,u=n.charCodeAt(0);if(y(u)){if(y(n.charCodeAt(1))&&!y(n.charCodeAt(2))){let b=3;const I=b;for(;b<s&&!y(n.charCodeAt(b));b++);if(I!==b&&!y(n.charCodeAt(b+1))){for(b+=1;b<s;b++)if(y(n.charCodeAt(b)))return n.slice(0,b+1).replace(/[\\/]/g,a)}}return a}else if(p(u)&&n.charCodeAt(1)===58)return y(n.charCodeAt(2))?n.slice(0,2)+a:n.slice(0,2);let w=n.indexOf("://");if(w!==-1){for(w+=3;w<s;w++)if(y(n.charCodeAt(w)))return n.slice(0,w+1)}return""}e.getRoot=S;function k(n){if(!v.isWindows||!n||n.length<5)return!1;let a=n.charCodeAt(0);if(a!==92||(a=n.charCodeAt(1),a!==92))return!1;let s=2;const u=s;for(;s<n.length&&(a=n.charCodeAt(s),a!==92);s++);return!(u===s||(a=n.charCodeAt(s+1),isNaN(a)||a===92))}e.isUNC=k;const i=/[\\/:\*\?"<>\|]/g,P=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(n,a=v.isWindows){const s=a?i:P;return!(!n||n.length===0||/^\s+$/.test(n)||(s.lastIndex=0,s.test(n))||a&&h.test(n)||n==="."||n===".."||a&&n[n.length-1]==="."||a&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=g;function r(n,a,s){const u=n===a;return!s||u?u:!n||!a?!1:(0,T.equalsIgnoreCase)(n,a)}e.isEqual=r;function o(n,a,s,u=D.sep){if(n===a)return!0;if(!n||!a||a.length>n.length)return!1;if(s){if(!(0,T.startsWithIgnoreCase)(n,a))return!1;if(a.length===n.length)return!0;let b=a.length;return a.charAt(a.length-1)===u&&b--,n.charAt(b)===u}return a.charAt(a.length-1)!==u&&(a+=u),n.indexOf(a)===0}e.isEqualOrParent=o;function p(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=p;function m(n,a){return v.isWindows&&n.endsWith(":")&&(n+=D.sep),(0,D.isAbsolute)(n)||(n=(0,D.join)(a,n)),n=(0,D.normalize)(n),v.isWindows?(n=(0,T.rtrim)(n,D.sep),n.endsWith(":")&&(n+=D.sep)):(n=(0,T.rtrim)(n,D.sep),n||(n=D.sep)),n}e.sanitizeFilePath=m;function E(n){const a=(0,D.normalize)(n);return v.isWindows?n.length>3?!1:l(a)&&(n.length===2||a.charCodeAt(2)===92):a===D.posix.sep}e.isRootOrDriveLetter=E;function l(n){return v.isWindows?p(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function c(n){return l(n)?n[0]:void 0}e.getDriveLetter=c;function d(n,a,s){return a.length>n.length?-1:n===a?0:(s&&(n=n.toLowerCase(),a=a.toLowerCase()),n.indexOf(a))}e.indexOfPath=d;function t(n){const a=n.split(":");let s,u,w;if(a.forEach(b=>{const I=Number(b);(0,A.isNumber)(I)?u===void 0?u=I:w===void 0&&(w=I):s=s?[s,b].join(":"):b}),!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:u!==void 0?u:void 0,column:w!==void 0?w:u!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(ve[23],we([0,1,10]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const p=Array.isArray(o)?[]:{};return Object.keys(o).forEach(m=>{o[m]&&typeof o[m]=="object"?p[m]=T(o[m]):p[m]=o[m]}),p}e.deepClone=T;function D(o){if(!o||typeof o!="object")return o;const p=[o];for(;p.length>0;){const m=p.shift();Object.freeze(m);for(const E in m)if(A.call(m,E)){const l=m[E];typeof l=="object"&&!Object.isFrozen(l)&&p.push(l)}}return o}e.deepFreeze=D;const A=Object.prototype.hasOwnProperty;function y(o,p){return C(o,p,new Set)}e.cloneAndChange=y;function C(o,p,m){if((0,v.isUndefinedOrNull)(o))return o;const E=p(o);if(typeof E!="undefined")return E;if((0,v.isArray)(o)){const l=[];for(const c of o)l.push(C(c,p,m));return l}if((0,v.isObject)(o)){if(m.has(o))throw new Error("Cannot clone recursive data-structure");m.add(o);const l={};for(let c in o)A.call(o,c)&&(l[c]=C(o[c],p,m));return m.delete(o),l}return o}function S(o,p,m=!0){return(0,v.isObject)(o)?((0,v.isObject)(p)&&Object.keys(p).forEach(E=>{E in o?m&&((0,v.isObject)(o[E])&&(0,v.isObject)(p[E])?S(o[E],p[E],m):o[E]=p[E]):o[E]=p[E]}),o):p}e.mixin=S;function k(o,p){if(o===p)return!0;if(o==null||p===null||p===void 0||typeof o!=typeof p||typeof o!="object"||Array.isArray(o)!==Array.isArray(p))return!1;let m,E;if(Array.isArray(o)){if(o.length!==p.length)return!1;for(m=0;m<o.length;m++)if(!k(o[m],p[m]))return!1}else{const l=[];for(E in o)l.push(E);l.sort();const c=[];for(E in p)c.push(E);if(c.sort(),!k(l,c))return!1;for(m=0;m<l.length;m++)if(!k(o[l[m]],p[l[m]]))return!1}return!0}e.equals=k;function i(o){const p=new Set;return JSON.stringify(o,(m,E)=>{if((0,v.isObject)(E)||Array.isArray(E)){if(p.has(E))return"[Circular]";p.add(E)}return E})}e.safeStringify=i;function P(o,p,m){const E=p(o);return typeof E=="undefined"?m:E}e.getOrDefault=P;function h(o,p){const m=Object.create(null);return!o||!p||Object.keys(p).forEach(l=>{const c=o[l],d=p[l];k(c,d)||(m[l]=d)}),m}e.distinct=h;function g(o,p){const m=p.toLowerCase(),E=Object.keys(o).find(l=>l.toLowerCase()===m);return E?o[E]:o[p]}e.getCaseInsensitive=g;function r(o,p){const m=Object.create(null);for(const E of Object.keys(o))p(E,o[E])&&(m[E]=o[E]);return m}e.filter=r}),define(ve[83],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var v;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(v=e.Constants||(e.Constants={}));function T(A){return A<0?0:A>255?255:A|0}e.toUint8=T;function D(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=D}),define(ve[2],we([0,1,21,14]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,A=/^\//,y=/^\/\//;function C(a,s){if(!a.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!D.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!A.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(a,s){return!a&&!s?"file":a}function k(a,s){switch(a){case"https":case"http":case"file":s?s[0]!==P&&(s=P+s):s=P;break}return s}const i="",P="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(s,u,w,b,I,f=!1){typeof s=="object"?(this.scheme=s.scheme||i,this.authority=s.authority||i,this.path=s.path||i,this.query=s.query||i,this.fragment=s.fragment||i):(this.scheme=S(s,f),this.authority=u||i,this.path=k(this.scheme,w||i),this.query=b||i,this.fragment=I||i,C(this,f))}static isUri(s){return s instanceof g?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return l(this,!1)}with(s){if(!s)return this;let{scheme:u,authority:w,path:b,query:I,fragment:f}=s;return u===void 0?u=this.scheme:u===null&&(u=i),w===void 0?w=this.authority:w===null&&(w=i),b===void 0?b=this.path:b===null&&(b=i),I===void 0?I=this.query:I===null&&(I=i),f===void 0?f=this.fragment:f===null&&(f=i),u===this.scheme&&w===this.authority&&b===this.path&&I===this.query&&f===this.fragment?this:new o(u,w,b,I,f)}static parse(s,u=!1){const w=h.exec(s);return w?new o(w[2]||i,n(w[4]||i),n(w[5]||i),n(w[7]||i),n(w[9]||i),u):new o(i,i,i,i,i)}static file(s){let u=i;if(v.isWindows&&(s=s.replace(/\\/g,P)),s[0]===P&&s[1]===P){const w=s.indexOf(P,2);w===-1?(u=s.substring(2),s=P):(u=s.substring(2,w),s=s.substring(w)||P)}return new o("file",u,s,i,i)}static from(s){return new o(s.scheme,s.authority,s.path,s.query,s.fragment)}static joinPath(s,...u){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return v.isWindows&&s.scheme==="file"?w=g.file(T.win32.join(l(s,!0),...u)).path:w=T.posix.join(s.path,...u),s.with({path:w})}toString(s=!1){return c(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof g)return s;{const u=new o(s);return u._formatted=s.external,u._fsPath=s._sep===r?s.fsPath:null,u}}else return s}}e.URI=g;const r=v.isWindows?1:void 0;class o extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(s=!1){return s?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=r),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(a,s){let u,w=-1;for(let b=0;b<a.length;b++){const I=a.charCodeAt(b);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||s&&I===47)w!==-1&&(u+=encodeURIComponent(a.substring(w,b)),w=-1),u!==void 0&&(u+=a.charAt(b));else{u===void 0&&(u=a.substr(0,b));const f=p[I];f!==void 0?(w!==-1&&(u+=encodeURIComponent(a.substring(w,b)),w=-1),u+=f):w===-1&&(w=b)}}return w!==-1&&(u+=encodeURIComponent(a.substring(w))),u!==void 0?u:a}function E(a){let s;for(let u=0;u<a.length;u++){const w=a.charCodeAt(u);w===35||w===63?(s===void 0&&(s=a.substr(0,u)),s+=p[w]):s!==void 0&&(s+=a[u])}return s!==void 0?s:a}function l(a,s){let u;return a.authority&&a.path.length>1&&a.scheme==="file"?u=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?s?u=a.path.substr(1):u=a.path[1].toLowerCase()+a.path.substr(2):u=a.path,v.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=l;function c(a,s){const u=s?E:m;let w="",{scheme:b,authority:I,path:f,query:_,fragment:F}=a;if(b&&(w+=b,w+=":"),(I||b==="file")&&(w+=P,w+=P),I){let U=I.indexOf("@");if(U!==-1){const z=I.substr(0,U);I=I.substr(U+1),U=z.indexOf(":"),U===-1?w+=u(z,!1):(w+=u(z.substr(0,U),!1),w+=":",w+=u(z.substr(U+1),!1)),w+="@"}I=I.toLowerCase(),U=I.indexOf(":"),U===-1?w+=u(I,!1):(w+=u(I.substr(0,U),!1),w+=I.substr(U))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const U=f.charCodeAt(1);U>=65&&U<=90&&(f=`/${String.fromCharCode(U+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const U=f.charCodeAt(0);U>=65&&U<=90&&(f=`${String.fromCharCode(U+32)}:${f.substr(2)}`)}w+=u(f,!0)}return _&&(w+="?",w+=u(_,!1)),F&&(w+="#",w+=s?F:m(F,!1)),w}function d(a){try{return decodeURIComponent(a)}catch(s){return a.length>3?a.substr(0,3)+d(a.substr(3)):a}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(a){return a.match(t)?a.replace(t,s=>d(s)):a}});var it=this&&this.__classPrivateFieldSet||function(Y,e,v,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Y,v):D?D.value=v:e.set(Y,v),v},Ue=this&&this.__classPrivateFieldGet||function(Y,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!T:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(Y):T?T.value:e.get(Y)};define(ve[22],we([0,1,2,8]),function(Y,e,v,T){"use strict";var D,A,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(t,n,a){let s=t.get(n);return s===void 0&&(s=a,t.set(n,s)),s}e.getOrSet=C;function S(t){const n=[];return t.forEach((a,s)=>{n.push(`${s} => ${a}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=S;function k(t){const n=[];return t.forEach(a=>{n.push(a)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=k;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const a=n.charCodeAt(0),s=this._value.charCodeAt(this._pos);return a-s}value(){return this._value[this._pos]}}e.StringIterator=i;class P{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,T.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class h{constructor(n=!0,a=!0){this._splitOnBackslash=n,this._caseSensitive=a}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,T.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=h;var g;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(g||(g={}));class r{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new h(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,T.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,T.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,T.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,T.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=r;class o{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class p{constructor(n){this._iter=n}static forUris(n=()=>!1){return new p(new r(n))}static forPaths(){return new p(new h)}static forStrings(){return new p(new i)}static forConfigKeys(){return new p(new P)}clear(){this._root=void 0}set(n,a){const s=this._iter.reset(n);let u;for(this._root||(this._root=new o,this._root.segment=s.value()),u=this._root;;){const b=s.cmp(u.segment);if(b>0)u.left||(u.left=new o,u.left.segment=s.value()),u=u.left;else if(b<0)u.right||(u.right=new o,u.right.segment=s.value()),u=u.right;else if(s.hasNext())s.next(),u.mid||(u.mid=new o,u.mid.segment=s.value()),u=u.mid;else break}const w=u.value;return u.value=a,u.key=n,w}get(n){var a;return(a=this._getNode(n))===null||a===void 0?void 0:a.value}_getNode(n){const a=this._iter.reset(n);let s=this._root;for(;s;){const u=a.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(a.hasNext())a.next(),s=s.mid;else break}return s}has(n){const a=this._getNode(n);return!((a==null?void 0:a.value)===void 0&&(a==null?void 0:a.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,a){const s=this._iter.reset(n),u=[];let w=this._root;for(;w;){const b=s.cmp(w.segment);if(b>0)u.push([1,w]),w=w.left;else if(b<0)u.push([-1,w]),w=w.right;else if(s.hasNext())s.next(),u.push([0,w]),w=w.mid;else{for(a?(w.left=void 0,w.mid=void 0,w.right=void 0):w.value=void 0;u.length>0&&w.isEmpty();){let[I,f]=u.pop();switch(I){case 1:f.left=void 0;break;case 0:f.mid=void 0;break;case-1:f.right=void 0;break}w=f}break}}}findSubstr(n){const a=this._iter.reset(n);let s=this._root,u;for(;s;){const w=a.cmp(s.segment);if(w>0)s=s.left;else if(w<0)s=s.right;else if(a.hasNext())a.next(),u=s.value||u,s=s.mid;else break}return s&&s.value||u}findSuperstr(n){const a=this._iter.reset(n);let s=this._root;for(;s;){const u=a.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(a.hasNext())a.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(n){for(const[a,s]of this)n(s,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=p;class m{constructor(n,a){this[D]="ResourceMap",n instanceof m?(this.map=new Map(n.map),this.toKey=a!=null?a:m.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:m.defaultToKey)}set(n,a){return this.map.set(this.toKey(n),a),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,a){typeof a!="undefined"&&(n=n.bind(a));for(let[s,u]of this.map)n(u,v.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield v.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[v.URI.parse(n[0]),n[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[v.URI.parse(n[0]),n[1]]}}e.ResourceMap=m,m.defaultToKey=t=>t.toString();var E;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class l{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,a=0){const s=this._map.get(n);if(!!s)return a!==0&&this.touch(s,a),s.value}set(n,a,s=0){let u=this._map.get(n);if(u)u.value=a,s!==0&&this.touch(u,s);else{switch(u={key:n,value:a,next:void 0,previous:void 0},s){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(n,u),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const a=this._map.get(n);if(!!a)return this._map.delete(n),this.removeItem(a),this._size--,a.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,a){const s=this._state;let u=this._head;for(;u;){if(a?n.bind(a)(u.value,u.key,this):n(u.value,u.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const n=this,a=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==a)throw new Error("LinkedMap got modified during iteration.");if(s){const w={value:s.key,done:!1};return s=s.next,w}else return{value:void 0,done:!0}}};return u}values(){const n=this,a=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==a)throw new Error("LinkedMap got modified during iteration.");if(s){const w={value:s.value,done:!1};return s=s.next,w}else return{value:void 0,done:!0}}};return u}entries(){const n=this,a=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==a)throw new Error("LinkedMap got modified during iteration.");if(s){const w={value:[s.key,s.value],done:!1};return s=s.next,w}else return{value:void 0,done:!0}}};return u}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let a=this._head,s=this.size;for(;a&&s>n;)this._map.delete(a.key),a=a.next,s--;this._head=a,this._size=s,a&&(a.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const a=n.next,s=n.previous;if(!a||!s)throw new Error("Invalid list");a.previous=s,s.next=a}n.next=void 0,n.previous=void 0,this._state++}touch(n,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(n===this._head)return;const s=n.next,u=n.previous;n===this._tail?(u.next=void 0,this._tail=u):(s.previous=u,u.next=s),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(a===2){if(n===this._tail)return;const s=n.next,u=n.previous;n===this._head?(s.previous=void 0,this._head=s):(s.previous=u,u.next=s),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((a,s)=>{n.push([s,a])}),n}fromJSON(n){this.clear();for(const[a,s]of n)this.set(a,s)}}e.LinkedMap=l;class c extends l{constructor(n,a=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,a=2){return super.get(n,a)}peek(n){return super.get(n,0)}set(n,a){return super.set(n,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class d{constructor(n){y.set(this,void 0),it(this,y,n,"f")}get size(){return Ue(this,y,"f").size}forEach(n,a){Ue(this,y,"f").forEach(n,a)}get(n){return Ue(this,y,"f").get(n)}has(n){return Ue(this,y,"f").has(n)}entries(){return Ue(this,y,"f").entries()}keys(){return Ue(this,y,"f").keys()}values(){return Ue(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return Ue(this,y,"f").entries()}}e.ReadonlyMapView=d}),define(ve[111],we([0,1,22,8]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...fe){return function(De,Re){for(let He=0,be=fe.length;He<be;He++){const Ke=fe[He](De,Re);if(Ke)return Ke}return null}}e.or=D,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(fe,De,Re){if(!Re||Re.length<De.length)return null;let He;return fe?He=T.startsWithIgnoreCase(Re,De):He=Re.indexOf(De)===0,He?De.length>0?[{start:0,end:De.length}]:[]:null}function y(fe,De){const Re=De.toLowerCase().indexOf(fe.toLowerCase());return Re===-1?null:[{start:Re,end:Re+fe.length}]}e.matchesContiguousSubString=y;function C(fe,De){return S(fe.toLowerCase(),De.toLowerCase(),0,0)}e.matchesSubString=C;function S(fe,De,Re,He){if(Re===fe.length)return[];if(He===De.length)return null;if(fe[Re]===De[He]){let be=null;return(be=S(fe,De,Re+1,He+1))?m({start:He,end:He+1},be):null}return S(fe,De,Re,He+1)}function k(fe){return 97<=fe&&fe<=122}function i(fe){return 65<=fe&&fe<=90}e.isUpper=i;function P(fe){return 48<=fe&&fe<=57}function h(fe){return fe===32||fe===9||fe===10||fe===13}const g=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(fe=>g.add(fe.charCodeAt(0)));function r(fe){return h(fe)||g.has(fe)}function o(fe,De){return fe===De||r(fe)&&r(De)}function p(fe){return k(fe)||i(fe)||P(fe)}function m(fe,De){return De.length===0?De=[fe]:fe.end===De[0].start?De[0].start=fe.start:De.unshift(fe),De}function E(fe,De){for(let Re=De;Re<fe.length;Re++){const He=fe.charCodeAt(Re);if(i(He)||P(He)||Re>0&&!p(fe.charCodeAt(Re-1)))return Re}return fe.length}function l(fe,De,Re,He){if(Re===fe.length)return[];if(He===De.length)return null;if(fe[Re]!==De[He].toLowerCase())return null;{let be=null,Ke=He+1;for(be=l(fe,De,Re+1,He+1);!be&&(Ke=E(De,Ke))<De.length;)be=l(fe,De,Re+1,Ke),Ke++;return be===null?null:m({start:He,end:He+1},be)}}function c(fe){let De=0,Re=0,He=0,be=0,Ke=0;for(let Ve=0;Ve<fe.length;Ve++)Ke=fe.charCodeAt(Ve),i(Ke)&&De++,k(Ke)&&Re++,p(Ke)&&He++,P(Ke)&&be++;const V=De/fe.length,Z=Re/fe.length,ge=He/fe.length,Ne=be/fe.length;return{upperPercent:V,lowerPercent:Z,alphaPercent:ge,numericPercent:Ne}}function d(fe){const{upperPercent:De,lowerPercent:Re}=fe;return Re===0&&De>.6}function t(fe){const{upperPercent:De,lowerPercent:Re,alphaPercent:He,numericPercent:be}=fe;return Re>.2&&De<.8&&He>.6&&be<.2}function n(fe){let De=0,Re=0,He=0,be=0;for(let Ke=0;Ke<fe.length;Ke++)He=fe.charCodeAt(Ke),i(He)&&De++,k(He)&&Re++,h(He)&&be++;return(De===0||Re===0)&&be===0?fe.length<=30:De<=5}function a(fe,De){if(!De||(De=De.trim(),De.length===0)||!n(fe)||De.length>60)return null;const Re=c(De);if(!t(Re)){if(!d(Re))return null;De=De.toLowerCase()}let He=null,be=0;for(fe=fe.toLowerCase();be<De.length&&(He=l(fe,De,0,be))===null;)be=E(De,be+1);return He}e.matchesCamelCase=a;function s(fe,De,Re=!1){if(!De||De.length===0)return null;let He=null,be=0;for(fe=fe.toLowerCase(),De=De.toLowerCase();be<De.length&&(He=u(fe,De,0,be,Re))===null;)be=w(De,be+1);return He}e.matchesWords=s;function u(fe,De,Re,He,be){if(Re===fe.length)return[];if(He===De.length)return null;if(o(fe.charCodeAt(Re),De.charCodeAt(He))){let Ke=null,V=He+1;if(Ke=u(fe,De,Re+1,He+1,be),!be)for(;!Ke&&(V=w(De,V))<De.length;)Ke=u(fe,De,Re+1,V,be),V++;return Ke===null?null:m({start:He,end:He+1},Ke)}else return null}function w(fe,De){for(let Re=De;Re<fe.length;Re++)if(r(fe.charCodeAt(Re))||Re>0&&r(fe.charCodeAt(Re-1)))return Re;return fe.length}const b=D(e.matchesPrefix,a,y),I=D(e.matchesPrefix,a,C),f=new v.LRUCache(1e4);function _(fe,De,Re=!1){if(typeof fe!="string"||typeof De!="string")return null;let He=f.get(fe);He||(He=new RegExp(T.convertSimple2RegExpPattern(fe),"i"),f.set(fe,He));const be=He.exec(De);return be?[{start:be.index,end:be.index+be[0].length}]:Re?I(fe,De):b(fe,De)}e.matchesFuzzy=_;function F(fe,De){const Re=W(fe,fe.toLowerCase(),0,De,De.toLowerCase(),0,!0);return Re?z(Re):null}e.matchesFuzzy2=F;function U(fe,De,Re,He,be,Ke){const V=Math.min(13,fe.length);for(;Re<V;Re++){const Z=W(fe,De,Re,He,be,Ke,!1);if(Z)return Z}return[0,Ke]}e.anyScore=U;function z(fe){if(typeof fe=="undefined")return[];const De=[],Re=fe[1];for(let He=fe.length-1;He>1;He--){const be=fe[He]+Re,Ke=De[De.length-1];Ke&&Ke.end===be?Ke.end=be+1:De.push({start:be,end:be+1})}return De}e.createMatches=z;const he=128;function de(){const fe=[],De=[];for(let Re=0;Re<=he;Re++)De[Re]=0;for(let Re=0;Re<=he;Re++)fe.push(De.slice(0));return fe}function x(fe){const De=[];for(let Re=0;Re<=fe;Re++)De[Re]=0;return De}const j=x(2*he),H=x(2*he),R=de(),L=de(),M=de(),$=!1;function G(fe,De,Re,He,be){function Ke(Z,ge,Ne=" "){for(;Z.length<ge;)Z=Ne+Z;return Z}let V=` |   |${He.split("").map(Z=>Ke(Z,3)).join("|")}
`;for(let Z=0;Z<=Re;Z++)Z===0?V+=" |":V+=`${De[Z-1]}|`,V+=fe[Z].slice(0,be+1).map(ge=>Ke(ge.toString(),3)).join("|")+`
`;return V}function J(fe,De,Re,He){fe=fe.substr(De),Re=Re.substr(He),console.log(G(L,fe,fe.length,Re,Re.length)),console.log(G(M,fe,fe.length,Re,Re.length)),console.log(G(R,fe,fe.length,Re,Re.length))}function te(fe,De){if(De<0||De>=fe.length)return!1;const Re=fe.codePointAt(De);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise(Re)}}function me(fe,De){if(De<0||De>=fe.length)return!1;switch(fe.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function Le(fe,De,Re){return De[fe]!==Re[fe]}function We(fe,De,Re,He,be,Ke,V=!1){for(;De<Re&&be<Ke;)fe[De]===He[be]&&(V&&(j[De]=be),De+=1),be+=1;return De===Re}e.isPatternInWord=We;var Fe;(function(fe){fe[fe.Diag=1]="Diag",fe[fe.Left=2]="Left",fe[fe.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var ze;(function(fe){fe.Default=[-100,0];function De(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}fe.isDefault=De})(ze=e.FuzzyScore||(e.FuzzyScore={}));function W(fe,De,Re,He,be,Ke,V){const Z=fe.length>he?he:fe.length,ge=He.length>he?he:He.length;if(!(Re>=Z||Ke>=ge||Z-Re>ge-Ke)&&!!We(De,Re,Z,be,Ke,ge,!0)){q(Z,ge,Re,Ke,De,be);let Ne=1,Ve=1,xe=Re,Xe=Ke;const ye=[!1];for(Ne=1,xe=Re;xe<Z;Ne++,xe++){const N=j[xe],Q=H[xe],oe=xe+1<Z?H[xe+1]:ge;for(Ve=N-Ke+1,Xe=N;Xe<oe;Ve++,Xe++){let ke=Number.MIN_SAFE_INTEGER,Ie=!1;Xe<=Q&&(ke=ee(fe,De,xe,Re,He,be,Xe,ge,Ke,R[Ne-1][Ve-1]===0,ye));let Ae=0;ke!==Number.MAX_SAFE_INTEGER&&(Ie=!0,Ae=ke+L[Ne-1][Ve-1]);const Be=Xe>N,Ye=Be?L[Ne][Ve-1]+(R[Ne][Ve-1]>0?-5:0):0,rt=Xe>N+1&&R[Ne][Ve-1]>0,tt=rt?L[Ne][Ve-2]+(R[Ne][Ve-2]>0?-5:0):0;if(rt&&(!Be||tt>=Ye)&&(!Ie||tt>=Ae))L[Ne][Ve]=tt,M[Ne][Ve]=3,R[Ne][Ve]=0;else if(Be&&(!Ie||Ye>=Ae))L[Ne][Ve]=Ye,M[Ne][Ve]=2,R[Ne][Ve]=0;else if(Ie)L[Ne][Ve]=Ae,M[Ne][Ve]=1,R[Ne][Ve]=R[Ne-1][Ve-1]+1;else throw new Error("not possible")}}if($&&J(fe,Re,He,Ke),!(!ye[0]&&!V)){Ne--,Ve--;const Ee=[L[Ne][Ve],Ke];let Ce=0,ie=0;for(;Ne>=1;){let N=Ve;do{const Q=M[Ne][N];if(Q===3)N=N-2;else if(Q===2)N=N-1;else break}while(N>=1);Ce>1&&De[Re+Ne-1]===be[Ke+Ve-1]&&!Le(N+Ke-1,He,be)&&Ce+1>R[Ne][N]&&(N=Ve),N===Ve?Ce++:Ce=1,ie||(ie=N),Ne--,Ve=N-1,Ee.push(Ve)}ge===Z&&(Ee[0]+=2);const ae=ie-Z;return Ee[0]-=ae,Ee}}}e.fuzzyScore=W;function q(fe,De,Re,He,be,Ke){let V=fe-1,Z=De-1;for(;V>=Re&&Z>=He;)be[V]===Ke[Z]&&(H[V]=Z,V--),Z--}function ee(fe,De,Re,He,be,Ke,V,Z,ge,Ne,Ve){if(De[Re]!==Ke[V])return Number.MIN_SAFE_INTEGER;let xe=1,Xe=!1;return V===Re-He?xe=fe[Re]===be[V]?7:5:Le(V,be,Ke)&&(V===0||!Le(V-1,be,Ke))?(xe=fe[Re]===be[V]?7:5,Xe=!0):te(Ke,V)&&(V===0||!te(Ke,V-1))?xe=5:(te(Ke,V-1)||me(Ke,V-1))&&(xe=5,Xe=!0),xe>1&&Re===He&&(Ve[0]=!0),Xe||(Xe=Le(V,be,Ke)||te(Ke,V-1)||me(Ke,V-1)),Re===He?V>ge&&(xe-=Xe?3:5):Ne?xe+=Xe?2:0:xe+=Xe?0:1,V+1===Z&&(xe-=Xe?3:5),xe}function se(fe,De,Re,He,be,Ke,V){return _e(fe,De,Re,He,be,Ke,!0,V)}e.fuzzyScoreGracefulAggressive=se;function ce(fe,De,Re,He,be,Ke,V){return _e(fe,De,Re,He,be,Ke,!1,V)}e.fuzzyScoreGraceful=ce;function _e(fe,De,Re,He,be,Ke,V,Z){let ge=W(fe,De,Re,He,be,Ke,Z);if(ge&&!V)return ge;if(fe.length>=3){const Ne=Math.min(7,fe.length-1);for(let Ve=Re+1;Ve<Ne;Ve++){const xe=$e(fe,Ve);if(xe){const Xe=W(xe,xe.toLowerCase(),Re,He,be,Ke,Z);Xe&&(Xe[0]-=3,(!ge||Xe[0]>ge[0])&&(ge=Xe))}}}return ge}function $e(fe,De){if(!(De+1>=fe.length)){const Re=fe[De],He=fe[De+1];if(Re!==He)return fe.slice(0,De)+He+Re+fe.slice(De+2)}}}),define(ve[112],we([0,1,36,111,8]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${A.source}`,"g");function C(o){return o.replace(y,(p,m)=>m?p:`\\${p}`)}e.escapeIcons=C;const S=new RegExp(`\\\\${A.source}`,"g");function k(o){return o.replace(S,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=k;const i=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function P(o){return o.indexOf(e.iconStartMarker)===-1?o:o.replace(i,(p,m,E,l)=>E?p:m||l||"")}e.stripIcons=P;function h(o){const p=o.indexOf(e.iconStartMarker);return p===-1?{text:o}:g(o,p)}e.parseLabelWithIcons=h;function g(o,p){const m=[];let E="";function l(w){if(w){E+=w;for(const b of w)m.push(t)}}let c=-1,d="",t=0,n,a,s=p;const u=o.length;for(l(o.substr(0,p));s<u;)n=o[s],a=o[s+1],n===e.iconStartMarker[0]&&a===e.iconStartMarker[1]?(c=s,l(d),d=e.iconStartMarker,s++):n===")"&&c!==-1?(t+=s-c+1,c=-1,d=""):c!==-1?/^[a-z0-9\-]$/i.test(n)?d+=n:(l(d),c=-1,d=""):l(n),s++;return l(d),{text:E,iconOffsets:m}}function r(o,p,m=!1){const{text:E,iconOffsets:l}=p;if(!l||l.length===0)return(0,T.matchesFuzzy)(o,E,m);const c=(0,D.ltrim)(E," "),d=E.length-c.length,t=(0,T.matchesFuzzy)(o,c,m);if(t)for(const n of t){const a=l[n.start+d]+d;n.start+=a,n.end+=a}return t}e.matchesFuzzyIconAware=r}),define(ve[84],we([0,1,13,112,12]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(o="",p=!1){var m,E;if(this.value=o,typeof this.value!="string")throw(0,D.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1):(this.isTrusted=(m=p.isTrusted)!==null&&m!==void 0?m:void 0,this.supportThemeIcons=(E=p.supportThemeIcons)!==null&&E!==void 0?E:!1)}appendText(o,p=0){return this.value+=P(this.supportThemeIcons?(0,T.escapeIcons)(o):o).replace(/([ \t]+)/g,(m,E)=>"&nbsp;".repeat(E.length)).replace(/^>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,p){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}}e.MarkdownString=y;function C(r){return S(r)?!r.value:Array.isArray(r)?r.every(C):!0}e.isEmptyMarkdownString=C;function S(r){return r instanceof y?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=S;function k(r,o){return!r&&!o?!0:!r||!o?!1:Array.isArray(r)&&Array.isArray(o)?(0,v.equals)(r,o,i):S(r)&&S(o)?i(r,o):!1}e.markedStringsEquals=k;function i(r,o){return r===o?!0:!r||!o?!1:r.value===o.value&&r.isTrusted===o.isTrusted&&r.supportThemeIcons===o.supportThemeIcons}function P(r){return r.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function h(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=h;function g(r){const o=[],p=r.split("|").map(E=>E.trim());r=p[0];const m=p[1];if(m){const E=/height=(\d+)/.exec(m),l=/width=(\d+)/.exec(m),c=E?E[1]:"",d=l?l[1]:"",t=isFinite(parseInt(d)),n=isFinite(parseInt(c));t&&o.push(`width="${d}"`),n&&o.push(`height="${c}"`)}return{href:r,dimensions:o}}e.parseHrefAndDimensions=g}),define(ve[57],we([0,1,24,8,2]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(k){return JSON.stringify(k,C)}e.stringify=A;function y(k){let i=JSON.parse(k);return i=S(i),i}e.parse=y;function C(k,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:(0,T.regExpFlags)(i)}:i}function S(k,i=0){if(!k||i>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return D.URI.revive(k);case 2:return new RegExp(k.source,k.flags)}if(k instanceof v.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let P=0;P<k.length;++P)k[P]=S(k[P],i+1);else for(const P in k)Object.hasOwnProperty.call(k,P)&&(k[P]=S(k[P],i+1))}return k}e.revive=S}),define(ve[19],we([0,1,2,21]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,k,i){this._hosts[S]=k,this._ports[S]=i}setConnectionToken(S,k){this._connectionTokens[S]=k}rewrite(S){if(this._delegate)return this._delegate(S);const k=S.authority;let i=this._hosts[k];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const P=this._ports[k],h=this._connectionTokens[k];let g=`path=${encodeURIComponent(S.path)}`;return typeof h=="string"&&(g+=`&tkn=${encodeURIComponent(h)}`),v.URI.from({scheme:T.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${i}:${P}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new A;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(S,k,i){const P=this.toUri(S,k);return P.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(P):T.isNative&&(i||T.isPreferringBrowserCodeLoad)&&P.scheme===D.file?P.with({scheme:D.vscodeFileResource,authority:P.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(S,k){const i=this.toUri(S,k);return i.scheme===D.vscodeFileResource?i.with({scheme:D.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(S,k){return v.URI.isUri(S)?S:v.URI.parse(k.toUrl(S))}}e.FileAccess=new y}),define(ve[25],we([0,1,37,14,2,8,19,21]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(g){return(0,D.uriToFsPath)(g,!0)}e.originalFSPath=S;class k{constructor(r){this._ignorePathCasing=r}compare(r,o,p=!1){return r===o?0:(0,A.compare)(this.getComparisonKey(r,p),this.getComparisonKey(o,p))}isEqual(r,o,p=!1){return r===o?!0:!r||!o?!1:this.getComparisonKey(r,p)===this.getComparisonKey(o,p)}getComparisonKey(r,o=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,o,p=!1){if(r.scheme===o.scheme){if(r.scheme===y.Schemas.file)return v.isEqualOrParent(S(r),S(o),this._ignorePathCasing(r))&&r.query===o.query&&(p||r.fragment===o.fragment);if((0,e.isEqualAuthority)(r.authority,o.authority))return v.isEqualOrParent(r.path,o.path,this._ignorePathCasing(r),"/")&&r.query===o.query&&(p||r.fragment===o.fragment)}return!1}joinPath(r,...o){return D.URI.joinPath(r,...o)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return T.posix.basename(r.path)}extname(r){return T.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let o;return r.scheme===y.Schemas.file?o=D.URI.file(T.dirname(S(r))).path:(o=T.posix.dirname(r.path),r.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),o="/")),r.with({path:o})}normalizePath(r){if(!r.path.length)return r;let o;return r.scheme===y.Schemas.file?o=D.URI.file(T.normalize(S(r))).path:o=T.posix.normalize(r.path),r.with({path:o})}relativePath(r,o){if(!(r.scheme!==o.scheme||!(0,e.isEqualAuthority)(r.authority,o.authority))){if(r.scheme===y.Schemas.file){const E=T.relative(S(r),S(o));return C.isWindows?v.toSlashes(E):E}let p=r.path||"/",m=o.path||"/";if(this._ignorePathCasing(r)){let E=0;for(const l=Math.min(p.length,m.length);E<l&&!(p.charCodeAt(E)!==m.charCodeAt(E)&&p.charAt(E).toLowerCase()!==m.charAt(E).toLowerCase());E++);p=m.substr(0,E)+p.substr(E)}return T.posix.relative(p,m)}}resolvePath(r,o){if(r.scheme===y.Schemas.file){const p=D.URI.file(T.resolve(S(r),o));return r.with({authority:p.authority,path:p.path})}return o.indexOf("/")===-1&&(o=v.toSlashes(o),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o)),r.with({path:T.posix.resolve(r.path,o)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,o){return r===o||(0,A.equalsIgnoreCase)(r,o)}hasTrailingPathSeparator(r,o=T.sep){if(r.scheme===y.Schemas.file){const p=S(r);return p.length>v.getRoot(p).length&&p[p.length-1]===o}else{const p=r.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,o=T.sep){return(0,e.hasTrailingPathSeparator)(r,o)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,o=T.sep){let p=!1;if(r.scheme===y.Schemas.file){const m=S(r);p=m!==void 0&&m.length===v.getRoot(m).length&&m[m.length-1]===o}else{o="/";const m=r.path;p=m.length===1&&m.charCodeAt(m.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(r,o)?r.with({path:r.path+"/"}):r}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(g=>g.scheme===y.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new k(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(g,r){const o=[];for(let p=0;p<g.length;p++){const m=r(g[p]);g.some((E,l)=>l===p?!1:(0,e.isEqualOrParent)(m,r(E)))||o.push(g[p])}return o}e.distinctParents=i;var P;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function r(o){const p=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(l=>{const[c,d]=l.split(":");c&&d&&p.set(c,d)});const E=o.path.substring(0,o.path.indexOf(";"));return E&&p.set(g.META_DATA_MIME,E),p}g.parseMetaData=r})(P=e.DataUri||(e.DataUri={}));function h(g,r,o){if(r){let p=g.path;return p&&p[0]!==T.posix.sep&&(p=T.posix.sep+p),g.with({scheme:o,authority:r,path:p})}return g.with({scheme:o})}e.toLocalResource=h}),define(ve[11],we([0,1,20,12,3,6,45,25]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(L){return!!L&&typeof L.then=="function"}e.isThenable=S;function k(L){const M=new v.CancellationTokenSource,$=L(M.token),G=new Promise((J,te)=>{M.token.onCancellationRequested(()=>{te((0,T.canceled)())}),Promise.resolve($).then(me=>{M.dispose(),J(me)},me=>{M.dispose(),te(me)})});return new class{cancel(){M.cancel()}then(J,te){return G.then(J,te)}catch(J){return this.then(void 0,J)}finally(J){return G.finally(J)}}}e.createCancelablePromise=k;function i(L,M,$){return Promise.race([L,new Promise(G=>M.onCancellationRequested(()=>G($)))])}e.raceCancellation=i;async function P(L){let M=-1;const $=L.map((J,te)=>J.then(me=>(M=te,me))),G=await Promise.race($);return L.forEach((J,te)=>{te!==M&&J.cancel()}),G}e.raceCancellablePromises=P;function h(L,M,$){let G;const J=setTimeout(()=>{G==null||G(void 0),$==null||$()},M);return Promise.race([L.finally(()=>clearTimeout(J)),new Promise(te=>G=te)])}e.raceTimeout=h;function g(L){return new Promise((M,$)=>{const G=L();S(G)?G.then(M,$):M(G)})}e.asPromise=g;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const $=()=>{this.queuedPromise=null;const G=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,G};this.queuedPromise=new Promise(G=>{this.activePromise.then($,$).then(G)})}return new Promise(($,G)=>{this.queuedPromise.then($,G)})}return this.activePromise=M(),new Promise(($,G)=>{this.activePromise.then(J=>{this.activePromise=null,$(J)},J=>{this.activePromise=null,G(J)})})}}e.Throttler=r;class o{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=o;class p{constructor(){this.promiseMap=new Map}queue(M,$){var G;const te=((G=this.promiseMap.get(M))!==null&&G!==void 0?G:Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.promiseMap.get(M)===te&&this.promiseMap.delete(M)});return this.promiseMap.set(M,te),te}}e.SequencerByKey=p;class m{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,$=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((G,J)=>{this.doResolve=G,this.doReject=J}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const G=this.task;return this.task=null,G()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},$),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,T.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=m;class E{constructor(M){this.delayer=new m(M),this.throttler=new r}trigger(M,$){return this.delayer.trigger(()=>this.throttler.queue(M),$)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class l{constructor(){this._isOpen=!1,this._promise=new Promise((M,$)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class c extends l{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function d(L,M){return M?new Promise(($,G)=>{const J=setTimeout($,L);M.onCancellationRequested(()=>{clearTimeout(J),G((0,T.canceled)())})}):k($=>d(L,$))}e.timeout=d;function t(L,M=0){const $=setTimeout(L,M);return(0,A.toDisposable)(()=>clearTimeout($))}e.disposableTimeout=t;function n(L){return L.then(void 0,M=>{})}e.ignoreErrors=n;function a(L){const M=[];let $=0;const G=L.length;function J(){return $<G?L[$++]():null}function te(me){me!=null&&M.push(me);const Le=J();return Le?Le.then(te):Promise.resolve(M)}return Promise.resolve(null).then(te)}e.sequence=a;function s(L,M=G=>!!G,$=null){let G=0;const J=L.length,te=()=>{if(G>=J)return Promise.resolve($);const me=L[G++];return Promise.resolve(me()).then(We=>M(We)?Promise.resolve(We):te())};return te()}e.first=s;function u(L,M=G=>!!G,$=null){if(L.length===0)return Promise.resolve($);let G=L.length;const J=()=>{var te,me;G=-1;for(const Le of L)(me=(te=Le).cancel)===null||me===void 0||me.call(te)};return new Promise((te,me)=>{for(const Le of L)Le.then(We=>{--G>=0&&M(We)?(J(),te(We)):G===0&&te($)}).catch(We=>{--G>=0&&(J(),me(We))})})}e.firstParallel=u;class w{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise(($,G)=>{this.outstandingPromises.push({factory:M,c:$,e:G}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const $=M.factory();$.then(M.c,M.e),$.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=w;class b extends w{constructor(){super(1)}}e.Queue=b;class I{constructor(){this.queues=new Map}queueFor(M,$=C.extUri){const G=$.getComparisonKey(M);let J=this.queues.get(G);return J||(J=new b,D.Event.once(J.onFinished)(()=>{J==null||J.dispose(),this.queues.delete(G)}),this.queues.set(G,J)),J}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=I;class f{constructor(M,$){this._token=-1,typeof M=="function"&&typeof $=="number"&&this.setIfNotSet(M,$)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,$){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},$)}setIfNotSet(M,$){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},$))}}e.TimeoutTimer=f;class _{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,$){this.cancel(),this._token=setInterval(()=>{M()},$)}}e.IntervalTimer=_;class F{constructor(M,$){this.timeoutToken=-1,this.runner=M,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class U extends F{constructor(M,$){super(M,$);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const L=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const $=setTimeout(()=>M(L));let G=!1;return{dispose(){G||(G=!0,clearTimeout($))}}}}else e.runWhenIdle=(L,M)=>{const $=requestIdleCallback(L,typeof M=="number"?{timeout:M}:void 0);let G=!1;return{dispose(){G||(G=!0,cancelIdleCallback($))}}}}();class z{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch($){this._error=$}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=z;async function he(L,M,$){let G;for(let J=0;J<$;J++)try{return await L()}catch(te){G=te,await d(M)}throw G}e.retry=he;class de{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var M;(M=this._pending)===null||M===void 0||M.cancel()}setPending(M,$,G){return this._pending={taskId:M,cancel:()=>G==null?void 0:G(),promise:$},$.then(()=>this.donePending(M),()=>this.donePending(M)),$}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let $,G;const J=new Promise((te,me)=>{$=te,G=me});this._next={run:M,promise:J,promiseResolve:$,promiseReject:G}}return this._next.promise}}e.TaskSequentializer=de;class x{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class j{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,$)=>{this.completeCallback=M,this.errorCallback=$})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise($=>{this.completeCallback(M),this.resolved=!0,$()})}error(M){return new Promise($=>{this.errorCallback(M),this.rejected=!0,$()})}cancel(){new Promise(M=>{this.errorCallback((0,T.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=j;class H extends D.Emitter{async fireAsync(M,$,G){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const J of this._listeners)this._asyncDeliveryQueue.push([J,M]);for(;this._asyncDeliveryQueue.size>0&&!$.isCancellationRequested;){const[J,te]=this._asyncDeliveryQueue.shift(),me=[],Le=Object.assign(Object.assign({},te),{waitUntil:We=>{if(Object.isFrozen(me))throw new Error("waitUntil can NOT be called asynchronous");G&&(We=G(We,typeof J=="function"?J:J[0])),me.push(We)}});try{typeof J=="function"?J.call(void 0,Le):J[0].call(J[1],Le)}catch(We){(0,T.onUnexpectedError)(We);continue}Object.freeze(me),await R.settled(me).catch(We=>(0,T.onUnexpectedError)(We))}}}}e.AsyncEmitter=H;var R;(function(L){async function M(te){return typeof Promise.allSettled=="function"?$(te):G(te)}L.allSettled=M;async function $(te){return Promise.allSettled(te)}async function G(te){return Promise.all(te.map(me=>me.then(Le=>({status:"fulfilled",value:Le}),Le=>({status:"rejected",reason:Le}))))}async function J(te){let me;const Le=await Promise.all(te.map(We=>We.then(Fe=>Fe,Fe=>{me||(me=Fe)})));if(typeof me!="undefined")throw me;return Le}L.settled=J})(R=e.Promises||(e.Promises={}))}),define(ve[113],we([0,1,14,11]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new T.IdleValue(()=>{const f=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:f,collatorIsNumeric:f.resolvedOptions().numeric}}),A=new T.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new T.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(f,_,F=!1){const U=f||"",z=_||"",he=D.value.collator.compare(U,z);return D.value.collatorIsNumeric&&he===0&&U!==z?U<z?-1:1:he}e.compareFileNames=C;function S(f,_){const F=A.value.collator;return f=f||"",_=_||"",d(F,f,_)}e.compareFileNamesDefault=S;function k(f,_){const F=A.value.collator;return f=f||"",_=_||"",s(f,_)||d(F,f,_)}e.compareFileNamesUpper=k;function i(f,_){const F=A.value.collator;return f=f||"",_=_||"",a(f,_)||d(F,f,_)}e.compareFileNamesLower=i;function P(f,_){return f=f||"",_=_||"",f===_?0:f<_?-1:1}e.compareFileNamesUnicode=P;function h(f,_,F=!1){F||(f=f&&f.toLowerCase(),_=_&&_.toLowerCase());const[U,z]=l(f),[he,de]=l(_);return U!==he?U<he?-1:1:z===de?0:z<de?-1:1}e.noIntlCompareFileNames=h;function g(f,_){const[F,U]=l(f),[z,he]=l(_);let de=D.value.collator.compare(U,he);if(de===0){if(D.value.collatorIsNumeric&&U!==he)return U<he?-1:1;if(de=D.value.collator.compare(F,z),D.value.collatorIsNumeric&&de===0&&F!==z)return F<z?-1:1}return de}e.compareFileExtensions=g;function r(f,_){f=f||"",_=_||"";const F=c(f),U=c(_),z=A.value.collator,he=y.value.collator;return d(he,F,U)||d(z,f,_)}e.compareFileExtensionsDefault=r;function o(f,_){f=f||"",_=_||"";const F=c(f),U=c(_),z=A.value.collator,he=y.value.collator;return d(he,F,U)||s(f,_)||d(z,f,_)}e.compareFileExtensionsUpper=o;function p(f,_){f=f||"",_=_||"";const F=c(f),U=c(_),z=A.value.collator,he=y.value.collator;return d(he,F,U)||a(f,_)||d(z,f,_)}e.compareFileExtensionsLower=p;function m(f,_){f=f||"",_=_||"";const F=c(f).toLowerCase(),U=c(_).toLowerCase();return F!==U?F<U?-1:1:f!==_?f<_?-1:1:0}e.compareFileExtensionsUnicode=m;const E=/^(.*?)(\.([^.]*))?$/;function l(f,_=!1){const F=f?E.exec(f):[];let U=[F&&F[1]||"",F&&F[3]||""];return _&&(!U[0]&&U[1]||U[0]&&U[0].charAt(0)===".")&&(U=[U[0]+"."+U[1],""]),U}function c(f){const _=f?E.exec(f):[];return _&&_[1]&&_[1].charAt(0)!=="."&&_[3]||""}function d(f,_,F){let U=f.compare(_,F);return U!==0?U:_.length!==F.length?_.length<F.length?-1:1:0}function t(f){const _=f.charAt(0);return _.toLocaleUpperCase()!==_}function n(f){const _=f.charAt(0);return _.toLocaleLowerCase()!==_}function a(f,_){return t(f)&&n(_)?-1:n(f)&&t(_)?1:0}function s(f,_){return n(f)&&t(_)?-1:t(f)&&n(_)?1:0}function u(f,_,F=!1){return F||(f=f&&f.toLowerCase(),_=_&&_.toLowerCase()),f===_?0:f<_?-1:1}function w(f,_,F=!1){const U=f.split(v.sep),z=_.split(v.sep),he=U.length-1,de=z.length-1;let x,j;for(let H=0;;H++){if(x=he===H,j=de===H,x&&j)return C(U[H],z[H],F);if(x)return-1;if(j)return 1;const R=u(U[H],z[H],F);if(R!==0)return R}}e.comparePaths=w;function b(f,_,F){const U=f.toLowerCase(),z=_.toLowerCase(),he=I(f,_,F);if(he)return he;const de=U.endsWith(F),x=z.endsWith(F);if(de!==x)return de?-1:1;const j=C(U,z);return j!==0?j:U.localeCompare(z)}e.compareAnything=b;function I(f,_,F){const U=f.toLowerCase(),z=_.toLowerCase(),he=U.startsWith(F),de=z.startsWith(F);if(he!==de)return he?-1:1;if(he&&de){if(U.length<z.length)return-1;if(U.length>z.length)return 1}return 0}e.compareByPrefix=I}),define(ve[28],we([0,1,8,37,14,22,11]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const S="**",k="/",i="[/\\\\]",P="[^/\\\\]",h=/\//g;function g($){switch($){case 0:return"";case 1:return`${P}*?`;default:return`(?:${i}|${P}+${i}|${i}${P}+)*?`}}function r($,G){if(!$)return[];const J=[];let te=!1,me=!1,Le="";for(const We of $){switch(We){case G:if(!te&&!me){J.push(Le),Le="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":me=!0;break;case"]":me=!1;break}Le+=We}return Le&&J.push(Le),J}e.splitGlobAware=r;function o($){if(!$)return"";let G="";const J=r($,k);if(J.every(te=>te===S))G=".*";else{let te=!1;J.forEach((me,Le)=>{if(me===S){te||(G+=g(2),te=!0);return}let We=!1,Fe="",ze=!1,W="";for(const q of me){if(q!=="}"&&We){Fe+=q;continue}if(ze&&(q!=="]"||!W)){let ee;q==="-"?ee=q:(q==="^"||q==="!")&&!W?ee="^":q===k?ee="":ee=v.escapeRegExpCharacters(q),W+=ee;continue}switch(q){case"{":We=!0;continue;case"[":ze=!0;continue;case"}":G+=`(?:${r(Fe,",").map(ce=>o(ce)).join("|")})`,We=!1,Fe="";break;case"]":G+="["+W+"]",ze=!1,W="";break;case"?":G+=P;continue;case"*":G+=g(1);continue;default:G+=v.escapeRegExpCharacters(q)}}Le<J.length-1&&(J[Le+1]!==S||Le+2<J.length)&&(G+=i),te=!1})}return G}const p=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),n=function(){return!1},a=function(){return null};function s($,G){if(!$)return a;let J;typeof $!="string"?J=$.pattern:J=$,J=J.trim();const te=`${J}_${!!G.trimForExclusions}`;let me=t.get(te);if(me)return u(me,$);let Le;if(p.test(J)){const We=J.substr(4);me=function(Fe,ze){return typeof Fe=="string"&&Fe.endsWith(We)?J:null}}else(Le=m.exec(w(J,G)))?me=b(Le[1],J):(G.trimForExclusions?l:E).test(J)?me=I(J,G):(Le=c.exec(w(J,G)))?me=f(Le[1].substr(1),J,!0):(Le=d.exec(w(J,G)))?me=f(Le[1],J,!1):me=_(J);return t.set(te,me),u(me,$)}function u($,G){return typeof G=="string"?$:function(J,te){return T.isEqualOrParent(J,G.base)?$(D.relative(G.base,J),te):null}}function w($,G){return G.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function b($,G){const J=`/${$}`,te=`\\${$}`,me=function(We,Fe){return typeof We!="string"?null:Fe?Fe===$?G:null:We===$||We.endsWith(J)||We.endsWith(te)?G:null},Le=[$];return me.basenames=Le,me.patterns=[G],me.allBasenames=Le,me}function I($,G){const J=M($.slice(1,-1).split(",").map(Fe=>s(Fe,G)).filter(Fe=>Fe!==a),$),te=J.length;if(!te)return a;if(te===1)return J[0];const me=function(Fe,ze){for(let W=0,q=J.length;W<q;W++)if(J[W](Fe,ze))return $;return null},Le=J.find(Fe=>!!Fe.allBasenames);Le&&(me.allBasenames=Le.allBasenames);const We=J.reduce((Fe,ze)=>ze.allPaths?Fe.concat(ze.allPaths):Fe,[]);return We.length&&(me.allPaths=We),me}function f($,G,J){const te=D.sep===D.posix.sep,me=te?$:$.replace(h,D.sep),Le=D.sep+me,We=D.posix.sep+$,Fe=J?function(ze,W){return typeof ze=="string"&&(ze===me||ze.endsWith(Le)||!te&&(ze===$||ze.endsWith(We)))?G:null}:function(ze,W){return typeof ze=="string"&&(ze===me||!te&&ze===$)?G:null};return Fe.allPaths=[(J?"*/":"./")+$],Fe}function _($){try{const G=new RegExp(`^${o($)}$`);return function(J){return G.lastIndex=0,typeof J=="string"&&G.test(J)?$:null}}catch(G){return a}}function F($,G,J){return!$||typeof G!="string"?!1:U($)(G,void 0,J)}e.match=F;function U($,G={}){if(!$)return n;if(typeof $=="string"||x($)){const J=s($,G);if(J===a)return n;const te=function(me,Le){return!!J(me,Le)};return J.allBasenames&&(te.allBasenames=J.allBasenames),J.allPaths&&(te.allPaths=J.allPaths),te}return R($,G)}e.parse=U;function z($){if(!!$){let G;return J=>(G||(G=($()||Promise.resolve([])).then(te=>te?de(te):{})),G.then(te=>!!te[J]))}}e.hasSiblingPromiseFn=z;function he($){if(!!$){let G;return J=>{if(!G){const te=$();G=te?de(te):{}}return!!G[J]}}}e.hasSiblingFn=he;function de($){const G={};for(const J of $)G[J]=!0;return G}function x($){const G=$;return G&&typeof G.base=="string"&&typeof G.pattern=="string"}e.isRelativePattern=x;function j($){return $.allBasenames||[]}e.getBasenameTerms=j;function H($){return $.allPaths||[]}e.getPathTerms=H;function R($,G){const J=M(Object.getOwnPropertyNames($).map(Fe=>L(Fe,$[Fe],G)).filter(Fe=>Fe!==a)),te=J.length;if(!te)return a;if(!J.some(Fe=>!!Fe.requiresSiblings)){if(te===1)return J[0];const Fe=function(q,ee){for(let se=0,ce=J.length;se<ce;se++){const _e=J[se](q,ee);if(_e)return _e}return null},ze=J.find(q=>!!q.allBasenames);ze&&(Fe.allBasenames=ze.allBasenames);const W=J.reduce((q,ee)=>ee.allPaths?q.concat(ee.allPaths):q,[]);return W.length&&(Fe.allPaths=W),Fe}const me=function(Fe,ze,W){let q;for(let ee=0,se=J.length;ee<se;ee++){const ce=J[ee];ce.requiresSiblings&&W&&(ze||(ze=D.basename(Fe)),q||(q=ze.substr(0,ze.length-D.extname(Fe).length)));const _e=ce(Fe,ze,q,W);if(_e)return _e}return null},Le=J.find(Fe=>!!Fe.allBasenames);Le&&(me.allBasenames=Le.allBasenames);const We=J.reduce((Fe,ze)=>ze.allPaths?Fe.concat(ze.allPaths):Fe,[]);return We.length&&(me.allPaths=We),me}function L($,G,J){if(G===!1)return a;const te=s($,J);if(te===a)return a;if(typeof G=="boolean")return te;if(G){const me=G.when;if(typeof me=="string"){const Le=(We,Fe,ze,W)=>{if(!W||!te(We,Fe))return null;const q=me.replace("$(basename)",ze),ee=W(q);return(0,y.isThenable)(ee)?ee.then(se=>se?$:null):ee?$:null};return Le.requiresSiblings=!0,Le}}return te}function M($,G){const J=$.filter(Fe=>!!Fe.basenames);if(J.length<2)return $;const te=J.reduce((Fe,ze)=>{const W=ze.basenames;return W?Fe.concat(W):Fe},[]);let me;if(G){me=[];for(let Fe=0,ze=te.length;Fe<ze;Fe++)me.push(G)}else me=J.reduce((Fe,ze)=>{const W=ze.patterns;return W?Fe.concat(W):Fe},[]);const Le=function(Fe,ze){if(typeof Fe!="string")return null;if(!ze){let q;for(q=Fe.length;q>0;q--){const ee=Fe.charCodeAt(q-1);if(ee===47||ee===92)break}ze=Fe.substr(q)}const W=te.indexOf(ze);return W!==-1?me[W]:null};Le.basenames=te,Le.patterns=me,Le.allBasenames=te;const We=$.filter(Fe=>!Fe.basenames);return We.push(Le),We}}),define(ve[58],we([0,1,2,14,8,19,21,25,37]),function(Y,e,v,T,D,A,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(s,u,w){if(typeof s=="string"&&(s=v.URI.file(s)),w){const I=w.getWorkspaceFolder(s);if(I){const f=w.getWorkspace().folders.length>1;let _;if((0,C.isEqual)(I.uri,s)?_="":_=(0,C.relativePath)(I.uri,s),f){const F=I.name?I.name:(0,C.basename)(I.uri);_=_?F+" \u2022 "+_:F}return _}}if(s.scheme!==A.Schemas.file&&s.scheme!==A.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,S.hasDriveLetter)(s.fsPath))return(0,T.normalize)(P(s.fsPath));let b=(0,T.normalize)(s.fsPath);return!y.isWindows&&(u==null?void 0:u.userHome)&&(b=g(b,u.userHome.fsPath)),b}e.getPathLabel=k;function i(s){if(!!s){typeof s=="string"&&(s=v.URI.file(s));const u=(0,C.basename)(s)||(s.scheme===A.Schemas.file?s.fsPath:s.path);return y.isWindows&&(0,S.isRootOrDriveLetter)(u)?P(u):u}}e.getBaseLabel=i;function P(s){return(0,S.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=P;let h=Object.create(null);function g(s,u){if(y.isWindows||!s||!u)return s;let w=h.original===u?h.normalized:void 0;return w||(w=`${(0,D.rtrim)(u,T.posix.sep)}${T.posix.sep}`,h={original:u,normalized:w}),(y.isLinux?s.startsWith(w):(0,D.startsWithIgnoreCase)(s,w))&&(s=`~/${s.substr(w.length)}`),s}e.tildify=g;function r(s,u){return s.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=r;const o="\u2026",p="\\\\",m="~";function E(s,u=T.sep){const w=new Array(s.length);let b=!1;for(let I=0;I<s.length;I++){let f=s[I];if(f===""){w[I]=`.${u}`;continue}if(!f){w[I]=f;continue}b=!0;let _="";f.indexOf(p)===0?(_=f.substr(0,f.indexOf(p)+p.length),f=f.substr(f.indexOf(p)+p.length)):f.indexOf(u)===0?(_=f.substr(0,f.indexOf(u)+u.length),f=f.substr(f.indexOf(u)+u.length)):f.indexOf(m)===0&&(_=f.substr(0,f.indexOf(m)+m.length),f=f.substr(f.indexOf(m)+m.length));const F=f.split(u);for(let U=1;b&&U<=F.length;U++)for(let z=F.length-U;b&&z>=0;z--){b=!1;let he=F.slice(z,z+U).join(u);for(let de=0;!b&&de<s.length;de++)if(de!==I&&s[de]&&s[de].indexOf(he)>-1){const x=z+U===F.length,j=z>0&&s[de].indexOf(u)>-1?u+he:he,H=s[de].endsWith(j);b=!x||H}if(!b){let de="";(F[0].endsWith(":")||_!=="")&&(z===1&&(z=0,U++,he=F[0]+u+he),z>0&&(de=F[0]+u),de=_+de),z>0&&(de=de+o+u),de=de+he,z+U<F.length&&(de=de+u+o),w[I]=de}}b&&(w[I]=f)}return w}e.shorten=E;var l;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function c(s,u=Object.create(null)){const w=[];let b=!1,I="";for(const f of s)if(f==="$"||b&&f==="{")I&&w.push({value:I,type:l.TEXT}),I="",b=!0;else if(f==="}"&&b){const _=u[I];if(typeof _=="string")_.length&&w.push({value:_,type:l.VARIABLE});else if(_){const F=w[w.length-1];(!F||F.type!==l.SEPARATOR)&&w.push({value:_.label,type:l.SEPARATOR})}I="",b=!1}else I+=f;return I&&!b&&w.push({value:I,type:l.TEXT}),w.filter((f,_)=>{if(f.type===l.SEPARATOR){const F=w[_-1],U=w[_+1];return[F,U].every(z=>z&&(z.type===l.VARIABLE||z.type===l.TEXT)&&z.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=c;function d(s,u){return y.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):s.replace(/&&|&/g,w=>w==="&"?"&&":"&")}e.mnemonicMenuLabel=d;function t(s,u){return y.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,""):y.isWindows?s.replace(/&&|&/g,w=>w==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=n;function a(s){const u=s.indexOf("/")!==-1?T.posix:T.win32,w=u.basename(s),b=u.dirname(s);return w.length?{name:w,parentPath:b}:{name:b,parentPath:""}}e.splitName=a}),define(ve[114],we([0,1,2]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(i){return i.toJSON()}class D{constructor(P){this._uriTransformer=P}transformIncoming(P){const h=this._uriTransformer.transformIncoming(P);return h===P?P:T(v.URI.from(h))}transformOutgoing(P){const h=this._uriTransformer.transformOutgoing(P);return h===P?P:T(v.URI.from(h))}transformOutgoingURI(P){const h=this._uriTransformer.transformOutgoing(P);return h===P?P:v.URI.from(h)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function A(i,P,h){if(!i||h>200)return null;if(typeof i=="object"){if(i instanceof v.URI)return P.transformOutgoing(i);for(let g in i)if(Object.hasOwnProperty.call(i,g)){const r=A(i[g],P,h+1);r!==null&&(i[g]=r)}}return null}function y(i,P){const h=A(i,P,0);return h===null?i:h}e.transformOutgoingURIs=y;function C(i,P,h,g){if(!i||g>200)return null;if(typeof i=="object"){if(i.$mid===1)return h?v.URI.revive(P.transformIncoming(i)):P.transformIncoming(i);for(let r in i)if(Object.hasOwnProperty.call(i,r)){const o=C(i[r],P,h,g+1);o!==null&&(i[r]=o)}}return null}function S(i,P){const h=C(i,P,!1,0);return h===null?i:h}e.transformIncomingURIs=S;function k(i,P){const h=C(i,P,!0,0);return h===null?i:h}e.transformAndReviveIncomingURIs=k}),define(ve[31],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(S){return v.test(S)}e.isUUID=T;const D=new Uint8Array(16),A=[];for(let S=0;S<256;S++)A.push(S.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(S){for(let k=0;k<S.length;k++)S[k]=Math.floor(Math.random()*256);return S};function C(){y(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let S=0,k="";return k+=A[D[S++]],k+=A[D[S++]],k+=A[D[S++]],k+=A[D[S++]],k+="-",k+=A[D[S++]],k+=A[D[S++]],k+="-",k+=A[D[S++]],k+=A[D[S++]],k+="-",k+=A[D[S++]],k+=A[D[S++]],k+="-",k+=A[D[S++]],k+=A[D[S++]],k+=A[D[S++]],k+=A[D[S++]],k+=A[D[S++]],k+=A[D[S++]],k}e.generateUuid=C}),define(ve[85],we([0,1,83]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class T{constructor(C){let S=(0,v.toUint8)(C);this._defaultValue=S,this._asciiMap=T._createAsciiMap(S),this._map=new Map}static _createAsciiMap(C){let S=new Uint8Array(256);for(let k=0;k<256;k++)S[k]=C;return S}set(C,S){let k=(0,v.toUint8)(S);C>=0&&C<256?this._asciiMap[C]=k:this._map.set(C,k)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=T;var D;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(D||(D={}));class A{constructor(){this._actual=new T(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=A}),define(ve[115],we([0,1,85]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var T;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(T=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends v.CharacterClassifier{constructor(C){super(0);for(let S=0,k=C.length;S<k;S++)this.set(C.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function A(y){let C={};return S=>(C.hasOwnProperty(S)||(C[S]=y(S)),C[S])}e.getMapForWordSeparators=A(y=>new D(y))}),define(ve[38],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class v{constructor(D,A){this.lineNumber=D,this.column=A}with(D=this.lineNumber,A=this.column){return D===this.lineNumber&&A===this.column?this:new v(D,A)}delta(D=0,A=0){return this.with(this.lineNumber+D,this.column+A)}equals(D){return v.equals(this,D)}static equals(D,A){return!D&&!A?!0:!!D&&!!A&&D.lineNumber===A.lineNumber&&D.column===A.column}isBefore(D){return v.isBefore(this,D)}static isBefore(D,A){return D.lineNumber<A.lineNumber?!0:A.lineNumber<D.lineNumber?!1:D.column<A.column}isBeforeOrEqual(D){return v.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,A){return D.lineNumber<A.lineNumber?!0:A.lineNumber<D.lineNumber?!1:D.column<=A.column}static compare(D,A){let y=D.lineNumber|0,C=A.lineNumber|0;if(y===C){let S=D.column|0,k=A.column|0;return S-k}return y-C}clone(){return new v(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new v(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=v}),define(ve[32],we([0,1,38]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class T{constructor(A,y,C,S){A>C||A===C&&y>S?(this.startLineNumber=C,this.startColumn=S,this.endLineNumber=A,this.endColumn=y):(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=C,this.endColumn=S)}isEmpty(){return T.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return T.containsPosition(this,A)}static containsPosition(A,y){return!(y.lineNumber<A.startLineNumber||y.lineNumber>A.endLineNumber||y.lineNumber===A.startLineNumber&&y.column<A.startColumn||y.lineNumber===A.endLineNumber&&y.column>A.endColumn)}containsRange(A){return T.containsRange(this,A)}static containsRange(A,y){return!(y.startLineNumber<A.startLineNumber||y.endLineNumber<A.startLineNumber||y.startLineNumber>A.endLineNumber||y.endLineNumber>A.endLineNumber||y.startLineNumber===A.startLineNumber&&y.startColumn<A.startColumn||y.endLineNumber===A.endLineNumber&&y.endColumn>A.endColumn)}strictContainsRange(A){return T.strictContainsRange(this,A)}static strictContainsRange(A,y){return!(y.startLineNumber<A.startLineNumber||y.endLineNumber<A.startLineNumber||y.startLineNumber>A.endLineNumber||y.endLineNumber>A.endLineNumber||y.startLineNumber===A.startLineNumber&&y.startColumn<=A.startColumn||y.endLineNumber===A.endLineNumber&&y.endColumn>=A.endColumn)}plusRange(A){return T.plusRange(this,A)}static plusRange(A,y){let C,S,k,i;return y.startLineNumber<A.startLineNumber?(C=y.startLineNumber,S=y.startColumn):y.startLineNumber===A.startLineNumber?(C=y.startLineNumber,S=Math.min(y.startColumn,A.startColumn)):(C=A.startLineNumber,S=A.startColumn),y.endLineNumber>A.endLineNumber?(k=y.endLineNumber,i=y.endColumn):y.endLineNumber===A.endLineNumber?(k=y.endLineNumber,i=Math.max(y.endColumn,A.endColumn)):(k=A.endLineNumber,i=A.endColumn),new T(C,S,k,i)}intersectRanges(A){return T.intersectRanges(this,A)}static intersectRanges(A,y){let C=A.startLineNumber,S=A.startColumn,k=A.endLineNumber,i=A.endColumn,P=y.startLineNumber,h=y.startColumn,g=y.endLineNumber,r=y.endColumn;return C<P?(C=P,S=h):C===P&&(S=Math.max(S,h)),k>g?(k=g,i=r):k===g&&(i=Math.min(i,r)),C>k||C===k&&S>i?null:new T(C,S,k,i)}equalsRange(A){return T.equalsRange(this,A)}static equalsRange(A,y){return!!A&&!!y&&A.startLineNumber===y.startLineNumber&&A.startColumn===y.startColumn&&A.endLineNumber===y.endLineNumber&&A.endColumn===y.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(A){return new v.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(A){return new v.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,y){return new T(this.startLineNumber,this.startColumn,A,y)}setStartPosition(A,y){return new T(A,y,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(A){return new T(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,y=A){return new T(A.lineNumber,A.column,y.lineNumber,y.column)}static lift(A){return A?new T(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,y){return!(A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<y.startColumn||y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<A.startColumn)}static areIntersecting(A,y){return!(A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<=y.startColumn||y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,y){if(A&&y){const k=A.startLineNumber|0,i=y.startLineNumber|0;if(k===i){const P=A.startColumn|0,h=y.startColumn|0;if(P===h){const g=A.endLineNumber|0,r=y.endLineNumber|0;if(g===r){const o=A.endColumn|0,p=y.endColumn|0;return o-p}return g-r}return P-h}return k-i}return(A?1:0)-(y?1:0)}static compareRangesUsingEnds(A,y){return A.endLineNumber===y.endLineNumber?A.endColumn===y.endColumn?A.startLineNumber===y.startLineNumber?A.startColumn-y.startColumn:A.startLineNumber-y.startLineNumber:A.endColumn-y.endColumn:A.endLineNumber-y.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}}e.Range=T}),define(ve[116],we([0,1,38,32]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class A extends T.Range{constructor(C,S,k,i){super(C,S,k,i);this.selectionStartLineNumber=C,this.selectionStartColumn=S,this.positionLineNumber=k,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return A.selectionsEqual(this,C)}static selectionsEqual(C,S){return C.selectionStartLineNumber===S.selectionStartLineNumber&&C.selectionStartColumn===S.selectionStartColumn&&C.positionLineNumber===S.positionLineNumber&&C.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,S){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,C,S):new A(C,S,this.startLineNumber,this.startColumn)}getPosition(){return new v.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(C,S){return this.getDirection()===0?new A(C,S,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,C,S)}static fromPositions(C,S=C){return new A(C.lineNumber,C.column,S.lineNumber,S.column)}static liftSelection(C){return new A(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,S){if(C&&!S||!C&&S)return!1;if(!C&&!S)return!0;if(C.length!==S.length)return!1;for(let k=0,i=C.length;k<i;k++)if(!this.selectionsEqual(C[k],S[k]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,S,k,i,P){return P===0?new A(C,S,k,i):new A(k,i,C,S)}}e.Selection=A}),define(ve[86],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var v;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(v=e.OverviewRulerLane||(e.OverviewRulerLane={}));var T;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(T=e.MinimapPosition||(e.MinimapPosition={}));var D;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(o){this.tabSize=Math.max(1,o.tabSize|0),this.indentSize=o.tabSize|0,this.insertSpaces=Boolean(o.insertSpaces),this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=Boolean(o.trimAutoWhitespace)}equals(o){return this.tabSize===o.tabSize&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class S{constructor(o,p){this.range=o,this.matches=p}}e.FindMatch=S;var k;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right"})(i=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var P;(function(r){r[r.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(P=e.ModelConstants||(e.ModelConstants={}));class h{constructor(o,p,m,E,l,c){this.identifier=o,this.range=p,this.text=m,this.forceMoveMarkers=E,this.isAutoWhitespaceEdit=l,this._isTracked=c}}e.ValidAnnotatedEditOperation=h;class g{constructor(o,p,m){this.reverseEdits=o,this.changes=p,this.trimAutoWhitespaceLineNumbers=m}}e.ApplyEditsResult=g}),define(ve[117],we([0,1,8,115,38,32,86]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class S{constructor(l,c,d,t){this.searchString=l,this.isRegex=c,this.matchCase=d,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let l;this.isRegex?l=k(this.searchString):l=this.searchString.indexOf(`
`)>=0;let c=null;try{c=v.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:l,global:!0,unicode:!0})}catch(t){return null}if(!c)return null;let d=!this.isRegex&&!l;return d&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(d=this.matchCase),new i(c,this.wordSeparators?(0,T.getMapForWordSeparators)(this.wordSeparators):null,d?this.searchString:null)}}e.SearchParams=S;function k(E){if(!E||E.length===0)return!1;for(let l=0,c=E.length;l<c;l++)if(E.charCodeAt(l)===92){if(l++,l>=c)break;const t=E.charCodeAt(l);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class i{constructor(l,c,d){this.regex=l,this.wordSeparators=c,this.simpleSearch=d}}e.SearchData=i;function P(E,l,c){if(!c)return new y.FindMatch(E,null);let d=[];for(let t=0,n=l.length;t<n;t++)d[t]=l[t];return new y.FindMatch(E,d)}e.createFindMatch=P;class h{constructor(l){let c=[],d=0;for(let t=0,n=l.length;t<n;t++)l.charCodeAt(t)===10&&(c[d++]=t);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(l){const c=this._lineFeedsOffsets;let d=0,t=c.length-1;if(t===-1||l<=c[0])return 0;for(;d<t;){const n=d+((t-d)/2>>0);c[n]>=l?t=n-1:c[n+1]>=l?(d=n,t=n):d=n+1}return d+1}}class g{static findMatches(l,c,d,t,n){const a=c.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(l,d,new m(a.wordSeparators,a.regex),t,n):this._doFindMatchesLineByLine(l,d,a,t,n):[]}static _getMultilineMatchRange(l,c,d,t,n,a){let s,u=0;t?(u=t.findLineFeedCountBeforeOffset(n),s=c+n+u):s=c+n;let w;if(t){let _=t.findLineFeedCountBeforeOffset(n+a.length)-u;w=s+a.length+_}else w=s+a.length;const b=l.getPositionAt(s),I=l.getPositionAt(w);return new A.Range(b.lineNumber,b.column,I.lineNumber,I.column)}static _doFindMatchesMultiline(l,c,d,t,n){const a=l.getOffsetAt(c.getStartPosition()),s=l.getValueInRange(c,1),u=l.getEOL()===`\r
`?new h(s):null,w=[];let b=0,I;for(d.reset(0);I=d.next(s);)if(w[b++]=P(this._getMultilineMatchRange(l,a,s,u,I.index,I[0]),I,t),b>=n)return w;return w}static _doFindMatchesLineByLine(l,c,d,t,n){const a=[];let s=0;if(c.startLineNumber===c.endLineNumber){const w=l.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return s=this._findMatchesInLine(d,w,c.startLineNumber,c.startColumn-1,s,a,t,n),a}const u=l.getLineContent(c.startLineNumber).substring(c.startColumn-1);s=this._findMatchesInLine(d,u,c.startLineNumber,c.startColumn-1,s,a,t,n);for(let w=c.startLineNumber+1;w<c.endLineNumber&&s<n;w++)s=this._findMatchesInLine(d,l.getLineContent(w),w,0,s,a,t,n);if(s<n){const w=l.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);s=this._findMatchesInLine(d,w,c.endLineNumber,0,s,a,t,n)}return a}static _findMatchesInLine(l,c,d,t,n,a,s,u){const w=l.wordSeparators;if(!s&&l.simpleSearch){const f=l.simpleSearch,_=f.length,F=c.length;let U=-_;for(;(U=c.indexOf(f,U+_))!==-1;)if((!w||p(w,c,F,U,_))&&(a[n++]=new y.FindMatch(new A.Range(d,U+1+t,d,U+1+_+t),null),n>=u))return n;return n}const b=new m(l.wordSeparators,l.regex);let I;b.reset(0);do if(I=b.next(c),I&&(a[n++]=P(new A.Range(d,I.index+1+t,d,I.index+1+I[0].length+t),I,s),n>=u))return n;while(I);return n}static findNextMatch(l,c,d,t){const n=c.parseSearchRequest();if(!n)return null;const a=new m(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(l,d,a,t):this._doFindNextMatchLineByLine(l,d,a,t)}static _doFindNextMatchMultiline(l,c,d,t){const n=new D.Position(c.lineNumber,1),a=l.getOffsetAt(n),s=l.getLineCount(),u=l.getValueInRange(new A.Range(n.lineNumber,n.column,s,l.getLineMaxColumn(s)),1),w=l.getEOL()===`\r
`?new h(u):null;d.reset(c.column-1);let b=d.next(u);return b?P(this._getMultilineMatchRange(l,a,u,w,b.index,b[0]),b,t):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(l,new D.Position(1,1),d,t):null}static _doFindNextMatchLineByLine(l,c,d,t){const n=l.getLineCount(),a=c.lineNumber,s=l.getLineContent(a),u=this._findFirstMatchInLine(d,s,a,c.column,t);if(u)return u;for(let w=1;w<=n;w++){const b=(a+w-1)%n,I=l.getLineContent(b+1),f=this._findFirstMatchInLine(d,I,b+1,1,t);if(f)return f}return null}static _findFirstMatchInLine(l,c,d,t,n){l.reset(t-1);const a=l.next(c);return a?P(new A.Range(d,a.index+1,d,a.index+1+a[0].length),a,n):null}static findPreviousMatch(l,c,d,t){const n=c.parseSearchRequest();if(!n)return null;const a=new m(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(l,d,a,t):this._doFindPreviousMatchLineByLine(l,d,a,t)}static _doFindPreviousMatchMultiline(l,c,d,t){const n=this._doFindMatchesMultiline(l,new A.Range(1,1,c.lineNumber,c.column),d,t,10*C);if(n.length>0)return n[n.length-1];const a=l.getLineCount();return c.lineNumber!==a||c.column!==l.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(l,new D.Position(a,l.getLineMaxColumn(a)),d,t):null}static _doFindPreviousMatchLineByLine(l,c,d,t){const n=l.getLineCount(),a=c.lineNumber,s=l.getLineContent(a).substring(0,c.column-1),u=this._findLastMatchInLine(d,s,a,t);if(u)return u;for(let w=1;w<=n;w++){const b=(n+a-w-1)%n,I=l.getLineContent(b+1),f=this._findLastMatchInLine(d,I,b+1,t);if(f)return f}return null}static _findLastMatchInLine(l,c,d,t){let n=null,a;for(l.reset(0);a=l.next(c);)n=P(new A.Range(d,a.index+1,d,a.index+1+a[0].length),a,t);return n}}e.TextModelSearch=g;function r(E,l,c,d,t){if(d===0)return!0;const n=l.charCodeAt(d-1);if(E.get(n)!==0||n===13||n===10)return!0;if(t>0){const a=l.charCodeAt(d);if(E.get(a)!==0)return!0}return!1}function o(E,l,c,d,t){if(d+t===c)return!0;const n=l.charCodeAt(d+t);if(E.get(n)!==0||n===13||n===10)return!0;if(t>0){const a=l.charCodeAt(d+t-1);if(E.get(a)!==0)return!0}return!1}function p(E,l,c,d,t){return r(E,l,c,d,t)&&o(E,l,c,d,t)}e.isValidMatch=p;class m{constructor(l,c){this._wordSeparators=l,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(l){this._searchRegex.lastIndex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(l){const c=l.length;let d;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(d=this._searchRegex.exec(l),!d))return null;const t=d.index,n=d[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){v.getNextCodePoint(l,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||p(this._wordSeparators,l,c,t,n))return d}while(d);return null}}e.Searcher=m}),define(ve[87],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function v(C=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)C.indexOf(k)>=0||(S+="\\"+k);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=v();function T(C){let S=e.DEFAULT_WORD_REGEXP;if(C&&C instanceof RegExp)if(C.global)S=C;else{let k="g";C.ignoreCase&&(k+="i"),C.multiline&&(k+="m"),C.unicode&&(k+="u"),S=new RegExp(C.source,k)}return S.lastIndex=0,S}e.ensureValidWordDefinition=T;const D={maxLen:1e3,windowSize:15,timeBudget:150};function A(C,S,k,i,P=D){if(k.length>P.maxLen){let p=C-P.maxLen/2;return p<0?p=0:i+=p,k=k.substring(p,C+P.maxLen/2),A(C,S,k,i,P)}const h=Date.now(),g=C-1-i;let r=-1,o=null;for(let p=1;!(Date.now()-h>=P.timeBudget);p++){const m=g-P.windowSize*p;S.lastIndex=Math.max(0,m);const E=y(S,k,g,r);if(!E&&o||(o=E,m<=0))break;r=m}if(o){let p={word:o[0],startColumn:i+1+o.index,endColumn:i+1+o.index+o[0].length};return S.lastIndex=0,p}return null}e.getWordAtText=A;function y(C,S,k,i){let P;for(;P=C.exec(S);){const h=P.index||0;if(h<=k&&C.lastIndex>=k)return P;if(i>0&&h>i)return null}return null}}),define(ve[118],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var v;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(v=e.IndentAction||(e.IndentAction={}));class T{constructor(C){if(this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let S=0,k=C.notIn.length;S<k;S++)switch(C.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=T;class D{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of C)A(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),A(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),A(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),A(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&A(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=D;function A(y,C,S){y.has(C)?y.get(C).push(S):y.set(C,[S])}}),define(ve[59],we([0,1,28,14]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(A,y,C,S){if(Array.isArray(A)){let k=0;for(const i of A){const P=D(i,y,C,S);if(P===10)return P;P>k&&(k=P)}return k}else{if(typeof A=="string")return S?A==="*"?5:A===C?10:0:0;if(A){const{language:k,pattern:i,scheme:P,hasAccessToAllModels:h}=A;if(!S&&!h)return 0;let g=0;if(P)if(P===y.scheme)g=10;else if(P==="*")g=5;else return 0;if(k)if(k===C)g=10;else if(k==="*")g=Math.max(g,5);else return 0;if(i){let r;if(typeof i=="string"?r=i:r=Object.assign(Object.assign({},i),{base:(0,T.normalize)(i.base)}),r===y.fsPath||(0,v.match)(r,y.fsPath))g=10;else return 0}return g}else return 0}}e.score=D}),define(ve[119],we([0,1,85]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var T;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(T=e.State||(e.State={}));class D{constructor(r,o,p){const m=new Uint8Array(r*o);for(let E=0,l=r*o;E<l;E++)m[E]=p;this._data=m,this.rows=r,this.cols=o}get(r,o){return this._data[r*this.cols+o]}set(r,o,p){this._data[r*this.cols+o]=p}}e.Uint8Matrix=D;class A{constructor(r){let o=0,p=0;for(let E=0,l=r.length;E<l;E++){let[c,d,t]=r[E];d>o&&(o=d),c>p&&(p=c),t>p&&(p=t)}o++,p++;let m=new D(p,o,0);for(let E=0,l=r.length;E<l;E++){let[c,d,t]=r[E];m.set(c,d,t)}this._states=m,this._maxCharCode=o}nextState(r,o){return o<0||o>=this._maxCharCode?0:this._states.get(r,o)}}e.StateMachine=A;let y=null;function C(){return y===null&&(y=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var S;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let k=null;function i(){if(k===null){k=new v.CharacterClassifier(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let o=0;o<g.length;o++)k.set(g.charCodeAt(o),1);const r=".,;";for(let o=0;o<r.length;o++)k.set(r.charCodeAt(o),2)}return k}class P{static _createLink(r,o,p,m,E){let l=E-1;do{const c=o.charCodeAt(l);if(r.get(c)!==2)break;l--}while(l>m);if(m>0){const c=o.charCodeAt(m-1),d=o.charCodeAt(l);(c===40&&d===41||c===91&&d===93||c===123&&d===125)&&l--}return{range:{startLineNumber:p,startColumn:m+1,endLineNumber:p,endColumn:l+2},url:o.substring(m,l+1)}}static computeLinks(r,o=C()){const p=i();let m=[];for(let E=1,l=r.getLineCount();E<=l;E++){const c=r.getLineContent(E),d=c.length;let t=0,n=0,a=0,s=1,u=!1,w=!1,b=!1,I=!1;for(;t<d;){let f=!1;const _=c.charCodeAt(t);if(s===13){let F;switch(_){case 40:u=!0,F=0;break;case 41:F=u?0:1;break;case 91:b=!0,w=!0,F=0;break;case 93:b=!1,F=w?0:1;break;case 123:I=!0,F=0;break;case 125:F=I?0:1;break;case 39:F=a===34||a===96?0:1;break;case 34:F=a===39||a===96?0:1;break;case 96:F=a===39||a===34?0:1;break;case 42:F=a===42?1:0;break;case 124:F=a===124?1:0;break;case 32:F=b?0:1;break;default:F=p.get(_)}F===1&&(m.push(P._createLink(p,c,E,n,t)),f=!0)}else if(s===12){let F;_===91?(w=!0,F=0):F=p.get(_),F===1?f=!0:s=13}else s=o.nextState(s,_),s===0&&(f=!0);f&&(s=1,u=!1,w=!1,I=!1,n=t+1,a=_),t++}s===13&&m.push(P._createLink(p,c,E,n,d))}return m}}e.LinkComputer=P;function h(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:P.computeLinks(g)}e.computeLinks=h}),define(ve[120],we([0,1,3,6]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class D{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new v.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,C){return this._map.set(y,C),this.fire([y]),(0,T.toDisposable)(()=>{this._map.get(y)===C&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,C){let S=null,k=!1;return this._promises.set(y,C.then(i=>{this._promises.delete(y),!(k||!i)&&(S=this.register(y,i))})),(0,T.toDisposable)(()=>{k=!0,S&&S.dispose()})}getPromise(y){const C=this.get(y);if(C)return Promise.resolve(C);const S=this._promises.get(y);return S?S.then(k=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=D}),define(ve[88],we([0,1,24,21]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(D||(D={}));function A(P){for(let h=0,g=P.length;h<g;h+=4){const r=P[h+0],o=P[h+1],p=P[h+2],m=P[h+3];P[h+0]=m,P[h+1]=p,P[h+2]=o,P[h+3]=r}}function y(P){const h=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return T.isLittleEndian()||A(h),v.VSBuffer.wrap(h)}function C(P){const h=P.buffer;if(T.isLittleEndian()||A(h),h.byteOffset%4==0)return new Uint32Array(h.buffer,h.byteOffset,h.length/4);{const g=new Uint8Array(h.byteLength);return g.set(h),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function S(P){const h=new Uint32Array(k(P));let g=0;if(h[g++]=P.id,P.type==="full")h[g++]=1,h[g++]=P.data.length,h.set(P.data,g),g+=P.data.length;else{h[g++]=2,h[g++]=P.deltas.length;for(const r of P.deltas)h[g++]=r.start,h[g++]=r.deleteCount,r.data?(h[g++]=r.data.length,h.set(r.data,g),g+=r.data.length):h[g++]=0}return y(h)}e.encodeSemanticTokensDto=S;function k(P){let h=0;if(h+=1+1,P.type==="full")h+=1+P.data.length;else{h+=1,h+=(1+1+1)*P.deltas.length;for(const g of P.deltas)g.data&&(h+=g.data.length)}return h}function i(P){const h=C(P);let g=0;const r=h[g++];if(h[g++]===1){const E=h[g++],l=h.subarray(g,g+E);return g+=E,{id:r,type:"full",data:l}}const p=h[g++];let m=[];for(let E=0;E<p;E++){const l=h[g++],c=h[g++],d=h[g++];let t;d>0&&(t=h.subarray(g,g+d),g+=d),m[E]={start:l,deleteCount:c,data:t}}return{id:r,type:"delta",deltas:m}}e.decodeSemanticTokensDto=i}),define(ve[89],we([0,1,83]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class T{constructor(y,C){this.index=y,this.remainder=C}}e.PrefixSumIndexOfResult=T;class D{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,C){y=(0,v.toUint32)(y);const S=this.values,k=this.prefixSum,i=C.length;return i===0?!1:(this.values=new Uint32Array(S.length+i),this.values.set(S.subarray(0,y),0),this.values.set(S.subarray(y),y+i),this.values.set(C,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,C){return y=(0,v.toUint32)(y),C=(0,v.toUint32)(C),this.values[y]===C?!1:(this.values[y]=C,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,C){y=(0,v.toUint32)(y),C=(0,v.toUint32)(C);const S=this.values,k=this.prefixSum;if(y>=S.length)return!1;let i=S.length-y;return C>=i&&(C=i),C===0?!1:(this.values=new Uint32Array(S.length-C),this.values.set(S.subarray(0,y),0),this.values.set(S.subarray(y+C),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,v.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),y>=this.values.length&&(y=this.values.length-1);for(let S=C;S<=y;S++)this.prefixSum[S]=this.prefixSum[S-1]+this.values[S];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let C=0,S=this.values.length-1,k=0,i=0,P=0;for(;C<=S;)if(k=C+(S-C)/2|0,i=this.prefixSum[k],P=i-this.values[k],y<P)S=k-1;else if(y>=i)C=k+1;else break;return new T(k,y-P)}}e.PrefixSumComputer=D}),define(ve[121],we([0,1,8,38,89]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(C,S,k,i){this._uri=C,this._lines=S,this._eol=k,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const S=C.changes;for(const k of S)this._acceptDeleteRange(k.range),this._acceptInsertText(new T.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,S=this._lines.length,k=new Uint32Array(S);for(let i=0;i<S;i++)k[i]=this._lines[i].length+C;this._lineStarts=new D.PrefixSumComputer(k)}}_setLineText(C,S){this._lines[C]=S,this._lineStarts&&this._lineStarts.changeValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,S){if(S.length!==0){let k=(0,v.splitLines)(S);if(k.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+k[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}k[k.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+k[0]);let i=new Uint32Array(k.length-1);for(let P=1;P<k.length;P++)this._lines.splice(C.lineNumber+P-1,0,k[P]),i[P-1]=k[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,i)}}}e.MirrorTextModel=A}),define(ve[122],we([17,18]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(ve[60],we([0,1,122,10,13]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(k,i){return i&&(k.stack||k.stacktrace)?v.localize(0,null,C(k),y(k.stack)||y(k.stacktrace)):C(k)}function y(k){return Array.isArray(k)?k.join(`
`):k}function C(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?v.localize(1,null,k.message):k.message||v.localize(2,null)}function S(k=null,i=!1){if(!k)return v.localize(3,null);if(Array.isArray(k)){const P=D.coalesce(k),h=S(P[0],i);return P.length>1?v.localize(4,null,h,P.length):h}if(T.isString(k))return k;if(k.detail){const P=k.detail;if(P.error)return A(P.error,i);if(P.exception)return A(P.exception,i)}return k.stack?A(k,i):k.message?k.message:v.localize(5,null)}e.toErrorMessage=S}),define(ve[123],we([17,18]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(ve[124],we([0,1,123,21,87]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(Z){this._values=Z}hasChanged(Z){return this._values[Z]}}e.ConfigurationChangedEvent=y;class C{constructor(){this._values=[]}_read(Z){return this._values[Z]}get(Z){return this._values[Z]}_write(Z,ge){this._values[Z]=ge}}e.ValidatedEditorOptions=C;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class k{constructor(Z,ge,Ne,Ve){this.id=Z,this.name=ge,this.defaultValue=Ne,this.schema=Ve}compute(Z,ge,Ne){return Ne}}class i{constructor(Z,ge=null){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0,this.deps=ge}validate(Z){return this.defaultValue}}class P{constructor(Z,ge,Ne,Ve){this.id=Z,this.name=ge,this.defaultValue=Ne,this.schema=Ve}validate(Z){return typeof Z=="undefined"?this.defaultValue:Z}compute(Z,ge,Ne){return Ne}}function h(V,Z){return typeof V=="undefined"?Z:V==="false"?!1:Boolean(V)}e.boolean=h;class g extends P{constructor(Z,ge,Ne,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="boolean",Ve.default=Ne),super(Z,ge,Ne,Ve)}validate(Z){return h(Z,this.defaultValue)}}class r extends P{constructor(Z,ge,Ne,Ve,xe,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="integer",Xe.default=Ne,Xe.minimum=Ve,Xe.maximum=xe),super(Z,ge,Ne,Xe),this.minimum=Ve,this.maximum=xe}static clampedInt(Z,ge,Ne,Ve){if(typeof Z=="undefined")return ge;let xe=parseInt(Z,10);return isNaN(xe)?ge:(xe=Math.max(Ne,xe),xe=Math.min(Ve,xe),xe|0)}validate(Z){return r.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}class o extends P{constructor(Z,ge,Ne,Ve,xe){typeof xe!="undefined"&&(xe.type="number",xe.default=Ne),super(Z,ge,Ne,xe),this.validationFn=Ve}static clamp(Z,ge,Ne){return Z<ge?ge:Z>Ne?Ne:Z}static float(Z,ge){if(typeof Z=="number")return Z;if(typeof Z=="undefined")return ge;const Ne=parseFloat(Z);return isNaN(Ne)?ge:Ne}validate(Z){return this.validationFn(o.float(Z,this.defaultValue))}}class p extends P{static string(Z,ge){return typeof Z!="string"?ge:Z}constructor(Z,ge,Ne,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.default=Ne),super(Z,ge,Ne,Ve)}validate(Z){return p.string(Z,this.defaultValue)}}function m(V,Z,ge){return typeof V!="string"||ge.indexOf(V)===-1?Z:V}e.stringSet=m;class E extends P{constructor(Z,ge,Ne,Ve,xe=void 0){typeof xe!="undefined"&&(xe.type="string",xe.enum=Ve,xe.default=Ne),super(Z,ge,Ne,xe),this._allowedValues=Ve}validate(Z){return m(Z,this.defaultValue,this._allowedValues)}}class l extends k{constructor(Z,ge,Ne,Ve,xe,Xe,ye=void 0){typeof ye!="undefined"&&(ye.type="string",ye.enum=xe,ye.default=Ve),super(Z,ge,Ne,ye),this._allowedValues=xe,this._convert=Xe}validate(Z){return typeof Z!="string"?this.defaultValue:this._allowedValues.indexOf(Z)===-1?this.defaultValue:this._convert(Z)}}function c(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[v.localize(0,null),v.localize(1,null),v.localize(2,null)],default:"auto",description:v.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,ge,Ne){return Ne===0?Z.accessibilitySupport:Ne}}class t extends k{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:v.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:v.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{insertSpace:h(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function a(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var s;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(s=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function u(V){switch(V){case s.Line:return"line";case s.Block:return"block";case s.Underline:return"underline";case s.LineThin:return"line-thin";case s.BlockOutline:return"block-outline";case s.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=u;function w(V){switch(V){case"line":return s.Line;case"block":return s.Block;case"underline":return s.Underline;case"line-thin":return s.LineThin;case"block-outline":return s.BlockOutline;case"underline-thin":return s.UnderlineThin}}class b extends i{constructor(){super(124,[62,31])}compute(Z,ge,Ne){const Ve=["monaco-editor"];return ge.get(31)&&Ve.push(ge.get(31)),Z.extraEditorClassName&&Ve.push(Z.extraEditorClassName),ge.get(62)==="default"?Ve.push("mouse-default"):ge.get(62)==="copy"&&Ve.push("mouse-copy"),ge.get(97)&&Ve.push("showUnused"),ge.get(122)&&Ve.push("showDeprecated"),Ve.join(" ")}}class I extends g{constructor(){super(30,"emptySelectionClipboard",!0,{description:v.localize(6,null)})}compute(Z,ge,Ne){return Ne&&Z.emptySelectionClipboard}}class f extends k{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:v.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:Z.seedSearchStringFromSelection,description:v.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[v.localize(9,null),v.localize(10,null),v.localize(11,null)],description:v.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:v.localize(13,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:v.localize(14,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:v.localize(15,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{cursorMoveOnType:h(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:h(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":m(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(ge.loop,this.defaultValue.loop)}}}class _ extends k{constructor(){super(41,"fontLigatures",_.OFF,{anyOf:[{type:"boolean",description:v.localize(16,null)},{type:"string",description:v.localize(17,null)}],description:v.localize(18,null),default:!1})}validate(Z){return typeof Z=="undefined"?this.defaultValue:typeof Z=="string"?Z==="false"?_.OFF:Z==="true"?_.ON:Z:Boolean(Z)?_.ON:_.OFF}}e.EditorFontLigatures=_,_.OFF='"liga" off, "calt" off',_.ON='"liga" on, "calt" on';class F extends i{constructor(){super(40)}compute(Z,ge,Ne){return Z.fontInfo}}class U extends P{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:v.localize(19,null)})}validate(Z){let ge=o.float(Z,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(ge,6,100)}compute(Z,ge,Ne){return Z.fontInfo.fontSize}}class z extends k{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:v.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:v.localize(21,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(r.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class he extends k{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[v.localize(22,null),v.localize(23,null),v.localize(24,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:v.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:v.localize(26,null)},ge),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:v.localize(27,null)},ge),"editor.gotoLocation.multipleDeclarations":Object.assign({description:v.localize(28,null)},ge),"editor.gotoLocation.multipleImplementations":Object.assign({description:v.localize(29,null)},ge),"editor.gotoLocation.multipleReferences":Object.assign({description:v.localize(30,null)},ge),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:Ne,description:v.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:Ne,description:v.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:Ne,description:v.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:Ne,description:v.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:Ne,description:v.localize(35,null)}})}validate(Z){var ge,Ne,Ve,xe,Xe;if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{multiple:m(ye.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ge=ye.multipleDefinitions)!==null&&ge!==void 0?ge:m(ye.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ne=ye.multipleTypeDefinitions)!==null&&Ne!==void 0?Ne:m(ye.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Ve=ye.multipleDeclarations)!==null&&Ve!==void 0?Ve:m(ye.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(xe=ye.multipleImplementations)!==null&&xe!==void 0?xe:m(ye.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Xe=ye.multipleReferences)!==null&&Xe!==void 0?Xe:m(ye.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(ye.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(ye.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(ye.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(ye.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(ye.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class de extends k{constructor(){const Z={enabled:!0,delay:300,sticky:!0};super(50,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:v.localize(36,null)},"editor.hover.delay":{type:"number",default:Z.delay,description:v.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:v.localize(38,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{enabled:h(ge.enabled,this.defaultValue.enabled),delay:r.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:h(ge.sticky,this.defaultValue.sticky)}}}var x;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(x=e.RenderMinimap||(e.RenderMinimap={}));class j extends i{constructor(){super(127,[46,54,35,61,89,56,57,91,114,117,118,119,2])}compute(Z,ge,Ne){return j.computeLayout(ge,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio})}static computeContainedMinimapLineCount(Z){const ge=Z.height/Z.lineHeight,Ne=Z.scrollBeyondLastLine?ge-1:0,Ve=(Z.viewLineCount+Ne)/(Z.pixelRatio*Z.height),xe=Math.floor(Z.viewLineCount/Ve);return{typicalViewportLineCount:ge,extraLinesBeyondLastLine:Ne,desiredRatio:Ve,minimapLineCount:xe}}static _computeMinimapLayout(Z,ge){const Ne=Z.outerWidth,Ve=Z.outerHeight,xe=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(xe*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const Xe=ge.stableMinimapLayoutInput,ye=Xe&&Z.outerHeight===Xe.outerHeight&&Z.lineHeight===Xe.lineHeight&&Z.typicalHalfwidthCharacterWidth===Xe.typicalHalfwidthCharacterWidth&&Z.pixelRatio===Xe.pixelRatio&&Z.scrollBeyondLastLine===Xe.scrollBeyondLastLine&&Z.minimap.enabled===Xe.minimap.enabled&&Z.minimap.side===Xe.minimap.side&&Z.minimap.size===Xe.minimap.size&&Z.minimap.showSlider===Xe.minimap.showSlider&&Z.minimap.renderCharacters===Xe.minimap.renderCharacters&&Z.minimap.maxColumn===Xe.minimap.maxColumn&&Z.minimap.scale===Xe.minimap.scale&&Z.verticalScrollbarWidth===Xe.verticalScrollbarWidth&&Z.isViewportWrapping===Xe.isViewportWrapping,Ee=Z.lineHeight,Ce=Z.typicalHalfwidthCharacterWidth,ie=Z.scrollBeyondLastLine,ae=Z.minimap.renderCharacters;let N=xe>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Q=Z.minimap.maxColumn,oe=Z.minimap.size,ke=Z.minimap.side,Ie=Z.verticalScrollbarWidth,Ae=Z.viewLineCount,Be=Z.remainingWidth,Ye=Z.isViewportWrapping,rt=ae?2:3;let tt=Math.floor(xe*Ve);const Qe=tt/xe;let gt=!1,bt=!1,pe=rt*N,ue=N/xe,re=1;if(oe==="fill"||oe==="fit"){const{typicalViewportLineCount:ct,extraLinesBeyondLastLine:Ze,desiredRatio:mt,minimapLineCount:ht}=j.computeContainedMinimapLineCount({viewLineCount:Ae,scrollBeyondLastLine:ie,height:Ve,lineHeight:Ee,pixelRatio:xe});if(Ae/ht>1)gt=!0,bt=!0,N=1,pe=1,ue=N/xe;else{let at=!1,yt=N+1;if(oe==="fit"){const Et=Math.ceil((Ae+Ze)*pe);Ye&&ye&&Be<=ge.stableFitRemainingWidth?(at=!0,yt=ge.stableFitMaxMinimapScale):(at=Et>tt,Ye&&at?(ge.stableMinimapLayoutInput=Z,ge.stableFitRemainingWidth=Be):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0))}if(oe==="fill"||at){gt=!0;const Et=N;pe=Math.min(Ee*xe,Math.max(1,Math.floor(1/mt))),N=Math.min(yt,Math.max(1,Math.floor(pe/rt))),N>Et&&(re=Math.min(2,N/Et)),ue=N/xe/re,tt=Math.ceil(Math.max(ct,Ae+Ze)*pe),Ye&&at&&(ge.stableFitMaxMinimapScale=N)}}}const K=Math.floor(Q*ue),Me=Math.min(K,Math.max(0,Math.floor((Be-Ie-2)*ue/(Ce+ue)))+e.MINIMAP_GUTTER_WIDTH);let Te=Math.floor(xe*Me);const Je=Te/xe;Te=Math.floor(Te*re);const et=ae?1:2,ut=ke==="left"?0:Ne-Me-Ie;return{renderMinimap:et,minimapLeft:ut,minimapWidth:Me,minimapHeightIsEditorHeight:gt,minimapIsSampling:bt,minimapScale:N,minimapLineHeight:pe,minimapCanvasInnerWidth:Te,minimapCanvasInnerHeight:tt,minimapCanvasOuterWidth:Je,minimapCanvasOuterHeight:Qe}}static computeLayout(Z,ge){const Ne=ge.outerWidth|0,Ve=ge.outerHeight|0,xe=ge.lineHeight|0,Xe=ge.lineNumbersDigitCount|0,ye=ge.typicalHalfwidthCharacterWidth,Ee=ge.maxDigitWidth,Ce=ge.pixelRatio,ie=ge.viewLineCount,ae=Z.get(119),N=ae==="inherit"?Z.get(118):ae,Q=N==="inherit"?Z.get(114):N,oe=Z.get(117),ke=Z.get(2),Ie=ge.isDominatedByLongLines,Ae=Z.get(46),Be=Z.get(56).renderType!==0,Ye=Z.get(57),rt=Z.get(91),tt=Z.get(61),Qe=Z.get(89),gt=Qe.verticalScrollbarSize,bt=Qe.verticalHasArrows,pe=Qe.arrowSize,ue=Qe.horizontalScrollbarSize,re=Z.get(54),K=Z.get(35);let Me;if(typeof re=="string"&&/^\d+(\.\d+)?ch$/.test(re)){const _t=parseFloat(re.substr(0,re.length-2));Me=r.clampedInt(_t*ye,0,0,1e3)}else Me=r.clampedInt(re,0,0,1e3);K&&(Me+=16);let Te=0;if(Be){const _t=Math.max(Xe,Ye);Te=Math.round(_t*Ee)}let Je=0;Ae&&(Je=xe);let et=0,ut=et+Je,ct=ut+Te,Ze=ct+Me;const mt=Ne-Je-Te-Me;let ht=!1,ft=!1,at=-1;ke!==2&&(N==="inherit"&&Ie?(ht=!0,ft=!0):Q==="on"||Q==="bounded"?ft=!0:Q==="wordWrapColumn"&&(at=oe));const yt=j._computeMinimapLayout({outerWidth:Ne,outerHeight:Ve,lineHeight:xe,typicalHalfwidthCharacterWidth:ye,pixelRatio:Ce,scrollBeyondLastLine:rt,minimap:tt,verticalScrollbarWidth:gt,viewLineCount:ie,remainingWidth:mt,isViewportWrapping:ft},ge.memory||new S);yt.renderMinimap!==0&&yt.minimapLeft===0&&(et+=yt.minimapWidth,ut+=yt.minimapWidth,ct+=yt.minimapWidth,Ze+=yt.minimapWidth);const Et=mt-yt.minimapWidth,Ot=Math.max(1,Math.floor((Et-gt-2)/ye)),Tt=bt?pe:0;return ft&&(at=Math.max(1,Ot),Q==="bounded"&&(at=Math.min(at,oe))),{width:Ne,height:Ve,glyphMarginLeft:et,glyphMarginWidth:Je,lineNumbersLeft:ut,lineNumbersWidth:Te,decorationsLeft:ct,decorationsWidth:Me,contentLeft:Ze,contentWidth:Et,minimap:yt,viewportColumn:Ot,isWordWrapMinified:ht,isViewportWrapping:ft,wrappingColumn:at,verticalScrollbarWidth:gt,horizontalScrollbarHeight:ue,overviewRuler:{top:Tt,width:gt,height:Ve-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=j;class H extends k{constructor(){const Z={enabled:!0};super(53,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:v.localize(39,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:h(Z.enabled,this.defaultValue.enabled)}}}class R extends k{constructor(){const Z={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(123,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"boolean",default:Z.enabled,description:v.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,description:v.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,description:v.localize(42,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{enabled:h(ge.enabled,this.defaultValue.enabled),fontSize:r.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(ge.fontFamily,this.defaultValue.fontFamily)}}}class L extends r{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:v.localize(43,null)})}compute(Z,ge,Ne){return Z.fontInfo.lineHeight}}class M extends k{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:v.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[v.localize(45,null),v.localize(46,null),v.localize(47,null)],default:Z.size,description:v.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:v.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:v.localize(50,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:v.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:v.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:v.localize(53,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{enabled:h(ge.enabled,this.defaultValue.enabled),size:m(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:m(ge.side,this.defaultValue.side,["right","left"]),showSlider:m(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(ge.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(ge.scale,1,1,3),maxColumn:r.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function $(V){return V==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class G extends k{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(55,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{top:r.clampedInt(ge.top,0,0,1e3),bottom:r.clampedInt(ge.bottom,0,0,1e3)}}}class J extends k{constructor(){const Z={enabled:!0,cycle:!1};super(72,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:v.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:v.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{enabled:h(ge.enabled,this.defaultValue.enabled),cycle:h(ge.cycle,this.defaultValue.cycle)}}}class te extends i{constructor(){super(125)}compute(Z,ge,Ne){return Z.pixelRatio}}class me extends k{constructor(){const Z={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",Z,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Z.strings,description:v.localize(58,null)},comments:{type:"boolean",default:Z.comments,description:v.localize(59,null)},other:{type:"boolean",default:Z.other,description:v.localize(60,null)}}}],default:Z,description:v.localize(61,null)});this.defaultValue=Z}validate(Z){if(typeof Z=="boolean")return Z;if(Z&&typeof Z=="object"){const ge=Z,Ne={other:h(ge.other,this.defaultValue.other),comments:h(ge.comments,this.defaultValue.comments),strings:h(ge.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var Le;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Le=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class We extends k{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[v.localize(62,null),v.localize(63,null),v.localize(64,null),v.localize(65,null)],default:"on",description:v.localize(66,null)})}validate(Z){let ge=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof Z!="undefined"&&(typeof Z=="function"?(ge=4,Ne=Z):Z==="interval"?ge=3:Z==="relative"?ge=2:Z==="on"?ge=1:ge=0),{renderType:ge,renderFn:Ne}}}function Fe(V){const Z=V.get(84);return Z==="editable"?V.get(77):Z!=="on"}e.filterValidationDecorations=Fe;class ze extends k{constructor(){const Z=[],ge={type:"number",description:v.localize(67,null)};super(88,"rulers",Z,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:v.localize(68,null),format:"color-hex"}}}]},default:Z,description:v.localize(69,null)})}validate(Z){if(Array.isArray(Z)){let ge=[];for(let Ne of Z)if(typeof Ne=="number")ge.push({column:r.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const Ve=Ne;ge.push({column:r.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return ge.sort((Ne,Ve)=>Ne.column-Ve.column),ge}return this.defaultValue}}function W(V,Z){if(typeof V!="string")return Z;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class q extends k{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z,Ne=r.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=r.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:W(ge.vertical,this.defaultValue.vertical),horizontal:W(ge.horizontal,this.defaultValue.horizontal),useShadows:h(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:r.clampedInt(ge.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:r.clampedInt(ge.verticalSliderSize,Ve,0,1e3),scrollByPage:h(ge.scrollByPage,this.defaultValue.scrollByPage)}}}class ee extends k{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[v.localize(70,null),v.localize(71,null)],default:Z.insertMode,description:v.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:v.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:v.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:v.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:v.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:v.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:v.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:v.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:v.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:v.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:v.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:v.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:v.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:v.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:v.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:v.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:v.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:v.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:v.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:v.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:v.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:v.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:v.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:v.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:v.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:v.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:v.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:v.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:v.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:v.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:v.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:v.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:v.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:v.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:v.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:v.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:v.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:v.localize(109,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ge=Z;return{insertMode:m(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:h(ge.showIcons,this.defaultValue.showIcons),showStatusBar:h(ge.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:h(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(ge.showMethods,this.defaultValue.showMethods),showFunctions:h(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:h(ge.showConstructors,this.defaultValue.showConstructors),showFields:h(ge.showFields,this.defaultValue.showFields),showVariables:h(ge.showVariables,this.defaultValue.showVariables),showClasses:h(ge.showClasses,this.defaultValue.showClasses),showStructs:h(ge.showStructs,this.defaultValue.showStructs),showInterfaces:h(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:h(ge.showModules,this.defaultValue.showModules),showProperties:h(ge.showProperties,this.defaultValue.showProperties),showEvents:h(ge.showEvents,this.defaultValue.showEvents),showOperators:h(ge.showOperators,this.defaultValue.showOperators),showUnits:h(ge.showUnits,this.defaultValue.showUnits),showValues:h(ge.showValues,this.defaultValue.showValues),showConstants:h(ge.showConstants,this.defaultValue.showConstants),showEnums:h(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:h(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(ge.showKeywords,this.defaultValue.showKeywords),showWords:h(ge.showWords,this.defaultValue.showWords),showColors:h(ge.showColors,this.defaultValue.showColors),showFiles:h(ge.showFiles,this.defaultValue.showFiles),showReferences:h(ge.showReferences,this.defaultValue.showReferences),showFolders:h(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:h(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(ge.showSnippets,this.defaultValue.showSnippets),showUsers:h(ge.showUsers,this.defaultValue.showUsers),showIssues:h(ge.showIssues,this.defaultValue.showIssues)}}}class se extends k{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:v.localize(110,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ce extends i{constructor(){super(126,[77])}compute(Z,ge,Ne){return ge.get(77)?!0:Z.tabFocusMode}}var _e;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(_e=e.WrappingIndent||(e.WrappingIndent={}));function $e(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class fe extends i{constructor(){super(128,[127])}compute(Z,ge,Ne){const Ve=ge.get(127);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}const De="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",He="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?Re:T.isLinux?He:De,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function be(V){return e.editorOptionsRegistry[V.id]=V,V}var Ke;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingDelete=6]="autoClosingDelete",V[V.autoClosingOvertype=7]="autoClosingOvertype",V[V.autoClosingQuotes=8]="autoClosingQuotes",V[V.autoIndent=9]="autoIndent",V[V.automaticLayout=10]="automaticLayout",V[V.autoSurround=11]="autoSurround",V[V.codeLens=12]="codeLens",V[V.codeLensFontFamily=13]="codeLensFontFamily",V[V.codeLensFontSize=14]="codeLensFontSize",V[V.colorDecorators=15]="colorDecorators",V[V.columnSelection=16]="columnSelection",V[V.comments=17]="comments",V[V.contextmenu=18]="contextmenu",V[V.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",V[V.cursorBlinking=20]="cursorBlinking",V[V.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",V[V.cursorStyle=22]="cursorStyle",V[V.cursorSurroundingLines=23]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",V[V.cursorWidth=25]="cursorWidth",V[V.disableLayerHinting=26]="disableLayerHinting",V[V.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",V[V.domReadOnly=28]="domReadOnly",V[V.dragAndDrop=29]="dragAndDrop",V[V.emptySelectionClipboard=30]="emptySelectionClipboard",V[V.extraEditorClassName=31]="extraEditorClassName",V[V.fastScrollSensitivity=32]="fastScrollSensitivity",V[V.find=33]="find",V[V.fixedOverflowWidgets=34]="fixedOverflowWidgets",V[V.folding=35]="folding",V[V.foldingStrategy=36]="foldingStrategy",V[V.foldingHighlight=37]="foldingHighlight",V[V.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=39]="fontFamily",V[V.fontInfo=40]="fontInfo",V[V.fontLigatures=41]="fontLigatures",V[V.fontSize=42]="fontSize",V[V.fontWeight=43]="fontWeight",V[V.formatOnPaste=44]="formatOnPaste",V[V.formatOnType=45]="formatOnType",V[V.glyphMargin=46]="glyphMargin",V[V.gotoLocation=47]="gotoLocation",V[V.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",V[V.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",V[V.hover=50]="hover",V[V.inDiffEditor=51]="inDiffEditor",V[V.letterSpacing=52]="letterSpacing",V[V.lightbulb=53]="lightbulb",V[V.lineDecorationsWidth=54]="lineDecorationsWidth",V[V.lineHeight=55]="lineHeight",V[V.lineNumbers=56]="lineNumbers",V[V.lineNumbersMinChars=57]="lineNumbersMinChars",V[V.linkedEditing=58]="linkedEditing",V[V.links=59]="links",V[V.matchBrackets=60]="matchBrackets",V[V.minimap=61]="minimap",V[V.mouseStyle=62]="mouseStyle",V[V.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=64]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",V[V.multiCursorModifier=66]="multiCursorModifier",V[V.multiCursorPaste=67]="multiCursorPaste",V[V.occurrencesHighlight=68]="occurrencesHighlight",V[V.overviewRulerBorder=69]="overviewRulerBorder",V[V.overviewRulerLanes=70]="overviewRulerLanes",V[V.padding=71]="padding",V[V.parameterHints=72]="parameterHints",V[V.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",V[V.quickSuggestions=75]="quickSuggestions",V[V.quickSuggestionsDelay=76]="quickSuggestionsDelay",V[V.readOnly=77]="readOnly",V[V.renameOnType=78]="renameOnType",V[V.renderControlCharacters=79]="renderControlCharacters",V[V.renderIndentGuides=80]="renderIndentGuides",V[V.renderFinalNewline=81]="renderFinalNewline",V[V.renderLineHighlight=82]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=84]="renderValidationDecorations",V[V.renderWhitespace=85]="renderWhitespace",V[V.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",V[V.roundedSelection=87]="roundedSelection",V[V.rulers=88]="rulers",V[V.scrollbar=89]="scrollbar",V[V.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=91]="scrollBeyondLastLine",V[V.scrollPredominantAxis=92]="scrollPredominantAxis",V[V.selectionClipboard=93]="selectionClipboard",V[V.selectionHighlight=94]="selectionHighlight",V[V.selectOnLineNumbers=95]="selectOnLineNumbers",V[V.showFoldingControls=96]="showFoldingControls",V[V.showUnused=97]="showUnused",V[V.snippetSuggestions=98]="snippetSuggestions",V[V.smartSelect=99]="smartSelect",V[V.smoothScrolling=100]="smoothScrolling",V[V.stickyTabStops=101]="stickyTabStops",V[V.stopRenderingLineAfter=102]="stopRenderingLineAfter",V[V.suggest=103]="suggest",V[V.suggestFontSize=104]="suggestFontSize",V[V.suggestLineHeight=105]="suggestLineHeight",V[V.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",V[V.suggestSelection=107]="suggestSelection",V[V.tabCompletion=108]="tabCompletion",V[V.tabIndex=109]="tabIndex",V[V.unusualLineTerminators=110]="unusualLineTerminators",V[V.useShadowDOM=111]="useShadowDOM",V[V.useTabStops=112]="useTabStops",V[V.wordSeparators=113]="wordSeparators",V[V.wordWrap=114]="wordWrap",V[V.wordWrapBreakAfterCharacters=115]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=116]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=117]="wordWrapColumn",V[V.wordWrapOverride1=118]="wordWrapOverride1",V[V.wordWrapOverride2=119]="wordWrapOverride2",V[V.wrappingIndent=120]="wrappingIndent",V[V.wrappingStrategy=121]="wrappingStrategy",V[V.showDeprecated=122]="showDeprecated",V[V.inlayHints=123]="inlayHints",V[V.editorClassName=124]="editorClassName",V[V.pixelRatio=125]="pixelRatio",V[V.tabFocusMode=126]="tabFocusMode",V[V.layoutInfo=127]="layoutInfo",V[V.wrappingInfo=128]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:be(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:v.localize(111,null)})),acceptSuggestionOnEnter:be(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",v.localize(112,null),""],markdownDescription:v.localize(113,null)})),accessibilitySupport:be(new d),accessibilityPageSize:be(new r(3,"accessibilityPageSize",10,1,1073741824,{description:v.localize(114,null)})),ariaLabel:be(new p(4,"ariaLabel",v.localize(115,null))),autoClosingBrackets:be(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(116,null),v.localize(117,null),""],description:v.localize(118,null)})),autoClosingDelete:be(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",v.localize(119,null),""],description:v.localize(120,null)})),autoClosingOvertype:be(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",v.localize(121,null),""],description:v.localize(122,null)})),autoClosingQuotes:be(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(123,null),v.localize(124,null),""],description:v.localize(125,null)})),autoIndent:be(new l(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[v.localize(126,null),v.localize(127,null),v.localize(128,null),v.localize(129,null),v.localize(130,null)],description:v.localize(131,null)})),automaticLayout:be(new g(10,"automaticLayout",!1)),autoSurround:be(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[v.localize(132,null),v.localize(133,null),v.localize(134,null),""],description:v.localize(135,null)})),stickyTabStops:be(new g(101,"stickyTabStops",!1,{description:v.localize(136,null)})),codeLens:be(new g(12,"codeLens",!0,{description:v.localize(137,null)})),codeLensFontFamily:be(new p(13,"codeLensFontFamily","",{description:v.localize(138,null)})),codeLensFontSize:be(new r(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:v.localize(139,null)})),colorDecorators:be(new g(15,"colorDecorators",!0,{description:v.localize(140,null)})),columnSelection:be(new g(16,"columnSelection",!1,{description:v.localize(141,null)})),comments:be(new t),contextmenu:be(new g(18,"contextmenu",!0)),copyWithSyntaxHighlighting:be(new g(19,"copyWithSyntaxHighlighting",!0,{description:v.localize(142,null)})),cursorBlinking:be(new l(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],a,{description:v.localize(143,null)})),cursorSmoothCaretAnimation:be(new g(21,"cursorSmoothCaretAnimation",!1,{description:v.localize(144,null)})),cursorStyle:be(new l(22,"cursorStyle",s.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],w,{description:v.localize(145,null)})),cursorSurroundingLines:be(new r(23,"cursorSurroundingLines",0,0,1073741824,{description:v.localize(146,null)})),cursorSurroundingLinesStyle:be(new E(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[v.localize(147,null),v.localize(148,null)],description:v.localize(149,null)})),cursorWidth:be(new r(25,"cursorWidth",0,0,1073741824,{markdownDescription:v.localize(150,null)})),disableLayerHinting:be(new g(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:be(new g(27,"disableMonospaceOptimizations",!1)),domReadOnly:be(new g(28,"domReadOnly",!1)),dragAndDrop:be(new g(29,"dragAndDrop",!0,{description:v.localize(151,null)})),emptySelectionClipboard:be(new I),extraEditorClassName:be(new p(31,"extraEditorClassName","")),fastScrollSensitivity:be(new o(32,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:v.localize(152,null)})),find:be(new f),fixedOverflowWidgets:be(new g(34,"fixedOverflowWidgets",!1)),folding:be(new g(35,"folding",!0,{description:v.localize(153,null)})),foldingStrategy:be(new E(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[v.localize(154,null),v.localize(155,null)],description:v.localize(156,null)})),foldingHighlight:be(new g(37,"foldingHighlight",!0,{description:v.localize(157,null)})),unfoldOnClickAfterEndOfLine:be(new g(38,"unfoldOnClickAfterEndOfLine",!1,{description:v.localize(158,null)})),fontFamily:be(new p(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:v.localize(159,null)})),fontInfo:be(new F),fontLigatures2:be(new _),fontSize:be(new U),fontWeight:be(new z),formatOnPaste:be(new g(44,"formatOnPaste",!1,{description:v.localize(160,null)})),formatOnType:be(new g(45,"formatOnType",!1,{description:v.localize(161,null)})),glyphMargin:be(new g(46,"glyphMargin",!0,{description:v.localize(162,null)})),gotoLocation:be(new he),hideCursorInOverviewRuler:be(new g(48,"hideCursorInOverviewRuler",!1,{description:v.localize(163,null)})),highlightActiveIndentGuide:be(new g(49,"highlightActiveIndentGuide",!0,{description:v.localize(164,null)})),hover:be(new de),inDiffEditor:be(new g(51,"inDiffEditor",!1)),letterSpacing:be(new o(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>o.clamp(V,-5,20),{description:v.localize(165,null)})),lightbulb:be(new H),lineDecorationsWidth:be(new P(54,"lineDecorationsWidth",10)),lineHeight:be(new L),lineNumbers:be(new We),lineNumbersMinChars:be(new r(57,"lineNumbersMinChars",5,1,300)),linkedEditing:be(new g(58,"linkedEditing",!1,{description:v.localize(166,null)})),links:be(new g(59,"links",!0,{description:v.localize(167,null)})),matchBrackets:be(new E(60,"matchBrackets","always",["always","near","never"],{description:v.localize(168,null)})),minimap:be(new M),mouseStyle:be(new E(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:be(new o(63,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:v.localize(169,null)})),mouseWheelZoom:be(new g(64,"mouseWheelZoom",!1,{markdownDescription:v.localize(170,null)})),multiCursorMergeOverlapping:be(new g(65,"multiCursorMergeOverlapping",!0,{description:v.localize(171,null)})),multiCursorModifier:be(new l(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],$,{markdownEnumDescriptions:[v.localize(172,null),v.localize(173,null)],markdownDescription:v.localize(174,null)})),multiCursorPaste:be(new E(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[v.localize(175,null),v.localize(176,null)],markdownDescription:v.localize(177,null)})),occurrencesHighlight:be(new g(68,"occurrencesHighlight",!0,{description:v.localize(178,null)})),overviewRulerBorder:be(new g(69,"overviewRulerBorder",!0,{description:v.localize(179,null)})),overviewRulerLanes:be(new r(70,"overviewRulerLanes",3,0,3)),padding:be(new G),parameterHints:be(new J),peekWidgetDefaultFocus:be(new E(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[v.localize(180,null),v.localize(181,null)],description:v.localize(182,null)})),definitionLinkOpensInPeek:be(new g(74,"definitionLinkOpensInPeek",!1,{description:v.localize(183,null)})),quickSuggestions:be(new me),quickSuggestionsDelay:be(new r(76,"quickSuggestionsDelay",10,0,1073741824,{description:v.localize(184,null)})),readOnly:be(new g(77,"readOnly",!1)),renameOnType:be(new g(78,"renameOnType",!1,{description:v.localize(185,null),markdownDeprecationMessage:v.localize(186,null)})),renderControlCharacters:be(new g(79,"renderControlCharacters",!1,{description:v.localize(187,null)})),renderIndentGuides:be(new g(80,"renderIndentGuides",!0,{description:v.localize(188,null)})),renderFinalNewline:be(new g(81,"renderFinalNewline",!0,{description:v.localize(189,null)})),renderLineHighlight:be(new E(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",v.localize(190,null)],description:v.localize(191,null)})),renderLineHighlightOnlyWhenFocus:be(new g(83,"renderLineHighlightOnlyWhenFocus",!1,{description:v.localize(192,null)})),renderValidationDecorations:be(new E(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:be(new E(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",v.localize(193,null),v.localize(194,null),v.localize(195,null),""],description:v.localize(196,null)})),revealHorizontalRightPadding:be(new r(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:be(new g(87,"roundedSelection",!0,{description:v.localize(197,null)})),rulers:be(new ze),scrollbar:be(new q),scrollBeyondLastColumn:be(new r(90,"scrollBeyondLastColumn",5,0,1073741824,{description:v.localize(198,null)})),scrollBeyondLastLine:be(new g(91,"scrollBeyondLastLine",!0,{description:v.localize(199,null)})),scrollPredominantAxis:be(new g(92,"scrollPredominantAxis",!0,{description:v.localize(200,null)})),selectionClipboard:be(new g(93,"selectionClipboard",!0,{description:v.localize(201,null),included:T.isLinux})),selectionHighlight:be(new g(94,"selectionHighlight",!0,{description:v.localize(202,null)})),selectOnLineNumbers:be(new g(95,"selectOnLineNumbers",!0)),showFoldingControls:be(new E(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[v.localize(203,null),v.localize(204,null)],description:v.localize(205,null)})),showUnused:be(new g(97,"showUnused",!0,{description:v.localize(206,null)})),showDeprecated:be(new g(122,"showDeprecated",!0,{description:v.localize(207,null)})),inlayHints:be(new R),snippetSuggestions:be(new E(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[v.localize(208,null),v.localize(209,null),v.localize(210,null),v.localize(211,null)],description:v.localize(212,null)})),smartSelect:be(new se),smoothScrolling:be(new g(100,"smoothScrolling",!1,{description:v.localize(213,null)})),stopRenderingLineAfter:be(new r(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:be(new ee),suggestFontSize:be(new r(104,"suggestFontSize",0,0,1e3,{markdownDescription:v.localize(214,null)})),suggestLineHeight:be(new r(105,"suggestLineHeight",0,0,1e3,{markdownDescription:v.localize(215,null)})),suggestOnTriggerCharacters:be(new g(106,"suggestOnTriggerCharacters",!0,{description:v.localize(216,null)})),suggestSelection:be(new E(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[v.localize(217,null),v.localize(218,null),v.localize(219,null)],description:v.localize(220,null)})),tabCompletion:be(new E(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[v.localize(221,null),v.localize(222,null),v.localize(223,null)],description:v.localize(224,null)})),tabIndex:be(new r(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:be(new E(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[v.localize(225,null),v.localize(226,null),v.localize(227,null)],description:v.localize(228,null)})),useShadowDOM:be(new g(111,"useShadowDOM",!0)),useTabStops:be(new g(112,"useTabStops",!0,{description:v.localize(229,null)})),wordSeparators:be(new p(113,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:v.localize(230,null)})),wordWrap:be(new E(114,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[v.localize(231,null),v.localize(232,null),v.localize(233,null),v.localize(234,null)],description:v.localize(235,null)})),wordWrapBreakAfterCharacters:be(new p(115,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:be(new p(116,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:be(new r(117,"wordWrapColumn",80,1,1073741824,{markdownDescription:v.localize(236,null)})),wordWrapOverride1:be(new E(118,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:be(new E(119,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:be(new l(120,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],$e,{enumDescriptions:[v.localize(237,null),v.localize(238,null),v.localize(239,null),v.localize(240,null)],description:v.localize(241,null)})),wrappingStrategy:be(new E(121,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[v.localize(242,null),v.localize(243,null)],description:v.localize(244,null)})),editorClassName:be(new b),pixelRatio:be(new te),tabFocusMode:be(new ce),layoutInfo:be(new j),wrappingInfo:be(new fe)}}),define(ve[125],we([17,18]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[126],we([17,18]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[127],we([17,18]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(ve[128],we([17,18]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(ve[129],we([17,18]),function(Y,e){return Y.create("vs/platform/theme/common/iconRegistry",e)}),define(ve[130],we([17,18]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(ve[131],we([17,18]),function(Y,e){return Y.create("vs/workbench/api/common/extHost.api.impl",e)}),define(ve[132],we([17,18]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[133],we([17,18]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[134],we([17,18]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[135],we([17,18]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[136],we([17,18]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[137],we([17,18]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[138],we([17,18]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[139],we([17,18]),function(Y,e){return Y.create("vs/workbench/common/views",e)}),define(ve[140],we([17,18]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[141],we([17,18]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ve[142],we([17,18]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ve[143],we([17,18]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[144],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var v;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(v=e.EditorActivation||(e.EditorActivation={}));var T;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(T=e.EditorOverride||(e.EditorOverride={}));var D;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(D=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ve[145],we([0,1,126]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function A(h){return h=h.trim(),h==="*"||T.test(h)}e.isValidVersionStr=A;function y(h){if(!A(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=h.match(T);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=y;function C(h){if(!h)return null;let g=h.majorBase,r=h.majorMustEqual,o=h.minorBase,p=h.minorMustEqual,m=h.patchBase,E=h.patchMustEqual;h.hasCaret&&(g===0||(p=!1),E=!1);let l=0;if(h.preRelease){const c=D.exec(h.preRelease);if(c){const[,d,t,n]=c;l=Date.UTC(Number(d),Number(t)-1,Number(n))}}return{majorBase:g,majorMustEqual:r,minorBase:o,minorMustEqual:p,patchBase:m,patchMustEqual:E,isMinimum:h.hasGreaterEquals,notBefore:l}}e.normalizeVersion=C;function S(h,g,r){let o;typeof h=="string"?o=C(y(h)):o=h;let p;g instanceof Date?p=g.getTime():typeof g=="string"&&(p=new Date(g).getTime());let m;if(typeof r=="string"?m=C(y(r)):m=r,!o||!m)return!1;let E=o.majorBase,l=o.minorBase,c=o.patchBase,d=m.majorBase,t=m.minorBase,n=m.patchBase,a=m.notBefore,s=m.majorMustEqual,u=m.minorMustEqual,w=m.patchMustEqual;return m.isMinimum?E>d?!0:E<d?!1:l>t?!0:l<t||p&&p<a?!1:c>=n:(E===1&&d===0&&(!s||!u||!w)&&(d=1,t=0,n=0,s=!0,u=!1,w=!1),E<d?!1:E>d?!s:l<t?!1:l>t?!u:c<n?!1:c>n?!w:!(p&&p<a))}e.isValidVersion=S;function k(h,g,r,o){return r.isBuiltin||typeof r.main=="undefined"?!0:P(h,g,r.engines.vscode,o)}e.isValidExtensionVersion=k;function i(h,g,r){return h==="*"||P(g,r,h)}e.isEngineValid=i;function P(h,g,r,o=[]){let p=C(y(r));if(!p)return o.push(v.localize(0,null,r)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return o.push(v.localize(1,null,r)),!1}else if(!p.majorMustEqual)return o.push(v.localize(2,null,r)),!1;return S(h,g,p)?!0:(o.push(v.localize(3,null,h,r)),!1)}}),define(ve[90],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(A,y=[],C=!1){this.ctor=A,this.staticArguments=y,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=v;const T=(D,...A)=>new v(D,A);e.createSyncDescriptor=T}),define(ve[61],we([0,1,90]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const T=[];function D(y,C,S){C instanceof v.SyncDescriptor||(C=new v.SyncDescriptor(C,[],S)),T.push([y,C])}e.registerSingleton=D;function A(){return T}e.getSingletonServiceDescriptors=A}),define(ve[146],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=v;class T{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let y of this._nodes.values())y.outgoing.size===0&&A.push(y);return A}insertEdge(A,y){const C=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(y);C.outgoing.set(this._hashFn(y),S),S.incoming.set(this._hashFn(A),C)}removeNode(A){const y=this._hashFn(A);this._nodes.delete(y);for(let C of this._nodes.values())C.outgoing.delete(y),C.incoming.delete(y)}lookupOrInsertNode(A){const y=this._hashFn(A);let C=this._nodes.get(y);return C||(C=new v(A),this._nodes.set(y,C)),C}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[y,C]of this._nodes)A.push(`${y}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,y]of this._nodes){const C=new Set([A]),S=this._findCycle(y,C);if(S)return S}}_findCycle(A,y){for(let[C,S]of A.outgoing){if(y.has(C))return[...y,C].join(" -> ");y.add(C);const k=this._findCycle(S,y);if(k)return k;y.delete(C)}}}e.Graph=T}),define(ve[4],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function S(k){return k[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=S})(v=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function T(C,S,k,i){S[v.DI_TARGET]===S?S[v.DI_DEPENDENCIES].push({id:C,index:k,optional:i}):(S[v.DI_DEPENDENCIES]=[{id:C,index:k,optional:i}],S[v.DI_TARGET]=S)}function D(C){if(v.serviceIds.has(C))return v.serviceIds.get(C);const S=function(k,i,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(S,k,P,!1)};return S.toString=()=>C,v.serviceIds.set(C,S),S}e.createDecorator=D;function A(C){return C}e.refineServiceDecorator=A;function y(C){return function(S,k,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");T(C,S,i,!0)}}e.optional=y}),define(ve[147],we([0,1,4]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,v.createDecorator)("modelService");function T(D){return!D.isTooLargeForSyncing()&&!D.isForSimpleWidget}e.shouldSynchronizeModel=T}),define(ve[148],we([0,1,3,56,6,22,82,59,147]),function(Y,e,v,T,D,A,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(h){return typeof h=="string"?!1:Array.isArray(h)?h.every(k):!!h.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new v.Emitter}get onDidChange(){return this._onDidChange.event}register(g,r){let o={selector:g,provider:r,_score:-1,_time:this._clock++};return this._entries.push(o),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,D.toDisposable)(()=>{if(o){let p=this._entries.indexOf(o);p>=0&&(this._entries.splice(p,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),o=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const r=[];for(let o of this._entries)o._score>0&&r.push(o.provider);return r}ordered(g){const r=[];return this._orderedForEach(g,o=>r.push(o.provider)),r}orderedGroups(g){const r=[];let o,p;return this._orderedForEach(g,m=>{o&&p===m._score?o.push(m.provider):(p=m._score,o=[m.provider],r.push(o))}),r}_orderedForEach(g,r){if(!!g){this._updateScores(g);for(const o of this._entries)o._score>0&&r(o)}}_updateScores(g){let r={uri:g.uri.toString(),language:g.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===r.language&&this._lastCandidate.uri===r.uri)){this._lastCandidate=r;for(let o of this._entries)if(o._score=(0,C.score)(o.selector,g.uri,g.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(g)),k(o.selector)&&o._score>0){for(let p of this._entries)p._score=0;o._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(g,r){return g._score<r._score?1:g._score>r._score?-1:g._time<r._time?1:g._time>r._time?-1:0}}e.LanguageFeatureRegistry=i;class P{constructor(g,r,o=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=r,this.max=o,this._cache=new A.LRUCache(50,.7)}_key(g){return g.id+(0,T.hash)(this._registry.all(g))}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const r=this._key(g),o=this._cache.get(r);return this._clamp(o==null?void 0:o.value)}update(g,r){const o=this._key(g);let p=this._cache.get(o);return p||(p=new y.MovingAverage,this._cache.set(o,p)),p.update(r),this.get(g)}}e.LanguageFeatureRequestDelays=P}),define(ve[62],we([0,1,2,32,148,120,36]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(f){f[f.Null=0]="Null",f[f.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class S{constructor(_,F){this.language=_,this.id=F}}e.LanguageIdentifier=S;var k;(function(f){f[f.NotSet=-1]="NotSet",f[f.None=0]="None",f[f.Italic=1]="Italic",f[f.Bold=2]="Bold",f[f.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var i;(function(f){f[f.None=0]="None",f[f.DefaultForeground=1]="DefaultForeground",f[f.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var P;(function(f){f[f.Other=0]="Other",f[f.Comment=1]="Comment",f[f.String=2]="String",f[f.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var h;(function(f){f[f.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",f[f.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",f[f.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",f[f.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",f[f.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",f[f.ITALIC_MASK=2048]="ITALIC_MASK",f[f.BOLD_MASK=4096]="BOLD_MASK",f[f.UNDERLINE_MASK=8192]="UNDERLINE_MASK",f[f.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",f[f.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",f[f.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",f[f.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",f[f.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",f[f.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",f[f.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",f[f.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",f[f.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",f[f.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(h=e.MetadataConsts||(e.MetadataConsts={}));class g{static getLanguageId(_){return(_&255)>>>0}static getTokenType(_){return(_&1792)>>>8}static getFontStyle(_){return(_&14336)>>>11}static getForeground(_){return(_&8372224)>>>14}static getBackground(_){return(_&4286578688)>>>23}static getClassNameFromMetadata(_){let F=this.getForeground(_),U="mtk"+F,z=this.getFontStyle(_);return z&1&&(U+=" mtki"),z&2&&(U+=" mtkb"),z&4&&(U+=" mtku"),U}static getInlineStyleFromMetadata(_,F){const U=this.getForeground(_),z=this.getFontStyle(_);let he=`color: ${F[U]};`;return z&1&&(he+="font-style: italic;"),z&2&&(he+="font-weight: bold;"),z&4&&(he+="text-decoration: underline;"),he}}e.TokenMetadata=g;var r;(function(f){f[f.Method=0]="Method",f[f.Function=1]="Function",f[f.Constructor=2]="Constructor",f[f.Field=3]="Field",f[f.Variable=4]="Variable",f[f.Class=5]="Class",f[f.Struct=6]="Struct",f[f.Interface=7]="Interface",f[f.Module=8]="Module",f[f.Property=9]="Property",f[f.Event=10]="Event",f[f.Operator=11]="Operator",f[f.Unit=12]="Unit",f[f.Value=13]="Value",f[f.Constant=14]="Constant",f[f.Enum=15]="Enum",f[f.EnumMember=16]="EnumMember",f[f.Keyword=17]="Keyword",f[f.Text=18]="Text",f[f.Color=19]="Color",f[f.File=20]="File",f[f.Reference=21]="Reference",f[f.Customcolor=22]="Customcolor",f[f.Folder=23]="Folder",f[f.TypeParameter=24]="TypeParameter",f[f.User=25]="User",f[f.Issue=26]="Issue",f[f.Snippet=27]="Snippet"})(r=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let f=Object.create(null);return f[0]="symbol-method",f[1]="symbol-function",f[2]="symbol-constructor",f[3]="symbol-field",f[4]="symbol-variable",f[5]="symbol-class",f[6]="symbol-struct",f[7]="symbol-interface",f[8]="symbol-module",f[9]="symbol-property",f[10]="symbol-event",f[11]="symbol-operator",f[12]="symbol-unit",f[13]="symbol-value",f[14]="symbol-constant",f[15]="symbol-enum",f[16]="symbol-enum-member",f[17]="symbol-keyword",f[27]="symbol-snippet",f[18]="symbol-text",f[19]="symbol-color",f[20]="symbol-file",f[21]="symbol-reference",f[22]="symbol-customcolor",f[23]="symbol-folder",f[24]="symbol-type-parameter",f[25]="account",f[26]="issues",function(_){const F=f[_];let U=F&&y.iconRegistry.get(F);return U||(console.info("No codicon found for CompletionItemKind "+_),U=y.Codicon.symbolProperty),U.classNames}}(),e.completionKindFromString=function(){let f=Object.create(null);return f.method=0,f.function=1,f.constructor=2,f.field=3,f.variable=4,f.class=5,f.struct=6,f.interface=7,f.module=8,f.property=9,f.event=10,f.operator=11,f.unit=12,f.value=13,f.constant=14,f.enum=15,f["enum-member"]=16,f.enumMember=16,f.keyword=17,f.snippet=27,f.text=18,f.color=19,f.file=20,f.reference=21,f.customcolor=22,f.folder=23,f["type-parameter"]=24,f.typeParameter=24,f.account=25,f.issue=26,function(_,F){let U=f[_];return typeof U=="undefined"&&!F&&(U=9),U}}();var o;(function(f){f[f.Deprecated=1]="Deprecated"})(o=e.CompletionItemTag||(e.CompletionItemTag={}));var p;(function(f){f[f.KeepWhitespace=1]="KeepWhitespace",f[f.InsertAsSnippet=4]="InsertAsSnippet"})(p=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var m;(function(f){f[f.Invoke=0]="Invoke",f[f.TriggerCharacter=1]="TriggerCharacter",f[f.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(f){f[f.Invoke=1]="Invoke",f[f.Auto=2]="Auto"})(E=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var l;(function(f){f[f.Invoke=1]="Invoke",f[f.TriggerCharacter=2]="TriggerCharacter",f[f.ContentChange=3]="ContentChange"})(l=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var c;(function(f){f[f.Text=0]="Text",f[f.Read=1]="Read",f[f.Write=2]="Write"})(c=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function d(f){return f&&v.URI.isUri(f.uri)&&T.Range.isIRange(f.range)&&(T.Range.isIRange(f.originSelectionRange)||T.Range.isIRange(f.targetSelectionRange))}e.isLocationLink=d;var t;(function(f){f[f.File=0]="File",f[f.Module=1]="Module",f[f.Namespace=2]="Namespace",f[f.Package=3]="Package",f[f.Class=4]="Class",f[f.Method=5]="Method",f[f.Property=6]="Property",f[f.Field=7]="Field",f[f.Constructor=8]="Constructor",f[f.Enum=9]="Enum",f[f.Interface=10]="Interface",f[f.Function=11]="Function",f[f.Variable=12]="Variable",f[f.Constant=13]="Constant",f[f.String=14]="String",f[f.Number=15]="Number",f[f.Boolean=16]="Boolean",f[f.Array=17]="Array",f[f.Object=18]="Object",f[f.Key=19]="Key",f[f.Null=20]="Null",f[f.EnumMember=21]="EnumMember",f[f.Struct=22]="Struct",f[f.Event=23]="Event",f[f.Operator=24]="Operator",f[f.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(f){f[f.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var a;(function(f){const _=new Map;_.set("file",0),_.set("module",1),_.set("namespace",2),_.set("package",3),_.set("class",4),_.set("method",5),_.set("property",6),_.set("field",7),_.set("constructor",8),_.set("enum",9),_.set("interface",10),_.set("function",11),_.set("variable",12),_.set("constant",13),_.set("string",14),_.set("number",15),_.set("boolean",16),_.set("array",17),_.set("object",18),_.set("key",19),_.set("null",20),_.set("enum-member",21),_.set("struct",22),_.set("event",23),_.set("operator",24),_.set("type-parameter",25);const F=new Map;F.set(0,"file"),F.set(1,"module"),F.set(2,"namespace"),F.set(3,"package"),F.set(4,"class"),F.set(5,"method"),F.set(6,"property"),F.set(7,"field"),F.set(8,"constructor"),F.set(9,"enum"),F.set(10,"interface"),F.set(11,"function"),F.set(12,"variable"),F.set(13,"constant"),F.set(14,"string"),F.set(15,"number"),F.set(16,"boolean"),F.set(17,"array"),F.set(18,"object"),F.set(19,"key"),F.set(20,"null"),F.set(21,"enum-member"),F.set(22,"struct"),F.set(23,"event"),F.set(24,"operator"),F.set(25,"type-parameter");function U(de){return _.get(de)}f.fromString=U;function z(de){return F.get(de)}f.toString=z;function he(de,x){const j=F.get(de);let H=j&&y.iconRegistry.get("symbol-"+j);return H||(console.info("No codicon found for SymbolKind "+de),H=y.Codicon.symbolProperty),`${x?"inline":"block"} ${H.classNames}`}f.toCssClassName=he})(a=e.SymbolKinds||(e.SymbolKinds={}));class s{constructor(_){this.value=_}}e.FoldingRangeKind=s,s.Comment=new s("comment"),s.Imports=new s("imports"),s.Region=new s("region");var u;(function(f){f[f.Collapsed=0]="Collapsed",f[f.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var w;(function(f){f[f.Editing=0]="Editing",f[f.Preview=1]="Preview"})(w=e.CommentMode||(e.CommentMode={}));var b;(function(f){f[f.Other=0]="Other",f[f.Type=1]="Type",f[f.Parameter=2]="Parameter"})(b=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new D.LanguageFeatureRegistry,e.RenameProviderRegistry=new D.LanguageFeatureRegistry,e.CompletionProviderRegistry=new D.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new D.LanguageFeatureRegistry,e.HoverProviderRegistry=new D.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new D.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new D.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new D.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new D.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new D.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.LinkProviderRegistry=new D.LanguageFeatureRegistry,e.ColorProviderRegistry=new D.LanguageFeatureRegistry,e.SelectionRangeRegistry=new D.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var I;(function(f){f[f.None=0]="None",f[f.Option=1]="Option",f[f.Default=2]="Default",f[f.Preferred=3]="Preferred"})(I=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[149],we([0,1,6,10,4,3,45,43]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,D.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new A.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(S,k){if(!S)throw new Error("invalid command");if(typeof S=="string"){if(!k)throw new Error("invalid command");return this.registerCommand({id:S,handler:k})}if(S.description){const r=[];for(let p of S.description.args)r.push(p.constraint);const o=S.handler;S.handler=function(p,...m){return(0,T.validateConstraints)(m,r),o(p,...m)}}const{id:i}=S;let P=this._commands.get(i);P||(P=new y.LinkedList,this._commands.set(i,P));let h=P.unshift(S),g=(0,v.toDisposable)(()=>{h();const r=this._commands.get(i);(r==null?void 0:r.isEmpty())&&this._commands.delete(i)});return this._onDidRegisterCommand.fire(i),g}registerCommandAlias(S,k){return e.CommandsRegistry.registerCommand(S,(i,...P)=>i.get(e.ICommandService).executeCommand(k,...P))}getCommand(S){const k=this._commands.get(S);if(!(!k||k.isEmpty()))return C.Iterable.first(k)}getCommands(){const S=new Map;for(const k of this._commands.keys()){const i=this.getCommand(k);i&&S.set(k,i)}return S}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>v.Disposable.None,onDidExecuteCommand:()=>v.Disposable.None,executeCommand(){return Promise.resolve(void 0)}},e.CommandsRegistry.registerCommand("noop",()=>{})}),define(ve[63],we([0,1,8,4,21]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=D.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",D.isMacintosh),y.set("isLinux",D.isLinux),y.set("isWindows",D.isWindows),y.set("isWeb",D.isWeb),y.set("isMacNative",D.isMacintosh&&!D.isWeb),y.set("isEdge",A.indexOf("Edg/")>=0),y.set("isFirefox",A.indexOf("Firefox")>=0),y.set("isChrome",A.indexOf("Chrome")>=0),y.set("isSafari",A.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var S;(function(f){f[f.False=0]="False",f[f.True=1]="True",f[f.Defined=2]="Defined",f[f.Not=3]="Not",f[f.Equals=4]="Equals",f[f.NotEquals=5]="NotEquals",f[f.And=6]="And",f[f.Regex=7]="Regex",f[f.NotRegex=8]="NotRegex",f[f.Or=9]="Or",f[f.In=10]="In",f[f.NotIn=11]="NotIn",f[f.Greater=12]="Greater",f[f.GreaterEquals=13]="GreaterEquals",f[f.Smaller=14]="Smaller",f[f.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return P.INSTANCE}static true(){return h.INSTANCE}static has(_){return g.create(_)}static equals(_,F){return r.create(_,F)}static notEquals(_,F){return m.create(_,F)}static regex(_,F){return n.create(_,F)}static in(_,F){return o.create(_,F)}static not(_){return E.create(_)}static and(..._){return s.create(_)}static or(..._){return u.create(_)}static greater(_,F){return l.create(_,F)}static less(_,F){return d.create(_,F)}static deserialize(_,F=!1){if(!!_)return this._deserializeOrExpression(_,F)}static _deserializeOrExpression(_,F){let U=_.split("||");return u.create(U.map(z=>this._deserializeAndExpression(z,F)))}static _deserializeAndExpression(_,F){let U=_.split("&&");return s.create(U.map(z=>this._deserializeOne(z,F)))}static _deserializeOne(_,F){if(_=_.trim(),_.indexOf("!=")>=0){let U=_.split("!=");return m.create(U[0].trim(),this._deserializeValue(U[1],F))}if(_.indexOf("==")>=0){let U=_.split("==");return r.create(U[0].trim(),this._deserializeValue(U[1],F))}if(_.indexOf("=~")>=0){let U=_.split("=~");return n.create(U[0].trim(),this._deserializeRegexValue(U[1],F))}if(_.indexOf(" in ")>=0){let U=_.split(" in ");return o.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(_)){const U=_.split(">=");return c.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(_)){const U=_.split(">");return l.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(_)){const U=_.split("<=");return t.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(_)){const U=_.split("<");return d.create(U[0].trim(),U[1].trim())}return/^\!\s*/.test(_)?E.create(_.substr(1).trim()):g.create(_)}static _deserializeValue(_,F){if(_=_.trim(),_==="true")return!0;if(_==="false")return!1;let U=/^'([^']*)'$/.exec(_);return U?U[1].trim():_}static _deserializeRegexValue(_,F){if((0,v.isFalsyOrWhitespace)(_)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let U=_.indexOf("/"),z=_.lastIndexOf("/");if(U===z||U<0){if(F)throw new Error(`bad regexp-value '${_}', missing /-enclosure`);return console.warn(`bad regexp-value '${_}', missing /-enclosure`),null}let he=_.slice(U+1,z),de=_[z+1]==="i"?"i":"";try{return new RegExp(he,de)}catch(x){if(F)throw new Error(`bad regexp-value '${_}', parse error: ${x}`);return console.warn(`bad regexp-value '${_}', parse error: ${x}`),null}}}e.ContextKeyExpr=k;function i(f,_){return f.cmp(_)}class P{constructor(){this.type=0}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}evaluate(_){return!1}serialize(){return"false"}keys(){return[]}map(_){return this}negate(){return h.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class h{constructor(){this.type=1}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}evaluate(_){return!0}serialize(){return"true"}keys(){return[]}map(_){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=h,h.INSTANCE=new h;class g{constructor(_){this.key=_,this.type=2}static create(_){const F=y.get(_);return typeof F=="boolean"?F?h.INSTANCE:P.INSTANCE:new g(_)}cmp(_){return _.type!==this.type?this.type-_.type:b(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}evaluate(_){return!!_.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(_){return _.mapDefined(this.key)}negate(){return E.create(this.key)}}e.ContextKeyDefinedExpr=g;class r{constructor(_,F){this.key=_,this.value=F,this.type=4}static create(_,F){if(typeof F=="boolean")return F?g.create(_):E.create(_);const U=y.get(_);return typeof U=="boolean"?F===(U?"true":"false")?h.INSTANCE:P.INSTANCE:new r(_,F)}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return _.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(_){return _.mapEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeyEqualsExpr=r;class o{constructor(_,F){this.key=_,this.valueKey=F,this.type=10}static create(_,F){return new o(_,F)}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,this.valueKey,_.key,_.valueKey)}equals(_){return _.type===this.type?this.key===_.key&&this.valueKey===_.valueKey:!1}evaluate(_){const F=_.getValue(this.valueKey),U=_.getValue(this.key);return Array.isArray(F)?F.indexOf(U)>=0:typeof U=="string"&&typeof F=="object"&&F!==null?C.call(F,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(_){return _.mapIn(this.key,this.valueKey)}negate(){return p.create(this)}}e.ContextKeyInExpr=o;class p{constructor(_){this._actual=_,this.type=11}static create(_){return new p(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new p(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotInExpr=p;class m{constructor(_,F){this.key=_,this.value=F,this.type=5}static create(_,F){if(typeof F=="boolean")return F?E.create(_):g.create(_);const U=y.get(_);return typeof U=="boolean"?F===(U?"true":"false")?P.INSTANCE:h.INSTANCE:new m(_,F)}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return _.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(_){return _.mapNotEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=m;class E{constructor(_){this.key=_,this.type=3}static create(_){const F=y.get(_);return typeof F=="boolean"?F?P.INSTANCE:h.INSTANCE:new E(_)}cmp(_){return _.type!==this.type?this.type-_.type:b(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}evaluate(_){return!_.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(_){return _.mapNot(this.key)}negate(){return g.create(this.key)}}e.ContextKeyNotExpr=E;class l{constructor(_,F){this.key=_,this.value=F,this.type=12}static create(_,F){return new l(_,F)}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=l;class c{constructor(_,F){this.key=_,this.value=F,this.type=13}static create(_,F){return new c(_,F)}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreaterEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=c;class d{constructor(_,F){this.key=_,this.value=F,this.type=14}static create(_,F){return new d(_,F)}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmaller(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerExpr=d;class t{constructor(_,F){this.key=_,this.value=F,this.type=15}static create(_,F){return new t(_,F)}cmp(_){return _.type!==this.type?this.type-_.type:I(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmallerEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(_,F){this.key=_,this.regexp=F,this.type=7}static create(_,F){return new n(_,F)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.key<_.key)return-1;if(this.key>_.key)return 1;const F=this.regexp?this.regexp.source:"",U=_.regexp?_.regexp.source:"";return F<U?-1:F>U?1:0}equals(_){if(_.type===this.type){const F=this.regexp?this.regexp.source:"",U=_.regexp?_.regexp.source:"";return this.key===_.key&&F===U}return!1}evaluate(_){let F=_.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const _=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${_}`}keys(){return[this.key]}map(_){return _.mapRegex(this.key,this.regexp)}negate(){return a.create(this)}}e.ContextKeyRegexExpr=n;class a{constructor(_){this._actual=_,this.type=8}static create(_){return new a(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new a(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=a;class s{constructor(_){this.expr=_,this.type=6}static create(_){return s._normalizeArr(_)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let F=0,U=this.expr.length;F<U;F++){const z=i(this.expr[F],_.expr[F]);if(z!==0)return z}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].equals(_.expr[F]))return!1;return!0}return!1}evaluate(_){for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].evaluate(_))return!1;return!0}static _normalizeArr(_){const F=[];let U=!1;for(const z of _)if(!!z){if(z.type===1){U=!0;continue}if(z.type===0)return P.INSTANCE;if(z.type===6){F.push(...z.expr);continue}F.push(z)}if(F.length===0&&U)return h.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];for(F.sort(i);F.length>1;){const z=F[F.length-1];if(z.type!==9)break;F.pop();const he=F.pop(),de=u.create(z.expr.map(x=>s.create([x,he])));de&&(F.push(de),F.sort(i))}return F.length===1?F[0]:new s(F)}}serialize(){return this.expr.map(_=>_.serialize()).join(" && ")}keys(){const _=[];for(let F of this.expr)_.push(...F.keys());return _}map(_){return new s(this.expr.map(F=>F.map(_)))}negate(){let _=[];for(let F of this.expr)_.push(F.negate());return u.create(_)}}e.ContextKeyAndExpr=s;class u{constructor(_){this.expr=_,this.type=9}static create(_){const F=u._normalizeArr(_);if(F.length!==0)return F.length===1?F[0]:new u(F)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let F=0,U=this.expr.length;F<U;F++){const z=i(this.expr[F],_.expr[F]);if(z!==0)return z}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].equals(_.expr[F]))return!1;return!0}return!1}evaluate(_){for(let F=0,U=this.expr.length;F<U;F++)if(this.expr[F].evaluate(_))return!0;return!1}static _normalizeArr(_){let F=[],U=!1;if(_){for(let z=0,he=_.length;z<he;z++){const de=_[z];if(!!de){if(de.type===0){U=!0;continue}if(de.type===1)return[h.INSTANCE];if(de.type===9){F=F.concat(de.expr);continue}F.push(de)}}if(F.length===0&&U)return[P.INSTANCE];F.sort(i)}return F}serialize(){return this.expr.map(_=>_.serialize()).join(" || ")}keys(){const _=[];for(let F of this.expr)_.push(...F.keys());return _}map(_){return new u(this.expr.map(F=>F.map(_)))}negate(){let _=[];for(let U of this.expr)_.push(U.negate());const F=U=>U.type===9?U.expr:[U];for(;_.length>1;){const U=_.shift(),z=_.shift(),he=[];for(const de of F(U))for(const x of F(z))he.push(k.and(de,x));_.unshift(k.or(...he))}return _[0]}}e.ContextKeyOrExpr=u;class w extends g{constructor(_,F,U){super(_);this._defaultValue=F,typeof U=="object"?w._info.push(Object.assign(Object.assign({},U),{key:_})):U!==!0&&w._info.push({key:_,description:U,type:F!=null?typeof F:void 0})}static all(){return w._info.values()}bindTo(_){return _.createKey(this.key,this._defaultValue)}getValue(_){return _.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(_){return k.equals(this.key,_)}notEqualsTo(_){return k.notEquals(this.key,_)}}e.RawContextKey=w,w._info=[],e.IContextKeyService=(0,T.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function b(f,_){return f<_?-1:f>_?1:0}function I(f,_,F,U){return f<F?-1:f>F?1:_<U?-1:_>U?1:0}}),define(ve[150],we([0,1,4]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[26],we([0,1,8,4]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function D(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class y{constructor(i){this.value=i,this._lower=i.toLowerCase()}static equals(i,P){if(typeof i=="undefined"||i===null)return typeof P=="undefined"||P===null;if(typeof P=="undefined"||P===null)return!1;if(typeof i=="string"||typeof P=="string"){let h=typeof i=="string"?i:i.value,g=typeof P=="string"?P:P.value;return v.equalsIgnoreCase(h,g)}return i._lower===P._lower}static toKey(i){return typeof i=="string"?i.toLowerCase():i._lower}}e.ExtensionIdentifier=y;function C(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function S(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=S,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[151],we([0,1,8,26]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(g,r){return g.uuid&&r.uuid?g.uuid===r.uuid:g.id===r.id?!0:(0,v.compareIgnoreCase)(g.id,r.id)===0}e.areSameExtensions=D;class A{constructor(r,o){this.version=o,this.id=r.id,this.uuid=r.uuid}key(){return`${this.id}-${this.version}`}equals(r){return r instanceof A?D(this,r)&&this.version===r.version:!1}}e.ExtensionIdentifierWithVersion=A;function y(g,r){return`${g}.${r}`}e.getExtensionId=y;function C(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function S(g,r){return C(y(g,r))}e.getGalleryExtensionId=S;function k(g,r){const o=[],p=m=>{for(const E of o)if(E.some(l=>D(r(l),r(m))))return E;return null};for(const m of g){const E=p(m);E?E.push(m):o.push([m])}return o}e.groupByExtension=k;function i(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function P(g){return Object.assign({id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0)},g.telemetryData)}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function h(g){const r=new Set;for(const o of g)o.malicious&&r.add(o.id.id);return r}e.getMaliciousExtensionsSet=h}),define(ve[64],we([0,1,127,14,2,4,8,10,22]),function(Y,e,v,T,D,A,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,A.createDecorator)("fileService");function k(x){return x.create===!0}e.isFileOpenForWriteOptions=k;var i;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var P;(function(x){x[x.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var h;(function(x){x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock"})(h=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(x){return!!(x.capabilities&2)}e.hasReadWriteCapability=g;function r(x){return!!(x.capabilities&8)}e.hasFileFolderCopyCapability=r;function o(x){return!!(x.capabilities&4)}e.hasOpenReadWriteCloseCapability=o;function p(x){return!!(x.capabilities&16)}e.hasFileReadStreamCapability=p;var m;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(j,H){super(j);this.code=H}}e.FileSystemProviderError=E;function l(x,j){const H=new E(x.toString(),j);return d(H,j),H}e.createFileSystemProviderError=l;function c(x){return x||l((0,v.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=c;function d(x,j){return x.name=j?`${j} (FileSystemError)`:"FileSystemError",x}e.markAsFileSystemProviderError=d;function t(x){if(!x)return m.Unknown;if(x instanceof E)return x.code;const j=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!j)return m.Unknown;switch(j[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=t;function n(x){if(x instanceof I)return x.fileOperationResult;switch(t(x)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var a;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY"})(a=e.FileOperation||(e.FileOperation={}));class s{constructor(j,H,R){this.resource=j,this.operation=H,this.target=R}isOperation(j){return this.operation===j}}e.FileOperationEvent=s;var u;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class w{constructor(j,H){this.ignorePathCasing=H,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=j;for(const R of j)switch(R.type){case 1:this.added||(this.added=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(R.resource,R);break;case 0:this.updated||(this.updated=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(R.resource,R);break;case 2:this.deleted||(this.deleted=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(R.resource,R);break}}contains(j,...H){return this.doContains(j,{includeChildren:!1},...H)}affects(j,...H){return this.doContains(j,{includeChildren:!0},...H)}doContains(j,H,...R){var L,M,$,G,J,te;if(!j)return!1;const me=R.length>0;return!!((!me||R.includes(1))&&(((L=this.added)===null||L===void 0?void 0:L.get(j))||H.includeChildren&&((M=this.added)===null||M===void 0?void 0:M.findSuperstr(j)))||(!me||R.includes(0))&&((($=this.updated)===null||$===void 0?void 0:$.get(j))||H.includeChildren&&((G=this.updated)===null||G===void 0?void 0:G.findSuperstr(j)))||(!me||R.includes(2))&&(((J=this.deleted)===null||J===void 0?void 0:J.findSubstr(j))||H.includeChildren&&((te=this.deleted)===null||te===void 0?void 0:te.findSuperstr(j))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(j){const H=[],R=j===1?this.added:j===0?this.updated:this.deleted;if(R)for(const[,L]of R)H.push(L);return H}filter(j){return new w(this.changes.filter(H=>j(H)),this.ignorePathCasing)}}e.FileChangesEvent=w;function b(x,j,H){return!x||!j||x===j||j.length>x.length?!1:(j.charAt(j.length-1)!==T.sep&&(j+=T.sep),H?(0,y.startsWithIgnoreCase)(x,j):x.indexOf(j)===0)}e.isParent=b;class I extends Error{constructor(j,H,R){super(j);this.fileOperationResult=H,this.options=R}static isFileOperationError(j){return j instanceof Error&&!(0,C.isUndefinedOrNull)(j.fileOperationResult)}}e.FileOperationError=I;var f;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",x[x.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(f=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.etag=F;async function U(x,j){if(!j.canHandleResource(D.URI.from({scheme:x.scheme})))return new Promise(H=>{const R=j.onDidChangeFileSystemProviderRegistrations(L=>{L.scheme===x.scheme&&L.added&&(R.dispose(),H())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(j){return(0,C.isNumber)(j)||(j=0),j<z.KB?(0,v.localize)(1,null,j.toFixed(0)):j<z.MB?(0,v.localize)(2,null,(j/z.KB).toFixed(2)):j<z.GB?(0,v.localize)(3,null,(j/z.MB).toFixed(2)):j<z.TB?(0,v.localize)(4,null,(j/z.GB).toFixed(2)):(0,v.localize)(5,null,(j/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var he;(function(x){x[x.IA32=0]="IA32",x[x.OTHER=1]="OTHER"})(he=e.Arch||(e.Arch={}));function de(x){return{maxFileSize:x===0?300*z.MB:16*z.GB,maxHeapSize:x===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=de}),define(ve[65],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...D){this._entries=new Map;for(let[A,y]of D)this.set(A,y)}set(D,A){const y=this._entries.get(D);return this._entries.set(D,A),y}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=v}),define(ve[152],we([0,1,12,146,90,4,65,11]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class k extends Error{constructor(r){var o;super("cyclic dependency between services");this.message=(o=r.findCycleSlow())!==null&&o!==void 0?o:`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class i{constructor(r=new y.ServiceCollection,o=!1,p){this._activeInstantiations=new Set,this._services=r,this._strict=o,this._parent=p,this._services.set(A.IInstantiationService,this)}createChild(r){return new i(r,this._strict,this)}invokeFunction(r,...o){let p=h.traceInvocation(r),m=!1;try{return r({get:(l,c)=>{if(m)throw(0,v.illegalState)("service accessor is only valid during the invocation of its target method");const d=this._getOrCreateServiceInstance(l,p);if(!d&&c!==A.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return d}},...o)}finally{m=!0,p.stop()}}createInstance(r,...o){let p,m;return r instanceof D.SyncDescriptor?(p=h.traceCreation(r.ctor),m=this._createInstance(r.ctor,r.staticArguments.concat(o),p)):(p=h.traceCreation(r),m=this._createInstance(r,o,p)),p.stop(),m}_createInstance(r,o=[],p){let m=A._util.getServiceDependencies(r).sort((c,d)=>c.index-d.index),E=[];for(const c of m){let d=this._getOrCreateServiceInstance(c.id,p);if(!d&&this._strict&&!c.optional)throw new Error(`[createInstance] ${r.name} depends on UNKNOWN service ${c.id}.`);E.push(d)}let l=m.length>0?m[0].index:o.length;if(o.length!==l){console.warn(`[createInstance] First service dependency of ${r.name} at position ${l+1} conflicts with ${o.length} static arguments`);let c=l-o.length;c>0?o=o.concat(new Array(c)):o=o.slice(0,l)}return new r(...[...o,...E])}_setServiceInstance(r,o){if(this._services.get(r)instanceof D.SyncDescriptor)this._services.set(r,o);else if(this._parent)this._parent._setServiceInstance(r,o);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let o=this._services.get(r);return!o&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):o}_getOrCreateServiceInstance(r,o){let p=this._getServiceInstanceOrDescriptor(r);return p instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,p,o.branch(r,!0)):(o.branch(r,!1),p)}_safeCreateAndCacheServiceInstance(r,o,p){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,o,p)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,o,p){const m=new T.Graph(c=>c.id.toString());let E=0;const l=[{id:r,desc:o,_trace:p}];for(;l.length;){const c=l.pop();if(m.lookupOrInsertNode(c),E++>1e3)throw new k(m);for(let d of A._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(d.id);if(!t&&!d.optional&&console.warn(`[createInstance] ${r} depends on ${d.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const n={id:d.id,desc:t,_trace:c._trace.branch(d.id,!0)};m.insertEdge(c,n),l.push(n)}}}for(;;){const c=m.roots();if(c.length===0){if(!m.isEmpty())throw new k(m);break}for(const{data:d}of c){if(this._getServiceInstanceOrDescriptor(d.id)instanceof D.SyncDescriptor){const n=this._createServiceInstanceWithOwner(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this._setServiceInstance(d.id,n)}m.removeNode(d)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,o,p=[],m,E){if(this._services.get(r)instanceof D.SyncDescriptor)return this._createServiceInstance(o,p,m,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,o,p,m,E);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}_createServiceInstance(r,o=[],p,m){if(p){const E=new C.IdleValue(()=>this._createInstance(r,o,m));return new Proxy(Object.create(null),{get(l,c){if(c in l)return l[c];let d=E.value,t=d[c];return typeof t!="function"||(t=t.bind(d),l[c]=t),t},set(l,c,d){return E.value[c]=d,!0}})}else return this._createInstance(r,o,m)}}e.InstantiationService=i;var P;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(P||(P={}));class h{constructor(r,o){this.type=r,this.name=o,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return S?new h(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(r){return S?new h(0,r.name):h._None}branch(r,o){let p=new h(2,r.toString());return this._dep.push([r,o,p]),p}stop(){let r=Date.now()-this._start;h._totals+=r;let o=!1;function p(E,l){let c=[],d=new Array(E+1).join("	");for(const[t,n,a]of l._dep)if(n&&a){o=!0,c.push(`${d}CREATES -> ${t}`);let s=p(E+1,a);s&&c.push(s)}else c.push(`${d}uses -> ${t}`);return c.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(r>2||o)&&console.log(m.join(`
`))}}h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(ve[16],we([0,1,4,6,21,3,60]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function C(){return new Date().toISOString()}var S;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class k extends T.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class i extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(S.Error))if(t instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=t.stack,this.log(S.Error,this.format(a))}else this.log(S.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let a=0;a<t.length;a++){let s=t[a];if(typeof s=="object")try{s=JSON.stringify(s)}catch(u){}n+=(a>0?" ":"")+s}return n}}e.AbstractMessageLogger=i;class P extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!D.isWindows}trace(t,...n){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}debug(t,...n){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}info(t,...n){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}warn(t,...n){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...n):console.warn(`[main ${C()}]`,t,...n))}error(t,...n){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...n):console.error(`[main ${C()}]`,t,...n))}critical(t,...n){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...n):console.error(`[main ${C()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class h extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=h;class g extends k{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,y.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class r extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const a of this.logServices)a.trace(t,...n)}debug(t,...n){for(const a of this.logServices)a.debug(t,...n)}info(t,...n){for(const a of this.logServices)a.info(t,...n)}warn(t,...n){for(const a of this.logServices)a.warn(t,...n)}error(t,...n){for(const a of this.logServices)a.error(t,...n)}critical(t,...n){for(const a of this.logServices)a.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=r;class o extends T.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=o;class p extends T.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(a=>{this.logLevel=a,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(a))}))}createLogger(t,n){let a=this.loggers.get(t.toString());return a||(a=this.doCreateLogger(t,(n==null?void 0:n.always)?S.Trace:this.logLevel,n),this.loggers.set(t.toString(),a),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(a)),a}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class m{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=m;function E(d){if(d.verbose)return S.Trace;if(typeof d.logLevel=="string"){const t=l(d.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function l(d){switch(d){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=l;function c(d){switch(d){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=c}),define(ve[91],we([0,1,4,128,47]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var y;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function k(r,o){return o-r}S.compare=k;const i=Object.create(null);i[S.Error]=(0,T.localize)(0,null),i[S.Warning]=(0,T.localize)(1,null),i[S.Info]=(0,T.localize)(2,null);function P(r){return i[r]||""}S.toString=P;function h(r){switch(r){case D.default.Error:return S.Error;case D.default.Warning:return S.Warning;case D.default.Info:return S.Info;case D.default.Ignore:return S.Hint}}S.fromSeverity=h;function g(r){switch(r){case S.Error:return D.default.Error;case S.Warning:return D.default.Warning;case S.Info:return D.default.Info;case S.Hint:return D.default.Ignore}}S.toSeverity=g}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(S){const k="";function i(h){return P(h,!0)}S.makeKey=i;function P(h,g){let r=[k];return h.source?r.push(h.source.replace("\xA6","\\\xA6")):r.push(k),h.code?typeof h.code=="string"?r.push(h.code.replace("\xA6","\\\xA6")):r.push(h.code.value.replace("\xA6","\\\xA6")):r.push(k),h.severity!==void 0&&h.severity!==null?r.push(y.toString(h.severity)):r.push(k),h.message&&g?r.push(h.message.replace("\xA6","\\\xA6")):r.push(k),h.startLineNumber!==void 0&&h.startLineNumber!==null?r.push(h.startLineNumber.toString()):r.push(k),h.startColumn!==void 0&&h.startColumn!==null?r.push(h.startColumn.toString()):r.push(k),h.endLineNumber!==void 0&&h.endLineNumber!==null?r.push(h.endLineNumber.toString()):r.push(k),h.endColumn!==void 0&&h.endColumn!==null?r.push(h.endColumn.toString()):r.push(k),r.push(k),r.join("\xA6")}S.makeKeyOptionalMessage=P})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,v.createDecorator)("markerService")}),define(ve[153],we([0,1,47,4,3]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=v.default,e.INotificationService=(0,T.createDecorator)("notificationService");var A;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new S,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=C;class S{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=S});var je=this&&this.__decorate||function(Y,e,v,T){var D=arguments.length,A=D<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,v):T,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(Y,e,v,T);else for(var C=Y.length-1;C>=0;C--)(y=Y[C])&&(A=(D<3?y(A):D>3?y(e,v,A):y(e,v))||A);return D>3&&A&&Object.defineProperty(e,v,A),A},qe=this&&this.__param||function(Y,e){return function(v,T){e(v,T,Y)}};define(ve[154],we([0,1,4,20,6,11]),function(Y,e,v,T,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,v.createDecorator)("progressService");var y;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let S=class extends D.Disposable{constructor(P,h){super();this.deferred=new A.DeferredPromise,h.withProgress(P,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};S=je([qe(1,e.IProgressService)],S),e.UnmanagedProgress=S;class k extends D.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(P){this.stop();const h=++this.currentOperationId,g=new T.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{h===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>g.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:h,token:g.token,stop:()=>this.doStop(h),isCurrent:()=>this.currentOperationId===h}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,v.createDecorator)("editorProgressService")}),define(ve[29],we([0,1,10,42]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(y,C){T.ok(v.isString(y)),T.ok(v.isObject(C)),T.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,C)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new D}),define(ve[92],we([0,1,29,3]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class A{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,k){this.schemasById[D(S)]=k,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new A;v.Registry.add(e.Extensions.JSONContribution,y)}),define(ve[66],we([0,1,125,3,29,10,92]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const S=D.Registry.as(y.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(m,E=!0){this.registerConfigurations([m],E)}registerConfigurations(m,E=!0){const l=[];m.forEach(c=>{l.push(...this.validateAndRegisterProperties(c,E,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterConfigurations(m){const E=[],l=c=>{if(c.properties)for(const d in c.properties)E.push(d),delete this.configurationProperties[d],this.removeFromSchema(d,c.properties[d]);c.allOf&&c.allOf.forEach(d=>l(d))};for(const c of m){l(c);const d=this.configurationContributors.indexOf(c);d!==-1&&this.configurationContributors.splice(d,1)}S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}registerDefaultConfigurations(m){const E=[],l=[];for(const c of m)for(const d in c)if(E.push(d),e.OVERRIDE_PROPERTY_PATTERN.test(d)){this.defaultValues[d]=Object.assign(Object.assign({},this.defaultValues[d]||{}),c[d]);const t={type:"object",default:this.defaultValues[d],description:v.localize(1,null,d),$ref:e.resourceLanguageSettingsSchemaId};l.push(P(d)),this.configurationProperties[d]=t,this.defaultLanguageConfigurationOverridesNode.properties[d]=t}else{this.defaultValues[d]=c[d];const t=this.configurationProperties[d];t&&(this.updatePropertyDefaultValue(d,t),this.updateSchema(d,t))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}deregisterDefaultConfigurations(m){const E=[];for(const l of m)for(const c in l)if(E.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const d=this.configurationProperties[c];d&&(this.updatePropertyDefaultValue(c,d),this.updateSchema(c,d))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const E of m)this.overrideIdentifiers.add(E);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(m,E=!0,l,c=3){var d;c=A.isUndefinedOrNull(m.scope)?c:m.scope;let t=[],n=m.properties;if(n)for(let s in n){if(E&&r(s)){delete n[s];continue}const u=n[s];if(this.updatePropertyDefaultValue(s,u),e.OVERRIDE_PROPERTY_PATTERN.test(s)?u.scope=void 0:(u.scope=A.isUndefinedOrNull(u.scope)?c:u.scope,u.restricted=A.isUndefinedOrNull(u.restricted)?!!((d=l==null?void 0:l.restrictedConfigurations)===null||d===void 0?void 0:d.includes(s)):u.restricted),n[s].hasOwnProperty("included")&&!n[s].included){this.excludedConfigurationProperties[s]=n[s],delete n[s];continue}else this.configurationProperties[s]=n[s];!n[s].deprecationMessage&&n[s].markdownDeprecationMessage&&(n[s].deprecationMessage=n[s].markdownDeprecationMessage),t.push(s)}let a=m.allOf;if(a)for(let s of a)t.push(...this.validateAndRegisterProperties(s,E,l,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(m){const E=l=>{let c=l.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let d=l.allOf;d&&d.forEach(E)};E(m)}updateSchema(m,E){switch(e.allSettings.properties[m]=E,E.scope){case 1:e.applicationSettings.properties[m]=E;break;case 2:e.machineSettings.properties[m]=E;break;case 6:e.machineOverridableSettings.properties[m]=E;break;case 3:e.windowSettings.properties[m]=E;break;case 4:e.resourceSettings.properties[m]=E;break;case 5:e.resourceSettings.properties[m]=E,this.resourceLanguageSettingsSchema.properties[m]=E;break}}removeFromSchema(m,E){switch(delete e.allSettings.properties[m],E.scope){case 1:delete e.applicationSettings.properties[m];break;case 2:delete e.machineSettings.properties[m];break;case 6:delete e.machineOverridableSettings.properties[m];break;case 3:delete e.windowSettings.properties[m];break;case 4:case 5:delete e.resourceSettings.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const E=`[${m}]`,l={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(E,l),e.allSettings.properties[E]=l,e.applicationSettings.properties[E]=l,e.machineSettings.properties[E]=l,e.machineOverridableSettings.properties[E]=l,e.windowSettings.properties[E]=l,e.resourceSettings.properties[E]=l}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,E){let l=this.defaultValues[m];A.isUndefined(l)&&(l=E.default),A.isUndefined(l)&&(l=h(E.type)),E.default=l}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function P(p){return p.substring(1,p.length-1)}e.overrideIdentifierFromKey=P;function h(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const g=new k;D.Registry.add(e.Extensions.Configuration,g);function r(p){return p.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(p)?v.localize(5,null,p):g.getConfigurationProperties()[p]!==void 0?v.localize(6,null,p):null:v.localize(4,null)}e.validateProperty=r;function o(){const p=[],m=g.getConfigurationProperties();for(const E of Object.keys(m))p.push([E,m[E].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=o}),define(ve[93],we([0,1,23,10,2,29,4,66]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function S(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof D.URI)}e.isConfigurationOverrides=S;var k;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function P(n,a){const s=a?n?a.keys.filter(F=>n.keys.indexOf(F)===-1):[...a.keys]:[],u=n?a?n.keys.filter(F=>a.keys.indexOf(F)===-1):[...n.keys]:[],w=[];if(a&&n){for(const F of n.keys)if(a.keys.indexOf(F)!==-1){const U=m(n.contents,F),z=m(a.contents,F);v.equals(U,z)||w.push(F)}}const b=[],I=F=>{const U={};for(const z of F)for(const he of z.identifiers)U[d(he)]=z;return U},f=a?I(a.overrides):{},_=n?I(n.overrides):{};if(Object.keys(f).length)for(const F of s){const U=f[F];U&&b.push([(0,C.overrideIdentifierFromKey)(F),U.keys])}if(Object.keys(_).length)for(const F of u){const U=_[F];U&&b.push([(0,C.overrideIdentifierFromKey)(F),U.keys])}if(Object.keys(f).length&&Object.keys(_).length)for(const F of w){const U=_[F],z=f[F];if(U&&z){const he=P({contents:U.contents,keys:U.keys,overrides:[]},{contents:z.contents,keys:z.keys,overrides:[]});b.push([(0,C.overrideIdentifierFromKey)(F),[...he.added,...he.removed,...he.updated]])}}return{added:s,removed:u,updated:w,overrides:b}}e.compare=P;function h(n,a){const s=[];for(const u of Object.keys(n))if(C.OVERRIDE_PROPERTY_PATTERN.test(u)){const w={};for(const b in n[u])w[b]=n[u][b];s.push({identifiers:[(0,C.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(w),contents:g(w,a)})}return s}e.toOverrides=h;function g(n,a){const s=Object.create(null);for(let u in n)r(s,u,n[u],a);return s}e.toValuesTree=g;function r(n,a,s,u){const w=a.split("."),b=w.pop();let I=n;for(let f=0;f<w.length;f++){let _=w[f],F=I[_];switch(typeof F){case"undefined":F=I[_]=Object.create(null);break;case"object":break;default:u(`Ignoring ${a} as ${w.slice(0,f+1).join(".")} is ${JSON.stringify(F)}`);return}I=F}if(typeof I=="object"&&I!==null)try{I[b]=s}catch(f){u(`Ignoring ${a} as ${w.join(".")} is ${JSON.stringify(I)}`)}else u(`Ignoring ${a} as ${w.join(".")} is ${JSON.stringify(I)}`)}e.addToValueTree=r;function o(n,a){const s=a.split(".");p(n,s)}e.removeFromValueTree=o;function p(n,a){const s=a.shift();if(a.length===0){delete n[s];return}if(Object.keys(n).indexOf(s)!==-1){const u=n[s];typeof u=="object"&&!Array.isArray(u)&&(p(u,a),Object.keys(u).length===0&&delete n[s])}}function m(n,a,s){function u(I,f){let _=I;for(const F of f){if(typeof _!="object"||_===null)return;_=_[F]}return _}const w=a.split("."),b=u(n,w);return typeof b=="undefined"?s:b}e.getConfigurationValue=m;function E(n,a,s){Object.keys(a).forEach(u=>{u!=="__proto__"&&(u in n?T.isObject(n[u])&&T.isObject(a[u])?E(n[u],a[u],s):s&&(n[u]=a[u]):n[u]=a[u])})}e.merge=E;function l(){const n=A.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=l;function c(){const n=Object.create(null),a=A.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let s in a){let u=a[s].default;r(n,s,u,w=>console.error(`Conflict in default settings: ${w}`))}return n}e.getDefaultValues=c;function d(n){return`[${n}]`}e.keyFromOverrideIdentifier=d;function t(n,a,s){const u=n.inspect(a),w=n.inspect(s);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof w.userValue!="undefined"||typeof w.workspaceValue!="undefined"||typeof w.workspaceFolderValue!="undefined"?w.value:u.defaultValue}e.getMigratedSettingValue=t}),define(ve[155],we([0,1,44,22,13,10,23,2,66,93,29,6,3]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(t={},n=[],a=[]){this._contents=t,this._keys=n,this._overrides=a,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,k.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const a=this.getContentsForOverrideIdentifer(n);return a?t?(0,k.getConfigurationValue)(a,t):a:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let a={};for(const s of D.distinct([...Object.keys(this.contents),...Object.keys(n)])){let u=this.contents[s],w=n[s];w&&(typeof u=="object"&&typeof w=="object"?(u=y.deepClone(u),this.mergeContents(u,w)):u=w),a[s]=u}return new g(a,this.keys,this.overrides)}merge(...t){const n=y.deepClone(this.contents),a=y.deepClone(this.overrides),s=[...this.keys];for(const u of t){this.mergeContents(n,u.contents);for(const w of u.overrides){const[b]=a.filter(I=>D.equals(I.identifiers,w.identifiers));b?this.mergeContents(b.contents,w.contents):a.push(y.deepClone(w))}for(const w of u.keys)s.indexOf(w)===-1&&s.push(w)}return new g(n,s,a)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const a of Object.keys(n)){if(a in t&&A.isObject(t[a])&&A.isObject(n[a])){this.mergeContents(t[a],n[a]);continue}t[a]=y.deepClone(n[a])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,k.addToValueTree)(this.contents,t,n,a=>{throw new Error(a)})}removeValue(t){this.removeKey(t)&&(0,k.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let a=0;a<n;a++)t.indexOf(this.keys[a])===0&&(n=a);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=g;class r extends g{constructor(){const t=(0,k.getDefaultValues)(),n=(0,k.getConfigurationKeys)(),a=[];for(const s of Object.keys(t))S.OVERRIDE_PROPERTY_PATTERN.test(s)&&a.push({identifiers:[(0,S.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(t[s]),contents:(0,k.toValuesTree)(t[s],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,n,a)}}e.DefaultConfigurationModel=r;class o{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!A.isUndefinedOrNull(t)){const a=this.doParseContent(t);this.parseRaw(a,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:a,keys:s,overrides:u,restricted:w}=this.doParseRaw(t,n);this._configurationModel=new g(a,s,u),this._restrictedConfigurations=w||[]}doParseContent(t){let n={},a=null,s=[],u=[],w=[];function b(f){Array.isArray(s)?s.push(f):a&&(s[a]=f)}let I={onObjectBegin:()=>{let f={};b(f),u.push(s),s=f,a=null},onObjectProperty:f=>{a=f},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{let f=[];b(f),u.push(s),s=f,a=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:b,onError:(f,_,F)=>{w.push({error:f,offset:_,length:F})}};if(t)try{v.visit(t,I),n=s[0]||{}}catch(f){console.error(`Error while parsing settings file ${this._name}: ${f}`),this._parseErrors=[f]}return n}doParseRaw(t,n){const a=i.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,a,!0,n);t=s.raw;const u=(0,k.toValuesTree)(t,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),w=Object.keys(t),b=(0,k.toOverrides)(t,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:u,keys:w,overrides:b,restricted:s.restricted}}filter(t,n,a,s){if(!(s==null?void 0:s.scopes)&&!(s==null?void 0:s.skipRestricted))return{raw:t,restricted:[]};const u={},w=[];for(let b in t)if(S.OVERRIDE_PROPERTY_PATTERN.test(b)&&a){const I=this.filter(t[b],n,!1,s);u[b]=I.raw,w.push(...I.restricted)}else{const I=n[b],f=I?typeof I.scope!="undefined"?I.scope:3:void 0;(I==null?void 0:I.restricted)&&w.push(b),(f===void 0||s.scopes===void 0||s.scopes.includes(f))&&(s.skipRestricted&&(I==null?void 0:I.restricted)||(u[b]=t[b]))}return{raw:u,restricted:w}}}e.ConfigurationModelParser=o;class p extends P.Disposable{constructor(t,n,a,s){super();this.userSettingsResource=t,this.scopes=n,this.fileService=s,this._onDidChange=this._register(new h.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new o(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(h.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class m{constructor(t,n,a=new g,s=new g,u=new T.ResourceMap,w=new g,b=new T.ResourceMap,I=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=a,this._workspaceConfiguration=s,this._folderConfigurations=u,this._memoryConfiguration=w,this._memoryConfigurationByResource=b,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(t,n,a){return this.getConsolidateConfigurationModel(n,a).getValue(t)}updateValue(t,n,a={}){let s;a.resource?(s=this._memoryConfigurationByResource.get(a.resource),s||(s=new g,this._memoryConfigurationByResource.set(a.resource,s))):s=this._memoryConfiguration,n===void 0?s.removeValue(t):s.setValue(t,n),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,a){const s=this.getConsolidateConfigurationModel(n,a),u=this.getFolderConfigurationModelForResource(n.resource,a),w=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,b=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),I=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),f=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),_=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),F=a?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,U=u?n.overrideIdentifier?u.freeze().override(n.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,z=n.overrideIdentifier?w.override(n.overrideIdentifier).getValue(t):w.getValue(t),he=s.getValue(t),de=D.distinct(D.flatten(s.overrides.map(x=>x.identifiers))).filter(x=>s.getOverrideValue(t,x)!==void 0);return{defaultValue:b,userValue:I,userLocalValue:f,userRemoteValue:_,workspaceValue:F,workspaceFolderValue:U,memoryValue:z,value:he,default:b!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:f!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:U!==void 0?{value:u==null?void 0:u.freeze().getValue(t),override:n.overrideIdentifier?u==null?void 0:u.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:w.getValue(t),override:n.overrideIdentifier?w.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:de.length?de:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const a=n.filter(s=>S.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const u=(0,S.overrideIdentifierFromKey)(s),w=this._defaultConfiguration.getKeysForOverrideIdentifier(u),b=t.getKeysForOverrideIdentifier(u),I=[...b.filter(f=>w.indexOf(f)===-1),...w.filter(f=>b.indexOf(f)===-1),...w.filter(f=>!y.equals(this._defaultConfiguration.override(u).getValue(f),t.override(u).getValue(f)))];return[u,I]});return this.updateDefaultConfiguration(t),{keys:n,overrides:a}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:a,removed:s,overrides:u}=(0,k.compare)(this.localUserConfiguration,t),w=[...n,...a,...s];return w.length&&this.updateLocalUserConfiguration(t),{keys:w,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:a,removed:s,overrides:u}=(0,k.compare)(this.remoteUserConfiguration,t);let w=[...n,...a,...s];return w.length&&this.updateRemoteUserConfiguration(t),{keys:w,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:a,removed:s,overrides:u}=(0,k.compare)(this.workspaceConfiguration,t);let w=[...n,...a,...s];return w.length&&this.updateWorkspaceConfiguration(t),{keys:w,overrides:u}}compareAndUpdateFolderConfiguration(t,n){const a=this.folderConfigurations.get(t),{added:s,updated:u,removed:w,overrides:b}=(0,k.compare)(a,n);let I=[...s,...u,...w];return(I.length||!a)&&this.updateFolderConfiguration(t,n),{keys:I,overrides:b}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:a,updated:s,removed:u,overrides:w}=(0,k.compare)(n,void 0);return{keys:[...a,...s,...u],overrides:w}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let a=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?a.override(t.overrideIdentifier):a}getConsolidatedConfigurationModelForResource({resource:t},n){let a=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const s=n.getFolder(t);s&&(a=this.getFolderConsolidatedConfiguration(s.uri)||a);const u=this._memoryConfigurationByResource.get(t);u&&(a=a.merge(u))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const a=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(n=a.merge(s),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=a}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const a=n.getFolder(t);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:a,overrides:s,keys:u}=this._folderConfigurations.get(n);return t.push([n,{contents:a,overrides:s,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(a=>t.add(a))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>n.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>n.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>n.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),a=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((w,b)=>(w.set(C.URI.revive(b[0]),this.parseConfigurationModel(b[1])),w),new T.ResourceMap);return new m(n,a,new g,s,u,new g,new T.ResourceMap,!1)}static parseConfigurationModel(t){return new g(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=m;function E(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const t=new Set,n=new Map;for(const s of d)s.keys.forEach(u=>t.add(u)),s.overrides.forEach(([u,w])=>{const b=(0,T.getOrSet)(n,u,new Set);w.forEach(I=>b.add(I))});const a=[];return n.forEach((s,u)=>a.push([u,[...s.values()]])),{keys:[...t.values()],overrides:a}}e.mergeChanges=E;class l{constructor(t,n,a,s){this.change=t,this.previous=n,this.currentConfiguraiton=a,this.currentWorkspace=s,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(b=>u.add(b)),t.overrides.forEach(([,b])=>b.forEach(I=>u.add(I))),this.affectedKeys=[...u.values()];const w=new g;this.affectedKeys.forEach(b=>w.setValue(b,{})),this.affectedKeysTree=w.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var a;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(a=this.previous)===null||a===void 0?void 0:a.workspace):void 0,u=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!y.equals(s,u)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let a=(0,k.toValuesTree)({[n]:!0},()=>{}),s;for(;typeof a=="object"&&(s=Object.keys(a)[0]);){if(t=t[s],!t)return!1;a=a[s]}return!0}}e.ConfigurationChangeEvent=l;class c extends l{constructor(t,n,a,s){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=a,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=c}),define(ve[67],we([0,1,4]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var T;(function(y){y[y.Unknown=0]="Unknown",y[y.DisableTrust=1]="DisableTrust",y[y.MachineTrusted=2]="MachineTrusted"})(T=e.RemoteTrustOption||(e.RemoteTrustOption={}));var D;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends Error{constructor(C,S=D.Unknown,k){super(C);this._message=C,this._code=S,this._detail=k,this.isHandled=S===D.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(C){return C instanceof A&&C._code===D.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof A&&C._code===D.NoResolverFound}static isHandled(C){return C instanceof A&&C.isHandled}}e.RemoteAuthorityResolverError=A}),define(ve[94],we([0,1,19]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function T(S){return S.scheme===v.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=T;function D(S){if(!!S){const k=S.indexOf("+");return k<0?S:S.substr(0,k)}}e.getRemoteName=D;function A(S){return S.scheme!==v.Schemas.file&&S.scheme!==v.Schemas.vscodeRemote}function y(S){if(S.folders.length)return S.folders.every(k=>A(k.uri))?S.folders[0].uri:void 0;if(S.configuration&&A(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=y;function C(S){var k;return(k=y(S))===null||k===void 0?void 0:k.scheme}e.getVirtualWorkspaceScheme=C}),define(ve[156],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class v{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,A,y=5){let C;return C=A(S=>{const k=typeof S=="string"?S:S.data;let i=this._terminalBufferMap.get(D);if(i){i.data.push(k);return}const P=setTimeout(()=>this.flushBuffer(D),y);i={data:[k],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(D),C.dispose()}},this._terminalBufferMap.set(D,i)}),C}stopBuffering(D){const A=this._terminalBufferMap.get(D);A&&A.dispose()}flushBuffer(D){const A=this._terminalBufferMap.get(D);A&&(this._terminalBufferMap.delete(D),this._callback(D,A.data.join("")))}}e.TerminalDataBufferer=v}),define(ve[157],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(T){T.DARK="dark",T.LIGHT="light",T.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(ve[158],we([0,1,4,6,29,3,157,36]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,v.createDecorator)("themeService");var S;(function(p){function m(E){return E&&typeof E=="object"&&typeof E.id=="string"}p.isThemeColor=m})(S=e.ThemeColor||(e.ThemeColor={}));function k(p){return{id:p}}e.themeColorFromId=k;var i;(function(p){function m(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||S.isThemeColor(t.color))}p.isThemeIcon=m;const E=new RegExp(`^\\$\\((${C.CSSIcon.iconNameExpression}(?:${C.CSSIcon.iconModifierExpression})?)\\)$`);function l(t){const n=E.exec(t);if(!!n){let[,a]=n;return{id:a}}}p.fromString=l;function c(t,n){let a=t.id;const s=a.lastIndexOf("~");return s!==-1&&(a=a.substring(0,s)),n&&(a=`${a}~${n}`),{id:a}}p.modify=c;function d(t,n){var a,s;return t.id===n.id&&((a=t.color)===null||a===void 0?void 0:a.id)===((s=n.color)===null||s===void 0?void 0:s.id)}p.isEqual=d,p.asClassNameArray=C.CSSIcon.asClassNameArray,p.asClassName=C.CSSIcon.asClassName,p.asCSSSelector=C.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=C.Codicon.file,e.FolderThemeIcon=C.Codicon.folder;function P(p){switch(p){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class h{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,T.toDisposable)(()=>{const E=this.themingParticipants.indexOf(m);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new h;D.Registry.add(e.Extensions.ThemingContribution,g);function r(p){return g.onColorThemeChange(p)}e.registerThemingParticipant=r;class o extends T.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,E){let l=this.theme.getColor(m);return l&&E&&(l=E(l,this.theme)),l?l.toString():null}}e.Themable=o}),define(ve[159],we([0,1,29,158,3,129,92,11,36]),function(Y,e,v,T,D,A,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${S.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(m,E,l,c){const d=this.iconsById[m];if(d){if(l&&!d.description){d.description=l,this.iconSchema.properties[m].markdownDescription=`${l} $(${m})`;const a=this.iconReferenceSchema.enum.indexOf(m);a!==-1&&(this.iconReferenceSchema.enumDescriptions[a]=l),this._onDidChange.fire()}return d}let t={id:m,description:l,defaults:E,deprecationMessage:c};this.iconsById[m]=t;let n={$ref:"#/definitions/icons"};return c&&(n.deprecationMessage=c),l&&(n.markdownDescription=`${l}: $(${m})`),this.iconSchema.properties[m]=n,this.iconReferenceSchema.enum.push(m),this.iconReferenceSchema.enumDescriptions.push(l||""),this._onDidChange.fire(),{id:m}}deregisterIcon(m){delete this.iconsById[m],delete this.iconSchema.properties[m];const E=this.iconReferenceSchema.enum.indexOf(m);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(m=>this.iconsById[m])}getIcon(m){return this.iconsById[m]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(m,E){const l=this.iconFontsById[m];if(l)return l;let c={id:m,definition:E};return this.iconFontsById[m]=c,this._onDidChange.fire(),c}deregisterIconFont(m){delete this.iconFontsById[m]}getIconFonts(){return Object.keys(this.iconFontsById).map(m=>this.iconFontsById[m])}getIconFont(m){return this.iconFontsById[m]}toString(){const m=(d,t)=>d.id.localeCompare(t.id),E=d=>{for(;T.ThemeIcon.isThemeIcon(d.defaults);)d=this.iconsById[d.defaults.id];return`codicon codicon-${d?d.id:""}`};let l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.iconsById).map(d=>this.iconsById[d]);for(const d of c.filter(t=>!!t.description).sort(m))l.push(`|<i class="${E(d)}"></i>|${d.id}|${T.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const d of c.filter(t=>!T.ThemeIcon.isThemeIcon(t.defaults)).sort(m))l.push(`|<i class="${E(d)}"></i>|${d.id}|`);return l.join(`
`)}}const i=new k;v.Registry.add(e.Extensions.IconContribution,i);function P(p,m,E,l){return i.registerIcon(p,m,E,l)}e.registerIcon=P;function h(){return i}e.getIconRegistry=h;function g(){for(const p of S.iconRegistry.all)i.registerIcon(p.id,p.definition,p.description);S.iconRegistry.onDidRegister(p=>i.registerIcon(p.id,p.definition,p.description))}g(),e.iconsSchemaId="vscode://schemas/icons";let r=v.Registry.as(y.Extensions.JSONContribution);r.registerSchema(e.iconsSchemaId,i.getIconSchema());const o=new C.RunOnceScheduler(()=>r.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.widgetClose=P("widget-close",S.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=P("goto-previous-location",S.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=P("goto-next-location",S.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=T.ThemeIcon.modify(S.Codicon.sync,"spin")}),define(ve[48],we([0,1,2,25,4,22]),function(Y,e,v,T,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");var y;(function(h){h[h.EMPTY=1]="EMPTY",h[h.FOLDER=2]="FOLDER",h[h.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function C(h){const g=h;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=C;function S(h){const g=h;return!!(g&&typeof g=="object"&&v.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=S;class k{constructor(g,r,o,p){this._id=g,this._configuration=o,this._ignorePathCasing=p,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(g){this._id=g.id,this._configuration=g.configuration,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g.with({scheme:g.scheme,authority:g.authority,path:g.path}))||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class i{constructor(g,r){this.raw=r,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,T.joinPath)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function P(h){return new i({uri:h,index:0,name:(0,T.basenameOrAuthority)(h)},{uri:h.toString()})}e.toWorkspaceFolder=P}),define(ve[160],we([0,1,4,130,48,2,21,14,25,108,44,19,58,37,94]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const o=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(j){return(typeof j=="string"?(0,C.extname)(j):(0,S.extname)(j))===o}e.hasWorkspaceFileExtension=p,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function m(j){return j.hasOwnProperty("workspace")}e.isRecentWorkspace=m;function E(j){return j.hasOwnProperty("folderUri")}e.isRecentFolder=E;function l(j){return j.hasOwnProperty("fileUri")}e.isRecentFile=l;function c(j){const H=j;return typeof(H==null?void 0:H.id)=="string"&&A.URI.isUri(H.uri)}e.isSingleFolderWorkspaceIdentifier=c;function d(j){if(j.configuration)return{id:j.id,configPath:j.configuration};if(j.folders.length===1)return{id:j.id,uri:j.folders[0].uri}}e.toWorkspaceIdentifier=d;function t(j){const H=j;return typeof(H==null?void 0:H.id)=="string"&&A.URI.isUri(H.configPath)}e.isWorkspaceIdentifier=t;function n(j){const H=j;if(H==null?void 0:H.uri)return{id:H.id,uri:A.URI.revive(H.uri)};const R=j;if(R==null?void 0:R.configPath)return{id:R.id,configPath:A.URI.revive(R.configPath)};if(j==null?void 0:j.id)return{id:j.id}}e.reviveIdentifier=n;function a(j,H){return S.extUriBiasedIgnorePathCase.isEqualOrParent(j,H.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function s(j){return u(j)||w(j)}e.isStoredWorkspaceFolder=s;function u(j){const H=j;return typeof(H==null?void 0:H.path)=="string"&&(!H.name||typeof H.name=="string")}e.isRawFileWorkspaceFolder=u;function w(j){const H=j;return typeof(H==null?void 0:H.uri)=="string"&&(!H.name||typeof H.name=="string")}e.isRawUriWorkspaceFolder=w;function b(j,H,R,L,M=!y.isWindows,$){if(j.scheme!==L.scheme)return{name:R,uri:j.toString(!0)};let G=H?void 0:$.relativePath(L,j);if(G!==void 0)G.length===0?G=".":y.isWindows&&j.scheme===P.Schemas.file&&!M&&(G=G.replace(/\//g,"\\"));else if(j.scheme===P.Schemas.file)G=j.fsPath,y.isWindows&&(G=(0,h.normalizeDriveLetter)(G),M&&(G=(0,g.toSlashes)(G)));else{if(!$.isEqualAuthority(j.authority,L.authority))return{name:R,uri:j.toString(!0)};G=j.path}return{name:R,path:G}}e.getStoredWorkspaceFolder=b;function I(j,H,R){let L=[],M=new Set;const $=R.dirname(H);for(let G of j){let J;if(u(G))G.path&&(J=R.resolvePath($,G.path));else if(w(G))try{J=A.URI.parse(G.uri),J.path[0]!=="/"&&(J=J.with({path:"/"+J.path}))}catch(te){console.warn(te)}if(J){let te=R.getComparisonKey(J);if(!M.has(te)){M.add(te);const me=G.name||R.basenameOrAuthority(J);L.push(new D.WorkspaceFolder({uri:J,name:me,index:L.length},G))}}}return L}e.toWorkspaceFolders=I;function f(j,H,R,L,M){let $=_(H,j);const G=M.dirname(H),J=M.dirname(L),te=[],me=F($.folders);for(const ze of $.folders){const W=u(ze)?M.resolvePath(G,ze.path):A.URI.parse(ze.uri);let q;R?q=!1:q=!u(ze)||(0,C.isAbsolute)(ze.path),te.push(b(W,q,ze.name,J,me,M))}const Le={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},We=k.setProperty(j,["folders"],te,Le);let Fe=k.applyEdits(j,We);return $.remoteAuthority===(0,r.getRemoteAuthority)(L)&&(Fe=k.applyEdits(Fe,k.removeProperty(Fe,["remoteAuthority"],Le))),Fe}e.rewriteWorkspaceFileForNewLocation=f;function _(j,H){let R=i.parse(H);if(R&&Array.isArray(R.folders))R.folders=R.folders.filter(L=>s(L));else throw new Error(`${j} looks like an invalid workspace file.`);return R}function F(j){return y.isWindows?j.some(H=>u(H)&&H.path.indexOf("/")>=0):!0}e.useSlashForPath=F;function U(j){return j.workspace&&typeof j.workspace=="object"&&typeof j.workspace.id=="string"&&typeof j.workspace.configPath=="string"}function z(j){return typeof j.folderUri=="string"}function he(j){return typeof j.fileUri=="string"}function de(j,H){const R={workspaces:[],files:[]};if(j){const L=function($,G){for(let J=0;J<$.length;J++)try{G($[J],J)}catch(te){H.warn(`Error restoring recent entry ${JSON.stringify($[J])}: ${te.toString()}. Skip entry.`)}},M=j;if(Array.isArray(M.entries))L(M.entries,$=>{const G=$.label,J=$.remoteAuthority;U($)?R.workspaces.push({label:G,remoteAuthority:J,workspace:{id:$.workspace.id,configPath:A.URI.parse($.workspace.configPath)}}):z($)?R.workspaces.push({label:G,remoteAuthority:J,folderUri:A.URI.parse($.folderUri)}):he($)&&R.files.push({label:G,remoteAuthority:J,fileUri:A.URI.parse($.fileUri)})});else{const $=j;Array.isArray($.workspaces3)&&L($.workspaces3,(G,J)=>{const te=Array.isArray($.workspaceLabels)&&$.workspaceLabels[J]||void 0;typeof G=="object"&&typeof G.id=="string"&&typeof G.configURIPath=="string"?R.workspaces.push({label:te,workspace:{id:G.id,configPath:A.URI.parse(G.configURIPath)}}):typeof G=="string"&&R.workspaces.push({label:te,folderUri:A.URI.parse(G)})}),Array.isArray($.files2)&&L($.files2,(G,J)=>{const te=Array.isArray($.fileLabels)&&$.fileLabels[J]||void 0;typeof G=="string"&&R.files.push({label:te,fileUri:A.URI.parse(G)})})}}return R}e.restoreRecentlyOpened=de;function x(j){const H={entries:[]};for(const R of j.workspaces)E(R)?H.entries.push({folderUri:R.folderUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority}):H.entries.push({workspace:{id:R.workspace.id,configPath:R.workspace.configPath.toString()},label:R.label,remoteAuthority:R.remoteAuthority});for(const R of j.files)H.entries.push({fileUri:R.fileUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority});return H}e.toStoreData=x}),define(ve[68],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class v{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const A=this._idPool++;return this._data.set(A,D),this.logDebugInfo(),A}get(D,A){return this._data.has(D)?this._data.get(D)[A]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!v.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=v,v.enableDebugLogging=!1}),define(ve[69],we([0,1,2,3,4]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class A{constructor(){this._onDidChangeTabs=new T.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(C){this._tabs=C.map(S=>({name:S.name,group:S.group,resource:v.URI.revive(S.resource),isActive:S.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(ve[49],we([0,1,19,4]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class D{constructor(){this._systemSchemes=new Set(Object.keys(v.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,C){C===null?this._providerInfo.delete(y):this._providerInfo.set(y,C)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=D,e.IExtHostFileSystemInfo=(0,T.createDecorator)("IExtHostFileSystemInfo")}),define(ve[27],we([0,1,4]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,v.createDecorator)("IExtHostInitDataService")}),define(ve[161],we([0,1,11]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(y,C,S){this._deferredPromises=new Map,this._id=y,this._shared=C,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new v.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of k.values())i.complete()}catch(i){for(const P of k.values())P.error(i)}})()},0)}get whenReady(){return this._init}get(y,C){let S=this._value[y];return typeof S=="undefined"&&(S=C),S}update(y,C){this._value[y]=C;let S=this._deferredPromises.get(y);if(S!==void 0)return S.p;const k=new v.DeferredPromise;return this._deferredPromises.set(y,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=T;class D extends T{constructor(y,C){super(y.identifier.value,!0,C);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=D}),define(ve[15],we([0,1,4]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,v.createDecorator)("IExtHostRpcService");class T{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=T});var it=this&&this.__classPrivateFieldSet||function(Y,e,v,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Y,v):D?D.value=v:e.set(Y,v),v},Ue=this&&this.__classPrivateFieldGet||function(Y,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!T:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(Y):T?T.value:e.get(Y)};define(ve[162],we([0,1,26,3]),function(Y,e,v,T){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(C,S){D.set(this,void 0),this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._id=v.ExtensionIdentifier.toKey(C.identifier),it(this,D,S,"f"),Ue(this,D,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(C){return Ue(this,D,"f").get(this._id,C)}store(C,S){return Ue(this,D,"f").store(this._id,C,S)}delete(C){return Ue(this,D,"f").delete(this._id,C)}}e.ExtensionSecrets=A,D=new WeakMap}),define(ve[95],we([0,1,4,3]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new T.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,v.createDecorator)("IExtHostTelemetry")}),define(ve[70],we([0,1,3]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var T;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(T=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const D=new WeakMap,A=y=>{let C=D.get(y);return C||(C={children:new Map,bus:new v.Emitter},D.set(y,C)),C};e.getPrivateApiFor=A}),define(ve[71],we([0,1,4,3,15]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(C){function S(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public}}C.fromApiTunnel=S;function k(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public}}C.fromServiceTunnel=k})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,v.createDecorator)("IExtHostTunnelService");let y=class{constructor(S){this.onDidChangeTunnels=new T.Emitter().event}async $applyCandidateFilter(S){return S}async openTunnel(S,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(S){return{dispose:()=>{}}}registerPortsAttributesProvider(S,k){return{dispose:()=>{}}}async $providePortAttributes(S,k,i,P,h){return[]}async $forwardPort(S,k){}async $closeTunnel(S){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=je([qe(0,D.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var it=this&&this.__classPrivateFieldSet||function(Y,e,v,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Y,v):D?D.value=v:e.set(Y,v),v},Ue=this&&this.__classPrivateFieldGet||function(Y,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!T:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(Y):T?T.value:e.get(Y)},Gt=this&&this.__rest||function(Y,e){var v={};for(var T in Y)Object.prototype.hasOwnProperty.call(Y,T)&&e.indexOf(T)<0&&(v[T]=Y[T]);if(Y!=null&&typeof Object.getOwnPropertySymbols=="function")for(var D=0,T=Object.getOwnPropertySymbols(Y);D<T.length;D++)e.indexOf(T[D])<0&&Object.prototype.propertyIsEnumerable.call(Y,T[D])&&(v[T[D]]=Y[T[D]]);return v};define(ve[7],we([0,1,13,12,84,22,8,10,2,31,64,67,70]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h){"use strict";var g,r,o,p,m,E,l,c,d,t,n,a,s,u,w,b;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelPreload=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function I(B){function O(){return Reflect.construct(B,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(B,"name")),Object.setPrototypeOf(O,B),Object.setPrototypeOf(O.prototype,B.prototype),O}let f=o=class{constructor(O){g.set(this,void 0),it(this,g,O,"f")}static from(...O){let ne=O;return new o(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}dispose(){typeof Ue(this,g,"f")=="function"&&(Ue(this,g,"f").call(this),it(this,g,void 0,"f"))}};g=new WeakMap,f=o=je([I],f),e.Disposable=f;let _=p=class{constructor(O,ne){if(O<0)throw(0,T.illegalArgument)("line must be non-negative");if(ne<0)throw(0,T.illegalArgument)("character must be non-negative");this._line=O,this._character=ne}static Min(...O){if(O.length===0)throw new TypeError;let ne=O[0];for(let Se=1;Se<O.length;Se++){const Ge=O[Se];Ge.isBefore(ne)&&(ne=Ge)}return ne}static Max(...O){if(O.length===0)throw new TypeError;let ne=O[0];for(let Se=1;Se<O.length;Se++){const Ge=O[Se];Ge.isAfter(ne)&&(ne=Ge)}return ne}static isPosition(O){if(!O)return!1;if(O instanceof p)return!0;let{line:ne,character:Se}=O;return typeof ne=="number"&&typeof Se=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,ne=0){if(O===null||ne===null)throw(0,T.illegalArgument)();let Se;return typeof O=="undefined"?Se=0:typeof O=="number"?Se=O:(Se=typeof O.lineDelta=="number"?O.lineDelta:0,ne=typeof O.characterDelta=="number"?O.characterDelta:0),Se===0&&ne===0?this:new p(this.line+Se,this.character+ne)}with(O,ne=this.character){if(O===null||ne===null)throw(0,T.illegalArgument)();let Se;return typeof O=="undefined"?Se=this.line:typeof O=="number"?Se=O:(Se=typeof O.line=="number"?O.line:this.line,ne=typeof O.character=="number"?O.character:this.character),Se===this.line&&ne===this.character?this:new p(Se,ne)}toJSON(){return{line:this.line,character:this.character}}};_=p=je([I],_),e.Position=_;let F=m=class{constructor(O,ne,Se,Ge){let nt,ot;if(typeof O=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Ge=="number"?(nt=new _(O,ne),ot=new _(Se,Ge)):O instanceof _&&ne instanceof _&&(nt=O,ot=ne),!nt||!ot)throw new Error("Invalid arguments");nt.isBefore(ot)?(this._start=nt,this._end=ot):(this._start=ot,this._end=nt)}static isRange(O){return O instanceof m?!0:O?_.isPosition(O.start)&&_.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof m?this.contains(O._start)&&this.contains(O._end):O instanceof _?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const ne=_.Max(O.start,this._start),Se=_.Min(O.end,this._end);if(!ne.isAfter(Se))return new m(ne,Se)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const ne=_.Min(O.start,this._start),Se=_.Max(O.end,this.end);return new m(ne,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,ne=this.end){if(O===null||ne===null)throw(0,T.illegalArgument)();let Se;return O?_.isPosition(O)?Se=O:(Se=O.start||this.start,ne=O.end||this.end):Se=this.start,Se.isEqual(this._start)&&ne.isEqual(this.end)?this:new m(Se,ne)}toJSON(){return[this.start,this.end]}};F=m=je([I],F),e.Range=F;let U=E=class extends F{constructor(O,ne,Se,Ge){let nt,ot;if(typeof O=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Ge=="number"?(nt=new _(O,ne),ot=new _(Se,Ge)):O instanceof _&&ne instanceof _&&(nt=O,ot=ne),!nt||!ot)throw new Error("Invalid arguments");super(nt,ot);this._anchor=nt,this._active=ot}static isSelection(O){return O instanceof E?!0:O?F.isRange(O)&&_.isPosition(O.anchor)&&_.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};U=E=je([I],U),e.Selection=U;class z{constructor(O,ne,Se){if(typeof O!="string"||O.length===0)throw(0,T.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,T.illegalArgument)("port");if(typeof Se!="undefined"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z\-]+$/.test(Se)))throw(0,T.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(ne),this.connectionToken=Se}}e.ResolvedAuthority=z;class he extends Error{constructor(O,ne=P.RemoteAuthorityResolverErrorCode.Unknown,Se){super(O);this._message=O,this._code=ne,this._detail=Se,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,he.prototype)}static NotAvailable(O,ne){return new he(O,P.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(O){return new he(O,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=he;var de;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(de=e.EndOfLine||(e.EndOfLine={}));var x;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let j=l=class{constructor(O,ne){this._range=O,this._newText=ne}static isTextEdit(O){return O instanceof l?!0:O?F.isRange(O)&&typeof O.newText=="string":!1}static replace(O,ne){return new l(O,ne)}static insert(O,ne){return l.replace(new F(O,O),ne)}static delete(O){return l.replace(O,"")}static setEndOfLine(O){const ne=new l(new F(new _(0,0),new _(0,0)),"");return ne.newEol=O,ne}get range(){return this._range}set range(O){if(O&&!F.isRange(O))throw(0,T.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,T.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,T.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};j=l=je([I],j),e.TextEdit=j;var H;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellOutput=4]="CellOutput",B[B.CellReplace=5]="CellReplace",B[B.CellOutputItem=6]="CellOutputItem"})(H=e.FileEditType||(e.FileEditType={}));let R=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,ne,Se,Ge){this._edits.push({_type:1,from:O,to:ne,options:Se,metadata:Ge})}createFile(O,ne,Se){this._edits.push({_type:1,from:void 0,to:O,options:ne,metadata:Se})}deleteFile(O,ne,Se){this._edits.push({_type:1,from:O,to:void 0,options:ne,metadata:Se})}replaceNotebookMetadata(O,ne,Se){this._edits.push({_type:3,metadata:Se,uri:O,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(O,ne,Se,Ge,nt){let ot,dt,St=[],kt;if(Wt.isNotebookRange(ne)&&Pt.isNotebookCellDataArray(Se)&&!Pt.isNotebookCellDataArray(Ge)?(ot=ne.start,dt=ne.end,St=Se,kt=Ge):typeof ne=="number"&&typeof Se=="number"&&Pt.isNotebookCellDataArray(Ge)&&(ot=ne,dt=Se,St=Ge,kt=nt),ot===void 0||dt===void 0)throw new Error("Invalid arguments");(ot!==dt||St.length>0)&&this._edits.push({_type:5,uri:O,index:ot,count:dt-ot,cells:St,metadata:kt})}replaceNotebookCellMetadata(O,ne,Se,Ge){this._edits.push({_type:3,metadata:Ge,uri:O,edit:{editType:8,index:ne,metadata:Se}})}replace(O,ne,Se,Ge){this._edits.push({_type:2,uri:O,edit:new j(ne,Se),metadata:Ge})}insert(O,ne,Se,Ge){this.replace(O,new F(ne,ne),Se,Ge)}delete(O,ne,Se){this.replace(O,ne,"",Se)}has(O){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===O.toString())}set(O,ne){if(ne)for(const Se of ne)Se&&this._edits.push({_type:2,uri:O,edit:Se});else{for(let Se=0;Se<this._edits.length;Se++){const Ge=this._edits[Se];Ge._type===2&&Ge.uri.toString()===O.toString()&&(this._edits[Se]=void 0)}(0,v.coalesceInPlace)(this._edits)}}get(O){const ne=[];for(let Se of this._edits)Se._type===2&&Se.uri.toString()===O.toString()&&ne.push(Se.edit);return ne}entries(){const O=new A.ResourceMap;for(let ne of this._edits)if(ne._type===2){let Se=O.get(ne.uri);Se||(Se=[ne.uri,[]],O.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};R=je([I],R),e.WorkspaceEdit=R;let L=c=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof c?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=c._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,ne=this._tabstop++){if(typeof O=="function"){const Se=new c;Se._tabstop=this._tabstop,O(Se),this._tabstop=Se._tabstop,O=Se.value}else O=c._escape(O);return this.value+="${",this.value+=ne,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,ne=this._tabstop++){const Se=O.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(O,ne){if(typeof ne=="function"){const Se=new c;Se._tabstop=this._tabstop,ne(Se),this._tabstop=Se._tabstop,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};L=c=je([I],L),e.SnippetString=L;var M;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(M=e.DiagnosticTag||(e.DiagnosticTag={}));var $;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})($=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let G=d=class{constructor(O,ne){if(this.uri=O,ne)if(ne instanceof F)this.range=ne;else if(ne instanceof _)this.range=new F(ne,ne);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof d?!0:O?F.isRange(O.range)&&S.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};G=d=je([I],G),e.Location=G;let J=class{constructor(O,ne){this.location=O,this.message=ne}static is(O){return O?typeof O.message=="string"&&O.location&&F.isRange(O.location.range)&&S.URI.isUri(O.location.uri):!1}static isEqual(O,ne){return O===ne?!0:!O||!ne?!1:O.message===ne.message&&O.location.range.isEqual(ne.location.range)&&O.location.uri.toString()===ne.location.uri.toString()}};J=je([I],J),e.DiagnosticRelatedInformation=J;let te=class{constructor(O,ne,Se=$.Error){if(!F.isRange(O))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=O,this.message=ne,this.severity=Se}toJSON(){return{severity:$[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,ne){return O===ne?!0:!O||!ne?!1:O.message===ne.message&&O.severity===ne.severity&&O.code===ne.code&&O.severity===ne.severity&&O.source===ne.source&&O.range.isEqual(ne.range)&&(0,v.equals)(O.tags,ne.tags)&&(0,v.equals)(O.relatedInformation,ne.relatedInformation,J.isEqual)}};te=je([I],te),e.Diagnostic=te;let me=class{constructor(O,ne){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:(0,D.isMarkdownString)(O)?this.contents=[O]:this.contents=[O],this.range=ne}};me=je([I],me),e.Hover=me;var Le;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(Le=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let We=class{constructor(O,ne=Le.Text){this.range=O,this.kind=ne}toJSON(){return{range:this.range,kind:Le[this.kind]}}};We=je([I],We),e.DocumentHighlight=We;var Fe;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(Fe=e.SymbolKind||(e.SymbolKind={}));var ze;(function(B){B[B.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let W=t=class{constructor(O,ne,Se,Ge,nt){this.name=O,this.kind=ne,this.containerName=nt,typeof Se=="string"&&(this.containerName=Se),Ge instanceof G?this.location=Ge:Se instanceof F&&(this.location=new G(Ge,Se)),t.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Fe[this.kind],location:this.location,containerName:this.containerName}}};W=t=je([I],W),e.SymbolInformation=W;let q=n=class{constructor(O,ne,Se,Ge,nt){this.name=O,this.detail=ne,this.kind=Se,this.range=Ge,this.selectionRange=nt,this.children=[],n.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(n.validate)}};q=n=je([I],q),e.DocumentSymbol=q;var ee;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let se=class{constructor(O,ne){this.title=O,this.kind=ne}};se=je([I],se),e.CodeAction=se;let ce=a=class{constructor(O){this.value=O}append(O){return new a(this.value?this.value+a.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+a.sep)}};ce.sep=".",ce=a=je([I],ce),e.CodeActionKind=ce,ce.Empty=new ce(""),ce.QuickFix=ce.Empty.append("quickfix"),ce.Refactor=ce.Empty.append("refactor"),ce.RefactorExtract=ce.Refactor.append("extract"),ce.RefactorInline=ce.Refactor.append("inline"),ce.RefactorRewrite=ce.Refactor.append("rewrite"),ce.Source=ce.Empty.append("source"),ce.SourceOrganizeImports=ce.Source.append("organizeImports"),ce.SourceFixAll=ce.Source.append("fixAll");let _e=class{constructor(O,ne){if(this.range=O,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};_e=je([I],_e),e.SelectionRange=_e;class $e{constructor(O,ne,Se,Ge,nt,ot){this.kind=O,this.name=ne,this.detail=Se,this.uri=Ge,this.range=nt,this.selectionRange=ot}}e.CallHierarchyItem=$e;class fe{constructor(O,ne){this.fromRanges=ne,this.from=O}}e.CallHierarchyIncomingCall=fe;class De{constructor(O,ne){this.fromRanges=ne,this.to=O}}e.CallHierarchyOutgoingCall=De;let Re=class{constructor(O,ne){this.range=O,this.command=ne}get isResolved(){return!!this.command}};Re=je([I],Re),e.CodeLens=Re;let He=s=class{constructor(O,ne=!1){r.set(this,void 0),it(this,r,new D.MarkdownString(O,{supportThemeIcons:ne}),"f")}static isMarkdownString(O){return O instanceof s?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Ue(this,r,"f").value}set value(O){Ue(this,r,"f").value=O}get isTrusted(){return Ue(this,r,"f").isTrusted}set isTrusted(O){Ue(this,r,"f").isTrusted=O}get supportThemeIcons(){return Ue(this,r,"f").supportThemeIcons}appendText(O){return Ue(this,r,"f").appendText(O),this}appendMarkdown(O){return Ue(this,r,"f").appendMarkdown(O),this}appendCodeblock(O,ne){return Ue(this,r,"f").appendCodeblock(ne!=null?ne:"",O),this}};r=new WeakMap,He=s=je([I],He),e.MarkdownString=He;let be=class{constructor(O,ne){this.label=O,this.documentation=ne}};be=je([I],be),e.ParameterInformation=be;let Ke=class{constructor(O,ne){this.label=O,this.documentation=ne,this.parameters=[]}};Ke=je([I],Ke),e.SignatureInformation=Ke;let V=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};V=je([I],V),e.SignatureHelp=V;var Z;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(Z=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ge;(function(B){B[B.Other=0]="Other",B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(ge=e.InlayHintKind||(e.InlayHintKind={}));let Ne=class{constructor(O,ne,Se){this.text=O,this.position=ne,this.kind=Se}};Ne=je([I],Ne),e.InlayHint=Ne;var Ve;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ve=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var xe;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(xe=e.CompletionItemKind||(e.CompletionItemKind={}));var Xe;(function(B){B[B.Deprecated=1]="Deprecated"})(Xe=e.CompletionItemTag||(e.CompletionItemTag={}));let ye=class{constructor(O,ne){this.label=O,this.kind=ne}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&xe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ye=je([I],ye),e.CompletionItem=ye;let Ee=class{constructor(O=[],ne=!1){this.items=O,this.isIncomplete=ne}};Ee=je([I],Ee),e.CompletionList=Ee;var Ce;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(Ce=e.ViewColumn||(e.ViewColumn={}));var ie;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(ie=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ae;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var N;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(N=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Q;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Q=e.TextEditorRevealType||(e.TextEditorRevealType={}));var oe;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ke;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(ke=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(B){function O(ne){switch(ne){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=O}(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ie=class{constructor(O,ne){if(ne&&!S.URI.isUri(ne))throw(0,T.illegalArgument)("target");if(!F.isRange(O)||O.isEmpty)throw(0,T.illegalArgument)("range");this.range=O,this.target=ne}};Ie=je([I],Ie),e.DocumentLink=Ie;let Ae=class{constructor(O,ne,Se,Ge){this.red=O,this.green=ne,this.blue=Se,this.alpha=Ge}};Ae=je([I],Ae),e.Color=Ae;let Be=class{constructor(O,ne){if(ne&&!(ne instanceof Ae))throw(0,T.illegalArgument)("color");if(!F.isRange(O)||O.isEmpty)throw(0,T.illegalArgument)("range");this.range=O,this.color=ne}};Be=je([I],Be),e.ColorInformation=Be;let Ye=class{constructor(O){if(!O||typeof O!="string")throw(0,T.illegalArgument)("label");this.label=O}};Ye=je([I],Ye),e.ColorPresentation=Ye;var rt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(rt=e.ColorFormat||(e.ColorFormat={}));var tt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(tt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Qe;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Qe=e.TaskRevealKind||(e.TaskRevealKind={}));var gt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(gt=e.TaskPanelKind||(e.TaskPanelKind={}));let bt=u=class{constructor(O,ne){if(typeof O!="string"||typeof ne!="string")throw(0,T.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}get id(){return this._id}};bt.Clean=new u("clean","Clean"),bt.Build=new u("build","Build"),bt.Rebuild=new u("rebuild","Rebuild"),bt.Test=new u("test","Test"),bt=u=je([I],bt),e.TaskGroup=bt;function pe(B){let O="";for(let ne=0;ne<B.length;ne++)O+=B[ne].replace(/,/g,",,")+",";return O}let ue=class{constructor(O,ne,Se){if(typeof O!="string")throw(0,T.illegalArgument)("process");this._args=[],this._process=O,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=Se):this._options=ne)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,T.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let ne of this._args)O.push(ne);return pe(O)}};ue=je([I],ue),e.ProcessExecution=ue;let re=class{constructor(O,ne,Se){if(this._args=[],Array.isArray(ne)){if(!O)throw(0,T.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,T.illegalArgument)("command");this._command=O,this._args=ne,this._options=Se}else{if(typeof O!="string")throw(0,T.illegalArgument)("commandLine");this._commandLine=O,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,T.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,T.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ne of this._args)O.push(typeof ne=="string"?ne:ne.value);return pe(O)}};re=je([I],re),e.ShellExecution=re;var K;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(K=e.ShellQuoting||(e.ShellQuoting={}));var Me;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Me=e.TaskScope||(e.TaskScope={}));class Te{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=Te;let Je=w=class{constructor(O,ne,Se,Ge,nt,ot){this.__deprecated=!1,this._definition=this.definition=O;let dt;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=Se,this.execution=Ge,dt=nt,this.__deprecated=!0):ne===Me.Global||ne===Me.Workspace?(this.target=ne,this._name=this.name=Se,this._source=this.source=Ge,this.execution=nt,dt=ot):(this.target=ne,this._name=this.name=Se,this._source=this.source=Ge,this.execution=nt,dt=ot),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ue?this._definition={type:w.ProcessType,id:this._execution.computeId()}:this._execution instanceof re?this._definition={type:w.ShellType,id:this._execution.computeId()}:this._execution instanceof Te?this._definition={type:w.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:w.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,T.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,T.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const ne=this._definition.type;(w.EmptyType===ne||w.ProcessType===ne||w.ShellType===ne||w.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,T.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};Je.ExtensionCallbackType="customExecution",Je.ProcessType="process",Je.ShellType="shell",Je.EmptyType="$empty",Je=w=je([I],Je),e.Task=Je;var et;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(et=e.ProgressLocation||(e.ProgressLocation={}));let ut=class{constructor(O,ne=ct.None){this.collapsibleState=ne,S.URI.isUri(O)?this.resourceUri=O:this.label=O}};ut=je([I],ut),e.TreeItem=ut;var ct;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ze=class{constructor(O,ne){this.id=O,this.color=ne}};Ze=je([I],Ze),e.ThemeIcon=Ze,Ze.File=new Ze("file"),Ze.Folder=new Ze("folder");let mt=class{constructor(O){this.id=O}};mt=je([I],mt),e.ThemeColor=mt;var ht;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(ht=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ft=class{constructor(O,ne){if(typeof O!="string"&&(!O||!S.URI.isUri(O)&&!S.URI.isUri(O.uri)))throw(0,T.illegalArgument)("base");if(typeof ne!="string")throw(0,T.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=S.URI.file(O),this.base=O):S.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=ne}};ft=je([I],ft),e.RelativePattern=ft;let at=class{constructor(O,ne,Se,Ge){this.enabled=typeof O=="boolean"?O:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,k.generateUuid)()),this._id}};at=je([I],at),e.Breakpoint=at;let yt=class extends at{constructor(O,ne,Se,Ge,nt){super(ne,Se,Ge,nt);if(O===null)throw(0,T.illegalArgument)("location");this.location=O}};yt=je([I],yt),e.SourceBreakpoint=yt;let Et=class extends at{constructor(O,ne,Se,Ge,nt){super(ne,Se,Ge,nt);this.functionName=O}};Et=je([I],Et),e.FunctionBreakpoint=Et;let Ot=class extends at{constructor(O,ne,Se,Ge,nt,ot,dt){super(Ge,nt,ot,dt);if(!ne)throw(0,T.illegalArgument)("dataId");this.label=O,this.dataId=ne,this.canPersist=Se}};Ot=je([I],Ot),e.DataBreakpoint=Ot;let Tt=class{constructor(O,ne,Se){this.command=O,this.args=ne||[],this.options=Se}};Tt=je([I],Tt),e.DebugAdapterExecutable=Tt;let _t=class{constructor(O,ne){this.port=O,this.host=ne}};_t=je([I],_t),e.DebugAdapterServer=_t;let Qt=class{constructor(O){this.path=O}};Qt=je([I],Qt),e.DebugAdapterNamedPipeServer=Qt;let Yt=class{constructor(O){this.implementation=O}};Yt=je([I],Yt),e.DebugAdapterInlineImplementation=Yt;let pt=class{constructor(O,ne){this.range=O,this.expression=ne}};pt=je([I],pt),e.EvaluatableExpression=pt;let Jt=class{constructor(O,ne){this.range=O,this.text=ne}};Jt=je([I],Jt),e.InlineValueText=Jt;let Dt=class{constructor(O,ne,Se=!0){this.range=O,this.variableName=ne,this.caseSensitiveLookup=Se}};Dt=je([I],Dt),e.InlineValueVariableLookup=Dt;let Vt=class{constructor(O,ne){this.range=O,this.expression=ne}};Vt=je([I],Vt),e.InlineValueEvaluatableExpression=Vt;let Xt=class{constructor(O,ne){this.frameId=O,this.stoppedLocation=ne}};Xt=je([I],Xt),e.InlineValueContext=Xt;var jt;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(jt=e.FileChangeType||(e.FileChangeType={}));let lt=b=class extends Error{constructor(O,ne=i.FileSystemProviderErrorCode.Unknown,Se){var Ge;super(S.URI.isUri(O)?O.toString(!0):O);this.code=(Ge=Se==null?void 0:Se.name)!==null&&Ge!==void 0?Ge:"Unknown",(0,i.markAsFileSystemProviderError)(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}static FileExists(O){return new b(O,i.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(O){return new b(O,i.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(O){return new b(O,i.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(O){return new b(O,i.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(O){return new b(O,i.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(O){return new b(O,i.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}};lt=b=je([I],lt),e.FileSystemError=lt;let Zt=class{constructor(O,ne,Se){this.start=O,this.end=ne,this.kind=Se}};Zt=je([I],Zt),e.FoldingRange=Zt;var Rt;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var xt;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(xt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var cn;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(cn=e.CommentMode||(e.CommentMode={}));class wn{constructor(O,ne=[]){this.tokenTypes=O,this.tokenModifiers=ne}}e.SemanticTokensLegend=wn;function dn(B){return typeof B=="undefined"||(0,C.isStringArray)(B)}class en{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let ne=0,Se=O.tokenTypes.length;ne<Se;ne++)this._tokenTypeStrToInt.set(O.tokenTypes[ne],ne);for(let ne=0,Se=O.tokenModifiers.length;ne<Se;ne++)this._tokenModifierStrToInt.set(O.tokenModifiers[ne],ne)}}push(O,ne,Se,Ge,nt){if(typeof O=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Ge=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(O,ne,Se,Ge,nt);if(F.isRange(O)&&typeof ne=="string"&&dn(Se))return this._push(O,ne,Se);throw(0,T.illegalArgument)()}_push(O,ne,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const Ge=O.start.line,nt=O.start.character,ot=O.end.character-O.start.character,dt=this._tokenTypeStrToInt.get(ne);let St=0;if(Se)for(const kt of Se){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const It=this._tokenModifierStrToInt.get(kt);St|=1<<It>>>0}this._pushEncoded(Ge,nt,ot,dt,St)}_pushEncoded(O,ne,Se,Ge,nt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let kt=0,It=0;for(let At=0;At<St;At++){let Lt=this._data[5*At],ln=this._data[5*At+1];Lt===0?(Lt=kt,ln+=It):Lt+=kt,this._data[5*At]=Lt,this._data[5*At+1]=ln,kt=Lt,It=ln}}let ot=O,dt=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=nt,this._prevLine=O,this._prevChar=ne}static _sortAndDeltaEncode(O){let ne=[];const Se=O.length/5|0;for(let dt=0;dt<Se;dt++)ne[dt]=dt;ne.sort((dt,St)=>{const kt=O[5*dt],It=O[5*St];if(kt===It){const At=O[5*dt+1],Lt=O[5*St+1];return At-Lt}return kt-It});const Ge=new Uint32Array(O.length);let nt=0,ot=0;for(let dt=0;dt<Se;dt++){const St=5*ne[dt],kt=O[St+0],It=O[St+1],At=O[St+2],Lt=O[St+3],ln=O[St+4],Tn=kt-nt,On=Tn===0?It-ot:It,un=5*dt;Ge[un+0]=Tn,Ge[un+1]=On,Ge[un+2]=At,Ge[un+3]=Lt,Ge[un+4]=ln,nt=kt,ot=It}return Ge}build(O){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),O):new qt(en._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=en;class qt{constructor(O,ne){this.resultId=ne,this.data=O}}e.SemanticTokens=qt;class Nt{constructor(O,ne,Se){this.start=O,this.deleteCount=ne,this.data=Se}}e.SemanticTokensEdit=Nt;class _n{constructor(O,ne){this.resultId=ne,this.edits=O}}e.SemanticTokensEdits=_n;var tn;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(tn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var nn;(function(B){B[B.Initial=1]="Initial",B[B.Dynamic=2]="Dynamic"})(nn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Kt=class{constructor(){}};Kt.Back={iconPath:new Ze("arrow-left")},Kt=je([I],Kt),e.QuickInputButtons=Kt;var En;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(En=e.ExtensionKind||(e.ExtensionKind={}));class Ft{constructor(O,ne,Se){this.badge=O,this.tooltip=ne,this.color=Se}static validate(O){if(O.badge&&O.badge.length!==1&&O.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Ft;let rn=class{constructor(O){this.kind=O}};rn=je([I],rn),e.ColorTheme=rn;var yn;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast"})(yn=e.ColorThemeKind||(e.ColorThemeKind={}));class Wt{constructor(O,ne){if(O<0)throw(0,T.illegalArgument)("start must be positive");if(ne<0)throw(0,T.illegalArgument)("end must be positive");O<=ne?(this._start=O,this._end=ne):(this._start=ne,this._end=O)}static isNotebookRange(O){return O instanceof Wt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let ne=this._start,Se=this._end;return O.start!==void 0&&(ne=O.start),O.end!==void 0&&(Se=O.end),ne===this._start&&Se===this._end?this:new Wt(ne,Se)}}e.NotebookRange=Wt;class sn{constructor(O,ne){typeof O=="object"?Object.assign(this,O):(this.inputCollapsed=O,this.outputCollapsed=ne)}with(O){let{inputCollapsed:ne,outputCollapsed:Se}=O,Ge=Gt(O,["inputCollapsed","outputCollapsed"]);return ne===void 0?ne=this.inputCollapsed:ne===null&&(ne=void 0),Se===void 0?Se=this.outputCollapsed:Se===null&&(Se=void 0),ne===this.inputCollapsed&&Se===this.outputCollapsed&&Object.keys(Ge).length===0?this:new sn(Object.assign({inputCollapsed:ne,outputCollapsed:Se},Ge))}}e.NotebookCellMetadata=sn;class Ut{constructor(O={}){Object.assign(this,O)}with(O){return new Ut(O)}}e.NotebookDocumentMetadata=Ut;class Pt{constructor(O,ne,Se,Ge,nt,ot){this.kind=O,this.value=ne,this.languageId=Se,this.outputs=Ge!=null?Ge:[],this.metadata=nt,this.executionSummary=ot,Pt.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(ne=>Pt.isNotebookCellData(ne))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Pt;class hn{constructor(O,ne){this.cells=O,this.metadata=ne!=null?ne:new Ut}}e.NotebookData=hn;class Bt{constructor(O,ne,Se){if(this.mime=O,this.value=ne,this.metadata=Se,(0,y.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(O){return O instanceof Bt?!0:O?typeof O.mime=="string":!1}static error(O){return new Bt("application/x.notebook.error",JSON.stringify({name:O.name,message:O.message,stack:O.stack}))}}e.NotebookCellOutputItem=Bt;class Oe{constructor(O,ne,Se){this.outputs=O,typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=(0,k.generateUuid)(),this.metadata=ne!=null?ne:Se)}}e.NotebookCellOutput=Oe;var on;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(on=e.NotebookCellKind||(e.NotebookCellKind={}));var an;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(an=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var vt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(vt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Sn;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Sn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Dn{constructor(O,ne,Se,Ge,nt,ot){this.text=O,this.alignment=ne,this.command=Se,this.tooltip=Ge,this.priority=nt,this.accessibilityInformation=ot}}e.NotebookCellStatusBarItem=Dn;var fn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(fn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class mn{constructor(O,ne=[]){this.uri=O,this.provides=typeof ne=="string"?[ne]:ne}}e.NotebookKernelPreload=mn;let Ht=class{constructor(O,ne){this.label=O,this.timestamp=ne}};Ht=je([I],Ht),e.TimelineItem=Ht;var Cn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(Cn=e.ExtensionMode||(e.ExtensionMode={}));var kn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(kn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var In;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=4]="RegEx"})(In=e.StandardTokenType||(e.StandardTokenType={}));class gn{constructor(O,ne){this.ranges=O,this.wordPattern=ne}}e.LinkedEditingRanges=gn;class Pn{constructor(O,ne){this._port=O,this._autoForwardAction=ne}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Pn;var An;(function(B){B[B.Unset=0]="Unset",B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(An=e.TestResultState||(e.TestResultState={}));var pn;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information",B[B.Hint=3]="Hint"})(pn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var vn;(function(B){B[B.Pending=0]="Pending",B[B.Resolved=1]="Resolved"})(vn=e.TestItemStatus||(e.TestItemStatus={}));const $t=(B,O,ne,Se)=>{let Ge=ne;return{enumerable:!0,configurable:!1,get(){return Ge},set(nt){Se(Ge,nt)||(Ge=nt,B.bus.fire([3,O,nt]))}}},X=(B,O)=>B===O,le=(B,O)=>B===O?!0:!B||!O?!1:B.isEqual(O);class Pe{constructor(O,ne,Se,Ge){this.label=ne,this.data=Ge;const nt=(0,h.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:O,enumerable:!0,writable:!1},uri:{value:Se,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>nt.parent},children:{value:new A.ReadonlyMapView(nt.children),enumerable:!0,writable:!1},range:$t(nt,"range",void 0,le),description:$t(nt,"description",void 0,X),runnable:$t(nt,"runnable",!0,X),debuggable:$t(nt,"debuggable",!1,X),status:$t(nt,"status",vn.Resolved,X),error:$t(nt,"error",void 0,X)})}invalidate(){(0,h.getPrivateApiFor)(this).bus.fire([2])}dispose(){const O=(0,h.getPrivateApiFor)(this);O.parent&&(0,h.getPrivateApiFor)(O.parent).children.delete(this.id),O.bus.fire([1])}addChild(O){if(!(O instanceof Pe))throw new Error("Test child must be created through vscode.test.createTestItem()");const ne=(0,h.getPrivateApiFor)(this);if(ne.children.has(O.id))throw new Error(`Attempted to insert a duplicate test item ID ${O.id}`);ne.children.set(O.id,O),ne.bus.fire([0,O])}}e.TestItemImpl=Pe;class st{constructor(O){this.message=O,this.severity=pn.Error}static diff(O,ne,Se){const Ge=new st(O);return Ge.expectedOutput=ne,Ge.actualOutput=Se,Ge}}e.TestMessage=st;var wt;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(wt=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ct;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(Ct=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Mn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore"})(Mn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ve[96],we([0,1,42,19,8,121,87,7,13]),function(Y,e,v,T,D,A,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function i(r,o){o?k.set(r,o):k.delete(r)}e.setWordDefinitionFor=i;function P(r){return k.get(r)}e.getWordDefinitionFor=P;class h extends A.MirrorTextModel{constructor(o,p,m,E,l,c,d,t){super(p,m,E,l);this._proxy=o,this._languageId=c,this._isDirty=d,this._notebook=t,this._isDisposed=!1}dispose(){(0,v.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(o){return(0,S.equals)(this._lines,o)}get document(){if(!this._document){const o=this;this._document={get uri(){return o._uri},get fileName(){return o._uri.fsPath},get isUntitled(){return o._uri.scheme===T.Schemas.untitled},get languageId(){return o._languageId},get version(){return o._versionId},get isClosed(){return o._isDisposed},get isDirty(){return o._isDirty},get notebook(){return o._notebook},save(){return o._save()},getText(p){return p?o._getTextInRange(p):o.getText()},get eol(){return o._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return o._lines.length},lineAt(p){return o._lineAt(p)},offsetAt(p){return o._offsetAt(p)},positionAt(p){return o._positionAt(p)},validateRange(p){return o._validateRange(p)},validatePosition(p){return o._validatePosition(p)},getWordRangeAtPosition(p,m){return o._getWordRangeAtPosition(p,m)}}}return Object.freeze(this._document)}_acceptLanguageId(o){(0,v.ok)(!this._isDisposed),this._languageId=o}_acceptIsDirty(o){(0,v.ok)(!this._isDisposed),this._isDirty=o}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(o){const p=this._validateRange(o);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const m=this._eol,E=p.start.line,l=p.end.line,c=[];c.push(this._lines[E].substring(p.start.character));for(let d=E+1;d<l;d++)c.push(this._lines[d]);return c.push(this._lines[l].substring(0,p.end.character)),c.join(m)}_lineAt(o){let p;if(o instanceof C.Position?p=o.line:typeof o=="number"&&(p=o),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new g(p,this._lines[p],p===this._lines.length-1)}_offsetAt(o){return o=this._validatePosition(o),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(o.line-1)+o.character}_positionAt(o){o=Math.floor(o),o=Math.max(0,o),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(o),m=this._lines[p.index].length;return new C.Position(p.index,Math.min(p.remainder,m))}_validateRange(o){if(!(o instanceof C.Range))throw new Error("Invalid argument");const p=this._validatePosition(o.start),m=this._validatePosition(o.end);return p===o.start&&m===o.end?o:new C.Range(p.line,p.character,m.line,m.character)}_validatePosition(o){if(!(o instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return o.with(0,0);let{line:p,character:m}=o,E=!1;if(p<0)p=0,m=0,E=!0;else if(p>=this._lines.length)p=this._lines.length-1,m=this._lines[p].length,E=!0;else{const l=this._lines[p].length;m<0?(m=0,E=!0):m>l&&(m=l,E=!0)}return E?new C.Position(p,m):o}_getWordRangeAtPosition(o,p){const m=this._validatePosition(o);if(!p)p=P(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const E=(0,y.getWordAtText)(m.character+1,(0,y.ensureValidWordDefinition)(p),this._lines[m.line],0);if(E)return new C.Range(m.line,E.startColumn-1,m.line,E.endColumn-1)}}e.ExtHostDocumentData=h;class g{constructor(o,p,m){this._line=o,this._text=p,this._isLastLine=m}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(ve[163],we([0,1,7,3,89,6,59,22,2,31]),function(Y,e,v,T,D,A,y,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(h,g,r,o){this._notebook=r,this._selector=o,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(g.onDidChangeDocument(m=>{const E=this._cellUris.get(m.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=m=>{m===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(h.onDidChangeNotebookCells(m=>p(m.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const h=[],g=[];for(const r of this._notebook.getCells())r.kind===v.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,r.document.uri,r.document.languageId,!0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),h.push(r.document.getText().length+1),g.push(r.document.lineCount));this._cellLengths=new D.PrefixSumComputer(new Uint32Array(h)),this._cellLines=new D.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(h){var g,r;if(!h){let l="";for(const c of this._cells)l+=c.document.getText()+`
`;return l=l.slice(0,-1),l}if(h.isEmpty)return"";const o=this.locationAt(h.start),p=this.locationAt(h.end),m=this._cells[(g=this._cellUris.get(o.uri))!==null&&g!==void 0?g:-1],E=this._cells[(r=this._cellUris.get(p.uri))!==null&&r!==void 0?r:-1];if(!m||!E)return"";if(m===E)return m.document.getText(new v.Range(o.range.start,p.range.end));{const l=m.document.getText(new v.Range(o.range.start,new v.Position(m.document.lineCount,0))),c=E.document.getText(new v.Range(new v.Position(0,0),p.range.end));return l+`
`+c}}offsetAt(h){const g=this._cellLines.getIndexOf(h.line),r=this._cellLengths.getAccumulatedValue(g.index-1),o=this._cells[g.index].document.offsetAt(h.with(g.remainder));return r+o}positionAt(h){if(typeof h=="number"){const r=this._cellLengths.getIndexOf(h),o=this._cellLines.getAccumulatedValue(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(o)}const g=this._cellUris.get(h.uri);if(g!==void 0){const r=this._cellLines.getAccumulatedValue(g-1);return new v.Position(r+h.range.start.line,h.range.start.character)}return new v.Position(0,0)}locationAt(h){v.Range.isRange(h)||(h=new v.Range(h,h));const g=this._cellLines.getIndexOf(h.start.line);let r=g;h.isEmpty||(r=this._cellLines.getIndexOf(h.end.line));const o=new v.Position(g.remainder,h.start.character),p=new v.Position(r.remainder,h.end.character),m=new v.Range(o,p),E=this._cells[g.index];return new v.Location(E.document.uri,E.document.validateRange(m))}contains(h){return this._cellUris.has(h)}validateRange(h){const g=this.validatePosition(h.start),r=this.validatePosition(h.end);return h.with(g,r)}validatePosition(h){const g=this._cellLines.getIndexOf(h.line),r=new v.Position(g.remainder,h.character),o=this._cells[g.index].document.validatePosition(r),p=this._cellLines.getAccumulatedValue(g.index-1);return new v.Position(p+o.line,o.character)}}e.ExtHostNotebookConcatDocument=i}),define(ve[164],we([0,1,7,15,3]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(C){this._actual=new v.ColorTheme(v.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let S=C==="light"?v.ColorThemeKind.Light:C==="dark"?v.ColorThemeKind.Dark:v.ColorThemeKind.HighContrast;this._actual=new v.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=je([qe(0,T.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(ve[72],we([0,1,4]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,v.createDecorator)("IURITransformerService");class T{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=T}),define(ve[165],we([0,1,24]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(S){let k=this.buffers.indexOf(S);return k<0&&(k=this.buffers.length,this.buffers.push(S)),k}}function D(C,S){if(S.serializeBuffersForPostMessage){const k=new T,i=(g,r)=>{if(r instanceof ArrayBuffer){const o=k.add(r);return{$$vscode_array_buffer_reference$$:!0,index:o}}else if(ArrayBuffer.isView(r)){const o=A(r);if(o){const p=k.add(r.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:o,byteLength:r.byteLength,byteOffset:r.byteOffset}}}}return r},P=JSON.stringify(C,i),h=k.buffers.map(g=>{const r=new Uint8Array(g);return v.VSBuffer.wrap(r)});return{message:P,buffers:h}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=D;function A(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(C,S){const k=S.map(h=>{const g=new ArrayBuffer(h.byteLength);return new Uint8Array(g).set(h.buffer),g}),i=S.length?(h,g)=>{if(typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const r=g,{index:o}=r,p=k[o];if(r.view)switch(r.view.type){case 1:return new Int8Array(p,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return g}:void 0;return{message:JSON.parse(C,i),arrayBuffers:k}}e.deserializeWebviewMessage=y}),define(ve[73],we([0,1,2]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function T(D,A,y){var C;const S=D.webviewResourceRoot.replace("{{resource}}",((C=D.remote.authority)!==null&&C!==void 0?C:"")+"/"+y.scheme+"/"+encodeURIComponent(y.authority)+y.path).replace("{{uuid}}",A);return v.URI.parse(S).with({fragment:y.fragment,query:y.query})}e.asWebviewUri=T}),define(ve[166],we([0,1,3,6,73,31]),function(Y,e,v,T,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(S,k,i){this._proxy=S,this._editors=k,this._initData=i,this._handlePool=0,this._disposables=new T.DisposableStore,this._insets=new Map,this._disposables.add(k.onDidChangeVisibleTextEditors(()=>{const P=k.getVisibleTextEditors();for(const h of this._insets.values())P.indexOf(h.editor)<0&&h.inset.dispose()}))}dispose(){this._insets.forEach(S=>S.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(S,k,i,P,h){let g;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===S){g=c;break}if(!g)throw new Error("not a visible editor");const r=this,o=this._handlePool++,p=new v.Emitter,m=new v.Emitter,E=new class{constructor(){this._uuid=(0,A.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,D.asWebviewUri)(r._initData,this._uuid,c)}get cspSource(){return r._initData.webviewCspSource}set options(c){this._options=c,r._proxy.$setOptions(o,c)}get options(){return this._options}set html(c){this._html=c,r._proxy.$setHtml(o,c)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(c){return r._proxy.$postMessage(o,c)}},l=new class{constructor(){this.editor=S,this.line=k,this.height=i,this.webview=E,this.onDidDispose=m.event}dispose(){r._insets.has(o)&&(r._insets.delete(o),r._proxy.$disposeEditorInset(o),m.fire(),m.dispose(),p.dispose())}};return this._proxy.$createEditorInset(o,g.id,g.value.document.uri,k+1,i,P||{},h.identifier,h.extensionLocation),this._insets.set(o,{editor:S,inset:l,onDidReceiveMessage:p}),l}$onDidDispose(S){const k=this._insets.get(S);k&&k.inset.dispose()}$onDidReceiveMessage(S,k){const i=this._insets.get(S);i&&i.onDidReceiveMessage.fire(k)}}e.ExtHostEditorInsets=y}),define(ve[167],we([0,1,3,63,139,4,6,22,29,13,51,23,36,159]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,g.registerIcon)("default-view-icon",h.Codicon.window,(0,D.localize)(0,null));var r;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(r=e.Extensions||(e.Extensions={}));var o;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel"})(o=e.ViewContainerLocation||(e.ViewContainerLocation={}));function p(u){switch(u){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=p;function m(u){return`viewContainer.${u}.enabled`}e.getEnabledViewContainerContextKey=m;class E extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new v.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new v.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(w,b,I){var f;const _=this.get(w.id);if(_)return _;const F=w;return F.openCommandActionDescriptor=(I==null?void 0:I.donotRegisterOpenCommand)?void 0:(f=F.openCommandActionDescriptor)!==null&&f!==void 0?f:{id:F.id},(0,C.getOrSet)(this.viewContainers,b,[]).push(F),(I==null?void 0:I.isDefault)&&this.defaultViewContainers.push(F),this._onDidRegister.fire({viewContainer:F,viewContainerLocation:b}),F}deregisterViewContainer(w){for(const b of this.viewContainers.keys()){const I=this.viewContainers.get(b),f=I==null?void 0:I.indexOf(w);if(f!==-1){I==null||I.splice(f,1),I.length===0&&this.viewContainers.delete(b),this._onDidDeregister.fire({viewContainer:w,viewContainerLocation:b});return}}}get(w){return this.all.filter(b=>b.id===w)[0]}getViewContainers(w){return[...this.viewContainers.get(w)||[]]}getViewContainerLocation(w){return[...this.viewContainers.keys()].filter(b=>this.getViewContainers(b).filter(I=>(I==null?void 0:I.id)===w.id).length>0)[0]}getDefaultViewContainer(w){return this.defaultViewContainers.find(b=>this.getViewContainerLocation(b)===w)}}S.Registry.add(r.ViewContainersRegistry,new E);var l;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(l=e.ViewContentGroups||(e.ViewContentGroups={}));function c(u,w){var b,I,f,_;const F=(b=u.group)!==null&&b!==void 0?b:l.More,U=(I=w.group)!==null&&I!==void 0?I:l.More;return F!==U?F.localeCompare(U):((f=u.order)!==null&&f!==void 0?f:5)-((_=w.order)!==null&&_!==void 0?_:5)}class d extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new v.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new v.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new v.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new v.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(w,b){this.registerViews2([{views:w,viewContainer:b}])}registerViews2(w){w.forEach(({views:b,viewContainer:I})=>this.addViews(b,I)),this._onViewsRegistered.fire(w)}deregisterViews(w,b){const I=this.removeViews(w,b);I.length&&this._onViewsDeregistered.fire({views:I,viewContainer:b})}moveViews(w,b){for(const I of this._views.keys())if(I!==b){const f=this.removeViews(w,I);f.length&&(this.addViews(f,b),this._onDidChangeContainer.fire({views:f,from:I,to:b}))}}getViews(w){return this._views.get(w)||[]}getView(w){for(const b of this._viewContainers){const I=(this._views.get(b)||[]).filter(f=>f.id===w)[0];if(I)return I}return null}getViewContainer(w){for(const b of this._viewContainers)if((this._views.get(b)||[]).filter(f=>f.id===w)[0])return b;return null}registerViewWelcomeContent(w,b){return this._viewWelcomeContents.add(w,b),this._onDidChangeViewWelcomeContent.fire(w),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(w,b),this._onDidChangeViewWelcomeContent.fire(w)})}registerViewWelcomeContent2(w,b){const I=new Map;for(const[f,_]of b)this._viewWelcomeContents.add(w,_),I.set(f,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(w,_),this._onDidChangeViewWelcomeContent.fire(w)}));return this._onDidChangeViewWelcomeContent.fire(w),I}getViewWelcomeContent(w){const b=[];return this._viewWelcomeContents.forEach(w,I=>b.push(I)),b.sort(c)}addViews(w,b){let I=this._views.get(b);I||(I=[],this._views.set(b,I),this._viewContainers.push(b));for(const f of w){if(this.getView(f.id)!==null)throw new Error((0,D.localize)(1,null,f.id));I.push(f)}}removeViews(w,b){const I=this._views.get(b);if(!I)return[];const f=[],_=[];for(const F of I)w.includes(F)?f.push(F):_.push(F);return f.length&&(_.length?this._views.set(b,_):(this._views.delete(b),this._viewContainers.splice(this._viewContainers.indexOf(b),1))),f}}S.Registry.add(r.ViewsRegistry,new d),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new T.RawContextKey("focusedView","",(0,D.localize)(2,null));function t(u){return`view.${u}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var n;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var a;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(a=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class s{constructor(w,b){this.resolved=!1,this._hasResolve=!1,(0,P.mixin)(this,w),this._hasResolve=!!b,this.resolve=async I=>{var f,_;if(b&&!this.resolved){const F=await b(I);F&&(this.tooltip=(f=this.tooltip)!==null&&f!==void 0?f:F.tooltip,this.command=(_=this.command)!==null&&_!==void 0?_:F.command)}I.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=s}),define(ve[168],we([0,1,2,149,160,16,150,167]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function S(o){return(p,...m)=>o(p.get(T.ICommandService),...m)}class k{static execute(p,m){const E={forceReuseWindow:m&&m.reuseWindow,remoteAuthority:m&&m.remoteAuthority};return p.executeCommand("_files.newWindow",E)}}e.NewWindowAPICommand=k,k.ID="vscode.newWindow",T.CommandsRegistry.registerCommand({id:k.ID,handler:S(k.execute),description:{description:"Opens an new window",args:[]}}),T.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(o,p){return o.get(D.IWorkspacesService).removeRecentlyOpened([p])});class i{static execute(p,m){return typeof m=="string"?m=m.match(/^[^:/?#]+:\/\//)?v.URI.parse(m):v.URI.file(m):m=v.URI.revive(m),p.executeCommand("_workbench.removeFromRecentlyOpened",m)}}e.RemoveFromRecentlyOpenedAPICommand=i,i.ID="vscode.removeFromRecentlyOpened",T.CommandsRegistry.registerCommand(i.ID,S(i.execute));class P{static execute(p,m){const E=typeof m=="string"?{extensionId:m}:m;return p.executeCommand("workbench.action.openIssueReporter",E)}}e.OpenIssueReporter=P,P.ID="vscode.openIssueReporter",T.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(o,p){const m=o.get(D.IWorkspacesService);let E;const l=p.uri,c=p.label,d=p.remoteAuthority;return p.type==="workspace"?E={workspace:await m.getWorkspaceIdentifier(l),label:c,remoteAuthority:d}:p.type==="folder"?E={folderUri:l,label:c,remoteAuthority:d}:E={fileUri:l,label:c,remoteAuthority:d},m.addRecentlyOpened([E])}),T.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(o){return o.get(D.IWorkspacesService).getRecentlyOpened()}),T.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(o,p){const m=o.get(A.ILogService),E=o.get(y.IEnvironmentService);E.isExtensionDevelopment&&!!E.extensionTestsLocationURI&&m.setLevel(p)}),T.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(o){return o.get(A.ILogService).getLevel()}),T.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(o,p){const m=o.get(C.IViewDescriptorService),E=m.getViewContainerById(p.destinationId);if(!!E){for(const l of p.viewIds){const c=m.getViewDescriptorById(l);(c==null?void 0:c.canMoveView)&&m.moveViewsToContainer([c],E,C.ViewVisibilityState.Default)}await o.get(C.IViewsService).openViewContainer(E.id,!0)}});class h{static execute(p,m){return!Array.isArray(m==null?void 0:m.viewIds)||typeof(m==null?void 0:m.destinationId)!="string"?Promise.reject("Invalid arguments"):p.executeCommand("_workbench.action.moveViews",m)}}e.MoveViewsAPICommand=h,h.ID="vscode.moveViews",T.CommandsRegistry.registerCommand({id:h.ID,handler:S(h.execute),description:{description:"Move Views",args:[]}});class g{static execute(p,m){return p.executeCommand("_workbench.open",m)}}g.ID="vscode.open",T.CommandsRegistry.registerCommand(g.ID,S(g.execute));class r{static execute(p,m,E,l,c){return p.executeCommand("_workbench.diff",[m,E,l])}}r.ID="vscode.diff",T.CommandsRegistry.registerCommand(r.ID,S(r.execute))}),define(ve[169],we([0,1,3,11,140]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new v.Emitter,this._onExit=new v.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,S,k,i){const P={command:C};if(S&&Object.keys(S).length>0&&(P.arguments=S),this.internalSend("request",P),typeof i=="number"){const h=setTimeout(()=>{clearTimeout(h);const g=this.pendingRequests.get(P.seq);if(g){this.pendingRequests.delete(P.seq);const r={type:"response",seq:0,request_seq:P.seq,success:!1,command:C,message:(0,D.localize)(0,null,i,C)};g(r)}},i)}return k&&this.pendingRequests.set(P.seq,k),P.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,S){return C.type!=="event"||S.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,T.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const S=C,k=this.pendingRequests.get(S.request_seq);k&&(this.pendingRequests.delete(S.request_seq),k(S));break}}}internalSend(C,S){S.type=C,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((S,k)=>C.set(k,S)),await(0,T.timeout)(500),C.forEach((S,k)=>{S({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(ve[170],we([0,1,8,2,14,23,19]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function S(n,a,s){return n.replace(C,function(u,w){return a&&w.length>0&&w[0]!=="_"?u:s&&s.hasOwnProperty(w)?s[w]:u})}e.formatPII=S;function k(n){const a={};for(const s of Object.keys(n))s.startsWith("!")||(a[s]=n[s]);return a}e.filterExceptionsFromTelemetry=k;function i(n){return n.configuration.request==="attach"&&!P(n)}e.isSessionAttach=i;function P(n){let a=n.configuration.type;if(!!a)return a==="vslsShare"&&(a=n.configuration.adapterProxy.configuration.type),(0,v.equalsIgnoreCase)(a,"extensionhost")||(0,v.equalsIgnoreCase)(a,"pwa-extensionhost")?n:n.parentSession?P(n.parentSession):void 0}e.getExtensionHostDebugSession=P;function h(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=h;function g(n,a,s){let u,w=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,I=null;for(;I=b.exec(n);){let f=I.index+1,_=f+I[0].length;if(f<=a&&_>=s){u=I[0],w=f;break}}if(u){let f=/\w+/g,_=null;for(;(_=f.exec(u))&&!(_.index+1+w+_[0].length>=s););_&&(u=u.substring(0,f.lastIndex))}return u?{start:w,end:w+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(n){return!!(n&&n.match(r))}e.isUri=o;function p(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(o(n.path))return T.URI.parse(n.path);if((0,D.isAbsolute)(n.path))return T.URI.file(n.path)}return n.path}function m(n){if(typeof n.path=="object"){const a=T.URI.revive(n.path);if(a)return a.scheme===y.Schemas.file?a.fsPath:a.toString()}return n.path}function E(n,a){const s=a?p:m,u=(0,A.deepClone)(n);return c(u,(w,b)=>{w&&b&&(b.path=s(b))}),u}e.convertToDAPaths=E;function l(n,a){const s=a?p:m,u=(0,A.deepClone)(n);return c(u,(w,b)=>{!w&&b&&(b.path=s(b))}),u}e.convertToVSCPaths=l;function c(n,a){switch(n.type){case"event":const s=n;switch(s.event){case"output":a(!1,s.body.source);break;case"loadedSource":a(!1,s.body.source);break;case"breakpoint":a(!1,s.body.breakpoint.source);break;default:break}break;case"request":const u=n;switch(u.command){case"setBreakpoints":a(!0,u.arguments.source);break;case"breakpointLocations":a(!0,u.arguments.source);break;case"source":a(!0,u.arguments.source);break;case"gotoTargets":a(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(b=>a(!1,b));break;default:break}break;case"response":const w=n;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(b=>a(!1,b.source));break;case"loadedSources":w.body.sources.forEach(b=>a(!1,b));break;case"scopes":w.body.scopes.forEach(b=>a(!1,b.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(b=>a(!1,b.source));break;case"setBreakpoints":w.body.breakpoints.forEach(b=>a(!1,b.source));break;default:break}break}}function d(n){return n.filter(a=>{var s;return!((s=a.presentation)===null||s===void 0?void 0:s.hidden)}).sort((a,s)=>a.presentation?s.presentation?a.presentation.group?s.presentation.group?a.presentation.group!==s.presentation.group?a.presentation.group.localeCompare(s.presentation.group):t(a.presentation.order,s.presentation.order):-1:s.presentation.group?1:t(a.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=d;function t(n,a){return typeof n!="number"?typeof a!="number"?0:1:typeof a!="number"?-1:n-a}}),define(ve[74],we([0,1,28,19,14,21,63]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarVisibility=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var C;(function(f){f[f.Markup=1]="Markup",f[f.Code=2]="Code"})(C=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var S;(function(f){f[f.Running=1]="Running",f[f.Idle=2]="Idle"})(S=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var k;(function(f){f[f.Idle=1]="Idle",f[f.Pending=2]="Pending",f[f.Executing=3]="Executing"})(k=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var i;(function(f){f[f.WithHardKernelDependency=0]="WithHardKernelDependency",f[f.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",f[f.Pure=2]="Pure",f[f.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var P;(function(f){f[f.ModelChange=1]="ModelChange",f[f.Move=2]="Move",f[f.CellClearOutput=3]="CellClearOutput",f[f.CellsClearOutput=4]="CellsClearOutput",f[f.ChangeLanguage=5]="ChangeLanguage",f[f.Initialize=6]="Initialize",f[f.ChangeCellMetadata=7]="ChangeCellMetadata",f[f.Output=8]="Output",f[f.OutputItem=9]="OutputItem",f[f.ChangeCellContent=10]="ChangeCellContent",f[f.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",f[f.Unknown=12]="Unknown"})(P=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var h;(function(f){f[f.Handle=0]="Handle",f[f.Index=1]="Index"})(h=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(f){f[f.Replace=1]="Replace",f[f.Output=2]="Output",f[f.Metadata=3]="Metadata",f[f.CellLanguage=4]="CellLanguage",f[f.DocumentMetadata=5]="DocumentMetadata",f[f.Move=6]="Move",f[f.OutputItems=7]="OutputItems",f[f.PartialMetadata=8]="PartialMetadata"})(g=e.CellEditType||(e.CellEditType={}));function r(f){const _=o.parse(f);return _?_.notebook.toString():f.toString()}e.getCellUndoRedoComparisonKey=r;var o;(function(f){f.scheme=T.Schemas.vscodeNotebookCell;const _=/^ch(\d{7,})/;function F(x,j){return x.with({scheme:f.scheme,fragment:`ch${j.toString().padStart(7,"0")}${x.scheme!==T.Schemas.file?x.scheme:""}`})}f.generate=F;function U(x){if(x.scheme===f.scheme){const j=_.exec(x.fragment);if(!!j)return{handle:Number(j[1]),notebook:x.with({scheme:x.fragment.substr(j[0].length)||T.Schemas.file,fragment:null})}}}f.parse=U;function z(x){if(x.scheme===T.Schemas.vscodeNotebookCellMetadata){const j=_.exec(x.fragment);if(!!j)return{handle:Number(j[1]),notebook:x.with({scheme:x.fragment.substr(j[0].length)||T.Schemas.file,fragment:null})}}}f.parseCellMetadataUri=z;function he(x,j,H){return x.with({scheme:H,fragment:`ch${j.toString().padStart(7,"0")}${x.scheme!==T.Schemas.file?x.scheme:""}`})}f.generateCellUri=he;function de(x,j){if(x.scheme===j){const H=_.exec(x.fragment);if(!!H)return{handle:Number(H[1]),notebook:x.with({scheme:x.fragment.substr(H[0].length)||T.Schemas.file,fragment:null})}}}f.parseCellUri=de})(o=e.CellUri||(e.CellUri={}));const p=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function m(f){var _,F;return(F=(_=p.get(f))===null||_===void 0?void 0:_.alwaysSecure)!==null&&F!==void 0?F:!1}e.mimeTypeIsAlwaysSecure=m;function E(f){var _,F;return(F=(_=p.get(f))===null||_===void 0?void 0:_.supportedByCore)!==null&&F!==void 0?F:!1}e.mimeTypeSupportedByCore=E;function l(f){var _,F;return(F=(_=p.get(f))===null||_===void 0?void 0:_.mergeable)!==null&&F!==void 0?F:!1}e.mimeTypeIsMergeable=l;function c(f,_){return A.isWindows&&(f=f.replace(/\//g,"\\"),_=_.replace(/\//g,"\\")),v.match(f,_)}function d(f,_,F){let U=0;for(let z=0;z<_.length;z++){if(c(_[z],f))return U;U++}for(let z=0;z<F.length;z++){if(c(F[z],f))return U;U++}return U}function t(f,_,F){return f.sort((U,z)=>d(U,_,F)-d(z,_,F))}e.sortMimeTypes=t;function n(f,_,F,U=(z,he)=>z===he){const z=[];function he(j,H,R){if(!(H===0&&R.length===0)){const L=z[z.length-1];L&&L.start+L.deleteCount===j?(L.deleteCount+=H,L.toInsert.push(...R)):z.push({start:j,deleteCount:H,toInsert:R})}}let de=0,x=0;for(;;){if(de===f.length){he(de,0,_.slice(x));break}if(x===_.length){he(de,f.length-de,[]);break}const j=f[de],H=_[x];if(U(j,H)){de+=1,x+=1;continue}F(H)?(he(de,1,[]),de+=1):(he(de,0,[H]),x+=1)}return z}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var a;(function(f){f.default="default",f.option="option"})(a=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(f){const _=f;return!!((typeof _.include=="string"||v.isRelativePattern(_.include))&&(typeof _.exclude=="string"||v.isRelativePattern(_.exclude)))}e.isDocumentExcludePattern=s;function u(f,_,F){if(Array.isArray(f.viewType)&&f.viewType.indexOf(_)>=0||f.viewType===_)return!0;if(f.filenamePattern){let U=s(f.filenamePattern)?f.filenamePattern.include:f.filenamePattern,z=s(f.filenamePattern)?f.filenamePattern.exclude:void 0;if(v.match(U,(0,D.basename)(F.fsPath).toLowerCase()))return!(z&&v.match(z,(0,D.basename)(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=u;class w{constructor(_){this.textModel=_}getElements(){const _=new Int32Array(this.textModel.cells.length);for(let F=0;F<this.textModel.cells.length;F++)_[F]=this.textModel.cells[F].getHashValue();return _}}e.CellSequence=w,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var b;(function(f){f[f.Left=1]="Left",f[f.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class I{static create(_){return`${I._prefix}/${_}`}static parse(_){if(_.startsWith(I._prefix))return _.substr(I._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=I,I._prefix="notebook/"}),define(ve[171],we([0,1,142,4,63]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new D.RawContextKey("customExecutionSupported",!0,v.localize(0,null)),e.ShellExecutionSupportedContext=new D.RawContextKey("shellExecutionSupported",!1,v.localize(1,null)),e.ProcessExecutionSupportedContext=new D.RawContextKey("processExecutionSupported",!1,v.localize(2,null)),e.ITaskService=(0,T.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[172],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function v(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=v;function T(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=T}),define(ve[97],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var v;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(S,k)=>{k.expand!==void 0&&(S.expand=k.expand),k.item!==void 0&&(S.item=S.item?Object.assign(S.item,k.item):k.item)};e.applyTestItemUpdate=T;var D;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.Remove=2]="Remove",S[S.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",S[S.Retire=4]="Retire"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));const A=(S,k)=>`${S}:${k.toString()}`;e.getTestSubscriptionKey=A;class y{add(k){}update(k){}remove(k,i){}complete(){}}e.IncrementalChangeCollector=y;class C{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(k){const i=this.createChangeCollector();for(const P of k)switch(P[0]){case 0:{const h=P[1];if(h.parent){if(this.items.has(h.parent)){const g=this.items.get(h.parent);g.children.add(h.item.extId);const r=this.createItem(h,g);this.items.set(h.item.extId,r),i.add(r)}}else{this.roots.add(h.item.extId);const g=this.createItem(h);this.items.set(h.item.extId,g),i.add(g)}h.expand===2&&this.busyControllerCount++;break}case 1:{const h=P[1],g=this.items.get(h.extId);if(!g)break;h.expand!==void 0&&(g.expand===2&&this.busyControllerCount--,h.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(g,h),i.update(g);break}case 2:{const h=this.items.get(P[1]);if(!h)break;h.parent?this.items.get(h.parent).children.delete(h.item.extId):this.roots.delete(h.item.extId);const g=[[P[1]]];for(;g.length;)for(const r of g.pop()){const o=this.items.get(r);o&&(g.push(o.children),this.items.delete(r),i.remove(o,o!==h),o.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(P[1]);break;case 3:this.updatePendingRoots(P[1]);break}i.complete()}retireTest(k){}updatePendingRoots(k){this.pendingRootCount+=k}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=C}),define(ve[173],we([0,1,14,46,10,23,21,58,143]),function(Y,e,v,T,D,A,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(P,h,g){this._contributedVariables=new Map,this._context=P,this._labelService=h,g&&(this._envVariablesPromise=g.then(r=>this.prepareEnv(r)))}prepareEnv(P){if(y.isWindows){const h=Object.create(null);return Object.keys(P).forEach(g=>{h[g.toLowerCase()]=P[g]}),h}return P}resolveWithEnvironment(P,h,g){return this.recursiveResolve(this.prepareEnv(P),h?h.uri:void 0,g)}async resolveAsync(P,h){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,h)}async resolveAnyBase(P,h,g,r){const o=A.deepClone(h);return y.isWindows&&o.windows?Object.keys(o.windows).forEach(p=>o[p]=o.windows[p]):y.isMacintosh&&o.osx?Object.keys(o.osx).forEach(p=>o[p]=o.osx[p]):y.isLinux&&o.linux&&Object.keys(o.linux).forEach(p=>o[p]=o.linux[p]),delete o.windows,delete o.osx,delete o.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,o,g,r)}async resolveAnyAsync(P,h,g){return this.resolveAnyBase(P,h,g)}async resolveAnyMap(P,h,g){const r=new Map;return{newConfig:await this.resolveAnyBase(P,h,g,r),resolvedVariables:r}}resolveWithInteractionReplace(P,h,g,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,h,g,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,h){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,h)}recursiveResolve(P,h,g,r,o){if(D.isString(g))return this.resolveString(P,h,g,r,o);if(D.isArray(g))return g.map(p=>this.recursiveResolve(P,h,p,r,o));if(D.isObject(g)){let p=Object.create(null);return Object.keys(g).forEach(m=>{const E=this.resolveString(P,h,m,r,o);p[E]=this.recursiveResolve(P,h,g[m],r,o)}),p}return g}resolveString(P,h,g,r,o){return g.replace(k.VARIABLE_REGEXP,(m,E)=>{if(E.includes(k.VARIABLE_LHS))return m;let l=this.evaluateSingleVariable(P,m,E,h,r);return o&&o.set(E,l),l})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,h,g,r,o){let p;const m=g.split(":");m.length>1&&(g=m[0],p=m[1]);const E=()=>{const d=this._context.getFilePath();if(d)return d;throw new Error((0,S.localize)(0,null,h))},l=()=>{const d=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,S.localize)(1,null,h,v.basename(d)))},c=()=>{if(p){const d=this._context.getFolderUri(p);if(d)return d;throw new Error((0,S.localize)(2,null,h,p))}if(r)return r;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,h)):new Error((0,S.localize)(4,null,h))};switch(g){case"env":if(p){if(P){const d=P[y.isWindows?p.toLowerCase():p];if(D.isString(d))return d}return""}throw new Error((0,S.localize)(5,null,h));case"config":if(p){const d=this._context.getConfigurationValue(r,p);if(D.isUndefinedOrNull(d))throw new Error((0,S.localize)(6,null,h,p));if(D.isObject(d))throw new Error((0,S.localize)(7,null,h,p));return d}throw new Error((0,S.localize)(8,null,h));case"command":return this.resolveFromMap(h,p,o,"command");case"input":return this.resolveFromMap(h,p,o,"input");default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return r||p?(0,C.normalizeDriveLetter)(this.fsPath(c())):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return v.basename(this.fsPath(c()));case"lineNumber":const d=this._context.getLineNumber();if(d)return d;throw new Error((0,S.localize)(9,null,h));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,S.localize)(10,null,h));case"file":return E();case"fileWorkspaceFolder":return l();case"relativeFile":return r||p?v.relative(this.fsPath(c()),E()):E();case"relativeFileDirname":const n=v.dirname(E());if(r||p){const w=v.relative(this.fsPath(c()),n);return w.length===0?".":w}return n;case"fileDirname":return v.dirname(E());case"fileExtname":return v.extname(E());case"fileBasename":return v.basename(E());case"fileBasenameNoExtension":const a=v.basename(E());return a.slice(0,a.length-v.extname(a).length);case"fileDirnameBasename":return v.basename(v.dirname(E()));case"execPath":const s=this._context.getExecPath();return s||h;case"execInstallFolder":const u=this._context.getAppRoot();return u||h;case"pathSeparator":return v.sep;default:try{const w=p?`${g}:${p}`:g;return this.resolveFromMap(h,w,o,void 0)}catch(w){return h}}}}resolveFromMap(P,h,g,r){if(h&&g){const o=r===void 0?g[h]:g[r+":"+h];if(typeof o=="string")return o;throw new Error((0,S.localize)(11,null,P))}return P}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[174],we([0,1,4]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,v.createDecorator)("editorGroupsService");var T;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(T=e.GroupDirection||(e.GroupDirection={}));var D;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(D=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var y;(function(h){h[h.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",h[h.EVEN=1]="EVEN",h[h.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));var S;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(S=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(h){h[h.GROUP_ACTIVE=0]="GROUP_ACTIVE",h[h.GROUP_INDEX=1]="GROUP_INDEX",h[h.EDITOR_OPEN=2]="EDITOR_OPEN",h[h.EDITOR_CLOSE=3]="EDITOR_CLOSE",h[h.EDITOR_MOVE=4]="EDITOR_MOVE",h[h.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",h[h.EDITOR_LABEL=6]="EDITOR_LABEL",h[h.EDITOR_PIN=7]="EDITOR_PIN",h[h.EDITOR_STICKY=8]="EDITOR_STICKY",h[h.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function P(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=P}),define(ve[175],we([0,1,4]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,v.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ve[9],we([0,1,13,84,229,57,23,10,2,32,62,144,91,74,175,7]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h,g,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var p;(function(pe){function ue(K){const{selectionStartLineNumber:Me,selectionStartColumn:Te,positionLineNumber:Je,positionColumn:et}=K,ut=new o.Position(Me-1,Te-1),ct=new o.Position(Je-1,et-1);return new o.Selection(ut,ct)}pe.to=ue;function re(K){const{anchor:Me,active:Te}=K;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}pe.from=re})(p=e.Selection||(e.Selection={}));var m;(function(pe){function ue(K){if(!!K){const{start:Me,end:Te}=K;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}}pe.from=ue;function re(K){if(!!K){const{startLineNumber:Me,startColumn:Te,endLineNumber:Je,endColumn:et}=K;return new o.Range(Me-1,Te-1,Je-1,et-1)}}pe.to=re})(m=e.Range||(e.Range={}));var E;(function(pe){function ue(re){switch(re){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 4:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}pe.to=ue})(E=e.TokenType||(e.TokenType={}));var l;(function(pe){function ue(K){return new o.Position(K.lineNumber-1,K.column-1)}pe.to=ue;function re(K){return{lineNumber:K.line+1,column:K.character+1}}pe.from=re})(l=e.Position||(e.Position={}));var c;(function(pe){function ue(K){switch(K){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}pe.from=ue;function re(K){switch(K){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}pe.to=re})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var d;(function(pe){function ue(K){let Me;return K.code&&((0,C.isString)(K.code)||(0,C.isNumber)(K.code)?Me=String(K.code):Me={value:String(K.code.value),target:K.code.target}),Object.assign(Object.assign({},m.from(K.range)),{message:K.message,source:K.source,code:Me,severity:n.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(t.from),tags:Array.isArray(K.tags)?(0,v.coalesce)(K.tags.map(c.from)):void 0})}pe.from=ue;function re(K){var Me;const Te=new o.Diagnostic(m.to(K),K.message,n.to(K.severity));return Te.source=K.source,Te.code=(0,C.isString)(K.code)?K.code:(Me=K.code)===null||Me===void 0?void 0:Me.value,Te.relatedInformation=K.relatedInformation&&K.relatedInformation.map(t.to),Te.tags=K.tags&&(0,v.coalesce)(K.tags.map(c.to)),Te}pe.to=re})(d=e.Diagnostic||(e.Diagnostic={}));var t;(function(pe){function ue(K){return Object.assign(Object.assign({},m.from(K.location.range)),{message:K.message,resource:K.location.uri})}pe.from=ue;function re(K){return new o.DiagnosticRelatedInformation(new o.Location(K.resource,m.to(K)),K.message)}pe.to=re})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(pe){function ue(K){switch(K){case o.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}pe.from=ue;function re(K){switch(K){case h.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}pe.to=re})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var a;(function(pe){function ue(K){return typeof K=="number"&&K>=o.ViewColumn.One?K-1:K===o.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}pe.from=ue;function re(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}pe.to=re})(a=e.ViewColumn||(e.ViewColumn={}));function s(pe){return typeof pe.range!="undefined"}function u(pe){return pe.length===0?!0:!!s(pe[0])}e.isDecorationOptionsArr=u;var w;(function(pe){function ue(et){return et.map(pe.from)}pe.fromMany=ue;function re(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function K(et){let ut;if(re(et)){const{language:ht,value:ft}=et;ut={value:"```"+ht+`
`+ft+"\n```\n"}}else o.MarkdownString.isMarkdownString(et)?ut={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?ut={value:et}:ut={value:""};const ct=Object.create(null);ut.uris=ct;const Ze=ht=>{try{let ft=S.URI.parse(ht,!0);ft=ft.with({query:Me(ft.query,ct)}),ct[ht]=ft}catch(ft){}return""},mt=new D.Renderer;return mt.link=Ze,mt.image=ht=>Ze(T.parseHrefAndDimensions(ht).href),D(ut.value,{renderer:mt}),ut}pe.from=K;function Me(et,ut){if(!et)return et;let ct;try{ct=(0,A.parse)(et)}catch(mt){}if(!ct)return et;let Ze=!1;return ct=(0,y.cloneAndChange)(ct,mt=>{if(S.URI.isUri(mt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ht]=mt,Ze=!0,ht}else return}),Ze?JSON.stringify(ct):et}function Te(et){const ut=new o.MarkdownString(et.value,et.supportThemeIcons);return ut.isTrusted=et.isTrusted,ut}pe.to=Te;function Je(et){if(!!et)return typeof et=="string"?et:pe.from(et)}pe.fromStrict=Je})(w=e.MarkdownString||(e.MarkdownString={}));function b(pe){return u(pe)?pe.map(ue=>({range:m.from(ue.range),hoverMessage:Array.isArray(ue.hoverMessage)?w.fromMany(ue.hoverMessage):ue.hoverMessage?w.from(ue.hoverMessage):void 0,renderOptions:ue.renderOptions})):pe.map(ue=>({range:m.from(ue)}))}e.fromRangeOrRangeWithMessage=b;function I(pe){return typeof pe=="undefined"?pe:typeof pe=="string"?S.URI.file(pe):pe}e.pathOrURIToURI=I;var f;(function(pe){function ue(re){return typeof re=="undefined"?re:{contentText:re.contentText,contentIconPath:re.contentIconPath?I(re.contentIconPath):void 0,border:re.border,borderColor:re.borderColor,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,color:re.color,backgroundColor:re.backgroundColor,margin:re.margin,width:re.width,height:re.height}}pe.from=ue})(f=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var _;(function(pe){function ue(re){return typeof re=="undefined"?re:{backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?I(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?f.from(re.before):void 0,after:re.after?f.from(re.after):void 0}}pe.from=ue})(_=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(pe){function ue(re){if(typeof re=="undefined")return re;switch(re){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}pe.from=ue})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var U;(function(pe){function ue(re){return{isWholeLine:re.isWholeLine,rangeBehavior:re.rangeBehavior?F.from(re.rangeBehavior):void 0,overviewRulerLane:re.overviewRulerLane,light:re.light?_.from(re.light):void 0,dark:re.dark?_.from(re.dark):void 0,backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?I(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?f.from(re.before):void 0,after:re.after?f.from(re.after):void 0}}pe.from=ue})(U=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(pe){function ue(K){return{text:K.newText,eol:K.newEol&&Z.from(K.newEol),range:m.from(K.range)}}pe.from=ue;function re(K){const Me=new o.TextEdit(m.to(K.range),K.text);return Me.newEol=typeof K.eol=="undefined"?void 0:Z.to(K.eol),Me}pe.to=re})(z=e.TextEdit||(e.TextEdit={}));var he;(function(pe){function ue(K,Me,Te){var Je,et,ut;const ct={edits:[]};if(K instanceof o.WorkspaceEdit)for(let Ze of K._allEntries())if(Ze._type===1)ct.edits.push({_type:1,oldUri:Ze.from,newUri:Ze.to,options:Ze.options,metadata:Ze.metadata});else if(Ze._type===2){const mt=Me==null?void 0:Me.getDocument(Ze.uri);ct.edits.push({_type:2,resource:Ze.uri,edit:z.from(Ze.edit),modelVersionId:mt==null?void 0:mt.version,metadata:Ze.metadata})}else Ze._type===3?ct.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,edit:Ze.edit,notebookMetadata:Ze.notebookMetadata,notebookVersionId:(Je=Te==null?void 0:Te.getNotebookDocument(Ze.uri,!0))===null||Je===void 0?void 0:Je.apiNotebook.version}):Ze._type===4?(Ze.newOutputs&&ct.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,edit:{editType:2,index:Ze.index,append:Ze.append,outputs:Ze.newOutputs.map(ke.from)}}),Ze.newMetadata&&ct.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,edit:{editType:8,index:Ze.index,metadata:Ze.newMetadata}})):Ze._type===5?ct.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,notebookVersionId:(et=Te==null?void 0:Te.getNotebookDocument(Ze.uri,!0))===null||et===void 0?void 0:et.apiNotebook.version,edit:{editType:1,index:Ze.index,count:Ze.count,cells:Ze.cells.map(Q.from)}}):Ze._type===6&&ct.edits.push({_type:3,metadata:Ze.metadata,resource:Ze.uri,edit:{editType:7,outputId:Ze.outputId,items:((ut=Ze.newOutputItems)===null||ut===void 0?void 0:ut.map(oe.from))||[],append:Ze.append}});return ct}pe.from=ue;function re(K){const Me=new o.WorkspaceEdit;for(const Te of K.edits)Te.edit?Me.replace(S.URI.revive(Te.resource),m.to(Te.edit.range),Te.edit.text):Me.renameFile(S.URI.revive(Te.oldUri),S.URI.revive(Te.newUri),Te.options);return Me}pe.to=re})(he=e.WorkspaceEdit||(e.WorkspaceEdit={}));var de;(function(pe){const ue=Object.create(null);ue[o.SymbolKind.File]=0,ue[o.SymbolKind.Module]=1,ue[o.SymbolKind.Namespace]=2,ue[o.SymbolKind.Package]=3,ue[o.SymbolKind.Class]=4,ue[o.SymbolKind.Method]=5,ue[o.SymbolKind.Property]=6,ue[o.SymbolKind.Field]=7,ue[o.SymbolKind.Constructor]=8,ue[o.SymbolKind.Enum]=9,ue[o.SymbolKind.Interface]=10,ue[o.SymbolKind.Function]=11,ue[o.SymbolKind.Variable]=12,ue[o.SymbolKind.Constant]=13,ue[o.SymbolKind.String]=14,ue[o.SymbolKind.Number]=15,ue[o.SymbolKind.Boolean]=16,ue[o.SymbolKind.Array]=17,ue[o.SymbolKind.Object]=18,ue[o.SymbolKind.Key]=19,ue[o.SymbolKind.Null]=20,ue[o.SymbolKind.EnumMember]=21,ue[o.SymbolKind.Struct]=22,ue[o.SymbolKind.Event]=23,ue[o.SymbolKind.Operator]=24,ue[o.SymbolKind.TypeParameter]=25;function re(Me){return typeof ue[Me]=="number"?ue[Me]:6}pe.from=re;function K(Me){for(const Te in ue)if(ue[Te]===Me)return Number(Te);return o.SymbolKind.Property}pe.to=K})(de=e.SymbolKind||(e.SymbolKind={}));var x;(function(pe){function ue(K){switch(K){case o.SymbolTag.Deprecated:return 1}}pe.from=ue;function re(K){switch(K){case 1:return o.SymbolTag.Deprecated}}pe.to=re})(x=e.SymbolTag||(e.SymbolTag={}));var j;(function(pe){function ue(K){return{name:K.name,kind:de.from(K.kind),tags:K.tags&&K.tags.map(x.from),containerName:K.containerName,location:$.from(K.location)}}pe.from=ue;function re(K){const Me=new o.SymbolInformation(K.name,de.to(K.kind),K.containerName,$.to(K.location));return Me.tags=K.tags&&K.tags.map(x.to),Me}pe.to=re})(j=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var H;(function(pe){function ue(K){var Me,Te;const Je={name:K.name||"!!MISSING: name!!",detail:K.detail,range:m.from(K.range),selectionRange:m.from(K.selectionRange),kind:de.from(K.kind),tags:(Te=(Me=K.tags)===null||Me===void 0?void 0:Me.map(x.from))!==null&&Te!==void 0?Te:[]};return K.children&&(Je.children=K.children.map(ue)),Je}pe.from=ue;function re(K){const Me=new o.DocumentSymbol(K.name,K.detail,de.to(K.kind),m.to(K.range),m.to(K.selectionRange));return(0,v.isNonEmptyArray)(K.tags)&&(Me.tags=K.tags.map(x.to)),K.children&&(Me.children=K.children.map(re)),Me}pe.to=re})(H=e.DocumentSymbol||(e.DocumentSymbol={}));var R;(function(pe){function ue(re){const K=new o.CallHierarchyItem(de.to(re.kind),re.name,re.detail||"",S.URI.revive(re.uri),m.to(re.range),m.to(re.selectionRange));return K._sessionId=re._sessionId,K._itemId=re._itemId,K}pe.to=ue})(R=e.CallHierarchyItem||(e.CallHierarchyItem={}));var L;(function(pe){function ue(re){return new o.CallHierarchyIncomingCall(R.to(re.from),re.fromRanges.map(K=>m.to(K)))}pe.to=ue})(L=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(pe){function ue(re){return new o.CallHierarchyOutgoingCall(R.to(re.to),re.fromRanges.map(K=>m.to(K)))}pe.to=ue})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var $;(function(pe){function ue(K){return{range:K.range&&m.from(K.range),uri:K.uri}}pe.from=ue;function re(K){return new o.Location(S.URI.revive(K.uri),m.to(K.range))}pe.to=re})($=e.location||(e.location={}));var G;(function(pe){function ue(K){const Me=K,Te=K;return{originSelectionRange:Me.originSelectionRange?m.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Te.uri,range:m.from(Me.targetRange?Me.targetRange:Te.range),targetSelectionRange:Me.targetSelectionRange?m.from(Me.targetSelectionRange):void 0}}pe.from=ue;function re(K){return{targetUri:S.URI.revive(K.uri),targetRange:m.to(K.range),targetSelectionRange:K.targetSelectionRange?m.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?m.to(K.originSelectionRange):void 0}}pe.to=re})(G=e.DefinitionLink||(e.DefinitionLink={}));var J;(function(pe){function ue(K){return{range:m.from(K.range),contents:w.fromMany(K.contents)}}pe.from=ue;function re(K){return new o.Hover(K.contents.map(w.to),m.to(K.range))}pe.to=re})(J=e.Hover||(e.Hover={}));var te;(function(pe){function ue(K){return{range:m.from(K.range),expression:K.expression}}pe.from=ue;function re(K){return new o.EvaluatableExpression(m.to(K.range),K.expression)}pe.to=re})(te=e.EvaluatableExpression||(e.EvaluatableExpression={}));var me;(function(pe){function ue(K){if(K instanceof o.InlineValueText)return{type:"text",range:m.from(K.range),text:K.text};if(K instanceof o.InlineValueVariableLookup)return{type:"variable",range:m.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:m.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}pe.from=ue;function re(K){switch(K.type){case"text":return{range:m.to(K.range),text:K.text};case"variable":return{range:m.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:m.to(K.range),expression:K.expression}}}pe.to=re})(me=e.InlineValue||(e.InlineValue={}));var Le;(function(pe){function ue(K){return{frameId:K.frameId,stoppedLocation:m.from(K.stoppedLocation)}}pe.from=ue;function re(K){return new o.InlineValueContext(K.frameId,m.to(K.stoppedLocation))}pe.to=re})(Le=e.InlineValueContext||(e.InlineValueContext={}));var We;(function(pe){function ue(K){return{range:m.from(K.range),kind:K.kind}}pe.from=ue;function re(K){return new o.DocumentHighlight(m.to(K.range),K.kind)}pe.to=re})(We=e.DocumentHighlight||(e.DocumentHighlight={}));var Fe;(function(pe){function ue(re){switch(re){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}pe.to=ue})(Fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ze;(function(pe){function ue(re){return{triggerKind:Fe.to(re.triggerKind),triggerCharacter:re.triggerCharacter}}pe.to=ue})(ze=e.CompletionContext||(e.CompletionContext={}));var W;(function(pe){function ue(K){switch(K){case o.CompletionItemTag.Deprecated:return 1}}pe.from=ue;function re(K){switch(K){case 1:return o.CompletionItemTag.Deprecated}}pe.to=re})(W=e.CompletionItemTag||(e.CompletionItemTag={}));var q;(function(pe){const ue=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function re(Te){var Je;return(Je=ue.get(Te))!==null&&Je!==void 0?Je:9}pe.from=re;const K=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Me(Te){var Je;return(Je=K.get(Te))!==null&&Je!==void 0?Je:o.CompletionItemKind.Property}pe.to=Me})(q=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(pe){function ue(re,K){var Me;const Te=new o.CompletionItem(typeof re.label=="string"?re.label:re.label.name);return typeof re.label!="string"&&(Te.label2=re.label),Te.insertText=re.insertText,Te.kind=q.to(re.kind),Te.tags=(Me=re.tags)===null||Me===void 0?void 0:Me.map(W.to),Te.detail=re.detail,Te.documentation=T.isMarkdownString(re.documentation)?w.to(re.documentation):re.documentation,Te.sortText=re.sortText,Te.filterText=re.filterText,Te.preselect=re.preselect,Te.commitCharacters=re.commitCharacters,k.Range.isIRange(re.range)?Te.range=m.to(re.range):typeof re.range=="object"&&(Te.range={inserting:m.to(re.range.insert),replacing:m.to(re.range.replace)}),Te.keepWhitespace=typeof re.insertTextRules=="undefined"?!1:Boolean(re.insertTextRules&1),typeof re.insertTextRules!="undefined"&&re.insertTextRules&4?Te.insertText=new o.SnippetString(re.insertText):(Te.insertText=re.insertText,Te.textEdit=Te.range instanceof o.Range?new o.TextEdit(Te.range,Te.insertText):void 0),re.additionalTextEdits&&re.additionalTextEdits.length>0&&(Te.additionalTextEdits=re.additionalTextEdits.map(Je=>z.to(Je))),Te.command=K&&re.command?K.fromInternal(re.command):void 0,Te}pe.to=ue})(ee=e.CompletionItem||(e.CompletionItem={}));var se;(function(pe){function ue(K){return{label:K.label,documentation:K.documentation?w.fromStrict(K.documentation):void 0}}pe.from=ue;function re(K){return{label:K.label,documentation:T.isMarkdownString(K.documentation)?w.to(K.documentation):K.documentation}}pe.to=re})(se=e.ParameterInformation||(e.ParameterInformation={}));var ce;(function(pe){function ue(K){return{label:K.label,documentation:K.documentation?w.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(se.from):[],activeParameter:K.activeParameter}}pe.from=ue;function re(K){return{label:K.label,documentation:T.isMarkdownString(K.documentation)?w.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(se.to):[],activeParameter:K.activeParameter}}pe.to=re})(ce=e.SignatureInformation||(e.SignatureInformation={}));var _e;(function(pe){function ue(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ce.from):[]}}pe.from=ue;function re(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ce.to):[]}}pe.to=re})(_e=e.SignatureHelp||(e.SignatureHelp={}));var $e;(function(pe){function ue(K){var Me;return{text:K.text,position:l.from(K.position),kind:fe.from((Me=K.kind)!==null&&Me!==void 0?Me:o.InlayHintKind.Other),whitespaceBefore:K.whitespaceBefore,whitespaceAfter:K.whitespaceAfter}}pe.from=ue;function re(K){const Me=new o.InlayHint(K.text,l.to(K.position),fe.to(K.kind));return Me.whitespaceAfter=K.whitespaceAfter,Me.whitespaceBefore=K.whitespaceBefore,Me}pe.to=re})($e=e.InlayHint||(e.InlayHint={}));var fe;(function(pe){function ue(K){return K}pe.from=ue;function re(K){return K}pe.to=re})(fe=e.InlayHintKind||(e.InlayHintKind={}));var De;(function(pe){function ue(K){return{range:m.from(K.range),url:K.target,tooltip:K.tooltip}}pe.from=ue;function re(K){let Me;if(K.url)try{Me=typeof K.url=="string"?S.URI.parse(K.url,!0):S.URI.revive(K.url)}catch(Te){}return new o.DocumentLink(m.to(K.range),Me)}pe.to=re})(De=e.DocumentLink||(e.DocumentLink={}));var Re;(function(pe){function ue(K){const Me=new o.ColorPresentation(K.label);return K.textEdit&&(Me.textEdit=z.to(K.textEdit)),K.additionalTextEdits&&(Me.additionalTextEdits=K.additionalTextEdits.map(Te=>z.to(Te))),Me}pe.to=ue;function re(K){return{label:K.label,textEdit:K.textEdit?z.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Me=>z.from(Me)):void 0}}pe.from=re})(Re=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(pe){function ue(K){return new o.Color(K[0],K[1],K[2],K[3])}pe.to=ue;function re(K){return[K.red,K.green,K.blue,K.alpha]}pe.from=re})(He=e.Color||(e.Color={}));var be;(function(pe){function ue(K){return{range:m.from(K.range)}}pe.from=ue;function re(K){return new o.SelectionRange(m.to(K.range))}pe.to=re})(be=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(pe){function ue(re){switch(re){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}pe.to=ue})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var V;(function(pe){function ue(K){switch(K){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}pe.from=ue;function re(K){switch(K){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}pe.to=re})(V=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Z;(function(pe){function ue(K){if(K===o.EndOfLine.CRLF)return 1;if(K===o.EndOfLine.LF)return 0}pe.from=ue;function re(K){if(K===1)return o.EndOfLine.CRLF;if(K===0)return o.EndOfLine.LF}pe.to=re})(Z=e.EndOfLine||(e.EndOfLine={}));var ge;(function(pe){function ue(re){if(typeof re=="object")return re.viewId;switch(re){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}pe.from=ue})(ge=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(pe){function ue(re){const K={start:re.start+1,end:re.end+1};return re.kind&&(K.kind=Ve.from(re.kind)),K}pe.from=ue})(Ne=e.FoldingRange||(e.FoldingRange={}));var Ve;(function(pe){function ue(re){if(re)switch(re){case o.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}pe.from=ue})(Ve=e.FoldingRangeKind||(e.FoldingRangeKind={}));var xe;(function(pe){function ue(re){if(re)return{pinned:typeof re.preview=="boolean"?!re.preview:void 0,inactive:re.background,preserveFocus:re.preserveFocus,selection:typeof re.selection=="object"?m.from(re.selection):void 0,override:typeof re.override=="boolean"?P.EditorOverride.DISABLED:void 0}}pe.from=ue})(xe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Xe;(function(pe){function ue(K){return K instanceof o.RelativePattern||typeof K=="string"?K:re(K)?new o.RelativePattern(K.base,K.pattern):K}pe.from=ue;function re(K){const Me=K;return Me&&typeof Me.base=="string"&&typeof Me.pattern=="string"}})(Xe=e.GlobPattern||(e.GlobPattern={}));var ye;(function(pe){function ue(re){if(re){if(Array.isArray(re))return re.map(ue);if(typeof re=="string")return re;{const K=re;return{language:K.language,scheme:K.scheme,pattern:typeof K.pattern=="undefined"?void 0:Xe.from(K.pattern),exclusive:K.exclusive}}}else return}pe.from=ue})(ye=e.LanguageSelector||(e.LanguageSelector={}));var Ee;(function(pe){function ue(K){return{start:K.start,end:K.end}}pe.from=ue;function re(K){return new o.NotebookRange(K.start,K.end)}pe.to=re})(Ee=e.NotebookRange||(e.NotebookRange={}));var Ce;(function(pe){function ue(re){return new o.NotebookCellMetadata().with(Object.assign(Object.assign({},re),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}pe.to=ue})(Ce=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var ie;(function(pe){function ue(K){return K}pe.from=ue;function re(K){return new o.NotebookDocumentMetadata().with(K)}pe.to=re})(ie=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ae;(function(pe){function ue(K){return{startTime:K.runStartTime,endTime:K.runEndTime,executionOrder:K.executionOrder,success:K.lastRunSuccess}}pe.to=ue;function re(K){return{lastRunSuccess:K.success,runStartTime:K.startTime,runEndTime:K.endTime,executionOrder:K.executionOrder}}pe.from=re})(ae=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var N;(function(pe){function ue(K){switch(K){case o.NotebookCellKind.Markup:return g.CellKind.Markup;case o.NotebookCellKind.Code:default:return g.CellKind.Code}}pe.from=ue;function re(K){switch(K){case g.CellKind.Markup:return o.NotebookCellKind.Markup;case g.CellKind.Code:default:return o.NotebookCellKind.Code}}pe.to=re})(N=e.NotebookCellKind||(e.NotebookCellKind={}));var Q;(function(pe){function ue(K){var Me;return{cellKind:N.from(K.kind),language:K.languageId,source:K.value,metadata:Object.assign(Object.assign({},K.metadata),ae.from((Me=K.executionSummary)!==null&&Me!==void 0?Me:{})),outputs:K.outputs?K.outputs.map(ke.from):[]}}pe.from=ue;function re(K){return new o.NotebookCellData(N.to(K.cellKind),K.source,K.language,K.outputs?K.outputs.map(ke.to):void 0,K.metadata?Ce.to(K.metadata):void 0)}pe.to=re})(Q=e.NotebookCellData||(e.NotebookCellData={}));var oe;(function(pe){function ue(K){return{mime:K.mime,value:K.value,metadata:K.metadata}}pe.from=ue;function re(K){return new o.NotebookCellOutputItem(K.mime,K.value,K.metadata)}pe.to=re})(oe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ke;(function(pe){function ue(K){return{outputId:K.id,outputs:K.outputs.map(oe.from),metadata:K.metadata}}pe.from=ue;function re(K){const Me=K.outputs.map(oe.to);return new o.NotebookCellOutput(Me,K.outputId,K.metadata)}pe.to=re})(ke=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ie;(function(pe){function ue(Te){if(Te!=null){if(Te instanceof o.RelativePattern||typeof Te=="string")return Te;if(Me(Te))return new o.RelativePattern(Te.base,Te.pattern);if(K(Te))return{include:Xe.from(Te.include)||void 0,exclude:Xe.from(Te.exclude)||void 0}}}pe.from=ue;function re(Te){return typeof Te=="string"?Te:Me(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}pe.to=re;function K(Te){const Je=Te,et=Xe.from(Je.include);if(!(et&&et instanceof o.RelativePattern||typeof et=="string"))return!1;const ut=Xe.from(Je.exclude);return!!(ut&&ut instanceof o.RelativePattern||typeof ut=="string")}function Me(Te){const Je=Te;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(Ie=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ae;(function(pe){function ue(re){return{backgroundColor:re.backgroundColor,borderColor:re.borderColor,top:re.top?f.from(re.top):void 0}}pe.from=ue})(Ae=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Be;(function(pe){function ue(re,K,Me){const Te=typeof re.command=="string"?{title:"",command:re.command}:re.command;return{alignment:re.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Te,Me),text:re.text,tooltip:re.tooltip,accessibilityInformation:re.accessibilityInformation,priority:re.priority}}pe.from=ue})(Be=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ye;(function(pe){function ue(re){var K,Me;return{transientOutputs:(K=re==null?void 0:re.transientOutputs)!==null&&K!==void 0?K:!1,transientCellMetadata:Object.assign(Object.assign({},re==null?void 0:re.transientCellMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Me=re==null?void 0:re.transientDocumentMetadata)!==null&&Me!==void 0?Me:{}}}pe.from=ue})(Ye=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var rt;(function(pe){function ue(K){var Me;return{uri:K.uri,provides:typeof K.provides=="string"?[K.provides]:(Me=K.provides)!==null&&Me!==void 0?Me:[]}}pe.from=ue;function re(K){return new o.NotebookKernelPreload(S.URI.revive(K.uri),K.provides)}pe.to=re})(rt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var tt;(function(pe){function ue(K){return{message:w.fromStrict(K.message)||"",severity:K.severity,expectedOutput:K.expectedOutput,actualOutput:K.actualOutput,location:K.location?$.from(K.location):void 0}}pe.from=ue;function re(K){const Me=new o.TestMessage(typeof K.message=="string"?K.message:w.to(K.message));return Me.severity=K.severity,Me.actualOutput=K.actualOutput,Me.expectedOutput=K.expectedOutput,Me}pe.to=re})(tt=e.TestMessage||(e.TestMessage={}));var Qe;(function(pe){function ue(Te){var Je,et;return{extId:Te.id,label:Te.label,uri:Te.uri,range:m.from(Te.range)||null,debuggable:(Je=Te.debuggable)!==null&&Je!==void 0?Je:!1,description:Te.description||null,runnable:(et=Te.runnable)!==null&&et!==void 0?et:!0,error:Te.error&&w.fromStrict(Te.error)||null}}pe.from=ue;function re(Te){return{extId:Te.id,label:Te.label,uri:Te.uri,range:m.from(Te.range)||null,debuggable:!1,description:Te.description||null,error:null,runnable:!0}}pe.fromResultSnapshot=re;function K(Te){return{id:Te.extId,label:Te.label,uri:S.URI.revive(Te.uri),range:m.to(Te.range||void 0),addChild:()=>{},dispose:()=>{},status:o.TestItemStatus.Pending,data:void 0,debuggable:Te.debuggable,description:Te.description||void 0,runnable:Te.runnable}}pe.toPlain=K;function Me(Te){const Je=new o.TestItemImpl(Te.extId,Te.label,S.URI.revive(Te.uri),void 0);return Je.range=m.to(Te.range||void 0),Je.debuggable=Te.debuggable,Je.description=Te.description||void 0,Je.runnable=Te.runnable,Je}pe.to=Me})(Qe=e.TestItem||(e.TestItem={}));var gt;(function(pe){const ue=(K,Me)=>Object.assign(Object.assign({},Qe.toPlain(K.item)),{taskStates:K.tasks.map(Te=>({state:Te.state,duration:Te.duration,messages:Te.messages.map(tt.to)})),children:K.children.map(Te=>Me.get(Te)).filter(C.isDefined).map(Te=>ue(Te,Me))});function re(K){const Me=[],Te=new Map;for(const Je of K.items)Te.set(Je.item.extId,Je),Je.direct&&Me.push(Je);return{completedAt:K.completedAt,results:Me.map(Je=>ue(Je,Te))}}pe.to=re})(gt=e.TestResults||(e.TestResults={}));var bt;(function(pe){function ue(re){switch(re){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}pe.to=ue})(bt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ve[176],we([0,1,2,12,7,9,45]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(k,i,P,h={timeout:1500,errors:3}){this._logService=k,this._documents=i,this._mainThreadBulkEdits=P,this._thresholds=h,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(i,P,h)=>{const r={dispose:this._callbacks.push([i,P,k])};return Array.isArray(h)&&h.push(r),r}}async $participateInSave(k,i){const P=v.URI.revive(k);let h=!1;const g=setTimeout(()=>h=!0,this._thresholds.timeout),r=[];try{for(let o of[...this._callbacks]){if(h)break;const p=this._documents.getDocument(P),m=await this._deliverEventAsyncAndBlameBadListeners(o,{document:p,reason:A.TextDocumentSaveReason.to(i)});r.push(m)}}finally{clearTimeout(g)}return r}_deliverEventAsyncAndBlameBadListeners([k,i,P],h){const g=this._badListeners.get(k);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,k,i,h).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const o=this._badListeners.get(k);this._badListeners.set(k,o?o+1:1),typeof o=="number"&&o>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,i,P,h){const g=[],r=Date.now(),{document:o,reason:p}=h,{version:m}=o,E=Object.freeze({document:o,reason:p,waitUntil(l){if(Object.isFrozen(g))throw(0,T.illegalState)("waitUntil can not be called async");g.push(Promise.resolve(l))}});try{i.apply(P,[E])}catch(l){return Promise.reject(l)}return Object.freeze(g),new Promise((l,c)=>{const d=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(d),l(t)}).catch(t=>{clearTimeout(d),c(t)})}).then(l=>{const c={edits:[]};for(const d of l)if(Array.isArray(d)&&d.every(t=>t instanceof D.TextEdit))for(const{newText:t,newEol:n,range:a}of d)c.edits.push({_type:2,resource:o.uri,edit:{range:a&&A.Range.from(a),text:t,eol:n&&A.EndOfLine.from(n)}});if(c.edits.length!==0)return m===o.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(ve[177],we([0,1,3,11,28,2,9,7]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{constructor(P,h,g,r,o){this._onDidCreate=new v.Emitter,this._onDidChange=new v.Emitter,this._onDidDelete=new v.Emitter,this._config=0,g&&(this._config+=1),r&&(this._config+=2),o&&(this._config+=4);const p=(0,D.parse)(h),m=P(E=>{if(!g)for(let l of E.created){const c=A.URI.revive(l);p(c.fsPath)&&this._onDidCreate.fire(c)}if(!r)for(let l of E.changed){const c=A.URI.revive(l);p(c.fsPath)&&this._onDidChange.fire(c)}if(!o)for(let l of E.deleted){const c=A.URI.revive(l);p(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=C.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,m)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(P,h,g){this._logService=h,this._extHostDocumentsAndEditors=g,this._onFileSystemEvent=new v.Emitter,this._onDidRenameFile=new v.Emitter,this._onDidCreateFile=new v.Emitter,this._onDidDeleteFile=new v.Emitter,this._onWillRenameFile=new T.AsyncEmitter,this._onWillCreateFile=new T.AsyncEmitter,this._onWillDeleteFile=new T.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(P,h,g,r){return new S(this._onFileSystemEvent.event,P,h,g,r)}$onFileEvent(P){this._onFileSystemEvent.fire(P)}$onDidRunFileOperation(P,h){switch(P){case 2:this._onDidRenameFile.fire(Object.freeze({files:h.map(g=>({oldUri:A.URI.revive(g.source),newUri:A.URI.revive(g.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:h.map(g=>A.URI.revive(g.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:h.map(g=>A.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(P){return this._createWillExecuteEvent(P,this._onWillRenameFile)}getOnWillCreateFileEvent(P){return this._createWillExecuteEvent(P,this._onWillCreateFile)}getOnWillDeleteFileEvent(P){return this._createWillExecuteEvent(P,this._onWillDeleteFile)}_createWillExecuteEvent(P,h){return(g,r,o)=>{const p=function(E){g.call(r,E)};return p.extension=P,h.event(p,void 0,o)}}async $onWillRunFileOperation(P,h,g,r){switch(P){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:h.map(o=>({oldUri:A.URI.revive(o.source),newUri:A.URI.revive(o.target)}))},g,r);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:h.map(o=>A.URI.revive(o.target))},g,r);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:h.map(o=>A.URI.revive(o.target))},g,r)}}async _fireWillEvent(P,h,g,r){const o=new Set,p=[];if(await P.fireAsync(h,r,async(E,l)=>{var c;const d=Date.now(),t=await Promise.resolve(E);t instanceof C.WorkspaceEdit&&(p.push(t),o.add((c=l.extension.displayName)!==null&&c!==void 0?c:l.extension.identifier.value)),Date.now()-d>g&&this._logService.warn("SLOW file-participant",l.extension.identifier)}),!r.isCancellationRequested&&p.length!==0){const m={edits:[]};for(let E of p){let{edits:l}=y.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);m.edits=m.edits.concat(l)}return{edit:m,extensionNames:Array.from(o)}}}}e.ExtHostFileSystemEventService=k}),define(ve[178],we([0,1,19,23,2,9,7,74]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(h,g,r,o){this.start=h,this.deletedCount=g,this.deletedItems=r,this.items=o}static asApiEvents(h){return h.map(g=>({start:g.start,deletedCount:g.deletedCount,deletedItems:g.deletedItems,items:g.items.map(r=>r.apiCell)}))}}class k{constructor(h,g,r){var o;this.notebook=h,this._extHostDocument=g,this._cellData=r,this.handle=r.handle,this.uri=D.URI.revive(r.uri),this.cellKind=r.cellKind,this._outputs=r.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=(o=r.metadata)!==null&&o!==void 0?o:{},this._metadata=A.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=A.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(h,g){return{EOL:g.eol,lines:g.source,modeId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:h}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const h=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return h.notebook.getCellIndex(h)},notebook:h.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get outputs(){return h._outputs.slice(0)},get metadata(){return h._metadata},get executionSummary(){return h._previousResult}})}return this._apiCell}setOutputs(h){this._outputs=h.map(A.NotebookCellOutput.to)}setOutputItems(h,g,r){const o=r.map(A.NotebookCellOutputItem.to),p=this._outputs.find(m=>m.id===h);p&&(g||(p.outputs.length=0),p.outputs.push(...o))}setMetadata(h){this._internalMetadata=h,this._metadata=A.NotebookCellMetadata.to(h),this._previousResult=A.NotebookCellPreviousExecutionResult.to(h)}}e.ExtHostCell=k;class i{constructor(h,g,r,o,p,m,E){this._proxy=h,this._textDocumentsAndEditors=g,this._textDocuments=r,this._emitter=o,this._viewType=p,this._metadata=m,this.uri=E,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const h=this;this._notebook={get uri(){return h.uri},get version(){return h._versionId},get viewType(){return h._viewType},get isDirty(){return h._isDirty},get isUntitled(){return h.uri.scheme===v.Schemas.untitled},get isClosed(){return h._disposed},get metadata(){return h._metadata},get cellCount(){return h._cells.length},cellAt(g){return g=h._validateIndex(g),h._cells[g].apiCell},getCells(g){return(g?h._getCells(g):h._cells).map(o=>o.apiCell)},save(){return h._save()}}}return this._notebook}updateBackup(h){var g;(g=this._backup)===null||g===void 0||g.delete(),this._backup=h}disposeBackup(){var h;(h=this._backup)===null||h===void 0||h.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(h){h.metadata&&(this._metadata=this._metadata.with(h.metadata))}acceptModelChanged(h,g){this._versionId=h.versionId,this._isDirty=g;for(const r of h.rawEvents)r.kind===C.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(r.changes,!0),r.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(r.changes,!1):r.kind===C.NotebookCellsChangeType.Move?this._moveCell(r.index,r.newIdx):r.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(r.index,r.outputs):r.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(r.index,r.outputId,r.append,r.outputItems):r.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(r.index,r.language):r.kind===C.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(r.index,r.metadata)}_validateIndex(h){return h=h|0,h<0?0:h>=this._cells.length?this._cells.length-1:h}_validateRange(h){let g=h.start|0,r=h.end|0;return g<0&&(g=0),r>this._cells.length&&(r=this._cells.length),h.with({start:g,end:r})}_getCells(h){h=this._validateRange(h);const g=[];for(let r=h.start;r<h.end;r++)g.push(this._cells[r]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(h,g){if(!this._disposed){const r=[],o=[],p=[];h.reverse().forEach(m=>{const l=m[2].map(t=>{const n=new k(this,this._textDocumentsAndEditors,t);return g||o.push(k.asModelAddData(this.apiNotebook,t)),n}),c=new S(m[0],m[1],[],l),d=this._cells.splice(m[0],m[1],...l);for(const t of d)p.push(t.uri),c.deletedItems.push(t.apiCell);r.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:o,removedDocuments:p}),g||this._emitter.emitModelChange((0,T.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(r)}))}}_moveCell(h,g){const r=this._cells.splice(h,1);this._cells.splice(g,0,...r);const o=[new S(h,1,r.map(p=>p.apiCell),[]),new S(g,0,[],r)];this._emitter.emitModelChange((0,T.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(o)}))}_setCellOutputs(h,g){const r=this._cells[h];r.setOutputs(g),this._emitter.emitCellOutputsChange((0,T.deepFreeze)({document:this.apiNotebook,cells:[r.apiCell]}))}_setCellOutputItems(h,g,r,o){const p=this._cells[h];p.setOutputItems(g,r,o),this._emitter.emitCellOutputsChange((0,T.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_changeCellLanguage(h,g){const r=this._cells[h];r.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelModeChanged(r.uri,g)}_changeCellMetadata(h,g){var r;const o=this._cells[h],p=o.internalMetadata,m=o.apiCell.metadata;o.setMetadata(g);const E=o.apiCell.metadata;if((0,T.equals)(m,E)||this._emitter.emitCellMetadataChange((0,T.deepFreeze)({document:this.apiNotebook,cell:o.apiCell})),p.runState!==g.runState){const l=(r=g.runState)!==null&&r!==void 0?r:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,T.deepFreeze)({document:this.apiNotebook,cell:o.apiCell,executionState:l}))}}getCellFromApiCell(h){return this._cells.find(g=>g.apiCell===h)}getCellFromIndex(h){return this._cells[h]}getCell(h){return this._cells.find(g=>g.handle===h)}getCellIndex(h){return this._cells.indexOf(h)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(ve[179],we([0,1,7,9]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class D{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,S){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:C,metadata:S})}replaceCells(C,S,k){this._throwIfFinalized(),!(C===S&&k.length===0)&&this._collectedEdits.push({editType:1,index:C,count:S-C,cells:k.map(T.NotebookCellData.from)})}}class A{constructor(C,S,k,i,P,h){this.id=C,this._proxy=S,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=P,this._visibleRanges=i,this._viewColumn=h}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},get visibleRanges(){return C._visibleRanges},revealRange(S,k){C._proxy.$tryRevealRange(C.id,T.NotebookRange.from(S),k!=null?k:v.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(S){const k=new D(this.document.version);return S(k),C._applyEdit(k.finalize())},setDecorations(S,k){return C.setDecorations(S,k)}}}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const S=[];let k=-1;for(let i=0;i<C.cellEdits.length;i++){if(k<0){S.push(C.cellEdits[i]),k++;continue}const h=S[k],g=C.cellEdits[i];if(h.editType===1&&g.editType===1&&h.index===g.index){h.cells.push(...C.cellEdits[i].cells),h.count+=C.cellEdits[i].count;continue}S.push(C.cellEdits[i]),k++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,S)}setDecorations(C,S){if(!(S.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return S.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,T.NotebookRange.from(S),C.key)}}e.ExtHostNotebookEditor=A}),define(ve[180],we([0,1,9,154,134,20,52]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(P){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=P}withProgress(P,h,g){const r=this._handles++,{title:o,location:p,cancellable:m}=h,E={label:(0,D.localize)(0,null,P.displayName||P.name),id:P.identifier.value};return this._proxy.$startProgress(r,{location:v.ProgressLocation.from(p),title:o,source:E,cancellable:m},P),this._withProgress(r,g,!!m)}_withProgress(P,h,g){let r;g&&(r=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(P,r));const o=m=>{this._proxy.$progressEnd(m),this._mapHandleToCancellationSource.delete(m),r&&r.dispose()};let p;try{p=h(new k(this._proxy,P),g&&r?r.token:A.CancellationToken.None)}catch(m){throw o(P),m}return p.then(m=>o(P),m=>o(P)),p}$acceptProgressCanceled(P){const h=this._mapHandleToCancellationSource.get(P);h&&(h.cancel(),this._mapHandleToCancellationSource.delete(P))}}e.ExtHostProgress=C;function S(i,P){return i.message=P.message,typeof P.increment=="number"&&(typeof i.increment=="number"?i.increment+=P.increment:i.increment=P.increment),i}class k extends T.Progress{constructor(P,h){super(g=>this.throttledReport(g));this._proxy=P,this._handle=h}throttledReport(P){this._proxy.$progressReport(this._handle,P)}}je([(0,y.throttle)(100,(i,P)=>S(i,P),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(ve[98],we([0,1,42,12,54,9,7]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(h,g){const r=C._Keys.nextId();h.$registerTextEditorDecorationType(r,A.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:r,dispose(){h.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=C,C._Keys=new D.IdGenerator("TextEditorDecorationType");class S{constructor(h,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=h,this._documentVersionId=h.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(h,g){this._throwIfFinalized();let r=null;if(h instanceof y.Position)r=new y.Range(h,h);else if(h instanceof y.Range)r=h;else throw new Error("Unrecognized location");this._pushEdit(r,g,!1)}insert(h,g){this._throwIfFinalized(),this._pushEdit(new y.Range(h,h),g,!0)}delete(h){this._throwIfFinalized();let g=null;if(h instanceof y.Range)g=h;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(h,g,r){const o=this._document.validateRange(h);this._collectedEdits.push({range:o,text:g,forceMoveMarkers:r})}setEndOfLine(h){if(this._throwIfFinalized(),h!==y.EndOfLine.LF&&h!==y.EndOfLine.CRLF)throw(0,T.illegalArgument)("endOfLine");this._setEndOfLine=h}}e.TextEditorEdit=S;class k{constructor(h,g,r,o){this._proxy=h,this._id=g,this._accept(r),this._logService=o;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(m){p._setTabSize(m)},get insertSpaces(){return p._insertSpaces},set insertSpaces(m){p._setInsertSpaces(m)},get cursorStyle(){return p._cursorStyle},set cursorStyle(m){p._setCursorStyle(m)},get lineNumbers(){return p._lineNumbers},set lineNumbers(m){p._setLineNumbers(m)}}}_accept(h){this._tabSize=h.tabSize,this._insertSpaces=h.insertSpaces,this._cursorStyle=h.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(h.lineNumbers)}_validateTabSize(h){if(h==="auto")return"auto";if(typeof h=="number"){const g=Math.floor(h);return g>0?g:null}if(typeof h=="string"){const g=parseInt(h,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(h){const g=this._validateTabSize(h);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(h){return h==="auto"?"auto":h==="false"?!1:Boolean(h)}_setInsertSpaces(h){const g=this._validateInsertSpaces(h);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(h){this._cursorStyle!==h&&(this._cursorStyle=h,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:h})))}_setLineNumbers(h){this._lineNumbers!==h&&(this._lineNumbers=h,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(h)})))}assign(h){const g={};let r=!1;if(typeof h.tabSize!="undefined"){const o=this._validateTabSize(h.tabSize);o==="auto"?(r=!0,g.tabSize=o):typeof o=="number"&&this._tabSize!==o&&(this._tabSize=o,r=!0,g.tabSize=o)}if(typeof h.insertSpaces!="undefined"){const o=this._validateInsertSpaces(h.insertSpaces);o==="auto"?(r=!0,g.insertSpaces=o):this._insertSpaces!==o&&(this._insertSpaces=o,r=!0,g.insertSpaces=o)}typeof h.cursorStyle!="undefined"&&this._cursorStyle!==h.cursorStyle&&(this._cursorStyle=h.cursorStyle,r=!0,g.cursorStyle=h.cursorStyle),typeof h.lineNumbers!="undefined"&&this._lineNumbers!==h.lineNumbers&&(this._lineNumbers=h.lineNumbers,r=!0,g.lineNumbers=A.TextEditorLineNumbersStyle.from(h.lineNumbers)),r&&this._warnOnError(this._proxy.$trySetOptions(this._id,g))}_warnOnError(h){h.catch(g=>this._logService.warn(g))}}e.ExtHostTextEditorOptions=k;class i{constructor(h,g,r,o,p,m,E,l){this.id=h,this._proxy=g,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new k(this._proxy,this.id,m,r),this._visibleRanges=E,this._viewColumn=l;const c=this;this.value=Object.freeze({get document(){return o.getValue()},set document(d){throw(0,T.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(d){if(!(d instanceof y.Selection))throw(0,T.illegalArgument)("selection");c._selections=[d],c._trySetSelection()},get selections(){return c._selections},set selections(d){if(!Array.isArray(d)||d.some(t=>!(t instanceof y.Selection)))throw(0,T.illegalArgument)("selections");c._selections=d,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(d){throw(0,T.readonly)("visibleRanges")},get options(){return c._options.value},set options(d){c._disposed||c._options.assign(d)},get viewColumn(){return c._viewColumn},set viewColumn(d){throw(0,T.readonly)("viewColumn")},edit(d,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new S(o.getValue(),t);return d(n),c._applyEdit(n)},insertSnippet(d,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=c._selections.map(s=>A.Range.from(s));else if(t instanceof y.Position){const{lineNumber:s,column:u}=A.Position.from(t);a=[{startLineNumber:s,startColumn:u,endLineNumber:s,endColumn:u}]}else if(t instanceof y.Range)a=[A.Range.from(t)];else{a=[];for(const s of t)if(s instanceof y.Range)a.push(A.Range.from(s));else{const{lineNumber:u,column:w}=A.Position.from(s);a.push({startLineNumber:u,startColumn:w,endLineNumber:u,endColumn:w})}}return g.$tryInsertSnippet(h,d.value,a,n)},setDecorations(d,t){const n=t.length===0;n&&!c._hasDecorationsForKey.has(d.key)||(n?c._hasDecorationsForKey.delete(d.key):c._hasDecorationsForKey.add(d.key),c._runOnProxy(()=>{if(A.isDecorationOptionsArr(t))return g.$trySetDecorations(h,d.key,A.fromRangeOrRangeWithMessage(t));{const a=new Array(4*t.length);for(let s=0,u=t.length;s<u;s++){const w=t[s];a[4*s]=w.start.line+1,a[4*s+1]=w.start.character+1,a[4*s+2]=w.end.line+1,a[4*s+3]=w.end.character+1}return g.$trySetDecorationsFast(h,d.key,a)}}))},revealRange(d,t){c._runOnProxy(()=>g.$tryRevealRange(h,A.Range.from(d),t||y.TextEditorRevealType.Default))},show(d){g.$tryShowEditor(h,A.ViewColumn.from(d))},hide(){g.$tryHideEditor(h)}})}dispose(){(0,v.ok)(!this._disposed),this._disposed=!0}_acceptOptions(h){(0,v.ok)(!this._disposed),this._options._accept(h)}_acceptVisibleRanges(h){(0,v.ok)(!this._disposed),this._visibleRanges=h}_acceptViewColumn(h){(0,v.ok)(!this._disposed),this._viewColumn=h}_acceptSelections(h){(0,v.ok)(!this._disposed),this._selections=h}async _trySetSelection(){const h=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,h)),this.value}_applyEdit(h){const g=h.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const r=g.edits.map(p=>p.range);r.sort((p,m)=>p.end.line===m.end.line?p.end.character===m.end.character?p.start.line===m.start.line?p.start.character-m.start.character:p.start.line-m.start.line:p.end.character-m.end.character:p.end.line-m.end.line);for(let p=0,m=r.length-1;p<m;p++){const E=r[p].end;if(r[p+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const o=g.edits.map(p=>({range:A.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,o,{setEndOfLine:typeof g.setEndOfLine=="number"?A.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(h){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):h().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=i}),define(ve[181],we([0,1,137,25,2,3,6,11,7,10,13,9,20]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(p,m){if((0,k.isString)(p))return{label:p};if(p&&typeof p=="object"&&typeof p.label=="string"){let E;return Array.isArray(p.highlights)&&(E=p.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),E=E.length?E:void 0),{label:p.label,highlights:E}}}class r{constructor(m,E,l){this._proxy=m,this.commands=E,this.logService=l,this.treeViews=new Map;function c(d){return d&&d.$treeViewId&&d.$treeItemHandle}E.registerArgumentProcessor({processArgument:d=>c(d)?this.convertArgument(d):Array.isArray(d)&&d.length>0?d.map(t=>c(t)?this.convertArgument(t):t):d})}registerTreeDataProvider(m,E,l){const c=this.createTreeView(m,{treeDataProvider:E},l);return{dispose:()=>c.dispose()}}createTreeView(m,E,l){if(!E||!E.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=this._proxy.$registerTreeViewDataProvider(m,{showCollapseAll:!!E.showCollapseAll,canSelectMany:!!E.canSelectMany,canDragAndDrop:!!E.canDragAndDrop}),d=this.createExtHostTreeView(m,E,l);return{get onDidCollapseElement(){return d.onDidCollapseElement},get onDidExpandElement(){return d.onDidExpandElement},get selection(){return d.selectedElements},get onDidChangeSelection(){return d.onDidChangeSelection},get visible(){return d.visible},get onDidChangeVisibility(){return d.onDidChangeVisibility},get message(){return d.message},set message(t){d.message=t},get title(){return d.title},set title(t){d.title=t},get description(){return d.description},set description(t){d.description=t},reveal:(t,n)=>d.reveal(t,n),dispose:async()=>{await c,this.treeViews.delete(m),d.dispose()}}}$getChildren(m,E){const l=this.treeViews.get(m);return l?l.getChildren(E):Promise.reject(new Error((0,v.localize)(0,null,m)))}$setParent(m,E,l){const c=this.treeViews.get(m);return c?c.setParent(E,l):Promise.reject(new Error((0,v.localize)(1,null,m)))}async $hasResolve(m){const E=this.treeViews.get(m);if(!E)throw new Error((0,v.localize)(2,null,m));return E.hasResolve}$resolve(m,E,l){const c=this.treeViews.get(m);if(!c)throw new Error((0,v.localize)(3,null,m));return c.resolveTreeItem(E,l)}$setExpanded(m,E,l){const c=this.treeViews.get(m);if(!c)throw new Error((0,v.localize)(4,null,m));c.setExpanded(E,l)}$setSelection(m,E){const l=this.treeViews.get(m);if(!l)throw new Error((0,v.localize)(5,null,m));l.setSelection(E)}$setVisible(m,E){const l=this.treeViews.get(m);if(!l)throw new Error((0,v.localize)(6,null,m));l.setVisible(E)}createExtHostTreeView(m,E,l){const c=new o(m,E,this._proxy,this.commands.converter,this.logService,l);return this.treeViews.set(m,c),c}convertArgument(m){const E=this.treeViews.get(m.$treeViewId);return E?E.getExtensionElement(m.$treeItemHandle):null}}e.ExtHostTreeViews=r;class o extends y.Disposable{constructor(m,E,l,c,d,t){super();if(this.viewId=m,this.proxy=l,this.commands=c,this.logService=d,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new h.CancellationTokenSource,t.contributes&&t.contributes.views)for(const s in t.contributes.views)for(const u of t.contributes.views[s])u.id===m&&(this._title=u.name);this.dataProvider=E.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let n,a;this._register(A.Event.debounce(this._onDidChangeData.event,(s,u)=>(s||(s={message:!1,elements:[]}),u.element!==!1&&(n||(n=new Promise(w=>a=w),this.refreshPromise=this.refreshPromise.then(()=>n)),s.elements.push(u.element)),u.message&&(s.message=!0),s),200,!0)(({message:s,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const w=a;return n=null,this.refresh(u).then(()=>w())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(m=>this.getExtensionElement(m)).filter(m=>!(0,k.isUndefinedOrNull)(m))}getChildren(m){const E=m?this.getExtensionElement(m):void 0;if(m&&!E)return this.logService.error(`No tree item with id '${m}' found.`),Promise.resolve([]);const l=this.getChildrenNodes(m);return(l?Promise.resolve(l):this.fetchChildrenNodes(E)).then(c=>c.map(d=>d.item))}getExtensionElement(m){return this.elements.get(m)}reveal(m,E){E=E||{select:!0,focus:!1};const l=(0,k.isUndefinedOrNull)(E.select)?!0:E.select,c=(0,k.isUndefinedOrNull)(E.focus)?!1:E.focus,d=(0,k.isUndefinedOrNull)(E.expand)?!1:E.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.refreshPromise.then(()=>this.resolveUnknownParentChain(m)).then(t=>this.resolveTreeNode(m,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(a=>a.item)},{select:l,focus:c,expand:d})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:l,focus:c,expand:d})}get message(){return this._message}set message(m){this._message=m,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(m){this._title=m,this.proxy.$setTitle(this.viewId,m,this._description)}get description(){return this._description}set description(m){this._description=m,this.proxy.$setTitle(this.viewId,this._title,m)}setExpanded(m,E){const l=this.getExtensionElement(m);l&&(E?this._onDidExpandElement.fire(Object.freeze({element:l})):this._onDidCollapseElement.fire(Object.freeze({element:l})))}setSelection(m){(0,i.equals)(this._selectedHandles,m)||(this._selectedHandles=m,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(m){m!==this._visible&&(this._visible=m,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}setParent(m,E){const l=m.map(d=>this.getExtensionElement(d)).filter(d=>!(0,k.isUndefinedOrNull)(d)),c=this.getExtensionElement(E);return this.dataProvider.setParent&&l&&c?(0,C.asPromise)(()=>this.dataProvider.setParent(l,c)):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(m,E){var l;if(!!this.dataProvider.resolveTreeItem){const c=this.elements.get(m);if(c){const d=this.nodes.get(c);if(d){const t=(l=await this.dataProvider.resolveTreeItem(d.extensionItem,c,E))!==null&&l!==void 0?l:d.extensionItem;return d.item.tooltip=this.getTooltip(t.tooltip),d.item.command=this.getCommand(d.disposableStore,t.command),d.item}}}}resolveUnknownParentChain(m){return this.resolveParent(m).then(E=>E?this.resolveUnknownParentChain(E).then(l=>this.resolveTreeNode(E,l[l.length-1]).then(c=>(l.push(c),l))):Promise.resolve([]))}resolveParent(m){const E=this.nodes.get(m);return E?Promise.resolve(E.parent?this.elements.get(E.parent.item.handle):void 0):(0,C.asPromise)(()=>this.dataProvider.getParent(m))}resolveTreeNode(m,E){const l=this.nodes.get(m);return l?Promise.resolve(l):(0,C.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(c=>this.createHandle(m,c,E,!0)).then(c=>this.getChildren(E?E.item.handle:void 0).then(()=>{const d=this.getExtensionElement(c);if(d){const t=this.nodes.get(d);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(m){if(m){let E;if(typeof m=="string"){const l=this.getExtensionElement(m);E=l?this.nodes.get(l):void 0}else E=m;return E&&E.children||null}return this.roots}async fetchChildrenNodes(m){this.clearChildren(m);const E=new h.CancellationTokenSource(this._refreshCancellationSource.token);try{const l=m?this.nodes.get(m):void 0,c=await this.dataProvider.getChildren(m);if(E.token.isCancellationRequested)return[];const d=await Promise.all((0,i.coalesce)(c||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!E.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,l):null}));return E.token.isCancellationRequested?[]:(0,i.coalesce)(d)}finally{E.dispose()}}refresh(m){if(m.some(l=>!l))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new h.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const l=this.getHandlesToRefresh(m);if(l.length)return this.refreshHandles(l)}return Promise.resolve(void 0)}getHandlesToRefresh(m){const E=new Set,l=m.map(d=>this.nodes.get(d));for(const d of l)if(d&&!E.has(d.item.handle)){let t=d;for(;t&&t.parent&&l.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&E.add(d.item.handle)}const c=[];return E.forEach(d=>{const t=this.elements.get(d);if(t){const n=this.nodes.get(t);n&&(!n.parent||!E.has(n.parent.item.handle))&&c.push(d)}}),c}refreshHandles(m){const E={};return Promise.all(m.map(l=>this.refreshNode(l).then(c=>{c&&(E[l]=c.item)}))).then(()=>Object.keys(E).length?this.proxy.$refresh(this.viewId,E):void 0)}refreshNode(m){const E=this.getExtensionElement(m);if(E){const l=this.nodes.get(E);if(l)return this.clearChildren(E),(0,C.asPromise)(()=>this.dataProvider.getTreeItem(E)).then(c=>{if(c){const d=this.createTreeNode(E,c,l.parent);return this.updateNodeCache(E,d,l,l.parent),l.dispose(),d}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(m,E,l){const c=this.createTreeNode(m,E,l);if(E.id&&this.elements.has(c.item.handle))throw new Error((0,v.localize)(7,null,E.id));return this.addNodeToCache(m,c),this.addNodeToParentCache(c,l),c}getTooltip(m){return S.MarkdownString.isMarkdownString(m)?P.MarkdownString.from(m):m}getCommand(m,E){return E?this.commands.toInternal(E,m):void 0}createTreeNode(m,E,l){const c=new y.DisposableStore,d=this.createHandle(m,E,l),t=this.getLightIconPath(E);return{item:{handle:d,parentHandle:l?l.item.handle:void 0,label:g(E.label,this.extension),description:E.description,resourceUri:E.resourceUri,tooltip:this.getTooltip(E.tooltip),command:this.getCommand(c,E.command),contextValue:E.contextValue,icon:t,iconDark:this.getDarkIconPath(E)||t,themeIcon:this.getThemeIcon(E),collapsibleState:(0,k.isUndefinedOrNull)(E.collapsibleState)?S.TreeItemCollapsibleState.None:E.collapsibleState,accessibilityInformation:E.accessibilityInformation},extensionItem:E,parent:l,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(m){return m.iconPath instanceof S.ThemeIcon?m.iconPath:void 0}createHandle(m,{id:E,label:l,resourceUri:c},d,t){if(E)return`${o.ID_HANDLE_PREFIX}/${E}`;const n=g(l,this.extension),a=d?d.item.handle:o.LABEL_HANDLE_PREFIX;let s=n?n.label:c?(0,T.basename)(c):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const u=this.nodes.has(m)?this.nodes.get(m).item.handle:void 0,w=this.getChildrenNodes(d)||[];let b,I=0;do{if(b=`${a}/${I}:${s}`,t||!this.elements.has(b)||u===b)break;I++}while(I<=w.length);return b}getLightIconPath(m){if(m.iconPath&&!(m.iconPath instanceof S.ThemeIcon))return typeof m.iconPath=="string"||D.URI.isUri(m.iconPath)?this.getIconPath(m.iconPath):this.getIconPath(m.iconPath.light)}getDarkIconPath(m){if(m.iconPath&&!(m.iconPath instanceof S.ThemeIcon)&&m.iconPath.dark)return this.getIconPath(m.iconPath.dark)}getIconPath(m){return D.URI.isUri(m)?m:D.URI.file(m)}addNodeToCache(m,E){this.elements.set(E.item.handle,m),this.nodes.set(m,E)}updateNodeCache(m,E,l,c){this.elements.delete(E.item.handle),this.nodes.delete(m),E.item.handle!==l.item.handle&&this.elements.delete(l.item.handle),this.addNodeToCache(m,E);const d=this.getChildrenNodes(c)||[],t=d.filter(n=>n.item.handle===l.item.handle)[0];t&&d.splice(d.indexOf(t),1,E)}addNodeToParentCache(m,E){E?(E.children||(E.children=[]),E.children.push(m)):(this.roots||(this.roots=[]),this.roots.push(m))}clearChildren(m){if(m){const E=this.nodes.get(m);if(E){if(E.children)for(const l of E.children){const c=this.elements.get(l.item.handle);c&&this.clear(c)}E.children=void 0}}else this.clearAll()}clear(m){const E=this.nodes.get(m);if(E){if(E.children)for(const l of E.children){const c=this.elements.get(l.item.handle);c&&this.clear(c)}this.nodes.delete(m),this.elements.delete(E.item.handle),E.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(m=>m.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}o.LABEL_HANDLE_PREFIX="0",o.ID_HANDLE_PREFIX="1"}),define(ve[182],we([0,1,13,11,20,10,70,9,7,97]),function(Y,e,v,T,D,A,y,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class i{constructor(){this.testIdsToInternal=new Map}getTestById(p,m){if(m!==void 0){const E=this.testIdsToInternal.get(m),l=E==null?void 0:E.get(p);if(l)return[E,l]}return(0,v.mapFind)(this.testIdsToInternal.values(),E=>{const l=E.get(p);return l&&[E,l]})}createForHierarchy(p=()=>{}){return new r(this.createIdMap(h++),p)}createIdMap(p){const m=new g(p);return this.testIdsToInternal.set(m.id,m),{object:m,dispose:()=>this.testIdsToInternal.delete(m.id)}}}e.OwnedTestCollection=i;var P;(function(o){o[o.Disconnected=0]="Disconnected",o[o.IsChild=1]="IsChild",o[o.IsParent=2]="IsParent",o[o.IsSame=3]="IsSame"})(P=e.TestPosition||(e.TestPosition={}));let h=0;class g{constructor(p){this.id=p,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(p){if(this.map.has(p.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${p.item.extId}`);this.map.set(p.item.extId,p),p.parent||this._roots.add(p)}has(p){return this.map.has(p)}delete(p){const m=this.map.get(p);return m?(this.map.delete(p),this._roots.delete(m),!0):!1}get(p){return this.map.get(p)}comparePositions(p,m){const E=typeof p=="string"?this.map.get(p):p,l=typeof m=="string"?this.map.get(m):m;if(!E||!l)return 0;if(E===l)return 3;for(let c=this.map.get(l.parent);c;c=this.map.get(c.parent))if(c===E)return 1;for(let c=this.map.get(E.parent);c;c=this.map.get(c.parent))if(c===l)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=g;class r{constructor(p,m){this.testIdToInternal=p,this.publishDiff=m,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new T.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(p,m){this.addItem(p,m,null)}getTestByReference(p){return this.testItemToInternal.get(p)}collectDiff(){const p=this.diff;return this.diff=[],p}pushDiff(p){const m=this.diff[this.diff.length-1];if(m&&p[0]===1){if(m[0]===1&&m[1].extId===p[1].extId){(0,k.applyTestItemUpdate)(m[1],p[1]);return}if(m[0]===0&&m[1].item.extId===p[1].extId){(0,k.applyTestItemUpdate)(m[1],p[1]);return}}this.diff.push(p),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(p,m){var E;const l=this.testIdToInternal.object.get(p);if(!!l){if((l.expandLevels===void 0||m>l.expandLevels)&&(l.expandLevels=m),l.expand===1){const c=this.refreshChildren(l);return c.isSettled?this.expandChildren(l,m-1):c.p.then(()=>this.expandChildren(l,m-1))}else if(l.expand===3)return((E=l.initialExpand)===null||E===void 0?void 0:E.isSettled)===!1?l.initialExpand.p.then(()=>this.expandChildren(l,m-1)):this.expandChildren(l,m-1)}}dispose(){var p;for(const m of this.testItemToInternal.values())(p=m.discoverCts)===null||p===void 0||p.dispose(!0),(0,y.getPrivateApiFor)(m.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(p,m){const E=p==null?void 0:p.actual.id;switch(m[0]){case 2:this.pushDiff([4,E]);break;case 1:this.removeItem(p);break;case 0:this.addItem(m[1],p.src.controller,p);break;case 3:const[l,c,d]=m;switch(c){case"status":this.updateExpandability(p);break;case"range":this.pushDiff([1,{extId:E,item:{range:C.Range.from(d)}}]);break;case"error":this.pushDiff([1,{extId:E,item:{error:C.MarkdownString.fromStrict(d)||null}}]);break;default:this.pushDiff([1,{extId:E,item:{[c]:d!=null?d:null}}]);break}break;default:(0,A.assertNever)(m[0])}}addItem(p,m,E){if(!(p instanceof S.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${p.id} did not`);if(this.testItemToInternal.has(p))throw new Error(`Attempted to add a single TestItem ${p.id} multiple times to the tree`);if(this.testIdToInternal.object.has(p.id))throw new Error(`Attempted to insert a duplicate test item ID ${p.id}`);const l=E?E.item.extId:null,c=p.resolveHandler?1:0,d=E?E.expandLevels:1,t={controller:m,tree:this.testIdToInternal.object.id},n={actual:p,parent:l,item:C.TestItem.from(p),expandLevels:d?d-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(p,n),this.pushDiff([0,{parent:l,src:t,expand:c,item:n.item}]);const a=(0,y.getPrivateApiFor)(p);a.parent=E==null?void 0:E.actual,a.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const s of a.children.values())this.testItemToInternal.has(s)||this.addItem(s,m,n)}updateExpandability(p){var m;let E;p.actual.resolveHandler?p.actual.status===S.TestItemStatus.Pending?E=p.discoverCts?2:1:((m=p.initialExpand)===null||m===void 0||m.complete(),E=3):E=0,E!==p.expand&&(p.expand=E,this.pushDiff([1,{extId:p.actual.id,expand:E}]),E===1&&p.expandLevels!==void 0&&this.refreshChildren(p))}expandChildren(p,m){if(!(m<0)){const E=[...p.actual.children.values()].map(l=>this.expand(l.id,m)).filter(T.isThenable);if(E.length)return Promise.all(E).then(()=>{})}}refreshChildren(p){if(p.discoverCts&&p.discoverCts.dispose(!0),!p.actual.resolveHandler){const m=new T.DeferredPromise;return m.complete(),m}return p.expand=2,p.discoverCts=new D.CancellationTokenSource,this.pushExpandStateUpdate(p),p.initialExpand=new T.DeferredPromise,p.actual.resolveHandler(p.discoverCts.token),p.initialExpand}pushExpandStateUpdate(p){this.pushDiff([1,{extId:p.actual.id,expand:p.expand}])}removeItem(p){var m;this.pushDiff([2,p.actual.id]);const E=[p];for(;E.length;){const l=E.pop();if(!!l){(m=l.discoverCts)===null||m===void 0||m.dispose(!0),this.testIdToInternal.object.delete(l.item.extId),this.testItemToInternal.delete(l.actual);for(const c of l.actual.children.values())E.push(this.testIdToInternal.object.get(c.id))}}}flushDiff(){const p=this.collectDiff();p.length&&this.publishDiff(p)}}e.SingleUseTestCollection=r}),define(ve[183],we([0,1,26,3,14]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=A;class y{constructor(i){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(v.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(v.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let P of i.activationEvents)P==="onUri"&&(P=`onUri:${v.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(i)}}keepOnly(i){const P=new Set;i.forEach(h=>P.add(v.ExtensionIdentifier.toKey(h))),this._extensionDescriptions=this._extensionDescriptions.filter(h=>P.has(v.ExtensionIdentifier.toKey(h.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,P){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const h=y._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(h.map(g=>g.identifier)),P.length>0){const g=new Set;P.forEach(r=>g.add(v.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!g.has(v.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(h)}static _findLoopingExtensions(i){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,m){this.addNode(p),this.addNode(m),this._arcs.has(p)?this._arcs.get(p).push(m):this._arcs.set(p,[m])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,m){const E=P.getArcs(p);for(let l=0;l<E.length;l++)if(!m.has(E[l]))return!1;return!0}getNodes(){return this._nodesArr}};let h=new Map;for(let p of i){const m=v.ExtensionIdentifier.toKey(p.identifier);if(h.set(m,p),p.extensionDependencies)for(let E of p.extensionDependencies){const l=v.ExtensionIdentifier.toKey(E);P.addArc(m,l)}}let g=new Set;P.getNodes().filter(p=>P.getArcs(p).length===0).forEach(p=>g.add(p));let r=P.getNodes().filter(p=>!g.has(p)),o;do{o=!1;for(let p=0;p<r.length;p++){const m=r[p];P.hasOnlyGoodArcs(m,g)&&(r.splice(p,1),p--,g.add(m),o=!0)}}while(o);return r.map(p=>h.get(p))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(v.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const P=this._activationMap.get(i);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const P=this._extensionsMap.get(v.ExtensionIdentifier.toKey(i));return P||void 0}}e.ExtensionDescriptionRegistry=y;var C;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(C||(C={}));function S(k,i){const P=k.isBuiltin?0:k.isUnderDevelopment?2:1,h=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(P!==h)return P-h;const g=D.posix.basename(k.extensionLocation.path),r=D.posix.basename(i.extensionLocation.path);return g<r?-1:g>r?1:0}}),define(ve[184],we([0,1,24]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var T;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(T=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var D;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(D=e.MessageType||(e.MessageType={}));function A(C){const S=v.VSBuffer.alloc(1);switch(C){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=A;function y(C,S){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=y}),define(ve[33],we([0,1,3,2,4,26,151]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class C{constructor(E){this.dependency=E}}e.MissingExtensionDependency=C;var S;(function(m){m[m.LocalProcess=0]="LocalProcess",m[m.LocalWebWorker=1]="LocalWebWorker",m[m.Remote=2]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(E,l,c,d){this.codeLoadingTime=E,this.activateCallTime=l,this.activateResolvedTime=c,this.activationReason=d}}e.ActivationTimes=k;class i{constructor(E,l){this.description=E,this.value=l}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var P;(function(m){m[m.Normal=0]="Normal",m[m.Immediate=1]="Immediate"})(P=e.ActivationKind||(e.ActivationKind={}));function h(m){m.enableProposedApi||g(m)}e.checkProposedApiEnabled=h;function g(m){throw new Error(`[${m.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${m.identifier.value}`)}e.throwProposedApiError=g;function r(m){return{type:m.isBuiltin?0:1,isBuiltin:m.isBuiltin||m.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(m.publisher,m.name),uuid:m.uuid},manifest:m,location:m.extensionLocation}}e.toExtension=r;function o(m){return Object.assign(Object.assign({identifier:new A.ExtensionIdentifier(m.identifier.id),isBuiltin:m.type===0,isUserBuiltin:m.type===1&&m.isBuiltin,isUnderDevelopment:!1,extensionLocation:m.location},m.manifest),{uuid:m.identifier.uuid})}e.toExtensionDescription=o;class p{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None}activateByEvent(E){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(E){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(E){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(E){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(E,l){return Promise.resolve()}_onWillActivateExtension(E){}_onDidActivateExtension(E,l,c,d,t){}_onDidActivateExtensionError(E,l){}_onExtensionRuntimeError(E,l){}_onExtensionHostExit(E){}}e.NullExtensionService=p}),define(ve[185],we([0,1,26,33,16]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class y{constructor(r,o,p,m){this.startup=r,this.codeLoadingTime=o,this.activateCallTime=p,this.activateResolvedTime=m}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class C{constructor(r){this._startup=r,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(r,o){return r===-1||o===-1?-1:o-r}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class S{constructor(r,o,p,m,E,l){this.activationFailed=r,this.activationFailedError=o,this.activationTimes=p,this.module=m,this.exports=E,this.subscriptions=l}}e.ActivatedExtension=S;class k extends S{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class i extends S{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class P extends S{constructor(r){super(!0,r,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=P;let h=class{constructor(r,o,p,m,E){this._logService=E,this._registry=r,this._resolvedExtensionsSet=new Set,o.forEach(l=>this._resolvedExtensionsSet.add(v.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,p.forEach(l=>this._hostExtensionsMap.set(v.ExtensionIdentifier.toKey(l),l)),this._host=m,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(r){const o=v.ExtensionIdentifier.toKey(r);return this._activatedExtensions.has(o)}getActivatedExtension(r){const o=v.ExtensionIdentifier.toKey(r),p=this._activatedExtensions.get(o);if(!p)throw new Error("Extension `"+r.value+"` is not known or not activated");return p}activateByEvent(r,o){if(this._alreadyActivatedEvents[r])return A;const p=this._registry.getExtensionDescriptionsForActivationEvent(r);return this._activateExtensions(p.map(m=>({id:m.identifier,reason:{startup:o,extensionId:m.identifier,activationEvent:r}}))).then(()=>{this._alreadyActivatedEvents[r]=!0})}activateById(r,o){const p=this._registry.getExtensionDescription(r);if(!p)throw new Error("Extension `"+r+"` is not known");return this._activateExtensions([{id:p.identifier,reason:o}])}_handleActivateRequest(r,o,p){if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(r.id))){o[v.ExtensionIdentifier.toKey(r.id)]=r;return}const m=this._registry.getExtensionDescription(r.id);if(!m){const c=new Error(`Cannot activate unknown extension '${r.id.value}'`);this._host.onExtensionActivationError(r.id,c,new T.MissingExtensionDependency(r.id.value)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(r.id),new P(c));return}const E=typeof m.extensionDependencies=="undefined"?[]:m.extensionDependencies;let l=!0;for(let c=0,d=E.length;c<d;c++){const t=E[c];if(!this._resolvedExtensionsSet.has(v.ExtensionIdentifier.toKey(t))){const n=this._activatedExtensions.get(v.ExtensionIdentifier.toKey(t));if(!(n&&!n.activationFailed)){if(n&&n.activationFailed){const w=m.displayName||m.identifier.value,b=this._registry.getExtensionDescription(t),I=b&&b.displayName||t,f=new Error(`Cannot activate the '${w}' extension because its dependency '${I}' failed to activate`);f.detail=n.activationFailedError,this._host.onExtensionActivationError(m.identifier,f,null),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(m.identifier),new P(f));return}if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(t))){l=!1,o[v.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(v.ExtensionIdentifier.toKey(t)),reason:r.reason};continue}const a=this._registry.getExtensionDescription(t);if(a){l=!1,o[v.ExtensionIdentifier.toKey(t)]={id:a.identifier,reason:r.reason};continue}const s=m.displayName||m.identifier.value,u=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(m.identifier,u,new T.MissingExtensionDependency(t)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(m.identifier),new P(u));return}}}l?o[v.ExtensionIdentifier.toKey(m.identifier)]=r:p.push(r)}_activateExtensions(r){if(r.length===0||(r=r.filter(E=>!this._activatedExtensions.has(v.ExtensionIdentifier.toKey(E.id))),r.length===0))return Promise.resolve(void 0);const o=Object.create(null),p=[];for(let E=0,l=r.length;E<l;E++)this._handleActivateRequest(r[E],o,p);for(let E=0,l=p.length;E<l;E++){const c=v.ExtensionIdentifier.toKey(p[E].id);o[c]&&delete o[c]}const m=Object.keys(o).map(E=>o[E]);return p.length===0?Promise.all(m.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(m).then(E=>this._activateExtensions(p))}_activateExtension(r,o){const p=v.ExtensionIdentifier.toKey(r);if(this._activatedExtensions.has(p))return Promise.resolve(void 0);const m=this._activatingExtensions.get(p);if(m)return m;const E=this._host.actualActivateExtension(r,o).then(void 0,l=>{const c=new Error;return l&&l.name&&(c.name=l.name),l&&l.message?c.message=`Activating extension '${r.value}' failed: ${l.message}.`:c.message=`Activating extension '${r.value}' failed: ${l}.`,l&&l.stack&&(c.stack=l.stack),this._host.onExtensionActivationError(r,c,null),this._logService.error(`Activating extension ${r.value} failed due to an error:`),this._logService.error(l),new P(l)}).then(l=>{this._activatedExtensions.set(p,l),this._activatingExtensions.delete(p)});return this._activatingExtensions.set(p,E),E}};h=je([qe(4,D.ILogService)],h),e.ExtensionsActivator=h}),define(ve[186],we([0,1,12]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class T{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,y)=>{this._actualOk=A,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,v.onUnexpectedError)(A))}then(A,y){return this._ensureActual().then(A,y)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=T}),define(ve[99],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class v{constructor(S,k){this.isMain=S,this.sid=k,this.nid=++v.count}}e.ProxyIdentifier=v,v.count=0;const T=[];function D(C){const S=new v(!0,C);return T[S.nid]=S,S}e.createMainContextProxyIdentifier=D;function A(C){const S=new v(!1,C);return T[S.nid]=S,S}e.createExtHostContextProxyIdentifier=A;function y(C){return T[C].sid}e.getStringIdentifierForProxy=y}),define(ve[5],we([0,1,57,2,99]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var y;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var P;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(P=e.CandidatePortSource||(e.CandidatePortSource={}));var h;(function(l){l.name="$ident";function c(t,n){return Object.defineProperty(t,l.name,{value:n,enumerable:!0}),t}l.mixin=c;function d(t){return t[l.name]}l.of=d})(h=e.ObjectIdentifier||(e.ObjectIdentifier={}));class g{static mixin(c){return c._id=g._n++,c}}e.IdObject=g,g._n=0;var r;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n",l.label2="o"})(r=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var o;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(o=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function m(l){if(l&&l.edits)for(const c of l.edits)typeof c.resource=="object"?c.resource=T.URI.revive(c.resource):(c.newUri=T.URI.revive(c.newUri),c.oldUri=T.URI.revive(c.oldUri)),c.metadata&&c.metadata.iconPath&&(c.metadata=(0,v.revive)(c.metadata));return l}e.reviveWorkspaceEditDto=m;var E;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,D.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,D.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,D.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,D.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,D.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,D.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,D.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,D.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,D.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,D.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,D.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,D.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,D.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,D.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,D.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,D.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,D.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,D.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,D.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,D.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,D.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ve[75],we([0,1,5,3,4]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(C){this._onDidChangePassword=new T.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(v.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,S){return this._proxy.$getPassword(C,S)}store(C,S,k){return this._proxy.$setPassword(C,S,k)}delete(C,S){return this._proxy.$deletePassword(C,S)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(ve[76],we([0,1,4,16,5,15]),function(Y,e,v,T,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,v.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(S,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(D.MainContext.MainThreadTelemetry)}report(S,k,i){const P=this.getUsageKey(S,k);this._reportedUsages.has(P)||(this._reportedUsages.add(P),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:S}))}getUsageKey(S,k){return`${S}-${k.identifier.value}`}};y=je([qe(0,A.IExtHostRpcService),qe(1,T.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(C,S,k){}})}),define(ve[187],we([0,1,3,5,7,26]),function(Y,e,v,T,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new v.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new v.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(S,k,i,P={}){const h=A.ExtensionIdentifier.toKey(S.identifier),g=this._inFlightRequests.get(h)||[],r=i.sort().join(" ");let o=g.find(p=>p.scopes===r);if(o)return o.result;{const p=this._getSession(S,h,k,i,P);o={scopes:r,result:p},g.push(o),this._inFlightRequests.set(h,g);try{await p}finally{const m=g.findIndex(E=>E.scopes===r);m>-1&&(g.splice(m),this._inFlightRequests.set(h,g))}return p}}async _getSession(S,k,i,P,h={}){await this._proxy.$ensureProvider(i);const g=S.displayName||S.name;return this._proxy.$getSession(i,P,k,g,h)}async removeSession(S,k){const i=this._authenticationProviders.get(S);return i?i.provider.removeSession(k):this._proxy.$removeSession(S,k)}registerAuthenticationProvider(S,k,i,P){var h;if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:k,provider:i,options:P!=null?P:{supportsMultipleAccounts:!1}}),this._providers.find(r=>r.id===S)||this._providers.push({id:S,label:k});const g=i.onDidChangeSessions(r=>{var o,p,m;this._proxy.$sendDidChangeSessions(S,{added:(o=r.added)!==null&&o!==void 0?o:[],changed:(p=r.changed)!==null&&p!==void 0?p:[],removed:(m=r.removed)!==null&&m!==void 0?m:[]})});return this._proxy.$registerAuthenticationProvider(S,k,(h=P==null?void 0:P.supportsMultipleAccounts)!==null&&h!==void 0?h:!1),new D.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(S);const r=this._providers.findIndex(o=>o.id===S);r>-1&&this._providers.splice(r),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,k){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,k){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,k){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,k){return this._onDidChangeSessions.fire({provider:{id:S,label:k}}),Promise.resolve()}$onDidChangeAuthenticationProviders(S,k){return S.forEach(i=>{this._providers.some(P=>P.id===i.id)||this._providers.push(i)}),k.forEach(i=>{const P=this._providers.findIndex(h=>h.id===i.id);P>-1&&this._providers.splice(P)}),this._onDidChangeAuthenticationProviders.fire({added:S,removed:k}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(ve[188],we([0,1,5,15,9]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(C,S){this._extHostDocumentsAndEditors=S,this._proxy=C.getProxy(v.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const S=D.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};A=je([qe(0,T.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(ve[189],we([0,1,5]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(A){const y=A.getProxy(v.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(C){return y.$writeText(C)}})}}e.ExtHostClipboard=T}),define(ve[77],we([0,1,10,7,9,23,5,13,16,57,32,38,2,6,4,15]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h,g,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let p=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=n,this.converter=new m(this,a=>{const s=this._apiCommands.get(a);return(s==null?void 0:s.result)===l.Void?s:void 0},n),this._argumentProcessors=[{processArgument(a){return(0,k.revive)(a)}},{processArgument(a){return(0,A.cloneAndChange)(a,function(s){if(i.Range.isIRange(s))return D.Range.to(s);if(P.Position.isIPosition(s))return D.Position.to(s);if(i.Range.isIRange(s.range)&&h.URI.isUri(s.uri))return D.location.to(s);if(!Array.isArray(s))return s})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...a)=>{const s=t.args.map((w,b)=>{if(!w.validate(a[b]))throw new Error(`Invalid argument '${w.name}' when running '${t.id}', received: ${a[b]}`);return w.convert(a[b])}),u=await this.executeCommand(t.internalId,...s);return t.result.convert(u,a,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new T.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,a,s,u){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:a,thisArg:s,description:u}),t&&this._proxy.$registerCommand(n),new T.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,a){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const s=(0,A.cloneAndChange)(n,function(u){if(u instanceof T.Position)return D.Position.from(u);if(u instanceof T.Range)return D.Range.from(u);if(u instanceof T.Location)return D.location.from(u);if(T.NotebookRange.isNotebookRange(u))return D.NotebookRange.from(u);if(!Array.isArray(u))return u});try{const u=await this._proxy.$executeCommand(t,s,a);return(0,k.revive)(u)}catch(u){if(u instanceof Error&&u.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw u}}}async _executeContributedCommand(t,n){const a=this._commands.get(t);if(!a)throw new Error("Unknown command");let{callback:s,thisArg:u,description:w}=a;if(w)for(let b=0;b<w.args.length;b++)try{(0,v.validateConstraint)(n[b],w.args[b].constraint)}catch(I){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${w.args[b].name}' - ${w.args[b].description}`)}try{return await s.apply(u,n)}catch(b){if(t===this.converter.delegatingCommandId){const I=this.converter.getActualCommand(...n);I&&(t=I.command)}throw this._logService.error(b,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(a=>this._argumentProcessors.reduce((s,u)=>u.processArgument(s),a)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(a=>a[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,a]of this._commands){let{description:s}=a;s&&(t[n]=s)}return Promise.resolve(t)}};p=je([qe(0,o.IExtHostRpcService),qe(1,S.ILogService)],p),e.ExtHostCommands=p,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class m{constructor(t,n,a){this._commands=t,this._lookupApiCommand=n,this._logService=a,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const a={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return a;const s=this._lookupApiCommand(t.command);if(s)a.id=s.internalId,a.arguments=s.args.map((u,w)=>u.convert(t.arguments&&t.arguments[w]));else if((0,C.isNonEmptyArray)(t.arguments)){const u=++this._cachIdPool;this._cache.set(u,t),n.add((0,g.toDisposable)(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),a.$ident=u,a.id=this.delegatingCommandId,a.arguments=[u],this._logService.trace("CommandsConverter#CREATE",t.command,u)}return a}}fromInternal(t){const n=y.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=m;class E{constructor(t,n,a,s){this.name=t,this.description=n,this.validate=a,this.convert=s}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new E(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",d=>h.URI.isUri(d),d=>d),E.Position=new E("position","A position in a text document",d=>T.Position.isPosition(d),D.Position.from),E.Range=new E("range","A range in a text document",d=>T.Range.isRange(d),D.Range.from),E.Selection=new E("selection","A selection in a text document",d=>T.Selection.isSelection(d),D.Selection.from),E.Number=new E("number","",d=>typeof d=="number",d=>d),E.String=new E("string","",d=>typeof d=="string",d=>d),E.CallHierarchyItem=new E("item","A call hierarchy item",d=>d instanceof T.CallHierarchyItem,D.CallHierarchyItem.to);class l{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=l,l.Void=new l("no result",d=>d);class c{constructor(t,n,a,s,u){this.id=t,this.internalId=n,this.description=a,this.args=s,this.result=u}}e.ApiCommand=c}),define(ve[190],we([0,1,6,9,7,62,77,168,13,88]),function(Y,e,v,T,D,A,y,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const i=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",h(T.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if(!(0,S.isFalsyOrEmpty)(r)){class p extends D.SymbolInformation{static to(E){const l=new p(E.name,T.SymbolKind.to(E.kind),E.containerName||"",new D.Location(o[0],T.Range.to(E.range)));return l.detail=E.detail,l.range=l.location.range,l.selectionRange=T.Range.to(E.selectionRange),l.children=E.children?E.children.map(p.to):[],l}}return r.map(p.to)}})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",h(T.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",h(T.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new y.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",h(T.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",h(T.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",h(T.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>D.Position.isPosition(o)),r=>r.map(T.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(o=>{let p;for(const m of o.reverse())p=new D.SelectionRange(T.Range.to(m),p);return p}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const o=[];if(Array.isArray(r))for(let p of r)o.push(...p[1].map(T.WorkspaceSymbol.to));return o})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(T.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(T.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(T.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return T.WorkspaceEdit.to(r)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(T.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new D.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const o=(0,k.decodeSemanticTokensDto)(r);if(o.type==="full")return new D.SemanticTokens(o.data,void 0)}})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new D.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const o=(0,k.decodeSemanticTokensDto)(r);if(o.type==="full")return new D.SemanticTokens(o.data,void 0)}})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,o,p)=>{if(!r)return new D.CompletionList([]);const m=r.suggestions.map(E=>T.CompletionItem.to(E,p));return new D.CompletionList(m,r.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return T.SignatureHelp.to(r)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,o,p)=>h(m=>new D.CodeLens(T.Range.to(m.range),m.command&&p.fromInternal(m.command)))(r))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>D.Range.isRange(r),r=>D.Selection.isSelection(r)?T.Selection.from(r):T.Range.from(r)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,o,p)=>h(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(m.command)}else{const E=new D.CodeAction(m.title,m.kind?new D.CodeActionKind(m.kind):void 0);return m.edit&&(E.edit=T.WorkspaceEdit.to(m.edit)),m.command&&(E.command=p.fromInternal(m.command)),E.isPreferred=m.isPreferred,E}})(r))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new D.ColorInformation(T.Range.to(o.range),T.Color.to(o.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",r=>r instanceof D.Color,T.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:T.Range.from(r.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(T.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",r=>r.map(T.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",h(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>T.NotebookExclusiveDocumentPattern.to(o))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(T.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[T.ViewColumn.from(r.viewColumn),T.TextEditorOpenOptions.from(r)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[T.ViewColumn.from(r.viewColumn),T.TextEditorOpenOptions.from(r)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[T.ViewColumn.from(r.viewColumn),T.TextEditorOpenOptions.from(r)]).optional()],y.ApiCommandResult.Void)];class P{constructor(o){this._disposables=new v.DisposableStore,this._commands=o}static register(o){return i.forEach(o.registerApiCommand,o),new P(o).registerCommands()}registerCommands(){const o=p=>(...m)=>p(this._commands,...m);this._register(C.RemoveFromRecentlyOpenedAPICommand.ID,o(C.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:p=>typeof p=="string"}]}),this._register(C.OpenIssueReporter.ID,o(C.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:p=>typeof p=="string"||typeof p=="object"&&typeof p.extensionId=="string"}]})}_register(o,p,m){const E=this._commands.registerCommand(!1,o,p,this,m);this._disposables.add(E)}}e.ExtHostApiCommands=P;function h(r){return o=>{if(Array.isArray(o))return o.map(r)}}function g(r){if(!!Array.isArray(r)){const o=[];for(const p of r)A.isLocationLink(p)?o.push(T.DefinitionLink.to(p)):o.push(T.location.to(p));return o}}}),define(ve[191],we([0,1,11,52,3,6,2,62,26,9,7,5]),function(Y,e,v,T,D,A,y,C,S,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class h{constructor(c,d,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=c.getProxy(P.MainContext.MainThreadComments),d.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const a=this._commentControllers.get(n.handle);return a||n}else if(n&&n.$mid===7){const a=this._commentControllers.get(n.commentControlHandle);if(!a)return n;const s=a.getCommentThread(n.commentThreadHandle);return s||n}else if(n&&n.$mid===8){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const s=a.getCommentThread(n.thread.commentThreadHandle);return s?{thread:s,text:n.text}:n}else if(n&&n.$mid===9){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const s=a.getCommentThread(n.thread.commentThreadHandle);if(!s)return n;let u=n.commentUniqueId,w=s.getCommentByUniqueId(u);return w||n}else if(n&&n.$mid===10){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const s=a.getCommentThread(n.thread.commentThreadHandle);if(!s)return n;let u=n.text,w=n.commentUniqueId,b=s.getCommentByUniqueId(w);return b?(b.body=u,b):n}return n}})}createCommentController(c,d,t){const n=h.handlePool++,a=new r(c,n,this._proxy,d,t);this._commentControllers.set(a.handle,a);const s=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(c.identifier))||[];return s.push(a),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(c.identifier),s),a}$createCommentThreadTemplate(c,d,t){const n=this._commentControllers.get(c);!n||n.$createCommentThreadTemplate(d,t)}async $updateCommentThreadTemplate(c,d,t){const n=this._commentControllers.get(c);!n||n.$updateCommentThreadTemplate(d,t)}$deleteCommentThread(c,d){const t=this._commentControllers.get(c);t&&t.$deleteCommentThread(d)}$provideCommentingRanges(c,d,t){const n=this._commentControllers.get(c);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const a=this._documents.getDocument(y.URI.revive(d));return(0,v.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(a,t)).then(s=>s?s.map(u=>k.Range.from(u)):void 0)}$toggleReaction(c,d,t,n,a){const s=this._commentControllers.get(c);return!s||!s.reactionHandler?Promise.resolve(void 0):(0,v.asPromise)(()=>{const u=s.getCommentThread(d);if(u){const w=u.getCommentByUniqueId(n.uniqueIdInThread);if(s!==void 0&&w&&s.reactionHandler)return s.reactionHandler(w,m(a))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=h,h.handlePool=0;class g{constructor(c,d,t,n,a,s,u){this._proxy=c,this._commentController=d,this._id=t,this._uri=n,this._range=a,this._comments=s,this.handle=g._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${d.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,k.Range.from(this._range),u),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=s}set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){c.isEqual(this._range)||(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const c=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),d={};c("range")&&(d.range=k.Range.from(this._range)),c("label")&&(d.label=this.label),c("contextValue")&&(d.contextValue=this.contextValue),c("comments")&&(d.comments=this._comments.map(t=>o(this,this._commentController,t,this._commentsMap))),c("collapsibleState")&&(d.collapseState=E(this._collapseState)),c("canReply")&&(d.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,d)}}getCommentByUniqueId(c){for(let d of this._commentsMap){let t=d[0],n=d[1];if(c===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}g._handlePool=0,je([(0,T.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=g;class r{constructor(c,d,t,n,a){this._extension=c,this._handle=d,this._proxy=t,this._id=n,this._label=a,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,a)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(c,d,t,n){if(typeof c=="string"){const a=new g(this._proxy,this,c,d,t,n,this._extension.identifier);return this._threads.set(a.handle,a),a}else{const a=new g(this._proxy,this,void 0,c,d,t,this._extension.identifier);return this._threads.set(a.handle,a),a}}$createCommentThreadTemplate(c,d){const t=new g(this._proxy,this,void 0,y.URI.revive(c),k.Range.to(d),[],this._extension.identifier);return t.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(c,d){let t=this._threads.get(c);t&&(t.range=k.Range.to(d))}$deleteCommentThread(c){let d=this._threads.get(c);d&&d.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function o(l,c,d,t){let n=t.get(d);n||(n=++l.commentHandle,t.set(d,n));const a=d.author&&d.author.iconPath?d.author.iconPath.toString():void 0;return{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:n,body:k.MarkdownString.from(d.body),userName:d.author.name,userIconPath:a,label:d.label,commentReactions:d.reactions?d.reactions.map(s=>p(s)):void 0}}function p(l){return{label:l.label,iconPath:l.iconPath?k.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function m(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?y.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function E(l){if(l!==void 0)switch(l){case i.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}}),define(ve[100],we([0,1,2,5,7,4,15,16,13,8,14]),function(Y,e,v,T,D,A,y,C,S,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class bn{constructor(g,r){this._logService=r,this._provider=new Map,this._proxy=g.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,r){const o=bn._handlePool++;this._provider.set(o,{provider:g,extensionId:r}),this._proxy.$registerDecorationProvider(o,r.value);const p=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(m=>{if(!m){this._proxy.$onDidChange(o,null);return}let E=(0,S.asArray)(m);if(E.length<=bn._maxEventSize){this._proxy.$onDidChange(o,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,E.length);const l=E.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),c=(0,S.groupBy)(l,(t,n)=>t.rank-n.rank||(0,k.compare)(t.uri.path,n.uri.path));let d=[];e:for(let t of c){let n;for(let a of t){let s=(0,i.dirname)(a.uri.path);if(n!==s&&(n=s,d.push(a.uri)>=bn._maxEventSize))break e}}this._proxy.$onDidChange(o,d)});return new D.Disposable(()=>{p==null||p.dispose(),this._proxy.$unregisterDecorationProvider(o),this._provider.delete(o)})}async $provideDecorations(g,r,o){if(!this._provider.has(g))return Object.create(null);const p=Object.create(null),{provider:m,extensionId:E}=this._provider.get(g);return await Promise.all(r.map(async l=>{try{const{uri:c,id:d}=l,t=await Promise.resolve(m.provideFileDecoration(v.URI.revive(c),o));if(!t)return;try{D.FileDecoration.validate(t),p[d]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${E.value}': ${n}`)}}catch(c){this._logService.error(c)}})),p}};P._handlePool=0,P._maxEventSize=250,P=je([qe(0,y.IExtHostRpcService),qe(1,C.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(ve[192],we([0,1,132,91,2,5,7,9,3,16,22]),function(Y,e,v,T,D,A,y,C,S,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class P{constructor(r,o,p,m,E){this._name=r,this._owner=o,this._maxDiagnosticsPerFile=p,this._proxy=m,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(r,o){if(!r){this.clear();return}this._checkDisposed();let p=[];if(D.URI.isUri(r)){if(!o){this.delete(r);return}this._data.set(r,o.slice()),p=[r]}else if(Array.isArray(r)){p=[];let E;r=[...r].sort(P._compareIndexedTuplesByUri);for(const l of r){const[c,d]=l;if((!E||c.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=c,p.push(c),this._data.set(c,[])),d){const t=this._data.get(c);t&&t.push(...d)}else{const t=this._data.get(c);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(p),!!this._proxy){const m=[];for(let E of p){let l=[];const c=this._data.get(E);if(c)if(c.length>this._maxDiagnosticsPerFile){l=[];const d=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of c)if(n.severity===d[t]&&l.push(C.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;l.push({severity:T.MarkerSeverity.Info,message:(0,v.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=c.map(d=>C.Diagnostic.from(d));m.push([E,l])}this._proxy.$changeMany(this._owner,m)}}delete(r){this._checkDisposed(),this._onDidChangeDiagnostics.fire([r]),this._data.delete(r),this._proxy&&this._proxy.$changeMany(this._owner,[[r,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(r,o){this._checkDisposed();for(let p of this._data.keys())r.apply(o,[p,this.get(p),this])}get(r){this._checkDisposed();const o=this._data.get(r);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(r){return this._checkDisposed(),Array.isArray(this._data.get(r))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(r,o){return r[0].toString()<o[0].toString()?-1:r[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=P;let h=class zt{constructor(r,o){this._logService=o,this._collections=new Map,this._onDidChangeDiagnostics=new S.Emitter,this.onDidChangeDiagnostics=S.Event.map(S.Event.debounce(this._onDidChangeDiagnostics.event,zt._debouncer,50),zt._mapper),this._proxy=r.getProxy(A.MainContext.MainThreadDiagnostics)}static _debouncer(r,o){return r?r.concat(o):o}static _mapper(r){const o=new i.ResourceMap;for(const p of r)o.set(p,p);return{uris:Object.freeze(Array.from(o.values()))}}createDiagnosticCollection(r,o){const{_collections:p,_proxy:m,_onDidChangeDiagnostics:E,_logService:l}=this,c=new class{$changeMany(n,a){m.$changeMany(n,a),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,n,a.length===0?"CLEARING":a)}$clear(n){m.$clear(n),l.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,n)}dispose(){m.dispose()}};let d;if(!o)o="_generated_diagnostic_collection_name_#"+zt._idPool++,d=o;else if(!p.has(o))d=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do d=o+zt._idPool++;while(p.has(d))}return new class extends P{constructor(){super(o,d,zt._maxDiagnosticsPerFile,c,E);p.set(d,this)}dispose(){super.dispose(),p.delete(d)}}}getDiagnostics(r){if(r)return this._getDiagnostics(r);{const o=new Map,p=[];for(const m of this._collections.values())m.forEach((E,l)=>{let c=o.get(E.toString());typeof c=="undefined"&&(c=p.length,o.set(E.toString(),c),p.push([E,[]])),p[c][1]=p[c][1].concat(...l)});return p}}_getDiagnostics(r){let o=[];for(let p of this._collections.values())p.has(r)&&(o=o.concat(p.get(r)));return o}$acceptMarkersChange(r){if(!this._mirrorCollection){const o="_generated_mirror",p=new P(o,o,zt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(o,p),this._mirrorCollection=p}for(const[o,p]of r)this._mirrorCollection.set(D.URI.revive(o),p.map(C.Diagnostic.to))}};h._idPool=0,h._maxDiagnosticsPerFile=1e3,h=je([qe(1,k.ILogService)],h),e.ExtHostDiagnostics=h}),define(ve[193],we([0,1,2,5]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(y){this._proxy=y.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(C=>C?C.map(S=>v.URI.revive(S)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(C=>C?v.URI.revive(C):void 0)}}e.ExtHostDialogs=D}),define(ve[194],we([0,1,12,2,7,5,19,20,8]),function(Y,e,v,T,D,A,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(P,h,g){this._documentsAndEditors=h,this._logService=g,this._documentContentProviders=new Map,this._proxy=P.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,h){if(Object.keys(y.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const g=k._handlePool++;this._documentContentProviders.set(g,h),this._proxy.$registerTextContentProvider(g,P);let r;return typeof h.onDidChange=="function"&&(r=h.onDidChange(o=>{if(o.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(o)&&this.$provideTextDocumentContent(g,o).then(p=>{if(!(!p&&typeof p!="string")){const m=this._documentsAndEditors.getDocument(o);if(!!m){const E=(0,S.splitLines)(p);if(!m.equalLines(E))return this._proxy.$onVirtualDocumentChange(o,p)}}},v.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(P,h){const g=this._documentContentProviders.get(P);return g?Promise.resolve(g.provideTextDocumentContent(T.URI.revive(h),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${h.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(ve[195],we([0,1,3,6,2,5,96,9,10,23]),function(Y,e,v,T,D,A,y,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class i{constructor(h,g){this._onDidAddDocument=new v.Emitter,this._onDidRemoveDocument=new v.Emitter,this._onDidChangeDocument=new v.Emitter,this._onDidSaveDocument=new v.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new T.DisposableStore,this._documentLoader=new Map,this._proxy=h.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const o of r)this._onDidRemoveDocument.fire(o.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const o of r)this._onDidAddDocument.fire(o.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(h){if(!!h){const g=this._documentsAndEditors.getDocument(h);if(g)return g}}getDocument(h){const g=this.getDocumentData(h);if(!(g==null?void 0:g.document))throw new Error(`Unable to retrieve document from URI '${h}'`);return g.document}ensureDocumentData(h){const g=this._documentsAndEditors.getDocument(h);if(g)return Promise.resolve(g);let r=this._documentLoader.get(h.toString());return r||(r=this._proxy.$tryOpenDocument(h).then(o=>{this._documentLoader.delete(h.toString());const p=D.URI.revive(o);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(p))},o=>(this._documentLoader.delete(h.toString()),Promise.reject(o))),this._documentLoader.set(h.toString(),r)),r}createDocumentData(h){return this._proxy.$tryCreateDocument(h).then(g=>D.URI.revive(g))}$acceptModelModeChanged(h,g){const r=D.URI.revive(h),o=this._documentsAndEditors.getDocument(r);if(!o)throw new Error("unknown document");this._onDidRemoveDocument.fire(o.document),o._acceptLanguageId(g),this._onDidAddDocument.fire(o.document)}$acceptModelSaved(h){const g=D.URI.revive(h),r=this._documentsAndEditors.getDocument(g);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(h,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(h,g){const r=D.URI.revive(h),o=this._documentsAndEditors.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(g),this._onDidChangeDocument.fire({document:o.document,contentChanges:[]})}$acceptModelChanged(h,g,r){const o=D.URI.revive(h),p=this._documentsAndEditors.getDocument(o);if(!p)throw new Error("unknown document");p._acceptIsDirty(r),p.onEvents(g),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:p.document,contentChanges:g.changes.map(m=>({range:C.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text}))}))}setWordDefinitionFor(h,g){(0,y.setWordDefinitionFor)(h,g)}}e.ExtHostDocuments=i}),define(ve[39],we([0,1,42,3,6,2,4,5,96,15,98,9,16,22,19,43,109]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h,g,r,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class m{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(c,d){this._extHostRpc=c,this._logService=d,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new T.Emitter,this._onDidRemoveDocuments=new T.Emitter,this._onDidChangeVisibleTextEditors=new T.Emitter,this._onDidChangeActiveTextEditor=new T.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const d=[],t=[],n=[];if(c.removedDocuments)for(const a of c.removedDocuments){const s=A.URI.revive(a),u=this._documents.get(s);(u==null?void 0:u.unref())&&(this._documents.delete(s),d.push(u.value))}if(c.addedDocuments)for(const a of c.addedDocuments){const s=A.URI.revive(a.uri);let u=this._documents.get(s);if(u&&s.scheme!==r.Schemas.vscodeNotebookCell)throw new Error(`document '${s} already exists!'`);u||(u=new m(new S.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),s,a.lines,a.EOL,a.versionId,a.modeId,a.isDirty,a.notebook)),this._documents.set(s,u),t.push(u.value)),u.ref()}if(c.removedEditors)for(const a of c.removedEditors){const s=this._editors.get(a);this._editors.delete(a),s&&n.push(s)}if(c.addedEditors)for(const a of c.addedEditors){const s=A.URI.revive(a.documentUri);v.ok(this._documents.has(s),`document '${s}' does not exist`),v.ok(!this._editors.has(a.id),`editor '${a.id}' already exists!`);const u=this._documents.get(s).value,w=new i.ExtHostTextEditor(a.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>u.document),a.selections.map(P.Selection.to),a.options,a.visibleRanges.map(b=>P.Range.to(b)),typeof a.editorPosition=="number"?P.ViewColumn.to(a.editorPosition):void 0);this._editors.set(a.id,w)}c.newActiveEditor!==void 0&&(v.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,D.dispose)(d),(0,D.dispose)(n),c.removedDocuments&&this._onDidRemoveDocuments.fire(d),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(a=>a.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){var d;return(d=this._documents.get(c))===null||d===void 0?void 0:d.value}allDocuments(){return o.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!!this._activeEditorId){const d=this._editors.get(this._activeEditorId);return c?d:d==null?void 0:d.value}}allEditors(){return[...this._editors.values()]}};E=je([qe(0,k.IExtHostRpcService),qe(1,h.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(ve[196],we([0,1,2,5,6,7,9,119,8,24]),function(Y,e,v,T,D,A,y,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const r=this._schemes.indexOf(g);r>=0&&(this._schemes.splice(r,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),r=[];let o,p,m=14,E=14;for(const l of g){let c=o?(0,S.commonPrefixLength)(o,l):0;for(c===0?p=1:p=E;c<l.length;c++)c+1===l.length?(m=E,E=9):E+=1,r.push([p,l.toUpperCase().charCodeAt(c),E]),r.push([p,l.toLowerCase().charCodeAt(c),E]),p=E;o=l,E=m}r.push([9,58,10]),r.push([10,47,12]),this._stateMachine=new C.StateMachine(r)}}provideDocumentLinks(g){this._initStateMachine();const r=[],o=C.LinkComputer.computeLinks({getLineContent(p){return g.lineAt(p-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const p of o){const m=y.DocumentLink.to(p);m.target&&r.push(m)}return r}}class P{constructor(g,r){this._extHostLanguageFeatures=r,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=g.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){var g;(g=this._linkProviderRegistration)===null||g===void 0||g.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(g,r,o,p={},m){if(this._registeredSchemes.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const E=this._handlePool++;this._linkProvider.add(r),this._registeredSchemes.add(r),this._fsProvider.set(E,o),this._enableProposedApi.set(E,m!=null?m:!1);let l=2;p.isCaseSensitive&&(l+=1024),p.isReadonly&&(l+=2048),typeof o.copy=="function"&&(l+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&(l+=4),this._proxy.$registerFileSystemProvider(E,r,l).catch(d=>{console.error(`FAILED to register filesystem provider of ${g.value}-extension for the scheme ${r}`),console.error(d)});const c=o.onDidChangeFile(d=>{const t=[];for(const n of d){let{uri:a,type:s}=n;if(a.scheme===r){let u;switch(s){case A.FileChangeType.Changed:u=0;break;case A.FileChangeType.Created:u=1;break;case A.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:a,type:u})}}this._proxy.$onFileSystemChange(E,t)});return(0,D.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(r),this._registeredSchemes.delete(r),this._fsProvider.delete(E),this._enableProposedApi.delete(E),this._proxy.$unregisterProvider(E)})}static _asIStat(g,r){const{type:o,ctime:p,mtime:m,size:E,permissions:l}=g;return r?{type:o,ctime:p,mtime:m,size:E,permissions:l}:{type:o,ctime:p,mtime:m,size:E}}$stat(g,r){return Promise.resolve(this._getFsProvider(g).stat(v.URI.revive(r))).then(o=>{var p;return P._asIStat(o,(p=this._enableProposedApi.get(g))!==null&&p!==void 0?p:!1)})}$readdir(g,r){return Promise.resolve(this._getFsProvider(g).readDirectory(v.URI.revive(r)))}$readFile(g,r){return Promise.resolve(this._getFsProvider(g).readFile(v.URI.revive(r))).then(o=>k.VSBuffer.wrap(o))}$writeFile(g,r,o,p){return Promise.resolve(this._getFsProvider(g).writeFile(v.URI.revive(r),o.buffer,p))}$delete(g,r,o){return Promise.resolve(this._getFsProvider(g).delete(v.URI.revive(r),o))}$rename(g,r,o,p){return Promise.resolve(this._getFsProvider(g).rename(v.URI.revive(r),v.URI.revive(o),p))}$copy(g,r,o,p){const m=this._getFsProvider(g);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(v.URI.revive(r),v.URI.revive(o),p))}$mkdir(g,r){return Promise.resolve(this._getFsProvider(g).createDirectory(v.URI.revive(r)))}$watch(g,r,o,p){const m=this._getFsProvider(g).watch(v.URI.revive(o),p);this._watches.set(r,m)}$unwatch(g,r){const o=this._watches.get(r);o&&(o.dispose(),this._watches.delete(r))}$open(g,r,o){const p=this._getFsProvider(g);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(v.URI.revive(r),o))}$close(g,r){const o=this._getFsProvider(g);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(r))}$read(g,r,o,p){const m=this._getFsProvider(g);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const E=k.VSBuffer.alloc(p);return Promise.resolve(m.read(r,o,E.buffer,0,p)).then(l=>E.slice(0,l))}$write(g,r,o,p){const m=this._getFsProvider(g);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(r,o,p.buffer,0,p.byteLength))}_getFsProvider(g){const r=this._fsProvider.get(g);if(!r){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return r}}e.ExtHostFileSystem=P}),define(ve[78],we([0,1,5,64,7,24,4,15,49]),function(Y,e,v,T,D,A,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Mt{constructor(P,h){const g=P.getProxy(v.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(r){return g.$stat(r).catch(Mt._handleError)},readDirectory(r){return g.$readdir(r).catch(Mt._handleError)},createDirectory(r){return g.$mkdir(r).catch(Mt._handleError)},async readFile(r){return g.$readFile(r).then(o=>o.buffer).catch(Mt._handleError)},writeFile(r,o){return g.$writeFile(r,A.VSBuffer.wrap(o)).catch(Mt._handleError)},delete(r,o){return g.$delete(r,Object.assign({recursive:!1,useTrash:!1},o)).catch(Mt._handleError)},rename(r,o,p){return g.$rename(r,o,Object.assign({overwrite:!1},p)).catch(Mt._handleError)},copy(r,o,p){return g.$copy(r,o,Object.assign({overwrite:!1},p)).catch(Mt._handleError)},isWritableFileSystem(r){const o=h.getCapabilities(r);if(typeof o=="number")return!(o&2048)}})}static _handleError(P){if(!(P instanceof Error))throw new D.FileSystemError(String(P));if(P.name==="ENOPRO")throw D.FileSystemError.Unavailable(P.message);switch(P.name){case T.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(P.message);case T.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(P.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(P.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(P.message);case T.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(P.message);case T.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(P.message);default:throw new D.FileSystemError(P.message,P.name)}}};k=je([qe(0,C.IExtHostRpcService),qe(1,S.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(ve[197],we([0,1,6,5]),function(Y,e,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(y){this._handlePool=0,this._proxy=y.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,y),(0,v.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=D}),define(ve[198],we([0,1,2,23,9,7,11,5,8,32,13,10,116,6,88,54,68,55,12]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h,g,r,o,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class l{constructor(W,q){this._documents=W,this._provider=q}provideDocumentSymbols(W,q){const ee=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(ee,q)).then(se=>{if(!(0,i.isFalsyOrEmpty)(se))return se[0]instanceof A.DocumentSymbol?se.map(D.DocumentSymbol.from):l._asDocumentSymbolTree(se)})}static _asDocumentSymbolTree(W){var q;W=W.slice(0).sort((ce,_e)=>{let $e=ce.location.range.start.compareTo(_e.location.range.start);return $e===0&&($e=_e.location.range.end.compareTo(ce.location.range.end)),$e});const ee=[],se=[];for(const ce of W){const _e={name:ce.name||"!!MISSING: name!!",kind:D.SymbolKind.from(ce.kind),tags:((q=ce.tags)===null||q===void 0?void 0:q.map(D.SymbolTag.from))||[],detail:"",containerName:ce.containerName,range:D.Range.from(ce.location.range),selectionRange:D.Range.from(ce.location.range),children:[]};for(;;){if(se.length===0){se.push(_e),ee.push(_e);break}const $e=se[se.length-1];if(k.Range.containsRange($e.range,_e.range)&&!k.Range.equalsRange($e.range,_e.range)){$e.children&&$e.children.push(_e),se.push(_e);break}se.pop()}}return ee}}class c{constructor(W,q,ee){this._documents=W,this._commands=q,this._provider=ee,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(W,q){const ee=this._documents.getDocument(W),se=await this._provider.provideCodeLenses(ee,q);if(!(!se||q.isCancellationRequested)){const ce=this._cache.add(se),_e=new g.DisposableStore;this._disposables.set(ce,_e);const $e={cacheId:ce,lenses:[]};for(let fe=0;fe<se.length;fe++)$e.lenses.push({cacheId:[ce,fe],range:D.Range.from(se[fe].range),command:this._commands.toInternal(se[fe].command,_e)});return $e}}async resolveCodeLens(W,q){var ee;const se=W.cacheId&&this._cache.get(...W.cacheId);if(!!se){let ce;if(typeof this._provider.resolveCodeLens!="function"||se.isResolved?ce=se:ce=await this._provider.resolveCodeLens(se,q),ce||(ce=se),!q.isCancellationRequested){const _e=W.cacheId&&this._disposables.get(W.cacheId[0]);if(!!_e)return W.command=this._commands.toInternal((ee=ce.command)!==null&&ee!==void 0?ee:c._badCmd,_e),W}}}releaseCodeLenses(W){var q;(q=this._disposables.get(W))===null||q===void 0||q.dispose(),this._disposables.delete(W),this._cache.delete(W)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function d(ze){return Array.isArray(ze)?ze.map(D.DefinitionLink.from):ze?[D.DefinitionLink.from(ze)]:[]}class t{constructor(W,q){this._documents=W,this._provider=q}provideDefinition(W,q,ee){const se=this._documents.getDocument(W),ce=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideDefinition(se,ce,ee)).then(d)}}class n{constructor(W,q){this._documents=W,this._provider=q}provideDeclaration(W,q,ee){const se=this._documents.getDocument(W),ce=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideDeclaration(se,ce,ee)).then(d)}}class a{constructor(W,q){this._documents=W,this._provider=q}provideImplementation(W,q,ee){const se=this._documents.getDocument(W),ce=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideImplementation(se,ce,ee)).then(d)}}class s{constructor(W,q){this._documents=W,this._provider=q}provideTypeDefinition(W,q,ee){const se=this._documents.getDocument(W),ce=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(se,ce,ee)).then(d)}}class u{constructor(W,q){this._documents=W,this._provider=q}provideHover(W,q,ee){const se=this._documents.getDocument(W),ce=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideHover(se,ce,ee)).then(_e=>{if(!(!_e||(0,i.isFalsyOrEmpty)(_e.contents)))return _e.range||(_e.range=se.getWordRangeAtPosition(ce)),_e.range||(_e.range=new A.Range(ce,ce)),D.Hover.from(_e)})}}class w{constructor(W,q){this._documents=W,this._provider=q}provideEvaluatableExpression(W,q,ee){const se=this._documents.getDocument(W),ce=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(se,ce,ee)).then(_e=>{if(_e)return D.EvaluatableExpression.from(_e)})}}class b{constructor(W,q){this._documents=W,this._provider=q}provideInlineValues(W,q,ee,se){const ce=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideInlineValues(ce,D.Range.to(q),D.InlineValueContext.to(ee),se)).then(_e=>{if(Array.isArray(_e))return _e.map($e=>D.InlineValue.from($e))})}}class I{constructor(W,q){this._documents=W,this._provider=q}provideDocumentHighlights(W,q,ee){const se=this._documents.getDocument(W),ce=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(se,ce,ee)).then(_e=>{if(Array.isArray(_e))return _e.map(D.DocumentHighlight.from)})}}class f{constructor(W,q){this._documents=W,this._provider=q}provideLinkedEditingRanges(W,q,ee){const se=this._documents.getDocument(W),ce=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(se,ce,ee)).then(_e=>{if(_e&&Array.isArray(_e.ranges))return{ranges:(0,i.coalesce)(_e.ranges.map(D.Range.from)),wordPattern:_e.wordPattern}})}}class _{constructor(W,q){this._documents=W,this._provider=q}provideReferences(W,q,ee,se){const ce=this._documents.getDocument(W),_e=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideReferences(ce,_e,ee,se)).then($e=>{if(Array.isArray($e))return $e.map(D.location.from)})}}class F{constructor(W,q,ee,se,ce,_e,$e){this._documents=W,this._commands=q,this._diagnostics=ee,this._provider=se,this._logService=ce,this._extension=_e,this._apiDeprecation=$e,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(W,q,ee,se){const ce=this._documents.getDocument(W),_e=h.Selection.isISelection(q)?D.Selection.to(q):D.Range.to(q),$e=[];for(const De of this._diagnostics.getDiagnostics(W))if(_e.intersection(De.range)&&$e.push(De)>F._maxCodeActionsPerFile)break;const fe={diagnostics:$e,only:ee.only?new A.CodeActionKind(ee.only):void 0,triggerKind:D.CodeActionTriggerKind.to(ee.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(ce,_e,fe,se)).then(De=>{var Re;if(!(!(0,i.isNonEmptyArray)(De)||se.isCancellationRequested)){const He=this._cache.add(De),be=new g.DisposableStore;this._disposables.set(He,be);const Ke=[];for(let V=0;V<De.length;V++){const Z=De[V];!Z||(F._isCommand(Z)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:Z.title,command:this._commands.toInternal(Z,be)})):(fe.only&&(Z.kind?fe.only.contains(Z.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${fe.only.value} 'requested but returned code action is of kind '${Z.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${fe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[He,V],title:Z.title,command:Z.command&&this._commands.toInternal(Z.command,be),diagnostics:Z.diagnostics&&Z.diagnostics.map(D.Diagnostic.from),edit:Z.edit&&D.WorkspaceEdit.from(Z.edit),kind:Z.kind&&Z.kind.value,isPreferred:Z.isPreferred,disabled:(Re=Z.disabled)===null||Re===void 0?void 0:Re.reason})))}return{cacheId:He,actions:Ke}}})}async resolveCodeAction(W,q){var ee;const[se,ce]=W,_e=this._cache.get(se,ce);if(!(!_e||F._isCommand(_e))&&!!this._provider.resolveCodeAction){const $e=(ee=await this._provider.resolveCodeAction(_e,q))!==null&&ee!==void 0?ee:_e;return($e==null?void 0:$e.edit)?D.WorkspaceEdit.from($e.edit):void 0}}releaseCodeActions(W){var q;(q=this._disposables.get(W))===null||q===void 0||q.dispose(),this._disposables.delete(W),this._cache.delete(W)}static _isCommand(W){return typeof W.command=="string"&&typeof W.title=="string"}}F._maxCodeActionsPerFile=1e3;class U{constructor(W,q){this._documents=W,this._provider=q}provideDocumentFormattingEdits(W,q,ee){const se=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(se,q,ee)).then(ce=>{if(Array.isArray(ce))return ce.map(D.TextEdit.from)})}}class z{constructor(W,q){this._documents=W,this._provider=q}provideDocumentRangeFormattingEdits(W,q,ee,se){const ce=this._documents.getDocument(W),_e=D.Range.to(q);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(ce,_e,ee,se)).then($e=>{if(Array.isArray($e))return $e.map(D.TextEdit.from)})}}class he{constructor(W,q){this._documents=W,this._provider=q,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(W,q,ee,se,ce){const _e=this._documents.getDocument(W),$e=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(_e,$e,ee,se,ce)).then(fe=>{if(Array.isArray(fe))return fe.map(D.TextEdit.from)})}}class de{constructor(W,q){this._provider=W,this._logService=q,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(W,q){const ee=C.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(W,q)).then(se=>{if((0,i.isNonEmptyArray)(se)){for(const ce of se)if(!!ce){if(!ce.name){this._logService.warn("INVALID SymbolInformation, lacks name",ce);continue}const _e=C.IdObject.mixin(D.WorkspaceSymbol.from(ce));this._symbolCache.set(_e._id,ce),ee.symbols.push(_e)}}}).then(()=>(ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee))}async resolveWorkspaceSymbol(W,q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return W;const ee=this._symbolCache.get(W._id);if(ee){const se=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ee,q));return se&&(0,T.mixin)(W,D.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(W){const q=this._resultCache.get(W);if(q){for(let[ee,se]=q;ee<=se;ee++)this._symbolCache.delete(ee);this._resultCache.delete(W)}}}class x{constructor(W,q,ee){this._documents=W,this._provider=q,this._logService=ee}static supportsResolving(W){return typeof W.prepareRename=="function"}provideRenameEdits(W,q,ee,se){const ce=this._documents.getDocument(W),_e=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(ce,_e,ee,se)).then($e=>{if(!!$e)return D.WorkspaceEdit.from($e)},$e=>{const fe=x._asMessage($e);return fe?{rejectReason:fe,edits:void 0}:Promise.reject($e)})}resolveRenameLocation(W,q,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument(W),ce=D.Position.to(q);return(0,y.asPromise)(()=>this._provider.prepareRename(se,ce,ee)).then(_e=>{let $e,fe;if(A.Range.isRange(_e)?($e=_e,fe=se.getText(_e)):(0,P.isObject)(_e)&&($e=_e.range,fe=_e.placeholder),!!$e){if($e.start.line>ce.line||$e.end.line<ce.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from($e),text:fe}}},_e=>{const $e=x._asMessage(_e);return $e?{rejectReason:$e,range:void 0,text:void 0}:Promise.reject(_e)})}static _asMessage(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class j{constructor(W,q){this.resultId=W,this.tokens=q}}class H{constructor(W,q){this._documents=W,this._provider=q,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(W,q,ee){const se=this._documents.getDocument(W),ce=q!==0?this._previousResults.get(q):null;return(0,y.asPromise)(()=>ce&&typeof ce.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(se,ce.resultId,ee):this._provider.provideDocumentSemanticTokens(se,ee)).then(_e=>(ce&&this._previousResults.delete(q),_e?(_e=H._fixProvidedSemanticTokens(_e),this._send(H._convertToEdits(ce,_e),_e)):null))}async releaseDocumentSemanticColoring(W){this._previousResults.delete(W)}static _fixProvidedSemanticTokens(W){return H._isSemanticTokens(W)?H._isCorrectSemanticTokens(W)?W:new A.SemanticTokens(new Uint32Array(W.data),W.resultId):H._isSemanticTokensEdits(W)?H._isCorrectSemanticTokensEdits(W)?W:new A.SemanticTokensEdits(W.edits.map(q=>new A.SemanticTokensEdit(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),W.resultId):W}static _isSemanticTokens(W){return W&&!!W.data}static _isCorrectSemanticTokens(W){return W.data instanceof Uint32Array}static _isSemanticTokensEdits(W){return W&&Array.isArray(W.edits)}static _isCorrectSemanticTokensEdits(W){for(const q of W.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(W,q){if(!H._isSemanticTokens(q)||!W||!W.tokens)return q;const ee=W.tokens,se=ee.length,ce=q.data,_e=ce.length;let $e=0;const fe=Math.min(se,_e);for(;$e<fe&&ee[$e]===ce[$e];)$e++;if($e===se&&$e===_e)return new A.SemanticTokensEdits([],q.resultId);let De=0;const Re=fe-$e;for(;De<Re&&ee[se-De-1]===ce[_e-De-1];)De++;return new A.SemanticTokensEdits([{start:$e,deleteCount:se-$e-De,data:ce.subarray($e,_e-De)}],q.resultId)}_send(W,q){if(H._isSemanticTokens(W)){const ee=this._nextResultId++;return this._previousResults.set(ee,new j(W.resultId,W.data)),(0,r.encodeSemanticTokensDto)({id:ee,type:"full",data:W.data})}if(H._isSemanticTokensEdits(W)){const ee=this._nextResultId++;return H._isSemanticTokens(q)?this._previousResults.set(ee,new j(q.resultId,q.data)):this._previousResults.set(ee,new j(W.resultId)),(0,r.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(W.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=H;class R{constructor(W,q){this._documents=W,this._provider=q}provideDocumentRangeSemanticTokens(W,q,ee){const se=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(se,D.Range.to(q),ee)).then(ce=>ce?this._send(ce):null)}_send(W){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:W.data})}}e.DocumentRangeSemanticTokensAdapter=R;class L{constructor(W,q,ee,se,ce){this._documents=W,this._commands=q,this._provider=ee,this._apiDeprecation=se,this._extension=ce,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}async provideCompletionItems(W,q,ee,se){const ce=this._documents.getDocument(W),_e=D.Position.to(q),$e=ce.getWordRangeAtPosition(_e)||new A.Range(_e,_e),fe=$e.with({end:_e}),De=new m.StopWatch(!0),Re=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(ce,_e,se,D.CompletionContext.to(ee)));if(!!Re&&!se.isCancellationRequested){const He=Array.isArray(Re)?new A.CompletionList(Re):Re,be=L.supportsResolving(this._provider)?this._cache.add(He.items):this._cache.add([]),Ke=new g.DisposableStore;this._disposables.set(be,Ke);const V=[],Z={x:be,b:V,a:{replace:D.Range.from($e),insert:D.Range.from(fe)},c:He.isIncomplete||void 0,d:De.elapsed()};for(let ge=0;ge<He.items.length;ge++){const Ne=He.items[ge],Ve=this._convertCompletionItem(Ne,[be,ge],fe,$e);V.push(Ve)}return Z}}async resolveCompletionItem(W,q){if(typeof this._provider.resolveCompletionItem=="function"){const ee=this._cache.get(...W);if(!!ee){const se=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(ee,q));if(!!se)return this._convertCompletionItem(se,W)}}}releaseCompletionItems(W){var q;(q=this._disposables.get(W))===null||q===void 0||q.dispose(),this._disposables.delete(W),this._cache.delete(W)}_convertCompletionItem(W,q,ee,se){var ce;const _e=this._disposables.get(q[0]);if(!_e)throw Error("DisposableStore is missing...");const $e={x:q,a:(ce=W.label)!==null&&ce!==void 0?ce:"",o:W.label2,b:W.kind!==void 0?D.CompletionItemKind.from(W.kind):void 0,n:W.tags&&W.tags.map(D.CompletionItemTag.from),c:W.detail,d:typeof W.documentation=="undefined"?void 0:D.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters,l:W.additionalTextEdits&&W.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(W.command,_e)};W.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),$e.h=W.textEdit.newText):typeof W.insertText=="string"?$e.h=W.insertText:W.insertText instanceof A.SnippetString&&($e.h=W.insertText.value,$e.i|=4);let fe;return W.textEdit?fe=W.textEdit.range:W.range&&(fe=W.range),A.Range.isRange(fe)?$e.j=D.Range.from(fe):fe&&(!(ee==null?void 0:ee.isEqual(fe.inserting))||!(se==null?void 0:se.isEqual(fe.replacing)))&&($e.j={insert:D.Range.from(fe.inserting),replace:D.Range.from(fe.replacing)}),$e}}class M{constructor(W,q){this._documents=W,this._provider=q,this._cache=new p.Cache("SignatureHelp")}provideSignatureHelp(W,q,ee,se){const ce=this._documents.getDocument(W),_e=D.Position.to(q),$e=this.reviveContext(ee);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(ce,_e,se,$e)).then(fe=>{if(fe){const De=this._cache.add([fe]);return Object.assign(Object.assign({},D.SignatureHelp.from(fe)),{id:De})}})}reviveContext(W){let q;if(W.activeSignatureHelp){const ee=D.SignatureHelp.to(W.activeSignatureHelp),se=this._cache.get(W.activeSignatureHelp.id,0);se?(q=se,q.activeSignature=ee.activeSignature,q.activeParameter=ee.activeParameter):q=ee}return Object.assign(Object.assign({},W),{activeSignatureHelp:q})}releaseSignatureHelp(W){this._cache.delete(W)}}class ${constructor(W,q){this._documents=W,this._provider=q}provideInlayHints(W,q,ee){const se=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideInlayHints(se,D.Range.to(q),ee)).then(ce=>ce?{hints:ce.map(D.InlayHint.from)}:void 0)}}class G{constructor(W,q){this._documents=W,this._provider=q,this._cache=new p.Cache("DocumentLink")}provideLinks(W,q){const ee=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(ee,q)).then(se=>{if(!(!Array.isArray(se)||se.length===0)&&!q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.map(D.DocumentLink.from)};{const ce=this._cache.add(se),_e={links:[],id:ce};for(let $e=0;$e<se.length;$e++){const fe=D.DocumentLink.from(se[$e]);fe.cacheId=[ce,$e],_e.links.push(fe)}return _e}}})}resolveLink(W,q){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ee=this._cache.get(...W);return ee?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(ee,q)).then(se=>se&&D.DocumentLink.from(se)||void 0):Promise.resolve(void 0)}releaseLinks(W){this._cache.delete(W)}}class J{constructor(W,q){this._documents=W,this._provider=q}provideColors(W,q){const ee=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(ee,q)).then(se=>Array.isArray(se)?se.map(_e=>({color:D.Color.from(_e.color),range:D.Range.from(_e.range)})):[])}provideColorPresentations(W,q,ee){const se=this._documents.getDocument(W),ce=D.Range.to(q.range),_e=D.Color.to(q.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(_e,{document:se,range:ce},ee)).then($e=>{if(!!Array.isArray($e))return $e.map(D.ColorPresentation.from)})}}class te{constructor(W,q){this._documents=W,this._provider=q}provideFoldingRanges(W,q,ee){const se=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(se,q,ee)).then(ce=>{if(!!Array.isArray(ce))return ce.map(D.FoldingRange.from)})}}class me{constructor(W,q,ee){this._documents=W,this._provider=q,this._logService=ee}provideSelectionRanges(W,q,ee){const se=this._documents.getDocument(W),ce=q.map(D.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(se,ce,ee)).then(_e=>{if(!(0,i.isNonEmptyArray)(_e))return[];if(_e.length!==ce.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const $e=[];for(let fe=0;fe<ce.length;fe++){const De=[];$e.push(De);let Re=ce[fe],He=_e[fe];for(;;){if(!He.range.contains(Re))throw new Error("INVALID selection range, must contain the previous range");if(De.push(D.SelectionRange.from(He)),!He.parent)break;Re=He.range,He=He.parent}}return $e})}}class Le{constructor(W,q){this._documents=W,this._provider=q,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(W,q,ee){const se=this._documents.getDocument(W),ce=D.Position.to(q),_e=await this._provider.prepareCallHierarchy(se,ce,ee);if(!!_e){const $e=this._idPool.nextId();return this._cache.set($e,new Map),Array.isArray(_e)?_e.map(fe=>this._cacheAndConvertItem($e,fe)):[this._cacheAndConvertItem($e,_e)]}}async provideCallsTo(W,q,ee){const se=this._itemFromCache(W,q);if(!se)throw new Error("missing call hierarchy item");const ce=await this._provider.provideCallHierarchyIncomingCalls(se,ee);if(!!ce)return ce.map(_e=>({from:this._cacheAndConvertItem(W,_e.from),fromRanges:_e.fromRanges.map($e=>D.Range.from($e))}))}async provideCallsFrom(W,q,ee){const se=this._itemFromCache(W,q);if(!se)throw new Error("missing call hierarchy item");const ce=await this._provider.provideCallHierarchyOutgoingCalls(se,ee);if(!!ce)return ce.map(_e=>({to:this._cacheAndConvertItem(W,_e.to),fromRanges:_e.fromRanges.map($e=>D.Range.from($e))}))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,q){var ee;const se=this._cache.get(W),ce={_sessionId:W,_itemId:se.size.toString(36),name:q.name,detail:q.detail,kind:D.SymbolKind.from(q.kind),uri:q.uri,range:D.Range.from(q.range),selectionRange:D.Range.from(q.selectionRange),tags:(ee=q.tags)===null||ee===void 0?void 0:ee.map(D.SymbolTag.from)};return se.set(ce._itemId,q),ce}_itemFromCache(W,q){const ee=this._cache.get(W);return ee==null?void 0:ee.get(q)}}class We{constructor(W,q){this.adapter=W,this.extension=q}}class Fe{constructor(W,q,ee,se,ce,_e,$e){this._adapter=new Map,this._uriTransformer=q,this._proxy=W.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=se,this._diagnostics=ce,this._logService=_e,this._apiDeprecation=$e}_transformDocumentSelector(W){return(0,i.coalesce)((0,i.asArray)(W).map(q=>this._doTransformDocumentSelector(q)))}_doTransformDocumentSelector(W){if(typeof W=="string")return{$serialized:!0,language:W};if(W)return{$serialized:!0,language:W.language,scheme:this._transformScheme(W.scheme),pattern:typeof W.pattern=="undefined"?void 0:D.GlobPattern.from(W.pattern),exclusive:W.exclusive}}_transformScheme(W){return this._uriTransformer&&typeof W=="string"?this._uriTransformer.transformOutgoingScheme(W):W}_createDisposable(W){return new A.Disposable(()=>{this._adapter.delete(W),this._proxy.$unregister(W)})}_nextHandle(){return Fe._handlePool++}_withAdapter(W,q,ee,se,ce=!1){const _e=this._adapter.get(W);if(!_e)return Promise.resolve(se);if(_e.adapter instanceof q){let $e;_e.extension&&($e=Date.now(),this._logService.trace(`[${_e.extension.identifier.value}] INVOKE provider '${q.name}'`));const fe=ee(_e.adapter,_e.extension),De=_e.extension;return De&&Promise.resolve(fe).then(()=>this._logService.trace(`[${De.identifier.value}] provider DONE after ${Date.now()-$e}ms`),Re=>{ce&&Re instanceof E.CancellationError||(this._logService.error(`[${De.identifier.value}] provider FAILED`),this._logService.error(Re))}),fe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(W,q){const ee=this._nextHandle();return this._adapter.set(ee,new We(W,q)),ee}static _extLabel(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,q,ee,se){const ce=this._addNewAdapter(new l(this._documents,ee),W),_e=se&&se.label||Fe._extLabel(W);return this._proxy.$registerDocumentSymbolProvider(ce,this._transformDocumentSelector(q),_e),this._createDisposable(ce)}$provideDocumentSymbols(W,q,ee){return this._withAdapter(W,l,se=>se.provideDocumentSymbols(v.URI.revive(q),ee),void 0)}registerCodeLensProvider(W,q,ee){const se=this._nextHandle(),ce=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new We(new c(this._documents,this._commands.converter,ee),W)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(q),ce);let _e=this._createDisposable(se);if(ce!==void 0){const $e=ee.onDidChangeCodeLenses(fe=>this._proxy.$emitCodeLensEvent(ce));_e=A.Disposable.from(_e,$e)}return _e}$provideCodeLenses(W,q,ee){return this._withAdapter(W,c,se=>se.provideCodeLenses(v.URI.revive(q),ee),void 0)}$resolveCodeLens(W,q,ee){return this._withAdapter(W,c,se=>se.resolveCodeLens(q,ee),void 0)}$releaseCodeLenses(W,q){this._withAdapter(W,c,ee=>Promise.resolve(ee.releaseCodeLenses(q)),void 0)}registerDefinitionProvider(W,q,ee){const se=this._addNewAdapter(new t(this._documents,ee),W);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideDefinition(W,q,ee,se){return this._withAdapter(W,t,ce=>ce.provideDefinition(v.URI.revive(q),ee,se),[])}registerDeclarationProvider(W,q,ee){const se=this._addNewAdapter(new n(this._documents,ee),W);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideDeclaration(W,q,ee,se){return this._withAdapter(W,n,ce=>ce.provideDeclaration(v.URI.revive(q),ee,se),[])}registerImplementationProvider(W,q,ee){const se=this._addNewAdapter(new a(this._documents,ee),W);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideImplementation(W,q,ee,se){return this._withAdapter(W,a,ce=>ce.provideImplementation(v.URI.revive(q),ee,se),[])}registerTypeDefinitionProvider(W,q,ee){const se=this._addNewAdapter(new s(this._documents,ee),W);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideTypeDefinition(W,q,ee,se){return this._withAdapter(W,s,ce=>ce.provideTypeDefinition(v.URI.revive(q),ee,se),[])}registerHoverProvider(W,q,ee,se){const ce=this._addNewAdapter(new u(this._documents,ee),W);return this._proxy.$registerHoverProvider(ce,this._transformDocumentSelector(q)),this._createDisposable(ce)}$provideHover(W,q,ee,se){return this._withAdapter(W,u,ce=>ce.provideHover(v.URI.revive(q),ee,se),void 0)}registerEvaluatableExpressionProvider(W,q,ee,se){const ce=this._addNewAdapter(new w(this._documents,ee),W);return this._proxy.$registerEvaluatableExpressionProvider(ce,this._transformDocumentSelector(q)),this._createDisposable(ce)}$provideEvaluatableExpression(W,q,ee,se){return this._withAdapter(W,w,ce=>ce.provideEvaluatableExpression(v.URI.revive(q),ee,se),void 0)}registerInlineValuesProvider(W,q,ee,se){const ce=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,_e=this._addNewAdapter(new b(this._documents,ee),W);this._proxy.$registerInlineValuesProvider(_e,this._transformDocumentSelector(q),ce);let $e=this._createDisposable(_e);if(ce!==void 0){const fe=ee.onDidChangeInlineValues(De=>this._proxy.$emitInlineValuesEvent(ce));$e=A.Disposable.from($e,fe)}return $e}$provideInlineValues(W,q,ee,se,ce){return this._withAdapter(W,b,_e=>_e.provideInlineValues(v.URI.revive(q),ee,se,ce),void 0)}registerDocumentHighlightProvider(W,q,ee){const se=this._addNewAdapter(new I(this._documents,ee),W);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideDocumentHighlights(W,q,ee,se){return this._withAdapter(W,I,ce=>ce.provideDocumentHighlights(v.URI.revive(q),ee,se),void 0)}registerLinkedEditingRangeProvider(W,q,ee){const se=this._addNewAdapter(new f(this._documents,ee),W);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideLinkedEditingRanges(W,q,ee,se){return this._withAdapter(W,f,async ce=>{const _e=await ce.provideLinkedEditingRanges(v.URI.revive(q),ee,se);if(_e)return{ranges:_e.ranges,wordPattern:_e.wordPattern?Fe._serializeRegExp(_e.wordPattern):void 0}},void 0)}registerReferenceProvider(W,q,ee){const se=this._addNewAdapter(new _(this._documents,ee),W);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideReferences(W,q,ee,se,ce){return this._withAdapter(W,_,_e=>_e.provideReferences(v.URI.revive(q),ee,se,ce),void 0)}registerCodeActionProvider(W,q,ee,se){var ce,_e;const $e=new g.DisposableStore,fe=this._addNewAdapter(new F(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,W,this._apiDeprecation),W);return this._proxy.$registerQuickFixSupport(fe,this._transformDocumentSelector(q),{providedKinds:(ce=se==null?void 0:se.providedCodeActionKinds)===null||ce===void 0?void 0:ce.map(De=>De.value),documentation:(_e=se==null?void 0:se.documentation)===null||_e===void 0?void 0:_e.map(De=>({kind:De.kind.value,command:this._commands.converter.toInternal(De.command,$e)}))},Fe._extLabel(W),Boolean(ee.resolveCodeAction)),$e.add(this._createDisposable(fe)),$e}$provideCodeActions(W,q,ee,se,ce){return this._withAdapter(W,F,_e=>_e.provideCodeActions(v.URI.revive(q),ee,se,ce),void 0)}$resolveCodeAction(W,q,ee){return this._withAdapter(W,F,se=>se.resolveCodeAction(q,ee),void 0)}$releaseCodeActions(W,q){this._withAdapter(W,F,ee=>Promise.resolve(ee.releaseCodeActions(q)),void 0)}registerDocumentFormattingEditProvider(W,q,ee){const se=this._addNewAdapter(new U(this._documents,ee),W);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(q),W.identifier,W.displayName||W.name),this._createDisposable(se)}$provideDocumentFormattingEdits(W,q,ee,se){return this._withAdapter(W,U,ce=>ce.provideDocumentFormattingEdits(v.URI.revive(q),ee,se),void 0)}registerDocumentRangeFormattingEditProvider(W,q,ee){const se=this._addNewAdapter(new z(this._documents,ee),W);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(q),W.identifier,W.displayName||W.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits(W,q,ee,se,ce){return this._withAdapter(W,z,_e=>_e.provideDocumentRangeFormattingEdits(v.URI.revive(q),ee,se,ce),void 0)}registerOnTypeFormattingEditProvider(W,q,ee,se){const ce=this._addNewAdapter(new he(this._documents,ee),W);return this._proxy.$registerOnTypeFormattingSupport(ce,this._transformDocumentSelector(q),se,W.identifier),this._createDisposable(ce)}$provideOnTypeFormattingEdits(W,q,ee,se,ce,_e){return this._withAdapter(W,he,$e=>$e.provideOnTypeFormattingEdits(v.URI.revive(q),ee,se,ce,_e),void 0)}registerWorkspaceSymbolProvider(W,q){const ee=this._addNewAdapter(new de(q,this._logService),W);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(W,q,ee){return this._withAdapter(W,de,se=>se.provideWorkspaceSymbols(q,ee),{symbols:[]})}$resolveWorkspaceSymbol(W,q,ee){return this._withAdapter(W,de,se=>se.resolveWorkspaceSymbol(q,ee),void 0)}$releaseWorkspaceSymbols(W,q){this._withAdapter(W,de,ee=>ee.releaseWorkspaceSymbols(q),void 0)}registerRenameProvider(W,q,ee){const se=this._addNewAdapter(new x(this._documents,ee,this._logService),W);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(q),x.supportsResolving(ee)),this._createDisposable(se)}$provideRenameEdits(W,q,ee,se,ce){return this._withAdapter(W,x,_e=>_e.provideRenameEdits(v.URI.revive(q),ee,se,ce),void 0)}$resolveRenameLocation(W,q,ee,se){return this._withAdapter(W,x,ce=>ce.resolveRenameLocation(v.URI.revive(q),ee,se),void 0)}registerDocumentSemanticTokensProvider(W,q,ee,se){const ce=this._nextHandle(),_e=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(ce,new We(new H(this._documents,ee),W)),this._proxy.$registerDocumentSemanticTokensProvider(ce,this._transformDocumentSelector(q),se,_e);let $e=this._createDisposable(ce);if(_e){const fe=ee.onDidChangeSemanticTokens(De=>this._proxy.$emitDocumentSemanticTokensEvent(_e));$e=A.Disposable.from($e,fe)}return $e}$provideDocumentSemanticTokens(W,q,ee,se){return this._withAdapter(W,H,ce=>ce.provideDocumentSemanticTokens(v.URI.revive(q),ee,se),null,!0)}$releaseDocumentSemanticTokens(W,q){this._withAdapter(W,H,ee=>ee.releaseDocumentSemanticColoring(q),void 0)}registerDocumentRangeSemanticTokensProvider(W,q,ee,se){const ce=this._addNewAdapter(new R(this._documents,ee),W);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ce,this._transformDocumentSelector(q),se),this._createDisposable(ce)}$provideDocumentRangeSemanticTokens(W,q,ee,se){return this._withAdapter(W,R,ce=>ce.provideDocumentRangeSemanticTokens(v.URI.revive(q),ee,se),null,!0)}registerCompletionItemProvider(W,q,ee,se){const ce=this._addNewAdapter(new L(this._documents,this._commands.converter,ee,this._apiDeprecation,W),W);return this._proxy.$registerSuggestSupport(ce,this._transformDocumentSelector(q),se,L.supportsResolving(ee),`${W.identifier.value}(${se.join("")})`),this._createDisposable(ce)}$provideCompletionItems(W,q,ee,se,ce){return this._withAdapter(W,L,_e=>_e.provideCompletionItems(v.URI.revive(q),ee,se,ce),void 0)}$resolveCompletionItem(W,q,ee){return this._withAdapter(W,L,se=>se.resolveCompletionItem(q,ee),void 0)}$releaseCompletionItems(W,q){this._withAdapter(W,L,ee=>ee.releaseCompletionItems(q),void 0)}registerSignatureHelpProvider(W,q,ee,se){const ce=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,_e=this._addNewAdapter(new M(this._documents,ee),W);return this._proxy.$registerSignatureHelpProvider(_e,this._transformDocumentSelector(q),ce),this._createDisposable(_e)}$provideSignatureHelp(W,q,ee,se,ce){return this._withAdapter(W,M,_e=>_e.provideSignatureHelp(v.URI.revive(q),ee,se,ce),void 0)}$releaseSignatureHelp(W,q){this._withAdapter(W,M,ee=>ee.releaseSignatureHelp(q),void 0)}registerInlayHintsProvider(W,q,ee){const se=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ce=this._addNewAdapter(new $(this._documents,ee),W);this._proxy.$registerInlayHintsProvider(ce,this._transformDocumentSelector(q),se);let _e=this._createDisposable(ce);if(se!==void 0){const $e=ee.onDidChangeInlayHints(fe=>this._proxy.$emitInlayHintsEvent(se));_e=A.Disposable.from(_e,$e)}return _e}$provideInlayHints(W,q,ee,se){return this._withAdapter(W,$,ce=>ce.provideInlayHints(v.URI.revive(q),ee,se),void 0)}registerDocumentLinkProvider(W,q,ee){const se=this._addNewAdapter(new G(this._documents,ee),W);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(q),typeof ee.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks(W,q,ee){return this._withAdapter(W,G,se=>se.provideLinks(v.URI.revive(q),ee),void 0)}$resolveDocumentLink(W,q,ee){return this._withAdapter(W,G,se=>se.resolveLink(q,ee),void 0)}$releaseDocumentLinks(W,q){this._withAdapter(W,G,ee=>ee.releaseLinks(q),void 0)}registerColorProvider(W,q,ee){const se=this._addNewAdapter(new J(this._documents,ee),W);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideDocumentColors(W,q,ee){return this._withAdapter(W,J,se=>se.provideColors(v.URI.revive(q),ee),[])}$provideColorPresentations(W,q,ee,se){return this._withAdapter(W,J,ce=>ce.provideColorPresentations(v.URI.revive(q),ee,se),void 0)}registerFoldingRangeProvider(W,q,ee){const se=this._nextHandle(),ce=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new We(new te(this._documents,ee),W)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(q),ce);let _e=this._createDisposable(se);if(ce!==void 0){const $e=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ce));_e=A.Disposable.from(_e,$e)}return _e}$provideFoldingRanges(W,q,ee,se){return this._withAdapter(W,te,ce=>ce.provideFoldingRanges(v.URI.revive(q),ee,se),void 0)}registerSelectionRangeProvider(W,q,ee){const se=this._addNewAdapter(new me(this._documents,ee,this._logService),W);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideSelectionRanges(W,q,ee,se){return this._withAdapter(W,me,ce=>ce.provideSelectionRanges(v.URI.revive(q),ee,se),[])}registerCallHierarchyProvider(W,q,ee){const se=this._addNewAdapter(new Le(this._documents,ee),W);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$prepareCallHierarchy(W,q,ee,se){return this._withAdapter(W,Le,ce=>Promise.resolve(ce.prepareSession(v.URI.revive(q),ee,se)),void 0)}$provideCallHierarchyIncomingCalls(W,q,ee,se){return this._withAdapter(W,Le,ce=>ce.provideCallsTo(q,ee,se),void 0)}$provideCallHierarchyOutgoingCalls(W,q,ee,se){return this._withAdapter(W,Le,ce=>ce.provideCallsFrom(q,ee,se),void 0)}$releaseCallHierarchy(W,q){this._withAdapter(W,Le,ee=>Promise.resolve(ee.releaseSession(q)),void 0)}static _serializeRegExp(W){return{pattern:W.source,flags:(0,S.regExpFlags)(W)}}static _serializeIndentationRule(W){return{decreaseIndentPattern:Fe._serializeRegExp(W.decreaseIndentPattern),increaseIndentPattern:Fe._serializeRegExp(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?Fe._serializeRegExp(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?Fe._serializeRegExp(W.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(W){return{beforeText:Fe._serializeRegExp(W.beforeText),afterText:W.afterText?Fe._serializeRegExp(W.afterText):void 0,previousLineText:W.previousLineText?Fe._serializeRegExp(W.previousLineText):void 0,action:W.action}}static _serializeOnEnterRules(W){return W.map(Fe._serializeOnEnterRule)}setLanguageConfiguration(W,q,ee){let{wordPattern:se}=ee;if(se&&(0,S.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(q,se):this._documents.setWordDefinitionFor(q,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const ce=this._nextHandle(),_e={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?Fe._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?Fe._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?Fe._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ce,q,_e),this._createDisposable(ce)}$setWordDefinitions(W){for(const q of W)this._documents.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.ExtHostLanguageFeatures=Fe,Fe._handlePool=0}),define(ve[199],we([0,1,5,9,7]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class A{constructor(C,S){this._proxy=C.getProxy(v.MainContext.MainThreadLanguages),this._documents=S}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(C,S){await this._proxy.$changeLanguage(C,S);const k=this._documents.getDocumentData(C);if(!k)throw new Error(`document '${C.toString}' NOT found`);return k.document}async tokenAtPosition(C,S){var k;const i=C.version,P=T.Position.from(S),h=await this._proxy.$tokensAtPosition(C.uri,P),g={type:D.StandardTokenType.Other,range:(k=C.getWordRangeAtPosition(S))!==null&&k!==void 0?k:new D.Range(S.line,S.character,S.line,S.character)};if(!h)return g;const r={range:T.Range.to(h.range),type:T.TokenType.to(h.type)};return!r.range.contains(S)||i!==C.version?g:r}}e.ExtHostLanguages=A}),define(ve[200],we([0,1,5,16,33]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(C){return C&&C.title}let y=class{constructor(S,k){this._logService=k,this._proxy=S.getProxy(v.MainContext.MainThreadMessageService)}showMessage(S,k,i,P,h){const g={extension:S};let r;typeof P=="string"||A(P)?r=[P,...h]:(g.modal=P&&P.modal,g.useCustom=P&&P.useCustom,r=h),g.useCustom&&(0,D.checkProposedApiEnabled)(S);const o=[];for(let p=0;p<r.length;p++){const m=r[p];if(typeof m=="string")o.push({title:m,handle:p,isCloseAffordance:!1});else if(typeof m=="object"){let{title:E,isCloseAffordance:l}=m;o.push({title:E,isCloseAffordance:!!l,handle:p})}else this._logService.warn("Invalid message item:",m)}return this._proxy.$showMessage(k,i,g,o).then(p=>{if(typeof p=="number")return r[p]})}};y=je([qe(1,T.ILogService)],y),e.ExtHostMessageService=y}),define(ve[201],we([0,1,24,3,56,54,6,22,8,10,2,68,5,9,7,74,178,179]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h,g,r,o,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class E{constructor(d,t){const n=E._Keys.nextId();d.$registerNotebookEditorDecorationType(n,g.NotebookDecorationRenderOptions.from(t)),this.value={key:n,dispose(){d.$removeNotebookEditorDecorationType(n)}}}}e.NotebookEditorDecorationType=E,E._Keys=new A.IdGenerator("NotebookEditorDecorationType");class l{constructor(d,t,n,a,s,u){this._textDocumentsAndEditors=n,this._textDocuments=a,this.logService=s,this._extensionStoragePaths=u,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new C.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new T.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new T.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new T.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new T.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new T.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new T.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new T.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new T.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new P.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=d.getProxy(h.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=d.getProxy(h.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=d.getProxy(h.MainContext.MainThreadNotebookEditors),this._commandsConverter=t.converter,t.registerArgumentProcessor({processArgument:w=>{var b;if(w&&w.$mid===12){const I=(b=w.notebookEditor)===null||b===void 0?void 0:b.notebookUri,f=w.cell.handle,_=this._documents.get(I),F=_==null?void 0:_.getCell(f);if(F)return F.apiCell}return w}})}get activeNotebookEditor(){var d;return(d=this._activeNotebookEditor)===null||d===void 0?void 0:d.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(d=>d.apiEditor)}getEditorById(d){return this._editors.get(d)}getIdByEditor(d){for(const[t,n]of this._editors)if(n.apiEditor===d)return t}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(d,t){const n=this._documents.get(d);if(!n&&!t)throw new Error(`NO notebook document for '${d}'`);return n}_getProviderData(d){const t=this._notebookContentProviders.get(d);if(!t)throw new Error(`NO provider for '${d}'`);return t}registerNotebookContentProvider(d,t,n,a,s){if((0,S.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(t))throw new Error(`Notebook provider for '${t}' already registered`);this._notebookContentProviders.set(t,{extension:d,provider:n});let u;return n.onDidChangeNotebookContentOptions&&(u=n.onDidChangeNotebookContentOptions(()=>{const w=g.NotebookDocumentContentOptions.from(n.options);this._notebookProxy.$updateNotebookProviderOptions(t,w)})),this._notebookProxy.$registerNotebookProvider({id:d.identifier,location:d.extensionLocation},t,g.NotebookDocumentContentOptions.from(a),l._convertNotebookRegistrationData(d,s)),new r.Disposable(()=>{u==null||u.dispose(),this._notebookContentProviders.delete(t),this._notebookProxy.$unregisterNotebookProvider(t)})}static _convertNotebookRegistrationData(d,t){if(!!t){const n=t.filenamePattern.map(a=>g.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(t.filenamePattern&&!n){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:d.identifier,providerDisplayName:d.displayName||d.name,displayName:t.displayName,filenamePattern:n,exclusive:t.exclusive||!1}}}registerNotebookCellStatusBarItemProvider(d,t,n){const a=l._notebookStatusBarItemProviderHandlePool++,s=typeof n.onDidChangeCellStatusBarItems=="function"?l._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,n),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,s,t);let u;return s!==void 0&&(u=n.onDidChangeCellStatusBarItems(w=>this._notebookProxy.$emitCellStatusBarEvent(s))),new r.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,s),u&&u.dispose()})}createNotebookEditorDecorationType(d){return new E(this._notebookEditorsProxy,d).value}async openNotebookDocument(d){const t=this._documents.get(d);if(t)return t.apiNotebook;const n=await this._notebookDocumentsProxy.$tryOpenDocument(d),a=this._documents.get(i.URI.revive(n));return(0,k.assertIsDefined)(a==null?void 0:a.apiNotebook)}async showNotebookDocument(d,t){var n;i.URI.isUri(d)&&(d=await this.openNotebookDocument(d));let a;typeof t=="object"?a={position:g.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(g.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:a={preserveFocus:!1};const s=await this._notebookEditorsProxy.$tryShowNotebookDocument(d.uri,d.viewType,a),u=s&&((n=this._editors.get(s))===null||n===void 0?void 0:n.apiEditor);if(u)return u;throw s?new Error(`Could NOT open editor for "${d.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${d.toString()}".`)}async $provideNotebookCellStatusBarItems(d,t,n,a){var s;const u=this._notebookStatusBarItemProviders.get(d),w=i.URI.revive(t),b=this._documents.get(w);if(!(!b||!u)){const I=b.getCellFromIndex(n);if(!!I){const f=await u.provideCellStatusBarItems(I.apiCell,a);if(!!f){const _=new y.DisposableStore,F=this._statusBarCache.add([_]),U=(s=f&&f.map(z=>g.NotebookStatusBarItem.from(z,this._commandsConverter,_)))!==null&&s!==void 0?s:void 0;return{cacheId:F,items:U}}}}}$releaseNotebookCellStatusBarItems(d){this._statusBarCache.delete(d)}registerNotebookSerializer(d,t,n,a,s){if((0,S.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");const u=this._handlePool++;return this._notebookSerializer.set(u,n),this._notebookProxy.$registerNotebookSerializer(u,{id:d.identifier,location:d.extensionLocation},t,g.NotebookDocumentContentOptions.from(a),l._convertNotebookRegistrationData(d,s)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(u)})}async $dataToNotebook(d,t,n){const a=this._notebookSerializer.get(d);if(!a)throw new Error("NO serializer found");const s=await a.deserializeNotebook(t.buffer,n),u={metadata:g.NotebookDocumentMetadata.from(s.metadata),cells:[]};for(let w of s.cells)r.NotebookCellData.validate(w),u.cells.push(g.NotebookCellData.from(w));return u}async $notebookToData(d,t,n){const a=this._notebookSerializer.get(d);if(!a)throw new Error("NO serializer found");const s=await a.serializeNotebook({metadata:g.NotebookDocumentMetadata.to(t.metadata),cells:t.cells.map(g.NotebookCellData.to)},n);return v.VSBuffer.wrap(s)}async $openNotebook(d,t,n,a,s){const{provider:u}=this._getProviderData(d),w=await u.openNotebook(i.URI.revive(t),{backupId:n,untitledDocumentData:a==null?void 0:a.buffer},s);return{metadata:g.NotebookDocumentMetadata.from(w.metadata),cells:w.cells.map(g.NotebookCellData.from)}}async $saveNotebook(d,t,n){const a=this.getNotebookDocument(i.URI.revive(t)),{provider:s}=this._getProviderData(d);return await s.saveNotebook(a.apiNotebook,n),!0}async $saveNotebookAs(d,t,n,a){const s=this.getNotebookDocument(i.URI.revive(t)),{provider:u}=this._getProviderData(d);return await u.saveNotebookAs(i.URI.revive(n),s.apiNotebook,a),!0}async $backupNotebook(d,t,n){var a;const s=this.getNotebookDocument(i.URI.revive(t)),u=this._getProviderData(d),w=(a=this._extensionStoragePaths.workspaceValue(u.extension))!==null&&a!==void 0?a:this._extensionStoragePaths.globalValue(u.extension),b=String((0,D.hash)([s.uri.toString(),this._backupIdPool++])),I=i.URI.joinPath(w,b),f=await u.provider.backupNotebook(s.apiNotebook,{destination:I},n);return s.updateBackup(f),f.id}$acceptModelChanged(d,t,n){this.getNotebookDocument(i.URI.revive(d)).acceptModelChanged(t,n)}$acceptDirtyStateChanged(d,t){const n=this.getNotebookDocument(i.URI.revive(d));n.acceptModelChanged({rawEvents:[],versionId:n.apiNotebook.version},t)}$acceptModelSaved(d){const t=this.getNotebookDocument(i.URI.revive(d));this._onDidSaveNotebookDocument.fire(t.apiNotebook)}$acceptEditorPropertiesChanged(d,t){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",d,t);const n=this._editors.get(d);if(!n)throw new Error(`unknown text editor: ${d}. known editors: ${[...this._editors.keys()]} `);t.visibleRanges&&n._acceptVisibleRanges(t.visibleRanges.ranges.map(g.NotebookRange.to)),t.selections&&n._acceptSelections(t.selections.selections.map(g.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:n.apiEditor,visibleRanges:n.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:n.apiEditor,selections:n.apiEditor.selections}))}$acceptEditorViewColumns(d){for(const t in d){const n=this._editors.get(t);if(!n)throw new Error(`unknown text editor: ${t}. known editors: ${[...this._editors.keys()]} `);n._acceptViewColumn(g.ViewColumn.to(d[t]))}}$acceptDocumentPropertiesChanged(d,t){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",d.path,t);const n=this.getNotebookDocument(i.URI.revive(d));n.acceptDocumentPropertiesChanged(t),t.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:n.apiNotebook})}_createExtHostEditor(d,t,n){if(this._editors.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const a=new m.ExtHostNotebookEditor(t,this._notebookEditorsProxy,d,n.visibleRanges.map(g.NotebookRange.to),n.selections.map(g.NotebookRange.to),typeof n.viewColumn=="number"?g.ViewColumn.to(n.viewColumn):void 0);this._editors.set(t,a)}$acceptDocumentAndEditorsDelta(d){var t,n,a;if(d.removedDocuments)for(const u of d.removedDocuments){const w=i.URI.revive(u),b=this._documents.get(w);b&&(b.dispose(),this._documents.delete(w),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(I=>I.document.uri)}),this._onDidCloseNotebookDocument.fire(b.apiNotebook));for(const I of this._editors.values())I.notebookData.uri.toString()===w.toString()&&this._editors.delete(I.id)}if(d.addedDocuments){const u=[];for(const w of d.addedDocuments){const b=i.URI.revive(w.uri),I=w.viewType;if(this._documents.has(b))throw new Error(`adding EXISTING notebook ${b} `);const f=this,_=new p.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(F){f._onDidChangeNotebookCells.fire(F)},emitCellOutputsChange(F){f._onDidChangeCellOutputs.fire(F)},emitCellMetadataChange(F){f._onDidChangeCellMetadata.fire(F)},emitCellExecutionStateChange(F){f._onDidChangeCellExecutionState.fire(F)}},I,w.metadata?g.NotebookDocumentMetadata.to(w.metadata):new r.NotebookDocumentMetadata,b);_.acceptModelChanged({versionId:w.versionId,rawEvents:[{kind:o.NotebookCellsChangeType.Initialize,changes:[[0,0,w.cells]]}]},!1),u.push(...w.cells.map(F=>p.ExtHostCell.asModelAddData(_.apiNotebook,F))),(t=this._documents.get(b))===null||t===void 0||t.dispose(),this._documents.set(b,_),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:u}),this._onDidOpenNotebookDocument.fire(_.apiNotebook)}}if(d.addedEditors)for(const u of d.addedEditors){if(this._editors.has(u.id))return;const w=i.URI.revive(u.documentUri),b=this._documents.get(w);b&&this._createExtHostEditor(b,u.id,u)}const s=[];if(d.removedEditors)for(const u of d.removedEditors){const w=this._editors.get(u);w&&(this._editors.delete(u),((n=this._activeNotebookEditor)===null||n===void 0?void 0:n.id)===w.id&&(this._activeNotebookEditor=void 0),s.push(w))}if(d.visibleEditors){this._visibleNotebookEditors=d.visibleEditors.map(w=>this._editors.get(w)).filter(w=>!!w);const u=new Set;this._visibleNotebookEditors.forEach(w=>u.add(w.id));for(const w of this._editors.values()){const b=u.has(w.id);w._acceptVisibility(b)}this._visibleNotebookEditors=[...this._editors.values()].map(w=>w).filter(w=>w.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}d.newActiveEditor===null?this._activeNotebookEditor=void 0:d.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(d.newActiveEditor)),d.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((a=this._activeNotebookEditor)===null||a===void 0?void 0:a.apiEditor)}}e.ExtHostNotebookController=l,l._notebookStatusBarItemProviderHandlePool=0}),define(ve[202],we([0,1,3,6,5,26,2,9,73,22,11,20,7,13,16]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let o=class{constructor(c,d,t,n){this._mainContext=c,this._initData=d,this._extHostNotebook=t,this._logService=n,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=c.getProxy(D.MainContext.MainThreadNotebookKernels)}createNotebookController(c,d,t,n,a,s){for(let R of this._kernelData.values())if(R.controller.id===d&&A.ExtensionIdentifier.equals(c.identifier,R.extensionId))throw new Error(`notebook controller with id '${d}' ALREADY exist`);const u=this._handlePool++,w=this;this._logService.trace(`NotebookController[${u}], CREATED by ${c.identifier.value}, ${d}`);const b=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${c.identifier}'`);let I=!1;const f=new T.DisposableStore,_=new v.Emitter,F=new v.Emitter,U={id:`${c.identifier.value}/${d}`,viewType:t,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:n||c.identifier.value,preloads:s?s.map(C.NotebookKernelPreload.from):[]};let z=a!=null?a:b,he;this._proxy.$addKernel(u,U).catch(R=>{console.log(R),I=!0});let de=0;const x=()=>{if(!I){const R=++de;Promise.resolve().then(()=>{R===de&&this._proxy.$updateKernel(u,U)})}},j=new k.ResourceMap,H={get id(){return d},get viewType(){return U.viewType},onDidChangeNotebookAssociation:_.event,get label(){return U.label},set label(R){var L;U.label=(L=R!=null?R:c.displayName)!==null&&L!==void 0?L:c.name,x()},get detail(){var R;return(R=U.detail)!==null&&R!==void 0?R:""},set detail(R){U.detail=R,x()},get description(){var R;return(R=U.description)!==null&&R!==void 0?R:""},set description(R){U.description=R,x()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(R){U.supportedLanguages=R,x()},get hasExecutionOrder(){var R;return(R=U.hasExecutionOrder)!==null&&R!==void 0?R:!1},set hasExecutionOrder(R){U.hasExecutionOrder=R,x()},get preloads(){return U.preloads?U.preloads.map(C.NotebookKernelPreload.to):[]},get executeHandler(){return z},set executeHandler(R){z=R!=null?R:b},get interruptHandler(){return he},set interruptHandler(R){he=R,U.supportsInterrupt=Boolean(R),x()},createNotebookCellExecutionTask(R){if(I)throw new Error("notebook controller is DISPOSED");if(!j.has(R.notebook.uri))throw w._logService.trace(`NotebookController[${u}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(j.keys()).map(L=>L.toString())),new Error(`notebook controller is NOT associated to notebook: ${R.notebook.uri.toString()}`);return w._createNotebookCellExecution(R)},dispose:()=>{I||(this._logService.trace(`NotebookController[${u}], DISPOSED`),I=!0,this._kernelData.delete(u),f.dispose(),_.dispose(),F.dispose(),this._proxy.$removeKernel(u))},onDidReceiveMessage:F.event,postMessage(R,L){return w._proxy.$postMessage(u,L&&w._extHostNotebook.getIdByEditor(L),R)},asWebviewUri(R){return(0,S.asWebviewUri)(Object.assign(Object.assign({},w._initData.environment),{remote:w._initData.remote}),String(u),R)},updateNotebookAffinity(R,L){w._proxy.$updateNotebookPriority(u,R.uri,L)}};return this._kernelData.set(u,{extensionId:c.identifier,controller:H,onDidReceiveMessage:F,onDidChangeSelection:_,associatedNotebooks:j}),H}$acceptNotebookAssociation(c,d,t){const n=this._kernelData.get(c);if(n){const a=this._extHostNotebook.getNotebookDocument(y.URI.revive(d));t?n.associatedNotebooks.set(a.uri,!0):n.associatedNotebooks.delete(a.uri),this._logService.trace(`NotebookController[${c}] ASSOCIATE notebook`,a.uri.toString(),t),n.onDidChangeSelection.fire({selected:t,notebook:a.apiNotebook})}}async $executeCells(c,d,t){const n=this._kernelData.get(c);if(!!n){const a=this._extHostNotebook.getNotebookDocument(y.URI.revive(d)),s=[];for(let u of t){const w=a.getCell(u);w&&s.push(w.apiCell)}try{this._logService.trace(`NotebookController[${c}] EXECUTE cells`,a.uri.toString(),s.length),await n.controller.executeHandler.call(n.controller,s,a.apiNotebook,n.controller)}catch(u){this._logService.error(`NotebookController[${c}] execute cells FAILED`,u),console.error(u)}}}async $cancelCells(c,d,t){var n;const a=this._kernelData.get(c);if(!!a){const s=this._extHostNotebook.getNotebookDocument(y.URI.revive(d));a.controller.interruptHandler&&await a.controller.interruptHandler.call(a.controller,s.apiNotebook);for(let u of t){const w=s.getCell(u);w&&((n=this._activeExecutions.get(w.uri))===null||n===void 0||n.cancel())}}}$acceptKernelMessageFromRenderer(c,d,t){const n=this._kernelData.get(c);if(!!n){const a=this._extHostNotebook.getEditorById(d);if(!a)throw new Error(`send message for UNKNOWN editor: ${d}`);n.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:t}))}}_createNotebookCellExecution(c){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const t=this._extHostNotebook.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!t)throw new Error("invalid cell");if(this._activeExecutions.has(t.uri))throw new Error(`duplicate execution for ${t.uri}`);const n=new m(t.notebook,t,this._mainContext.getProxy(D.MainContext.MainThreadNotebookDocuments));this._activeExecutions.set(t.uri,n);const a=n.onDidChangeState(()=>{n.state===p.Resolved&&(n.dispose(),a.dispose(),this._activeExecutions.delete(t.uri))});return n.asApiObject()}};o=je([qe(3,r.ILogService)],o),e.ExtHostNotebookKernels=o;var p;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(p||(p={}));class m extends T.Disposable{constructor(c,d,t){super();this._document=c,this._cell=d,this._proxy=t,this._onDidChangeState=new v.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=p.Init,this._tokenSource=this._register(new P.CancellationTokenSource),this._collector=new E(10,n=>this.applyEdits(n)),this._executionOrder=d.internalMetadata.executionOrder,this.mixinMetadata({runState:h.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(c){await this._collector.addItem(c)}async applyEdits(c){return this._proxy.$applyEdits(this._document.uri,c,!1)}verifyStateForOutput(){if(this._state===p.Init)throw new Error("Must call start before modifying cell output");if(this._state===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(c){const d={editType:8,handle:this._cell.handle,metadata:c};this.applyEdits([d])}cellIndexToHandle(c){if(typeof c!="number")return this._cell.handle;const d=this._document.getCellFromIndex(c);if(!d)throw new Error("INVALID cell index");return d.handle}asApiObject(){const c=this;return Object.freeze({get document(){return c._document.apiNotebook},get cell(){return c._cell.apiCell},get executionOrder(){return c._executionOrder},set executionOrder(d){c._executionOrder=d,c.mixinMetadata({executionOrder:d})},start(d){var t;if(c._state===p.Resolved||c._state===p.Started)throw new Error("Cannot call start again");c._state=p.Started,c._onDidChangeState.fire(),c.mixinMetadata({runState:h.NotebookCellExecutionState.Executing,runStartTime:(t=d==null?void 0:d.startTime)!==null&&t!==void 0?t:null})},end(d){var t,n;if(c._state===p.Resolved)throw new Error("Cannot call resolve twice");c._state=p.Resolved,c._onDidChangeState.fire(),c.mixinMetadata({runState:h.NotebookCellExecutionState.Idle,lastRunSuccess:(t=d==null?void 0:d.success)!==null&&t!==void 0?t:null,runEndTime:(n=d==null?void 0:d.endTime)!==null&&n!==void 0?n:null})},clearOutput(d){return c.verifyStateForOutput(),this.replaceOutput([],d)},async appendOutput(d,t){c.verifyStateForOutput();const n=c.cellIndexToHandle(t);return d=(0,g.asArray)(d),c.applyEditSoon({editType:2,handle:n,append:!0,outputs:d.map(C.NotebookCellOutput.from)})},async replaceOutput(d,t){c.verifyStateForOutput();const n=c.cellIndexToHandle(t);return d=(0,g.asArray)(d),c.applyEditSoon({editType:2,handle:n,outputs:d.map(C.NotebookCellOutput.from)})},async appendOutputItems(d,t){return c.verifyStateForOutput(),d=(0,g.asArray)(d),c.applyEditSoon({editType:7,append:!0,items:d.map(C.NotebookCellOutputItem.from),outputId:t})},async replaceOutputItems(d,t){return c.verifyStateForOutput(),d=(0,g.asArray)(d),c.applyEditSoon({editType:7,items:d.map(C.NotebookCellOutputItem.from),outputId:t})},token:c._tokenSource.token})}}class E{constructor(c,d){this.delay=c,this.callback=d,this.batch=[]}addItem(c){return this.batch.push(c),this.waitPromise||(this.waitPromise=(0,i.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const d=this.batch;return this.batch=[],this.callback(d)})),this.waitPromise}}}),define(ve[101],we([0,1,5,3,6,24,4,15]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends D.Disposable{constructor(r,o,p,m){super();this._onDidAppend=this._register(new T.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=r,this._proxy=m,this._id=m.$register(this.name,o,p),this._disposed=!1,this._offset=0}get name(){return this._name}append(r){this.validate(),this._offset+=r?A.VSBuffer.fromString(r).byteLength:0}update(){this._id.then(r=>this._proxy.$update(r))}appendLine(r){this.validate(),this.append(r+`
`)}clear(){this.validate();const r=this._offset;this._id.then(o=>this._proxy.$clear(o,r))}show(r,o){this.validate(),this._id.then(p=>this._proxy.$reveal(p,!!(typeof r=="boolean"?r:o)))}hide(){this.validate(),this._id.then(r=>this._proxy.$close(r))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(r=>this._proxy.$dispose(r)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class k extends S{constructor(r,o){super(r,!1,void 0,o)}append(r){super.append(r),this._id.then(o=>this._proxy.$append(o,r)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class i extends S{constructor(r,o,p){super(r,!0,o,p)}append(r){throw new Error("Not supported")}}class P{constructor(r,o){this.name=r,this._channel=o}append(r){this._channel.then(o=>o.append(r))}appendLine(r){this._channel.then(o=>o.appendLine(r))}clear(){this._channel.then(r=>r.clear())}show(r,o){this._channel.then(p=>p.show(r,o))}hide(){this._channel.then(r=>r.hide())}dispose(){this._channel.then(r=>r.dispose())}}e.LazyOutputChannel=P;let h=class{constructor(r){this._proxy=r.getProxy(v.MainContext.MainThreadOutputService)}$setVisibleChannel(r){}createOutputChannel(r){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");return new k(r,this._proxy)}createOutputChannelFromLogFile(r,o){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");if(!o)throw new Error("illegal argument `file`. must not be falsy");return new i(r,o,this._proxy)}};h=je([qe(0,C.IExtHostRpcService)],h),e.ExtHostOutputService=h,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(ve[203],we([0,1,11,20,3,6,5,2,7,12,13,47]),function(Y,e,v,T,D,A,y,C,S,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(g,r,o){const p=g.getProxy(y.MainContext.MainThreadQuickOpen);class m{constructor(s,u){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=u}showQuickPick(s,u,w,b=T.CancellationToken.None){this._onDidSelectItem=void 0;const I=Promise.resolve(s),f=++this._instances,_=p.$show(f,{title:w==null?void 0:w.title,placeHolder:w==null?void 0:w.placeHolder,matchOnDescription:w==null?void 0:w.matchOnDescription,matchOnDetail:w==null?void 0:w.matchOnDetail,ignoreFocusLost:w==null?void 0:w.ignoreFocusOut,canPickMany:w==null?void 0:w.canPickMany},b),F={},U=_.then(()=>F);return Promise.race([U,I]).then(z=>{if(z!==F)return I.then(he=>{const de=[];for(let x=0;x<he.length;x++){const j=he[x];let H,R,L,M,$;typeof j=="string"?H=j:(H=j.label,R=j.description,L=j.detail,M=j.picked,$=j.alwaysShow),de.push({label:H,description:R,handle:x,detail:L,picked:M,alwaysShow:$})}return w&&typeof w.onDidSelectItem=="function"&&(this._onDidSelectItem=x=>{w.onDidSelectItem(he[x])}),p.$setItems(f,de),_.then(x=>{if(typeof x=="number")return he[x];if(Array.isArray(x))return x.map(j=>he[j])})})}).then(void 0,z=>{if(!(0,k.isPromiseCanceledError)(z))return p.$setError(f,z),Promise.reject(z)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,u=T.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,p.$input(s,typeof this._validateInput=="function",u).then(void 0,w=>{if(!(0,k.isPromiseCanceledError)(w))return Promise.reject(w)})}$validateInput(s){return this._validateInput?(0,v.asPromise)(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,u=T.CancellationToken.None){const w=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!!w){const b=await this._workspace.getWorkspaceFolders2();if(!!b)return b.find(I=>I.uri.toString()===w.uri.toString())}}createQuickPick(s,u){const w=new t(s,u,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}createInputBox(s){const u=new n(s,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}$onDidChangeValue(s,u){const w=this._sessions.get(s);w&&w._fireDidChangeValue(u)}$onDidAccept(s){const u=this._sessions.get(s);u&&u._fireDidAccept()}$onDidChangeActive(s,u){const w=this._sessions.get(s);w instanceof t&&w._fireDidChangeActive(u)}$onDidChangeSelection(s,u){const w=this._sessions.get(s);w instanceof t&&w._fireDidChangeSelection(u)}$onDidTriggerButton(s,u){const w=this._sessions.get(s);w&&w._fireDidTriggerButton(u)}$onDidHide(s){const u=this._sessions.get(s);u&&u._fireDidHide()}}class E{constructor(s,u){this._extensionId=s,this._onDidDispose=u,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((u,w)=>{const b=u===S.QuickInputButtons.Back?-1:w;this._handlesToButtons.set(b,u)}),this.update({buttons:s.map((u,w)=>({iconPath:l(u.iconPath),tooltip:u.tooltip,handle:u===S.QuickInputButtons.Back?-1:w}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const u=this._handlesToButtons.get(s);u&&this._onDidTriggerButtonEmitter.fire(u)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),p.$dispose(this._id))}update(s){if(!this._disposed){for(const u of Object.keys(s)){const w=s[u];this._pendingUpdate[u]=w===void 0?null:w}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){p.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function l(a){if(a instanceof S.ThemeIcon)return{id:a.id};const s=d(a),u=c(a);return{dark:typeof s=="string"?C.URI.file(s):s,light:typeof u=="string"?C.URI.file(u):u}}function c(a){return typeof a=="object"&&"light"in a?a.light:a}function d(a){return typeof a=="object"&&"dark"in a?a.dark:a}class t extends E{constructor(s,u,w){super(s,w);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((u,w)=>{this._handlesToItems.set(w,u),this._itemsToHandles.set(u,w)}),this.update({items:s.map((u,w)=>({label:u.label,description:u.description,handle:w,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(u=>this._itemsToHandles.has(u)),this.update({activeItems:this._activeItems.map(u=>this._itemsToHandles.get(u))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(u=>this._itemsToHandles.has(u)),this.update({selectedItems:this._selectedItems.map(u=>this._itemsToHandles.get(u))})}_fireDidChangeActive(s){const u=(0,i.coalesce)(s.map(w=>this._handlesToItems.get(w)));this._activeItems=u,this._onDidChangeActiveEmitter.fire(u)}_fireDidChangeSelection(s){const u=(0,i.coalesce)(s.map(w=>this._handlesToItems.get(w)));this._selectedItems=u,this._onDidChangeSelectionEmitter.fire(u)}}class n extends E{constructor(s,u){super(s,u);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s,severity:s?P.default.Error:P.default.Ignore})}}return new m(r,o)}e.createExtHostQuickOpen=h}),define(ve[204],we([0,1,2,3,52,6,11,5,13,113,16,26,33]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(s){if(s)return typeof s.iconPath=="string"?v.URI.file(s.iconPath):s.iconPath}function r(s,u){if(!s.iconPath&&!u.iconPath)return 0;if(s.iconPath){if(!u.iconPath)return 1}else return-1;const w=typeof s.iconPath=="string"?s.iconPath:s.iconPath.fsPath,b=typeof u.iconPath=="string"?u.iconPath:u.iconPath.fsPath;return(0,k.comparePaths)(w,b)}function o(s,u){let w=0;if(s.strikeThrough!==u.strikeThrough)return s.strikeThrough?1:-1;if(s.faded!==u.faded)return s.faded?1:-1;if(s.tooltip!==u.tooltip)return(s.tooltip||"").localeCompare(u.tooltip||"");if(w=r(s,u),w!==0)return w;if(s.light&&u.light)w=r(s.light,u.light);else{if(s.light)return 1;if(u.light)return-1}if(w!==0)return w;if(s.dark&&u.dark)w=r(s.dark,u.dark);else{if(s.dark)return 1;if(u.dark)return-1}return w}function p(s,u){if(s.command!==u.command)return s.command<u.command?-1:1;if(s.title!==u.title)return s.title<u.title?-1:1;if(s.tooltip!==u.tooltip){if(s.tooltip!==void 0&&u.tooltip!==void 0)return s.tooltip<u.tooltip?-1:1;if(s.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(s.arguments===u.arguments)return 0;if(s.arguments)if(u.arguments){if(s.arguments.length!==u.arguments.length)return s.arguments.length-u.arguments.length}else return 1;else return-1;for(let w=0;w<s.arguments.length;w++){const b=s.arguments[w],I=u.arguments[w];if(b!==I)return b<I?-1:1}return 0}function m(s,u){let w=(0,k.comparePaths)(s.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(w!==0)return w;if(s.command&&u.command)w=p(s.command,u.command);else{if(s.command)return 1;if(u.command)return-1}if(w!==0)return w;if(s.decorations&&u.decorations)w=o(s.decorations,u.decorations);else{if(s.decorations)return 1;if(u.decorations)return-1}return w}function E(s,u){for(let w=0;w<s.length;w++)if(s[w]!==u[w])return!1;return!0}function l(s,u){return s.command===u.command&&s.title===u.title&&s.tooltip===u.tooltip&&(s.arguments&&u.arguments?E(s.arguments,u.arguments):s.arguments===u.arguments)}function c(s,u){return(0,S.equals)(s,u,l)}class d{constructor(u,w,b){this._extension=u,this._proxy=w,this._sourceControlHandle=b,this._value="",this._onDidChange=new T.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(u){this._proxy.$setInputBoxValue(this._sourceControlHandle,u),this.updateValue(u)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(u){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,u),this._placeholder=u}get validateInput(){return(0,h.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(u){if((0,h.checkProposedApiEnabled)(this._extension),u&&typeof u!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=u,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!u)}get visible(){return this._visible}set visible(u){u=!!u,this._visible!==u&&(this._visible=u,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,u))}focus(){(0,h.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(u,w){(0,h.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,u,w)}$onInputBoxValueChange(u){this.updateValue(u)}updateValue(u){this._value=u,this._onDidChange.fire(u)}}e.ExtHostSCMInputBox=d;class t{constructor(u,w,b,I,f){this._proxy=u,this._commands=w,this._sourceControlHandle=b,this._id=I,this._label=f,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new T.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new T.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(u){this._label=u,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,u)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(u){this._hideWhenEmpty=u,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(u){this._resourceStates=[...u],this._onDidUpdateResourceStates.fire()}getResourceState(u){return this._resourceStatesMap.get(u)}$executeResourceCommand(u,w){const b=this._resourceStatesCommandsMap.get(u);return b?(0,y.asPromise)(()=>this._commands.executeCommand(b.command,...b.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var u;const w=[...this._resourceStates].sort(m),I=(0,S.sortedDiff)(this._resourceSnapshot,w,m).map(F=>{const U=F.toInsert.map(z=>{const he=this._resourceHandlePool++;this._resourceStatesMap.set(he,z);const de=z.resourceUri,x=g(z.decorations),j=z.decorations&&g(z.decorations.light)||x,H=z.decorations&&g(z.decorations.dark)||x,R=[];let L;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const me=new A.DisposableStore;L=this._commands.converter.toInternal(z.command,me),this._resourceStatesDisposablesMap.set(he,me)}else this._resourceStatesCommandsMap.set(he,z.command);j&&R.push(j),H&&H.toString()!==(j==null?void 0:j.toString())&&R.push(H);const M=z.decorations&&z.decorations.tooltip||"",$=z.decorations&&!!z.decorations.strikeThrough,G=z.decorations&&!!z.decorations.faded,J=z.contextValue||"";return{rawResource:[he,de,R,M,$,G,J,L],handle:he}});return{start:F.start,deleteCount:F.deleteCount,toInsert:U}}),f=I.map(({start:F,deleteCount:U,toInsert:z})=>[F,U,z.map(he=>he.rawResource)]),_=I.reverse();for(const{start:F,deleteCount:U,toInsert:z}of _){const he=z.map(x=>x.handle),de=this._handlesSnapshot.splice(F,U,...he);for(const x of de)this._resourceStatesMap.delete(x),this._resourceStatesCommandsMap.delete(x),(u=this._resourceStatesDisposablesMap.get(x))===null||u===void 0||u.dispose(),this._resourceStatesDisposablesMap.delete(x)}return this._resourceSnapshot=w,f}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(u,w,b,I,f,_){this._proxy=w,this._commands=b,this._id=I,this._label=f,this._rootUri=_,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new T.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new d(u,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,I,f,_)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(u){this._count!==u&&(this._count=u,this._proxy.$updateSourceControl(this.handle,{count:u}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(u){this._quickDiffProvider=u,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!u})}get commitTemplate(){return this._commitTemplate}set commitTemplate(u){u!==this._commitTemplate&&(this._commitTemplate=u,this._proxy.$updateSourceControl(this.handle,{commitTemplate:u}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(u){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=u;const w=this._commands.converter.toInternal(u,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:w})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(u){if(!(this._statusBarCommands&&u&&c(this._statusBarCommands,u))){this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=u;const w=(u||[]).map(b=>this._commands.converter.toInternal(b,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:w})}}get selected(){return this._selected}createResourceGroup(u,w){const b=new t(this._proxy,this._commands,this.handle,u,w),I=T.Event.once(b.onDidDispose)(()=>this.createdResourceGroups.delete(b));return this.createdResourceGroups.set(b,I),this.eventuallyAddResourceGroups(),b}eventuallyAddResourceGroups(){const u=[],w=[];for(const[b,I]of this.createdResourceGroups){I.dispose();const f=b.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(b),this.eventuallyUpdateResourceStates()});T.Event.once(b.onDidDispose)(()=>{this.updatedResourceGroups.delete(b),f.dispose(),this._groups.delete(b.handle),this._proxy.$unregisterGroup(this.handle,b.handle)}),u.push([b.handle,b.id,b.label,b.features]);const _=b._takeResourceStateSnapshot();_.length>0&&w.push([b.handle,_]),this._groups.set(b.handle,b)}this._proxy.$registerGroups(this.handle,u,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const u=[];this.updatedResourceGroups.forEach(w=>{const b=w._takeResourceStateSnapshot();b.length!==0&&u.push([w.handle,b])}),u.length>0&&this._proxy.$spliceResourceStates(this.handle,u),this.updatedResourceGroups.clear()}getResourceGroup(u){return this._groups.get(u)}setSelectionState(u){this._selected=u,this._onDidChangeSelection.fire(u)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(u=>u.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,je([(0,D.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),je([(0,D.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let a=class Rn{constructor(u,w,b){this._commands=w,this.logService=b,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new T.Emitter,this._proxy=u.getProxy(C.MainContext.MainThreadSCM),this._telemetry=u.getProxy(C.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===3){const f=this._sourceControls.get(I.sourceControlHandle);if(!f)return I;const _=f.getResourceGroup(I.groupHandle);return _?_.getResourceState(I.handle):I}else if(I&&I.$mid===4){const f=this._sourceControls.get(I.sourceControlHandle);return f?f.getResourceGroup(I.groupHandle):I}else if(I&&I.$mid===5){const f=this._sourceControls.get(I.handle);return f||I}return I}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(u,w,b,I){this.logService.trace("ExtHostSCM#createSourceControl",u.identifier.value,w,b,I),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const f=Rn._handlePool++,_=new n(u,this._proxy,this._commands,w,b,I);this._sourceControls.set(f,_);const F=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(u.identifier))||[];return F.push(_),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(u.identifier),F),_}getLastInputBox(u){this.logService.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const w=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(u.identifier)),b=w&&w[w.length-1];return b&&b.inputBox}$provideOriginalResource(u,w,b){const I=v.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",u,I.toString());const f=this._sourceControls.get(u);return!f||!f.quickDiffProvider||!f.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>f.quickDiffProvider.provideOriginalResource(I,b)).then(_=>_||null)}$onInputBoxValueChange(u,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",u);const b=this._sourceControls.get(u);return b&&b.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(u,w,b,I){this.logService.trace("ExtHostSCM#$executeResourceCommand",u,w,b);const f=this._sourceControls.get(u);if(!f)return Promise.resolve(void 0);const _=f.getResourceGroup(w);return _?_.$executeResourceCommand(b,I):Promise.resolve(void 0)}$validateInput(u,w,b){this.logService.trace("ExtHostSCM#$validateInput",u);const I=this._sourceControls.get(u);return!I||!I.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>I.inputBox.validateInput(w,b)).then(f=>f?Promise.resolve([f.message,f.type]):Promise.resolve(void 0))}$setSelectedSourceControl(u){var w,b;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&((w=this._sourceControls.get(u))===null||w===void 0||w.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((b=this._sourceControls.get(this._selectedSourceControlHandle))===null||b===void 0||b.setSelectionState(!1)),this._selectedSourceControlHandle=u,Promise.resolve(void 0)}};a._handlePool=0,a=je([qe(2,i.ILogService)],a),e.ExtHostSCM=a});var it=this&&this.__classPrivateFieldSet||function(Y,e,v,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Y,v):D?D.value=v:e.set(Y,v),v},Ue=this&&this.__classPrivateFieldGet||function(Y,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!T:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(Y):T?T.value:e.get(Y)};define(ve[205],we([0,1,7,5,135,6]),function(Y,e,v,T,D,A){"use strict";var y,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class S{constructor(h,g,r,o,p=v.StatusBarAlignment.Left,m,E){y.set(this,void 0),C.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,it(this,y,h,"f"),it(this,C,g,"f"),this._id=S.ID_GEN++,this._statusId=r,this._statusName=o,this._alignment=p,this._priority=m,this._accessibilityInformation=E}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var h;return(h=this._command)===null||h===void 0?void 0:h.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!S.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){var g;((g=this._command)===null||g===void 0?void 0:g.fromApi)!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Ue(this,C,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Ue(this,C,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,y,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var h;this._timeoutHandle=void 0;let g=this._color;this._backgroundColor&&(g=S.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Ue(this,y,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(h=this._command)===null||h===void 0?void 0:h.internal,g,this._backgroundColor,this._alignment===v.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=S,y=new WeakMap,C=new WeakMap,S.ID_GEN=0,S.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new v.ThemeColor("statusBarItem.errorForeground")]]);class k{constructor(h){this._messages=[],this._item=h.createStatusBarEntry("status.extensionMessage",(0,D.localize)(0,null),v.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const g={message:h};return this._messages.unshift(g),this._update(),new v.Disposable(()=>{const r=this._messages.indexOf(g);r>=0&&(this._messages.splice(r,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(h,g){this._proxy=h.getProxy(T.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new k(this)}createStatusBarEntry(h,g,r,o,p){return new S(this._proxy,this._commands,h,g,r,o,p)}setStatusBarMessage(h,g){const r=this._statusMessage.setMessage(h);let o;return typeof g=="number"?o=setTimeout(()=>r.dispose(),g):typeof g!="undefined"&&g.then(()=>r.dispose(),()=>r.dispose()),new v.Disposable(()=>{r.dispose(),clearTimeout(o)})}}e.ExtHostStatusBar=i}),define(ve[79],we([0,1,5,3,4]),function(Y,e,v,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(C){this._onDidChangeStorage=new T.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(v.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,S){this._proxy.$registerExtensionStorageKeysToSync(C,S)}getValue(C,S,k){return this._proxy.$getValue(C,S).then(i=>i||k)}setValue(C,S,k){return this._proxy.$setValue(C,S,k)}$acceptValue(C,S,k){this._onDidChangeStorage.fire({shared:C,key:S,value:k})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(ve[80],we([0,1,4,27,16,78,2]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,v.createDecorator)("IExtensionStoragePaths");let C=class{constructor(k,i,P){var h;this._logService=i,this._extHostFileSystem=P,this._workspace=(h=k.workspace)!==null&&h!==void 0?h:void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getOrCreateWorkspaceStoragePath(){var k;if(!this._workspace)return Promise.resolve(void 0);const i=this._workspace.id,P=y.URI.joinPath(this._environment.workspaceStorageHome,i);try{return await this._extHostFileSystem.value.stat(P),this._logService.trace("[ExtHostStorage] storage dir already exists",P),P}catch(h){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",P),await this._extHostFileSystem.value.createDirectory(P),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(k=y.URI.revive(this._workspace.configuration))===null||k===void 0?void 0:k.toString(),name:this._workspace.name},void 0,2))),P}catch(h){this._logService.error("[ExtHostStorage]",h);return}}workspaceValue(k){if(this._value)return y.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return y.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}};C=je([qe(0,T.IExtHostInitDataService),qe(1,D.ILogService),qe(2,A.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(ve[40],we([0,1,3,5,4,2,15,6,7,136,12,172,20,31,156]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class o{constructor(t,n,a,s){this._proxy=t,this._id=n,this._creationOptions=a,this._name=s,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(w=>this._pidPromiseComplete=w);const u=this;this.value={get name(){return u._name||""},get processId(){return u._pidPromise},get creationOptions(){return u._creationOptions},get exitStatus(){return u._exitStatus},sendText(w,b=!0){u._checkDisposed(),u._proxy.$sendText(u._id,w,b)},show(w){u._checkDisposed(),u._proxy.$show(u._id,w)},hide(){u._checkDisposed(),u._proxy.$hide(u._id)},dispose(){u._disposed||(u._disposed=!0,u._proxy.$dispose(u._id))},get dimensions(){if(!(u._cols===void 0||u._rows===void 0))return{columns:u._cols,rows:u._rows}}}}async create(t,n,a,s,u,w,b,I,f,_,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:a,env:s,icon:u,initialText:w,waitOnExit:b,strictEnv:I,hideFromUser:f,isFeatureTerminal:_,isExtensionOwnedTerminal:F})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=o;class p{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new v.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new v.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new v.Emitter,this._onProcessTitleChanged=new v.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new v.Emitter,this._onProcessShellTypeChanged=new v.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=p;let m=1,E=class extends C.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new v.Emitter,this._onDidOpenTerminal=new v.Emitter,this._onDidChangeActiveTerminal=new v.Emitter,this._onDidChangeTerminalDimensions=new v.Emitter,this._proxy=n.getProxy(T.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new v.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[a,s]of this._terminalProcesses)s.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const n=new o(this._proxy,(0,g.generateUuid)(),t,t.name),a=new p(t.pty);return n.createExtensionTerminal().then(s=>{const u=this._setupExtHostProcessListeners(s,a);this._terminalProcessDisposables[s]=u}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const s=new p(n),u=this._setupExtHostProcessListeners(t,s);this._terminalProcessDisposables[t]=u}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const a=this._getTerminalById(t);a&&(this._activeTerminal=a,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const a=this._getTerminalById(t);a&&this._onDidWriteTerminalData.fire({terminal:a.value,data:n})}async $acceptTerminalDimensions(t,n,a){const s=this._getTerminalById(t);s&&s.setDimensions(n,a)&&this._onDidChangeTerminalDimensions.fire({terminal:s.value,dimensions:s.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,a){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.resize(n,a)}async $acceptTerminalTitleChange(t,n){const a=this._getTerminalById(t);a&&(a.name=n)}async $acceptTerminalClosed(t,n){const a=this._getTerminalObjectIndexById(this._terminals,t);if(a!==null){const s=this._terminals.splice(a,1)[0];s.setExitCode(n),this._onDidCloseTerminal.fire(s.value)}}$acceptTerminalOpened(t,n,a,s){if(n){const b=this._getTerminalObjectIndexById(this._terminals,n);if(b!==null){this._terminals[b]._id=t,this._onDidOpenTerminal.fire(this.terminals[b]),this._terminals[b].isOpen=!0;return}}const u={name:s.name,shellPath:s.executable,shellArgs:s.args,cwd:typeof s.cwd=="string"?s.cwd:A.URI.revive(s.cwd),env:s.env,hideFromUser:s.hideFromUser},w=new o(this._proxy,t,u,a);this._terminals.push(w),this._onDidOpenTerminal.fire(w.value),w.isOpen=!0}async $acceptTerminalProcessId(t,n){const a=this._getTerminalById(t);a&&a._setProcessId(n)}async $startExtensionTerminal(t,n){const a=this._getTerminalById(t);if(!a)return{message:(0,k.localize)(0,null,t)};a.isOpen||await new Promise(u=>{const w=this.onDidOpenTerminal(async b=>{b===a.value&&(w.dispose(),u())})});const s=this._terminalProcesses.get(t);s?s.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const a=new C.DisposableStore;a.add(n.onProcessReady(u=>this._proxy.$sendProcessReady(t,u.pid,u.cwd))),a.add(n.onProcessTitleChanged(u=>this._proxy.$sendProcessTitle(t,u))),this._bufferer.startBuffering(t,n.onProcessData),a.add(n.onProcessExit(u=>this._onProcessExit(t,u))),n.onProcessOverrideDimensions&&a.add(n.onProcessOverrideDimensions(u=>this._proxy.$sendOverrideDimensions(t,u))),this._terminalProcesses.set(t,n);const s=this._extensionTerminalAwaitingStart[t];return s&&n instanceof p&&(n.startSendingEvents(s.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),a}$acceptProcessAckDataEvent(t,n){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.input(n)}$acceptProcessResize(t,n,a){var s;try{(s=this._terminalProcesses.get(t))===null||s===void 0||s.resize(n,a)}catch(u){if(u.code!=="EPIPE"&&u.code!=="ERR_IPC_CHANNEL_CLOSED")throw u}}$acceptProcessShutdown(t,n){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(a=>this._proxy.$sendProcessInitialCwd(t,a))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(a=>this._proxy.$sendProcessCwd(t,a))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const a=this._getTerminalById(t);if(!a)return[];this._terminalLinkCache.delete(t);const s=this._terminalLinkCancellationSource.get(t);s&&s.dispose(!0);const u=new h.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,u);const w=[],b={terminal:a.value,line:n},I=[];for(const F of this._linkProviders)I.push(new Promise(async U=>{u.token.onCancellationRequested(()=>U({provider:F,links:[]}));const z=await F.provideTerminalLinks(b,u.token)||[];u.token.isCancellationRequested||U({provider:F,links:z})}));const f=await Promise.all(I);if(u.token.isCancellationRequested)return[];const _=new Map;for(const F of f)F&&F.links.length>0&&w.push(...F.links.map(U=>{const z={id:m++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return _.set(z.id,{provider:F.provider,link:U}),z}));return this._terminalLinkCache.set(t,_),w}$activateLink(t,n){var a;const s=(a=this._terminalLinkCache.get(t))===null||a===void 0?void 0:a.get(n);!s||s.provider.handleTerminalLink(s.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const a=this._terminalProcessDisposables[t];a&&(a.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const a=this._getTerminalObjectIndexById(t,n);return a!==null?t[a]:null}_getTerminalObjectIndexById(t,n){let a=null;return t.some((s,u)=>s._id===n?(a=u,!0):!1),a}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new l,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const a=(0,P.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,a.length===0?void 0:a)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const a=n[0],s=new l(n[1]);this._setEnvironmentVariableCollection(a,s)})}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};E=je([qe(1,y.IExtHostRpcService)],E),e.BaseExtHostTerminalService=E;class l{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new v.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:S.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:S.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const a=this.map.get(t);(!a||a.value!==n.value||a.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((a,s)=>t.call(n,s,a,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=l;let c=class extends E{constructor(t){super(!1,t)}createTerminal(t,n,a){throw new i.NotSupportedError}createTerminalFromOptions(t){throw new i.NotSupportedError}getDefaultShell(t,n){throw new i.NotSupportedError}getDefaultShellArgs(t,n){throw new i.NotSupportedError}async getDefaultShellAndArgs(t){throw new i.NotSupportedError}$getAvailableProfiles(t){throw new i.NotSupportedError}};c=je([qe(0,y.IExtHostRpcService)],c),e.WorkerExtHostTerminalService=c}),define(ve[206],we([0,1,3,13,5,98,9,7]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(i,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new v.Emitter,this._onDidChangeTextEditorOptions=new v.Emitter,this._onDidChangeTextEditorVisibleRanges=new v.Emitter,this._onDidChangeTextEditorViewColumn=new v.Emitter,this._onDidChangeActiveTextEditor=new v.Emitter,this._onDidChangeVisibleTextEditors=new v.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(h=>this._onDidChangeVisibleTextEditors.fire(h)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(h=>this._onDidChangeActiveTextEditor.fire(h))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const P=this._extHostDocumentsAndEditors.allEditors();return i?P:P.map(h=>h.value)}async showTextDocument(i,P,h){let g;typeof P=="number"?g={position:y.ViewColumn.from(P),preserveFocus:h}:typeof P=="object"?g={position:y.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?y.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:g={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(i.uri,g),o=r&&this._extHostDocumentsAndEditors.getEditor(r);if(o)return o.value;throw r?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i){return new A.TextEditorDecorationType(this._proxy,i).value}$acceptEditorPropertiesChanged(i,P){const h=this._extHostDocumentsAndEditors.getEditor(i);if(!h)throw new Error("unknown text editor");if(P.options&&h._acceptOptions(P.options),P.selections){const g=P.selections.selections.map(y.Selection.to);h._acceptSelections(g)}if(P.visibleRanges){const g=T.coalesce(P.visibleRanges.map(y.Range.to));h._acceptVisibleRanges(g)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:h.value,options:Object.assign(Object.assign({},P.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(P.options.lineNumbers)})}),P.selections){const g=C.TextEditorSelectionChangeKind.fromValue(P.selections.source),r=P.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:h.value,selections:r,kind:g})}if(P.visibleRanges){const g=T.coalesce(P.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:h.value,visibleRanges:g})}}$acceptEditorPositionData(i){for(const P in i){const h=this._extHostDocumentsAndEditors.getEditor(P);if(!h)throw new Error("Unknown text editor");const g=y.ViewColumn.to(i[P]);h.value.viewColumn!==g&&(h._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:h.value,viewColumn:g}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=S});var Gt=this&&this.__rest||function(Y,e){var v={};for(var T in Y)Object.prototype.hasOwnProperty.call(Y,T)&&e.indexOf(T)<0&&(v[T]=Y[T]);if(Y!=null&&typeof Object.getOwnPropertySymbols=="function")for(var D=0,T=Object.getOwnPropertySymbols(Y);D<T.length;D++)e.indexOf(T[D])<0&&Object.prototype.propertyIsEnumerable.call(Y,T[D])&&(v[T[D]]=Y[T[D]]);return v};define(ve[207],we([0,1,2,4,5,6,7]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,T.createDecorator)("IExtHostTimeline");class C{constructor(i,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(D.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:h=>{var g,r;if(h&&h.$mid===11){const o=h.uri===void 0?void 0:v.URI.revive(h.uri);return(r=(g=this._itemsBySourceAndUriMap.get(h.source))===null||g===void 0?void 0:g.get(S(o)))===null||r===void 0?void 0:r.get(h.handle)}return h}})}async $getTimeline(i,P,h,g,r){const o=this._providers.get(i);return o==null?void 0:o.provideTimeline(v.URI.revive(P),h,g,r)}registerTimelineProvider(i,P,h,g){const r=new A.DisposableStore,o=this.convertTimelineItem(P.id,g,r).bind(this);let p;P.onDidChange&&(p=P.onDidChange(E=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},E),{id:P.id})),this));const m=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},P),{scheme:i,onDidChange:void 0,async provideTimeline(E,l,c,d){var t;(d==null?void 0:d.resetCache)&&(r.clear(),(t=m.get(P.id))===null||t===void 0||t.clear());const n=await P.provideTimeline(E,l,c);if(n!=null){const a=o(E,d);return Object.assign(Object.assign({},n),{source:P.id,items:n.items.map(a)})}},dispose(){var E;for(const l of m.values())(E=l.get(P.id))===null||E===void 0||E.clear();p==null||p.dispose(),r.dispose()}}))}convertTimelineItem(i,P,h){return(g,r)=>{let o;if(r==null?void 0:r.cacheResults){let p=this._itemsBySourceAndUriMap.get(i);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(i,p));const m=S(g);o=p.get(m),o===void 0&&(o=new Map,p.set(m,o))}return p=>{var m,E;const{iconPath:l}=p,c=Gt(p,["iconPath"]),d=`${i}|${(m=p.id)!==null&&m!==void 0?m:p.timestamp}`;o==null||o.set(d,p);let t,n,a;return p.iconPath&&(l instanceof y.ThemeIcon?a={id:l.id}:v.URI.isUri(l)?(t=l,n=l):{light:t,dark:n}=l),Object.assign(Object.assign({},c),{id:(E=c.id)!==null&&E!==void 0?E:void 0,handle:d,source:i,command:p.command?P.toInternal(p.command,h):void 0,icon:t,iconDark:n,themeIcon:a,accessibilityInformation:p.accessibilityInformation})}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,A.toDisposable)(()=>{var h;for(const g of this._itemsBySourceAndUriMap.values())(h=g.get(i.id))===null||h===void 0||h.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=C;function S(k){return k==null?void 0:k.toString()}}),define(ve[208],we([0,1,6,19,2,5]),function(Y,e,v,T,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(S){this._openers=new Map,this._proxy=S.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,k,i,P){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const h=P.schemes.find(g=>!y.supportedSchemes.has(g));if(h)throw new Error(`Scheme '${h}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,i),this._proxy.$registerUriOpener(k,P.schemes,S,P.label),(0,v.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(S,k,i){const P=this._openers.get(S);if(!P)throw new Error(`Unknown opener with id: ${S}`);const h=D.URI.revive(k);return P.canOpenExternalUri(h,i)}async $openUri(S,k,i){const P=this._openers.get(S);if(!P)throw new Error(`Unknown opener id: '${S}'`);return P.openExternalUri(D.URI.revive(k.resolvedUri),{sourceUri:D.URI.revive(k.sourceUri)},i)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([T.Schemas.http,T.Schemas.https])}),define(ve[209],we([0,1,5,2,6,12,26]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(v.MainContext.MainThreadUrls)}registerUriHandler(k,i){if(this.handles.has(y.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const P=C.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(k)),this.handlers.set(P,i),this._proxy.$registerUriHandler(P,k),(0,D.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(k)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(k,i){const P=this.handlers.get(k);if(!P)return Promise.resolve(void 0);try{P.handleUri(T.URI.revive(i))}catch(h){(0,A.onUnexpectedError)(h)}return Promise.resolve(void 0)}async createAppUri(k){return T.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=C,C.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(Y,e,v,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Y,v):D?D.value=v:e.set(Y,v),v},Ue=this&&this.__classPrivateFieldGet||function(Y,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!T:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(Y):T?T.value:e.get(Y)};define(ve[50],we([0,1,3,2,145,165,73,5]),function(Y,e,v,T,D,A,y,C){"use strict";var S,k,i,P,h,g,r,o,p,m,E,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class c{constructor(b,I,f,_,F,U,z){S.set(this,void 0),k.set(this,void 0),i.set(this,void 0),P.set(this,void 0),h.set(this,void 0),g.set(this,void 0),r.set(this,""),o.set(this,void 0),p.set(this,!1),m.set(this,!1),E.set(this,!1),this._onMessageEmitter=new v.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new v.Emitter),this._onDidDispose=Ue(this,l,"f").event,it(this,S,b,"f"),it(this,k,I,"f"),it(this,o,f,"f"),it(this,P,_,"f"),it(this,h,F,"f"),it(this,g,U,"f"),it(this,E,d(U),"f"),it(this,i,z,"f")}dispose(){it(this,p,!0,"f"),Ue(this,l,"f").fire(),Ue(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return it(this,m,!0,"f"),(0,y.asWebviewUri)(Ue(this,P,"f"),Ue(this,S,"f"),b)}get cspSource(){return Ue(this,P,"f").webviewCspSource.replace("{{uuid}}",Ue(this,S,"f"))}get html(){return this.assertNotDisposed(),Ue(this,r,"f")}set html(b){this.assertNotDisposed(),Ue(this,r,"f")!==b&&(it(this,r,b,"f"),!Ue(this,m,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(it(this,m,!0,"f"),Ue(this,i,"f").report("Webview vscode-resource: uris",Ue(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,k,"f").$setHtml(Ue(this,S,"f"),b))}get options(){return this.assertNotDisposed(),Ue(this,o,"f")}set options(b){this.assertNotDisposed(),Ue(this,k,"f").$setOptions(Ue(this,S,"f"),a(Ue(this,g,"f"),Ue(this,h,"f"),b)),it(this,o,b,"f")}async postMessage(b){if(Ue(this,p,"f"))return!1;const I=(0,A.serializeWebviewMessage)(b,{serializeBuffersForPostMessage:Ue(this,E,"f")});return Ue(this,k,"f").$postMessage(Ue(this,S,"f"),I.message,...I.buffers)}assertNotDisposed(){if(Ue(this,p,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=c,S=new WeakMap,k=new WeakMap,i=new WeakMap,P=new WeakMap,h=new WeakMap,g=new WeakMap,r=new WeakMap,o=new WeakMap,p=new WeakMap,m=new WeakMap,E=new WeakMap,l=new WeakMap;function d(w){try{const b=(0,D.normalizeVersion)((0,D.parseVersion)(w.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch(b){return!1}}e.shouldSerializeBuffersForPostMessage=d;class t{constructor(b,I,f,_,F){this.initData=I,this.workspace=f,this._logService=_,this._deprecationService=F,this._webviews=new Map,this._webviewProxy=b.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(b,I,...f){const _=this.getWebview(b);if(_){const{message:F}=(0,A.deserializeWebviewMessage)(I,f);_._onMessageEmitter.fire(F)}}$onMissingCsp(b,I){this._logService.warn(`${I} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,I,f){const _=new c(b,this._webviewProxy,s(I),this.initData,this.workspace,f,this._deprecationService);return this._webviews.set(b,_),_._onDidDispose(()=>{this._webviews.delete(b)}),_}deleteWebview(b){this._webviews.delete(b)}getWebview(b){return this._webviews.get(b)}}e.ExtHostWebviews=t;function n(w){return{id:w.identifier,location:w.extensionLocation}}e.toExtensionData=n;function a(w,b,I){return{enableCommandUris:I.enableCommandUris,enableScripts:I.enableScripts,portMapping:I.portMapping,localResourceRoots:I.localResourceRoots||u(w,b)}}e.serializeWebviewOptions=a;function s(w){var b;return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,portMapping:w.portMapping,localResourceRoots:(b=w.localResourceRoots)===null||b===void 0?void 0:b.map(I=>T.URI.from(I))}}e.reviveOptions=s;function u(w,b){return[...((b==null?void 0:b.getWorkspaceFolders())||[]).map(I=>I.uri),w.extensionLocation]}}),define(ve[210],we([0,1,20,56,6,19,25,2,9,50,68,5,7]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=c(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class r{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,a){const s=this.key(t,n.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const u=new g(n,a);return this._documents.set(s,u),u}delete(t,n){const a=this.key(t,n.uri);this._documents.delete(a)}key(t,n){return`${t}@@@${n}`}}var o;(function(d){d[d.Text=0]="Text",d[d.Custom=1]="Custom"})(o||(o={}));class p{constructor(){this._providers=new Map}addTextProvider(t,n,a){return this.add(0,t,n,a)}addCustomProvider(t,n,a){return this.add(1,t,n,a)}get(t){return this._providers.get(t)}add(t,n,a,s){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:a,provider:s}),new h.Disposable(()=>this._providers.delete(n))}}class m{constructor(t,n,a,s,u){this._extHostDocuments=n,this._extensionStoragePaths=a,this._extHostWebview=s,this._extHostWebviewPanels=u,this._editorProviders=new p,this._documents=new r,this._proxy=t.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,a,s){const u=new D.DisposableStore;return E(a)?(u.add(this._editorProviders.addTextProvider(n,t,a)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),n,s.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(u.add(this._editorProviders.addCustomProvider(n,t,a)),this.supportEditing(a)&&u.add(a.onDidChangeCustomDocument(w=>{const b=this.getCustomDocumentEntry(n,w.document.uri);if(l(w)){const I=b.addEdit(w);this._proxy.$onDidEdit(w.document.uri,n,I,w.label)}else this._proxy.$onContentChange(w.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),n,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),h.Disposable.from(u,new h.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,a,s,u){var w;const b=this._editorProviders.get(n);if(!b)throw new Error(`No provider found for '${n}'`);if(b.type!==1)throw new Error(`Invalid provide type for '${n}'`);const I=C.URI.revive(t),f=await b.provider.openCustomDocument(I,{backupId:a,untitledDocumentData:s==null?void 0:s.buffer},u);let _;return this.supportEditing(b.provider)&&this._extensionStoragePaths&&(_=(w=this._extensionStoragePaths.workspaceValue(b.extension))!==null&&w!==void 0?w:this._extensionStoragePaths.globalValue(b.extension)),this._documents.add(n,f,_),{editable:this.supportEditing(b.provider)}}async $disposeCustomDocument(t,n){const a=this._editorProviders.get(n);if(!a)throw new Error(`No provider found for '${n}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${n}'`);const s=C.URI.revive(t),{document:u}=this.getCustomDocumentEntry(n,s);this._documents.delete(n,u),u.dispose()}async $resolveWebviewEditor(t,n,a,s,u,w){const b=this._editorProviders.get(a);if(!b)throw new Error(`No provider found for '${a}'`);const I=S.ViewColumn.to(u),f=this._extHostWebview.createNewWebview(n,s.webviewOptions,b.extension),_=this._extHostWebviewPanels.createNewWebviewPanel(n,a,s.title,I,s.panelOptions,f),F=C.URI.revive(t);switch(b.type){case 1:{const{document:U}=this.getCustomDocumentEntry(a,F);return b.provider.resolveCustomEditor(U,_,w)}case 0:{const U=this._extHostDocuments.getDocument(F);return b.provider.resolveCustomTextEditor(U,_,w)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,a){this.getCustomDocumentEntry(n,t).disposeEdits(a)}async $onMoveCustomEditor(t,n,a){const s=this._editorProviders.get(a);if(!s)throw new Error(`No provider found for '${a}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const u=this._extHostWebviewPanels.getWebviewPanel(t);if(!u)throw new Error("No webview found");const w=C.URI.revive(n),b=this._extHostDocuments.getDocument(w);await s.provider.moveCustomTextEditor(b,u,v.CancellationToken.None)}async $undo(t,n,a,s){return this.getCustomDocumentEntry(n,t).undo(a,s)}async $redo(t,n,a,s){return this.getCustomDocumentEntry(n,t).redo(a,s)}async $revert(t,n,a){const s=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(s.document,a),s.disposeBackup()}async $onSave(t,n,a){const s=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(s.document,a),s.disposeBackup()}async $onSaveAs(t,n,a,s){const u=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(u.document,C.URI.revive(a),s)}async $backup(t,n,a){const s=this.getCustomDocumentEntry(n,t),w=await this.getCustomEditorProvider(n).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},a);return s.updateBackup(w),w.id}getCustomDocumentEntry(t,n){const a=this._documents.get(t,C.URI.revive(n));if(!a)throw new Error("No custom document found");return a}getCustomEditorProvider(t){const n=this._editorProviders.get(t),a=n==null?void 0:n.provider;if(!a||!this.supportEditing(a))throw new Error("Custom document is not editable");return a}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=m;function E(d){return typeof d.resolveCustomTextEditor=="function"}function l(d){return typeof d.undo=="function"&&typeof d.redo=="function"}function c(d){const t=d.scheme===A.Schemas.file||d.scheme===A.Schemas.untitled?d.fsPath:d.toString();return(0,T.hash)(t)+""}});var it=this&&this.__classPrivateFieldSet||function(Y,e,v,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Y,v):D?D.value=v:e.set(Y,v),v},Ue=this&&this.__classPrivateFieldGet||function(Y,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!T:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(Y):T?T.value:e.get(Y)};define(ve[211],we([0,1,3,6,2,31,9,50,5,7]),function(Y,e,v,T,D,A,y,C,S,k){"use strict";var i,P,h,g,r,o,p,m,E,l,c,d,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends T.Disposable{constructor(w,b,I,f,_,F,U){super();i.set(this,void 0),P.set(this,void 0),h.set(this,void 0),g.set(this,void 0),r.set(this,void 0),o.set(this,void 0),p.set(this,void 0),m.set(this,void 0),E.set(this,!0),l.set(this,!0),c.set(this,!1),d.set(this,this._register(new v.Emitter)),this.onDidDispose=Ue(this,d,"f").event,t.set(this,this._register(new v.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,it(this,i,w,"f"),it(this,P,b,"f"),it(this,h,I,"f"),it(this,r,F,"f"),it(this,m,_,"f"),it(this,o,f,"f"),it(this,g,U,"f")}dispose(){Ue(this,c,"f")||(it(this,c,!0,"f"),Ue(this,d,"f").fire(),Ue(this,P,"f").$disposeWebview(Ue(this,i,"f")),Ue(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,g,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,h,"f")}get title(){return this.assertNotDisposed(),Ue(this,o,"f")}set title(w){this.assertNotDisposed(),Ue(this,o,"f")!==w&&(it(this,o,w,"f"),Ue(this,P,"f").$setTitle(Ue(this,i,"f"),w))}get iconPath(){return this.assertNotDisposed(),Ue(this,p,"f")}set iconPath(w){this.assertNotDisposed(),Ue(this,p,"f")!==w&&(it(this,p,w,"f"),Ue(this,P,"f").$setIconPath(Ue(this,i,"f"),D.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return Ue(this,r,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,m,"f")=="number"&&Ue(this,m,"f")<0))return Ue(this,m,"f")}get active(){return this.assertNotDisposed(),Ue(this,l,"f")}get visible(){return this.assertNotDisposed(),Ue(this,E,"f")}_updateViewState(w){Ue(this,c,"f")||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(it(this,l,w.active,"f"),it(this,E,w.visible,"f"),it(this,m,w.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(w,b){this.assertNotDisposed(),Ue(this,P,"f").$reveal(Ue(this,i,"f"),{viewColumn:w?y.ViewColumn.from(w):void 0,preserveFocus:!!b})}assertNotDisposed(){if(Ue(this,c,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,P=new WeakMap,h=new WeakMap,g=new WeakMap,r=new WeakMap,o=new WeakMap,p=new WeakMap,m=new WeakMap,E=new WeakMap,l=new WeakMap,c=new WeakMap,d=new WeakMap,t=new WeakMap;class a{constructor(w,b,I){this.webviews=b,this.workspace=I,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=w.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(w,b,I,f,_={}){const F=typeof f=="object"?f.viewColumn:f,U={viewColumn:y.ViewColumn.from(F),preserveFocus:typeof f=="object"&&!!f.preserveFocus},z=(0,C.shouldSerializeBuffersForPostMessage)(w),he=a.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(w),he,b,{title:I,panelOptions:s(_),webviewOptions:(0,C.serializeWebviewOptions)(w,this.workspace,_),serializeBuffersForPostMessage:z},U);const de=this.webviews.createNewWebview(he,_,w);return this.createNewWebviewPanel(he,b,I,F,_,de)}$onDidChangeWebviewPanelViewStates(w){const b=Object.keys(w);b.sort((I,f)=>{const _=w[I],F=w[f];return _.active?1:F.active?-1:+_.visible-+F.visible});for(const I of b){const f=this.getWebviewPanel(I);if(!!f){const _=w[I];f._updateViewState({active:_.active,visible:_.visible,viewColumn:y.ViewColumn.to(_.position)})}}}async $onDidDisposeWebviewPanel(w){const b=this.getWebviewPanel(w);b==null||b.dispose(),this._webviewPanels.delete(w),this.webviews.deleteWebview(w)}registerWebviewPanelSerializer(w,b,I){if(this._serializers.has(b))throw new Error(`Serializer for '${b}' already registered`);return this._serializers.set(b,{serializer:I,extension:w}),this._proxy.$registerSerializer(b,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(w)}),new k.Disposable(()=>{this._serializers.delete(b),this._proxy.$unregisterSerializer(b)})}async $deserializeWebviewPanel(w,b,I,f){const _=this._serializers.get(b);if(!_)throw new Error(`No serializer found for '${b}'`);const{serializer:F,extension:U}=_,z=this.webviews.createNewWebview(w,I.webviewOptions,U),he=this.createNewWebviewPanel(w,b,I.title,f,I.panelOptions,z);await F.deserializeWebviewPanel(he,I.state)}createNewWebviewPanel(w,b,I,f,_,F){const U=new n(w,this._proxy,b,I,f,_,F);return this._webviewPanels.set(w,U),U}getWebviewPanel(w){return this._webviewPanels.get(w)}}e.ExtHostWebviewPanels=a;function s(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(Y,e,v,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Y,v):D?D.value=v:e.set(Y,v),v},Ue=this&&this.__classPrivateFieldGet||function(Y,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!T:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(Y):T?T.value:e.get(Y)};define(ve[212],we([0,1,3,6,50,5,7]),function(Y,e,v,T,D,A,y){"use strict";var C,S,k,i,P,h,g,r,o,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends T.Disposable{constructor(c,d,t,n,a,s){super();C.set(this,void 0),S.set(this,void 0),k.set(this,void 0),i.set(this,void 0),P.set(this,!1),h.set(this,void 0),g.set(this,void 0),r.set(this,void 0),o.set(this,this._register(new v.Emitter)),this.onDidChangeVisibility=Ue(this,o,"f").event,p.set(this,this._register(new v.Emitter)),this.onDidDispose=Ue(this,p,"f").event,it(this,k,t,"f"),it(this,g,n,"f"),it(this,C,c,"f"),it(this,S,d,"f"),it(this,i,a,"f"),it(this,h,s,"f")}dispose(){Ue(this,P,"f")||(it(this,P,!0,"f"),Ue(this,p,"f").fire(),Ue(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,g,"f")}set title(c){this.assertNotDisposed(),Ue(this,g,"f")!==c&&(it(this,g,c,"f"),Ue(this,S,"f").$setWebviewViewTitle(Ue(this,C,"f"),c))}get description(){return this.assertNotDisposed(),Ue(this,r,"f")}set description(c){this.assertNotDisposed(),Ue(this,r,"f")!==c&&(it(this,r,c,"f"),Ue(this,S,"f").$setWebviewViewDescription(Ue(this,C,"f"),c))}get visible(){return Ue(this,h,"f")}get webview(){return Ue(this,i,"f")}get viewType(){return Ue(this,k,"f")}_setVisible(c){c===Ue(this,h,"f")||Ue(this,P,"f")||(it(this,h,c,"f"),Ue(this,o,"f").fire())}show(c){this.assertNotDisposed(),Ue(this,S,"f").$show(Ue(this,C,"f"),!!c)}assertNotDisposed(){if(Ue(this,P,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,S=new WeakMap,k=new WeakMap,i=new WeakMap,P=new WeakMap,h=new WeakMap,g=new WeakMap,r=new WeakMap,o=new WeakMap,p=new WeakMap;class E{constructor(c,d){this._extHostWebview=d,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,d,t,n){if(this._viewProviders.has(d))throw new Error(`View provider for '${d}' already registered`);return this._viewProviders.set(d,{provider:t,extension:c}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(c),d,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(d),this._proxy.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(c,d,t,n,a){const s=this._viewProviders.get(d);if(!s)throw new Error(`No view provider found for '${d}'`);const{provider:u,extension:w}=s,b=this._extHostWebview.createNewWebview(c,{},w),I=new m(c,this._proxy,d,t,b,!0);this._webviewViews.set(c,I),await u.resolveWebviewView(I,{state:n},a)}async $onDidChangeWebviewViewVisibility(c,d){this.getWebviewView(c)._setVisible(d)}async $disposeWebviewView(c){const d=this.getWebviewView(c);this._webviewViews.delete(c),d.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const d=this._webviewViews.get(c);if(!d)throw new Error("No webview found");return d}}e.ExtHostWebviewViews=E}),define(ve[102],we([0,1,3,5,2,19,8,4,15]),function(Y,e,v,T,D,A,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Fn{constructor(P){this._onDidChangeWindowState=new v.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Fn.InitialState,this._proxy=P.getProxy(T.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(h=>this.$onDidChangeWindowFocus(h))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:P}),this._onDidChangeWindowState.fire(this._state))}openUri(P,h){let g;if(typeof P=="string"){g=P;try{P=D.URI.parse(P)}catch(r){return Promise.reject(`Invalid uri - '${P}'`)}}return(0,y.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,g,h)}async asExternalUri(P,h){if((0,y.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([A.Schemas.http,A.Schemas.https]).has(P.scheme))return Promise.reject(`Invalid scheme '${P.scheme}'`);const g=await this._proxy.$asExternalUri(P,h);return D.URI.from(g)}};k.InitialState={focused:!0},k=je([qe(0,S.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(ve[213],we([0,1,16,5,27,15]),function(Y,e,v,T,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let y=class extends v.AbstractLogger{constructor(S,k){super();this._proxy=S.getProxy(T.MainContext.MainThreadLog),this._logFile=k.logFile.toJSON(),this.setLevel(k.logLevel)}$setLevel(S){this.setLevel(S)}trace(S,...k){this.getLevel()<=v.LogLevel.Trace&&this._proxy.$log(this._logFile,v.LogLevel.Trace,Array.from(arguments))}debug(S,...k){this.getLevel()<=v.LogLevel.Debug&&this._proxy.$log(this._logFile,v.LogLevel.Debug,Array.from(arguments))}info(S,...k){this.getLevel()<=v.LogLevel.Info&&this._proxy.$log(this._logFile,v.LogLevel.Info,Array.from(arguments))}warn(S,...k){this.getLevel()<=v.LogLevel.Warning&&this._proxy.$log(this._logFile,v.LogLevel.Warning,Array.from(arguments))}error(S,...k){this.getLevel()<=v.LogLevel.Error&&this._proxy.$log(this._logFile,v.LogLevel.Error,Array.from(arguments))}critical(S,...k){this.getLevel()<=v.LogLevel.Critical&&this._proxy.$log(this._logFile,v.LogLevel.Critical,Array.from(arguments))}flush(){}};y=je([qe(0,A.IExtHostRpcService),qe(1,D.IExtHostInitDataService)],y),e.ExtHostLogService=y}),define(ve[214],we([0,1,11,20,12,3,6,114,186,99,24]),function(Y,e,v,T,D,A,y,C,S,k,i){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function h(s,u){try{return JSON.stringify(s,u)}catch(w){return"null"}}function g(s,u){return JSON.stringify(s,u)}function r(s){return s?(u,w)=>w&&w.$mid===1?s.transformOutgoing(w):w:null}var o;(function(s){s[s.LocalSide=0]="LocalSide",s[s.OtherSide=1]="OtherSide"})(o=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(s){s[s.Responsive=0]="Responsive",s[s.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const m=()=>{},E=Symbol.for("rpcProtocol"),l=Symbol.for("rpcProxy");class c extends y.Disposable{constructor(u,w=null,b=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=u,this._logger=w,this._uriTransformer=b,this._uriReplacer=r(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let I=0,f=k.ProxyIdentifier.count;I<f;I++)this._locals[I]=null,this._proxies[I]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new v.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(I=>this._receiveOneMessage(I))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(u=>{this._pendingRPCReplies[u].resolveErr(D.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(u){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(u){this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(u){this._responsiveState!==u&&(this._responsiveState=u,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(u){return this._uriTransformer?(0,C.transformIncomingURIs)(u,this._uriTransformer):u}getProxy(u){const{nid:w,sid:b}=u;return this._proxies[w]||(this._proxies[w]=this._createProxy(w,b)),this._proxies[w]}_createProxy(u,w){let b={get:(I,f)=>(typeof f=="string"&&!I[f]&&f.charCodeAt(0)===36&&(I[f]=(..._)=>this._remoteCall(u,f,_)),f===l?w:I[f])};return new Proxy(Object.create(null),b)}set(u,w){return this._locals[u.nid]=w,w}assertRegistered(u){for(let w=0,b=u.length;w<b;w++){const I=u[w];if(!this._locals[I.nid])throw new Error(`Missing actor ${I.sid} (isMain: ${I.isMain})`)}}_receiveOneMessage(u){if(!this._isDisposed){const w=u.byteLength,b=d.read(u,0),I=b.readUInt8(),f=b.readUInt32();switch(I){case 1:case 2:{let{rpcId:_,method:F,args:U}=t.deserializeRequestJSONArgs(b);this._uriTransformer&&(U=(0,C.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest(w,f,_,F,U,I===2);break}case 3:case 4:{let{rpcId:_,method:F,args:U}=t.deserializeRequestMixedArgs(b);this._uriTransformer&&(U=(0,C.transformIncomingURIs)(U,this._uriTransformer)),this._receiveRequest(w,f,_,F,U,I===4);break}case 5:{this._logger&&this._logger.logIncoming(w,f,0,"ack"),this._onDidReceiveAcknowledge(f);break}case 6:{this._receiveCancel(w,f);break}case 7:{this._receiveReply(w,f,void 0);break}case 9:{let _=t.deserializeReplyOKJSON(b);this._uriTransformer&&(_=(0,C.transformIncomingURIs)(_,this._uriTransformer)),this._receiveReply(w,f,_);break}case 8:{let _=t.deserializeReplyOKVSBuffer(b);this._receiveReply(w,f,_);break}case 10:{let _=t.deserializeReplyErrError(b);this._uriTransformer&&(_=(0,C.transformIncomingURIs)(_,this._uriTransformer)),this._receiveReplyErr(w,f,_);break}case 11:{this._receiveReplyErr(w,f,void 0);break}default:console.error("received unexpected message"),console.error(u)}}}_receiveRequest(u,w,b,I,f,_){this._logger&&this._logger.logIncoming(u,w,1,`receiveRequest ${(0,k.getStringIdentifierForProxy)(b)}.${I}(`,f);const F=String(w);let U,z;if(_){const de=new T.CancellationTokenSource;f.push(de.token),U=this._invokeHandler(b,I,f),z=()=>de.cancel()}else U=this._invokeHandler(b,I,f),z=m;this._cancelInvokedHandlers[F]=z;const he=t.serializeAcknowledged(w);this._logger&&this._logger.logOutgoing(he.byteLength,w,1,"ack"),this._protocol.send(he),U.then(de=>{delete this._cancelInvokedHandlers[F];const x=t.serializeReplyOK(w,de,this._uriReplacer);this._logger&&this._logger.logOutgoing(x.byteLength,w,1,"reply:",de),this._protocol.send(x)},de=>{delete this._cancelInvokedHandlers[F];const x=t.serializeReplyErr(w,de);this._logger&&this._logger.logOutgoing(x.byteLength,w,1,"replyErr:",de),this._protocol.send(x)})}_receiveCancel(u,w){this._logger&&this._logger.logIncoming(u,w,1,"receiveCancel");const b=String(w);this._cancelInvokedHandlers[b]&&this._cancelInvokedHandlers[b]()}_receiveReply(u,w,b){this._logger&&this._logger.logIncoming(u,w,0,"receiveReply:",b);const I=String(w);if(!!this._pendingRPCReplies.hasOwnProperty(I)){const f=this._pendingRPCReplies[I];delete this._pendingRPCReplies[I],f.resolveOk(b)}}_receiveReplyErr(u,w,b){this._logger&&this._logger.logIncoming(u,w,0,"receiveReplyErr:",b);const I=String(w);if(!!this._pendingRPCReplies.hasOwnProperty(I)){const f=this._pendingRPCReplies[I];delete this._pendingRPCReplies[I];let _;b&&(b.$isError?(_=new Error,_.name=b.name,_.message=b.message,_.stack=b.stack):_=b),f.resolveErr(_)}}_invokeHandler(u,w,b){try{return Promise.resolve(this._doInvokeHandler(u,w,b))}catch(I){return Promise.reject(I)}}_doInvokeHandler(u,w,b){const I=this._locals[u];if(!I)throw new Error("Unknown actor "+(0,k.getStringIdentifierForProxy)(u));let f=I[w];if(typeof f!="function")throw new Error("Unknown method "+w+" on actor "+(0,k.getStringIdentifierForProxy)(u));return f.apply(I,b)}_remoteCall(u,w,b){if(this._isDisposed)return Promise.reject(D.canceled());let I=null;if(b.length>0&&T.CancellationToken.isCancellationToken(b[b.length-1])&&(I=b.pop()),I&&I.isCancellationRequested)return Promise.reject(D.canceled());const f=t.serializeRequestArguments(b,this._uriReplacer),_=++this._lastMessageId,F=String(_),U=new S.LazyPromise;I&&I.onCancellationRequested(()=>{const he=t.serializeCancel(_);this._logger&&this._logger.logOutgoing(he.byteLength,_,0,"cancel"),this._protocol.send(t.serializeCancel(_))}),this._pendingRPCReplies[F]=U,this._onWillSendRequest(_);const z=t.serializeRequest(_,u,w,f,!!I);return this._logger&&this._logger.logOutgoing(z.byteLength,_,0,`request: ${(0,k.getStringIdentifierForProxy)(u)}.${w}(`,b),this._protocol.send(z),U}}e.RPCProtocol=c,P=E,c.UNRESPONSIVE_TIME=3*1e3;class d{constructor(u,w){this._buff=u,this._offset=w}static alloc(u,w,b){let I=new d(i.VSBuffer.alloc(b+1+4),0);return I.writeUInt8(u),I.writeUInt32(w),I}static read(u,w){return new d(u,w)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(u){this._buff.writeUInt8(u,this._offset),this._offset+=1}readUInt8(){const u=this._buff.readUInt8(this._offset);return this._offset+=1,u}writeUInt32(u){this._buff.writeUInt32BE(u,this._offset),this._offset+=4}readUInt32(){const u=this._buff.readUInt32BE(this._offset);return this._offset+=4,u}static sizeShortString(u){return 1+u.byteLength}writeShortString(u){this._buff.writeUInt8(u.byteLength,this._offset),this._offset+=1,this._buff.set(u,this._offset),this._offset+=u.byteLength}readShortString(){const u=this._buff.readUInt8(this._offset);this._offset+=1;const b=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,b}static sizeLongString(u){return 4+u.byteLength}writeLongString(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readLongString(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const b=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,b}writeBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}static sizeVSBuffer(u){return 4+u.byteLength}writeVSBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readVSBuffer(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const w=this._buff.slice(this._offset,this._offset+u);return this._offset+=u,w}static sizeMixedArray(u,w){let b=0;b+=1;for(let I=0,f=u.length;I<f;I++){const _=u[I],F=w[I];switch(b+=1,F){case 1:b+=this.sizeLongString(_);break;case 2:b+=this.sizeVSBuffer(_);break;case 3:break}}return b}writeMixedArray(u,w){this._buff.writeUInt8(u.length,this._offset),this._offset+=1;for(let b=0,I=u.length;b<I;b++){const f=u[b];switch(w[b]){case 1:this.writeUInt8(1),this.writeLongString(f);break;case 2:this.writeUInt8(2),this.writeVSBuffer(f);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const u=this._buff.readUInt8(this._offset);this._offset+=1;let w=new Array(u);for(let b=0;b<u;b++)switch(this.readUInt8()){case 1:w[b]=this.readLongString();break;case 2:w[b]=this.readVSBuffer();break;case 3:w[b]=void 0;break}return w}}class t{static _arrayContainsBufferOrUndefined(u){for(let w=0,b=u.length;w<b;w++)if(u[w]instanceof i.VSBuffer||typeof u[w]=="undefined")return!0;return!1}static serializeRequestArguments(u,w){if(this._arrayContainsBufferOrUndefined(u)){let b=[],I=[];for(let f=0,_=u.length;f<_;f++){const F=u[f];F instanceof i.VSBuffer?(b[f]=F,I[f]=2):typeof F=="undefined"?(b[f]=i.VSBuffer.alloc(0),I[f]=3):(b[f]=i.VSBuffer.fromString(g(F,w)),I[f]=1)}return{type:"mixed",args:b,argsType:I}}return{type:"simple",args:g(u,w)}}static serializeRequest(u,w,b,I,f){return I.type==="mixed"?this._requestMixedArgs(u,w,b,I.args,I.argsType,f):this._requestJSONArgs(u,w,b,I.args,f)}static _requestJSONArgs(u,w,b,I,f){const _=i.VSBuffer.fromString(b),F=i.VSBuffer.fromString(I);let U=0;U+=d.sizeUInt8(),U+=d.sizeShortString(_),U+=d.sizeLongString(F);let z=d.alloc(f?2:1,u,U);return z.writeUInt8(w),z.writeShortString(_),z.writeLongString(F),z.buffer}static deserializeRequestJSONArgs(u){const w=u.readUInt8(),b=u.readShortString(),I=u.readLongString();return{rpcId:w,method:b,args:JSON.parse(I)}}static _requestMixedArgs(u,w,b,I,f,_){const F=i.VSBuffer.fromString(b);let U=0;U+=d.sizeUInt8(),U+=d.sizeShortString(F),U+=d.sizeMixedArray(I,f);let z=d.alloc(_?4:3,u,U);return z.writeUInt8(w),z.writeShortString(F),z.writeMixedArray(I,f),z.buffer}static deserializeRequestMixedArgs(u){const w=u.readUInt8(),b=u.readShortString(),I=u.readMixedArray(),f=new Array(I.length);for(let _=0,F=I.length;_<F;_++){const U=I[_];typeof U=="string"?f[_]=JSON.parse(U):f[_]=U}return{rpcId:w,method:b,args:f}}static serializeAcknowledged(u){return d.alloc(5,u,0).buffer}static serializeCancel(u){return d.alloc(6,u,0).buffer}static serializeReplyOK(u,w,b){return typeof w=="undefined"?this._serializeReplyOKEmpty(u):w instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(u,w):this._serializeReplyOKJSON(u,h(w,b))}static _serializeReplyOKEmpty(u){return d.alloc(7,u,0).buffer}static _serializeReplyOKVSBuffer(u,w){let b=0;b+=d.sizeVSBuffer(w);let I=d.alloc(8,u,b);return I.writeVSBuffer(w),I.buffer}static deserializeReplyOKVSBuffer(u){return u.readVSBuffer()}static _serializeReplyOKJSON(u,w){const b=i.VSBuffer.fromString(w);let I=0;I+=d.sizeLongString(b);let f=d.alloc(9,u,I);return f.writeLongString(b),f.buffer}static deserializeReplyOKJSON(u){const w=u.readLongString();return JSON.parse(w)}static serializeReplyErr(u,w){return w?this._serializeReplyErrEror(u,w):this._serializeReplyErrEmpty(u)}static _serializeReplyErrEror(u,w){const b=i.VSBuffer.fromString(h(D.transformErrorForSerialization(w),null));let I=0;I+=d.sizeLongString(b);let f=d.alloc(10,u,I);return f.writeLongString(b),f.buffer}static deserializeReplyErrError(u){const w=u.readLongString();return JSON.parse(w)}static _serializeReplyErrEmpty(u){return d.alloc(11,u,0).buffer}}var n;(function(s){s[s.RequestJSONArgs=1]="RequestJSONArgs",s[s.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",s[s.RequestMixedArgs=3]="RequestMixedArgs",s[s.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",s[s.Acknowledged=5]="Acknowledged",s[s.Cancel=6]="Cancel",s[s.ReplyOKEmpty=7]="ReplyOKEmpty",s[s.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",s[s.ReplyOKJSON=9]="ReplyOKJSON",s[s.ReplyErrError=10]="ReplyErrError",s[s.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var a;(function(s){s[s.String=1]="String",s[s.VSBuffer=2]="VSBuffer",s[s.Undefined=3]="Undefined"})(a||(a={}))}),define(ve[215],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const v=function(A){const y=C=>{self.removeEventListener("message",y);const S=C.data;Object.defineProperties(self,{postMessage:{value(k,i){S.postMessage(k,i)}},onmessage:{get(){return S.onmessage},set(k){S.onmessage=k}}}),S.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",y)}.toString();class T extends EventTarget{constructor(A,y,C){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${v})('${y}'))`,k=new Blob([S],{type:"application/javascript"}),i=URL.createObjectURL(k),P=new MessageChannel,h=i,g={type:"_newWorker",id:h,port:P.port2,url:i,options:C};A(g,[P.port2]),this.postMessage=P.port1.postMessage.bind(P.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:h};P.port1.postMessage(r),URL.revokeObjectURL(i),P.port1.close(),P.port2.close()},Object.defineProperties(this,{onmessage:{get(){return P.port1.onmessage},set(r){P.port1.onmessage=r}},onmessageerror:{get(){return P.port1.onmessageerror},set(r){P.port1.onmessageerror=r}}}),P.port1.addEventListener("messageerror",r=>{const o=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(o)}),P.port1.addEventListener("message",r=>{const o=new MessageEvent("message",{data:r.data});this.dispatchEvent(o)}),P.port1.start()}}e.NestedWorker=T}),define(ve[216],we([0,1,4]),function(Y,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,v.createDecorator)("remoteAgentService")}),define(ve[217],we([0,1,19,14,21,2,4,216]),function(Y,e,v,T,D,A,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let S=class{constructor(i,P){this.localUserHome=i,this.remoteAgentService=P,this.resolveOS=(async()=>{const h=await this.remoteAgentService.getEnvironment();return(h==null?void 0:h.os)||D.OS})(),this.resolveUserHome=(async()=>{const h=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(h==null?void 0:h.userHome)||i})()}async userHome(i){return(i==null?void 0:i.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?T.win32:T.posix)}async fileURI(i){let P="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const g=i.indexOf("/",2);g===-1?(P=i.substring(2),i="/"):(P=i.substring(2,g),i=i.substring(g)||"/")}return A.URI.from({scheme:v.Schemas.file,authority:P,path:i,query:"",fragment:""})}};S=je([qe(1,C.IRemoteAgentService)],S),e.AbstractPathService=S}),define(ve[103],we([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class v{constructor(y,C){this.line=y,this.character=C}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,C){return new v(0,0)}with(y){return new v(0,0)}}e.Position=v;class T{constructor(y,C,S,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(y,C),this.end=new v(S,k)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new T(0,0,0,0)}with(y){return new T(0,0,0,0)}}e.Range=T;var D;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ve[41],we([0,1,13,28,23,37,8,4,14,12,103]),function(Y,e,v,T,D,A,y,C,S,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const P="\u27EA ",h=" characters skipped \u27EB",g=(P.length+h.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var r;(function(R){R[R.file=0]="file",R[R.text=1]="text"})(r=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(R){R[R.File=1]="File",R[R.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function p(R){return!!R.preview}e.resultIsMatch=p;function m(R){return!!R.resource}e.isFileMatch=m;function E(R){return!!R.message}e.isProgressMessage=E;var l;(function(R){R[R.Normal=0]="Normal",R[R.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class c{constructor(L){this.resource=L,this.results=[]}}e.FileMatch=c;class d{constructor(L,M,$){this.ranges=M;const G=Array.isArray(M)?M:[M];if($&&$.matchLines===1&&t(G)){L=(0,y.getNLines)(L,$.matchLines);let J="",te=0,me=0;const Le=Math.floor($.charsPerLine/5),We=[];for(const Fe of G){const ze=Math.max(Fe.startColumn-Le,0),W=Fe.startColumn+$.charsPerLine;if(ze>me+Le+g){const q=P+(ze-me)+h;J+=q+L.slice(ze,W),te+=ze-(me+q.length)}else J+=L.slice(me,W);We.push(new a(0,Fe.startColumn-te,Fe.endColumn-te)),me=W}this.preview={text:J,matches:Array.isArray(this.ranges)?We:We[0]}}else{const J=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:L,matches:(0,v.mapArrayOrNot)(M,te=>new n(te.startLineNumber-J,te.startColumn,te.endLineNumber-J,te.endColumn))}}}}e.TextSearchMatch=d;function t(R){const L=R[0].startLineNumber;for(const M of R)if(M.startLineNumber!==L||M.endLineNumber!==L)return!1;return!0}class n{constructor(L,M,$,G){this.startLineNumber=L,this.startColumn=M,this.endLineNumber=$,this.endColumn=G}}e.SearchRange=n;class a extends n{constructor(L,M,$){super(L,M,L,$)}}e.OneLineRange=a;var s;(function(R){R.Default="default",R.FileNames="fileNames",R.Type="type",R.Modified="modified",R.CountDescending="countDescending",R.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function u(R,L=!0){const M=R&&R.files&&R.files.exclude,$=L&&R&&R.search&&R.search.exclude;if(!(!M&&!$)){if(!M||!$)return M||$;let G=Object.create(null);return G=D.mixin(G,D.deepClone(M)),G=D.mixin(G,D.deepClone($),!0),G}}e.getExcludes=u;function w(R,L){return R.excludePattern&&T.match(R.excludePattern,L)?!1:R.includePattern||R.usingSearchPaths?R.includePattern&&T.match(R.includePattern,L)?!0:R.usingSearchPaths?!!R.folderQueries&&R.folderQueries.some(M=>{const $=M.folder.fsPath;if(A.isEqualOrParent(L,$)){const G=S.relative($,L);return!M.includePattern||!!T.match(M.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=w;var b;(function(R){R[R.unknownEncoding=1]="unknownEncoding",R[R.regexParseError=2]="regexParseError",R[R.globParseError=3]="globParseError",R[R.invalidLiteral=4]="invalidLiteral",R[R.rgProcessError=5]="rgProcessError",R[R.other=6]="other",R[R.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class I extends Error{constructor(L,M){super(L);this.code=M}}e.SearchError=I;function f(R){const L=R.message;if((0,k.isPromiseCanceledError)(R))return new I(L,b.canceled);try{const M=JSON.parse(L);return new I(M.message,M.code)}catch(M){return new I(L,b.other)}}e.deserializeSearchError=f;function _(R){const L={message:R.message,code:R.code};return new Error(JSON.stringify(L))}e.serializeSearchError=_;function F(R){return R.type==="error"?!0:R.type==="success"}e.isSerializedSearchComplete=F;function U(R){return R.type==="success"}e.isSerializedSearchSuccess=U;function z(R){return!!R.path}e.isSerializedFileMatch=z;function he(R,L){const M=R.searchPath?R.searchPath:R.relativePath;return(0,y.fuzzyContains)(M,L)}e.isFilePatternMatch=he;class de{constructor(L){this.path=L,this.results=[]}addMatch(L){this.results.push(L)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=de;function x(R,L){const M=Object.assign(Object.assign({},R||{}),L||{});return Object.keys(M).filter($=>{const G=M[$];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=x;class j{constructor(L,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},L.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=T.parse(this._excludeExpression);let $=L.includePattern;M.includePattern&&($?$=Object.assign(Object.assign({},$),M.includePattern):$=M.includePattern),$&&(this._parsedIncludeExpression=T.parse($))}includedInQuerySync(L,M,$){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(L,M,$)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(L,M,$))}includedInQuery(L,M,$){return Promise.resolve(this._parsedExcludeExpression(L,M,$)).then(J=>!!J).then(J=>J?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(L,M,$)).then(te=>!!te):Promise.resolve(!0)).then(J=>J)}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=j;function H(R){for(const L in R)if(typeof R[L]!="boolean")return!0;return!1}}),define(ve[30],we([0,1,13,11,20,3,22,19,82,25,8,10,2,138,4,16,153,48,49,27,15,7,41,5]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h,g,r,o,p,m,E,l,c,d,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(F,U,z){return new k.ExtUri(he=>b(he,z)).isEqual(F,U)}function s(F,U,z){return a(F.uri,U.uri,z)?0:(0,i.compare)(F.uri.toString(),U.uri.toString())}function u(F,U,z){return F.index!==U.index?F.index<U.index?-1:1:a(F.uri,U.uri,z)?(0,i.compare)(F.name,U.name):(0,i.compare)(F.uri.toString(),U.uri.toString())}function w(F,U,z,he){const de=F.slice(0).sort((j,H)=>z(j,H,he)),x=U.slice(0).sort((j,H)=>z(j,H,he));return(0,v.delta)(de,x,(j,H)=>z(j,H,he))}function b(F,U){const z=U.getCapabilities(F.scheme);return!(z&&z&1024)}class I extends m.Workspace{constructor(U,z,he,de,x,j){super(U,he.map(H=>new m.WorkspaceFolder(H)),de,j);this._name=z,this._isUntitled=x,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(j),he.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}static toExtHostWorkspace(U,z,he,de){if(!U)return{workspace:null,added:[],removed:[]};const{id:x,name:j,folders:H,configuration:R,isUntitled:L}=U,M=[],$=z;z?H.forEach((me,Le)=>{const We=h.URI.revive(me.uri),Fe=I._findFolder(he||z,We,de);Fe?(Fe.name=me.name,Fe.index=me.index,M.push(Fe)):M.push({uri:We,name:me.name,index:Le})}):M.push(...H.map(({uri:me,name:Le,index:We})=>({uri:h.URI.revive(me),name:Le,index:We}))),M.sort((me,Le)=>me.index<Le.index?-1:1);const G=new I(x,j,M,R?h.URI.revive(R):null,!!L,me=>b(me,de)),{added:J,removed:te}=w($?$.workspaceFolders:[],G.workspaceFolders,s,de);return{workspace:G,added:J,removed:te}}static _findFolder(U,z,he){for(let de=0;de<U.folders.length;de++){const x=U.workspaceFolders[de];if(a(x.uri,z,he))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(U,z){return z&&this._structure.get(U)&&(U=(0,k.dirname)(U)),this._structure.findSubstr(U)}resolveWorkspaceFolder(U){return this._structure.get(U)}}let f=class{constructor(U,z,he,de){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=de,this._extHostFileSystemInfo=he,this._requestIdProvider=new S.Counter,this._barrier=new T.Barrier,this._proxy=U.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=U.getProxy(n.MainContext.MainThreadMessageService);const x=z.workspace;this._confirmedWorkspace=x?new I(x.id,x.name,[],x.configuration?h.URI.revive(x.configuration):null,!!x.isUntitled,j=>b(j,he)):void 0}$initializeWorkspace(U,z){this._trusted=z,this.$acceptWorkspaceData(U),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?h.URI.from({scheme:C.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(U,z,he,...de){const x=[];if(Array.isArray(de)&&de.forEach(M=>{h.URI.isUri(M.uri)&&!x.some($=>a($.uri,M.uri,this._extHostFileSystemInfo))&&x.push({uri:M.uri,name:M.name||(0,k.basenameOrAuthority)(M.uri)})}),this._unconfirmedWorkspace||[z,he].some(M=>typeof M!="number"||M<0)||he===0&&x.length===0)return!1;const j=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(z+he>j.length)return!1;const H=j.slice(0);H.splice(z,he,...x.map(M=>({uri:M.uri,name:M.name||(0,k.basenameOrAuthority)(M.uri),index:void 0})));for(let M=0;M<H.length;M++){const $=H[M];if(H.some((G,J)=>J!==M&&a($.uri,G.uri,this._extHostFileSystemInfo)))return!1}H.forEach((M,$)=>M.index=$);const{added:R,removed:L}=w(j,H,u,this._extHostFileSystemInfo);if(R.length===0&&L.length===0)return!1;if(this._proxy){const M=U.displayName||U.name;this._proxy.$updateWorkspaceFolders(M,z,he,x).then(void 0,$=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,g.localize)(0,null,M,$.toString()),{extension:U},[])})}return this.trySetWorkspaceFolders(H),!0}getWorkspaceFolder(U,z){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(U,z)}async getWorkspaceFolder2(U,z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(U,z)}async resolveWorkspaceFolder(U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(U)}getPath(){if(!!this._actualWorkspace){const{folders:U}=this._actualWorkspace;if(U.length!==0)return U[0].uri.fsPath}}getRelativePath(U,z){let he,de="";if(typeof U=="string"?(he=h.URI.file(U),de=U):typeof U!="undefined"&&(he=U,de=U.fsPath),!he)return de;const x=this.getWorkspaceFolder(he,!0);if(!x)return de;typeof z=="undefined"&&this._actualWorkspace&&(z=this._actualWorkspace.folders.length>1);let j=(0,k.relativePath)(x.uri,he);return z&&x.name&&(j=`${x.name}/${j}`),j}trySetWorkspaceFolders(U){this._actualWorkspace&&(this._unconfirmedWorkspace=I.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:U,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(U){const{workspace:z,added:he,removed:de}=I.toExtHostWorkspace(U,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=z||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:he,removed:de}))}findFiles(U,z,he,de,x=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${de.value}, entryPoint: findFiles`);let j;if(z===null?j=!1:z&&(typeof z=="string"?j=z:j=z.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:H,folder:R}=_(U);return this._proxy.$startFileSearch((0,P.withUndefinedAsNull)(H),(0,P.withUndefinedAsNull)(R),(0,P.withUndefinedAsNull)(j),(0,P.withUndefinedAsNull)(he),x).then(L=>Array.isArray(L)?L.map(M=>h.URI.revive(M)):[])}async findTextInFiles(U,z,he,de,x=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${de.value}, entryPoint: findTextInFiles`);const j=this._requestIdProvider.getNext(),H=typeof z.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:R,folder:L}=_(z.include),M=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,$={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:H,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:R,excludePattern:M},G=!1;if(this._activeSearchCallbacks[j]=J=>{if(!G){const te=h.URI.revive(J.resource);J.results.forEach(me=>{(0,t.resultIsMatch)(me)?he({uri:te,preview:{text:me.preview.text,matches:(0,v.mapArrayOrNot)(me.preview.matches,Le=>new d.Range(Le.startLineNumber,Le.startColumn,Le.endLineNumber,Le.endColumn))},ranges:(0,v.mapArrayOrNot)(me.ranges,Le=>new d.Range(Le.startLineNumber,Le.startColumn,Le.endLineNumber,Le.endColumn))}):he({uri:te,text:me.text,lineNumber:me.lineNumber})})}},x.isCancellationRequested)return{};try{const J=await this._proxy.$startTextSearch(U,(0,P.withUndefinedAsNull)(L),$,j,x);return delete this._activeSearchCallbacks[j],J||{}}catch(J){throw delete this._activeSearchCallbacks[j],J}}$handleTextSearchResult(U,z){this._activeSearchCallbacks[z]&&this._activeSearchCallbacks[z](U)}saveAll(U){return this._proxy.$saveAll(U)}resolveProxy(U){return this._proxy.$resolveProxy(U)}get trusted(){return this._trusted}requestWorkspaceTrust(U){return this._proxy.$requestWorkspaceTrust(U)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};f=je([qe(0,c.IExtHostRpcService),qe(1,l.IExtHostInitDataService),qe(2,E.IExtHostFileSystemInfo),qe(3,o.ILogService)],f),e.ExtHostWorkspace=f,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function _(F){let U,z;return F&&(typeof F=="string"?U=F:(U=F.pattern,z=F.baseFolder||h.URI.file(F.base))),{includePattern:U,folder:z}}}),define(ve[34],we([0,1,23,3,30,5,7,155,66,10,11,4,15,16,2]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function o(n,a){if(a){const s=a.split(".");let u=n;for(let w=0;u&&w<s.length;w++)u=u[s[w]];return u}}function p(n){return n instanceof r.URI}function m(n){return n&&n.uri instanceof r.URI&&n.languageId&&typeof n.languageId=="string"}function E(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function l(n){return n&&n.uri instanceof r.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function c(n){if(p(n))return{resource:n};if(m(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(E(n))return{overrideIdentifier:n.languageId};if(l(n))return{resource:n.uri};if(n===null)return{resource:null}}let d=class{constructor(a,s,u){this._proxy=a.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=u,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(a=>this._actual)}$initializeConfiguration(a){this._actual=new t(this._proxy,this._extHostWorkspace,a,this._logService),this._barrier.open()}$acceptConfigurationChanged(a,s){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(a,s))}};d=je([qe(0,h.IExtHostRpcService),qe(1,D.IExtHostWorkspace),qe(2,g.ILogService)],d),e.ExtHostConfiguration=d;class t{constructor(a,s,u,w){this._onDidChangeConfiguration=new T.Emitter,this._proxy=a,this._logService=w,this._extHostWorkspace=s,this._configuration=C.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(a,s){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,u))}getConfiguration(a,s,u){const w=c(s)||{},b=this._toReadonlyValue(a?o(this._configuration.getValue(void 0,w,this._extHostWorkspace.workspace),a):this._configuration.getValue(void 0,w,this._extHostWorkspace.workspace));a&&this._validateConfigurationAccess(a,w,u==null?void 0:u.identifier);function I(_){if(_==null)return null;if(typeof _=="boolean")return _?1:4;switch(_){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const f={has(_){return typeof o(b,_)!="undefined"},get:(_,F)=>{this._validateConfigurationAccess(a?`${a}.${_}`:_,w,u==null?void 0:u.identifier);let U=o(b,_);if(typeof U=="undefined")U=F;else{let z;const he=(de,x)=>{let j;const H=()=>{z=z||(0,v.deepClone)(b),j=j||o(z,x)};return(0,k.isObject)(de)?new Proxy(de,{get:(R,L)=>{if(typeof L=="string"&&L.toLowerCase()==="tojson")return H(),()=>j;if(z)return j=j||o(z,x),j[L];const M=R[L];return typeof L=="string"?he(M,`${x}.${L}`):M},set:(R,L,M)=>(H(),j&&(j[L]=M),!0),deleteProperty:(R,L)=>(H(),j&&delete j[L],!0),defineProperty:(R,L,M)=>(H(),j&&Object.defineProperty(j,L,M),!0)}):de};U=he(U,_)}return U},update:(_,F,U,z)=>{_=a?`${a}.${_}`:_;const he=I(U);return F!==void 0?this._proxy.$updateConfigurationOption(he,_,F,w,z):this._proxy.$removeConfigurationOption(he,_,w,z)},inspect:_=>{var F,U,z,he,de,x,j,H;_=a?`${a}.${_}`:_;const R=(0,v.deepClone)(this._configuration.inspect(_,w,this._extHostWorkspace.workspace));if(R)return{key:_,defaultValue:(F=R.default)===null||F===void 0?void 0:F.value,globalValue:(U=R.user)===null||U===void 0?void 0:U.value,workspaceValue:(z=R.workspace)===null||z===void 0?void 0:z.value,workspaceFolderValue:(he=R.workspaceFolder)===null||he===void 0?void 0:he.value,defaultLanguageValue:(de=R.default)===null||de===void 0?void 0:de.override,globalLanguageValue:(x=R.user)===null||x===void 0?void 0:x.override,workspaceLanguageValue:(j=R.workspace)===null||j===void 0?void 0:j.override,workspaceFolderLanguageValue:(H=R.workspaceFolder)===null||H===void 0?void 0:H.override,languageIds:R.overrideIdentifiers}}};return typeof b=="object"&&(0,v.mixin)(f,b,!1),Object.freeze(f)}_toReadonlyValue(a){const s=u=>(0,k.isObject)(u)?new Proxy(u,{get:(w,b)=>s(w[b]),set:(w,b,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(w,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(w,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:w=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return s(a)}_validateConfigurationAccess(a,s,u){const w=S.OVERRIDE_PROPERTY_PATTERN.test(a)?4:this._configurationScopes.get(a),b=u?`[${u.value}] `:"";if(w===4){typeof(s==null?void 0:s.resource)=="undefined"&&this._logService.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(w===3){(s==null?void 0:s.resource)&&this._logService.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(a,s){const u=new C.ConfigurationChangeEvent(a,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(w,b)=>u.affectsConfiguration(w,c(b))})}_toMap(a){return a.reduce((s,u)=>(s.set(u[0],u[1]),s),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(Y,e,v,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Y,v):D?D.value=v:e.set(Y,v),v},Ue=this&&this.__classPrivateFieldGet||function(Y,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!T:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(Y):T?T.value:e.get(Y)};define(ve[104],we([0,1,2,11,3,5,7,30,39,34,20,40,15,27,4,19,21,16,76,171,12]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h,g,r,o,p,m,E,l,c){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(de){function x(H){if(H!=null)return H}de.from=x;function j(H){if(H!=null)return H}de.to=j})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(de){function x(H){if(H!=null)return H}de.from=x;function j(H){if(H!=null)return H}de.to=j})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var a;(function(de){function x(H){if(H!=null)return H}de.from=x;function j(H){if(H!=null)return H}de.to=j})(a=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(de){function x(R){if(R){const L=R;return L&&!!L.process}else return!1}de.is=x;function j(R){if(R!=null){const L={process:R.process,args:R.args};return R.options&&(L.options=a.from(R.options)),L}}de.from=j;function H(R){if(R!=null)return new y.ProcessExecution(R.process,R.args,R.options)}de.to=H})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function(de){function x(H){if(H!=null)return H}de.from=x;function j(H){if(H!=null)return H}de.to=j})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var w;(function(de){function x(R){if(R){const L=R;return L&&(!!L.commandLine||!!L.command)}else return!1}de.is=x;function j(R){if(R!=null){const L={};return R.commandLine!==void 0?L.commandLine=R.commandLine:(L.command=R.command,L.args=R.args),R.options&&(L.options=u.from(R.options)),L}}de.from=j;function H(R){if(!(R==null||R.command===void 0&&R.commandLine===void 0))return R.commandLine?new y.ShellExecution(R.commandLine,R.options):new y.ShellExecution(R.command,R.args?R.args:[],R.options)}de.to=H})(w=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var b;(function(de){function x(R){if(R){let L=R;return L&&L.customExecution==="customExecution"}else return!1}de.is=x;function j(R){return{customExecution:"customExecution"}}de.from=j;function H(R,L){return L.get(R)}de.to=H})(b=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var I;(function(de){function x(j,H){let R;return j.scope!==void 0&&typeof j.scope!="number"?R=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===y.TaskScope.Workspace&&H&&H.workspaceFile?R=H.workspaceFile:R=l.USER_TASKS_GROUP_KEY),{id:j._id,workspaceFolder:R}}de.from=x})(I=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(de){function x(R,L){if(R==null)return[];const M=[];for(let $ of R){const G=j($,L);G&&M.push(G)}return M}de.fromMany=x;function j(R,L){if(R!=null){let M;R.execution instanceof y.ProcessExecution?M=s.from(R.execution):R.execution instanceof y.ShellExecution?M=w.from(R.execution):R.execution&&R.execution instanceof y.CustomExecution&&(M=b.from(R.execution));const $=t.from(R.definition);let G;if(R.scope?typeof R.scope=="number"?G=R.scope:G=R.scope.uri:G=y.TaskScope.Workspace,!(!$||!G)){const J=R.group?R.group.id:void 0;return{_id:R._id,definition:$,name:R.name,source:{extensionId:L.identifier.value,label:R.source,scope:G},execution:M,isBackground:R.isBackground,group:J,presentationOptions:n.from(R.presentationOptions),problemMatchers:R.problemMatchers,hasDefinedMatchers:R.hasDefinedMatchers,runOptions:R.runOptions?R.runOptions:{reevaluateOnRerun:!0},detail:R.detail}}}}de.from=j;async function H(R,L,M){if(R!=null){let $;s.is(R.execution)?$=s.to(R.execution):w.is(R.execution)?$=w.to(R.execution):b.is(R.execution)&&($=b.to(R._id,M));const G=t.to(R.definition);let J;if(R.source&&(R.source.scope!==void 0?typeof R.source.scope=="number"?J=R.source.scope:J=await L.resolveWorkspaceFolder(v.URI.revive(R.source.scope)):J=y.TaskScope.Workspace),!(!G||!J)){const te=new y.Task(G,J,R.name,R.source.label,$,R.problemMatchers);return R.isBackground!==void 0&&(te.isBackground=R.isBackground),R.group!==void 0&&(te.group=y.TaskGroup.from(R.group)),R.presentationOptions&&(te.presentationOptions=n.to(R.presentationOptions)),R._id&&(te._id=R._id),R.detail&&(te.detail=R.detail),te}}}de.to=H})(f=e.TaskDTO||(e.TaskDTO={}));var _;(function(de){function x(H){return H}de.from=x;function j(H){if(!!H)return Object.assign(Object.create(null),H)}de.to=j})(_=e.TaskFilterDTO||(e.TaskFilterDTO={}));class F{constructor(x,j,H){this._id=j,this._task=H,d.set(this,void 0),it(this,d,x,"f")}get task(){return this._task}terminate(){Ue(this,d,"f").terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}d=new WeakMap;var U;(function(de){function x(j){return{id:j._id,task:void 0}}de.from=x})(U=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let z=class{constructor(x,j,H,R,L,M,$,G){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=x.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=R,this._configurationService=L,this._terminalService=M,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=$,this._deprecationService=G,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(x,j,H){if(!H)return new y.Disposable(()=>{});const R=this.nextHandle();return this._handlers.set(R,{type:j,provider:H,extension:x}),this._proxy.$registerTaskProvider(R,j),new y.Disposable(()=>{this._handlers.delete(R),this._proxy.$unregisterTaskProvider(R)})}registerTaskSystem(x,j){this._proxy.$registerTaskSystem(x,j)}fetchTasks(x){return this._proxy.$fetchTasks(_.from(x)).then(async j=>{const H=[];for(let R of j){const L=await f.to(R,this._workspaceProvider,this._providedCustomExecutions2);L&&H.push(L)}return H})}get taskExecutions(){const x=[];return this._taskExecutions.forEach(j=>x.push(j)),x}terminateTask(x){if(!(x instanceof F))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(x._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(x,j,H){const R=this._providedCustomExecutions2.get(x.id);if(R){if(this._activeCustomExecutions2.get(x.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(x.id,R),this._terminalService.attachPtyToTerminal(j,await R.callback(H))}this._lastStartedTask=x.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(x)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(x){const j=await this.getTaskExecution(x);this._taskExecutionPromises.delete(x.id),this._taskExecutions.delete(x.id),this.customExecutionComplete(x),this._onDidTerminateTask.fire({execution:j})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(x){const j=await this.getTaskExecution(x.id);this._onDidTaskProcessStarted.fire({execution:j,processId:x.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(x){const j=await this.getTaskExecution(x.id);this._onDidTaskProcessEnded.fire({execution:j,exitCode:x.exitCode})}$provideTasks(x,j){const H=this._handlers.get(x);if(!H)return Promise.reject(new Error("no handler found"));const R=[],L=(0,T.asPromise)(()=>H.provider.provideTasks(i.CancellationToken.None)).then(M=>this.provideTasksInternal(j,R,H,M));return new Promise(M=>{L.then($=>{Promise.all(R).then(()=>{M($)})})})}async $resolveTask(x,j){const H=this._handlers.get(x);if(!H)return Promise.reject(new Error("no handler found"));if(j.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${H.type}].`);const R=await f.to(j,this._workspaceProvider,this._providedCustomExecutions2);if(!R)throw new Error("Unexpected: Task cannot be resolved.");const L=await H.provider.resolveTask(R,i.CancellationToken.None);if(!!L){this.checkDeprecation(L,H);const M=f.from(L,H.extension);if(!M)throw new Error("Unexpected: Task cannot be resolved.");if(L.definition!==R.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return b.is(M.execution)&&await this.addCustomExecution(M,L,!0),await this.resolveTaskInternal(M)}}nextHandle(){return this._handleCounter++}async addCustomExecution(x,j,H){const R=await this._proxy.$createTaskId(x);!H&&!this._providedCustomExecutions2.has(R)&&this._notProvidedCustomExecutions.add(R),this._providedCustomExecutions2.set(R,j.execution)}async getTaskExecution(x,j){if(typeof x=="string"){const L=this._taskExecutionPromises.get(x);if(!L)throw new Error("Unexpected: The specified task is missing an execution");return L}let H=this._taskExecutionPromises.get(x.id);if(H)return H;const R=new Promise(async(L,M)=>{const $=j||await f.to(x.task,this._workspaceProvider,this._providedCustomExecutions2);$?L(new F(this,x.id,$)):M("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(x.id,R),R.then(L=>(this._taskExecutions.set(x.id,L),L),L=>Promise.reject(L))}checkDeprecation(x,j){x._deprecated&&this._deprecationService.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(x){this._activeCustomExecutions2.get(x.id)&&this._activeCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.has(x.id)&&this._lastStartedTask!==x.id&&(this._providedCustomExecutions2.delete(x.id),this._notProvidedCustomExecutions.delete(x.id));let H=this._notProvidedCustomExecutions.values(),R=H.next();for(;!R.done;)!this._activeCustomExecutions2.has(R.value)&&this._lastStartedTask!==R.value&&(this._providedCustomExecutions2.delete(R.value),this._notProvidedCustomExecutions.delete(R.value)),R=H.next()}};z=je([qe(0,h.IExtHostRpcService),qe(1,g.IExtHostInitDataService),qe(2,C.IExtHostWorkspace),qe(3,S.IExtHostDocumentsAndEditors),qe(4,k.IExtHostConfiguration),qe(5,P.IExtHostTerminalService),qe(6,m.ILogService),qe(7,E.IExtHostApiDeprecationService)],z),e.ExtHostTaskBase=z;let he=class extends z{constructor(x,j,H,R,L,M,$,G){super(x,j,H,R,L,M,$,G);this.registerTaskSystem(o.Schemas.vscodeRemote,{scheme:o.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(x,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const H=f.from(j,x);if(H===void 0)throw new Error("Task is not valid");if(b.is(H.execution))await this.addCustomExecution(H,j,!1);else throw new c.NotSupportedError;const R=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),j);return this._proxy.$executeTask(H).catch(L=>{throw new Error(L)}),R}provideTasksInternal(x,j,H,R){const L=[];if(R)for(let M of R){this.checkDeprecation(M,H),(!M.definition||!x[M.definition.type])&&this._logService.warn(`The task [${M.source}, ${M.name}] uses an undefined task type. The task will be ignored in the future.`);const $=f.from(M,H.extension);$&&b.is($.execution)?(L.push($),j.push(this.addCustomExecution($,M,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:L,extension:H.extension}}async resolveTaskInternal(x){if(b.is(x.execution))return x;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(x,j){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(x,j,H){}};he=je([qe(0,h.IExtHostRpcService),qe(1,g.IExtHostInitDataService),qe(2,C.IExtHostWorkspace),qe(3,S.IExtHostDocumentsAndEditors),qe(4,k.IExtHostConfiguration),qe(5,P.IExtHostTerminalService),qe(6,m.ILogService),qe(7,E.IExtHostApiDeprecationService)],he),e.WorkerExtHostTask=he,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")});var it=this&&this.__classPrivateFieldSet||function(Y,e,v,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Y,v):D?D.value=v:e.set(Y,v),v},Ue=this&&this.__classPrivateFieldGet||function(Y,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!T:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(Y):T?T.value:e.get(Y)},Gt=this&&this.__rest||function(Y,e){var v={};for(var T in Y)Object.prototype.hasOwnProperty.call(Y,T)&&e.indexOf(T)<0&&(v[T]=Y[T]);if(Y!=null&&typeof Object.getOwnPropertySymbols=="function")for(var D=0,T=Object.getOwnPropertySymbols(Y);D<T.length;D++)e.indexOf(T[D])<0&&Object.prototype.propertyIsEnumerable.call(Y,T[D])&&(v[T[D]]=Y[T[D]]);return v};define(ve[218],we([0,1,13,11,24,20,3,53,43,6,23,10,2,31,5,39,15,70,9,7,30,182,97]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h,g,r,o,p,m,E,l,c,d,t){"use strict";var n,a,s,u;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const w=(H,R)=>`${H}:${R.toString()}`;let b=class{constructor(R,L,M){this.documents=L,this.workspace=M,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new d.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(r.MainContext.MainThreadTesting),this.runQueue=new I(this.proxy),this.workspaceObservers=new x(this.proxy),this.textDocumentObservers=new j(this.proxy,L)}registerTestController(R,L){const M=(0,g.generateUuid)();this.controllers.set(M,{instance:L,extensionId:R}),this.proxy.$registerTestController(M);const $=[...this.testControllers.keys()];return setTimeout(()=>{var G;for(const J of $)(G=this.testControllers.get(J))===null||G===void 0||G.subscribeFn(M,L)},0),new l.Disposable(()=>{this.controllers.delete(M),this.proxy.$unregisterTestController(M)})}createTextDocumentTestObserver(R){return this.textDocumentObservers.checkout(R.uri)}createWorkspaceTestObserver(R){return this.workspaceObservers.checkout(R.uri)}async runTests(R,L=A.CancellationToken.None){const M=$=>$.map(this.getInternalTestForReference,this).filter(P.isDefined).map(G=>({src:G.src,testId:G.item.extId}));await this.proxy.$runTests({exclude:R.exclude?M(R.exclude).map($=>$.testId):void 0,tests:M(R.tests),debug:R.debug},L)}createTestRun(R,L,M,$=!0){return this.runQueue.createTestRun(R,L,M,$)}$publishTestResults(R){this.results=Object.freeze(R.map(L=>(0,i.deepFreeze)(E.TestResults.to(L))).concat(this.results).sort((L,M)=>M.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(R,L){const M=h.URI.revive(L),$=w(R,M);if(!this.testControllers.has($)){const G=new A.CancellationTokenSource;let J;if(R===1){let Fe=this.documents.getDocument(M);if(!Fe){const ze=new k.DisposableStore;Fe=await new Promise(W=>{ze.add((0,T.disposableTimeout)(()=>W(void 0),5e3)),ze.add(this.documents.onDidAddDocuments(q=>{const ee=q.find(se=>se.document.uri.toString()===M.toString());ee&&W(ee)}))}).finally(()=>ze.dispose())}if(Fe){const ze=await this.workspace.getWorkspaceFolder2(M,!1);J=W=>W.createDocumentTestRoot?W.createDocumentTestRoot(Fe.document,G.token):(0,e.createDefaultDocumentTestRoot)(W,Fe.document,ze,G.token)}}else{const Fe=await this.workspace.getWorkspaceFolder2(M,!1);Fe&&(J=ze=>ze.createWorkspaceTestRoot(Fe,G.token))}if(!!J){const te=async(Fe,ze)=>{try{const W=await J(ze);W&&Le.addRoot(W,Fe)}catch(W){console.error(W)}},me=new k.DisposableStore,Le=me.add(this.ownedTests.createForHierarchy(Fe=>this.proxy.$publishDiff(R,L,Fe)));me.add((0,k.toDisposable)(()=>G.dispose(!0)));const We=[];for(const[Fe,ze]of this.controllers)We.push(te(Fe,ze.instance));Promise.all(We).then(()=>Le.pushDiff([3,-1])),this.testControllers.set($,{store:me,collection:Le,subscribeFn:te})}}}async $expandTest(R,L){const M=(0,v.mapFind)(this.testControllers.values(),$=>$.collection.treeId===R.src.tree?$:void 0);await(M==null?void 0:M.collection.expand(R.testId,L<0?Infinity:L)),this.flushCollectionDiffs()}$unsubscribeFromTests(R,L){var M;const $=h.URI.revive(L),G=w(R,$);(M=this.testControllers.get(G))===null||M===void 0||M.store.dispose(),this.testControllers.delete(G)}$acceptDiff(R,L,M){R===1?this.textDocumentObservers.acceptDiff(h.URI.revive(L),M):this.workspaceObservers.acceptDiff(h.URI.revive(L),M)}async $runTestsForProvider(R,L){const M=this.controllers.get(R.tests[0].src.controller);if(!!M){const $=R.tests.map(({testId:te,src:me})=>this.ownedTests.getTestById(te,me==null?void 0:me.tree)).filter(P.isDefined).map(([te,me])=>me),G=R.excludeExtIds.map(te=>this.ownedTests.getTestById(te)).filter(P.isDefined).filter(([te,me])=>$.some(Le=>te.comparePositions(Le,me)===1));if(!!$.length){const J={tests:$.map(te=>U.unwrap(te.actual)),exclude:G.map(([,te])=>U.unwrap(te.actual)),debug:R.debug};await this.runQueue.enqueueRun({dto:f.fromInternal(R),token:L,extensionId:M.extensionId,req:J,doRun:()=>M.instance.runTests(J,L)})}}}$lookupTest(R){const L=this.ownedTests.getTestById(R.testId);if(!L)return Promise.resolve(void 0);const M=L[1],{actual:$,discoverCts:G,expandLevels:J}=M,te=Gt(M,["actual","discoverCts","expandLevels"]);return Promise.resolve(te)}flushCollectionDiffs(){for(const{collection:R}of this.testControllers.values())R.flushDiff()}getInternalTestForReference(R){var L,M;return(M=(L=this.workspaceObservers.getMirroredTestDataByReference(R))!==null&&L!==void 0?L:(0,v.mapFind)(this.testControllers.values(),$=>$.collection.getTestByReference(R)))!==null&&M!==void 0?M:this.textDocumentObservers.getMirroredTestDataByReference(R)}};b=je([qe(0,p.IExtHostRpcService),qe(1,o.IExtHostDocumentsAndEditors),qe(2,c.IExtHostWorkspace)],b),e.ExtHostTesting=b;class I{constructor(R){this.proxy=R,this.state=new Map}enqueueRun(R){let L=this.state.get(R.extensionId);L||(L={queue:[],current:void 0},this.state.set(R.extensionId,L));const M=new T.DeferredPromise,$=()=>{const G=[],J=new Set;L.current={publicReq:R.req,factory:te=>{const me=new _(te,R.dto,J,this.proxy);return G.push(me),R.token.onCancellationRequested(()=>me.end()),me}},this.invokeRunner(R.extensionId,R.dto.id,R.doRun,G).finally(()=>M.complete())};return L.queue.push($),L.queue.length===1&&$(),M.p}createTestRun(R,L,M,$){var G,J;const te=this.state.get(R);if((te==null?void 0:te.current.publicReq)===L)return te.current.factory(M);const me=f.fromPublic(L),Le=new _(M,me,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:L.debug,exclude:(J=(G=L.exclude)===null||G===void 0?void 0:G.map(We=>We.id))!==null&&J!==void 0?J:[],id:me.id,tests:L.tests.map(We=>We.id),persist:$}),Le.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(me.id)),Le}invokeRunner(R,L,M,$){try{const G=M();return(0,T.isThenable)(G)?G.then(()=>this.handleInvokeResult(R,L,$,void 0)).catch(J=>this.handleInvokeResult(R,L,$,J)):this.handleInvokeResult(R,L,$,void 0)}catch(G){return this.handleInvokeResult(R,L,$,G)}}async handleInvokeResult(R,L,M,$){const G=this.state.get(R);!G||(G.queue.shift(),G.queue.length>0?G.queue[0]():this.state.delete(R),await Promise.all(M.map(J=>J.onEnd.wait())))}}class f{constructor(R,L,M){this.id=R,this.include=L,this.exclude=M}static fromPublic(R){var L,M;return new f((0,g.generateUuid)(),new Set(R.tests.map($=>$.id)),new Set((M=(L=R.exclude)===null||L===void 0?void 0:L.map($=>$.id))!==null&&M!==void 0?M:S.Iterable.empty()))}static fromInternal(R){return new f(R.runId,new Set(R.tests.map(L=>L.testId)),new Set(R.excludeExtIds))}isIncluded(R){for(let L=R;L;L=L.parent){if(this.include.has(L.id))return!0;if(this.exclude.has(L.id))return!1}return!0}}class _{constructor(R,L,M,$){this.name=R,n.set(this,void 0),a.set(this,void 0),s.set(this,(0,g.generateUuid)()),u.set(this,void 0),this.onEnd=new T.Barrier,it(this,n,$,"f"),it(this,a,L,"f"),it(this,u,M,"f"),$.$startedTestRunTask(L.id,{id:Ue(this,s,"f"),name:R,running:!0})}setState(R,L,M){Ue(this,a,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),Ue(this,n,"f").$updateTestStateInRun(Ue(this,a,"f").id,Ue(this,s,"f"),R.id,L,M))}appendMessage(R,L){Ue(this,a,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),Ue(this,n,"f").$appendTestMessageInRun(Ue(this,a,"f").id,Ue(this,s,"f"),R.id,E.TestMessage.from(L)))}appendOutput(R){Ue(this,n,"f").$appendOutputToRun(Ue(this,a,"f").id,Ue(this,s,"f"),D.VSBuffer.fromString(R))}end(){Ue(this,n,"f").$finishedTestRunTask(Ue(this,a,"f").id,Ue(this,s,"f")),this.onEnd.open()}ensureTestIsKnown(R){const L=Ue(this,u,"f");if(!L.has(R.id)){const M=[];for(;M.unshift(E.TestItem.from(R)),!(L.has(R.id)||(L.add(R.id),!R.parent));)R=R.parent;Ue(this,n,"f").$addTestsToRun(Ue(this,a,"f").id,M)}}}n=new WeakMap,a=new WeakMap,s=new WeakMap,u=new WeakMap;const F=async(H,R,L,M)=>{if(!!L){const $=await H.createWorkspaceTestRoot(L,M);if(!!$){M.onCancellationRequested(()=>{U.removeFilter(R)});const G=U.getWrapperForTestItem($,R);return G.refreshMatch(),G}}};e.createDefaultDocumentTestRoot=F;class U extends l.TestItemImpl{constructor(R,L,M){super(R.id,R.label,R.uri,void 0);if(this.actual=R,this.filterDocument=L,this.actualParent=M,!(R instanceof l.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${R.id} did not`);this.debuggable=R.debuggable,this.runnable=R.runnable,this.description=R.description,this.error=R.error,this.status=R.status,this.range=R.range,this.resolveHandler=R.resolveHandler;const $=(0,m.getPrivateApiFor)(this);(0,m.getPrivateApiFor)(R).bus.event(J=>{switch(J[0]){case 3:this[J[1]]=J[2];break;case 0:const te=U.getWrapperForTestItem(J[1],this.filterDocument,this);(0,m.getPrivateApiFor)(te).parent=R,te.refreshMatch();break;default:$.bus.fire(J)}})}static removeFilter(R){this.wrapperMap.delete(R)}static getWrapperForTestItem(R,L,M){let $=this.wrapperMap.get(L);if($==null?void 0:$.has(R))return $.get(R);$||($=new WeakMap,this.wrapperMap.set(L,$));const G=new U(R,L,M);return $.set(R,G),G}static unwrap(R){return R instanceof U?R.actual:R}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var R,L;const M=this._cachedMatchesFilter;for(const G of this.actual.children.values()){const J=U.getWrapperForTestItem(G,this.filterDocument,this);J.hasNodeMatchingFilter?this.children.has(J.id)||this.addChild(J):J.dispose()}const $=this.children.size>0||((R=this.actual.uri)===null||R===void 0?void 0:R.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=$,$!==M&&((L=this.actualParent)===null||L===void 0||L.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,m.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,m.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=U,U.wrapperMap=new WeakMap;class z extends t.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,E.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:L,removed:M}=this;return{get added(){return[...R].map($=>$.revived)},get updated(){return[...L].map($=>$.revived)},get removed(){return[...M].map($=>$.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class he extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(R){let L=[];for(const M of R){const $=this.items.get(M);$&&L.push($.revived)}return L}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,L){return Object.assign(Object.assign({},R),{revived:E.TestItem.toPlain(R.item),depth:L?L.depth+1:0,children:new Set})}createChangeCollector(){return new z(this.changeEmitter)}}e.MirroredTestCollection=he;class de{constructor(){this.resources=new Map}checkout(R){var L,M;const $=R.toString(),G=(L=this.resources.get($))!==null&&L!==void 0?L:this.createObserverData(R);return(M=G.pendingDeletion)===null||M===void 0||M.dispose(),G.observers++,{onDidChangeTest:G.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return G.tests.rootTestItems},dispose:(0,C.once)(()=>{--G.observers||(G.pendingDeletion=this.eventuallyDispose(R))})}}getMirroredTestDataByReference(R){for(const{tests:L}of this.resources.values()){const M=L.getMirroredTestDataByReference(R);if(M)return M}}eventuallyDispose(R){return(0,T.disposableTimeout)(()=>this.unlisten(R),10*1e3)}createObserverData(R){const L=new he,M=this.listen(R,G=>L.apply(G)),$={observers:0,tests:L,listener:M};return this.resources.set(R.toString(),$),$}unlisten(R){var L;const M=R.toString(),$=this.resources.get(M);$&&($.observers=-1,(L=$.pendingDeletion)===null||L===void 0||L.dispose(),$.listener.dispose(),this.resources.delete(M))}}class x extends de{constructor(R){super();this.proxy=R,this.diffListeners=new Map}acceptDiff(R,L){var M;(M=this.diffListeners.get(R.toString()))===null||M===void 0||M(L)}listen(R,L){this.proxy.$subscribeToDiffs(0,R);const M=R.toString();return this.diffListeners.set(M,L),new l.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,R),this.diffListeners.delete(M)})}}class j extends de{constructor(R,L){super();this.proxy=R,this.documents=L,this.diffListeners=new Map}acceptDiff(R,L){var M;(M=this.diffListeners.get(R.toString()))===null||M===void 0||M(L)}listen(R,L){if(!this.documents.getDocument(R))return new l.Disposable(()=>{});const $=R.toString();return this.diffListeners.set($,L),this.proxy.$subscribeToDiffs(1,R),new l.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,R),this.diffListeners.delete($)})}}}),define(ve[219],we([0,1,13,51,28,58,22,19,14,25,8,10,2,117,141,93,48,174,217,41]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h,g,r,o,p,m,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let c=class{constructor(I,f,_,F){this.configurationService=I,this.workspaceContextService=f,this.editorGroupsService=_,this.pathService=F}text(I,f,_={}){I=this.getContentPattern(I,_);const F=this.configurationService.getValue(),U=f&&f.some(he=>!this.configurationService.getValue({resource:he}).search.useRipgrep),z=this.commonQuery(f==null?void 0:f.map(p.toWorkspaceFolder),_);return Object.assign(Object.assign({},z),{type:2,contentPattern:I,previewOptions:_.previewOptions,maxFileSize:_.maxFileSize,usePCRE2:F.search.usePCRE2||U||!1,beforeContext:_.beforeContext,afterContext:_.afterContext,userDisabledExcludesAndIgnoreFiles:_.disregardExcludeSettings&&_.disregardIgnoreFiles})}getContentPattern(I,f){const _=this.configurationService.getValue();I.isRegExp&&(I.pattern=I.pattern.replace(/\r?\n/g,"\\n"));const F=Object.assign(Object.assign({},I),{wordSeparators:_.editor.wordSeparators});return this.isCaseSensitive(I,f)&&(F.isCaseSensitive=!0),this.isMultiline(I)&&(F.isMultiline=!0),F}file(I,f={}){const _=this.commonQuery(I,f);return Object.assign(Object.assign({},_),{type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey})}handleIncludeExclude(I,f){return I?(I=Array.isArray(I)?I.map(s):s(I),f?this.parseSearchPaths(I):{pattern:t(...Array.isArray(I)?I:[I])}):{}}commonQuery(I=[],f={}){const _=this.handleIncludeExclude(f.includePattern,f.expandPatterns),F=this.handleIncludeExclude(f.excludePattern,f.expandPatterns),U=I.length>1,z=(_.searchPaths&&_.searchPaths.length?_.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,f,F)):I.map(x=>this.getFolderQueryForRoot(x,f,F,U))).filter(x=>!!x),he={_reason:f._reason,folderQueries:z,usingSearchPaths:!!(_.searchPaths&&_.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:F.pattern,includePattern:_.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const j=v.coalesce(v.flatten(this.editorGroupsService.groups.map(R=>R.editors.map(L=>L.resource)))).filter(R=>(0,l.pathIncludedInQuery)(he,R.fsPath)),H=this.commonQueryFromFileList(j);return Object.assign(Object.assign({},he),H)}const de=f.extraFileResources&&f.extraFileResources.filter(x=>(0,l.pathIncludedInQuery)(he,x.fsPath));return he.extraFileResources=de&&de.length?de:void 0,he}commonQueryFromFileList(I){const f=[],_=new y.ResourceMap,F={};let U=!1;return I.forEach(z=>{var he,de;if(z.scheme!==C.Schemas.walkThrough)if((0,k.isAbsolutePath)(z)){const j=(de=(he=this.workspaceContextService.getWorkspaceFolder(z))===null||he===void 0?void 0:he.uri)!==null&&de!==void 0?de:z.with({path:S.dirname(z.fsPath)});let H=_.get(j);H||(U=!0,H={folder:j,includePattern:{}},f.push(H),_.set(j,H));const R=S.relative(j.fsPath,z.fsPath);(0,P.assertIsDefined)(H.includePattern)[R.replace(/\\/g,"/")]=!0}else z.fsPath&&(U=!0,F[z.fsPath]=!0)}),{folderQueries:f,includePattern:F,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}isCaseSensitive(I,f){if(f.isSmartCase){if(I.isRegExp){if(i.containsUppercaseCharacter(I.pattern,!0))return!0}else if(i.containsUppercaseCharacter(I.pattern))return!0}return!!I.isCaseSensitive}isMultiline(I){return I.isMultiline||I.isRegExp&&(0,g.isMultilineRegexSource)(I.pattern)||I.pattern.indexOf(`
`)>=0?!0:!!I.isMultiline}parseSearchPaths(I){const f=H=>S.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),F=(Array.isArray(I)?I:n(I)).map(H=>{const R=this.pathService.resolvedUserHome;return R?(0,A.untildify)(H,R.scheme===C.Schemas.file?R.fsPath:R.path):H}),U=T.groupBy(F,H=>f(H)?"searchPaths":"exprSegments"),z=(U.exprSegments||[]).map(H=>i.rtrim(H,"/")).map(H=>i.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),a(H))),he={},de=this.expandSearchPathPatterns(U.searchPaths||[]);de&&de.length&&(he.searchPaths=de);const x=v.flatten(z),j=t(...x);return j&&(he.pattern=j),he}getExcludesForFolder(I,f){return f.disregardExcludeSettings?void 0:(0,l.getExcludes)(I,!f.disregardSearchExcludeSettings)}expandSearchPathPatterns(I){if(!I||!I.length)return[];const f=v.flatten(I.map(F=>{let{pathPortion:U,globPortion:z}=d(F);z&&(z=u(z));const he=this.expandOneSearchPath(U);return v.flatten(he.map(de=>this.resolveOneSearchPathPattern(de,z)))})),_=new Map;return f.forEach(F=>{const U=F.searchPath.toString(),z=_.get(U);z?F.pattern&&(z.pattern=z.pattern||{},z.pattern[F.pattern]=!0):_.set(U,{searchPath:F.searchPath,pattern:F.pattern?t(F.pattern):void 0})}),Array.from(_.values())}expandOneSearchPath(I){if(S.isAbsolute(I)){const f=this.workspaceContextService.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==C.Schemas.file?[{searchPath:f[0].uri.with({path:I})}]:[{searchPath:h.URI.file(S.normalize(I))}]}if(this.workspaceContextService.getWorkbenchState()===2){const f=this.workspaceContextService.getWorkspace().folders[0].uri;if(I=s(I),I.startsWith("../")||I===".."){const F=S.posix.resolve(f.path,I);return[{searchPath:f.with({path:F})}]}const _=u(I);return[{searchPath:f,pattern:_}]}else{if(I==="./"||I===".\\")return[];{const f=I.replace(/^\.[\/\\]/,""),F=this.workspaceContextService.getWorkspace().folders.map(U=>{const z=f.match(new RegExp(`^${U.name}(?:/(.*))?`));return z?{match:z,folder:U}:null}).filter(P.isDefined);if(F.length)return F.map(U=>{const z=U.match[1];return{searchPath:U.folder.uri,pattern:z&&u(z)}});{const U=I.match(/\.[\/\\](.+)[\/\\]?/),z=U?U[1]:I,he=r.localize(0,null,z);throw new Error(he)}}}}resolveOneSearchPathPattern(I,f){const _=I.pattern&&f?`${I.pattern}/${f}`:I.pattern||f,F=[{searchPath:I.searchPath,pattern:_}];return _&&!_.endsWith("**")&&F.push({searchPath:I.searchPath,pattern:_+"/**"}),F}getFolderQueryForSearchPath(I,f,_){const F=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(I.searchPath),f,_,!1);return F?Object.assign(Object.assign({},F),{includePattern:I.pattern}):null}getFolderQueryForRoot(I,f,_,F){let U;const z=h.URI.isUri(I)?I:I.uri;if(_.searchPaths){const H=_.searchPaths.filter(R=>(0,k.isEqual)(R.searchPath,z))[0];if(H&&!H.pattern)return null;H&&(U=H.pattern)}const he=this.configurationService.getValue({resource:z}),de=this.getExcludesForFolder(he,f),x=Object.assign(Object.assign({},de||{}),U||{}),j=h.URI.isUri(I)?(0,k.basename)(I):I.name;return{folder:z,folderName:F?j:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:he.files&&he.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!he.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!he.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!he.search.followSymlinks}}};c=je([qe(0,o.IConfigurationService),qe(1,p.IWorkspaceContextService),qe(2,m.IEditorGroupsService),qe(3,E.IPathService)],c),e.QueryBuilder=c;function d(b){const I=b.match(/[\*\{\}\(\)\[\]\?]/);if(I){const f=I.index,_=b.substr(0,f).match(/[/|\\][^/\\]*$/);if(_){let F=b.substr(0,_.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:b.substr((_.index||0)+1)}}}return{pathPortion:b}}function t(...b){return b.length?b.reduce((I,f)=>(I[f]=!0,I),Object.create(null)):void 0}function n(b){return D.splitGlobAware(b,",").map(I=>I.trim()).filter(I=>!!I.length)}function a(b){return[`**/${b}/**`,`**/${b}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function s(b){return b.replace(/\\/g,"/")}function u(b){return s(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function w(b,I){b=v.distinct(b,F=>F.toString());const f=[],_=I.getWorkspace();return b&&b.forEach(F=>{let U;if(I.getWorkbenchState()===2)U=(0,k.relativePath)(_.folders[0].uri,F),U&&U!=="."&&(U="./"+U);else{const z=I.getWorkspaceFolder(F);if(z){const he=z.name;if(_.folders.filter(x=>x.name===he).length===1){const x=(0,k.relativePath)(z.uri,F);x===""?U=`./${z.name}`:U=`./${z.name}/${x}`}else U=F.fsPath}}U&&f.push(U)}),f}e.resolveResourcesForSearchIncludes=w}),define(ve[220],we([0,1,25,2,20,12,4,219,41,48]),function(Y,e,v,T,D,A,y,C,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function P(o,p){const m=p.activationEvents;if(!m)return Promise.resolve(void 0);const E=[],l=[];for(const s of m)if(/^workspaceContains:/.test(s)){const u=s.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||o.forceUsingSearch?l.push(u):E.push(u)}if(E.length===0&&l.length===0)return Promise.resolve(void 0);let c;const d=new Promise((s,u)=>{c=s}),t=s=>c({activationEvent:s}),n=Promise.all(E.map(s=>h(o,s,t))).then(()=>{}),a=g(o,p.identifier,l,t);return Promise.all([n,a]).then(()=>{c(void 0)}),d}e.checkActivateWorkspaceContainsExtension=P;async function h(o,p,m){for(const E of o.folders)if(await o.exists(v.joinPath(T.URI.revive(E),p))){m(`workspaceContains:${p}`);return}}async function g(o,p,m,E){if(m.length===0)return Promise.resolve(void 0);const l=new D.CancellationTokenSource,c=o.checkExists(o.folders,m,l.token),d=setTimeout(async()=>{l.cancel(),E(`workspaceContainsTimeout:${m.join(",")}`)},i);let t=!1;try{t=await c}catch(n){A.isPromiseCanceledError(n)||A.onUnexpectedError(n)}l.dispose(),clearTimeout(d),t&&E(`workspaceContains:${m.join(",")}`)}function r(o,p,m,E){const l=o.get(y.IInstantiationService),c=o.get(S.ISearchService),t=l.createInstance(C.QueryBuilder).file(p.map(n=>(0,k.toWorkspaceFolder)(T.URI.revive(n))),{_reason:"checkExists",includePattern:m,exists:!0});return c.fileSearch(t,E).then(n=>!!n.limitHit,n=>A.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=r});var it=this&&this.__classPrivateFieldSet||function(Y,e,v,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Y,v):D?D.value=v:e.set(Y,v),v},Ue=this&&this.__classPrivateFieldGet||function(Y,e,v,T){if(v==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!T:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?T:v==="a"?T.call(Y):T?T.value:e.get(Y)};define(ve[35],we([0,1,133,14,81,25,11,6,22,2,16,5,34,185,79,30,33,183,12,26,24,161,7,67,4,27,80,15,65,71,40,3,220,75,162]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h,g,r,o,p,m,E,l,c,d,t,n,a,s,u,w,b,I,f,_,F,U,z){"use strict";var he,de,x;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let j=class Ln extends C.Disposable{constructor(M,$,G,J,te,me,Le,We,Fe,ze){super();this._onDidChangeRemoteConnectionData=this._register(new _.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=$,this._extHostContext=G,this._initData=Le,this._extHostWorkspace=J,this._extHostConfiguration=te,this._logService=me,this._extHostTunnelService=Fe,this._extHostTerminalService=ze,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new m.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new U.ExtHostSecretState(this._extHostContext),this._storagePath=We,this._instaService=M.createChild(new b.ServiceCollection([r.IExtHostStorage,this._storage],[U.IExtHostSecretState,this._secretState]));const W=new Set;this._initData.hostExtensions.forEach(q=>W.add(l.ExtensionIdentifier.toKey(q))),this._activator=new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(q,ee,se)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(q,E.transformErrorForSerialization(ee),se)},actualActivateExtension:async(q,ee)=>{if(W.has(l.ExtensionIdentifier.toKey(q)))return await this._mainThreadExtensionsProxy.$activateExtension(q,ee),new g.HostExtension;const se=this._registry.getExtensionDescription(q);return this._activateExtension(se,ee)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){E.onUnexpectedError(M)}}async deactivateAll(){let M=[];try{M=this._registry.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this._deactivate(te))}catch($){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,$){return this._activator.activateByEvent(M,$)}_activateById(M,$){return this._activator.activateById(M,$)}activateByIdWithErrors(M,$){return this._activateById(M,$).then(()=>{const G=this._activator.getActivatedExtension(M);if(G.activationFailed)return Promise.reject(G.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=S.TernarySearchTree.forPaths(),$=this._registry.getAllExtensionDescriptions().map(G=>{if(!!this._getEntryPoint(G))return this._hostUtils.realpath(G.extensionLocation.fsPath).then(J=>M.set(k.URI.file(J).fsPath,G))});this._extensionPathIndex=Promise.all($).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let $=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return $;const G=this._activator.getActivatedExtension(M);if(!G)return $;try{typeof G.module.deactivate=="function"&&($=Promise.resolve(G.module.deactivate()).then(void 0,J=>Promise.resolve(void 0)))}catch(J){}try{(0,C.dispose)(G.subscriptions)}catch(J){}return $}async _activateExtension(M,$){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,$).then(G=>{const J=G.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,J.codeLoadingTime,J.activateCallTime,J.activateResolvedTime,$),this._logExtensionActivationTimes(M,$,"success",J),G},G=>{throw this._logExtensionActivationTimes(M,$,"failure"),G})}_logExtensionActivationTimes(M,$,G,J){const te=H(M,$);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},te),J||{}),{outcome:G}))}_doActivateExtension(M,$){const G=H(M,$);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",G);const J=this._getEntryPoint(M);if(!J)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify($)}`),this._logService.flush();const te=new g.ExtensionActivationTimesBuilder($.startup);return Promise.all([this._loadCommonJSModule(M.identifier,(0,A.joinPath)(M.extensionLocation,J),te),this._loadExtensionContext(M)]).then(me=>(D.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Ln._callActivate(this._logService,M.identifier,me[0],me[1],te))).then(me=>(D.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),me))}_loadExtensionContext(M){const $=new d.ExtensionGlobalMemento(M,this._storage),G=new d.ExtensionMemento(M.identifier.value,!1,this._storage),J=new z.ExtensionSecrets(M,this._secretState),te=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,me=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([$.whenReady,G.whenReady,this._storagePath.whenReady]).then(()=>{const Le=this;let We;return Object.freeze({globalState:$,workspaceState:G,secrets:J,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Fe){return T.join(M.extensionLocation.fsPath,Fe)},get storagePath(){var Fe;return(Fe=Le._storagePath.workspaceValue(M))===null||Fe===void 0?void 0:Fe.fsPath},get globalStoragePath(){return Le._storagePath.globalValue(M).fsPath},get logPath(){return T.join(Le._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return k.URI.joinPath(Le._initData.logsLocation,M.identifier.value)},get storageUri(){return Le._storagePath.workspaceValue(M)},get globalStorageUri(){return Le._storagePath.globalValue(M)},get extensionMode(){return te},get extension(){return We===void 0&&(We=new R(Le,M.identifier,M,me)),We},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(M),Le.extensionRuntime},get environmentVariableCollection(){return Le._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,$,G,J,te){return G=G||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,$,G,J,te).then(me=>new g.ActivatedExtension(!1,null,te.build(),G,me,J.subscriptions))}static _callActivateOptional(M,$,G,J,te){if(typeof G.activate=="function")try{te.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${$.value}`);const me=typeof global=="object"?global:self,Le=G.activate.apply(me,[J]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(Le).then(We=>(te.activateResolveStop(),We))}catch(me){return Promise.reject(me)}else return Promise.resolve(G)}_activateOneStartupFinished(M,$){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:$}).then(void 0,G=>{this._logService.error(G)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const $ of M.activationEvents)$==="onStartupFinished"&&this._activateOneStartupFinished(M,$)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,te=>{this._logService.error(te)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(te=>this._handleWorkspaceContainsEagerExtensions(te.added)));const $=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],G=this._handleWorkspaceContainsEagerExtensions($),J=Promise.all([M,G]).then(()=>{});return Promise.race([J,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),J}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map($=>this._handleWorkspaceContainsEagerExtension(M,$))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,$){if(!this.isActivated($.identifier)){const G=!this._initData.remote.isRemote&&!!this._initData.remote.authority,J={folders:M.map(me=>me.uri),forceUsingSearch:G,exists:me=>this._hostUtils.exists(me.fsPath),checkExists:(me,Le,We)=>this._mainThreadWorkspaceProxy.$checkExists(me,Le,We)},te=await(0,F.checkActivateWorkspaceContainsExtension)(J,$);if(!!te)return this._activateById($.identifier,{startup:!0,extensionId:$.identifier,activationEvent:te.activationEvent}).then(void 0,me=>this._logService.error(me))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:$}=this._initData.environment;if(!M||!$)throw new Error(v.localize(0,null));const G=await this._loadCommonJSModule(null,$,new g.ExtensionActivationTimesBuilder(!1));if(!G||typeof G.run!="function")throw new Error(v.localize(1,null,$.toString()));return new Promise((J,te)=>{const me=(Fe,ze)=>{Fe?te(Fe):J(typeof ze=="number"&&ze>0?1:0)},Le=(0,A.originalFSPath)($),We=G.run(Le,me);We&&We.then&&We.then(()=>{J(0)}).catch(Fe=>{te(Fe.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,$){return this._resolvers[M]=$,(0,C.toDisposable)(()=>{delete this._resolvers[M]})}async $resolveAuthority(M,$){const G=M.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const J=M.substr(0,G);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${J}`,!1);const te=this._resolvers[J];if(!te)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${J}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(te)),D.mark(`code/extHost/willResolveAuthority/${J}`);const me=await te.resolve(M,{resolveAttempt:$});D.mark(`code/extHost/didResolveAuthorityOK/${J}`);const Le={authority:M,host:me.host,port:me.port,connectionToken:me.connectionToken},We={extensionHostEnv:me.extensionHostEnv,trust:me.trust};return{type:"ok",value:{authority:Le,options:We,tunnelInformation:{environmentTunnels:me.environmentTunnels}}}}catch(me){if(D.mark(`code/extHost/didResolveAuthorityError/${J}`),me instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:me._code,message:me._message,detail:me._detail}};throw me}}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,$){return $===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(G=>this._activateByEvent(M,!1))}async $activate(M,$){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,$),!0):!1}async $deltaExtensions(M,$){M.forEach(J=>J.extensionLocation=k.URI.revive(J.extensionLocation));const G=await this.getExtensionPathIndex();return await Promise.all($.map(async J=>{const te=this._registry.getExtensionDescription(J);if(!!te){const me=await this._hostUtils.realpath(te.extensionLocation.fsPath);G.delete(k.URI.file(me).fsPath)}})),await Promise.all(M.map(async J=>{const te=await this._hostUtils.realpath(J.extensionLocation.fsPath);G.set(k.URI.file(te).fsPath,J)})),this._registry.deltaExtensions(M,$),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let $=c.VSBuffer.alloc(M),G=Math.random()%256;for(let J=0;J<M;J++)$.writeUInt8(G,J);return $}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};j=je([qe(0,a.IInstantiationService),qe(1,e.IHostUtils),qe(2,w.IExtHostRpcService),qe(3,o.IExtHostWorkspace),qe(4,h.IExtHostConfiguration),qe(5,i.ILogService),qe(6,s.IExtHostInitDataService),qe(7,u.IExtensionStoragePaths),qe(8,I.IExtHostTunnelService),qe(9,f.IExtHostTerminalService)],j),e.AbstractExtHostExtensionService=j;function H(L,M){return{id:L.identifier.value,name:L.name,extensionVersion:L.version,publisherDisplayName:L.publisher,activationEvents:L.activationEvents?L.activationEvents.join(","):null,isBuiltin:L.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class R{constructor(M,$,G,J){he.set(this,void 0),de.set(this,void 0),x.set(this,void 0),it(this,he,M,"f"),it(this,de,$,"f"),it(this,x,G.identifier,"f"),this.id=G.identifier.value,this.extensionUri=G.extensionLocation,this.extensionPath=T.normalize((0,A.originalFSPath)(G.extensionLocation)),this.packageJSON=G,this.extensionKind=J}get isActive(){return Ue(this,he,"f").isActivated(Ue(this,x,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,he,"f").getExtensionExports(Ue(this,x,"f"))}activate(){return Ue(this,he,"f").activateByIdWithErrors(Ue(this,x,"f"),{startup:!1,extensionId:Ue(this,de,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=R,he=new WeakMap,de=new WeakMap,x=new WeakMap}),define(ve[105],we([0,1,14,2,3,11,5,7,169,30,35,39,173,34,170,15,4,10,46,69]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h,g,r,o,p,m,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let c=class{constructor(b,I,f,_,F,U){this._workspaceService=I,this._extensionService=f,this._editorsService=_,this._configurationService=F,this._editorTabs=U,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=b.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(z=>{z.onDidChange(he=>{this.registerAllDebugTypes(z)}),this.registerAllDebugTypes(z)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(b,I){const f=b;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let _=`debug:${encodeURIComponent(f.path||"")}`,F="?";return I&&(_+=`${F}session=${encodeURIComponent(I.id)}`,F="&"),_+=`${F}ref=${f.sourceReference}`,T.URI.parse(_)}else{if(f.path)return T.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(b){const I=[];for(const f of b.getAllExtensionDescriptions())if(f.contributes){const _=f.contributes.debuggers;if(_&&_.length>0)for(const F of _)(0,r.isDebuggerMainContribution)(F)&&I.push(F.type)}this._debugServiceProxy.$registerDebugTypes(I)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const b=[];return this._breakpoints.forEach(I=>b.push(I)),b}addBreakpoints(b){this.startBreakpoints();const I=b.filter(F=>{const U=F.id;return this._breakpoints.has(U)?!1:(this._breakpoints.set(U,F),!0)});this.fireBreakpointChanges(I,[],[]);const f=[],_=new Map;for(const F of I)if(F instanceof C.SourceBreakpoint){let U=_.get(F.location.uri.toString());U||(U={type:"sourceMulti",uri:F.location.uri,lines:[]},_.set(F.location.uri.toString(),U),f.push(U)),U.lines.push({id:F.id,enabled:F.enabled,condition:F.condition,hitCondition:F.hitCondition,logMessage:F.logMessage,line:F.location.range.start.line,character:F.location.range.start.character})}else F instanceof C.FunctionBreakpoint&&f.push({type:"function",id:F.id,enabled:F.enabled,hitCondition:F.hitCondition,logMessage:F.logMessage,condition:F.condition,functionName:F.functionName});return this._debugServiceProxy.$registerBreakpoints(f)}removeBreakpoints(b){this.startBreakpoints();const I=b.filter(U=>this._breakpoints.delete(U.id));this.fireBreakpointChanges([],I,[]);const f=I.filter(U=>U instanceof C.SourceBreakpoint).map(U=>U.id),_=I.filter(U=>U instanceof C.FunctionBreakpoint).map(U=>U.id),F=I.filter(U=>U instanceof C.DataBreakpoint).map(U=>U.id);return this._debugServiceProxy.$unregisterBreakpoints(f,_,F)}startDebugging(b,I,f){return this._debugServiceProxy.$startDebugging(b?b.uri:void 0,I,{parentSessionID:f.parentSession?f.parentSession.id:void 0,repl:f.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact})}stopDebugging(b){return this._debugServiceProxy.$stopDebugging(b?b.id:void 0)}registerDebugConfigurationProvider(b,I,f){if(!I)return new C.Disposable(()=>{});const _=this._configProviderHandleCounter++;return this._configProviders.push({type:b,handle:_,provider:I}),this._debugServiceProxy.$registerDebugConfigurationProvider(b,f,!!I.provideDebugConfigurations,!!I.resolveDebugConfiguration,!!I.resolveDebugConfigurationWithSubstitutedVariables,_),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(F=>F.provider!==I),this._debugServiceProxy.$unregisterDebugConfigurationProvider(_)})}registerDebugAdapterDescriptorFactory(b,I,f){if(!f)return new C.Disposable(()=>{});if(!this.definesDebugType(b,I))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${I}' debugger.`);if(this.getAdapterDescriptorFactoryByType(I))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const _=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:I,handle:_,factory:f}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(I,_),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(F=>F.factory!==f),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(_)})}registerDebugAdapterTrackerFactory(b,I){if(!I)return new C.Disposable(()=>{});const f=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:b,handle:f,factory:I}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(_=>_.factory!==I)})}async $runInTerminal(b,I){return Promise.resolve(void 0)}async $substituteVariables(b,I){if(!this._variableResolver){const[F,U]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(F||[],this._editorsService,U)}let f;const _=await this.getFolder(b);return _&&(f={uri:_.uri,name:_.name,index:_.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(f,I)}createDebugAdapter(b,I){if(b.type==="implementation")return new s(b.implementation)}createSignService(){}async $startDASession(b,I){const f=this,_=await this.getSession(I);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(_.type),_).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}' (extension might have failed to activate)`);const U=this.convertToDto(F),z=this.createDebugAdapter(U,_);if(!z)throw new Error(`Couldn't create a debug adapter for type '${_.type}'.`);const he=z;return this._debugAdapters.set(b,he),this.getDebugAdapterTrackers(_).then(de=>(de&&this._debugAdaptersTrackers.set(b,de),he.onMessage(async x=>{if(x.type==="request"&&x.command==="handshake"){const j=x,H={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const R=await this._signService.sign(j.arguments.value);H.body={signature:R},he.sendResponse(H)}else throw new Error("no signer")}catch(R){H.success=!1,H.message=R.message,he.sendResponse(H)}}else de&&de.onDidSendMessage&&de.onDidSendMessage(x),x=(0,r.convertToVSCPaths)(x,!0),f._debugServiceProxy.$acceptDAMessage(b,x)}),he.onError(x=>{de&&de.onError&&de.onError(x),this._debugServiceProxy.$acceptDAError(b,x.name,x.message,x.stack)}),he.onExit(x=>{de&&de.onExit&&de.onExit((0,m.withNullAsUndefined)(x),void 0),this._debugServiceProxy.$acceptDAExit(b,(0,m.withNullAsUndefined)(x),void 0)}),de&&de.onWillStartSession&&de.onWillStartSession(),he.startSession()))})}$sendDAMessage(b,I){I=(0,r.convertToDAPaths)(I,!1);const f=this._debugAdaptersTrackers.get(b);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(I);const _=this._debugAdapters.get(b);_&&_.sendMessage(I)}$stopDASession(b){const I=this._debugAdaptersTrackers.get(b);this._debugAdaptersTrackers.delete(b),I&&I.onWillStopSession&&I.onWillStopSession();const f=this._debugAdapters.get(b);return this._debugAdapters.delete(b),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(b){const I=[],f=[],_=[];if(b.added)for(const F of b.added){const U=F.id;if(U&&!this._breakpoints.has(U)){let z;if(F.type==="function")z=new C.FunctionBreakpoint(F.functionName,F.enabled,F.condition,F.hitCondition,F.logMessage);else if(F.type==="data")z=new C.DataBreakpoint(F.label,F.dataId,F.canPersist,F.enabled,F.hitCondition,F.condition,F.logMessage);else{const he=T.URI.revive(F.uri);z=new C.SourceBreakpoint(new C.Location(he,new C.Position(F.line,F.character)),F.enabled,F.condition,F.hitCondition,F.logMessage)}z._id=U,this._breakpoints.set(U,z),I.push(z)}}if(b.removed)for(const F of b.removed){const U=this._breakpoints.get(F);U&&(this._breakpoints.delete(F),f.push(U))}if(b.changed){for(const F of b.changed)if(F.id){const U=this._breakpoints.get(F.id);if(U){if(U instanceof C.FunctionBreakpoint&&F.type==="function"){const z=U;z.enabled=F.enabled,z.condition=F.condition,z.hitCondition=F.hitCondition,z.logMessage=F.logMessage,z.functionName=F.functionName}else if(U instanceof C.SourceBreakpoint&&F.type==="source"){const z=U;z.enabled=F.enabled,z.condition=F.condition,z.hitCondition=F.hitCondition,z.logMessage=F.logMessage,z.location=new C.Location(T.URI.revive(F.uri),new C.Position(F.line,F.character))}_.push(U)}}}this.fireBreakpointChanges(I,f,_)}$provideDebugConfigurations(b,I,f){return(0,A.asPromise)(async()=>{const _=this.getConfigProviderByHandle(b);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const F=await this.getFolder(I);return _.provideDebugConfigurations(F,f)}).then(_=>{if(!_)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return _})}$resolveDebugConfiguration(b,I,f,_){return(0,A.asPromise)(async()=>{const F=this.getConfigProviderByHandle(b);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const U=await this.getFolder(I);return F.resolveDebugConfiguration(U,f,_)})}$resolveDebugConfigurationWithSubstitutedVariables(b,I,f,_){return(0,A.asPromise)(async()=>{const F=this.getConfigProviderByHandle(b);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const U=await this.getFolder(I);return F.resolveDebugConfigurationWithSubstitutedVariables(U,f,_)})}async $provideDebugAdapter(b,I){const f=this.getAdapterDescriptorFactoryByHandle(b);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const _=await this.getSession(I);return this.getAdapterDescriptor(f,_).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}'`);return this.convertToDto(F)})}async $acceptDebugSessionStarted(b){const I=await this.getSession(b);this._onDidStartDebugSession.fire(I)}async $acceptDebugSessionTerminated(b){const I=await this.getSession(b);I&&(this._onDidTerminateDebugSession.fire(I),this._debugSessions.delete(I.id))}async $acceptDebugSessionActiveChanged(b){this._activeDebugSession=b?await this.getSession(b):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(b,I){const f=await this.getSession(b);f&&f._acceptNameChanged(I)}async $acceptDebugSessionCustomEvent(b,I){const _={session:await this.getSession(b),event:I.event,body:I.body};this._onDidReceiveDebugSessionCustomEvent.fire(_)}convertToDto(b){if(b instanceof C.DebugAdapterExecutable)return{type:"executable",command:b.command,args:b.args,options:b.options};if(b instanceof C.DebugAdapterServer)return{type:"server",port:b.port,host:b.host};if(b instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:b.path};if(b instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:b.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(b){const I=this._adapterFactories.filter(f=>f.type===b);if(I.length>0)return I[0].factory}getAdapterDescriptorFactoryByHandle(b){const I=this._adapterFactories.filter(f=>f.handle===b);if(I.length>0)return I[0].factory}getConfigProviderByHandle(b){const I=this._configProviders.filter(f=>f.handle===b);if(I.length>0)return I[0].provider}definesDebugType(b,I){if(b.contributes){const f=b.contributes.debuggers;if(f&&f.length>0){for(const _ of f)if(_.label&&_.type&&_.type===I)return!0}}return!1}getDebugAdapterTrackers(b){const f=b.configuration.type,_=this._trackerFactories.filter(F=>F.type===f||F.type==="*").map(F=>(0,A.asPromise)(()=>F.factory.createDebugAdapterTracker(b)).then(U=>U,U=>null));return Promise.race([Promise.all(_).then(F=>{const U=F.filter(z=>!!z);if(U.length>0)return new a(U)}),new Promise((F,U)=>{const z=setTimeout(()=>{clearTimeout(z),U(new Error("timeout"))},1e3)})]).catch(F=>{})}async getAdapterDescriptor(b,I){const f=I.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new C.DebugAdapterServer(f));if(b){const F=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>b.createDebugAdapterDescriptor(I,this.daExecutableFromPackage(I,F))).then(U=>{if(U)return U})}const _=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(I,_))}daExecutableFromPackage(b,I){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(b,I,f){(b.length>0||I.length>0||f.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:b,removed:I,changed:f}))}async getSession(b){if(b)if(typeof b=="string"){const I=this._debugSessions.get(b);if(I)return I}else{let I=this._debugSessions.get(b.id);if(!I){const f=await this.getFolder(b.folderUri);I=new d(this._debugServiceProxy,b.id,b.type,b.name,f,b.configuration),this._debugSessions.set(I.id,I),this._debugServiceProxy.$sessionCached(I.id)}return I}throw new Error("cannot find session")}getFolder(b){if(b){const I=T.URI.revive(b);return this._workspaceService.resolveWorkspaceFolder(I)}return Promise.resolve(void 0)}};c=je([qe(0,o.IExtHostRpcService),qe(1,k.IExtHostWorkspace),qe(2,i.IExtHostExtensionService),qe(3,P.IExtHostDocumentsAndEditors),qe(4,g.IExtHostConfiguration),qe(5,l.IExtHostEditorTabs)],c),e.ExtHostDebugServiceBase=c;class d{constructor(b,I,f,_,F,U){this._debugServiceProxy=b,this._id=I,this._type=f,this._name=_,this._workspaceFolder=F,this._configuration=U}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(b){this._name=b,this._debugServiceProxy.$setDebugSessionName(this._id,b)}_acceptNameChanged(b){this._name=b}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(b,I){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,b,I)}getDebugProtocolBreakpoint(b){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,b.id)}}e.ExtHostDebugSession=d;class t{constructor(b){this.value=Object.freeze({append(I){b.$appendDebugConsole(I)},appendLine(I){this.append(I+`
`)}})}}e.ExtHostDebugConsole=t;class n extends h.AbstractVariableResolverService{constructor(b,I,f,_,F){function U(){if(I){const z=I.activeEditor();if(z)return z.document.uri;const he=_.tabs.filter(de=>de.isActive);if(he.length>0)return he[0].resource}}super({getFolderUri:z=>{const he=b.filter(de=>de.name===z);if(he&&he.length>0)return he[0].uri},getWorkspaceFolderCount:()=>b.length,getConfigurationValue:(z,he)=>f.getConfiguration(void 0,z).get(he),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const z=U();if(z)return v.normalize(z.fsPath)},getWorkspaceFolderPathForFile:()=>{if(F){const z=U();if(z){const he=F.getWorkspaceFolder(z);if(he)return v.normalize(he.uri.fsPath)}}},getSelectedText:()=>{if(I){const z=I.activeEditor();if(z&&!z.selection.isEmpty)return z.document.getText(z.selection)}},getLineNumber:()=>{if(I){const z=I.activeEditor();if(z)return String(z.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=n;class a{constructor(b){this.trackers=b}onWillStartSession(){this.trackers.forEach(b=>b.onWillStartSession?b.onWillStartSession():void 0)}onWillReceiveMessage(b){this.trackers.forEach(I=>I.onWillReceiveMessage?I.onWillReceiveMessage(b):void 0)}onDidSendMessage(b){this.trackers.forEach(I=>I.onDidSendMessage?I.onDidSendMessage(b):void 0)}onWillStopSession(){this.trackers.forEach(b=>b.onWillStopSession?b.onWillStopSession():void 0)}onError(b){this.trackers.forEach(I=>I.onError?I.onError(b):void 0)}onExit(b,I){this.trackers.forEach(f=>f.onExit?f.onExit(b,I):void 0)}}class s extends S.AbstractDebugAdapter{constructor(b){super();this.implementation=b,b.onDidSendMessage(I=>{this.acceptMessage(I)})}startSession(){return Promise.resolve(void 0)}sendMessage(b){this.implementation.handleMessage(b)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends c{constructor(b,I,f,_,F,U){super(b,I,f,_,F,U)}createVariableResolver(b,I,f){return new n(b,I,f,this._editorTabs)}};u=je([qe(0,o.IExtHostRpcService),qe(1,k.IExtHostWorkspace),qe(2,i.IExtHostExtensionService),qe(3,P.IExtHostDocumentsAndEditors),qe(4,g.IExtHostConfiguration),qe(5,l.IExtHostEditorTabs)],u),e.WorkerExtHostDebugService=u}),define(ve[221],we([0,1,81,2,5,34,33,26,15,27,4,35,46,16]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(l,c,d,t,n,a,s){this._apiFactory=l,this._extensionRegistry=c,this._instaService=d,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=a,this._logService=s,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),v.mark("code/extHost/willWaitForConfig");const l=await this._extHostConfiguration.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const c=await this._extHostExtensionService.getExtensionPathIndex();this.register(new o(this._apiFactory,c,this._extensionRegistry,l,this._logService)),this.register(this._instaService.createInstance(p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(m,c,this._initData.environment.appUriScheme))}register(l){if(Array.isArray(l.nodeModuleName))for(let c of l.nodeModuleName)this._factories.set(c,l);else this._factories.set(l.nodeModuleName,l);typeof l.alternativeModuleName=="function"&&this._alternatives.push(c=>l.alternativeModuleName(c))}};r=je([qe(2,i.IInstantiationService),qe(3,A.IExtHostConfiguration),qe(4,P.IExtHostExtensionService),qe(5,k.IExtHostInitDataService),qe(6,g.ILogService)],r),e.RequireInterceptor=r;class o{constructor(l,c,d,t,n){this._apiFactory=l,this._extensionPaths=c,this._extensionRegistry=d,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(l,c){const d=this._extensionPaths.findSubstr(c.fsPath);if(d){let t=this._extApiImpl.get(C.ExtensionIdentifier.toKey(d.identifier));return t||(t=this._apiFactory(d,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(d.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,a)=>t+=`	${a} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${c.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(l,c){this.nodeModuleName="keytar";const{environment:d}=c,t=l.getProxy(D.MainContext.MainThreadKeytar);if(d.appRoot){let n=d.appRoot.fsPath;h.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,a)=>t.$getPassword(n,a),setPassword:(n,a,s)=>t.$setPassword(n,a,s),deletePassword:(n,a)=>t.$deletePassword(n,a),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(l,c){return this._impl}alternativeModuleName(l){const c=l.length;if(!(c<=7||!this.alternativeNames)){const d=c-7;if((l.charAt(d)==="/"||l.charAt(d)==="\\")&&l.endsWith("keytar")&&(l=l.replace(/\\/g,"/"),this.alternativeNames.has(l)))return"keytar"}}};p=je([qe(0,S.IExtHostRpcService),qe(1,k.IExtHostInitDataService)],p);let m=class{constructor(l,c,d){this._extensionPaths=l,this._appUriScheme=c,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=d.getProxy(D.MainContext.MainThreadTelemetry);const t=d.getProxy(D.MainContext.MainThreadWindow);this._impl=(n,a)=>{const s=T.URI.parse(n);return a?this.callOriginal(n,a):s.scheme==="http"||s.scheme==="https"?t.$openUri(s,n,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this._appUriScheme?t.$openUri(s,n,{}):this.callOriginal(n,a)}}load(l,c,d){const t=this._extensionPaths.findSubstr(c.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=d(l),this._impl}callOriginal(l,c){return this.sendNoForwardTelemetry(),this._original(l,c)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};m=je([qe(2,S.IExtHostRpcService)],m)}),define(ve[222],we([0,1,11,12,81,6,2,5,214,16,61,65,27,152,15,72,35,40]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h,g,r,o,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(c,d,t,n){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const a=new S.RPCProtocol(c,null,n);d=E._transform(d,a);const s=new P.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());s.set(h.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},d)),s.set(r.IExtHostRpcService,new r.ExtHostRpcService(a)),s.set(o.IURITransformerService,new o.URITransformerService(n)),s.set(p.IHostUtils,t);const u=new g.InstantiationService(s,!0),w=u.invokeFunction(_=>_.get(m.IExtHostTerminalService));this._disposables.add(w),this._logService=u.invokeFunction(_=>_.get(k.ILogService)),D.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",d),this._extensionService=u.invokeFunction(_=>_.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const b=new WeakMap;this._extensionService.getExtensionPathIndex().then(_=>{Error.prepareStackTrace=(F,U)=>{let z="",he,de;for(const x of U)z+=`
	at ${x.toString()}`,de=x.getFileName(),!he&&de&&(he=_.findSubstr(de));return b.set(F,he),`${F.name||"Error"}: ${F.message||""}${z}`}});const I=a.getProxy(C.MainContext.MainThreadExtensionService),f=a.getProxy(C.MainContext.MainThreadErrors);T.setUnexpectedErrorHandler(_=>{const F=T.transformErrorForSerialization(_),U=b.get(_);U?I.$onExtensionRuntimeError(U.identifier,F):f.$onUnexpectedError(F)})}terminate(c){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),T.setUnexpectedErrorHandler(t=>{});const d=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,v.timeout)(4e3),d]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(c,d){c.extensions.forEach(n=>n.extensionLocation=y.URI.revive(d.transformIncomingURIs(n.extensionLocation))),c.environment.appRoot=y.URI.revive(d.transformIncomingURIs(c.environment.appRoot));const t=c.environment.extensionDevelopmentLocationURI;return t&&(c.environment.extensionDevelopmentLocationURI=t.map(n=>y.URI.revive(d.transformIncomingURIs(n)))),c.environment.extensionTestsLocationURI=y.URI.revive(d.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=y.URI.revive(d.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=y.URI.revive(d.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=y.URI.revive(d.transformIncomingURIs(c.logsLocation)),c.logFile=y.URI.revive(d.transformIncomingURIs(c.logFile)),c.workspace=d.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=E}),define(ve[223],we([0,1,14,20,60,28,25,55,41]),function(Y,e,v,T,D,A,y,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(h,g,r){this.config=h,this.provider=g,this.sessionToken=r,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=h.filePattern,this.includePattern=h.includePattern&&A.parse(h.includePattern),this.maxResults=h.maxResults||void 0,this.exists=h.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=h.excludePattern&&A.parse(h.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(h=>h.cancel()),this.activeCancellationTokens=new Set}search(h){const g=this.config.folderQueries||[];return new Promise((r,o)=>{const p=m=>{this.resultCount++,h(m)};if(this.isCanceled)return r({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(m=>{const E=m.toString(),l=v.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,l)||this.matchFile(p,{base:m,basename:l})}),Promise.all(g.map(m=>this.searchInFolder(m,p))).then(m=>{r({limitHit:this.isLimitHit,stats:m[0]||void 0})},m=>{o(new Error((0,D.toErrorMessage)(m)))})})}async searchInFolder(h,g){const r=new T.CancellationTokenSource,o=this.getSearchOptionsForFolder(h),p=this.initDirectoryTree(),m=new S.QueryGlobTester(this.config,h),E=!m.hasSiblingExcludeClauses();let l;try{this.activeCancellationTokens.add(r),l=C.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},o,r.token),d=l.elapsed(),t=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(n=>{const a=v.posix.relative(h.folder.path,n.path);if(E){const s=v.basename(n.path);this.matchFile(g,{base:h.folder,relativePath:a,basename:s});return}this.addDirectoryEntries(p,h.folder,a,g)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,m,g),{providerTime:d,postProcessTime:t.elapsed()})}finally{r.dispose(),this.activeCancellationTokens.delete(r)}}getSearchOptionsForFolder(h){const g=(0,S.resolvePatternsForProvider)(this.config.includePattern,h.includePattern),r=(0,S.resolvePatternsForProvider)(this.config.excludePattern,h.excludePattern);return{folder:h.folder,excludes:r,includes:g,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,followSymlinks:!h.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}addDirectoryEntries({pathToEntries:h},g,r,o){if(r===this.filePattern){const m=v.basename(this.filePattern);this.matchFile(o,{base:g,relativePath:this.filePattern,basename:m})}function p(m){const E=v.basename(m),l=v.dirname(m);let c=h[l];c||(c=h[l]=[],p(l)),c.push({base:g,relativePath:m,basename:E})}p(r)}matchDirectoryTree({rootEntries:h,pathToEntries:g},r,o){const p=this,m=this.filePattern;function E(l){const c=A.hasSiblingFn(()=>l.map(d=>d.basename));for(let d=0,t=l.length;d<t;d++){const n=l[d],{relativePath:a,basename:s}=n;if(!!r.includedInQuerySync(a,s,m!==s?c:void 0)){const u=g[a];if(u)E(u);else{if(a===m)continue;p.matchFile(o,n)}if(p.isLimitHit)break}}}E(h)}matchFile(h,g){(!this.includePattern||g.relativePath&&this.includePattern(g.relativePath,g.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||h(g))}}class i{constructor(){this.sessions=new Map}fileSearch(h,g,r,o){const p=this.getSessionTokenSource(h.cacheKey),m=new k(h,g,p&&p.token);let E=0;const l=c=>{E+=c.length,r(c.map(d=>this.rawMatchToSearchItem(d)))};return this.doSearch(m,i.BATCH_SIZE,l,o).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:c.stats}}))}clearCache(h){const g=this.getSessionTokenSource(h);g&&g.cancel()}getSessionTokenSource(h){if(!!h)return this.sessions.has(h)||this.sessions.set(h,new T.CancellationTokenSource),this.sessions.get(h)}rawMatchToSearchItem(h){return h.relativePath?{resource:y.joinPath(h.base,h.relativePath)}:{resource:h.base}}doSearch(h,g,r,o){o.onCancellationRequested(()=>{h.cancel()});const p=E=>{E&&(m.push(E),g>0&&m.length>=g&&(r(m),m=[]))};let m=[];return h.search(p).then(E=>(m.length&&r(m),E),E=>(m.length&&r(m),Promise.reject(E)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(ve[224],we([0,1,14,13,20,60,25,28,2,41,19,10]),function(Y,e,v,T,D,A,y,C,S,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class h{constructor(l,c,d){this.query=l,this.provider=c,this.fileUtils=d,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(l,c){const d=this.query.folderQueries||[],t=new D.CancellationTokenSource;return c.onCancellationRequested(()=>t.cancel()),new Promise((n,a)=>{this.collector=new r(l);let s=!1;const u=(w,b)=>{if(!s&&!this.isLimitHit){const I=this.resultSize(w);p(w)&&typeof this.query.maxResults=="number"&&this.resultCount+I>this.query.maxResults&&(this.isLimitHit=!0,s=!0,t.cancel(),w=this.trimResultToSize(w,this.query.maxResults-this.resultCount));const f=this.resultSize(w);this.resultCount+=f,(f>0||!p(w))&&this.collector.add(w,b)}};Promise.all(d.map((w,b)=>this.searchInFolder(w,I=>u(I,b),t.token))).then(w=>{t.dispose(),this.collector.flush();const b=w.some(I=>!!I&&!!I.limitHit);n({limitHit:this.isLimitHit||b,messages:(0,T.flatten)(w.map(I=>(I==null?void 0:I.message)?(0,P.isArray)(I.message)?I.message:[I.message]:[])),stats:{type:"textSearchProvider"}})},w=>{t.dispose();const b=(0,A.toErrorMessage)(w);a(new Error(b))})})}resultSize(l){return p(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}trimResultToSize(l,c){const d=Array.isArray(l.ranges)?l.ranges:[l.ranges],t=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:d.slice(0,c),preview:{matches:t.slice(0,c),text:l.preview.text},uri:l.uri}}async searchInFolder(l,c,d){const t=new k.QueryGlobTester(this.query,l),n=[],a={report:w=>{if(!!this.validateProviderResult(w)){const b=l.folder.scheme===i.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(w.uri))):void 0,I=y.relativePath(l.folder,w.uri);I&&n.push(t.includedInQuery(I,v.basename(I),b).then(f=>{f&&c(w)}))}}},s=this.getSearchOptionsForFolder(l),u=await this.provider.provideTextSearchResults(g(this.query.contentPattern),s,a,d);return await Promise.all(n),u}validateProviderResult(l){if(p(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(l){const c=(0,k.resolvePatternsForProvider)(this.query.includePattern,l.includePattern),d=(0,k.resolvePatternsForProvider)(this.query.excludePattern,l.excludePattern),t={folder:S.URI.from(l.folder),excludes:d,includes:c,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.fileUtils.toCanonicalName(l.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=h;function g(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class r{constructor(l){this._onResult=l,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new m(512,c=>this.sendItems(c))}add(l,c){this._currentFileMatch&&(this._currentFolderIdx!==c||!y.isEqual(this._currentUri,l.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=c,this._currentFileMatch={resource:l.uri,results:[]}),this._currentFileMatch.results.push(o(l))}pushToCollector(){const l=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,l)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(l){this._onResult(l)}}e.TextSearchResultsCollector=r;function o(E){return p(E)?{preview:{matches:(0,T.mapArrayOrNot)(E.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:E.preview.text},ranges:(0,T.mapArrayOrNot)(E.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function p(E){return!!E.preview}e.extensionResultIsMatch=p;class m{constructor(l,c){this.maxBatchSize=l,this.cb=c,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(l,c){!l||this.addItemToBatch(l,c)}addItems(l,c){!l||this.addItemsToBatch(l,c)}addItemToBatch(l,c){this.batch.push(l),this.batchSize+=c,this.onUpdate()}addItemsToBatch(l,c){this.batch=this.batch.concat(l),this.batchSize+=c,this.onUpdate()}onUpdate(){this.totalNumberCompleted<m.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},m.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=m,m.TIMEOUT=4e3,m.START_BATCH_AFTER_COUNT=50}),define(ve[106],we([0,1,6,5,4,223,15,72,16,2,224]),function(Y,e,v,T,D,A,y,C,S,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let P=class{constructor(o,p,m){this.extHostRpc=o,this._uriTransformer=p,this._logService=m,this._proxy=this.extHostRpc.getProxy(T.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(o){return this._uriTransformer.transformOutgoingScheme(o)}registerTextSearchProvider(o,p){if(this._textSearchUsedSchemes.has(o))throw new Error(`a text search provider for the scheme '${o}' is already registered`);this._textSearchUsedSchemes.add(o);const m=this._handlePool++;return this._textSearchProvider.set(m,p),this._proxy.$registerTextSearchProvider(m,this._transformScheme(o)),(0,v.toDisposable)(()=>{this._textSearchUsedSchemes.delete(o),this._textSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}registerFileSearchProvider(o,p){if(this._fileSearchUsedSchemes.has(o))throw new Error(`a file search provider for the scheme '${o}' is already registered`);this._fileSearchUsedSchemes.add(o);const m=this._handlePool++;return this._fileSearchProvider.set(m,p),this._proxy.$registerFileSearchProvider(m,this._transformScheme(o)),(0,v.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(o),this._fileSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}$provideFileSearchResults(o,p,m,E){const l=h(m),c=this._fileSearchProvider.get(o);if(c)return this._fileSearchManager.fileSearch(l,c,d=>{this._proxy.$handleFileMatch(o,p,d.map(t=>t.resource))},E);throw new Error("unknown provider: "+o)}$clearCache(o){return this._fileSearchManager.clearCache(o),Promise.resolve(void 0)}$provideTextSearchResults(o,p,m,E){const l=this._textSearchProvider.get(o);if(!l||!l.provideTextSearchResults)throw new Error(`Unknown provider ${o}`);const c=h(m);return this.createTextSearchManager(c,l).search(t=>this._proxy.$handleTextMatch(o,p,t),E)}createTextSearchManager(o,p){return new i.TextSearchManager(o,p,{readdir:m=>Promise.resolve([]),toCanonicalName:m=>m})}};P=je([qe(0,y.IExtHostRpcService),qe(1,C.IURITransformerService),qe(2,S.ILogService)],P),e.ExtHostSearch=P;function h(r){return Object.assign(Object.assign({},r),{folderQueries:r.folderQueries&&r.folderQueries.map(g),extraFileResources:r.extraFileResources&&r.extraFileResources.map(o=>k.URI.revive(o))})}e.reviveQuery=h;function g(r){return Object.assign(Object.assign({},r),{folder:k.URI.revive(r.folder)})}}),define(ve[225],we([0,1,131,20,12,3,47,2,124,86,118,59,64,5,190,189,77,191,34,192,193,194,176,195,39,35,196,177,198,199,200,101,180,203,204,205,79,40,206,181,9,7,209,50,102,30,33,51,166,197,94,100,104,105,106,16,72,15,27,201,164,71,76,187,207,163,80,78,212,210,211,188,49,218,208,75,69,95,202,67,103]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h,g,r,o,p,m,E,l,c,d,t,n,a,s,u,w,b,I,f,_,F,U,z,he,de,x,j,H,R,L,M,$,G,J,te,me,Le,We,Fe,ze,W,q,ee,se,ce,_e,$e,fe,De,Re,He,be,Ke,V,Z,ge,Ne,Ve,xe,Xe,ye,Ee,Ce,ie,ae,N,Q,oe,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ie(Ae){const Be=Ae.get($e.IExtHostInitDataService),Ye=Ae.get(ye.IExtHostFileSystemInfo),rt=Ae.get(ge.IExtHostConsumerFileSystem),tt=Ae.get(s.IExtHostExtensionService),Qe=Ae.get(J.IExtHostWorkspace),gt=Ae.get(N.IExtHostTelemetry),bt=Ae.get(E.IExtHostConfiguration),pe=Ae.get(ce.IURITransformerService),ue=Ae.get(_e.IExtHostRpcService),re=Ae.get(de.IExtHostStorage),K=Ae.get(Z.IExtensionStoragePaths),Me=Ae.get(se.ILogService),Te=Ae.get(Re.IExtHostTunnelService),Je=Ae.get(He.IExtHostApiDeprecationService),et=Ae.get(G.IExtHostWindow),ut=Ae.get(ie.IExtHostSecretState),ct=Ae.get(ae.IExtHostEditorTabs);ue.set(g.ExtHostContext.ExtHostFileSystemInfo,Ye),ue.set(g.ExtHostContext.ExtHostLogService,Me),ue.set(g.ExtHostContext.ExtHostWorkspace,Qe),ue.set(g.ExtHostContext.ExtHostConfiguration,bt),ue.set(g.ExtHostContext.ExtHostExtensionService,tt),ue.set(g.ExtHostContext.ExtHostStorage,re),ue.set(g.ExtHostContext.ExtHostTunnelService,Te),ue.set(g.ExtHostContext.ExtHostWindow,et),ue.set(g.ExtHostContext.ExtHostSecretState,ut),ue.set(g.ExtHostContext.ExtHostTelemetry,gt),ue.set(g.ExtHostContext.ExtHostEditorTabs,ct);const Ze=ue.set(g.ExtHostContext.ExtHostDecorations,Ae.get(ze.IExtHostDecorations)),mt=ue.set(g.ExtHostContext.ExtHostDocumentsAndEditors,Ae.get(a.IExtHostDocumentsAndEditors)),ht=ue.set(g.ExtHostContext.ExtHostCommands,Ae.get(p.IExtHostCommands)),ft=ue.set(g.ExtHostContext.ExtHostTerminalService,Ae.get(x.IExtHostTerminalService)),at=ue.set(g.ExtHostContext.ExtHostDebugService,Ae.get(q.IExtHostDebugService)),yt=ue.set(g.ExtHostContext.ExtHostSearch,Ae.get(ee.IExtHostSearch)),Et=ue.set(g.ExtHostContext.ExtHostTask,Ae.get(W.IExtHostTask)),Ot=ue.set(g.ExtHostContext.ExtHostOutputService,Ae.get(_.IExtHostOutputService)),Tt=ue.set(g.ExtHostContext.ExtHostUrls,new M.ExtHostUrls(ue)),_t=ue.set(g.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(ue,mt)),Qt=ue.set(g.ExtHostContext.ExtHostDocumentContentProviders,new d.ExtHostDocumentContentProvider(ue,mt,Me)),Yt=ue.set(g.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Me,_t,ue.getProxy(g.MainContext.MainThreadBulkEdits))),pt=ue.set(g.ExtHostContext.ExtHostNotebook,new fe.ExtHostNotebookController(ue,ht,mt,_t,Me,K)),Jt=ue.set(g.ExtHostContext.ExtHostNotebookKernels,new Q.ExtHostNotebookKernels(ue,Be,pt,Me)),Dt=ue.set(g.ExtHostContext.ExtHostEditors,new j.ExtHostEditors(ue,mt)),Vt=ue.set(g.ExtHostContext.ExtHostTreeViews,new H.ExtHostTreeViews(ue.getProxy(g.MainContext.MainThreadTreeViews),ht,Me)),Xt=ue.set(g.ExtHostContext.ExtHostEditorInsets,new Le.ExtHostEditorInsets(ue.getProxy(g.MainContext.MainThreadEditorInsets),Dt,Object.assign(Object.assign({},Be.environment),{remote:Be.remote}))),jt=ue.set(g.ExtHostContext.ExtHostDiagnostics,new l.ExtHostDiagnostics(ue,Me)),lt=ue.set(g.ExtHostContext.ExtHostLanguageFeatures,new b.ExtHostLanguageFeatures(ue,pe,_t,ht,jt,Me,Je)),Zt=ue.set(g.ExtHostContext.ExtHostFileSystem,new u.ExtHostFileSystem(ue,lt)),Rt=ue.set(g.ExtHostContext.ExtHostFileSystemEventService,new w.ExtHostFileSystemEventService(ue,Me,mt)),xt=ue.set(g.ExtHostContext.ExtHostQuickOpen,(0,U.createExtHostQuickOpen)(ue,Qe,ht)),cn=ue.set(g.ExtHostContext.ExtHostSCM,new z.ExtHostSCM(ue,ht,Me)),wn=ue.set(g.ExtHostContext.ExtHostComments,new m.ExtHostComments(ue,ht,_t)),dn=ue.set(g.ExtHostContext.ExtHostProgress,new F.ExtHostProgress(ue.getProxy(g.MainContext.MainThreadProgress))),en=ue.set(g.ExtHostContext.ExtHosLabelService,new We.ExtHostLabelService(ue)),qt=ue.set(g.ExtHostContext.ExtHostTheming,new De.ExtHostTheming(ue)),Nt=ue.set(g.ExtHostContext.ExtHostAuthentication,new be.ExtHostAuthentication(ue)),_n=ue.set(g.ExtHostContext.ExtHostTimeline,new Ke.ExtHostTimeline(ue,ht)),tn=ue.set(g.ExtHostContext.ExtHostWebviews,new $.ExtHostWebviews(ue,Object.assign(Object.assign({},Be.environment),{remote:Be.remote}),Qe,Me,Je)),nn=ue.set(g.ExtHostContext.ExtHostWebviewPanels,new xe.ExtHostWebviewPanels(ue,tn,Qe)),Kt=ue.set(g.ExtHostContext.ExtHostCustomEditors,new Ve.ExtHostCustomEditors(ue,_t,K,tn,nn)),En=ue.set(g.ExtHostContext.ExtHostWebviewViews,new Ne.ExtHostWebviewViews(ue,tn)),Ft=ue.set(g.ExtHostContext.ExtHostTesting,new Ee.ExtHostTesting(ue,mt,Qe)),rn=ue.set(g.ExtHostContext.ExtHostUriOpeners,new Ce.ExtHostUriOpeners(ue)),yn=(0,me.values)(g.ExtHostContext);ue.assertRegistered(yn);const Wt=new Xe.ExtHostBulkEdits(ue,mt),sn=new o.ExtHostClipboard(ue),Ut=new f.ExtHostMessageService(ue,Me),Pt=new c.ExtHostDialogs(ue),hn=new he.ExtHostStatusBar(ue,ht.converter),Bt=new I.ExtHostLanguages(ue,_t);return r.ExtHostApiCommands.register(ht),function(Oe,on,an){const vt=function(){let X=!Oe.isUnderDevelopment;function le(Pe){X||(Me.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function Pe(st){if(Array.isArray(st))st.forEach(Pe);else if(typeof st=="string")le(st);else{const wt=st;typeof wt.scheme=="undefined"&&le(st),!Oe.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,te.throwProposedApiError)(Oe)}return st}}(),Sn={getSession(X,le,Pe){return Nt.getSession(Oe,X,le,Pe)},get onDidChangeSessions(){return Nt.onDidChangeSessions},registerAuthenticationProvider(X,le,Pe,st){return Nt.registerAuthenticationProvider(X,le,Pe,st)},get onDidChangeAuthenticationProviders(){return(0,te.checkProposedApiEnabled)(Oe),Nt.onDidChangeAuthenticationProviders},get providers(){return(0,te.checkProposedApiEnabled)(Oe),Nt.providers},logout(X,le){return(0,te.checkProposedApiEnabled)(Oe),Nt.removeSession(X,le)}},Dn={registerCommand(X,le,Pe){return ht.registerCommand(!0,X,le,Pe)},registerTextEditorCommand(X,le,Pe){return ht.registerCommand(!0,X,(...st)=>{const wt=Dt.getActiveTextEditor();if(!wt){Me.warn("Cannot execute "+X+" because there is no active text editor.");return}return wt.edit(Ct=>{le.apply(Pe,[wt,Ct,...st])}).then(Ct=>{Ct||Me.warn("Edits from command "+X+" were not applied.")},Ct=>{Me.warn("An error occurred while running command "+X,Ct)})})},registerDiffInformationCommand:(X,le,Pe)=>((0,te.checkProposedApiEnabled)(Oe),ht.registerCommand(!0,X,async(...st)=>{const wt=mt.activeEditor(!0);if(!wt){Me.warn("Cannot execute "+X+" because there is no active text editor.");return}const Ct=await Dt.getDiffInformation(wt.id);le.apply(Pe,[Ct,...st])})),executeCommand(X,...le){return ht.executeCommand(X,...le)},getCommands(X=!1){return ht.getCommands(X)}},fn={get machineId(){return Be.telemetryInfo.machineId},get sessionId(){return Be.telemetryInfo.sessionId},get language(){return Be.environment.appLanguage},get appName(){return Be.environment.appName},get appRoot(){var X,le;return(le=(X=Be.environment.appRoot)===null||X===void 0?void 0:X.fsPath)!==null&&le!==void 0?le:""},get uriScheme(){return Be.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return ft.getDefaultShell(!1,an)},get isTelemetryEnabled(){return gt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return gt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(Be.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,le){return et.openUri(X,{allowTunneling:!!Be.remote.authority,allowContributedOpeners:le==null?void 0:le.allowContributedOpeners})},asExternalUri(X){return X.scheme===Be.environment.appUriScheme?Tt.createAppUri(X):et.asExternalUri(X,{allowTunneling:!!Be.remote.authority})},get remoteName(){return(0,Fe.getRemoteName)(Be.remote.authority)},get uiKind(){return Be.uiKind}};Be.environment.extensionTestsLocationURI||Object.freeze(fn);const mn=Be.remote.isRemote?L.ExtensionKind.Workspace:L.ExtensionKind.UI,Ht={registerTestController(X){return(0,te.checkProposedApiEnabled)(Oe),Ft.registerTestController(Oe.identifier.value,X)},createDocumentTestObserver(X){return(0,te.checkProposedApiEnabled)(Oe),Ft.createTextDocumentTestObserver(X)},createWorkspaceTestObserver(X){return(0,te.checkProposedApiEnabled)(Oe),Ft.createWorkspaceTestObserver(X)},runTests(X){return(0,te.checkProposedApiEnabled)(Oe),Ft.runTests(X)},createTestItem(X,le){return new L.TestItemImpl(X.id,X.label,X.uri,le)},createTestRun(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),Ft.createTestRun(Oe.identifier.value,X,le,Pe)},get onDidChangeTestResults(){return(0,te.checkProposedApiEnabled)(Oe),Ft.onResultsChanged},get testResults(){return(0,te.checkProposedApiEnabled)(Oe),Ft.results}};Ht.createTestRunTask=Ht.createTestRun;const Cn={getExtension(X){const le=on.getExtensionDescription(X);if(le)return new s.Extension(tt,Oe.identifier,le,mn)},get all(){return on.getAllExtensionDescriptions().map(X=>new s.Extension(tt,Oe.identifier,X,mn))},get onDidChange(){return on.onDidChange}},kn={createDiagnosticCollection(X){return jt.createDiagnosticCollection(Oe.identifier,X)},get onDidChangeDiagnostics(){return jt.onDidChangeDiagnostics},getDiagnostics:X=>jt.getDiagnostics(X),getLanguages(){return Bt.getLanguages()},setTextDocumentLanguage(X,le){return Bt.changeLanguage(X.uri,le)},match(X,le){return(0,P.score)(R.LanguageSelector.from(X),le.uri,le.languageId,!0)},registerCodeActionsProvider(X,le,Pe){return lt.registerCodeActionProvider(Oe,vt(X),le,Pe)},registerCodeLensProvider(X,le){return lt.registerCodeLensProvider(Oe,vt(X),le)},registerDefinitionProvider(X,le){return lt.registerDefinitionProvider(Oe,vt(X),le)},registerDeclarationProvider(X,le){return lt.registerDeclarationProvider(Oe,vt(X),le)},registerImplementationProvider(X,le){return lt.registerImplementationProvider(Oe,vt(X),le)},registerTypeDefinitionProvider(X,le){return lt.registerTypeDefinitionProvider(Oe,vt(X),le)},registerHoverProvider(X,le){return lt.registerHoverProvider(Oe,vt(X),le,Oe.identifier)},registerEvaluatableExpressionProvider(X,le){return lt.registerEvaluatableExpressionProvider(Oe,vt(X),le,Oe.identifier)},registerInlineValuesProvider(X,le){return lt.registerInlineValuesProvider(Oe,vt(X),le,Oe.identifier)},registerDocumentHighlightProvider(X,le){return lt.registerDocumentHighlightProvider(Oe,vt(X),le)},registerLinkedEditingRangeProvider(X,le){return lt.registerLinkedEditingRangeProvider(Oe,vt(X),le)},registerReferenceProvider(X,le){return lt.registerReferenceProvider(Oe,vt(X),le)},registerRenameProvider(X,le){return lt.registerRenameProvider(Oe,vt(X),le)},registerDocumentSymbolProvider(X,le,Pe){return lt.registerDocumentSymbolProvider(Oe,vt(X),le,Pe)},registerWorkspaceSymbolProvider(X){return lt.registerWorkspaceSymbolProvider(Oe,X)},registerDocumentFormattingEditProvider(X,le){return lt.registerDocumentFormattingEditProvider(Oe,vt(X),le)},registerDocumentRangeFormattingEditProvider(X,le){return lt.registerDocumentRangeFormattingEditProvider(Oe,vt(X),le)},registerOnTypeFormattingEditProvider(X,le,Pe,...st){return lt.registerOnTypeFormattingEditProvider(Oe,vt(X),le,[Pe].concat(st))},registerDocumentSemanticTokensProvider(X,le,Pe){return lt.registerDocumentSemanticTokensProvider(Oe,vt(X),le,Pe)},registerDocumentRangeSemanticTokensProvider(X,le,Pe){return lt.registerDocumentRangeSemanticTokensProvider(Oe,vt(X),le,Pe)},registerSignatureHelpProvider(X,le,Pe,...st){return typeof Pe=="object"?lt.registerSignatureHelpProvider(Oe,vt(X),le,Pe):lt.registerSignatureHelpProvider(Oe,vt(X),le,typeof Pe=="undefined"?[]:[Pe,...st])},registerCompletionItemProvider(X,le,...Pe){return lt.registerCompletionItemProvider(Oe,vt(X),le,Pe)},registerDocumentLinkProvider(X,le){return lt.registerDocumentLinkProvider(Oe,vt(X),le)},registerColorProvider(X,le){return lt.registerColorProvider(Oe,vt(X),le)},registerFoldingRangeProvider(X,le){return lt.registerFoldingRangeProvider(Oe,vt(X),le)},registerSelectionRangeProvider(X,le){return lt.registerSelectionRangeProvider(Oe,X,le)},registerCallHierarchyProvider(X,le){return lt.registerCallHierarchyProvider(Oe,X,le)},setLanguageConfiguration:(X,le)=>lt.setLanguageConfiguration(Oe,X,le),getTokenInformationAtPosition(X,le){return(0,te.checkProposedApiEnabled)(Oe),Bt.tokenAtPosition(X,le)},registerInlayHintsProvider(X,le){return(0,te.checkProposedApiEnabled)(Oe),lt.registerInlayHintsProvider(Oe,X,le)}},In={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(X,le,Pe){const st=await(C.URI.isUri(X)?Promise.resolve(gn.openTextDocument(X)):Promise.resolve(X));return Dt.showTextDocument(st,le,Pe)},createTextEditorDecorationType(X){return Dt.createTextEditorDecorationType(X)},onDidChangeActiveTextEditor(X,le,Pe){return Dt.onDidChangeActiveTextEditor(X,le,Pe)},onDidChangeVisibleTextEditors(X,le,Pe){return Dt.onDidChangeVisibleTextEditors(X,le,Pe)},onDidChangeTextEditorSelection(X,le,Pe){return Dt.onDidChangeTextEditorSelection(X,le,Pe)},onDidChangeTextEditorOptions(X,le,Pe){return Dt.onDidChangeTextEditorOptions(X,le,Pe)},onDidChangeTextEditorVisibleRanges(X,le,Pe){return Dt.onDidChangeTextEditorVisibleRanges(X,le,Pe)},onDidChangeTextEditorViewColumn(X,le,Pe){return Dt.onDidChangeTextEditorViewColumn(X,le,Pe)},onDidCloseTerminal(X,le,Pe){return ft.onDidCloseTerminal(X,le,Pe)},onDidOpenTerminal(X,le,Pe){return ft.onDidOpenTerminal(X,le,Pe)},onDidChangeActiveTerminal(X,le,Pe){return ft.onDidChangeActiveTerminal(X,le,Pe)},onDidChangeTerminalDimensions(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),ft.onDidChangeTerminalDimensions(X,le,Pe)},onDidWriteTerminalData(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),ft.onDidWriteTerminalData(X,le,Pe)},get state(){return et.state},onDidChangeWindowState(X,le,Pe){return et.onDidChangeWindowState(X,le,Pe)},showInformationMessage(X,...le){return Ut.showMessage(Oe,y.default.Info,X,le[0],le.slice(1))},showWarningMessage(X,...le){return Ut.showMessage(Oe,y.default.Warning,X,le[0],le.slice(1))},showErrorMessage(X,...le){return Ut.showMessage(Oe,y.default.Error,X,le[0],le.slice(1))},showQuickPick(X,le,Pe){return xt.showQuickPick(X,!!Oe.enableProposedApi,le,Pe)},showWorkspaceFolderPick(X){return xt.showWorkspaceFolderPick(X)},showInputBox(X,le){return xt.showInput(X,le)},showOpenDialog(X){return Pt.showOpenDialog(X)},showSaveDialog(X){return Pt.showSaveDialog(X)},createStatusBarItem(X,le){let Pe,st,wt,Ct;return X&&typeof X!="number"?(Pe=X.id,st=X.name,wt=X.alignment,le=X.priority,Ct=X.accessibilityInformation):(Pe=Oe.identifier.value,st=v.localize(0,null,Oe.displayName||Oe.name),wt=X),hn.createStatusBarEntry(Pe,st,wt,le,Ct)},setStatusBarMessage(X,le){return hn.setStatusBarMessage(X,le)},withScmProgress(X){return Je.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),dn.withProgress(Oe,{location:L.ProgressLocation.SourceControl},(le,Pe)=>X({report(st){}}))},withProgress(X,le){return dn.withProgress(Oe,X,le)},createOutputChannel(X){return Ot.createOutputChannel(X)},createWebviewPanel(X,le,Pe,st){return nn.createWebviewPanel(Oe,X,le,Pe,st)},createWebviewTextEditorInset(X,le,Pe,st){return(0,te.checkProposedApiEnabled)(Oe),Xt.createWebviewEditorInset(X,le,Pe,st,Oe)},createTerminal(X,le,Pe){return typeof X=="object"?"pty"in X?ft.createExtensionTerminal(X):(X.icon&&(0,te.checkProposedApiEnabled)(Oe),ft.createTerminalFromOptions(X)):ft.createTerminal(X,le,Pe)},registerTerminalLinkProvider(X){return ft.registerLinkProvider(X)},registerTreeDataProvider(X,le){return Vt.registerTreeDataProvider(X,le,Oe)},createTreeView(X,le){return Vt.createTreeView(X,le,Oe)},registerWebviewPanelSerializer:(X,le)=>nn.registerWebviewPanelSerializer(Oe,X,le),registerCustomEditorProvider:(X,le,Pe={})=>Kt.registerCustomEditorProvider(Oe,X,le,Pe),registerFileDecorationProvider(X){return Ze.registerFileDecorationProvider(X,Oe.identifier)},registerUriHandler(X){return Tt.registerUriHandler(Oe.identifier,X)},createQuickPick(){return xt.createQuickPick(Oe.identifier,!!Oe.enableProposedApi)},createInputBox(){return xt.createInputBox(Oe.identifier)},get activeColorTheme(){return qt.activeColorTheme},onDidChangeActiveColorTheme(X,le,Pe){return qt.onDidChangeActiveColorTheme(X,le,Pe)},registerWebviewViewProvider(X,le,Pe){return En.registerWebviewViewProvider(Oe,X,le,Pe==null?void 0:Pe.webviewOptions)},get activeNotebookEditor(){return(0,te.checkProposedApiEnabled)(Oe),pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidChangeActiveNotebookEditor(X,le,Pe)},get visibleNotebookEditors(){return(0,te.checkProposedApiEnabled)(Oe),pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidChangeNotebookEditorSelection(X,le,Pe)},onDidChangeNotebookEditorVisibleRanges(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidChangeNotebookEditorVisibleRanges(X,le,Pe)},showNotebookDocument(X,le){return(0,te.checkProposedApiEnabled)(Oe),pt.showNotebookDocument(X,le)},registerExternalUriOpener(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),rn.registerExternalUriOpener(Oe.identifier,X,le,Pe)},get openEditors(){return(0,te.checkProposedApiEnabled)(Oe),ct.tabs},get onDidChangeOpenEditors(){return(0,te.checkProposedApiEnabled)(Oe),ct.onDidChangeTabs}},gn={get rootPath(){return Je.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Qe.getPath()},set rootPath(X){throw D.readonly()},getWorkspaceFolder(X){return Qe.getWorkspaceFolder(X)},get workspaceFolders(){return Qe.getWorkspaceFolders()},get name(){return Qe.name},set name(X){throw D.readonly()},get workspaceFile(){return Qe.workspaceFile},set workspaceFile(X){throw D.readonly()},updateWorkspaceFolders:(X,le,...Pe)=>Qe.updateWorkspaceFolders(Oe,X,le||0,...Pe),onDidChangeWorkspaceFolders:function(X,le,Pe){return Qe.onDidChangeWorkspace(X,le,Pe)},asRelativePath:(X,le)=>Qe.getRelativePath(X,le),findFiles:(X,le,Pe,st)=>Qe.findFiles(R.GlobPattern.from(X),R.GlobPattern.from(le),Pe,Oe.identifier,st),findTextInFiles:(X,le,Pe,st)=>{let wt,Ct;return typeof le=="object"?(wt=le,Ct=Pe):(wt={},Ct=le,st=Pe),Qe.findTextInFiles(X,wt||{},Ct,Oe.identifier,st)},saveAll:X=>Qe.saveAll(X),applyEdit(X){return Wt.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,le,Pe,st)=>Rt.createFileSystemWatcher(R.GlobPattern.from(X),le,Pe,st),get textDocuments(){return _t.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw D.readonly()},openTextDocument(X){let le;const Pe=X;if(typeof X=="string")le=Promise.resolve(C.URI.file(X));else if(C.URI.isUri(X))le=Promise.resolve(X);else if(!Pe||typeof Pe=="object")le=_t.createDocumentData(Pe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(st=>_t.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(X,le,Pe)=>_t.onDidAddDocument(X,le,Pe),onDidCloseTextDocument:(X,le,Pe)=>_t.onDidRemoveDocument(X,le,Pe),onDidChangeTextDocument:(X,le,Pe)=>_t.onDidChangeDocument(X,le,Pe),onDidSaveTextDocument:(X,le,Pe)=>_t.onDidSaveDocument(X,le,Pe),onWillSaveTextDocument:(X,le,Pe)=>Yt.getOnWillSaveTextDocumentEvent(Oe)(X,le,Pe),onDidChangeConfiguration:(X,le,Pe)=>an.onDidChangeConfiguration(X,le,Pe),getConfiguration(X,le){return le=arguments.length===1?void 0:le,an.getConfiguration(X,le,Oe)},registerTextDocumentContentProvider(X,le){return Qt.registerTextDocumentContentProvider(X,le)},registerTaskProvider:(X,le)=>(Je.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Oe,X,le)),registerFileSystemProvider(X,le,Pe){return Zt.registerFileSystemProvider(Oe.identifier,X,le,Pe,Oe.enableProposedApi)},get fs(){return rt.value},registerFileSearchProvider:(X,le)=>((0,te.checkProposedApiEnabled)(Oe),yt.registerFileSearchProvider(X,le)),registerTextSearchProvider:(X,le)=>((0,te.checkProposedApiEnabled)(Oe),yt.registerTextSearchProvider(X,le)),registerRemoteAuthorityResolver:(X,le)=>((0,te.checkProposedApiEnabled)(Oe),tt.registerRemoteAuthorityResolver(X,le)),registerResourceLabelFormatter:X=>((0,te.checkProposedApiEnabled)(Oe),en.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,le,Pe)=>Rt.onDidCreateFile(X,le,Pe),onDidDeleteFiles:(X,le,Pe)=>Rt.onDidDeleteFile(X,le,Pe),onDidRenameFiles:(X,le,Pe)=>Rt.onDidRenameFile(X,le,Pe),onWillCreateFiles:(X,le,Pe)=>Rt.getOnWillCreateFileEvent(Oe)(X,le,Pe),onWillDeleteFiles:(X,le,Pe)=>Rt.getOnWillDeleteFileEvent(Oe)(X,le,Pe),onWillRenameFiles:(X,le,Pe)=>Rt.getOnWillRenameFileEvent(Oe)(X,le,Pe),openTunnel:X=>((0,te.checkProposedApiEnabled)(Oe),Te.openTunnel(Oe,X).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,te.checkProposedApiEnabled)(Oe),Te.getTunnels()},onDidChangeTunnels:(X,le,Pe)=>((0,te.checkProposedApiEnabled)(Oe),Te.onDidChangeTunnels(X,le,Pe)),registerPortAttributesProvider:(X,le)=>((0,te.checkProposedApiEnabled)(Oe),Te.registerPortsAttributesProvider(X,le)),registerTimelineProvider:(X,le)=>((0,te.checkProposedApiEnabled)(Oe),_n.registerTimelineProvider(X,le,Oe.identifier,ht.converter)),get isTrusted(){return Qe.trusted},requestWorkspaceTrust:X=>((0,te.checkProposedApiEnabled)(Oe),Qe.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,le,Pe)=>Qe.onDidGrantWorkspaceTrust(X,le,Pe)},Pn={get inputBox(){return Je.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),cn.getLastInputBox(Oe)},createSourceControl(X,le,Pe){return cn.createSourceControl(Oe,X,le,Pe)}},An={createCommentController(X,le){return wn.createCommentController(Oe,X,le)}},pn={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(X,le,Pe){return at.onDidStartDebugSession(X,le,Pe)},onDidTerminateDebugSession(X,le,Pe){return at.onDidTerminateDebugSession(X,le,Pe)},onDidChangeActiveDebugSession(X,le,Pe){return at.onDidChangeActiveDebugSession(X,le,Pe)},onDidReceiveDebugSessionCustomEvent(X,le,Pe){return at.onDidReceiveDebugSessionCustomEvent(X,le,Pe)},onDidChangeBreakpoints(X,le,Pe){return at.onDidChangeBreakpoints(X,le,Pe)},registerDebugConfigurationProvider(X,le,Pe){return at.registerDebugConfigurationProvider(X,le,Pe||L.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,le){return at.registerDebugAdapterDescriptorFactory(Oe,X,le)},registerDebugAdapterTrackerFactory(X,le){return at.registerDebugAdapterTrackerFactory(X,le)},startDebugging(X,le,Pe){return!Pe||typeof Pe=="object"&&"configuration"in Pe?at.startDebugging(X,le,{parentSession:Pe}):at.startDebugging(X,le,Pe||{})},stopDebugging(X){return at.stopDebugging(X)},addBreakpoints(X){return at.addBreakpoints(X)},removeBreakpoints(X){return at.removeBreakpoints(X)},asDebugSourceUri(X,le){return at.asDebugSourceUri(X,le)}},vn={registerTaskProvider:(X,le)=>Et.registerTaskProvider(Oe,X,le),fetchTasks:X=>Et.fetchTasks(X),executeTask:X=>Et.executeTask(Oe,X),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(X,le,Pe)=>Et.onDidStartTask(X,le,Pe),onDidEndTask:(X,le,Pe)=>Et.onDidEndTask(X,le,Pe),onDidStartTaskProcess:(X,le,Pe)=>Et.onDidStartTaskProcess(X,le,Pe),onDidEndTaskProcess:(X,le,Pe)=>Et.onDidEndTaskProcess(X,le,Pe)},$t={openNotebookDocument:X=>((0,te.checkProposedApiEnabled)(Oe),pt.openNotebookDocument(X)),get onDidOpenNotebookDocument(){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,te.checkProposedApiEnabled)(Oe),pt.notebookDocuments.map(X=>X.apiNotebook)},registerNotebookSerializer(X,le,Pe,st){return(0,te.checkProposedApiEnabled)(Oe),pt.registerNotebookSerializer(Oe,X,le,Pe,Oe.enableProposedApi?st:void 0)},registerNotebookContentProvider:(X,le,Pe,st)=>((0,te.checkProposedApiEnabled)(Oe),pt.registerNotebookContentProvider(Oe,X,le,Pe,Oe.enableProposedApi?st:void 0)),registerNotebookCellStatusBarItemProvider:(X,le)=>((0,te.checkProposedApiEnabled)(Oe),pt.registerNotebookCellStatusBarItemProvider(Oe,X,le)),createNotebookEditorDecorationType(X){return(0,te.checkProposedApiEnabled)(Oe),pt.createNotebookEditorDecorationType(X)},onDidChangeNotebookDocumentMetadata(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidChangeNotebookDocumentMetadata(X,le,Pe)},onDidChangeNotebookCells(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidChangeNotebookCells(X,le,Pe)},onDidChangeNotebookCellExecutionState(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidChangeNotebookCellExecutionState(X,le,Pe)},onDidChangeCellOutputs(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidChangeCellOutputs(X,le,Pe)},onDidChangeCellMetadata(X,le,Pe){return(0,te.checkProposedApiEnabled)(Oe),pt.onDidChangeCellMetadata(X,le,Pe)},createConcatTextDocument(X,le){return(0,te.checkProposedApiEnabled)(Oe),new V.ExtHostNotebookConcatDocument(pt,_t,X,le)},createNotebookController(X,le,Pe,st,wt){return(0,te.checkProposedApiEnabled)(Oe),Jt.createNotebookController(Oe,X,le,Pe,st,wt)}};return{version:Be.version,authentication:Sn,commands:Dn,comments:An,debug:pn,env:fn,extensions:Cn,languages:kn,notebook:$t,scm:Pn,tasks:vn,test:Ht,window:In,workspace:gn,Breakpoint:L.Breakpoint,CallHierarchyIncomingCall:L.CallHierarchyIncomingCall,CallHierarchyItem:L.CallHierarchyItem,CallHierarchyOutgoingCall:L.CallHierarchyOutgoingCall,CancellationError:D.CancellationError,CancellationTokenSource:T.CancellationTokenSource,CandidatePortSource:g.CandidatePortSource,CodeAction:L.CodeAction,CodeActionKind:L.CodeActionKind,CodeActionTriggerKind:L.CodeActionTriggerKind,CodeLens:L.CodeLens,Color:L.Color,ColorInformation:L.ColorInformation,ColorPresentation:L.ColorPresentation,ColorThemeKind:L.ColorThemeKind,CommentMode:L.CommentMode,CommentThreadCollapsibleState:L.CommentThreadCollapsibleState,CompletionItem:L.CompletionItem,CompletionItemKind:L.CompletionItemKind,CompletionItemTag:L.CompletionItemTag,CompletionList:L.CompletionList,CompletionTriggerKind:L.CompletionTriggerKind,ConfigurationTarget:L.ConfigurationTarget,CustomExecution:L.CustomExecution,DebugAdapterExecutable:L.DebugAdapterExecutable,DebugAdapterInlineImplementation:L.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:L.DebugAdapterNamedPipeServer,DebugAdapterServer:L.DebugAdapterServer,DebugConfigurationProviderTriggerKind:L.DebugConfigurationProviderTriggerKind,DebugConsoleMode:L.DebugConsoleMode,DecorationRangeBehavior:L.DecorationRangeBehavior,Diagnostic:L.Diagnostic,DiagnosticRelatedInformation:L.DiagnosticRelatedInformation,DiagnosticSeverity:L.DiagnosticSeverity,DiagnosticTag:L.DiagnosticTag,Disposable:L.Disposable,DocumentHighlight:L.DocumentHighlight,DocumentHighlightKind:L.DocumentHighlightKind,DocumentLink:L.DocumentLink,DocumentSymbol:L.DocumentSymbol,EndOfLine:L.EndOfLine,EnvironmentVariableMutatorType:L.EnvironmentVariableMutatorType,EvaluatableExpression:L.EvaluatableExpression,InlineValueText:L.InlineValueText,InlineValueVariableLookup:L.InlineValueVariableLookup,InlineValueEvaluatableExpression:L.InlineValueEvaluatableExpression,EventEmitter:A.Emitter,ExtensionKind:L.ExtensionKind,ExtensionMode:L.ExtensionMode,ExternalUriOpenerPriority:L.ExternalUriOpenerPriority,FileChangeType:L.FileChangeType,FileDecoration:L.FileDecoration,FileSystemError:L.FileSystemError,FileType:h.FileType,FilePermission:h.FilePermission,FoldingRange:L.FoldingRange,FoldingRangeKind:L.FoldingRangeKind,FunctionBreakpoint:L.FunctionBreakpoint,Hover:L.Hover,IndentAction:i.IndentAction,Location:L.Location,MarkdownString:L.MarkdownString,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:L.ParameterInformation,PortAutoForwardAction:L.PortAutoForwardAction,Position:L.Position,ProcessExecution:L.ProcessExecution,ProgressLocation:L.ProgressLocation,QuickInputButtons:L.QuickInputButtons,Range:L.Range,RelativePattern:L.RelativePattern,Selection:L.Selection,SelectionRange:L.SelectionRange,SemanticTokens:L.SemanticTokens,SemanticTokensBuilder:L.SemanticTokensBuilder,SemanticTokensEdit:L.SemanticTokensEdit,SemanticTokensEdits:L.SemanticTokensEdits,SemanticTokensLegend:L.SemanticTokensLegend,ShellExecution:L.ShellExecution,ShellQuoting:L.ShellQuoting,SignatureHelp:L.SignatureHelp,SignatureHelpTriggerKind:L.SignatureHelpTriggerKind,SignatureInformation:L.SignatureInformation,SnippetString:L.SnippetString,SourceBreakpoint:L.SourceBreakpoint,StandardTokenType:L.StandardTokenType,StatusBarAlignment:L.StatusBarAlignment,SymbolInformation:L.SymbolInformation,SymbolKind:L.SymbolKind,SymbolTag:L.SymbolTag,Task:L.Task,TaskGroup:L.TaskGroup,TaskPanelKind:L.TaskPanelKind,TaskRevealKind:L.TaskRevealKind,TaskScope:L.TaskScope,TextDocumentSaveReason:L.TextDocumentSaveReason,TextEdit:L.TextEdit,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:L.TextEditorLineNumbersStyle,TextEditorRevealType:L.TextEditorRevealType,TextEditorSelectionChangeKind:L.TextEditorSelectionChangeKind,ThemeColor:L.ThemeColor,ThemeIcon:L.ThemeIcon,TreeItem:L.TreeItem,TreeItemCollapsibleState:L.TreeItemCollapsibleState,UIKind:g.UIKind,Uri:C.URI,ViewColumn:L.ViewColumn,WorkspaceEdit:L.WorkspaceEdit,InlayHint:L.InlayHint,InlayHintKind:L.InlayHintKind,RemoteAuthorityResolverError:L.RemoteAuthorityResolverError,RemoteTrustOption:oe.RemoteTrustOption,ResolvedAuthority:L.ResolvedAuthority,SourceControlInputBoxValidationType:L.SourceControlInputBoxValidationType,ExtensionRuntime:L.ExtensionRuntime,TimelineItem:L.TimelineItem,NotebookRange:L.NotebookRange,NotebookCellKind:L.NotebookCellKind,NotebookCellExecutionState:L.NotebookCellExecutionState,NotebookDocumentMetadata:L.NotebookDocumentMetadata,NotebookCellMetadata:L.NotebookCellMetadata,NotebookCellData:L.NotebookCellData,NotebookData:L.NotebookData,NotebookKernelPreload:L.NotebookKernelPreload,NotebookCellStatusBarAlignment:L.NotebookCellStatusBarAlignment,NotebookEditorRevealType:L.NotebookEditorRevealType,NotebookCellOutput:L.NotebookCellOutput,NotebookCellOutputItem:L.NotebookCellOutputItem,NotebookCellStatusBarItem:L.NotebookCellStatusBarItem,NotebookControllerAffinity:L.NotebookControllerAffinity,PortAttributes:L.PortAttributes,LinkedEditingRanges:L.LinkedEditingRanges,TestItemStatus:L.TestItemStatus,TestResultState:L.TestResultState,TestMessage:L.TestMessage,TextSearchCompleteMessageType:ke.TextSearchCompleteMessageType,TestMessageSeverity:L.TestMessageSeverity,WorkspaceTrustState:L.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ie}),define(ve[226],we([0,1,61,101,30,100,34,77,39,40,104,105,106,80,79,71,76,102,78,49,75,95,69]),function(Y,e,v,T,D,A,y,C,S,k,i,P,h,g,r,o,p,m,E,l,c,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.registerSingleton)(g.IExtensionStoragePaths,g.ExtensionStoragePaths),(0,v.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService),(0,v.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,v.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,v.registerSingleton)(E.IExtHostConsumerFileSystem,E.ExtHostConsumerFileSystem),(0,v.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService),(0,v.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,v.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,v.registerSingleton)(l.IExtHostFileSystemInfo,l.ExtHostFileSystemInfo),(0,v.registerSingleton)(T.IExtHostOutputService,T.ExtHostOutputService),(0,v.registerSingleton)(h.IExtHostSearch,h.ExtHostSearch),(0,v.registerSingleton)(r.IExtHostStorage,r.ExtHostStorage),(0,v.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,v.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,v.registerSingleton)(o.IExtHostTunnelService,o.ExtHostTunnelService),(0,v.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow),(0,v.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace),(0,v.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,v.registerSingleton)(d.IExtHostTelemetry,d.ExtHostTelemetry),(0,v.registerSingleton)(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(ve[227],we([0,1,225,35,221,7,11,5]),function(Y,e,v,T,D,A,y,C){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var k;(function(r){var o;const p=(o=self.trustedTypes)===null||o===void 0?void 0:o.createPolicy("TrustedFunctionWorkaround",{createScript:(E,...l)=>{l.forEach(n=>{var a;if(!((a=self.trustedTypes)===null||a===void 0?void 0:a.isScript(n)))throw new Error("TrustedScripts only, please")});const c=l.slice(0,-1).join(","),d=l.pop().toString();return`(function anonymous(${c}) {
${d}
})`}});function m(...E){return p?self.eval(p.createScript("",...E)):new Function(...E)}r.create=m})(k||(k={}));class i extends D.RequireInterceptor{_installInterceptor(){}getModule(o,p){for(let m of this._alternatives){let E=m(o);if(E){o=E;break}}if(this._factories.has(o))return this._factories.get(o).load(o,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends T.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const o=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);g(o,this._initData.environment.isExtensionDevelopmentDebug);const p=this._instaService.invokeFunction(v.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(i,p,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(o){return o.browser}async _loadCommonJSModule(o,p,m){var E,l,c,d,t,n,a,s;p=p.with({path:h(p.path,".js")}),o&&performance.mark(`code/extHost/willFetchExtensionCode/${o.value}`);const u=await fetch(p.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o.value}`),u.status!==200)throw new Error(u.statusText);const w=await u.text(),b=`${p.toString(!0)}#vscode-extension`,I=`${w}
//# sourceURL=${b}`;let f;try{f=k.create((l=(E=P._ttpExtensionScripts)===null||E===void 0?void 0:E.createScript("module"))!==null&&l!==void 0?l:"module",(d=(c=P._ttpExtensionScripts)===null||c===void 0?void 0:c.createScript("exports"))!==null&&d!==void 0?d:"exports",(n=(t=P._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&n!==void 0?n:"require",(s=(a=P._ttpExtensionScripts)===null||a===void 0?void 0:a.createScript(I))!==null&&s!==void 0?s:I)}catch(z){throw o?console.error(`Loading code for extension ${o.value} failed: ${z.message}`):console.error(`Loading code failed: ${z.message}`),console.error(`${p.toString(!0)}${typeof z.line=="number"?` line ${z.line}`:""}${typeof z.column=="number"?` column ${z.column}`:""}`),console.error(z),z}const _={},F={exports:_},U=z=>{const he=this._fakeModules.getModule(z,p);if(he===void 0)throw new Error(`Cannot load module '${z}'`);return he};try{return m.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o.value}`),f(F,_,U),F.exports!==_?F.exports:_}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o.value}`),m.codeLoadingStop()}}async $setRemoteEnvironment(o){throw new Error("Not supported")}async _waitForDebuggerAttachment(o=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const p=Date.now()+o;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,y.timeout)(10)}}}e.ExtHostExtensionService=P,P._ttpExtensionScripts=(S=self.trustedTypes)===null||S===void 0?void 0:S.createPolicy("ExtensionScripts",{createScript:r=>r});function h(r,o){return r.endsWith(o)?r:r+o}function g(r,o){p("info","log"),p("log","log"),p("warn","warn"),p("error","error");function p(l,c){const d=console[l];console[l]=function(){r.$logExtensionHostMessage({type:"__$console",severity:c,arguments:E(arguments)}),o&&d.apply(console,arguments)}}const m=1e5;function E(l){const c=[],d=[];if(l.length)for(let t=0;t<l.length;t++){if(typeof l[t]=="undefined")l[t]="undefined";else if(l[t]instanceof Error){const n=l[t];n.stack?l[t]=n.stack:l[t]=n.toString()}d.push(l[t])}try{const t=JSON.stringify(d,function(n,a){if(a&&typeof a=="object"){if(c.indexOf(a)!==-1)return"[Circular]";c.push(a)}return a});return t.length>m?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(ve[228],we([0,1,61,16,35,227,213]),function(Y,e,v,T,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.registerSingleton)(D.IExtHostExtensionService,A.ExtHostExtensionService),(0,v.registerSingleton)(T.ILogService,y.ExtHostLogService)}),define(ve[230],we([0,1,24,3,184,222,215,14,81,226,228]),function(Y,e,v,T,D,A,y,C,S){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0});const i=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const P=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const p=(k=self.trustedTypes)===null||k===void 0?void 0:k.createPolicy("extensionHostWorker",{createScriptURL:E=>E}),m=self.Worker;Worker=function(E,l){const c=`importScripts('${E}');`;l=l||{},l.name=l.name||C.basename(E.toString());const d=new Blob([c],{type:"application/javascript"}),t=URL.createObjectURL(d);return new m(p?p.createScriptURL(t):t,l)}}else self.Worker=class extends y.NestedWorker{constructor(p,m){super(P,p,Object.assign({name:C.basename(p.toString())},m))}};const h=new class{exit(p){i()}async exists(p){return!0}async realpath(p){return p}};class g{constructor(){const m=new MessageChannel,E=new T.Emitter;let l=!1;P(m.port2,[m.port2]),m.port1.onmessage=c=>{const{data:d}=c;if(!(d instanceof ArrayBuffer)){console.warn("UNKNOWN data received",d);return}const t=v.VSBuffer.wrap(new Uint8Array(d,0,d.byteLength));if((0,D.isMessageOfType)(t,2)){l=!0,o("received terminate message from renderer");return}E.fire(t)},this.protocol={onMessage:E.event,send:c=>{if(!l){const d=c.buffer.buffer.slice(c.buffer.byteOffset,c.buffer.byteOffset+c.buffer.byteLength);m.port1.postMessage(d,[d])}}}}}function r(p){return new Promise(m=>{const E=p.onMessage(l=>{E.dispose();const c=JSON.parse(l.toString());p.send((0,D.createMessageOfType)(0)),m({protocol:p,initData:c})});p.send((0,D.createMessageOfType)(1))})}let o=p=>i();(function(){const m=new g;S.mark("code/extHost/willConnectToRenderer"),r(m.protocol).then(E=>{S.mark("code/extHost/didWaitForInitData");const l=new A.ExtensionHostMain(E.protocol,E.initData,h,null);o=c=>l.terminate(c)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/659175fa39b994fc39381b0af2874c85efeb2a01/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
